/************************************************
* Utilisation de GMPLIB sous licence LGPL
************************************************/

#include <gmpxx.h>

using namespace std;

#ifndef FIELDELEMENT_HPP_INCLUDED
#define FIELDELEMENT_HPP_INCLUDED

class FieldElement{
	private:
	  mpz_class value;
	  mpz_class prime;
	public:
	  FieldElement(mpz_class val, mpz_class pri);
	  FieldElement(mpz_class pri);
	  FieldElement();
	  const char* toString();
	  mpz_class getValue() const;
	  mpz_class getModulo() const;
	  void setValue(mpz_class val);
	  void setModulo(mpz_class val);
	  FieldElement& operator=(FieldElement const& a);
	  FieldElement& operator=(mpz_class const& a);
	  FieldElement operator+(FieldElement const& a);
	  FieldElement operator-(FieldElement const& a);
	  FieldElement operator+() const;
	  FieldElement operator-() const;
	  FieldElement operator*(FieldElement const& a);
	  FieldElement operator/(FieldElement const& a);
	  FieldElement& operator++();
	  FieldElement operator++(int x);
	  FieldElement& operator--();
	  FieldElement operator--(int x);
	  bool operator==(FieldElement const& a);
	  bool operator!=(FieldElement const& a);
	  bool operator>(FieldElement const& a);
	  bool operator<(FieldElement const& a);
	  bool operator>=(FieldElement const& a);
	  bool operator<=(FieldElement const& a);
	  FieldElement& operator+=(FieldElement const& a);
	  FieldElement& operator-=(FieldElement const& a);
	  FieldElement& operator*=(FieldElement const& a);
	  FieldElement& operator/=(FieldElement const& a);
};

inline ostream& operator<<(ostream& os , const FieldElement& a){
    os << a.getValue();
    return os;
}

#endif // FIELDELEMENT_HPP_INCLUDED