//     All Rights Reserved © Copyright 2013 - Morpho - Paris France
//
//     This module is free software: you can redistribute it and/or modify
//     it under the terms of the GNU General Public License as published by
//     the Free Software Foundation, either version 3 of the License, or
//     (at your option) any later version.
//
//     This program is distributed in the hope that it will be useful,
//     but WITHOUT ANY WARRANTY; without even the implied warranty of
//     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//     GNU General Public License for more details.

//     You should have received a copy of the GNU General Public License
//     along with this program.  If not, see <http://www.gnu.org/licenses/>.

function getCuttingLayouts() {
   
    return {
        absoluteForm: {
            title: 'Cutting Page',
            id: 'cutting-panel',
            xtype: 'form',
            //layout: 'fit',
            bodyPadding: 15,
            layout: 'hbox',
            items: [
                    {
                    //title: 'cutting',
                    //layout: 'fit',
                    frame: true,
                    border: true,
                    items: [
                        {
                            xtype: 'textfield',
                            width: 410,
                            name: 'database',
                            id: 'databaseC',
                            fieldLabel: 'Database',
                            value: 'jio',
                            labelWidth: 120,
                            msgTarget: 'side',
                            disabled: true,
                            allowBlank: false, // field required !!! ==> form.isValid()
                            anchor: '100%',
                            labelAlign: 'left',
                        },
                        {
                            xtype: 'textfield',
                            width: 410,
                            name: 'cNameField',
                            id: 'cNameField',
                            fieldLabel: 'Nom',
                            labelWidth: 120,
                            msgTarget: 'side',
                            allowBlank: false, // field required !!! ==> form.isValid()
                            anchor: '100%',
                            labelAlign: 'left',
                        },
                        {
                            xtype: 'textfield',
                            width: 410,
                            name: 'cFirstNameField',
                            id: 'cFirstNameField',
                            fieldLabel: 'Pr&eacutenom',
                            labelWidth: 120,
                            msgTarget: 'side',
                            allowBlank: false, // field required !!! ==> form.isValid()
                            anchor: '100%',
                            labelAlign: 'left',
                        },
                        {
                            fieldLabel: 'Sexe',
                            labelWidth: 120,
                            width: 410,
                            xtype: 'combo',
                            id: 'cSexCombo',
                            store: ['Homme','Femme','Inconnu'],
                            mode: 'local',
                            editable: false,
                            displayField: 'Inconnu'
                        },
                        {
                            xtype: 'textfield',
                            width: 410,
                            name: 'decoupage',
                            id: 'decoupage',
                            fieldLabel: 'Number cut',
                            labelWidth: 120,
                            msgTarget: 'side',
                            allowBlank: false, // field required !!! ==> form.isValid()
                            disabled: true,
                            anchor: '100%',
                            labelAlign: 'left',
                        },
                        {
                            xtype: 'filefield',
                            width: 410,
                            name: 'file',
                            id: 'fileC',
                            fieldLabel: 'File',
                            labelWidth: 120,
                            emptyText: 'Select an image to Upload',
                            msgTarget: 'side',
                            allowBlank: false, // field required !!! ==> form.isValid()
                            anchor: '100%',
                            labelAlign: 'left',
                            buttonText: 'Select an image...',
                            listeners:{
                                afterrender:function(cmp){
                                  cmp.fileInputEl.set({
                                    accept:'image/*' // or w/e type
                                  });
                                }
                            }
                        }
                        ],
                    buttons: [
                              {
                                text: 'start',
                                handler: function(value) {
                                    var form = this.up('form').getForm();
                                    if(form.isValid()){
                                        var database = Ext.getCmp('databaseC').value;
                                        var file     = Ext.getCmp('fileC').getEl().down('input[type=file]').dom.files[0];
                                        var name = Ext.getCmp('cNameField').value;
                                        var firstName = Ext.getCmp('cFirstNameField').value;
                                        var sex = Ext.getCmp('cSexCombo').value;
                                        
                                        splitFile(file, database, name, firstName, sex);
                                        
                                        //MessageBox as ProgressBar
                                        Ext.MessageBox.show({
                                            msg : 'Please wait...',
                                            progressText : 'Saving...',
                                            width : 300,
                                            wait : true,
                                            waitConfig : 
                                            {
                                                duration : 1000,
                                                increment : 1,
                                                text : 'Cutting image ...',
                                                scope : this,
                                                fn : function(){
                                                    Ext.MessageBox.hide();
                                                    Ext.Msg.alert('Status', 'cutting successfully!');
                                                }
                                            }
                                        });
                                                         
                                    }
                                }
                              }
                             ]
            }, // end Frame
            {
                title: 'Image',
                frame: false,
                border: false,
                padding: '0 0 10 10',
                items: [
                        {
                            xtype: 'image',
                            name: 'img',
                            id:'img',
                            src: '#',
                            width: 620,
                            height: 800
                        }
                       ]  
            }
            ]
        } // absoluteForm
    }; // end return
} // end function
