package com.safran.morpho.matching;

import java.io.File;


/**
 * Start convert into wsq.
 * command use : C:\dev\TestJni\src>javah -jni com.safran.morpho.matching.JNIStartCwsq
 * @author DIN
 *
 */
public class JNIStartCwsq {

    private static String OS = System.getProperty("os.name").toLowerCase();
    
    /**
     * Start convert into wsq.
     * @param bitrate Bitrate
     * @param formatoutput Format output
     * @param fileInput Data input
     * @param rawflag Flaw raw image in input
     * @param width Width image
     * @param height HEight image
     * @param depth Depth image
     * @return 0 if OK
     */
    public static final native int cwsq(final float bitrate, final String formatoutput, final String fileInput, final int rawflag, final int width, final int height, final int depth);
   
    // Load Dll
    static {
        if (OS.indexOf("win") >= 0) {
            System.loadLibrary("cwsq");
        } else {
            System.load(System.getProperty("java.library.path") + File.separator + "cwsq.so");
        }
    }
    
    /**
     * Main to test.
     * @param args
     */
    public static void main(String[] args) {}
    
}
