package com.safran.morpho.matching;

import java.io.File;


/**
 * Start convert wsq into minutiae.
 * command use : C:\dev\TestJni\src>javah -jni com.safran.morpho.matching.JNIStartMindtct
 * @author DIN
 *
 */
public class JNIStartMindtct {

    private static String OS = System.getProperty("os.name").toLowerCase();
    
    /**
     * Start convert wsq into minutiae.
     * @param fileInput Input file wsq to be processed
     * @param fileOutput Output file 
     * @return 0 if OK
     */
    public static final native int mindtct(final String fileInput, final String fileOutput);
   
    // Load Dll
    static {
        if (OS.indexOf("win") >= 0) {
            System.loadLibrary("mindtct");
        } else {
            System.load(System.getProperty("java.library.path") + File.separator + "mindtct.so");
        }
    }
    
    /**
     * Main to test.
     * @param args
     */
    public static void main(String[] args) {}
    
}
