//     All Rights Reserved © Copyright 2013 - Morpho - Paris France
//
//     This module is free software: you can redistribute it and/or modify
//     it under the terms of the GNU General Public License as published by
//     the Free Software Foundation, either version 3 of the License, or
//     (at your option) any later version.
//
//     This program is distributed in the hope that it will be useful,
//     but WITHOUT ANY WARRANTY; without even the implied warranty of
//     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//     GNU General Public License for more details.

//     You should have received a copy of the GNU General Public License
//     along with this program.  If not, see <http://www.gnu.org/licenses/>.


// Variables globals
var tabletAllIdImage    = [];
var dataBase64          = null;
var database            = null;
var fileToMatch         = null;


/**
 * Matching.
 * @param file File to match
 * @param base Name database
 */
function matching(file, base){

    // Initialize
    tabletAllIdImage    = [];
    lstClsImageId       = [];
    dataBase64          = null;
    database            = base;
    fileToMatch         = file;
    seuilAcc            = 0;
    seuilMatch          = 0;

    // Read file
    readFileMatching(executeAllDocuments); 
   
}

/**
 * Read file matching.
 * @param callback Call Function callback after end reading file
 */
function readFileMatching(callback) {
    
    var fileReader = new FileReader();
    var _URL = window.URL || window.webkitURL;
    
    fileReader.onload = function(fileLoadedEvent) {
        dataBase64 = fileLoadedEvent.target.result; // <--- data: base64
        
        // Test if it's an image
        if (!isImageData(dataBase64)) {
            Ext.MessageBox.alert('Failed', file.name + " is not an image.");
           return;
        }
        
        // Show image
        //patch for android
        //var image = document.getElementById("imgM");
        //image.src = dataBase64;
        
        // search width/height of image
        var img    = new Image();
        img.onload = function() {
            width = this.width,
            height = this.height;
        };
        img.src = _URL.createObjectURL(fileToMatch);
        
        // get data in base64
        dataBase64 = dataBase64.substring(dataBase64.indexOf(",") + 1 );
        
        // get seuils
        seuilAcc   = Ext.getCmp('seuilA').value;
        seuilMatch = Ext.getCmp('seuilM').value;
            
        callback(); // return and call function callback
    };
    fileReader.onerror = function(evt) {
        Ext.MessageBox.alert('Error', "Impossible reading file : " + file.name);
    };
    fileReader.readAsDataURL(fileToMatch);
}

/**
 * Get list documents ID.
 */
function executeAllDocuments() {
    // Get all documents
    getAllId(confrest.confrests[0].url, executeAllId);
}

/**
 * Get all Id in database.
 */
function getAllId(url, callback) {
    
    // Get all documents ---------------------------------------------------------------------------
    var allId_jio = getInstanceJIO(url, database);
    if (!allId_jio) {
        return error('no jio set for getting all documents');
    }

    // Params request ..............................................................................
    var opts        = initializeOpts();
    var doc         = {};
    var document_id = "";
    doc             = JSON.parse('{"_id":"' +  document_id + '"}');
    // .............................................................................. Params request
    
    // Execute request
    allId_jio['allDocs'](doc, opts, function(err, val) {
        if(val) {
            if(val.rows.length > 0) {
                // Get image for each Id found in database .............................................
                for(var i=0; i < val.rows.length; i++) {
                    tabletAllIdImage.push(val.rows[i].id);
                }
                //  ............................................ Get image for each Id found in database
            } else {
                log('no document found');
            }
        }
        callback(); // return and call function callback
    });
    //  --------------------------------------------------------------------------- Get all documents
    
}

/**
 * Treatment for each document ID.
 */
function executeAllId() {
    
    // Iterate for every ID found
    for(var i= 0; i < tabletAllIdImage.length; i++) {
        for (var j=0 ; j< confrest.confrests.length; j++) {
            var conf = confrest.confrests[j];
            var url = conf.url;
            var document_id = tabletAllIdImage[i];
            getImageId(j, document_id, url);
        }
    }
}

/**
 * Merge parts of Image.
 * @param document_id
 */
function executeMergeImageId(document_id) {
    // construct image
    constructImageRef(document_id);
}

/**
 * Get Image from database.
 */
function getImageId(colonne, document_id, url) {

    var id_jio   = getInstanceJIO(url, database);
    if (!id_jio) {
        return error('no jio set for getting Image.');
    }

    // Params request ..............................................................................
    // Initialize opts
    var opts = initializeOpts();
    
    var doc  = JSON.parse('{"_id":"' +  document_id + '", "_attachment":"att2"}');
    // .............................................................................. Params request

    
    // RBO Next STEP = recompose
    // Execute request
    id_jio['getAttachment'](doc, opts, function(err, val) {
        if(val) {
            var base64Image = val.split("data:image/jpeg;base64,")[1];
            var clsImgId = getClsImageId(document_id);
            clsImgId.setPartImageBase64(colonne, base64Image == null ? val.trim() : base64Image);
            clsImgId.setDocumentId(document_id);
            clsImgId.incCountImage();
            if (isObjImageExist(document_id) == null) {
                lstClsImageId.push(clsImgId);
            }
            
            doc = JSON.parse('{"_id":"' +  document_id + '"}');
            id_jio['get'](doc, opts, function (err, val) {
                if (null != clsImgId) {
                    clsImgId.setFileName(val.auteur);
                    clsImgId.setWidth(val.width);
                    clsImgId.setHeight(val.height);
                }
                executeMergeImageId(document_id);
            });
        }
    });
}

/**
 * Merge parts of image.
 */
function constructImageRef(document_id) {
    
    if (null != document_id) {
        var clsImgId = isObjImageExist(document_id);
        if (null != clsImgId) {
            //if (clsImgId.getCountImage() == confrest.confrests.length && clsImgId.getFileName() != null && !clsImgId.isMerge()) {
            if (clsImgId.getCountImage() > shamirThreshold && clsImgId.getFileName() != null && !clsImgId.isMerge()) {
                clsImgId.setMerge(true);
                var mergeImageRefId = clsImgId.getImageBase64Shamir();
                httpPost(fileToMatch.name, clsImgId.getFileName(), clsImgId.getWidth(), clsImgId.getHeight(), document_id, mergeImageRefId);
            }
        }
    }
}

/**
 * Search Object Image in the list.
 * @return clsImageId
 */
function getClsImageId(document_id) {
    if (document_id == null) {
        return null;
    }
    var clsImgId = isObjImageExist(document_id);
    return  clsImgId == null ? new clsImageId() : clsImgId ;
}

/**
 * Test if object ClsImageId exist.
 * @param document_id Image searching
 * @returns null if not found
 */
function isObjImageExist(document_id) {
    for(var i=0;i<lstClsImageId.length;i++) {
        if (lstClsImageId[i].document_id == document_id) {
            return lstClsImageId[i];
        }
    }
    return null;
}

/**
 * Post data to server for matching.    
 * @param fileinputMatch Input filename matching
 * @param fileinputRef Input file Reference
 * @param widthRef Width of Image Ref
 * @param heightRef Height of Image Ref
 * @param document_id ID image in database
 * @param mergeImageRefId Data image Ref in base64
 * @returns
 */
function httpPost(fileinputMatch, fileinputRef, widthRef, heightRef, document_id, mergeImageRefId) {
    var xmlHttp = null;

    xmlHttp = new XMLHttpRequest();
 
    xmlHttp.open( "POST", "/WebDin/matching?fileinputMatch=" + fileinputMatch + "&fileinputRef=" + fileinputRef + "&widthMatch=" + width + "&heightMatch=" + height + "&widthRef=" + widthRef + "&heightRef=" + heightRef + "&document_id=" + document_id +"&numberDatabase=" + confrest.confrests.length + "&threshold=" + shamirThreshold, false );
    xmlHttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded"); // This is needed for any POST request made via Ajax
    xmlHttp.send(dataBase64 + ";" + mergeImageRefId);
    var matchResult = JSON.parse(xmlHttp.responseText);
    try {
        if (null != matchResult && parseInt(matchResult.score) >= parseInt(seuilAcc)) {
            var storeMatching = Ext.getCmp('matching-panel').items.items[1].items.items[0].store;
            if (null != storeMatching) {
                var data = [];
                var vals = Object.keys(matchResult).map(function (key) {
                    return (key == "score") ? parseInt(matchResult[key]) : matchResult[key];
                });
                data.push(vals);
                storeMatching.add(data);
            }
        }
    } catch (exception) {
    }
}


function showImageWithMetaData(document_id, base) {
    var popupId = Ext.id();
    var candidateForm = Ext.create('Ext.window.Window', {
            title: 'Fiche num&eacutero ' + document_id,
            id:'fiche' + popupId,
            height: 300,
            width: 650,
            frame: true,
            renderTo: Ext.getBody(),
            layout: 'column', // arrange fieldsets side by side
            resizable: true,
            closable: true,
            floatable: true,
            items: [{
                // MetaData
                xtype:'fieldset',
                columnWidth: 0.5,
                title: 'MetaData',
                collapsible: false,
                defaultType: 'textfield',
                defaults: {anchor: '100%', disabled:false},
                layout: 'anchor',
                id: 'metadata' + popupId,
                items :[{
                    fieldLabel: 'Nom',
                    id: 'nameField' + popupId + document_id, 
                    name: 'nameField',
                    value:'undefined'
                }, {
                    fieldLabel: 'Pr&eacutenom',
                    id: 'firstNameField'+ popupId + document_id,
                    name: 'firstNameField',
                    value: 'undefined'
                }, {
                    fieldLabel: 'Sexe',
                    id: 'sexField'+ popupId + document_id,
                    name: 'sexField',
                    value: 'undefined'
                }, {
                    fieldLabel: 'Date de cr&eacuteation',
                    id: 'creationDateField'+ popupId + document_id,
                    name: 'creationDateField',
                    value: 'undefined'
                }]
            }, {
                // Image
                xtype:'fieldset',
                title: 'Image NIST', 
                columnWidth: 0.5,
                collapsed: false, 
                layout:'ux.center',
                id:'imageContainer' + popupId,
                items :[{
                        xtype: 'image',
                        name: 'imageRefPopUp',
                        id:'imageRefPopUp'+ popupId + document_id,
                        src: '#',
                        width: 280,
                        height: 256             
                }]
            }]
    });
    candidateForm.on('show', function(candidateForm) {
                
                view(document_id, base, popupId);
                
    });
    candidateForm.show();
}