//     All Rights Reserved © Copyright 2013 - Morpho - Paris France
//
//     This module is free software: you can redistribute it and/or modify
//     it under the terms of the GNU General Public License as published by
//     the Free Software Foundation, either version 3 of the License, or
//     (at your option) any later version.
//
//     This program is distributed in the hope that it will be useful,
//     but WITHOUT ANY WARRANTY; without even the implied warranty of
//     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//     GNU General Public License for more details.

//     You should have received a copy of the GNU General Public License
//     along with this program.  If not, see <http://www.gnu.org/licenses/>.


/**
create matching layout result
TODO: double click listener is implemented but not used
*/
function getMatchingLayouts() {

    // Load data response matching
    var dataM  = [];
    var storeM = new Ext.data.ArrayStore({ // store configs
                                           autoDestroy: true,
                                           id: 'storeM',
                                           // reader configs
                                           fields: [
                                                     {name: 'fileinputMatch' , type: 'string'   },
                                                     {name: 'fileinputRef'   , type: 'string'   },
                                                     {name: 'document_id'    , type: 'string'   },
                                                     {name: 'score'          , type: 'int'      },
                                                     {name: 'success'        , type: 'string'   },
                                                     {name: 'message'        , type: 'string'   }
                                                   ],
                                           data: dataM
                                          });
    
    /**
     * Custom function used for column renderer
     * @param val Value score testing
     */
    function change(val) {
        if (val > seuilMatch) {
            return '<span style="color:red;">' + val + '</span>';
        }
        return val;
    }
   
    return {
        absoluteForm: {
            title: 'Matching Page',
            id: 'matching-panel',
            xtype: 'form',
            bodyPadding: 15,
            width: 400,
            layout: 'border',
            items: [
                    {
                        frame: true,
                        border: true,
                        region: 'north',
                        items: [
                                {
                                    xtype: 'textfield',
                                    width: 410,
                                    name: 'database',
                                    id: 'database',
                                    fieldLabel: 'Database',
                                    value: 'jio',
                                    labelWidth: 140,
                                    msgTarget: 'side',
                                    disabled: true,
                                    allowBlank: false, // field required !!! ==> form.isValid()
                                    anchor: '100%',
                                    labelAlign: 'left',
                                },
                                {
                                    xtype: 'textfield',
                                    width: 410,
                                    name: 'seuilA',
                                    id: 'seuilA',
                                    fieldLabel: 'Threshold acceptable',
                                    value: seuilAccValue,
                                    labelWidth: 140,
                                    msgTarget: 'side',
                                    allowBlank: false, // field required !!! ==> form.isValid()
                                    anchor: '100%',
                                    labelAlign: 'left',
                                },
                                {
                                    xtype: 'textfield',
                                    width: 410,
                                    name: 'seuilM',
                                    id: 'seuilM',
                                    fieldLabel: 'Threshold matching',
                                    value: seuilMatchValue,
                                    labelWidth: 140,
                                    msgTarget: 'side',
                                    allowBlank: false, // field required !!! ==> form.isValid()
                                    anchor: '100%',
                                    labelAlign: 'left',
                                },
                                {
                                    xtype: 'filefield',
                                    width: 410,
                                    name: 'file',
                                    id: 'file',
                                    fieldLabel: 'File',
                                    labelWidth: 140,
                                    emptyText: 'Select an image to match',
                                    msgTarget: 'side',
                                    allowBlank: false, // field required !!! ==> form.isValid()
                                    anchor: '100%',
                                    labelAlign: 'left',
                                    buttonText: 'Select an image...',
                                    
                                    listeners:{
                                        afterrender:function(cmp){
                                          cmp.fileInputEl.set({
                                            accept:'image/*' // or w/e type
                                          });
                                        }
                                    }
                                    
                               }
                               ],
                    buttons: [
                              {
                                text: 'start',
                                handler: function(value){
                                    var form = this.up('form').getForm();
                                    if(form.isValid()){
                                        var database = Ext.getCmp('database').value;
                                        var file     = Ext.getCmp('file').getEl().down('input[type=file]').dom.files[0];
                                        
                                        // clear data
                                        clearMatchingStart();
                                        
                                        // process matching
                                        matching(file, database);
                                        
                                        //MessageBox as ProgressBar
                                        /*
                                        Ext.MessageBox.show({
                                            msg : 'Please wait...',
                                            progressText : 'Saving...',
                                            width : 300,
                                            wait : true,
                                            waitConfig : 
                                            {
                                                duration : 60000,
                                                increment : 5,
                                                text : 'Matching image ...',
                                                scope : this,
                                                fn : function(){
                                                    Ext.MessageBox.hide();
                                                    Ext.Msg.alert('Status', 'matching successfully!');
                                                }
                                            }
                                        });
                                        */

                                        Ext.MessageBox.show({
                                            msg: 'Please wait ... matching in progress',
                                            progressText: 'Matching...',
                                            width:300,
                                            wait:true,
                                            waitConfig: {interval:200}
                                            //animateTarget: 'waitButton'
                                         });
                                         setTimeout(function(){
                                             Ext.MessageBox.hide();
                                             Ext.example.msg('Done', 'matching successful!');
                                             }, 8000);
                                                                             
                                    }
                                }
                              }
                             ]
                    }, // end Frame
                    {
                        xtype: 'panel',
                        title: 'Description',
                        region: 'center',
                        padding: '10 10 0 0',
                        //width:1020,
                        //height:200,
                        layout: 'fit',
                        scrollable: true,
                        items: [
                                {                                    
                                    xtype: 'grid',
                                    id: 'msg',
                                    store:  storeM,
                                    columns: [
                                        {
                                            text     : 'File matching',
                                            width    : 150,
                                            sortable : false, 
                                            dataIndex: 'fileinputMatch'
                                        },
                                        {
                                            text     : 'File Ref', 
                                            width    : 150, 
                                            sortable : true, 
                                            dataIndex: 'fileinputRef'
                                        },
                                        {
                                            text     : 'ID Ref', 
                                            width    : 150, 
                                            sortable : true, 
                                            dataIndex: 'document_id'
                                        },                                        
                                        {
                                            text     : 'Score', 
                                            width    : 80,
                                            sortable : true, 
                                            renderer : change,
                                            dataIndex: 'score'
                                        },
                                        {
                                            text     : 'Success', 
                                            width    : 80,
                                            sortable : true, 
                                            dataIndex: 'success'
                                        },
                                        {
                                            text     : 'Message', 
                                            flex: 1,
                                            sortable : true, 
                                            dataIndex: 'message'
                                        },
                                        {
                                            xtype:'actioncolumn',
                                            width:50,
                                            sortable : false, 
                                            icon: './images/download.png',  // Use a URL in the icon config
                                            tooltip: 'Download',
                                            handler: function(grid, rowIndex, colIndex) {
                                                var rec = grid.getStore().getAt(rowIndex);
                                                grouping(rec.get('document_id'), 'jio');
                                            }
                                        },
                                        {
                                            xtype:'actioncolumn',
                                            width:50,
                                            sortable : false,
                                            icon: './images/eyes.png',  // Use a URL in the icon config
                                            tooltip: 'View',
                                            handler: function(grid, rowIndex, colIndex) {
                                                var rec = grid.getStore().getAt(rowIndex);
                                                var database = Ext.getCmp('database').value;
                                                showImageWithMetaData(rec.get('document_id'), database);
                                            }
                                        }
                                    ],
                                    stripeRows: true,
                                    listeners : {
                                            'celldblclick' : function(grid, rowIndex, cellIndex, e){
                                                var rec = grid.getStore().getAt(rowIndex);
                                                Ext.MessageBox.hide();
                                                alert("double click listener");
                                            }
                                    }
                                } // end Grid
                               ]  
                    }                
                   ]
            } // end absoluteForm   
    }; // end return
} // end function
