//     All Rights Reserved © Copyright 2013 - Morpho - Paris France
//
//     This module is free software: you can redistribute it and/or modify
//     it under the terms of the GNU General Public License as published by
//     the Free Software Foundation, either version 3 of the License, or
//     (at your option) any later version.
//
//     This program is distributed in the hope that it will be useful,
//     but WITHOUT ANY WARRANTY; without even the implied warranty of
//     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//     GNU General Public License for more details.

//     You should have received a copy of the GNU General Public License
//     along with this program.  If not, see <http://www.gnu.org/licenses/>.

function getDatabaseLayouts() {
   
    // Load Conf database
    var my_array_store = new Ext.data.ArrayStore({
                                                    // store configs
                                                    autoDestroy: true,
                                                    id: 'my_array_store',
                                                    // reader configs
                                                    fields: [
                                                             {name: 'id'  , type: 'int'   },
                                                             {name: 'port', type: 'int'   },
                                                             {name: 'url' , type: 'string'}
                                                            ],
                                                    data: confrest.confrests
                                                });

    return {

        /*
         * ================  Database Layout Form  =======================
         */
        databaseForm: {
            title: 'Configuration',
            id: 'database-panel',
            layout: 'fit',
            bodyPadding: 15,
            items: {
                title: 'Database JIO',
                layout: 'fit',
                frame: true,
                border: false,
                items: [
                        {
                            xtype: 'grid',
                            layout: 'fit',
                            store:  my_array_store,
                            columns: [
                                {
                                    text     : 'Id',
                                    width    : 75,
                                    sortable : false, 
                                    dataIndex: 'id'
                                },
                                {
                                    text     : 'Port', 
                                    width    : 75, 
                                    sortable : true, 
                                    dataIndex: 'port'
                                },
                                {
                                    text     : 'Url', 
                                    flex     : 1,
                                    sortable : true, 
                                    dataIndex: 'url'
                                }
                            ],
                            stripeRows: true
                        } // end Grid
                       ]
            }
        }
    };
}
