<!--
//     All Rights Reserved  Copyright 2013 - Morpho - Paris France
//
//     This module is free software: you can redistribute it and/or modify
//     it under the terms of the GNU General Public License as published by
//     the Free Software Foundation, either version 3 of the License, or
//     (at your option) any later version.
//
//     This program is distributed in the hope that it will be useful,
//     but WITHOUT ANY WARRANTY; without even the implied warranty of
//     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//     GNU General Public License for more details.
//
//     You should have received a copy of the GNU General Public License
//     along with this program.  If not, see <http://www.gnu.org/licenses/>.
-->
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8" />
  <title>JIO MATCHING</title>
  <!--<link rel="stylesheet" href="css/jio_matching.css">	-->
  <script type="text/javascript" src="lib/jquery/jquery.min.js"></script>  
  <script>
  
  function imageData() {
    this.filename       = null;
    this.data           = null,
    this.width          = 0;
    this.height         = 0;
    this.isset          = false;
  }
  imageData.prototype.setFilename = function(filename){
    this.filename=filename;
  }
  imageData.prototype.setData = function(data){
    this.data=data;
  }
  imageData.prototype.setWidth = function(width){
    this.width=width;
  }
  imageData.prototype.setHeight = function(height){
    this.height=height;
  }
  imageData.prototype.setIsset = function(isset){
    this.isset=isset;
  }
  imageData.prototype.getFilename = function(){
    return this.filename;
  }
  imageData.prototype.getData=function(){
    return this.data;
  }
  imageData.prototype.getWidth=function(){
    return this.width;
  }
  imageData.prototype.getHeight=function(){
    return this.height;
  }
  imageData.prototype.getIsset=function(){
    return this.isset;
  }
  
  
  var datainputcan=new imageData();
  var datainputref=new imageData();
  
    function clearCandidate() {
        $('#imginputcan').attr('src', "");
        $('#inputcan').val('');
        datainputcan=new imageData();
    }
    
    function clearReference(){
        $('#imginputref').attr('src', "");
        $('#inputref').val('');
        datainputref=new imageData();
    }
  
    function load(imgsdata,width,height){

        switch(imgsdata){
            case 'imginputcan':
                if(width < 256 || height < 256 )
                {
                    alert("Input image must be at least 256 X 256");
                    clearCandidate();
                }else{
                    datainputcan.setWidth(width);
                    datainputcan.setHeight(height);
                    datainputcan.setIsset(true);
                }
                break;
            case 'imginputref':
                if(width < 256 || height < 256 )
                {
                    alert("Input image must be at least 256 X 256");
                    clearReference();
                }else{
                    datainputref.setWidth(width);
                    datainputref.setHeight(height);
                    datainputref.setIsset(true);
                }
                break;
            default:
                alert("internal error 1");
                break;
        }
    }

  
  function readURL(input,id,filename) {
        if (input.files && input.files[0]) {
            var reader = new FileReader();
            reader.onload = function (e) {
                $('#img'+id).attr('src', e.target.result);
                switch(id){
                    case 'inputcan':
                        datainputcan.setData(e.target.result.split("data:image/jpeg;base64,")[1]);
                        break;
                    case 'inputref':
                        datainputref.setData(e.target.result.split("data:image/jpeg;base64,")[1]);
                        break;
                    default:
                        alert("internal error 2");
                        break;
                }
            }
            reader.readAsDataURL(input.files[0]);
        }
    }

    /**
 * Merge parts of image.
 */
    function constructImageRef(document_id) {
        
        if (null != document_id) {
            var clsImgId = isObjImageExist(document_id);
            if (null != clsImgId) {
                //if (clsImgId.getCountImage() == confrest.confrests.length && clsImgId.getFileName() != null && !clsImgId.isMerge()) {
                if (clsImgId.getCountImage() > shamirThreshold && clsImgId.getFileName() != null && !clsImgId.isMerge()) {
                    clsImgId.setMerge(true);
                    var mergeImageRefId = clsImgId.getImageBase64Shamir();
                    httpPost(fileToMatch.name, clsImgId.getFileName(), clsImgId.getWidth(), clsImgId.getHeight(), document_id, mergeImageRefId);
                }
            }
        }
    }
    
    /**
     * Post data to server for matching.    
     * @param fileinputMatch Input filename matching
     * @param fileinputRef Input file Reference
     * @param widthRef Width of Image Ref
     * @param heightRef Height of Image Ref
     * @param document_id ID image in database
     * @param mergeImageRefId Data image Ref in base64
     * @returns
     */
    function httpPost(fileinputCandidate, widthCandidate, heightCandidate, fileinputRef, widthRef, heightRef, mergeImageCanId ,mergeImageRefId) {
        var xmlHttp = null;

        xmlHttp = new XMLHttpRequest();
     
        xmlHttp.open( "POST", "/WebDin/test_matching?fileinputCandidate=" + fileinputCandidate + "&widthCandidate=" + widthCandidate + "&heightCandidate=" + heightCandidate + "&fileinputRef=" + fileinputRef + "&widthRef=" + widthRef + "&heightRef=" + heightRef, false );
        xmlHttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded"); // This is needed for any POST request made via Ajax
        xmlHttp.send(mergeImageCanId + ";" + mergeImageRefId);
        var matchResult = JSON.parse(xmlHttp.responseText);
        try {
        
            //TODO handle match result
        
            if (null != matchResult && parseInt(matchResult.score) >= 0) {
                    if($("#threshold").val() < parseInt(matchResult.score)){
                        $("#result").text("MATCHED (score= "+parseInt(matchResult.score)+" > "+$("#threshold").val()+" )");
                    }else{
                        $("#result").text("UNMATCHED (score= "+parseInt(matchResult.score)+" < "+$("#threshold").val()+" )");
                    }
            
                }
        } catch (exception) {
            alert("unhandled exception");
        }
        
    }

    
   $( document ).ready(function(){
    
    $(".inputfile").change(function(){
        readURL(this,this.attributes["id"].nodeValue);
    });
    
    $("img").load(function() {
        load($(this).attr("id"),$(this).height(),$(this).width())
    });
    
    $("#matching").click(function() {
        if (datainputcan.getIsset() && datainputref.getIsset()){
            httpPost("candidate.jpg",datainputcan.getWidth(),datainputcan.getHeight(),"reference.jpg",datainputref.getWidth(),datainputref.getHeight(),datainputcan.getData(),datainputref.getData());
        }else{
            alert("Please provide both input image before launching a match.");
        }
    });
    
    $('#clear').click(function(){
        clearCandidate();
        clearReference();
    });
  });
  </script>
</head>
<body>
  <table border="1" style="width: 100%;">
    <tr style="font-style:italic;">
		<td colspan="2" style="text-align: center;">JIO MATCHING WEB PAGE</td>
    </tr>

    <tr>
		<td style="text-align: center;">
			<img class="drop-zone" src="" id="imginputcan" alt="First image here (candidate)." height="280" weight="256"> 
		</td>
		<td style="text-align: center;">
			<img class="drop-zone" src="" id="imginputref" alt="Second image here (reference)." height="280" weight="256"> 
		</td>
	</tr>
    
     <tr>
		<td style="text-align: center;">
            <input type="file" id="inputcan" class="inputfile"/></input>
		</td>
		<td style="text-align: center;">
            <input type="file" id="inputref" class="inputfile"/></input>
		</td>
	</tr>
	
	<tr>
		<td colspan="2" style="text-align: center;">
            <h2 style="color:red;font-weight:bold;font-style:italic">Matching </h2><br/>
			<button id="matching">Matching</button>
        </td>
    </tr>  
    
    <tr>
        <td align="right">
            <h3>Threshold value: </h3><input value="200" min="0" max="1000" id="threshold" name="threshold" type="number">
        </td>
        <td align="left">
            <h3>Results: </h3><div id="result"></div>
        </td>
    </tr> 
	<tr>
      <td colspan="2" style="text-align: center;">
        <button id="clear">Clear</button>
      </td>
    </tr>
    
    
  </table>

  <div id="log">
  </div>
  
  
</body>
</html>
