package org.resilience;


import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.util.Properties;

public class RateToolConfigParser {
	
	private Properties _props;

	public RateToolConfigParser() throws RateToolException {
		InputStream config=null;
		try {
			this._props = new Properties();
			config = this.getClass().getClassLoader().getResourceAsStream("config.properties");
			this._props.load(config);
		} catch (IOException e) {
			throw new RateToolException(e.getMessage());
		}finally{
			try{
				if (config!=null)
					config.close();
			}catch(Exception ignore){}
		}
	}
	
	public String getProperty(String propertyName) throws RateToolException{
		if (null==this._props.getProperty(propertyName))
			throw new RateToolException("Property \"" +propertyName+"\" not found.");
		return this._props.getProperty(propertyName);
	}
	
	public String getHomePath(){
		return this._props.getProperty("RATETOOL_HOME");
	}
	public String getMonitorPath(){
		return this._props.getProperty("RATETOOL_HOME")+File.separator+this._props.getProperty("MONITORING_FOLDER");
	}
	public String getScanPath(){
		return this._props.getProperty("RATETOOL_HOME")+File.separator+this._props.getProperty("SCAN_FOLDER");
	}
	public String getResultsPath(){
		return this._props.getProperty("RATETOOL_HOME")+File.separator+this._props.getProperty("RESULTS_FOLDER");
	}
}
