package org.resilience.fileutilities;

import java.io.File;
import java.io.IOException;
import java.nio.charset.Charset;
import java.nio.charset.StandardCharsets;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;

import org.resilience.RateToolException;

public class FileOperation {
	public FileOperation(){
		 
	}
	
	public void waitAndCopy(String zipFile) throws InterruptedException{
		File file = null;

		file = new File(zipFile);
    	if (file.exists()){
    		long size = file.length();
    		Thread.sleep(1000);
    		long newsize = file.length();
    		while(size < newsize){
    			size = file.length();
        		Thread.sleep(1000);
        		newsize = file.length();
    		}
    	}

	}
	
	
	public void createFolders(String scanPath, String resultPath) throws RateToolException{
		// Create the temporary scan folder
        File scan_dir = new File(scanPath);
        if (!scan_dir.exists()) {
        	if(!scan_dir.mkdirs())
        		throw new RateToolException("Failed to create scan folder");
        }
        // Create the result folder
        File result_dir = new File(resultPath);
        if (!result_dir.exists()) {
        	if(!result_dir.mkdirs())
        		throw new RateToolException("Failed to create result folder");
        }
	}
	
	public void deleteScanFolder(String scanPath){
		File scan_dir = new File(scanPath);
		this.recursiveDelete(scan_dir);
	}
	
	public void copy(String sourceFile, String destFile) throws IOException{
		Files.copy(Paths.get(sourceFile), Paths.get(destFile));
	}
	
	public void move(String sourceFile, String destFile) throws IOException{
		this.copy(sourceFile, destFile);
		this.recursiveDelete(sourceFile);
	}
	
	private void recursiveDelete(String file) {
		File f=new File(file);
        if (!f.exists())
            return;
        if (f.isDirectory()) {
            for (File fi : f.listFiles()) {
                recursiveDelete(fi);
            }
        }
        f.delete();
    }
	
	private void recursiveDelete(File file) {
        if (!file.exists())
            return;
        if (file.isDirectory()) {
            for (File f : file.listFiles()) {
                recursiveDelete(f);
            }
        }
        file.delete();
    }
	
	public String getBuildTool( String projectpath){
		File directory = new File(projectpath);
		File[] fList = directory.listFiles();
	
	    for (File file : fList) {
	        if (file.getName().equals("Makefile")) {
	            return "make";
	        } else if (file.getName().equals("build.xml")) {
	        	return "ant";
	        }
	    }
	    return "none";
    
	}
	
	public void replace_compiler(String projectpath, String buildid, String uuid)throws IOException{
		
		Path path = Paths.get(projectpath + File.separator + "Makefile");
		Charset charset = StandardCharsets.UTF_8;

		String content = new String(Files.readAllBytes(path), charset);
		content = content.replaceAll("CC=gcc", "CC=sourceanalyzer -64 -Xmx2048m -b "+buildid+uuid+" gcc");
		content = content.replaceAll("CXX=g\\+\\+", "CXX=sourceanalyzer -64 -Xmx2048m -b "+buildid+uuid+" g\\+\\+");
		content = content.replaceAll("AR=ar", "AR=sourceanalyzer -64 -Xmx2048m -b "+buildid+uuid+" ar");
		Files.write(path, content.getBytes(charset));

	}
	
}
