// Note: Some Emscripten settings will significantly limit the speed of the generated code.
// Note: Some Emscripten settings may limit the speed of the generated code.
// The Module object: Our interface to the outside world. We import
// and export values on it, and do the work to get that through
// closure compiler if necessary. There are various ways Module can be used:
// 1. Not defined. We create it here
// 2. A function parameter, function(Module) { ..generated code.. }
// 3. pre-run appended it, var Module = {}; ..generated code..
// 4. External script tag defines var Module.
// We need to do an eval in order to handle the closure compiler
// case, where this code here is minified but Module was defined
// elsewhere (e.g. case 4 above). We also need to check if Module
// already exists (e.g. case 3 above).
// Note that if you want to run closure, and also to use Module
// after the generated code, you will need to define   var Module = {};
// before the code. Then that object will be used in the code, and you
// can continue to use Module afterwards as well.
var Module;
if (!Module) Module = eval('(function() { try { return Module || {} } catch(e) { return {} } })()');

// Sometimes an existing Module object exists with properties
// meant to overwrite the default module functionality. Here
// we collect those properties and reapply _after_ we configure
// the current environment's defaults to avoid having to be so
// defensive during initialization.
var moduleOverrides = {};
for (var key in Module) {
  if (Module.hasOwnProperty(key)) {
    moduleOverrides[key] = Module[key];
  }
}

// The environment setup code below is customized to use Module.
// *** Environment setup code ***
var ENVIRONMENT_IS_NODE = typeof process === 'object' && typeof require === 'function';
var ENVIRONMENT_IS_WEB = typeof window === 'object';
var ENVIRONMENT_IS_WORKER = typeof importScripts === 'function';
var ENVIRONMENT_IS_SHELL = !ENVIRONMENT_IS_WEB && !ENVIRONMENT_IS_NODE && !ENVIRONMENT_IS_WORKER;

if (ENVIRONMENT_IS_NODE) {
  // Expose functionality in the same simple way that the shells work
  // Note that we pollute the global namespace here, otherwise we break in node
  if (!Module['print']) Module['print'] = function print(x) {
    process['stdout'].write(x + '\n');
  };
  if (!Module['printErr']) Module['printErr'] = function printErr(x) {
    process['stderr'].write(x + '\n');
  };

  var nodeFS = require('fs');
  var nodePath = require('path');

  Module['read'] = function read(filename, binary) {
    filename = nodePath['normalize'](filename);
    var ret = nodeFS['readFileSync'](filename);
    // The path is absolute if the normalized version is the same as the resolved.
    if (!ret && filename != nodePath['resolve'](filename)) {
      filename = path.join(__dirname, '..', 'src', filename);
      ret = nodeFS['readFileSync'](filename);
    }
    if (ret && !binary) ret = ret.toString();
    return ret;
  };

  Module['readBinary'] = function readBinary(filename) { return Module['read'](filename, true) };

  Module['load'] = function load(f) {
    globalEval(read(f));
  };

  Module['arguments'] = process['argv'].slice(2);

  module['exports'] = Module;
}
else if (ENVIRONMENT_IS_SHELL) {
  if (!Module['print']) Module['print'] = print;
  if (typeof printErr != 'undefined') Module['printErr'] = printErr; // not present in v8 or older sm

  if (typeof read != 'undefined') {
    Module['read'] = read;
  } else {
    Module['read'] = function read() { throw 'no read() available (jsc?)' };
  }

  Module['readBinary'] = function readBinary(f) {
    return read(f, 'binary');
  };

  if (typeof scriptArgs != 'undefined') {
    Module['arguments'] = scriptArgs;
  } else if (typeof arguments != 'undefined') {
    Module['arguments'] = arguments;
  }

  this['Module'] = Module;

  eval("if (typeof gc === 'function' && gc.toString().indexOf('[native code]') > 0) var gc = undefined"); // wipe out the SpiderMonkey shell 'gc' function, which can confuse closure (uses it as a minified name, and it is then initted to a non-falsey value unexpectedly)
}
else if (ENVIRONMENT_IS_WEB || ENVIRONMENT_IS_WORKER) {
  Module['read'] = function read(url) {
    var xhr = new XMLHttpRequest();
    xhr.open('GET', url, false);
    xhr.send(null);
    return xhr.responseText;
  };

  if (typeof arguments != 'undefined') {
    Module['arguments'] = arguments;
  }

  if (typeof console !== 'undefined') {
    if (!Module['print']) Module['print'] = function print(x) {
      console.log(x);
    };
    if (!Module['printErr']) Module['printErr'] = function printErr(x) {
      console.log(x);
    };
  } else {
    // Probably a worker, and without console.log. We can do very little here...
    var TRY_USE_DUMP = false;
    if (!Module['print']) Module['print'] = (TRY_USE_DUMP && (typeof(dump) !== "undefined") ? (function(x) {
      dump(x);
    }) : (function(x) {
      // self.postMessage(x); // enable this if you want stdout to be sent as messages
    }));
  }

  if (ENVIRONMENT_IS_WEB) {
    this['Module'] = Module;
  } else {
    Module['load'] = importScripts;
  }
}
else {
  // Unreachable because SHELL is dependant on the others
  throw 'Unknown runtime environment. Where are we?';
}

function globalEval(x) {
  eval.call(null, x);
}
if (!Module['load'] == 'undefined' && Module['read']) {
  Module['load'] = function load(f) {
    globalEval(Module['read'](f));
  };
}
if (!Module['print']) {
  Module['print'] = function(){};
}
if (!Module['printErr']) {
  Module['printErr'] = Module['print'];
}
if (!Module['arguments']) {
  Module['arguments'] = [];
}
// *** Environment setup code ***

// Closure helpers
Module.print = Module['print'];
Module.printErr = Module['printErr'];

// Callbacks
Module['preRun'] = [];
Module['postRun'] = [];

// Merge back in the overrides
for (var key in moduleOverrides) {
  if (moduleOverrides.hasOwnProperty(key)) {
    Module[key] = moduleOverrides[key];
  }
}



// === Auto-generated preamble library stuff ===

//========================================
// Runtime code shared with compiler
//========================================

var Runtime = {
  stackSave: function () {
    return STACKTOP;
  },
  stackRestore: function (stackTop) {
    STACKTOP = stackTop;
  },
  forceAlign: function (target, quantum) {
    quantum = quantum || 4;
    if (quantum == 1) return target;
    if (isNumber(target) && isNumber(quantum)) {
      return Math.ceil(target/quantum)*quantum;
    } else if (isNumber(quantum) && isPowerOfTwo(quantum)) {
      return '(((' +target + ')+' + (quantum-1) + ')&' + -quantum + ')';
    }
    return 'Math.ceil((' + target + ')/' + quantum + ')*' + quantum;
  },
  isNumberType: function (type) {
    return type in Runtime.INT_TYPES || type in Runtime.FLOAT_TYPES;
  },
  isPointerType: function isPointerType(type) {
  return type[type.length-1] == '*';
},
  isStructType: function isStructType(type) {
  if (isPointerType(type)) return false;
  if (isArrayType(type)) return true;
  if (/<?\{ ?[^}]* ?\}>?/.test(type)) return true; // { i32, i8 } etc. - anonymous struct types
  // See comment in isStructPointerType()
  return type[0] == '%';
},
  INT_TYPES: {"i1":0,"i8":0,"i16":0,"i32":0,"i64":0},
  FLOAT_TYPES: {"float":0,"double":0},
  or64: function (x, y) {
    var l = (x | 0) | (y | 0);
    var h = (Math.round(x / 4294967296) | Math.round(y / 4294967296)) * 4294967296;
    return l + h;
  },
  and64: function (x, y) {
    var l = (x | 0) & (y | 0);
    var h = (Math.round(x / 4294967296) & Math.round(y / 4294967296)) * 4294967296;
    return l + h;
  },
  xor64: function (x, y) {
    var l = (x | 0) ^ (y | 0);
    var h = (Math.round(x / 4294967296) ^ Math.round(y / 4294967296)) * 4294967296;
    return l + h;
  },
  getNativeTypeSize: function (type) {
    switch (type) {
      case 'i1': case 'i8': return 1;
      case 'i16': return 2;
      case 'i32': return 4;
      case 'i64': return 8;
      case 'float': return 4;
      case 'double': return 8;
      default: {
        if (type[type.length-1] === '*') {
          return Runtime.QUANTUM_SIZE; // A pointer
        } else if (type[0] === 'i') {
          var bits = parseInt(type.substr(1));
          assert(bits % 8 === 0);
          return bits/8;
        } else {
          return 0;
        }
      }
    }
  },
  getNativeFieldSize: function (type) {
    return Math.max(Runtime.getNativeTypeSize(type), Runtime.QUANTUM_SIZE);
  },
  dedup: function dedup(items, ident) {
  var seen = {};
  if (ident) {
    return items.filter(function(item) {
      if (seen[item[ident]]) return false;
      seen[item[ident]] = true;
      return true;
    });
  } else {
    return items.filter(function(item) {
      if (seen[item]) return false;
      seen[item] = true;
      return true;
    });
  }
},
  set: function set() {
  var args = typeof arguments[0] === 'object' ? arguments[0] : arguments;
  var ret = {};
  for (var i = 0; i < args.length; i++) {
    ret[args[i]] = 0;
  }
  return ret;
},
  STACK_ALIGN: 8,
  getAlignSize: function (type, size, vararg) {
    // we align i64s and doubles on 64-bit boundaries, unlike x86
    if (vararg) return 8;
    if (!vararg && (type == 'i64' || type == 'double')) return 8;
    if (!type) return Math.min(size, 8); // align structures internally to 64 bits
    return Math.min(size || (type ? Runtime.getNativeFieldSize(type) : 0), Runtime.QUANTUM_SIZE);
  },
  calculateStructAlignment: function calculateStructAlignment(type) {
    type.flatSize = 0;
    type.alignSize = 0;
    var diffs = [];
    var prev = -1;
    var index = 0;
    type.flatIndexes = type.fields.map(function(field) {
      index++;
      var size, alignSize;
      if (Runtime.isNumberType(field) || Runtime.isPointerType(field)) {
        size = Runtime.getNativeTypeSize(field); // pack char; char; in structs, also char[X]s.
        alignSize = Runtime.getAlignSize(field, size);
      } else if (Runtime.isStructType(field)) {
        if (field[1] === '0') {
          // this is [0 x something]. When inside another structure like here, it must be at the end,
          // and it adds no size
          // XXX this happens in java-nbody for example... assert(index === type.fields.length, 'zero-length in the middle!');
          size = 0;
          if (Types.types[field]) {
            alignSize = Runtime.getAlignSize(null, Types.types[field].alignSize);
          } else {
            alignSize = type.alignSize || QUANTUM_SIZE;
          }
        } else {
          size = Types.types[field].flatSize;
          alignSize = Runtime.getAlignSize(null, Types.types[field].alignSize);
        }
      } else if (field[0] == 'b') {
        // bN, large number field, like a [N x i8]
        size = field.substr(1)|0;
        alignSize = 1;
      } else if (field[0] === '<') {
        // vector type
        size = alignSize = Types.types[field].flatSize; // fully aligned
      } else if (field[0] === 'i') {
        // illegal integer field, that could not be legalized because it is an internal structure field
        // it is ok to have such fields, if we just use them as markers of field size and nothing more complex
        size = alignSize = parseInt(field.substr(1))/8;
        assert(size % 1 === 0, 'cannot handle non-byte-size field ' + field);
      } else {
        assert(false, 'invalid type for calculateStructAlignment');
      }
      if (type.packed) alignSize = 1;
      type.alignSize = Math.max(type.alignSize, alignSize);
      var curr = Runtime.alignMemory(type.flatSize, alignSize); // if necessary, place this on aligned memory
      type.flatSize = curr + size;
      if (prev >= 0) {
        diffs.push(curr-prev);
      }
      prev = curr;
      return curr;
    });
    if (type.name_ && type.name_[0] === '[') {
      // arrays have 2 elements, so we get the proper difference. then we scale here. that way we avoid
      // allocating a potentially huge array for [999999 x i8] etc.
      type.flatSize = parseInt(type.name_.substr(1))*type.flatSize/2;
    }
    type.flatSize = Runtime.alignMemory(type.flatSize, type.alignSize);
    if (diffs.length == 0) {
      type.flatFactor = type.flatSize;
    } else if (Runtime.dedup(diffs).length == 1) {
      type.flatFactor = diffs[0];
    }
    type.needsFlattening = (type.flatFactor != 1);
    return type.flatIndexes;
  },
  generateStructInfo: function (struct, typeName, offset) {
    var type, alignment;
    if (typeName) {
      offset = offset || 0;
      type = (typeof Types === 'undefined' ? Runtime.typeInfo : Types.types)[typeName];
      if (!type) return null;
      if (type.fields.length != struct.length) {
        printErr('Number of named fields must match the type for ' + typeName + ': possibly duplicate struct names. Cannot return structInfo');
        return null;
      }
      alignment = type.flatIndexes;
    } else {
      var type = { fields: struct.map(function(item) { return item[0] }) };
      alignment = Runtime.calculateStructAlignment(type);
    }
    var ret = {
      __size__: type.flatSize
    };
    if (typeName) {
      struct.forEach(function(item, i) {
        if (typeof item === 'string') {
          ret[item] = alignment[i] + offset;
        } else {
          // embedded struct
          var key;
          for (var k in item) key = k;
          ret[key] = Runtime.generateStructInfo(item[key], type.fields[i], alignment[i]);
        }
      });
    } else {
      struct.forEach(function(item, i) {
        ret[item[1]] = alignment[i];
      });
    }
    return ret;
  },
  dynCall: function (sig, ptr, args) {
    if (args && args.length) {
      assert(args.length == sig.length-1);
      return FUNCTION_TABLE[ptr].apply(null, args);
    } else {
      assert(sig.length == 1);
      return FUNCTION_TABLE[ptr]();
    }
  },
  addFunction: function (func) {
    var table = FUNCTION_TABLE;
    var ret = table.length;
    assert(ret % 2 === 0);
    table.push(func);
    for (var i = 0; i < 2-1; i++) table.push(0);
    return ret;
  },
  removeFunction: function (index) {
    var table = FUNCTION_TABLE;
    table[index] = null;
  },
  getAsmConst: function (code, numArgs) {
    // code is a constant string on the heap, so we can cache these
    if (!Runtime.asmConstCache) Runtime.asmConstCache = {};
    var func = Runtime.asmConstCache[code];
    if (func) return func;
    var args = [];
    for (var i = 0; i < numArgs; i++) {
      args.push(String.fromCharCode(36) + i); // $0, $1 etc
    }
    code = Pointer_stringify(code);
    if (code[0] === '"') {
      // tolerate EM_ASM("..code..") even though EM_ASM(..code..) is correct
      if (code.indexOf('"', 1) === code.length-1) {
        code = code.substr(1, code.length-2);
      } else {
        // something invalid happened, e.g. EM_ASM("..code($0)..", input)
        abort('invalid EM_ASM input |' + code + '|. Please use EM_ASM(..code..) (no quotes) or EM_ASM({ ..code($0).. }, input) (to input values)');
      }
    }
    return Runtime.asmConstCache[code] = eval('(function(' + args.join(',') + '){ ' + code + ' })'); // new Function does not allow upvars in node
  },
  warnOnce: function (text) {
    if (!Runtime.warnOnce.shown) Runtime.warnOnce.shown = {};
    if (!Runtime.warnOnce.shown[text]) {
      Runtime.warnOnce.shown[text] = 1;
      Module.printErr(text);
    }
  },
  funcWrappers: {},
  getFuncWrapper: function (func, sig) {
    assert(sig);
    if (!Runtime.funcWrappers[func]) {
      Runtime.funcWrappers[func] = function dynCall_wrapper() {
        return Runtime.dynCall(sig, func, arguments);
      };
    }
    return Runtime.funcWrappers[func];
  },
  UTF8Processor: function () {
    var buffer = [];
    var needed = 0;
    this.processCChar = function (code) {
      code = code & 0xFF;

      if (buffer.length == 0) {
        if ((code & 0x80) == 0x00) {        // 0xxxxxxx
          return String.fromCharCode(code);
        }
        buffer.push(code);
        if ((code & 0xE0) == 0xC0) {        // 110xxxxx
          needed = 1;
        } else if ((code & 0xF0) == 0xE0) { // 1110xxxx
          needed = 2;
        } else {                            // 11110xxx
          needed = 3;
        }
        return '';
      }

      if (needed) {
        buffer.push(code);
        needed--;
        if (needed > 0) return '';
      }

      var c1 = buffer[0];
      var c2 = buffer[1];
      var c3 = buffer[2];
      var c4 = buffer[3];
      var ret;
      if (buffer.length == 2) {
        ret = String.fromCharCode(((c1 & 0x1F) << 6)  | (c2 & 0x3F));
      } else if (buffer.length == 3) {
        ret = String.fromCharCode(((c1 & 0x0F) << 12) | ((c2 & 0x3F) << 6)  | (c3 & 0x3F));
      } else {
        // http://mathiasbynens.be/notes/javascript-encoding#surrogate-formulae
        var codePoint = ((c1 & 0x07) << 18) | ((c2 & 0x3F) << 12) |
                        ((c3 & 0x3F) << 6)  | (c4 & 0x3F);
        ret = String.fromCharCode(
          Math.floor((codePoint - 0x10000) / 0x400) + 0xD800,
          (codePoint - 0x10000) % 0x400 + 0xDC00);
      }
      buffer.length = 0;
      return ret;
    }
    this.processJSString = function processJSString(string) {
      string = unescape(encodeURIComponent(string));
      var ret = [];
      for (var i = 0; i < string.length; i++) {
        ret.push(string.charCodeAt(i));
      }
      return ret;
    }
  },
  getCompilerSetting: function (name) {
    throw 'You must build with -s RETAIN_COMPILER_SETTINGS=1 for Runtime.getCompilerSetting or emscripten_get_compiler_setting to work';
  },
  stackAlloc: function (size) { var ret = STACKTOP;STACKTOP = (STACKTOP + size)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0); return ret; },
  staticAlloc: function (size) { var ret = STATICTOP;STATICTOP = (STATICTOP + (assert(!staticSealed),size))|0;STATICTOP = (((STATICTOP)+7)&-8); return ret; },
  dynamicAlloc: function (size) { var ret = DYNAMICTOP;DYNAMICTOP = (DYNAMICTOP + (assert(DYNAMICTOP > 0),size))|0;DYNAMICTOP = (((DYNAMICTOP)+7)&-8); if (DYNAMICTOP >= TOTAL_MEMORY) enlargeMemory();; return ret; },
  alignMemory: function (size,quantum) { var ret = size = Math.ceil((size)/(quantum ? quantum : 8))*(quantum ? quantum : 8); return ret; },
  makeBigInt: function (low,high,unsigned) { var ret = (unsigned ? ((low>>>0)+((high>>>0)*4294967296)) : ((low>>>0)+((high|0)*4294967296))); return ret; },
  GLOBAL_BASE: 8,
  QUANTUM_SIZE: 4,
  __dummy__: 0
}


Module['Runtime'] = Runtime;









//========================================
// Runtime essentials
//========================================

var __THREW__ = 0; // Used in checking for thrown exceptions.
var setjmpId = 1; // Used in setjmp/longjmp
var setjmpLabels = {};

var ABORT = false; // whether we are quitting the application. no code should run after this. set in exit() and abort()
var EXITSTATUS = 0;

var undef = 0;
// tempInt is used for 32-bit signed values or smaller. tempBigInt is used
// for 32-bit unsigned values or more than 32 bits. TODO: audit all uses of tempInt
var tempValue, tempInt, tempBigInt, tempInt2, tempBigInt2, tempPair, tempBigIntI, tempBigIntR, tempBigIntS, tempBigIntP, tempBigIntD, tempDouble, tempFloat;
var tempI64, tempI64b;
var tempRet0, tempRet1, tempRet2, tempRet3, tempRet4, tempRet5, tempRet6, tempRet7, tempRet8, tempRet9;

function assert(condition, text) {
  if (!condition) {
    abort('Assertion failed: ' + text);
  }
}

var globalScope = this;

// C calling interface. A convenient way to call C functions (in C files, or
// defined with extern "C").
//
// Note: LLVM optimizations can inline and remove functions, after which you will not be
//       able to call them. Closure can also do so. To avoid that, add your function to
//       the exports using something like
//
//         -s EXPORTED_FUNCTIONS='["_main", "_myfunc"]'
//
// @param ident      The name of the C function (note that C++ functions will be name-mangled - use extern "C")
// @param returnType The return type of the function, one of the JS types 'number', 'string' or 'array' (use 'number' for any C pointer, and
//                   'array' for JavaScript arrays and typed arrays; note that arrays are 8-bit).
// @param argTypes   An array of the types of arguments for the function (if there are no arguments, this can be ommitted). Types are as in returnType,
//                   except that 'array' is not possible (there is no way for us to know the length of the array)
// @param args       An array of the arguments to the function, as native JS values (as in returnType)
//                   Note that string arguments will be stored on the stack (the JS string will become a C string on the stack).
// @return           The return value, as a native JS value (as in returnType)
function ccall(ident, returnType, argTypes, args) {
  return ccallFunc(getCFunc(ident), returnType, argTypes, args);
}
Module["ccall"] = ccall;

// Returns the C function with a specified identifier (for C++, you need to do manual name mangling)
function getCFunc(ident) {
  try {
    var func = Module['_' + ident]; // closure exported function
    if (!func) func = eval('_' + ident); // explicit lookup
  } catch(e) {
  }
  assert(func, 'Cannot call unknown function ' + ident + ' (perhaps LLVM optimizations or closure removed it?)');
  return func;
}

// Internal function that does a C call using a function, not an identifier
function ccallFunc(func, returnType, argTypes, args) {
  var stack = 0;
  function toC(value, type) {
    if (type == 'string') {
      if (value === null || value === undefined || value === 0) return 0; // null string
      value = intArrayFromString(value);
      type = 'array';
    }
    if (type == 'array') {
      if (!stack) stack = Runtime.stackSave();
      var ret = Runtime.stackAlloc(value.length);
      writeArrayToMemory(value, ret);
      return ret;
    }
    return value;
  }
  function fromC(value, type) {
    if (type == 'string') {
      return Pointer_stringify(value);
    }
    assert(type != 'array');
    return value;
  }
  var i = 0;
  var cArgs = args ? args.map(function(arg) {
    return toC(arg, argTypes[i++]);
  }) : [];
  var ret = fromC(func.apply(null, cArgs), returnType);
  if (stack) Runtime.stackRestore(stack);
  return ret;
}

// Returns a native JS wrapper for a C function. This is similar to ccall, but
// returns a function you can call repeatedly in a normal way. For example:
//
//   var my_function = cwrap('my_c_function', 'number', ['number', 'number']);
//   alert(my_function(5, 22));
//   alert(my_function(99, 12));
//
function cwrap(ident, returnType, argTypes) {
  var func = getCFunc(ident);
  return function() {
    return ccallFunc(func, returnType, argTypes, Array.prototype.slice.call(arguments));
  }
}
Module["cwrap"] = cwrap;

// Sets a value in memory in a dynamic way at run-time. Uses the
// type data. This is the same as makeSetValue, except that
// makeSetValue is done at compile-time and generates the needed
// code then, whereas this function picks the right code at
// run-time.
// Note that setValue and getValue only do *aligned* writes and reads!
// Note that ccall uses JS types as for defining types, while setValue and
// getValue need LLVM types ('i8', 'i32') - this is a lower-level operation
function setValue(ptr, value, type, noSafe) {
  type = type || 'i8';
  if (type.charAt(type.length-1) === '*') type = 'i32'; // pointers are 32-bit
    switch(type) {
      case 'i1': HEAP8[(ptr)]=value; break;
      case 'i8': HEAP8[(ptr)]=value; break;
      case 'i16': HEAP16[((ptr)>>1)]=value; break;
      case 'i32': HEAP32[((ptr)>>2)]=value; break;
      case 'i64': (tempI64 = [value>>>0,(tempDouble=value,Math_abs(tempDouble) >= 1 ? (tempDouble > 0 ? Math_min(Math_floor((tempDouble)/4294967296), 4294967295)>>>0 : (~~(Math_ceil((tempDouble - +(((~~(tempDouble)))>>>0))/4294967296)))>>>0) : 0)],HEAP32[((ptr)>>2)]=tempI64[0],HEAP32[(((ptr)+(4))>>2)]=tempI64[1]); break;
      case 'float': HEAPF32[((ptr)>>2)]=value; break;
      case 'double': HEAPF64[((ptr)>>3)]=value; break;
      default: abort('invalid type for setValue: ' + type);
    }
}
Module['setValue'] = setValue;

// Parallel to setValue.
function getValue(ptr, type, noSafe) {
  type = type || 'i8';
  if (type.charAt(type.length-1) === '*') type = 'i32'; // pointers are 32-bit
    switch(type) {
      case 'i1': return HEAP8[(ptr)];
      case 'i8': return HEAP8[(ptr)];
      case 'i16': return HEAP16[((ptr)>>1)];
      case 'i32': return HEAP32[((ptr)>>2)];
      case 'i64': return HEAP32[((ptr)>>2)];
      case 'float': return HEAPF32[((ptr)>>2)];
      case 'double': return HEAPF64[((ptr)>>3)];
      default: abort('invalid type for setValue: ' + type);
    }
  return null;
}
Module['getValue'] = getValue;

var ALLOC_NORMAL = 0; // Tries to use _malloc()
var ALLOC_STACK = 1; // Lives for the duration of the current function call
var ALLOC_STATIC = 2; // Cannot be freed
var ALLOC_DYNAMIC = 3; // Cannot be freed except through sbrk
var ALLOC_NONE = 4; // Do not allocate
Module['ALLOC_NORMAL'] = ALLOC_NORMAL;
Module['ALLOC_STACK'] = ALLOC_STACK;
Module['ALLOC_STATIC'] = ALLOC_STATIC;
Module['ALLOC_DYNAMIC'] = ALLOC_DYNAMIC;
Module['ALLOC_NONE'] = ALLOC_NONE;

// allocate(): This is for internal use. You can use it yourself as well, but the interface
//             is a little tricky (see docs right below). The reason is that it is optimized
//             for multiple syntaxes to save space in generated code. So you should
//             normally not use allocate(), and instead allocate memory using _malloc(),
//             initialize it with setValue(), and so forth.
// @slab: An array of data, or a number. If a number, then the size of the block to allocate,
//        in *bytes* (note that this is sometimes confusing: the next parameter does not
//        affect this!)
// @types: Either an array of types, one for each byte (or 0 if no type at that position),
//         or a single type which is used for the entire block. This only matters if there
//         is initial data - if @slab is a number, then this does not matter at all and is
//         ignored.
// @allocator: How to allocate memory, see ALLOC_*
function allocate(slab, types, allocator, ptr) {
  var zeroinit, size;
  if (typeof slab === 'number') {
    zeroinit = true;
    size = slab;
  } else {
    zeroinit = false;
    size = slab.length;
  }

  var singleType = typeof types === 'string' ? types : null;

  var ret;
  if (allocator == ALLOC_NONE) {
    ret = ptr;
  } else {
    ret = [_malloc, Runtime.stackAlloc, Runtime.staticAlloc, Runtime.dynamicAlloc][allocator === undefined ? ALLOC_STATIC : allocator](Math.max(size, singleType ? 1 : types.length));
  }

  if (zeroinit) {
    var ptr = ret, stop;
    assert((ret & 3) == 0);
    stop = ret + (size & ~3);
    for (; ptr < stop; ptr += 4) {
      HEAP32[((ptr)>>2)]=0;
    }
    stop = ret + size;
    while (ptr < stop) {
      HEAP8[((ptr++)|0)]=0;
    }
    return ret;
  }

  if (singleType === 'i8') {
    if (slab.subarray || slab.slice) {
      HEAPU8.set(slab, ret);
    } else {
      HEAPU8.set(new Uint8Array(slab), ret);
    }
    return ret;
  }

  var i = 0, type, typeSize, previousType;
  while (i < size) {
    var curr = slab[i];

    if (typeof curr === 'function') {
      curr = Runtime.getFunctionIndex(curr);
    }

    type = singleType || types[i];
    if (type === 0) {
      i++;
      continue;
    }
    assert(type, 'Must know what type to store in allocate!');

    if (type == 'i64') type = 'i32'; // special case: we have one i32 here, and one i32 later

    setValue(ret+i, curr, type);

    // no need to look up size unless type changes, so cache it
    if (previousType !== type) {
      typeSize = Runtime.getNativeTypeSize(type);
      previousType = type;
    }
    i += typeSize;
  }

  return ret;
}
Module['allocate'] = allocate;

function Pointer_stringify(ptr, /* optional */ length) {
  // TODO: use TextDecoder
  // Find the length, and check for UTF while doing so
  var hasUtf = false;
  var t;
  var i = 0;
  while (1) {
    assert(ptr + i < TOTAL_MEMORY);
    t = HEAPU8[(((ptr)+(i))|0)];
    if (t >= 128) hasUtf = true;
    else if (t == 0 && !length) break;
    i++;
    if (length && i == length) break;
  }
  if (!length) length = i;

  var ret = '';

  if (!hasUtf) {
    var MAX_CHUNK = 1024; // split up into chunks, because .apply on a huge string can overflow the stack
    var curr;
    while (length > 0) {
      curr = String.fromCharCode.apply(String, HEAPU8.subarray(ptr, ptr + Math.min(length, MAX_CHUNK)));
      ret = ret ? ret + curr : curr;
      ptr += MAX_CHUNK;
      length -= MAX_CHUNK;
    }
    return ret;
  }

  var utf8 = new Runtime.UTF8Processor();
  for (i = 0; i < length; i++) {
    assert(ptr + i < TOTAL_MEMORY);
    t = HEAPU8[(((ptr)+(i))|0)];
    ret += utf8.processCChar(t);
  }
  return ret;
}
Module['Pointer_stringify'] = Pointer_stringify;

// Given a pointer 'ptr' to a null-terminated UTF16LE-encoded string in the emscripten HEAP, returns
// a copy of that string as a Javascript String object.
function UTF16ToString(ptr) {
  var i = 0;

  var str = '';
  while (1) {
    var codeUnit = HEAP16[(((ptr)+(i*2))>>1)];
    if (codeUnit == 0)
      return str;
    ++i;
    // fromCharCode constructs a character from a UTF-16 code unit, so we can pass the UTF16 string right through.
    str += String.fromCharCode(codeUnit);
  }
}
Module['UTF16ToString'] = UTF16ToString;

// Copies the given Javascript String object 'str' to the emscripten HEAP at address 'outPtr',
// null-terminated and encoded in UTF16LE form. The copy will require at most (str.length*2+1)*2 bytes of space in the HEAP.
function stringToUTF16(str, outPtr) {
  for(var i = 0; i < str.length; ++i) {
    // charCodeAt returns a UTF-16 encoded code unit, so it can be directly written to the HEAP.
    var codeUnit = str.charCodeAt(i); // possibly a lead surrogate
    HEAP16[(((outPtr)+(i*2))>>1)]=codeUnit;
  }
  // Null-terminate the pointer to the HEAP.
  HEAP16[(((outPtr)+(str.length*2))>>1)]=0;
}
Module['stringToUTF16'] = stringToUTF16;

// Given a pointer 'ptr' to a null-terminated UTF32LE-encoded string in the emscripten HEAP, returns
// a copy of that string as a Javascript String object.
function UTF32ToString(ptr) {
  var i = 0;

  var str = '';
  while (1) {
    var utf32 = HEAP32[(((ptr)+(i*4))>>2)];
    if (utf32 == 0)
      return str;
    ++i;
    // Gotcha: fromCharCode constructs a character from a UTF-16 encoded code (pair), not from a Unicode code point! So encode the code point to UTF-16 for constructing.
    if (utf32 >= 0x10000) {
      var ch = utf32 - 0x10000;
      str += String.fromCharCode(0xD800 | (ch >> 10), 0xDC00 | (ch & 0x3FF));
    } else {
      str += String.fromCharCode(utf32);
    }
  }
}
Module['UTF32ToString'] = UTF32ToString;

// Copies the given Javascript String object 'str' to the emscripten HEAP at address 'outPtr',
// null-terminated and encoded in UTF32LE form. The copy will require at most (str.length+1)*4 bytes of space in the HEAP,
// but can use less, since str.length does not return the number of characters in the string, but the number of UTF-16 code units in the string.
function stringToUTF32(str, outPtr) {
  var iChar = 0;
  for(var iCodeUnit = 0; iCodeUnit < str.length; ++iCodeUnit) {
    // Gotcha: charCodeAt returns a 16-bit word that is a UTF-16 encoded code unit, not a Unicode code point of the character! We must decode the string to UTF-32 to the heap.
    var codeUnit = str.charCodeAt(iCodeUnit); // possibly a lead surrogate
    if (codeUnit >= 0xD800 && codeUnit <= 0xDFFF) {
      var trailSurrogate = str.charCodeAt(++iCodeUnit);
      codeUnit = 0x10000 + ((codeUnit & 0x3FF) << 10) | (trailSurrogate & 0x3FF);
    }
    HEAP32[(((outPtr)+(iChar*4))>>2)]=codeUnit;
    ++iChar;
  }
  // Null-terminate the pointer to the HEAP.
  HEAP32[(((outPtr)+(iChar*4))>>2)]=0;
}
Module['stringToUTF32'] = stringToUTF32;

function demangle(func) {
  var i = 3;
  // params, etc.
  var basicTypes = {
    'v': 'void',
    'b': 'bool',
    'c': 'char',
    's': 'short',
    'i': 'int',
    'l': 'long',
    'f': 'float',
    'd': 'double',
    'w': 'wchar_t',
    'a': 'signed char',
    'h': 'unsigned char',
    't': 'unsigned short',
    'j': 'unsigned int',
    'm': 'unsigned long',
    'x': 'long long',
    'y': 'unsigned long long',
    'z': '...'
  };
  var subs = [];
  var first = true;
  function dump(x) {
    //return;
    if (x) Module.print(x);
    Module.print(func);
    var pre = '';
    for (var a = 0; a < i; a++) pre += ' ';
    Module.print (pre + '^');
  }
  function parseNested() {
    i++;
    if (func[i] === 'K') i++; // ignore const
    var parts = [];
    while (func[i] !== 'E') {
      if (func[i] === 'S') { // substitution
        i++;
        var next = func.indexOf('_', i);
        var num = func.substring(i, next) || 0;
        parts.push(subs[num] || '?');
        i = next+1;
        continue;
      }
      if (func[i] === 'C') { // constructor
        parts.push(parts[parts.length-1]);
        i += 2;
        continue;
      }
      var size = parseInt(func.substr(i));
      var pre = size.toString().length;
      if (!size || !pre) { i--; break; } // counter i++ below us
      var curr = func.substr(i + pre, size);
      parts.push(curr);
      subs.push(curr);
      i += pre + size;
    }
    i++; // skip E
    return parts;
  }
  function parse(rawList, limit, allowVoid) { // main parser
    limit = limit || Infinity;
    var ret = '', list = [];
    function flushList() {
      return '(' + list.join(', ') + ')';
    }
    var name;
    if (func[i] === 'N') {
      // namespaced N-E
      name = parseNested().join('::');
      limit--;
      if (limit === 0) return rawList ? [name] : name;
    } else {
      // not namespaced
      if (func[i] === 'K' || (first && func[i] === 'L')) i++; // ignore const and first 'L'
      var size = parseInt(func.substr(i));
      if (size) {
        var pre = size.toString().length;
        name = func.substr(i + pre, size);
        i += pre + size;
      }
    }
    first = false;
    if (func[i] === 'I') {
      i++;
      var iList = parse(true);
      var iRet = parse(true, 1, true);
      ret += iRet[0] + ' ' + name + '<' + iList.join(', ') + '>';
    } else {
      ret = name;
    }
    paramLoop: while (i < func.length && limit-- > 0) {
      //dump('paramLoop');
      var c = func[i++];
      if (c in basicTypes) {
        list.push(basicTypes[c]);
      } else {
        switch (c) {
          case 'P': list.push(parse(true, 1, true)[0] + '*'); break; // pointer
          case 'R': list.push(parse(true, 1, true)[0] + '&'); break; // reference
          case 'L': { // literal
            i++; // skip basic type
            var end = func.indexOf('E', i);
            var size = end - i;
            list.push(func.substr(i, size));
            i += size + 2; // size + 'EE'
            break;
          }
          case 'A': { // array
            var size = parseInt(func.substr(i));
            i += size.toString().length;
            if (func[i] !== '_') throw '?';
            i++; // skip _
            list.push(parse(true, 1, true)[0] + ' [' + size + ']');
            break;
          }
          case 'E': break paramLoop;
          default: ret += '?' + c; break paramLoop;
        }
      }
    }
    if (!allowVoid && list.length === 1 && list[0] === 'void') list = []; // avoid (void)
    return rawList ? list : ret + flushList();
  }
  try {
    // Special-case the entry point, since its name differs from other name mangling.
    if (func == 'Object._main' || func == '_main') {
      return 'main()';
    }
    if (typeof func === 'number') func = Pointer_stringify(func);
    if (func[0] !== '_') return func;
    if (func[1] !== '_') return func; // C function
    if (func[2] !== 'Z') return func;
    switch (func[3]) {
      case 'n': return 'operator new()';
      case 'd': return 'operator delete()';
    }
    return parse();
  } catch(e) {
    return func;
  }
}

function demangleAll(text) {
  return text.replace(/__Z[\w\d_]+/g, function(x) { var y = demangle(x); return x === y ? x : (x + ' [' + y + ']') });
}

function stackTrace() {
  var stack = new Error().stack;
  return stack ? demangleAll(stack) : '(no stack trace available)'; // Stack trace is not available at least on IE10 and Safari 6.
}

// Memory management

var PAGE_SIZE = 4096;
function alignMemoryPage(x) {
  return (x+4095)&-4096;
}

var HEAP;
var HEAP8, HEAPU8, HEAP16, HEAPU16, HEAP32, HEAPU32, HEAPF32, HEAPF64;

var STATIC_BASE = 0, STATICTOP = 0, staticSealed = false; // static area
var STACK_BASE = 0, STACKTOP = 0, STACK_MAX = 0; // stack area
var DYNAMIC_BASE = 0, DYNAMICTOP = 0; // dynamic area handled by sbrk

function enlargeMemory() {
  abort('Cannot enlarge memory arrays. Either (1) compile with -s TOTAL_MEMORY=X with X higher than the current value ' + TOTAL_MEMORY + ', (2) compile with ALLOW_MEMORY_GROWTH which adjusts the size at runtime but prevents some optimizations, or (3) set Module.TOTAL_MEMORY before the program runs.');
}

var TOTAL_STACK = Module['TOTAL_STACK'] || 5242880;
var TOTAL_MEMORY = Module['TOTAL_MEMORY'] || 16777216;
var FAST_MEMORY = Module['FAST_MEMORY'] || 2097152;


// Initialize the runtime's memory
// check for full engine support (use string 'subarray' to avoid closure compiler confusion)
assert(typeof Int32Array !== 'undefined' && typeof Float64Array !== 'undefined' && !!(new Int32Array(1)['subarray']) && !!(new Int32Array(1)['set']),
       'JS engine does not provide full typed array support');

var buffer = new ArrayBuffer(TOTAL_MEMORY);
HEAP8 = new Int8Array(buffer);
HEAP16 = new Int16Array(buffer);
HEAP32 = new Int32Array(buffer);
HEAPU8 = new Uint8Array(buffer);
HEAPU16 = new Uint16Array(buffer);
HEAPU32 = new Uint32Array(buffer);
HEAPF32 = new Float32Array(buffer);
HEAPF64 = new Float64Array(buffer);

// Endianness check (note: assumes compiler arch was little-endian)
HEAP32[0] = 255;
assert(HEAPU8[0] === 255 && HEAPU8[3] === 0, 'Typed arrays 2 must be run on a little-endian system');

Module['HEAP'] = HEAP;
Module['HEAP8'] = HEAP8;
Module['HEAP16'] = HEAP16;
Module['HEAP32'] = HEAP32;
Module['HEAPU8'] = HEAPU8;
Module['HEAPU16'] = HEAPU16;
Module['HEAPU32'] = HEAPU32;
Module['HEAPF32'] = HEAPF32;
Module['HEAPF64'] = HEAPF64;

function callRuntimeCallbacks(callbacks) {
  while(callbacks.length > 0) {
    var callback = callbacks.shift();
    if (typeof callback == 'function') {
      callback();
      continue;
    }
    var func = callback.func;
    if (typeof func === 'number') {
      if (callback.arg === undefined) {
        Runtime.dynCall('v', func);
      } else {
        Runtime.dynCall('vi', func, [callback.arg]);
      }
    } else {
      func(callback.arg === undefined ? null : callback.arg);
    }
  }
}

var __ATPRERUN__  = []; // functions called before the runtime is initialized
var __ATINIT__    = []; // functions called during startup
var __ATMAIN__    = []; // functions called when main() is to be run
var __ATEXIT__    = []; // functions called during shutdown
var __ATPOSTRUN__ = []; // functions called after the runtime has exited

var runtimeInitialized = false;

function preRun() {
  // compatibility - merge in anything from Module['preRun'] at this time
  if (Module['preRun']) {
    if (typeof Module['preRun'] == 'function') Module['preRun'] = [Module['preRun']];
    while (Module['preRun'].length) {
      addOnPreRun(Module['preRun'].shift());
    }
  }
  callRuntimeCallbacks(__ATPRERUN__);
}

function ensureInitRuntime() {
  if (runtimeInitialized) return;
  runtimeInitialized = true;
  callRuntimeCallbacks(__ATINIT__);
}

function preMain() {
  callRuntimeCallbacks(__ATMAIN__);
}

function exitRuntime() {
  if (ENVIRONMENT_IS_WEB || ENVIRONMENT_IS_WORKER) {
    Module.printErr('Exiting runtime. Any attempt to access the compiled C code may fail from now. If you want to keep the runtime alive, set Module["noExitRuntime"] = true or build with -s NO_EXIT_RUNTIME=1');
  }
  callRuntimeCallbacks(__ATEXIT__);
}

function postRun() {
  // compatibility - merge in anything from Module['postRun'] at this time
  if (Module['postRun']) {
    if (typeof Module['postRun'] == 'function') Module['postRun'] = [Module['postRun']];
    while (Module['postRun'].length) {
      addOnPostRun(Module['postRun'].shift());
    }
  }
  callRuntimeCallbacks(__ATPOSTRUN__);
}

function addOnPreRun(cb) {
  __ATPRERUN__.unshift(cb);
}
Module['addOnPreRun'] = Module.addOnPreRun = addOnPreRun;

function addOnInit(cb) {
  __ATINIT__.unshift(cb);
}
Module['addOnInit'] = Module.addOnInit = addOnInit;

function addOnPreMain(cb) {
  __ATMAIN__.unshift(cb);
}
Module['addOnPreMain'] = Module.addOnPreMain = addOnPreMain;

function addOnExit(cb) {
  __ATEXIT__.unshift(cb);
}
Module['addOnExit'] = Module.addOnExit = addOnExit;

function addOnPostRun(cb) {
  __ATPOSTRUN__.unshift(cb);
}
Module['addOnPostRun'] = Module.addOnPostRun = addOnPostRun;

// Tools

// This processes a JS string into a C-line array of numbers, 0-terminated.
// For LLVM-originating strings, see parser.js:parseLLVMString function
function intArrayFromString(stringy, dontAddNull, length /* optional */) {
  var ret = (new Runtime.UTF8Processor()).processJSString(stringy);
  if (length) {
    ret.length = length;
  }
  if (!dontAddNull) {
    ret.push(0);
  }
  return ret;
}
Module['intArrayFromString'] = intArrayFromString;

function intArrayToString(array) {
  var ret = [];
  for (var i = 0; i < array.length; i++) {
    var chr = array[i];
    if (chr > 0xFF) {
        assert(false, 'Character code ' + chr + ' (' + String.fromCharCode(chr) + ')  at offset ' + i + ' not in 0x00-0xFF.');
      chr &= 0xFF;
    }
    ret.push(String.fromCharCode(chr));
  }
  return ret.join('');
}
Module['intArrayToString'] = intArrayToString;

// Write a Javascript array to somewhere in the heap
function writeStringToMemory(string, buffer, dontAddNull) {
  var array = intArrayFromString(string, dontAddNull);
  var i = 0;
  while (i < array.length) {
    var chr = array[i];
    HEAP8[(((buffer)+(i))|0)]=chr;
    i = i + 1;
  }
}
Module['writeStringToMemory'] = writeStringToMemory;

function writeArrayToMemory(array, buffer) {
  for (var i = 0; i < array.length; i++) {
    HEAP8[(((buffer)+(i))|0)]=array[i];
  }
}
Module['writeArrayToMemory'] = writeArrayToMemory;

function writeAsciiToMemory(str, buffer, dontAddNull) {
  for (var i = 0; i < str.length; i++) {
    assert(str.charCodeAt(i) === str.charCodeAt(i)&0xff);
    HEAP8[(((buffer)+(i))|0)]=str.charCodeAt(i);
  }
  if (!dontAddNull) HEAP8[(((buffer)+(str.length))|0)]=0;
}
Module['writeAsciiToMemory'] = writeAsciiToMemory;

function unSign(value, bits, ignore) {
  if (value >= 0) {
    return value;
  }
  return bits <= 32 ? 2*Math.abs(1 << (bits-1)) + value // Need some trickery, since if bits == 32, we are right at the limit of the bits JS uses in bitshifts
                    : Math.pow(2, bits)         + value;
}
function reSign(value, bits, ignore) {
  if (value <= 0) {
    return value;
  }
  var half = bits <= 32 ? Math.abs(1 << (bits-1)) // abs is needed if bits == 32
                        : Math.pow(2, bits-1);
  if (value >= half && (bits <= 32 || value > half)) { // for huge values, we can hit the precision limit and always get true here. so don't do that
                                                       // but, in general there is no perfect solution here. With 64-bit ints, we get rounding and errors
                                                       // TODO: In i64 mode 1, resign the two parts separately and safely
    value = -2*half + value; // Cannot bitshift half, as it may be at the limit of the bits JS uses in bitshifts
  }
  return value;
}

// check for imul support, and also for correctness ( https://bugs.webkit.org/show_bug.cgi?id=126345 )
if (!Math['imul'] || Math['imul'](0xffffffff, 5) !== -5) Math['imul'] = function imul(a, b) {
  var ah  = a >>> 16;
  var al = a & 0xffff;
  var bh  = b >>> 16;
  var bl = b & 0xffff;
  return (al*bl + ((ah*bl + al*bh) << 16))|0;
};
Math.imul = Math['imul'];


var Math_abs = Math.abs;
var Math_cos = Math.cos;
var Math_sin = Math.sin;
var Math_tan = Math.tan;
var Math_acos = Math.acos;
var Math_asin = Math.asin;
var Math_atan = Math.atan;
var Math_atan2 = Math.atan2;
var Math_exp = Math.exp;
var Math_log = Math.log;
var Math_sqrt = Math.sqrt;
var Math_ceil = Math.ceil;
var Math_floor = Math.floor;
var Math_pow = Math.pow;
var Math_imul = Math.imul;
var Math_fround = Math.fround;
var Math_min = Math.min;

// A counter of dependencies for calling run(). If we need to
// do asynchronous work before running, increment this and
// decrement it. Incrementing must happen in a place like
// PRE_RUN_ADDITIONS (used by emcc to add file preloading).
// Note that you can add dependencies in preRun, even though
// it happens right before run - run will be postponed until
// the dependencies are met.
var runDependencies = 0;
var runDependencyWatcher = null;
var dependenciesFulfilled = null; // overridden to take different actions when all run dependencies are fulfilled
var runDependencyTracking = {};

function addRunDependency(id) {
  runDependencies++;
  if (Module['monitorRunDependencies']) {
    Module['monitorRunDependencies'](runDependencies);
  }
  if (id) {
    assert(!runDependencyTracking[id]);
    runDependencyTracking[id] = 1;
    if (runDependencyWatcher === null && typeof setInterval !== 'undefined') {
      // Check for missing dependencies every few seconds
      runDependencyWatcher = setInterval(function() {
        var shown = false;
        for (var dep in runDependencyTracking) {
          if (!shown) {
            shown = true;
            Module.printErr('still waiting on run dependencies:');
          }
          Module.printErr('dependency: ' + dep);
        }
        if (shown) {
          Module.printErr('(end of list)');
        }
      }, 10000);
    }
  } else {
    Module.printErr('warning: run dependency added without ID');
  }
}
Module['addRunDependency'] = addRunDependency;
function removeRunDependency(id) {
  runDependencies--;
  if (Module['monitorRunDependencies']) {
    Module['monitorRunDependencies'](runDependencies);
  }
  if (id) {
    assert(runDependencyTracking[id]);
    delete runDependencyTracking[id];
  } else {
    Module.printErr('warning: run dependency removed without ID');
  }
  if (runDependencies == 0) {
    if (runDependencyWatcher !== null) {
      clearInterval(runDependencyWatcher);
      runDependencyWatcher = null;
    }
    if (dependenciesFulfilled) {
      var callback = dependenciesFulfilled;
      dependenciesFulfilled = null;
      callback(); // can add another dependenciesFulfilled
    }
  }
}
Module['removeRunDependency'] = removeRunDependency;

Module["preloadedImages"] = {}; // maps url to image data
Module["preloadedAudios"] = {}; // maps url to audio data


var memoryInitializer = null;

// === Body ===



STATIC_BASE = 8;

STATICTOP = STATIC_BASE + 14776;

var _stdout;
var _stdout=_stdout=allocate(1, "i32*", ALLOC_STATIC);
var _stdin;
var _stdin=_stdin=allocate(1, "i32*", ALLOC_STATIC);
var _stderr;
var _stderr=_stderr=allocate(1, "i32*", ALLOC_STATIC);

/* global initializers */ __ATINIT__.push({ func: function() { runPostSets() } },{ func: function() { __GLOBAL__I_a() } });







































































































































































































































































var ___dso_handle;
var ___dso_handle=___dso_handle=allocate(1, "i32*", ALLOC_STATIC);




























































































































































var __ZTVN10__cxxabiv120__si_class_type_infoE;
__ZTVN10__cxxabiv120__si_class_type_infoE=allocate([0,0,0,0,8,41,0,0,242,2,0,0,234,2,0,0,164,0,0,0,144,1,0,0,206,0,0,0,108,0,0,0,244,0,0,0,22,1,0,0,0,0,0,0,0,0,0,0], "i8", ALLOC_STATIC);;
var __ZTVN10__cxxabiv117__class_type_infoE;
__ZTVN10__cxxabiv117__class_type_infoE=allocate([0,0,0,0,24,41,0,0,242,2,0,0,224,0,0,0,164,0,0,0,144,1,0,0,206,0,0,0,58,2,0,0,16,1,0,0,164,1,0,0,0,0,0,0,0,0,0,0], "i8", ALLOC_STATIC);;


















































































































































































































































































































































var __ZN13ShamirSharing7numBitsE;
var __ZN13ShamirSharing5primeE;





























































































































var __ZNSt13runtime_errorC1EPKc;
var __ZNSt13runtime_errorD1Ev;
var __ZNSt12length_errorD1Ev;
var __ZNSt12out_of_rangeD1Ev;
var __ZNSt3__16localeC1Ev;
var __ZNSt3__16localeC1ERKS0_;
var __ZNSt3__16localeD1Ev;
var __ZNSt8bad_castC1Ev;
var __ZNSt8bad_castD1Ev;
/* memory initializer */ allocate([95,112,137,0,255,9,47,15,10,0,0,0,100,0,0,0,232,3,0,0,16,39,0,0,160,134,1,0,64,66,15,0,128,150,152,0,0,225,245,5,74,117,108,0,0,0,0,0,74,117,110,0,0,0,0,0,65,112,114,0,0,0,0,0,77,97,114,0,0,0,0,0,70,101,98,0,0,0,0,0,74,97,110,0,0,0,0,0,117,110,115,117,112,112,111,114,116,101,100,32,108,111,99,97,108,101,32,102,111,114,32,115,116,97,110,100,97,114,100,32,105,110,112,117,116,0,0,0,68,101,99,101,109,98,101,114,0,0,0,0,0,0,0,0,78,111,118,101,109,98,101,114,0,0,0,0,0,0,0,0,79,99,116,111,98,101,114,0,83,101,112,116,101,109,98,101,114,0,0,0,0,0,0,0,46,116,120,116,0,0,0,0,65,117,103,117,115,116,0,0,74,117,108,121,0,0,0,0,74,117,110,101,0,0,0,0,77,97,121,0,0,0,0,0,65,112,114,105,108,0,0,0,77,97,114,99,104,0,0,0,70,101,98,114,117,97,114,121,0,0,0,0,0,0,0,0,74,97,110,117,97,114,121,0,68,0,0,0,101,0,0,0,99,0,0,0,0,0,0,0,112,97,114,116,105,101,0,0,78,0,0,0,111,0,0,0,118,0,0,0,0,0,0,0,79,0,0,0,99,0,0,0,116,0,0,0,0,0,0,0,83,0,0,0,101,0,0,0,112,0,0,0,0,0,0,0,65,0,0,0,117,0,0,0,103,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,108,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,110,0,0,0,0,0,0,0,77,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,65,0,0,0,112,0,0,0,114,0,0,0,0,0,0,0,77,0,0,0,97,0,0,0,114,0,0,0,0,0,0,0,70,0,0,0,101,0,0,0,98,0,0,0,0,0,0,0,112,97,114,116,105,101,37,100,46,116,120,116,0,0,0,0,74,0,0,0,97,0,0,0,110,0,0,0,0,0,0,0,68,0,0,0,101,0,0,0,99,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,0,0,0,0,78,0,0,0,111,0,0,0,118,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,0,0,0,0,79,0,0,0,99,0,0,0,116,0,0,0,111,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,83,0,0,0,101,0,0,0,112,0,0,0,116,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,105,110,102,105,110,105,116,121,0,0,0,0,0,0,0,0,65,0,0,0,117,0,0,0,103,0,0,0,117,0,0,0,115,0,0,0,116,0,0,0,0,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,108,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,110,0,0,0,101,0,0,0,0,0,0,0,0,0,0,0,65,0,0,0,112,0,0,0,114,0,0,0,105,0,0,0,108,0,0,0,0,0,0,0,115,101,99,114,101,116,46,116,120,116,0,0,0,0,0,0,77,0,0,0,97,0,0,0,114,0,0,0,99,0,0,0,104,0,0,0,0,0,0,0,70,0,0,0,101,0,0,0,98,0,0,0,114,0,0,0,117,0,0,0,97,0,0,0,114,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,74,0,0,0,97,0,0,0,110,0,0,0,117,0,0,0,97,0,0,0,114,0,0,0,121,0,0,0,0,0,0,0,80,77,0,0,0,0,0,0,65,77,0,0,0,0,0,0,80,0,0,0,77,0,0,0,0,0,0,0,0,0,0,0,65,0,0,0,77,0,0,0,0,0,0,0,0,0,0,0,101,110,116,114,101,101,0,0,69,114,114,101,117,114,32,108,111,114,115,32,100,101,32,108,39,111,117,118,101,114,116,117,114,101,32,100,101,32,0,0,108,111,99,97,108,101,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,0,0,0,37,0,0,0,73,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,32,0,0,0,37,0,0,0,112,0,0,0,0,0,0,0,37,73,58,37,77,58,37,83,32,37,112,0,0,0,0,0,37,0,0,0,97,0,0,0,32,0,0,0,37,0,0,0,98,0,0,0,32,0,0,0,37,0,0,0,100,0,0,0,32,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,32,0,0,0,37,0,0,0,89,0,0,0,0,0,0,0,0,0,0,0,115,116,100,58,58,98,97,100,95,97,108,108,111,99,0,0,37,112,0,0,0,0,0,0,37,97,32,37,98,32,37,100,32,37,72,58,37,77,58,37,83,32,37,89,0,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,0,0,0,0,0,0,0,0,37,72,58,37,77,58,37,83,0,0,0,0,0,0,0,0,37,0,0,0,109,0,0,0,47,0,0,0,37,0,0,0,100,0,0,0,47,0,0,0,37,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,115,116,100,58,58,98,97,100,95,99,97,115,116,0,0,0,37,109,47,37,100,47,37,121,0,0,0,0,0,0,0,0,114,98,0,0,0,0,0,0,102,0,0,0,97,0,0,0,108,0,0,0,115,0,0,0,101,0,0,0,0,0,0,0,102,97,108,115,101,0,0,0,58,32,0,0,0,0,0,0,116,0,0,0,114,0,0,0,117,0,0,0,101,0,0,0,0,0,0,0,0,0,0,0,116,114,117,101,0,0,0,0,105,111,115,95,98,97,115,101,58,58,99,108,101,97,114,0,97,43,98,0,0,0,0,0,119,43,98,0,0,0,0,0,32,32,32,32,32,32,32,32,78,111,109,98,114,101,32,100,101,32,112,97,114,116,105,101,115,32,62,32,83,101,117,105,108,32,62,32,48,0,0,0,114,43,98,0,0,0,0,0,105,111,115,116,114,101,97,109,0,0,0,0,0,0,0,0,97,98,0,0,0,0,0,0,67,0,0,0,0,0,0,0,119,98,0,0,0,0,0,0,118,101,99,116,111,114,0,0,97,43,0,0,0,0,0,0,37,46,48,76,102,0,0,0,119,43,0,0,0,0,0,0,109,111,110,101,121,95,103,101,116,32,101,114,114,111,114,0,114,43,0,0,0,0,0,0,83,97,116,0,0,0,0,0,37,76,102,0,0,0,0,0,70,114,105,0,0,0,0,0,84,104,117,0,0,0,0,0,87,101,100,0,0,0,0,0,84,117,101,0,0,0,0,0,114,0,0,0,0,0,0,0,77,111,110,0,0,0,0,0,83,117,110,0,0,0,0,0,83,97,116,117,114,100,97,121,0,0,0,0,0,0,0,0,70,114,105,100,97,121,0,0,84,104,117,114,115,100,97,121,0,0,0,0,0,0,0,0,87,101,100,110,101,115,100,97,121,0,0,0,0,0,0,0,84,117,101,115,100,97,121,0,98,97,115,105,99,95,115,116,114,105,110,103,0,0,0,0,77,111,110,100,97,121,0,0,83,117,110,100,97,121,0,0,97,0,0,0,0,0,0,0,83,0,0,0,97,0,0,0,116,0,0,0,0,0,0,0,117,110,115,112,101,99,105,102,105,101,100,32,105,111,115,116,114,101,97,109,95,99,97,116,101,103,111,114,121,32,101,114,114,111,114,0,0,0,0,0,70,0,0,0,114,0,0,0,105,0,0,0,0,0,0,0,84,0,0,0,104,0,0,0,117,0,0,0,0,0,0,0,87,0,0,0,101,0,0,0,100,0,0,0,0,0,0,0,84,0,0,0,117,0,0,0,101,0,0,0,0,0,0,0,77,0,0,0,111,0,0,0,110,0,0,0,0,0,0,0,83,0,0,0,117,0,0,0,110,0,0,0,0,0,0,0,83,0,0,0,97,0,0,0,116,0,0,0,117,0,0,0,114,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,70,0,0,0,114,0,0,0,105,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,84,0,0,0,104,0,0,0,117,0,0,0,114,0,0,0,115,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,119,0,0,0,0,0,0,0,87,0,0,0,101,0,0,0,100,0,0,0,110,0,0,0,101,0,0,0,115,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,84,0,0,0,117,0,0,0,101,0,0,0,115,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,77,0,0,0,111,0,0,0,110,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,83,0,0,0,117,0,0,0,110,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,68,101,99,0,0,0,0,0,78,111,118,0,0,0,0,0,79,99,116,0,0,0,0,0,83,101,112,0,0,0,0,0,65,117,103,0,0,0,0,0,45,0,0,0,0,0,0,0,32,40,78,111,109,98,114,101,32,100,101,32,112,97,114,116,105,101,115,41,32,40,83,101,117,105,108,41,32,91,102,97,99,117,108,116,97,116,105,102,32,58,32,78,111,109,32,100,117,32,102,105,99,104,105,101,114,44,32,39,101,110,116,114,101,101,39,32,112,97,114,32,100,233,102,97,117,116,93,0,85,115,97,103,101,32,58,32,0,0,0,0,0,0,0,0,2,0,0,192,3,0,0,192,4,0,0,192,5,0,0,192,6,0,0,192,7,0,0,192,8,0,0,192,9,0,0,192,10,0,0,192,11,0,0,192,12,0,0,192,13,0,0,192,14,0,0,192,15,0,0,192,16,0,0,192,17,0,0,192,18,0,0,192,19,0,0,192,20,0,0,192,21,0,0,192,22,0,0,192,23,0,0,192,24,0,0,192,25,0,0,192,26,0,0,192,27,0,0,192,28,0,0,192,29,0,0,192,30,0,0,192,31,0,0,192,0,0,0,179,1,0,0,195,2,0,0,195,3,0,0,195,4,0,0,195,5,0,0,195,6,0,0,195,7,0,0,195,8,0,0,195,9,0,0,195,10,0,0,195,11,0,0,195,12,0,0,195,13,0,0,211,14,0,0,195,15,0,0,195,0,0,12,187,1,0,12,195,2,0,12,195,3,0,12,195,4,0,12,211,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,49,50,51,52,53,54,55,56,57,0,0,0,0,0,0,48,49,50,51,52,53,54,55,56,57,0,0,0,0,0,0,37,0,0,0,89,0,0,0,45,0,0,0,37,0,0,0,109,0,0,0,45,0,0,0,37,0,0,0,100,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,0,0,0,0,37,0,0,0,73,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,32,0,0,0,37,0,0,0,112,0,0,0,0,0,0,0,37,0,0,0,109,0,0,0,47,0,0,0,37,0,0,0,100,0,0,0,47,0,0,0,37,0,0,0,121,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,37,72,58,37,77,58,37,83,37,72,58,37,77,0,0,0,37,73,58,37,77,58,37,83,32,37,112,0,0,0,0,0,37,89,45,37,109,45,37,100,37,109,47,37,100,47,37,121,37,72,58,37,77,58,37,83,37,0,0,0,0,0,0,0,37,112,0,0,0,0,0,0,0,0,0,0,240,34,0,0,72,0,0,0,66,1,0,0,152,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,35,0,0,34,2,0,0,178,1,0,0,208,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,35,0,0,192,0,0,0,12,3,0,0,220,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,35,0,0,0,1,0,0,58,0,0,0,110,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,35,0,0,0,1,0,0,20,0,0,0,110,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,35,0,0,0,1,0,0,42,0,0,0,110,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,88,35,0,0,186,1,0,0,226,0,0,0,124,0,0,0,230,1,0,0,56,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,120,35,0,0,254,2,0,0,242,1,0,0,124,0,0,0,216,2,0,0,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,152,35,0,0,176,1,0,0,246,1,0,0,124,0,0,0,232,1,0,0,240,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,184,35,0,0,4,3,0,0,124,1,0,0,124,0,0,0,216,1,0,0,46,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,232,35,0,0,108,2,0,0,74,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,88,36,0,0,248,2,0,0,252,0,0,0,124,0,0,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,120,36,0,0,174,1,0,0,48,1,0,0,124,0,0,0,176,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,152,36,0,0,94,0,0,0,50,1,0,0,124,0,0,0,160,2,0,0,24,0,0,0,248,1,0,0,32,0,0,0,204,0,0,0,162,2,0,0,234,0,0,0,248,255,255,255,152,36,0,0,120,0,0,0,52,0,0,0,184,0,0,0,82,0,0,0,10,0,0,0,170,0,0,0,190,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,36,0,0,232,2,0,0,172,2,0,0,124,0,0,0,116,0,0,0,136,0,0,0,192,2,0,0,136,1,0,0,168,0,0,0,18,0,0,0,136,2,0,0,248,255,255,255,192,36,0,0,110,1,0,0,82,2,0,0,138,2,0,0,180,2,0,0,44,2,0,0,246,0,0,0,32,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,232,36,0,0,214,0,0,0,252,1,0,0,124,0,0,0,12,1,0,0,230,0,0,0,122,0,0,0,114,1,0,0,198,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,248,36,0,0,160,0,0,0,178,0,0,0,124,0,0,0,240,0,0,0,240,1,0,0,162,0,0,0,224,1,0,0,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,37,0,0,236,2,0,0,2,0,0,0,124,0,0,0,148,1,0,0,250,2,0,0,62,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,37,0,0,118,0,0,0,130,2,0,0,124,0,0,0,170,2,0,0,212,0,0,0,188,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,72,37,0,0,150,2,0,0,60,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,80,37,0,0,68,0,0,0,122,1,0,0,220,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,37,0,0,16,0,0,0,192,1,0,0,124,0,0,0,106,0,0,0,92,0,0,0,86,0,0,0,90,0,0,0,84,0,0,0,102,0,0,0,100,0,0,0,156,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,37,0,0,8,1,0,0,40,0,0,0,124,0,0,0,28,2,0,0,32,2,0,0,18,2,0,0,30,2,0,0,6,1,0,0,22,2,0,0,20,2,0,0,196,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,160,37,0,0,96,0,0,0,54,0,0,0,124,0,0,0,94,2,0,0,90,2,0,0,80,2,0,0,84,2,0,0,238,1,0,0,88,2,0,0,78,2,0,0,100,2,0,0,98,2,0,0,96,2,0,0,98,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,37,0,0,140,0,0,0,4,0,0,0,124,0,0,0,228,2,0,0,214,2,0,0,208,2,0,0,210,2,0,0,188,2,0,0,212,2,0,0,206,2,0,0,222,2,0,0,220,2,0,0,218,2,0,0,86,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,37,0,0,202,0,0,0,248,0,0,0,124,0,0,0,94,1,0,0,14,2,0,0,52,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,37,0,0,66,0,0,0,200,1,0,0,124,0,0,0,8,2,0,0,122,2,0,0,48,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,38,0,0,26,0,0,0,236,1,0,0,124,0,0,0,80,0,0,0,226,1,0,0,220,1,0,0,158,2,0,0,68,2,0,0,148,2,0,0,126,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,38,0,0,210,1,0,0,106,1,0,0,124,0,0,0,196,2,0,0,252,2,0,0,38,2,0,0,18,1,0,0,50,0,0,0,42,2,0,0,26,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,38,0,0,210,1,0,0,44,0,0,0,124,0,0,0,254,0,0,0,114,0,0,0,238,0,0,0,60,2,0,0,62,1,0,0,170,1,0,0,224,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,38,0,0,210,1,0,0,26,1,0,0,124,0,0,0,16,2,0,0,194,1,0,0,120,2,0,0,158,0,0,0,140,1,0,0,120,1,0,0,2,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,38,0,0,210,1,0,0,78,0,0,0,124,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,144,38,0,0,150,0,0,0,162,1,0,0,124,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,160,38,0,0,210,1,0,0,218,0,0,0,124,0,0,0,128,1,0,0,190,0,0,0,84,1,0,0,244,2,0,0,194,0,0,0,48,2,0,0,0,2,0,0,62,0,0,0,126,0,0,0,142,2,0,0,36,1,0,0,196,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,38,0,0,10,3,0,0,88,0,0,0,124,0,0,0,154,0,0,0,138,1,0,0,100,1,0,0,132,2,0,0,146,0,0,0,104,1,0,0,180,1,0,0,172,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,38,0,0,182,0,0,0,164,2,0,0,166,1,0,0,56,2,0,0,72,1,0,0,104,2,0,0,112,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,39,0,0,210,1,0,0,228,0,0,0,124,0,0,0,16,2,0,0,194,1,0,0,120,2,0,0,158,0,0,0,140,1,0,0,120,1,0,0,2,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,39,0,0,210,1,0,0,182,1,0,0,124,0,0,0,16,2,0,0,194,1,0,0,120,2,0,0,158,0,0,0,140,1,0,0,120,1,0,0,2,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,39,0,0,90,1,0,0,198,2,0,0,198,0,0,0,146,1,0,0,2,1,0,0,54,2,0,0,2,2,0,0,72,2,0,0,124,2,0,0,152,0,0,0,142,0,0,0,132,0,0,0,6,3,0,0,250,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,39,0,0,22,0,0,0,70,1,0,0,254,1,0,0,182,2,0,0,178,2,0,0,10,2,0,0,14,1,0,0,244,1,0,0,96,1,0,0,36,0,0,0,64,0,0,0,200,2,0,0,78,1,0,0,176,2,0,0,0,0,0,0,0,0,0,0,104,0,0,0,0,0,0,0,56,39,0,0,68,1,0,0,38,1,0,0,152,255,255,255,152,255,255,255,56,39,0,0,232,0,0,0,208,1,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,104,39,0,0,112,0,0,0,116,2,0,0,252,255,255,255,252,255,255,255,104,39,0,0,132,1,0,0,88,1,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,128,39,0,0,152,2,0,0,202,2,0,0,252,255,255,255,252,255,255,255,128,39,0,0,46,1,0,0,50,2,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,152,39,0,0,236,0,0,0,14,3,0,0,248,255,255,255,248,255,255,255,152,39,0,0,212,1,0,0,194,2,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,176,39,0,0,44,1,0,0,76,2,0,0,248,255,255,255,248,255,255,255,176,39,0,0,116,1,0,0,138,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,200,39,0,0,134,2,0,0,166,0,0,0,150,1,0,0,158,1,0,0,86,1,0,0,134,0,0,0,10,1,0,0,244,1,0,0,96,1,0,0,24,2,0,0,64,0,0,0,80,1,0,0,78,1,0,0,186,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,216,39,0,0,66,2,0,0,214,1,0,0,220,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,0,0,238,2,0,0,218,1,0,0,186,0,0,0,146,1,0,0,2,1,0,0,54,2,0,0,40,1,0,0,72,2,0,0,124,2,0,0,152,0,0,0,142,0,0,0,132,0,0,0,92,2,0,0,204,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,40,0,0,154,1,0,0,206,1,0,0,56,1,0,0,182,2,0,0,178,2,0,0,10,2,0,0,4,2,0,0,244,1,0,0,96,1,0,0,36,0,0,0,64,0,0,0,200,2,0,0,226,2,0,0,180,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,40,0,0,166,2,0,0,130,1,0,0,124,0,0,0,108,1,0,0,144,2,0,0,54,1,0,0,246,2,0,0,60,0,0,0,28,1,0,0,24,1,0,0,216,0,0,0,102,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,40,0,0,42,1,0,0,148,0,0,0,124,0,0,0,118,2,0,0,12,0,0,0,70,2,0,0,168,2,0,0,184,2,0,0,242,0,0,0,128,2,0,0,202,1,0,0,144,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,40,0,0,174,2,0,0,64,1,0,0,124,0,0,0,104,0,0,0,58,1,0,0,74,0,0,0,156,1,0,0,0,3,0,0,204,1,0,0,40,2,0,0,228,1,0,0,172,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,160,40,0,0,210,0,0,0,190,1,0,0,124,0,0,0,74,2,0,0,102,2,0,0,20,1,0,0,140,2,0,0,250,0,0,0,200,0,0,0,168,1,0,0,114,2,0,0,106,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,216,40,0,0,12,2,0,0,38,0,0,0,92,1,0,0,146,1,0,0,2,1,0,0,54,2,0,0,2,2,0,0,72,2,0,0,124,2,0,0,118,1,0,0,222,1,0,0,174,0,0,0,6,3,0,0,250,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,232,40,0,0,30,0,0,0,154,2,0,0,64,2,0,0,182,2,0,0,178,2,0,0,10,2,0,0,14,1,0,0,244,1,0,0,96,1,0,0,52,2,0,0,130,0,0,0,34,0,0,0,78,1,0,0,176,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,248,40,0,0,242,2,0,0,36,2,0,0,164,0,0,0,144,1,0,0,206,0,0,0,70,0,0,0,146,2,0,0,30,1,0,0,0,0,0,0,0,0,0,0,20,19,0,0,68,41,0,0,88,41,0,0,40,19,0,0,83,116,57,116,121,112,101,95,105,110,102,111,0,0,0,0,83,116,57,101,120,99,101,112,116,105,111,110,0,0,0,0,83,116,57,98,97,100,95,97,108,108,111,99,0,0,0,0,83,116,56,98,97,100,95,99,97,115,116,0,0,0,0,0,83,116,49,51,114,117,110,116,105,109,101,95,101,114,114,111,114,0,0,0,0,0,0,0,83,116,49,50,111,117,116,95,111,102,95,114,97,110,103,101,0,0,0,0,0,0,0,0,83,116,49,50,108,101,110,103,116,104,95,101,114,114,111,114,0,0,0,0,0,0,0,0,83,116,49,49,108,111,103,105,99,95,101,114,114,111,114,0,78,83,116,51,95,95,49,57,116,105,109,101,95,98,97,115,101,69,0,0,0,0,0,0,78,83,116,51,95,95,49,57,109,111,110,101,121,95,112,117,116,73,119,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,78,83,116,51,95,95,49,57,109,111,110,101,121,95,112,117,116,73,99,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,78,83,116,51,95,95,49,57,109,111,110,101,121,95,103,101,116,73,119,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,78,83,116,51,95,95,49,57,109,111,110,101,121,95,103,101,116,73,99,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,78,83,116,51,95,95,49,57,98,97,115,105,99,95,105,111,115,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,0,0,0,0,0,0,78,83,116,51,95,95,49,57,98,97,115,105,99,95,105,111,115,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,0,0,0,0,0,78,83,116,51,95,95,49,57,95,95,110,117,109,95,112,117,116,73,119,69,69,0,0,0,78,83,116,51,95,95,49,57,95,95,110,117,109,95,112,117,116,73,99,69,69,0,0,0,78,83,116,51,95,95,49,57,95,95,110,117,109,95,103,101,116,73,119,69,69,0,0,0,78,83,116,51,95,95,49,57,95,95,110,117,109,95,103,101,116,73,99,69,69,0,0,0,78,83,116,51,95,95,49,56,116,105,109,101,95,112,117,116,73,119,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,0,78,83,116,51,95,95,49,56,116,105,109,101,95,112,117,116,73,99,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,0,78,83,116,51,95,95,49,56,116,105,109,101,95,103,101,116,73,119,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,0,78,83,116,51,95,95,49,56,116,105,109,101,95,103,101,116,73,99,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,0,78,83,116,51,95,95,49,56,110,117,109,112,117,110,99,116,73,119,69,69,0,0,0,0,78,83,116,51,95,95,49,56,110,117,109,112,117,110,99,116,73,99,69,69,0,0,0,0,78,83,116,51,95,95,49,56,109,101,115,115,97,103,101,115,73,119,69,69,0,0,0,0,78,83,116,51,95,95,49,56,109,101,115,115,97,103,101,115,73,99,69,69,0,0,0,0,78,83,116,51,95,95,49,56,105,111,115,95,98,97,115,101,69,0,0,0,0,0,0,0,78,83,116,51,95,95,49,56,105,111,115,95,98,97,115,101,55,102,97,105,108,117,114,101,69,0,0,0,0,0,0,0,78,83,116,51,95,95,49,55,110,117,109,95,112,117,116,73,119,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,55,110,117,109,95,112,117,116,73,99,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,55,110,117,109,95,103,101,116,73,119,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,55,110,117,109,95,103,101,116,73,99,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,55,99,111,108,108,97,116,101,73,119,69,69,0,0,0,0,0,78,83,116,51,95,95,49,55,99,111,108,108,97,116,101,73,99,69,69,0,0,0,0,0,78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,119,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,0,0,0,0,0,0,78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,99,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,0,0,0,0,0,0,78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,68,115,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,0,0,0,0,0,78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,68,105,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,0,0,0,0,0,78,83,116,51,95,95,49,54,108,111,99,97,108,101,53,102,97,99,101,116,69,0,0,0,78,83,116,51,95,95,49,54,108,111,99,97,108,101,53,95,95,105,109,112,69,0,0,0,78,83,116,51,95,95,49,53,99,116,121,112,101,73,119,69,69,0,0,0,0,0,0,0,78,83,116,51,95,95,49,53,99,116,121,112,101,73,99,69,69,0,0,0,0,0,0,0,78,83,116,51,95,95,49,50,48,95,95,116,105,109,101,95,103,101,116,95,99,95,115,116,111,114,97,103,101,73,119,69,69,0,0,0,0,0,0,0,78,83,116,51,95,95,49,50,48,95,95,116,105,109,101,95,103,101,116,95,99,95,115,116,111,114,97,103,101,73,99,69,69,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,57,95,95,105,111,115,116,114,101,97,109,95,99,97,116,101,103,111,114,121,69,0,0,0,78,83,116,51,95,95,49,49,55,95,95,119,105,100,101,110,95,102,114,111,109,95,117,116,102,56,73,76,106,51,50,69,69,69,0,0,0,0,0,0,78,83,116,51,95,95,49,49,54,95,95,110,97,114,114,111,119,95,116,111,95,117,116,102,56,73,76,106,51,50,69,69,69,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,53,98,97,115,105,99,95,115,116,114,101,97,109,98,117,102,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,53,98,97,115,105,99,95,115,116,114,101,97,109,98,117,102,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,52,101,114,114,111,114,95,99,97,116,101,103,111,114,121,69,0,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,52,98,97,115,105,99,95,111,102,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,78,83,116,51,95,95,49,49,52,95,95,115,104,97,114,101,100,95,99,111,117,110,116,69,0,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,52,95,95,110,117,109,95,112,117,116,95,98,97,115,101,69,0,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,52,95,95,110,117,109,95,103,101,116,95,98,97,115,101,69,0,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,51,109,101,115,115,97,103,101,115,95,98,97,115,101,69,0,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,111,115,116,114,101,97,109,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,0,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,111,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,105,115,116,114,101,97,109,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,0,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,105,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,102,105,108,101,98,117,102,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,78,83,116,51,95,95,49,49,50,115,121,115,116,101,109,95,101,114,114,111,114,69,0,0,78,83,116,51,95,95,49,49,50,99,111,100,101,99,118,116,95,98,97,115,101,69,0,0,78,83,116,51,95,95,49,49,50,95,95,100,111,95,109,101,115,115,97,103,101,69,0,0,78,83,116,51,95,95,49,49,49,95,95,115,116,100,111,117,116,98,117,102,73,119,69,69,0,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,49,95,95,115,116,100,111,117,116,98,117,102,73,99,69,69,0,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,112,117,116,73,119,69,69,0,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,112,117,116,73,99,69,69,0,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,103,101,116,73,119,69,69,0,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,103,101,116,73,99,69,69,0,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,119,76,98,49,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,119,76,98,48,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,99,76,98,49,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,99,76,98,48,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,95,98,97,115,101,69,0,0,0,0,78,83,116,51,95,95,49,49,48,99,116,121,112,101,95,98,97,115,101,69,0,0,0,0,78,83,116,51,95,95,49,49,48,95,95,116,105,109,101,95,112,117,116,69,0,0,0,0,78,83,116,51,95,95,49,49,48,95,95,115,116,100,105,110,98,117,102,73,119,69,69,0,78,83,116,51,95,95,49,49,48,95,95,115,116,100,105,110,98,117,102,73,99,69,69,0,78,49,48,95,95,99,120,120,97,98,105,118,49,50,49,95,95,118,109,105,95,99,108,97,115,115,95,116,121,112,101,95,105,110,102,111,69,0,0,0,78,49,48,95,95,99,120,120,97,98,105,118,49,50,48,95,95,115,105,95,99,108,97,115,115,95,116,121,112,101,95,105,110,102,111,69,0,0,0,0,78,49,48,95,95,99,120,120,97,98,105,118,49,49,55,95,95,99,108,97,115,115,95,116,121,112,101,95,105,110,102,111,69,0,0,0,0,0,0,0,78,49,48,95,95,99,120,120,97,98,105,118,49,49,54,95,95,115,104,105,109,95,116,121,112,101,95,105,110,102,111,69,0,0,0,0,0,0,0,0,0,0,0,0,192,22,0,0,0,0,0,0,208,22,0,0,0,0,0,0,224,22,0,0,232,34,0,0,0,0,0,0,0,0,0,0,240,22,0,0,232,34,0,0,0,0,0,0,0,0,0,0,0,23,0,0,232,34,0,0,0,0,0,0,0,0,0,0,24,23,0,0,64,35,0,0,0,0,0,0,0,0,0,0,48,23,0,0,64,35,0,0,0,0,0,0,0,0,0,0,72,23,0,0,232,34,0,0,0,0,0,0,0,0,0,0,88,23,0,0,136,22,0,0,112,23,0,0,0,0,0,0,2,0,0,0,128,38,0,0,2,0,0,0,32,40,0,0,0,0,0,0,136,22,0,0,184,23,0,0,0,0,0,0,2,0,0,0,128,38,0,0,2,0,0,0,40,40,0,0,0,0,0,0,136,22,0,0,0,24,0,0,0,0,0,0,2,0,0,0,128,38,0,0,2,0,0,0,48,40,0,0,0,0,0,0,136,22,0,0,72,24,0,0,0,0,0,0,2,0,0,0,128,38,0,0,2,0,0,0,56,40,0,0,0,0,0,0,0,0,0,0,144,24,0,0,72,37,0,0,0,0,0,0,0,0,0,0,192,24,0,0,72,37,0,0,0,0,0,0,136,22,0,0,240,24,0,0,0,0,0,0,1,0,0,0,80,39,0,0,0,0,0,0,136,22,0,0,8,25,0,0,0,0,0,0,1,0,0,0,80,39,0,0,0,0,0,0,136,22,0,0,32,25,0,0,0,0,0,0,1,0,0,0,88,39,0,0,0,0,0,0,136,22,0,0,56,25,0,0,0,0,0,0,1,0,0,0,88,39,0,0,0,0,0,0,136,22,0,0,80,25,0,0,0,0,0,0,2,0,0,0,128,38,0,0,2,0,0,0,208,40,0,0,0,8,0,0,136,22,0,0,152,25,0,0,0,0,0,0,2,0,0,0,128,38,0,0,2,0,0,0,208,40,0,0,0,8,0,0,136,22,0,0,224,25,0,0,0,0,0,0,3,0,0,0,128,38,0,0,2,0,0,0,80,35,0,0,2,0,0,0,224,38,0,0,0,8,0,0,136,22,0,0,40,26,0,0,0,0,0,0,3,0,0,0,128,38,0,0,2,0,0,0,80,35,0,0,2,0,0,0,232,38,0,0,0,8,0,0,0,0,0,0,112,26,0,0,128,38,0,0,0,0,0,0,0,0,0,0,136,26,0,0,128,38,0,0,0,0,0,0,136,22,0,0,160,26,0,0,0,0,0,0,2,0,0,0,128,38,0,0,2,0,0,0,96,39,0,0,2,0,0,0,136,22,0,0,184,26,0,0,0,0,0,0,2,0,0,0,128,38,0,0,2,0,0,0,96,39,0,0,2,0,0,0,0,0,0,0,208,26,0,0,0,0,0,0,232,26,0,0,216,39,0,0,0,0,0,0,136,22,0,0,8,27,0,0,0,0,0,0,2,0,0,0,128,38,0,0,2,0,0,0,248,35,0,0,0,0,0,0,136,22,0,0,80,27,0,0,0,0,0,0,2,0,0,0,128,38,0,0,2,0,0,0,16,36,0,0,0,0,0,0,136,22,0,0,152,27,0,0,0,0,0,0,2,0,0,0,128,38,0,0,2,0,0,0,40,36,0,0,0,0,0,0,136,22,0,0,224,27,0,0,0,0,0,0,2,0,0,0,128,38,0,0,2,0,0,0,64,36,0,0,0,0,0,0,0,0,0,0,40,28,0,0,128,38,0,0,0,0,0,0,0,0,0,0,64,28,0,0,128,38,0,0,0,0,0,0,136,22,0,0,88,28,0,0,0,0,0,0,2,0,0,0,128,38,0,0,2,0,0,0,232,39,0,0,2,0,0,0,136,22,0,0,128,28,0,0,0,0,0,0,2,0,0,0,128,38,0,0,2,0,0,0,232,39,0,0,2,0,0,0,136,22,0,0,168,28,0,0,0,0,0,0,2,0,0,0,128,38,0,0,2,0,0,0,232,39,0,0,2,0,0,0,136,22,0,0,208,28,0,0,0,0,0,0,2,0,0,0,128,38,0,0,2,0,0,0,232,39,0,0,2,0,0,0,0,0,0,0,248,28,0,0,72,39,0,0,0,0,0,0,0,0,0,0,16,29,0,0,128,38,0,0,0,0,0,0,136,22,0,0,40,29,0,0,0,0,0,0,2,0,0,0,128,38,0,0,2,0,0,0,200,40,0,0,2,0,0,0,136,22,0,0,64,29,0,0,0,0,0,0,2,0,0,0,128,38,0,0,2,0,0,0,200,40,0,0,2,0,0,0,0,0,0,0,88,29,0,0,0,0,0,0,128,29,0,0,0,0,0,0,168,29,0,0,240,39,0,0,0,0,0,0,0,0,0,0,200,29,0,0,96,38,0,0,0,0,0,0,0,0,0,0,240,29,0,0,96,38,0,0,0,0,0,0,0,0,0,0,24,30,0,0,0,0,0,0,80,30,0,0,0,0,0,0,136,30,0,0,0,0,0,0,168,30,0,0,128,39,0,0,0,0,0,0,0,0,0,0,216,30,0,0,0,0,0,0,248,30,0,0,0,0,0,0,24,31,0,0,0,0,0,0,56,31,0,0,136,22,0,0,80,31,0,0,0,0,0,0,1,0,0,0,216,35,0,0,3,244,255,255,136,22,0,0,128,31,0,0,0,0,0,0,1,0,0,0,232,35,0,0,3,244,255,255,136,22,0,0,176,31,0,0,0,0,0,0,1,0,0,0,216,35,0,0,3,244,255,255,136,22,0,0,224,31,0,0,0,0,0,0,1,0,0,0,232,35,0,0,3,244,255,255,0,0,0,0,16,32,0,0,40,39,0,0,0,0,0,0,0,0,0,0,64,32,0,0,16,35,0,0,0,0,0,0,0,0,0,0,88,32,0,0,0,0,0,0,112,32,0,0,48,39,0,0,0,0,0,0,0,0,0,0,136,32], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE);
/* memory initializer */ allocate([32,39,0,0,0,0,0,0,0,0,0,0,168,32,0,0,40,39,0,0,0,0,0,0,0,0,0,0,200,32,0,0,0,0,0,0,232,32,0,0,0,0,0,0,8,33,0,0,0,0,0,0,40,33,0,0,136,22,0,0,72,33,0,0,0,0,0,0,2,0,0,0,128,38,0,0,2,0,0,0,192,40,0,0,2,0,0,0,136,22,0,0,104,33,0,0,0,0,0,0,2,0,0,0,128,38,0,0,2,0,0,0,192,40,0,0,2,0,0,0,136,22,0,0,136,33,0,0,0,0,0,0,2,0,0,0,128,38,0,0,2,0,0,0,192,40,0,0,2,0,0,0,136,22,0,0,168,33,0,0,0,0,0,0,2,0,0,0,128,38,0,0,2,0,0,0,192,40,0,0,2,0,0,0,0,0,0,0,200,33,0,0,0,0,0,0,224,33,0,0,0,0,0,0,248,33,0,0,0,0,0,0,16,34,0,0,32,39,0,0,0,0,0,0,0,0,0,0,40,34,0,0,40,39,0,0,0,0,0,0,0,0,0,0,64,34,0,0,24,41,0,0,0,0,0,0,0,0,0,0,104,34,0,0,24,41,0,0,0,0,0,0,0,0,0,0,144,34,0,0,40,41,0,0,0,0,0,0,0,0,0,0,184,34,0,0,224,34,0,0,0,0,0,0,104,0,0,0,0,0,0,0,128,39,0,0,152,2,0,0,202,2,0,0,152,255,255,255,152,255,255,255,128,39,0,0,46,1,0,0,50,2,0,0,48,49,50,51,52,53,54,55,56,57,97,98,99,100,101,102,65,66,67,68,69,70,120,88,43,45,112,80,105,73,110,78,0,0,0,0,0,0,0,0], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+10240);
function runPostSets() {

HEAP32[((8928 )>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((8936 )>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((8944 )>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((8960 )>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((8976 )>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((8992 )>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((9008 )>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((9024 )>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((9040 )>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((9176 )>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((9192 )>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((9448 )>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((9464 )>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((9544 )>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((9552 )>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((9696 )>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((9712 )>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((9856 )>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((9872 )>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((9952 )>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((9960 )>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((9968 )>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((9984 )>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((10000 )>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((10016 )>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((10024 )>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((10032 )>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((10040 )>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((10056 )>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((10064 )>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((10072 )>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((10080 )>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((10184 )>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((10200 )>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((10216 )>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((10224 )>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((10240 )>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((10256 )>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((10272 )>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((10280 )>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((10288 )>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((10296 )>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((10432 )>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((10440 )>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((10448 )>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((10456 )>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((10472 )>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((10488 )>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((10504 )>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((10520 )>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((10536 )>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
}

var tempDoublePtr = Runtime.alignMemory(allocate(12, "i8", ALLOC_STATIC), 8);

assert(tempDoublePtr % 8 == 0);

function copyTempFloat(ptr) { // functions, because inlining this code increases code size too much

  HEAP8[tempDoublePtr] = HEAP8[ptr];

  HEAP8[tempDoublePtr+1] = HEAP8[ptr+1];

  HEAP8[tempDoublePtr+2] = HEAP8[ptr+2];

  HEAP8[tempDoublePtr+3] = HEAP8[ptr+3];

}

function copyTempDouble(ptr) {

  HEAP8[tempDoublePtr] = HEAP8[ptr];

  HEAP8[tempDoublePtr+1] = HEAP8[ptr+1];

  HEAP8[tempDoublePtr+2] = HEAP8[ptr+2];

  HEAP8[tempDoublePtr+3] = HEAP8[ptr+3];

  HEAP8[tempDoublePtr+4] = HEAP8[ptr+4];

  HEAP8[tempDoublePtr+5] = HEAP8[ptr+5];

  HEAP8[tempDoublePtr+6] = HEAP8[ptr+6];

  HEAP8[tempDoublePtr+7] = HEAP8[ptr+7];

}


  
  
  
  function _isspace(chr) {
      return (chr == 32) || (chr >= 9 && chr <= 13);
    }
  
  
  var ___errno_state=0;function ___setErrNo(value) {
      // For convenient setting and returning of errno.
      HEAP32[((___errno_state)>>2)]=value;
      return value;
    }
  
  var ERRNO_CODES={EPERM:1,ENOENT:2,ESRCH:3,EINTR:4,EIO:5,ENXIO:6,E2BIG:7,ENOEXEC:8,EBADF:9,ECHILD:10,EAGAIN:11,EWOULDBLOCK:11,ENOMEM:12,EACCES:13,EFAULT:14,ENOTBLK:15,EBUSY:16,EEXIST:17,EXDEV:18,ENODEV:19,ENOTDIR:20,EISDIR:21,EINVAL:22,ENFILE:23,EMFILE:24,ENOTTY:25,ETXTBSY:26,EFBIG:27,ENOSPC:28,ESPIPE:29,EROFS:30,EMLINK:31,EPIPE:32,EDOM:33,ERANGE:34,ENOMSG:42,EIDRM:43,ECHRNG:44,EL2NSYNC:45,EL3HLT:46,EL3RST:47,ELNRNG:48,EUNATCH:49,ENOCSI:50,EL2HLT:51,EDEADLK:35,ENOLCK:37,EBADE:52,EBADR:53,EXFULL:54,ENOANO:55,EBADRQC:56,EBADSLT:57,EDEADLOCK:35,EBFONT:59,ENOSTR:60,ENODATA:61,ETIME:62,ENOSR:63,ENONET:64,ENOPKG:65,EREMOTE:66,ENOLINK:67,EADV:68,ESRMNT:69,ECOMM:70,EPROTO:71,EMULTIHOP:72,EDOTDOT:73,EBADMSG:74,ENOTUNIQ:76,EBADFD:77,EREMCHG:78,ELIBACC:79,ELIBBAD:80,ELIBSCN:81,ELIBMAX:82,ELIBEXEC:83,ENOSYS:38,ENOTEMPTY:39,ENAMETOOLONG:36,ELOOP:40,EOPNOTSUPP:95,EPFNOSUPPORT:96,ECONNRESET:104,ENOBUFS:105,EAFNOSUPPORT:97,EPROTOTYPE:91,ENOTSOCK:88,ENOPROTOOPT:92,ESHUTDOWN:108,ECONNREFUSED:111,EADDRINUSE:98,ECONNABORTED:103,ENETUNREACH:101,ENETDOWN:100,ETIMEDOUT:110,EHOSTDOWN:112,EHOSTUNREACH:113,EINPROGRESS:115,EALREADY:114,EDESTADDRREQ:89,EMSGSIZE:90,EPROTONOSUPPORT:93,ESOCKTNOSUPPORT:94,EADDRNOTAVAIL:99,ENETRESET:102,EISCONN:106,ENOTCONN:107,ETOOMANYREFS:109,EUSERS:87,EDQUOT:122,ESTALE:116,ENOTSUP:95,ENOMEDIUM:123,EILSEQ:84,EOVERFLOW:75,ECANCELED:125,ENOTRECOVERABLE:131,EOWNERDEAD:130,ESTRPIPE:86};function __parseInt(str, endptr, base, min, max, bits, unsign) {
      // Skip space.
      while (_isspace(HEAP8[(str)])) str++;
  
      // Check for a plus/minus sign.
      var multiplier = 1;
      if (HEAP8[(str)] == 45) {
        multiplier = -1;
        str++;
      } else if (HEAP8[(str)] == 43) {
        str++;
      }
  
      // Find base.
      var finalBase = base;
      if (!finalBase) {
        if (HEAP8[(str)] == 48) {
          if (HEAP8[((str+1)|0)] == 120 ||
              HEAP8[((str+1)|0)] == 88) {
            finalBase = 16;
            str += 2;
          } else {
            finalBase = 8;
            str++;
          }
        }
      } else if (finalBase==16) {
        if (HEAP8[(str)] == 48) {
          if (HEAP8[((str+1)|0)] == 120 ||
              HEAP8[((str+1)|0)] == 88) {
            str += 2;
          }
        }
      }
      if (!finalBase) finalBase = 10;
  
      // Get digits.
      var chr;
      var ret = 0;
      while ((chr = HEAP8[(str)]) != 0) {
        var digit = parseInt(String.fromCharCode(chr), finalBase);
        if (isNaN(digit)) {
          break;
        } else {
          ret = ret * finalBase + digit;
          str++;
        }
      }
  
      // Apply sign.
      ret *= multiplier;
  
      // Set end pointer.
      if (endptr) {
        HEAP32[((endptr)>>2)]=str;
      }
  
      // Unsign if needed.
      if (unsign) {
        if (Math.abs(ret) > max) {
          ret = max;
          ___setErrNo(ERRNO_CODES.ERANGE);
        } else {
          ret = unSign(ret, bits);
        }
      }
  
      // Validate range.
      if (ret > max || ret < min) {
        ret = ret > max ? max : min;
        ___setErrNo(ERRNO_CODES.ERANGE);
      }
  
      if (bits == 64) {
        return tempRet0 = (tempDouble=ret,Math_abs(tempDouble) >= 1 ? (tempDouble > 0 ? Math_min(Math_floor((tempDouble)/4294967296), 4294967295)>>>0 : (~~(Math_ceil((tempDouble - +(((~~(tempDouble)))>>>0))/4294967296)))>>>0) : 0),ret>>>0;
      }
  
      return ret;
    }function _strtol(str, endptr, base) {
      return __parseInt(str, endptr, base, -2147483648, 2147483647, 32);  // LONG_MIN, LONG_MAX.
    }function _atoi(ptr) {
      return _strtol(ptr, null, 10);
    }

  
  
  var ERRNO_MESSAGES={0:"Success",1:"Not super-user",2:"No such file or directory",3:"No such process",4:"Interrupted system call",5:"I/O error",6:"No such device or address",7:"Arg list too long",8:"Exec format error",9:"Bad file number",10:"No children",11:"No more processes",12:"Not enough core",13:"Permission denied",14:"Bad address",15:"Block device required",16:"Mount device busy",17:"File exists",18:"Cross-device link",19:"No such device",20:"Not a directory",21:"Is a directory",22:"Invalid argument",23:"Too many open files in system",24:"Too many open files",25:"Not a typewriter",26:"Text file busy",27:"File too large",28:"No space left on device",29:"Illegal seek",30:"Read only file system",31:"Too many links",32:"Broken pipe",33:"Math arg out of domain of func",34:"Math result not representable",35:"File locking deadlock error",36:"File or path name too long",37:"No record locks available",38:"Function not implemented",39:"Directory not empty",40:"Too many symbolic links",42:"No message of desired type",43:"Identifier removed",44:"Channel number out of range",45:"Level 2 not synchronized",46:"Level 3 halted",47:"Level 3 reset",48:"Link number out of range",49:"Protocol driver not attached",50:"No CSI structure available",51:"Level 2 halted",52:"Invalid exchange",53:"Invalid request descriptor",54:"Exchange full",55:"No anode",56:"Invalid request code",57:"Invalid slot",59:"Bad font file fmt",60:"Device not a stream",61:"No data (for no delay io)",62:"Timer expired",63:"Out of streams resources",64:"Machine is not on the network",65:"Package not installed",66:"The object is remote",67:"The link has been severed",68:"Advertise error",69:"Srmount error",70:"Communication error on send",71:"Protocol error",72:"Multihop attempted",73:"Cross mount point (not really error)",74:"Trying to read unreadable message",75:"Value too large for defined data type",76:"Given log. name not unique",77:"f.d. invalid for this operation",78:"Remote address changed",79:"Can   access a needed shared lib",80:"Accessing a corrupted shared lib",81:".lib section in a.out corrupted",82:"Attempting to link in too many libs",83:"Attempting to exec a shared library",84:"Illegal byte sequence",86:"Streams pipe error",87:"Too many users",88:"Socket operation on non-socket",89:"Destination address required",90:"Message too long",91:"Protocol wrong type for socket",92:"Protocol not available",93:"Unknown protocol",94:"Socket type not supported",95:"Not supported",96:"Protocol family not supported",97:"Address family not supported by protocol family",98:"Address already in use",99:"Address not available",100:"Network interface is not configured",101:"Network is unreachable",102:"Connection reset by network",103:"Connection aborted",104:"Connection reset by peer",105:"No buffer space available",106:"Socket is already connected",107:"Socket is not connected",108:"Can't send after socket shutdown",109:"Too many references",110:"Connection timed out",111:"Connection refused",112:"Host is down",113:"Host is unreachable",114:"Socket already connected",115:"Connection already in progress",116:"Stale file handle",122:"Quota exceeded",123:"No medium (in tape drive)",125:"Operation canceled",130:"Previous owner died",131:"State not recoverable"};
  
  var PATH={splitPath:function (filename) {
        var splitPathRe = /^(\/?|)([\s\S]*?)((?:\.{1,2}|[^\/]+?|)(\.[^.\/]*|))(?:[\/]*)$/;
        return splitPathRe.exec(filename).slice(1);
      },normalizeArray:function (parts, allowAboveRoot) {
        // if the path tries to go above the root, `up` ends up > 0
        var up = 0;
        for (var i = parts.length - 1; i >= 0; i--) {
          var last = parts[i];
          if (last === '.') {
            parts.splice(i, 1);
          } else if (last === '..') {
            parts.splice(i, 1);
            up++;
          } else if (up) {
            parts.splice(i, 1);
            up--;
          }
        }
        // if the path is allowed to go above the root, restore leading ..s
        if (allowAboveRoot) {
          for (; up--; up) {
            parts.unshift('..');
          }
        }
        return parts;
      },normalize:function (path) {
        var isAbsolute = path.charAt(0) === '/',
            trailingSlash = path.substr(-1) === '/';
        // Normalize the path
        path = PATH.normalizeArray(path.split('/').filter(function(p) {
          return !!p;
        }), !isAbsolute).join('/');
        if (!path && !isAbsolute) {
          path = '.';
        }
        if (path && trailingSlash) {
          path += '/';
        }
        return (isAbsolute ? '/' : '') + path;
      },dirname:function (path) {
        var result = PATH.splitPath(path),
            root = result[0],
            dir = result[1];
        if (!root && !dir) {
          // No dirname whatsoever
          return '.';
        }
        if (dir) {
          // It has a dirname, strip trailing slash
          dir = dir.substr(0, dir.length - 1);
        }
        return root + dir;
      },basename:function (path) {
        // EMSCRIPTEN return '/'' for '/', not an empty string
        if (path === '/') return '/';
        var lastSlash = path.lastIndexOf('/');
        if (lastSlash === -1) return path;
        return path.substr(lastSlash+1);
      },extname:function (path) {
        return PATH.splitPath(path)[3];
      },join:function () {
        var paths = Array.prototype.slice.call(arguments, 0);
        return PATH.normalize(paths.join('/'));
      },join2:function (l, r) {
        return PATH.normalize(l + '/' + r);
      },resolve:function () {
        var resolvedPath = '',
          resolvedAbsolute = false;
        for (var i = arguments.length - 1; i >= -1 && !resolvedAbsolute; i--) {
          var path = (i >= 0) ? arguments[i] : FS.cwd();
          // Skip empty and invalid entries
          if (typeof path !== 'string') {
            throw new TypeError('Arguments to path.resolve must be strings');
          } else if (!path) {
            continue;
          }
          resolvedPath = path + '/' + resolvedPath;
          resolvedAbsolute = path.charAt(0) === '/';
        }
        // At this point the path should be resolved to a full absolute path, but
        // handle relative paths to be safe (might happen when process.cwd() fails)
        resolvedPath = PATH.normalizeArray(resolvedPath.split('/').filter(function(p) {
          return !!p;
        }), !resolvedAbsolute).join('/');
        return ((resolvedAbsolute ? '/' : '') + resolvedPath) || '.';
      },relative:function (from, to) {
        from = PATH.resolve(from).substr(1);
        to = PATH.resolve(to).substr(1);
        function trim(arr) {
          var start = 0;
          for (; start < arr.length; start++) {
            if (arr[start] !== '') break;
          }
          var end = arr.length - 1;
          for (; end >= 0; end--) {
            if (arr[end] !== '') break;
          }
          if (start > end) return [];
          return arr.slice(start, end - start + 1);
        }
        var fromParts = trim(from.split('/'));
        var toParts = trim(to.split('/'));
        var length = Math.min(fromParts.length, toParts.length);
        var samePartsLength = length;
        for (var i = 0; i < length; i++) {
          if (fromParts[i] !== toParts[i]) {
            samePartsLength = i;
            break;
          }
        }
        var outputParts = [];
        for (var i = samePartsLength; i < fromParts.length; i++) {
          outputParts.push('..');
        }
        outputParts = outputParts.concat(toParts.slice(samePartsLength));
        return outputParts.join('/');
      }};
  
  var TTY={ttys:[],init:function () {
        // https://github.com/kripken/emscripten/pull/1555
        // if (ENVIRONMENT_IS_NODE) {
        //   // currently, FS.init does not distinguish if process.stdin is a file or TTY
        //   // device, it always assumes it's a TTY device. because of this, we're forcing
        //   // process.stdin to UTF8 encoding to at least make stdin reading compatible
        //   // with text files until FS.init can be refactored.
        //   process['stdin']['setEncoding']('utf8');
        // }
      },shutdown:function () {
        // https://github.com/kripken/emscripten/pull/1555
        // if (ENVIRONMENT_IS_NODE) {
        //   // inolen: any idea as to why node -e 'process.stdin.read()' wouldn't exit immediately (with process.stdin being a tty)?
        //   // isaacs: because now it's reading from the stream, you've expressed interest in it, so that read() kicks off a _read() which creates a ReadReq operation
        //   // inolen: I thought read() in that case was a synchronous operation that just grabbed some amount of buffered data if it exists?
        //   // isaacs: it is. but it also triggers a _read() call, which calls readStart() on the handle
        //   // isaacs: do process.stdin.pause() and i'd think it'd probably close the pending call
        //   process['stdin']['pause']();
        // }
      },register:function (dev, ops) {
        TTY.ttys[dev] = { input: [], output: [], ops: ops };
        FS.registerDevice(dev, TTY.stream_ops);
      },stream_ops:{open:function (stream) {
          var tty = TTY.ttys[stream.node.rdev];
          if (!tty) {
            throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
          }
          stream.tty = tty;
          stream.seekable = false;
        },close:function (stream) {
          // flush any pending line data
          if (stream.tty.output.length) {
            stream.tty.ops.put_char(stream.tty, 10);
          }
        },read:function (stream, buffer, offset, length, pos /* ignored */) {
          if (!stream.tty || !stream.tty.ops.get_char) {
            throw new FS.ErrnoError(ERRNO_CODES.ENXIO);
          }
          var bytesRead = 0;
          for (var i = 0; i < length; i++) {
            var result;
            try {
              result = stream.tty.ops.get_char(stream.tty);
            } catch (e) {
              throw new FS.ErrnoError(ERRNO_CODES.EIO);
            }
            if (result === undefined && bytesRead === 0) {
              throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
            }
            if (result === null || result === undefined) break;
            bytesRead++;
            buffer[offset+i] = result;
          }
          if (bytesRead) {
            stream.node.timestamp = Date.now();
          }
          return bytesRead;
        },write:function (stream, buffer, offset, length, pos) {
          if (!stream.tty || !stream.tty.ops.put_char) {
            throw new FS.ErrnoError(ERRNO_CODES.ENXIO);
          }
          for (var i = 0; i < length; i++) {
            try {
              stream.tty.ops.put_char(stream.tty, buffer[offset+i]);
            } catch (e) {
              throw new FS.ErrnoError(ERRNO_CODES.EIO);
            }
          }
          if (length) {
            stream.node.timestamp = Date.now();
          }
          return i;
        }},default_tty_ops:{get_char:function (tty) {
          if (!tty.input.length) {
            var result = null;
            if (ENVIRONMENT_IS_NODE) {
              result = process['stdin']['read']();
              if (!result) {
                if (process['stdin']['_readableState'] && process['stdin']['_readableState']['ended']) {
                  return null;  // EOF
                }
                return undefined;  // no data available
              }
            } else if (typeof window != 'undefined' &&
              typeof window.prompt == 'function') {
              // Browser.
              result = window.prompt('Input: ');  // returns null on cancel
              if (result !== null) {
                result += '\n';
              }
            } else if (typeof readline == 'function') {
              // Command line.
              result = readline();
              if (result !== null) {
                result += '\n';
              }
            }
            if (!result) {
              return null;
            }
            tty.input = intArrayFromString(result, true);
          }
          return tty.input.shift();
        },put_char:function (tty, val) {
          if (val === null || val === 10) {
            Module['print'](tty.output.join(''));
            tty.output = [];
          } else {
            tty.output.push(TTY.utf8.processCChar(val));
          }
        }},default_tty1_ops:{put_char:function (tty, val) {
          if (val === null || val === 10) {
            Module['printErr'](tty.output.join(''));
            tty.output = [];
          } else {
            tty.output.push(TTY.utf8.processCChar(val));
          }
        }}};
  
  var MEMFS={ops_table:null,CONTENT_OWNING:1,CONTENT_FLEXIBLE:2,CONTENT_FIXED:3,mount:function (mount) {
        return MEMFS.createNode(null, '/', 16384 | 511 /* 0777 */, 0);
      },createNode:function (parent, name, mode, dev) {
        if (FS.isBlkdev(mode) || FS.isFIFO(mode)) {
          // no supported
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (!MEMFS.ops_table) {
          MEMFS.ops_table = {
            dir: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr,
                lookup: MEMFS.node_ops.lookup,
                mknod: MEMFS.node_ops.mknod,
                rename: MEMFS.node_ops.rename,
                unlink: MEMFS.node_ops.unlink,
                rmdir: MEMFS.node_ops.rmdir,
                readdir: MEMFS.node_ops.readdir,
                symlink: MEMFS.node_ops.symlink
              },
              stream: {
                llseek: MEMFS.stream_ops.llseek
              }
            },
            file: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr
              },
              stream: {
                llseek: MEMFS.stream_ops.llseek,
                read: MEMFS.stream_ops.read,
                write: MEMFS.stream_ops.write,
                allocate: MEMFS.stream_ops.allocate,
                mmap: MEMFS.stream_ops.mmap
              }
            },
            link: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr,
                readlink: MEMFS.node_ops.readlink
              },
              stream: {}
            },
            chrdev: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr
              },
              stream: FS.chrdev_stream_ops
            },
          };
        }
        var node = FS.createNode(parent, name, mode, dev);
        if (FS.isDir(node.mode)) {
          node.node_ops = MEMFS.ops_table.dir.node;
          node.stream_ops = MEMFS.ops_table.dir.stream;
          node.contents = {};
        } else if (FS.isFile(node.mode)) {
          node.node_ops = MEMFS.ops_table.file.node;
          node.stream_ops = MEMFS.ops_table.file.stream;
          node.contents = [];
          node.contentMode = MEMFS.CONTENT_FLEXIBLE;
        } else if (FS.isLink(node.mode)) {
          node.node_ops = MEMFS.ops_table.link.node;
          node.stream_ops = MEMFS.ops_table.link.stream;
        } else if (FS.isChrdev(node.mode)) {
          node.node_ops = MEMFS.ops_table.chrdev.node;
          node.stream_ops = MEMFS.ops_table.chrdev.stream;
        }
        node.timestamp = Date.now();
        // add the new node to the parent
        if (parent) {
          parent.contents[name] = node;
        }
        return node;
      },ensureFlexible:function (node) {
        if (node.contentMode !== MEMFS.CONTENT_FLEXIBLE) {
          var contents = node.contents;
          node.contents = Array.prototype.slice.call(contents);
          node.contentMode = MEMFS.CONTENT_FLEXIBLE;
        }
      },node_ops:{getattr:function (node) {
          var attr = {};
          // device numbers reuse inode numbers.
          attr.dev = FS.isChrdev(node.mode) ? node.id : 1;
          attr.ino = node.id;
          attr.mode = node.mode;
          attr.nlink = 1;
          attr.uid = 0;
          attr.gid = 0;
          attr.rdev = node.rdev;
          if (FS.isDir(node.mode)) {
            attr.size = 4096;
          } else if (FS.isFile(node.mode)) {
            attr.size = node.contents.length;
          } else if (FS.isLink(node.mode)) {
            attr.size = node.link.length;
          } else {
            attr.size = 0;
          }
          attr.atime = new Date(node.timestamp);
          attr.mtime = new Date(node.timestamp);
          attr.ctime = new Date(node.timestamp);
          // NOTE: In our implementation, st_blocks = Math.ceil(st_size/st_blksize),
          //       but this is not required by the standard.
          attr.blksize = 4096;
          attr.blocks = Math.ceil(attr.size / attr.blksize);
          return attr;
        },setattr:function (node, attr) {
          if (attr.mode !== undefined) {
            node.mode = attr.mode;
          }
          if (attr.timestamp !== undefined) {
            node.timestamp = attr.timestamp;
          }
          if (attr.size !== undefined) {
            MEMFS.ensureFlexible(node);
            var contents = node.contents;
            if (attr.size < contents.length) contents.length = attr.size;
            else while (attr.size > contents.length) contents.push(0);
          }
        },lookup:function (parent, name) {
          throw FS.genericErrors[ERRNO_CODES.ENOENT];
        },mknod:function (parent, name, mode, dev) {
          return MEMFS.createNode(parent, name, mode, dev);
        },rename:function (old_node, new_dir, new_name) {
          // if we're overwriting a directory at new_name, make sure it's empty.
          if (FS.isDir(old_node.mode)) {
            var new_node;
            try {
              new_node = FS.lookupNode(new_dir, new_name);
            } catch (e) {
            }
            if (new_node) {
              for (var i in new_node.contents) {
                throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY);
              }
            }
          }
          // do the internal rewiring
          delete old_node.parent.contents[old_node.name];
          old_node.name = new_name;
          new_dir.contents[new_name] = old_node;
          old_node.parent = new_dir;
        },unlink:function (parent, name) {
          delete parent.contents[name];
        },rmdir:function (parent, name) {
          var node = FS.lookupNode(parent, name);
          for (var i in node.contents) {
            throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY);
          }
          delete parent.contents[name];
        },readdir:function (node) {
          var entries = ['.', '..']
          for (var key in node.contents) {
            if (!node.contents.hasOwnProperty(key)) {
              continue;
            }
            entries.push(key);
          }
          return entries;
        },symlink:function (parent, newname, oldpath) {
          var node = MEMFS.createNode(parent, newname, 511 /* 0777 */ | 40960, 0);
          node.link = oldpath;
          return node;
        },readlink:function (node) {
          if (!FS.isLink(node.mode)) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
          return node.link;
        }},stream_ops:{read:function (stream, buffer, offset, length, position) {
          var contents = stream.node.contents;
          if (position >= contents.length)
            return 0;
          var size = Math.min(contents.length - position, length);
          assert(size >= 0);
          if (size > 8 && contents.subarray) { // non-trivial, and typed array
            buffer.set(contents.subarray(position, position + size), offset);
          } else
          {
            for (var i = 0; i < size; i++) {
              buffer[offset + i] = contents[position + i];
            }
          }
          return size;
        },write:function (stream, buffer, offset, length, position, canOwn) {
          var node = stream.node;
          node.timestamp = Date.now();
          var contents = node.contents;
          if (length && contents.length === 0 && position === 0 && buffer.subarray) {
            // just replace it with the new data
            assert(buffer.length);
            if (canOwn && offset === 0) {
              node.contents = buffer; // this could be a subarray of Emscripten HEAP, or allocated from some other source.
              node.contentMode = (buffer.buffer === HEAP8.buffer) ? MEMFS.CONTENT_OWNING : MEMFS.CONTENT_FIXED;
            } else {
              node.contents = new Uint8Array(buffer.subarray(offset, offset+length));
              node.contentMode = MEMFS.CONTENT_FIXED;
            }
            return length;
          }
          MEMFS.ensureFlexible(node);
          var contents = node.contents;
          while (contents.length < position) contents.push(0);
          for (var i = 0; i < length; i++) {
            contents[position + i] = buffer[offset + i];
          }
          return length;
        },llseek:function (stream, offset, whence) {
          var position = offset;
          if (whence === 1) {  // SEEK_CUR.
            position += stream.position;
          } else if (whence === 2) {  // SEEK_END.
            if (FS.isFile(stream.node.mode)) {
              position += stream.node.contents.length;
            }
          }
          if (position < 0) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
          stream.ungotten = [];
          stream.position = position;
          return position;
        },allocate:function (stream, offset, length) {
          MEMFS.ensureFlexible(stream.node);
          var contents = stream.node.contents;
          var limit = offset + length;
          while (limit > contents.length) contents.push(0);
        },mmap:function (stream, buffer, offset, length, position, prot, flags) {
          if (!FS.isFile(stream.node.mode)) {
            throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
          }
          var ptr;
          var allocated;
          var contents = stream.node.contents;
          // Only make a new copy when MAP_PRIVATE is specified.
          if ( !(flags & 2) &&
                (contents.buffer === buffer || contents.buffer === buffer.buffer) ) {
            // We can't emulate MAP_SHARED when the file is not backed by the buffer
            // we're mapping to (e.g. the HEAP buffer).
            allocated = false;
            ptr = contents.byteOffset;
          } else {
            // Try to avoid unnecessary slices.
            if (position > 0 || position + length < contents.length) {
              if (contents.subarray) {
                contents = contents.subarray(position, position + length);
              } else {
                contents = Array.prototype.slice.call(contents, position, position + length);
              }
            }
            allocated = true;
            ptr = _malloc(length);
            if (!ptr) {
              throw new FS.ErrnoError(ERRNO_CODES.ENOMEM);
            }
            buffer.set(contents, ptr);
          }
          return { ptr: ptr, allocated: allocated };
        }}};
  
  var IDBFS={dbs:{},indexedDB:function () {
        return window.indexedDB || window.mozIndexedDB || window.webkitIndexedDB || window.msIndexedDB;
      },DB_VERSION:21,DB_STORE_NAME:"FILE_DATA",mount:function (mount) {
        // reuse all of the core MEMFS functionality
        return MEMFS.mount.apply(null, arguments);
      },syncfs:function (mount, populate, callback) {
        IDBFS.getLocalSet(mount, function(err, local) {
          if (err) return callback(err);
  
          IDBFS.getRemoteSet(mount, function(err, remote) {
            if (err) return callback(err);
  
            var src = populate ? remote : local;
            var dst = populate ? local : remote;
  
            IDBFS.reconcile(src, dst, callback);
          });
        });
      },getDB:function (name, callback) {
        // check the cache first
        var db = IDBFS.dbs[name];
        if (db) {
          return callback(null, db);
        }
  
        var req;
        try {
          req = IDBFS.indexedDB().open(name, IDBFS.DB_VERSION);
        } catch (e) {
          return callback(e);
        }
        req.onupgradeneeded = function(e) {
          var db = e.target.result;
          var transaction = e.target.transaction;
  
          var fileStore;
  
          if (db.objectStoreNames.contains(IDBFS.DB_STORE_NAME)) {
            fileStore = transaction.objectStore(IDBFS.DB_STORE_NAME);
          } else {
            fileStore = db.createObjectStore(IDBFS.DB_STORE_NAME);
          }
  
          fileStore.createIndex('timestamp', 'timestamp', { unique: false });
        };
        req.onsuccess = function() {
          db = req.result;
  
          // add to the cache
          IDBFS.dbs[name] = db;
          callback(null, db);
        };
        req.onerror = function() {
          callback(this.error);
        };
      },getLocalSet:function (mount, callback) {
        var entries = {};
  
        function isRealDir(p) {
          return p !== '.' && p !== '..';
        };
        function toAbsolute(root) {
          return function(p) {
            return PATH.join2(root, p);
          }
        };
  
        var check = FS.readdir(mount.mountpoint).filter(isRealDir).map(toAbsolute(mount.mountpoint));
  
        while (check.length) {
          var path = check.pop();
          var stat;
  
          try {
            stat = FS.stat(path);
          } catch (e) {
            return callback(e);
          }
  
          if (FS.isDir(stat.mode)) {
            check.push.apply(check, FS.readdir(path).filter(isRealDir).map(toAbsolute(path)));
          }
  
          entries[path] = { timestamp: stat.mtime };
        }
  
        return callback(null, { type: 'local', entries: entries });
      },getRemoteSet:function (mount, callback) {
        var entries = {};
  
        IDBFS.getDB(mount.mountpoint, function(err, db) {
          if (err) return callback(err);
  
          var transaction = db.transaction([IDBFS.DB_STORE_NAME], 'readonly');
          transaction.onerror = function() { callback(this.error); };
  
          var store = transaction.objectStore(IDBFS.DB_STORE_NAME);
          var index = store.index('timestamp');
  
          index.openKeyCursor().onsuccess = function(event) {
            var cursor = event.target.result;
  
            if (!cursor) {
              return callback(null, { type: 'remote', db: db, entries: entries });
            }
  
            entries[cursor.primaryKey] = { timestamp: cursor.key };
  
            cursor.continue();
          };
        });
      },loadLocalEntry:function (path, callback) {
        var stat, node;
  
        try {
          var lookup = FS.lookupPath(path);
          node = lookup.node;
          stat = FS.stat(path);
        } catch (e) {
          return callback(e);
        }
  
        if (FS.isDir(stat.mode)) {
          return callback(null, { timestamp: stat.mtime, mode: stat.mode });
        } else if (FS.isFile(stat.mode)) {
          return callback(null, { timestamp: stat.mtime, mode: stat.mode, contents: node.contents });
        } else {
          return callback(new Error('node type not supported'));
        }
      },storeLocalEntry:function (path, entry, callback) {
        try {
          if (FS.isDir(entry.mode)) {
            FS.mkdir(path, entry.mode);
          } else if (FS.isFile(entry.mode)) {
            FS.writeFile(path, entry.contents, { encoding: 'binary', canOwn: true });
          } else {
            return callback(new Error('node type not supported'));
          }
  
          FS.utime(path, entry.timestamp, entry.timestamp);
        } catch (e) {
          return callback(e);
        }
  
        callback(null);
      },removeLocalEntry:function (path, callback) {
        try {
          var lookup = FS.lookupPath(path);
          var stat = FS.stat(path);
  
          if (FS.isDir(stat.mode)) {
            FS.rmdir(path);
          } else if (FS.isFile(stat.mode)) {
            FS.unlink(path);
          }
        } catch (e) {
          return callback(e);
        }
  
        callback(null);
      },loadRemoteEntry:function (store, path, callback) {
        var req = store.get(path);
        req.onsuccess = function(event) { callback(null, event.target.result); };
        req.onerror = function() { callback(this.error); };
      },storeRemoteEntry:function (store, path, entry, callback) {
        var req = store.put(entry, path);
        req.onsuccess = function() { callback(null); };
        req.onerror = function() { callback(this.error); };
      },removeRemoteEntry:function (store, path, callback) {
        var req = store.delete(path);
        req.onsuccess = function() { callback(null); };
        req.onerror = function() { callback(this.error); };
      },reconcile:function (src, dst, callback) {
        var total = 0;
  
        var create = [];
        Object.keys(src.entries).forEach(function (key) {
          var e = src.entries[key];
          var e2 = dst.entries[key];
          if (!e2 || e.timestamp > e2.timestamp) {
            create.push(key);
            total++;
          }
        });
  
        var remove = [];
        Object.keys(dst.entries).forEach(function (key) {
          var e = dst.entries[key];
          var e2 = src.entries[key];
          if (!e2) {
            remove.push(key);
            total++;
          }
        });
  
        if (!total) {
          return callback(null);
        }
  
        var errored = false;
        var completed = 0;
        var db = src.type === 'remote' ? src.db : dst.db;
        var transaction = db.transaction([IDBFS.DB_STORE_NAME], 'readwrite');
        var store = transaction.objectStore(IDBFS.DB_STORE_NAME);
  
        function done(err) {
          if (err) {
            if (!done.errored) {
              done.errored = true;
              return callback(err);
            }
            return;
          }
          if (++completed >= total) {
            return callback(null);
          }
        };
  
        transaction.onerror = function() { done(this.error); };
  
        // sort paths in ascending order so directory entries are created
        // before the files inside them
        create.sort().forEach(function (path) {
          if (dst.type === 'local') {
            IDBFS.loadRemoteEntry(store, path, function (err, entry) {
              if (err) return done(err);
              IDBFS.storeLocalEntry(path, entry, done);
            });
          } else {
            IDBFS.loadLocalEntry(path, function (err, entry) {
              if (err) return done(err);
              IDBFS.storeRemoteEntry(store, path, entry, done);
            });
          }
        });
  
        // sort paths in descending order so files are deleted before their
        // parent directories
        remove.sort().reverse().forEach(function(path) {
          if (dst.type === 'local') {
            IDBFS.removeLocalEntry(path, done);
          } else {
            IDBFS.removeRemoteEntry(store, path, done);
          }
        });
      }};
  
  var NODEFS={isWindows:false,staticInit:function () {
        NODEFS.isWindows = !!process.platform.match(/^win/);
      },mount:function (mount) {
        assert(ENVIRONMENT_IS_NODE);
        return NODEFS.createNode(null, '/', NODEFS.getMode(mount.opts.root), 0);
      },createNode:function (parent, name, mode, dev) {
        if (!FS.isDir(mode) && !FS.isFile(mode) && !FS.isLink(mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var node = FS.createNode(parent, name, mode);
        node.node_ops = NODEFS.node_ops;
        node.stream_ops = NODEFS.stream_ops;
        return node;
      },getMode:function (path) {
        var stat;
        try {
          stat = fs.lstatSync(path);
          if (NODEFS.isWindows) {
            // On Windows, directories return permission bits 'rw-rw-rw-', even though they have 'rwxrwxrwx', so 
            // propagate write bits to execute bits.
            stat.mode = stat.mode | ((stat.mode & 146) >> 1);
          }
        } catch (e) {
          if (!e.code) throw e;
          throw new FS.ErrnoError(ERRNO_CODES[e.code]);
        }
        return stat.mode;
      },realPath:function (node) {
        var parts = [];
        while (node.parent !== node) {
          parts.push(node.name);
          node = node.parent;
        }
        parts.push(node.mount.opts.root);
        parts.reverse();
        return PATH.join.apply(null, parts);
      },flagsToPermissionStringMap:{0:"r",1:"r+",2:"r+",64:"r",65:"r+",66:"r+",129:"rx+",193:"rx+",514:"w+",577:"w",578:"w+",705:"wx",706:"wx+",1024:"a",1025:"a",1026:"a+",1089:"a",1090:"a+",1153:"ax",1154:"ax+",1217:"ax",1218:"ax+",4096:"rs",4098:"rs+"},flagsToPermissionString:function (flags) {
        if (flags in NODEFS.flagsToPermissionStringMap) {
          return NODEFS.flagsToPermissionStringMap[flags];
        } else {
          return flags;
        }
      },node_ops:{getattr:function (node) {
          var path = NODEFS.realPath(node);
          var stat;
          try {
            stat = fs.lstatSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          // node.js v0.10.20 doesn't report blksize and blocks on Windows. Fake them with default blksize of 4096.
          // See http://support.microsoft.com/kb/140365
          if (NODEFS.isWindows && !stat.blksize) {
            stat.blksize = 4096;
          }
          if (NODEFS.isWindows && !stat.blocks) {
            stat.blocks = (stat.size+stat.blksize-1)/stat.blksize|0;
          }
          return {
            dev: stat.dev,
            ino: stat.ino,
            mode: stat.mode,
            nlink: stat.nlink,
            uid: stat.uid,
            gid: stat.gid,
            rdev: stat.rdev,
            size: stat.size,
            atime: stat.atime,
            mtime: stat.mtime,
            ctime: stat.ctime,
            blksize: stat.blksize,
            blocks: stat.blocks
          };
        },setattr:function (node, attr) {
          var path = NODEFS.realPath(node);
          try {
            if (attr.mode !== undefined) {
              fs.chmodSync(path, attr.mode);
              // update the common node structure mode as well
              node.mode = attr.mode;
            }
            if (attr.timestamp !== undefined) {
              var date = new Date(attr.timestamp);
              fs.utimesSync(path, date, date);
            }
            if (attr.size !== undefined) {
              fs.truncateSync(path, attr.size);
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },lookup:function (parent, name) {
          var path = PATH.join2(NODEFS.realPath(parent), name);
          var mode = NODEFS.getMode(path);
          return NODEFS.createNode(parent, name, mode);
        },mknod:function (parent, name, mode, dev) {
          var node = NODEFS.createNode(parent, name, mode, dev);
          // create the backing node for this in the fs root as well
          var path = NODEFS.realPath(node);
          try {
            if (FS.isDir(node.mode)) {
              fs.mkdirSync(path, node.mode);
            } else {
              fs.writeFileSync(path, '', { mode: node.mode });
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          return node;
        },rename:function (oldNode, newDir, newName) {
          var oldPath = NODEFS.realPath(oldNode);
          var newPath = PATH.join2(NODEFS.realPath(newDir), newName);
          try {
            fs.renameSync(oldPath, newPath);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },unlink:function (parent, name) {
          var path = PATH.join2(NODEFS.realPath(parent), name);
          try {
            fs.unlinkSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },rmdir:function (parent, name) {
          var path = PATH.join2(NODEFS.realPath(parent), name);
          try {
            fs.rmdirSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },readdir:function (node) {
          var path = NODEFS.realPath(node);
          try {
            return fs.readdirSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },symlink:function (parent, newName, oldPath) {
          var newPath = PATH.join2(NODEFS.realPath(parent), newName);
          try {
            fs.symlinkSync(oldPath, newPath);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },readlink:function (node) {
          var path = NODEFS.realPath(node);
          try {
            return fs.readlinkSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        }},stream_ops:{open:function (stream) {
          var path = NODEFS.realPath(stream.node);
          try {
            if (FS.isFile(stream.node.mode)) {
              stream.nfd = fs.openSync(path, NODEFS.flagsToPermissionString(stream.flags));
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },close:function (stream) {
          try {
            if (FS.isFile(stream.node.mode) && stream.nfd) {
              fs.closeSync(stream.nfd);
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },read:function (stream, buffer, offset, length, position) {
          // FIXME this is terrible.
          var nbuffer = new Buffer(length);
          var res;
          try {
            res = fs.readSync(stream.nfd, nbuffer, 0, length, position);
          } catch (e) {
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          if (res > 0) {
            for (var i = 0; i < res; i++) {
              buffer[offset + i] = nbuffer[i];
            }
          }
          return res;
        },write:function (stream, buffer, offset, length, position) {
          // FIXME this is terrible.
          var nbuffer = new Buffer(buffer.subarray(offset, offset + length));
          var res;
          try {
            res = fs.writeSync(stream.nfd, nbuffer, 0, length, position);
          } catch (e) {
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          return res;
        },llseek:function (stream, offset, whence) {
          var position = offset;
          if (whence === 1) {  // SEEK_CUR.
            position += stream.position;
          } else if (whence === 2) {  // SEEK_END.
            if (FS.isFile(stream.node.mode)) {
              try {
                var stat = fs.fstatSync(stream.nfd);
                position += stat.size;
              } catch (e) {
                throw new FS.ErrnoError(ERRNO_CODES[e.code]);
              }
            }
          }
  
          if (position < 0) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
  
          stream.position = position;
          return position;
        }}};
  
  var _stdin=allocate(1, "i32*", ALLOC_STATIC);
  
  var _stdout=allocate(1, "i32*", ALLOC_STATIC);
  
  var _stderr=allocate(1, "i32*", ALLOC_STATIC);
  
  function _fflush(stream) {
      // int fflush(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fflush.html
      // we don't currently perform any user-space buffering of data
    }var FS={root:null,mounts:[],devices:[null],streams:[],nextInode:1,nameTable:null,currentPath:"/",initialized:false,ignorePermissions:true,ErrnoError:null,genericErrors:{},handleFSError:function (e) {
        if (!(e instanceof FS.ErrnoError)) throw e + ' : ' + stackTrace();
        return ___setErrNo(e.errno);
      },lookupPath:function (path, opts) {
        path = PATH.resolve(FS.cwd(), path);
        opts = opts || {};
  
        var defaults = {
          follow_mount: true,
          recurse_count: 0
        };
        for (var key in defaults) {
          if (opts[key] === undefined) {
            opts[key] = defaults[key];
          }
        }
  
        if (opts.recurse_count > 8) {  // max recursive lookup of 8
          throw new FS.ErrnoError(ERRNO_CODES.ELOOP);
        }
  
        // split the path
        var parts = PATH.normalizeArray(path.split('/').filter(function(p) {
          return !!p;
        }), false);
  
        // start at the root
        var current = FS.root;
        var current_path = '/';
  
        for (var i = 0; i < parts.length; i++) {
          var islast = (i === parts.length-1);
          if (islast && opts.parent) {
            // stop resolving
            break;
          }
  
          current = FS.lookupNode(current, parts[i]);
          current_path = PATH.join2(current_path, parts[i]);
  
          // jump to the mount's root node if this is a mountpoint
          if (FS.isMountpoint(current)) {
            if (!islast || (islast && opts.follow_mount)) {
              current = current.mounted.root;
            }
          }
  
          // by default, lookupPath will not follow a symlink if it is the final path component.
          // setting opts.follow = true will override this behavior.
          if (!islast || opts.follow) {
            var count = 0;
            while (FS.isLink(current.mode)) {
              var link = FS.readlink(current_path);
              current_path = PATH.resolve(PATH.dirname(current_path), link);
              
              var lookup = FS.lookupPath(current_path, { recurse_count: opts.recurse_count });
              current = lookup.node;
  
              if (count++ > 40) {  // limit max consecutive symlinks to 40 (SYMLOOP_MAX).
                throw new FS.ErrnoError(ERRNO_CODES.ELOOP);
              }
            }
          }
        }
  
        return { path: current_path, node: current };
      },getPath:function (node) {
        var path;
        while (true) {
          if (FS.isRoot(node)) {
            var mount = node.mount.mountpoint;
            if (!path) return mount;
            return mount[mount.length-1] !== '/' ? mount + '/' + path : mount + path;
          }
          path = path ? node.name + '/' + path : node.name;
          node = node.parent;
        }
      },hashName:function (parentid, name) {
        var hash = 0;
  
  
        for (var i = 0; i < name.length; i++) {
          hash = ((hash << 5) - hash + name.charCodeAt(i)) | 0;
        }
        return ((parentid + hash) >>> 0) % FS.nameTable.length;
      },hashAddNode:function (node) {
        var hash = FS.hashName(node.parent.id, node.name);
        node.name_next = FS.nameTable[hash];
        FS.nameTable[hash] = node;
      },hashRemoveNode:function (node) {
        var hash = FS.hashName(node.parent.id, node.name);
        if (FS.nameTable[hash] === node) {
          FS.nameTable[hash] = node.name_next;
        } else {
          var current = FS.nameTable[hash];
          while (current) {
            if (current.name_next === node) {
              current.name_next = node.name_next;
              break;
            }
            current = current.name_next;
          }
        }
      },lookupNode:function (parent, name) {
        var err = FS.mayLookup(parent);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        var hash = FS.hashName(parent.id, name);
        for (var node = FS.nameTable[hash]; node; node = node.name_next) {
          var nodeName = node.name;
          if (node.parent.id === parent.id && nodeName === name) {
            return node;
          }
        }
        // if we failed to find it in the cache, call into the VFS
        return FS.lookup(parent, name);
      },createNode:function (parent, name, mode, rdev) {
        if (!FS.FSNode) {
          FS.FSNode = function(parent, name, mode, rdev) {
            if (!parent) {
              parent = this;  // root node sets parent to itself
            }
            this.parent = parent;
            this.mount = parent.mount;
            this.mounted = null;
            this.id = FS.nextInode++;
            this.name = name;
            this.mode = mode;
            this.node_ops = {};
            this.stream_ops = {};
            this.rdev = rdev;
          };
  
          FS.FSNode.prototype = {};
  
          // compatibility
          var readMode = 292 | 73;
          var writeMode = 146;
  
          // NOTE we must use Object.defineProperties instead of individual calls to
          // Object.defineProperty in order to make closure compiler happy
          Object.defineProperties(FS.FSNode.prototype, {
            read: {
              get: function() { return (this.mode & readMode) === readMode; },
              set: function(val) { val ? this.mode |= readMode : this.mode &= ~readMode; }
            },
            write: {
              get: function() { return (this.mode & writeMode) === writeMode; },
              set: function(val) { val ? this.mode |= writeMode : this.mode &= ~writeMode; }
            },
            isFolder: {
              get: function() { return FS.isDir(this.mode); },
            },
            isDevice: {
              get: function() { return FS.isChrdev(this.mode); },
            },
          });
        }
  
        var node = new FS.FSNode(parent, name, mode, rdev);
  
        FS.hashAddNode(node);
  
        return node;
      },destroyNode:function (node) {
        FS.hashRemoveNode(node);
      },isRoot:function (node) {
        return node === node.parent;
      },isMountpoint:function (node) {
        return !!node.mounted;
      },isFile:function (mode) {
        return (mode & 61440) === 32768;
      },isDir:function (mode) {
        return (mode & 61440) === 16384;
      },isLink:function (mode) {
        return (mode & 61440) === 40960;
      },isChrdev:function (mode) {
        return (mode & 61440) === 8192;
      },isBlkdev:function (mode) {
        return (mode & 61440) === 24576;
      },isFIFO:function (mode) {
        return (mode & 61440) === 4096;
      },isSocket:function (mode) {
        return (mode & 49152) === 49152;
      },flagModes:{"r":0,"rs":1052672,"r+":2,"w":577,"wx":705,"xw":705,"w+":578,"wx+":706,"xw+":706,"a":1089,"ax":1217,"xa":1217,"a+":1090,"ax+":1218,"xa+":1218},modeStringToFlags:function (str) {
        var flags = FS.flagModes[str];
        if (typeof flags === 'undefined') {
          throw new Error('Unknown file open mode: ' + str);
        }
        return flags;
      },flagsToPermissionString:function (flag) {
        var accmode = flag & 2097155;
        var perms = ['r', 'w', 'rw'][accmode];
        if ((flag & 512)) {
          perms += 'w';
        }
        return perms;
      },nodePermissions:function (node, perms) {
        if (FS.ignorePermissions) {
          return 0;
        }
        // return 0 if any user, group or owner bits are set.
        if (perms.indexOf('r') !== -1 && !(node.mode & 292)) {
          return ERRNO_CODES.EACCES;
        } else if (perms.indexOf('w') !== -1 && !(node.mode & 146)) {
          return ERRNO_CODES.EACCES;
        } else if (perms.indexOf('x') !== -1 && !(node.mode & 73)) {
          return ERRNO_CODES.EACCES;
        }
        return 0;
      },mayLookup:function (dir) {
        return FS.nodePermissions(dir, 'x');
      },mayCreate:function (dir, name) {
        try {
          var node = FS.lookupNode(dir, name);
          return ERRNO_CODES.EEXIST;
        } catch (e) {
        }
        return FS.nodePermissions(dir, 'wx');
      },mayDelete:function (dir, name, isdir) {
        var node;
        try {
          node = FS.lookupNode(dir, name);
        } catch (e) {
          return e.errno;
        }
        var err = FS.nodePermissions(dir, 'wx');
        if (err) {
          return err;
        }
        if (isdir) {
          if (!FS.isDir(node.mode)) {
            return ERRNO_CODES.ENOTDIR;
          }
          if (FS.isRoot(node) || FS.getPath(node) === FS.cwd()) {
            return ERRNO_CODES.EBUSY;
          }
        } else {
          if (FS.isDir(node.mode)) {
            return ERRNO_CODES.EISDIR;
          }
        }
        return 0;
      },mayOpen:function (node, flags) {
        if (!node) {
          return ERRNO_CODES.ENOENT;
        }
        if (FS.isLink(node.mode)) {
          return ERRNO_CODES.ELOOP;
        } else if (FS.isDir(node.mode)) {
          if ((flags & 2097155) !== 0 ||  // opening for write
              (flags & 512)) {
            return ERRNO_CODES.EISDIR;
          }
        }
        return FS.nodePermissions(node, FS.flagsToPermissionString(flags));
      },MAX_OPEN_FDS:4096,nextfd:function (fd_start, fd_end) {
        fd_start = fd_start || 0;
        fd_end = fd_end || FS.MAX_OPEN_FDS;
        for (var fd = fd_start; fd <= fd_end; fd++) {
          if (!FS.streams[fd]) {
            return fd;
          }
        }
        throw new FS.ErrnoError(ERRNO_CODES.EMFILE);
      },getStream:function (fd) {
        return FS.streams[fd];
      },createStream:function (stream, fd_start, fd_end) {
        if (!FS.FSStream) {
          FS.FSStream = function(){};
          FS.FSStream.prototype = {};
          // compatibility
          Object.defineProperties(FS.FSStream.prototype, {
            object: {
              get: function() { return this.node; },
              set: function(val) { this.node = val; }
            },
            isRead: {
              get: function() { return (this.flags & 2097155) !== 1; }
            },
            isWrite: {
              get: function() { return (this.flags & 2097155) !== 0; }
            },
            isAppend: {
              get: function() { return (this.flags & 1024); }
            }
          });
        }
        if (stream.__proto__) {
          // reuse the object
          stream.__proto__ = FS.FSStream.prototype;
        } else {
          var newStream = new FS.FSStream();
          for (var p in stream) {
            newStream[p] = stream[p];
          }
          stream = newStream;
        }
        var fd = FS.nextfd(fd_start, fd_end);
        stream.fd = fd;
        FS.streams[fd] = stream;
        return stream;
      },closeStream:function (fd) {
        FS.streams[fd] = null;
      },getStreamFromPtr:function (ptr) {
        return FS.streams[ptr - 1];
      },getPtrForStream:function (stream) {
        return stream ? stream.fd + 1 : 0;
      },chrdev_stream_ops:{open:function (stream) {
          var device = FS.getDevice(stream.node.rdev);
          // override node's stream ops with the device's
          stream.stream_ops = device.stream_ops;
          // forward the open call
          if (stream.stream_ops.open) {
            stream.stream_ops.open(stream);
          }
        },llseek:function () {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }},major:function (dev) {
        return ((dev) >> 8);
      },minor:function (dev) {
        return ((dev) & 0xff);
      },makedev:function (ma, mi) {
        return ((ma) << 8 | (mi));
      },registerDevice:function (dev, ops) {
        FS.devices[dev] = { stream_ops: ops };
      },getDevice:function (dev) {
        return FS.devices[dev];
      },getMounts:function (mount) {
        var mounts = [];
        var check = [mount];
  
        while (check.length) {
          var m = check.pop();
  
          mounts.push(m);
  
          check.push.apply(check, m.mounts);
        }
  
        return mounts;
      },syncfs:function (populate, callback) {
        if (typeof(populate) === 'function') {
          callback = populate;
          populate = false;
        }
  
        var mounts = FS.getMounts(FS.root.mount);
        var completed = 0;
  
        function done(err) {
          if (err) {
            if (!done.errored) {
              done.errored = true;
              return callback(err);
            }
            return;
          }
          if (++completed >= mounts.length) {
            callback(null);
          }
        };
  
        // sync all mounts
        mounts.forEach(function (mount) {
          if (!mount.type.syncfs) {
            return done(null);
          }
          mount.type.syncfs(mount, populate, done);
        });
      },mount:function (type, opts, mountpoint) {
        var root = mountpoint === '/';
        var pseudo = !mountpoint;
        var node;
  
        if (root && FS.root) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        } else if (!root && !pseudo) {
          var lookup = FS.lookupPath(mountpoint, { follow_mount: false });
  
          mountpoint = lookup.path;  // use the absolute path
          node = lookup.node;
  
          if (FS.isMountpoint(node)) {
            throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
          }
  
          if (!FS.isDir(node.mode)) {
            throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR);
          }
        }
  
        var mount = {
          type: type,
          opts: opts,
          mountpoint: mountpoint,
          mounts: []
        };
  
        // create a root node for the fs
        var mountRoot = type.mount(mount);
        mountRoot.mount = mount;
        mount.root = mountRoot;
  
        if (root) {
          FS.root = mountRoot;
        } else if (node) {
          // set as a mountpoint
          node.mounted = mount;
  
          // add the new mount to the current mount's children
          if (node.mount) {
            node.mount.mounts.push(mount);
          }
        }
  
        return mountRoot;
      },unmount:function (mountpoint) {
        var lookup = FS.lookupPath(mountpoint, { follow_mount: false });
  
        if (!FS.isMountpoint(lookup.node)) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
  
        // destroy the nodes for this mount, and all its child mounts
        var node = lookup.node;
        var mount = node.mounted;
        var mounts = FS.getMounts(mount);
  
        Object.keys(FS.nameTable).forEach(function (hash) {
          var current = FS.nameTable[hash];
  
          while (current) {
            var next = current.name_next;
  
            if (mounts.indexOf(current.mount) !== -1) {
              FS.destroyNode(current);
            }
  
            current = next;
          }
        });
  
        // no longer a mountpoint
        node.mounted = null;
  
        // remove this mount from the child mounts
        var idx = node.mount.mounts.indexOf(mount);
        assert(idx !== -1);
        node.mount.mounts.splice(idx, 1);
      },lookup:function (parent, name) {
        return parent.node_ops.lookup(parent, name);
      },mknod:function (path, mode, dev) {
        var lookup = FS.lookupPath(path, { parent: true });
        var parent = lookup.node;
        var name = PATH.basename(path);
        var err = FS.mayCreate(parent, name);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.mknod) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        return parent.node_ops.mknod(parent, name, mode, dev);
      },create:function (path, mode) {
        mode = mode !== undefined ? mode : 438 /* 0666 */;
        mode &= 4095;
        mode |= 32768;
        return FS.mknod(path, mode, 0);
      },mkdir:function (path, mode) {
        mode = mode !== undefined ? mode : 511 /* 0777 */;
        mode &= 511 | 512;
        mode |= 16384;
        return FS.mknod(path, mode, 0);
      },mkdev:function (path, mode, dev) {
        if (typeof(dev) === 'undefined') {
          dev = mode;
          mode = 438 /* 0666 */;
        }
        mode |= 8192;
        return FS.mknod(path, mode, dev);
      },symlink:function (oldpath, newpath) {
        var lookup = FS.lookupPath(newpath, { parent: true });
        var parent = lookup.node;
        var newname = PATH.basename(newpath);
        var err = FS.mayCreate(parent, newname);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.symlink) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        return parent.node_ops.symlink(parent, newname, oldpath);
      },rename:function (old_path, new_path) {
        var old_dirname = PATH.dirname(old_path);
        var new_dirname = PATH.dirname(new_path);
        var old_name = PATH.basename(old_path);
        var new_name = PATH.basename(new_path);
        // parents must exist
        var lookup, old_dir, new_dir;
        try {
          lookup = FS.lookupPath(old_path, { parent: true });
          old_dir = lookup.node;
          lookup = FS.lookupPath(new_path, { parent: true });
          new_dir = lookup.node;
        } catch (e) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        // need to be part of the same mount
        if (old_dir.mount !== new_dir.mount) {
          throw new FS.ErrnoError(ERRNO_CODES.EXDEV);
        }
        // source must exist
        var old_node = FS.lookupNode(old_dir, old_name);
        // old path should not be an ancestor of the new path
        var relative = PATH.relative(old_path, new_dirname);
        if (relative.charAt(0) !== '.') {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        // new path should not be an ancestor of the old path
        relative = PATH.relative(new_path, old_dirname);
        if (relative.charAt(0) !== '.') {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY);
        }
        // see if the new path already exists
        var new_node;
        try {
          new_node = FS.lookupNode(new_dir, new_name);
        } catch (e) {
          // not fatal
        }
        // early out if nothing needs to change
        if (old_node === new_node) {
          return;
        }
        // we'll need to delete the old entry
        var isdir = FS.isDir(old_node.mode);
        var err = FS.mayDelete(old_dir, old_name, isdir);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        // need delete permissions if we'll be overwriting.
        // need create permissions if new doesn't already exist.
        err = new_node ?
          FS.mayDelete(new_dir, new_name, isdir) :
          FS.mayCreate(new_dir, new_name);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!old_dir.node_ops.rename) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isMountpoint(old_node) || (new_node && FS.isMountpoint(new_node))) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        // if we are going to change the parent, check write permissions
        if (new_dir !== old_dir) {
          err = FS.nodePermissions(old_dir, 'w');
          if (err) {
            throw new FS.ErrnoError(err);
          }
        }
        // remove the node from the lookup hash
        FS.hashRemoveNode(old_node);
        // do the underlying fs rename
        try {
          old_dir.node_ops.rename(old_node, new_dir, new_name);
        } catch (e) {
          throw e;
        } finally {
          // add the node back to the hash (in case node_ops.rename
          // changed its name)
          FS.hashAddNode(old_node);
        }
      },rmdir:function (path) {
        var lookup = FS.lookupPath(path, { parent: true });
        var parent = lookup.node;
        var name = PATH.basename(path);
        var node = FS.lookupNode(parent, name);
        var err = FS.mayDelete(parent, name, true);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.rmdir) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isMountpoint(node)) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        parent.node_ops.rmdir(parent, name);
        FS.destroyNode(node);
      },readdir:function (path) {
        var lookup = FS.lookupPath(path, { follow: true });
        var node = lookup.node;
        if (!node.node_ops.readdir) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR);
        }
        return node.node_ops.readdir(node);
      },unlink:function (path) {
        var lookup = FS.lookupPath(path, { parent: true });
        var parent = lookup.node;
        var name = PATH.basename(path);
        var node = FS.lookupNode(parent, name);
        var err = FS.mayDelete(parent, name, false);
        if (err) {
          // POSIX says unlink should set EPERM, not EISDIR
          if (err === ERRNO_CODES.EISDIR) err = ERRNO_CODES.EPERM;
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.unlink) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isMountpoint(node)) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        parent.node_ops.unlink(parent, name);
        FS.destroyNode(node);
      },readlink:function (path) {
        var lookup = FS.lookupPath(path);
        var link = lookup.node;
        if (!link.node_ops.readlink) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        return link.node_ops.readlink(link);
      },stat:function (path, dontFollow) {
        var lookup = FS.lookupPath(path, { follow: !dontFollow });
        var node = lookup.node;
        if (!node.node_ops.getattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        return node.node_ops.getattr(node);
      },lstat:function (path) {
        return FS.stat(path, true);
      },chmod:function (path, mode, dontFollow) {
        var node;
        if (typeof path === 'string') {
          var lookup = FS.lookupPath(path, { follow: !dontFollow });
          node = lookup.node;
        } else {
          node = path;
        }
        if (!node.node_ops.setattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        node.node_ops.setattr(node, {
          mode: (mode & 4095) | (node.mode & ~4095),
          timestamp: Date.now()
        });
      },lchmod:function (path, mode) {
        FS.chmod(path, mode, true);
      },fchmod:function (fd, mode) {
        var stream = FS.getStream(fd);
        if (!stream) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        FS.chmod(stream.node, mode);
      },chown:function (path, uid, gid, dontFollow) {
        var node;
        if (typeof path === 'string') {
          var lookup = FS.lookupPath(path, { follow: !dontFollow });
          node = lookup.node;
        } else {
          node = path;
        }
        if (!node.node_ops.setattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        node.node_ops.setattr(node, {
          timestamp: Date.now()
          // we ignore the uid / gid for now
        });
      },lchown:function (path, uid, gid) {
        FS.chown(path, uid, gid, true);
      },fchown:function (fd, uid, gid) {
        var stream = FS.getStream(fd);
        if (!stream) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        FS.chown(stream.node, uid, gid);
      },truncate:function (path, len) {
        if (len < 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var node;
        if (typeof path === 'string') {
          var lookup = FS.lookupPath(path, { follow: true });
          node = lookup.node;
        } else {
          node = path;
        }
        if (!node.node_ops.setattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isDir(node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EISDIR);
        }
        if (!FS.isFile(node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var err = FS.nodePermissions(node, 'w');
        if (err) {
          throw new FS.ErrnoError(err);
        }
        node.node_ops.setattr(node, {
          size: len,
          timestamp: Date.now()
        });
      },ftruncate:function (fd, len) {
        var stream = FS.getStream(fd);
        if (!stream) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if ((stream.flags & 2097155) === 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        FS.truncate(stream.node, len);
      },utime:function (path, atime, mtime) {
        var lookup = FS.lookupPath(path, { follow: true });
        var node = lookup.node;
        node.node_ops.setattr(node, {
          timestamp: Math.max(atime, mtime)
        });
      },open:function (path, flags, mode, fd_start, fd_end) {
        flags = typeof flags === 'string' ? FS.modeStringToFlags(flags) : flags;
        mode = typeof mode === 'undefined' ? 438 /* 0666 */ : mode;
        if ((flags & 64)) {
          mode = (mode & 4095) | 32768;
        } else {
          mode = 0;
        }
        var node;
        if (typeof path === 'object') {
          node = path;
        } else {
          path = PATH.normalize(path);
          try {
            var lookup = FS.lookupPath(path, {
              follow: !(flags & 131072)
            });
            node = lookup.node;
          } catch (e) {
            // ignore
          }
        }
        // perhaps we need to create the node
        if ((flags & 64)) {
          if (node) {
            // if O_CREAT and O_EXCL are set, error out if the node already exists
            if ((flags & 128)) {
              throw new FS.ErrnoError(ERRNO_CODES.EEXIST);
            }
          } else {
            // node doesn't exist, try to create it
            node = FS.mknod(path, mode, 0);
          }
        }
        if (!node) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOENT);
        }
        // can't truncate a device
        if (FS.isChrdev(node.mode)) {
          flags &= ~512;
        }
        // check permissions
        var err = FS.mayOpen(node, flags);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        // do truncation if necessary
        if ((flags & 512)) {
          FS.truncate(node, 0);
        }
        // we've already handled these, don't pass down to the underlying vfs
        flags &= ~(128 | 512);
  
        // register the stream with the filesystem
        var stream = FS.createStream({
          node: node,
          path: FS.getPath(node),  // we want the absolute path to the node
          flags: flags,
          seekable: true,
          position: 0,
          stream_ops: node.stream_ops,
          // used by the file family libc calls (fopen, fwrite, ferror, etc.)
          ungotten: [],
          error: false
        }, fd_start, fd_end);
        // call the new stream's open function
        if (stream.stream_ops.open) {
          stream.stream_ops.open(stream);
        }
        if (Module['logReadFiles'] && !(flags & 1)) {
          if (!FS.readFiles) FS.readFiles = {};
          if (!(path in FS.readFiles)) {
            FS.readFiles[path] = 1;
            Module['printErr']('read file: ' + path);
          }
        }
        return stream;
      },close:function (stream) {
        try {
          if (stream.stream_ops.close) {
            stream.stream_ops.close(stream);
          }
        } catch (e) {
          throw e;
        } finally {
          FS.closeStream(stream.fd);
        }
      },llseek:function (stream, offset, whence) {
        if (!stream.seekable || !stream.stream_ops.llseek) {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }
        return stream.stream_ops.llseek(stream, offset, whence);
      },read:function (stream, buffer, offset, length, position) {
        if (length < 0 || position < 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        if ((stream.flags & 2097155) === 1) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if (FS.isDir(stream.node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EISDIR);
        }
        if (!stream.stream_ops.read) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var seeking = true;
        if (typeof position === 'undefined') {
          position = stream.position;
          seeking = false;
        } else if (!stream.seekable) {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }
        var bytesRead = stream.stream_ops.read(stream, buffer, offset, length, position);
        if (!seeking) stream.position += bytesRead;
        return bytesRead;
      },write:function (stream, buffer, offset, length, position, canOwn) {
        if (length < 0 || position < 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        if ((stream.flags & 2097155) === 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if (FS.isDir(stream.node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EISDIR);
        }
        if (!stream.stream_ops.write) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var seeking = true;
        if (typeof position === 'undefined') {
          position = stream.position;
          seeking = false;
        } else if (!stream.seekable) {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }
        if (stream.flags & 1024) {
          // seek to the end before writing in append mode
          FS.llseek(stream, 0, 2);
        }
        var bytesWritten = stream.stream_ops.write(stream, buffer, offset, length, position, canOwn);
        if (!seeking) stream.position += bytesWritten;
        return bytesWritten;
      },allocate:function (stream, offset, length) {
        if (offset < 0 || length <= 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        if ((stream.flags & 2097155) === 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if (!FS.isFile(stream.node.mode) && !FS.isDir(node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
        }
        if (!stream.stream_ops.allocate) {
          throw new FS.ErrnoError(ERRNO_CODES.EOPNOTSUPP);
        }
        stream.stream_ops.allocate(stream, offset, length);
      },mmap:function (stream, buffer, offset, length, position, prot, flags) {
        // TODO if PROT is PROT_WRITE, make sure we have write access
        if ((stream.flags & 2097155) === 1) {
          throw new FS.ErrnoError(ERRNO_CODES.EACCES);
        }
        if (!stream.stream_ops.mmap) {
          throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
        }
        return stream.stream_ops.mmap(stream, buffer, offset, length, position, prot, flags);
      },ioctl:function (stream, cmd, arg) {
        if (!stream.stream_ops.ioctl) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTTY);
        }
        return stream.stream_ops.ioctl(stream, cmd, arg);
      },readFile:function (path, opts) {
        opts = opts || {};
        opts.flags = opts.flags || 'r';
        opts.encoding = opts.encoding || 'binary';
        if (opts.encoding !== 'utf8' && opts.encoding !== 'binary') {
          throw new Error('Invalid encoding type "' + opts.encoding + '"');
        }
        var ret;
        var stream = FS.open(path, opts.flags);
        var stat = FS.stat(path);
        var length = stat.size;
        var buf = new Uint8Array(length);
        FS.read(stream, buf, 0, length, 0);
        if (opts.encoding === 'utf8') {
          ret = '';
          var utf8 = new Runtime.UTF8Processor();
          for (var i = 0; i < length; i++) {
            ret += utf8.processCChar(buf[i]);
          }
        } else if (opts.encoding === 'binary') {
          ret = buf;
        }
        FS.close(stream);
        return ret;
      },writeFile:function (path, data, opts) {
        opts = opts || {};
        opts.flags = opts.flags || 'w';
        opts.encoding = opts.encoding || 'utf8';
        if (opts.encoding !== 'utf8' && opts.encoding !== 'binary') {
          throw new Error('Invalid encoding type "' + opts.encoding + '"');
        }
        var stream = FS.open(path, opts.flags, opts.mode);
        if (opts.encoding === 'utf8') {
          var utf8 = new Runtime.UTF8Processor();
          var buf = new Uint8Array(utf8.processJSString(data));
          FS.write(stream, buf, 0, buf.length, 0, opts.canOwn);
        } else if (opts.encoding === 'binary') {
          FS.write(stream, data, 0, data.length, 0, opts.canOwn);
        }
        FS.close(stream);
      },cwd:function () {
        return FS.currentPath;
      },chdir:function (path) {
        var lookup = FS.lookupPath(path, { follow: true });
        if (!FS.isDir(lookup.node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR);
        }
        var err = FS.nodePermissions(lookup.node, 'x');
        if (err) {
          throw new FS.ErrnoError(err);
        }
        FS.currentPath = lookup.path;
      },createDefaultDirectories:function () {
        FS.mkdir('/tmp');
      },createDefaultDevices:function () {
        // create /dev
        FS.mkdir('/dev');
        // setup /dev/null
        FS.registerDevice(FS.makedev(1, 3), {
          read: function() { return 0; },
          write: function() { return 0; }
        });
        FS.mkdev('/dev/null', FS.makedev(1, 3));
        // setup /dev/tty and /dev/tty1
        // stderr needs to print output using Module['printErr']
        // so we register a second tty just for it.
        TTY.register(FS.makedev(5, 0), TTY.default_tty_ops);
        TTY.register(FS.makedev(6, 0), TTY.default_tty1_ops);
        FS.mkdev('/dev/tty', FS.makedev(5, 0));
        FS.mkdev('/dev/tty1', FS.makedev(6, 0));
        // we're not going to emulate the actual shm device,
        // just create the tmp dirs that reside in it commonly
        FS.mkdir('/dev/shm');
        FS.mkdir('/dev/shm/tmp');
      },createStandardStreams:function () {
        // TODO deprecate the old functionality of a single
        // input / output callback and that utilizes FS.createDevice
        // and instead require a unique set of stream ops
  
        // by default, we symlink the standard streams to the
        // default tty devices. however, if the standard streams
        // have been overwritten we create a unique device for
        // them instead.
        if (Module['stdin']) {
          FS.createDevice('/dev', 'stdin', Module['stdin']);
        } else {
          FS.symlink('/dev/tty', '/dev/stdin');
        }
        if (Module['stdout']) {
          FS.createDevice('/dev', 'stdout', null, Module['stdout']);
        } else {
          FS.symlink('/dev/tty', '/dev/stdout');
        }
        if (Module['stderr']) {
          FS.createDevice('/dev', 'stderr', null, Module['stderr']);
        } else {
          FS.symlink('/dev/tty1', '/dev/stderr');
        }
  
        // open default streams for the stdin, stdout and stderr devices
        var stdin = FS.open('/dev/stdin', 'r');
        HEAP32[((_stdin)>>2)]=FS.getPtrForStream(stdin);
        assert(stdin.fd === 0, 'invalid handle for stdin (' + stdin.fd + ')');
  
        var stdout = FS.open('/dev/stdout', 'w');
        HEAP32[((_stdout)>>2)]=FS.getPtrForStream(stdout);
        assert(stdout.fd === 1, 'invalid handle for stdout (' + stdout.fd + ')');
  
        var stderr = FS.open('/dev/stderr', 'w');
        HEAP32[((_stderr)>>2)]=FS.getPtrForStream(stderr);
        assert(stderr.fd === 2, 'invalid handle for stderr (' + stderr.fd + ')');
      },ensureErrnoError:function () {
        if (FS.ErrnoError) return;
        FS.ErrnoError = function ErrnoError(errno) {
          this.errno = errno;
          for (var key in ERRNO_CODES) {
            if (ERRNO_CODES[key] === errno) {
              this.code = key;
              break;
            }
          }
          this.message = ERRNO_MESSAGES[errno];
          if (this.stack) this.stack = demangleAll(this.stack);
        };
        FS.ErrnoError.prototype = new Error();
        FS.ErrnoError.prototype.constructor = FS.ErrnoError;
        // Some errors may happen quite a bit, to avoid overhead we reuse them (and suffer a lack of stack info)
        [ERRNO_CODES.ENOENT].forEach(function(code) {
          FS.genericErrors[code] = new FS.ErrnoError(code);
          FS.genericErrors[code].stack = '<generic error, no stack>';
        });
      },staticInit:function () {
        FS.ensureErrnoError();
  
        FS.nameTable = new Array(4096);
  
        FS.mount(MEMFS, {}, '/');
  
        FS.createDefaultDirectories();
        FS.createDefaultDevices();
      },init:function (input, output, error) {
        assert(!FS.init.initialized, 'FS.init was previously called. If you want to initialize later with custom parameters, remove any earlier calls (note that one is automatically added to the generated code)');
        FS.init.initialized = true;
  
        FS.ensureErrnoError();
  
        // Allow Module.stdin etc. to provide defaults, if none explicitly passed to us here
        Module['stdin'] = input || Module['stdin'];
        Module['stdout'] = output || Module['stdout'];
        Module['stderr'] = error || Module['stderr'];
  
        FS.createStandardStreams();
      },quit:function () {
        FS.init.initialized = false;
        for (var i = 0; i < FS.streams.length; i++) {
          var stream = FS.streams[i];
          if (!stream) {
            continue;
          }
          FS.close(stream);
        }
      },getMode:function (canRead, canWrite) {
        var mode = 0;
        if (canRead) mode |= 292 | 73;
        if (canWrite) mode |= 146;
        return mode;
      },joinPath:function (parts, forceRelative) {
        var path = PATH.join.apply(null, parts);
        if (forceRelative && path[0] == '/') path = path.substr(1);
        return path;
      },absolutePath:function (relative, base) {
        return PATH.resolve(base, relative);
      },standardizePath:function (path) {
        return PATH.normalize(path);
      },findObject:function (path, dontResolveLastLink) {
        var ret = FS.analyzePath(path, dontResolveLastLink);
        if (ret.exists) {
          return ret.object;
        } else {
          ___setErrNo(ret.error);
          return null;
        }
      },analyzePath:function (path, dontResolveLastLink) {
        // operate from within the context of the symlink's target
        try {
          var lookup = FS.lookupPath(path, { follow: !dontResolveLastLink });
          path = lookup.path;
        } catch (e) {
        }
        var ret = {
          isRoot: false, exists: false, error: 0, name: null, path: null, object: null,
          parentExists: false, parentPath: null, parentObject: null
        };
        try {
          var lookup = FS.lookupPath(path, { parent: true });
          ret.parentExists = true;
          ret.parentPath = lookup.path;
          ret.parentObject = lookup.node;
          ret.name = PATH.basename(path);
          lookup = FS.lookupPath(path, { follow: !dontResolveLastLink });
          ret.exists = true;
          ret.path = lookup.path;
          ret.object = lookup.node;
          ret.name = lookup.node.name;
          ret.isRoot = lookup.path === '/';
        } catch (e) {
          ret.error = e.errno;
        };
        return ret;
      },createFolder:function (parent, name, canRead, canWrite) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        var mode = FS.getMode(canRead, canWrite);
        return FS.mkdir(path, mode);
      },createPath:function (parent, path, canRead, canWrite) {
        parent = typeof parent === 'string' ? parent : FS.getPath(parent);
        var parts = path.split('/').reverse();
        while (parts.length) {
          var part = parts.pop();
          if (!part) continue;
          var current = PATH.join2(parent, part);
          try {
            FS.mkdir(current);
          } catch (e) {
            // ignore EEXIST
          }
          parent = current;
        }
        return current;
      },createFile:function (parent, name, properties, canRead, canWrite) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        var mode = FS.getMode(canRead, canWrite);
        return FS.create(path, mode);
      },createDataFile:function (parent, name, data, canRead, canWrite, canOwn) {
        var path = name ? PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name) : parent;
        var mode = FS.getMode(canRead, canWrite);
        var node = FS.create(path, mode);
        if (data) {
          if (typeof data === 'string') {
            var arr = new Array(data.length);
            for (var i = 0, len = data.length; i < len; ++i) arr[i] = data.charCodeAt(i);
            data = arr;
          }
          // make sure we can write to the file
          FS.chmod(node, mode | 146);
          var stream = FS.open(node, 'w');
          FS.write(stream, data, 0, data.length, 0, canOwn);
          FS.close(stream);
          FS.chmod(node, mode);
        }
        return node;
      },createDevice:function (parent, name, input, output) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        var mode = FS.getMode(!!input, !!output);
        if (!FS.createDevice.major) FS.createDevice.major = 64;
        var dev = FS.makedev(FS.createDevice.major++, 0);
        // Create a fake device that a set of stream ops to emulate
        // the old behavior.
        FS.registerDevice(dev, {
          open: function(stream) {
            stream.seekable = false;
          },
          close: function(stream) {
            // flush any pending line data
            if (output && output.buffer && output.buffer.length) {
              output(10);
            }
          },
          read: function(stream, buffer, offset, length, pos /* ignored */) {
            var bytesRead = 0;
            for (var i = 0; i < length; i++) {
              var result;
              try {
                result = input();
              } catch (e) {
                throw new FS.ErrnoError(ERRNO_CODES.EIO);
              }
              if (result === undefined && bytesRead === 0) {
                throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
              }
              if (result === null || result === undefined) break;
              bytesRead++;
              buffer[offset+i] = result;
            }
            if (bytesRead) {
              stream.node.timestamp = Date.now();
            }
            return bytesRead;
          },
          write: function(stream, buffer, offset, length, pos) {
            for (var i = 0; i < length; i++) {
              try {
                output(buffer[offset+i]);
              } catch (e) {
                throw new FS.ErrnoError(ERRNO_CODES.EIO);
              }
            }
            if (length) {
              stream.node.timestamp = Date.now();
            }
            return i;
          }
        });
        return FS.mkdev(path, mode, dev);
      },createLink:function (parent, name, target, canRead, canWrite) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        return FS.symlink(target, path);
      },forceLoadFile:function (obj) {
        if (obj.isDevice || obj.isFolder || obj.link || obj.contents) return true;
        var success = true;
        if (typeof XMLHttpRequest !== 'undefined') {
          throw new Error("Lazy loading should have been performed (contents set) in createLazyFile, but it was not. Lazy loading only works in web workers. Use --embed-file or --preload-file in emcc on the main thread.");
        } else if (Module['read']) {
          // Command-line.
          try {
            // WARNING: Can't read binary files in V8's d8 or tracemonkey's js, as
            //          read() will try to parse UTF8.
            obj.contents = intArrayFromString(Module['read'](obj.url), true);
          } catch (e) {
            success = false;
          }
        } else {
          throw new Error('Cannot load without read() or XMLHttpRequest.');
        }
        if (!success) ___setErrNo(ERRNO_CODES.EIO);
        return success;
      },createLazyFile:function (parent, name, url, canRead, canWrite) {
        if (typeof XMLHttpRequest !== 'undefined') {
          if (!ENVIRONMENT_IS_WORKER) throw 'Cannot do synchronous binary XHRs outside webworkers in modern browsers. Use --embed-file or --preload-file in emcc';
          // Lazy chunked Uint8Array (implements get and length from Uint8Array). Actual getting is abstracted away for eventual reuse.
          function LazyUint8Array() {
            this.lengthKnown = false;
            this.chunks = []; // Loaded chunks. Index is the chunk number
          }
          LazyUint8Array.prototype.get = function LazyUint8Array_get(idx) {
            if (idx > this.length-1 || idx < 0) {
              return undefined;
            }
            var chunkOffset = idx % this.chunkSize;
            var chunkNum = Math.floor(idx / this.chunkSize);
            return this.getter(chunkNum)[chunkOffset];
          }
          LazyUint8Array.prototype.setDataGetter = function LazyUint8Array_setDataGetter(getter) {
            this.getter = getter;
          }
          LazyUint8Array.prototype.cacheLength = function LazyUint8Array_cacheLength() {
              // Find length
              var xhr = new XMLHttpRequest();
              xhr.open('HEAD', url, false);
              xhr.send(null);
              if (!(xhr.status >= 200 && xhr.status < 300 || xhr.status === 304)) throw new Error("Couldn't load " + url + ". Status: " + xhr.status);
              var datalength = Number(xhr.getResponseHeader("Content-length"));
              var header;
              var hasByteServing = (header = xhr.getResponseHeader("Accept-Ranges")) && header === "bytes";
              var chunkSize = 1024*1024; // Chunk size in bytes
  
              if (!hasByteServing) chunkSize = datalength;
  
              // Function to get a range from the remote URL.
              var doXHR = (function(from, to) {
                if (from > to) throw new Error("invalid range (" + from + ", " + to + ") or no bytes requested!");
                if (to > datalength-1) throw new Error("only " + datalength + " bytes available! programmer error!");
  
                // TODO: Use mozResponseArrayBuffer, responseStream, etc. if available.
                var xhr = new XMLHttpRequest();
                xhr.open('GET', url, false);
                if (datalength !== chunkSize) xhr.setRequestHeader("Range", "bytes=" + from + "-" + to);
  
                // Some hints to the browser that we want binary data.
                if (typeof Uint8Array != 'undefined') xhr.responseType = 'arraybuffer';
                if (xhr.overrideMimeType) {
                  xhr.overrideMimeType('text/plain; charset=x-user-defined');
                }
  
                xhr.send(null);
                if (!(xhr.status >= 200 && xhr.status < 300 || xhr.status === 304)) throw new Error("Couldn't load " + url + ". Status: " + xhr.status);
                if (xhr.response !== undefined) {
                  return new Uint8Array(xhr.response || []);
                } else {
                  return intArrayFromString(xhr.responseText || '', true);
                }
              });
              var lazyArray = this;
              lazyArray.setDataGetter(function(chunkNum) {
                var start = chunkNum * chunkSize;
                var end = (chunkNum+1) * chunkSize - 1; // including this byte
                end = Math.min(end, datalength-1); // if datalength-1 is selected, this is the last block
                if (typeof(lazyArray.chunks[chunkNum]) === "undefined") {
                  lazyArray.chunks[chunkNum] = doXHR(start, end);
                }
                if (typeof(lazyArray.chunks[chunkNum]) === "undefined") throw new Error("doXHR failed!");
                return lazyArray.chunks[chunkNum];
              });
  
              this._length = datalength;
              this._chunkSize = chunkSize;
              this.lengthKnown = true;
          }
  
          var lazyArray = new LazyUint8Array();
          Object.defineProperty(lazyArray, "length", {
              get: function() {
                  if(!this.lengthKnown) {
                      this.cacheLength();
                  }
                  return this._length;
              }
          });
          Object.defineProperty(lazyArray, "chunkSize", {
              get: function() {
                  if(!this.lengthKnown) {
                      this.cacheLength();
                  }
                  return this._chunkSize;
              }
          });
  
          var properties = { isDevice: false, contents: lazyArray };
        } else {
          var properties = { isDevice: false, url: url };
        }
  
        var node = FS.createFile(parent, name, properties, canRead, canWrite);
        // This is a total hack, but I want to get this lazy file code out of the
        // core of MEMFS. If we want to keep this lazy file concept I feel it should
        // be its own thin LAZYFS proxying calls to MEMFS.
        if (properties.contents) {
          node.contents = properties.contents;
        } else if (properties.url) {
          node.contents = null;
          node.url = properties.url;
        }
        // override each stream op with one that tries to force load the lazy file first
        var stream_ops = {};
        var keys = Object.keys(node.stream_ops);
        keys.forEach(function(key) {
          var fn = node.stream_ops[key];
          stream_ops[key] = function forceLoadLazyFile() {
            if (!FS.forceLoadFile(node)) {
              throw new FS.ErrnoError(ERRNO_CODES.EIO);
            }
            return fn.apply(null, arguments);
          };
        });
        // use a custom read function
        stream_ops.read = function stream_ops_read(stream, buffer, offset, length, position) {
          if (!FS.forceLoadFile(node)) {
            throw new FS.ErrnoError(ERRNO_CODES.EIO);
          }
          var contents = stream.node.contents;
          if (position >= contents.length)
            return 0;
          var size = Math.min(contents.length - position, length);
          assert(size >= 0);
          if (contents.slice) { // normal array
            for (var i = 0; i < size; i++) {
              buffer[offset + i] = contents[position + i];
            }
          } else {
            for (var i = 0; i < size; i++) { // LazyUint8Array from sync binary XHR
              buffer[offset + i] = contents.get(position + i);
            }
          }
          return size;
        };
        node.stream_ops = stream_ops;
        return node;
      },createPreloadedFile:function (parent, name, url, canRead, canWrite, onload, onerror, dontCreateFile, canOwn) {
        Browser.init();
        // TODO we should allow people to just pass in a complete filename instead
        // of parent and name being that we just join them anyways
        var fullname = name ? PATH.resolve(PATH.join2(parent, name)) : parent;
        function processData(byteArray) {
          function finish(byteArray) {
            if (!dontCreateFile) {
              FS.createDataFile(parent, name, byteArray, canRead, canWrite, canOwn);
            }
            if (onload) onload();
            removeRunDependency('cp ' + fullname);
          }
          var handled = false;
          Module['preloadPlugins'].forEach(function(plugin) {
            if (handled) return;
            if (plugin['canHandle'](fullname)) {
              plugin['handle'](byteArray, fullname, finish, function() {
                if (onerror) onerror();
                removeRunDependency('cp ' + fullname);
              });
              handled = true;
            }
          });
          if (!handled) finish(byteArray);
        }
        addRunDependency('cp ' + fullname);
        if (typeof url == 'string') {
          Browser.asyncLoad(url, function(byteArray) {
            processData(byteArray);
          }, onerror);
        } else {
          processData(url);
        }
      },indexedDB:function () {
        return window.indexedDB || window.mozIndexedDB || window.webkitIndexedDB || window.msIndexedDB;
      },DB_NAME:function () {
        return 'EM_FS_' + window.location.pathname;
      },DB_VERSION:20,DB_STORE_NAME:"FILE_DATA",saveFilesToDB:function (paths, onload, onerror) {
        onload = onload || function(){};
        onerror = onerror || function(){};
        var indexedDB = FS.indexedDB();
        try {
          var openRequest = indexedDB.open(FS.DB_NAME(), FS.DB_VERSION);
        } catch (e) {
          return onerror(e);
        }
        openRequest.onupgradeneeded = function openRequest_onupgradeneeded() {
          console.log('creating db');
          var db = openRequest.result;
          db.createObjectStore(FS.DB_STORE_NAME);
        };
        openRequest.onsuccess = function openRequest_onsuccess() {
          var db = openRequest.result;
          var transaction = db.transaction([FS.DB_STORE_NAME], 'readwrite');
          var files = transaction.objectStore(FS.DB_STORE_NAME);
          var ok = 0, fail = 0, total = paths.length;
          function finish() {
            if (fail == 0) onload(); else onerror();
          }
          paths.forEach(function(path) {
            var putRequest = files.put(FS.analyzePath(path).object.contents, path);
            putRequest.onsuccess = function putRequest_onsuccess() { ok++; if (ok + fail == total) finish() };
            putRequest.onerror = function putRequest_onerror() { fail++; if (ok + fail == total) finish() };
          });
          transaction.onerror = onerror;
        };
        openRequest.onerror = onerror;
      },loadFilesFromDB:function (paths, onload, onerror) {
        onload = onload || function(){};
        onerror = onerror || function(){};
        var indexedDB = FS.indexedDB();
        try {
          var openRequest = indexedDB.open(FS.DB_NAME(), FS.DB_VERSION);
        } catch (e) {
          return onerror(e);
        }
        openRequest.onupgradeneeded = onerror; // no database to load from
        openRequest.onsuccess = function openRequest_onsuccess() {
          var db = openRequest.result;
          try {
            var transaction = db.transaction([FS.DB_STORE_NAME], 'readonly');
          } catch(e) {
            onerror(e);
            return;
          }
          var files = transaction.objectStore(FS.DB_STORE_NAME);
          var ok = 0, fail = 0, total = paths.length;
          function finish() {
            if (fail == 0) onload(); else onerror();
          }
          paths.forEach(function(path) {
            var getRequest = files.get(path);
            getRequest.onsuccess = function getRequest_onsuccess() {
              if (FS.analyzePath(path).exists) {
                FS.unlink(path);
              }
              FS.createDataFile(PATH.dirname(path), PATH.basename(path), getRequest.result, true, true, true);
              ok++;
              if (ok + fail == total) finish();
            };
            getRequest.onerror = function getRequest_onerror() { fail++; if (ok + fail == total) finish() };
          });
          transaction.onerror = onerror;
        };
        openRequest.onerror = onerror;
      }};
  
  function _open(path, oflag, varargs) {
      // int open(const char *path, int oflag, ...);
      // http://pubs.opengroup.org/onlinepubs/009695399/functions/open.html
      var mode = HEAP32[((varargs)>>2)];
      path = Pointer_stringify(path);
      try {
        var stream = FS.open(path, oflag, mode);
        return stream.fd;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fopen(filename, mode) {
      // FILE *fopen(const char *restrict filename, const char *restrict mode);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fopen.html
      var flags;
      mode = Pointer_stringify(mode);
      if (mode[0] == 'r') {
        if (mode.indexOf('+') != -1) {
          flags = 2;
        } else {
          flags = 0;
        }
      } else if (mode[0] == 'w') {
        if (mode.indexOf('+') != -1) {
          flags = 2;
        } else {
          flags = 1;
        }
        flags |= 64;
        flags |= 512;
      } else if (mode[0] == 'a') {
        if (mode.indexOf('+') != -1) {
          flags = 2;
        } else {
          flags = 1;
        }
        flags |= 64;
        flags |= 1024;
      } else {
        ___setErrNo(ERRNO_CODES.EINVAL);
        return 0;
      }
      var fd = _open(filename, flags, allocate([0x1FF, 0, 0, 0], 'i32', ALLOC_STACK));  // All creation permissions.
      return fd === -1 ? 0 : FS.getPtrForStream(FS.getStream(fd));
    }

  
  
  
  
  function _mkport() { throw 'TODO' }var SOCKFS={mount:function (mount) {
        return FS.createNode(null, '/', 16384 | 511 /* 0777 */, 0);
      },createSocket:function (family, type, protocol) {
        var streaming = type == 1;
        if (protocol) {
          assert(streaming == (protocol == 6)); // if SOCK_STREAM, must be tcp
        }
  
        // create our internal socket structure
        var sock = {
          family: family,
          type: type,
          protocol: protocol,
          server: null,
          peers: {},
          pending: [],
          recv_queue: [],
          sock_ops: SOCKFS.websocket_sock_ops
        };
  
        // create the filesystem node to store the socket structure
        var name = SOCKFS.nextname();
        var node = FS.createNode(SOCKFS.root, name, 49152, 0);
        node.sock = sock;
  
        // and the wrapping stream that enables library functions such
        // as read and write to indirectly interact with the socket
        var stream = FS.createStream({
          path: name,
          node: node,
          flags: FS.modeStringToFlags('r+'),
          seekable: false,
          stream_ops: SOCKFS.stream_ops
        });
  
        // map the new stream to the socket structure (sockets have a 1:1
        // relationship with a stream)
        sock.stream = stream;
  
        return sock;
      },getSocket:function (fd) {
        var stream = FS.getStream(fd);
        if (!stream || !FS.isSocket(stream.node.mode)) {
          return null;
        }
        return stream.node.sock;
      },stream_ops:{poll:function (stream) {
          var sock = stream.node.sock;
          return sock.sock_ops.poll(sock);
        },ioctl:function (stream, request, varargs) {
          var sock = stream.node.sock;
          return sock.sock_ops.ioctl(sock, request, varargs);
        },read:function (stream, buffer, offset, length, position /* ignored */) {
          var sock = stream.node.sock;
          var msg = sock.sock_ops.recvmsg(sock, length);
          if (!msg) {
            // socket is closed
            return 0;
          }
          buffer.set(msg.buffer, offset);
          return msg.buffer.length;
        },write:function (stream, buffer, offset, length, position /* ignored */) {
          var sock = stream.node.sock;
          return sock.sock_ops.sendmsg(sock, buffer, offset, length);
        },close:function (stream) {
          var sock = stream.node.sock;
          sock.sock_ops.close(sock);
        }},nextname:function () {
        if (!SOCKFS.nextname.current) {
          SOCKFS.nextname.current = 0;
        }
        return 'socket[' + (SOCKFS.nextname.current++) + ']';
      },websocket_sock_ops:{createPeer:function (sock, addr, port) {
          var ws;
  
          if (typeof addr === 'object') {
            ws = addr;
            addr = null;
            port = null;
          }
  
          if (ws) {
            // for sockets that've already connected (e.g. we're the server)
            // we can inspect the _socket property for the address
            if (ws._socket) {
              addr = ws._socket.remoteAddress;
              port = ws._socket.remotePort;
            }
            // if we're just now initializing a connection to the remote,
            // inspect the url property
            else {
              var result = /ws[s]?:\/\/([^:]+):(\d+)/.exec(ws.url);
              if (!result) {
                throw new Error('WebSocket URL must be in the format ws(s)://address:port');
              }
              addr = result[1];
              port = parseInt(result[2], 10);
            }
          } else {
            // create the actual websocket object and connect
            try {
              var url = 'ws://' + addr + ':' + port;
              // the node ws library API is slightly different than the browser's
              var opts = ENVIRONMENT_IS_NODE ? {headers: {'websocket-protocol': ['binary']}} : ['binary'];
              // If node we use the ws library.
              var WebSocket = ENVIRONMENT_IS_NODE ? require('ws') : window['WebSocket'];
              ws = new WebSocket(url, opts);
              ws.binaryType = 'arraybuffer';
            } catch (e) {
              throw new FS.ErrnoError(ERRNO_CODES.EHOSTUNREACH);
            }
          }
  
  
          var peer = {
            addr: addr,
            port: port,
            socket: ws,
            dgram_send_queue: []
          };
  
          SOCKFS.websocket_sock_ops.addPeer(sock, peer);
          SOCKFS.websocket_sock_ops.handlePeerEvents(sock, peer);
  
          // if this is a bound dgram socket, send the port number first to allow
          // us to override the ephemeral port reported to us by remotePort on the
          // remote end.
          if (sock.type === 2 && typeof sock.sport !== 'undefined') {
            peer.dgram_send_queue.push(new Uint8Array([
                255, 255, 255, 255,
                'p'.charCodeAt(0), 'o'.charCodeAt(0), 'r'.charCodeAt(0), 't'.charCodeAt(0),
                ((sock.sport & 0xff00) >> 8) , (sock.sport & 0xff)
            ]));
          }
  
          return peer;
        },getPeer:function (sock, addr, port) {
          return sock.peers[addr + ':' + port];
        },addPeer:function (sock, peer) {
          sock.peers[peer.addr + ':' + peer.port] = peer;
        },removePeer:function (sock, peer) {
          delete sock.peers[peer.addr + ':' + peer.port];
        },handlePeerEvents:function (sock, peer) {
          var first = true;
  
          var handleOpen = function () {
            try {
              var queued = peer.dgram_send_queue.shift();
              while (queued) {
                peer.socket.send(queued);
                queued = peer.dgram_send_queue.shift();
              }
            } catch (e) {
              // not much we can do here in the way of proper error handling as we've already
              // lied and said this data was sent. shut it down.
              peer.socket.close();
            }
          };
  
          function handleMessage(data) {
            assert(typeof data !== 'string' && data.byteLength !== undefined);  // must receive an ArrayBuffer
            data = new Uint8Array(data);  // make a typed array view on the array buffer
  
  
            // if this is the port message, override the peer's port with it
            var wasfirst = first;
            first = false;
            if (wasfirst &&
                data.length === 10 &&
                data[0] === 255 && data[1] === 255 && data[2] === 255 && data[3] === 255 &&
                data[4] === 'p'.charCodeAt(0) && data[5] === 'o'.charCodeAt(0) && data[6] === 'r'.charCodeAt(0) && data[7] === 't'.charCodeAt(0)) {
              // update the peer's port and it's key in the peer map
              var newport = ((data[8] << 8) | data[9]);
              SOCKFS.websocket_sock_ops.removePeer(sock, peer);
              peer.port = newport;
              SOCKFS.websocket_sock_ops.addPeer(sock, peer);
              return;
            }
  
            sock.recv_queue.push({ addr: peer.addr, port: peer.port, data: data });
          };
  
          if (ENVIRONMENT_IS_NODE) {
            peer.socket.on('open', handleOpen);
            peer.socket.on('message', function(data, flags) {
              if (!flags.binary) {
                return;
              }
              handleMessage((new Uint8Array(data)).buffer);  // copy from node Buffer -> ArrayBuffer
            });
            peer.socket.on('error', function() {
              // don't throw
            });
          } else {
            peer.socket.onopen = handleOpen;
            peer.socket.onmessage = function peer_socket_onmessage(event) {
              handleMessage(event.data);
            };
          }
        },poll:function (sock) {
          if (sock.type === 1 && sock.server) {
            // listen sockets should only say they're available for reading
            // if there are pending clients.
            return sock.pending.length ? (64 | 1) : 0;
          }
  
          var mask = 0;
          var dest = sock.type === 1 ?  // we only care about the socket state for connection-based sockets
            SOCKFS.websocket_sock_ops.getPeer(sock, sock.daddr, sock.dport) :
            null;
  
          if (sock.recv_queue.length ||
              !dest ||  // connection-less sockets are always ready to read
              (dest && dest.socket.readyState === dest.socket.CLOSING) ||
              (dest && dest.socket.readyState === dest.socket.CLOSED)) {  // let recv return 0 once closed
            mask |= (64 | 1);
          }
  
          if (!dest ||  // connection-less sockets are always ready to write
              (dest && dest.socket.readyState === dest.socket.OPEN)) {
            mask |= 4;
          }
  
          if ((dest && dest.socket.readyState === dest.socket.CLOSING) ||
              (dest && dest.socket.readyState === dest.socket.CLOSED)) {
            mask |= 16;
          }
  
          return mask;
        },ioctl:function (sock, request, arg) {
          switch (request) {
            case 21531:
              var bytes = 0;
              if (sock.recv_queue.length) {
                bytes = sock.recv_queue[0].data.length;
              }
              HEAP32[((arg)>>2)]=bytes;
              return 0;
            default:
              return ERRNO_CODES.EINVAL;
          }
        },close:function (sock) {
          // if we've spawned a listen server, close it
          if (sock.server) {
            try {
              sock.server.close();
            } catch (e) {
            }
            sock.server = null;
          }
          // close any peer connections
          var peers = Object.keys(sock.peers);
          for (var i = 0; i < peers.length; i++) {
            var peer = sock.peers[peers[i]];
            try {
              peer.socket.close();
            } catch (e) {
            }
            SOCKFS.websocket_sock_ops.removePeer(sock, peer);
          }
          return 0;
        },bind:function (sock, addr, port) {
          if (typeof sock.saddr !== 'undefined' || typeof sock.sport !== 'undefined') {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);  // already bound
          }
          sock.saddr = addr;
          sock.sport = port || _mkport();
          // in order to emulate dgram sockets, we need to launch a listen server when
          // binding on a connection-less socket
          // note: this is only required on the server side
          if (sock.type === 2) {
            // close the existing server if it exists
            if (sock.server) {
              sock.server.close();
              sock.server = null;
            }
            // swallow error operation not supported error that occurs when binding in the
            // browser where this isn't supported
            try {
              sock.sock_ops.listen(sock, 0);
            } catch (e) {
              if (!(e instanceof FS.ErrnoError)) throw e;
              if (e.errno !== ERRNO_CODES.EOPNOTSUPP) throw e;
            }
          }
        },connect:function (sock, addr, port) {
          if (sock.server) {
            throw new FS.ErrnoError(ERRNO_CODS.EOPNOTSUPP);
          }
  
          // TODO autobind
          // if (!sock.addr && sock.type == 2) {
          // }
  
          // early out if we're already connected / in the middle of connecting
          if (typeof sock.daddr !== 'undefined' && typeof sock.dport !== 'undefined') {
            var dest = SOCKFS.websocket_sock_ops.getPeer(sock, sock.daddr, sock.dport);
            if (dest) {
              if (dest.socket.readyState === dest.socket.CONNECTING) {
                throw new FS.ErrnoError(ERRNO_CODES.EALREADY);
              } else {
                throw new FS.ErrnoError(ERRNO_CODES.EISCONN);
              }
            }
          }
  
          // add the socket to our peer list and set our
          // destination address / port to match
          var peer = SOCKFS.websocket_sock_ops.createPeer(sock, addr, port);
          sock.daddr = peer.addr;
          sock.dport = peer.port;
  
          // always "fail" in non-blocking mode
          throw new FS.ErrnoError(ERRNO_CODES.EINPROGRESS);
        },listen:function (sock, backlog) {
          if (!ENVIRONMENT_IS_NODE) {
            throw new FS.ErrnoError(ERRNO_CODES.EOPNOTSUPP);
          }
          if (sock.server) {
             throw new FS.ErrnoError(ERRNO_CODES.EINVAL);  // already listening
          }
          var WebSocketServer = require('ws').Server;
          var host = sock.saddr;
          sock.server = new WebSocketServer({
            host: host,
            port: sock.sport
            // TODO support backlog
          });
  
          sock.server.on('connection', function(ws) {
            if (sock.type === 1) {
              var newsock = SOCKFS.createSocket(sock.family, sock.type, sock.protocol);
  
              // create a peer on the new socket
              var peer = SOCKFS.websocket_sock_ops.createPeer(newsock, ws);
              newsock.daddr = peer.addr;
              newsock.dport = peer.port;
  
              // push to queue for accept to pick up
              sock.pending.push(newsock);
            } else {
              // create a peer on the listen socket so calling sendto
              // with the listen socket and an address will resolve
              // to the correct client
              SOCKFS.websocket_sock_ops.createPeer(sock, ws);
            }
          });
          sock.server.on('closed', function() {
            sock.server = null;
          });
          sock.server.on('error', function() {
            // don't throw
          });
        },accept:function (listensock) {
          if (!listensock.server) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
          var newsock = listensock.pending.shift();
          newsock.stream.flags = listensock.stream.flags;
          return newsock;
        },getname:function (sock, peer) {
          var addr, port;
          if (peer) {
            if (sock.daddr === undefined || sock.dport === undefined) {
              throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
            }
            addr = sock.daddr;
            port = sock.dport;
          } else {
            // TODO saddr and sport will be set for bind()'d UDP sockets, but what
            // should we be returning for TCP sockets that've been connect()'d?
            addr = sock.saddr || 0;
            port = sock.sport || 0;
          }
          return { addr: addr, port: port };
        },sendmsg:function (sock, buffer, offset, length, addr, port) {
          if (sock.type === 2) {
            // connection-less sockets will honor the message address,
            // and otherwise fall back to the bound destination address
            if (addr === undefined || port === undefined) {
              addr = sock.daddr;
              port = sock.dport;
            }
            // if there was no address to fall back to, error out
            if (addr === undefined || port === undefined) {
              throw new FS.ErrnoError(ERRNO_CODES.EDESTADDRREQ);
            }
          } else {
            // connection-based sockets will only use the bound
            addr = sock.daddr;
            port = sock.dport;
          }
  
          // find the peer for the destination address
          var dest = SOCKFS.websocket_sock_ops.getPeer(sock, addr, port);
  
          // early out if not connected with a connection-based socket
          if (sock.type === 1) {
            if (!dest || dest.socket.readyState === dest.socket.CLOSING || dest.socket.readyState === dest.socket.CLOSED) {
              throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
            } else if (dest.socket.readyState === dest.socket.CONNECTING) {
              throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
            }
          }
  
          // create a copy of the incoming data to send, as the WebSocket API
          // doesn't work entirely with an ArrayBufferView, it'll just send
          // the entire underlying buffer
          var data;
          if (buffer instanceof Array || buffer instanceof ArrayBuffer) {
            data = buffer.slice(offset, offset + length);
          } else {  // ArrayBufferView
            data = buffer.buffer.slice(buffer.byteOffset + offset, buffer.byteOffset + offset + length);
          }
  
          // if we're emulating a connection-less dgram socket and don't have
          // a cached connection, queue the buffer to send upon connect and
          // lie, saying the data was sent now.
          if (sock.type === 2) {
            if (!dest || dest.socket.readyState !== dest.socket.OPEN) {
              // if we're not connected, open a new connection
              if (!dest || dest.socket.readyState === dest.socket.CLOSING || dest.socket.readyState === dest.socket.CLOSED) {
                dest = SOCKFS.websocket_sock_ops.createPeer(sock, addr, port);
              }
              dest.dgram_send_queue.push(data);
              return length;
            }
          }
  
          try {
            // send the actual data
            dest.socket.send(data);
            return length;
          } catch (e) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
        },recvmsg:function (sock, length) {
          // http://pubs.opengroup.org/onlinepubs/7908799/xns/recvmsg.html
          if (sock.type === 1 && sock.server) {
            // tcp servers should not be recv()'ing on the listen socket
            throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
          }
  
          var queued = sock.recv_queue.shift();
          if (!queued) {
            if (sock.type === 1) {
              var dest = SOCKFS.websocket_sock_ops.getPeer(sock, sock.daddr, sock.dport);
  
              if (!dest) {
                // if we have a destination address but are not connected, error out
                throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
              }
              else if (dest.socket.readyState === dest.socket.CLOSING || dest.socket.readyState === dest.socket.CLOSED) {
                // return null if the socket has closed
                return null;
              }
              else {
                // else, our socket is in a valid state but truly has nothing available
                throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
              }
            } else {
              throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
            }
          }
  
          // queued.data will be an ArrayBuffer if it's unadulterated, but if it's
          // requeued TCP data it'll be an ArrayBufferView
          var queuedLength = queued.data.byteLength || queued.data.length;
          var queuedOffset = queued.data.byteOffset || 0;
          var queuedBuffer = queued.data.buffer || queued.data;
          var bytesRead = Math.min(length, queuedLength);
          var res = {
            buffer: new Uint8Array(queuedBuffer, queuedOffset, bytesRead),
            addr: queued.addr,
            port: queued.port
          };
  
  
          // push back any unread data for TCP connections
          if (sock.type === 1 && bytesRead < queuedLength) {
            var bytesRemaining = queuedLength - bytesRead;
            queued.data = new Uint8Array(queuedBuffer, queuedOffset + bytesRead, bytesRemaining);
            sock.recv_queue.unshift(queued);
          }
  
          return res;
        }}};function _recv(fd, buf, len, flags) {
      var sock = SOCKFS.getSocket(fd);
      if (!sock) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      // TODO honor flags
      return _read(fd, buf, len);
    }
  
  function _pread(fildes, buf, nbyte, offset) {
      // ssize_t pread(int fildes, void *buf, size_t nbyte, off_t offset);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/read.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        var slab = HEAP8;
        return FS.read(stream, slab, buf, nbyte, offset);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _read(fildes, buf, nbyte) {
      // ssize_t read(int fildes, void *buf, size_t nbyte);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/read.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
  
  
      try {
        var slab = HEAP8;
        return FS.read(stream, slab, buf, nbyte);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fread(ptr, size, nitems, stream) {
      // size_t fread(void *restrict ptr, size_t size, size_t nitems, FILE *restrict stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fread.html
      var bytesToRead = nitems * size;
      if (bytesToRead == 0) {
        return 0;
      }
      var bytesRead = 0;
      var streamObj = FS.getStreamFromPtr(stream);
      if (!streamObj) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return 0;
      }
      while (streamObj.ungotten.length && bytesToRead > 0) {
        HEAP8[((ptr++)|0)]=streamObj.ungotten.pop();
        bytesToRead--;
        bytesRead++;
      }
      var err = _read(streamObj.fd, ptr, bytesToRead);
      if (err == -1) {
        if (streamObj) streamObj.error = true;
        return 0;
      }
      bytesRead += err;
      if (bytesRead < bytesToRead) streamObj.eof = true;
      return Math.floor(bytesRead / size);
    }

  function __ZN13ShamirSharing10bytesToIntEPcij() {
  Module['printErr']('missing function: _ZN13ShamirSharing10bytesToIntEPcij'); abort(-1);
  }

  
  function __ZSt18uncaught_exceptionv() { // std::uncaught_exception()
      return !!__ZSt18uncaught_exceptionv.uncaught_exception;
    }
  
  
  
  function ___cxa_is_number_type(type) {
      var isNumber = false;
      try { if (type == __ZTIi) isNumber = true } catch(e){}
      try { if (type == __ZTIj) isNumber = true } catch(e){}
      try { if (type == __ZTIl) isNumber = true } catch(e){}
      try { if (type == __ZTIm) isNumber = true } catch(e){}
      try { if (type == __ZTIx) isNumber = true } catch(e){}
      try { if (type == __ZTIy) isNumber = true } catch(e){}
      try { if (type == __ZTIf) isNumber = true } catch(e){}
      try { if (type == __ZTId) isNumber = true } catch(e){}
      try { if (type == __ZTIe) isNumber = true } catch(e){}
      try { if (type == __ZTIc) isNumber = true } catch(e){}
      try { if (type == __ZTIa) isNumber = true } catch(e){}
      try { if (type == __ZTIh) isNumber = true } catch(e){}
      try { if (type == __ZTIs) isNumber = true } catch(e){}
      try { if (type == __ZTIt) isNumber = true } catch(e){}
      return isNumber;
    }function ___cxa_does_inherit(definiteType, possibilityType, possibility) {
      if (possibility == 0) return false;
      if (possibilityType == 0 || possibilityType == definiteType)
        return true;
      var possibility_type_info;
      if (___cxa_is_number_type(possibilityType)) {
        possibility_type_info = possibilityType;
      } else {
        var possibility_type_infoAddr = HEAP32[((possibilityType)>>2)] - 8;
        possibility_type_info = HEAP32[((possibility_type_infoAddr)>>2)];
      }
      switch (possibility_type_info) {
      case 0: // possibility is a pointer
        // See if definite type is a pointer
        var definite_type_infoAddr = HEAP32[((definiteType)>>2)] - 8;
        var definite_type_info = HEAP32[((definite_type_infoAddr)>>2)];
        if (definite_type_info == 0) {
          // Also a pointer; compare base types of pointers
          var defPointerBaseAddr = definiteType+8;
          var defPointerBaseType = HEAP32[((defPointerBaseAddr)>>2)];
          var possPointerBaseAddr = possibilityType+8;
          var possPointerBaseType = HEAP32[((possPointerBaseAddr)>>2)];
          return ___cxa_does_inherit(defPointerBaseType, possPointerBaseType, possibility);
        } else
          return false; // one pointer and one non-pointer
      case 1: // class with no base class
        return false;
      case 2: // class with base class
        var parentTypeAddr = possibilityType + 8;
        var parentType = HEAP32[((parentTypeAddr)>>2)];
        return ___cxa_does_inherit(definiteType, parentType, possibility);
      default:
        return false; // some unencountered type
      }
    }
  
  
  
  var ___cxa_last_thrown_exception=0;function ___resumeException(ptr) {
      if (!___cxa_last_thrown_exception) { ___cxa_last_thrown_exception = ptr; }
      throw ptr;
    }
  
  var ___cxa_exception_header_size=8;function ___cxa_find_matching_catch(thrown, throwntype) {
      if (thrown == -1) thrown = ___cxa_last_thrown_exception;
      header = thrown - ___cxa_exception_header_size;
      if (throwntype == -1) throwntype = HEAP32[((header)>>2)];
      var typeArray = Array.prototype.slice.call(arguments, 2);
  
      // If throwntype is a pointer, this means a pointer has been
      // thrown. When a pointer is thrown, actually what's thrown
      // is a pointer to the pointer. We'll dereference it.
      if (throwntype != 0 && !___cxa_is_number_type(throwntype)) {
        var throwntypeInfoAddr= HEAP32[((throwntype)>>2)] - 8;
        var throwntypeInfo= HEAP32[((throwntypeInfoAddr)>>2)];
        if (throwntypeInfo == 0)
          thrown = HEAP32[((thrown)>>2)];
      }
      // The different catch blocks are denoted by different types.
      // Due to inheritance, those types may not precisely match the
      // type of the thrown object. Find one which matches, and
      // return the type of the catch block which should be called.
      for (var i = 0; i < typeArray.length; i++) {
        if (___cxa_does_inherit(typeArray[i], throwntype, thrown))
          return tempRet0 = typeArray[i],thrown;
      }
      // Shouldn't happen unless we have bogus data in typeArray
      // or encounter a type for which emscripten doesn't have suitable
      // typeinfo defined. Best-efforts match just in case.
      return tempRet0 = throwntype,thrown;
    }function ___gxx_personality_v0() {
    }

  function __ZN12FieldElementC1Ev() {
  Module['printErr']('missing function: _ZN12FieldElementC1Ev'); abort(-1);
  }

  function __ZN12FieldElementaSERKS_() {
  Module['printErr']('missing function: _ZN12FieldElementaSERKS_'); abort(-1);
  }

  function __ZN12FieldElementC1E10__gmp_exprI12__gmpz_valueS1_ES2_() {
  Module['printErr']('missing function: _ZN12FieldElementC1E10__gmp_exprI12__gmpz_valueS1_ES2_'); abort(-1);
  }

  
  
  function __exit(status) {
      // void _exit(int status);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/exit.html
      Module['exit'](status);
    }function _exit(status) {
      __exit(status);
    }function __ZSt9terminatev() {
      _exit(-1234);
    }

  function __ZN13ShamirSharing5shareE12FieldElementii() {
  Module['printErr']('missing function: _ZN13ShamirSharing5shareE12FieldElementii'); abort(-1);
  }

  
  
  
  function _strlen(ptr) {
      ptr = ptr|0;
      var curr = 0;
      curr = ptr;
      while (HEAP8[(curr)]) {
        curr = (curr + 1)|0;
      }
      return (curr - ptr)|0;
    }
  
  function __reallyNegative(x) {
      return x < 0 || (x === 0 && (1/x) === -Infinity);
    }function __formatString(format, varargs) {
      var textIndex = format;
      var argIndex = 0;
      function getNextArg(type) {
        // NOTE: Explicitly ignoring type safety. Otherwise this fails:
        //       int x = 4; printf("%c\n", (char)x);
        var ret;
        if (type === 'double') {
          ret = HEAPF64[(((varargs)+(argIndex))>>3)];
        } else if (type == 'i64') {
          ret = [HEAP32[(((varargs)+(argIndex))>>2)],
                 HEAP32[(((varargs)+(argIndex+8))>>2)]];
          argIndex += 8; // each 32-bit chunk is in a 64-bit block
  
        } else {
          type = 'i32'; // varargs are always i32, i64, or double
          ret = HEAP32[(((varargs)+(argIndex))>>2)];
        }
        argIndex += Math.max(Runtime.getNativeFieldSize(type), Runtime.getAlignSize(type, null, true));
        return ret;
      }
  
      var ret = [];
      var curr, next, currArg;
      while(1) {
        var startTextIndex = textIndex;
        curr = HEAP8[(textIndex)];
        if (curr === 0) break;
        next = HEAP8[((textIndex+1)|0)];
        if (curr == 37) {
          // Handle flags.
          var flagAlwaysSigned = false;
          var flagLeftAlign = false;
          var flagAlternative = false;
          var flagZeroPad = false;
          var flagPadSign = false;
          flagsLoop: while (1) {
            switch (next) {
              case 43:
                flagAlwaysSigned = true;
                break;
              case 45:
                flagLeftAlign = true;
                break;
              case 35:
                flagAlternative = true;
                break;
              case 48:
                if (flagZeroPad) {
                  break flagsLoop;
                } else {
                  flagZeroPad = true;
                  break;
                }
              case 32:
                flagPadSign = true;
                break;
              default:
                break flagsLoop;
            }
            textIndex++;
            next = HEAP8[((textIndex+1)|0)];
          }
  
          // Handle width.
          var width = 0;
          if (next == 42) {
            width = getNextArg('i32');
            textIndex++;
            next = HEAP8[((textIndex+1)|0)];
          } else {
            while (next >= 48 && next <= 57) {
              width = width * 10 + (next - 48);
              textIndex++;
              next = HEAP8[((textIndex+1)|0)];
            }
          }
  
          // Handle precision.
          var precisionSet = false, precision = -1;
          if (next == 46) {
            precision = 0;
            precisionSet = true;
            textIndex++;
            next = HEAP8[((textIndex+1)|0)];
            if (next == 42) {
              precision = getNextArg('i32');
              textIndex++;
            } else {
              while(1) {
                var precisionChr = HEAP8[((textIndex+1)|0)];
                if (precisionChr < 48 ||
                    precisionChr > 57) break;
                precision = precision * 10 + (precisionChr - 48);
                textIndex++;
              }
            }
            next = HEAP8[((textIndex+1)|0)];
          }
          if (precision < 0) {
            precision = 6; // Standard default.
            precisionSet = false;
          }
  
          // Handle integer sizes. WARNING: These assume a 32-bit architecture!
          var argSize;
          switch (String.fromCharCode(next)) {
            case 'h':
              var nextNext = HEAP8[((textIndex+2)|0)];
              if (nextNext == 104) {
                textIndex++;
                argSize = 1; // char (actually i32 in varargs)
              } else {
                argSize = 2; // short (actually i32 in varargs)
              }
              break;
            case 'l':
              var nextNext = HEAP8[((textIndex+2)|0)];
              if (nextNext == 108) {
                textIndex++;
                argSize = 8; // long long
              } else {
                argSize = 4; // long
              }
              break;
            case 'L': // long long
            case 'q': // int64_t
            case 'j': // intmax_t
              argSize = 8;
              break;
            case 'z': // size_t
            case 't': // ptrdiff_t
            case 'I': // signed ptrdiff_t or unsigned size_t
              argSize = 4;
              break;
            default:
              argSize = null;
          }
          if (argSize) textIndex++;
          next = HEAP8[((textIndex+1)|0)];
  
          // Handle type specifier.
          switch (String.fromCharCode(next)) {
            case 'd': case 'i': case 'u': case 'o': case 'x': case 'X': case 'p': {
              // Integer.
              var signed = next == 100 || next == 105;
              argSize = argSize || 4;
              var currArg = getNextArg('i' + (argSize * 8));
              var origArg = currArg;
              var argText;
              // Flatten i64-1 [low, high] into a (slightly rounded) double
              if (argSize == 8) {
                currArg = Runtime.makeBigInt(currArg[0], currArg[1], next == 117);
              }
              // Truncate to requested size.
              if (argSize <= 4) {
                var limit = Math.pow(256, argSize) - 1;
                currArg = (signed ? reSign : unSign)(currArg & limit, argSize * 8);
              }
              // Format the number.
              var currAbsArg = Math.abs(currArg);
              var prefix = '';
              if (next == 100 || next == 105) {
                if (argSize == 8 && i64Math) argText = i64Math.stringify(origArg[0], origArg[1], null); else
                argText = reSign(currArg, 8 * argSize, 1).toString(10);
              } else if (next == 117) {
                if (argSize == 8 && i64Math) argText = i64Math.stringify(origArg[0], origArg[1], true); else
                argText = unSign(currArg, 8 * argSize, 1).toString(10);
                currArg = Math.abs(currArg);
              } else if (next == 111) {
                argText = (flagAlternative ? '0' : '') + currAbsArg.toString(8);
              } else if (next == 120 || next == 88) {
                prefix = (flagAlternative && currArg != 0) ? '0x' : '';
                if (argSize == 8 && i64Math) {
                  if (origArg[1]) {
                    argText = (origArg[1]>>>0).toString(16);
                    var lower = (origArg[0]>>>0).toString(16);
                    while (lower.length < 8) lower = '0' + lower;
                    argText += lower;
                  } else {
                    argText = (origArg[0]>>>0).toString(16);
                  }
                } else
                if (currArg < 0) {
                  // Represent negative numbers in hex as 2's complement.
                  currArg = -currArg;
                  argText = (currAbsArg - 1).toString(16);
                  var buffer = [];
                  for (var i = 0; i < argText.length; i++) {
                    buffer.push((0xF - parseInt(argText[i], 16)).toString(16));
                  }
                  argText = buffer.join('');
                  while (argText.length < argSize * 2) argText = 'f' + argText;
                } else {
                  argText = currAbsArg.toString(16);
                }
                if (next == 88) {
                  prefix = prefix.toUpperCase();
                  argText = argText.toUpperCase();
                }
              } else if (next == 112) {
                if (currAbsArg === 0) {
                  argText = '(nil)';
                } else {
                  prefix = '0x';
                  argText = currAbsArg.toString(16);
                }
              }
              if (precisionSet) {
                while (argText.length < precision) {
                  argText = '0' + argText;
                }
              }
  
              // Add sign if needed
              if (currArg >= 0) {
                if (flagAlwaysSigned) {
                  prefix = '+' + prefix;
                } else if (flagPadSign) {
                  prefix = ' ' + prefix;
                }
              }
  
              // Move sign to prefix so we zero-pad after the sign
              if (argText.charAt(0) == '-') {
                prefix = '-' + prefix;
                argText = argText.substr(1);
              }
  
              // Add padding.
              while (prefix.length + argText.length < width) {
                if (flagLeftAlign) {
                  argText += ' ';
                } else {
                  if (flagZeroPad) {
                    argText = '0' + argText;
                  } else {
                    prefix = ' ' + prefix;
                  }
                }
              }
  
              // Insert the result into the buffer.
              argText = prefix + argText;
              argText.split('').forEach(function(chr) {
                ret.push(chr.charCodeAt(0));
              });
              break;
            }
            case 'f': case 'F': case 'e': case 'E': case 'g': case 'G': {
              // Float.
              var currArg = getNextArg('double');
              var argText;
              if (isNaN(currArg)) {
                argText = 'nan';
                flagZeroPad = false;
              } else if (!isFinite(currArg)) {
                argText = (currArg < 0 ? '-' : '') + 'inf';
                flagZeroPad = false;
              } else {
                var isGeneral = false;
                var effectivePrecision = Math.min(precision, 20);
  
                // Convert g/G to f/F or e/E, as per:
                // http://pubs.opengroup.org/onlinepubs/9699919799/functions/printf.html
                if (next == 103 || next == 71) {
                  isGeneral = true;
                  precision = precision || 1;
                  var exponent = parseInt(currArg.toExponential(effectivePrecision).split('e')[1], 10);
                  if (precision > exponent && exponent >= -4) {
                    next = ((next == 103) ? 'f' : 'F').charCodeAt(0);
                    precision -= exponent + 1;
                  } else {
                    next = ((next == 103) ? 'e' : 'E').charCodeAt(0);
                    precision--;
                  }
                  effectivePrecision = Math.min(precision, 20);
                }
  
                if (next == 101 || next == 69) {
                  argText = currArg.toExponential(effectivePrecision);
                  // Make sure the exponent has at least 2 digits.
                  if (/[eE][-+]\d$/.test(argText)) {
                    argText = argText.slice(0, -1) + '0' + argText.slice(-1);
                  }
                } else if (next == 102 || next == 70) {
                  argText = currArg.toFixed(effectivePrecision);
                  if (currArg === 0 && __reallyNegative(currArg)) {
                    argText = '-' + argText;
                  }
                }
  
                var parts = argText.split('e');
                if (isGeneral && !flagAlternative) {
                  // Discard trailing zeros and periods.
                  while (parts[0].length > 1 && parts[0].indexOf('.') != -1 &&
                         (parts[0].slice(-1) == '0' || parts[0].slice(-1) == '.')) {
                    parts[0] = parts[0].slice(0, -1);
                  }
                } else {
                  // Make sure we have a period in alternative mode.
                  if (flagAlternative && argText.indexOf('.') == -1) parts[0] += '.';
                  // Zero pad until required precision.
                  while (precision > effectivePrecision++) parts[0] += '0';
                }
                argText = parts[0] + (parts.length > 1 ? 'e' + parts[1] : '');
  
                // Capitalize 'E' if needed.
                if (next == 69) argText = argText.toUpperCase();
  
                // Add sign.
                if (currArg >= 0) {
                  if (flagAlwaysSigned) {
                    argText = '+' + argText;
                  } else if (flagPadSign) {
                    argText = ' ' + argText;
                  }
                }
              }
  
              // Add padding.
              while (argText.length < width) {
                if (flagLeftAlign) {
                  argText += ' ';
                } else {
                  if (flagZeroPad && (argText[0] == '-' || argText[0] == '+')) {
                    argText = argText[0] + '0' + argText.slice(1);
                  } else {
                    argText = (flagZeroPad ? '0' : ' ') + argText;
                  }
                }
              }
  
              // Adjust case.
              if (next < 97) argText = argText.toUpperCase();
  
              // Insert the result into the buffer.
              argText.split('').forEach(function(chr) {
                ret.push(chr.charCodeAt(0));
              });
              break;
            }
            case 's': {
              // String.
              var arg = getNextArg('i8*');
              var argLength = arg ? _strlen(arg) : '(null)'.length;
              if (precisionSet) argLength = Math.min(argLength, precision);
              if (!flagLeftAlign) {
                while (argLength < width--) {
                  ret.push(32);
                }
              }
              if (arg) {
                for (var i = 0; i < argLength; i++) {
                  ret.push(HEAPU8[((arg++)|0)]);
                }
              } else {
                ret = ret.concat(intArrayFromString('(null)'.substr(0, argLength), true));
              }
              if (flagLeftAlign) {
                while (argLength < width--) {
                  ret.push(32);
                }
              }
              break;
            }
            case 'c': {
              // Character.
              if (flagLeftAlign) ret.push(getNextArg('i8'));
              while (--width > 0) {
                ret.push(32);
              }
              if (!flagLeftAlign) ret.push(getNextArg('i8'));
              break;
            }
            case 'n': {
              // Write the length written so far to the next parameter.
              var ptr = getNextArg('i32*');
              HEAP32[((ptr)>>2)]=ret.length;
              break;
            }
            case '%': {
              // Literal percent sign.
              ret.push(curr);
              break;
            }
            default: {
              // Unknown specifiers remain untouched.
              for (var i = startTextIndex; i < textIndex + 2; i++) {
                ret.push(HEAP8[(i)]);
              }
            }
          }
          textIndex += 2;
          // TODO: Support a/A (hex float) and m (last error) specifiers.
          // TODO: Support %1${specifier} for arg selection.
        } else {
          ret.push(curr);
          textIndex += 1;
        }
      }
      return ret;
    }function _snprintf(s, n, format, varargs) {
      // int snprintf(char *restrict s, size_t n, const char *restrict format, ...);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/printf.html
      var result = __formatString(format, varargs);
      var limit = (n === undefined) ? result.length
                                    : Math.min(result.length, Math.max(n - 1, 0));
      if (s < 0) {
        s = -s;
        var buf = _malloc(limit+1);
        HEAP32[((s)>>2)]=buf;
        s = buf;
      }
      for (var i = 0; i < limit; i++) {
        HEAP8[(((s)+(i))|0)]=result[i];
      }
      if (limit < n || (n === undefined)) HEAP8[(((s)+(i))|0)]=0;
      return result.length;
    }function _sprintf(s, format, varargs) {
      // int sprintf(char *restrict s, const char *restrict format, ...);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/printf.html
      return _snprintf(s, undefined, format, varargs);
    }

  
  function _close(fildes) {
      // int close(int fildes);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/close.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        FS.close(stream);
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }
  
  function _fsync(fildes) {
      // int fsync(int fildes);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fsync.html
      var stream = FS.getStream(fildes);
      if (stream) {
        // We write directly to the file system, so there's nothing to do here.
        return 0;
      } else {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
    }
  
  function _fileno(stream) {
      // int fileno(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fileno.html
      return FS.getStreamFromPtr(stream).fd;
    }function _fclose(stream) {
      // int fclose(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fclose.html
      var fd = _fileno(stream);
      _fsync(fd);
      return _close(fd);
    }

  function ___cxa_call_unexpected(exception) {
      Module.printErr('Unexpected exception thrown, this is not properly supported - aborting');
      ABORT = true;
      throw exception;
    }

  
  var ___cxa_caught_exceptions=[];function ___cxa_begin_catch(ptr) {
      __ZSt18uncaught_exceptionv.uncaught_exception--;
      ___cxa_caught_exceptions.push(___cxa_last_thrown_exception);
      return ptr;
    }

  
  function ___cxa_free_exception(ptr) {
      try {
        return _free(ptr - ___cxa_exception_header_size);
      } catch(e) { // XXX FIXME
        Module.printErr('exception during cxa_free_exception: ' + e);
      }
    }function ___cxa_end_catch() {
      if (___cxa_end_catch.rethrown) {
        ___cxa_end_catch.rethrown = false;
        return;
      }
      // Clear state flag.
      __THREW__ = 0;
      // Call destructor if one is registered then clear it.
      var ptr = ___cxa_caught_exceptions.pop();
      if (ptr) {
        header = ptr - ___cxa_exception_header_size;
        var destructor = HEAP32[(((header)+(4))>>2)];
        if (destructor) {
          Runtime.dynCall('vi', destructor, [ptr]);
          HEAP32[(((header)+(4))>>2)]=0;
        }
        ___cxa_free_exception(ptr);
        ___cxa_last_thrown_exception = 0;
      }
    }


  
  
  function _emscripten_memcpy_big(dest, src, num) {
      HEAPU8.set(HEAPU8.subarray(src, src+num), dest);
      return dest;
    }function _memcpy(dest, src, num) {
      dest = dest|0; src = src|0; num = num|0;
      var ret = 0;
      if ((num|0) >= 4096) return _emscripten_memcpy_big(dest|0, src|0, num|0)|0;
      ret = dest|0;
      if ((dest&3) == (src&3)) {
        while (dest & 3) {
          if ((num|0) == 0) return ret|0;
          HEAP8[(dest)]=HEAP8[(src)];
          dest = (dest+1)|0;
          src = (src+1)|0;
          num = (num-1)|0;
        }
        while ((num|0) >= 4) {
          HEAP32[((dest)>>2)]=HEAP32[((src)>>2)];
          dest = (dest+4)|0;
          src = (src+4)|0;
          num = (num-4)|0;
        }
      }
      while ((num|0) > 0) {
        HEAP8[(dest)]=HEAP8[(src)];
        dest = (dest+1)|0;
        src = (src+1)|0;
        num = (num-1)|0;
      }
      return ret|0;
    }var _llvm_memcpy_p0i8_p0i8_i32=_memcpy;

  
  function _lseek(fildes, offset, whence) {
      // off_t lseek(int fildes, off_t offset, int whence);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/lseek.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        return FS.llseek(stream, offset, whence);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fseek(stream, offset, whence) {
      // int fseek(FILE *stream, long offset, int whence);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fseek.html
      var fd = _fileno(stream);
      var ret = _lseek(fd, offset, whence);
      if (ret == -1) {
        return -1;
      }
      stream = FS.getStreamFromPtr(stream);
      stream.eof = false;
      return 0;
    }

  
  
  function _send(fd, buf, len, flags) {
      var sock = SOCKFS.getSocket(fd);
      if (!sock) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      // TODO honor flags
      return _write(fd, buf, len);
    }
  
  function _pwrite(fildes, buf, nbyte, offset) {
      // ssize_t pwrite(int fildes, const void *buf, size_t nbyte, off_t offset);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/write.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        var slab = HEAP8;
        return FS.write(stream, slab, buf, nbyte, offset);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _write(fildes, buf, nbyte) {
      // ssize_t write(int fildes, const void *buf, size_t nbyte);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/write.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
  
  
      try {
        var slab = HEAP8;
        return FS.write(stream, slab, buf, nbyte);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fwrite(ptr, size, nitems, stream) {
      // size_t fwrite(const void *restrict ptr, size_t size, size_t nitems, FILE *restrict stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fwrite.html
      var bytesToWrite = nitems * size;
      if (bytesToWrite == 0) return 0;
      var fd = _fileno(stream);
      var bytesWritten = _write(fd, ptr, bytesToWrite);
      if (bytesWritten == -1) {
        var streamObj = FS.getStreamFromPtr(stream);
        if (streamObj) streamObj.error = true;
        return 0;
      } else {
        return Math.floor(bytesWritten / size);
      }
    }

  function ___cxa_allocate_exception(size) {
      var ptr = _malloc(size + ___cxa_exception_header_size);
      return ptr + ___cxa_exception_header_size;
    }

  function ___cxa_throw(ptr, type, destructor) {
      if (!___cxa_throw.initialized) {
        try {
          HEAP32[((__ZTVN10__cxxabiv119__pointer_type_infoE)>>2)]=0; // Workaround for libcxxabi integration bug
        } catch(e){}
        try {
          HEAP32[((__ZTVN10__cxxabiv117__class_type_infoE)>>2)]=1; // Workaround for libcxxabi integration bug
        } catch(e){}
        try {
          HEAP32[((__ZTVN10__cxxabiv120__si_class_type_infoE)>>2)]=2; // Workaround for libcxxabi integration bug
        } catch(e){}
        ___cxa_throw.initialized = true;
      }
      var header = ptr - ___cxa_exception_header_size;
      HEAP32[((header)>>2)]=type;
      HEAP32[(((header)+(4))>>2)]=destructor;
      ___cxa_last_thrown_exception = ptr;
      if (!("uncaught_exception" in __ZSt18uncaught_exceptionv)) {
        __ZSt18uncaught_exceptionv.uncaught_exception = 1;
      } else {
        __ZSt18uncaught_exceptionv.uncaught_exception++;
      }
      throw ptr;
    }

  
  function _memmove(dest, src, num) {
      dest = dest|0; src = src|0; num = num|0;
      var ret = 0;
      if (((src|0) < (dest|0)) & ((dest|0) < ((src + num)|0))) {
        // Unlikely case: Copy backwards in a safe manner
        ret = dest;
        src = (src + num)|0;
        dest = (dest + num)|0;
        while ((num|0) > 0) {
          dest = (dest - 1)|0;
          src = (src - 1)|0;
          num = (num - 1)|0;
          HEAP8[(dest)]=HEAP8[(src)];
        }
        dest = ret;
      } else {
        _memcpy(dest, src, num) | 0;
      }
      return dest | 0;
    }var _llvm_memmove_p0i8_p0i8_i32=_memmove;


  var _fseeko=_fseek;

  
  function _memset(ptr, value, num) {
      ptr = ptr|0; value = value|0; num = num|0;
      var stop = 0, value4 = 0, stop4 = 0, unaligned = 0;
      stop = (ptr + num)|0;
      if ((num|0) >= 20) {
        // This is unaligned, but quite large, so work hard to get to aligned settings
        value = value & 0xff;
        unaligned = ptr & 3;
        value4 = value | (value << 8) | (value << 16) | (value << 24);
        stop4 = stop & ~3;
        if (unaligned) {
          unaligned = (ptr + 4 - unaligned)|0;
          while ((ptr|0) < (unaligned|0)) { // no need to check for stop, since we have large num
            HEAP8[(ptr)]=value;
            ptr = (ptr+1)|0;
          }
        }
        while ((ptr|0) < (stop4|0)) {
          HEAP32[((ptr)>>2)]=value4;
          ptr = (ptr+4)|0;
        }
      }
      while ((ptr|0) < (stop|0)) {
        HEAP8[(ptr)]=value;
        ptr = (ptr+1)|0;
      }
      return (ptr-num)|0;
    }var _llvm_memset_p0i8_i32=_memset;

  
  function _ftell(stream) {
      // long ftell(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/ftell.html
      stream = FS.getStreamFromPtr(stream);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      if (FS.isChrdev(stream.node.mode)) {
        ___setErrNo(ERRNO_CODES.ESPIPE);
        return -1;
      } else {
        return stream.position;
      }
    }var _ftello=_ftell;



  function __ZNK12FieldElement8getValueEv() {
  Module['printErr']('missing function: _ZNK12FieldElement8getValueEv'); abort(-1);
  }

  function __ZlsRNSt3__113basic_ostreamIcNS_11char_traitsIcEEEEPK12__mpz_struct() {
  Module['printErr']('missing function: _ZlsRNSt3__113basic_ostreamIcNS_11char_traitsIcEEEEPK12__mpz_struct'); abort(-1);
  }

  function ___gmpz_clear() {
  Module['printErr']('missing function: __gmpz_clear'); abort(-1);
  }

  function ___gmpz_init_set() {
  Module['printErr']('missing function: __gmpz_init_set'); abort(-1);
  }

  var _llvm_memcpy_p0i8_p0i8_i64=_memcpy;

  function _pthread_mutex_lock() {}

  function _pthread_mutex_unlock() {}

  function ___cxa_guard_acquire(variable) {
      if (!HEAP8[(variable)]) { // ignore SAFE_HEAP stuff because llvm mixes i64 and i8 here
        HEAP8[(variable)]=1;
        return 1;
      }
      return 0;
    }

  function ___cxa_guard_release() {}

  function _pthread_cond_broadcast() {
      return 0;
    }

  function _pthread_cond_wait() {
      return 0;
    }

  
  function _atexit(func, arg) {
      __ATEXIT__.unshift({ func: func, arg: arg });
    }var ___cxa_atexit=_atexit;

  var _llvm_memset_p0i8_i64=_memset;

  function _llvm_lifetime_start() {}

  function _llvm_lifetime_end() {}

  function _ungetc(c, stream) {
      // int ungetc(int c, FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/ungetc.html
      stream = FS.getStreamFromPtr(stream);
      if (!stream) {
        return -1;
      }
      if (c === -1) {
        // do nothing for EOF character
        return c;
      }
      c = unSign(c & 0xFF);
      stream.ungotten.push(c);
      stream.eof = false;
      return c;
    }

  
  function _fgetc(stream) {
      // int fgetc(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fgetc.html
      var streamObj = FS.getStreamFromPtr(stream);
      if (!streamObj) return -1;
      if (streamObj.eof || streamObj.error) return -1;
      var ret = _fread(_fgetc.ret, 1, 1, stream);
      if (ret == 0) {
        return -1;
      } else if (ret == -1) {
        streamObj.error = true;
        return -1;
      } else {
        return HEAPU8[((_fgetc.ret)|0)];
      }
    }var _getc=_fgetc;

  function __ZNSt9exceptionD2Ev() {}

  function ___errno_location() {
      return ___errno_state;
    }

  
  function _strerror_r(errnum, strerrbuf, buflen) {
      if (errnum in ERRNO_MESSAGES) {
        if (ERRNO_MESSAGES[errnum].length > buflen - 1) {
          return ___setErrNo(ERRNO_CODES.ERANGE);
        } else {
          var msg = ERRNO_MESSAGES[errnum];
          writeAsciiToMemory(msg, strerrbuf);
          return 0;
        }
      } else {
        return ___setErrNo(ERRNO_CODES.EINVAL);
      }
    }function _strerror(errnum) {
      if (!_strerror.buffer) _strerror.buffer = _malloc(256);
      _strerror_r(errnum, _strerror.buffer, 256);
      return _strerror.buffer;
    }

  function _abort() {
      Module['abort']();
    }

  function ___cxa_rethrow() {
      ___cxa_end_catch.rethrown = true;
      var ptr = ___cxa_caught_exceptions.pop();
      throw ptr;
    }


  function _sysconf(name) {
      // long sysconf(int name);
      // http://pubs.opengroup.org/onlinepubs/009695399/functions/sysconf.html
      switch(name) {
        case 30: return PAGE_SIZE;
        case 132:
        case 133:
        case 12:
        case 137:
        case 138:
        case 15:
        case 235:
        case 16:
        case 17:
        case 18:
        case 19:
        case 20:
        case 149:
        case 13:
        case 10:
        case 236:
        case 153:
        case 9:
        case 21:
        case 22:
        case 159:
        case 154:
        case 14:
        case 77:
        case 78:
        case 139:
        case 80:
        case 81:
        case 79:
        case 82:
        case 68:
        case 67:
        case 164:
        case 11:
        case 29:
        case 47:
        case 48:
        case 95:
        case 52:
        case 51:
        case 46:
          return 200809;
        case 27:
        case 246:
        case 127:
        case 128:
        case 23:
        case 24:
        case 160:
        case 161:
        case 181:
        case 182:
        case 242:
        case 183:
        case 184:
        case 243:
        case 244:
        case 245:
        case 165:
        case 178:
        case 179:
        case 49:
        case 50:
        case 168:
        case 169:
        case 175:
        case 170:
        case 171:
        case 172:
        case 97:
        case 76:
        case 32:
        case 173:
        case 35:
          return -1;
        case 176:
        case 177:
        case 7:
        case 155:
        case 8:
        case 157:
        case 125:
        case 126:
        case 92:
        case 93:
        case 129:
        case 130:
        case 131:
        case 94:
        case 91:
          return 1;
        case 74:
        case 60:
        case 69:
        case 70:
        case 4:
          return 1024;
        case 31:
        case 42:
        case 72:
          return 32;
        case 87:
        case 26:
        case 33:
          return 2147483647;
        case 34:
        case 1:
          return 47839;
        case 38:
        case 36:
          return 99;
        case 43:
        case 37:
          return 2048;
        case 0: return 2097152;
        case 3: return 65536;
        case 28: return 32768;
        case 44: return 32767;
        case 75: return 16384;
        case 39: return 1000;
        case 89: return 700;
        case 71: return 256;
        case 40: return 255;
        case 2: return 100;
        case 180: return 64;
        case 25: return 20;
        case 5: return 16;
        case 6: return 6;
        case 73: return 4;
        case 84: return 1;
      }
      ___setErrNo(ERRNO_CODES.EINVAL);
      return -1;
    }

  function ___cxa_guard_abort() {}

  
  function _isxdigit(chr) {
      return (chr >= 48 && chr <= 57) ||
             (chr >= 97 && chr <= 102) ||
             (chr >= 65 && chr <= 70);
    }function _isxdigit_l(chr) {
      return _isxdigit(chr); // no locale support yet
    }

  
  function _isdigit(chr) {
      return chr >= 48 && chr <= 57;
    }function _isdigit_l(chr) {
      return _isdigit(chr); // no locale support yet
    }

  
  
  function __getFloat(text) {
      return /^[+-]?[0-9]*\.?[0-9]+([eE][+-]?[0-9]+)?/.exec(text);
    }function __scanString(format, get, unget, varargs) {
      if (!__scanString.whiteSpace) {
        __scanString.whiteSpace = {};
        __scanString.whiteSpace[32] = 1;
        __scanString.whiteSpace[9] = 1;
        __scanString.whiteSpace[10] = 1;
        __scanString.whiteSpace[11] = 1;
        __scanString.whiteSpace[12] = 1;
        __scanString.whiteSpace[13] = 1;
      }
      // Supports %x, %4x, %d.%d, %lld, %s, %f, %lf.
      // TODO: Support all format specifiers.
      format = Pointer_stringify(format);
      var soFar = 0;
      if (format.indexOf('%n') >= 0) {
        // need to track soFar
        var _get = get;
        get = function get() {
          soFar++;
          return _get();
        }
        var _unget = unget;
        unget = function unget() {
          soFar--;
          return _unget();
        }
      }
      var formatIndex = 0;
      var argsi = 0;
      var fields = 0;
      var argIndex = 0;
      var next;
  
      mainLoop:
      for (var formatIndex = 0; formatIndex < format.length;) {
        if (format[formatIndex] === '%' && format[formatIndex+1] == 'n') {
          var argPtr = HEAP32[(((varargs)+(argIndex))>>2)];
          argIndex += Runtime.getAlignSize('void*', null, true);
          HEAP32[((argPtr)>>2)]=soFar;
          formatIndex += 2;
          continue;
        }
  
        if (format[formatIndex] === '%') {
          var nextC = format.indexOf('c', formatIndex+1);
          if (nextC > 0) {
            var maxx = 1;
            if (nextC > formatIndex+1) {
              var sub = format.substring(formatIndex+1, nextC);
              maxx = parseInt(sub);
              if (maxx != sub) maxx = 0;
            }
            if (maxx) {
              var argPtr = HEAP32[(((varargs)+(argIndex))>>2)];
              argIndex += Runtime.getAlignSize('void*', null, true);
              fields++;
              for (var i = 0; i < maxx; i++) {
                next = get();
                HEAP8[((argPtr++)|0)]=next;
                if (next === 0) return i > 0 ? fields : fields-1; // we failed to read the full length of this field
              }
              formatIndex += nextC - formatIndex + 1;
              continue;
            }
          }
        }
  
        // handle %[...]
        if (format[formatIndex] === '%' && format.indexOf('[', formatIndex+1) > 0) {
          var match = /\%([0-9]*)\[(\^)?(\]?[^\]]*)\]/.exec(format.substring(formatIndex));
          if (match) {
            var maxNumCharacters = parseInt(match[1]) || Infinity;
            var negateScanList = (match[2] === '^');
            var scanList = match[3];
  
            // expand "middle" dashs into character sets
            var middleDashMatch;
            while ((middleDashMatch = /([^\-])\-([^\-])/.exec(scanList))) {
              var rangeStartCharCode = middleDashMatch[1].charCodeAt(0);
              var rangeEndCharCode = middleDashMatch[2].charCodeAt(0);
              for (var expanded = ''; rangeStartCharCode <= rangeEndCharCode; expanded += String.fromCharCode(rangeStartCharCode++));
              scanList = scanList.replace(middleDashMatch[1] + '-' + middleDashMatch[2], expanded);
            }
  
            var argPtr = HEAP32[(((varargs)+(argIndex))>>2)];
            argIndex += Runtime.getAlignSize('void*', null, true);
            fields++;
  
            for (var i = 0; i < maxNumCharacters; i++) {
              next = get();
              if (negateScanList) {
                if (scanList.indexOf(String.fromCharCode(next)) < 0) {
                  HEAP8[((argPtr++)|0)]=next;
                } else {
                  unget();
                  break;
                }
              } else {
                if (scanList.indexOf(String.fromCharCode(next)) >= 0) {
                  HEAP8[((argPtr++)|0)]=next;
                } else {
                  unget();
                  break;
                }
              }
            }
  
            // write out null-terminating character
            HEAP8[((argPtr++)|0)]=0;
            formatIndex += match[0].length;
            
            continue;
          }
        }      
        // remove whitespace
        while (1) {
          next = get();
          if (next == 0) return fields;
          if (!(next in __scanString.whiteSpace)) break;
        }
        unget();
  
        if (format[formatIndex] === '%') {
          formatIndex++;
          var suppressAssignment = false;
          if (format[formatIndex] == '*') {
            suppressAssignment = true;
            formatIndex++;
          }
          var maxSpecifierStart = formatIndex;
          while (format[formatIndex].charCodeAt(0) >= 48 &&
                 format[formatIndex].charCodeAt(0) <= 57) {
            formatIndex++;
          }
          var max_;
          if (formatIndex != maxSpecifierStart) {
            max_ = parseInt(format.slice(maxSpecifierStart, formatIndex), 10);
          }
          var long_ = false;
          var half = false;
          var longLong = false;
          if (format[formatIndex] == 'l') {
            long_ = true;
            formatIndex++;
            if (format[formatIndex] == 'l') {
              longLong = true;
              formatIndex++;
            }
          } else if (format[formatIndex] == 'h') {
            half = true;
            formatIndex++;
          }
          var type = format[formatIndex];
          formatIndex++;
          var curr = 0;
          var buffer = [];
          // Read characters according to the format. floats are trickier, they may be in an unfloat state in the middle, then be a valid float later
          if (type == 'f' || type == 'e' || type == 'g' ||
              type == 'F' || type == 'E' || type == 'G') {
            next = get();
            while (next > 0 && (!(next in __scanString.whiteSpace)))  {
              buffer.push(String.fromCharCode(next));
              next = get();
            }
            var m = __getFloat(buffer.join(''));
            var last = m ? m[0].length : 0;
            for (var i = 0; i < buffer.length - last + 1; i++) {
              unget();
            }
            buffer.length = last;
          } else {
            next = get();
            var first = true;
            
            // Strip the optional 0x prefix for %x.
            if ((type == 'x' || type == 'X') && (next == 48)) {
              var peek = get();
              if (peek == 120 || peek == 88) {
                next = get();
              } else {
                unget();
              }
            }
            
            while ((curr < max_ || isNaN(max_)) && next > 0) {
              if (!(next in __scanString.whiteSpace) && // stop on whitespace
                  (type == 's' ||
                   ((type === 'd' || type == 'u' || type == 'i') && ((next >= 48 && next <= 57) ||
                                                                     (first && next == 45))) ||
                   ((type === 'x' || type === 'X') && (next >= 48 && next <= 57 ||
                                     next >= 97 && next <= 102 ||
                                     next >= 65 && next <= 70))) &&
                  (formatIndex >= format.length || next !== format[formatIndex].charCodeAt(0))) { // Stop when we read something that is coming up
                buffer.push(String.fromCharCode(next));
                next = get();
                curr++;
                first = false;
              } else {
                break;
              }
            }
            unget();
          }
          if (buffer.length === 0) return 0;  // Failure.
          if (suppressAssignment) continue;
  
          var text = buffer.join('');
          var argPtr = HEAP32[(((varargs)+(argIndex))>>2)];
          argIndex += Runtime.getAlignSize('void*', null, true);
          switch (type) {
            case 'd': case 'u': case 'i':
              if (half) {
                HEAP16[((argPtr)>>1)]=parseInt(text, 10);
              } else if (longLong) {
                (tempI64 = [parseInt(text, 10)>>>0,(tempDouble=parseInt(text, 10),Math_abs(tempDouble) >= 1 ? (tempDouble > 0 ? Math_min(Math_floor((tempDouble)/4294967296), 4294967295)>>>0 : (~~(Math_ceil((tempDouble - +(((~~(tempDouble)))>>>0))/4294967296)))>>>0) : 0)],HEAP32[((argPtr)>>2)]=tempI64[0],HEAP32[(((argPtr)+(4))>>2)]=tempI64[1]);
              } else {
                HEAP32[((argPtr)>>2)]=parseInt(text, 10);
              }
              break;
            case 'X':
            case 'x':
              HEAP32[((argPtr)>>2)]=parseInt(text, 16);
              break;
            case 'F':
            case 'f':
            case 'E':
            case 'e':
            case 'G':
            case 'g':
            case 'E':
              // fallthrough intended
              if (long_) {
                HEAPF64[((argPtr)>>3)]=parseFloat(text);
              } else {
                HEAPF32[((argPtr)>>2)]=parseFloat(text);
              }
              break;
            case 's':
              var array = intArrayFromString(text);
              for (var j = 0; j < array.length; j++) {
                HEAP8[(((argPtr)+(j))|0)]=array[j];
              }
              break;
          }
          fields++;
        } else if (format[formatIndex].charCodeAt(0) in __scanString.whiteSpace) {
          next = get();
          while (next in __scanString.whiteSpace) {
            if (next <= 0) break mainLoop;  // End of input.
            next = get();
          }
          unget(next);
          formatIndex++;
        } else {
          // Not a specifier.
          next = get();
          if (format[formatIndex].charCodeAt(0) !== next) {
            unget(next);
            break mainLoop;
          }
          formatIndex++;
        }
      }
      return fields;
    }function _sscanf(s, format, varargs) {
      // int sscanf(const char *restrict s, const char *restrict format, ... );
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/scanf.html
      var index = 0;
      function get() { return HEAP8[(((s)+(index++))|0)]; };
      function unget() { index--; };
      return __scanString(format, get, unget, varargs);
    }

  function _catopen(name, oflag) {
      // nl_catd catopen (const char *name, int oflag)
      return -1;
    }

  function _catgets(catd, set_id, msg_id, s) {
      // char *catgets (nl_catd catd, int set_id, int msg_id, const char *s)
      return s;
    }

  function _catclose(catd) {
      // int catclose (nl_catd catd)
      return 0;
    }

  function _newlocale(mask, locale, base) {
      return _malloc(4);
    }

  function _freelocale(locale) {
      _free(locale);
    }

  function ___ctype_b_loc() {
      // http://refspecs.freestandards.org/LSB_3.0.0/LSB-Core-generic/LSB-Core-generic/baselib---ctype-b-loc.html
      var me = ___ctype_b_loc;
      if (!me.ret) {
        var values = [
          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
          0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,2,2,8195,8194,8194,8194,8194,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,24577,49156,49156,49156,
          49156,49156,49156,49156,49156,49156,49156,49156,49156,49156,49156,49156,55304,55304,55304,55304,55304,55304,55304,55304,
          55304,55304,49156,49156,49156,49156,49156,49156,49156,54536,54536,54536,54536,54536,54536,50440,50440,50440,50440,50440,
          50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,49156,49156,49156,49156,49156,
          49156,54792,54792,54792,54792,54792,54792,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,
          50696,50696,50696,50696,50696,50696,50696,49156,49156,49156,49156,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
        ];
        var i16size = 2;
        var arr = _malloc(values.length * i16size);
        for (var i = 0; i < values.length; i++) {
          HEAP16[(((arr)+(i * i16size))>>1)]=values[i];
        }
        me.ret = allocate([arr + 128 * i16size], 'i16*', ALLOC_NORMAL);
      }
      return me.ret;
    }

  function ___ctype_tolower_loc() {
      // http://refspecs.freestandards.org/LSB_3.1.1/LSB-Core-generic/LSB-Core-generic/libutil---ctype-tolower-loc.html
      var me = ___ctype_tolower_loc;
      if (!me.ret) {
        var values = [
          128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,
          158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,
          188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,
          218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,
          248,249,250,251,252,253,254,-1,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,
          33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,97,98,99,100,101,102,103,
          104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,91,92,93,94,95,96,97,98,99,100,101,102,103,
          104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,128,129,130,131,132,133,
          134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,
          164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,
          194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,
          224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,
          254,255
        ];
        var i32size = 4;
        var arr = _malloc(values.length * i32size);
        for (var i = 0; i < values.length; i++) {
          HEAP32[(((arr)+(i * i32size))>>2)]=values[i];
        }
        me.ret = allocate([arr + 128 * i32size], 'i32*', ALLOC_NORMAL);
      }
      return me.ret;
    }

  function ___ctype_toupper_loc() {
      // http://refspecs.freestandards.org/LSB_3.1.1/LSB-Core-generic/LSB-Core-generic/libutil---ctype-toupper-loc.html
      var me = ___ctype_toupper_loc;
      if (!me.ret) {
        var values = [
          128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,
          158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,
          188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,
          218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,
          248,249,250,251,252,253,254,-1,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,
          33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,
          73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,
          81,82,83,84,85,86,87,88,89,90,123,124,125,126,127,128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,
          145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,
          175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,
          205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,
          235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,255
        ];
        var i32size = 4;
        var arr = _malloc(values.length * i32size);
        for (var i = 0; i < values.length; i++) {
          HEAP32[(((arr)+(i * i32size))>>2)]=values[i];
        }
        me.ret = allocate([arr + 128 * i32size], 'i32*', ALLOC_NORMAL);
      }
      return me.ret;
    }

  
  
  function __isLeapYear(year) {
        return year%4 === 0 && (year%100 !== 0 || year%400 === 0);
    }
  
  function __arraySum(array, index) {
      var sum = 0;
      for (var i = 0; i <= index; sum += array[i++]);
      return sum;
    }
  
  
  var __MONTH_DAYS_LEAP=[31,29,31,30,31,30,31,31,30,31,30,31];
  
  var __MONTH_DAYS_REGULAR=[31,28,31,30,31,30,31,31,30,31,30,31];function __addDays(date, days) {
      var newDate = new Date(date.getTime());
      while(days > 0) {
        var leap = __isLeapYear(newDate.getFullYear());
        var currentMonth = newDate.getMonth();
        var daysInCurrentMonth = (leap ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR)[currentMonth];
  
        if (days > daysInCurrentMonth-newDate.getDate()) {
          // we spill over to next month
          days -= (daysInCurrentMonth-newDate.getDate()+1);
          newDate.setDate(1);
          if (currentMonth < 11) {
            newDate.setMonth(currentMonth+1)
          } else {
            newDate.setMonth(0);
            newDate.setFullYear(newDate.getFullYear()+1);
          }
        } else {
          // we stay in current month 
          newDate.setDate(newDate.getDate()+days);
          return newDate;
        }
      }
  
      return newDate;
    }function _strftime(s, maxsize, format, tm) {
      // size_t strftime(char *restrict s, size_t maxsize, const char *restrict format, const struct tm *restrict timeptr);
      // http://pubs.opengroup.org/onlinepubs/009695399/functions/strftime.html
      
      var date = {
        tm_sec: HEAP32[((tm)>>2)],
        tm_min: HEAP32[(((tm)+(4))>>2)],
        tm_hour: HEAP32[(((tm)+(8))>>2)],
        tm_mday: HEAP32[(((tm)+(12))>>2)],
        tm_mon: HEAP32[(((tm)+(16))>>2)],
        tm_year: HEAP32[(((tm)+(20))>>2)],
        tm_wday: HEAP32[(((tm)+(24))>>2)],
        tm_yday: HEAP32[(((tm)+(28))>>2)],
        tm_isdst: HEAP32[(((tm)+(32))>>2)]
      };
  
      var pattern = Pointer_stringify(format);
  
      // expand format
      var EXPANSION_RULES_1 = {
        '%c': '%a %b %d %H:%M:%S %Y',     // Replaced by the locale's appropriate date and time representation - e.g., Mon Aug  3 14:02:01 2013
        '%D': '%m/%d/%y',                 // Equivalent to %m / %d / %y
        '%F': '%Y-%m-%d',                 // Equivalent to %Y - %m - %d
        '%h': '%b',                       // Equivalent to %b
        '%r': '%I:%M:%S %p',              // Replaced by the time in a.m. and p.m. notation
        '%R': '%H:%M',                    // Replaced by the time in 24-hour notation
        '%T': '%H:%M:%S',                 // Replaced by the time
        '%x': '%m/%d/%y',                 // Replaced by the locale's appropriate date representation
        '%X': '%H:%M:%S',                 // Replaced by the locale's appropriate date representation
      };
      for (var rule in EXPANSION_RULES_1) {
        pattern = pattern.replace(new RegExp(rule, 'g'), EXPANSION_RULES_1[rule]);
      }
  
      var WEEKDAYS = ['Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday'];
      var MONTHS = ['January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December'];
  
      function leadingSomething(value, digits, character) {
        var str = typeof value === 'number' ? value.toString() : (value || '');
        while (str.length < digits) {
          str = character[0]+str;
        }
        return str;
      };
  
      function leadingNulls(value, digits) {
        return leadingSomething(value, digits, '0');
      };
  
      function compareByDay(date1, date2) {
        function sgn(value) {
          return value < 0 ? -1 : (value > 0 ? 1 : 0);
        };
  
        var compare;
        if ((compare = sgn(date1.getFullYear()-date2.getFullYear())) === 0) {
          if ((compare = sgn(date1.getMonth()-date2.getMonth())) === 0) {
            compare = sgn(date1.getDate()-date2.getDate());
          }
        }
        return compare;
      };
  
      function getFirstWeekStartDate(janFourth) {
          switch (janFourth.getDay()) {
            case 0: // Sunday
              return new Date(janFourth.getFullYear()-1, 11, 29);
            case 1: // Monday
              return janFourth;
            case 2: // Tuesday
              return new Date(janFourth.getFullYear(), 0, 3);
            case 3: // Wednesday
              return new Date(janFourth.getFullYear(), 0, 2);
            case 4: // Thursday
              return new Date(janFourth.getFullYear(), 0, 1);
            case 5: // Friday
              return new Date(janFourth.getFullYear()-1, 11, 31);
            case 6: // Saturday
              return new Date(janFourth.getFullYear()-1, 11, 30);
          }
      };
  
      function getWeekBasedYear(date) {
          var thisDate = __addDays(new Date(date.tm_year+1900, 0, 1), date.tm_yday);
  
          var janFourthThisYear = new Date(thisDate.getFullYear(), 0, 4);
          var janFourthNextYear = new Date(thisDate.getFullYear()+1, 0, 4);
  
          var firstWeekStartThisYear = getFirstWeekStartDate(janFourthThisYear);
          var firstWeekStartNextYear = getFirstWeekStartDate(janFourthNextYear);
  
          if (compareByDay(firstWeekStartThisYear, thisDate) <= 0) {
            // this date is after the start of the first week of this year
            if (compareByDay(firstWeekStartNextYear, thisDate) <= 0) {
              return thisDate.getFullYear()+1;
            } else {
              return thisDate.getFullYear();
            }
          } else { 
            return thisDate.getFullYear()-1;
          }
      };
  
      var EXPANSION_RULES_2 = {
        '%a': function(date) {
          return WEEKDAYS[date.tm_wday].substring(0,3);
        },
        '%A': function(date) {
          return WEEKDAYS[date.tm_wday];
        },
        '%b': function(date) {
          return MONTHS[date.tm_mon].substring(0,3);
        },
        '%B': function(date) {
          return MONTHS[date.tm_mon];
        },
        '%C': function(date) {
          var year = date.tm_year+1900;
          return leadingNulls(Math.floor(year/100),2);
        },
        '%d': function(date) {
          return leadingNulls(date.tm_mday, 2);
        },
        '%e': function(date) {
          return leadingSomething(date.tm_mday, 2, ' ');
        },
        '%g': function(date) {
          // %g, %G, and %V give values according to the ISO 8601:2000 standard week-based year. 
          // In this system, weeks begin on a Monday and week 1 of the year is the week that includes 
          // January 4th, which is also the week that includes the first Thursday of the year, and 
          // is also the first week that contains at least four days in the year. 
          // If the first Monday of January is the 2nd, 3rd, or 4th, the preceding days are part of 
          // the last week of the preceding year; thus, for Saturday 2nd January 1999, 
          // %G is replaced by 1998 and %V is replaced by 53. If December 29th, 30th, 
          // or 31st is a Monday, it and any following days are part of week 1 of the following year. 
          // Thus, for Tuesday 30th December 1997, %G is replaced by 1998 and %V is replaced by 01.
          
          return getWeekBasedYear(date).toString().substring(2);
        },
        '%G': function(date) {
          return getWeekBasedYear(date);
        },
        '%H': function(date) {
          return leadingNulls(date.tm_hour, 2);
        },
        '%I': function(date) {
          return leadingNulls(date.tm_hour < 13 ? date.tm_hour : date.tm_hour-12, 2);
        },
        '%j': function(date) {
          // Day of the year (001-366)
          return leadingNulls(date.tm_mday+__arraySum(__isLeapYear(date.tm_year+1900) ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR, date.tm_mon-1), 3);
        },
        '%m': function(date) {
          return leadingNulls(date.tm_mon+1, 2);
        },
        '%M': function(date) {
          return leadingNulls(date.tm_min, 2);
        },
        '%n': function() {
          return '\n';
        },
        '%p': function(date) {
          if (date.tm_hour > 0 && date.tm_hour < 13) {
            return 'AM';
          } else {
            return 'PM';
          }
        },
        '%S': function(date) {
          return leadingNulls(date.tm_sec, 2);
        },
        '%t': function() {
          return '\t';
        },
        '%u': function(date) {
          var day = new Date(date.tm_year+1900, date.tm_mon+1, date.tm_mday, 0, 0, 0, 0);
          return day.getDay() || 7;
        },
        '%U': function(date) {
          // Replaced by the week number of the year as a decimal number [00,53]. 
          // The first Sunday of January is the first day of week 1; 
          // days in the new year before this are in week 0. [ tm_year, tm_wday, tm_yday]
          var janFirst = new Date(date.tm_year+1900, 0, 1);
          var firstSunday = janFirst.getDay() === 0 ? janFirst : __addDays(janFirst, 7-janFirst.getDay());
          var endDate = new Date(date.tm_year+1900, date.tm_mon, date.tm_mday);
          
          // is target date after the first Sunday?
          if (compareByDay(firstSunday, endDate) < 0) {
            // calculate difference in days between first Sunday and endDate
            var februaryFirstUntilEndMonth = __arraySum(__isLeapYear(endDate.getFullYear()) ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR, endDate.getMonth()-1)-31;
            var firstSundayUntilEndJanuary = 31-firstSunday.getDate();
            var days = firstSundayUntilEndJanuary+februaryFirstUntilEndMonth+endDate.getDate();
            return leadingNulls(Math.ceil(days/7), 2);
          }
  
          return compareByDay(firstSunday, janFirst) === 0 ? '01': '00';
        },
        '%V': function(date) {
          // Replaced by the week number of the year (Monday as the first day of the week) 
          // as a decimal number [01,53]. If the week containing 1 January has four 
          // or more days in the new year, then it is considered week 1. 
          // Otherwise, it is the last week of the previous year, and the next week is week 1. 
          // Both January 4th and the first Thursday of January are always in week 1. [ tm_year, tm_wday, tm_yday]
          var janFourthThisYear = new Date(date.tm_year+1900, 0, 4);
          var janFourthNextYear = new Date(date.tm_year+1901, 0, 4);
  
          var firstWeekStartThisYear = getFirstWeekStartDate(janFourthThisYear);
          var firstWeekStartNextYear = getFirstWeekStartDate(janFourthNextYear);
  
          var endDate = __addDays(new Date(date.tm_year+1900, 0, 1), date.tm_yday);
  
          if (compareByDay(endDate, firstWeekStartThisYear) < 0) {
            // if given date is before this years first week, then it belongs to the 53rd week of last year
            return '53';
          } 
  
          if (compareByDay(firstWeekStartNextYear, endDate) <= 0) {
            // if given date is after next years first week, then it belongs to the 01th week of next year
            return '01';
          }
  
          // given date is in between CW 01..53 of this calendar year
          var daysDifference;
          if (firstWeekStartThisYear.getFullYear() < date.tm_year+1900) {
            // first CW of this year starts last year
            daysDifference = date.tm_yday+32-firstWeekStartThisYear.getDate()
          } else {
            // first CW of this year starts this year
            daysDifference = date.tm_yday+1-firstWeekStartThisYear.getDate();
          }
          return leadingNulls(Math.ceil(daysDifference/7), 2);
        },
        '%w': function(date) {
          var day = new Date(date.tm_year+1900, date.tm_mon+1, date.tm_mday, 0, 0, 0, 0);
          return day.getDay();
        },
        '%W': function(date) {
          // Replaced by the week number of the year as a decimal number [00,53]. 
          // The first Monday of January is the first day of week 1; 
          // days in the new year before this are in week 0. [ tm_year, tm_wday, tm_yday]
          var janFirst = new Date(date.tm_year, 0, 1);
          var firstMonday = janFirst.getDay() === 1 ? janFirst : __addDays(janFirst, janFirst.getDay() === 0 ? 1 : 7-janFirst.getDay()+1);
          var endDate = new Date(date.tm_year+1900, date.tm_mon, date.tm_mday);
  
          // is target date after the first Monday?
          if (compareByDay(firstMonday, endDate) < 0) {
            var februaryFirstUntilEndMonth = __arraySum(__isLeapYear(endDate.getFullYear()) ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR, endDate.getMonth()-1)-31;
            var firstMondayUntilEndJanuary = 31-firstMonday.getDate();
            var days = firstMondayUntilEndJanuary+februaryFirstUntilEndMonth+endDate.getDate();
            return leadingNulls(Math.ceil(days/7), 2);
          }
          return compareByDay(firstMonday, janFirst) === 0 ? '01': '00';
        },
        '%y': function(date) {
          // Replaced by the last two digits of the year as a decimal number [00,99]. [ tm_year]
          return (date.tm_year+1900).toString().substring(2);
        },
        '%Y': function(date) {
          // Replaced by the year as a decimal number (for example, 1997). [ tm_year]
          return date.tm_year+1900;
        },
        '%z': function(date) {
          // Replaced by the offset from UTC in the ISO 8601:2000 standard format ( +hhmm or -hhmm ),
          // or by no characters if no timezone is determinable. 
          // For example, "-0430" means 4 hours 30 minutes behind UTC (west of Greenwich). 
          // If tm_isdst is zero, the standard time offset is used. 
          // If tm_isdst is greater than zero, the daylight savings time offset is used. 
          // If tm_isdst is negative, no characters are returned. 
          // FIXME: we cannot determine time zone (or can we?)
          return '';
        },
        '%Z': function(date) {
          // Replaced by the timezone name or abbreviation, or by no bytes if no timezone information exists. [ tm_isdst]
          // FIXME: we cannot determine time zone (or can we?)
          return '';
        },
        '%%': function() {
          return '%';
        }
      };
      for (var rule in EXPANSION_RULES_2) {
        if (pattern.indexOf(rule) >= 0) {
          pattern = pattern.replace(new RegExp(rule, 'g'), EXPANSION_RULES_2[rule](date));
        }
      }
  
      var bytes = intArrayFromString(pattern, false);
      if (bytes.length > maxsize) {
        return 0;
      } 
  
      writeArrayToMemory(bytes, s);
      return bytes.length-1;
    }function _strftime_l(s, maxsize, format, tm) {
      return _strftime(s, maxsize, format, tm); // no locale support yet
    }

  
  
  function __parseInt64(str, endptr, base, min, max, unsign) {
      var isNegative = false;
      // Skip space.
      while (_isspace(HEAP8[(str)])) str++;
  
      // Check for a plus/minus sign.
      if (HEAP8[(str)] == 45) {
        str++;
        isNegative = true;
      } else if (HEAP8[(str)] == 43) {
        str++;
      }
  
      // Find base.
      var ok = false;
      var finalBase = base;
      if (!finalBase) {
        if (HEAP8[(str)] == 48) {
          if (HEAP8[((str+1)|0)] == 120 ||
              HEAP8[((str+1)|0)] == 88) {
            finalBase = 16;
            str += 2;
          } else {
            finalBase = 8;
            ok = true; // we saw an initial zero, perhaps the entire thing is just "0"
          }
        }
      } else if (finalBase==16) {
        if (HEAP8[(str)] == 48) {
          if (HEAP8[((str+1)|0)] == 120 ||
              HEAP8[((str+1)|0)] == 88) {
            str += 2;
          }
        }
      }
      if (!finalBase) finalBase = 10;
      var start = str;
  
      // Get digits.
      var chr;
      while ((chr = HEAP8[(str)]) != 0) {
        var digit = parseInt(String.fromCharCode(chr), finalBase);
        if (isNaN(digit)) {
          break;
        } else {
          str++;
          ok = true;
        }
      }
  
      if (!ok) {
        ___setErrNo(ERRNO_CODES.EINVAL);
        return tempRet0 = 0,0;
      }
  
      // Set end pointer.
      if (endptr) {
        HEAP32[((endptr)>>2)]=str;
      }
  
      try {
        var numberString = isNegative ? '-'+Pointer_stringify(start, str - start) : Pointer_stringify(start, str - start);
        i64Math.fromString(numberString, finalBase, min, max, unsign);
      } catch(e) {
        ___setErrNo(ERRNO_CODES.ERANGE); // not quite correct
      }
  
      return tempRet0 = HEAP32[(((tempDoublePtr)+(4))>>2)],HEAP32[((tempDoublePtr)>>2)];
    }function _strtoull(str, endptr, base) {
      return __parseInt64(str, endptr, base, 0, '18446744073709551615', true);  // ULONG_MAX.
    }function _strtoull_l(str, endptr, base) {
      return _strtoull(str, endptr, base); // no locale support yet
    }

  
  function _strtoll(str, endptr, base) {
      return __parseInt64(str, endptr, base, '-9223372036854775808', '9223372036854775807');  // LLONG_MIN, LLONG_MAX.
    }function _strtoll_l(str, endptr, base) {
      return _strtoll(str, endptr, base); // no locale support yet
    }

  function _uselocale(locale) {
      return 0;
    }

  var _llvm_va_start=undefined;

  
  function _asprintf(s, format, varargs) {
      return _sprintf(-s, format, varargs);
    }function _vasprintf(s, format, va_arg) {
      return _asprintf(s, format, HEAP32[((va_arg)>>2)]);
    }

  function _llvm_va_end() {}

  function _vsnprintf(s, n, format, va_arg) {
      return _snprintf(s, n, format, HEAP32[((va_arg)>>2)]);
    }

  function _vsscanf(s, format, va_arg) {
      return _sscanf(s, format, HEAP32[((va_arg)>>2)]);
    }


  var _fabs=Math_abs;

  function _sbrk(bytes) {
      // Implement a Linux-like 'memory area' for our 'process'.
      // Changes the size of the memory area by |bytes|; returns the
      // address of the previous top ('break') of the memory area
      // We control the "dynamic" memory - DYNAMIC_BASE to DYNAMICTOP
      var self = _sbrk;
      if (!self.called) {
        DYNAMICTOP = alignMemoryPage(DYNAMICTOP); // make sure we start out aligned
        self.called = true;
        assert(Runtime.dynamicAlloc);
        self.alloc = Runtime.dynamicAlloc;
        Runtime.dynamicAlloc = function() { abort('cannot dynamically allocate, sbrk now has control') };
      }
      var ret = DYNAMICTOP;
      if (bytes != 0) self.alloc(bytes);
      return ret;  // Previous break location.
    }

  function _time(ptr) {
      var ret = Math.floor(Date.now()/1000);
      if (ptr) {
        HEAP32[((ptr)>>2)]=ret;
      }
      return ret;
    }

  
  function _copysign(a, b) {
      return __reallyNegative(a) === __reallyNegative(b) ? a : -a;
    }var _copysignl=_copysign;

  
  function _fmod(x, y) {
      return x % y;
    }var _fmodl=_fmod;






  var Browser={mainLoop:{scheduler:null,method:"",shouldPause:false,paused:false,queue:[],pause:function () {
          Browser.mainLoop.shouldPause = true;
        },resume:function () {
          if (Browser.mainLoop.paused) {
            Browser.mainLoop.paused = false;
            Browser.mainLoop.scheduler();
          }
          Browser.mainLoop.shouldPause = false;
        },updateStatus:function () {
          if (Module['setStatus']) {
            var message = Module['statusMessage'] || 'Please wait...';
            var remaining = Browser.mainLoop.remainingBlockers;
            var expected = Browser.mainLoop.expectedBlockers;
            if (remaining) {
              if (remaining < expected) {
                Module['setStatus'](message + ' (' + (expected - remaining) + '/' + expected + ')');
              } else {
                Module['setStatus'](message);
              }
            } else {
              Module['setStatus']('');
            }
          }
        }},isFullScreen:false,pointerLock:false,moduleContextCreatedCallbacks:[],workers:[],init:function () {
        if (!Module["preloadPlugins"]) Module["preloadPlugins"] = []; // needs to exist even in workers
  
        if (Browser.initted || ENVIRONMENT_IS_WORKER) return;
        Browser.initted = true;
  
        try {
          new Blob();
          Browser.hasBlobConstructor = true;
        } catch(e) {
          Browser.hasBlobConstructor = false;
          console.log("warning: no blob constructor, cannot create blobs with mimetypes");
        }
        Browser.BlobBuilder = typeof MozBlobBuilder != "undefined" ? MozBlobBuilder : (typeof WebKitBlobBuilder != "undefined" ? WebKitBlobBuilder : (!Browser.hasBlobConstructor ? console.log("warning: no BlobBuilder") : null));
        Browser.URLObject = typeof window != "undefined" ? (window.URL ? window.URL : window.webkitURL) : undefined;
        if (!Module.noImageDecoding && typeof Browser.URLObject === 'undefined') {
          console.log("warning: Browser does not support creating object URLs. Built-in browser image decoding will not be available.");
          Module.noImageDecoding = true;
        }
  
        // Support for plugins that can process preloaded files. You can add more of these to
        // your app by creating and appending to Module.preloadPlugins.
        //
        // Each plugin is asked if it can handle a file based on the file's name. If it can,
        // it is given the file's raw data. When it is done, it calls a callback with the file's
        // (possibly modified) data. For example, a plugin might decompress a file, or it
        // might create some side data structure for use later (like an Image element, etc.).
  
        var imagePlugin = {};
        imagePlugin['canHandle'] = function imagePlugin_canHandle(name) {
          return !Module.noImageDecoding && /\.(jpg|jpeg|png|bmp)$/i.test(name);
        };
        imagePlugin['handle'] = function imagePlugin_handle(byteArray, name, onload, onerror) {
          var b = null;
          if (Browser.hasBlobConstructor) {
            try {
              b = new Blob([byteArray], { type: Browser.getMimetype(name) });
              if (b.size !== byteArray.length) { // Safari bug #118630
                // Safari's Blob can only take an ArrayBuffer
                b = new Blob([(new Uint8Array(byteArray)).buffer], { type: Browser.getMimetype(name) });
              }
            } catch(e) {
              Runtime.warnOnce('Blob constructor present but fails: ' + e + '; falling back to blob builder');
            }
          }
          if (!b) {
            var bb = new Browser.BlobBuilder();
            bb.append((new Uint8Array(byteArray)).buffer); // we need to pass a buffer, and must copy the array to get the right data range
            b = bb.getBlob();
          }
          var url = Browser.URLObject.createObjectURL(b);
          assert(typeof url == 'string', 'createObjectURL must return a url as a string');
          var img = new Image();
          img.onload = function img_onload() {
            assert(img.complete, 'Image ' + name + ' could not be decoded');
            var canvas = document.createElement('canvas');
            canvas.width = img.width;
            canvas.height = img.height;
            var ctx = canvas.getContext('2d');
            ctx.drawImage(img, 0, 0);
            Module["preloadedImages"][name] = canvas;
            Browser.URLObject.revokeObjectURL(url);
            if (onload) onload(byteArray);
          };
          img.onerror = function img_onerror(event) {
            console.log('Image ' + url + ' could not be decoded');
            if (onerror) onerror();
          };
          img.src = url;
        };
        Module['preloadPlugins'].push(imagePlugin);
  
        var audioPlugin = {};
        audioPlugin['canHandle'] = function audioPlugin_canHandle(name) {
          return !Module.noAudioDecoding && name.substr(-4) in { '.ogg': 1, '.wav': 1, '.mp3': 1 };
        };
        audioPlugin['handle'] = function audioPlugin_handle(byteArray, name, onload, onerror) {
          var done = false;
          function finish(audio) {
            if (done) return;
            done = true;
            Module["preloadedAudios"][name] = audio;
            if (onload) onload(byteArray);
          }
          function fail() {
            if (done) return;
            done = true;
            Module["preloadedAudios"][name] = new Audio(); // empty shim
            if (onerror) onerror();
          }
          if (Browser.hasBlobConstructor) {
            try {
              var b = new Blob([byteArray], { type: Browser.getMimetype(name) });
            } catch(e) {
              return fail();
            }
            var url = Browser.URLObject.createObjectURL(b); // XXX we never revoke this!
            assert(typeof url == 'string', 'createObjectURL must return a url as a string');
            var audio = new Audio();
            audio.addEventListener('canplaythrough', function() { finish(audio) }, false); // use addEventListener due to chromium bug 124926
            audio.onerror = function audio_onerror(event) {
              if (done) return;
              console.log('warning: browser could not fully decode audio ' + name + ', trying slower base64 approach');
              function encode64(data) {
                var BASE = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/';
                var PAD = '=';
                var ret = '';
                var leftchar = 0;
                var leftbits = 0;
                for (var i = 0; i < data.length; i++) {
                  leftchar = (leftchar << 8) | data[i];
                  leftbits += 8;
                  while (leftbits >= 6) {
                    var curr = (leftchar >> (leftbits-6)) & 0x3f;
                    leftbits -= 6;
                    ret += BASE[curr];
                  }
                }
                if (leftbits == 2) {
                  ret += BASE[(leftchar&3) << 4];
                  ret += PAD + PAD;
                } else if (leftbits == 4) {
                  ret += BASE[(leftchar&0xf) << 2];
                  ret += PAD;
                }
                return ret;
              }
              audio.src = 'data:audio/x-' + name.substr(-3) + ';base64,' + encode64(byteArray);
              finish(audio); // we don't wait for confirmation this worked - but it's worth trying
            };
            audio.src = url;
            // workaround for chrome bug 124926 - we do not always get oncanplaythrough or onerror
            Browser.safeSetTimeout(function() {
              finish(audio); // try to use it even though it is not necessarily ready to play
            }, 10000);
          } else {
            return fail();
          }
        };
        Module['preloadPlugins'].push(audioPlugin);
  
        // Canvas event setup
  
        var canvas = Module['canvas'];
        canvas.requestPointerLock = canvas['requestPointerLock'] ||
                                    canvas['mozRequestPointerLock'] ||
                                    canvas['webkitRequestPointerLock'];
        canvas.exitPointerLock = document['exitPointerLock'] ||
                                 document['mozExitPointerLock'] ||
                                 document['webkitExitPointerLock'] ||
                                 function(){}; // no-op if function does not exist
        canvas.exitPointerLock = canvas.exitPointerLock.bind(document);
  
        function pointerLockChange() {
          Browser.pointerLock = document['pointerLockElement'] === canvas ||
                                document['mozPointerLockElement'] === canvas ||
                                document['webkitPointerLockElement'] === canvas;
        }
  
        document.addEventListener('pointerlockchange', pointerLockChange, false);
        document.addEventListener('mozpointerlockchange', pointerLockChange, false);
        document.addEventListener('webkitpointerlockchange', pointerLockChange, false);
  
        if (Module['elementPointerLock']) {
          canvas.addEventListener("click", function(ev) {
            if (!Browser.pointerLock && canvas.requestPointerLock) {
              canvas.requestPointerLock();
              ev.preventDefault();
            }
          }, false);
        }
      },createContext:function (canvas, useWebGL, setInModule, webGLContextAttributes) {
        var ctx;
        var errorInfo = '?';
        function onContextCreationError(event) {
          errorInfo = event.statusMessage || errorInfo;
        }
        try {
          if (useWebGL) {
            var contextAttributes = {
              antialias: false,
              alpha: false
            };
  
            if (webGLContextAttributes) {
              for (var attribute in webGLContextAttributes) {
                contextAttributes[attribute] = webGLContextAttributes[attribute];
              }
            }
  
  
            canvas.addEventListener('webglcontextcreationerror', onContextCreationError, false);
            try {
              ['experimental-webgl', 'webgl'].some(function(webglId) {
                return ctx = canvas.getContext(webglId, contextAttributes);
              });
            } finally {
              canvas.removeEventListener('webglcontextcreationerror', onContextCreationError, false);
            }
          } else {
            ctx = canvas.getContext('2d');
          }
          if (!ctx) throw ':(';
        } catch (e) {
          Module.print('Could not create canvas: ' + [errorInfo, e]);
          return null;
        }
        if (useWebGL) {
          // Set the background of the WebGL canvas to black
          canvas.style.backgroundColor = "black";
  
          // Warn on context loss
          canvas.addEventListener('webglcontextlost', function(event) {
            alert('WebGL context lost. You will need to reload the page.');
          }, false);
        }
        if (setInModule) {
          GLctx = Module.ctx = ctx;
          Module.useWebGL = useWebGL;
          Browser.moduleContextCreatedCallbacks.forEach(function(callback) { callback() });
          Browser.init();
        }
        return ctx;
      },destroyContext:function (canvas, useWebGL, setInModule) {},fullScreenHandlersInstalled:false,lockPointer:undefined,resizeCanvas:undefined,requestFullScreen:function (lockPointer, resizeCanvas) {
        Browser.lockPointer = lockPointer;
        Browser.resizeCanvas = resizeCanvas;
        if (typeof Browser.lockPointer === 'undefined') Browser.lockPointer = true;
        if (typeof Browser.resizeCanvas === 'undefined') Browser.resizeCanvas = false;
  
        var canvas = Module['canvas'];
        function fullScreenChange() {
          Browser.isFullScreen = false;
          if ((document['webkitFullScreenElement'] || document['webkitFullscreenElement'] ||
               document['mozFullScreenElement'] || document['mozFullscreenElement'] ||
               document['fullScreenElement'] || document['fullscreenElement']) === canvas) {
            canvas.cancelFullScreen = document['cancelFullScreen'] ||
                                      document['mozCancelFullScreen'] ||
                                      document['webkitCancelFullScreen'];
            canvas.cancelFullScreen = canvas.cancelFullScreen.bind(document);
            if (Browser.lockPointer) canvas.requestPointerLock();
            Browser.isFullScreen = true;
            if (Browser.resizeCanvas) Browser.setFullScreenCanvasSize();
          } else if (Browser.resizeCanvas){
            Browser.setWindowedCanvasSize();
          }
          if (Module['onFullScreen']) Module['onFullScreen'](Browser.isFullScreen);
        }
  
        if (!Browser.fullScreenHandlersInstalled) {
          Browser.fullScreenHandlersInstalled = true;
          document.addEventListener('fullscreenchange', fullScreenChange, false);
          document.addEventListener('mozfullscreenchange', fullScreenChange, false);
          document.addEventListener('webkitfullscreenchange', fullScreenChange, false);
        }
  
        canvas.requestFullScreen = canvas['requestFullScreen'] ||
                                   canvas['mozRequestFullScreen'] ||
                                   (canvas['webkitRequestFullScreen'] ? function() { canvas['webkitRequestFullScreen'](Element['ALLOW_KEYBOARD_INPUT']) } : null);
        canvas.requestFullScreen();
      },requestAnimationFrame:function requestAnimationFrame(func) {
        if (typeof window === 'undefined') { // Provide fallback to setTimeout if window is undefined (e.g. in Node.js)
          setTimeout(func, 1000/60);
        } else {
          if (!window.requestAnimationFrame) {
            window.requestAnimationFrame = window['requestAnimationFrame'] ||
                                           window['mozRequestAnimationFrame'] ||
                                           window['webkitRequestAnimationFrame'] ||
                                           window['msRequestAnimationFrame'] ||
                                           window['oRequestAnimationFrame'] ||
                                           window['setTimeout'];
          }
          window.requestAnimationFrame(func);
        }
      },safeCallback:function (func) {
        return function() {
          if (!ABORT) return func.apply(null, arguments);
        };
      },safeRequestAnimationFrame:function (func) {
        return Browser.requestAnimationFrame(function() {
          if (!ABORT) func();
        });
      },safeSetTimeout:function (func, timeout) {
        return setTimeout(function() {
          if (!ABORT) func();
        }, timeout);
      },safeSetInterval:function (func, timeout) {
        return setInterval(function() {
          if (!ABORT) func();
        }, timeout);
      },getMimetype:function (name) {
        return {
          'jpg': 'image/jpeg',
          'jpeg': 'image/jpeg',
          'png': 'image/png',
          'bmp': 'image/bmp',
          'ogg': 'audio/ogg',
          'wav': 'audio/wav',
          'mp3': 'audio/mpeg'
        }[name.substr(name.lastIndexOf('.')+1)];
      },getUserMedia:function (func) {
        if(!window.getUserMedia) {
          window.getUserMedia = navigator['getUserMedia'] ||
                                navigator['mozGetUserMedia'];
        }
        window.getUserMedia(func);
      },getMovementX:function (event) {
        return event['movementX'] ||
               event['mozMovementX'] ||
               event['webkitMovementX'] ||
               0;
      },getMovementY:function (event) {
        return event['movementY'] ||
               event['mozMovementY'] ||
               event['webkitMovementY'] ||
               0;
      },getMouseWheelDelta:function (event) {
        return Math.max(-1, Math.min(1, event.type === 'DOMMouseScroll' ? event.detail : -event.wheelDelta));
      },mouseX:0,mouseY:0,mouseMovementX:0,mouseMovementY:0,calculateMouseEvent:function (event) { // event should be mousemove, mousedown or mouseup
        if (Browser.pointerLock) {
          // When the pointer is locked, calculate the coordinates
          // based on the movement of the mouse.
          // Workaround for Firefox bug 764498
          if (event.type != 'mousemove' &&
              ('mozMovementX' in event)) {
            Browser.mouseMovementX = Browser.mouseMovementY = 0;
          } else {
            Browser.mouseMovementX = Browser.getMovementX(event);
            Browser.mouseMovementY = Browser.getMovementY(event);
          }
          
          // check if SDL is available
          if (typeof SDL != "undefined") {
          	Browser.mouseX = SDL.mouseX + Browser.mouseMovementX;
          	Browser.mouseY = SDL.mouseY + Browser.mouseMovementY;
          } else {
          	// just add the mouse delta to the current absolut mouse position
          	// FIXME: ideally this should be clamped against the canvas size and zero
          	Browser.mouseX += Browser.mouseMovementX;
          	Browser.mouseY += Browser.mouseMovementY;
          }        
        } else {
          // Otherwise, calculate the movement based on the changes
          // in the coordinates.
          var rect = Module["canvas"].getBoundingClientRect();
          var x, y;
          
          // Neither .scrollX or .pageXOffset are defined in a spec, but
          // we prefer .scrollX because it is currently in a spec draft.
          // (see: http://www.w3.org/TR/2013/WD-cssom-view-20131217/)
          var scrollX = ((typeof window.scrollX !== 'undefined') ? window.scrollX : window.pageXOffset);
          var scrollY = ((typeof window.scrollY !== 'undefined') ? window.scrollY : window.pageYOffset);
          // If this assert lands, it's likely because the browser doesn't support scrollX or pageXOffset
          // and we have no viable fallback.
          assert((typeof scrollX !== 'undefined') && (typeof scrollY !== 'undefined'), 'Unable to retrieve scroll position, mouse positions likely broken.');
          if (event.type == 'touchstart' ||
              event.type == 'touchend' ||
              event.type == 'touchmove') {
            var t = event.touches.item(0);
            if (t) {
              x = t.pageX - (scrollX + rect.left);
              y = t.pageY - (scrollY + rect.top);
            } else {
              return;
            }
          } else {
            x = event.pageX - (scrollX + rect.left);
            y = event.pageY - (scrollY + rect.top);
          }
  
          // the canvas might be CSS-scaled compared to its backbuffer;
          // SDL-using content will want mouse coordinates in terms
          // of backbuffer units.
          var cw = Module["canvas"].width;
          var ch = Module["canvas"].height;
          x = x * (cw / rect.width);
          y = y * (ch / rect.height);
  
          Browser.mouseMovementX = x - Browser.mouseX;
          Browser.mouseMovementY = y - Browser.mouseY;
          Browser.mouseX = x;
          Browser.mouseY = y;
        }
      },xhrLoad:function (url, onload, onerror) {
        var xhr = new XMLHttpRequest();
        xhr.open('GET', url, true);
        xhr.responseType = 'arraybuffer';
        xhr.onload = function xhr_onload() {
          if (xhr.status == 200 || (xhr.status == 0 && xhr.response)) { // file URLs can return 0
            onload(xhr.response);
          } else {
            onerror();
          }
        };
        xhr.onerror = onerror;
        xhr.send(null);
      },asyncLoad:function (url, onload, onerror, noRunDep) {
        Browser.xhrLoad(url, function(arrayBuffer) {
          assert(arrayBuffer, 'Loading data file "' + url + '" failed (no arrayBuffer).');
          onload(new Uint8Array(arrayBuffer));
          if (!noRunDep) removeRunDependency('al ' + url);
        }, function(event) {
          if (onerror) {
            onerror();
          } else {
            throw 'Loading data file "' + url + '" failed.';
          }
        });
        if (!noRunDep) addRunDependency('al ' + url);
      },resizeListeners:[],updateResizeListeners:function () {
        var canvas = Module['canvas'];
        Browser.resizeListeners.forEach(function(listener) {
          listener(canvas.width, canvas.height);
        });
      },setCanvasSize:function (width, height, noUpdates) {
        var canvas = Module['canvas'];
        canvas.width = width;
        canvas.height = height;
        if (!noUpdates) Browser.updateResizeListeners();
      },windowedWidth:0,windowedHeight:0,setFullScreenCanvasSize:function () {
        var canvas = Module['canvas'];
        this.windowedWidth = canvas.width;
        this.windowedHeight = canvas.height;
        canvas.width = screen.width;
        canvas.height = screen.height;
        // check if SDL is available   
        if (typeof SDL != "undefined") {
        	var flags = HEAPU32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)];
        	flags = flags | 0x00800000; // set SDL_FULLSCREEN flag
        	HEAP32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)]=flags
        }
        Browser.updateResizeListeners();
      },setWindowedCanvasSize:function () {
        var canvas = Module['canvas'];
        canvas.width = this.windowedWidth;
        canvas.height = this.windowedHeight;
        // check if SDL is available       
        if (typeof SDL != "undefined") {
        	var flags = HEAPU32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)];
        	flags = flags & ~0x00800000; // clear SDL_FULLSCREEN flag
        	HEAP32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)]=flags
        }
        Browser.updateResizeListeners();
      }};
___errno_state = Runtime.staticAlloc(4); HEAP32[((___errno_state)>>2)]=0;
FS.staticInit();__ATINIT__.unshift({ func: function() { if (!Module["noFSInit"] && !FS.init.initialized) FS.init() } });__ATMAIN__.push({ func: function() { FS.ignorePermissions = false } });__ATEXIT__.push({ func: function() { FS.quit() } });Module["FS_createFolder"] = FS.createFolder;Module["FS_createPath"] = FS.createPath;Module["FS_createDataFile"] = FS.createDataFile;Module["FS_createPreloadedFile"] = FS.createPreloadedFile;Module["FS_createLazyFile"] = FS.createLazyFile;Module["FS_createLink"] = FS.createLink;Module["FS_createDevice"] = FS.createDevice;
__ATINIT__.unshift({ func: function() { TTY.init() } });__ATEXIT__.push({ func: function() { TTY.shutdown() } });TTY.utf8 = new Runtime.UTF8Processor();
if (ENVIRONMENT_IS_NODE) { var fs = require("fs"); NODEFS.staticInit(); }
__ATINIT__.push({ func: function() { SOCKFS.root = FS.mount(SOCKFS, {}, null); } });
_fgetc.ret = allocate([0], "i8", ALLOC_STATIC);
Module["requestFullScreen"] = function Module_requestFullScreen(lockPointer, resizeCanvas) { Browser.requestFullScreen(lockPointer, resizeCanvas) };
  Module["requestAnimationFrame"] = function Module_requestAnimationFrame(func) { Browser.requestAnimationFrame(func) };
  Module["setCanvasSize"] = function Module_setCanvasSize(width, height, noUpdates) { Browser.setCanvasSize(width, height, noUpdates) };
  Module["pauseMainLoop"] = function Module_pauseMainLoop() { Browser.mainLoop.pause() };
  Module["resumeMainLoop"] = function Module_resumeMainLoop() { Browser.mainLoop.resume() };
  Module["getUserMedia"] = function Module_getUserMedia() { Browser.getUserMedia() }
STACK_BASE = STACKTOP = Runtime.alignMemory(STATICTOP);

staticSealed = true; // seal the static portion of memory

STACK_MAX = STACK_BASE + 5242880;

DYNAMIC_BASE = DYNAMICTOP = Runtime.alignMemory(STACK_MAX);

assert(DYNAMIC_BASE < TOTAL_MEMORY, "TOTAL_MEMORY not big enough for stack");



var FUNCTION_TABLE = [0,0,__ZNSt3__18messagesIwED0Ev,0,__ZNSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEED0Ev,0,__ZNKSt3__18numpunctIcE12do_falsenameEv,0,__ZNSt3__14endlIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_,0,__ZNKSt3__120__time_get_c_storageIwE3__rEv,0,__ZNKSt3__110moneypunctIwLb0EE16do_thousands_sepEv,0,__ZNSt11logic_errorD2Ev,0,__ZNSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEED1Ev,0,__ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE11do_get_yearES4_S4_RNS_8ios_baseERjP2tm,0,__ZNSt12length_errorD0Ev,0,__ZNSt3__115basic_streambufIcNS_11char_traitsIcEEED1Ev,0,__ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE11do_get_timeES4_S4_RNS_8ios_baseERjP2tm,0,__ZNSt3__17codecvtIwc11__mbstate_tED2Ev,0,__ZNSt3__16locale2id6__initEv,0,__ZNSt3__110__stdinbufIcED1Ev,0,__ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE14do_get_weekdayES4_S4_RNS_8ios_baseERjP2tm,0,__ZNSt3__110__stdinbufIcE9pbackfailEi,0,__ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE9underflowEv,0,__ZNSt3__110__stdinbufIwED0Ev,0,__ZNSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEED0Ev,0,__ZNSt11logic_errorD0Ev,0,__ZNSt3__17codecvtIDsc11__mbstate_tED0Ev,0,__ZNSt13runtime_errorD2Ev,0,__ZNKSt3__17collateIcE7do_hashEPKcS3_,0,__ZNKSt3__17codecvtIcc11__mbstate_tE16do_always_noconvEv,0,__ZNKSt3__120__time_get_c_storageIwE8__monthsEv,0,__ZNSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEED0Ev,0,__ZNKSt3__19money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_bRNS_8ios_baseEwRKNS_12basic_stringIwS3_NS_9allocatorIwEEEE,0,__ZNSt12out_of_rangeD0Ev,0,__ZNKSt3__110moneypunctIwLb1EE16do_positive_signEv,0,__ZNKSt3__15ctypeIwE10do_tolowerEPwPKw,0,__ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE5uflowEv,0,__ZNSt3__17collateIcED1Ev,0,__ZNSt3__18ios_base7failureD2Ev,0,__ZNK10__cxxabiv121__vmi_class_type_info16search_above_dstEPNS_19__dynamic_cast_infoEPKvS4_ib,0,__ZNSt9bad_allocD2Ev,0,__ZNKSt3__110moneypunctIcLb1EE11do_groupingEv,0,__ZNSt11logic_errorD2Ev,0,__ZNSt3__16locale5facetD0Ev,0,__ZNKSt3__17codecvtIwc11__mbstate_tE6do_outERS1_PKwS5_RS5_PcS7_RS7_,0,__ZNKSt3__120__time_get_c_storageIwE3__cEv,0,__ZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwy,0,__ZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwx,0,__ZNSt3__15ctypeIcED0Ev,0,__ZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwm,0,__ZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwl,0,__ZNSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEED1Ev,0,__ZNSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEED1Ev,0,__ZNSt8bad_castC2Ev,0,__ZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwe,0,__ZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwd,0,__ZNKSt3__110moneypunctIcLb1EE16do_decimal_pointEv,0,__ZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwb,0,__ZNK10__cxxabiv120__si_class_type_info16search_above_dstEPNS_19__dynamic_cast_infoEPKvS4_ib,0,__ZNKSt3__19money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_bRNS_8ios_baseEcRKNS_12basic_stringIcS3_NS_9allocatorIcEEEE,0,__ZNSt3__113basic_ostreamIwNS_11char_traitsIwEEED1Ev,0,__ZNKSt3__17codecvtIDsc11__mbstate_tE5do_inERS1_PKcS5_RS5_PDsS7_RS7_,0,__ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE13do_date_orderEv,0,__ZNSt3__18messagesIcED1Ev,0,__ZNKSt3__120__time_get_c_storageIwE7__weeksEv,0,__ZNKSt3__18numpunctIwE11do_groupingEv,0,__ZNSt3__16locale5facet16__on_zero_sharedEv,0,__ZNKSt3__15ctypeIwE8do_widenEc,0,__ZNKSt3__18time_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwPK2tmcc,0,__ZNSt3__110__stdinbufIcE5uflowEv,0,__ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE9pbackfailEj,0,__ZNSt3__113basic_filebufIcNS_11char_traitsIcEEE7seekposENS_4fposI11__mbstate_tEEj,0,__ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE11do_get_timeES4_S4_RNS_8ios_baseERjP2tm,0,__ZTv0_n12_NSt3__113basic_istreamIcNS_11char_traitsIcEEED0Ev,0,__ZNSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEED1Ev,0,__ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE5uflowEv,0,__ZNKSt3__110moneypunctIwLb0EE13do_neg_formatEv,0,__ZNKSt3__15ctypeIcE8do_widenEc,0,__ZNSt3__110moneypunctIwLb0EED0Ev,0,__ZNSt3__16locale5__impD2Ev,0,__ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE9underflowEv,0,__ZNKSt3__15ctypeIcE10do_toupperEc,0,__ZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwPKv,0,__ZNKSt3__17codecvtIDic11__mbstate_tE11do_encodingEv,0,__ZNSt3__18numpunctIcED2Ev,0,__ZNKSt3__18numpunctIcE11do_groupingEv,0,__ZNK10__cxxabiv116__shim_type_info5noop1Ev,0,__ZNSt3__113basic_filebufIcNS_11char_traitsIcEEED0Ev,0,__ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE16do_get_monthnameES4_S4_RNS_8ios_baseERjP2tm,0,__ZNKSt3__120__time_get_c_storageIwE3__xEv,0,__ZNKSt3__110moneypunctIcLb1EE13do_neg_formatEv,0,__ZNSt3__110__stdinbufIwE9pbackfailEj,0,__ZNKSt3__18time_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcPK2tmcc,0,__ZNSt3__18numpunctIcED0Ev,0,__ZNSt3__111__stdoutbufIcE8overflowEi,0,__ZNSt3__119__iostream_categoryD1Ev,0,__ZNKSt3__120__time_get_c_storageIwE7__am_pmEv,0,__ZNSt3__111__stdoutbufIwE5imbueERKNS_6localeE,0,__ZNKSt3__18messagesIcE8do_closeEi,0,__ZNKSt3__15ctypeIwE5do_isEPKwS3_Pt,0,__ZNSt13runtime_errorD2Ev,0,__ZNKSt3__15ctypeIwE10do_toupperEw,0,__ZNKSt3__15ctypeIwE9do_narrowEPKwS3_cPc,0,__ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE5imbueERKNS_6localeE,0,__ZNKSt3__110moneypunctIcLb0EE16do_negative_signEv,0,__ZNSt3__17collateIwED1Ev,0,__ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE16do_get_monthnameES4_S4_RNS_8ios_baseERjP2tm,0,__ZNK10__cxxabiv117__class_type_info9can_catchEPKNS_16__shim_type_infoERPv,0,__ZNKSt8bad_cast4whatEv,0,__ZNSt3__110moneypunctIcLb0EED1Ev,0,__ZNKSt3__18messagesIcE6do_getEiiiRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE,0,__ZNSt3__18numpunctIwED2Ev,0,__ZNKSt3__110moneypunctIwLb1EE13do_pos_formatEv,0,__ZNSt3__15ctypeIwED0Ev,0,__ZNKSt13runtime_error4whatEv,0,_free,0,__ZN10__cxxabiv117__class_type_infoD0Ev,0,__ZNSt3__19money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEED0Ev,0,__ZNSt3__117__widen_from_utf8ILj32EED0Ev,0,__ZNKSt3__18numpunctIwE16do_thousands_sepEv,0,__ZTv0_n12_NSt3__114basic_ofstreamIcNS_11char_traitsIcEEED1Ev,0,__ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjP2tmcc,0,__ZNSt3__113basic_istreamIwNS_11char_traitsIwEEED1Ev,0,__ZNKSt3__17codecvtIDsc11__mbstate_tE10do_unshiftERS1_PcS4_RS4_,0,__ZNKSt3__18numpunctIcE16do_decimal_pointEv,0,__ZNKSt3__110moneypunctIwLb0EE16do_negative_signEv,0,__ZNK10__cxxabiv120__si_class_type_info16search_below_dstEPNS_19__dynamic_cast_infoEPKvib,0,__ZNKSt3__120__time_get_c_storageIcE3__xEv,0,__ZNSt3__17collateIwED0Ev,0,__ZNKSt3__110moneypunctIcLb0EE16do_positive_signEv,0,__ZNSt3__18time_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEED0Ev,0,__ZNKSt3__17codecvtIDsc11__mbstate_tE6do_outERS1_PKDsS5_RS5_PcS7_RS7_,0,__ZNSt11logic_errorD2Ev,0,__ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE7seekoffExNS_8ios_base7seekdirEj,0,__ZNSt3__117__call_once_proxyINS_5tupleIJNS_12_GLOBAL__N_111__fake_bindEEEEEEvPv,0,__ZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcy,0,__ZNSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEED1Ev,0,__ZNSt3__113basic_filebufIcNS_11char_traitsIcEEE4syncEv,0,__ZNKSt3__18numpunctIwE16do_decimal_pointEv,0,__ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE4syncEv,0,__ZNK10__cxxabiv117__class_type_info16search_below_dstEPNS_19__dynamic_cast_infoEPKvib,0,__ZNKSt3__17codecvtIcc11__mbstate_tE11do_encodingEv,0,__ZNKSt3__110moneypunctIcLb0EE11do_groupingEv,0,__ZNK10__cxxabiv120__si_class_type_info27has_unambiguous_public_baseEPNS_19__dynamic_cast_infoEPvi,0,__ZNKSt3__110moneypunctIwLb1EE14do_frac_digitsEv,0,__ZNSt3__17codecvtIDic11__mbstate_tED0Ev,0,__ZNKSt3__110moneypunctIwLb1EE16do_negative_signEv,0,__ZNK10__cxxabiv121__vmi_class_type_info27has_unambiguous_public_baseEPNS_19__dynamic_cast_infoEPvi,0,__ZNKSt3__120__time_get_c_storageIcE3__XEv,0,__ZNSt3__16localeC2ERKS0_,0,__ZNKSt3__15ctypeIwE9do_narrowEwc,0,__ZNSt3__114basic_ofstreamIcNS_11char_traitsIcEEED0Ev,0,__ZNSt3__111__stdoutbufIwE4syncEv,0,__ZNSt3__110moneypunctIwLb0EED1Ev,0,__ZNSt3__113basic_istreamIcNS_11char_traitsIcEEED1Ev,0,__ZTv0_n12_NSt3__113basic_ostreamIcNS_11char_traitsIcEEED1Ev,0,__ZNSt3__18time_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEED0Ev,0,__ZNSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEED0Ev,0,__ZNKSt3__17collateIwE7do_hashEPKwS3_,0,__ZNKSt3__110moneypunctIwLb1EE11do_groupingEv,0,__ZNSt3__111__stdoutbufIcE5imbueERKNS_6localeE,0,__ZNKSt3__110moneypunctIcLb1EE16do_thousands_sepEv,0,__ZNSt3__18ios_baseD0Ev,0,__ZNKSt3__17codecvtIDsc11__mbstate_tE16do_always_noconvEv,0,__ZNSt3__110moneypunctIcLb1EED0Ev,0,__ZNSt9bad_allocD0Ev,0,__ZNSt3__114basic_ofstreamIcNS_11char_traitsIcEEED1Ev,0,__ZNSt3__115basic_streambufIcNS_11char_traitsIcEEED0Ev,0,__ZNKSt3__114error_category10equivalentEiRKNS_15error_conditionE,0,__ZNSt3__19basic_iosIcNS_11char_traitsIcEEED0Ev,0,___cxx_global_array_dtor53,0,__ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE6xsputnEPKci,0,__ZNSt3__113basic_filebufIcNS_11char_traitsIcEEE9pbackfailEi,0,___cxx_global_array_dtor56,0,__ZNKSt3__15ctypeIwE10do_scan_isEtPKwS3_,0,__ZNSt3__113basic_filebufIcNS_11char_traitsIcEEE7seekoffExNS_8ios_base7seekdirEj,0,__ZTv0_n12_NSt3__113basic_ostreamIwNS_11char_traitsIwEEED0Ev,0,__ZNSt3__115basic_streambufIwNS_11char_traitsIwEEED1Ev,0,__ZNSt3__110__stdinbufIwE5imbueERKNS_6localeE,0,__ZNKSt3__17collateIwE10do_compareEPKwS3_S3_S3_,0,__ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE6xsgetnEPci,0,__ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRPv,0,__ZNKSt3__15ctypeIcE10do_tolowerEc,0,__ZNKSt3__110moneypunctIwLb1EE13do_neg_formatEv,0,__ZNKSt3__15ctypeIcE8do_widenEPKcS3_Pc,0,__ZNSt3__17codecvtIcc11__mbstate_tED0Ev,0,__ZNKSt3__110moneypunctIwLb1EE16do_decimal_pointEv,0,__ZNKSt3__120__time_get_c_storageIcE7__weeksEv,0,__ZNSt8bad_castD2Ev,0,__ZNKSt3__18numpunctIwE11do_truenameEv,0,__ZTv0_n12_NSt3__113basic_istreamIcNS_11char_traitsIcEEED1Ev,0,__ZNSt3__110__stdinbufIwE9underflowEv,0,__ZNKSt3__17codecvtIDic11__mbstate_tE9do_lengthERS1_PKcS5_j,0,__ZNSt3__18ios_base7failureD0Ev,0,__ZNSt3__19money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEED0Ev,0,__ZNSt3__18ios_base4InitD2Ev,0,__ZNKSt3__15ctypeIwE5do_isEtw,0,__ZNSt3__110moneypunctIwLb1EED0Ev,0,__ZTv0_n12_NSt3__113basic_ostreamIwNS_11char_traitsIwEEED1Ev,0,__ZNSt3__16localeD2Ev,0,__ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE14do_get_weekdayES4_S4_RNS_8ios_baseERjP2tm,0,__ZNKSt3__15ctypeIcE10do_toupperEPcPKc,0,__ZNKSt3__17codecvtIDic11__mbstate_tE16do_always_noconvEv,0,___cxx_global_array_dtor105,0,__ZNK10__cxxabiv116__shim_type_info5noop2Ev,0,__ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE6setbufEPwi,0,__ZNKSt3__18messagesIwE7do_openERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERKNS_6localeE,0,__ZNSt3__113basic_filebufIcNS_11char_traitsIcEEE5imbueERKNS_6localeE,0,__ZNKSt9bad_alloc4whatEv,0,__ZNSt3__111__stdoutbufIcED1Ev,0,__ZNKSt3__110moneypunctIcLb1EE14do_curr_symbolEv,0,__ZNSt3__113basic_filebufIcNS_11char_traitsIcEEE6setbufEPci,0,__ZNSt13runtime_errorC2EPKc,0,__ZNSt3__16locale5__impD0Ev,0,__ZNK10__cxxabiv117__class_type_info27has_unambiguous_public_baseEPNS_19__dynamic_cast_infoEPvi,0,__ZNKSt3__119__iostream_category4nameEv,0,__ZNKSt3__110moneypunctIcLb0EE14do_frac_digitsEv,0,__ZNKSt3__17codecvtIDsc11__mbstate_tE9do_lengthERS1_PKcS5_j,0,__ZNKSt3__15ctypeIcE9do_narrowEPKcS3_cPc,0,__ZNSt3__18time_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEED1Ev,0,__ZNSt3__19money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEED1Ev,0,__ZNSt8bad_castD0Ev,0,__ZNKSt3__15ctypeIcE9do_narrowEcc,0,__ZNSt3__116__narrow_to_utf8ILj32EED0Ev,0,__ZNSt3__112__do_nothingEPv,0,__ZNSt3__19money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEED1Ev,0,___cxx_global_array_dtor81,0,__ZNSt3__110moneypunctIcLb0EED0Ev,0,__ZNSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEED0Ev,0,__ZNKSt3__17codecvtIDic11__mbstate_tE5do_inERS1_PKcS5_RS5_PDiS7_RS7_,0,__ZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcPKv,0,__ZNKSt3__18numpunctIwE12do_falsenameEv,0,__ZNSt3__17collateIcED0Ev,0,__ZNKSt3__110moneypunctIwLb0EE13do_pos_formatEv,0,__ZNKSt3__110moneypunctIcLb1EE16do_negative_signEv,0,__ZNSt3__111__stdoutbufIcED0Ev,0,__ZTv0_n12_NSt3__114basic_ofstreamIcNS_11char_traitsIcEEED0Ev,0,__ZNSt3__16locale5facetD2Ev,0,__ZTv0_n12_NSt3__113basic_istreamIwNS_11char_traitsIwEEED1Ev,0,__ZNSt3__112system_errorD0Ev,0,__ZNKSt3__19money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_bRNS_8ios_baseERjRe,0,__ZNSt3__111__stdoutbufIwED0Ev,0,__ZNKSt3__17codecvtIwc11__mbstate_tE10do_unshiftERS1_PcS4_RS4_,0,__ZNSt3__110__stdinbufIwE5uflowEv,0,__ZNKSt3__18numpunctIcE11do_truenameEv,0,__ZNKSt3__17codecvtIwc11__mbstate_tE5do_inERS1_PKcS5_RS5_PwS7_RS7_,0,__ZNKSt3__110moneypunctIcLb1EE13do_pos_formatEv,0,__ZNKSt3__19money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_bRNS_8ios_baseEwe,0,__ZNKSt3__19money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_bRNS_8ios_baseERjRe,0,_fclose,0,__ZNSt3__17codecvtIwc11__mbstate_tED0Ev,0,__ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjS8_,0,__ZNKSt3__18numpunctIcE16do_thousands_sepEv,0,__ZNSt3__19money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEED0Ev,0,__ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE9showmanycEv,0,__ZNSt3__19money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEED0Ev,0,__ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE11do_get_dateES4_S4_RNS_8ios_baseERjP2tm,0,__ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE8overflowEj,0,__ZNSt3__18numpunctIwED0Ev,0,__ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE5imbueERKNS_6localeE,0,__ZNKSt3__15ctypeIwE10do_tolowerEw,0,__ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE4syncEv,0,__ZNSt3__111__stdoutbufIcE4syncEv,0,__ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev,0,__ZNKSt3__17collateIcE10do_compareEPKcS3_S3_S3_,0,__ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE7seekposENS_4fposI11__mbstate_tEEj,0,__ZNSt3__110__stdinbufIwED1Ev,0,__ZNKSt3__17collateIwE12do_transformEPKwS3_,0,__ZNKSt3__17codecvtIDic11__mbstate_tE6do_outERS1_PKDiS5_RS5_PcS7_RS7_,0,__ZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcx,0,__ZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEce,0,__ZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcd,0,__ZNSt3__113basic_filebufIcNS_11char_traitsIcEEE9underflowEv,0,__ZNKSt3__17codecvtIcc11__mbstate_tE13do_max_lengthEv,0,__ZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcb,0,__ZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcm,0,__ZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcl,0,__ZNSt8bad_castD2Ev,0,__ZN10__cxxabiv121__vmi_class_type_infoD0Ev,0,__ZNKSt3__17codecvtIcc11__mbstate_tE10do_unshiftERS1_PcS4_RS4_,0,__ZNKSt3__110moneypunctIcLb1EE14do_frac_digitsEv,0,__ZNKSt3__17codecvtIcc11__mbstate_tE9do_lengthERS1_PKcS5_j,0,__ZNKSt3__120__time_get_c_storageIcE3__rEv,0,__ZNKSt3__19money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_bRNS_8ios_baseERjRNS_12basic_stringIcS3_NS_9allocatorIcEEEE,0,__ZNKSt3__15ctypeIwE10do_toupperEPwPKw,0,__ZTv0_n12_NSt3__113basic_ostreamIcNS_11char_traitsIcEEED0Ev,0,__ZNSt3__110__stdinbufIcE9underflowEv,0,__ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE7seekposENS_4fposI11__mbstate_tEEj,0,__ZNKSt3__114error_category23default_error_conditionEi,0,__ZNK10__cxxabiv117__class_type_info16search_above_dstEPNS_19__dynamic_cast_infoEPKvS4_ib,0,__ZNKSt3__17codecvtIDsc11__mbstate_tE11do_encodingEv,0,__ZNKSt3__18messagesIwE8do_closeEi,0,__ZNSt3__110__stdinbufIcE5imbueERKNS_6localeE,0,__ZNSt3__112system_errorD2Ev,0,__ZNKSt3__17codecvtIwc11__mbstate_tE16do_always_noconvEv,0,__ZNKSt3__110moneypunctIwLb0EE11do_groupingEv,0,__ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE9showmanycEv,0,__ZNKSt3__110moneypunctIcLb0EE16do_decimal_pointEv,0,__ZNSt3__113basic_istreamIcNS_11char_traitsIcEEED0Ev,0,__ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRy,0,__ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRx,0,__ZNKSt3__120__time_get_c_storageIcE8__monthsEv,0,__ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRt,0,__ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRPv,0,__ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRm,0,__ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRl,0,__ZNSt3__111__stdoutbufIwE6xsputnEPKwi,0,__ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRb,0,__ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRe,0,__ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRd,0,__ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRf,0,__ZNKSt3__110moneypunctIcLb0EE16do_thousands_sepEv,0,__ZNKSt3__114error_category10equivalentERKNS_10error_codeEi,0,__ZNKSt3__110moneypunctIcLb0EE13do_neg_formatEv,0,__ZNSt3__19basic_iosIcNS_11char_traitsIcEEED1Ev,0,__ZNKSt11logic_error4whatEv,0,__ZNKSt3__119__iostream_category7messageEi,0,__ZNKSt3__110moneypunctIcLb0EE13do_pos_formatEv,0,__ZNSt3__113basic_ostreamIwNS_11char_traitsIwEEED0Ev,0,__ZNKSt3__110moneypunctIwLb0EE16do_decimal_pointEv,0,__ZNKSt3__17codecvtIDic11__mbstate_tE10do_unshiftERS1_PcS4_RS4_,0,__ZNKSt3__17collateIcE12do_transformEPKcS3_,0,__ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE6xsgetnEPwi,0,__ZNKSt3__17codecvtIwc11__mbstate_tE13do_max_lengthEv,0,__ZNKSt3__110moneypunctIwLb0EE14do_frac_digitsEv,0,__ZNSt3__18messagesIcED0Ev,0,__ZNKSt3__15ctypeIcE10do_tolowerEPcPKc,0,__ZNSt3__113basic_filebufIcNS_11char_traitsIcEEED1Ev,0,__ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjP2tmcc,0,__ZNKSt3__120__time_get_c_storageIcE7__am_pmEv,0,__ZNKSt3__110moneypunctIcLb0EE14do_curr_symbolEv,0,__ZNKSt3__15ctypeIwE8do_widenEPKcS3_Pw,0,__ZNKSt3__110moneypunctIwLb1EE16do_thousands_sepEv,0,__ZNK10__cxxabiv121__vmi_class_type_info16search_below_dstEPNS_19__dynamic_cast_infoEPKvib,0,__ZNKSt3__17codecvtIwc11__mbstate_tE9do_lengthERS1_PKcS5_j,0,__ZNSt3__18ios_baseD2Ev,0,__ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEED1Ev,0,__ZNSt3__110__stdinbufIcED0Ev,0,__ZNSt3__16localeC2Ev,0,__ZNKSt3__17codecvtIwc11__mbstate_tE11do_encodingEv,0,__ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE13do_date_orderEv,0,__ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE11do_get_yearES4_S4_RNS_8ios_baseERjP2tm,0,__ZNSt3__119__iostream_categoryD0Ev,0,__ZNSt3__110moneypunctIwLb1EED1Ev,0,__ZNKSt3__110moneypunctIwLb0EE14do_curr_symbolEv,0,__ZNKSt3__18messagesIcE7do_openERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERKNS_6localeE,0,__ZNSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEED0Ev,0,__ZNSt3__110moneypunctIcLb1EED1Ev,0,__ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE8overflowEi,0,__ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE7seekoffExNS_8ios_base7seekdirEj,0,__ZNKSt3__120__time_get_c_storageIcE3__cEv,0,__ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE6setbufEPci,0,__ZNKSt3__110moneypunctIwLb0EE16do_positive_signEv,0,__ZNSt3__113basic_filebufIcNS_11char_traitsIcEEE8overflowEi,0,__ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjS8_,0,__ZNKSt3__120__time_get_c_storageIwE3__XEv,0,__ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE11do_get_dateES4_S4_RNS_8ios_baseERjP2tm,0,__ZTv0_n12_NSt3__113basic_istreamIwNS_11char_traitsIwEEED0Ev,0,__ZNKSt3__17codecvtIcc11__mbstate_tE6do_outERS1_PKcS5_RS5_PcS7_RS7_,0,__ZNSt3__115basic_streambufIwNS_11char_traitsIwEEED0Ev,0,__ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE9pbackfailEi,0,__ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEED0Ev,0,__ZNSt3__111__stdoutbufIwE8overflowEj,0,__ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRy,0,__ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRx,0,__ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRt,0,__ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRm,0,__ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRl,0,__ZNKSt3__19money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_bRNS_8ios_baseEce,0,__ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRe,0,__ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRd,0,__ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRf,0,__ZNKSt3__17codecvtIDsc11__mbstate_tE13do_max_lengthEv,0,__ZNSt3__111__stdoutbufIcE6xsputnEPKci,0,__ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRb,0,___cxx_global_array_dtor,0,__ZNSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEED1Ev,0,__ZN10__cxxabiv120__si_class_type_infoD0Ev,0,__ZNSt3__18messagesIwED1Ev,0,__ZNSt3__111__stdoutbufIwED1Ev,0,__ZNKSt3__19money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_bRNS_8ios_baseERjRNS_12basic_stringIwS3_NS_9allocatorIwEEEE,0,__ZN10__cxxabiv116__shim_type_infoD2Ev,0,__ZNKSt3__15ctypeIwE11do_scan_notEtPKwS3_,0,__ZNKSt3__110moneypunctIwLb1EE14do_curr_symbolEv,0,__ZNSt3__18time_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEED1Ev,0,__ZNKSt3__18messagesIwE6do_getEiiiRKNS_12basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEE,0,__ZNKSt3__17codecvtIcc11__mbstate_tE5do_inERS1_PKcS5_RS5_PcS7_RS7_,0,__ZNSt3__19money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEED1Ev,0,__ZNKSt3__110moneypunctIcLb1EE16do_positive_signEv,0,__ZNKSt3__17codecvtIDic11__mbstate_tE13do_max_lengthEv,0,__ZNSt3__19money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEED1Ev,0,__ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE6xsputnEPKwi,0,__ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev,0,__ZNSt3__15ctypeIcED2Ev,0,__ZNSt13runtime_errorD0Ev,0,__ZNSt3__113basic_istreamIwNS_11char_traitsIwEEED0Ev,0,___cxx_global_array_dtor120,0];

// EMSCRIPTEN_START_FUNCS

function __Z5usagePc($name){
 var label=0;
 var sp=STACKTOP; (assert((STACKTOP|0) < (STACK_MAX|0))|0);

 var $1;
 var $2;
 var $3;
 $3=$name;
 var $4=__ZNSt3__1lsINS_11char_traitsIcEEEERNS_13basic_ostreamIcT_EES6_PKc(14368,2280);
 var $5=$3;
 var $6=__ZNSt3__1lsINS_11char_traitsIcEEEERNS_13basic_ostreamIcT_EES6_PKc($4,$5);
 var $7=__ZNSt3__1lsINS_11char_traitsIcEEEERNS_13basic_ostreamIcT_EES6_PKc($6,2200);
 $1=$7;
 $2=8;
 var $8=$1;
 var $9=$2;
 var $10=FUNCTION_TABLE[$9]($8);
 var $11=__ZNSt3__1lsINS_11char_traitsIcEEEERNS_13basic_ostreamIcT_EES6_PKc(14368,1424);
 STACKTOP=sp;return;
}


function __ZNSt3__1lsINS_11char_traitsIcEEEERNS_13basic_ostreamIcT_EES6_PKc($__os,$__str){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+32)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1;
 var $2;
 var $3;
 var $4;
 var $5;
 var $6;
 var $7;
 var $8;
 var $9=sp;
 var $10;
 var $11;
 var $12;
 var $13;
 var $14;
 var $15;
 var $16;
 var $17;
 var $18;
 var $19;
 var $20;
 var $21;
 var $22;
 var $23;
 var $24;
 var $25;
 var $26;
 var $27;
 var $28;
 var $29;
 var $__s=(sp)+(8);
 var $30;
 var $31;
 var $__len;
 var $32=(sp)+(16);
 var $33=(sp)+(24);
 $28=$__os;
 $29=$__str;
 var $34=$28;
 (function() { try { __THREW__ = 0; return __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE6sentryC1ERS3_($__s,$34) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=2;break; } else { label=25;break; }
 case 2: 
 $27=$__s;
 var $36=$27;
 var $37=(($36)|0);
 var $38=HEAP8[($37)];
 var $39=(($38)&1);
 label=3;break;
 case 3: 
 if($39){label=4;break;}else{label=29;break;}
 case 4: 
 var $42=$29;
 $26=$42;
 var $43=$26;
 var $44=(function() { try { __THREW__ = 0; return _strlen($43) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=5;break; } else { label=26;break; }
 case 5: 
 label=6;break;
 case 6: 
 $__len=$44;
 var $46=$28;
 $24=$32;
 $25=$46;
 var $47=$24;
 var $48=$25;
 $20=$47;
 $21=$48;
 var $49=$20;
 var $50=$49;
 var $51=(($49)|0);
 var $52=$21;
 var $53=$52;
 var $54=HEAP32[(($53)>>2)];
 var $55=((($54)-(12))|0);
 var $56=$55;
 var $57=HEAP32[(($56)>>2)];
 var $58=$52;
 var $59=(($58+$57)|0);
 var $60=$59;
 $19=$60;
 var $61=$19;
 var $62=$61;
 $18=$62;
 var $63=$18;
 var $64=(($63+24)|0);
 var $65=HEAP32[(($64)>>2)];
 var $66=$65;
 HEAP32[(($51)>>2)]=$66;
 var $67=$29;
 var $68=$28;
 var $69=$68;
 var $70=HEAP32[(($69)>>2)];
 var $71=((($70)-(12))|0);
 var $72=$71;
 var $73=HEAP32[(($72)>>2)];
 var $74=$68;
 var $75=(($74+$73)|0);
 var $76=$75;
 $17=$76;
 var $77=$17;
 var $78=(($77+4)|0);
 var $79=HEAP32[(($78)>>2)];
 label=7;break;
 case 7: 
 var $81=$79&176;
 var $82=($81|0)==32;
 if($82){label=8;break;}else{label=9;break;}
 case 8: 
 var $84=$29;
 var $85=$__len;
 var $86=(($84+$85)|0);
 var $90=$86;label=10;break;
 case 9: 
 var $88=$29;
 var $90=$88;label=10;break;
 case 10: 
 var $90;
 var $91=$29;
 var $92=$__len;
 var $93=(($91+$92)|0);
 var $94=$28;
 var $95=$94;
 var $96=HEAP32[(($95)>>2)];
 var $97=((($96)-(12))|0);
 var $98=$97;
 var $99=HEAP32[(($98)>>2)];
 var $100=$94;
 var $101=(($100+$99)|0);
 var $102=$101;
 var $103=$28;
 var $104=$103;
 var $105=HEAP32[(($104)>>2)];
 var $106=((($105)-(12))|0);
 var $107=$106;
 var $108=HEAP32[(($107)>>2)];
 var $109=$103;
 var $110=(($109+$108)|0);
 var $111=$110;
 $12=$111;
 var $112=$12;
 var $113=(($112+76)|0);
 var $114=HEAP32[(($113)>>2)];
 $2=-1;
 $3=$114;
 var $115=$2;
 var $116=$3;
 var $117=($115|0)==($116|0);
 if($117){label=11;break;}else{label=19;break;}
 case 11: 
 $7=$112;
 $8=32;
 var $119=$7;
 var $120=$119;
 (function() { try { __THREW__ = 0; return __ZNKSt3__18ios_base6getlocEv($9,$120) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=12;break; } else { label=26;break; }
 case 12: 
 $6=$9;
 var $121=$6;
 var $122=(function() { try { __THREW__ = 0; return __ZNKSt3__16locale9use_facetERNS0_2idE($121,14096) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=13;break; } else { label=14;break; }
 case 13: 
 var $123=$122;
 var $124=$8;
 $4=$123;
 $5=$124;
 var $125=$4;
 var $126=$125;
 var $127=HEAP32[(($126)>>2)];
 var $128=(($127+28)|0);
 var $129=HEAP32[(($128)>>2)];
 var $130=$5;
 var $131=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$129]($125,$130) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=17;break; } else { label=14;break; }
 case 14: 
 var $133$0 = ___cxa_find_matching_catch(-1, -1,0); var $133$1 = tempRet0;
 var $134=$133$0;
 $10=$134;
 var $135=$133$1;
 $11=$135;
 (function() { try { __THREW__ = 0; return __ZNSt3__16localeD2Ev($9) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=15;break; } else { label=16;break; }
 case 15: 
 var $137=$10;
 var $138=$11;
 var $139$0=$137;
 var $139$1=0;
 var $140$0=$139$0;
 var $140$1=$138;
 var $eh_lpad_body$1=$140$1;var $eh_lpad_body$0=$140$0;label=27;break;
 case 16: 
 var $142$0 = ___cxa_find_matching_catch(-1, -1,0,0); var $142$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
 case 17: 
 (function() { try { __THREW__ = 0; return __ZNSt3__16localeD2Ev($9) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=18;break; } else { label=26;break; }
 case 18: 
 var $143=(($131<<24)>>24);
 var $144=(($112+76)|0);
 HEAP32[(($144)>>2)]=$143;
 label=19;break;
 case 19: 
 var $145=(($112+76)|0);
 var $146=HEAP32[(($145)>>2)];
 var $147=(($146)&255);
 label=20;break;
 case 20: 
 (function() { try { __THREW__ = 0; return __ZNSt3__116__pad_and_outputIcNS_11char_traitsIcEEEENS_19ostreambuf_iteratorIT_T0_EES6_PKS4_S8_S8_RNS_8ios_baseES4_($33,$32,$67,$90,$93,$102,$147) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=21;break; } else { label=26;break; }
 case 21: 
 $1=$33;
 var $150=$1;
 var $151=(($150)|0);
 var $152=HEAP32[(($151)>>2)];
 var $153=($152|0)==0;
 if($153){label=22;break;}else{label=28;break;}
 case 22: 
 var $155=$28;
 var $156=$155;
 var $157=HEAP32[(($156)>>2)];
 var $158=((($157)-(12))|0);
 var $159=$158;
 var $160=HEAP32[(($159)>>2)];
 var $161=$155;
 var $162=(($161+$160)|0);
 var $163=$162;
 $15=$163;
 $16=5;
 var $164=$15;
 var $165=$164;
 var $166=$16;
 $13=$165;
 $14=$166;
 var $167=$13;
 var $168=(($167+16)|0);
 var $169=HEAP32[(($168)>>2)];
 var $170=$14;
 var $171=$169|$170;
 (function() { try { __THREW__ = 0; return __ZNSt3__18ios_base5clearEj($167,$171) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=23;break; } else { label=26;break; }
 case 23: 
 label=24;break;
 case 24: 
 label=28;break;
 case 25: 
 var $174$0 = ___cxa_find_matching_catch(-1, -1,0); var $174$1 = tempRet0;
 var $175=$174$0;
 $30=$175;
 var $176=$174$1;
 $31=$176;
 label=32;break;
 case 26: 
 var $178$0 = ___cxa_find_matching_catch(-1, -1,0); var $178$1 = tempRet0;
 var $eh_lpad_body$1=$178$1;var $eh_lpad_body$0=$178$0;label=27;break;
 case 27: 
 var $eh_lpad_body$0;
 var $eh_lpad_body$1;
 var $179=$eh_lpad_body$0;
 $30=$179;
 var $180=$eh_lpad_body$1;
 $31=$180;
 (function() { try { __THREW__ = 0; return __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE6sentryD1Ev($__s) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=31;break; } else { label=38;break; }
 case 28: 
 label=29;break;
 case 29: 
 (function() { try { __THREW__ = 0; return __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE6sentryD1Ev($__s) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=30;break; } else { label=25;break; }
 case 30: 
 label=34;break;
 case 31: 
 label=32;break;
 case 32: 
 var $186=$30;
 var $187=___cxa_begin_catch($186);
 var $188=$28;
 var $189=$188;
 var $190=HEAP32[(($189)>>2)];
 var $191=((($190)-(12))|0);
 var $192=$191;
 var $193=HEAP32[(($192)>>2)];
 var $194=$188;
 var $195=(($194+$193)|0);
 var $196=$195;
 (function() { try { __THREW__ = 0; return __ZNSt3__18ios_base33__set_badbit_and_consider_rethrowEv($196) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=33;break; } else { label=35;break; }
 case 33: 
 ___cxa_end_catch();
 label=34;break;
 case 34: 
 var $199=$28;
 STACKTOP=sp;return $199;
 case 35: 
 var $201$0 = ___cxa_find_matching_catch(-1, -1); var $201$1 = tempRet0;
 var $202=$201$0;
 $30=$202;
 var $203=$201$1;
 $31=$203;
 (function() { try { __THREW__ = 0; return ___cxa_end_catch() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=36;break; } else { label=38;break; }
 case 36: 
 label=37;break;
 case 37: 
 var $206=$30;
 var $207=$31;
 var $208$0=$206;
 var $208$1=0;
 var $209$0=$208$0;
 var $209$1=$207;
 ___resumeException($209$0)
 case 38: 
 var $211$0 = ___cxa_find_matching_catch(-1, -1,0); var $211$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__14endlIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_($__os){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+8)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1;
 var $2;
 var $3;
 var $4;
 var $5;
 var $6=sp;
 var $7;
 var $8;
 var $9;
 $9=$__os;
 var $10=$9;
 var $11=$9;
 var $12=$11;
 var $13=HEAP32[(($12)>>2)];
 var $14=((($13)-(12))|0);
 var $15=$14;
 var $16=HEAP32[(($15)>>2)];
 var $17=$11;
 var $18=(($17+$16)|0);
 var $19=$18;
 $4=$19;
 $5=10;
 var $20=$4;
 var $21=$20;
 __ZNKSt3__18ios_base6getlocEv($6,$21);
 $3=$6;
 var $22=$3;
 var $23=(function() { try { __THREW__ = 0; return __ZNKSt3__16locale9use_facetERNS0_2idE($22,14096) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=2;break; } else { label=3;break; }
 case 2: 
 var $24=$23;
 var $25=$5;
 $1=$24;
 $2=$25;
 var $26=$1;
 var $27=$26;
 var $28=HEAP32[(($27)>>2)];
 var $29=(($28+28)|0);
 var $30=HEAP32[(($29)>>2)];
 var $31=$2;
 var $32=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$30]($26,$31) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=6;break; } else { label=3;break; }
 case 3: 
 var $34$0 = ___cxa_find_matching_catch(-1, -1); var $34$1 = tempRet0;
 var $35=$34$0;
 $7=$35;
 var $36=$34$1;
 $8=$36;
 (function() { try { __THREW__ = 0; return __ZNSt3__16localeD2Ev($6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=4;break; } else { label=5;break; }
 case 4: 
 var $38=$7;
 var $39=$8;
 var $40$0=$38;
 var $40$1=0;
 var $41$0=$40$0;
 var $41$1=$39;
 ___resumeException($41$0)
 case 5: 
 var $43$0 = ___cxa_find_matching_catch(-1, -1,0); var $43$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
 case 6: 
 __ZNSt3__16localeD2Ev($6);
 var $44=__ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE3putEc($10,$32);
 var $45=$9;
 var $46=__ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE5flushEv($45);
 var $47=$9;
 STACKTOP=sp;return $47;
  default: assert(0, "bad label: " + label);
 }

}


function _main($argc,$argv){
 var label=0;
 var tempVarArgs=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+1672)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1;
 var $2;
 var $3;
 var $4;
 var $5;
 var $6;
 var $7;
 var $8;
 var $9;
 var $10;
 var $11;
 var $12;
 var $13;
 var $14;
 var $15;
 var $16;
 var $17;
 var $18;
 var $19;
 var $20;
 var $21;
 var $22;
 var $23;
 var $24;
 var $25;
 var $26;
 var $27;
 var $28;
 var $29;
 var $30;
 var $31;
 var $32;
 var $33;
 var $34;
 var $35;
 var $36;
 var $37;
 var $38;
 var $39;
 var $40;
 var $41;
 var $42;
 var $43;
 var $44;
 var $45;
 var $46;
 var $47;
 var $48;
 var $49;
 var $50;
 var $51;
 var $52;
 var $53;
 var $54;
 var $55;
 var $56;
 var $57;
 var $58;
 var $59;
 var $60;
 var $61;
 var $62;
 var $63;
 var $64=sp;
 var $65;
 var $66;
 var $67=(sp)+(8);
 var $68;
 var $69;
 var $70;
 var $71;
 var $72=(sp)+(16);
 var $73=(sp)+(24);
 var $74=(sp)+(32);
 var $75;
 var $76;
 var $77;
 var $78;
 var $79;
 var $80;
 var $81;
 var $82;
 var $83;
 var $num_players;
 var $threshold;
 var $secretFile;
 var $buffer=(sp)+(40);
 var $totalSize;
 var $fileC;
 var $size;
 var $i;
 var $i1;
 var $numBits;
 var $prime=(sp)+(1064);
 var $code=(sp)+(1080);
 var $84;
 var $85;
 var $secret=(sp)+(1096);
 var $shares=(sp)+(1120);
 var $i2;
 var $86=(sp)+(1136);
 var $87=(sp)+(1160);
 var $88=(sp)+(1176);
 var $89=(sp)+(1192);
 var $90=(sp)+(1208);
 var $partyFile=(sp)+(1232);
 var $i3;
 var $partyFileName=(sp)+(1416);
 var $91;
 var $j;
 $81=0;
 $82=$argc;
 $83=$argv;
 var $92=$82;
 var $93=($92|0)<3;
 if($93){label=3;break;}else{label=2;break;}
 case 2: 
 var $95=$82;
 var $96=($95|0)>4;
 if($96){label=3;break;}else{label=4;break;}
 case 3: 
 var $98=$83;
 var $99=(($98)|0);
 var $100=HEAP32[(($99)>>2)];
 __Z5usagePc($100);
 $81=1;
 label=137;break;
 case 4: 
 var $102=$83;
 var $103=(($102+4)|0);
 var $104=HEAP32[(($103)>>2)];
 var $105=_atoi($104);
 $num_players=$105;
 var $106=$83;
 var $107=(($106+8)|0);
 var $108=HEAP32[(($107)>>2)];
 var $109=_atoi($108);
 $threshold=$109;
 var $110=$threshold;
 var $111=$num_players;
 var $112=($110|0)>=($111|0);
 if($112){label=6;break;}else{label=5;break;}
 case 5: 
 var $114=$num_players;
 var $115=($114|0)<0;
 if($115){label=6;break;}else{label=7;break;}
 case 6: 
 var $117=$83;
 var $118=(($117)|0);
 var $119=HEAP32[(($118)>>2)];
 __Z5usagePc($119);
 $81=3;
 label=137;break;
 case 7: 
 var $121=$82;
 var $122=($121|0)==4;
 if($122){label=8;break;}else{label=11;break;}
 case 8: 
 var $124=$83;
 var $125=(($124+12)|0);
 var $126=HEAP32[(($125)>>2)];
 var $127=_fopen($126,1312);
 $secretFile=$127;
 var $128=$secretFile;
 var $129=($128|0)!=0;
 if($129){label=10;break;}else{label=9;break;}
 case 9: 
 var $131=__ZNSt3__1lsINS_11char_traitsIcEEEERNS_13basic_ostreamIcT_EES6_PKc(14368,928);
 var $132=$83;
 var $133=(($132+12)|0);
 var $134=HEAP32[(($133)>>2)];
 var $135=__ZNSt3__1lsINS_11char_traitsIcEEEERNS_13basic_ostreamIcT_EES6_PKc($131,$134);
 $79=$135;
 $80=8;
 var $136=$79;
 var $137=$80;
 var $138=FUNCTION_TABLE[$137]($136);
 $81=2;
 label=137;break;
 case 10: 
 label=14;break;
 case 11: 
 var $141=_fopen(920,1312);
 $secretFile=$141;
 var $142=$secretFile;
 var $143=($142|0)!=0;
 if($143){label=13;break;}else{label=12;break;}
 case 12: 
 var $145=__ZNSt3__1lsINS_11char_traitsIcEEEERNS_13basic_ostreamIcT_EES6_PKc(14368,928);
 var $146=__ZNSt3__1lsINS_11char_traitsIcEEEERNS_13basic_ostreamIcT_EES6_PKc($145,760);
 $77=$146;
 $78=8;
 var $147=$77;
 var $148=$78;
 var $149=FUNCTION_TABLE[$148]($147);
 $81=2;
 label=137;break;
 case 13: 
 label=14;break;
 case 14: 
 $totalSize=0;
 var $152=$totalSize;
 var $153=$152;
 var $154=_malloc($153);
 $fileC=$154;
 var $155=(($buffer)|0);
 var $156=$secretFile;
 var $157=_fread($155,1,1024,$156);
 $size=$157;
 label=15;break;
 case 15: 
 var $159=$size;
 var $160=($159|0)==1024;
 if($160){label=16;break;}else{label=21;break;}
 case 16: 
 var $162=$size;
 var $163=$totalSize;
 var $164=((($163)+($162))|0);
 $totalSize=$164;
 var $165=$fileC;
 var $166=$totalSize;
 var $167=_realloc($165,$166);
 $fileC=$167;
 $i=0;
 label=17;break;
 case 17: 
 var $169=$i;
 var $170=$size;
 var $171=($169>>>0)<($170>>>0);
 if($171){label=18;break;}else{label=20;break;}
 case 18: 
 var $173=$i;
 var $174=(($buffer+$173)|0);
 var $175=HEAP8[($174)];
 var $176=$i;
 var $177=$totalSize;
 var $178=((($176)+($177))|0);
 var $179=$size;
 var $180=((($178)-($179))|0);
 var $181=$fileC;
 var $182=(($181+$180)|0);
 HEAP8[($182)]=$175;
 label=19;break;
 case 19: 
 var $184=$i;
 var $185=((($184)+(1))|0);
 $i=$185;
 label=17;break;
 case 20: 
 var $187=(($buffer)|0);
 var $188=$secretFile;
 var $189=_fread($187,1,1024,$188);
 $size=$189;
 label=15;break;
 case 21: 
 var $191=$size;
 var $192=($191|0)!=0;
 if($192){label=22;break;}else{label=27;break;}
 case 22: 
 var $194=$size;
 var $195=$totalSize;
 var $196=((($195)+($194))|0);
 $totalSize=$196;
 var $197=$fileC;
 var $198=$totalSize;
 var $199=_realloc($197,$198);
 $fileC=$199;
 $i1=0;
 label=23;break;
 case 23: 
 var $201=$i1;
 var $202=$size;
 var $203=($201>>>0)<($202>>>0);
 if($203){label=24;break;}else{label=26;break;}
 case 24: 
 var $205=$i1;
 var $206=(($buffer+$205)|0);
 var $207=HEAP8[($206)];
 var $208=$i1;
 var $209=$totalSize;
 var $210=((($208)+($209))|0);
 var $211=$size;
 var $212=((($210)-($211))|0);
 var $213=$fileC;
 var $214=(($213+$212)|0);
 HEAP8[($214)]=$207;
 label=25;break;
 case 25: 
 var $216=$i1;
 var $217=((($216)+(1))|0);
 $i1=$217;
 label=23;break;
 case 26: 
 label=27;break;
 case 27: 
 var $220=HEAP32[((__ZN13ShamirSharing7numBitsE)>>2)];
 $numBits=$220;
 __ZN10__gmp_exprI12__gmpz_valueS0_EC1ERKS1_($prime,__ZN13ShamirSharing5primeE);
 var $221=$fileC;
 var $222=$totalSize;
 var $223=$numBits;
 (function() { try { __THREW__ = 0; return __ZN13ShamirSharing10bytesToIntEPcij($code,$221,$222,$223) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=28;break; } else { label=54;break; }
 case 28: 
 (function() { try { __THREW__ = 0; return __ZN12FieldElementC1Ev($secret) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=29;break; } else { label=55;break; }
 case 29: 
 $76=$shares;
 var $226=$76;
 $75=$226;
 var $227=$75;
 var $228=$227;
 $71=$228;
 var $229=$71;
 var $230=$229;
 $70=$230;
 var $231=$70;
 var $232=(($229)|0);
 $48=$72;
 $49=-1;
 var $233=$48;
 var $234=$49;
 $46=$233;
 $47=$234;
 var $235=$46;
 var $236=(($235)|0);
 HEAP32[(($236)>>2)]=0;
 $50=$72;
 var $237=$50;
 HEAP32[(($232)>>2)]=0;
 var $238=(($229+4)|0);
 $53=$73;
 $54=-1;
 var $239=$53;
 var $240=$54;
 $51=$239;
 $52=$240;
 var $241=$51;
 var $242=(($241)|0);
 HEAP32[(($242)>>2)]=0;
 $55=$73;
 var $243=$55;
 HEAP32[(($238)>>2)]=0;
 var $244=(($229+8)|0);
 $58=$74;
 $59=-1;
 var $245=$58;
 var $246=$59;
 $56=$245;
 $57=$246;
 var $247=$56;
 var $248=(($247)|0);
 HEAP32[(($248)>>2)]=0;
 $60=$74;
 var $249=$60;
 $68=$244;
 $69=0;
 var $250=$68;
 var $251=$69;
 $66=$250;
 HEAP32[(($67)>>2)]=$251;
 var $252=$66;
 var $253=$252;
 $65=$67;
 var $254=$65;
 var $255=HEAP32[(($254)>>2)];
 $63=$253;
 HEAP32[(($64)>>2)]=$255;
 var $256=$63;
 var $257=$256;
 $62=$257;
 var $258=$62;
 var $259=(($256)|0);
 $61=$64;
 var $260=$61;
 var $261=HEAP32[(($260)>>2)];
 HEAP32[(($259)>>2)]=$261;
 label=30;break;
 case 30: 
 $i2=0;
 label=31;break;
 case 31: 
 var $264=$i2;
 $45=$code;
 var $265=$45;
 var $266=$265;
 var $267=(($266+4)|0);
 var $268=HEAP32[(($267)>>2)];
 var $269=$265;
 var $270=(($269)|0);
 var $271=HEAP32[(($270)>>2)];
 var $272=$268;
 var $273=$271;
 var $274=((($272)-($273))|0);
 var $275=(((($274|0))/(12))&-1);
 var $276=($264>>>0)<($275>>>0);
 if($276){label=32;break;}else{label=72;break;}
 case 32: 
 var $278=$i2;
 var $279=(function() { try { __THREW__ = 0; return __ZNSt3__16vectorI10__gmp_exprI12__gmpz_valueS2_ENS_9allocatorIS3_EEE2atEj($code,$278) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=33;break; } else { label=57;break; }
 case 33: 
 (function() { try { __THREW__ = 0; return __ZN10__gmp_exprI12__gmpz_valueS0_EC1ERKS1_($87,$279) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=34;break; } else { label=57;break; }
 case 34: 
 (function() { try { __THREW__ = 0; return __ZN10__gmp_exprI12__gmpz_valueS0_EC1ERKS1_($88,$prime) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=35;break; } else { label=59;break; }
 case 35: 
 (function() { try { __THREW__ = 0; return __ZN12FieldElementC1E10__gmp_exprI12__gmpz_valueS1_ES2_($86,$87,$88) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=36;break; } else { label=60;break; }
 case 36: 
 var $284=(function() { try { __THREW__ = 0; return __ZN12FieldElementaSERKS_($secret,$86) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=37;break; } else { label=61;break; }
 case 37: 
 (function() { try { __THREW__ = 0; return __ZN12FieldElementD1Ev($86) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=38;break; } else { label=60;break; }
 case 38: 
 (function() { try { __THREW__ = 0; return __ZN10__gmp_exprI12__gmpz_valueS0_ED1Ev($88) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=39;break; } else { label=59;break; }
 case 39: 
 (function() { try { __THREW__ = 0; return __ZN10__gmp_exprI12__gmpz_valueS0_ED1Ev($87) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=40;break; } else { label=57;break; }
 case 40: 
 (function() { try { __THREW__ = 0; return __ZN12FieldElementC1ERKS_($90,$secret) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=41;break; } else { label=57;break; }
 case 41: 
 var $290=$threshold;
 var $291=$num_players;
 (function() { try { __THREW__ = 0; return __ZN13ShamirSharing5shareE12FieldElementii($89,$90,$290,$291) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=42;break; } else { label=67;break; }
 case 42: 
 $43=$shares;
 $44=$89;
 var $293=$43;
 var $294=$293;
 var $295=(($294+4)|0);
 var $296=HEAP32[(($295)>>2)];
 var $297=$293;
 $42=$297;
 var $298=$42;
 var $299=(($298+8)|0);
 $41=$299;
 var $300=$41;
 var $301=$300;
 $40=$301;
 var $302=$40;
 var $303=(($302)|0);
 var $304=HEAP32[(($303)>>2)];
 var $305=($296|0)!=($304|0);
 if($305){label=43;break;}else{label=47;break;}
 case 43: 
 var $307=$293;
 $39=$307;
 var $308=$39;
 var $309=(($308+8)|0);
 $38=$309;
 var $310=$38;
 var $311=$310;
 $37=$311;
 var $312=$37;
 var $313=$312;
 var $314=$293;
 var $315=(($314+4)|0);
 var $316=HEAP32[(($315)>>2)];
 $33=$316;
 var $317=$33;
 var $318=$44;
 $34=$313;
 $35=$317;
 $36=$318;
 var $319=$35;
 var $320=$319;
 var $321=($320|0)==0;
 if($321){var $325=0;label=46;break;}else{label=44;break;}
 case 44: 
 var $323=$320;
 var $324=$36;
 (function() { try { __THREW__ = 0; return __ZNSt3__16vectorINS_4pairIi12FieldElementEENS_9allocatorIS3_EEEC1ERKS6_($323,$324) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=45;break; } else { label=68;break; }
 case 45: 
 var $325=$323;label=46;break;
 case 46: 
 var $325;
 var $326=$293;
 var $327=(($326+4)|0);
 var $328=HEAP32[(($327)>>2)];
 var $329=(($328+12)|0);
 HEAP32[(($327)>>2)]=$329;
 label=49;break;
 case 47: 
 var $331=$44;
 (function() { try { __THREW__ = 0; return __ZNSt3__16vectorINS0_INS_4pairIi12FieldElementEENS_9allocatorIS3_EEEENS4_IS6_EEE21__push_back_slow_pathIKS6_EEvRT_($293,$331) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=48;break; } else { label=68;break; }
 case 48: 
 label=49;break;
 case 49: 
 label=50;break;
 case 50: 
 (function() { try { __THREW__ = 0; return __ZNSt3__16vectorINS_4pairIi12FieldElementEENS_9allocatorIS3_EEED1Ev($89) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=51;break; } else { label=67;break; }
 case 51: 
 (function() { try { __THREW__ = 0; return __ZN12FieldElementD1Ev($90) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=52;break; } else { label=57;break; }
 case 52: 
 label=53;break;
 case 53: 
 var $336=$i2;
 var $337=((($336)+(1))|0);
 $i2=$337;
 label=31;break;
 case 54: 
 var $339$0 = ___cxa_find_matching_catch(-1, -1); var $339$1 = tempRet0;
 var $340=$339$0;
 $84=$340;
 var $341=$339$1;
 $85=$341;
 label=135;break;
 case 55: 
 var $343$0 = ___cxa_find_matching_catch(-1, -1); var $343$1 = tempRet0;
 var $344=$343$0;
 $84=$344;
 var $345=$343$1;
 $85=$345;
 label=133;break;
 case 56: 
 var $347$0 = ___cxa_find_matching_catch(-1, -1); var $347$1 = tempRet0;
 var $348=$347$0;
 $84=$348;
 var $349=$347$1;
 $85=$349;
 label=130;break;
 case 57: 
 var $351$0 = ___cxa_find_matching_catch(-1, -1); var $351$1 = tempRet0;
 var $eh_lpad_body$1=$351$1;var $eh_lpad_body$0=$351$0;label=58;break;
 case 58: 
 var $eh_lpad_body$0;
 var $eh_lpad_body$1;
 var $352=$eh_lpad_body$0;
 $84=$352;
 var $353=$eh_lpad_body$1;
 $85=$353;
 label=127;break;
 case 59: 
 var $355$0 = ___cxa_find_matching_catch(-1, -1); var $355$1 = tempRet0;
 var $356=$355$0;
 $84=$356;
 var $357=$355$1;
 $85=$357;
 label=65;break;
 case 60: 
 var $359$0 = ___cxa_find_matching_catch(-1, -1); var $359$1 = tempRet0;
 var $360=$359$0;
 $84=$360;
 var $361=$359$1;
 $85=$361;
 label=63;break;
 case 61: 
 var $363$0 = ___cxa_find_matching_catch(-1, -1); var $363$1 = tempRet0;
 var $364=$363$0;
 $84=$364;
 var $365=$363$1;
 $85=$365;
 (function() { try { __THREW__ = 0; return __ZN12FieldElementD1Ev($86) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=62;break; } else { label=139;break; }
 case 62: 
 label=63;break;
 case 63: 
 (function() { try { __THREW__ = 0; return __ZN10__gmp_exprI12__gmpz_valueS0_ED1Ev($88) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=64;break; } else { label=139;break; }
 case 64: 
 label=65;break;
 case 65: 
 (function() { try { __THREW__ = 0; return __ZN10__gmp_exprI12__gmpz_valueS0_ED1Ev($87) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=66;break; } else { label=139;break; }
 case 66: 
 label=127;break;
 case 67: 
 var $372$0 = ___cxa_find_matching_catch(-1, -1); var $372$1 = tempRet0;
 var $373=$372$0;
 $84=$373;
 var $374=$372$1;
 $85=$374;
 label=70;break;
 case 68: 
 var $376$0 = ___cxa_find_matching_catch(-1, -1); var $376$1 = tempRet0;
 var $377=$376$0;
 $84=$377;
 var $378=$376$1;
 $85=$378;
 (function() { try { __THREW__ = 0; return __ZNSt3__16vectorINS_4pairIi12FieldElementEENS_9allocatorIS3_EEED1Ev($89) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=69;break; } else { label=139;break; }
 case 69: 
 label=70;break;
 case 70: 
 (function() { try { __THREW__ = 0; return __ZN12FieldElementD1Ev($90) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=71;break; } else { label=139;break; }
 case 71: 
 label=127;break;
 case 72: 
 $30=$partyFile;
 var $383=$30;
 var $384=$383;
 var $385=(($384+104)|0);
 var $386=$385;
 $29=$386;
 var $387=$29;
 var $388=$387;
 $28=$388;
 var $389=$28;
 var $390=$389;
 HEAP32[(($390)>>2)]=3736;
 var $391=$387;
 HEAP32[(($391)>>2)]=3280;
 var $392=$383;
 HEAP32[(($392)>>2)]=4884;
 var $393=$383;
 var $394=(($393+104)|0);
 var $395=$394;
 HEAP32[(($395)>>2)]=4904;
 var $396=$383;
 var $397=(($383+4)|0);
 var $398=$397;
 $25=$396;
 $26=5812;
 $27=$398;
 var $399=$25;
 var $400=$26;
 var $401=HEAP32[(($400)>>2)];
 var $402=$399;
 HEAP32[(($402)>>2)]=$401;
 var $403=(($400+4)|0);
 var $404=HEAP32[(($403)>>2)];
 var $405=$399;
 var $406=HEAP32[(($405)>>2)];
 var $407=((($406)-(12))|0);
 var $408=$407;
 var $409=HEAP32[(($408)>>2)];
 var $410=$399;
 var $411=(($410+$409)|0);
 var $412=$411;
 HEAP32[(($412)>>2)]=$404;
 var $413=$399;
 var $414=HEAP32[(($413)>>2)];
 var $415=((($414)-(12))|0);
 var $416=$415;
 var $417=HEAP32[(($416)>>2)];
 var $418=$399;
 var $419=(($418+$417)|0);
 var $420=$419;
 var $421=$27;
 $23=$420;
 $24=$421;
 var $422=$23;
 var $423=$422;
 var $424=$24;
 var $425=$424;
 (function() { try { __THREW__ = 0; return __ZNSt3__18ios_base4initEPv($423,$425) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=73;break; } else { label=74;break; }
 case 73: 
 var $426=(($422+72)|0);
 HEAP32[(($426)>>2)]=0;
 var $427=(($422+76)|0);
 HEAP32[(($427)>>2)]=-1;
 var $428=$383;
 HEAP32[(($428)>>2)]=4884;
 var $429=$383;
 var $430=(($429+104)|0);
 var $431=$430;
 HEAP32[(($431)>>2)]=4904;
 var $432=(($383+4)|0);
 (function() { try { __THREW__ = 0; return __ZNSt3__113basic_filebufIcNS_11char_traitsIcEEEC1Ev($432) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=80;break; } else { label=75;break; }
 case 74: 
 var $434$0 = ___cxa_find_matching_catch(-1, -1); var $434$1 = tempRet0;
 var $435=$434$0;
 $31=$435;
 var $436=$434$1;
 $32=$436;
 label=77;break;
 case 75: 
 var $438$0 = ___cxa_find_matching_catch(-1, -1); var $438$1 = tempRet0;
 var $439=$438$0;
 $31=$439;
 var $440=$438$1;
 $32=$440;
 var $441=$383;
 (function() { try { __THREW__ = 0; return __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEED2Ev($441,5812) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=76;break; } else { label=79;break; }
 case 76: 
 label=77;break;
 case 77: 
 var $444=$383;
 var $445=(($444+104)|0);
 var $446=$445;
 (function() { try { __THREW__ = 0; return __ZNSt3__19basic_iosIcNS_11char_traitsIcEEED2Ev($446) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=78;break; } else { label=79;break; }
 case 78: 
 var $448=$31;
 var $449=$32;
 var $450$0=$448;
 var $450$1=0;
 var $451$0=$450$0;
 var $451$1=$449;
 var $eh_lpad_body$1=$451$1;var $eh_lpad_body$0=$451$0;label=58;break;
 case 79: 
 var $453$0 = ___cxa_find_matching_catch(-1, -1,0); var $453$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
 case 80: 
 label=81;break;
 case 81: 
 $i3=0;
 label=82;break;
 case 82: 
 var $456=$i3;
 var $457=$num_players;
 var $458=($456|0)<($457|0);
 if($458){label=83;break;}else{label=122;break;}
 case 83: 
 var $460=(($partyFileName)|0);
 var $461=$i3;
 var $462=((($461)+(1))|0);
 var $463=(function() { try { __THREW__ = 0; return _sprintf($460,456,(tempVarArgs=STACKTOP,STACKTOP = (STACKTOP + 8)|0,(assert((STACKTOP|0) < (STACK_MAX|0))|0),HEAP32[((tempVarArgs)>>2)]=$462,tempVarArgs)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })(); STACKTOP=tempVarArgs;if (!__THREW__) { label=84;break; } else { label=94;break; }
 case 84: 
 var $465=(($partyFileName)|0);
 (function() { try { __THREW__ = 0; return __ZNSt3__114basic_ofstreamIcNS_11char_traitsIcEEE4openEPKcj($partyFile,$465,16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=85;break; } else { label=94;break; }
 case 85: 
 $22=$partyFile;
 var $467=$22;
 var $468=(($467+4)|0);
 $21=$468;
 var $469=$21;
 var $470=(($469+64)|0);
 var $471=HEAP32[(($470)>>2)];
 var $472=($471|0)!=0;
 label=86;break;
 case 86: 
 if($472){label=95;break;}else{label=87;break;}
 case 87: 
 var $475=(function() { try { __THREW__ = 0; return __ZNSt3__1lsINS_11char_traitsIcEEEERNS_13basic_ostreamIcT_EES6_PKc(14368,928) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=88;break; } else { label=94;break; }
 case 88: 
 var $477=(function() { try { __THREW__ = 0; return __ZNSt3__1lsINS_11char_traitsIcEEEERNS_13basic_ostreamIcT_EES6_PKc($475,288) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=89;break; } else { label=94;break; }
 case 89: 
 var $479=$i3;
 var $480=((($479)+(1))|0);
 var $481=(function() { try { __THREW__ = 0; return __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEElsEi($477,$480) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=90;break; } else { label=94;break; }
 case 90: 
 var $483=(function() { try { __THREW__ = 0; return __ZNSt3__1lsINS_11char_traitsIcEEEERNS_13basic_ostreamIcT_EES6_PKc($481,192) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=91;break; } else { label=94;break; }
 case 91: 
 $19=$483;
 $20=8;
 var $485=$19;
 var $486=$20;
 var $487=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$486]($485) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=92;break; } else { label=94;break; }
 case 92: 
 label=93;break;
 case 93: 
 $81=2;
 $91=1;
 label=123;break;
 case 94: 
 var $490$0 = ___cxa_find_matching_catch(-1, -1); var $490$1 = tempRet0;
 var $491=$490$0;
 $84=$491;
 var $492=$490$1;
 $85=$492;
 (function() { try { __THREW__ = 0; return __ZNSt3__114basic_ofstreamIcNS_11char_traitsIcEEED1Ev($partyFile) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=125;break; } else { label=139;break; }
 case 95: 
 var $494=$partyFile;
 $17=$shares;
 $18=0;
 var $495=$17;
 var $496=$18;
 var $497=$495;
 var $498=(($497)|0);
 var $499=HEAP32[(($498)>>2)];
 var $500=(($499+((($496)*(12))&-1))|0);
 label=96;break;
 case 96: 
 var $502=$i3;
 $15=$500;
 $16=$502;
 var $503=$15;
 var $504=$16;
 var $505=$503;
 var $506=(($505)|0);
 var $507=HEAP32[(($506)>>2)];
 var $508=(($507+((($504)*(28))&-1))|0);
 label=97;break;
 case 97: 
 var $510=(($508)|0);
 var $511=HEAP32[(($510)>>2)];
 var $512=(function() { try { __THREW__ = 0; return __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEElsEi($494,$511) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=98;break; } else { label=94;break; }
 case 98: 
 var $514=(function() { try { __THREW__ = 0; return __ZNSt3__1lsINS_11char_traitsIcEEEERNS_13basic_ostreamIcT_EES6_PKc($512,2192) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=99;break; } else { label=94;break; }
 case 99: 
 var $516=$num_players;
 var $517=(function() { try { __THREW__ = 0; return __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEElsEi($514,$516) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=100;break; } else { label=94;break; }
 case 100: 
 var $519=(function() { try { __THREW__ = 0; return __ZNSt3__1lsINS_11char_traitsIcEEEERNS_13basic_ostreamIcT_EES6_PKc($517,2192) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=101;break; } else { label=94;break; }
 case 101: 
 var $521=$threshold;
 var $522=(function() { try { __THREW__ = 0; return __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEElsEi($519,$521) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=102;break; } else { label=94;break; }
 case 102: 
 $13=$522;
 $14=8;
 var $524=$13;
 var $525=$14;
 var $526=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$525]($524) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=103;break; } else { label=94;break; }
 case 103: 
 label=104;break;
 case 104: 
 $j=0;
 label=105;break;
 case 105: 
 var $529=$j;
 $12=$shares;
 var $530=$12;
 var $531=$530;
 var $532=(($531+4)|0);
 var $533=HEAP32[(($532)>>2)];
 var $534=$530;
 var $535=(($534)|0);
 var $536=HEAP32[(($535)>>2)];
 var $537=$533;
 var $538=$536;
 var $539=((($537)-($538))|0);
 var $540=(((($539|0))/(12))&-1);
 var $541=($529>>>0)<($540>>>0);
 if($541){label=106;break;}else{label=115;break;}
 case 106: 
 var $543=$partyFile;
 var $544=$j;
 var $545=((($544)+(1))|0);
 var $546=(function() { try { __THREW__ = 0; return __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEElsEj($543,$545) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=107;break; } else { label=94;break; }
 case 107: 
 var $548=(function() { try { __THREW__ = 0; return __ZNSt3__1lsINS_11char_traitsIcEEEERNS_13basic_ostreamIcT_EES6_PKc($546,2192) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=108;break; } else { label=94;break; }
 case 108: 
 var $550=$j;
 $10=$shares;
 $11=$550;
 var $551=$10;
 var $552=$11;
 var $553=$551;
 var $554=(($553)|0);
 var $555=HEAP32[(($554)>>2)];
 var $556=(($555+((($552)*(12))&-1))|0);
 label=109;break;
 case 109: 
 var $558=$i3;
 $8=$556;
 $9=$558;
 var $559=$8;
 var $560=$9;
 var $561=$559;
 var $562=(($561)|0);
 var $563=HEAP32[(($562)>>2)];
 var $564=(($563+((($560)*(28))&-1))|0);
 label=110;break;
 case 110: 
 var $566=(($564+4)|0);
 var $567=(function() { try { __THREW__ = 0; return __ZlsRNSt3__113basic_ostreamIcNS_11char_traitsIcEEEERK12FieldElement($548,$566) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=111;break; } else { label=94;break; }
 case 111: 
 $6=$567;
 $7=8;
 var $569=$6;
 var $570=$7;
 var $571=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$570]($569) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=112;break; } else { label=94;break; }
 case 112: 
 label=113;break;
 case 113: 
 label=114;break;
 case 114: 
 var $574=$j;
 var $575=((($574)+(1))|0);
 $j=$575;
 label=105;break;
 case 115: 
 $5=$partyFile;
 var $577=$5;
 var $578=(($577+4)|0);
 var $579=(function() { try { __THREW__ = 0; return __ZNSt3__113basic_filebufIcNS_11char_traitsIcEEE5closeEv($578) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=116;break; } else { label=94;break; }
 case 116: 
 var $580=($579|0)==0;
 if($580){label=117;break;}else{label=119;break;}
 case 117: 
 var $582=$577;
 var $583=HEAP32[(($582)>>2)];
 var $584=((($583)-(12))|0);
 var $585=$584;
 var $586=HEAP32[(($585)>>2)];
 var $587=$577;
 var $588=(($587+$586)|0);
 var $589=$588;
 $3=$589;
 $4=4;
 var $590=$3;
 var $591=$590;
 var $592=$4;
 $1=$591;
 $2=$592;
 var $593=$1;
 var $594=(($593+16)|0);
 var $595=HEAP32[(($594)>>2)];
 var $596=$2;
 var $597=$595|$596;
 (function() { try { __THREW__ = 0; return __ZNSt3__18ios_base5clearEj($593,$597) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=118;break; } else { label=94;break; }
 case 118: 
 label=119;break;
 case 119: 
 label=120;break;
 case 120: 
 label=121;break;
 case 121: 
 var $600=$i3;
 var $601=((($600)+(1))|0);
 $i3=$601;
 label=82;break;
 case 122: 
 $81=0;
 $91=1;
 label=123;break;
 case 123: 
 (function() { try { __THREW__ = 0; return __ZNSt3__114basic_ofstreamIcNS_11char_traitsIcEEED1Ev($partyFile) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=124;break; } else { label=57;break; }
 case 124: 
 (function() { try { __THREW__ = 0; return __ZNSt3__16vectorINS0_INS_4pairIi12FieldElementEENS_9allocatorIS3_EEEENS4_IS6_EEED1Ev($shares) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=126;break; } else { label=56;break; }
 case 125: 
 label=127;break;
 case 126: 
 (function() { try { __THREW__ = 0; return __ZN12FieldElementD1Ev($secret) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=129;break; } else { label=55;break; }
 case 127: 
 (function() { try { __THREW__ = 0; return __ZNSt3__16vectorINS0_INS_4pairIi12FieldElementEENS_9allocatorIS3_EEEENS4_IS6_EEED1Ev($shares) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=128;break; } else { label=139;break; }
 case 128: 
 label=130;break;
 case 129: 
 (function() { try { __THREW__ = 0; return __ZNSt3__16vectorI10__gmp_exprI12__gmpz_valueS2_ENS_9allocatorIS3_EEED1Ev($code) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=132;break; } else { label=54;break; }
 case 130: 
 (function() { try { __THREW__ = 0; return __ZN12FieldElementD1Ev($secret) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=131;break; } else { label=139;break; }
 case 131: 
 label=133;break;
 case 132: 
 __ZN10__gmp_exprI12__gmpz_valueS0_ED1Ev($prime);
 label=137;break;
 case 133: 
 (function() { try { __THREW__ = 0; return __ZNSt3__16vectorI10__gmp_exprI12__gmpz_valueS2_ENS_9allocatorIS3_EEED1Ev($code) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=134;break; } else { label=139;break; }
 case 134: 
 label=135;break;
 case 135: 
 (function() { try { __THREW__ = 0; return __ZN10__gmp_exprI12__gmpz_valueS0_ED1Ev($prime) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=136;break; } else { label=139;break; }
 case 136: 
 label=138;break;
 case 137: 
 var $618=$81;
 STACKTOP=sp;return $618;
 case 138: 
 var $620=$84;
 var $621=$85;
 var $622$0=$620;
 var $622$1=0;
 var $623$0=$622$0;
 var $623$1=$621;
 ___resumeException($623$0)
 case 139: 
 var $625$0 = ___cxa_find_matching_catch(-1, -1,0); var $625$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
  default: assert(0, "bad label: " + label);
 }

}
Module["_main"] = _main;

function __ZN10__gmp_exprI12__gmpz_valueS0_EC1ERKS1_($this,$z){
 var label=0;
 var sp=STACKTOP; (assert((STACKTOP|0) < (STACK_MAX|0))|0);

 var $1;
 var $2;
 $1=$this;
 $2=$z;
 var $3=$1;
 var $4=$2;
 __ZN10__gmp_exprI12__gmpz_valueS0_EC2ERKS1_($3,$4);
 STACKTOP=sp;return;
}


function __ZNSt3__16vectorI10__gmp_exprI12__gmpz_valueS2_ENS_9allocatorIS3_EEE2atEj($this,$__n){
 var label=0;
 var sp=STACKTOP; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1;
 var $2;
 var $3;
 $2=$this;
 $3=$__n;
 var $4=$2;
 var $5=$3;
 $1=$4;
 var $6=$1;
 var $7=$6;
 var $8=(($7+4)|0);
 var $9=HEAP32[(($8)>>2)];
 var $10=$6;
 var $11=(($10)|0);
 var $12=HEAP32[(($11)>>2)];
 var $13=$9;
 var $14=$12;
 var $15=((($13)-($14))|0);
 var $16=(((($15|0))/(12))&-1);
 var $17=($5>>>0)>=($16>>>0);
 if($17){label=2;break;}else{label=3;break;}
 case 2: 
 var $19=$4;
 __ZNKSt3__120__vector_base_commonILb1EE20__throw_out_of_rangeEv($19);
 label=3;break;
 case 3: 
 var $21=$3;
 var $22=$4;
 var $23=(($22)|0);
 var $24=HEAP32[(($23)>>2)];
 var $25=(($24+((($21)*(12))&-1))|0);
 STACKTOP=sp;return $25;
  default: assert(0, "bad label: " + label);
 }

}


function __ZN12FieldElementD1Ev($this){
 var label=0;
 var sp=STACKTOP; (assert((STACKTOP|0) < (STACK_MAX|0))|0);

 var $1;
 $1=$this;
 var $2=$1;
 __ZN12FieldElementD2Ev($2);
 STACKTOP=sp;return;
}


function __ZN10__gmp_exprI12__gmpz_valueS0_ED1Ev($this){
 var label=0;
 var sp=STACKTOP; (assert((STACKTOP|0) < (STACK_MAX|0))|0);

 var $1;
 $1=$this;
 var $2=$1;
 __ZN10__gmp_exprI12__gmpz_valueS0_ED2Ev($2);
 STACKTOP=sp;return;
}


function __ZN12FieldElementC1ERKS_($this,$0){
 var label=0;
 var sp=STACKTOP; (assert((STACKTOP|0) < (STACK_MAX|0))|0);

 var $2;
 var $3;
 $2=$this;
 $3=$0;
 var $4=$2;
 var $5=$3;
 __ZN12FieldElementC2ERKS_($4,$5);
 STACKTOP=sp;return;
}


function __ZNSt3__16vectorINS_4pairIi12FieldElementEENS_9allocatorIS3_EEED1Ev($this){
 var label=0;
 var sp=STACKTOP; (assert((STACKTOP|0) < (STACK_MAX|0))|0);

 var $1;
 $1=$this;
 var $2=$1;
 __ZNSt3__16vectorINS_4pairIi12FieldElementEENS_9allocatorIS3_EEED2Ev($2);
 STACKTOP=sp;return;
}


function __ZNSt3__114basic_ofstreamIcNS_11char_traitsIcEEE4openEPKcj($this,$__s,$__mode){
 var label=0;
 var sp=STACKTOP; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1;
 var $2;
 var $3;
 var $4;
 var $5;
 var $6;
 var $7;
 var $8;
 var $9;
 $7=$this;
 $8=$__s;
 $9=$__mode;
 var $10=$7;
 var $11=(($10+4)|0);
 var $12=$8;
 var $13=$9;
 var $14=$13|16;
 var $15=__ZNSt3__113basic_filebufIcNS_11char_traitsIcEEE4openEPKcj($11,$12,$14);
 var $16=($15|0)!=0;
 if($16){label=2;break;}else{label=3;break;}
 case 2: 
 var $18=$10;
 var $19=HEAP32[(($18)>>2)];
 var $20=((($19)-(12))|0);
 var $21=$20;
 var $22=HEAP32[(($21)>>2)];
 var $23=$10;
 var $24=(($23+$22)|0);
 var $25=$24;
 $5=$25;
 $6=0;
 var $26=$5;
 var $27=$26;
 var $28=$6;
 __ZNSt3__18ios_base5clearEj($27,$28);
 label=4;break;
 case 3: 
 var $30=$10;
 var $31=HEAP32[(($30)>>2)];
 var $32=((($31)-(12))|0);
 var $33=$32;
 var $34=HEAP32[(($33)>>2)];
 var $35=$10;
 var $36=(($35+$34)|0);
 var $37=$36;
 $3=$37;
 $4=4;
 var $38=$3;
 var $39=$38;
 var $40=$4;
 $1=$39;
 $2=$40;
 var $41=$1;
 var $42=(($41+16)|0);
 var $43=HEAP32[(($42)>>2)];
 var $44=$2;
 var $45=$43|$44;
 __ZNSt3__18ios_base5clearEj($41,$45);
 label=4;break;
 case 4: 
 STACKTOP=sp;return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZlsRNSt3__113basic_ostreamIcNS_11char_traitsIcEEEERK12FieldElement($os,$a){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+16)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1;
 var $2;
 var $3=sp;
 var $4;
 var $5;
 $1=$os;
 $2=$a;
 var $6=$1;
 var $7=$2;
 __ZNK12FieldElement8getValueEv($3,$7);
 var $8=(function() { try { __THREW__ = 0; return __ZlsRNSt3__113basic_ostreamIcNS_11char_traitsIcEEEERK10__gmp_exprI12__gmpz_valueS6_E($6,$3) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=2;break; } else { label=3;break; }
 case 2: 
 __ZN10__gmp_exprI12__gmpz_valueS0_ED1Ev($3);
 var $10=$1;
 STACKTOP=sp;return $10;
 case 3: 
 var $12$0 = ___cxa_find_matching_catch(-1, -1); var $12$1 = tempRet0;
 var $13=$12$0;
 $4=$13;
 var $14=$12$1;
 $5=$14;
 (function() { try { __THREW__ = 0; return __ZN10__gmp_exprI12__gmpz_valueS0_ED1Ev($3) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=4;break; } else { label=6;break; }
 case 4: 
 label=5;break;
 case 5: 
 var $17=$4;
 var $18=$5;
 var $19$0=$17;
 var $19$1=0;
 var $20$0=$19$0;
 var $20$1=$18;
 ___resumeException($20$0)
 case 6: 
 var $22$0 = ___cxa_find_matching_catch(-1, -1,0); var $22$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__114basic_ofstreamIcNS_11char_traitsIcEEED1Ev($this){
 var label=0;
 var sp=STACKTOP; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1;
 var $2;
 var $3;
 $1=$this;
 var $4=$1;
 (function() { try { __THREW__ = 0; return __ZNSt3__114basic_ofstreamIcNS_11char_traitsIcEEED2Ev($4,5808) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=2;break; } else { label=3;break; }
 case 2: 
 var $6=$4;
 var $7=(($6+104)|0);
 var $8=$7;
 __ZNSt3__19basic_iosIcNS_11char_traitsIcEEED2Ev($8);
 STACKTOP=sp;return;
 case 3: 
 var $10$0 = ___cxa_find_matching_catch(-1, -1); var $10$1 = tempRet0;
 var $11=$10$0;
 $2=$11;
 var $12=$10$1;
 $3=$12;
 var $13=$4;
 var $14=(($13+104)|0);
 var $15=$14;
 (function() { try { __THREW__ = 0; return __ZNSt3__19basic_iosIcNS_11char_traitsIcEEED2Ev($15) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=4;break; } else { label=6;break; }
 case 4: 
 label=5;break;
 case 5: 
 var $18=$2;
 var $19=$3;
 var $20$0=$18;
 var $20$1=0;
 var $21$0=$20$0;
 var $21$1=$19;
 ___resumeException($21$0)
 case 6: 
 var $23$0 = ___cxa_find_matching_catch(-1, -1,0); var $23$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__16vectorINS0_INS_4pairIi12FieldElementEENS_9allocatorIS3_EEEENS4_IS6_EEED1Ev($this){
 var label=0;
 var sp=STACKTOP; (assert((STACKTOP|0) < (STACK_MAX|0))|0);

 var $1;
 $1=$this;
 var $2=$1;
 __ZNSt3__16vectorINS0_INS_4pairIi12FieldElementEENS_9allocatorIS3_EEEENS4_IS6_EEED2Ev($2);
 STACKTOP=sp;return;
}


function __ZNSt3__16vectorI10__gmp_exprI12__gmpz_valueS2_ENS_9allocatorIS3_EEED1Ev($this){
 var label=0;
 var sp=STACKTOP; (assert((STACKTOP|0) < (STACK_MAX|0))|0);

 var $1;
 $1=$this;
 var $2=$1;
 __ZNSt3__16vectorI10__gmp_exprI12__gmpz_valueS2_ENS_9allocatorIS3_EEED2Ev($2);
 STACKTOP=sp;return;
}


function __ZNSt3__113basic_filebufIcNS_11char_traitsIcEEE5closeEv($this){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+56)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1;
 var $2;
 var $3;
 var $4;
 var $5;
 var $__t_i;
 var $6;
 var $7;
 var $8;
 var $9;
 var $10;
 var $11;
 var $12;
 var $13;
 var $__tmp_i_i_i1;
 var $14;
 var $15;
 var $16;
 var $17;
 var $18;
 var $19;
 var $20;
 var $21;
 var $22;
 var $23;
 var $24;
 var $25;
 var $__tmp_i_i_i;
 var $26;
 var $27;
 var $28;
 var $29;
 var $30;
 var $31;
 var $32;
 var $33;
 var $34;
 var $35=sp;
 var $36=(sp)+(8);
 var $37;
 var $38;
 var $39=(sp)+(16);
 var $40=(sp)+(24);
 var $41;
 var $42;
 var $43;
 var $44;
 var $45;
 var $46=(sp)+(32);
 var $47=(sp)+(40);
 var $48;
 var $49;
 var $50;
 var $51;
 var $__rt;
 var $__h=(sp)+(48);
 var $52;
 var $53;
 $51=$this;
 var $54=$51;
 $__rt=0;
 var $55=(($54+64)|0);
 var $56=HEAP32[(($55)>>2)];
 var $57=($56|0)!=0;
 if($57){label=2;break;}else{label=20;break;}
 case 2: 
 $__rt=$54;
 var $59=(($54+64)|0);
 var $60=HEAP32[(($59)>>2)];
 $48=$__h;
 $49=$60;
 $50=490;
 var $61=$48;
 var $62=$49;
 var $63=$50;
 $45=$61;
 HEAP32[(($46)>>2)]=$62;
 HEAP32[(($47)>>2)]=$63;
 var $64=$45;
 var $65=(($64)|0);
 $44=$46;
 var $66=$44;
 var $67=HEAP32[(($66)>>2)];
 $30=$47;
 var $68=$30;
 var $69=HEAP32[(($68)>>2)];
 $41=$65;
 $42=$67;
 $43=$69;
 var $70=$41;
 var $71=$42;
 var $72=$43;
 $38=$70;
 HEAP32[(($39)>>2)]=$71;
 HEAP32[(($40)>>2)]=$72;
 var $73=$38;
 var $74=$73;
 $37=$39;
 var $75=$37;
 var $76=HEAP32[(($75)>>2)];
 $31=$40;
 var $77=$31;
 var $78=HEAP32[(($77)>>2)];
 $34=$74;
 HEAP32[(($35)>>2)]=$76;
 HEAP32[(($36)>>2)]=$78;
 var $79=$34;
 var $80=(($79)|0);
 $33=$35;
 var $81=$33;
 var $82=HEAP32[(($81)>>2)];
 HEAP32[(($80)>>2)]=$82;
 var $83=(($79+4)|0);
 $32=$36;
 var $84=$32;
 var $85=HEAP32[(($84)>>2)];
 HEAP32[(($83)>>2)]=$85;
 var $86=$54;
 var $87=HEAP32[(($86)>>2)];
 var $88=(($87+24)|0);
 var $89=HEAP32[(($88)>>2)];
 var $90=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$89]($54) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=3;break; } else { label=5;break; }
 case 3: 
 var $92=($90|0)!=0;
 if($92){label=4;break;}else{label=10;break;}
 case 4: 
 $__rt=0;
 label=10;break;
 case 5: 
 var $95$0 = ___cxa_find_matching_catch(-1, -1); var $95$1 = tempRet0;
 var $96=$95$0;
 $52=$96;
 var $97=$95$1;
 $53=$97;
 $17=$__h;
 var $98=$17;
 $16=$98;
 var $99=$16;
 $12=$99;
 $13=0;
 var $100=$12;
 var $101=(($100)|0);
 $11=$101;
 var $102=$11;
 var $103=$102;
 $10=$103;
 var $104=$10;
 var $105=(($104)|0);
 var $106=HEAP32[(($105)>>2)];
 $__tmp_i_i_i1=$106;
 var $107=$13;
 var $108=(($100)|0);
 $9=$108;
 var $109=$9;
 var $110=$109;
 $8=$110;
 var $111=$8;
 var $112=(($111)|0);
 HEAP32[(($112)>>2)]=$107;
 var $113=$__tmp_i_i_i1;
 var $114=($113|0)!=0;
 if($114){label=6;break;}else{label=9;break;}
 case 6: 
 var $116=(($100)|0);
 $7=$116;
 var $117=$7;
 var $118=$117;
 $6=$118;
 var $119=$6;
 var $120=(($119+4)|0);
 var $121=HEAP32[(($120)>>2)];
 var $122=$__tmp_i_i_i1;
 var $123=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$121]($122) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=7;break; } else { label=8;break; }
 case 7: 
 label=9;break;
 case 8: 
 var $126$0 = ___cxa_find_matching_catch(-1, -1,0); var $126$1 = tempRet0;
 var $127=$126$0;
 $14=$127;
 var $128=$126$1;
 $15=$128;
 var $129=$14;
 ___cxa_call_unexpected($129);
 throw "Reached an unreachable!";
 case 9: 
 label=19;break;
 case 10: 
 $5=$__h;
 var $131=$5;
 var $132=(($131)|0);
 $4=$132;
 var $133=$4;
 var $134=$133;
 $3=$134;
 var $135=$3;
 var $136=(($135)|0);
 var $137=HEAP32[(($136)>>2)];
 $__t_i=$137;
 var $138=(($131)|0);
 $2=$138;
 var $139=$2;
 var $140=$139;
 $1=$140;
 var $141=$1;
 var $142=(($141)|0);
 HEAP32[(($142)>>2)]=0;
 var $143=$__t_i;
 var $144=(function() { try { __THREW__ = 0; return _fclose($143) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=11;break; } else { label=5;break; }
 case 11: 
 var $146=($144|0)==0;
 if($146){label=12;break;}else{label=13;break;}
 case 12: 
 var $148=(($54+64)|0);
 HEAP32[(($148)>>2)]=0;
 label=14;break;
 case 13: 
 $__rt=0;
 label=14;break;
 case 14: 
 $29=$__h;
 var $151=$29;
 $28=$151;
 var $152=$28;
 $24=$152;
 $25=0;
 var $153=$24;
 var $154=(($153)|0);
 $23=$154;
 var $155=$23;
 var $156=$155;
 $22=$156;
 var $157=$22;
 var $158=(($157)|0);
 var $159=HEAP32[(($158)>>2)];
 $__tmp_i_i_i=$159;
 var $160=$25;
 var $161=(($153)|0);
 $21=$161;
 var $162=$21;
 var $163=$162;
 $20=$163;
 var $164=$20;
 var $165=(($164)|0);
 HEAP32[(($165)>>2)]=$160;
 var $166=$__tmp_i_i_i;
 var $167=($166|0)!=0;
 if($167){label=15;break;}else{label=18;break;}
 case 15: 
 var $169=(($153)|0);
 $19=$169;
 var $170=$19;
 var $171=$170;
 $18=$171;
 var $172=$18;
 var $173=(($172+4)|0);
 var $174=HEAP32[(($173)>>2)];
 var $175=$__tmp_i_i_i;
 var $176=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$174]($175) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=16;break; } else { label=17;break; }
 case 16: 
 label=18;break;
 case 17: 
 var $179$0 = ___cxa_find_matching_catch(-1, -1); var $179$1 = tempRet0;
 var $180=$179$0;
 $26=$180;
 var $181=$179$1;
 $27=$181;
 var $182=$26;
 ___cxa_call_unexpected($182);
 throw "Reached an unreachable!";
 case 18: 
 label=20;break;
 case 19: 
 label=21;break;
 case 20: 
 var $185=$__rt;
 STACKTOP=sp;return $185;
 case 21: 
 var $187=$52;
 var $188=$53;
 var $189$0=$187;
 var $189$1=0;
 var $190$0=$189$0;
 var $190$1=$188;
 ___resumeException($190$0)
 var $192$0 = ___cxa_find_matching_catch(-1, -1,0); var $192$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__113basic_filebufIcNS_11char_traitsIcEEE4openEPKcj($this,$__s,$__mode){
 var label=0;
 var sp=STACKTOP; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1;
 var $2;
 var $3;
 var $__rt;
 var $__mdstr;
 $1=$this;
 $2=$__s;
 $3=$__mode;
 var $4=$1;
 $__rt=0;
 var $5=(($4+64)|0);
 var $6=HEAP32[(($5)>>2)];
 var $7=($6|0)==0;
 if($7){label=2;break;}else{label=26;break;}
 case 2: 
 $__rt=$4;
 var $9=$3;
 var $10=$9&-3;
 switch(($10|0)){case 21:case 5:{ label=10;break;}case 12:{ label=11;break;}case 28:{ label=12;break;}case 60:{ label=13;break;}case 29:case 13:{ label=14;break;}case 16:case 48:{ label=3;break;}case 17:case 1:{ label=4;break;}case 8:{ label=5;break;}case 24:{ label=6;break;}case 56:{ label=7;break;}case 25:case 9:{ label=8;break;}case 20:case 52:{ label=9;break;}default:{label=15;break;}}break;
 case 3: 
 $__mdstr=2008;
 label=16;break;
 case 4: 
 $__mdstr=1736;
 label=16;break;
 case 5: 
 $__mdstr=1616;
 label=16;break;
 case 6: 
 $__mdstr=1560;
 label=16;break;
 case 7: 
 $__mdstr=1536;
 label=16;break;
 case 8: 
 $__mdstr=1520;
 label=16;break;
 case 9: 
 $__mdstr=1504;
 label=16;break;
 case 10: 
 $__mdstr=1488;
 label=16;break;
 case 11: 
 $__mdstr=1312;
 label=16;break;
 case 12: 
 $__mdstr=1464;
 label=16;break;
 case 13: 
 $__mdstr=1416;
 label=16;break;
 case 14: 
 $__mdstr=1408;
 label=16;break;
 case 15: 
 $__rt=0;
 label=16;break;
 case 16: 
 var $25=$__rt;
 var $26=($25|0)!=0;
 if($26){label=17;break;}else{label=25;break;}
 case 17: 
 var $28=$2;
 var $29=$__mdstr;
 var $30=_fopen($28,$29);
 var $31=(($4+64)|0);
 HEAP32[(($31)>>2)]=$30;
 var $32=(($4+64)|0);
 var $33=HEAP32[(($32)>>2)];
 var $34=($33|0)!=0;
 if($34){label=18;break;}else{label=23;break;}
 case 18: 
 var $36=$3;
 var $37=(($4+88)|0);
 HEAP32[(($37)>>2)]=$36;
 var $38=$3;
 var $39=$38&2;
 var $40=($39|0)!=0;
 if($40){label=19;break;}else{label=22;break;}
 case 19: 
 var $42=(($4+64)|0);
 var $43=HEAP32[(($42)>>2)];
 var $44=_fseek($43,0,2);
 var $45=($44|0)!=0;
 if($45){label=20;break;}else{label=21;break;}
 case 20: 
 var $47=(($4+64)|0);
 var $48=HEAP32[(($47)>>2)];
 var $49=_fclose($48);
 var $50=(($4+64)|0);
 HEAP32[(($50)>>2)]=0;
 $__rt=0;
 label=21;break;
 case 21: 
 label=22;break;
 case 22: 
 label=24;break;
 case 23: 
 $__rt=0;
 label=24;break;
 case 24: 
 label=25;break;
 case 25: 
 label=26;break;
 case 26: 
 var $57=$__rt;
 STACKTOP=sp;return $57;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__113basic_filebufIcNS_11char_traitsIcEEEC1Ev($this){
 var label=0;
 var sp=STACKTOP; (assert((STACKTOP|0) < (STACK_MAX|0))|0);

 var $1;
 $1=$this;
 var $2=$1;
 __ZNSt3__113basic_filebufIcNS_11char_traitsIcEEEC2Ev($2);
 STACKTOP=sp;return;
}


function __ZNSt3__114basic_ofstreamIcNS_11char_traitsIcEEED0Ev($this){
 var label=0;
 var sp=STACKTOP; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1;
 var $2;
 var $3;
 $1=$this;
 var $4=$1;
 (function() { try { __THREW__ = 0; return __ZNSt3__114basic_ofstreamIcNS_11char_traitsIcEEED1Ev($4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=2;break; } else { label=3;break; }
 case 2: 
 var $6=$4;
 __ZdlPv($6);
 STACKTOP=sp;return;
 case 3: 
 var $8$0 = ___cxa_find_matching_catch(-1, -1); var $8$1 = tempRet0;
 var $9=$8$0;
 $2=$9;
 var $10=$8$1;
 $3=$10;
 var $11=$4;
 __ZdlPv($11);
 label=4;break;
 case 4: 
 var $13=$2;
 var $14=$3;
 var $15$0=$13;
 var $15$1=0;
 var $16$0=$15$0;
 var $16$1=$14;
 ___resumeException($16$0)
  default: assert(0, "bad label: " + label);
 }

}


function __ZTv0_n12_NSt3__114basic_ofstreamIcNS_11char_traitsIcEEED1Ev($this){
 var label=0;
 var sp=STACKTOP; (assert((STACKTOP|0) < (STACK_MAX|0))|0);

 var $1;
 $1=$this;
 var $2=$1;
 var $3=$2;
 var $4=$3;
 var $5=HEAP32[(($4)>>2)];
 var $6=((($5)-(12))|0);
 var $7=$6;
 var $8=HEAP32[(($7)>>2)];
 var $9=(($3+$8)|0);
 var $10=$9;
 __ZNSt3__114basic_ofstreamIcNS_11char_traitsIcEEED1Ev($10);
 STACKTOP=sp;return;
}


function __ZTv0_n12_NSt3__114basic_ofstreamIcNS_11char_traitsIcEEED0Ev($this){
 var label=0;
 var sp=STACKTOP; (assert((STACKTOP|0) < (STACK_MAX|0))|0);

 var $1;
 $1=$this;
 var $2=$1;
 var $3=$2;
 var $4=$3;
 var $5=HEAP32[(($4)>>2)];
 var $6=((($5)-(12))|0);
 var $7=$6;
 var $8=HEAP32[(($7)>>2)];
 var $9=(($3+$8)|0);
 var $10=$9;
 __ZNSt3__114basic_ofstreamIcNS_11char_traitsIcEEED0Ev($10);
 STACKTOP=sp;return;
}


function __ZNSt3__114basic_ofstreamIcNS_11char_traitsIcEEED2Ev($this,$vtt){
 var label=0;
 var sp=STACKTOP; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1;
 var $2;
 var $3;
 var $4;
 $1=$this;
 $2=$vtt;
 var $5=$1;
 var $6=$2;
 var $7=HEAP32[(($6)>>2)];
 var $8=$5;
 HEAP32[(($8)>>2)]=$7;
 var $9=(($6+12)|0);
 var $10=HEAP32[(($9)>>2)];
 var $11=$5;
 var $12=HEAP32[(($11)>>2)];
 var $13=((($12)-(12))|0);
 var $14=$13;
 var $15=HEAP32[(($14)>>2)];
 var $16=$5;
 var $17=(($16+$15)|0);
 var $18=$17;
 HEAP32[(($18)>>2)]=$10;
 var $19=(($5+4)|0);
 (function() { try { __THREW__ = 0; return __ZNSt3__113basic_filebufIcNS_11char_traitsIcEEED1Ev($19) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=2;break; } else { label=3;break; }
 case 2: 
 var $21=$5;
 var $22=(($6+4)|0);
 __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEED2Ev($21,$22);
 STACKTOP=sp;return;
 case 3: 
 var $24$0 = ___cxa_find_matching_catch(-1, -1); var $24$1 = tempRet0;
 var $25=$24$0;
 $3=$25;
 var $26=$24$1;
 $4=$26;
 var $27=$5;
 var $28=(($6+4)|0);
 (function() { try { __THREW__ = 0; return __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEED2Ev($27,$28) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=4;break; } else { label=6;break; }
 case 4: 
 label=5;break;
 case 5: 
 var $31=$3;
 var $32=$4;
 var $33$0=$31;
 var $33$1=0;
 var $34$0=$33$0;
 var $34$1=$32;
 ___resumeException($34$0)
 case 6: 
 var $36$0 = ___cxa_find_matching_catch(-1, -1,0); var $36$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__113basic_filebufIcNS_11char_traitsIcEEED1Ev($this){
 var label=0;
 var sp=STACKTOP; (assert((STACKTOP|0) < (STACK_MAX|0))|0);

 var $1;
 $1=$this;
 var $2=$1;
 __ZNSt3__113basic_filebufIcNS_11char_traitsIcEEED2Ev($2);
 STACKTOP=sp;return;
}


function __ZNSt3__113basic_filebufIcNS_11char_traitsIcEEED2Ev($this){
 var label=0;
 var sp=STACKTOP; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1;
 var $2;
 var $3;
 $1=$this;
 var $4=$1;
 var $5=$4;
 HEAP32[(($5)>>2)]=5120;
 var $6=(function() { try { __THREW__ = 0; return __ZNSt3__113basic_filebufIcNS_11char_traitsIcEEE5closeEv($4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=2;break; } else { label=3;break; }
 case 2: 
 label=6;break;
 case 3: 
 var $9$0 = ___cxa_find_matching_catch(-1, -1,0); var $9$1 = tempRet0;
 var $10=$9$0;
 $2=$10;
 var $11=$9$1;
 $3=$11;
 label=4;break;
 case 4: 
 var $13=$2;
 var $14=___cxa_begin_catch($13);
 (function() { try { __THREW__ = 0; return ___cxa_end_catch() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=5;break; } else { label=10;break; }
 case 5: 
 label=6;break;
 case 6: 
 var $17=(($4+96)|0);
 var $18=HEAP8[($17)];
 var $19=(($18)&1);
 if($19){label=7;break;}else{label=11;break;}
 case 7: 
 var $21=(($4+32)|0);
 var $22=HEAP32[(($21)>>2)];
 var $23=($22|0)==0;
 if($23){label=9;break;}else{label=8;break;}
 case 8: 
 __ZdaPv($22);
 label=9;break;
 case 9: 
 label=11;break;
 case 10: 
 var $27$0 = ___cxa_find_matching_catch(-1, -1); var $27$1 = tempRet0;
 var $28=$27$0;
 $2=$28;
 var $29=$27$1;
 $3=$29;
 var $30=$4;
 (function() { try { __THREW__ = 0; return __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEED2Ev($30) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=16;break; } else { label=18;break; }
 case 11: 
 var $32=(($4+97)|0);
 var $33=HEAP8[($32)];
 var $34=(($33)&1);
 if($34){label=12;break;}else{label=15;break;}
 case 12: 
 var $36=(($4+56)|0);
 var $37=HEAP32[(($36)>>2)];
 var $38=($37|0)==0;
 if($38){label=14;break;}else{label=13;break;}
 case 13: 
 __ZdaPv($37);
 label=14;break;
 case 14: 
 label=15;break;
 case 15: 
 var $42=$4;
 __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEED2Ev($42);
 STACKTOP=sp;return;
 case 16: 
 label=17;break;
 case 17: 
 var $45=$2;
 var $46=$3;
 var $47$0=$45;
 var $47$1=0;
 var $48$0=$47$0;
 var $48$1=$46;
 ___resumeException($48$0)
 case 18: 
 var $50$0 = ___cxa_find_matching_catch(-1, -1,0); var $50$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__113basic_filebufIcNS_11char_traitsIcEEED0Ev($this){
 var label=0;
 var sp=STACKTOP; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1;
 var $2;
 var $3;
 $1=$this;
 var $4=$1;
 (function() { try { __THREW__ = 0; return __ZNSt3__113basic_filebufIcNS_11char_traitsIcEEED1Ev($4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=2;break; } else { label=3;break; }
 case 2: 
 var $6=$4;
 __ZdlPv($6);
 STACKTOP=sp;return;
 case 3: 
 var $8$0 = ___cxa_find_matching_catch(-1, -1); var $8$1 = tempRet0;
 var $9=$8$0;
 $2=$9;
 var $10=$8$1;
 $3=$10;
 var $11=$4;
 __ZdlPv($11);
 label=4;break;
 case 4: 
 var $13=$2;
 var $14=$3;
 var $15$0=$13;
 var $15$1=0;
 var $16$0=$15$0;
 var $16$1=$14;
 ___resumeException($16$0)
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__113basic_filebufIcNS_11char_traitsIcEEE5imbueERKNS_6localeE($this,$__loc){
 var label=0;
 var sp=STACKTOP; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1;
 var $2;
 var $3;
 var $4;
 var $5;
 var $6;
 var $7;
 var $8;
 var $9;
 var $10;
 var $11;
 var $__old_anc;
 $10=$this;
 $11=$__loc;
 var $12=$10;
 var $13=$12;
 var $14=HEAP32[(($13)>>2)];
 var $15=(($14+24)|0);
 var $16=HEAP32[(($15)>>2)];
 var $17=FUNCTION_TABLE[$16]($12);
 var $18=$11;
 $9=$18;
 var $19=$9;
 var $20=__ZNKSt3__16locale9use_facetERNS0_2idE($19,13792);
 var $21=$20;
 var $22=(($12+68)|0);
 HEAP32[(($22)>>2)]=$21;
 var $23=(($12+98)|0);
 var $24=HEAP8[($23)];
 var $25=(($24)&1);
 var $26=($25&1);
 $__old_anc=$26;
 var $27=(($12+68)|0);
 var $28=HEAP32[(($27)>>2)];
 $8=$28;
 var $29=$8;
 var $30=$29;
 var $31=HEAP32[(($30)>>2)];
 var $32=(($31+28)|0);
 var $33=HEAP32[(($32)>>2)];
 var $34=FUNCTION_TABLE[$33]($29);
 var $35=(($12+98)|0);
 var $36=($34&1);
 HEAP8[($35)]=$36;
 var $37=$__old_anc;
 var $38=(($37)&1);
 var $39=($38&1);
 var $40=(($12+98)|0);
 var $41=HEAP8[($40)];
 var $42=(($41)&1);
 var $43=($42&1);
 var $44=($39|0)!=($43|0);
 if($44){label=2;break;}else{label=14;break;}
 case 2: 
 var $46=$12;
 $4=$46;
 $5=0;
 $6=0;
 $7=0;
 var $47=$4;
 var $48=$5;
 var $49=(($47+8)|0);
 HEAP32[(($49)>>2)]=$48;
 var $50=$6;
 var $51=(($47+12)|0);
 HEAP32[(($51)>>2)]=$50;
 var $52=$7;
 var $53=(($47+16)|0);
 HEAP32[(($53)>>2)]=$52;
 var $54=$12;
 $1=$54;
 $2=0;
 $3=0;
 var $55=$1;
 var $56=$2;
 var $57=(($55+24)|0);
 HEAP32[(($57)>>2)]=$56;
 var $58=(($55+20)|0);
 HEAP32[(($58)>>2)]=$56;
 var $59=$3;
 var $60=(($55+28)|0);
 HEAP32[(($60)>>2)]=$59;
 var $61=(($12+98)|0);
 var $62=HEAP8[($61)];
 var $63=(($62)&1);
 if($63){label=3;break;}else{label=8;break;}
 case 3: 
 var $65=(($12+96)|0);
 var $66=HEAP8[($65)];
 var $67=(($66)&1);
 if($67){label=4;break;}else{label=7;break;}
 case 4: 
 var $69=(($12+32)|0);
 var $70=HEAP32[(($69)>>2)];
 var $71=($70|0)==0;
 if($71){label=6;break;}else{label=5;break;}
 case 5: 
 __ZdaPv($70);
 label=6;break;
 case 6: 
 label=7;break;
 case 7: 
 var $75=(($12+97)|0);
 var $76=HEAP8[($75)];
 var $77=(($76)&1);
 var $78=(($12+96)|0);
 var $79=($77&1);
 HEAP8[($78)]=$79;
 var $80=(($12+60)|0);
 var $81=HEAP32[(($80)>>2)];
 var $82=(($12+52)|0);
 HEAP32[(($82)>>2)]=$81;
 var $83=(($12+56)|0);
 var $84=HEAP32[(($83)>>2)];
 var $85=(($12+32)|0);
 HEAP32[(($85)>>2)]=$84;
 var $86=(($12+60)|0);
 HEAP32[(($86)>>2)]=0;
 var $87=(($12+56)|0);
 HEAP32[(($87)>>2)]=0;
 var $88=(($12+97)|0);
 HEAP8[($88)]=0;
 label=13;break;
 case 8: 
 var $90=(($12+96)|0);
 var $91=HEAP8[($90)];
 var $92=(($91)&1);
 if($92){label=11;break;}else{label=9;break;}
 case 9: 
 var $94=(($12+32)|0);
 var $95=HEAP32[(($94)>>2)];
 var $96=(($12+44)|0);
 var $97=(($96)|0);
 var $98=($95|0)!=($97|0);
 if($98){label=10;break;}else{label=11;break;}
 case 10: 
 var $100=(($12+52)|0);
 var $101=HEAP32[(($100)>>2)];
 var $102=(($12+60)|0);
 HEAP32[(($102)>>2)]=$101;
 var $103=(($12+32)|0);
 var $104=HEAP32[(($103)>>2)];
 var $105=(($12+56)|0);
 HEAP32[(($105)>>2)]=$104;
 var $106=(($12+97)|0);
 HEAP8[($106)]=0;
 var $107=(($12+52)|0);
 var $108=HEAP32[(($107)>>2)];
 var $109=__Znaj($108);
 var $110=(($12+32)|0);
 HEAP32[(($110)>>2)]=$109;
 var $111=(($12+96)|0);
 HEAP8[($111)]=1;
 label=12;break;
 case 11: 
 var $113=(($12+52)|0);
 var $114=HEAP32[(($113)>>2)];
 var $115=(($12+60)|0);
 HEAP32[(($115)>>2)]=$114;
 var $116=(($12+60)|0);
 var $117=HEAP32[(($116)>>2)];
 var $118=__Znaj($117);
 var $119=(($12+56)|0);
 HEAP32[(($119)>>2)]=$118;
 var $120=(($12+97)|0);
 HEAP8[($120)]=1;
 label=12;break;
 case 12: 
 label=13;break;
 case 13: 
 label=14;break;
 case 14: 
 STACKTOP=sp;return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__113basic_filebufIcNS_11char_traitsIcEEE6setbufEPci($this,$__s,$__n){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+32)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1;
 var $2;
 var $3;
 var $4;
 var $5;
 var $6;
 var $7;
 var $8;
 var $9=sp;
 var $10;
 var $11;
 var $12=(sp)+(8);
 var $13;
 var $14;
 var $15;
 var $16;
 var $17;
 var $18;
 var $19=(sp)+(16);
 var $20=(sp)+(24);
 $17=$this;
 $18=$__s;
 HEAP32[(($19)>>2)]=$__n;
 var $21=$17;
 var $22=$21;
 $13=$22;
 $14=0;
 $15=0;
 $16=0;
 var $23=$13;
 var $24=$14;
 var $25=(($23+8)|0);
 HEAP32[(($25)>>2)]=$24;
 var $26=$15;
 var $27=(($23+12)|0);
 HEAP32[(($27)>>2)]=$26;
 var $28=$16;
 var $29=(($23+16)|0);
 HEAP32[(($29)>>2)]=$28;
 var $30=$21;
 $1=$30;
 $2=0;
 $3=0;
 var $31=$1;
 var $32=$2;
 var $33=(($31+24)|0);
 HEAP32[(($33)>>2)]=$32;
 var $34=(($31+20)|0);
 HEAP32[(($34)>>2)]=$32;
 var $35=$3;
 var $36=(($31+28)|0);
 HEAP32[(($36)>>2)]=$35;
 var $37=(($21+96)|0);
 var $38=HEAP8[($37)];
 var $39=(($38)&1);
 if($39){label=2;break;}else{label=5;break;}
 case 2: 
 var $41=(($21+32)|0);
 var $42=HEAP32[(($41)>>2)];
 var $43=($42|0)==0;
 if($43){label=4;break;}else{label=3;break;}
 case 3: 
 __ZdaPv($42);
 label=4;break;
 case 4: 
 label=5;break;
 case 5: 
 var $47=(($21+97)|0);
 var $48=HEAP8[($47)];
 var $49=(($48)&1);
 if($49){label=6;break;}else{label=9;break;}
 case 6: 
 var $51=(($21+56)|0);
 var $52=HEAP32[(($51)>>2)];
 var $53=($52|0)==0;
 if($53){label=8;break;}else{label=7;break;}
 case 7: 
 __ZdaPv($52);
 label=8;break;
 case 8: 
 label=9;break;
 case 9: 
 var $57=HEAP32[(($19)>>2)];
 var $58=(($21+52)|0);
 HEAP32[(($58)>>2)]=$57;
 var $59=(($21+52)|0);
 var $60=HEAP32[(($59)>>2)];
 var $61=($60>>>0)>8;
 if($61){label=10;break;}else{label=15;break;}
 case 10: 
 var $63=(($21+98)|0);
 var $64=HEAP8[($63)];
 var $65=(($64)&1);
 if($65){label=11;break;}else{label=13;break;}
 case 11: 
 var $67=$18;
 var $68=($67|0)!=0;
 if($68){label=12;break;}else{label=13;break;}
 case 12: 
 var $70=$18;
 var $71=(($21+32)|0);
 HEAP32[(($71)>>2)]=$70;
 var $72=(($21+96)|0);
 HEAP8[($72)]=0;
 label=14;break;
 case 13: 
 var $74=(($21+52)|0);
 var $75=HEAP32[(($74)>>2)];
 var $76=__Znaj($75);
 var $77=(($21+32)|0);
 HEAP32[(($77)>>2)]=$76;
 var $78=(($21+96)|0);
 HEAP8[($78)]=1;
 label=14;break;
 case 14: 
 label=16;break;
 case 15: 
 var $81=(($21+44)|0);
 var $82=(($81)|0);
 var $83=(($21+32)|0);
 HEAP32[(($83)>>2)]=$82;
 var $84=(($21+52)|0);
 HEAP32[(($84)>>2)]=8;
 var $85=(($21+96)|0);
 HEAP8[($85)]=0;
 label=16;break;
 case 16: 
 var $87=(($21+98)|0);
 var $88=HEAP8[($87)];
 var $89=(($88)&1);
 if($89){label=25;break;}else{label=17;break;}
 case 17: 
 HEAP32[(($20)>>2)]=8;
 $10=$19;
 $11=$20;
 var $91=$10;
 var $92=$11;
 var $tmp_i=$9;
 var $tmp1_i=$12;
 assert(1 % 1 === 0);HEAP8[($tmp_i)]=HEAP8[($tmp1_i)];
 $7=$91;
 $8=$92;
 var $93=$7;
 var $94=$8;
 $4=$9;
 $5=$93;
 $6=$94;
 var $95=$4;
 var $96=$5;
 var $97=HEAP32[(($96)>>2)];
 var $98=$6;
 var $99=HEAP32[(($98)>>2)];
 var $100=($97|0)<($99|0);
 if($100){label=18;break;}else{label=19;break;}
 case 18: 
 var $102=$8;
 var $105=$102;label=20;break;
 case 19: 
 var $104=$7;
 var $105=$104;label=20;break;
 case 20: 
 var $105;
 var $106=HEAP32[(($105)>>2)];
 var $107=(($21+60)|0);
 HEAP32[(($107)>>2)]=$106;
 var $108=$18;
 var $109=($108|0)!=0;
 if($109){label=21;break;}else{label=23;break;}
 case 21: 
 var $111=(($21+60)|0);
 var $112=HEAP32[(($111)>>2)];
 var $113=($112>>>0)>=8;
 if($113){label=22;break;}else{label=23;break;}
 case 22: 
 var $115=$18;
 var $116=(($21+56)|0);
 HEAP32[(($116)>>2)]=$115;
 var $117=(($21+97)|0);
 HEAP8[($117)]=0;
 label=24;break;
 case 23: 
 var $119=(($21+60)|0);
 var $120=HEAP32[(($119)>>2)];
 var $121=__Znaj($120);
 var $122=(($21+56)|0);
 HEAP32[(($122)>>2)]=$121;
 var $123=(($21+97)|0);
 HEAP8[($123)]=1;
 label=24;break;
 case 24: 
 label=26;break;
 case 25: 
 var $126=(($21+60)|0);
 HEAP32[(($126)>>2)]=0;
 var $127=(($21+56)|0);
 HEAP32[(($127)>>2)]=0;
 var $128=(($21+97)|0);
 HEAP8[($128)]=0;
 label=26;break;
 case 26: 
 var $130=$21;
 STACKTOP=sp;return $130;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__113basic_filebufIcNS_11char_traitsIcEEE7seekoffExNS_8ios_base7seekdirEj($agg_result,$this,$__off$0,$__off$1,$__way,$0){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+104)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $2;
 var $3=sp;
 var $4;
 var $5=(sp)+(8);
 var $6;
 var $7=(sp)+(16);
 var $8;
 var $9=(sp)+(24);
 var $10;
 var $11=(sp)+(32);
 var $12;
 var $13=(sp)+(40);
 var $14;
 var $15=(sp)+(48);
 var $16;
 var $17=(sp)+(56);
 var $18;
 var $19=(sp)+(64);
 var $20;
 var $21;
 var $22=(sp)+(72);
 var $23;
 var $24;
 var $__width;
 var $__whence;
 var $__r=(sp)+(80);
 var $25=(sp)+(96);
 $21=$this;
 var $st$0$0=(($22)|0);
 HEAP32[(($st$0$0)>>2)]=$__off$0;
 var $st$1$1=(($22+4)|0);
 HEAP32[(($st$1$1)>>2)]=$__off$1;
 $23=$__way;
 $24=$0;
 var $26=$21;
 var $27=(($26+68)|0);
 var $28=HEAP32[(($27)>>2)];
 var $29=($28|0)!=0;
 if($29){label=3;break;}else{label=2;break;}
 case 2: 
 var $31=___cxa_allocate_exception(4);
 var $32=$31;
 __ZNSt8bad_castC2Ev($32);
 ___cxa_throw($31,8960,(368));
 throw "Reached an unreachable!";
 case 3: 
 var $34=(($26+68)|0);
 var $35=HEAP32[(($34)>>2)];
 $20=$35;
 var $36=$20;
 var $37=$36;
 var $38=HEAP32[(($37)>>2)];
 var $39=(($38+24)|0);
 var $40=HEAP32[(($39)>>2)];
 var $41=FUNCTION_TABLE[$40]($36);
 $__width=$41;
 var $42=(($26+64)|0);
 var $43=HEAP32[(($42)>>2)];
 var $44=($43|0)==0;
 if($44){label=7;break;}else{label=4;break;}
 case 4: 
 var $46=$__width;
 var $47=($46|0)<=0;
 if($47){label=5;break;}else{label=6;break;}
 case 5: 
 var $ld$2$0=(($22)|0);
 var $49$0=HEAP32[(($ld$2$0)>>2)];
 var $ld$3$1=(($22+4)|0);
 var $49$1=HEAP32[(($ld$3$1)>>2)];
 var $$etemp$4$0=0;
 var $$etemp$4$1=0;
 var $50=(($49$0|0) != ($$etemp$4$0|0)) | (($49$1|0) != ($$etemp$4$1|0));
 if($50){label=7;break;}else{label=6;break;}
 case 6: 
 var $52=$26;
 var $53=HEAP32[(($52)>>2)];
 var $54=(($53+24)|0);
 var $55=HEAP32[(($54)>>2)];
 var $56=FUNCTION_TABLE[$55]($26);
 var $57=($56|0)!=0;
 if($57){label=7;break;}else{label=8;break;}
 case 7: 
 $18=$agg_result;
 var $$etemp$5$0=-1;
 var $$etemp$5$1=-1;
 var $st$6$0=(($19)|0);
 HEAP32[(($st$6$0)>>2)]=$$etemp$5$0;
 var $st$7$1=(($19+4)|0);
 HEAP32[(($st$7$1)>>2)]=$$etemp$5$1;
 var $59=$18;
 var $ld$8$0=(($19)|0);
 var $60$0=HEAP32[(($ld$8$0)>>2)];
 var $ld$9$1=(($19+4)|0);
 var $60$1=HEAP32[(($ld$9$1)>>2)];
 $16=$59;
 var $st$10$0=(($17)|0);
 HEAP32[(($st$10$0)>>2)]=$60$0;
 var $st$11$1=(($17+4)|0);
 HEAP32[(($st$11$1)>>2)]=$60$1;
 var $61=$16;
 var $62=(($61)|0);
 var $63=$62;
 HEAP32[(($63)>>2)]=0; HEAP32[((($63)+(4))>>2)]=0;
 var $64=(($61+8)|0);
 var $ld$12$0=(($17)|0);
 var $65$0=HEAP32[(($ld$12$0)>>2)];
 var $ld$13$1=(($17+4)|0);
 var $65$1=HEAP32[(($ld$13$1)>>2)];
 var $st$14$0=(($64)|0);
 HEAP32[(($st$14$0)>>2)]=$65$0;
 var $st$15$1=(($64+4)|0);
 HEAP32[(($st$15$1)>>2)]=$65$1;
 label=19;break;
 case 8: 
 var $67=$23;
 if(($67|0)==1){ label=10;break;}else if(($67|0)==2){ label=11;break;}else if(($67|0)==0){ label=9;break;}else{label=12;break;}
 case 9: 
 $__whence=0;
 label=13;break;
 case 10: 
 $__whence=1;
 label=13;break;
 case 11: 
 $__whence=2;
 label=13;break;
 case 12: 
 $4=$agg_result;
 var $$etemp$16$0=-1;
 var $$etemp$16$1=-1;
 var $st$17$0=(($5)|0);
 HEAP32[(($st$17$0)>>2)]=$$etemp$16$0;
 var $st$18$1=(($5+4)|0);
 HEAP32[(($st$18$1)>>2)]=$$etemp$16$1;
 var $72=$4;
 var $ld$19$0=(($5)|0);
 var $73$0=HEAP32[(($ld$19$0)>>2)];
 var $ld$20$1=(($5+4)|0);
 var $73$1=HEAP32[(($ld$20$1)>>2)];
 $2=$72;
 var $st$21$0=(($3)|0);
 HEAP32[(($st$21$0)>>2)]=$73$0;
 var $st$22$1=(($3+4)|0);
 HEAP32[(($st$22$1)>>2)]=$73$1;
 var $74=$2;
 var $75=(($74)|0);
 var $76=$75;
 HEAP32[(($76)>>2)]=0; HEAP32[((($76)+(4))>>2)]=0;
 var $77=(($74+8)|0);
 var $ld$23$0=(($3)|0);
 var $78$0=HEAP32[(($ld$23$0)>>2)];
 var $ld$24$1=(($3+4)|0);
 var $78$1=HEAP32[(($ld$24$1)>>2)];
 var $st$25$0=(($77)|0);
 HEAP32[(($st$25$0)>>2)]=$78$0;
 var $st$26$1=(($77+4)|0);
 HEAP32[(($st$26$1)>>2)]=$78$1;
 label=19;break;
 case 13: 
 var $80=(($26+64)|0);
 var $81=HEAP32[(($80)>>2)];
 var $82=$__width;
 var $83=($82|0)>0;
 if($83){label=14;break;}else{label=15;break;}
 case 14: 
 var $85=$__width;
 var $86$0=$85;
 var $86$1=((((($85|0)<0))|0)?-1:0);
 var $ld$27$0=(($22)|0);
 var $87$0=HEAP32[(($ld$27$0)>>2)];
 var $ld$28$1=(($22+4)|0);
 var $87$1=HEAP32[(($ld$28$1)>>2)];
 var $88$0=___muldi3($86$0,$86$1,$87$0,$87$1);var $88$1=tempRet0;
 var $91$1=$88$1;var $91$0=$88$0;label=16;break;
 case 15: 
 var $91$1=0;var $91$0=0;label=16;break;
 case 16: 
 var $91$0;
 var $91$1;
 var $92$0=$91$0;
 var $92=$92$0;
 var $93=$__whence;
 var $94=_fseek($81,$92,$93);
 var $95=($94|0)!=0;
 if($95){label=17;break;}else{label=18;break;}
 case 17: 
 $8=$agg_result;
 var $$etemp$29$0=-1;
 var $$etemp$29$1=-1;
 var $st$30$0=(($9)|0);
 HEAP32[(($st$30$0)>>2)]=$$etemp$29$0;
 var $st$31$1=(($9+4)|0);
 HEAP32[(($st$31$1)>>2)]=$$etemp$29$1;
 var $97=$8;
 var $ld$32$0=(($9)|0);
 var $98$0=HEAP32[(($ld$32$0)>>2)];
 var $ld$33$1=(($9+4)|0);
 var $98$1=HEAP32[(($ld$33$1)>>2)];
 $6=$97;
 var $st$34$0=(($7)|0);
 HEAP32[(($st$34$0)>>2)]=$98$0;
 var $st$35$1=(($7+4)|0);
 HEAP32[(($st$35$1)>>2)]=$98$1;
 var $99=$6;
 var $100=(($99)|0);
 var $101=$100;
 HEAP32[(($101)>>2)]=0; HEAP32[((($101)+(4))>>2)]=0;
 var $102=(($99+8)|0);
 var $ld$36$0=(($7)|0);
 var $103$0=HEAP32[(($ld$36$0)>>2)];
 var $ld$37$1=(($7+4)|0);
 var $103$1=HEAP32[(($ld$37$1)>>2)];
 var $st$38$0=(($102)|0);
 HEAP32[(($st$38$0)>>2)]=$103$0;
 var $st$39$1=(($102+4)|0);
 HEAP32[(($st$39$1)>>2)]=$103$1;
 label=19;break;
 case 18: 
 var $105=(($26+64)|0);
 var $106=HEAP32[(($105)>>2)];
 var $107=_ftell($106);
 var $108$0=$107;
 var $108$1=((((($107|0)<0))|0)?-1:0);
 $12=$__r;
 var $st$40$0=(($13)|0);
 HEAP32[(($st$40$0)>>2)]=$108$0;
 var $st$41$1=(($13+4)|0);
 HEAP32[(($st$41$1)>>2)]=$108$1;
 var $109=$12;
 var $ld$42$0=(($13)|0);
 var $110$0=HEAP32[(($ld$42$0)>>2)];
 var $ld$43$1=(($13+4)|0);
 var $110$1=HEAP32[(($ld$43$1)>>2)];
 $10=$109;
 var $st$44$0=(($11)|0);
 HEAP32[(($st$44$0)>>2)]=$110$0;
 var $st$45$1=(($11+4)|0);
 HEAP32[(($st$45$1)>>2)]=$110$1;
 var $111=$10;
 var $112=(($111)|0);
 var $113=$112;
 HEAP32[(($113)>>2)]=0; HEAP32[((($113)+(4))>>2)]=0;
 var $114=(($111+8)|0);
 var $ld$46$0=(($11)|0);
 var $115$0=HEAP32[(($ld$46$0)>>2)];
 var $ld$47$1=(($11+4)|0);
 var $115$1=HEAP32[(($ld$47$1)>>2)];
 var $st$48$0=(($114)|0);
 HEAP32[(($st$48$0)>>2)]=$115$0;
 var $st$49$1=(($114+4)|0);
 HEAP32[(($st$49$1)>>2)]=$115$1;
 var $116=(($26+72)|0);
 var $117=$25;
 var $118=$116;
 assert(8 % 1 === 0);HEAP32[(($117)>>2)]=HEAP32[(($118)>>2)];HEAP32[((($117)+(4))>>2)]=HEAP32[((($118)+(4))>>2)];
 var $tmp=$15;
 var $tmp1=$25;
 assert(8 % 1 === 0);(_memcpy($tmp, $tmp1, 8)|0);
 $14=$__r;
 var $119=$14;
 var $120=(($119)|0);
 var $121=$120;
 var $122=$15;
 assert(8 % 1 === 0);HEAP32[(($121)>>2)]=HEAP32[(($122)>>2)];HEAP32[((($121)+(4))>>2)]=HEAP32[((($122)+(4))>>2)];
 var $123=$agg_result;
 var $124=$__r;
 assert(16 % 1 === 0);HEAP32[(($123)>>2)]=HEAP32[(($124)>>2)];HEAP32[((($123)+(4))>>2)]=HEAP32[((($124)+(4))>>2)];HEAP32[((($123)+(8))>>2)]=HEAP32[((($124)+(8))>>2)];HEAP32[((($123)+(12))>>2)]=HEAP32[((($124)+(12))>>2)];
 label=19;break;
 case 19: 
 STACKTOP=sp;return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__113basic_filebufIcNS_11char_traitsIcEEE7seekposENS_4fposI11__mbstate_tEEj($agg_result,$this,$__sp,$0){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+40)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var tempParam = $__sp; $__sp=STACKTOP;STACKTOP = (STACKTOP + 16)|0;(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__sp)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[((($__sp)+(4))>>2)]=HEAP32[(((tempParam)+(4))>>2)];HEAP32[((($__sp)+(8))>>2)]=HEAP32[(((tempParam)+(8))>>2)];HEAP32[((($__sp)+(12))>>2)]=HEAP32[(((tempParam)+(12))>>2)];
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $2;
 var $3;
 var $4=sp;
 var $5;
 var $6=(sp)+(8);
 var $7;
 var $8;
 var $9=(sp)+(16);
 var $10;
 var $11=(sp)+(24);
 var $12;
 var $13;
 var $14=(sp)+(32);
 $12=$this;
 $13=$0;
 var $15=$12;
 var $16=(($15+64)|0);
 var $17=HEAP32[(($16)>>2)];
 var $18=($17|0)==0;
 if($18){label=3;break;}else{label=2;break;}
 case 2: 
 var $20=$15;
 var $21=HEAP32[(($20)>>2)];
 var $22=(($21+24)|0);
 var $23=HEAP32[(($22)>>2)];
 var $24=FUNCTION_TABLE[$23]($15);
 var $25=($24|0)!=0;
 if($25){label=3;break;}else{label=4;break;}
 case 3: 
 $10=$agg_result;
 var $$etemp$0$0=-1;
 var $$etemp$0$1=-1;
 var $st$1$0=(($11)|0);
 HEAP32[(($st$1$0)>>2)]=$$etemp$0$0;
 var $st$2$1=(($11+4)|0);
 HEAP32[(($st$2$1)>>2)]=$$etemp$0$1;
 var $27=$10;
 var $ld$3$0=(($11)|0);
 var $28$0=HEAP32[(($ld$3$0)>>2)];
 var $ld$4$1=(($11+4)|0);
 var $28$1=HEAP32[(($ld$4$1)>>2)];
 $8=$27;
 var $st$5$0=(($9)|0);
 HEAP32[(($st$5$0)>>2)]=$28$0;
 var $st$6$1=(($9+4)|0);
 HEAP32[(($st$6$1)>>2)]=$28$1;
 var $29=$8;
 var $30=(($29)|0);
 var $31=$30;
 HEAP32[(($31)>>2)]=0; HEAP32[((($31)+(4))>>2)]=0;
 var $32=(($29+8)|0);
 var $ld$7$0=(($9)|0);
 var $33$0=HEAP32[(($ld$7$0)>>2)];
 var $ld$8$1=(($9+4)|0);
 var $33$1=HEAP32[(($ld$8$1)>>2)];
 var $st$9$0=(($32)|0);
 HEAP32[(($st$9$0)>>2)]=$33$0;
 var $st$10$1=(($32+4)|0);
 HEAP32[(($st$10$1)>>2)]=$33$1;
 label=7;break;
 case 4: 
 var $35=(($15+64)|0);
 var $36=HEAP32[(($35)>>2)];
 $2=$__sp;
 var $37=$2;
 var $38=(($37+8)|0);
 var $ld$11$0=(($38)|0);
 var $39$0=HEAP32[(($ld$11$0)>>2)];
 var $ld$12$1=(($38+4)|0);
 var $39$1=HEAP32[(($ld$12$1)>>2)];
 var $40$0=$39$0;
 var $40=$40$0;
 var $41=_fseek($36,$40,0);
 var $42=($41|0)!=0;
 if($42){label=5;break;}else{label=6;break;}
 case 5: 
 $5=$agg_result;
 var $$etemp$13$0=-1;
 var $$etemp$13$1=-1;
 var $st$14$0=(($6)|0);
 HEAP32[(($st$14$0)>>2)]=$$etemp$13$0;
 var $st$15$1=(($6+4)|0);
 HEAP32[(($st$15$1)>>2)]=$$etemp$13$1;
 var $44=$5;
 var $ld$16$0=(($6)|0);
 var $45$0=HEAP32[(($ld$16$0)>>2)];
 var $ld$17$1=(($6+4)|0);
 var $45$1=HEAP32[(($ld$17$1)>>2)];
 $3=$44;
 var $st$18$0=(($4)|0);
 HEAP32[(($st$18$0)>>2)]=$45$0;
 var $st$19$1=(($4+4)|0);
 HEAP32[(($st$19$1)>>2)]=$45$1;
 var $46=$3;
 var $47=(($46)|0);
 var $48=$47;
 HEAP32[(($48)>>2)]=0; HEAP32[((($48)+(4))>>2)]=0;
 var $49=(($46+8)|0);
 var $ld$20$0=(($4)|0);
 var $50$0=HEAP32[(($ld$20$0)>>2)];
 var $ld$21$1=(($4+4)|0);
 var $50$1=HEAP32[(($ld$21$1)>>2)];
 var $st$22$0=(($49)|0);
 HEAP32[(($st$22$0)>>2)]=$50$0;
 var $st$23$1=(($49+4)|0);
 HEAP32[(($st$23$1)>>2)]=$50$1;
 label=7;break;
 case 6: 
 var $52=(($15+72)|0);
 $7=$__sp;
 var $53=$7;
 var $54=(($53)|0);
 var $55=$14;
 var $56=$54;
 assert(8 % 1 === 0);HEAP32[(($55)>>2)]=HEAP32[(($56)>>2)];HEAP32[((($55)+(4))>>2)]=HEAP32[((($56)+(4))>>2)];
 var $57=$52;
 var $58=$14;
 assert(8 % 1 === 0);HEAP32[(($57)>>2)]=HEAP32[(($58)>>2)];HEAP32[((($57)+(4))>>2)]=HEAP32[((($58)+(4))>>2)];
 var $59=$agg_result;
 var $60=$__sp;
 assert(16 % 1 === 0);HEAP32[(($59)>>2)]=HEAP32[(($60)>>2)];HEAP32[((($59)+(4))>>2)]=HEAP32[((($60)+(4))>>2)];HEAP32[((($59)+(8))>>2)]=HEAP32[((($60)+(8))>>2)];HEAP32[((($59)+(12))>>2)]=HEAP32[((($60)+(12))>>2)];
 label=7;break;
 case 7: 
 STACKTOP=sp;return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__113basic_filebufIcNS_11char_traitsIcEEE4syncEv($this){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+24)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1;
 var $2;
 var $3;
 var $4;
 var $5;
 var $6;
 var $7;
 var $8;
 var $9;
 var $10;
 var $11;
 var $12;
 var $13;
 var $14;
 var $15;
 var $16;
 var $17;
 var $18;
 var $19;
 var $20;
 var $21;
 var $22;
 var $23;
 var $24;
 var $25;
 var $26;
 var $27;
 var $__r;
 var $__extbe=sp;
 var $__nmemb;
 var $__c=(sp)+(8);
 var $__state=(sp)+(16);
 var $__update_st;
 var $__width;
 var $__off;
 $27=$this;
 var $28=$27;
 var $29=(($28+64)|0);
 var $30=HEAP32[(($29)>>2)];
 var $31=($30|0)==0;
 if($31){label=2;break;}else{label=3;break;}
 case 2: 
 $26=0;
 label=36;break;
 case 3: 
 var $34=(($28+68)|0);
 var $35=HEAP32[(($34)>>2)];
 var $36=($35|0)!=0;
 if($36){label=5;break;}else{label=4;break;}
 case 4: 
 var $38=___cxa_allocate_exception(4);
 var $39=$38;
 __ZNSt8bad_castC2Ev($39);
 ___cxa_throw($38,8960,(368));
 throw "Reached an unreachable!";
 case 5: 
 var $41=(($28+92)|0);
 var $42=HEAP32[(($41)>>2)];
 var $43=$42&16;
 var $44=($43|0)!=0;
 if($44){label=6;break;}else{label=20;break;}
 case 6: 
 var $46=$28;
 $25=$46;
 var $47=$25;
 var $48=(($47+24)|0);
 var $49=HEAP32[(($48)>>2)];
 var $50=$28;
 $15=$50;
 var $51=$15;
 var $52=(($51+20)|0);
 var $53=HEAP32[(($52)>>2)];
 var $54=($49|0)!=($53|0);
 if($54){label=7;break;}else{label=10;break;}
 case 7: 
 var $56=$28;
 var $57=HEAP32[(($56)>>2)];
 var $58=(($57+52)|0);
 var $59=HEAP32[(($58)>>2)];
 var $60=FUNCTION_TABLE[$59]($28,-1);
 var $61=($60|0)==-1;
 if($61){label=8;break;}else{label=9;break;}
 case 8: 
 $26=-1;
 label=36;break;
 case 9: 
 label=10;break;
 case 10: 
 label=11;break;
 case 11: 
 var $66=(($28+68)|0);
 var $67=HEAP32[(($66)>>2)];
 var $68=(($28+72)|0);
 var $69=(($28+32)|0);
 var $70=HEAP32[(($69)>>2)];
 var $71=(($28+32)|0);
 var $72=HEAP32[(($71)>>2)];
 var $73=(($28+52)|0);
 var $74=HEAP32[(($73)>>2)];
 var $75=(($72+$74)|0);
 $1=$67;
 $2=$68;
 $3=$70;
 $4=$75;
 $5=$__extbe;
 var $76=$1;
 var $77=$76;
 var $78=HEAP32[(($77)>>2)];
 var $79=(($78+20)|0);
 var $80=HEAP32[(($79)>>2)];
 var $81=$2;
 var $82=$3;
 var $83=$4;
 var $84=$5;
 var $85=FUNCTION_TABLE[$80]($76,$81,$82,$83,$84);
 $__r=$85;
 var $86=HEAP32[(($__extbe)>>2)];
 var $87=(($28+32)|0);
 var $88=HEAP32[(($87)>>2)];
 var $89=$86;
 var $90=$88;
 var $91=((($89)-($90))|0);
 $__nmemb=$91;
 var $92=(($28+32)|0);
 var $93=HEAP32[(($92)>>2)];
 var $94=$__nmemb;
 var $95=(($28+64)|0);
 var $96=HEAP32[(($95)>>2)];
 var $97=_fwrite($93,1,$94,$96);
 var $98=$__nmemb;
 var $99=($97|0)!=($98|0);
 if($99){label=12;break;}else{label=13;break;}
 case 12: 
 $26=-1;
 label=36;break;
 case 13: 
 label=14;break;
 case 14: 
 var $103=$__r;
 var $104=($103|0)==1;
 if($104){label=11;break;}else{label=15;break;}
 case 15: 
 var $106=$__r;
 var $107=($106|0)==2;
 if($107){label=16;break;}else{label=17;break;}
 case 16: 
 $26=-1;
 label=36;break;
 case 17: 
 var $110=(($28+64)|0);
 var $111=HEAP32[(($110)>>2)];
 var $112=_fflush($111);
 var $113=($112|0)!=0;
 if($113){label=18;break;}else{label=19;break;}
 case 18: 
 $26=-1;
 label=36;break;
 case 19: 
 label=35;break;
 case 20: 
 var $117=(($28+92)|0);
 var $118=HEAP32[(($117)>>2)];
 var $119=$118&8;
 var $120=($119|0)!=0;
 if($120){label=21;break;}else{label=34;break;}
 case 21: 
 var $122=(($28+80)|0);
 var $123=$__state;
 var $124=$122;
 assert(8 % 1 === 0);HEAP32[(($123)>>2)]=HEAP32[(($124)>>2)];HEAP32[((($123)+(4))>>2)]=HEAP32[((($124)+(4))>>2)];
 $__update_st=0;
 var $125=(($28+98)|0);
 var $126=HEAP8[($125)];
 var $127=(($126)&1);
 if($127){label=22;break;}else{label=23;break;}
 case 22: 
 var $129=$28;
 $6=$129;
 var $130=$6;
 var $131=(($130+16)|0);
 var $132=HEAP32[(($131)>>2)];
 var $133=$28;
 $7=$133;
 var $134=$7;
 var $135=(($134+12)|0);
 var $136=HEAP32[(($135)>>2)];
 var $137=$132;
 var $138=$136;
 var $139=((($137)-($138))|0);
 var $140$0=$139;
 var $140$1=((((($139|0)<0))|0)?-1:0);
 var $st$0$0=(($__c)|0);
 HEAP32[(($st$0$0)>>2)]=$140$0;
 var $st$1$1=(($__c+4)|0);
 HEAP32[(($st$1$1)>>2)]=$140$1;
 label=29;break;
 case 23: 
 var $142=(($28+68)|0);
 var $143=HEAP32[(($142)>>2)];
 $8=$143;
 var $144=$8;
 var $145=$144;
 var $146=HEAP32[(($145)>>2)];
 var $147=(($146+24)|0);
 var $148=HEAP32[(($147)>>2)];
 var $149=FUNCTION_TABLE[$148]($144);
 $__width=$149;
 var $150=(($28+40)|0);
 var $151=HEAP32[(($150)>>2)];
 var $152=(($28+36)|0);
 var $153=HEAP32[(($152)>>2)];
 var $154=$151;
 var $155=$153;
 var $156=((($154)-($155))|0);
 var $157$0=$156;
 var $157$1=((((($156|0)<0))|0)?-1:0);
 var $st$2$0=(($__c)|0);
 HEAP32[(($st$2$0)>>2)]=$157$0;
 var $st$3$1=(($__c+4)|0);
 HEAP32[(($st$3$1)>>2)]=$157$1;
 var $158=$__width;
 var $159=($158|0)>0;
 if($159){label=24;break;}else{label=25;break;}
 case 24: 
 var $161=$__width;
 var $162=$28;
 $9=$162;
 var $163=$9;
 var $164=(($163+16)|0);
 var $165=HEAP32[(($164)>>2)];
 var $166=$28;
 $10=$166;
 var $167=$10;
 var $168=(($167+12)|0);
 var $169=HEAP32[(($168)>>2)];
 var $170=$165;
 var $171=$169;
 var $172=((($170)-($171))|0);
 var $173=(Math_imul($161,$172)|0);
 var $174$0=$173;
 var $174$1=((((($173|0)<0))|0)?-1:0);
 var $ld$4$0=(($__c)|0);
 var $175$0=HEAP32[(($ld$4$0)>>2)];
 var $ld$5$1=(($__c+4)|0);
 var $175$1=HEAP32[(($ld$5$1)>>2)];
 var $176$0=_i64Add($175$0,$175$1,$174$0,$174$1);var $176$1=tempRet0;
 var $st$6$0=(($__c)|0);
 HEAP32[(($st$6$0)>>2)]=$176$0;
 var $st$7$1=(($__c+4)|0);
 HEAP32[(($st$7$1)>>2)]=$176$1;
 label=28;break;
 case 25: 
 var $178=$28;
 $11=$178;
 var $179=$11;
 var $180=(($179+12)|0);
 var $181=HEAP32[(($180)>>2)];
 var $182=$28;
 $12=$182;
 var $183=$12;
 var $184=(($183+16)|0);
 var $185=HEAP32[(($184)>>2)];
 var $186=($181|0)!=($185|0);
 if($186){label=26;break;}else{label=27;break;}
 case 26: 
 var $188=(($28+68)|0);
 var $189=HEAP32[(($188)>>2)];
 var $190=(($28+32)|0);
 var $191=HEAP32[(($190)>>2)];
 var $192=(($28+36)|0);
 var $193=HEAP32[(($192)>>2)];
 var $194=$28;
 $13=$194;
 var $195=$13;
 var $196=(($195+12)|0);
 var $197=HEAP32[(($196)>>2)];
 var $198=$28;
 $14=$198;
 var $199=$14;
 var $200=(($199+8)|0);
 var $201=HEAP32[(($200)>>2)];
 var $202=$197;
 var $203=$201;
 var $204=((($202)-($203))|0);
 $16=$189;
 $17=$__state;
 $18=$191;
 $19=$193;
 $20=$204;
 var $205=$16;
 var $206=$205;
 var $207=HEAP32[(($206)>>2)];
 var $208=(($207+32)|0);
 var $209=HEAP32[(($208)>>2)];
 var $210=$17;
 var $211=$18;
 var $212=$19;
 var $213=$20;
 var $214=FUNCTION_TABLE[$209]($205,$210,$211,$212,$213);
 $__off=$214;
 var $215=(($28+36)|0);
 var $216=HEAP32[(($215)>>2)];
 var $217=(($28+32)|0);
 var $218=HEAP32[(($217)>>2)];
 var $219=$216;
 var $220=$218;
 var $221=((($219)-($220))|0);
 var $222=$__off;
 var $223=((($221)-($222))|0);
 var $224$0=$223;
 var $224$1=((((($223|0)<0))|0)?-1:0);
 var $ld$8$0=(($__c)|0);
 var $225$0=HEAP32[(($ld$8$0)>>2)];
 var $ld$9$1=(($__c+4)|0);
 var $225$1=HEAP32[(($ld$9$1)>>2)];
 var $226$0=_i64Add($225$0,$225$1,$224$0,$224$1);var $226$1=tempRet0;
 var $st$10$0=(($__c)|0);
 HEAP32[(($st$10$0)>>2)]=$226$0;
 var $st$11$1=(($__c+4)|0);
 HEAP32[(($st$11$1)>>2)]=$226$1;
 $__update_st=1;
 label=27;break;
 case 27: 
 label=28;break;
 case 28: 
 label=29;break;
 case 29: 
 var $230=(($28+64)|0);
 var $231=HEAP32[(($230)>>2)];
 var $ld$12$0=(($__c)|0);
 var $232$0=HEAP32[(($ld$12$0)>>2)];
 var $ld$13$1=(($__c+4)|0);
 var $232$1=HEAP32[(($ld$13$1)>>2)];
 var $$etemp$14$0=0;
 var $$etemp$14$1=0;
 var $233$0=_i64Subtract($$etemp$14$0,$$etemp$14$1,$232$0,$232$1);var $233$1=tempRet0;
 var $234$0=$233$0;
 var $234=$234$0;
 var $235=_fseek($231,$234,1);
 var $236=($235|0)!=0;
 if($236){label=30;break;}else{label=31;break;}
 case 30: 
 $26=-1;
 label=36;break;
 case 31: 
 var $239=$__update_st;
 var $240=(($239)&1);
 if($240){label=32;break;}else{label=33;break;}
 case 32: 
 var $242=(($28+72)|0);
 var $243=$242;
 var $244=$__state;
 assert(8 % 1 === 0);HEAP32[(($243)>>2)]=HEAP32[(($244)>>2)];HEAP32[((($243)+(4))>>2)]=HEAP32[((($244)+(4))>>2)];
 label=33;break;
 case 33: 
 var $246=(($28+32)|0);
 var $247=HEAP32[(($246)>>2)];
 var $248=(($28+40)|0);
 HEAP32[(($248)>>2)]=$247;
 var $249=(($28+36)|0);
 HEAP32[(($249)>>2)]=$247;
 var $250=$28;
 $21=$250;
 $22=0;
 $23=0;
 $24=0;
 var $251=$21;
 var $252=$22;
 var $253=(($251+8)|0);
 HEAP32[(($253)>>2)]=$252;
 var $254=$23;
 var $255=(($251+12)|0);
 HEAP32[(($255)>>2)]=$254;
 var $256=$24;
 var $257=(($251+16)|0);
 HEAP32[(($257)>>2)]=$256;
 var $258=(($28+92)|0);
 HEAP32[(($258)>>2)]=0;
 label=34;break;
 case 34: 
 label=35;break;
 case 35: 
 $26=0;
 label=36;break;
 case 36: 
 var $262=$26;
 STACKTOP=sp;return $262;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__113basic_filebufIcNS_11char_traitsIcEEE9underflowEv($this){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+80)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1;
 var $2;
 var $3;
 var $4;
 var $5;
 var $6;
 var $7;
 var $8;
 var $9;
 var $10;
 var $11;
 var $12=sp;
 var $13;
 var $14;
 var $15=(sp)+(8);
 var $16;
 var $17;
 var $18;
 var $19;
 var $20;
 var $21;
 var $22;
 var $23;
 var $24;
 var $25;
 var $26;
 var $27;
 var $28;
 var $29;
 var $30;
 var $31;
 var $32;
 var $33;
 var $34;
 var $35;
 var $36;
 var $37=(sp)+(16);
 var $38;
 var $39;
 var $40=(sp)+(24);
 var $41;
 var $42;
 var $43;
 var $44;
 var $45;
 var $46;
 var $47;
 var $48;
 var $49;
 var $50;
 var $51;
 var $52;
 var $53;
 var $54;
 var $55;
 var $56;
 var $57;
 var $58;
 var $59;
 var $60;
 var $61;
 var $62;
 var $63;
 var $64;
 var $65;
 var $66;
 var $67;
 var $68;
 var $69;
 var $70;
 var $71;
 var $72;
 var $73;
 var $74;
 var $75;
 var $__initial;
 var $__1buf=(sp)+(32);
 var $__unget_sz;
 var $76=(sp)+(40);
 var $77=(sp)+(48);
 var $__c;
 var $__nmemb;
 var $__nmemb1;
 var $78=(sp)+(56);
 var $79=(sp)+(64);
 var $__r;
 var $__nr;
 var $__inext=(sp)+(72);
 $75=$this;
 var $80=$75;
 var $81=(($80+64)|0);
 var $82=HEAP32[(($81)>>2)];
 var $83=($82|0)==0;
 if($83){label=2;break;}else{label=3;break;}
 case 2: 
 $74=-1;
 label=37;break;
 case 3: 
 var $86=__ZNSt3__113basic_filebufIcNS_11char_traitsIcEEE11__read_modeEv($80);
 var $87=($86&1);
 $__initial=$87;
 var $88=$80;
 $43=$88;
 var $89=$43;
 var $90=(($89+12)|0);
 var $91=HEAP32[(($90)>>2)];
 var $92=($91|0)==0;
 if($92){label=4;break;}else{label=5;break;}
 case 4: 
 var $94=$80;
 var $95=(($__1buf+1)|0);
 var $96=(($__1buf+1)|0);
 $1=$94;
 $2=$__1buf;
 $3=$95;
 $4=$96;
 var $97=$1;
 var $98=$2;
 var $99=(($97+8)|0);
 HEAP32[(($99)>>2)]=$98;
 var $100=$3;
 var $101=(($97+12)|0);
 HEAP32[(($101)>>2)]=$100;
 var $102=$4;
 var $103=(($97+16)|0);
 HEAP32[(($103)>>2)]=$102;
 label=5;break;
 case 5: 
 var $105=$__initial;
 var $106=(($105)&1);
 if($106){label=6;break;}else{label=7;break;}
 case 6: 
 var $138=0;label=11;break;
 case 7: 
 var $109=$80;
 $5=$109;
 var $110=$5;
 var $111=(($110+16)|0);
 var $112=HEAP32[(($111)>>2)];
 var $113=$80;
 $6=$113;
 var $114=$6;
 var $115=(($114+8)|0);
 var $116=HEAP32[(($115)>>2)];
 var $117=$112;
 var $118=$116;
 var $119=((($117)-($118))|0);
 var $120=(((($119|0))/(2))&-1);
 HEAP32[(($76)>>2)]=$120;
 HEAP32[(($77)>>2)]=4;
 $13=$76;
 $14=$77;
 var $121=$13;
 var $122=$14;
 var $tmp_i2=$12;
 var $tmp1_i3=$15;
 assert(1 % 1 === 0);HEAP8[($tmp_i2)]=HEAP8[($tmp1_i3)];
 $10=$121;
 $11=$122;
 var $123=$11;
 var $124=$10;
 $7=$12;
 $8=$123;
 $9=$124;
 var $125=$7;
 var $126=$8;
 var $127=HEAP32[(($126)>>2)];
 var $128=$9;
 var $129=HEAP32[(($128)>>2)];
 var $130=($127>>>0)<($129>>>0);
 if($130){label=8;break;}else{label=9;break;}
 case 8: 
 var $132=$11;
 var $135=$132;label=10;break;
 case 9: 
 var $134=$10;
 var $135=$134;label=10;break;
 case 10: 
 var $135;
 var $136=HEAP32[(($135)>>2)];
 var $138=$136;label=11;break;
 case 11: 
 var $138;
 $__unget_sz=$138;
 $__c=-1;
 var $139=$80;
 $16=$139;
 var $140=$16;
 var $141=(($140+12)|0);
 var $142=HEAP32[(($141)>>2)];
 var $143=$80;
 $17=$143;
 var $144=$17;
 var $145=(($144+16)|0);
 var $146=HEAP32[(($145)>>2)];
 var $147=($142|0)==($146|0);
 if($147){label=12;break;}else{label=33;break;}
 case 12: 
 var $149=$80;
 $18=$149;
 var $150=$18;
 var $151=(($150+8)|0);
 var $152=HEAP32[(($151)>>2)];
 var $153=$80;
 $19=$153;
 var $154=$19;
 var $155=(($154+16)|0);
 var $156=HEAP32[(($155)>>2)];
 var $157=$__unget_sz;
 var $158=(((-$157))|0);
 var $159=(($156+$158)|0);
 var $160=$__unget_sz;
 var $161=$160;
 _memmove($152,$159,$161,1,0);
 var $162=(($80+98)|0);
 var $163=HEAP8[($162)];
 var $164=(($163)&1);
 if($164){label=13;break;}else{label=16;break;}
 case 13: 
 var $166=$80;
 $20=$166;
 var $167=$20;
 var $168=(($167+16)|0);
 var $169=HEAP32[(($168)>>2)];
 var $170=$80;
 $21=$170;
 var $171=$21;
 var $172=(($171+8)|0);
 var $173=HEAP32[(($172)>>2)];
 var $174=$169;
 var $175=$173;
 var $176=((($174)-($175))|0);
 var $177=$__unget_sz;
 var $178=((($176)-($177))|0);
 $__nmemb=$178;
 var $179=$80;
 $22=$179;
 var $180=$22;
 var $181=(($180+8)|0);
 var $182=HEAP32[(($181)>>2)];
 var $183=$__unget_sz;
 var $184=(($182+$183)|0);
 var $185=$__nmemb;
 var $186=(($80+64)|0);
 var $187=HEAP32[(($186)>>2)];
 var $188=_fread($184,1,$185,$187);
 $__nmemb=$188;
 var $189=$__nmemb;
 var $190=($189|0)!=0;
 if($190){label=14;break;}else{label=15;break;}
 case 14: 
 var $192=$80;
 var $193=$80;
 $23=$193;
 var $194=$23;
 var $195=(($194+8)|0);
 var $196=HEAP32[(($195)>>2)];
 var $197=$80;
 $24=$197;
 var $198=$24;
 var $199=(($198+8)|0);
 var $200=HEAP32[(($199)>>2)];
 var $201=$__unget_sz;
 var $202=(($200+$201)|0);
 var $203=$80;
 $25=$203;
 var $204=$25;
 var $205=(($204+8)|0);
 var $206=HEAP32[(($205)>>2)];
 var $207=$__unget_sz;
 var $208=(($206+$207)|0);
 var $209=$__nmemb;
 var $210=(($208+$209)|0);
 $26=$192;
 $27=$196;
 $28=$202;
 $29=$210;
 var $211=$26;
 var $212=$27;
 var $213=(($211+8)|0);
 HEAP32[(($213)>>2)]=$212;
 var $214=$28;
 var $215=(($211+12)|0);
 HEAP32[(($215)>>2)]=$214;
 var $216=$29;
 var $217=(($211+16)|0);
 HEAP32[(($217)>>2)]=$216;
 var $218=$80;
 $30=$218;
 var $219=$30;
 var $220=(($219+12)|0);
 var $221=HEAP32[(($220)>>2)];
 var $222=HEAP8[($221)];
 $31=$222;
 var $223=$31;
 var $224=($223&255);
 $__c=$224;
 label=15;break;
 case 15: 
 label=32;break;
 case 16: 
 var $227=(($80+32)|0);
 var $228=HEAP32[(($227)>>2)];
 var $229=(($80+36)|0);
 var $230=HEAP32[(($229)>>2)];
 var $231=(($80+40)|0);
 var $232=HEAP32[(($231)>>2)];
 var $233=(($80+36)|0);
 var $234=HEAP32[(($233)>>2)];
 var $235=$232;
 var $236=$234;
 var $237=((($235)-($236))|0);
 _memmove($228,$230,$237,1,0);
 var $238=(($80+32)|0);
 var $239=HEAP32[(($238)>>2)];
 var $240=(($80+40)|0);
 var $241=HEAP32[(($240)>>2)];
 var $242=(($80+36)|0);
 var $243=HEAP32[(($242)>>2)];
 var $244=$241;
 var $245=$243;
 var $246=((($244)-($245))|0);
 var $247=(($239+$246)|0);
 var $248=(($80+36)|0);
 HEAP32[(($248)>>2)]=$247;
 var $249=(($80+32)|0);
 var $250=HEAP32[(($249)>>2)];
 var $251=(($80+32)|0);
 var $252=HEAP32[(($251)>>2)];
 var $253=(($80+44)|0);
 var $254=(($253)|0);
 var $255=($252|0)==($254|0);
 if($255){label=17;break;}else{label=18;break;}
 case 17: 
 var $261=8;label=19;break;
 case 18: 
 var $258=(($80+52)|0);
 var $259=HEAP32[(($258)>>2)];
 var $261=$259;label=19;break;
 case 19: 
 var $261;
 var $262=(($250+$261)|0);
 var $263=(($80+40)|0);
 HEAP32[(($263)>>2)]=$262;
 var $264=(($80+60)|0);
 var $265=HEAP32[(($264)>>2)];
 var $266=$__unget_sz;
 var $267=((($265)-($266))|0);
 HEAP32[(($78)>>2)]=$267;
 var $268=(($80+40)|0);
 var $269=HEAP32[(($268)>>2)];
 var $270=(($80+36)|0);
 var $271=HEAP32[(($270)>>2)];
 var $272=$269;
 var $273=$271;
 var $274=((($272)-($273))|0);
 HEAP32[(($79)>>2)]=$274;
 $38=$78;
 $39=$79;
 var $275=$38;
 var $276=$39;
 var $tmp_i=$37;
 var $tmp1_i=$40;
 assert(1 % 1 === 0);HEAP8[($tmp_i)]=HEAP8[($tmp1_i)];
 $35=$275;
 $36=$276;
 var $277=$36;
 var $278=$35;
 $32=$37;
 $33=$277;
 $34=$278;
 var $279=$32;
 var $280=$33;
 var $281=HEAP32[(($280)>>2)];
 var $282=$34;
 var $283=HEAP32[(($282)>>2)];
 var $284=($281>>>0)<($283>>>0);
 if($284){label=20;break;}else{label=21;break;}
 case 20: 
 var $286=$36;
 var $289=$286;label=22;break;
 case 21: 
 var $288=$35;
 var $289=$288;label=22;break;
 case 22: 
 var $289;
 var $290=HEAP32[(($289)>>2)];
 $__nmemb1=$290;
 var $291=(($80+80)|0);
 var $292=(($80+72)|0);
 var $293=$291;
 var $294=$292;
 assert(8 % 1 === 0);HEAP32[(($293)>>2)]=HEAP32[(($294)>>2)];HEAP32[((($293)+(4))>>2)]=HEAP32[((($294)+(4))>>2)];
 var $295=(($80+36)|0);
 var $296=HEAP32[(($295)>>2)];
 var $297=$__nmemb1;
 var $298=(($80+64)|0);
 var $299=HEAP32[(($298)>>2)];
 var $300=_fread($296,1,$297,$299);
 $__nr=$300;
 var $301=$__nr;
 var $302=($301|0)!=0;
 if($302){label=23;break;}else{label=31;break;}
 case 23: 
 var $304=(($80+68)|0);
 var $305=HEAP32[(($304)>>2)];
 var $306=($305|0)!=0;
 if($306){label=25;break;}else{label=24;break;}
 case 24: 
 var $308=___cxa_allocate_exception(4);
 var $309=$308;
 __ZNSt8bad_castC2Ev($309);
 ___cxa_throw($308,8960,(368));
 throw "Reached an unreachable!";
 case 25: 
 var $311=(($80+36)|0);
 var $312=HEAP32[(($311)>>2)];
 var $313=$__nr;
 var $314=(($312+$313)|0);
 var $315=(($80+40)|0);
 HEAP32[(($315)>>2)]=$314;
 var $316=(($80+68)|0);
 var $317=HEAP32[(($316)>>2)];
 var $318=(($80+72)|0);
 var $319=(($80+32)|0);
 var $320=HEAP32[(($319)>>2)];
 var $321=(($80+40)|0);
 var $322=HEAP32[(($321)>>2)];
 var $323=(($80+36)|0);
 var $324=$80;
 $41=$324;
 var $325=$41;
 var $326=(($325+8)|0);
 var $327=HEAP32[(($326)>>2)];
 var $328=$__unget_sz;
 var $329=(($327+$328)|0);
 var $330=$80;
 $42=$330;
 var $331=$42;
 var $332=(($331+8)|0);
 var $333=HEAP32[(($332)>>2)];
 var $334=(($80+60)|0);
 var $335=HEAP32[(($334)>>2)];
 var $336=(($333+$335)|0);
 $44=$317;
 $45=$318;
 $46=$320;
 $47=$322;
 $48=$323;
 $49=$329;
 $50=$336;
 $51=$__inext;
 var $337=$44;
 var $338=$337;
 var $339=HEAP32[(($338)>>2)];
 var $340=(($339+16)|0);
 var $341=HEAP32[(($340)>>2)];
 var $342=$45;
 var $343=$46;
 var $344=$47;
 var $345=$48;
 var $346=$49;
 var $347=$50;
 var $348=$51;
 var $349=FUNCTION_TABLE[$341]($337,$342,$343,$344,$345,$346,$347,$348);
 $__r=$349;
 var $350=$__r;
 var $351=($350|0)==3;
 if($351){label=26;break;}else{label=27;break;}
 case 26: 
 var $353=$80;
 var $354=(($80+32)|0);
 var $355=HEAP32[(($354)>>2)];
 var $356=(($80+32)|0);
 var $357=HEAP32[(($356)>>2)];
 var $358=(($80+40)|0);
 var $359=HEAP32[(($358)>>2)];
 $52=$353;
 $53=$355;
 $54=$357;
 $55=$359;
 var $360=$52;
 var $361=$53;
 var $362=(($360+8)|0);
 HEAP32[(($362)>>2)]=$361;
 var $363=$54;
 var $364=(($360+12)|0);
 HEAP32[(($364)>>2)]=$363;
 var $365=$55;
 var $366=(($360+16)|0);
 HEAP32[(($366)>>2)]=$365;
 var $367=$80;
 $56=$367;
 var $368=$56;
 var $369=(($368+12)|0);
 var $370=HEAP32[(($369)>>2)];
 var $371=HEAP8[($370)];
 $57=$371;
 var $372=$57;
 var $373=($372&255);
 $__c=$373;
 label=30;break;
 case 27: 
 var $375=HEAP32[(($__inext)>>2)];
 var $376=$80;
 $58=$376;
 var $377=$58;
 var $378=(($377+8)|0);
 var $379=HEAP32[(($378)>>2)];
 var $380=$__unget_sz;
 var $381=(($379+$380)|0);
 var $382=($375|0)!=($381|0);
 if($382){label=28;break;}else{label=29;break;}
 case 28: 
 var $384=$80;
 var $385=$80;
 $59=$385;
 var $386=$59;
 var $387=(($386+8)|0);
 var $388=HEAP32[(($387)>>2)];
 var $389=$80;
 $60=$389;
 var $390=$60;
 var $391=(($390+8)|0);
 var $392=HEAP32[(($391)>>2)];
 var $393=$__unget_sz;
 var $394=(($392+$393)|0);
 var $395=HEAP32[(($__inext)>>2)];
 $61=$384;
 $62=$388;
 $63=$394;
 $64=$395;
 var $396=$61;
 var $397=$62;
 var $398=(($396+8)|0);
 HEAP32[(($398)>>2)]=$397;
 var $399=$63;
 var $400=(($396+12)|0);
 HEAP32[(($400)>>2)]=$399;
 var $401=$64;
 var $402=(($396+16)|0);
 HEAP32[(($402)>>2)]=$401;
 var $403=$80;
 $65=$403;
 var $404=$65;
 var $405=(($404+12)|0);
 var $406=HEAP32[(($405)>>2)];
 var $407=HEAP8[($406)];
 $66=$407;
 var $408=$66;
 var $409=($408&255);
 $__c=$409;
 label=29;break;
 case 29: 
 label=30;break;
 case 30: 
 label=31;break;
 case 31: 
 label=32;break;
 case 32: 
 label=34;break;
 case 33: 
 var $415=$80;
 $67=$415;
 var $416=$67;
 var $417=(($416+12)|0);
 var $418=HEAP32[(($417)>>2)];
 var $419=HEAP8[($418)];
 $68=$419;
 var $420=$68;
 var $421=($420&255);
 $__c=$421;
 label=34;break;
 case 34: 
 var $423=$80;
 $69=$423;
 var $424=$69;
 var $425=(($424+8)|0);
 var $426=HEAP32[(($425)>>2)];
 var $427=($426|0)==($__1buf|0);
 if($427){label=35;break;}else{label=36;break;}
 case 35: 
 var $429=$80;
 $70=$429;
 $71=0;
 $72=0;
 $73=0;
 var $430=$70;
 var $431=$71;
 var $432=(($430+8)|0);
 HEAP32[(($432)>>2)]=$431;
 var $433=$72;
 var $434=(($430+12)|0);
 HEAP32[(($434)>>2)]=$433;
 var $435=$73;
 var $436=(($430+16)|0);
 HEAP32[(($436)>>2)]=$435;
 label=36;break;
 case 36: 
 var $438=$__c;
 $74=$438;
 label=37;break;
 case 37: 
 var $440=$74;
 STACKTOP=sp;return $440;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__113basic_filebufIcNS_11char_traitsIcEEE9pbackfailEi($this,$__c){
 var label=0;
 var sp=STACKTOP; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1;
 var $2;
 var $3;
 var $4;
 var $5;
 var $6;
 var $7;
 var $8;
 var $9;
 var $10;
 var $11;
 var $12;
 var $13;
 var $14;
 var $15;
 var $16;
 var $17;
 var $18;
 var $19;
 var $20;
 $19=$this;
 $20=$__c;
 var $21=$19;
 var $22=(($21+64)|0);
 var $23=HEAP32[(($22)>>2)];
 var $24=($23|0)!=0;
 if($24){label=2;break;}else{label=12;break;}
 case 2: 
 var $26=$21;
 $17=$26;
 var $27=$17;
 var $28=(($27+8)|0);
 var $29=HEAP32[(($28)>>2)];
 var $30=$21;
 $1=$30;
 var $31=$1;
 var $32=(($31+12)|0);
 var $33=HEAP32[(($32)>>2)];
 var $34=($29>>>0)<($33>>>0);
 if($34){label=3;break;}else{label=12;break;}
 case 3: 
 var $36=$20;
 $2=$36;
 $3=-1;
 var $37=$2;
 var $38=$3;
 var $39=($37|0)==($38|0);
 if($39){label=4;break;}else{label=8;break;}
 case 4: 
 var $41=$21;
 $4=$41;
 $5=-1;
 var $42=$4;
 var $43=$5;
 var $44=(($42+12)|0);
 var $45=HEAP32[(($44)>>2)];
 var $46=(($45+$43)|0);
 HEAP32[(($44)>>2)]=$46;
 var $47=$20;
 $8=$47;
 var $48=$8;
 $6=$48;
 $7=-1;
 var $49=$6;
 var $50=$7;
 var $51=($49|0)==($50|0);
 if($51){label=5;break;}else{label=6;break;}
 case 5: 
 var $55=0;label=7;break;
 case 6: 
 var $54=$8;
 var $55=$54;label=7;break;
 case 7: 
 var $55;
 $18=$55;
 label=13;break;
 case 8: 
 var $57=(($21+88)|0);
 var $58=HEAP32[(($57)>>2)];
 var $59=$58&16;
 var $60=($59|0)!=0;
 if($60){label=10;break;}else{label=9;break;}
 case 9: 
 var $62=$20;
 $9=$62;
 var $63=$9;
 var $64=(($63)&255);
 var $65=$21;
 $10=$65;
 var $66=$10;
 var $67=(($66+12)|0);
 var $68=HEAP32[(($67)>>2)];
 var $69=((($68)-(1))|0);
 var $70=HEAP8[($69)];
 $11=$64;
 $12=$70;
 var $71=$11;
 var $72=(($71<<24)>>24);
 var $73=$12;
 var $74=(($73<<24)>>24);
 var $75=($72|0)==($74|0);
 if($75){label=10;break;}else{label=11;break;}
 case 10: 
 var $77=$21;
 $13=$77;
 $14=-1;
 var $78=$13;
 var $79=$14;
 var $80=(($78+12)|0);
 var $81=HEAP32[(($80)>>2)];
 var $82=(($81+$79)|0);
 HEAP32[(($80)>>2)]=$82;
 var $83=$20;
 $15=$83;
 var $84=$15;
 var $85=(($84)&255);
 var $86=$21;
 $16=$86;
 var $87=$16;
 var $88=(($87+12)|0);
 var $89=HEAP32[(($88)>>2)];
 HEAP8[($89)]=$85;
 var $90=$20;
 $18=$90;
 label=13;break;
 case 11: 
 label=12;break;
 case 12: 
 $18=-1;
 label=13;break;
 case 13: 
 var $94=$18;
 STACKTOP=sp;return $94;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__113basic_filebufIcNS_11char_traitsIcEEE8overflowEi($this,$__c){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+24)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1;
 var $2;
 var $3;
 var $4;
 var $5;
 var $6;
 var $7;
 var $8;
 var $9;
 var $10;
 var $11;
 var $12;
 var $13;
 var $14;
 var $15;
 var $16;
 var $17;
 var $18;
 var $19;
 var $20;
 var $21;
 var $22;
 var $23;
 var $24;
 var $25;
 var $26;
 var $27;
 var $28;
 var $29;
 var $30;
 var $31;
 var $32;
 var $33;
 var $34;
 var $35;
 var $36;
 var $37;
 var $38;
 var $39;
 var $40;
 var $41;
 var $42;
 var $43;
 var $44;
 var $45;
 var $46;
 var $47;
 var $48;
 var $__1buf=sp;
 var $__pb_save;
 var $__epb_save;
 var $__nmemb;
 var $__extbe=(sp)+(8);
 var $__r;
 var $__e=(sp)+(16);
 var $__nmemb1;
 var $__nmemb2;
 $47=$this;
 $48=$__c;
 var $49=$47;
 var $50=(($49+64)|0);
 var $51=HEAP32[(($50)>>2)];
 var $52=($51|0)==0;
 if($52){label=2;break;}else{label=3;break;}
 case 2: 
 $46=-1;
 label=38;break;
 case 3: 
 __ZNSt3__113basic_filebufIcNS_11char_traitsIcEEE12__write_modeEv($49);
 var $55=$49;
 $19=$55;
 var $56=$19;
 var $57=(($56+20)|0);
 var $58=HEAP32[(($57)>>2)];
 $__pb_save=$58;
 var $59=$49;
 $1=$59;
 var $60=$1;
 var $61=(($60+28)|0);
 var $62=HEAP32[(($61)>>2)];
 $__epb_save=$62;
 var $63=$48;
 $2=$63;
 $3=-1;
 var $64=$2;
 var $65=$3;
 var $66=($64|0)==($65|0);
 if($66){label=7;break;}else{label=4;break;}
 case 4: 
 var $68=$49;
 $4=$68;
 var $69=$4;
 var $70=(($69+24)|0);
 var $71=HEAP32[(($70)>>2)];
 var $72=($71|0)==0;
 if($72){label=5;break;}else{label=6;break;}
 case 5: 
 var $74=$49;
 var $75=(($__1buf+1)|0);
 $5=$74;
 $6=$__1buf;
 $7=$75;
 var $76=$5;
 var $77=$6;
 var $78=(($76+24)|0);
 HEAP32[(($78)>>2)]=$77;
 var $79=(($76+20)|0);
 HEAP32[(($79)>>2)]=$77;
 var $80=$7;
 var $81=(($76+28)|0);
 HEAP32[(($81)>>2)]=$80;
 label=6;break;
 case 6: 
 var $83=$48;
 $8=$83;
 var $84=$8;
 var $85=(($84)&255);
 var $86=$49;
 $9=$86;
 var $87=$9;
 var $88=(($87+24)|0);
 var $89=HEAP32[(($88)>>2)];
 HEAP8[($89)]=$85;
 var $90=$49;
 $10=$90;
 $11=1;
 var $91=$10;
 var $92=$11;
 var $93=(($91+24)|0);
 var $94=HEAP32[(($93)>>2)];
 var $95=(($94+$92)|0);
 HEAP32[(($93)>>2)]=$95;
 label=7;break;
 case 7: 
 var $97=$49;
 $12=$97;
 var $98=$12;
 var $99=(($98+24)|0);
 var $100=HEAP32[(($99)>>2)];
 var $101=$49;
 $13=$101;
 var $102=$13;
 var $103=(($102+20)|0);
 var $104=HEAP32[(($103)>>2)];
 var $105=($100|0)!=($104|0);
 if($105){label=8;break;}else{label=34;break;}
 case 8: 
 var $107=(($49+98)|0);
 var $108=HEAP8[($107)];
 var $109=(($108)&1);
 if($109){label=9;break;}else{label=12;break;}
 case 9: 
 var $111=$49;
 $14=$111;
 var $112=$14;
 var $113=(($112+24)|0);
 var $114=HEAP32[(($113)>>2)];
 var $115=$49;
 $15=$115;
 var $116=$15;
 var $117=(($116+20)|0);
 var $118=HEAP32[(($117)>>2)];
 var $119=$114;
 var $120=$118;
 var $121=((($119)-($120))|0);
 $__nmemb=$121;
 var $122=$49;
 $16=$122;
 var $123=$16;
 var $124=(($123+20)|0);
 var $125=HEAP32[(($124)>>2)];
 var $126=$__nmemb;
 var $127=(($49+64)|0);
 var $128=HEAP32[(($127)>>2)];
 var $129=_fwrite($125,1,$126,$128);
 var $130=$__nmemb;
 var $131=($129|0)!=($130|0);
 if($131){label=10;break;}else{label=11;break;}
 case 10: 
 $46=-1;
 label=38;break;
 case 11: 
 label=33;break;
 case 12: 
 var $135=(($49+32)|0);
 var $136=HEAP32[(($135)>>2)];
 HEAP32[(($__extbe)>>2)]=$136;
 label=13;break;
 case 13: 
 var $138=(($49+68)|0);
 var $139=HEAP32[(($138)>>2)];
 var $140=($139|0)!=0;
 if($140){label=15;break;}else{label=14;break;}
 case 14: 
 var $142=___cxa_allocate_exception(4);
 var $143=$142;
 __ZNSt8bad_castC2Ev($143);
 ___cxa_throw($142,8960,(368));
 throw "Reached an unreachable!";
 case 15: 
 var $145=(($49+68)|0);
 var $146=HEAP32[(($145)>>2)];
 var $147=(($49+72)|0);
 var $148=$49;
 $17=$148;
 var $149=$17;
 var $150=(($149+20)|0);
 var $151=HEAP32[(($150)>>2)];
 var $152=$49;
 $18=$152;
 var $153=$18;
 var $154=(($153+24)|0);
 var $155=HEAP32[(($154)>>2)];
 var $156=(($49+32)|0);
 var $157=HEAP32[(($156)>>2)];
 var $158=(($49+32)|0);
 var $159=HEAP32[(($158)>>2)];
 var $160=(($49+52)|0);
 var $161=HEAP32[(($160)>>2)];
 var $162=(($159+$161)|0);
 $20=$146;
 $21=$147;
 $22=$151;
 $23=$155;
 $24=$__e;
 $25=$157;
 $26=$162;
 $27=$__extbe;
 var $163=$20;
 var $164=$163;
 var $165=HEAP32[(($164)>>2)];
 var $166=(($165+12)|0);
 var $167=HEAP32[(($166)>>2)];
 var $168=$21;
 var $169=$22;
 var $170=$23;
 var $171=$24;
 var $172=$25;
 var $173=$26;
 var $174=$27;
 var $175=FUNCTION_TABLE[$167]($163,$168,$169,$170,$171,$172,$173,$174);
 $__r=$175;
 var $176=HEAP32[(($__e)>>2)];
 var $177=$49;
 $28=$177;
 var $178=$28;
 var $179=(($178+20)|0);
 var $180=HEAP32[(($179)>>2)];
 var $181=($176|0)==($180|0);
 if($181){label=16;break;}else{label=17;break;}
 case 16: 
 $46=-1;
 label=38;break;
 case 17: 
 var $184=$__r;
 var $185=($184|0)==3;
 if($185){label=18;break;}else{label=21;break;}
 case 18: 
 var $187=$49;
 $29=$187;
 var $188=$29;
 var $189=(($188+24)|0);
 var $190=HEAP32[(($189)>>2)];
 var $191=$49;
 $30=$191;
 var $192=$30;
 var $193=(($192+20)|0);
 var $194=HEAP32[(($193)>>2)];
 var $195=$190;
 var $196=$194;
 var $197=((($195)-($196))|0);
 $__nmemb1=$197;
 var $198=$49;
 $31=$198;
 var $199=$31;
 var $200=(($199+20)|0);
 var $201=HEAP32[(($200)>>2)];
 var $202=$__nmemb1;
 var $203=(($49+64)|0);
 var $204=HEAP32[(($203)>>2)];
 var $205=_fwrite($201,1,$202,$204);
 var $206=$__nmemb1;
 var $207=($205|0)!=($206|0);
 if($207){label=19;break;}else{label=20;break;}
 case 19: 
 $46=-1;
 label=38;break;
 case 20: 
 label=30;break;
 case 21: 
 var $211=$__r;
 var $212=($211|0)==0;
 if($212){label=23;break;}else{label=22;break;}
 case 22: 
 var $214=$__r;
 var $215=($214|0)==1;
 if($215){label=23;break;}else{label=28;break;}
 case 23: 
 var $217=HEAP32[(($__extbe)>>2)];
 var $218=(($49+32)|0);
 var $219=HEAP32[(($218)>>2)];
 var $220=$217;
 var $221=$219;
 var $222=((($220)-($221))|0);
 $__nmemb2=$222;
 var $223=(($49+32)|0);
 var $224=HEAP32[(($223)>>2)];
 var $225=$__nmemb2;
 var $226=(($49+64)|0);
 var $227=HEAP32[(($226)>>2)];
 var $228=_fwrite($224,1,$225,$227);
 var $229=$__nmemb2;
 var $230=($228|0)!=($229|0);
 if($230){label=24;break;}else{label=25;break;}
 case 24: 
 $46=-1;
 label=38;break;
 case 25: 
 var $233=$__r;
 var $234=($233|0)==1;
 if($234){label=26;break;}else{label=27;break;}
 case 26: 
 var $236=$49;
 var $237=HEAP32[(($__e)>>2)];
 var $238=$49;
 $32=$238;
 var $239=$32;
 var $240=(($239+24)|0);
 var $241=HEAP32[(($240)>>2)];
 $33=$236;
 $34=$237;
 $35=$241;
 var $242=$33;
 var $243=$34;
 var $244=(($242+24)|0);
 HEAP32[(($244)>>2)]=$243;
 var $245=(($242+20)|0);
 HEAP32[(($245)>>2)]=$243;
 var $246=$35;
 var $247=(($242+28)|0);
 HEAP32[(($247)>>2)]=$246;
 var $248=$49;
 var $249=$49;
 $36=$249;
 var $250=$36;
 var $251=(($250+28)|0);
 var $252=HEAP32[(($251)>>2)];
 var $253=$49;
 $37=$253;
 var $254=$37;
 var $255=(($254+20)|0);
 var $256=HEAP32[(($255)>>2)];
 var $257=$252;
 var $258=$256;
 var $259=((($257)-($258))|0);
 $38=$248;
 $39=$259;
 var $260=$38;
 var $261=$39;
 var $262=(($260+24)|0);
 var $263=HEAP32[(($262)>>2)];
 var $264=(($263+$261)|0);
 HEAP32[(($262)>>2)]=$264;
 label=27;break;
 case 27: 
 label=29;break;
 case 28: 
 $46=-1;
 label=38;break;
 case 29: 
 label=30;break;
 case 30: 
 label=31;break;
 case 31: 
 var $270=$__r;
 var $271=($270|0)==1;
 if($271){label=13;break;}else{label=32;break;}
 case 32: 
 label=33;break;
 case 33: 
 var $274=$49;
 var $275=$__pb_save;
 var $276=$__epb_save;
 $40=$274;
 $41=$275;
 $42=$276;
 var $277=$40;
 var $278=$41;
 var $279=(($277+24)|0);
 HEAP32[(($279)>>2)]=$278;
 var $280=(($277+20)|0);
 HEAP32[(($280)>>2)]=$278;
 var $281=$42;
 var $282=(($277+28)|0);
 HEAP32[(($282)>>2)]=$281;
 label=34;break;
 case 34: 
 var $284=$48;
 $45=$284;
 var $285=$45;
 $43=$285;
 $44=-1;
 var $286=$43;
 var $287=$44;
 var $288=($286|0)==($287|0);
 if($288){label=35;break;}else{label=36;break;}
 case 35: 
 var $292=0;label=37;break;
 case 36: 
 var $291=$45;
 var $292=$291;label=37;break;
 case 37: 
 var $292;
 $46=$292;
 label=38;break;
 case 38: 
 var $294=$46;
 STACKTOP=sp;return $294;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__113basic_filebufIcNS_11char_traitsIcEEE12__write_modeEv($this){
 var label=0;
 var sp=STACKTOP; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1;
 var $2;
 var $3;
 var $4;
 var $5;
 var $6;
 var $7;
 var $8;
 var $9;
 var $10;
 var $11;
 var $12;
 var $13;
 var $14;
 $14=$this;
 var $15=$14;
 var $16=(($15+92)|0);
 var $17=HEAP32[(($16)>>2)];
 var $18=$17&16;
 var $19=($18|0)!=0;
 if($19){label=9;break;}else{label=2;break;}
 case 2: 
 var $21=$15;
 $10=$21;
 $11=0;
 $12=0;
 $13=0;
 var $22=$10;
 var $23=$11;
 var $24=(($22+8)|0);
 HEAP32[(($24)>>2)]=$23;
 var $25=$12;
 var $26=(($22+12)|0);
 HEAP32[(($26)>>2)]=$25;
 var $27=$13;
 var $28=(($22+16)|0);
 HEAP32[(($28)>>2)]=$27;
 var $29=(($15+52)|0);
 var $30=HEAP32[(($29)>>2)];
 var $31=($30>>>0)>8;
 if($31){label=3;break;}else{label=7;break;}
 case 3: 
 var $33=(($15+98)|0);
 var $34=HEAP8[($33)];
 var $35=(($34)&1);
 if($35){label=4;break;}else{label=5;break;}
 case 4: 
 var $37=$15;
 var $38=(($15+32)|0);
 var $39=HEAP32[(($38)>>2)];
 var $40=(($15+32)|0);
 var $41=HEAP32[(($40)>>2)];
 var $42=(($15+52)|0);
 var $43=HEAP32[(($42)>>2)];
 var $44=((($43)-(1))|0);
 var $45=(($41+$44)|0);
 $1=$37;
 $2=$39;
 $3=$45;
 var $46=$1;
 var $47=$2;
 var $48=(($46+24)|0);
 HEAP32[(($48)>>2)]=$47;
 var $49=(($46+20)|0);
 HEAP32[(($49)>>2)]=$47;
 var $50=$3;
 var $51=(($46+28)|0);
 HEAP32[(($51)>>2)]=$50;
 label=6;break;
 case 5: 
 var $53=$15;
 var $54=(($15+56)|0);
 var $55=HEAP32[(($54)>>2)];
 var $56=(($15+56)|0);
 var $57=HEAP32[(($56)>>2)];
 var $58=(($15+60)|0);
 var $59=HEAP32[(($58)>>2)];
 var $60=((($59)-(1))|0);
 var $61=(($57+$60)|0);
 $4=$53;
 $5=$55;
 $6=$61;
 var $62=$4;
 var $63=$5;
 var $64=(($62+24)|0);
 HEAP32[(($64)>>2)]=$63;
 var $65=(($62+20)|0);
 HEAP32[(($65)>>2)]=$63;
 var $66=$6;
 var $67=(($62+28)|0);
 HEAP32[(($67)>>2)]=$66;
 label=6;break;
 case 6: 
 label=8;break;
 case 7: 
 var $70=$15;
 $7=$70;
 $8=0;
 $9=0;
 var $71=$7;
 var $72=$8;
 var $73=(($71+24)|0);
 HEAP32[(($73)>>2)]=$72;
 var $74=(($71+20)|0);
 HEAP32[(($74)>>2)]=$72;
 var $75=$9;
 var $76=(($71+28)|0);
 HEAP32[(($76)>>2)]=$75;
 label=8;break;
 case 8: 
 var $78=(($15+92)|0);
 HEAP32[(($78)>>2)]=16;
 label=9;break;
 case 9: 
 STACKTOP=sp;return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__113basic_filebufIcNS_11char_traitsIcEEE11__read_modeEv($this){
 var label=0;
 var sp=STACKTOP; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1;
 var $2;
 var $3;
 var $4;
 var $5;
 var $6;
 var $7;
 var $8;
 var $9;
 var $10;
 var $11;
 var $12;
 var $13;
 $13=$this;
 var $14=$13;
 var $15=(($14+92)|0);
 var $16=HEAP32[(($15)>>2)];
 var $17=$16&8;
 var $18=($17|0)!=0;
 if($18){label=6;break;}else{label=2;break;}
 case 2: 
 var $20=$14;
 $9=$20;
 $10=0;
 $11=0;
 var $21=$9;
 var $22=$10;
 var $23=(($21+24)|0);
 HEAP32[(($23)>>2)]=$22;
 var $24=(($21+20)|0);
 HEAP32[(($24)>>2)]=$22;
 var $25=$11;
 var $26=(($21+28)|0);
 HEAP32[(($26)>>2)]=$25;
 var $27=(($14+98)|0);
 var $28=HEAP8[($27)];
 var $29=(($28)&1);
 if($29){label=3;break;}else{label=4;break;}
 case 3: 
 var $31=$14;
 var $32=(($14+32)|0);
 var $33=HEAP32[(($32)>>2)];
 var $34=(($14+32)|0);
 var $35=HEAP32[(($34)>>2)];
 var $36=(($14+52)|0);
 var $37=HEAP32[(($36)>>2)];
 var $38=(($35+$37)|0);
 var $39=(($14+32)|0);
 var $40=HEAP32[(($39)>>2)];
 var $41=(($14+52)|0);
 var $42=HEAP32[(($41)>>2)];
 var $43=(($40+$42)|0);
 $1=$31;
 $2=$33;
 $3=$38;
 $4=$43;
 var $44=$1;
 var $45=$2;
 var $46=(($44+8)|0);
 HEAP32[(($46)>>2)]=$45;
 var $47=$3;
 var $48=(($44+12)|0);
 HEAP32[(($48)>>2)]=$47;
 var $49=$4;
 var $50=(($44+16)|0);
 HEAP32[(($50)>>2)]=$49;
 label=5;break;
 case 4: 
 var $52=$14;
 var $53=(($14+56)|0);
 var $54=HEAP32[(($53)>>2)];
 var $55=(($14+56)|0);
 var $56=HEAP32[(($55)>>2)];
 var $57=(($14+60)|0);
 var $58=HEAP32[(($57)>>2)];
 var $59=(($56+$58)|0);
 var $60=(($14+56)|0);
 var $61=HEAP32[(($60)>>2)];
 var $62=(($14+60)|0);
 var $63=HEAP32[(($62)>>2)];
 var $64=(($61+$63)|0);
 $5=$52;
 $6=$54;
 $7=$59;
 $8=$64;
 var $65=$5;
 var $66=$6;
 var $67=(($65+8)|0);
 HEAP32[(($67)>>2)]=$66;
 var $68=$7;
 var $69=(($65+12)|0);
 HEAP32[(($69)>>2)]=$68;
 var $70=$8;
 var $71=(($65+16)|0);
 HEAP32[(($71)>>2)]=$70;
 label=5;break;
 case 5: 
 var $73=(($14+92)|0);
 HEAP32[(($73)>>2)]=8;
 $12=1;
 label=7;break;
 case 6: 
 $12=0;
 label=7;break;
 case 7: 
 var $76=$12;
 STACKTOP=sp;return $76;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__113basic_filebufIcNS_11char_traitsIcEEEC2Ev($this){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+24)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1;
 var $2;
 var $3;
 var $4;
 var $5;
 var $6;
 var $7;
 var $8;
 var $9;
 var $10;
 var $11;
 var $12;
 var $13;
 var $14=sp;
 var $15;
 var $16;
 var $17=(sp)+(8);
 var $18=(sp)+(16);
 $13=$this;
 var $19=$13;
 var $20=$19;
 __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEEC2Ev($20);
 var $21=$19;
 HEAP32[(($21)>>2)]=5120;
 var $22=(($19+32)|0);
 HEAP32[(($22)>>2)]=0;
 var $23=(($19+36)|0);
 HEAP32[(($23)>>2)]=0;
 var $24=(($19+40)|0);
 HEAP32[(($24)>>2)]=0;
 var $25=(($19+52)|0);
 HEAP32[(($25)>>2)]=0;
 var $26=(($19+56)|0);
 HEAP32[(($26)>>2)]=0;
 var $27=(($19+60)|0);
 HEAP32[(($27)>>2)]=0;
 var $28=(($19+64)|0);
 HEAP32[(($28)>>2)]=0;
 var $29=(($19+68)|0);
 $11=$14;
 $12=-1;
 var $30=$11;
 var $31=$12;
 $9=$30;
 $10=$31;
 var $32=$9;
 var $33=(($32)|0);
 HEAP32[(($33)>>2)]=0;
 label=2;break;
 case 2: 
 $8=$14;
 var $35=$8;
 label=3;break;
 case 3: 
 HEAP32[(($29)>>2)]=0;
 var $37=(($19+72)|0);
 var $38=$37;
 HEAP32[(($38)>>2)]=0; HEAP32[((($38)+(4))>>2)]=0;
 var $39=(($19+80)|0);
 var $40=$39;
 HEAP32[(($40)>>2)]=0; HEAP32[((($40)+(4))>>2)]=0;
 var $41=(($19+88)|0);
 HEAP32[(($41)>>2)]=0;
 var $42=(($19+92)|0);
 HEAP32[(($42)>>2)]=0;
 var $43=(($19+96)|0);
 HEAP8[($43)]=0;
 var $44=(($19+97)|0);
 HEAP8[($44)]=0;
 var $45=(($19+98)|0);
 HEAP8[($45)]=0;
 var $46=$19;
 $7=$46;
 var $47=$7;
 var $48=(($47+4)|0);
 __ZNSt3__16localeC2ERKS0_($17,$48);
 label=4;break;
 case 4: 
 $4=$17;
 var $50=$4;
 var $51=(function() { try { __THREW__ = 0; return __ZNKSt3__16locale9has_facetERNS0_2idE($50,13792) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=6;break; } else { label=5;break; }
 case 5: 
 var $53$0 = ___cxa_find_matching_catch(-1, -1); var $53$1 = tempRet0;
 var $54=$53$0;
 $5=$54;
 var $55=$53$1;
 $6=$55;
 var $56=$5;
 ___cxa_call_unexpected($56);
 throw "Reached an unreachable!";
 case 6: 
 (function() { try { __THREW__ = 0; return __ZNSt3__16localeD2Ev($17) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=7;break; } else { label=13;break; }
 case 7: 
 if($51){label=8;break;}else{label=16;break;}
 case 8: 
 var $59=$19;
 $3=$59;
 var $60=$3;
 var $61=(($60+4)|0);
 __ZNSt3__16localeC2ERKS0_($18,$61);
 label=9;break;
 case 9: 
 $2=$18;
 var $63=$2;
 var $64=(function() { try { __THREW__ = 0; return __ZNKSt3__16locale9use_facetERNS0_2idE($63,13792) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=10;break; } else { label=14;break; }
 case 10: 
 var $65=$64;
 label=11;break;
 case 11: 
 var $67=(($19+68)|0);
 HEAP32[(($67)>>2)]=$65;
 (function() { try { __THREW__ = 0; return __ZNSt3__16localeD2Ev($18) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=12;break; } else { label=13;break; }
 case 12: 
 var $69=(($19+68)|0);
 var $70=HEAP32[(($69)>>2)];
 $1=$70;
 var $71=$1;
 var $72=$71;
 var $73=HEAP32[(($72)>>2)];
 var $74=(($73+28)|0);
 var $75=HEAP32[(($74)>>2)];
 var $76=FUNCTION_TABLE[$75]($71);
 var $77=(($19+98)|0);
 var $78=($76&1);
 HEAP8[($77)]=$78;
 label=16;break;
 case 13: 
 var $80$0 = ___cxa_find_matching_catch(-1, -1); var $80$1 = tempRet0;
 var $81=$80$0;
 $15=$81;
 var $82=$80$1;
 $16=$82;
 label=18;break;
 case 14: 
 var $84$0 = ___cxa_find_matching_catch(-1, -1); var $84$1 = tempRet0;
 var $85=$84$0;
 $15=$85;
 var $86=$84$1;
 $16=$86;
 (function() { try { __THREW__ = 0; return __ZNSt3__16localeD2Ev($18) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=15;break; } else { label=21;break; }
 case 15: 
 label=18;break;
 case 16: 
 var $89=$19;
 var $90=HEAP32[(($89)>>2)];
 var $91=(($90+12)|0);
 var $92=HEAP32[(($91)>>2)];
 var $93=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$92]($19,0,4096) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=17;break; } else { label=13;break; }
 case 17: 
 STACKTOP=sp;return;
 case 18: 
 var $96=$19;
 (function() { try { __THREW__ = 0; return __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEED2Ev($96) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=19;break; } else { label=21;break; }
 case 19: 
 label=20;break;
 case 20: 
 var $99=$15;
 var $100=$16;
 var $101$0=$99;
 var $101$1=0;
 var $102$0=$101$0;
 var $102$1=$100;
 ___resumeException($102$0)
 case 21: 
 var $104$0 = ___cxa_find_matching_catch(-1, -1,0); var $104$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
  default: assert(0, "bad label: " + label);
 }

}

// WARNING: content after a branch in a label, line: 6098
// WARNING: content after a branch in a label, line: 6100
// WARNING: content after a branch in a label, line: 6101
// WARNING: content after a branch in a label, line: 6102
// WARNING: content after a branch in a label, line: 6103
// WARNING: content after a branch in a label, line: 6104

function __ZNSt3__16vectorINS0_INS_4pairIi12FieldElementEENS_9allocatorIS3_EEEENS4_IS6_EEE21__push_back_slow_pathIKS6_EEvRT_($this,$__x){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+56)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1;
 var $2;
 var $3;
 var $4;
 var $5;
 var $6;
 var $7;
 var $8;
 var $9;
 var $10;
 var $11;
 var $12=sp;
 var $13;
 var $14;
 var $15=(sp)+(8);
 var $16;
 var $17;
 var $18;
 var $19;
 var $20;
 var $21;
 var $22;
 var $23=(sp)+(16);
 var $__ms_i;
 var $__cap_i;
 var $24=(sp)+(24);
 var $25;
 var $26;
 var $27;
 var $28;
 var $29;
 var $30;
 var $__a;
 var $__v=(sp)+(32);
 var $31;
 var $32;
 $29=$this;
 $30=$__x;
 var $33=$29;
 var $34=$33;
 $28=$34;
 var $35=$28;
 var $36=(($35+8)|0);
 $27=$36;
 var $37=$27;
 var $38=$37;
 $26=$38;
 var $39=$26;
 var $40=$39;
 $__a=$40;
 $25=$33;
 var $41=$25;
 var $42=$41;
 var $43=(($42+4)|0);
 var $44=HEAP32[(($43)>>2)];
 var $45=$41;
 var $46=(($45)|0);
 var $47=HEAP32[(($46)>>2)];
 var $48=$44;
 var $49=$47;
 var $50=((($48)-($49))|0);
 var $51=(((($50|0))/(12))&-1);
 var $52=((($51)+(1))|0);
 $22=$33;
 HEAP32[(($23)>>2)]=$52;
 var $53=$22;
 var $54=__ZNKSt3__16vectorINS0_INS_4pairIi12FieldElementEENS_9allocatorIS3_EEEENS4_IS6_EEE8max_sizeEv($53);
 $__ms_i=$54;
 var $55=HEAP32[(($23)>>2)];
 var $56=$__ms_i;
 var $57=($55>>>0)>($56>>>0);
 if($57){label=2;break;}else{label=3;break;}
 case 2: 
 var $59=$53;
 __ZNKSt3__120__vector_base_commonILb1EE20__throw_length_errorEv($59);
 label=3;break;
 case 3: 
 $20=$53;
 var $61=$20;
 var $62=$61;
 $19=$62;
 var $63=$19;
 $18=$63;
 var $64=$18;
 var $65=(($64+8)|0);
 $17=$65;
 var $66=$17;
 var $67=$66;
 $16=$67;
 var $68=$16;
 var $69=(($68)|0);
 var $70=HEAP32[(($69)>>2)];
 var $71=(($63)|0);
 var $72=HEAP32[(($71)>>2)];
 var $73=$70;
 var $74=$72;
 var $75=((($73)-($74))|0);
 var $76=(((($75|0))/(12))&-1);
 $__cap_i=$76;
 var $77=$__cap_i;
 var $78=$__ms_i;
 var $79=(((($78>>>0))/(2))&-1);
 var $80=($77>>>0)>=($79>>>0);
 if($80){label=4;break;}else{label=5;break;}
 case 4: 
 var $82=$__ms_i;
 $21=$82;
 label=9;break;
 case 5: 
 var $84=$__cap_i;
 var $85=($84<<1);
 HEAP32[(($24)>>2)]=$85;
 $13=$24;
 $14=$23;
 var $86=$13;
 var $87=$14;
 var $tmp_i_i=$12;
 var $tmp1_i_i=$15;
 assert(1 % 1 === 0);HEAP8[($tmp_i_i)]=HEAP8[($tmp1_i_i)];
 $10=$86;
 $11=$87;
 var $88=$10;
 var $89=$11;
 $7=$12;
 $8=$88;
 $9=$89;
 var $90=$7;
 var $91=$8;
 var $92=HEAP32[(($91)>>2)];
 var $93=$9;
 var $94=HEAP32[(($93)>>2)];
 var $95=($92>>>0)<($94>>>0);
 if($95){label=6;break;}else{label=7;break;}
 case 6: 
 var $97=$11;
 var $100=$97;label=8;break;
 case 7: 
 var $99=$10;
 var $100=$99;label=8;break;
 case 8: 
 var $100;
 var $101=HEAP32[(($100)>>2)];
 $21=$101;
 label=9;break;
 case 9: 
 var $102=$21;
 $6=$33;
 var $103=$6;
 var $104=$103;
 var $105=(($104+4)|0);
 var $106=HEAP32[(($105)>>2)];
 var $107=$103;
 var $108=(($107)|0);
 var $109=HEAP32[(($108)>>2)];
 var $110=$106;
 var $111=$109;
 var $112=((($110)-($111))|0);
 var $113=(((($112|0))/(12))&-1);
 var $114=$__a;
 __ZNSt3__114__split_bufferINS_6vectorINS_4pairIi12FieldElementEENS_9allocatorIS4_EEEERNS5_IS7_EEEC1EjjS9_($__v,$102,$113,$114);
 var $115=$__a;
 var $116=(($__v+8)|0);
 var $117=HEAP32[(($116)>>2)];
 $5=$117;
 var $118=$5;
 var $119=$30;
 $4=$119;
 var $120=$4;
 $1=$115;
 $2=$118;
 $3=$120;
 var $121=$2;
 var $122=$121;
 var $123=($122|0)==0;
 if($123){var $127=0;label=12;break;}else{label=10;break;}
 case 10: 
 var $125=$122;
 var $126=$3;
 (function() { try { __THREW__ = 0; return __ZNSt3__16vectorINS_4pairIi12FieldElementEENS_9allocatorIS3_EEEC1ERKS6_($125,$126) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=11;break; } else { label=15;break; }
 case 11: 
 var $127=$125;label=12;break;
 case 12: 
 var $127;
 label=13;break;
 case 13: 
 var $129=(($__v+8)|0);
 var $130=HEAP32[(($129)>>2)];
 var $131=(($130+12)|0);
 HEAP32[(($129)>>2)]=$131;
 (function() { try { __THREW__ = 0; return __ZNSt3__16vectorINS0_INS_4pairIi12FieldElementEENS_9allocatorIS3_EEEENS4_IS6_EEE26__swap_out_circular_bufferERNS_14__split_bufferIS6_RS7_EE($33,$__v) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=14;break; } else { label=15;break; }
 case 14: 
 __ZNSt3__114__split_bufferINS_6vectorINS_4pairIi12FieldElementEENS_9allocatorIS4_EEEERNS5_IS7_EEED1Ev($__v);
 STACKTOP=sp;return;
 case 15: 
 var $134$0 = ___cxa_find_matching_catch(-1, -1); var $134$1 = tempRet0;
 var $135=$134$0;
 $31=$135;
 var $136=$134$1;
 $32=$136;
 (function() { try { __THREW__ = 0; return __ZNSt3__114__split_bufferINS_6vectorINS_4pairIi12FieldElementEENS_9allocatorIS4_EEEERNS5_IS7_EEED1Ev($__v) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=16;break; } else { label=18;break; }
 case 16: 
 label=17;break;
 case 17: 
 var $139=$31;
 var $140=$32;
 var $141$0=$139;
 var $141$1=0;
 var $142$0=$141$0;
 var $142$1=$140;
 ___resumeException($142$0)
 case 18: 
 var $144$0 = ___cxa_find_matching_catch(-1, -1,0); var $144$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__114__split_bufferINS_6vectorINS_4pairIi12FieldElementEENS_9allocatorIS4_EEEERNS5_IS7_EEEC1EjjS9_($this,$__cap,$__start,$__a){
 var label=0;
 var sp=STACKTOP; (assert((STACKTOP|0) < (STACK_MAX|0))|0);

 var $1;
 var $2;
 var $3;
 var $4;
 $1=$this;
 $2=$__cap;
 $3=$__start;
 $4=$__a;
 var $5=$1;
 var $6=$2;
 var $7=$3;
 var $8=$4;
 __ZNSt3__114__split_bufferINS_6vectorINS_4pairIi12FieldElementEENS_9allocatorIS4_EEEERNS5_IS7_EEEC2EjjS9_($5,$6,$7,$8);
 STACKTOP=sp;return;
}


function __ZNSt3__16vectorINS0_INS_4pairIi12FieldElementEENS_9allocatorIS3_EEEENS4_IS6_EEE26__swap_out_circular_bufferERNS_14__split_bufferIS6_RS7_EE($this,$__v){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+24)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1;
 var $2;
 var $3;
 var $4;
 var $5;
 var $6;
 var $7;
 var $8;
 var $9;
 var $10;
 var $11;
 var $12;
 var $13;
 var $14;
 var $15;
 var $16;
 var $17;
 var $__t_i2=sp;
 var $18;
 var $19;
 var $20;
 var $21;
 var $22;
 var $__t_i1=(sp)+(8);
 var $23;
 var $24;
 var $25;
 var $26;
 var $27;
 var $28;
 var $29;
 var $30;
 var $31;
 var $32;
 var $33;
 var $__t_i=(sp)+(16);
 var $34;
 var $35;
 var $36;
 var $37;
 var $38;
 var $39;
 $38=$this;
 $39=$__v;
 var $40=$38;
 var $41=$40;
 $37=$41;
 var $42=$37;
 var $43=(($42+8)|0);
 $36=$43;
 var $44=$36;
 var $45=$44;
 $35=$45;
 var $46=$35;
 var $47=$46;
 var $48=$40;
 var $49=(($48)|0);
 var $50=HEAP32[(($49)>>2)];
 var $51=$40;
 var $52=(($51+4)|0);
 var $53=HEAP32[(($52)>>2)];
 var $54=$39;
 var $55=(($54+4)|0);
 $9=$47;
 $10=$50;
 $11=$53;
 $12=$55;
 label=2;break;
 case 2: 
 var $57=$11;
 var $58=$10;
 var $59=($57|0)!=($58|0);
 if($59){label=3;break;}else{label=6;break;}
 case 3: 
 var $61=$9;
 var $62=$12;
 var $63=HEAP32[(($62)>>2)];
 var $64=((($63)-(12))|0);
 $8=$64;
 var $65=$8;
 var $66=$11;
 var $67=((($66)-(12))|0);
 $11=$67;
 $2=$67;
 var $68=$2;
 $1=$68;
 var $69=$1;
 $5=$61;
 $6=$65;
 $7=$69;
 var $70=$6;
 var $71=$70;
 var $72=($71|0)==0;
 if($72){var $76=0;label=5;break;}else{label=4;break;}
 case 4: 
 var $74=$71;
 var $75=$7;
 __ZNSt3__16vectorINS_4pairIi12FieldElementEENS_9allocatorIS3_EEEC1ERKS6_($74,$75);
 var $76=$74;label=5;break;
 case 5: 
 var $76;
 var $77=$12;
 var $78=HEAP32[(($77)>>2)];
 var $79=((($78)-(12))|0);
 HEAP32[(($77)>>2)]=$79;
 label=2;break;
 case 6: 
 var $80=$40;
 var $81=(($80)|0);
 var $82=$39;
 var $83=(($82+4)|0);
 $16=$81;
 $17=$83;
 var $84=$16;
 $15=$84;
 var $85=$15;
 var $86=HEAP32[(($85)>>2)];
 HEAP32[(($__t_i2)>>2)]=$86;
 var $87=$17;
 $13=$87;
 var $88=$13;
 var $89=HEAP32[(($88)>>2)];
 var $90=$16;
 HEAP32[(($90)>>2)]=$89;
 $14=$__t_i2;
 var $91=$14;
 var $92=HEAP32[(($91)>>2)];
 var $93=$17;
 HEAP32[(($93)>>2)]=$92;
 var $94=$40;
 var $95=(($94+4)|0);
 var $96=$39;
 var $97=(($96+8)|0);
 $21=$95;
 $22=$97;
 var $98=$21;
 $20=$98;
 var $99=$20;
 var $100=HEAP32[(($99)>>2)];
 HEAP32[(($__t_i1)>>2)]=$100;
 var $101=$22;
 $18=$101;
 var $102=$18;
 var $103=HEAP32[(($102)>>2)];
 var $104=$21;
 HEAP32[(($104)>>2)]=$103;
 $19=$__t_i1;
 var $105=$19;
 var $106=HEAP32[(($105)>>2)];
 var $107=$22;
 HEAP32[(($107)>>2)]=$106;
 var $108=$40;
 $25=$108;
 var $109=$25;
 var $110=(($109+8)|0);
 $24=$110;
 var $111=$24;
 var $112=$111;
 $23=$112;
 var $113=$23;
 var $114=(($113)|0);
 var $115=$39;
 $28=$115;
 var $116=$28;
 var $117=(($116+12)|0);
 $27=$117;
 var $118=$27;
 var $119=$118;
 $26=$119;
 var $120=$26;
 var $121=(($120)|0);
 $32=$114;
 $33=$121;
 var $122=$32;
 $31=$122;
 var $123=$31;
 var $124=HEAP32[(($123)>>2)];
 HEAP32[(($__t_i)>>2)]=$124;
 var $125=$33;
 $29=$125;
 var $126=$29;
 var $127=HEAP32[(($126)>>2)];
 var $128=$32;
 HEAP32[(($128)>>2)]=$127;
 $30=$__t_i;
 var $129=$30;
 var $130=HEAP32[(($129)>>2)];
 var $131=$33;
 HEAP32[(($131)>>2)]=$130;
 var $132=$39;
 var $133=(($132+4)|0);
 var $134=HEAP32[(($133)>>2)];
 var $135=$39;
 var $136=(($135)|0);
 HEAP32[(($136)>>2)]=$134;
 $34=$40;
 var $137=$34;
 STACKTOP=sp;return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__114__split_bufferINS_6vectorINS_4pairIi12FieldElementEENS_9allocatorIS4_EEEERNS5_IS7_EEED1Ev($this){
 var label=0;
 var sp=STACKTOP; (assert((STACKTOP|0) < (STACK_MAX|0))|0);

 var $1;
 $1=$this;
 var $2=$1;
 __ZNSt3__114__split_bufferINS_6vectorINS_4pairIi12FieldElementEENS_9allocatorIS4_EEEERNS5_IS7_EEED2Ev($2);
 STACKTOP=sp;return;
}


function __ZNSt3__114__split_bufferINS_6vectorINS_4pairIi12FieldElementEENS_9allocatorIS4_EEEERNS5_IS7_EEED2Ev($this){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+40)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1;
 var $2;
 var $3;
 var $4;
 var $5;
 var $6;
 var $7;
 var $8;
 var $9;
 var $10;
 var $11;
 var $12;
 var $13;
 var $14;
 var $15;
 var $16;
 var $17=sp;
 var $18;
 var $19;
 var $20=(sp)+(8);
 var $21=(sp)+(16);
 var $22;
 var $23;
 var $24;
 var $25;
 var $26;
 var $27;
 var $28;
 var $29=(sp)+(24);
 var $30;
 var $31;
 var $32=(sp)+(32);
 var $33;
 var $34;
 $34=$this;
 var $35=$34;
 $33=$35;
 var $36=$33;
 var $37=(($36+4)|0);
 var $38=HEAP32[(($37)>>2)];
 $30=$36;
 $31=$38;
 var $39=$30;
 var $40=$31;
 var $tmp_i_i=$29;
 var $tmp1_i_i=$32;
 assert(1 % 1 === 0);HEAP8[($tmp_i_i)]=HEAP8[($tmp1_i_i)];
 $25=$39;
 $26=$40;
 var $41=$25;
 label=2;break;
 case 2: 
 var $43=$26;
 var $44=(($41+8)|0);
 var $45=HEAP32[(($44)>>2)];
 var $46=($43|0)!=($45|0);
 if($46){label=3;break;}else{label=6;break;}
 case 3: 
 $24=$41;
 var $48=$24;
 var $49=(($48+12)|0);
 $23=$49;
 var $50=$23;
 var $51=$50;
 $22=$51;
 var $52=$22;
 var $53=(($52+4)|0);
 var $54=HEAP32[(($53)>>2)];
 var $55=(($41+8)|0);
 var $56=HEAP32[(($55)>>2)];
 var $57=((($56)-(12))|0);
 HEAP32[(($55)>>2)]=$57;
 $14=$57;
 var $58=$14;
 $18=$54;
 $19=$58;
 var $59=$21;
 var $60=$18;
 var $61=$19;
 var $tmp_i_i_i_i=$17;
 var $tmp1_i_i_i_i=$20;
 assert(1 % 1 === 0);HEAP8[($tmp_i_i_i_i)]=HEAP8[($tmp1_i_i_i_i)];
 $15=$60;
 $16=$61;
 var $62=$16;
 (function() { try { __THREW__ = 0; return __ZNSt3__16vectorINS_4pairIi12FieldElementEENS_9allocatorIS3_EEED1Ev($62) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=4;break; } else { label=5;break; }
 case 4: 
 label=2;break;
 case 5: 
 var $64$0 = ___cxa_find_matching_catch(-1, -1); var $64$1 = tempRet0;
 var $65=$64$0;
 $27=$65;
 var $66=$64$1;
 $28=$66;
 var $67=$27;
 ___cxa_call_unexpected($67);
 throw "Reached an unreachable!";
 case 6: 
 var $68=(($35)|0);
 var $69=HEAP32[(($68)>>2)];
 var $70=($69|0)!=0;
 if($70){label=7;break;}else{label=8;break;}
 case 7: 
 $13=$35;
 var $72=$13;
 var $73=(($72+12)|0);
 $12=$73;
 var $74=$12;
 var $75=$74;
 $11=$75;
 var $76=$11;
 var $77=(($76+4)|0);
 var $78=HEAP32[(($77)>>2)];
 var $79=(($35)|0);
 var $80=HEAP32[(($79)>>2)];
 $10=$35;
 var $81=$10;
 $9=$81;
 var $82=$9;
 var $83=(($82+12)|0);
 $8=$83;
 var $84=$8;
 var $85=$84;
 $7=$85;
 var $86=$7;
 var $87=(($86)|0);
 var $88=HEAP32[(($87)>>2)];
 var $89=(($81)|0);
 var $90=HEAP32[(($89)>>2)];
 var $91=$88;
 var $92=$90;
 var $93=((($91)-($92))|0);
 var $94=(((($93|0))/(12))&-1);
 $4=$78;
 $5=$80;
 $6=$94;
 var $95=$4;
 var $96=$5;
 var $97=$6;
 $1=$95;
 $2=$96;
 $3=$97;
 var $98=$1;
 var $99=$2;
 var $100=$99;
 __ZdlPv($100);
 label=8;break;
 case 8: 
 STACKTOP=sp;return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__16vectorINS0_INS_4pairIi12FieldElementEENS_9allocatorIS3_EEEENS4_IS6_EEE8max_sizeEv($this){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+56)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1;
 var $2;
 var $3=sp;
 var $4;
 var $5=(sp)+(8);
 var $6=(sp)+(16);
 var $7;
 var $8;
 var $9;
 var $10;
 var $11;
 var $12;
 var $13;
 var $14=(sp)+(24);
 var $15;
 var $16;
 var $17=(sp)+(32);
 var $18;
 var $19;
 var $20;
 var $21;
 var $22=(sp)+(40);
 var $23=(sp)+(48);
 var $24;
 var $25;
 $21=$this;
 var $26=$21;
 var $27=$26;
 $20=$27;
 var $28=$20;
 var $29=(($28+8)|0);
 $19=$29;
 var $30=$19;
 var $31=$30;
 $18=$31;
 var $32=$18;
 var $33=$32;
 $4=$33;
 var $34=$6;
 var $35=$4;
 var $tmp_i1=$3;
 var $tmp1_i2=$5;
 assert(1 % 1 === 0);HEAP8[($tmp_i1)]=HEAP8[($tmp1_i2)];
 $2=$35;
 var $36=$2;
 $1=$36;
 var $37=$1;
 HEAP32[(($22)>>2)]=357913941;
 var $38=((2147483647)&-1);
 HEAP32[(($23)>>2)]=$38;
 $15=$22;
 $16=$23;
 var $39=$15;
 var $40=$16;
 var $tmp_i=$14;
 var $tmp1_i=$17;
 assert(1 % 1 === 0);HEAP8[($tmp_i)]=HEAP8[($tmp1_i)];
 $12=$39;
 $13=$40;
 var $41=$13;
 var $42=$12;
 $9=$14;
 $10=$41;
 $11=$42;
 var $43=$9;
 var $44=$10;
 var $45=HEAP32[(($44)>>2)];
 var $46=$11;
 var $47=HEAP32[(($46)>>2)];
 var $48=($45>>>0)<($47>>>0);
 if($48){label=2;break;}else{label=3;break;}
 case 2: 
 var $50=$13;
 var $53=$50;label=4;break;
 case 3: 
 var $52=$12;
 var $53=$52;label=4;break;
 case 4: 
 var $53;
 label=5;break;
 case 5: 
 var $55=HEAP32[(($53)>>2)];
 STACKTOP=sp;return $55;
 case 6: 
 var $61=$24;
 ___cxa_call_unexpected($61);
 throw "Reached an unreachable!";
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__114__split_bufferINS_6vectorINS_4pairIi12FieldElementEENS_9allocatorIS4_EEEERNS5_IS7_EEEC2EjjS9_($this,$__cap,$__start,$__a){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+32)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1;
 var $2;
 var $3;
 var $4;
 var $5=sp;
 var $6;
 var $7;
 var $8;
 var $9=(sp)+(8);
 var $10;
 var $11;
 var $12;
 var $13;
 var $14;
 var $15;
 var $16;
 var $17;
 var $18;
 var $19;
 var $20;
 var $21;
 var $22;
 var $23;
 var $24;
 var $25;
 var $26;
 var $27;
 var $28;
 var $29;
 var $30;
 var $31;
 var $32;
 var $33;
 var $34;
 var $35;
 var $36;
 var $37;
 var $38;
 var $39=(sp)+(16);
 var $40=(sp)+(24);
 $35=$this;
 $36=$__cap;
 $37=$__start;
 $38=$__a;
 var $41=$35;
 var $42=$41;
 var $43=(($41+12)|0);
 $33=$39;
 $34=-1;
 var $44=$33;
 var $45=$34;
 $31=$44;
 $32=$45;
 var $46=$31;
 var $47=(($46)|0);
 HEAP32[(($47)>>2)]=0;
 $17=$39;
 var $48=$17;
 var $49=$38;
 $11=$43;
 $12=0;
 $13=$49;
 var $50=$11;
 var $51=$12;
 var $52=$13;
 $8=$50;
 HEAP32[(($9)>>2)]=$51;
 $10=$52;
 var $53=$8;
 var $54=$53;
 $7=$9;
 var $55=$7;
 var $56=HEAP32[(($55)>>2)];
 var $57=$10;
 $1=$57;
 var $58=$1;
 $4=$54;
 HEAP32[(($5)>>2)]=$56;
 $6=$58;
 var $59=$4;
 var $60=(($59)|0);
 $3=$5;
 var $61=$3;
 var $62=HEAP32[(($61)>>2)];
 HEAP32[(($60)>>2)]=$62;
 var $63=(($59+4)|0);
 var $64=$6;
 $2=$64;
 var $65=$2;
 HEAP32[(($63)>>2)]=$65;
 var $66=$36;
 var $67=($66|0)!=0;
 if($67){label=2;break;}else{label=3;break;}
 case 2: 
 $16=$41;
 var $69=$16;
 var $70=(($69+12)|0);
 $15=$70;
 var $71=$15;
 var $72=$71;
 $14=$72;
 var $73=$14;
 var $74=(($73+4)|0);
 var $75=HEAP32[(($74)>>2)];
 var $76=$36;
 $21=$75;
 $22=$76;
 var $77=$21;
 var $78=$22;
 $18=$77;
 $19=$78;
 $20=0;
 var $79=$18;
 var $80=$19;
 var $81=((($80)*(12))&-1);
 var $82=__Znwj($81);
 var $83=$82;
 var $91=$83;label=4;break;
 case 3: 
 $25=$40;
 $26=-1;
 var $85=$25;
 var $86=$26;
 $23=$85;
 $24=$86;
 var $87=$23;
 var $88=(($87)|0);
 HEAP32[(($88)>>2)]=0;
 $27=$40;
 var $89=$27;
 var $91=0;label=4;break;
 case 4: 
 var $91;
 var $92=(($41)|0);
 HEAP32[(($92)>>2)]=$91;
 var $93=(($41)|0);
 var $94=HEAP32[(($93)>>2)];
 var $95=$37;
 var $96=(($94+((($95)*(12))&-1))|0);
 var $97=(($41+8)|0);
 HEAP32[(($97)>>2)]=$96;
 var $98=(($41+4)|0);
 HEAP32[(($98)>>2)]=$96;
 var $99=(($41)|0);
 var $100=HEAP32[(($99)>>2)];
 var $101=$36;
 var $102=(($100+((($101)*(12))&-1))|0);
 $30=$41;
 var $103=$30;
 var $104=(($103+12)|0);
 $29=$104;
 var $105=$29;
 var $106=$105;
 $28=$106;
 var $107=$28;
 var $108=(($107)|0);
 HEAP32[(($108)>>2)]=$102;
 STACKTOP=sp;return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__16vectorINS_4pairIi12FieldElementEENS_9allocatorIS3_EEEC1ERKS6_($this,$__x){
 var label=0;
 var sp=STACKTOP; (assert((STACKTOP|0) < (STACK_MAX|0))|0);

 var $1;
 var $2;
 $1=$this;
 $2=$__x;
 var $3=$1;
 var $4=$2;
 __ZNSt3__16vectorINS_4pairIi12FieldElementEENS_9allocatorIS3_EEEC2ERKS6_($3,$4);
 STACKTOP=sp;return;
}

// WARNING: content after a branch in a label, line: 6950
// WARNING: content after a branch in a label, line: 6952
// WARNING: content after a branch in a label, line: 6953
// WARNING: content after a branch in a label, line: 6954
// WARNING: content after a branch in a label, line: 6955
// WARNING: content after a branch in a label, line: 6956

function __ZNSt3__16vectorINS_4pairIi12FieldElementEENS_9allocatorIS3_EEEC2ERKS6_($this,$__x){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+112)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1;
 var $2;
 var $3;
 var $4;
 var $5;
 var $6;
 var $7;
 var $8;
 var $9;
 var $10;
 var $11;
 var $12;
 var $13;
 var $14;
 var $15;
 var $16;
 var $17;
 var $18;
 var $19;
 var $20;
 var $21=sp;
 var $22=(sp)+(8);
 var $23;
 var $24;
 var $25=(sp)+(16);
 var $26=(sp)+(24);
 var $__t21_i_i=(sp)+(32);
 var $27;
 var $28;
 var $29=(sp)+(40);
 var $30;
 var $31;
 var $32;
 var $33=(sp)+(48);
 var $34=(sp)+(56);
 var $35=(sp)+(64);
 var $36=(sp)+(72);
 var $37;
 var $38=(sp)+(80);
 var $39;
 var $40=(sp)+(88);
 var $41=(sp)+(96);
 var $42;
 var $43;
 var $44;
 var $45;
 var $46;
 var $47=(sp)+(104);
 var $__n;
 var $48;
 var $49;
 $45=$this;
 $46=$__x;
 var $50=$45;
 var $51=$50;
 var $52=$46;
 var $53=$52;
 $44=$53;
 var $54=$44;
 var $55=(($54+8)|0);
 $43=$55;
 var $56=$43;
 var $57=$56;
 $42=$57;
 var $58=$42;
 var $59=$58;
 $39=$59;
 var $60=$41;
 var $61=$39;
 var $tmp_i=$38;
 var $tmp1_i=$40;
 assert(1 % 1 === 0);HEAP8[($tmp_i)]=HEAP8[($tmp1_i)];
 $37=$61;
 var $62=$37;
 $31=$51;
 $32=$47;
 var $63=$31;
 var $64=$63;
 $30=$64;
 var $65=$30;
 var $66=(($63)|0);
 $4=$33;
 $5=-1;
 var $67=$4;
 var $68=$5;
 $2=$67;
 $3=$68;
 var $69=$2;
 var $70=(($69)|0);
 HEAP32[(($70)>>2)]=0;
 $6=$33;
 var $71=$6;
 HEAP32[(($66)>>2)]=0;
 var $72=(($63+4)|0);
 $9=$34;
 $10=-1;
 var $73=$9;
 var $74=$10;
 $7=$73;
 $8=$74;
 var $75=$7;
 var $76=(($75)|0);
 HEAP32[(($76)>>2)]=0;
 $11=$34;
 var $77=$11;
 HEAP32[(($72)>>2)]=0;
 var $78=(($63+8)|0);
 $14=$35;
 $15=-1;
 var $79=$14;
 var $80=$15;
 $12=$79;
 $13=$80;
 var $81=$12;
 var $82=(($81)|0);
 HEAP32[(($82)>>2)]=0;
 $16=$35;
 var $83=$16;
 var $84=$32;
 var $tmp_i1=$29;
 var $tmp1_i2=$36;
 assert(1 % 1 === 0);HEAP8[($tmp_i1)]=HEAP8[($tmp1_i2)];
 $27=$78;
 $28=0;
 var $85=$27;
 var $86=$28;
 var $tmp_i_i=$__t21_i_i;
 var $tmp2_i_i=$29;
 assert(1 % 1 === 0);HEAP8[($tmp_i_i)]=HEAP8[($tmp2_i_i)];
 $24=$85;
 HEAP32[(($25)>>2)]=$86;
 var $87=$24;
 var $88=$87;
 $23=$25;
 var $89=$23;
 var $90=HEAP32[(($89)>>2)];
 $17=$__t21_i_i;
 var $91=$17;
 var $tmp_i_i_i=$22;
 var $tmp1_i_i_i=$26;
 assert(1 % 1 === 0);HEAP8[($tmp_i_i_i)]=HEAP8[($tmp1_i_i_i)];
 $20=$88;
 HEAP32[(($21)>>2)]=$90;
 var $92=$20;
 var $93=$92;
 $19=$22;
 var $94=$19;
 var $95=(($92)|0);
 $18=$21;
 var $96=$18;
 var $97=HEAP32[(($96)>>2)];
 HEAP32[(($95)>>2)]=$97;
 var $98=$46;
 $1=$98;
 var $99=$1;
 var $100=$99;
 var $101=(($100+4)|0);
 var $102=HEAP32[(($101)>>2)];
 var $103=$99;
 var $104=(($103)|0);
 var $105=HEAP32[(($104)>>2)];
 var $106=$102;
 var $107=$105;
 var $108=((($106)-($107))|0);
 var $109=(((($108|0))/(28))&-1);
 $__n=$109;
 var $110=$__n;
 var $111=($110>>>0)>0;
 if($111){label=2;break;}else{label=6;break;}
 case 2: 
 var $113=$__n;
 (function() { try { __THREW__ = 0; return __ZNSt3__16vectorINS_4pairIi12FieldElementEENS_9allocatorIS3_EEE8allocateEj($50,$113) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=3;break; } else { label=5;break; }
 case 3: 
 var $115=$46;
 var $116=$115;
 var $117=(($116)|0);
 var $118=HEAP32[(($117)>>2)];
 var $119=$46;
 var $120=$119;
 var $121=(($120+4)|0);
 var $122=HEAP32[(($121)>>2)];
 (function() { try { __THREW__ = 0; return __ZNSt3__16vectorINS_4pairIi12FieldElementEENS_9allocatorIS3_EEE18__construct_at_endIPS3_EENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESA_SA_($50,$118,$122) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=4;break; } else { label=5;break; }
 case 4: 
 label=6;break;
 case 5: 
 var $125$0 = ___cxa_find_matching_catch(-1, -1); var $125$1 = tempRet0;
 var $126=$125$0;
 $48=$126;
 var $127=$125$1;
 $49=$127;
 var $128=$50;
 (function() { try { __THREW__ = 0; return __ZNSt3__113__vector_baseINS_4pairIi12FieldElementEENS_9allocatorIS3_EEED2Ev($128) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=7;break; } else { label=9;break; }
 case 6: 
 STACKTOP=sp;return;
 case 7: 
 label=8;break;
 case 8: 
 var $132=$48;
 var $133=$49;
 var $134$0=$132;
 var $134$1=0;
 var $135$0=$134$0;
 var $135$1=$133;
 ___resumeException($135$0)
 case 9: 
 var $137$0 = ___cxa_find_matching_catch(-1, -1,0); var $137$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__16vectorINS_4pairIi12FieldElementEENS_9allocatorIS3_EEE8allocateEj($this,$__n){
 var label=0;
 var sp=STACKTOP; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1;
 var $2;
 var $3;
 var $4;
 var $5;
 var $6;
 var $7;
 var $8;
 var $9;
 var $10;
 var $11;
 var $12;
 var $13;
 $12=$this;
 $13=$__n;
 var $14=$12;
 var $15=$13;
 var $16=__ZNKSt3__16vectorINS_4pairIi12FieldElementEENS_9allocatorIS3_EEE8max_sizeEv($14);
 var $17=($15>>>0)>($16>>>0);
 if($17){label=2;break;}else{label=3;break;}
 case 2: 
 var $19=$14;
 __ZNKSt3__120__vector_base_commonILb1EE20__throw_length_errorEv($19);
 label=3;break;
 case 3: 
 var $21=$14;
 $11=$21;
 var $22=$11;
 var $23=(($22+8)|0);
 $10=$23;
 var $24=$10;
 var $25=$24;
 $9=$25;
 var $26=$9;
 var $27=$26;
 var $28=$13;
 $4=$27;
 $5=$28;
 var $29=$4;
 var $30=$5;
 $1=$29;
 $2=$30;
 $3=0;
 var $31=$1;
 var $32=$2;
 var $33=((($32)*(28))&-1);
 var $34=__Znwj($33);
 var $35=$34;
 var $36=$14;
 var $37=(($36+4)|0);
 HEAP32[(($37)>>2)]=$35;
 var $38=$14;
 var $39=(($38)|0);
 HEAP32[(($39)>>2)]=$35;
 var $40=$14;
 var $41=(($40)|0);
 var $42=HEAP32[(($41)>>2)];
 var $43=$13;
 var $44=(($42+((($43)*(28))&-1))|0);
 var $45=$14;
 $8=$45;
 var $46=$8;
 var $47=(($46+8)|0);
 $7=$47;
 var $48=$7;
 var $49=$48;
 $6=$49;
 var $50=$6;
 var $51=(($50)|0);
 HEAP32[(($51)>>2)]=$44;
 STACKTOP=sp;return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__16vectorINS_4pairIi12FieldElementEENS_9allocatorIS3_EEE18__construct_at_endIPS3_EENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESA_SA_($this,$__first,$__last){
 var label=0;
 var sp=STACKTOP; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1;
 var $2;
 var $3;
 var $4;
 var $5;
 var $6;
 var $7;
 var $8;
 var $9;
 var $10;
 var $__a;
 $8=$this;
 $9=$__first;
 $10=$__last;
 var $11=$8;
 var $12=$11;
 $7=$12;
 var $13=$7;
 var $14=(($13+8)|0);
 $6=$14;
 var $15=$6;
 var $16=$15;
 $5=$16;
 var $17=$5;
 var $18=$17;
 $__a=$18;
 label=2;break;
 case 2: 
 var $20=$9;
 var $21=$10;
 var $22=($20|0)!=($21|0);
 if($22){label=3;break;}else{label=7;break;}
 case 3: 
 var $24=$__a;
 var $25=$11;
 var $26=(($25+4)|0);
 var $27=HEAP32[(($26)>>2)];
 $1=$27;
 var $28=$1;
 var $29=$9;
 $2=$24;
 $3=$28;
 $4=$29;
 var $30=$3;
 var $31=$30;
 var $32=($31|0)==0;
 if($32){var $36=0;label=5;break;}else{label=4;break;}
 case 4: 
 var $34=$31;
 var $35=$4;
 __ZNSt3__14pairIi12FieldElementEC1ERKS2_($34,$35);
 var $36=$34;label=5;break;
 case 5: 
 var $36;
 var $37=$11;
 var $38=(($37+4)|0);
 var $39=HEAP32[(($38)>>2)];
 var $40=(($39+28)|0);
 HEAP32[(($38)>>2)]=$40;
 label=6;break;
 case 6: 
 var $42=$9;
 var $43=(($42+28)|0);
 $9=$43;
 label=2;break;
 case 7: 
 STACKTOP=sp;return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__113__vector_baseINS_4pairIi12FieldElementEENS_9allocatorIS3_EEED2Ev($this){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+32)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1;
 var $2;
 var $3;
 var $4=sp;
 var $5;
 var $6;
 var $7=(sp)+(8);
 var $8=(sp)+(16);
 var $9;
 var $10;
 var $11;
 var $12;
 var $13;
 var $14;
 var $15;
 var $16;
 var $17;
 var $18;
 var $19;
 var $20;
 var $21;
 var $22;
 var $23;
 var $24;
 var $25;
 var $26;
 var $27;
 var $28;
 var $29;
 var $30;
 var $31;
 var $32;
 var $33;
 var $34;
 var $35;
 var $36=(sp)+(24);
 $35=$this;
 var $37=$35;
 var $38=(($37)|0);
 var $39=HEAP32[(($38)>>2)];
 $33=$36;
 $34=-1;
 var $40=$33;
 var $41=$34;
 $31=$40;
 $32=$41;
 var $42=$31;
 var $43=(($42)|0);
 HEAP32[(($43)>>2)]=0;
 $24=$36;
 var $44=$24;
 var $45=($39|0)!=0;
 if($45){label=2;break;}else{label=8;break;}
 case 2: 
 $16=$37;
 var $47=$16;
 var $48=(($47)|0);
 var $49=HEAP32[(($48)>>2)];
 $12=$47;
 $13=$49;
 var $50=$12;
 label=3;break;
 case 3: 
 var $52=$13;
 var $53=(($50+4)|0);
 var $54=HEAP32[(($53)>>2)];
 var $55=($52|0)!=($54|0);
 if($55){label=4;break;}else{label=7;break;}
 case 4: 
 $11=$50;
 var $57=$11;
 var $58=(($57+8)|0);
 $10=$58;
 var $59=$10;
 var $60=$59;
 $9=$60;
 var $61=$9;
 var $62=$61;
 var $63=(($50+4)|0);
 var $64=HEAP32[(($63)>>2)];
 var $65=((($64)-(28))|0);
 HEAP32[(($63)>>2)]=$65;
 $1=$65;
 var $66=$1;
 $5=$62;
 $6=$66;
 var $67=$8;
 var $68=$5;
 var $69=$6;
 var $tmp_i_i_i=$4;
 var $tmp1_i_i_i=$7;
 assert(1 % 1 === 0);HEAP8[($tmp_i_i_i)]=HEAP8[($tmp1_i_i_i)];
 $2=$68;
 $3=$69;
 var $70=$3;
 (function() { try { __THREW__ = 0; return __ZNSt3__14pairIi12FieldElementED1Ev($70) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=5;break; } else { label=6;break; }
 case 5: 
 label=3;break;
 case 6: 
 var $72$0 = ___cxa_find_matching_catch(-1, -1); var $72$1 = tempRet0;
 var $73=$72$0;
 $14=$73;
 var $74=$72$1;
 $15=$74;
 var $75=$14;
 ___cxa_call_unexpected($75);
 throw "Reached an unreachable!";
 case 7: 
 $19=$37;
 var $76=$19;
 var $77=(($76+8)|0);
 $18=$77;
 var $78=$18;
 var $79=$78;
 $17=$79;
 var $80=$17;
 var $81=$80;
 var $82=(($37)|0);
 var $83=HEAP32[(($82)>>2)];
 $23=$37;
 var $84=$23;
 $22=$84;
 var $85=$22;
 var $86=(($85+8)|0);
 $21=$86;
 var $87=$21;
 var $88=$87;
 $20=$88;
 var $89=$20;
 var $90=(($89)|0);
 var $91=HEAP32[(($90)>>2)];
 var $92=(($84)|0);
 var $93=HEAP32[(($92)>>2)];
 var $94=$91;
 var $95=$93;
 var $96=((($94)-($95))|0);
 var $97=(((($96|0))/(28))&-1);
 $28=$81;
 $29=$83;
 $30=$97;
 var $98=$28;
 var $99=$29;
 var $100=$30;
 $25=$98;
 $26=$99;
 $27=$100;
 var $101=$25;
 var $102=$26;
 var $103=$102;
 __ZdlPv($103);
 label=8;break;
 case 8: 
 STACKTOP=sp;return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__14pairIi12FieldElementED1Ev($this){
 var label=0;
 var sp=STACKTOP; (assert((STACKTOP|0) < (STACK_MAX|0))|0);

 var $1;
 $1=$this;
 var $2=$1;
 __ZNSt3__14pairIi12FieldElementED2Ev($2);
 STACKTOP=sp;return;
}


function __ZNSt3__14pairIi12FieldElementED2Ev($this){
 var label=0;
 var sp=STACKTOP; (assert((STACKTOP|0) < (STACK_MAX|0))|0);

 var $1;
 $1=$this;
 var $2=$1;
 var $3=(($2+4)|0);
 __ZN12FieldElementD1Ev($3);
 STACKTOP=sp;return;
}


function __ZNSt3__14pairIi12FieldElementEC1ERKS2_($this,$0){
 var label=0;
 var sp=STACKTOP; (assert((STACKTOP|0) < (STACK_MAX|0))|0);

 var $2;
 var $3;
 $2=$this;
 $3=$0;
 var $4=$2;
 var $5=$3;
 __ZNSt3__14pairIi12FieldElementEC2ERKS2_($4,$5);
 STACKTOP=sp;return;
}


function __ZNSt3__14pairIi12FieldElementEC2ERKS2_($this,$0){
 var label=0;
 var sp=STACKTOP; (assert((STACKTOP|0) < (STACK_MAX|0))|0);

 var $2;
 var $3;
 $2=$this;
 $3=$0;
 var $4=$2;
 var $5=(($4)|0);
 var $6=$3;
 var $7=(($6)|0);
 var $8=HEAP32[(($7)>>2)];
 HEAP32[(($5)>>2)]=$8;
 var $9=(($4+4)|0);
 var $10=$3;
 var $11=(($10+4)|0);
 __ZN12FieldElementC1ERKS_($9,$11);
 STACKTOP=sp;return;
}


function __ZNKSt3__16vectorINS_4pairIi12FieldElementEENS_9allocatorIS3_EEE8max_sizeEv($this){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+56)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1;
 var $2;
 var $3=sp;
 var $4;
 var $5=(sp)+(8);
 var $6=(sp)+(16);
 var $7;
 var $8;
 var $9;
 var $10;
 var $11;
 var $12;
 var $13;
 var $14=(sp)+(24);
 var $15;
 var $16;
 var $17=(sp)+(32);
 var $18;
 var $19;
 var $20;
 var $21;
 var $22=(sp)+(40);
 var $23=(sp)+(48);
 var $24;
 var $25;
 $21=$this;
 var $26=$21;
 var $27=$26;
 $20=$27;
 var $28=$20;
 var $29=(($28+8)|0);
 $19=$29;
 var $30=$19;
 var $31=$30;
 $18=$31;
 var $32=$18;
 var $33=$32;
 $4=$33;
 var $34=$6;
 var $35=$4;
 var $tmp_i1=$3;
 var $tmp1_i2=$5;
 assert(1 % 1 === 0);HEAP8[($tmp_i1)]=HEAP8[($tmp1_i2)];
 $2=$35;
 var $36=$2;
 $1=$36;
 var $37=$1;
 HEAP32[(($22)>>2)]=153391689;
 var $38=((2147483647)&-1);
 HEAP32[(($23)>>2)]=$38;
 $15=$22;
 $16=$23;
 var $39=$15;
 var $40=$16;
 var $tmp_i=$14;
 var $tmp1_i=$17;
 assert(1 % 1 === 0);HEAP8[($tmp_i)]=HEAP8[($tmp1_i)];
 $12=$39;
 $13=$40;
 var $41=$13;
 var $42=$12;
 $9=$14;
 $10=$41;
 $11=$42;
 var $43=$9;
 var $44=$10;
 var $45=HEAP32[(($44)>>2)];
 var $46=$11;
 var $47=HEAP32[(($46)>>2)];
 var $48=($45>>>0)<($47>>>0);
 if($48){label=2;break;}else{label=3;break;}
 case 2: 
 var $50=$13;
 var $53=$50;label=4;break;
 case 3: 
 var $52=$12;
 var $53=$52;label=4;break;
 case 4: 
 var $53;
 label=5;break;
 case 5: 
 var $55=HEAP32[(($53)>>2)];
 STACKTOP=sp;return $55;
 case 6: 
 var $61=$24;
 ___cxa_call_unexpected($61);
 throw "Reached an unreachable!";
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__116__pad_and_outputIcNS_11char_traitsIcEEEENS_19ostreambuf_iteratorIT_T0_EES6_PKS4_S8_S8_RNS_8ios_baseES4_($agg_result,$__s,$__ob,$__op,$__oe,$__iob,$__fl){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+48)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var tempParam = $__s; $__s=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__s)>>2)]=HEAP32[((tempParam)>>2)];
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1;
 var $2;
 var $3;
 var $4;
 var $5;
 var $6;
 var $7;
 var $8;
 var $9;
 var $10;
 var $11;
 var $12;
 var $13;
 var $14;
 var $15;
 var $16;
 var $17;
 var $18;
 var $19;
 var $20;
 var $21;
 var $22;
 var $23;
 var $24;
 var $25;
 var $26;
 var $27;
 var $28;
 var $29;
 var $30;
 var $31;
 var $32;
 var $33;
 var $34;
 var $35;
 var $36;
 var $37;
 var $38;
 var $39;
 var $40;
 var $41;
 var $42;
 var $43;
 var $44;
 var $45;
 var $46;
 var $47;
 var $48;
 var $49;
 var $50;
 var $51;
 var $52;
 var $__r_i;
 var $53;
 var $54;
 var $55;
 var $56;
 var $57;
 var $58;
 var $59;
 var $60;
 var $61;
 var $62=sp;
 var $__sz;
 var $__ns;
 var $__np;
 var $63=(sp)+(8);
 var $__sp=(sp)+(16);
 var $64;
 var $65;
 var $66=(sp)+(32);
 var $67;
 var $68=(sp)+(40);
 $57=$__ob;
 $58=$__op;
 $59=$__oe;
 $60=$__iob;
 $61=$__fl;
 var $69=(($__s)|0);
 var $70=HEAP32[(($69)>>2)];
 $55=$62;
 $56=-1;
 var $71=$55;
 var $72=$56;
 $53=$71;
 $54=$72;
 var $73=$53;
 var $74=(($73)|0);
 HEAP32[(($74)>>2)]=0;
 $42=$62;
 var $75=$42;
 var $76=($70|0)==0;
 if($76){label=2;break;}else{label=3;break;}
 case 2: 
 var $78=$agg_result;
 var $79=$__s;
 assert(4 % 1 === 0);HEAP32[(($78)>>2)]=HEAP32[(($79)>>2)];
 label=30;break;
 case 3: 
 var $81=$59;
 var $82=$57;
 var $83=$81;
 var $84=$82;
 var $85=((($83)-($84))|0);
 $__sz=$85;
 var $86=$60;
 $41=$86;
 var $87=$41;
 var $88=(($87+12)|0);
 var $89=HEAP32[(($88)>>2)];
 $__ns=$89;
 var $90=$__ns;
 var $91=$__sz;
 var $92=($90|0)>($91|0);
 if($92){label=4;break;}else{label=5;break;}
 case 4: 
 var $94=$__sz;
 var $95=$__ns;
 var $96=((($95)-($94))|0);
 $__ns=$96;
 label=6;break;
 case 5: 
 $__ns=0;
 label=6;break;
 case 6: 
 var $99=$58;
 var $100=$57;
 var $101=$99;
 var $102=$100;
 var $103=((($101)-($102))|0);
 $__np=$103;
 var $104=$__np;
 var $105=($104|0)>0;
 if($105){label=7;break;}else{label=10;break;}
 case 7: 
 var $107=(($__s)|0);
 var $108=HEAP32[(($107)>>2)];
 var $109=$57;
 var $110=$__np;
 $38=$108;
 $39=$109;
 $40=$110;
 var $111=$38;
 var $112=$111;
 var $113=HEAP32[(($112)>>2)];
 var $114=(($113+48)|0);
 var $115=HEAP32[(($114)>>2)];
 var $116=$39;
 var $117=$40;
 var $118=FUNCTION_TABLE[$115]($111,$116,$117);
 var $119=$__np;
 var $120=($118|0)!=($119|0);
 if($120){label=8;break;}else{label=9;break;}
 case 8: 
 $36=$63;
 $37=-1;
 var $122=$36;
 var $123=$37;
 $34=$122;
 $35=$123;
 var $124=$34;
 var $125=(($124)|0);
 HEAP32[(($125)>>2)]=0;
 $25=$63;
 var $126=$25;
 var $127=(($__s)|0);
 HEAP32[(($127)>>2)]=0;
 var $128=$agg_result;
 var $129=$__s;
 assert(4 % 1 === 0);HEAP32[(($128)>>2)]=HEAP32[(($129)>>2)];
 label=30;break;
 case 9: 
 label=10;break;
 case 10: 
 var $132=$__ns;
 var $133=($132|0)>0;
 if($133){label=11;break;}else{label=25;break;}
 case 11: 
 var $135=$__ns;
 var $136=$61;
 $8=$__sp;
 $9=$135;
 $10=$136;
 var $137=$8;
 var $138=$9;
 var $139=$10;
 $5=$137;
 $6=$138;
 $7=$139;
 var $140=$5;
 var $141=$140;
 var $142=(($140)|0);
 $4=$142;
 var $143=$4;
 $3=$143;
 var $144=$3;
 var $145=$144;
 $2=$145;
 var $146=$2;
 var $147=$146;
 $1=$147;
 var $148=$1;
 var $149=(($146)|0);
 var $150=$6;
 var $151=$7;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEjc($140,$150,$151);
 var $152=(($__s)|0);
 var $153=HEAP32[(($152)>>2)];
 $24=$__sp;
 var $154=$24;
 $23=$154;
 var $155=$23;
 $22=$155;
 var $156=$22;
 var $157=(($156)|0);
 $21=$157;
 var $158=$21;
 var $159=$158;
 $20=$159;
 var $160=$20;
 var $161=(($160)|0);
 var $162=(($161)|0);
 var $163=$162;
 var $164=(($163)|0);
 var $165=$164;
 var $166=HEAP8[($165)];
 var $167=($166&255);
 var $168=$167&1;
 var $169=($168|0)!=0;
 if($169){label=12;break;}else{label=13;break;}
 case 12: 
 $14=$155;
 var $171=$14;
 var $172=(($171)|0);
 $13=$172;
 var $173=$13;
 var $174=$173;
 $12=$174;
 var $175=$12;
 var $176=(($175)|0);
 var $177=(($176)|0);
 var $178=$177;
 var $179=(($178+8)|0);
 var $180=HEAP32[(($179)>>2)];
 var $194=$180;label=14;break;
 case 13: 
 $19=$155;
 var $182=$19;
 var $183=(($182)|0);
 $18=$183;
 var $184=$18;
 var $185=$184;
 $17=$185;
 var $186=$17;
 var $187=(($186)|0);
 var $188=(($187)|0);
 var $189=$188;
 var $190=(($189+1)|0);
 var $191=(($190)|0);
 $16=$191;
 var $192=$16;
 $15=$192;
 var $193=$15;
 var $194=$193;label=14;break;
 case 14: 
 var $194;
 $11=$194;
 var $195=$11;
 var $196=$__ns;
 $26=$153;
 $27=$195;
 $28=$196;
 var $197=$26;
 var $198=$197;
 var $199=HEAP32[(($198)>>2)];
 var $200=(($199+48)|0);
 var $201=HEAP32[(($200)>>2)];
 var $202=$27;
 var $203=$28;
 var $204=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$201]($197,$202,$203) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=15;break; } else { label=20;break; }
 case 15: 
 label=16;break;
 case 16: 
 var $206=$__ns;
 var $207=($204|0)!=($206|0);
 if($207){label=17;break;}else{label=21;break;}
 case 17: 
 $31=$66;
 $32=-1;
 var $209=$31;
 var $210=$32;
 $29=$209;
 $30=$210;
 var $211=$29;
 var $212=(($211)|0);
 HEAP32[(($212)>>2)]=0;
 label=18;break;
 case 18: 
 $33=$66;
 var $214=$33;
 label=19;break;
 case 19: 
 var $216=(($__s)|0);
 HEAP32[(($216)>>2)]=0;
 var $217=$agg_result;
 var $218=$__s;
 assert(4 % 1 === 0);HEAP32[(($217)>>2)]=HEAP32[(($218)>>2)];
 $67=1;
 label=22;break;
 case 20: 
 var $220$0 = ___cxa_find_matching_catch(-1, -1); var $220$1 = tempRet0;
 var $221=$220$0;
 $64=$221;
 var $222=$220$1;
 $65=$222;
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__sp) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=24;break; } else { label=32;break; }
 case 21: 
 $67=0;
 label=22;break;
 case 22: 
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__sp);
 var $cleanup_dest=$67;
 if(($cleanup_dest|0)==0){ label=23;break;}else if(($cleanup_dest|0)==1){ label=30;break;}else{label=33;break;}
 case 23: 
 label=25;break;
 case 24: 
 label=31;break;
 case 25: 
 var $228=$59;
 var $229=$58;
 var $230=$228;
 var $231=$229;
 var $232=((($230)-($231))|0);
 $__np=$232;
 var $233=$__np;
 var $234=($233|0)>0;
 if($234){label=26;break;}else{label=29;break;}
 case 26: 
 var $236=(($__s)|0);
 var $237=HEAP32[(($236)>>2)];
 var $238=$58;
 var $239=$__np;
 $43=$237;
 $44=$238;
 $45=$239;
 var $240=$43;
 var $241=$240;
 var $242=HEAP32[(($241)>>2)];
 var $243=(($242+48)|0);
 var $244=HEAP32[(($243)>>2)];
 var $245=$44;
 var $246=$45;
 var $247=FUNCTION_TABLE[$244]($240,$245,$246);
 var $248=$__np;
 var $249=($247|0)!=($248|0);
 if($249){label=27;break;}else{label=28;break;}
 case 27: 
 $48=$68;
 $49=-1;
 var $251=$48;
 var $252=$49;
 $46=$251;
 $47=$252;
 var $253=$46;
 var $254=(($253)|0);
 HEAP32[(($254)>>2)]=0;
 $50=$68;
 var $255=$50;
 var $256=(($__s)|0);
 HEAP32[(($256)>>2)]=0;
 var $257=$agg_result;
 var $258=$__s;
 assert(4 % 1 === 0);HEAP32[(($257)>>2)]=HEAP32[(($258)>>2)];
 label=30;break;
 case 28: 
 label=29;break;
 case 29: 
 var $261=$60;
 $51=$261;
 $52=0;
 var $262=$51;
 var $263=(($262+12)|0);
 var $264=HEAP32[(($263)>>2)];
 $__r_i=$264;
 var $265=$52;
 var $266=(($262+12)|0);
 HEAP32[(($266)>>2)]=$265;
 var $267=$__r_i;
 var $268=$agg_result;
 var $269=$__s;
 assert(4 % 1 === 0);HEAP32[(($268)>>2)]=HEAP32[(($269)>>2)];
 label=30;break;
 case 30: 
 STACKTOP=sp;return;
 case 31: 
 var $272=$64;
 var $273=$65;
 var $274$0=$272;
 var $274$1=0;
 var $275$0=$274$0;
 var $275$1=$273;
 ___resumeException($275$0)
 case 32: 
 var $277$0 = ___cxa_find_matching_catch(-1, -1,0); var $277$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
 case 33: 
 throw "Reached an unreachable!";
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__16vectorI10__gmp_exprI12__gmpz_valueS2_ENS_9allocatorIS3_EEED2Ev($this){
 var label=0;
 var sp=STACKTOP; (assert((STACKTOP|0) < (STACK_MAX|0))|0);

 var $1;
 $1=$this;
 var $2=$1;
 var $3=$2;
 __ZNSt3__113__vector_baseI10__gmp_exprI12__gmpz_valueS2_ENS_9allocatorIS3_EEED2Ev($3);
 STACKTOP=sp;return;
}


function __ZNSt3__113__vector_baseI10__gmp_exprI12__gmpz_valueS2_ENS_9allocatorIS3_EEED2Ev($this){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+32)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1;
 var $2;
 var $3;
 var $4=sp;
 var $5;
 var $6;
 var $7=(sp)+(8);
 var $8=(sp)+(16);
 var $9;
 var $10;
 var $11;
 var $12;
 var $13;
 var $14;
 var $15;
 var $16;
 var $17;
 var $18;
 var $19;
 var $20;
 var $21;
 var $22;
 var $23;
 var $24;
 var $25;
 var $26;
 var $27;
 var $28;
 var $29;
 var $30;
 var $31;
 var $32;
 var $33;
 var $34;
 var $35;
 var $36=(sp)+(24);
 $35=$this;
 var $37=$35;
 var $38=(($37)|0);
 var $39=HEAP32[(($38)>>2)];
 $33=$36;
 $34=-1;
 var $40=$33;
 var $41=$34;
 $31=$40;
 $32=$41;
 var $42=$31;
 var $43=(($42)|0);
 HEAP32[(($43)>>2)]=0;
 $24=$36;
 var $44=$24;
 var $45=($39|0)!=0;
 if($45){label=2;break;}else{label=8;break;}
 case 2: 
 $16=$37;
 var $47=$16;
 var $48=(($47)|0);
 var $49=HEAP32[(($48)>>2)];
 $12=$47;
 $13=$49;
 var $50=$12;
 label=3;break;
 case 3: 
 var $52=$13;
 var $53=(($50+4)|0);
 var $54=HEAP32[(($53)>>2)];
 var $55=($52|0)!=($54|0);
 if($55){label=4;break;}else{label=7;break;}
 case 4: 
 $11=$50;
 var $57=$11;
 var $58=(($57+8)|0);
 $10=$58;
 var $59=$10;
 var $60=$59;
 $9=$60;
 var $61=$9;
 var $62=$61;
 var $63=(($50+4)|0);
 var $64=HEAP32[(($63)>>2)];
 var $65=((($64)-(12))|0);
 HEAP32[(($63)>>2)]=$65;
 $1=$65;
 var $66=$1;
 $5=$62;
 $6=$66;
 var $67=$8;
 var $68=$5;
 var $69=$6;
 var $tmp_i_i_i=$4;
 var $tmp1_i_i_i=$7;
 assert(1 % 1 === 0);HEAP8[($tmp_i_i_i)]=HEAP8[($tmp1_i_i_i)];
 $2=$68;
 $3=$69;
 var $70=$3;
 (function() { try { __THREW__ = 0; return __ZN10__gmp_exprI12__gmpz_valueS0_ED1Ev($70) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=5;break; } else { label=6;break; }
 case 5: 
 label=3;break;
 case 6: 
 var $72$0 = ___cxa_find_matching_catch(-1, -1); var $72$1 = tempRet0;
 var $73=$72$0;
 $14=$73;
 var $74=$72$1;
 $15=$74;
 var $75=$14;
 ___cxa_call_unexpected($75);
 throw "Reached an unreachable!";
 case 7: 
 $19=$37;
 var $76=$19;
 var $77=(($76+8)|0);
 $18=$77;
 var $78=$18;
 var $79=$78;
 $17=$79;
 var $80=$17;
 var $81=$80;
 var $82=(($37)|0);
 var $83=HEAP32[(($82)>>2)];
 $23=$37;
 var $84=$23;
 $22=$84;
 var $85=$22;
 var $86=(($85+8)|0);
 $21=$86;
 var $87=$21;
 var $88=$87;
 $20=$88;
 var $89=$20;
 var $90=(($89)|0);
 var $91=HEAP32[(($90)>>2)];
 var $92=(($84)|0);
 var $93=HEAP32[(($92)>>2)];
 var $94=$91;
 var $95=$93;
 var $96=((($94)-($95))|0);
 var $97=(((($96|0))/(12))&-1);
 $28=$81;
 $29=$83;
 $30=$97;
 var $98=$28;
 var $99=$29;
 var $100=$30;
 $25=$98;
 $26=$99;
 $27=$100;
 var $101=$25;
 var $102=$26;
 var $103=$102;
 __ZdlPv($103);
 label=8;break;
 case 8: 
 STACKTOP=sp;return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__16vectorINS0_INS_4pairIi12FieldElementEENS_9allocatorIS3_EEEENS4_IS6_EEED2Ev($this){
 var label=0;
 var sp=STACKTOP; (assert((STACKTOP|0) < (STACK_MAX|0))|0);

 var $1;
 $1=$this;
 var $2=$1;
 var $3=$2;
 __ZNSt3__113__vector_baseINS_6vectorINS_4pairIi12FieldElementEENS_9allocatorIS4_EEEENS5_IS7_EEED2Ev($3);
 STACKTOP=sp;return;
}


function __ZNSt3__113__vector_baseINS_6vectorINS_4pairIi12FieldElementEENS_9allocatorIS4_EEEENS5_IS7_EEED2Ev($this){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+32)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1;
 var $2;
 var $3;
 var $4=sp;
 var $5;
 var $6;
 var $7=(sp)+(8);
 var $8=(sp)+(16);
 var $9;
 var $10;
 var $11;
 var $12;
 var $13;
 var $14;
 var $15;
 var $16;
 var $17;
 var $18;
 var $19;
 var $20;
 var $21;
 var $22;
 var $23;
 var $24;
 var $25;
 var $26;
 var $27;
 var $28;
 var $29;
 var $30;
 var $31;
 var $32;
 var $33;
 var $34;
 var $35;
 var $36=(sp)+(24);
 $35=$this;
 var $37=$35;
 var $38=(($37)|0);
 var $39=HEAP32[(($38)>>2)];
 $33=$36;
 $34=-1;
 var $40=$33;
 var $41=$34;
 $31=$40;
 $32=$41;
 var $42=$31;
 var $43=(($42)|0);
 HEAP32[(($43)>>2)]=0;
 $24=$36;
 var $44=$24;
 var $45=($39|0)!=0;
 if($45){label=2;break;}else{label=8;break;}
 case 2: 
 $16=$37;
 var $47=$16;
 var $48=(($47)|0);
 var $49=HEAP32[(($48)>>2)];
 $12=$47;
 $13=$49;
 var $50=$12;
 label=3;break;
 case 3: 
 var $52=$13;
 var $53=(($50+4)|0);
 var $54=HEAP32[(($53)>>2)];
 var $55=($52|0)!=($54|0);
 if($55){label=4;break;}else{label=7;break;}
 case 4: 
 $11=$50;
 var $57=$11;
 var $58=(($57+8)|0);
 $10=$58;
 var $59=$10;
 var $60=$59;
 $9=$60;
 var $61=$9;
 var $62=$61;
 var $63=(($50+4)|0);
 var $64=HEAP32[(($63)>>2)];
 var $65=((($64)-(12))|0);
 HEAP32[(($63)>>2)]=$65;
 $1=$65;
 var $66=$1;
 $5=$62;
 $6=$66;
 var $67=$8;
 var $68=$5;
 var $69=$6;
 var $tmp_i_i_i=$4;
 var $tmp1_i_i_i=$7;
 assert(1 % 1 === 0);HEAP8[($tmp_i_i_i)]=HEAP8[($tmp1_i_i_i)];
 $2=$68;
 $3=$69;
 var $70=$3;
 (function() { try { __THREW__ = 0; return __ZNSt3__16vectorINS_4pairIi12FieldElementEENS_9allocatorIS3_EEED1Ev($70) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=5;break; } else { label=6;break; }
 case 5: 
 label=3;break;
 case 6: 
 var $72$0 = ___cxa_find_matching_catch(-1, -1); var $72$1 = tempRet0;
 var $73=$72$0;
 $14=$73;
 var $74=$72$1;
 $15=$74;
 var $75=$14;
 ___cxa_call_unexpected($75);
 throw "Reached an unreachable!";
 case 7: 
 $19=$37;
 var $76=$19;
 var $77=(($76+8)|0);
 $18=$77;
 var $78=$18;
 var $79=$78;
 $17=$79;
 var $80=$17;
 var $81=$80;
 var $82=(($37)|0);
 var $83=HEAP32[(($82)>>2)];
 $23=$37;
 var $84=$23;
 $22=$84;
 var $85=$22;
 var $86=(($85+8)|0);
 $21=$86;
 var $87=$21;
 var $88=$87;
 $20=$88;
 var $89=$20;
 var $90=(($89)|0);
 var $91=HEAP32[(($90)>>2)];
 var $92=(($84)|0);
 var $93=HEAP32[(($92)>>2)];
 var $94=$91;
 var $95=$93;
 var $96=((($94)-($95))|0);
 var $97=(((($96|0))/(12))&-1);
 $28=$81;
 $29=$83;
 $30=$97;
 var $98=$28;
 var $99=$29;
 var $100=$30;
 $25=$98;
 $26=$99;
 $27=$100;
 var $101=$25;
 var $102=$26;
 var $103=$102;
 __ZdlPv($103);
 label=8;break;
 case 8: 
 STACKTOP=sp;return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZlsRNSt3__113basic_ostreamIcNS_11char_traitsIcEEEERK10__gmp_exprI12__gmpz_valueS6_E($o,$z){
 var label=0;
 var sp=STACKTOP; (assert((STACKTOP|0) < (STACK_MAX|0))|0);

 var $1;
 var $2;
 $1=$o;
 $2=$z;
 var $3=$1;
 var $4=$2;
 var $5=__ZNK10__gmp_exprI12__gmpz_valueS0_E9get_mpz_tEv($4);
 var $6=__ZlsRNSt3__113basic_ostreamIcNS_11char_traitsIcEEEEPK12__mpz_struct($3,$5);
 STACKTOP=sp;return $6;
}


function __ZNK10__gmp_exprI12__gmpz_valueS0_E9get_mpz_tEv($this){
 var label=0;
 var sp=STACKTOP; (assert((STACKTOP|0) < (STACK_MAX|0))|0);

 var $1;
 $1=$this;
 var $2=$1;
 var $3=(($2)|0);
 var $4=(($3)|0);
 STACKTOP=sp;return $4;
}


function __ZNSt3__16vectorINS_4pairIi12FieldElementEENS_9allocatorIS3_EEED2Ev($this){
 var label=0;
 var sp=STACKTOP; (assert((STACKTOP|0) < (STACK_MAX|0))|0);

 var $1;
 $1=$this;
 var $2=$1;
 var $3=$2;
 __ZNSt3__113__vector_baseINS_4pairIi12FieldElementEENS_9allocatorIS3_EEED2Ev($3);
 STACKTOP=sp;return;
}


function __ZN12FieldElementC2ERKS_($this,$0){
 var label=0;
 var sp=STACKTOP; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $2;
 var $3;
 var $4;
 var $5;
 $2=$this;
 $3=$0;
 var $6=$2;
 var $7=(($6)|0);
 var $8=$3;
 var $9=(($8)|0);
 __ZN10__gmp_exprI12__gmpz_valueS0_EC1ERKS1_($7,$9);
 var $10=(($6+12)|0);
 var $11=$3;
 var $12=(($11+12)|0);
 (function() { try { __THREW__ = 0; return __ZN10__gmp_exprI12__gmpz_valueS0_EC1ERKS1_($10,$12) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=2;break; } else { label=3;break; }
 case 2: 
 STACKTOP=sp;return;
 case 3: 
 var $15$0 = ___cxa_find_matching_catch(-1, -1); var $15$1 = tempRet0;
 var $16=$15$0;
 $4=$16;
 var $17=$15$1;
 $5=$17;
 (function() { try { __THREW__ = 0; return __ZN10__gmp_exprI12__gmpz_valueS0_ED1Ev($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=4;break; } else { label=6;break; }
 case 4: 
 label=5;break;
 case 5: 
 var $20=$4;
 var $21=$5;
 var $22$0=$20;
 var $22$1=0;
 var $23$0=$22$0;
 var $23$1=$21;
 ___resumeException($23$0)
 case 6: 
 var $25$0 = ___cxa_find_matching_catch(-1, -1,0); var $25$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
  default: assert(0, "bad label: " + label);
 }

}


function __ZN10__gmp_exprI12__gmpz_valueS0_ED2Ev($this){
 var label=0;
 var sp=STACKTOP; (assert((STACKTOP|0) < (STACK_MAX|0))|0);

 var $1;
 $1=$this;
 var $2=$1;
 var $3=(($2)|0);
 var $4=(($3)|0);
 ___gmpz_clear($4);
 STACKTOP=sp;return;
}


function __ZN12FieldElementD2Ev($this){
 var label=0;
 var sp=STACKTOP; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1;
 var $2;
 var $3;
 $1=$this;
 var $4=$1;
 var $5=(($4+12)|0);
 (function() { try { __THREW__ = 0; return __ZN10__gmp_exprI12__gmpz_valueS0_ED1Ev($5) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=2;break; } else { label=3;break; }
 case 2: 
 var $7=(($4)|0);
 __ZN10__gmp_exprI12__gmpz_valueS0_ED1Ev($7);
 STACKTOP=sp;return;
 case 3: 
 var $9$0 = ___cxa_find_matching_catch(-1, -1); var $9$1 = tempRet0;
 var $10=$9$0;
 $2=$10;
 var $11=$9$1;
 $3=$11;
 var $12=(($4)|0);
 (function() { try { __THREW__ = 0; return __ZN10__gmp_exprI12__gmpz_valueS0_ED1Ev($12) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=4;break; } else { label=6;break; }
 case 4: 
 label=5;break;
 case 5: 
 var $15=$2;
 var $16=$3;
 var $17$0=$15;
 var $17$1=0;
 var $18$0=$17$0;
 var $18$1=$16;
 ___resumeException($18$0)
 case 6: 
 var $20$0 = ___cxa_find_matching_catch(-1, -1,0); var $20$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
  default: assert(0, "bad label: " + label);
 }

}


function __ZN10__gmp_exprI12__gmpz_valueS0_EC2ERKS1_($this,$z){
 var label=0;
 var sp=STACKTOP; (assert((STACKTOP|0) < (STACK_MAX|0))|0);

 var $1;
 var $2;
 $1=$this;
 $2=$z;
 var $3=$1;
 var $4=(($3)|0);
 var $5=(($3)|0);
 var $6=(($5)|0);
 var $7=$2;
 var $8=(($7)|0);
 var $9=(($8)|0);
 ___gmpz_init_set($6,$9);
 STACKTOP=sp;return;
}


function __ZNSt3__18ios_base4InitC2Ev($this){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+32)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=sp;
 var $2=(sp)+(8);
 var $3=(sp)+(16);
 var $4=(sp)+(24);
 var $5=HEAP32[((_stdin)>>2)];
 __ZNSt3__110__stdinbufIcEC2EP8_IO_FILEP11__mbstate_t(13464,$5,13592);
 HEAP32[((14456)>>2)]=5076;
 HEAP32[((14464)>>2)]=5096;
 HEAP32[((14460)>>2)]=0;
 (function() { try { __THREW__ = 0; return __ZNSt3__18ios_base4initEPv(14464,13464) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=3;break; } else { label=2;break; }
 case 2: 
 var $7$0 = ___cxa_find_matching_catch(-1, -1); var $7$1 = tempRet0;
 __ZNSt3__18ios_baseD2Ev(14464);
 ___resumeException($7$0)
 case 3: 
 HEAP32[((14536)>>2)]=0;
 HEAP32[((14540)>>2)]=-1;
 var $8=HEAP32[((_stdout)>>2)];
 var $9=$4;
 HEAP32[((13368)>>2)]=4808;
 __ZNSt3__16localeC2Ev(13372);
 HEAP32[((13376)>>2)]=0; HEAP32[((13380)>>2)]=0; HEAP32[((13384)>>2)]=0; HEAP32[((13388)>>2)]=0; HEAP32[((13392)>>2)]=0; HEAP32[((13396)>>2)]=0;
 HEAP32[((13368)>>2)]=5296;
 HEAP32[((13400)>>2)]=$8;
 __ZNSt3__16localeC2ERKS0_($4,13372);
 var $10=(function() { try { __THREW__ = 0; return __ZNKSt3__16locale9use_facetERNS0_2idE($4,13792) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=5;break; } else { label=4;break; }
 case 4: 
 var $12$0 = ___cxa_find_matching_catch(-1, -1); var $12$1 = tempRet0;
 __ZNSt3__16localeD2Ev($4);
 HEAP32[((13368)>>2)]=4808;
 __ZNSt3__16localeD2Ev(13372);
 ___resumeException($12$0)
 case 5: 
 var $13=$10;
 __ZNSt3__16localeD2Ev($4);
 HEAP32[((13404)>>2)]=$13;
 HEAP32[((13408)>>2)]=13600;
 var $14=$10;
 var $15=HEAP32[(($14)>>2)];
 var $16=(($15+28)|0);
 var $17=HEAP32[(($16)>>2)];
 var $18=FUNCTION_TABLE[$17]($13);
 var $19=($18&1);
 HEAP8[(13412)]=$19;
 HEAP32[((14192)>>2)]=4980;
 HEAP32[((14196)>>2)]=5000;
 (function() { try { __THREW__ = 0; return __ZNSt3__18ios_base4initEPv(14196,13368) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=7;break; } else { label=6;break; }
 case 6: 
 var $21$0 = ___cxa_find_matching_catch(-1, -1); var $21$1 = tempRet0;
 __ZNSt3__18ios_baseD2Ev(14196);
 ___resumeException($21$0)
 case 7: 
 HEAP32[((14268)>>2)]=0;
 HEAP32[((14272)>>2)]=-1;
 var $22=HEAP32[((_stderr)>>2)];
 var $23=$3;
 HEAP32[((13416)>>2)]=4808;
 __ZNSt3__16localeC2Ev(13420);
 HEAP32[((13424)>>2)]=0; HEAP32[((13428)>>2)]=0; HEAP32[((13432)>>2)]=0; HEAP32[((13436)>>2)]=0; HEAP32[((13440)>>2)]=0; HEAP32[((13444)>>2)]=0;
 HEAP32[((13416)>>2)]=5296;
 HEAP32[((13448)>>2)]=$22;
 __ZNSt3__16localeC2ERKS0_($3,13420);
 var $24=(function() { try { __THREW__ = 0; return __ZNKSt3__16locale9use_facetERNS0_2idE($3,13792) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=9;break; } else { label=8;break; }
 case 8: 
 var $26$0 = ___cxa_find_matching_catch(-1, -1); var $26$1 = tempRet0;
 __ZNSt3__16localeD2Ev($3);
 HEAP32[((13416)>>2)]=4808;
 __ZNSt3__16localeD2Ev(13420);
 ___resumeException($26$0)
 case 9: 
 var $27=$24;
 __ZNSt3__16localeD2Ev($3);
 HEAP32[((13452)>>2)]=$27;
 HEAP32[((13456)>>2)]=13608;
 var $28=$24;
 var $29=HEAP32[(($28)>>2)];
 var $30=(($29+28)|0);
 var $31=HEAP32[(($30)>>2)];
 var $32=FUNCTION_TABLE[$31]($27);
 var $33=($32&1);
 HEAP8[(13460)]=$33;
 HEAP32[((14368)>>2)]=4980;
 HEAP32[((14372)>>2)]=5000;
 (function() { try { __THREW__ = 0; return __ZNSt3__18ios_base4initEPv(14372,13416) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=11;break; } else { label=10;break; }
 case 10: 
 var $35$0 = ___cxa_find_matching_catch(-1, -1); var $35$1 = tempRet0;
 __ZNSt3__18ios_baseD2Ev(14372);
 ___resumeException($35$0)
 case 11: 
 HEAP32[((14444)>>2)]=0;
 HEAP32[((14448)>>2)]=-1;
 var $36=HEAP32[((14368)>>2)];
 var $37=((($36)-(12))|0);
 var $38=$37;
 var $39=HEAP32[(($38)>>2)];
 var $_sum=((($39)+(24))|0);
 var $40=((14368+$_sum)|0);
 var $41=$40;
 var $42=HEAP32[(($41)>>2)];
 HEAP32[((14280)>>2)]=4980;
 HEAP32[((14284)>>2)]=5000;
 (function() { try { __THREW__ = 0; return __ZNSt3__18ios_base4initEPv(14284,$42) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=13;break; } else { label=12;break; }
 case 12: 
 var $44$0 = ___cxa_find_matching_catch(-1, -1); var $44$1 = tempRet0;
 __ZNSt3__18ios_baseD2Ev(14284);
 ___resumeException($44$0)
 case 13: 
 HEAP32[((14356)>>2)]=0;
 HEAP32[((14360)>>2)]=-1;
 var $45=HEAP32[((14456)>>2)];
 var $46=((($45)-(12))|0);
 var $47=$46;
 var $48=HEAP32[(($47)>>2)];
 var $_sum13=((($48)+(72))|0);
 var $49=((14456+$_sum13)|0);
 var $50=$49;
 HEAP32[(($50)>>2)]=14192;
 var $51=HEAP32[((14368)>>2)];
 var $52=((($51)-(12))|0);
 var $53=$52;
 var $54=HEAP32[(($53)>>2)];
 var $_sum14=((($54)+(4))|0);
 var $55=((14368+$_sum14)|0);
 var $56=$55;
 var $57=HEAP32[(($56)>>2)];
 var $58=$57|8192;
 HEAP32[(($56)>>2)]=$58;
 var $59=HEAP32[((14368)>>2)];
 var $60=((($59)-(12))|0);
 var $61=$60;
 var $62=HEAP32[(($61)>>2)];
 var $_sum15=((($62)+(72))|0);
 var $63=((14368+$_sum15)|0);
 var $64=$63;
 HEAP32[(($64)>>2)]=14192;
 __ZNSt3__110__stdinbufIwEC2EP8_IO_FILEP11__mbstate_t(13312,$5,13616);
 HEAP32[((14104)>>2)]=5028;
 HEAP32[((14112)>>2)]=5048;
 HEAP32[((14108)>>2)]=0;
 (function() { try { __THREW__ = 0; return __ZNSt3__18ios_base4initEPv(14112,13312) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=15;break; } else { label=14;break; }
 case 14: 
 var $66$0 = ___cxa_find_matching_catch(-1, -1); var $66$1 = tempRet0;
 __ZNSt3__18ios_baseD2Ev(14112);
 ___resumeException($66$0)
 case 15: 
 HEAP32[((14184)>>2)]=0;
 HEAP32[((14188)>>2)]=-1;
 var $67=$2;
 HEAP32[((13216)>>2)]=4736;
 __ZNSt3__16localeC2Ev(13220);
 HEAP32[((13224)>>2)]=0; HEAP32[((13228)>>2)]=0; HEAP32[((13232)>>2)]=0; HEAP32[((13236)>>2)]=0; HEAP32[((13240)>>2)]=0; HEAP32[((13244)>>2)]=0;
 HEAP32[((13216)>>2)]=5224;
 HEAP32[((13248)>>2)]=$8;
 __ZNSt3__16localeC2ERKS0_($2,13220);
 var $68=(function() { try { __THREW__ = 0; return __ZNKSt3__16locale9use_facetERNS0_2idE($2,13784) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=17;break; } else { label=16;break; }
 case 16: 
 var $70$0 = ___cxa_find_matching_catch(-1, -1); var $70$1 = tempRet0;
 __ZNSt3__16localeD2Ev($2);
 HEAP32[((13216)>>2)]=4736;
 __ZNSt3__16localeD2Ev(13220);
 ___resumeException($70$0)
 case 17: 
 var $71=$68;
 __ZNSt3__16localeD2Ev($2);
 HEAP32[((13252)>>2)]=$71;
 HEAP32[((13256)>>2)]=13624;
 var $72=$68;
 var $73=HEAP32[(($72)>>2)];
 var $74=(($73+28)|0);
 var $75=HEAP32[(($74)>>2)];
 var $76=FUNCTION_TABLE[$75]($71);
 var $77=($76&1);
 HEAP8[(13260)]=$77;
 HEAP32[((13824)>>2)]=4932;
 HEAP32[((13828)>>2)]=4952;
 (function() { try { __THREW__ = 0; return __ZNSt3__18ios_base4initEPv(13828,13216) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=19;break; } else { label=18;break; }
 case 18: 
 var $79$0 = ___cxa_find_matching_catch(-1, -1); var $79$1 = tempRet0;
 __ZNSt3__18ios_baseD2Ev(13828);
 ___resumeException($79$0)
 case 19: 
 HEAP32[((13900)>>2)]=0;
 HEAP32[((13904)>>2)]=-1;
 var $80=$1;
 HEAP32[((13264)>>2)]=4736;
 __ZNSt3__16localeC2Ev(13268);
 HEAP32[((13272)>>2)]=0; HEAP32[((13276)>>2)]=0; HEAP32[((13280)>>2)]=0; HEAP32[((13284)>>2)]=0; HEAP32[((13288)>>2)]=0; HEAP32[((13292)>>2)]=0;
 HEAP32[((13264)>>2)]=5224;
 HEAP32[((13296)>>2)]=$22;
 __ZNSt3__16localeC2ERKS0_($1,13268);
 var $81=(function() { try { __THREW__ = 0; return __ZNKSt3__16locale9use_facetERNS0_2idE($1,13784) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=21;break; } else { label=20;break; }
 case 20: 
 var $83$0 = ___cxa_find_matching_catch(-1, -1); var $83$1 = tempRet0;
 __ZNSt3__16localeD2Ev($1);
 HEAP32[((13264)>>2)]=4736;
 __ZNSt3__16localeD2Ev(13268);
 ___resumeException($83$0)
 case 21: 
 var $84=$81;
 __ZNSt3__16localeD2Ev($1);
 HEAP32[((13300)>>2)]=$84;
 HEAP32[((13304)>>2)]=13632;
 var $85=$81;
 var $86=HEAP32[(($85)>>2)];
 var $87=(($86+28)|0);
 var $88=HEAP32[(($87)>>2)];
 var $89=FUNCTION_TABLE[$88]($84);
 var $90=($89&1);
 HEAP8[(13308)]=$90;
 HEAP32[((14000)>>2)]=4932;
 HEAP32[((14004)>>2)]=4952;
 (function() { try { __THREW__ = 0; return __ZNSt3__18ios_base4initEPv(14004,13264) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=23;break; } else { label=22;break; }
 case 22: 
 var $92$0 = ___cxa_find_matching_catch(-1, -1); var $92$1 = tempRet0;
 __ZNSt3__18ios_baseD2Ev(14004);
 ___resumeException($92$0)
 case 23: 
 HEAP32[((14076)>>2)]=0;
 HEAP32[((14080)>>2)]=-1;
 var $93=HEAP32[((14000)>>2)];
 var $94=((($93)-(12))|0);
 var $95=$94;
 var $96=HEAP32[(($95)>>2)];
 var $_sum16=((($96)+(24))|0);
 var $97=((14000+$_sum16)|0);
 var $98=$97;
 var $99=HEAP32[(($98)>>2)];
 HEAP32[((13912)>>2)]=4932;
 HEAP32[((13916)>>2)]=4952;
 (function() { try { __THREW__ = 0; return __ZNSt3__18ios_base4initEPv(13916,$99) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=25;break; } else { label=24;break; }
 case 24: 
 var $101$0 = ___cxa_find_matching_catch(-1, -1); var $101$1 = tempRet0;
 __ZNSt3__18ios_baseD2Ev(13916);
 ___resumeException($101$0)
 case 25: 
 HEAP32[((13988)>>2)]=0;
 HEAP32[((13992)>>2)]=-1;
 var $102=HEAP32[((14104)>>2)];
 var $103=((($102)-(12))|0);
 var $104=$103;
 var $105=HEAP32[(($104)>>2)];
 var $_sum17=((($105)+(72))|0);
 var $106=((14104+$_sum17)|0);
 var $107=$106;
 HEAP32[(($107)>>2)]=13824;
 var $108=HEAP32[((14000)>>2)];
 var $109=((($108)-(12))|0);
 var $110=$109;
 var $111=HEAP32[(($110)>>2)];
 var $_sum18=((($111)+(4))|0);
 var $112=((14000+$_sum18)|0);
 var $113=$112;
 var $114=HEAP32[(($113)>>2)];
 var $115=$114|8192;
 HEAP32[(($113)>>2)]=$115;
 var $116=HEAP32[((14000)>>2)];
 var $117=((($116)-(12))|0);
 var $118=$117;
 var $119=HEAP32[(($118)>>2)];
 var $_sum19=((($119)+(72))|0);
 var $120=((14000+$_sum19)|0);
 var $121=$120;
 HEAP32[(($121)>>2)]=13824;
 STACKTOP=sp;return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__18ios_base4InitD2Ev($this){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=(function() { try { __THREW__ = 0; return __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE5flushEv(14192) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=2;break; } else { label=6;break; }
 case 2: 
 var $3=(function() { try { __THREW__ = 0; return __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE5flushEv(14280) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=3;break; } else { label=6;break; }
 case 3: 
 var $5=(function() { try { __THREW__ = 0; return __ZNSt3__113basic_ostreamIwNS_11char_traitsIwEEE5flushEv(13824) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=4;break; } else { label=6;break; }
 case 4: 
 var $7=(function() { try { __THREW__ = 0; return __ZNSt3__113basic_ostreamIwNS_11char_traitsIwEEE5flushEv(13912) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=5;break; } else { label=6;break; }
 case 5: 
 return;
 case 6: 
 var $10$0 = ___cxa_find_matching_catch(-1, -1,0); var $10$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__111__stdoutbufIwED1Ev($this){
 var label=0;


 var $1=(($this)|0);
 HEAP32[(($1)>>2)]=4736;
 var $2=(($this+4)|0);
 __ZNSt3__16localeD2Ev($2);
 return;
}


function __ZNSt3__111__stdoutbufIwED0Ev($this){
 var label=0;


 var $1=(($this)|0);
 HEAP32[(($1)>>2)]=4736;
 var $2=(($this+4)|0);
 __ZNSt3__16localeD2Ev($2);
 var $3=$this;
 __ZdlPv($3);
 return;
}


function __ZNSt3__111__stdoutbufIwE5imbueERKNS_6localeE($this,$__loc){
 var label=0;


 var $1=$this;
 var $2=HEAP32[(($1)>>2)];
 var $3=(($2+24)|0);
 var $4=HEAP32[(($3)>>2)];
 var $5=FUNCTION_TABLE[$4]($this);
 var $6=__ZNKSt3__16locale9use_facetERNS0_2idE($__loc,13784);
 var $7=$6;
 var $8=(($this+36)|0);
 HEAP32[(($8)>>2)]=$7;
 var $9=$6;
 var $10=HEAP32[(($9)>>2)];
 var $11=(($10+28)|0);
 var $12=HEAP32[(($11)>>2)];
 var $13=FUNCTION_TABLE[$12]($7);
 var $14=(($this+44)|0);
 var $15=($13&1);
 HEAP8[($14)]=$15;
 return;
}


function __ZNSt3__111__stdoutbufIwE4syncEv($this){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+16)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $__extbuf=sp;
 var $__extbe=(sp)+(8);
 var $1=(($this+36)|0);
 var $2=(($this+40)|0);
 var $3=(($__extbuf)|0);
 var $4=(($__extbuf+8)|0);
 var $5=$__extbuf;
 var $6=(($this+32)|0);
 label=2;break;
 case 2: 
 var $8=HEAP32[(($1)>>2)];
 var $9=HEAP32[(($2)>>2)];
 var $10=$8;
 var $11=HEAP32[(($10)>>2)];
 var $12=(($11+20)|0);
 var $13=HEAP32[(($12)>>2)];
 var $14=FUNCTION_TABLE[$13]($8,$9,$3,$4,$__extbe);
 var $15=HEAP32[(($__extbe)>>2)];
 var $16=$15;
 var $17=((($16)-($5))|0);
 var $18=HEAP32[(($6)>>2)];
 var $19=_fwrite($3,1,$17,$18);
 var $20=($19|0)==($17|0);
 if($20){label=3;break;}else{var $_0=-1;label=5;break;}
 case 3: 
 if(($14|0)==1){ label=2;break;}else if(($14|0)==2){ var $_0=-1;label=5;break;}else{label=4;break;}
 case 4: 
 var $23=HEAP32[(($6)>>2)];
 var $24=_fflush($23);
 var $not_=($24|0)!=0;
 var $_=(($not_<<31)>>31);
 var $_0=$_;label=5;break;
 case 5: 
 var $_0;
 STACKTOP=sp;return $_0;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__111__stdoutbufIwE6xsputnEPKwi($this,$__s,$__n){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=(($this+44)|0);
 var $2=HEAP8[($1)];
 var $3=(($2<<24)>>24)==0;
 if($3){label=2;break;}else{label=3;break;}
 case 2: 
 var $4=$this;
 var $5=($__n|0)>0;
 if($5){var $_0910=$__s;var $__i_011=0;label=4;break;}else{var $_0=0;label=6;break;}
 case 3: 
 var $7=$__s;
 var $8=(($this+32)|0);
 var $9=HEAP32[(($8)>>2)];
 var $10=_fwrite($7,4,$__n,$9);
 var $_0=$10;label=6;break;
 case 4: 
 var $__i_011;
 var $_0910;
 var $11=HEAP32[(($4)>>2)];
 var $12=(($11+52)|0);
 var $13=HEAP32[(($12)>>2)];
 var $14=HEAP32[(($_0910)>>2)];
 var $15=FUNCTION_TABLE[$13]($this,$14);
 var $16=($15|0)==-1;
 if($16){var $_0=$__i_011;label=6;break;}else{label=5;break;}
 case 5: 
 var $18=((($__i_011)+(1))|0);
 var $19=(($_0910+4)|0);
 var $20=($18|0)<($__n|0);
 if($20){var $_0910=$19;var $__i_011=$18;label=4;break;}else{var $_0=$18;label=6;break;}
 case 6: 
 var $_0;
 return $_0;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__111__stdoutbufIwE8overflowEj($this,$__c){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+32)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $__extbuf=sp;
 var $__1buf=(sp)+(8);
 var $__extbe=(sp)+(16);
 var $__e=(sp)+(24);
 var $1=($__c|0)==-1;
 if($1){label=11;break;}else{label=2;break;}
 case 2: 
 HEAP32[(($__1buf)>>2)]=$__c;
 var $3=(($this+44)|0);
 var $4=HEAP8[($3)];
 var $5=(($4<<24)>>24)==0;
 if($5){label=4;break;}else{label=3;break;}
 case 3: 
 var $7=$__1buf;
 var $8=(($this+32)|0);
 var $9=HEAP32[(($8)>>2)];
 var $10=_fwrite($7,4,1,$9);
 var $11=($10|0)==1;
 if($11){label=11;break;}else{var $_0=-1;label=12;break;}
 case 4: 
 var $13=(($__extbuf)|0);
 HEAP32[(($__extbe)>>2)]=$13;
 var $14=(($__1buf+4)|0);
 var $15=(($this+36)|0);
 var $16=(($this+40)|0);
 var $17=(($__extbuf+8)|0);
 var $18=$__extbuf;
 var $19=(($this+32)|0);
 var $pbase_0=$__1buf;label=5;break;
 case 5: 
 var $pbase_0;
 var $21=HEAP32[(($15)>>2)];
 var $22=HEAP32[(($16)>>2)];
 var $23=$21;
 var $24=HEAP32[(($23)>>2)];
 var $25=(($24+12)|0);
 var $26=HEAP32[(($25)>>2)];
 var $27=FUNCTION_TABLE[$26]($21,$22,$pbase_0,$14,$__e,$13,$17,$__extbe);
 var $28=HEAP32[(($__e)>>2)];
 var $29=($28|0)==($pbase_0|0);
 if($29){var $_0=-1;label=12;break;}else{label=6;break;}
 case 6: 
 var $31=($27|0)==3;
 if($31){label=7;break;}else{label=8;break;}
 case 7: 
 var $33=$pbase_0;
 var $34=HEAP32[(($19)>>2)];
 var $35=_fwrite($33,1,1,$34);
 var $36=($35|0)==1;
 if($36){label=11;break;}else{var $_0=-1;label=12;break;}
 case 8: 
 var $38=($27|0)==1;
 var $39=($27>>>0)<2;
 if($39){label=9;break;}else{var $_0=-1;label=12;break;}
 case 9: 
 var $41=HEAP32[(($__extbe)>>2)];
 var $42=$41;
 var $43=((($42)-($18))|0);
 var $44=HEAP32[(($19)>>2)];
 var $45=_fwrite($13,1,$43,$44);
 var $46=($45|0)==($43|0);
 if($46){label=10;break;}else{var $_0=-1;label=12;break;}
 case 10: 
 var $48=HEAP32[(($__e)>>2)];
 var $_pbase_0=($38?$48:$pbase_0);
 if($38){var $pbase_0=$_pbase_0;label=5;break;}else{label=11;break;}
 case 11: 
 var $___c_i=($1?0:$__c);
 var $_0=$___c_i;label=12;break;
 case 12: 
 var $_0;
 STACKTOP=sp;return $_0;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__110__stdinbufIwEC2EP8_IO_FILEP11__mbstate_t($this,$__fp,$__st){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+8)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=sp;
 var $2=(($this)|0);
 HEAP32[(($2)>>2)]=4736;
 var $3=(($this+4)|0);
 __ZNSt3__16localeC2Ev($3);
 var $4=(($this+8)|0);
 var $5=$4;
 HEAP32[(($5)>>2)]=0; HEAP32[((($5)+(4))>>2)]=0; HEAP32[((($5)+(8))>>2)]=0; HEAP32[((($5)+(12))>>2)]=0; HEAP32[((($5)+(16))>>2)]=0; HEAP32[((($5)+(20))>>2)]=0;
 HEAP32[(($2)>>2)]=5624;
 var $6=(($this+32)|0);
 HEAP32[(($6)>>2)]=$__fp;
 var $7=(($this+40)|0);
 HEAP32[(($7)>>2)]=$__st;
 var $8=(($this+48)|0);
 HEAP32[(($8)>>2)]=-1;
 var $9=(($this+52)|0);
 HEAP8[($9)]=0;
 __ZNSt3__16localeC2ERKS0_($1,$3);
 var $10=(function() { try { __THREW__ = 0; return __ZNKSt3__16locale9use_facetERNS0_2idE($1,13784) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=2;break; } else { label=5;break; }
 case 2: 
 var $11=$10;
 var $12=(($this+36)|0);
 HEAP32[(($12)>>2)]=$11;
 var $13=$10;
 var $14=HEAP32[(($13)>>2)];
 var $15=(($14+24)|0);
 var $16=HEAP32[(($15)>>2)];
 var $17=FUNCTION_TABLE[$16]($11);
 var $18=(($this+44)|0);
 HEAP32[(($18)>>2)]=$17;
 var $19=HEAP32[(($12)>>2)];
 var $20=$19;
 var $21=HEAP32[(($20)>>2)];
 var $22=(($21+28)|0);
 var $23=HEAP32[(($22)>>2)];
 var $24=FUNCTION_TABLE[$23]($19);
 var $25=(($this+53)|0);
 var $26=($24&1);
 HEAP8[($25)]=$26;
 var $27=HEAP32[(($18)>>2)];
 var $28=($27|0)>8;
 if($28){label=3;break;}else{label=4;break;}
 case 3: 
 (function() { try { __THREW__ = 0; return __ZNSt3__121__throw_runtime_errorEPKc(96) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=4;break; } else { label=5;break; }
 case 4: 
 __ZNSt3__16localeD2Ev($1);
 STACKTOP=sp;return;
 case 5: 
 var $31$0 = ___cxa_find_matching_catch(-1, -1); var $31$1 = tempRet0;
 __ZNSt3__16localeD2Ev($1);
 HEAP32[(($2)>>2)]=4736;
 __ZNSt3__16localeD2Ev($3);
 ___resumeException($31$0)
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__110__stdinbufIwED1Ev($this){
 var label=0;


 var $1=(($this)|0);
 HEAP32[(($1)>>2)]=4736;
 var $2=(($this+4)|0);
 __ZNSt3__16localeD2Ev($2);
 return;
}


function __ZNSt3__110__stdinbufIwED0Ev($this){
 var label=0;


 var $1=(($this)|0);
 HEAP32[(($1)>>2)]=4736;
 var $2=(($this+4)|0);
 __ZNSt3__16localeD2Ev($2);
 var $3=$this;
 __ZdlPv($3);
 return;
}


function __ZNSt3__110__stdinbufIwE5imbueERKNS_6localeE($this,$__loc){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=__ZNKSt3__16locale9use_facetERNS0_2idE($__loc,13784);
 var $2=$1;
 var $3=(($this+36)|0);
 HEAP32[(($3)>>2)]=$2;
 var $4=$1;
 var $5=HEAP32[(($4)>>2)];
 var $6=(($5+24)|0);
 var $7=HEAP32[(($6)>>2)];
 var $8=FUNCTION_TABLE[$7]($2);
 var $9=(($this+44)|0);
 HEAP32[(($9)>>2)]=$8;
 var $10=HEAP32[(($3)>>2)];
 var $11=$10;
 var $12=HEAP32[(($11)>>2)];
 var $13=(($12+28)|0);
 var $14=HEAP32[(($13)>>2)];
 var $15=FUNCTION_TABLE[$14]($10);
 var $16=(($this+53)|0);
 var $17=($15&1);
 HEAP8[($16)]=$17;
 var $18=HEAP32[(($9)>>2)];
 var $19=($18|0)>8;
 if($19){label=2;break;}else{label=3;break;}
 case 2: 
 __ZNSt3__121__throw_runtime_errorEPKc(96);
 label=3;break;
 case 3: 
 return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__110__stdinbufIwE9underflowEv($this){
 var label=0;


 var $1=__ZNSt3__110__stdinbufIwE9__getcharEb($this,0);
 return $1;
}


function __ZNSt3__110__stdinbufIwE5uflowEv($this){
 var label=0;


 var $1=__ZNSt3__110__stdinbufIwE9__getcharEb($this,1);
 return $1;
}


function __ZNSt3__110__stdinbufIwE9pbackfailEj($this,$__c){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+32)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $__extbuf=sp;
 var $__enxt=(sp)+(8);
 var $__ci=(sp)+(16);
 var $__inxt=(sp)+(24);
 var $1=($__c|0)==-1;
 var $2=(($this+52)|0);
 var $3=HEAP8[($2)];
 var $4=(($3<<24)>>24)!=0;
 if($1){label=2;break;}else{label=4;break;}
 case 2: 
 if($4){var $_06=-1;label=11;break;}else{label=3;break;}
 case 3: 
 var $7=(($this+48)|0);
 var $8=HEAP32[(($7)>>2)];
 var $9=($8|0)!=-1;
 var $10=($9&1);
 HEAP8[($2)]=$10;
 var $_06=$8;label=11;break;
 case 4: 
 var $12=(($this+48)|0);
 if($4){label=5;break;}else{label=10;break;}
 case 5: 
 var $14=HEAP32[(($12)>>2)];
 HEAP32[(($__ci)>>2)]=$14;
 var $15=(($this+36)|0);
 var $16=HEAP32[(($15)>>2)];
 var $17=(($this+40)|0);
 var $18=HEAP32[(($17)>>2)];
 var $19=(($__ci+4)|0);
 var $20=(($__extbuf)|0);
 var $21=(($__extbuf+8)|0);
 var $22=$16;
 var $23=HEAP32[(($22)>>2)];
 var $24=(($23+12)|0);
 var $25=HEAP32[(($24)>>2)];
 var $26=FUNCTION_TABLE[$25]($16,$18,$__ci,$19,$__inxt,$20,$21,$__enxt);
 if(($26|0)==2|($26|0)==1){ var $_06=-1;label=11;break;}else if(($26|0)==3){ label=6;break;}else{label=7;break;}
 case 6: 
 var $28=HEAP32[(($12)>>2)];
 var $29=(($28)&255);
 HEAP8[($20)]=$29;
 var $30=(($__extbuf+1)|0);
 HEAP32[(($__enxt)>>2)]=$30;
 label=7;break;
 case 7: 
 var $31=(($this+32)|0);
 label=8;break;
 case 8: 
 var $32=HEAP32[(($__enxt)>>2)];
 var $33=($32>>>0)>($20>>>0);
 if($33){label=9;break;}else{label=10;break;}
 case 9: 
 var $35=((($32)-(1))|0);
 HEAP32[(($__enxt)>>2)]=$35;
 var $36=HEAP8[($35)];
 var $37=(($36<<24)>>24);
 var $38=HEAP32[(($31)>>2)];
 var $39=_ungetc($37,$38);
 var $40=($39|0)==-1;
 if($40){var $_06=-1;label=11;break;}else{label=8;break;}
 case 10: 
 HEAP32[(($12)>>2)]=$__c;
 HEAP8[($2)]=1;
 var $_06=$__c;label=11;break;
 case 11: 
 var $_06;
 STACKTOP=sp;return $_06;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__110__stdinbufIwE9__getcharEb($this,$__consume){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+32)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $__extbuf=sp;
 var $__1buf=(sp)+(8);
 var $__enxt=(sp)+(16);
 var $__inxt=(sp)+(24);
 var $1=(($this+52)|0);
 var $2=HEAP8[($1)];
 var $3=(($2<<24)>>24)==0;
 if($3){label=4;break;}else{label=2;break;}
 case 2: 
 var $5=(($this+48)|0);
 var $6=HEAP32[(($5)>>2)];
 if($__consume){label=3;break;}else{var $_0=$6;label=22;break;}
 case 3: 
 HEAP32[(($5)>>2)]=-1;
 HEAP8[($1)]=0;
 var $_0=$6;label=22;break;
 case 4: 
 var $9=(($this+44)|0);
 var $10=HEAP32[(($9)>>2)];
 var $11=($10|0)>1;
 var $_sroa_speculated=($11?$10:1);
 var $12=($_sroa_speculated|0)>0;
 if($12){label=5;break;}else{label=8;break;}
 case 5: 
 var $13=(($this+32)|0);
 var $__i_024=0;label=6;break;
 case 6: 
 var $__i_024;
 var $15=HEAP32[(($13)>>2)];
 var $16=_fgetc($15);
 var $17=($16|0)==-1;
 if($17){var $_0=-1;label=22;break;}else{label=7;break;}
 case 7: 
 var $19=(($16)&255);
 var $20=(($__extbuf+$__i_024)|0);
 HEAP8[($20)]=$19;
 var $21=((($__i_024)+(1))|0);
 var $22=($21|0)<($_sroa_speculated|0);
 if($22){var $__i_024=$21;label=6;break;}else{label=8;break;}
 case 8: 
 var $23=(($this+53)|0);
 var $24=HEAP8[($23)];
 var $25=(($24<<24)>>24)==0;
 if($25){label=9;break;}else{label=10;break;}
 case 9: 
 var $26=(($this+40)|0);
 var $27=(($this+36)|0);
 var $28=(($__extbuf)|0);
 var $29=(($__1buf+4)|0);
 var $30=(($this+32)|0);
 var $__nread_0=$_sroa_speculated;label=11;break;
 case 10: 
 var $32=(($__extbuf)|0);
 var $33=HEAP8[($32)];
 var $34=(($33<<24)>>24);
 HEAP32[(($__1buf)>>2)]=$34;
 var $__nread_2=$_sroa_speculated;label=16;break;
 case 11: 
 var $__nread_0;
 var $36=HEAP32[(($26)>>2)];
 var $37=$36;
 var $ld$0$0=(($37)|0);
 var $38$0=HEAP32[(($ld$0$0)>>2)];
 var $ld$1$1=(($37+4)|0);
 var $38$1=HEAP32[(($ld$1$1)>>2)];
 var $39=HEAP32[(($27)>>2)];
 var $40=(($__extbuf+$__nread_0)|0);
 var $41=$39;
 var $42=HEAP32[(($41)>>2)];
 var $43=(($42+16)|0);
 var $44=HEAP32[(($43)>>2)];
 var $45=FUNCTION_TABLE[$44]($39,$36,$28,$40,$__enxt,$__1buf,$29,$__inxt);
 if(($45|0)==1){ label=12;break;}else if(($45|0)==3){ label=14;break;}else if(($45|0)==2){ var $_0=-1;label=22;break;}else{var $__nread_2=$__nread_0;label=16;break;}
 case 12: 
 var $47=HEAP32[(($26)>>2)];
 var $48=$47;
 var $st$2$0=(($48)|0);
 HEAP32[(($st$2$0)>>2)]=$38$0;
 var $st$3$1=(($48+4)|0);
 HEAP32[(($st$3$1)>>2)]=$38$1;
 var $49=($__nread_0|0)==8;
 if($49){var $_0=-1;label=22;break;}else{label=13;break;}
 case 13: 
 var $51=HEAP32[(($30)>>2)];
 var $52=_fgetc($51);
 var $53=($52|0)==-1;
 if($53){var $_0=-1;label=22;break;}else{label=15;break;}
 case 14: 
 var $55=HEAP8[($28)];
 var $56=(($55<<24)>>24);
 HEAP32[(($__1buf)>>2)]=$56;
 var $__nread_2=$__nread_0;label=16;break;
 case 15: 
 var $58=(($52)&255);
 HEAP8[($40)]=$58;
 var $59=((($__nread_0)+(1))|0);
 var $__nread_0=$59;label=11;break;
 case 16: 
 var $__nread_2;
 if($__consume){label=20;break;}else{label=17;break;}
 case 17: 
 var $60=(($this+32)|0);
 var $__i2_0=$__nread_2;label=18;break;
 case 18: 
 var $__i2_0;
 var $62=($__i2_0|0)>0;
 if($62){label=19;break;}else{label=21;break;}
 case 19: 
 var $64=((($__i2_0)-(1))|0);
 var $65=(($__extbuf+$64)|0);
 var $66=HEAP8[($65)];
 var $67=(($66<<24)>>24);
 var $68=HEAP32[(($60)>>2)];
 var $69=_ungetc($67,$68);
 var $70=($69|0)==-1;
 if($70){var $_0=-1;label=22;break;}else{var $__i2_0=$64;label=18;break;}
 case 20: 
 var $72=HEAP32[(($__1buf)>>2)];
 var $73=(($this+48)|0);
 HEAP32[(($73)>>2)]=$72;
 var $_0=$72;label=22;break;
 case 21: 
 var $_pre=HEAP32[(($__1buf)>>2)];
 var $_0=$_pre;label=22;break;
 case 22: 
 var $_0;
 STACKTOP=sp;return $_0;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__111__stdoutbufIcED1Ev($this){
 var label=0;


 var $1=(($this)|0);
 HEAP32[(($1)>>2)]=4808;
 var $2=(($this+4)|0);
 __ZNSt3__16localeD2Ev($2);
 return;
}


function __ZNSt3__111__stdoutbufIcED0Ev($this){
 var label=0;


 var $1=(($this)|0);
 HEAP32[(($1)>>2)]=4808;
 var $2=(($this+4)|0);
 __ZNSt3__16localeD2Ev($2);
 var $3=$this;
 __ZdlPv($3);
 return;
}


function __ZNSt3__111__stdoutbufIcE5imbueERKNS_6localeE($this,$__loc){
 var label=0;


 var $1=$this;
 var $2=HEAP32[(($1)>>2)];
 var $3=(($2+24)|0);
 var $4=HEAP32[(($3)>>2)];
 var $5=FUNCTION_TABLE[$4]($this);
 var $6=__ZNKSt3__16locale9use_facetERNS0_2idE($__loc,13792);
 var $7=$6;
 var $8=(($this+36)|0);
 HEAP32[(($8)>>2)]=$7;
 var $9=$6;
 var $10=HEAP32[(($9)>>2)];
 var $11=(($10+28)|0);
 var $12=HEAP32[(($11)>>2)];
 var $13=FUNCTION_TABLE[$12]($7);
 var $14=(($this+44)|0);
 var $15=($13&1);
 HEAP8[($14)]=$15;
 return;
}


function __ZNSt3__111__stdoutbufIcE4syncEv($this){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+16)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $__extbuf=sp;
 var $__extbe=(sp)+(8);
 var $1=(($this+36)|0);
 var $2=(($this+40)|0);
 var $3=(($__extbuf)|0);
 var $4=(($__extbuf+8)|0);
 var $5=$__extbuf;
 var $6=(($this+32)|0);
 label=2;break;
 case 2: 
 var $8=HEAP32[(($1)>>2)];
 var $9=HEAP32[(($2)>>2)];
 var $10=$8;
 var $11=HEAP32[(($10)>>2)];
 var $12=(($11+20)|0);
 var $13=HEAP32[(($12)>>2)];
 var $14=FUNCTION_TABLE[$13]($8,$9,$3,$4,$__extbe);
 var $15=HEAP32[(($__extbe)>>2)];
 var $16=$15;
 var $17=((($16)-($5))|0);
 var $18=HEAP32[(($6)>>2)];
 var $19=_fwrite($3,1,$17,$18);
 var $20=($19|0)==($17|0);
 if($20){label=3;break;}else{var $_0=-1;label=5;break;}
 case 3: 
 if(($14|0)==1){ label=2;break;}else if(($14|0)==2){ var $_0=-1;label=5;break;}else{label=4;break;}
 case 4: 
 var $23=HEAP32[(($6)>>2)];
 var $24=_fflush($23);
 var $not_=($24|0)!=0;
 var $_=(($not_<<31)>>31);
 var $_0=$_;label=5;break;
 case 5: 
 var $_0;
 STACKTOP=sp;return $_0;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__111__stdoutbufIcE6xsputnEPKci($this,$__s,$__n){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=(($this+44)|0);
 var $2=HEAP8[($1)];
 var $3=(($2<<24)>>24)==0;
 if($3){label=2;break;}else{label=3;break;}
 case 2: 
 var $4=$this;
 var $5=($__n|0)>0;
 if($5){var $_0910=$__s;var $__i_011=0;label=4;break;}else{var $_0=0;label=6;break;}
 case 3: 
 var $7=(($this+32)|0);
 var $8=HEAP32[(($7)>>2)];
 var $9=_fwrite($__s,1,$__n,$8);
 var $_0=$9;label=6;break;
 case 4: 
 var $__i_011;
 var $_0910;
 var $10=HEAP32[(($4)>>2)];
 var $11=(($10+52)|0);
 var $12=HEAP32[(($11)>>2)];
 var $13=HEAP8[($_0910)];
 var $14=($13&255);
 var $15=FUNCTION_TABLE[$12]($this,$14);
 var $16=($15|0)==-1;
 if($16){var $_0=$__i_011;label=6;break;}else{label=5;break;}
 case 5: 
 var $18=((($__i_011)+(1))|0);
 var $19=(($_0910+1)|0);
 var $20=($18|0)<($__n|0);
 if($20){var $_0910=$19;var $__i_011=$18;label=4;break;}else{var $_0=$18;label=6;break;}
 case 6: 
 var $_0;
 return $_0;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__111__stdoutbufIcE8overflowEi($this,$__c){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+32)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $__extbuf=sp;
 var $__1buf=(sp)+(8);
 var $__extbe=(sp)+(16);
 var $__e=(sp)+(24);
 var $1=($__c|0)==-1;
 if($1){label=11;break;}else{label=2;break;}
 case 2: 
 var $3=(($__c)&255);
 HEAP8[($__1buf)]=$3;
 var $4=(($this+44)|0);
 var $5=HEAP8[($4)];
 var $6=(($5<<24)>>24)==0;
 if($6){label=4;break;}else{label=3;break;}
 case 3: 
 var $8=(($this+32)|0);
 var $9=HEAP32[(($8)>>2)];
 var $10=_fwrite($__1buf,1,1,$9);
 var $11=($10|0)==1;
 if($11){label=11;break;}else{var $_0=-1;label=12;break;}
 case 4: 
 var $13=(($__extbuf)|0);
 HEAP32[(($__extbe)>>2)]=$13;
 var $14=(($__1buf+1)|0);
 var $15=(($this+36)|0);
 var $16=(($this+40)|0);
 var $17=(($__extbuf+8)|0);
 var $18=$__extbuf;
 var $19=(($this+32)|0);
 var $pbase_0=$__1buf;label=5;break;
 case 5: 
 var $pbase_0;
 var $21=HEAP32[(($15)>>2)];
 var $22=HEAP32[(($16)>>2)];
 var $23=$21;
 var $24=HEAP32[(($23)>>2)];
 var $25=(($24+12)|0);
 var $26=HEAP32[(($25)>>2)];
 var $27=FUNCTION_TABLE[$26]($21,$22,$pbase_0,$14,$__e,$13,$17,$__extbe);
 var $28=HEAP32[(($__e)>>2)];
 var $29=($28|0)==($pbase_0|0);
 if($29){var $_0=-1;label=12;break;}else{label=6;break;}
 case 6: 
 var $31=($27|0)==3;
 if($31){label=7;break;}else{label=8;break;}
 case 7: 
 var $33=HEAP32[(($19)>>2)];
 var $34=_fwrite($pbase_0,1,1,$33);
 var $35=($34|0)==1;
 if($35){label=11;break;}else{var $_0=-1;label=12;break;}
 case 8: 
 var $37=($27|0)==1;
 var $38=($27>>>0)<2;
 if($38){label=9;break;}else{var $_0=-1;label=12;break;}
 case 9: 
 var $40=HEAP32[(($__extbe)>>2)];
 var $41=$40;
 var $42=((($41)-($18))|0);
 var $43=HEAP32[(($19)>>2)];
 var $44=_fwrite($13,1,$42,$43);
 var $45=($44|0)==($42|0);
 if($45){label=10;break;}else{var $_0=-1;label=12;break;}
 case 10: 
 var $47=HEAP32[(($__e)>>2)];
 var $_pbase_0=($37?$47:$pbase_0);
 if($37){var $pbase_0=$_pbase_0;label=5;break;}else{label=11;break;}
 case 11: 
 var $___c_i=($1?0:$__c);
 var $_0=$___c_i;label=12;break;
 case 12: 
 var $_0;
 STACKTOP=sp;return $_0;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__110__stdinbufIcEC2EP8_IO_FILEP11__mbstate_t($this,$__fp,$__st){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+8)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=sp;
 var $2=(($this)|0);
 HEAP32[(($2)>>2)]=4808;
 var $3=(($this+4)|0);
 __ZNSt3__16localeC2Ev($3);
 var $4=(($this+8)|0);
 var $5=$4;
 HEAP32[(($5)>>2)]=0; HEAP32[((($5)+(4))>>2)]=0; HEAP32[((($5)+(8))>>2)]=0; HEAP32[((($5)+(12))>>2)]=0; HEAP32[((($5)+(16))>>2)]=0; HEAP32[((($5)+(20))>>2)]=0;
 HEAP32[(($2)>>2)]=5696;
 var $6=(($this+32)|0);
 HEAP32[(($6)>>2)]=$__fp;
 var $7=(($this+40)|0);
 HEAP32[(($7)>>2)]=$__st;
 var $8=(($this+48)|0);
 HEAP32[(($8)>>2)]=-1;
 var $9=(($this+52)|0);
 HEAP8[($9)]=0;
 __ZNSt3__16localeC2ERKS0_($1,$3);
 var $10=(function() { try { __THREW__ = 0; return __ZNKSt3__16locale9use_facetERNS0_2idE($1,13792) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=2;break; } else { label=5;break; }
 case 2: 
 var $11=$10;
 var $12=(($this+36)|0);
 HEAP32[(($12)>>2)]=$11;
 var $13=$10;
 var $14=HEAP32[(($13)>>2)];
 var $15=(($14+24)|0);
 var $16=HEAP32[(($15)>>2)];
 var $17=FUNCTION_TABLE[$16]($11);
 var $18=(($this+44)|0);
 HEAP32[(($18)>>2)]=$17;
 var $19=HEAP32[(($12)>>2)];
 var $20=$19;
 var $21=HEAP32[(($20)>>2)];
 var $22=(($21+28)|0);
 var $23=HEAP32[(($22)>>2)];
 var $24=FUNCTION_TABLE[$23]($19);
 var $25=(($this+53)|0);
 var $26=($24&1);
 HEAP8[($25)]=$26;
 var $27=HEAP32[(($18)>>2)];
 var $28=($27|0)>8;
 if($28){label=3;break;}else{label=4;break;}
 case 3: 
 (function() { try { __THREW__ = 0; return __ZNSt3__121__throw_runtime_errorEPKc(96) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=4;break; } else { label=5;break; }
 case 4: 
 __ZNSt3__16localeD2Ev($1);
 STACKTOP=sp;return;
 case 5: 
 var $31$0 = ___cxa_find_matching_catch(-1, -1); var $31$1 = tempRet0;
 __ZNSt3__16localeD2Ev($1);
 HEAP32[(($2)>>2)]=4808;
 __ZNSt3__16localeD2Ev($3);
 ___resumeException($31$0)
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__110__stdinbufIcED1Ev($this){
 var label=0;


 var $1=(($this)|0);
 HEAP32[(($1)>>2)]=4808;
 var $2=(($this+4)|0);
 __ZNSt3__16localeD2Ev($2);
 return;
}


function __ZNSt3__110__stdinbufIcED0Ev($this){
 var label=0;


 var $1=(($this)|0);
 HEAP32[(($1)>>2)]=4808;
 var $2=(($this+4)|0);
 __ZNSt3__16localeD2Ev($2);
 var $3=$this;
 __ZdlPv($3);
 return;
}


function __ZNSt3__110__stdinbufIcE5imbueERKNS_6localeE($this,$__loc){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=__ZNKSt3__16locale9use_facetERNS0_2idE($__loc,13792);
 var $2=$1;
 var $3=(($this+36)|0);
 HEAP32[(($3)>>2)]=$2;
 var $4=$1;
 var $5=HEAP32[(($4)>>2)];
 var $6=(($5+24)|0);
 var $7=HEAP32[(($6)>>2)];
 var $8=FUNCTION_TABLE[$7]($2);
 var $9=(($this+44)|0);
 HEAP32[(($9)>>2)]=$8;
 var $10=HEAP32[(($3)>>2)];
 var $11=$10;
 var $12=HEAP32[(($11)>>2)];
 var $13=(($12+28)|0);
 var $14=HEAP32[(($13)>>2)];
 var $15=FUNCTION_TABLE[$14]($10);
 var $16=(($this+53)|0);
 var $17=($15&1);
 HEAP8[($16)]=$17;
 var $18=HEAP32[(($9)>>2)];
 var $19=($18|0)>8;
 if($19){label=2;break;}else{label=3;break;}
 case 2: 
 __ZNSt3__121__throw_runtime_errorEPKc(96);
 label=3;break;
 case 3: 
 return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__110__stdinbufIcE9underflowEv($this){
 var label=0;


 var $1=__ZNSt3__110__stdinbufIcE9__getcharEb($this,0);
 return $1;
}


function __ZNSt3__110__stdinbufIcE5uflowEv($this){
 var label=0;


 var $1=__ZNSt3__110__stdinbufIcE9__getcharEb($this,1);
 return $1;
}


function __ZNSt3__110__stdinbufIcE9pbackfailEi($this,$__c){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+32)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $__extbuf=sp;
 var $__enxt=(sp)+(8);
 var $__ci=(sp)+(16);
 var $__inxt=(sp)+(24);
 var $1=($__c|0)==-1;
 var $2=(($this+52)|0);
 var $3=HEAP8[($2)];
 var $4=(($3<<24)>>24)!=0;
 if($1){label=2;break;}else{label=4;break;}
 case 2: 
 if($4){var $_06=-1;label=11;break;}else{label=3;break;}
 case 3: 
 var $7=(($this+48)|0);
 var $8=HEAP32[(($7)>>2)];
 var $9=($8|0)!=-1;
 var $10=($9&1);
 HEAP8[($2)]=$10;
 var $_06=$8;label=11;break;
 case 4: 
 var $12=(($this+48)|0);
 if($4){label=5;break;}else{label=10;break;}
 case 5: 
 var $14=HEAP32[(($12)>>2)];
 var $15=(($14)&255);
 HEAP8[($__ci)]=$15;
 var $16=(($this+36)|0);
 var $17=HEAP32[(($16)>>2)];
 var $18=(($this+40)|0);
 var $19=HEAP32[(($18)>>2)];
 var $20=(($__ci+1)|0);
 var $21=(($__extbuf)|0);
 var $22=(($__extbuf+8)|0);
 var $23=$17;
 var $24=HEAP32[(($23)>>2)];
 var $25=(($24+12)|0);
 var $26=HEAP32[(($25)>>2)];
 var $27=FUNCTION_TABLE[$26]($17,$19,$__ci,$20,$__inxt,$21,$22,$__enxt);
 if(($27|0)==2|($27|0)==1){ var $_06=-1;label=11;break;}else if(($27|0)==3){ label=6;break;}else{label=7;break;}
 case 6: 
 var $29=HEAP32[(($12)>>2)];
 var $30=(($29)&255);
 HEAP8[($21)]=$30;
 var $31=(($__extbuf+1)|0);
 HEAP32[(($__enxt)>>2)]=$31;
 label=7;break;
 case 7: 
 var $32=(($this+32)|0);
 label=8;break;
 case 8: 
 var $33=HEAP32[(($__enxt)>>2)];
 var $34=($33>>>0)>($21>>>0);
 if($34){label=9;break;}else{label=10;break;}
 case 9: 
 var $36=((($33)-(1))|0);
 HEAP32[(($__enxt)>>2)]=$36;
 var $37=HEAP8[($36)];
 var $38=(($37<<24)>>24);
 var $39=HEAP32[(($32)>>2)];
 var $40=_ungetc($38,$39);
 var $41=($40|0)==-1;
 if($41){var $_06=-1;label=11;break;}else{label=8;break;}
 case 10: 
 HEAP32[(($12)>>2)]=$__c;
 HEAP8[($2)]=1;
 var $_06=$__c;label=11;break;
 case 11: 
 var $_06;
 STACKTOP=sp;return $_06;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__110__stdinbufIcE9__getcharEb($this,$__consume){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+32)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $__extbuf=sp;
 var $__1buf=(sp)+(8);
 var $__enxt=(sp)+(16);
 var $__inxt=(sp)+(24);
 var $1=(($this+52)|0);
 var $2=HEAP8[($1)];
 var $3=(($2<<24)>>24)==0;
 if($3){label=4;break;}else{label=2;break;}
 case 2: 
 var $5=(($this+48)|0);
 var $6=HEAP32[(($5)>>2)];
 if($__consume){label=3;break;}else{var $_0=$6;label=23;break;}
 case 3: 
 HEAP32[(($5)>>2)]=-1;
 HEAP8[($1)]=0;
 var $_0=$6;label=23;break;
 case 4: 
 var $9=(($this+44)|0);
 var $10=HEAP32[(($9)>>2)];
 var $11=($10|0)>1;
 var $_sroa_speculated=($11?$10:1);
 var $12=($_sroa_speculated|0)>0;
 if($12){label=5;break;}else{label=8;break;}
 case 5: 
 var $13=(($this+32)|0);
 var $__i_024=0;label=6;break;
 case 6: 
 var $__i_024;
 var $15=HEAP32[(($13)>>2)];
 var $16=_fgetc($15);
 var $17=($16|0)==-1;
 if($17){var $_0=-1;label=23;break;}else{label=7;break;}
 case 7: 
 var $19=(($16)&255);
 var $20=(($__extbuf+$__i_024)|0);
 HEAP8[($20)]=$19;
 var $21=((($__i_024)+(1))|0);
 var $22=($21|0)<($_sroa_speculated|0);
 if($22){var $__i_024=$21;label=6;break;}else{label=8;break;}
 case 8: 
 var $23=(($this+53)|0);
 var $24=HEAP8[($23)];
 var $25=(($24<<24)>>24)==0;
 if($25){label=9;break;}else{label=10;break;}
 case 9: 
 var $26=(($this+40)|0);
 var $27=(($this+36)|0);
 var $28=(($__extbuf)|0);
 var $29=(($__1buf+1)|0);
 var $30=(($this+32)|0);
 var $__nread_0=$_sroa_speculated;label=11;break;
 case 10: 
 var $32=(($__extbuf)|0);
 var $33=HEAP8[($32)];
 HEAP8[($__1buf)]=$33;
 var $__nread_2=$_sroa_speculated;label=16;break;
 case 11: 
 var $__nread_0;
 var $35=HEAP32[(($26)>>2)];
 var $36=$35;
 var $ld$0$0=(($36)|0);
 var $37$0=HEAP32[(($ld$0$0)>>2)];
 var $ld$1$1=(($36+4)|0);
 var $37$1=HEAP32[(($ld$1$1)>>2)];
 var $38=HEAP32[(($27)>>2)];
 var $39=(($__extbuf+$__nread_0)|0);
 var $40=$38;
 var $41=HEAP32[(($40)>>2)];
 var $42=(($41+16)|0);
 var $43=HEAP32[(($42)>>2)];
 var $44=FUNCTION_TABLE[$43]($38,$35,$28,$39,$__enxt,$__1buf,$29,$__inxt);
 if(($44|0)==1){ label=12;break;}else if(($44|0)==3){ label=14;break;}else if(($44|0)==2){ var $_0=-1;label=23;break;}else{var $__nread_2=$__nread_0;label=16;break;}
 case 12: 
 var $46=HEAP32[(($26)>>2)];
 var $47=$46;
 var $st$2$0=(($47)|0);
 HEAP32[(($st$2$0)>>2)]=$37$0;
 var $st$3$1=(($47+4)|0);
 HEAP32[(($st$3$1)>>2)]=$37$1;
 var $48=($__nread_0|0)==8;
 if($48){var $_0=-1;label=23;break;}else{label=13;break;}
 case 13: 
 var $50=HEAP32[(($30)>>2)];
 var $51=_fgetc($50);
 var $52=($51|0)==-1;
 if($52){var $_0=-1;label=23;break;}else{label=15;break;}
 case 14: 
 var $54=HEAP8[($28)];
 HEAP8[($__1buf)]=$54;
 var $__nread_2=$__nread_0;label=16;break;
 case 15: 
 var $56=(($51)&255);
 HEAP8[($39)]=$56;
 var $57=((($__nread_0)+(1))|0);
 var $__nread_0=$57;label=11;break;
 case 16: 
 var $__nread_2;
 if($__consume){label=20;break;}else{label=17;break;}
 case 17: 
 var $58=(($this+32)|0);
 var $__i2_0=$__nread_2;label=18;break;
 case 18: 
 var $__i2_0;
 var $60=($__i2_0|0)>0;
 if($60){label=19;break;}else{label=21;break;}
 case 19: 
 var $62=((($__i2_0)-(1))|0);
 var $63=(($__extbuf+$62)|0);
 var $64=HEAP8[($63)];
 var $65=($64&255);
 var $66=HEAP32[(($58)>>2)];
 var $67=_ungetc($65,$66);
 var $68=($67|0)==-1;
 if($68){var $_0=-1;label=23;break;}else{var $__i2_0=$62;label=18;break;}
 case 20: 
 var $70=HEAP8[($__1buf)];
 var $71=($70&255);
 var $72=(($this+48)|0);
 HEAP32[(($72)>>2)]=$71;
 var $74=$70;label=22;break;
 case 21: 
 var $_pre=HEAP8[($__1buf)];
 var $74=$_pre;label=22;break;
 case 22: 
 var $74;
 var $75=($74&255);
 var $_0=$75;label=23;break;
 case 23: 
 var $_0;
 STACKTOP=sp;return $_0;
  default: assert(0, "bad label: " + label);
 }

}


function __GLOBAL__I_a(){
 var label=0;


 __ZNSt3__18ios_base4InitC2Ev(0);
 var $1=_atexit((382),14544,___dso_handle);
 return;
}


function __ZNSt3__114__shared_countD2Ev($this){
 var label=0;


 return;
}


function __ZNSt3__114__shared_count12__add_sharedEv($this){
 var label=0;


 var $1=(($this+4)|0);
 var $2=(tempValue=HEAP32[(($1)>>2)],HEAP32[(($1)>>2)]=tempValue+1,tempValue);
 return;
}


function __ZNSt3__114__shared_count16__release_sharedEv($this){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=(($this+4)|0);
 var $2=(tempValue=HEAP32[(($1)>>2)],HEAP32[(($1)>>2)]=tempValue+-1,tempValue);
 var $3=($2|0)==0;
 if($3){label=2;break;}else{var $_0=0;label=3;break;}
 case 2: 
 var $5=$this;
 var $6=HEAP32[(($5)>>2)];
 var $7=(($6+8)|0);
 var $8=HEAP32[(($7)>>2)];
 FUNCTION_TABLE[$8]($this);
 var $_0=1;label=3;break;
 case 3: 
 var $_0;
 return $_0;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt11logic_errorC2EPKc($this,$msg){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=(($this)|0);
 var $2=(($this)|0);
 HEAP32[(($2)>>2)]=3088;
 var $3=(($this+4)|0);
 var $4=($3|0)==0;
 if($4){label=4;break;}else{label=2;break;}
 case 2: 
 var $6=_strlen($msg);
 var $7=((($6)+(13))|0);
 var $8=(function() { try { __THREW__ = 0; return __Znaj($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=3;break; } else { label=5;break; }
 case 3: 
 var $9=((($6)+(1))|0);
 var $10=$8;
 var $11=(($8+4)|0);
 var $12=$11;
 HEAP32[(($12)>>2)]=$6;
 HEAP32[(($10)>>2)]=$6;
 var $13=(($8+12)|0);
 HEAP32[(($3)>>2)]=$13;
 var $14=(($8+8)|0);
 var $15=$14;
 HEAP32[(($15)>>2)]=0;
 assert($9 % 1 === 0);(_memcpy($13, $msg, $9)|0);
 label=4;break;
 case 4: 
 return;
 case 5: 
 var $18$0 = ___cxa_find_matching_catch(-1, -1); var $18$1 = tempRet0;

 ___resumeException($18$0)
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt11logic_errorD0Ev($this){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=(($this)|0);
 HEAP32[(($1)>>2)]=3088;
 var $2=(($this+4)|0);
 var $this_idx_val_i_i=HEAP32[(($2)>>2)];
 var $3=((($this_idx_val_i_i)-(4))|0);
 var $4=$3;
 var $5=(tempValue=HEAP32[(($4)>>2)],HEAP32[(($4)>>2)]=tempValue+-1,tempValue);
 var $6=((($5)-(1))|0);
 var $7=($6|0)<0;
 if($7){label=2;break;}else{label=4;break;}
 case 2: 
 var $9=HEAP32[(($2)>>2)];
 var $10=((($9)-(12))|0);
 var $11=($10|0)==0;
 if($11){label=4;break;}else{label=3;break;}
 case 3: 
 __ZdaPv($10);
 label=4;break;
 case 4: 
 var $13=(($this)|0);

 var $14=$this;
 __ZdlPv($14);
 return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt11logic_errorD2Ev($this){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=(($this)|0);
 HEAP32[(($1)>>2)]=3088;
 var $2=(($this+4)|0);
 var $this_idx_val_i=HEAP32[(($2)>>2)];
 var $3=((($this_idx_val_i)-(4))|0);
 var $4=$3;
 var $5=(tempValue=HEAP32[(($4)>>2)],HEAP32[(($4)>>2)]=tempValue+-1,tempValue);
 var $6=((($5)-(1))|0);
 var $7=($6|0)<0;
 if($7){label=2;break;}else{label=4;break;}
 case 2: 
 var $9=HEAP32[(($2)>>2)];
 var $10=((($9)-(12))|0);
 var $11=($10|0)==0;
 if($11){label=4;break;}else{label=3;break;}
 case 3: 
 __ZdaPv($10);
 label=4;break;
 case 4: 
 var $13=(($this)|0);

 return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt11logic_error4whatEv($this){
 var label=0;


 var $1=(($this+4)|0);
 var $_idx_val=HEAP32[(($1)>>2)];
 return $_idx_val;
}


function __ZNSt13runtime_errorC2ERKNSt3__112basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE($this,$msg){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=(($this)|0);
 var $2=(($this)|0);
 HEAP32[(($2)>>2)]=2992;
 var $3=(($this+4)|0);
 var $4=($3|0)==0;
 if($4){label=7;break;}else{label=2;break;}
 case 2: 
 var $6=$msg;
 var $7=HEAP8[($6)];
 var $8=$7&1;
 var $9=(($8<<24)>>24)==0;
 if($9){label=4;break;}else{label=3;break;}
 case 3: 
 var $11=(($msg+8)|0);
 var $12=HEAP32[(($11)>>2)];
 var $16=$12;label=5;break;
 case 4: 
 var $14=$msg;
 var $15=(($14+1)|0);
 var $16=$15;label=5;break;
 case 5: 
 var $16;
 var $17=_strlen($16);
 var $18=((($17)+(13))|0);
 var $19=(function() { try { __THREW__ = 0; return __Znaj($18) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=6;break; } else { label=8;break; }
 case 6: 
 var $20=((($17)+(1))|0);
 var $21=$19;
 var $22=(($19+4)|0);
 var $23=$22;
 HEAP32[(($23)>>2)]=$17;
 HEAP32[(($21)>>2)]=$17;
 var $24=(($19+12)|0);
 HEAP32[(($3)>>2)]=$24;
 var $25=(($19+8)|0);
 var $26=$25;
 HEAP32[(($26)>>2)]=0;
 assert($20 % 1 === 0);(_memcpy($24, $16, $20)|0);
 label=7;break;
 case 7: 
 return;
 case 8: 
 var $29$0 = ___cxa_find_matching_catch(-1, -1); var $29$1 = tempRet0;

 ___resumeException($29$0)
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt13runtime_errorC2EPKc($this,$msg){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=(($this)|0);
 var $2=(($this)|0);
 HEAP32[(($2)>>2)]=2992;
 var $3=(($this+4)|0);
 var $4=($3|0)==0;
 if($4){label=4;break;}else{label=2;break;}
 case 2: 
 var $6=_strlen($msg);
 var $7=((($6)+(13))|0);
 var $8=(function() { try { __THREW__ = 0; return __Znaj($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=3;break; } else { label=5;break; }
 case 3: 
 var $9=((($6)+(1))|0);
 var $10=$8;
 var $11=(($8+4)|0);
 var $12=$11;
 HEAP32[(($12)>>2)]=$6;
 HEAP32[(($10)>>2)]=$6;
 var $13=(($8+12)|0);
 HEAP32[(($3)>>2)]=$13;
 var $14=(($8+8)|0);
 var $15=$14;
 HEAP32[(($15)>>2)]=0;
 assert($9 % 1 === 0);(_memcpy($13, $msg, $9)|0);
 label=4;break;
 case 4: 
 return;
 case 5: 
 var $18$0 = ___cxa_find_matching_catch(-1, -1); var $18$1 = tempRet0;

 ___resumeException($18$0)
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt13runtime_errorD0Ev($this){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=(($this)|0);
 HEAP32[(($1)>>2)]=2992;
 var $2=(($this+4)|0);
 var $this_idx_val_i_i=HEAP32[(($2)>>2)];
 var $3=((($this_idx_val_i_i)-(4))|0);
 var $4=$3;
 var $5=(tempValue=HEAP32[(($4)>>2)],HEAP32[(($4)>>2)]=tempValue+-1,tempValue);
 var $6=((($5)-(1))|0);
 var $7=($6|0)<0;
 if($7){label=2;break;}else{label=4;break;}
 case 2: 
 var $9=HEAP32[(($2)>>2)];
 var $10=((($9)-(12))|0);
 var $11=($10|0)==0;
 if($11){label=4;break;}else{label=3;break;}
 case 3: 
 __ZdaPv($10);
 label=4;break;
 case 4: 
 var $13=(($this)|0);

 var $14=$this;
 __ZdlPv($14);
 return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt13runtime_errorD2Ev($this){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=(($this)|0);
 HEAP32[(($1)>>2)]=2992;
 var $2=(($this+4)|0);
 var $this_idx_val_i=HEAP32[(($2)>>2)];
 var $3=((($this_idx_val_i)-(4))|0);
 var $4=$3;
 var $5=(tempValue=HEAP32[(($4)>>2)],HEAP32[(($4)>>2)]=tempValue+-1,tempValue);
 var $6=((($5)-(1))|0);
 var $7=($6|0)<0;
 if($7){label=2;break;}else{label=4;break;}
 case 2: 
 var $9=HEAP32[(($2)>>2)];
 var $10=((($9)-(12))|0);
 var $11=($10|0)==0;
 if($11){label=4;break;}else{label=3;break;}
 case 3: 
 __ZdaPv($10);
 label=4;break;
 case 4: 
 var $13=(($this)|0);

 return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt13runtime_error4whatEv($this){
 var label=0;


 var $1=(($this+4)|0);
 var $_idx_val=HEAP32[(($1)>>2)];
 return $_idx_val;
}


function __ZNSt12length_errorD0Ev($this){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=(($this)|0);
 HEAP32[(($1)>>2)]=3088;
 var $2=(($this+4)|0);
 var $this_idx_val_i_i=HEAP32[(($2)>>2)];
 var $3=((($this_idx_val_i_i)-(4))|0);
 var $4=$3;
 var $5=(tempValue=HEAP32[(($4)>>2)],HEAP32[(($4)>>2)]=tempValue+-1,tempValue);
 var $6=((($5)-(1))|0);
 var $7=($6|0)<0;
 if($7){label=2;break;}else{label=4;break;}
 case 2: 
 var $9=HEAP32[(($2)>>2)];
 var $10=((($9)-(12))|0);
 var $11=($10|0)==0;
 if($11){label=4;break;}else{label=3;break;}
 case 3: 
 __ZdaPv($10);
 label=4;break;
 case 4: 
 var $13=(($this)|0);

 var $14=$this;
 __ZdlPv($14);
 return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt12out_of_rangeD0Ev($this){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=(($this)|0);
 HEAP32[(($1)>>2)]=3088;
 var $2=(($this+4)|0);
 var $this_idx_val_i_i=HEAP32[(($2)>>2)];
 var $3=((($this_idx_val_i_i)-(4))|0);
 var $4=$3;
 var $5=(tempValue=HEAP32[(($4)>>2)],HEAP32[(($4)>>2)]=tempValue+-1,tempValue);
 var $6=((($5)-(1))|0);
 var $7=($6|0)<0;
 if($7){label=2;break;}else{label=4;break;}
 case 2: 
 var $9=HEAP32[(($2)>>2)];
 var $10=((($9)-(12))|0);
 var $11=($10|0)==0;
 if($11){label=4;break;}else{label=3;break;}
 case 3: 
 __ZdaPv($10);
 label=4;break;
 case 4: 
 var $13=(($this)|0);

 var $14=$this;
 __ZdlPv($14);
 return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__114error_categoryD2Ev($this){
 var label=0;


 return;
}


function __ZNKSt3__114error_category23default_error_conditionEi($agg_result,$this,$ev){
 var label=0;


 var $1=(($agg_result)|0);
 HEAP32[(($1)>>2)]=$ev;
 var $2=(($agg_result+4)|0);
 HEAP32[(($2)>>2)]=$this;
 return;
}


function __ZNKSt3__114error_category10equivalentEiRKNS_15error_conditionE($this,$code,$condition){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+8)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=sp;
 var $2=$this;
 var $3=HEAP32[(($2)>>2)];
 var $4=(($3+12)|0);
 var $5=HEAP32[(($4)>>2)];
 FUNCTION_TABLE[$5]($1,$this,$code);
 var $6=(($1+4)|0);
 var $7=HEAP32[(($6)>>2)];
 var $8=(($condition+4)|0);
 var $9=HEAP32[(($8)>>2)];
 var $10=($7|0)==($9|0);
 if($10){label=2;break;}else{var $17=0;label=3;break;}
 case 2: 
 var $12=(($1)|0);
 var $13=HEAP32[(($12)>>2)];
 var $14=(($condition)|0);
 var $15=HEAP32[(($14)>>2)];
 var $16=($13|0)==($15|0);
 var $17=$16;label=3;break;
 case 3: 
 var $17;
 STACKTOP=sp;return $17;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__114error_category10equivalentERKNS_10error_codeEi($this,$code,$condition){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=(($code+4)|0);
 var $2=HEAP32[(($1)>>2)];
 var $3=($2|0)==($this|0);
 if($3){label=2;break;}else{var $9=0;label=3;break;}
 case 2: 
 var $5=(($code)|0);
 var $6=HEAP32[(($5)>>2)];
 var $7=($6|0)==($condition|0);
 var $9=$7;label=3;break;
 case 3: 
 var $9;
 return $9;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__112__do_message7messageEi($agg_result,$this,$ev){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=_strerror($ev);
 var $2=_strlen($1);
 var $3=($2>>>0)>4294967279;
 if($3){label=2;break;}else{label=3;break;}
 case 2: 
 __ZNKSt3__121__basic_string_commonILb1EE20__throw_length_errorEv(0);
 throw "Reached an unreachable!";
 case 3: 
 var $6=($2>>>0)<11;
 if($6){label=4;break;}else{label=5;break;}
 case 4: 
 var $8=$2<<1;
 var $9=(($8)&255);
 var $10=$agg_result;
 HEAP8[($10)]=$9;
 var $11=$agg_result;
 var $12=(($11+1)|0);
 var $__p_0_i_i_i=$12;label=6;break;
 case 5: 
 var $13=((($2)+(16))|0);
 var $14=$13&-16;
 var $15=__Znwj($14);
 var $16=(($agg_result+8)|0);
 HEAP32[(($16)>>2)]=$15;
 var $17=$14|1;
 var $18=(($agg_result)|0);
 HEAP32[(($18)>>2)]=$17;
 var $19=(($agg_result+4)|0);
 HEAP32[(($19)>>2)]=$2;
 var $__p_0_i_i_i=$15;label=6;break;
 case 6: 
 var $__p_0_i_i_i;
 assert($2 % 1 === 0);(_memcpy($__p_0_i_i_i, $1, $2)|0);
 var $20=(($__p_0_i_i_i+$2)|0);
 HEAP8[($20)]=0;
 return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__112system_error6__initERKNS_10error_codeENS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE($agg_result,$ec,$what_arg){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+16)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=sp;
 var $2=(($ec)|0);
 var $3=HEAP32[(($2)>>2)];
 var $4=($3|0)==0;
 var $_pre5=$what_arg;
 if($4){label=16;break;}else{label=2;break;}
 case 2: 
 var $6=HEAP8[($_pre5)];
 var $7=$6&1;
 var $8=(($7<<24)>>24)==0;
 if($8){label=4;break;}else{label=3;break;}
 case 3: 
 var $10=(($what_arg+4)|0);
 var $11=HEAP32[(($10)>>2)];
 var $15=$11;label=5;break;
 case 4: 
 var $13=($6&255);
 var $14=$13>>>1;
 var $15=$14;label=5;break;
 case 5: 
 var $15;
 var $16=($15|0)==0;
 if($16){var $20=$3;label=7;break;}else{label=6;break;}
 case 6: 
 var $18=__ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj($what_arg,1352,2);
 var $_pre=HEAP32[(($2)>>2)];
 var $20=$_pre;label=7;break;
 case 7: 
 var $20;
 var $21=(($ec+4)|0);
 var $22=HEAP32[(($21)>>2)];
 var $23=$22;
 var $24=HEAP32[(($23)>>2)];
 var $25=(($24+24)|0);
 var $26=HEAP32[(($25)>>2)];
 FUNCTION_TABLE[$26]($1,$22,$20);
 var $27=$1;
 var $28=HEAP8[($27)];
 var $29=$28&1;
 var $30=(($29<<24)>>24)==0;
 if($30){label=9;break;}else{label=8;break;}
 case 8: 
 var $32=(($1+8)|0);
 var $33=HEAP32[(($32)>>2)];
 var $34=(($1+4)|0);
 var $35=HEAP32[(($34)>>2)];
 var $42=$35;var $41=$33;label=10;break;
 case 9: 
 var $37=$1;
 var $38=(($37+1)|0);
 var $39=($28&255);
 var $40=$39>>>1;
 var $42=$40;var $41=$38;label=10;break;
 case 10: 
 var $41;
 var $42;
 var $43=(function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj($what_arg,$41,$42) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=11;break; } else { label=13;break; }
 case 11: 
 var $44=HEAP8[($27)];
 var $45=$44&1;
 var $46=(($45<<24)>>24)==0;
 if($46){label=16;break;}else{label=12;break;}
 case 12: 
 var $48=(($1+8)|0);
 var $49=HEAP32[(($48)>>2)];
 __ZdlPv($49);
 label=16;break;
 case 13: 
 var $51$0 = ___cxa_find_matching_catch(-1, -1); var $51$1 = tempRet0;
 var $52=HEAP8[($27)];
 var $53=$52&1;
 var $54=(($53<<24)>>24)==0;
 if($54){label=15;break;}else{label=14;break;}
 case 14: 
 var $56=(($1+8)|0);
 var $57=HEAP32[(($56)>>2)];
 __ZdlPv($57);
 label=15;break;
 case 15: 
 ___resumeException($51$0)
 case 16: 
 var $58=$agg_result;
 assert(12 % 1 === 0);HEAP32[(($58)>>2)]=HEAP32[(($_pre5)>>2)];HEAP32[((($58)+(4))>>2)]=HEAP32[((($_pre5)+(4))>>2)];HEAP32[((($58)+(8))>>2)]=HEAP32[((($_pre5)+(8))>>2)];
 HEAP32[(($_pre5)>>2)]=0; HEAP32[((($_pre5)+(4))>>2)]=0; HEAP32[((($_pre5)+(8))>>2)]=0;
 STACKTOP=sp;return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__112system_errorC2ENS_10error_codeEPKc($this,$ec,$what_arg){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+32)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var tempParam = $ec; $ec=STACKTOP;STACKTOP = (STACKTOP + 8)|0;(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($ec)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[((($ec)+(4))>>2)]=HEAP32[(((tempParam)+(4))>>2)];
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=sp;
 var $2=(sp)+(16);
 var $3=_strlen($what_arg);
 var $4=($3>>>0)>4294967279;
 if($4){label=2;break;}else{label=3;break;}
 case 2: 
 __ZNKSt3__121__basic_string_commonILb1EE20__throw_length_errorEv(0);
 throw "Reached an unreachable!";
 case 3: 
 var $7=($3>>>0)<11;
 if($7){label=4;break;}else{label=5;break;}
 case 4: 
 var $9=$3<<1;
 var $10=(($9)&255);
 var $11=$2;
 HEAP8[($11)]=$10;
 var $12=$2;
 var $13=(($12+1)|0);
 var $__p_0_i_i_i=$13;label=6;break;
 case 5: 
 var $14=((($3)+(16))|0);
 var $15=$14&-16;
 var $16=__Znwj($15);
 var $17=(($2+8)|0);
 HEAP32[(($17)>>2)]=$16;
 var $18=$15|1;
 var $19=(($2)|0);
 HEAP32[(($19)>>2)]=$18;
 var $20=(($2+4)|0);
 HEAP32[(($20)>>2)]=$3;
 var $__p_0_i_i_i=$16;label=6;break;
 case 6: 
 var $__p_0_i_i_i;
 assert($3 % 1 === 0);(_memcpy($__p_0_i_i_i, $what_arg, $3)|0);
 var $21=(($__p_0_i_i_i+$3)|0);
 HEAP8[($21)]=0;
 (function() { try { __THREW__ = 0; return __ZNSt3__112system_error6__initERKNS_10error_codeENS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE($1,$ec,$2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=7;break; } else { label=13;break; }
 case 7: 
 var $23=(($this)|0);
 (function() { try { __THREW__ = 0; return __ZNSt13runtime_errorC2ERKNSt3__112basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE($23,$1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=8;break; } else { label=14;break; }
 case 8: 
 var $25=$1;
 var $26=HEAP8[($25)];
 var $27=$26&1;
 var $28=(($27<<24)>>24)==0;
 if($28){label=10;break;}else{label=9;break;}
 case 9: 
 var $30=(($1+8)|0);
 var $31=HEAP32[(($30)>>2)];
 __ZdlPv($31);
 label=10;break;
 case 10: 
 var $32=$2;
 var $33=HEAP8[($32)];
 var $34=$33&1;
 var $35=(($34<<24)>>24)==0;
 if($35){label=12;break;}else{label=11;break;}
 case 11: 
 var $37=(($2+8)|0);
 var $38=HEAP32[(($37)>>2)];
 __ZdlPv($38);
 label=12;break;
 case 12: 
 var $39=(($this)|0);
 HEAP32[(($39)>>2)]=5192;
 var $40=(($this+8)|0);
 var $41=$ec;
 var $42=$40;
 var $ld$0$0=(($41)|0);
 var $43$0=HEAP32[(($ld$0$0)>>2)];
 var $ld$1$1=(($41+4)|0);
 var $43$1=HEAP32[(($ld$1$1)>>2)];
 var $st$2$0=(($42)|0);
 HEAP32[(($st$2$0)>>2)]=$43$0;
 var $st$3$1=(($42+4)|0);
 HEAP32[(($st$3$1)>>2)]=$43$1;
 STACKTOP=sp;return;
 case 13: 
 var $45$0 = ___cxa_find_matching_catch(-1, -1); var $45$1 = tempRet0;
 var $46=$45$0;
 var $47=$45$1;
 var $_0=$47;var $_04=$46;label=16;break;
 case 14: 
 var $49$0 = ___cxa_find_matching_catch(-1, -1); var $49$1 = tempRet0;
 var $50=$49$0;
 var $51=$49$1;
 var $52=$1;
 var $53=HEAP8[($52)];
 var $54=$53&1;
 var $55=(($54<<24)>>24)==0;
 if($55){var $_0=$51;var $_04=$50;label=16;break;}else{label=15;break;}
 case 15: 
 var $57=(($1+8)|0);
 var $58=HEAP32[(($57)>>2)];
 __ZdlPv($58);
 var $_0=$51;var $_04=$50;label=16;break;
 case 16: 
 var $_04;
 var $_0;
 var $59=$2;
 var $60=HEAP8[($59)];
 var $61=$60&1;
 var $62=(($61<<24)>>24)==0;
 if($62){label=18;break;}else{label=17;break;}
 case 17: 
 var $64=(($2+8)|0);
 var $65=HEAP32[(($64)>>2)];
 __ZdlPv($65);
 label=18;break;
 case 18: 
 var $66$0=$_04;
 var $66$1=0;
 var $67$0=$66$0;
 var $67$1=$_0;
 ___resumeException($67$0)
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__112system_errorD0Ev($this){
 var label=0;


 var $1=(($this)|0);
 __ZNSt13runtime_errorD2Ev($1);
 var $2=$this;
 __ZdlPv($2);
 return;
}


function __ZNSt3__112system_errorD2Ev($this){
 var label=0;


 var $1=(($this)|0);
 __ZNSt13runtime_errorD2Ev($1);
 return;
}


function __ZNSt3__111__call_onceERVmPvPFvS2_E($flag,$arg,$func){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1;
 var $2=HEAP32[(($flag)>>2)];
 var $3=($2|0)==1;
 if($3){label=2;break;}else{label=3;break;}
 case 2: 
 var $4=_pthread_cond_wait(13544,13520);
 var $5=HEAP32[(($flag)>>2)];
 var $6=($5|0)==1;
 if($6){label=2;break;}else{label=3;break;}
 case 3: 
 var $7=HEAP32[(($flag)>>2)];
 var $8=($7|0)==0;
 if($8){label=4;break;}else{label=14;break;}
 case 4: 
 HEAP32[(($flag)>>2)]=1;
 var $10=(function() { try { __THREW__ = 0; return _pthread_mutex_unlock(13520) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=5;break; } else { label=9;break; }
 case 5: 
 (function() { try { __THREW__ = 0; return FUNCTION_TABLE[$func]($arg) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=6;break; } else { label=9;break; }
 case 6: 
 var $13=(function() { try { __THREW__ = 0; return _pthread_mutex_lock(13520) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=7;break; } else { label=9;break; }
 case 7: 
 HEAP32[(($flag)>>2)]=-1;
 var $15=(function() { try { __THREW__ = 0; return _pthread_mutex_unlock(13520) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=8;break; } else { label=9;break; }
 case 8: 
 var $17=(function() { try { __THREW__ = 0; return _pthread_cond_broadcast(13544) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=15;break; } else { label=9;break; }
 case 9: 
 var $19$0 = ___cxa_find_matching_catch(-1, -1,0); var $19$1 = tempRet0;
 var $20=$19$0;
 var $21=___cxa_begin_catch($20);
 var $22=(function() { try { __THREW__ = 0; return _pthread_mutex_lock(13520) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=10;break; } else { label=13;break; }
 case 10: 
 HEAP32[(($flag)>>2)]=0;
 var $24=(function() { try { __THREW__ = 0; return _pthread_mutex_unlock(13520) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=11;break; } else { label=13;break; }
 case 11: 
 var $26=(function() { try { __THREW__ = 0; return _pthread_cond_broadcast(13544) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=12;break; } else { label=13;break; }
 case 12: 
 (function() { try { __THREW__ = 0; return ___cxa_rethrow() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=18;break; } else { label=13;break; }
 case 13: 
 var $29$0 = ___cxa_find_matching_catch(-1, -1); var $29$1 = tempRet0;
 (function() { try { __THREW__ = 0; return ___cxa_end_catch() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=16;break; } else { label=17;break; }
 case 14: 
 var $31;
 label=15;break;
 case 15: 
 return;
 case 16: 
 ___resumeException($29$0)
 case 17: 
 var $35$0 = ___cxa_find_matching_catch(-1, -1,0); var $35$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
 case 18: 
 throw "Reached an unreachable!";
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__121__basic_string_commonILb1EE20__throw_length_errorEv($this){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=___cxa_allocate_exception(8);
 var $2=$1;
 (function() { try { __THREW__ = 0; return __ZNSt11logic_errorC2EPKc($2,1704) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=2;break; } else { label=3;break; }
 case 2: 
 var $4=$1;
 HEAP32[(($4)>>2)]=3056;
 ___cxa_throw($1,9008,(76));
 throw "Reached an unreachable!";
 case 3: 
 var $6$0 = ___cxa_find_matching_catch(-1, -1); var $6$1 = tempRet0;
 ___cxa_free_exception($1);
 ___resumeException($6$0)
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC1ERKS5_($this,$__str){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=$__str;
 var $2=HEAP8[($1)];
 var $3=$2&1;
 var $4=(($3<<24)>>24)==0;
 if($4){label=2;break;}else{label=3;break;}
 case 2: 
 var $6=$this;
 assert(12 % 1 === 0);HEAP32[(($6)>>2)]=HEAP32[(($1)>>2)];HEAP32[((($6)+(4))>>2)]=HEAP32[((($1)+(4))>>2)];HEAP32[((($6)+(8))>>2)]=HEAP32[((($1)+(8))>>2)];
 label=9;break;
 case 3: 
 var $8=(($__str+8)|0);
 var $9=HEAP32[(($8)>>2)];
 var $10=(($__str+4)|0);
 var $11=HEAP32[(($10)>>2)];
 var $12=($11>>>0)>4294967279;
 if($12){label=4;break;}else{label=5;break;}
 case 4: 
 __ZNKSt3__121__basic_string_commonILb1EE20__throw_length_errorEv(0);
 throw "Reached an unreachable!";
 case 5: 
 var $15=($11>>>0)<11;
 if($15){label=6;break;}else{label=7;break;}
 case 6: 
 var $17=$11<<1;
 var $18=(($17)&255);
 var $19=$this;
 HEAP8[($19)]=$18;
 var $20=$this;
 var $21=(($20+1)|0);
 var $__p_0_i_i=$21;label=8;break;
 case 7: 
 var $22=((($11)+(16))|0);
 var $23=$22&-16;
 var $24=__Znwj($23);
 var $25=(($this+8)|0);
 HEAP32[(($25)>>2)]=$24;
 var $26=$23|1;
 var $27=(($this)|0);
 HEAP32[(($27)>>2)]=$26;
 var $28=(($this+4)|0);
 HEAP32[(($28)>>2)]=$11;
 var $__p_0_i_i=$24;label=8;break;
 case 8: 
 var $__p_0_i_i;
 assert($11 % 1 === 0);(_memcpy($__p_0_i_i, $9, $11)|0);
 var $29=(($__p_0_i_i+$11)|0);
 HEAP8[($29)]=0;
 label=9;break;
 case 9: 
 return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj($this,$__s,$__sz){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=($__sz>>>0)>4294967279;
 if($1){label=2;break;}else{label=3;break;}
 case 2: 
 __ZNKSt3__121__basic_string_commonILb1EE20__throw_length_errorEv(0);
 throw "Reached an unreachable!";
 case 3: 
 var $4=($__sz>>>0)<11;
 if($4){label=4;break;}else{label=5;break;}
 case 4: 
 var $6=$__sz<<1;
 var $7=(($6)&255);
 var $8=$this;
 HEAP8[($8)]=$7;
 var $9=$this;
 var $10=(($9+1)|0);
 var $__p_0=$10;label=6;break;
 case 5: 
 var $11=((($__sz)+(16))|0);
 var $12=$11&-16;
 var $13=__Znwj($12);
 var $14=(($this+8)|0);
 HEAP32[(($14)>>2)]=$13;
 var $15=$12|1;
 var $16=(($this)|0);
 HEAP32[(($16)>>2)]=$15;
 var $17=(($this+4)|0);
 HEAP32[(($17)>>2)]=$__sz;
 var $__p_0=$13;label=6;break;
 case 6: 
 var $__p_0;
 assert($__sz % 1 === 0);(_memcpy($__p_0, $__s, $__sz)|0);
 var $19=(($__p_0+$__sz)|0);
 HEAP8[($19)]=0;
 return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEjc($this,$__n,$__c){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=($__n>>>0)>4294967279;
 if($1){label=2;break;}else{label=3;break;}
 case 2: 
 __ZNKSt3__121__basic_string_commonILb1EE20__throw_length_errorEv(0);
 throw "Reached an unreachable!";
 case 3: 
 var $4=($__n>>>0)<11;
 if($4){label=4;break;}else{label=5;break;}
 case 4: 
 var $6=$__n<<1;
 var $7=(($6)&255);
 var $8=$this;
 HEAP8[($8)]=$7;
 var $9=$this;
 var $10=(($9+1)|0);
 var $__p_0=$10;label=6;break;
 case 5: 
 var $11=((($__n)+(16))|0);
 var $12=$11&-16;
 var $13=__Znwj($12);
 var $14=(($this+8)|0);
 HEAP32[(($14)>>2)]=$13;
 var $15=$12|1;
 var $16=(($this)|0);
 HEAP32[(($16)>>2)]=$15;
 var $17=(($this+4)|0);
 HEAP32[(($17)>>2)]=$__n;
 var $__p_0=$13;label=6;break;
 case 6: 
 var $__p_0;
 _memset($__p_0, $__c, $__n)|0;
 var $19=(($__p_0+$__n)|0);
 HEAP8[($19)]=0;
 return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($this){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=$this;
 var $2=HEAP8[($1)];
 var $3=$2&1;
 var $4=(($3<<24)>>24)==0;
 if($4){label=3;break;}else{label=2;break;}
 case 2: 
 var $6=(($this+8)|0);
 var $7=HEAP32[(($6)>>2)];
 __ZdlPv($7);
 label=3;break;
 case 3: 
 return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc($this,$__s){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=_strlen($__s);
 var $2=$this;
 var $3=HEAP8[($2)];
 var $4=$3&1;
 var $5=(($4<<24)>>24)==0;
 if($5){var $12=10;var $11=$3;label=3;break;}else{label=2;break;}
 case 2: 
 var $7=(($this)|0);
 var $8=HEAP32[(($7)>>2)];
 var $9=$8&-2;
 var $phitmp_i_i=((($9)-(1))|0);
 var $10=(($8)&255);
 var $12=$phitmp_i_i;var $11=$10;label=3;break;
 case 3: 
 var $11;
 var $12;
 var $13=($12>>>0)<($1>>>0);
 var $14=$11&1;
 var $15=(($14<<24)>>24)==0;
 if($13){label=10;break;}else{label=4;break;}
 case 4: 
 if($15){label=6;break;}else{label=5;break;}
 case 5: 
 var $18=(($this+8)|0);
 var $19=HEAP32[(($18)>>2)];
 var $23=$19;label=7;break;
 case 6: 
 var $21=$this;
 var $22=(($21+1)|0);
 var $23=$22;label=7;break;
 case 7: 
 var $23;
 _memmove($23,$__s,$1,1,0);
 var $24=(($23+$1)|0);
 HEAP8[($24)]=0;
 var $25=HEAP8[($2)];
 var $26=$25&1;
 var $27=(($26<<24)>>24)==0;
 if($27){label=9;break;}else{label=8;break;}
 case 8: 
 var $29=(($this+4)|0);
 HEAP32[(($29)>>2)]=$1;
 label=14;break;
 case 9: 
 var $31=$1<<1;
 var $32=(($31)&255);
 HEAP8[($2)]=$32;
 label=14;break;
 case 10: 
 if($15){label=12;break;}else{label=11;break;}
 case 11: 
 var $35=(($this+4)|0);
 var $36=HEAP32[(($35)>>2)];
 var $40=$36;label=13;break;
 case 12: 
 var $38=($11&255);
 var $39=$38>>>1;
 var $40=$39;label=13;break;
 case 13: 
 var $40;
 var $41=((($1)-($12))|0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE21__grow_by_and_replaceEjjjjjjPKc($this,$12,$41,$40,0,$40,$1,$__s);
 label=14;break;
 case 14: 
 return $this;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc($this,$__n,$__c){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=$this;
 var $2=HEAP8[($1)];
 var $3=$2&1;
 var $4=(($3<<24)>>24)==0;
 if($4){label=3;break;}else{label=2;break;}
 case 2: 
 var $6=(($this+4)|0);
 var $7=HEAP32[(($6)>>2)];
 var $11=$7;label=4;break;
 case 3: 
 var $9=($2&255);
 var $10=$9>>>1;
 var $11=$10;label=4;break;
 case 4: 
 var $11;
 var $12=($11>>>0)<($__n>>>0);
 if($12){label=5;break;}else{label=6;break;}
 case 5: 
 var $14=((($__n)-($11))|0);
 var $15=__ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEjc($this,$14,$__c);
 label=9;break;
 case 6: 
 if($4){label=8;break;}else{label=7;break;}
 case 7: 
 var $18=(($this+8)|0);
 var $19=HEAP32[(($18)>>2)];
 var $20=(($19+$__n)|0);
 HEAP8[($20)]=0;
 var $21=(($this+4)|0);
 HEAP32[(($21)>>2)]=$__n;
 label=9;break;
 case 8: 
 var $23=$this;
 var $24=(($23+1+$__n)|0);
 HEAP8[($24)]=0;
 var $25=$__n<<1;
 var $26=(($25)&255);
 HEAP8[($1)]=$26;
 label=9;break;
 case 9: 
 return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEjc($this,$__n,$__c){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=($__n|0)==0;
 if($1){label=16;break;}else{label=2;break;}
 case 2: 
 var $3=$this;
 var $4=HEAP8[($3)];
 var $5=$4&1;
 var $6=(($5<<24)>>24)==0;
 if($6){var $13=10;var $12=$4;label=4;break;}else{label=3;break;}
 case 3: 
 var $8=(($this)|0);
 var $9=HEAP32[(($8)>>2)];
 var $10=$9&-2;
 var $phitmp_i=((($10)-(1))|0);
 var $11=(($9)&255);
 var $13=$phitmp_i;var $12=$11;label=4;break;
 case 4: 
 var $12;
 var $13;
 var $14=$12&1;
 var $15=(($14<<24)>>24)==0;
 if($15){label=6;break;}else{label=5;break;}
 case 5: 
 var $17=(($this+4)|0);
 var $18=HEAP32[(($17)>>2)];
 var $22=$18;label=7;break;
 case 6: 
 var $20=($12&255);
 var $21=$20>>>1;
 var $22=$21;label=7;break;
 case 7: 
 var $22;
 var $23=((($13)-($22))|0);
 var $24=($23>>>0)<($__n>>>0);
 if($24){label=8;break;}else{var $29=$12;label=9;break;}
 case 8: 
 var $26=((($__n)-($13))|0);
 var $27=((($26)+($22))|0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9__grow_byEjjjjjj($this,$13,$27,$22,$22,0,0);
 var $_pre=HEAP8[($3)];
 var $29=$_pre;label=9;break;
 case 9: 
 var $29;
 var $30=$29&1;
 var $31=(($30<<24)>>24)==0;
 if($31){label=11;break;}else{label=10;break;}
 case 10: 
 var $33=(($this+8)|0);
 var $34=HEAP32[(($33)>>2)];
 var $38=$34;label=12;break;
 case 11: 
 var $36=$this;
 var $37=(($36+1)|0);
 var $38=$37;label=12;break;
 case 12: 
 var $38;
 var $39=(($38+$22)|0);
 _memset($39, $__c, $__n)|0;
 var $40=((($22)+($__n))|0);
 var $41=HEAP8[($3)];
 var $42=$41&1;
 var $43=(($42<<24)>>24)==0;
 if($43){label=14;break;}else{label=13;break;}
 case 13: 
 var $45=(($this+4)|0);
 HEAP32[(($45)>>2)]=$40;
 label=15;break;
 case 14: 
 var $47=$40<<1;
 var $48=(($47)&255);
 HEAP8[($3)]=$48;
 label=15;break;
 case 15: 
 var $49=(($38+$40)|0);
 HEAP8[($49)]=0;
 label=16;break;
 case 16: 
 return $this;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7reserveEj($this,$__res_arg){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=($__res_arg>>>0)>4294967279;
 if($1){label=2;break;}else{label=3;break;}
 case 2: 
 __ZNKSt3__121__basic_string_commonILb1EE20__throw_length_errorEv(0);
 throw "Reached an unreachable!";
 case 3: 
 var $4=$this;
 var $5=HEAP8[($4)];
 var $6=$5&1;
 var $7=(($6<<24)>>24)==0;
 if($7){var $14=10;var $13=$5;label=5;break;}else{label=4;break;}
 case 4: 
 var $9=(($this)|0);
 var $10=HEAP32[(($9)>>2)];
 var $11=$10&-2;
 var $phitmp_i=((($11)-(1))|0);
 var $12=(($10)&255);
 var $14=$phitmp_i;var $13=$12;label=5;break;
 case 5: 
 var $13;
 var $14;
 var $15=$13&1;
 var $16=(($15<<24)>>24)==0;
 if($16){label=7;break;}else{label=6;break;}
 case 6: 
 var $18=(($this+4)|0);
 var $19=HEAP32[(($18)>>2)];
 var $23=$19;label=8;break;
 case 7: 
 var $21=($13&255);
 var $22=$21>>>1;
 var $23=$22;label=8;break;
 case 8: 
 var $23;
 var $24=($23>>>0)>($__res_arg>>>0);
 var $_sroa_speculated=($24?$23:$__res_arg);
 var $25=($_sroa_speculated>>>0)<11;
 if($25){var $29=10;label=10;break;}else{label=9;break;}
 case 9: 
 var $27=((($_sroa_speculated)+(16))|0);
 var $28=$27&-16;
 var $phitmp_i7=((($28)-(1))|0);
 var $29=$phitmp_i7;label=10;break;
 case 10: 
 var $29;
 var $30=($29|0)==($14|0);
 if($30){label=28;break;}else{label=11;break;}
 case 11: 
 var $32=($29|0)==10;
 if($32){label=12;break;}else{label=13;break;}
 case 12: 
 var $34=$this;
 var $35=(($34+1)|0);
 var $36=(($this+8)|0);
 var $37=HEAP32[(($36)>>2)];
 var $__new_data_1=$35;var $__p_0=$37;var $__was_long_0_off0=1;var $__now_long_0_off0=0;label=20;break;
 case 13: 
 var $39=($29>>>0)>($14>>>0);
 var $40=((($29)+(1))|0);
 if($39){label=14;break;}else{label=15;break;}
 case 14: 
 var $42=__Znwj($40);
 var $__new_data_0=$42;label=17;break;
 case 15: 
 var $44=(function() { try { __THREW__ = 0; return __Znwj($40) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $__new_data_0=$44;label=17;break; } else { label=16;break; }
 case 16: 
 var $46$0 = ___cxa_find_matching_catch(-1, -1,0); var $46$1 = tempRet0;
 var $47=$46$0;
 var $48=___cxa_begin_catch($47);
 ___cxa_end_catch();
 label=28;break;
 case 17: 
 var $__new_data_0;
 var $49=$13&1;
 var $50=(($49<<24)>>24)==0;
 if($50){label=19;break;}else{label=18;break;}
 case 18: 
 var $52=(($this+8)|0);
 var $53=HEAP32[(($52)>>2)];
 var $__new_data_1=$__new_data_0;var $__p_0=$53;var $__was_long_0_off0=1;var $__now_long_0_off0=1;label=20;break;
 case 19: 
 var $55=$this;
 var $56=(($55+1)|0);
 var $__new_data_1=$__new_data_0;var $__p_0=$56;var $__was_long_0_off0=0;var $__now_long_0_off0=1;label=20;break;
 case 20: 
 var $__now_long_0_off0;
 var $__was_long_0_off0;
 var $__p_0;
 var $__new_data_1;
 var $57=$13&1;
 var $58=(($57<<24)>>24)==0;
 if($58){label=22;break;}else{label=21;break;}
 case 21: 
 var $60=(($this+4)|0);
 var $61=HEAP32[(($60)>>2)];
 var $65=$61;label=23;break;
 case 22: 
 var $63=($13&255);
 var $64=$63>>>1;
 var $65=$64;label=23;break;
 case 23: 
 var $65;
 var $66=((($65)+(1))|0);
 assert($66 % 1 === 0);(_memcpy($__new_data_1, $__p_0, $66)|0);
 if($__was_long_0_off0){label=24;break;}else{label=25;break;}
 case 24: 
 __ZdlPv($__p_0);
 label=25;break;
 case 25: 
 if($__now_long_0_off0){label=26;break;}else{label=27;break;}
 case 26: 
 var $70=((($29)+(1))|0);
 var $71=$70|1;
 var $72=(($this)|0);
 HEAP32[(($72)>>2)]=$71;
 var $73=(($this+4)|0);
 HEAP32[(($73)>>2)]=$23;
 var $74=(($this+8)|0);
 HEAP32[(($74)>>2)]=$__new_data_1;
 label=28;break;
 case 27: 
 var $76=$23<<1;
 var $77=(($76)&255);
 HEAP8[($4)]=$77;
 label=28;break;
 case 28: 
 return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9push_backEc($this,$__c){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=$this;
 var $2=HEAP8[($1)];
 var $3=$2&1;
 var $4=(($3<<24)>>24)!=0;
 if($4){label=3;break;}else{label=2;break;}
 case 2: 
 var $6=($2&255);
 var $7=$6>>>1;
 var $__sz_0=$7;var $__cap_0=10;label=4;break;
 case 3: 
 var $9=(($this)|0);
 var $10=HEAP32[(($9)>>2)];
 var $11=$10&-2;
 var $12=((($11)-(1))|0);
 var $13=(($this+4)|0);
 var $14=HEAP32[(($13)>>2)];
 var $__sz_0=$14;var $__cap_0=$12;label=4;break;
 case 4: 
 var $__cap_0;
 var $__sz_0;
 var $16=($__sz_0|0)==($__cap_0|0);
 if($16){label=5;break;}else{label=6;break;}
 case 5: 
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9__grow_byEjjjjjj($this,$__cap_0,1,$__cap_0,$__cap_0,0,0);
 var $18=HEAP8[($1)];
 var $19=$18&1;
 var $20=(($19<<24)>>24)==0;
 if($20){label=7;break;}else{label=8;break;}
 case 6: 
 if($4){label=8;break;}else{label=7;break;}
 case 7: 
 var $23=$this;
 var $24=(($23+1)|0);
 var $25=$__sz_0<<1;
 var $26=((($25)+(2))|0);
 var $27=(($26)&255);
 HEAP8[($1)]=$27;
 var $__p_0_sum_pre=((($__sz_0)+(1))|0);
 var $_pn=$24;var $__p_0_sum_pre_phi=$__p_0_sum_pre;label=9;break;
 case 8: 
 var $29=(($this+8)|0);
 var $30=HEAP32[(($29)>>2)];
 var $31=((($__sz_0)+(1))|0);
 var $32=(($this+4)|0);
 HEAP32[(($32)>>2)]=$31;
 var $_pn=$30;var $__p_0_sum_pre_phi=$31;label=9;break;
 case 9: 
 var $__p_0_sum_pre_phi;
 var $_pn;
 var $__p_0=(($_pn+$__sz_0)|0);
 HEAP8[($__p_0)]=$__c;
 var $34=(($_pn+$__p_0_sum_pre_phi)|0);
 HEAP8[($34)]=0;
 return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj($this,$__s,$__n){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=$this;
 var $2=HEAP8[($1)];
 var $3=$2&1;
 var $4=(($3<<24)>>24)==0;
 if($4){var $11=10;var $10=$2;label=3;break;}else{label=2;break;}
 case 2: 
 var $6=(($this)|0);
 var $7=HEAP32[(($6)>>2)];
 var $8=$7&-2;
 var $phitmp_i=((($8)-(1))|0);
 var $9=(($7)&255);
 var $11=$phitmp_i;var $10=$9;label=3;break;
 case 3: 
 var $10;
 var $11;
 var $12=$10&1;
 var $13=(($12<<24)>>24)==0;
 if($13){label=5;break;}else{label=4;break;}
 case 4: 
 var $15=(($this+4)|0);
 var $16=HEAP32[(($15)>>2)];
 var $20=$16;label=6;break;
 case 5: 
 var $18=($10&255);
 var $19=$18>>>1;
 var $20=$19;label=6;break;
 case 6: 
 var $20;
 var $21=((($11)-($20))|0);
 var $22=($21>>>0)<($__n>>>0);
 if($22){label=15;break;}else{label=7;break;}
 case 7: 
 var $24=($__n|0)==0;
 if($24){label=16;break;}else{label=8;break;}
 case 8: 
 var $26=$10&1;
 var $27=(($26<<24)>>24)==0;
 if($27){label=10;break;}else{label=9;break;}
 case 9: 
 var $29=(($this+8)|0);
 var $30=HEAP32[(($29)>>2)];
 var $34=$30;label=11;break;
 case 10: 
 var $32=$this;
 var $33=(($32+1)|0);
 var $34=$33;label=11;break;
 case 11: 
 var $34;
 var $35=(($34+$20)|0);
 assert($__n % 1 === 0);(_memcpy($35, $__s, $__n)|0);
 var $36=((($20)+($__n))|0);
 var $37=HEAP8[($1)];
 var $38=$37&1;
 var $39=(($38<<24)>>24)==0;
 if($39){label=13;break;}else{label=12;break;}
 case 12: 
 var $41=(($this+4)|0);
 HEAP32[(($41)>>2)]=$36;
 label=14;break;
 case 13: 
 var $43=$36<<1;
 var $44=(($43)&255);
 HEAP8[($1)]=$44;
 label=14;break;
 case 14: 
 var $45=(($34+$36)|0);
 HEAP8[($45)]=0;
 label=16;break;
 case 15: 
 var $47=((($__n)-($11))|0);
 var $48=((($47)+($20))|0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE21__grow_by_and_replaceEjjjjjjPKc($this,$11,$48,$20,$20,0,$__n,$__s);
 label=16;break;
 case 16: 
 return $this;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE21__grow_by_and_replaceEjjjjjjPKc($this,$__old_cap,$__delta_cap,$__old_sz,$__n_copy,$__n_del,$__n_add,$__p_new_stuff){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=(((-18)-($__old_cap))|0);
 var $2=($1>>>0)<($__delta_cap>>>0);
 if($2){label=2;break;}else{label=3;break;}
 case 2: 
 __ZNKSt3__121__basic_string_commonILb1EE20__throw_length_errorEv(0);
 throw "Reached an unreachable!";
 case 3: 
 var $5=$this;
 var $6=HEAP8[($5)];
 var $7=$6&1;
 var $8=(($7<<24)>>24)==0;
 if($8){label=5;break;}else{label=4;break;}
 case 4: 
 var $10=(($this+8)|0);
 var $11=HEAP32[(($10)>>2)];
 var $15=$11;label=6;break;
 case 5: 
 var $13=$this;
 var $14=(($13+1)|0);
 var $15=$14;label=6;break;
 case 6: 
 var $15;
 var $16=($__old_cap>>>0)<2147483623;
 if($16){label=7;break;}else{var $25=-17;label=9;break;}
 case 7: 
 var $18=((($__delta_cap)+($__old_cap))|0);
 var $19=$__old_cap<<1;
 var $20=($18>>>0)<($19>>>0);
 var $_sroa_speculated=($20?$19:$18);
 var $21=($_sroa_speculated>>>0)<11;
 if($21){var $25=11;label=9;break;}else{label=8;break;}
 case 8: 
 var $23=((($_sroa_speculated)+(16))|0);
 var $24=$23&-16;
 var $25=$24;label=9;break;
 case 9: 
 var $25;
 var $26=__Znwj($25);
 var $27=($__n_copy|0)==0;
 if($27){label=11;break;}else{label=10;break;}
 case 10: 
 assert($__n_copy % 1 === 0);(_memcpy($26, $15, $__n_copy)|0);
 label=11;break;
 case 11: 
 var $30=($__n_add|0)==0;
 if($30){label=13;break;}else{label=12;break;}
 case 12: 
 var $32=(($26+$__n_copy)|0);
 assert($__n_add % 1 === 0);(_memcpy($32, $__p_new_stuff, $__n_add)|0);
 label=13;break;
 case 13: 
 var $34=((($__old_sz)-($__n_del))|0);
 var $35=($34|0)==($__n_copy|0);
 if($35){label=15;break;}else{label=14;break;}
 case 14: 
 var $37=((($34)-($__n_copy))|0);
 var $_sum=((($__n_add)+($__n_copy))|0);
 var $38=(($26+$_sum)|0);
 var $_sum37=((($__n_del)+($__n_copy))|0);
 var $39=(($15+$_sum37)|0);
 assert($37 % 1 === 0);(_memcpy($38, $39, $37)|0);
 label=15;break;
 case 15: 
 var $41=($__old_cap|0)==10;
 if($41){label=17;break;}else{label=16;break;}
 case 16: 
 __ZdlPv($15);
 label=17;break;
 case 17: 
 var $44=(($this+8)|0);
 HEAP32[(($44)>>2)]=$26;
 var $45=$25|1;
 var $46=(($this)|0);
 HEAP32[(($46)>>2)]=$45;
 var $47=((($34)+($__n_add))|0);
 var $48=(($this+4)|0);
 HEAP32[(($48)>>2)]=$47;
 var $49=(($26+$47)|0);
 HEAP8[($49)]=0;
 return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9__grow_byEjjjjjj($this,$__old_cap,$__delta_cap,$__old_sz,$__n_copy,$__n_del,$__n_add){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=(((-17)-($__old_cap))|0);
 var $2=($1>>>0)<($__delta_cap>>>0);
 if($2){label=2;break;}else{label=3;break;}
 case 2: 
 __ZNKSt3__121__basic_string_commonILb1EE20__throw_length_errorEv(0);
 throw "Reached an unreachable!";
 case 3: 
 var $5=$this;
 var $6=HEAP8[($5)];
 var $7=$6&1;
 var $8=(($7<<24)>>24)==0;
 if($8){label=5;break;}else{label=4;break;}
 case 4: 
 var $10=(($this+8)|0);
 var $11=HEAP32[(($10)>>2)];
 var $15=$11;label=6;break;
 case 5: 
 var $13=$this;
 var $14=(($13+1)|0);
 var $15=$14;label=6;break;
 case 6: 
 var $15;
 var $16=($__old_cap>>>0)<2147483623;
 if($16){label=7;break;}else{var $25=-17;label=9;break;}
 case 7: 
 var $18=((($__delta_cap)+($__old_cap))|0);
 var $19=$__old_cap<<1;
 var $20=($18>>>0)<($19>>>0);
 var $_sroa_speculated=($20?$19:$18);
 var $21=($_sroa_speculated>>>0)<11;
 if($21){var $25=11;label=9;break;}else{label=8;break;}
 case 8: 
 var $23=((($_sroa_speculated)+(16))|0);
 var $24=$23&-16;
 var $25=$24;label=9;break;
 case 9: 
 var $25;
 var $26=__Znwj($25);
 var $27=($__n_copy|0)==0;
 if($27){label=11;break;}else{label=10;break;}
 case 10: 
 assert($__n_copy % 1 === 0);(_memcpy($26, $15, $__n_copy)|0);
 label=11;break;
 case 11: 
 var $30=((($__old_sz)-($__n_del))|0);
 var $31=($30|0)==($__n_copy|0);
 if($31){label=13;break;}else{label=12;break;}
 case 12: 
 var $33=((($30)-($__n_copy))|0);
 var $_sum=((($__n_add)+($__n_copy))|0);
 var $34=(($26+$_sum)|0);
 var $_sum26=((($__n_del)+($__n_copy))|0);
 var $35=(($15+$_sum26)|0);
 assert($33 % 1 === 0);(_memcpy($34, $35, $33)|0);
 label=13;break;
 case 13: 
 var $37=($__old_cap|0)==10;
 if($37){label=15;break;}else{label=14;break;}
 case 14: 
 __ZdlPv($15);
 label=15;break;
 case 15: 
 var $40=(($this+8)|0);
 HEAP32[(($40)>>2)]=$26;
 var $41=$25|1;
 var $42=(($this)|0);
 HEAP32[(($42)>>2)]=$41;
 return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6__initEPKwj($this,$__s,$__sz){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=($__sz>>>0)>1073741807;
 if($1){label=2;break;}else{label=3;break;}
 case 2: 
 __ZNKSt3__121__basic_string_commonILb1EE20__throw_length_errorEv(0);
 throw "Reached an unreachable!";
 case 3: 
 var $4=($__sz>>>0)<2;
 if($4){label=4;break;}else{label=5;break;}
 case 4: 
 var $6=$__sz<<1;
 var $7=(($6)&255);
 var $8=$this;
 HEAP8[($8)]=$7;
 var $9=(($this+4)|0);
 var $__p_0=$9;label=6;break;
 case 5: 
 var $10=((($__sz)+(4))|0);
 var $11=$10&-4;
 var $12=$11<<2;
 var $13=__Znwj($12);
 var $14=$13;
 var $15=(($this+8)|0);
 HEAP32[(($15)>>2)]=$14;
 var $16=$11|1;
 var $17=(($this)|0);
 HEAP32[(($17)>>2)]=$16;
 var $18=(($this+4)|0);
 HEAP32[(($18)>>2)]=$__sz;
 var $__p_0=$14;label=6;break;
 case 6: 
 var $__p_0;
 var $20=_wmemcpy($__p_0,$__s,$__sz);
 var $21=(($__p_0+($__sz<<2))|0);
 HEAP32[(($21)>>2)]=0;
 return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6__initEjw($this,$__n,$__c){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=($__n>>>0)>1073741807;
 if($1){label=2;break;}else{label=3;break;}
 case 2: 
 __ZNKSt3__121__basic_string_commonILb1EE20__throw_length_errorEv(0);
 throw "Reached an unreachable!";
 case 3: 
 var $4=($__n>>>0)<2;
 if($4){label=4;break;}else{label=5;break;}
 case 4: 
 var $6=$__n<<1;
 var $7=(($6)&255);
 var $8=$this;
 HEAP8[($8)]=$7;
 var $9=(($this+4)|0);
 var $__p_0=$9;label=6;break;
 case 5: 
 var $10=((($__n)+(4))|0);
 var $11=$10&-4;
 var $12=$11<<2;
 var $13=__Znwj($12);
 var $14=$13;
 var $15=(($this+8)|0);
 HEAP32[(($15)>>2)]=$14;
 var $16=$11|1;
 var $17=(($this)|0);
 HEAP32[(($17)>>2)]=$16;
 var $18=(($this+4)|0);
 HEAP32[(($18)>>2)]=$__n;
 var $__p_0=$14;label=6;break;
 case 6: 
 var $__p_0;
 var $20=_wmemset($__p_0,$__c,$__n);
 var $21=(($__p_0+($__n<<2))|0);
 HEAP32[(($21)>>2)]=0;
 return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev($this){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=$this;
 var $2=HEAP8[($1)];
 var $3=$2&1;
 var $4=(($3<<24)>>24)==0;
 if($4){label=3;break;}else{label=2;break;}
 case 2: 
 var $6=(($this+8)|0);
 var $7=HEAP32[(($6)>>2)];
 var $8=$7;
 __ZdlPv($8);
 label=3;break;
 case 3: 
 return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw($this,$__s){
 var label=0;


 var $1=_wcslen($__s);
 var $2=__ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKwj($this,$__s,$1);
 return $2;
}


function __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKwj($this,$__s,$__n){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=$this;
 var $2=HEAP8[($1)];
 var $3=$2&1;
 var $4=(($3<<24)>>24)==0;
 if($4){var $11=1;var $10=$2;label=3;break;}else{label=2;break;}
 case 2: 
 var $6=(($this)|0);
 var $7=HEAP32[(($6)>>2)];
 var $8=$7&-2;
 var $phitmp_i=((($8)-(1))|0);
 var $9=(($7)&255);
 var $11=$phitmp_i;var $10=$9;label=3;break;
 case 3: 
 var $10;
 var $11;
 var $12=($11>>>0)<($__n>>>0);
 var $13=$10&1;
 var $14=(($13<<24)>>24)==0;
 if($12){label=10;break;}else{label=4;break;}
 case 4: 
 if($14){label=6;break;}else{label=5;break;}
 case 5: 
 var $17=(($this+8)|0);
 var $18=HEAP32[(($17)>>2)];
 var $21=$18;label=7;break;
 case 6: 
 var $20=(($this+4)|0);
 var $21=$20;label=7;break;
 case 7: 
 var $21;
 var $22=_wmemmove($21,$__s,$__n);
 var $23=(($21+($__n<<2))|0);
 HEAP32[(($23)>>2)]=0;
 var $24=HEAP8[($1)];
 var $25=$24&1;
 var $26=(($25<<24)>>24)==0;
 if($26){label=9;break;}else{label=8;break;}
 case 8: 
 var $28=(($this+4)|0);
 HEAP32[(($28)>>2)]=$__n;
 label=14;break;
 case 9: 
 var $30=$__n<<1;
 var $31=(($30)&255);
 HEAP8[($1)]=$31;
 label=14;break;
 case 10: 
 if($14){label=12;break;}else{label=11;break;}
 case 11: 
 var $34=(($this+4)|0);
 var $35=HEAP32[(($34)>>2)];
 var $39=$35;label=13;break;
 case 12: 
 var $37=($10&255);
 var $38=$37>>>1;
 var $39=$38;label=13;break;
 case 13: 
 var $39;
 var $40=((($__n)-($11))|0);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE21__grow_by_and_replaceEjjjjjjPKw($this,$11,$40,$39,0,$39,$__n,$__s);
 label=14;break;
 case 14: 
 return $this;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE7reserveEj($this,$__res_arg){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=($__res_arg>>>0)>1073741807;
 if($1){label=2;break;}else{label=3;break;}
 case 2: 
 __ZNKSt3__121__basic_string_commonILb1EE20__throw_length_errorEv(0);
 throw "Reached an unreachable!";
 case 3: 
 var $4=$this;
 var $5=HEAP8[($4)];
 var $6=$5&1;
 var $7=(($6<<24)>>24)==0;
 if($7){var $14=1;var $13=$5;label=5;break;}else{label=4;break;}
 case 4: 
 var $9=(($this)|0);
 var $10=HEAP32[(($9)>>2)];
 var $11=$10&-2;
 var $phitmp_i=((($11)-(1))|0);
 var $12=(($10)&255);
 var $14=$phitmp_i;var $13=$12;label=5;break;
 case 5: 
 var $13;
 var $14;
 var $15=$13&1;
 var $16=(($15<<24)>>24)==0;
 if($16){label=7;break;}else{label=6;break;}
 case 6: 
 var $18=(($this+4)|0);
 var $19=HEAP32[(($18)>>2)];
 var $23=$19;label=8;break;
 case 7: 
 var $21=($13&255);
 var $22=$21>>>1;
 var $23=$22;label=8;break;
 case 8: 
 var $23;
 var $24=($23>>>0)>($__res_arg>>>0);
 var $_sroa_speculated=($24?$23:$__res_arg);
 var $25=($_sroa_speculated>>>0)<2;
 if($25){var $29=1;label=10;break;}else{label=9;break;}
 case 9: 
 var $27=((($_sroa_speculated)+(4))|0);
 var $28=$27&-4;
 var $phitmp_i7=((($28)-(1))|0);
 var $29=$phitmp_i7;label=10;break;
 case 10: 
 var $29;
 var $30=($29|0)==($14|0);
 if($30){label=28;break;}else{label=11;break;}
 case 11: 
 var $32=($29|0)==1;
 if($32){label=12;break;}else{label=13;break;}
 case 12: 
 var $34=(($this+4)|0);
 var $35=(($this+8)|0);
 var $36=HEAP32[(($35)>>2)];
 var $__new_data_1=$34;var $__p_0=$36;var $__was_long_0_off0=1;var $__now_long_0_off0=0;label=20;break;
 case 13: 
 var $38=($29>>>0)>($14>>>0);
 var $39=$29<<2;
 var $40=((($39)+(4))|0);
 if($38){label=14;break;}else{label=15;break;}
 case 14: 
 var $42=__Znwj($40);
 var $_sink=$42;label=17;break;
 case 15: 
 var $44=(function() { try { __THREW__ = 0; return __Znwj($40) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $_sink=$44;label=17;break; } else { label=16;break; }
 case 16: 
 var $46$0 = ___cxa_find_matching_catch(-1, -1,0); var $46$1 = tempRet0;
 var $47=$46$0;
 var $48=___cxa_begin_catch($47);
 ___cxa_end_catch();
 label=28;break;
 case 17: 
 var $_sink;
 var $49=$_sink;
 var $50=$13&1;
 var $51=(($50<<24)>>24)==0;
 if($51){label=19;break;}else{label=18;break;}
 case 18: 
 var $53=(($this+8)|0);
 var $54=HEAP32[(($53)>>2)];
 var $__new_data_1=$49;var $__p_0=$54;var $__was_long_0_off0=1;var $__now_long_0_off0=1;label=20;break;
 case 19: 
 var $56=(($this+4)|0);
 var $__new_data_1=$49;var $__p_0=$56;var $__was_long_0_off0=0;var $__now_long_0_off0=1;label=20;break;
 case 20: 
 var $__now_long_0_off0;
 var $__was_long_0_off0;
 var $__p_0;
 var $__new_data_1;
 var $57=$13&1;
 var $58=(($57<<24)>>24)==0;
 if($58){label=22;break;}else{label=21;break;}
 case 21: 
 var $60=(($this+4)|0);
 var $61=HEAP32[(($60)>>2)];
 var $65=$61;label=23;break;
 case 22: 
 var $63=($13&255);
 var $64=$63>>>1;
 var $65=$64;label=23;break;
 case 23: 
 var $65;
 var $66=((($65)+(1))|0);
 var $67=_wmemcpy($__new_data_1,$__p_0,$66);
 if($__was_long_0_off0){label=24;break;}else{label=25;break;}
 case 24: 
 var $69=$__p_0;
 __ZdlPv($69);
 label=25;break;
 case 25: 
 if($__now_long_0_off0){label=26;break;}else{label=27;break;}
 case 26: 
 var $72=((($29)+(1))|0);
 var $73=$72|1;
 var $74=(($this)|0);
 HEAP32[(($74)>>2)]=$73;
 var $75=(($this+4)|0);
 HEAP32[(($75)>>2)]=$23;
 var $76=(($this+8)|0);
 HEAP32[(($76)>>2)]=$__new_data_1;
 label=28;break;
 case 27: 
 var $78=$23<<1;
 var $79=(($78)&255);
 HEAP8[($4)]=$79;
 label=28;break;
 case 28: 
 return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE9push_backEw($this,$__c){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=$this;
 var $2=HEAP8[($1)];
 var $3=$2&1;
 var $4=(($3<<24)>>24)!=0;
 if($4){label=3;break;}else{label=2;break;}
 case 2: 
 var $6=($2&255);
 var $7=$6>>>1;
 var $__sz_0=$7;var $__cap_0=1;label=4;break;
 case 3: 
 var $9=(($this)|0);
 var $10=HEAP32[(($9)>>2)];
 var $11=$10&-2;
 var $12=((($11)-(1))|0);
 var $13=(($this+4)|0);
 var $14=HEAP32[(($13)>>2)];
 var $__sz_0=$14;var $__cap_0=$12;label=4;break;
 case 4: 
 var $__cap_0;
 var $__sz_0;
 var $16=($__sz_0|0)==($__cap_0|0);
 if($16){label=5;break;}else{label=6;break;}
 case 5: 
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE9__grow_byEjjjjjj($this,$__cap_0,1,$__cap_0,$__cap_0,0,0);
 var $18=HEAP8[($1)];
 var $19=$18&1;
 var $20=(($19<<24)>>24)==0;
 if($20){label=7;break;}else{label=8;break;}
 case 6: 
 if($4){label=8;break;}else{label=7;break;}
 case 7: 
 var $23=(($this+4)|0);
 var $24=$__sz_0<<1;
 var $25=((($24)+(2))|0);
 var $26=(($25)&255);
 HEAP8[($1)]=$26;
 var $__p_0_sum_pre=((($__sz_0)+(1))|0);
 var $_pn=$23;var $__p_0_sum_pre_phi=$__p_0_sum_pre;label=9;break;
 case 8: 
 var $28=(($this+8)|0);
 var $29=HEAP32[(($28)>>2)];
 var $30=((($__sz_0)+(1))|0);
 var $31=(($this+4)|0);
 HEAP32[(($31)>>2)]=$30;
 var $_pn=$29;var $__p_0_sum_pre_phi=$30;label=9;break;
 case 9: 
 var $__p_0_sum_pre_phi;
 var $_pn;
 var $__p_0=(($_pn+($__sz_0<<2))|0);
 HEAP32[(($__p_0)>>2)]=$__c;
 var $33=(($_pn+($__p_0_sum_pre_phi<<2))|0);
 HEAP32[(($33)>>2)]=0;
 return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE21__grow_by_and_replaceEjjjjjjPKw($this,$__old_cap,$__delta_cap,$__old_sz,$__n_copy,$__n_del,$__n_add,$__p_new_stuff){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=(((1073741806)-($__old_cap))|0);
 var $2=($1>>>0)<($__delta_cap>>>0);
 if($2){label=2;break;}else{label=3;break;}
 case 2: 
 __ZNKSt3__121__basic_string_commonILb1EE20__throw_length_errorEv(0);
 throw "Reached an unreachable!";
 case 3: 
 var $5=$this;
 var $6=HEAP8[($5)];
 var $7=$6&1;
 var $8=(($7<<24)>>24)==0;
 if($8){label=5;break;}else{label=4;break;}
 case 4: 
 var $10=(($this+8)|0);
 var $11=HEAP32[(($10)>>2)];
 var $14=$11;label=6;break;
 case 5: 
 var $13=(($this+4)|0);
 var $14=$13;label=6;break;
 case 6: 
 var $14;
 var $15=($__old_cap>>>0)<536870887;
 if($15){label=7;break;}else{var $24=1073741807;label=9;break;}
 case 7: 
 var $17=((($__delta_cap)+($__old_cap))|0);
 var $18=$__old_cap<<1;
 var $19=($17>>>0)<($18>>>0);
 var $_sroa_speculated=($19?$18:$17);
 var $20=($_sroa_speculated>>>0)<2;
 if($20){var $24=2;label=9;break;}else{label=8;break;}
 case 8: 
 var $22=((($_sroa_speculated)+(4))|0);
 var $23=$22&-4;
 var $24=$23;label=9;break;
 case 9: 
 var $24;
 var $25=$24<<2;
 var $26=__Znwj($25);
 var $27=$26;
 var $28=($__n_copy|0)==0;
 if($28){label=11;break;}else{label=10;break;}
 case 10: 
 var $30=_wmemcpy($27,$14,$__n_copy);
 label=11;break;
 case 11: 
 var $32=($__n_add|0)==0;
 if($32){label=13;break;}else{label=12;break;}
 case 12: 
 var $34=(($27+($__n_copy<<2))|0);
 var $35=_wmemcpy($34,$__p_new_stuff,$__n_add);
 label=13;break;
 case 13: 
 var $37=((($__old_sz)-($__n_del))|0);
 var $38=($37|0)==($__n_copy|0);
 if($38){label=15;break;}else{label=14;break;}
 case 14: 
 var $40=((($37)-($__n_copy))|0);
 var $_sum=((($__n_add)+($__n_copy))|0);
 var $41=(($27+($_sum<<2))|0);
 var $_sum37=((($__n_del)+($__n_copy))|0);
 var $42=(($14+($_sum37<<2))|0);
 var $43=_wmemcpy($41,$42,$40);
 label=15;break;
 case 15: 
 var $45=($__old_cap|0)==1;
 if($45){label=17;break;}else{label=16;break;}
 case 16: 
 var $47=$14;
 __ZdlPv($47);
 label=17;break;
 case 17: 
 var $49=(($this+8)|0);
 HEAP32[(($49)>>2)]=$27;
 var $50=$24|1;
 var $51=(($this)|0);
 HEAP32[(($51)>>2)]=$50;
 var $52=((($37)+($__n_add))|0);
 var $53=(($this+4)|0);
 HEAP32[(($53)>>2)]=$52;
 var $54=(($27+($52<<2))|0);
 HEAP32[(($54)>>2)]=0;
 return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE9__grow_byEjjjjjj($this,$__old_cap,$__delta_cap,$__old_sz,$__n_copy,$__n_del,$__n_add){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=(((1073741807)-($__old_cap))|0);
 var $2=($1>>>0)<($__delta_cap>>>0);
 if($2){label=2;break;}else{label=3;break;}
 case 2: 
 __ZNKSt3__121__basic_string_commonILb1EE20__throw_length_errorEv(0);
 throw "Reached an unreachable!";
 case 3: 
 var $5=$this;
 var $6=HEAP8[($5)];
 var $7=$6&1;
 var $8=(($7<<24)>>24)==0;
 if($8){label=5;break;}else{label=4;break;}
 case 4: 
 var $10=(($this+8)|0);
 var $11=HEAP32[(($10)>>2)];
 var $14=$11;label=6;break;
 case 5: 
 var $13=(($this+4)|0);
 var $14=$13;label=6;break;
 case 6: 
 var $14;
 var $15=($__old_cap>>>0)<536870887;
 if($15){label=7;break;}else{var $24=1073741807;label=9;break;}
 case 7: 
 var $17=((($__delta_cap)+($__old_cap))|0);
 var $18=$__old_cap<<1;
 var $19=($17>>>0)<($18>>>0);
 var $_sroa_speculated=($19?$18:$17);
 var $20=($_sroa_speculated>>>0)<2;
 if($20){var $24=2;label=9;break;}else{label=8;break;}
 case 8: 
 var $22=((($_sroa_speculated)+(4))|0);
 var $23=$22&-4;
 var $24=$23;label=9;break;
 case 9: 
 var $24;
 var $25=$24<<2;
 var $26=__Znwj($25);
 var $27=$26;
 var $28=($__n_copy|0)==0;
 if($28){label=11;break;}else{label=10;break;}
 case 10: 
 var $30=_wmemcpy($27,$14,$__n_copy);
 label=11;break;
 case 11: 
 var $32=((($__old_sz)-($__n_del))|0);
 var $33=($32|0)==($__n_copy|0);
 if($33){label=13;break;}else{label=12;break;}
 case 12: 
 var $35=((($32)-($__n_copy))|0);
 var $_sum=((($__n_add)+($__n_copy))|0);
 var $36=(($27+($_sum<<2))|0);
 var $_sum26=((($__n_del)+($__n_copy))|0);
 var $37=(($14+($_sum26<<2))|0);
 var $38=_wmemcpy($36,$37,$35);
 label=13;break;
 case 13: 
 var $40=($__old_cap|0)==1;
 if($40){label=15;break;}else{label=14;break;}
 case 14: 
 var $42=$14;
 __ZdlPv($42);
 label=15;break;
 case 15: 
 var $44=(($this+8)|0);
 HEAP32[(($44)>>2)]=$27;
 var $45=$24|1;
 var $46=(($this)|0);
 HEAP32[(($46)>>2)]=$45;
 return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__18ios_base5clearEj($this,$state){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+8)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=sp;
 var $2=(($this+24)|0);
 var $3=HEAP32[(($2)>>2)];
 var $4=($3|0)==0;
 if($4){label=3;break;}else{label=2;break;}
 case 2: 
 var $6=(($this+16)|0);
 HEAP32[(($6)>>2)]=$state;
 label=4;break;
 case 3: 
 var $8=$state|1;
 var $9=(($this+16)|0);
 HEAP32[(($9)>>2)]=$8;
 label=4;break;
 case 4: 
 var $11=($4&1);
 var $12=$11|$state;
 var $13=(($this+20)|0);
 var $14=HEAP32[(($13)>>2)];
 var $15=$12&$14;
 var $16=($15|0)==0;
 if($16){label=11;break;}else{label=5;break;}
 case 5: 
 var $18=___cxa_allocate_exception(16);
 var $19=HEAP8[(14664)];
 var $20=(($19<<24)>>24)==0;
 if($20){label=6;break;}else{label=8;break;}
 case 6: 
 var $22=___cxa_guard_acquire(14664);
 var $23=($22|0)==0;
 if($23){label=8;break;}else{label=7;break;}
 case 7: 
 HEAP32[((12672)>>2)]=4576;
 var $25=_atexit((182),12672,___dso_handle);

 label=8;break;
 case 8: 
 var $26=$1;
 var $tmpcast_i=$1;
 var $27=$18;
 var $$etemp$2$0=1;
 var $$etemp$2$1=0;
 var $$etemp$4$0=0;
 var $$etemp$4$1=-1;
 var $$etemp$6$0=32;
 var $$etemp$6$1=0;
 var $$etemp$7=12672;
 var $$etemp$5$0=$$etemp$7;
 var $$etemp$5$1=0;
 var $$etemp$3$0=_bitshift64Shl($$etemp$5$0,$$etemp$5$1,$$etemp$6$0);var $$etemp$3$1=tempRet0;
 var $$etemp$1$0=$$etemp$3$0&$$etemp$4$0;
 var $$etemp$1$1=$$etemp$3$1&$$etemp$4$1;
 var $$etemp$0$0=$$etemp$1$0|$$etemp$2$0;
 var $$etemp$0$1=$$etemp$1$1|$$etemp$2$1;
 var $st$8$0=(($1)|0);
 HEAP32[(($st$8$0)>>2)]=$$etemp$0$0;
 var $st$9$1=(($1+4)|0);
 HEAP32[(($st$9$1)>>2)]=$$etemp$0$1;
 (function() { try { __THREW__ = 0; return __ZNSt3__112system_errorC2ENS_10error_codeEPKc($27,$tmpcast_i,1392) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=9;break; } else { label=10;break; }
 case 9: 
 var $29=$18;
 HEAP32[(($29)>>2)]=3760;
 ___cxa_throw($18,9552,(68));
 throw "Reached an unreachable!";
 case 10: 
 var $31$0 = ___cxa_find_matching_catch(-1, -1); var $31$1 = tempRet0;
 ___cxa_free_exception($18);
 ___resumeException($31$0)
 case 11: 
 STACKTOP=sp;return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__18ios_baseD2Ev($this){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=(($this)|0);
 HEAP32[(($1)>>2)]=3736;
 var $2=(($this+40)|0);
 var $3=HEAP32[(($2)>>2)];
 var $4=($3|0)==0;
 var $_pre=(($this+32)|0);
 var $_pre1=(($this+36)|0);
 if($4){label=4;break;}else{var $i_05_i=$3;label=2;break;}
 case 2: 
 var $i_05_i;
 var $5=((($i_05_i)-(1))|0);
 var $6=HEAP32[(($_pre)>>2)];
 var $7=(($6+($5<<2))|0);
 var $8=HEAP32[(($7)>>2)];
 var $9=HEAP32[(($_pre1)>>2)];
 var $10=(($9+($5<<2))|0);
 var $11=HEAP32[(($10)>>2)];
 (function() { try { __THREW__ = 0; return FUNCTION_TABLE[$8](0,$this,$11) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=3;break; } else { label=5;break; }
 case 3: 
 var $12=($5|0)==0;
 if($12){label=4;break;}else{var $i_05_i=$5;label=2;break;}
 case 4: 
 var $13=(($this+28)|0);
 var $14=$13;
 __ZNSt3__16localeD2Ev($14);
 var $15=HEAP32[(($_pre)>>2)];
 var $16=$15;
 _free($16);
 var $17=HEAP32[(($_pre1)>>2)];
 var $18=$17;
 _free($18);
 var $19=(($this+48)|0);
 var $20=HEAP32[(($19)>>2)];
 var $21=$20;
 _free($21);
 var $22=(($this+60)|0);
 var $23=HEAP32[(($22)>>2)];
 var $24=$23;
 _free($24);
 return;
 case 5: 
 var $26$0 = ___cxa_find_matching_catch(-1, -1,0); var $26$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__19basic_iosIcNS_11char_traitsIcEEED0Ev($this){
 var label=0;


 var $1=(($this)|0);
 __ZNSt3__18ios_baseD2Ev($1);
 var $2=$this;
 __ZdlPv($2);
 return;
}


function __ZNSt3__19basic_iosIcNS_11char_traitsIcEEED1Ev($this){
 var label=0;


 var $1=(($this)|0);
 __ZNSt3__18ios_baseD2Ev($1);
 return;
}


function __ZNSt3__19basic_iosIcNS_11char_traitsIcEEED2Ev($this){
 var label=0;


 var $1=(($this)|0);
 __ZNSt3__18ios_baseD2Ev($1);
 return;
}


function __ZNKSt3__18ios_base6getlocEv($agg_result,$this){
 var label=0;


 var $1=(($this+28)|0);
 var $2=$1;
 __ZNSt3__16localeC2ERKS0_($agg_result,$2);
 return;
}


function __ZNSt3__18ios_base4initEPv($this,$sb){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=(($this+24)|0);
 HEAP32[(($1)>>2)]=$sb;
 var $not_=($sb|0)==0;
 var $2=($not_&1);
 var $3=(($this+16)|0);
 HEAP32[(($3)>>2)]=$2;
 var $4=(($this+20)|0);
 HEAP32[(($4)>>2)]=0;
 var $5=(($this+4)|0);
 HEAP32[(($5)>>2)]=4098;
 var $6=(($this+12)|0);
 HEAP32[(($6)>>2)]=0;
 var $7=(($this+8)|0);
 HEAP32[(($7)>>2)]=6;
 var $8=(($this+32)|0);
 var $9=(($this+28)|0);
 var $10=($9|0)==0;
 var $11=$8;
 _memset($11, 0, 40)|0;
 if($10){label=3;break;}else{label=2;break;}
 case 2: 
 var $13=$9;
 __ZNSt3__16localeC2Ev($13);
 label=3;break;
 case 3: 
 return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEED0Ev($this){
 var label=0;


 var $1=(($this)|0);
 HEAP32[(($1)>>2)]=4808;
 var $2=(($this+4)|0);
 __ZNSt3__16localeD2Ev($2);
 var $3=$this;
 __ZdlPv($3);
 return;
}


function __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEED1Ev($this){
 var label=0;


 var $1=(($this)|0);
 HEAP32[(($1)>>2)]=4808;
 var $2=(($this+4)|0);
 __ZNSt3__16localeD2Ev($2);
 return;
}


function __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEED2Ev($this){
 var label=0;


 var $1=(($this)|0);
 HEAP32[(($1)>>2)]=4808;
 var $2=(($this+4)|0);
 __ZNSt3__16localeD2Ev($2);
 return;
}


function __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEEC2Ev($this){
 var label=0;


 var $1=(($this)|0);
 HEAP32[(($1)>>2)]=4808;
 var $2=(($this+4)|0);
 __ZNSt3__16localeC2Ev($2);
 var $3=(($this+8)|0);
 var $4=$3;
 HEAP32[(($4)>>2)]=0; HEAP32[((($4)+(4))>>2)]=0; HEAP32[((($4)+(8))>>2)]=0; HEAP32[((($4)+(12))>>2)]=0; HEAP32[((($4)+(16))>>2)]=0; HEAP32[((($4)+(20))>>2)]=0;
 return;
}


function __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE5imbueERKNS_6localeE($this,$0){
 var label=0;


 return;
}


function __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE6setbufEPci($this,$0,$1){
 var label=0;


 return $this;
}


function __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE7seekoffExNS_8ios_base7seekdirEj($agg_result,$this,$0$0,$0$1,$1,$2){
 var label=0;


 var $4=$agg_result;
 var $$etemp$0$0=0;
 var $$etemp$0$1=0;
 var $st$1$0=(($4)|0);
 HEAP32[(($st$1$0)>>2)]=$$etemp$0$0;
 var $st$2$1=(($4+4)|0);
 HEAP32[(($st$2$1)>>2)]=$$etemp$0$1;
 var $5=(($agg_result+8)|0);
 var $$etemp$3$0=-1;
 var $$etemp$3$1=-1;
 var $st$4$0=(($5)|0);
 HEAP32[(($st$4$0)>>2)]=$$etemp$3$0;
 var $st$5$1=(($5+4)|0);
 HEAP32[(($st$5$1)>>2)]=$$etemp$3$1;
 return;
}


function __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE7seekposENS_4fposI11__mbstate_tEEj($agg_result,$this,$0,$1){
 var label=0;
 var sp=STACKTOP; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var tempParam = $0; $0=STACKTOP;STACKTOP = (STACKTOP + 16)|0;(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[((($0)+(4))>>2)]=HEAP32[(((tempParam)+(4))>>2)];HEAP32[((($0)+(8))>>2)]=HEAP32[(((tempParam)+(8))>>2)];HEAP32[((($0)+(12))>>2)]=HEAP32[(((tempParam)+(12))>>2)];

 var $3=$agg_result;
 var $$etemp$0$0=0;
 var $$etemp$0$1=0;
 var $st$1$0=(($3)|0);
 HEAP32[(($st$1$0)>>2)]=$$etemp$0$0;
 var $st$2$1=(($3+4)|0);
 HEAP32[(($st$2$1)>>2)]=$$etemp$0$1;
 var $4=(($agg_result+8)|0);
 var $$etemp$3$0=-1;
 var $$etemp$3$1=-1;
 var $st$4$0=(($4)|0);
 HEAP32[(($st$4$0)>>2)]=$$etemp$3$0;
 var $st$5$1=(($4+4)|0);
 HEAP32[(($st$5$1)>>2)]=$$etemp$3$1;
 STACKTOP=sp;return;
}


function __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE4syncEv($this){
 var label=0;


 return 0;
}


function __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE9showmanycEv($this){
 var label=0;


 return 0;
}


function __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE6xsgetnEPci($this,$__s,$__n){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=$this;
 var $2=($__n|0)>0;
 if($2){label=2;break;}else{var $__i_0_lcssa=0;label=8;break;}
 case 2: 
 var $3=(($this+12)|0);
 var $4=(($this+16)|0);
 var $_07=$__s;var $__i_08=0;label=3;break;
 case 3: 
 var $__i_08;
 var $_07;
 var $6=HEAP32[(($3)>>2)];
 var $7=HEAP32[(($4)>>2)];
 var $8=($6>>>0)<($7>>>0);
 if($8){label=4;break;}else{label=5;break;}
 case 4: 
 var $10=(($6+1)|0);
 HEAP32[(($3)>>2)]=$10;
 var $11=HEAP8[($6)];
 var $storemerge=$11;label=7;break;
 case 5: 
 var $13=HEAP32[(($1)>>2)];
 var $14=(($13+40)|0);
 var $15=HEAP32[(($14)>>2)];
 var $16=FUNCTION_TABLE[$15]($this);
 var $17=($16|0)==-1;
 if($17){var $__i_0_lcssa=$__i_08;label=8;break;}else{label=6;break;}
 case 6: 
 var $19=(($16)&255);
 var $storemerge=$19;label=7;break;
 case 7: 
 var $storemerge;
 HEAP8[($_07)]=$storemerge;
 var $21=((($__i_08)+(1))|0);
 var $22=(($_07+1)|0);
 var $23=($21|0)<($__n|0);
 if($23){var $_07=$22;var $__i_08=$21;label=3;break;}else{var $__i_0_lcssa=$21;label=8;break;}
 case 8: 
 var $__i_0_lcssa;
 return $__i_0_lcssa;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE9underflowEv($this){
 var label=0;


 return -1;
}


function __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE5uflowEv($this){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=$this;
 var $2=HEAP32[(($1)>>2)];
 var $3=(($2+36)|0);
 var $4=HEAP32[(($3)>>2)];
 var $5=FUNCTION_TABLE[$4]($this);
 var $6=($5|0)==-1;
 if($6){var $_0=-1;label=3;break;}else{label=2;break;}
 case 2: 
 var $8=(($this+12)|0);
 var $9=HEAP32[(($8)>>2)];
 var $10=(($9+1)|0);
 HEAP32[(($8)>>2)]=$10;
 var $11=HEAP8[($9)];
 var $12=($11&255);
 var $_0=$12;label=3;break;
 case 3: 
 var $_0;
 return $_0;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE9pbackfailEi($this,$0){
 var label=0;


 return -1;
}


function __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE6xsputnEPKci($this,$__s,$__n){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=$this;
 var $2=($__n|0)>0;
 if($2){label=2;break;}else{var $__i_0_lcssa=0;label=7;break;}
 case 2: 
 var $3=(($this+24)|0);
 var $4=(($this+28)|0);
 var $__i_07=0;var $_08=$__s;label=3;break;
 case 3: 
 var $_08;
 var $__i_07;
 var $6=HEAP32[(($3)>>2)];
 var $7=HEAP32[(($4)>>2)];
 var $8=($6>>>0)<($7>>>0);
 if($8){label=4;break;}else{label=5;break;}
 case 4: 
 var $10=HEAP8[($_08)];
 var $11=(($6+1)|0);
 HEAP32[(($3)>>2)]=$11;
 HEAP8[($6)]=$10;
 label=6;break;
 case 5: 
 var $13=HEAP32[(($1)>>2)];
 var $14=(($13+52)|0);
 var $15=HEAP32[(($14)>>2)];
 var $16=HEAP8[($_08)];
 var $17=($16&255);
 var $18=FUNCTION_TABLE[$15]($this,$17);
 var $19=($18|0)==-1;
 if($19){var $__i_0_lcssa=$__i_07;label=7;break;}else{label=6;break;}
 case 6: 
 var $21=(($_08+1)|0);
 var $22=((($__i_07)+(1))|0);
 var $23=($22|0)<($__n|0);
 if($23){var $__i_07=$22;var $_08=$21;label=3;break;}else{var $__i_0_lcssa=$22;label=7;break;}
 case 7: 
 var $__i_0_lcssa;
 return $__i_0_lcssa;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE8overflowEi($this,$0){
 var label=0;


 return -1;
}


function __ZNSt3__115basic_streambufIwNS_11char_traitsIwEEED0Ev($this){
 var label=0;


 var $1=(($this)|0);
 HEAP32[(($1)>>2)]=4736;
 var $2=(($this+4)|0);
 __ZNSt3__16localeD2Ev($2);
 var $3=$this;
 __ZdlPv($3);
 return;
}


function __ZNSt3__115basic_streambufIwNS_11char_traitsIwEEED1Ev($this){
 var label=0;


 var $1=(($this)|0);
 HEAP32[(($1)>>2)]=4736;
 var $2=(($this+4)|0);
 __ZNSt3__16localeD2Ev($2);
 return;
}


function __ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE5imbueERKNS_6localeE($this,$0){
 var label=0;


 return;
}


function __ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE6setbufEPwi($this,$0,$1){
 var label=0;


 return $this;
}


function __ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE7seekoffExNS_8ios_base7seekdirEj($agg_result,$this,$0$0,$0$1,$1,$2){
 var label=0;


 var $4=$agg_result;
 var $$etemp$0$0=0;
 var $$etemp$0$1=0;
 var $st$1$0=(($4)|0);
 HEAP32[(($st$1$0)>>2)]=$$etemp$0$0;
 var $st$2$1=(($4+4)|0);
 HEAP32[(($st$2$1)>>2)]=$$etemp$0$1;
 var $5=(($agg_result+8)|0);
 var $$etemp$3$0=-1;
 var $$etemp$3$1=-1;
 var $st$4$0=(($5)|0);
 HEAP32[(($st$4$0)>>2)]=$$etemp$3$0;
 var $st$5$1=(($5+4)|0);
 HEAP32[(($st$5$1)>>2)]=$$etemp$3$1;
 return;
}


function __ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE7seekposENS_4fposI11__mbstate_tEEj($agg_result,$this,$0,$1){
 var label=0;
 var sp=STACKTOP; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var tempParam = $0; $0=STACKTOP;STACKTOP = (STACKTOP + 16)|0;(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[((($0)+(4))>>2)]=HEAP32[(((tempParam)+(4))>>2)];HEAP32[((($0)+(8))>>2)]=HEAP32[(((tempParam)+(8))>>2)];HEAP32[((($0)+(12))>>2)]=HEAP32[(((tempParam)+(12))>>2)];

 var $3=$agg_result;
 var $$etemp$0$0=0;
 var $$etemp$0$1=0;
 var $st$1$0=(($3)|0);
 HEAP32[(($st$1$0)>>2)]=$$etemp$0$0;
 var $st$2$1=(($3+4)|0);
 HEAP32[(($st$2$1)>>2)]=$$etemp$0$1;
 var $4=(($agg_result+8)|0);
 var $$etemp$3$0=-1;
 var $$etemp$3$1=-1;
 var $st$4$0=(($4)|0);
 HEAP32[(($st$4$0)>>2)]=$$etemp$3$0;
 var $st$5$1=(($4+4)|0);
 HEAP32[(($st$5$1)>>2)]=$$etemp$3$1;
 STACKTOP=sp;return;
}


function __ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE4syncEv($this){
 var label=0;


 return 0;
}


function __ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE9showmanycEv($this){
 var label=0;


 return 0;
}


function __ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE6xsgetnEPwi($this,$__s,$__n){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=$this;
 var $2=($__n|0)>0;
 if($2){label=2;break;}else{var $__i_0_lcssa=0;label=7;break;}
 case 2: 
 var $3=(($this+12)|0);
 var $4=(($this+16)|0);
 var $_07=$__s;var $__i_08=0;label=3;break;
 case 3: 
 var $__i_08;
 var $_07;
 var $6=HEAP32[(($3)>>2)];
 var $7=HEAP32[(($4)>>2)];
 var $8=($6>>>0)<($7>>>0);
 if($8){label=4;break;}else{label=5;break;}
 case 4: 
 var $10=(($6+4)|0);
 HEAP32[(($3)>>2)]=$10;
 var $11=HEAP32[(($6)>>2)];
 var $storemerge=$11;label=6;break;
 case 5: 
 var $13=HEAP32[(($1)>>2)];
 var $14=(($13+40)|0);
 var $15=HEAP32[(($14)>>2)];
 var $16=FUNCTION_TABLE[$15]($this);
 var $17=($16|0)==-1;
 if($17){var $__i_0_lcssa=$__i_08;label=7;break;}else{var $storemerge=$16;label=6;break;}
 case 6: 
 var $storemerge;
 HEAP32[(($_07)>>2)]=$storemerge;
 var $19=((($__i_08)+(1))|0);
 var $20=(($_07+4)|0);
 var $21=($19|0)<($__n|0);
 if($21){var $_07=$20;var $__i_08=$19;label=3;break;}else{var $__i_0_lcssa=$19;label=7;break;}
 case 7: 
 var $__i_0_lcssa;
 return $__i_0_lcssa;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE9underflowEv($this){
 var label=0;


 return -1;
}


function __ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE5uflowEv($this){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=$this;
 var $2=HEAP32[(($1)>>2)];
 var $3=(($2+36)|0);
 var $4=HEAP32[(($3)>>2)];
 var $5=FUNCTION_TABLE[$4]($this);
 var $6=($5|0)==-1;
 if($6){var $_0=-1;label=3;break;}else{label=2;break;}
 case 2: 
 var $8=(($this+12)|0);
 var $9=HEAP32[(($8)>>2)];
 var $10=(($9+4)|0);
 HEAP32[(($8)>>2)]=$10;
 var $11=HEAP32[(($9)>>2)];
 var $_0=$11;label=3;break;
 case 3: 
 var $_0;
 return $_0;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE9pbackfailEj($this,$0){
 var label=0;


 return -1;
}


function __ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE6xsputnEPKwi($this,$__s,$__n){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=$this;
 var $2=($__n|0)>0;
 if($2){label=2;break;}else{var $__i_0_lcssa=0;label=8;break;}
 case 2: 
 var $3=(($this+24)|0);
 var $4=(($this+28)|0);
 var $__i_07=0;var $_08=$__s;label=3;break;
 case 3: 
 var $_08;
 var $__i_07;
 var $6=HEAP32[(($3)>>2)];
 var $7=HEAP32[(($4)>>2)];
 var $8=($6>>>0)<($7>>>0);
 if($8){label=4;break;}else{label=5;break;}
 case 4: 
 var $10=HEAP32[(($_08)>>2)];
 var $11=(($6+4)|0);
 HEAP32[(($3)>>2)]=$11;
 HEAP32[(($6)>>2)]=$10;
 label=6;break;
 case 5: 
 var $13=HEAP32[(($1)>>2)];
 var $14=(($13+52)|0);
 var $15=HEAP32[(($14)>>2)];
 var $16=HEAP32[(($_08)>>2)];
 var $17=FUNCTION_TABLE[$15]($this,$16);
 var $18=($17|0)==-1;
 if($18){var $__i_0_lcssa=$__i_07;label=8;break;}else{label=6;break;}
 case 6: 
 var $20=((($__i_07)+(1))|0);
 var $21=($20|0)<($__n|0);
 if($21){label=7;break;}else{var $__i_0_lcssa=$20;label=8;break;}
 case 7: 
 var $22=(($_08+4)|0);
 var $__i_07=$20;var $_08=$22;label=3;break;
 case 8: 
 var $__i_0_lcssa;
 return $__i_0_lcssa;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE8overflowEj($this,$0){
 var label=0;


 return -1;
}


function __ZNSt3__113basic_istreamIcNS_11char_traitsIcEEED0Ev($this){
 var label=0;


 var $1=(($this+8)|0);
 __ZNSt3__18ios_baseD2Ev($1);
 var $2=$this;
 __ZdlPv($2);
 return;
}


function __ZNSt3__113basic_istreamIcNS_11char_traitsIcEEED1Ev($this){
 var label=0;


 var $1=(($this+8)|0);
 __ZNSt3__18ios_baseD2Ev($1);
 return;
}


function __ZTv0_n12_NSt3__113basic_istreamIcNS_11char_traitsIcEEED0Ev($this){
 var label=0;


 var $1=$this;
 var $2=$this;
 var $3=HEAP32[(($2)>>2)];
 var $4=((($3)-(12))|0);
 var $5=$4;
 var $6=HEAP32[(($5)>>2)];
 var $7=(($1+$6)|0);
 var $_sum=((($6)+(8))|0);
 var $8=(($1+$_sum)|0);
 var $9=$8;
 __ZNSt3__18ios_baseD2Ev($9);
 __ZdlPv($7);
 return;
}


function __ZTv0_n12_NSt3__113basic_istreamIcNS_11char_traitsIcEEED1Ev($this){
 var label=0;


 var $1=$this;
 var $2=$this;
 var $3=HEAP32[(($2)>>2)];
 var $4=((($3)-(12))|0);
 var $5=$4;
 var $6=HEAP32[(($5)>>2)];
 var $_sum=((($6)+(8))|0);
 var $7=(($1+$_sum)|0);
 var $8=$7;
 __ZNSt3__18ios_baseD2Ev($8);
 return;
}


function __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE5flushEv($this){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+8)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $__s=sp;
 var $1=$this;
 var $2=HEAP32[(($1)>>2)];
 var $3=((($2)-(12))|0);
 var $4=$3;
 var $5=HEAP32[(($4)>>2)];
 var $6=$this;
 var $_sum=((($5)+(24))|0);
 var $7=(($6+$_sum)|0);
 var $8=$7;
 var $9=HEAP32[(($8)>>2)];
 var $10=($9|0)==0;
 if($10){label=15;break;}else{label=2;break;}
 case 2: 
 var $12=(($__s)|0);
 HEAP8[($12)]=0;
 var $13=(($__s+4)|0);
 HEAP32[(($13)>>2)]=$this;
 var $_sum8=((($5)+(16))|0);
 var $14=(($6+$_sum8)|0);
 var $15=$14;
 var $16=HEAP32[(($15)>>2)];
 var $17=($16|0)==0;
 if($17){label=3;break;}else{label=16;break;}
 case 3: 
 var $_sum13=((($5)+(72))|0);
 var $19=(($6+$_sum13)|0);
 var $20=$19;
 var $21=HEAP32[(($20)>>2)];
 var $22=($21|0)==0;
 if($22){var $_pre15=$5;label=6;break;}else{label=4;break;}
 case 4: 
 var $24=(function() { try { __THREW__ = 0; return __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE5flushEv($21) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=5;break; } else { label=9;break; }
 case 5: 
 var $_pre_pre=HEAP32[(($1)>>2)];
 var $_phi_trans_insert_phi_trans_insert=((($_pre_pre)-(12))|0);
 var $_phi_trans_insert14_phi_trans_insert=$_phi_trans_insert_phi_trans_insert;
 var $_pre15_pre=HEAP32[(($_phi_trans_insert14_phi_trans_insert)>>2)];
 var $_pre15=$_pre15_pre;label=6;break;
 case 6: 
 var $_pre15;
 HEAP8[($12)]=1;
 var $_sum9=((($_pre15)+(24))|0);
 var $26=(($6+$_sum9)|0);
 var $27=$26;
 var $28=HEAP32[(($27)>>2)];
 var $29=$28;
 var $30=$28;
 var $31=HEAP32[(($30)>>2)];
 var $32=(($31+24)|0);
 var $33=HEAP32[(($32)>>2)];
 var $34=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$33]($29) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=7;break; } else { label=10;break; }
 case 7: 
 var $35=($34|0)==-1;
 if($35){label=8;break;}else{label=16;break;}
 case 8: 
 var $37=HEAP32[(($1)>>2)];
 var $38=((($37)-(12))|0);
 var $39=$38;
 var $40=HEAP32[(($39)>>2)];
 var $41=(($6+$40)|0);
 var $42=$41;
 var $_sum12=((($40)+(16))|0);
 var $43=(($6+$_sum12)|0);
 var $44=$43;
 var $45=HEAP32[(($44)>>2)];
 var $46=$45|1;
 (function() { try { __THREW__ = 0; return __ZNSt3__18ios_base5clearEj($42,$46) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=16;break; } else { label=10;break; }
 case 9: 
 var $48$0 = ___cxa_find_matching_catch(-1, -1,0); var $48$1 = tempRet0;
 var $49=$48$0;
 var $_0=$49;label=11;break;
 case 10: 
 var $51$0 = ___cxa_find_matching_catch(-1, -1,0); var $51$1 = tempRet0;
 var $52=$51$0;
 __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE6sentryD2Ev($__s);
 var $_0=$52;label=11;break;
 case 11: 
 var $_0;
 var $54=___cxa_begin_catch($_0);
 var $55=HEAP32[(($1)>>2)];
 var $56=((($55)-(12))|0);
 var $57=$56;
 var $58=HEAP32[(($57)>>2)];
 var $_sum10=((($58)+(16))|0);
 var $59=(($6+$_sum10)|0);
 var $60=$59;
 var $61=HEAP32[(($60)>>2)];
 var $62=$61|1;
 HEAP32[(($60)>>2)]=$62;
 var $_sum11=((($58)+(20))|0);
 var $63=(($6+$_sum11)|0);
 var $64=$63;
 var $65=HEAP32[(($64)>>2)];
 var $66=$65&1;
 var $67=($66|0)==0;
 if($67){label=14;break;}else{label=12;break;}
 case 12: 
 (function() { try { __THREW__ = 0; return ___cxa_rethrow() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=13;break; } else { label=17;break; }
 case 13: 
 throw "Reached an unreachable!";
 case 14: 
 ___cxa_end_catch();
 label=15;break;
 case 15: 
 STACKTOP=sp;return $this;
 case 16: 
 __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE6sentryD2Ev($__s);
 label=15;break;
 case 17: 
 var $71$0 = ___cxa_find_matching_catch(-1, -1); var $71$1 = tempRet0;
 (function() { try { __THREW__ = 0; return ___cxa_end_catch() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=18;break; } else { label=19;break; }
 case 18: 
 ___resumeException($71$0)
 case 19: 
 var $74$0 = ___cxa_find_matching_catch(-1, -1,0); var $74$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__18ios_base33__set_badbit_and_consider_rethrowEv($this){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=(($this+16)|0);
 var $2=HEAP32[(($1)>>2)];
 var $3=$2|1;
 HEAP32[(($1)>>2)]=$3;
 var $4=(($this+20)|0);
 var $5=HEAP32[(($4)>>2)];
 var $6=$5&1;
 var $7=($6|0)==0;
 if($7){label=3;break;}else{label=2;break;}
 case 2: 
 ___cxa_rethrow();
 throw "Reached an unreachable!";
 case 3: 
 return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__113basic_istreamIwNS_11char_traitsIwEEED0Ev($this){
 var label=0;


 var $1=(($this+8)|0);
 __ZNSt3__18ios_baseD2Ev($1);
 var $2=$this;
 __ZdlPv($2);
 return;
}


function __ZNSt3__113basic_istreamIwNS_11char_traitsIwEEED1Ev($this){
 var label=0;


 var $1=(($this+8)|0);
 __ZNSt3__18ios_baseD2Ev($1);
 return;
}


function __ZTv0_n12_NSt3__113basic_istreamIwNS_11char_traitsIwEEED0Ev($this){
 var label=0;


 var $1=$this;
 var $2=$this;
 var $3=HEAP32[(($2)>>2)];
 var $4=((($3)-(12))|0);
 var $5=$4;
 var $6=HEAP32[(($5)>>2)];
 var $7=(($1+$6)|0);
 var $_sum=((($6)+(8))|0);
 var $8=(($1+$_sum)|0);
 var $9=$8;
 __ZNSt3__18ios_baseD2Ev($9);
 __ZdlPv($7);
 return;
}


function __ZTv0_n12_NSt3__113basic_istreamIwNS_11char_traitsIwEEED1Ev($this){
 var label=0;


 var $1=$this;
 var $2=$this;
 var $3=HEAP32[(($2)>>2)];
 var $4=((($3)-(12))|0);
 var $5=$4;
 var $6=HEAP32[(($5)>>2)];
 var $_sum=((($6)+(8))|0);
 var $7=(($1+$_sum)|0);
 var $8=$7;
 __ZNSt3__18ios_baseD2Ev($8);
 return;
}


function __ZNSt3__113basic_ostreamIwNS_11char_traitsIwEEE5flushEv($this){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+8)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $__s=sp;
 var $1=$this;
 var $2=HEAP32[(($1)>>2)];
 var $3=((($2)-(12))|0);
 var $4=$3;
 var $5=HEAP32[(($4)>>2)];
 var $6=$this;
 var $_sum=((($5)+(24))|0);
 var $7=(($6+$_sum)|0);
 var $8=$7;
 var $9=HEAP32[(($8)>>2)];
 var $10=($9|0)==0;
 if($10){label=15;break;}else{label=2;break;}
 case 2: 
 var $12=(($__s)|0);
 HEAP8[($12)]=0;
 var $13=(($__s+4)|0);
 HEAP32[(($13)>>2)]=$this;
 var $_sum8=((($5)+(16))|0);
 var $14=(($6+$_sum8)|0);
 var $15=$14;
 var $16=HEAP32[(($15)>>2)];
 var $17=($16|0)==0;
 if($17){label=3;break;}else{label=16;break;}
 case 3: 
 var $_sum13=((($5)+(72))|0);
 var $19=(($6+$_sum13)|0);
 var $20=$19;
 var $21=HEAP32[(($20)>>2)];
 var $22=($21|0)==0;
 if($22){var $_pre15=$5;label=6;break;}else{label=4;break;}
 case 4: 
 var $24=(function() { try { __THREW__ = 0; return __ZNSt3__113basic_ostreamIwNS_11char_traitsIwEEE5flushEv($21) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=5;break; } else { label=9;break; }
 case 5: 
 var $_pre_pre=HEAP32[(($1)>>2)];
 var $_phi_trans_insert_phi_trans_insert=((($_pre_pre)-(12))|0);
 var $_phi_trans_insert14_phi_trans_insert=$_phi_trans_insert_phi_trans_insert;
 var $_pre15_pre=HEAP32[(($_phi_trans_insert14_phi_trans_insert)>>2)];
 var $_pre15=$_pre15_pre;label=6;break;
 case 6: 
 var $_pre15;
 HEAP8[($12)]=1;
 var $_sum9=((($_pre15)+(24))|0);
 var $26=(($6+$_sum9)|0);
 var $27=$26;
 var $28=HEAP32[(($27)>>2)];
 var $29=$28;
 var $30=$28;
 var $31=HEAP32[(($30)>>2)];
 var $32=(($31+24)|0);
 var $33=HEAP32[(($32)>>2)];
 var $34=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$33]($29) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=7;break; } else { label=10;break; }
 case 7: 
 var $35=($34|0)==-1;
 if($35){label=8;break;}else{label=16;break;}
 case 8: 
 var $37=HEAP32[(($1)>>2)];
 var $38=((($37)-(12))|0);
 var $39=$38;
 var $40=HEAP32[(($39)>>2)];
 var $41=(($6+$40)|0);
 var $42=$41;
 var $_sum12=((($40)+(16))|0);
 var $43=(($6+$_sum12)|0);
 var $44=$43;
 var $45=HEAP32[(($44)>>2)];
 var $46=$45|1;
 (function() { try { __THREW__ = 0; return __ZNSt3__18ios_base5clearEj($42,$46) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=16;break; } else { label=10;break; }
 case 9: 
 var $48$0 = ___cxa_find_matching_catch(-1, -1,0); var $48$1 = tempRet0;
 var $49=$48$0;
 var $_0=$49;label=11;break;
 case 10: 
 var $51$0 = ___cxa_find_matching_catch(-1, -1,0); var $51$1 = tempRet0;
 var $52=$51$0;
 __ZNSt3__113basic_ostreamIwNS_11char_traitsIwEEE6sentryD2Ev($__s);
 var $_0=$52;label=11;break;
 case 11: 
 var $_0;
 var $54=___cxa_begin_catch($_0);
 var $55=HEAP32[(($1)>>2)];
 var $56=((($55)-(12))|0);
 var $57=$56;
 var $58=HEAP32[(($57)>>2)];
 var $_sum10=((($58)+(16))|0);
 var $59=(($6+$_sum10)|0);
 var $60=$59;
 var $61=HEAP32[(($60)>>2)];
 var $62=$61|1;
 HEAP32[(($60)>>2)]=$62;
 var $_sum11=((($58)+(20))|0);
 var $63=(($6+$_sum11)|0);
 var $64=$63;
 var $65=HEAP32[(($64)>>2)];
 var $66=$65&1;
 var $67=($66|0)==0;
 if($67){label=14;break;}else{label=12;break;}
 case 12: 
 (function() { try { __THREW__ = 0; return ___cxa_rethrow() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=13;break; } else { label=17;break; }
 case 13: 
 throw "Reached an unreachable!";
 case 14: 
 ___cxa_end_catch();
 label=15;break;
 case 15: 
 STACKTOP=sp;return $this;
 case 16: 
 __ZNSt3__113basic_ostreamIwNS_11char_traitsIwEEE6sentryD2Ev($__s);
 label=15;break;
 case 17: 
 var $71$0 = ___cxa_find_matching_catch(-1, -1); var $71$1 = tempRet0;
 (function() { try { __THREW__ = 0; return ___cxa_end_catch() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=18;break; } else { label=19;break; }
 case 18: 
 ___resumeException($71$0)
 case 19: 
 var $74$0 = ___cxa_find_matching_catch(-1, -1,0); var $74$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEED0Ev($this){
 var label=0;


 var $1=(($this+4)|0);
 __ZNSt3__18ios_baseD2Ev($1);
 var $2=$this;
 __ZdlPv($2);
 return;
}


function __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEED1Ev($this){
 var label=0;


 var $1=(($this+4)|0);
 __ZNSt3__18ios_baseD2Ev($1);
 return;
}


function __ZTv0_n12_NSt3__113basic_ostreamIcNS_11char_traitsIcEEED0Ev($this){
 var label=0;


 var $1=$this;
 var $2=$this;
 var $3=HEAP32[(($2)>>2)];
 var $4=((($3)-(12))|0);
 var $5=$4;
 var $6=HEAP32[(($5)>>2)];
 var $7=(($1+$6)|0);
 var $_sum=((($6)+(4))|0);
 var $8=(($1+$_sum)|0);
 var $9=$8;
 __ZNSt3__18ios_baseD2Ev($9);
 __ZdlPv($7);
 return;
}


function __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEED2Ev($this,$vtt){
 var label=0;


 return;
}


function __ZTv0_n12_NSt3__113basic_ostreamIcNS_11char_traitsIcEEED1Ev($this){
 var label=0;


 var $1=$this;
 var $2=$this;
 var $3=HEAP32[(($2)>>2)];
 var $4=((($3)-(12))|0);
 var $5=$4;
 var $6=HEAP32[(($5)>>2)];
 var $_sum=((($6)+(4))|0);
 var $7=(($1+$_sum)|0);
 var $8=$7;
 __ZNSt3__18ios_baseD2Ev($8);
 return;
}


function __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE6sentryC1ERS3_($this,$__os){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=(($this)|0);
 HEAP8[($1)]=0;
 var $2=(($this+4)|0);
 HEAP32[(($2)>>2)]=$__os;
 var $3=$__os;
 var $4=HEAP32[(($3)>>2)];
 var $5=((($4)-(12))|0);
 var $6=$5;
 var $7=HEAP32[(($6)>>2)];
 var $8=$__os;
 var $_sum=((($7)+(16))|0);
 var $9=(($8+$_sum)|0);
 var $10=$9;
 var $11=HEAP32[(($10)>>2)];
 var $12=($11|0)==0;
 if($12){label=2;break;}else{label=5;break;}
 case 2: 
 var $_sum2=((($7)+(72))|0);
 var $14=(($8+$_sum2)|0);
 var $15=$14;
 var $16=HEAP32[(($15)>>2)];
 var $17=($16|0)==0;
 if($17){label=4;break;}else{label=3;break;}
 case 3: 
 var $19=__ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE5flushEv($16);
 label=4;break;
 case 4: 
 HEAP8[($1)]=1;
 label=5;break;
 case 5: 
 return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE6sentryD1Ev($this){
 var label=0;


 __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE6sentryD2Ev($this);
 return;
}


function __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE6sentryD2Ev($this){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=(($this+4)|0);
 var $2=HEAP32[(($1)>>2)];
 var $3=$2;
 var $4=HEAP32[(($3)>>2)];
 var $5=((($4)-(12))|0);
 var $6=$5;
 var $7=HEAP32[(($6)>>2)];
 var $8=$2;
 var $_sum=((($7)+(24))|0);
 var $9=(($8+$_sum)|0);
 var $10=$9;
 var $11=HEAP32[(($10)>>2)];
 var $12=($11|0)==0;
 if($12){label=9;break;}else{label=2;break;}
 case 2: 
 var $_sum2=((($7)+(16))|0);
 var $14=(($8+$_sum2)|0);
 var $15=$14;
 var $16=HEAP32[(($15)>>2)];
 var $17=($16|0)==0;
 if($17){label=3;break;}else{label=9;break;}
 case 3: 
 var $_sum3=((($7)+(4))|0);
 var $19=(($8+$_sum3)|0);
 var $20=$19;
 var $21=HEAP32[(($20)>>2)];
 var $22=$21&8192;
 var $23=($22|0)==0;
 if($23){label=9;break;}else{label=4;break;}
 case 4: 
 var $25=__ZSt18uncaught_exceptionv();
 if($25){label=9;break;}else{label=5;break;}
 case 5: 
 var $27=HEAP32[(($1)>>2)];
 var $28=$27;
 var $29=HEAP32[(($28)>>2)];
 var $30=((($29)-(12))|0);
 var $31=$30;
 var $32=HEAP32[(($31)>>2)];
 var $33=$27;
 var $_sum4=((($32)+(24))|0);
 var $34=(($33+$_sum4)|0);
 var $35=$34;
 var $36=HEAP32[(($35)>>2)];
 var $37=$36;
 var $38=$36;
 var $39=HEAP32[(($38)>>2)];
 var $40=(($39+24)|0);
 var $41=HEAP32[(($40)>>2)];
 var $42=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$41]($37) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=6;break; } else { label=8;break; }
 case 6: 
 var $43=($42|0)==-1;
 if($43){label=7;break;}else{label=9;break;}
 case 7: 
 var $45=HEAP32[(($1)>>2)];
 var $46=$45;
 var $47=HEAP32[(($46)>>2)];
 var $48=((($47)-(12))|0);
 var $49=$48;
 var $50=HEAP32[(($49)>>2)];
 var $51=$45;
 var $52=(($51+$50)|0);
 var $53=$52;
 var $_sum5=((($50)+(16))|0);
 var $54=(($51+$_sum5)|0);
 var $55=$54;
 var $56=HEAP32[(($55)>>2)];
 var $57=$56|1;
 (function() { try { __THREW__ = 0; return __ZNSt3__18ios_base5clearEj($53,$57) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=9;break; } else { label=8;break; }
 case 8: 
 var $59$0 = ___cxa_find_matching_catch(-1, -1,0); var $59$1 = tempRet0;
 var $60=$59$0;
 var $61=___cxa_begin_catch($60);
 (function() { try { __THREW__ = 0; return ___cxa_end_catch() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=9;break; } else { label=10;break; }
 case 9: 
 return;
 case 10: 
 var $63$0 = ___cxa_find_matching_catch(-1, -1,0); var $63$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEElsEi($this,$__n){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+40)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=sp;
 var $2=(sp)+(8);
 var $__s=(sp)+(16);
 var $3=(sp)+(24);
 var $4=(sp)+(32);
 var $5=(($__s)|0);
 HEAP8[($5)]=0;
 var $6=(($__s+4)|0);
 HEAP32[(($6)>>2)]=$this;
 var $7=$this;
 var $8=HEAP32[(($7)>>2)];
 var $9=((($8)-(12))|0);
 var $10=$9;
 var $11=HEAP32[(($10)>>2)];
 var $12=$this;
 var $_sum_i=((($11)+(16))|0);
 var $13=(($12+$_sum_i)|0);
 var $14=$13;
 var $15=HEAP32[(($14)>>2)];
 var $16=($15|0)==0;
 if($16){label=2;break;}else{label=18;break;}
 case 2: 
 var $_sum2_i=((($11)+(72))|0);
 var $18=(($12+$_sum2_i)|0);
 var $19=$18;
 var $20=HEAP32[(($19)>>2)];
 var $21=($20|0)==0;
 if($21){var $_pre20=$11;label=5;break;}else{label=3;break;}
 case 3: 
 var $23=(function() { try { __THREW__ = 0; return __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE5flushEv($20) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=4;break; } else { label=14;break; }
 case 4: 
 var $_pre_pre=HEAP32[(($7)>>2)];
 var $_phi_trans_insert_phi_trans_insert=((($_pre_pre)-(12))|0);
 var $_phi_trans_insert19_phi_trans_insert=$_phi_trans_insert_phi_trans_insert;
 var $_pre20_pre=HEAP32[(($_phi_trans_insert19_phi_trans_insert)>>2)];
 var $_pre20=$_pre20_pre;label=5;break;
 case 5: 
 var $_pre20;
 HEAP8[($5)]=1;
 var $_sum=((($_pre20)+(28))|0);
 var $25=(($12+$_sum)|0);
 var $26=$25;
 __ZNSt3__16localeC2ERKS0_($3,$26);
 var $27=(function() { try { __THREW__ = 0; return __ZNKSt3__16locale9use_facetERNS0_2idE($3,13744) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=6;break; } else { label=17;break; }
 case 6: 
 var $29=$27;
 __ZNSt3__16localeD2Ev($3);
 var $30=HEAP32[(($7)>>2)];
 var $31=((($30)-(12))|0);
 var $32=$31;
 var $33=HEAP32[(($32)>>2)];
 var $_sum_i_i=((($33)+(24))|0);
 var $34=(($12+$_sum_i_i)|0);
 var $35=$34;
 var $36=HEAP32[(($35)>>2)];
 var $37=$36;
 var $38=(($12+$33)|0);
 var $_sum16=((($33)+(76))|0);
 var $39=(($12+$_sum16)|0);
 var $40=$39;
 var $41=HEAP32[(($40)>>2)];
 var $42=($41|0)==-1;
 var $extract_t1_i=(($41)&255);
 if($42){label=7;break;}else{var $_off0_i=$extract_t1_i;label=11;break;}
 case 7: 
 var $44=$2;
 var $_sum18=((($33)+(28))|0);
 var $45=(($12+$_sum18)|0);
 var $46=$45;
 __ZNSt3__16localeC2ERKS0_($2,$46);
 var $47=(function() { try { __THREW__ = 0; return __ZNKSt3__16locale9use_facetERNS0_2idE($2,14096) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=8;break; } else { label=9;break; }
 case 8: 
 var $49=$47;
 var $50=$47;
 var $51=HEAP32[(($50)>>2)];
 var $52=(($51+28)|0);
 var $53=HEAP32[(($52)>>2)];
 var $54=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$53]($49,32) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=10;break; } else { label=9;break; }
 case 9: 
 var $56$0 = ___cxa_find_matching_catch(-1, -1,0); var $56$1 = tempRet0;
 __ZNSt3__16localeD2Ev($2);
 var $eh_lpad_body$1=$56$1;var $eh_lpad_body$0=$56$0;label=16;break;
 case 10: 
 __ZNSt3__16localeD2Ev($2);
 var $57=(($54<<24)>>24);
 HEAP32[(($40)>>2)]=$57;
 var $_off0_i=$54;label=11;break;
 case 11: 
 var $_off0_i;
 var $58=$38;
 var $59=$1;
 var $60=$27;
 var $61=HEAP32[(($60)>>2)];
 var $62=(($61+16)|0);
 var $63=HEAP32[(($62)>>2)];
 var $64=(($1)|0);
 HEAP32[(($64)>>2)]=$37;
 (function() { try { __THREW__ = 0; return FUNCTION_TABLE[$63]($4,$29,$1,$58,$_off0_i,$__n) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=12;break; } else { label=15;break; }
 case 12: 
 var $66=(($4)|0);
 var $67=HEAP32[(($66)>>2)];
 var $68=($67|0)==0;
 if($68){label=13;break;}else{label=18;break;}
 case 13: 
 var $70=HEAP32[(($7)>>2)];
 var $71=((($70)-(12))|0);
 var $72=$71;
 var $73=HEAP32[(($72)>>2)];
 var $74=(($12+$73)|0);
 var $75=$74;
 var $_sum17=((($73)+(16))|0);
 var $76=(($12+$_sum17)|0);
 var $77=$76;
 var $78=HEAP32[(($77)>>2)];
 var $79=$78|5;
 (function() { try { __THREW__ = 0; return __ZNSt3__18ios_base5clearEj($75,$79) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=18;break; } else { label=15;break; }
 case 14: 
 var $81$0 = ___cxa_find_matching_catch(-1, -1,0); var $81$1 = tempRet0;
 var $82=$81$0;
 var $_1=$82;label=20;break;
 case 15: 
 var $84$0 = ___cxa_find_matching_catch(-1, -1,0); var $84$1 = tempRet0;
 var $eh_lpad_body$1=$84$1;var $eh_lpad_body$0=$84$0;label=16;break;
 case 16: 
 var $eh_lpad_body$0;
 var $eh_lpad_body$1;
 var $85=$eh_lpad_body$0;
 var $_0=$85;label=19;break;
 case 17: 
 var $87$0 = ___cxa_find_matching_catch(-1, -1,0); var $87$1 = tempRet0;
 var $88=$87$0;
 __ZNSt3__16localeD2Ev($3);
 var $_0=$88;label=19;break;
 case 18: 
 __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE6sentryD2Ev($__s);
 label=24;break;
 case 19: 
 var $_0;
 __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE6sentryD2Ev($__s);
 var $_1=$_0;label=20;break;
 case 20: 
 var $_1;
 var $91=___cxa_begin_catch($_1);
 var $92=HEAP32[(($7)>>2)];
 var $93=((($92)-(12))|0);
 var $94=$93;
 var $95=HEAP32[(($94)>>2)];
 var $_sum14=((($95)+(16))|0);
 var $96=(($12+$_sum14)|0);
 var $97=$96;
 var $98=HEAP32[(($97)>>2)];
 var $99=$98|1;
 HEAP32[(($97)>>2)]=$99;
 var $_sum15=((($95)+(20))|0);
 var $100=(($12+$_sum15)|0);
 var $101=$100;
 var $102=HEAP32[(($101)>>2)];
 var $103=$102&1;
 var $104=($103|0)==0;
 if($104){label=23;break;}else{label=21;break;}
 case 21: 
 (function() { try { __THREW__ = 0; return ___cxa_rethrow() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=22;break; } else { label=25;break; }
 case 22: 
 throw "Reached an unreachable!";
 case 23: 
 ___cxa_end_catch();
 label=24;break;
 case 24: 
 STACKTOP=sp;return $this;
 case 25: 
 var $108$0 = ___cxa_find_matching_catch(-1, -1); var $108$1 = tempRet0;
 (function() { try { __THREW__ = 0; return ___cxa_end_catch() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=26;break; } else { label=27;break; }
 case 26: 
 ___resumeException($108$0)
 case 27: 
 var $111$0 = ___cxa_find_matching_catch(-1, -1,0); var $111$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEElsEj($this,$__n){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+40)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=sp;
 var $2=(sp)+(8);
 var $__s=(sp)+(16);
 var $3=(sp)+(24);
 var $4=(sp)+(32);
 var $5=(($__s)|0);
 HEAP8[($5)]=0;
 var $6=(($__s+4)|0);
 HEAP32[(($6)>>2)]=$this;
 var $7=$this;
 var $8=HEAP32[(($7)>>2)];
 var $9=((($8)-(12))|0);
 var $10=$9;
 var $11=HEAP32[(($10)>>2)];
 var $12=$this;
 var $_sum_i=((($11)+(16))|0);
 var $13=(($12+$_sum_i)|0);
 var $14=$13;
 var $15=HEAP32[(($14)>>2)];
 var $16=($15|0)==0;
 if($16){label=2;break;}else{label=18;break;}
 case 2: 
 var $_sum2_i=((($11)+(72))|0);
 var $18=(($12+$_sum2_i)|0);
 var $19=$18;
 var $20=HEAP32[(($19)>>2)];
 var $21=($20|0)==0;
 if($21){var $_pre17=$11;label=5;break;}else{label=3;break;}
 case 3: 
 var $23=(function() { try { __THREW__ = 0; return __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE5flushEv($20) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=4;break; } else { label=14;break; }
 case 4: 
 var $_pre_pre=HEAP32[(($7)>>2)];
 var $_phi_trans_insert_phi_trans_insert=((($_pre_pre)-(12))|0);
 var $_phi_trans_insert16_phi_trans_insert=$_phi_trans_insert_phi_trans_insert;
 var $_pre17_pre=HEAP32[(($_phi_trans_insert16_phi_trans_insert)>>2)];
 var $_pre17=$_pre17_pre;label=5;break;
 case 5: 
 var $_pre17;
 HEAP8[($5)]=1;
 var $_sum=((($_pre17)+(28))|0);
 var $25=(($12+$_sum)|0);
 var $26=$25;
 __ZNSt3__16localeC2ERKS0_($3,$26);
 var $27=(function() { try { __THREW__ = 0; return __ZNKSt3__16locale9use_facetERNS0_2idE($3,13744) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=6;break; } else { label=17;break; }
 case 6: 
 var $29=$27;
 __ZNSt3__16localeD2Ev($3);
 var $30=HEAP32[(($7)>>2)];
 var $31=((($30)-(12))|0);
 var $32=$31;
 var $33=HEAP32[(($32)>>2)];
 var $_sum_i_i=((($33)+(24))|0);
 var $34=(($12+$_sum_i_i)|0);
 var $35=$34;
 var $36=HEAP32[(($35)>>2)];
 var $37=$36;
 var $38=(($12+$33)|0);
 var $_sum13=((($33)+(76))|0);
 var $39=(($12+$_sum13)|0);
 var $40=$39;
 var $41=HEAP32[(($40)>>2)];
 var $42=($41|0)==-1;
 var $extract_t1_i=(($41)&255);
 if($42){label=7;break;}else{var $_off0_i=$extract_t1_i;label=11;break;}
 case 7: 
 var $44=$2;
 var $_sum15=((($33)+(28))|0);
 var $45=(($12+$_sum15)|0);
 var $46=$45;
 __ZNSt3__16localeC2ERKS0_($2,$46);
 var $47=(function() { try { __THREW__ = 0; return __ZNKSt3__16locale9use_facetERNS0_2idE($2,14096) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=8;break; } else { label=9;break; }
 case 8: 
 var $49=$47;
 var $50=$47;
 var $51=HEAP32[(($50)>>2)];
 var $52=(($51+28)|0);
 var $53=HEAP32[(($52)>>2)];
 var $54=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$53]($49,32) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=10;break; } else { label=9;break; }
 case 9: 
 var $56$0 = ___cxa_find_matching_catch(-1, -1,0); var $56$1 = tempRet0;
 __ZNSt3__16localeD2Ev($2);
 var $eh_lpad_body$1=$56$1;var $eh_lpad_body$0=$56$0;label=16;break;
 case 10: 
 __ZNSt3__16localeD2Ev($2);
 var $57=(($54<<24)>>24);
 HEAP32[(($40)>>2)]=$57;
 var $_off0_i=$54;label=11;break;
 case 11: 
 var $_off0_i;
 var $58=$38;
 var $59=$1;
 var $60=$27;
 var $61=HEAP32[(($60)>>2)];
 var $62=(($61+24)|0);
 var $63=HEAP32[(($62)>>2)];
 var $64=(($1)|0);
 HEAP32[(($64)>>2)]=$37;
 (function() { try { __THREW__ = 0; return FUNCTION_TABLE[$63]($4,$29,$1,$58,$_off0_i,$__n) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=12;break; } else { label=15;break; }
 case 12: 
 var $66=(($4)|0);
 var $67=HEAP32[(($66)>>2)];
 var $68=($67|0)==0;
 if($68){label=13;break;}else{label=18;break;}
 case 13: 
 var $70=HEAP32[(($7)>>2)];
 var $71=((($70)-(12))|0);
 var $72=$71;
 var $73=HEAP32[(($72)>>2)];
 var $74=(($12+$73)|0);
 var $75=$74;
 var $_sum14=((($73)+(16))|0);
 var $76=(($12+$_sum14)|0);
 var $77=$76;
 var $78=HEAP32[(($77)>>2)];
 var $79=$78|5;
 (function() { try { __THREW__ = 0; return __ZNSt3__18ios_base5clearEj($75,$79) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=18;break; } else { label=15;break; }
 case 14: 
 var $81$0 = ___cxa_find_matching_catch(-1, -1,0); var $81$1 = tempRet0;
 var $82=$81$0;
 var $_1=$82;label=20;break;
 case 15: 
 var $84$0 = ___cxa_find_matching_catch(-1, -1,0); var $84$1 = tempRet0;
 var $eh_lpad_body$1=$84$1;var $eh_lpad_body$0=$84$0;label=16;break;
 case 16: 
 var $eh_lpad_body$0;
 var $eh_lpad_body$1;
 var $85=$eh_lpad_body$0;
 var $_0=$85;label=19;break;
 case 17: 
 var $87$0 = ___cxa_find_matching_catch(-1, -1,0); var $87$1 = tempRet0;
 var $88=$87$0;
 __ZNSt3__16localeD2Ev($3);
 var $_0=$88;label=19;break;
 case 18: 
 __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE6sentryD2Ev($__s);
 label=24;break;
 case 19: 
 var $_0;
 __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE6sentryD2Ev($__s);
 var $_1=$_0;label=20;break;
 case 20: 
 var $_1;
 var $91=___cxa_begin_catch($_1);
 var $92=HEAP32[(($7)>>2)];
 var $93=((($92)-(12))|0);
 var $94=$93;
 var $95=HEAP32[(($94)>>2)];
 var $_sum11=((($95)+(16))|0);
 var $96=(($12+$_sum11)|0);
 var $97=$96;
 var $98=HEAP32[(($97)>>2)];
 var $99=$98|1;
 HEAP32[(($97)>>2)]=$99;
 var $_sum12=((($95)+(20))|0);
 var $100=(($12+$_sum12)|0);
 var $101=$100;
 var $102=HEAP32[(($101)>>2)];
 var $103=$102&1;
 var $104=($103|0)==0;
 if($104){label=23;break;}else{label=21;break;}
 case 21: 
 (function() { try { __THREW__ = 0; return ___cxa_rethrow() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=22;break; } else { label=25;break; }
 case 22: 
 throw "Reached an unreachable!";
 case 23: 
 ___cxa_end_catch();
 label=24;break;
 case 24: 
 STACKTOP=sp;return $this;
 case 25: 
 var $108$0 = ___cxa_find_matching_catch(-1, -1); var $108$1 = tempRet0;
 (function() { try { __THREW__ = 0; return ___cxa_end_catch() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=26;break; } else { label=27;break; }
 case 26: 
 ___resumeException($108$0)
 case 27: 
 var $111$0 = ___cxa_find_matching_catch(-1, -1,0); var $111$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE3putEc($this,$__c){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+8)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $__s=sp;
 var $1=(($__s)|0);
 HEAP8[($1)]=0;
 var $2=(($__s+4)|0);
 HEAP32[(($2)>>2)]=$this;
 var $3=$this;
 var $4=HEAP32[(($3)>>2)];
 var $5=((($4)-(12))|0);
 var $6=$5;
 var $7=HEAP32[(($6)>>2)];
 var $8=$this;
 var $_sum_i=((($7)+(16))|0);
 var $9=(($8+$_sum_i)|0);
 var $10=$9;
 var $11=HEAP32[(($10)>>2)];
 var $12=($11|0)==0;
 if($12){label=2;break;}else{label=19;break;}
 case 2: 
 var $_sum2_i=((($7)+(72))|0);
 var $14=(($8+$_sum2_i)|0);
 var $15=$14;
 var $16=HEAP32[(($15)>>2)];
 var $17=($16|0)==0;
 if($17){var $_pre=$4;var $_pre12=$7;label=5;break;}else{label=3;break;}
 case 3: 
 var $19=(function() { try { __THREW__ = 0; return __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE5flushEv($16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=4;break; } else { label=12;break; }
 case 4: 
 var $_pre_pre=HEAP32[(($3)>>2)];
 var $_phi_trans_insert_phi_trans_insert=((($_pre_pre)-(12))|0);
 var $_phi_trans_insert11_phi_trans_insert=$_phi_trans_insert_phi_trans_insert;
 var $_pre12_pre=HEAP32[(($_phi_trans_insert11_phi_trans_insert)>>2)];
 var $_pre=$_pre_pre;var $_pre12=$_pre12_pre;label=5;break;
 case 5: 
 var $_pre12;
 var $_pre;
 HEAP8[($1)]=1;
 var $_sum_i_i=((($_pre12)+(24))|0);
 var $21=(($8+$_sum_i_i)|0);
 var $22=$21;
 var $23=HEAP32[(($22)>>2)];
 var $24=$23;
 var $25=($23|0)==0;
 if($25){var $42=$_pre;label=11;break;}else{label=6;break;}
 case 6: 
 var $27=(($23+24)|0);
 var $28=$27;
 var $29=HEAP32[(($28)>>2)];
 var $30=(($23+28)|0);
 var $31=$30;
 var $32=HEAP32[(($31)>>2)];
 var $33=($29|0)==($32|0);
 if($33){label=8;break;}else{label=7;break;}
 case 7: 
 var $34=(($29+1)|0);
 HEAP32[(($28)>>2)]=$34;
 HEAP8[($29)]=$__c;
 label=19;break;
 case 8: 
 var $35=$23;
 var $36=HEAP32[(($35)>>2)];
 var $37=(($36+52)|0);
 var $38=HEAP32[(($37)>>2)];
 var $39=($__c&255);
 var $40=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$38]($24,$39) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=9;break; } else { label=13;break; }
 case 9: 
 var $41=($40|0)==-1;
 if($41){label=10;break;}else{label=19;break;}
 case 10: 
 var $_pre13=HEAP32[(($3)>>2)];
 var $42=$_pre13;label=11;break;
 case 11: 
 var $42;
 var $43=((($42)-(12))|0);
 var $44=$43;
 var $45=HEAP32[(($44)>>2)];
 var $46=(($8+$45)|0);
 var $47=$46;
 var $_sum=((($45)+(16))|0);
 var $48=(($8+$_sum)|0);
 var $49=$48;
 var $50=HEAP32[(($49)>>2)];
 var $51=$50|1;
 (function() { try { __THREW__ = 0; return __ZNSt3__18ios_base5clearEj($47,$51) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=19;break; } else { label=13;break; }
 case 12: 
 var $53$0 = ___cxa_find_matching_catch(-1, -1,0); var $53$1 = tempRet0;
 var $54=$53$0;
 var $_0=$54;label=14;break;
 case 13: 
 var $56$0 = ___cxa_find_matching_catch(-1, -1,0); var $56$1 = tempRet0;
 var $57=$56$0;
 __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE6sentryD2Ev($__s);
 var $_0=$57;label=14;break;
 case 14: 
 var $_0;
 var $59=___cxa_begin_catch($_0);
 var $60=HEAP32[(($3)>>2)];
 var $61=((($60)-(12))|0);
 var $62=$61;
 var $63=HEAP32[(($62)>>2)];
 var $_sum9=((($63)+(16))|0);
 var $64=(($8+$_sum9)|0);
 var $65=$64;
 var $66=HEAP32[(($65)>>2)];
 var $67=$66|1;
 HEAP32[(($65)>>2)]=$67;
 var $_sum10=((($63)+(20))|0);
 var $68=(($8+$_sum10)|0);
 var $69=$68;
 var $70=HEAP32[(($69)>>2)];
 var $71=$70&1;
 var $72=($71|0)==0;
 if($72){label=17;break;}else{label=15;break;}
 case 15: 
 (function() { try { __THREW__ = 0; return ___cxa_rethrow() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=16;break; } else { label=20;break; }
 case 16: 
 throw "Reached an unreachable!";
 case 17: 
 ___cxa_end_catch();
 label=18;break;
 case 18: 
 STACKTOP=sp;return $this;
 case 19: 
 __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE6sentryD2Ev($__s);
 label=18;break;
 case 20: 
 var $76$0 = ___cxa_find_matching_catch(-1, -1); var $76$1 = tempRet0;
 (function() { try { __THREW__ = 0; return ___cxa_end_catch() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=21;break; } else { label=22;break; }
 case 21: 
 ___resumeException($76$0)
 case 22: 
 var $79$0 = ___cxa_find_matching_catch(-1, -1,0); var $79$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__113basic_ostreamIwNS_11char_traitsIwEEED0Ev($this){
 var label=0;


 var $1=(($this+4)|0);
 __ZNSt3__18ios_baseD2Ev($1);
 var $2=$this;
 __ZdlPv($2);
 return;
}


function __ZNSt3__113basic_ostreamIwNS_11char_traitsIwEEED1Ev($this){
 var label=0;


 var $1=(($this+4)|0);
 __ZNSt3__18ios_baseD2Ev($1);
 return;
}


function __ZTv0_n12_NSt3__113basic_ostreamIwNS_11char_traitsIwEEED0Ev($this){
 var label=0;


 var $1=$this;
 var $2=$this;
 var $3=HEAP32[(($2)>>2)];
 var $4=((($3)-(12))|0);
 var $5=$4;
 var $6=HEAP32[(($5)>>2)];
 var $7=(($1+$6)|0);
 var $_sum=((($6)+(4))|0);
 var $8=(($1+$_sum)|0);
 var $9=$8;
 __ZNSt3__18ios_baseD2Ev($9);
 __ZdlPv($7);
 return;
}


function __ZTv0_n12_NSt3__113basic_ostreamIwNS_11char_traitsIwEEED1Ev($this){
 var label=0;


 var $1=$this;
 var $2=$this;
 var $3=HEAP32[(($2)>>2)];
 var $4=((($3)-(12))|0);
 var $5=$4;
 var $6=HEAP32[(($5)>>2)];
 var $_sum=((($6)+(4))|0);
 var $7=(($1+$_sum)|0);
 var $8=$7;
 __ZNSt3__18ios_baseD2Ev($8);
 return;
}


function __ZNSt3__113basic_ostreamIwNS_11char_traitsIwEEE6sentryD2Ev($this){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=(($this+4)|0);
 var $2=HEAP32[(($1)>>2)];
 var $3=$2;
 var $4=HEAP32[(($3)>>2)];
 var $5=((($4)-(12))|0);
 var $6=$5;
 var $7=HEAP32[(($6)>>2)];
 var $8=$2;
 var $_sum=((($7)+(24))|0);
 var $9=(($8+$_sum)|0);
 var $10=$9;
 var $11=HEAP32[(($10)>>2)];
 var $12=($11|0)==0;
 if($12){label=9;break;}else{label=2;break;}
 case 2: 
 var $_sum2=((($7)+(16))|0);
 var $14=(($8+$_sum2)|0);
 var $15=$14;
 var $16=HEAP32[(($15)>>2)];
 var $17=($16|0)==0;
 if($17){label=3;break;}else{label=9;break;}
 case 3: 
 var $_sum3=((($7)+(4))|0);
 var $19=(($8+$_sum3)|0);
 var $20=$19;
 var $21=HEAP32[(($20)>>2)];
 var $22=$21&8192;
 var $23=($22|0)==0;
 if($23){label=9;break;}else{label=4;break;}
 case 4: 
 var $25=__ZSt18uncaught_exceptionv();
 if($25){label=9;break;}else{label=5;break;}
 case 5: 
 var $27=HEAP32[(($1)>>2)];
 var $28=$27;
 var $29=HEAP32[(($28)>>2)];
 var $30=((($29)-(12))|0);
 var $31=$30;
 var $32=HEAP32[(($31)>>2)];
 var $33=$27;
 var $_sum4=((($32)+(24))|0);
 var $34=(($33+$_sum4)|0);
 var $35=$34;
 var $36=HEAP32[(($35)>>2)];
 var $37=$36;
 var $38=$36;
 var $39=HEAP32[(($38)>>2)];
 var $40=(($39+24)|0);
 var $41=HEAP32[(($40)>>2)];
 var $42=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$41]($37) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=6;break; } else { label=8;break; }
 case 6: 
 var $43=($42|0)==-1;
 if($43){label=7;break;}else{label=9;break;}
 case 7: 
 var $45=HEAP32[(($1)>>2)];
 var $46=$45;
 var $47=HEAP32[(($46)>>2)];
 var $48=((($47)-(12))|0);
 var $49=$48;
 var $50=HEAP32[(($49)>>2)];
 var $51=$45;
 var $52=(($51+$50)|0);
 var $53=$52;
 var $_sum5=((($50)+(16))|0);
 var $54=(($51+$_sum5)|0);
 var $55=$54;
 var $56=HEAP32[(($55)>>2)];
 var $57=$56|1;
 (function() { try { __THREW__ = 0; return __ZNSt3__18ios_base5clearEj($53,$57) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=9;break; } else { label=8;break; }
 case 8: 
 var $59$0 = ___cxa_find_matching_catch(-1, -1,0); var $59$1 = tempRet0;
 var $60=$59$0;
 var $61=___cxa_begin_catch($60);
 (function() { try { __THREW__ = 0; return ___cxa_end_catch() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=9;break; } else { label=10;break; }
 case 9: 
 return;
 case 10: 
 var $63$0 = ___cxa_find_matching_catch(-1, -1,0); var $63$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__119__iostream_category4nameEv($this){
 var label=0;


 return 1472;
}


function __ZNKSt3__119__iostream_category7messageEi($agg_result,$this,$ev){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=($ev|0)==1;
 if($1){label=3;break;}else{label=2;break;}
 case 2: 
 var $3=(($this)|0);
 __ZNKSt3__112__do_message7messageEi($agg_result,$3,$ev);
 label=4;break;
 case 3: 
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj($agg_result,1760,35);
 label=4;break;
 case 4: 
 return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__119__iostream_categoryD1Ev($this){
 var label=0;


 var $1=(($this)|0);
 __ZNSt3__114error_categoryD2Ev($1);
 return;
}


function __ZNSt3__18ios_base7failureD0Ev($this){
 var label=0;


 var $1=(($this)|0);
 __ZNSt3__112system_errorD2Ev($1);
 var $2=$this;
 __ZdlPv($2);
 return;
}


function __ZNSt3__18ios_base7failureD2Ev($this){
 var label=0;


 var $1=(($this)|0);
 __ZNSt3__112system_errorD2Ev($1);
 return;
}


function __ZNSt3__18ios_baseD0Ev($this){
 var label=0;


 __ZNSt3__18ios_baseD2Ev($this);
 var $1=$this;
 __ZdlPv($1);
 return;
}


function __ZNSt3__119__iostream_categoryD0Ev($this){
 var label=0;


 var $1=(($this)|0);
 __ZNSt3__114error_categoryD2Ev($1);
 var $2=$this;
 __ZdlPv($2);
 return;
}


function __ZNSt3__17collateIcED0Ev($this){
 var label=0;


 var $1=(($this)|0);
 __ZNSt3__114__shared_countD2Ev($1);
 var $2=$this;
 __ZdlPv($2);
 return;
}


function __ZNSt3__17collateIcED1Ev($this){
 var label=0;


 var $1=(($this)|0);
 __ZNSt3__114__shared_countD2Ev($1);
 return;
}


function __ZNSt3__16locale5facetD2Ev($this){
 var label=0;


 var $1=(($this)|0);
 __ZNSt3__114__shared_countD2Ev($1);
 return;
}


function __ZNKSt3__17collateIcE10do_compareEPKcS3_S3_S3_($this,$__lo1,$__hi1,$__lo2,$__hi2){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=($__lo2|0)==($__hi2|0);
 if($1){var $_013_lcssa=$__lo1;label=6;break;}else{var $_01315=$__lo1;var $_01216=$__lo2;label=2;break;}
 case 2: 
 var $_01216;
 var $_01315;
 var $2=($_01315|0)==($__hi1|0);
 if($2){var $_0=-1;label=7;break;}else{label=3;break;}
 case 3: 
 var $4=HEAP8[($_01315)];
 var $5=HEAP8[($_01216)];
 var $6=(($4<<24)>>24)<(($5<<24)>>24);
 if($6){var $_0=-1;label=7;break;}else{label=4;break;}
 case 4: 
 var $8=(($5<<24)>>24)<(($4<<24)>>24);
 if($8){var $_0=1;label=7;break;}else{label=5;break;}
 case 5: 
 var $10=(($_01315+1)|0);
 var $11=(($_01216+1)|0);
 var $12=($11|0)==($__hi2|0);
 if($12){var $_013_lcssa=$10;label=6;break;}else{var $_01315=$10;var $_01216=$11;label=2;break;}
 case 6: 
 var $_013_lcssa;
 var $13=($_013_lcssa|0)!=($__hi1|0);
 var $14=($13&1);
 var $_0=$14;label=7;break;
 case 7: 
 var $_0;
 return $_0;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__17collateIcE12do_transformEPKcS3_($agg_result,$this,$__lo,$__hi){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=$__lo;
 var $2=$__hi;
 var $3=((($2)-($1))|0);
 var $4=($3>>>0)>4294967279;
 if($4){label=2;break;}else{label=3;break;}
 case 2: 
 var $6=$agg_result;
 __ZNKSt3__121__basic_string_commonILb1EE20__throw_length_errorEv($6);
 label=3;break;
 case 3: 
 var $8=($3>>>0)<11;
 if($8){label=4;break;}else{label=5;break;}
 case 4: 
 var $10=$3<<1;
 var $11=(($10)&255);
 var $12=$agg_result;
 HEAP8[($12)]=$11;
 var $13=$agg_result;
 var $14=(($13+1)|0);
 var $__p_0_ph_i_i_i=$14;label=6;break;
 case 5: 
 var $15=((($3)+(16))|0);
 var $16=$15&-16;
 var $17=__Znwj($16);
 var $18=(($agg_result+8)|0);
 HEAP32[(($18)>>2)]=$17;
 var $19=$16|1;
 var $20=(($agg_result)|0);
 HEAP32[(($20)>>2)]=$19;
 var $21=(($agg_result+4)|0);
 HEAP32[(($21)>>2)]=$3;
 var $__p_0_ph_i_i_i=$17;label=6;break;
 case 6: 
 var $__p_0_ph_i_i_i;
 var $22=($__lo|0)==($__hi|0);
 if($22){var $__p_0_lcssa_i_i_i=$__p_0_ph_i_i_i;label=9;break;}else{var $__p_013_i_i_i=$__p_0_ph_i_i_i;var $_014_i_i_i=$__lo;label=7;break;}
 case 7: 
 var $_014_i_i_i;
 var $__p_013_i_i_i;
 var $23=HEAP8[($_014_i_i_i)];
 HEAP8[($__p_013_i_i_i)]=$23;
 var $24=(($_014_i_i_i+1)|0);
 var $25=(($__p_013_i_i_i+1)|0);
 var $26=($24|0)==($__hi|0);
 if($26){label=8;break;}else{var $__p_013_i_i_i=$25;var $_014_i_i_i=$24;label=7;break;}
 case 8: 
 var $27=(((-$1))|0);
 var $scevgep_i_i_i=(($__hi+$27)|0);
 var $scevgep15_i_i_i=$scevgep_i_i_i;
 var $scevgep16_i_i_i=(($__p_0_ph_i_i_i+$scevgep15_i_i_i)|0);
 var $__p_0_lcssa_i_i_i=$scevgep16_i_i_i;label=9;break;
 case 9: 
 var $__p_0_lcssa_i_i_i;
 HEAP8[($__p_0_lcssa_i_i_i)]=0;
 return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__17collateIcE7do_hashEPKcS3_($this,$__lo,$__hi){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=($__lo|0)==($__hi|0);
 if($1){var $__h_0_lcssa=0;label=3;break;}else{var $__p_08=$__lo;var $__h_09=0;label=2;break;}
 case 2: 
 var $__h_09;
 var $__p_08;
 var $2=$__h_09<<4;
 var $3=HEAP8[($__p_08)];
 var $4=(($3<<24)>>24);
 var $5=((($4)+($2))|0);
 var $6=$5&-268435456;
 var $7=$6>>>24;
 var $8=$7|$6;
 var $9=$8^$5;
 var $10=(($__p_08+1)|0);
 var $11=($10|0)==($__hi|0);
 if($11){var $__h_0_lcssa=$9;label=3;break;}else{var $__p_08=$10;var $__h_09=$9;label=2;break;}
 case 3: 
 var $__h_0_lcssa;
 return $__h_0_lcssa;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__17collateIwED0Ev($this){
 var label=0;


 var $1=(($this)|0);
 __ZNSt3__114__shared_countD2Ev($1);
 var $2=$this;
 __ZdlPv($2);
 return;
}


function __ZNSt3__17collateIwED1Ev($this){
 var label=0;


 var $1=(($this)|0);
 __ZNSt3__114__shared_countD2Ev($1);
 return;
}


function __ZNKSt3__17collateIwE10do_compareEPKwS3_S3_S3_($this,$__lo1,$__hi1,$__lo2,$__hi2){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=($__lo2|0)==($__hi2|0);
 if($1){var $_013_lcssa=$__lo1;label=6;break;}else{var $_01315=$__lo1;var $_01216=$__lo2;label=2;break;}
 case 2: 
 var $_01216;
 var $_01315;
 var $2=($_01315|0)==($__hi1|0);
 if($2){var $_0=-1;label=7;break;}else{label=3;break;}
 case 3: 
 var $4=HEAP32[(($_01315)>>2)];
 var $5=HEAP32[(($_01216)>>2)];
 var $6=($4|0)<($5|0);
 if($6){var $_0=-1;label=7;break;}else{label=4;break;}
 case 4: 
 var $8=($5|0)<($4|0);
 if($8){var $_0=1;label=7;break;}else{label=5;break;}
 case 5: 
 var $10=(($_01315+4)|0);
 var $11=(($_01216+4)|0);
 var $12=($11|0)==($__hi2|0);
 if($12){var $_013_lcssa=$10;label=6;break;}else{var $_01315=$10;var $_01216=$11;label=2;break;}
 case 6: 
 var $_013_lcssa;
 var $13=($_013_lcssa|0)!=($__hi1|0);
 var $14=($13&1);
 var $_0=$14;label=7;break;
 case 7: 
 var $_0;
 return $_0;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__17collateIwE12do_transformEPKwS3_($agg_result,$this,$__lo,$__hi){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=$__lo;
 var $2=$__hi;
 var $3=((($2)-($1))|0);
 var $4=$3>>2;
 var $5=($4>>>0)>1073741807;
 if($5){label=2;break;}else{label=3;break;}
 case 2: 
 var $7=$agg_result;
 __ZNKSt3__121__basic_string_commonILb1EE20__throw_length_errorEv($7);
 label=3;break;
 case 3: 
 var $9=($4>>>0)<2;
 if($9){label=4;break;}else{label=5;break;}
 case 4: 
 var $11=$3>>>1;
 var $12=(($11)&255);
 var $13=$agg_result;
 HEAP8[($13)]=$12;
 var $14=(($agg_result+4)|0);
 var $__p_0_ph_i_i_i=$14;label=6;break;
 case 5: 
 var $15=((($4)+(4))|0);
 var $16=$15&-4;
 var $17=$16<<2;
 var $18=__Znwj($17);
 var $19=$18;
 var $20=(($agg_result+8)|0);
 HEAP32[(($20)>>2)]=$19;
 var $21=$16|1;
 var $22=(($agg_result)|0);
 HEAP32[(($22)>>2)]=$21;
 var $23=(($agg_result+4)|0);
 HEAP32[(($23)>>2)]=$4;
 var $__p_0_ph_i_i_i=$19;label=6;break;
 case 6: 
 var $__p_0_ph_i_i_i;
 var $24=($__lo|0)==($__hi|0);
 if($24){var $__p_0_lcssa_i_i_i=$__p_0_ph_i_i_i;label=10;break;}else{label=7;break;}
 case 7: 
 var $scevgep_i_i_i=((($__hi)-(4))|0);
 var $scevgep15_i_i_i=$scevgep_i_i_i;
 var $25=(((-$1))|0);
 var $uglygep_i_i_i=(($scevgep15_i_i_i+$25)|0);
 var $__p_013_i_i_i=$__p_0_ph_i_i_i;var $_014_i_i_i=$__lo;label=8;break;
 case 8: 
 var $_014_i_i_i;
 var $__p_013_i_i_i;
 var $27=HEAP32[(($_014_i_i_i)>>2)];
 HEAP32[(($__p_013_i_i_i)>>2)]=$27;
 var $28=(($_014_i_i_i+4)|0);
 var $29=(($__p_013_i_i_i+4)|0);
 var $30=($28|0)==($__hi|0);
 if($30){label=9;break;}else{var $__p_013_i_i_i=$29;var $_014_i_i_i=$28;label=8;break;}
 case 9: 
 var $uglygep16_i_i_i=$uglygep_i_i_i;
 var $31=$uglygep16_i_i_i>>>2;
 var $32=((($31)+(1))|0);
 var $scevgep17_i_i_i=(($__p_0_ph_i_i_i+($32<<2))|0);
 var $__p_0_lcssa_i_i_i=$scevgep17_i_i_i;label=10;break;
 case 10: 
 var $__p_0_lcssa_i_i_i;
 HEAP32[(($__p_0_lcssa_i_i_i)>>2)]=0;
 return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__17collateIwE7do_hashEPKwS3_($this,$__lo,$__hi){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=($__lo|0)==($__hi|0);
 if($1){var $__h_0_lcssa=0;label=3;break;}else{var $__p_08=$__lo;var $__h_09=0;label=2;break;}
 case 2: 
 var $__h_09;
 var $__p_08;
 var $2=$__h_09<<4;
 var $3=HEAP32[(($__p_08)>>2)];
 var $4=((($3)+($2))|0);
 var $5=$4&-268435456;
 var $6=$5>>>24;
 var $7=$6|$5;
 var $8=$7^$4;
 var $9=(($__p_08+4)|0);
 var $10=($9|0)==($__hi|0);
 if($10){var $__h_0_lcssa=$8;label=3;break;}else{var $__p_08=$9;var $__h_09=$8;label=2;break;}
 case 3: 
 var $__h_0_lcssa;
 return $__h_0_lcssa;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEED0Ev($this){
 var label=0;


 var $1=(($this)|0);
 __ZNSt3__114__shared_countD2Ev($1);
 var $2=$this;
 __ZdlPv($2);
 return;
}


function __ZNSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEED1Ev($this){
 var label=0;


 var $1=(($this)|0);
 __ZNSt3__114__shared_countD2Ev($1);
 return;
}


function __ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRb($agg_result,$this,$__b,$__e,$__iob,$__err,$__v){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+112)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var tempParam = $__b; $__b=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__b)>>2)]=HEAP32[((tempParam)>>2)];
 var tempParam = $__e; $__e=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $__p_i_i_i_i19=sp;
 var $__p_i_i_i_i=(sp)+(16);
 var $__lv=(sp)+(32);
 var $1=(sp)+(40);
 var $2=(sp)+(48);
 var $3=(sp)+(56);
 var $4=(sp)+(64);
 var $5=(sp)+(72);
 var $__names=(sp)+(80);
 var $6=(sp)+(104);
 var $7=(($__iob+4)|0);
 var $8=HEAP32[(($7)>>2)];
 var $9=$8&1;
 var $10=($9|0)==0;
 if($10){label=2;break;}else{label=7;break;}
 case 2: 
 HEAP32[(($__lv)>>2)]=-1;
 var $12=$this;
 var $13=HEAP32[(($12)>>2)];
 var $14=(($13+16)|0);
 var $15=HEAP32[(($14)>>2)];
 var $16=(($__b)|0);
 var $17=HEAP32[(($16)>>2)];
 var $18=(($2)|0);
 HEAP32[(($18)>>2)]=$17;
 var $19=(($__e)|0);
 var $20=HEAP32[(($19)>>2)];
 var $21=(($3)|0);
 HEAP32[(($21)>>2)]=$20;
 FUNCTION_TABLE[$15]($1,$this,$2,$3,$__iob,$__err,$__lv);
 var $22=(($1)|0);
 var $23=HEAP32[(($22)>>2)];
 HEAP32[(($16)>>2)]=$23;
 var $24=HEAP32[(($__lv)>>2)];
 if(($24|0)==0){ label=3;break;}else if(($24|0)==1){ label=4;break;}else{label=5;break;}
 case 3: 
 HEAP8[($__v)]=0;
 label=6;break;
 case 4: 
 HEAP8[($__v)]=1;
 label=6;break;
 case 5: 
 HEAP8[($__v)]=1;
 HEAP32[(($__err)>>2)]=4;
 label=6;break;
 case 6: 
 var $29=(($agg_result)|0);
 HEAP32[(($29)>>2)]=$23;
 label=28;break;
 case 7: 
 __ZNKSt3__18ios_base6getlocEv($4,$__iob);
 var $31=(($4)|0);
 var $32=HEAP32[(($31)>>2)];
 var $33=$__p_i_i_i_i;
 var $34=HEAP32[((14096)>>2)];
 var $35=($34|0)==-1;
 if($35){label=9;break;}else{label=8;break;}
 case 8: 
 var $_sroa_01_0___p67_i_idx_i_i_i=(($__p_i_i_i_i)|0);
 HEAP32[(($_sroa_01_0___p67_i_idx_i_i_i)>>2)]=14096;
 var $_sroa_12_4___p67_i_idx3_i_i_i=(($__p_i_i_i_i+4)|0);
 HEAP32[(($_sroa_12_4___p67_i_idx3_i_i_i)>>2)]=(28);
 var $_sroa_2_8___p67_i_idx4_i_i_i=(($__p_i_i_i_i+8)|0);
 HEAP32[(($_sroa_2_8___p67_i_idx4_i_i_i)>>2)]=0;
 (function() { try { __THREW__ = 0; return __ZNSt3__111__call_onceERVmPvPFvS2_E(14096,$33,260) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=9;break; } else { label=23;break; }
 case 9: 
 var $37=HEAP32[((14100)>>2)];
 var $38=((($37)-(1))|0);
 var $39=(($32+12)|0);
 var $40=HEAP32[(($39)>>2)];
 var $41=(($32+8)|0);
 var $42=HEAP32[(($41)>>2)];
 var $43=$40;
 var $44=$42;
 var $45=((($43)-($44))|0);
 var $46=$45>>2;
 var $47=($46>>>0)>($38>>>0);
 if($47){label=10;break;}else{label=11;break;}
 case 10: 
 var $48=(($42+($38<<2))|0);
 var $49=HEAP32[(($48)>>2)];
 var $50=($49|0)==0;
 if($50){label=11;break;}else{label=13;break;}
 case 11: 
 var $51=___cxa_allocate_exception(4);
 var $52=$51;
 __ZNSt8bad_castC2Ev($52);
 (function() { try { __THREW__ = 0; return ___cxa_throw($51,8960,(368)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=12;break; } else { label=23;break; }
 case 12: 
 throw "Reached an unreachable!";
 case 13: 
 var $54=$49;
 var $55=HEAP32[(($31)>>2)];
 var $56=(($55)|0);
 var $57=__ZNSt3__114__shared_count16__release_sharedEv($56);
 __ZNKSt3__18ios_base6getlocEv($5,$__iob);
 var $58=(($5)|0);
 var $59=HEAP32[(($58)>>2)];
 var $60=$__p_i_i_i_i19;
 var $61=HEAP32[((13712)>>2)];
 var $62=($61|0)==-1;
 if($62){label=15;break;}else{label=14;break;}
 case 14: 
 var $_sroa_01_0___p67_i_idx_i_i_i20=(($__p_i_i_i_i19)|0);
 HEAP32[(($_sroa_01_0___p67_i_idx_i_i_i20)>>2)]=13712;
 var $_sroa_12_4___p67_i_idx3_i_i_i21=(($__p_i_i_i_i19+4)|0);
 HEAP32[(($_sroa_12_4___p67_i_idx3_i_i_i21)>>2)]=(28);
 var $_sroa_2_8___p67_i_idx4_i_i_i22=(($__p_i_i_i_i19+8)|0);
 HEAP32[(($_sroa_2_8___p67_i_idx4_i_i_i22)>>2)]=0;
 (function() { try { __THREW__ = 0; return __ZNSt3__111__call_onceERVmPvPFvS2_E(13712,$60,260) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=15;break; } else { label=24;break; }
 case 15: 
 var $64=HEAP32[((13716)>>2)];
 var $65=((($64)-(1))|0);
 var $66=(($59+12)|0);
 var $67=HEAP32[(($66)>>2)];
 var $68=(($59+8)|0);
 var $69=HEAP32[(($68)>>2)];
 var $70=$67;
 var $71=$69;
 var $72=((($70)-($71))|0);
 var $73=$72>>2;
 var $74=($73>>>0)>($65>>>0);
 if($74){label=16;break;}else{label=17;break;}
 case 16: 
 var $75=(($69+($65<<2))|0);
 var $76=HEAP32[(($75)>>2)];
 var $77=($76|0)==0;
 if($77){label=17;break;}else{label=19;break;}
 case 17: 
 var $78=___cxa_allocate_exception(4);
 var $79=$78;
 __ZNSt8bad_castC2Ev($79);
 (function() { try { __THREW__ = 0; return ___cxa_throw($78,8960,(368)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=18;break; } else { label=24;break; }
 case 18: 
 throw "Reached an unreachable!";
 case 19: 
 var $81=$76;
 var $82=HEAP32[(($58)>>2)];
 var $83=(($82)|0);
 var $84=__ZNSt3__114__shared_count16__release_sharedEv($83);
 var $85=(($__names)|0);
 var $86=$76;
 var $87=HEAP32[(($86)>>2)];
 var $88=(($87+24)|0);
 var $89=HEAP32[(($88)>>2)];
 (function() { try { __THREW__ = 0; return FUNCTION_TABLE[$89]($85,$81) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=20;break; } else { var $_017=$85;label=25;break; }
 case 20: 
 var $90=(($__names+12)|0);
 var $91=HEAP32[(($86)>>2)];
 var $92=(($91+28)|0);
 var $93=HEAP32[(($92)>>2)];
 (function() { try { __THREW__ = 0; return FUNCTION_TABLE[$93]($90,$81) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=21;break; } else { var $_017=$90;label=25;break; }
 case 21: 
 var $94=(($__e)|0);
 var $95=HEAP32[(($94)>>2)];
 var $96=(($6)|0);
 HEAP32[(($96)>>2)]=$95;
 var $97=(($__names+24)|0);
 var $98=(function() { try { __THREW__ = 0; return __ZNSt3__114__scan_keywordINS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEPKNS_12basic_stringIcS3_NS_9allocatorIcEEEENS_5ctypeIcEEEET0_RT_SE_SD_SD_RKT1_Rjb($__b,$6,$85,$97,$54,$__err,1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=22;break; } else { label=27;break; }
 case 22: 
 var $99=($98|0)==($85|0);
 var $100=($99&1);
 HEAP8[($__v)]=$100;
 var $101=(($__b)|0);
 var $102=HEAP32[(($101)>>2)];
 var $103=(($agg_result)|0);
 HEAP32[(($103)>>2)]=$102;
 var $104=(($__names+12)|0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($104);
 var $105=(($__names)|0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($105);
 label=28;break;
 case 23: 
 var $107$0 = ___cxa_find_matching_catch(-1, -1); var $107$1 = tempRet0;
 var $108=$107$0;
 var $109=$107$1;
 var $110=HEAP32[(($31)>>2)];
 var $111=(($110)|0);
 var $112=__ZNSt3__114__shared_count16__release_sharedEv($111);
 var $_0=$108;var $_016=$109;label=29;break;
 case 24: 
 var $114$0 = ___cxa_find_matching_catch(-1, -1); var $114$1 = tempRet0;
 var $115=$114$0;
 var $116=$114$1;
 var $117=HEAP32[(($58)>>2)];
 var $118=(($117)|0);
 var $119=__ZNSt3__114__shared_count16__release_sharedEv($118);
 var $_0=$115;var $_016=$116;label=29;break;
 case 25: 
 var $_017;
 var $121$0 = ___cxa_find_matching_catch(-1, -1); var $121$1 = tempRet0;
 var $122=$121$0;
 var $123=$121$1;
 var $124=($85|0)==($_017|0);
 if($124){var $_0=$122;var $_016=$123;label=29;break;}else{var $125=$_017;label=26;break;}
 case 26: 
 var $125;
 var $126=((($125)-(12))|0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($126);
 var $127=($126|0)==($85|0);
 if($127){var $_0=$122;var $_016=$123;label=29;break;}else{var $125=$126;label=26;break;}
 case 27: 
 var $128$0 = ___cxa_find_matching_catch(-1, -1); var $128$1 = tempRet0;
 var $129=$128$0;
 var $130=(($__names+12)|0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($130);
 var $131=(($__names)|0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($131);
 var $132=$128$1;
 var $_0=$129;var $_016=$132;label=29;break;
 case 28: 
 STACKTOP=sp;return;
 case 29: 
 var $_016;
 var $_0;
 var $134$0=$_0;
 var $134$1=0;
 var $135$0=$134$0;
 var $135$1=$_016;
 ___resumeException($135$0)
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__114__scan_keywordINS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEPKNS_12basic_stringIcS3_NS_9allocatorIcEEEENS_5ctypeIcEEEET0_RT_SE_SD_SD_RKT1_Rjb($__b,$__e,$__kb,$__ke,$__ct,$__err,$__case_sensitive){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+104)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var tempParam = $__e; $__e=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $__statbuf=sp;
 var $1=$__ke;
 var $2=$__kb;
 var $3=((($1)-($2))|0);
 var $4=(((($3|0))/(12))&-1);
 var $5=(($__statbuf)|0);
 var $6=($4>>>0)>100;
 if($6){label=2;break;}else{var $__status_0=$5;var $__stat_hold_sroa_0_0_load8285=0;label=11;break;}
 case 2: 
 var $8=_malloc($4);
 var $9=($8|0)==0;
 if($9){label=3;break;}else{var $__status_0=$8;var $__stat_hold_sroa_0_0_load8285=$8;label=11;break;}
 case 3: 
 (function() { try { __THREW__ = 0; return __ZSt17__throw_bad_allocv() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $__status_0=0;var $__stat_hold_sroa_0_0_load8285=0;label=11;break; } else { label=4;break; }
 case 4: 
 var $11$0 = ___cxa_find_matching_catch(-1, -1); var $11$1 = tempRet0;
 var $14$1=$11$1;var $14$0=$11$0;label=10;break;
 case 5: 
 var $lpad_us_lcssa$0 = ___cxa_find_matching_catch(-1, -1); var $lpad_us_lcssa$1 = tempRet0;
 var $lpad_phi$1=$lpad_us_lcssa$1;var $lpad_phi$0=$lpad_us_lcssa$0;label=8;break;
 case 6: 
 var $lpad_loopexit$0 = ___cxa_find_matching_catch(-1, -1); var $lpad_loopexit$1 = tempRet0;
 var $lpad_phi$1=$lpad_loopexit$1;var $lpad_phi$0=$lpad_loopexit$0;label=8;break;
 case 7: 
 var $lpad_nonloopexit118$0 = ___cxa_find_matching_catch(-1, -1); var $lpad_nonloopexit118$1 = tempRet0;
 var $lpad_phi$1=$lpad_nonloopexit118$1;var $lpad_phi$0=$lpad_nonloopexit118$0;label=8;break;
 case 8: 
 var $lpad_phi$0;
 var $lpad_phi$1;
 var $12=($__stat_hold_sroa_0_0_load8285|0)==0;
 if($12){var $14$1=$lpad_phi$1;var $14$0=$lpad_phi$0;label=10;break;}else{label=9;break;}
 case 9: 
 _free($__stat_hold_sroa_0_0_load8285);
 var $14$1=$lpad_phi$1;var $14$0=$lpad_phi$0;label=10;break;
 case 10: 
 var $14$0;
 var $14$1;
 ___resumeException($14$0)
 case 11: 
 var $__stat_hold_sroa_0_0_load8285;
 var $__status_0;
 var $15=($__kb|0)==($__ke|0);
 if($15){var $__n_might_match_0_lcssa=$4;var $__n_does_match_0_lcssa=0;label=12;break;}else{var $__n_might_match_0128=$4;var $__n_does_match_0129=0;var $__st_0130=$__status_0;var $__ky_0131=$__kb;label=13;break;}
 case 12: 
 var $__n_does_match_0_lcssa;
 var $__n_might_match_0_lcssa;
 var $16=(($__b)|0);
 var $17=(($__e)|0);
 var $18=$__ct;
 var $__indx_0=0;var $__n_does_match_2=$__n_does_match_0_lcssa;var $__n_might_match_2=$__n_might_match_0_lcssa;label=20;break;
 case 13: 
 var $__ky_0131;
 var $__st_0130;
 var $__n_does_match_0129;
 var $__n_might_match_0128;
 var $19=$__ky_0131;
 var $20=HEAP8[($19)];
 var $21=$20&1;
 var $22=(($21<<24)>>24)==0;
 if($22){label=15;break;}else{label=14;break;}
 case 14: 
 var $24=(($__ky_0131+4)|0);
 var $25=HEAP32[(($24)>>2)];
 var $29=$25;label=16;break;
 case 15: 
 var $27=($20&255);
 var $28=$27>>>1;
 var $29=$28;label=16;break;
 case 16: 
 var $29;
 var $30=($29|0)==0;
 if($30){label=18;break;}else{label=17;break;}
 case 17: 
 HEAP8[($__st_0130)]=1;
 var $__n_does_match_1=$__n_does_match_0129;var $__n_might_match_1=$__n_might_match_0128;label=19;break;
 case 18: 
 HEAP8[($__st_0130)]=2;
 var $33=((($__n_might_match_0128)-(1))|0);
 var $34=((($__n_does_match_0129)+(1))|0);
 var $__n_does_match_1=$34;var $__n_might_match_1=$33;label=19;break;
 case 19: 
 var $__n_might_match_1;
 var $__n_does_match_1;
 var $36=(($__ky_0131+12)|0);
 var $37=(($__st_0130+1)|0);
 var $38=($36|0)==($__ke|0);
 if($38){var $__n_might_match_0_lcssa=$__n_might_match_1;var $__n_does_match_0_lcssa=$__n_does_match_1;label=12;break;}else{var $__n_might_match_0128=$__n_might_match_1;var $__n_does_match_0129=$__n_does_match_1;var $__st_0130=$37;var $__ky_0131=$36;label=13;break;}
 case 20: 
 var $__n_might_match_2;
 var $__n_does_match_2;
 var $__indx_0;
 var $39=HEAP32[(($16)>>2)];
 var $40=($39|0)==0;
 if($40){var $54=0;label=26;break;}else{label=21;break;}
 case 21: 
 var $42=(($39+12)|0);
 var $43=HEAP32[(($42)>>2)];
 var $44=(($39+16)|0);
 var $45=HEAP32[(($44)>>2)];
 var $46=($43|0)==($45|0);
 if($46){label=22;break;}else{var $54=$39;label=26;break;}
 case 22: 
 var $47=$39;
 var $48=HEAP32[(($47)>>2)];
 var $49=(($48+36)|0);
 var $50=HEAP32[(($49)>>2)];
 var $51=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$50]($39) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=23;break; } else { label=6;break; }
 case 23: 
 var $52=($51|0)==-1;
 if($52){label=25;break;}else{label=24;break;}
 case 24: 
 var $_pre_i_i_i=HEAP32[(($16)>>2)];
 var $54=$_pre_i_i_i;label=26;break;
 case 25: 
 HEAP32[(($16)>>2)]=0;
 var $54=0;label=26;break;
 case 26: 
 var $54;
 var $55=($54|0)==0;
 var $56=HEAP32[(($17)>>2)];
 var $57=($56|0)==0;
 if($57){var $_pre_i3_i_i76=0;label=31;break;}else{label=27;break;}
 case 27: 
 var $59=(($56+12)|0);
 var $60=HEAP32[(($59)>>2)];
 var $61=(($56+16)|0);
 var $62=HEAP32[(($61)>>2)];
 var $63=($60|0)==($62|0);
 if($63){label=28;break;}else{var $_pre_i3_i_i76=$56;label=31;break;}
 case 28: 
 var $64=$56;
 var $65=HEAP32[(($64)>>2)];
 var $66=(($65+36)|0);
 var $67=HEAP32[(($66)>>2)];
 var $68=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$67]($56) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=29;break; } else { label=6;break; }
 case 29: 
 var $69=($68|0)==-1;
 if($69){label=30;break;}else{var $_pre_i3_i_i76=$56;label=31;break;}
 case 30: 
 HEAP32[(($17)>>2)]=0;
 var $_pre_i3_i_i76=0;label=31;break;
 case 31: 
 var $_pre_i3_i_i76;
 var $71=($_pre_i3_i_i76|0)==0;
 var $tmp_i_i=$55^$71;
 var $72=($__n_might_match_2|0)!=0;
 var $_=$tmp_i_i&$72;
 var $73=HEAP32[(($16)>>2)];
 if($_){label=32;break;}else{label=79;break;}
 case 32: 
 var $75=(($73+12)|0);
 var $76=HEAP32[(($75)>>2)];
 var $77=(($73+16)|0);
 var $78=HEAP32[(($77)>>2)];
 var $79=($76|0)==($78|0);
 if($79){label=33;break;}else{label=35;break;}
 case 33: 
 var $81=$73;
 var $82=HEAP32[(($81)>>2)];
 var $83=(($82+36)|0);
 var $84=HEAP32[(($83)>>2)];
 var $85=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$84]($73) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=34;break; } else { label=6;break; }
 case 34: 
 var $extract_t_i=(($85)&255);
 var $_0_i_off0_i=$extract_t_i;label=36;break;
 case 35: 
 var $87=HEAP8[($76)];
 var $_0_i_off0_i=$87;label=36;break;
 case 36: 
 var $_0_i_off0_i;
 if($__case_sensitive){var $__c_0=$_0_i_off0_i;label=38;break;}else{label=37;break;}
 case 37: 
 var $89=HEAP32[(($18)>>2)];
 var $90=(($89+12)|0);
 var $91=HEAP32[(($90)>>2)];
 var $92=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$91]($__ct,$_0_i_off0_i) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $__c_0=$92;label=38;break; } else { label=6;break; }
 case 38: 
 var $__c_0;
 var $_pre=((($__indx_0)+(1))|0);
 if($15){var $__indx_0=$_pre;var $__n_does_match_2=$__n_does_match_2;var $__n_might_match_2=$__n_might_match_2;label=20;break;}else{label=39;break;}
 case 39: 
 if($__case_sensitive){var $__n_might_match_398_us=$__n_might_match_2;var $__n_does_match_399_us=$__n_does_match_2;var $__st_1100_us=$__status_0;var $__consume_0_off0102_us=0;var $__ky1_0103_us=$__kb;label=40;break;}else{var $__n_might_match_398=$__n_might_match_2;var $__n_does_match_399=$__n_does_match_2;var $__st_1100=$__status_0;var $__consume_0_off0102=0;var $__ky1_0103=$__kb;label=53;break;}
 case 40: 
 var $__ky1_0103_us;
 var $__consume_0_off0102_us;
 var $__st_1100_us;
 var $__n_does_match_399_us;
 var $__n_might_match_398_us;
 var $93=HEAP8[($__st_1100_us)];
 var $94=(($93<<24)>>24)==1;
 if($94){label=41;break;}else{var $__consume_1_off0_us=$__consume_0_off0102_us;var $__n_does_match_4_us=$__n_does_match_399_us;var $__n_might_match_4_us=$__n_might_match_398_us;label=51;break;}
 case 41: 
 var $96=$__ky1_0103_us;
 var $97=HEAP8[($96)];
 var $98=$97&1;
 var $99=(($98<<24)>>24)==0;
 if($99){label=43;break;}else{label=42;break;}
 case 42: 
 var $101=(($__ky1_0103_us+8)|0);
 var $102=HEAP32[(($101)>>2)];
 var $106=$102;label=44;break;
 case 43: 
 var $104=$__ky1_0103_us;
 var $105=(($104+1)|0);
 var $106=$105;label=44;break;
 case 44: 
 var $106;
 var $107=(($106+$__indx_0)|0);
 var $108=HEAP8[($107)];
 var $109=(($__c_0<<24)>>24)==(($108<<24)>>24);
 if($109){label=46;break;}else{label=45;break;}
 case 45: 
 HEAP8[($__st_1100_us)]=0;
 var $111=((($__n_might_match_398_us)-(1))|0);
 var $__consume_1_off0_us=$__consume_0_off0102_us;var $__n_does_match_4_us=$__n_does_match_399_us;var $__n_might_match_4_us=$111;label=51;break;
 case 46: 
 if($99){label=48;break;}else{label=47;break;}
 case 47: 
 var $114=(($__ky1_0103_us+4)|0);
 var $115=HEAP32[(($114)>>2)];
 var $119=$115;label=49;break;
 case 48: 
 var $117=($97&255);
 var $118=$117>>>1;
 var $119=$118;label=49;break;
 case 49: 
 var $119;
 var $120=($119|0)==($_pre|0);
 if($120){label=50;break;}else{var $__consume_1_off0_us=1;var $__n_does_match_4_us=$__n_does_match_399_us;var $__n_might_match_4_us=$__n_might_match_398_us;label=51;break;}
 case 50: 
 HEAP8[($__st_1100_us)]=2;
 var $122=((($__n_might_match_398_us)-(1))|0);
 var $123=((($__n_does_match_399_us)+(1))|0);
 var $__consume_1_off0_us=1;var $__n_does_match_4_us=$123;var $__n_might_match_4_us=$122;label=51;break;
 case 51: 
 var $__n_might_match_4_us;
 var $__n_does_match_4_us;
 var $__consume_1_off0_us;
 var $125=(($__ky1_0103_us+12)|0);
 var $126=($125|0)==($__ke|0);
 if($126){var $__n_might_match_3_lcssa=$__n_might_match_4_us;var $__n_does_match_3_lcssa=$__n_does_match_4_us;var $__consume_0_off0_lcssa=$__consume_1_off0_us;label=67;break;}else{label=52;break;}
 case 52: 
 var $127=(($__st_1100_us+1)|0);
 var $__n_might_match_398_us=$__n_might_match_4_us;var $__n_does_match_399_us=$__n_does_match_4_us;var $__st_1100_us=$127;var $__consume_0_off0102_us=$__consume_1_off0_us;var $__ky1_0103_us=$125;label=40;break;
 case 53: 
 var $__ky1_0103;
 var $__consume_0_off0102;
 var $__st_1100;
 var $__n_does_match_399;
 var $__n_might_match_398;
 var $128=HEAP8[($__st_1100)];
 var $129=(($128<<24)>>24)==1;
 if($129){label=54;break;}else{var $__consume_1_off0=$__consume_0_off0102;var $__n_does_match_4=$__n_does_match_399;var $__n_might_match_4=$__n_might_match_398;label=65;break;}
 case 54: 
 var $131=$__ky1_0103;
 var $132=HEAP8[($131)];
 var $133=$132&1;
 var $134=(($133<<24)>>24)==0;
 if($134){label=56;break;}else{label=55;break;}
 case 55: 
 var $136=(($__ky1_0103+8)|0);
 var $137=HEAP32[(($136)>>2)];
 var $142=$137;label=57;break;
 case 56: 
 var $139=$__ky1_0103;
 var $140=(($139+1)|0);
 var $142=$140;label=57;break;
 case 57: 
 var $142;
 var $143=(($142+$__indx_0)|0);
 var $144=HEAP8[($143)];
 var $145=HEAP32[(($18)>>2)];
 var $146=(($145+12)|0);
 var $147=HEAP32[(($146)>>2)];
 var $148=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$147]($__ct,$144) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=58;break; } else { label=5;break; }
 case 58: 
 var $149=(($__c_0<<24)>>24)==(($148<<24)>>24);
 if($149){label=59;break;}else{label=64;break;}
 case 59: 
 var $151=HEAP8[($131)];
 var $152=$151&1;
 var $153=(($152<<24)>>24)==0;
 if($153){label=61;break;}else{label=60;break;}
 case 60: 
 var $155=(($__ky1_0103+4)|0);
 var $156=HEAP32[(($155)>>2)];
 var $160=$156;label=62;break;
 case 61: 
 var $158=($151&255);
 var $159=$158>>>1;
 var $160=$159;label=62;break;
 case 62: 
 var $160;
 var $161=($160|0)==($_pre|0);
 if($161){label=63;break;}else{var $__consume_1_off0=1;var $__n_does_match_4=$__n_does_match_399;var $__n_might_match_4=$__n_might_match_398;label=65;break;}
 case 63: 
 HEAP8[($__st_1100)]=2;
 var $163=((($__n_might_match_398)-(1))|0);
 var $164=((($__n_does_match_399)+(1))|0);
 var $__consume_1_off0=1;var $__n_does_match_4=$164;var $__n_might_match_4=$163;label=65;break;
 case 64: 
 HEAP8[($__st_1100)]=0;
 var $166=((($__n_might_match_398)-(1))|0);
 var $__consume_1_off0=$__consume_0_off0102;var $__n_does_match_4=$__n_does_match_399;var $__n_might_match_4=$166;label=65;break;
 case 65: 
 var $__n_might_match_4;
 var $__n_does_match_4;
 var $__consume_1_off0;
 var $168=(($__ky1_0103+12)|0);
 var $169=($168|0)==($__ke|0);
 if($169){var $__n_might_match_3_lcssa=$__n_might_match_4;var $__n_does_match_3_lcssa=$__n_does_match_4;var $__consume_0_off0_lcssa=$__consume_1_off0;label=67;break;}else{label=66;break;}
 case 66: 
 var $170=(($__st_1100+1)|0);
 var $__n_might_match_398=$__n_might_match_4;var $__n_does_match_399=$__n_does_match_4;var $__st_1100=$170;var $__consume_0_off0102=$__consume_1_off0;var $__ky1_0103=$168;label=53;break;
 case 67: 
 var $__consume_0_off0_lcssa;
 var $__n_does_match_3_lcssa;
 var $__n_might_match_3_lcssa;
 if($__consume_0_off0_lcssa){label=68;break;}else{var $__indx_0=$_pre;var $__n_does_match_2=$__n_does_match_3_lcssa;var $__n_might_match_2=$__n_might_match_3_lcssa;label=20;break;}
 case 68: 
 var $172=HEAP32[(($16)>>2)];
 var $173=(($172+12)|0);
 var $174=HEAP32[(($173)>>2)];
 var $175=(($172+16)|0);
 var $176=HEAP32[(($175)>>2)];
 var $177=($174|0)==($176|0);
 if($177){label=69;break;}else{label=70;break;}
 case 69: 
 var $179=$172;
 var $180=HEAP32[(($179)>>2)];
 var $181=(($180+40)|0);
 var $182=HEAP32[(($181)>>2)];
 var $183=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$182]($172) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=71;break; } else { label=6;break; }
 case 70: 
 var $185=(($174+1)|0);
 HEAP32[(($173)>>2)]=$185;
 label=71;break;
 case 71: 
 var $186=((($__n_might_match_3_lcssa)+($__n_does_match_3_lcssa))|0);
 var $_not=($186>>>0)<2;
 if($_not){var $__indx_0=$_pre;var $__n_does_match_2=$__n_does_match_3_lcssa;var $__n_might_match_2=$__n_might_match_3_lcssa;label=20;break;}else{var $__n_does_match_5112=$__n_does_match_3_lcssa;var $__st_2113=$__status_0;var $__ky2_0114=$__kb;label=72;break;}
 case 72: 
 var $__ky2_0114;
 var $__st_2113;
 var $__n_does_match_5112;
 var $187=HEAP8[($__st_2113)];
 var $188=(($187<<24)>>24)==2;
 if($188){label=73;break;}else{var $__n_does_match_6=$__n_does_match_5112;label=78;break;}
 case 73: 
 var $190=$__ky2_0114;
 var $191=HEAP8[($190)];
 var $192=$191&1;
 var $193=(($192<<24)>>24)==0;
 if($193){label=75;break;}else{label=74;break;}
 case 74: 
 var $195=(($__ky2_0114+4)|0);
 var $196=HEAP32[(($195)>>2)];
 var $200=$196;label=76;break;
 case 75: 
 var $198=($191&255);
 var $199=$198>>>1;
 var $200=$199;label=76;break;
 case 76: 
 var $200;
 var $201=($200|0)==($_pre|0);
 if($201){var $__n_does_match_6=$__n_does_match_5112;label=78;break;}else{label=77;break;}
 case 77: 
 HEAP8[($__st_2113)]=0;
 var $203=((($__n_does_match_5112)-(1))|0);
 var $__n_does_match_6=$203;label=78;break;
 case 78: 
 var $__n_does_match_6;
 var $205=(($__ky2_0114+12)|0);
 var $206=(($__st_2113+1)|0);
 var $207=($205|0)==($__ke|0);
 if($207){var $__indx_0=$_pre;var $__n_does_match_2=$__n_does_match_6;var $__n_might_match_2=$__n_might_match_3_lcssa;label=20;break;}else{var $__n_does_match_5112=$__n_does_match_6;var $__st_2113=$206;var $__ky2_0114=$205;label=72;break;}
 case 79: 
 var $209=($73|0)==0;
 if($209){var $223=0;label=85;break;}else{label=80;break;}
 case 80: 
 var $211=(($73+12)|0);
 var $212=HEAP32[(($211)>>2)];
 var $213=(($73+16)|0);
 var $214=HEAP32[(($213)>>2)];
 var $215=($212|0)==($214|0);
 if($215){label=81;break;}else{var $223=$73;label=85;break;}
 case 81: 
 var $216=$73;
 var $217=HEAP32[(($216)>>2)];
 var $218=(($217+36)|0);
 var $219=HEAP32[(($218)>>2)];
 var $220=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$219]($73) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=82;break; } else { label=7;break; }
 case 82: 
 var $221=($220|0)==-1;
 if($221){label=84;break;}else{label=83;break;}
 case 83: 
 var $_pre_i_i_i72=HEAP32[(($16)>>2)];
 var $223=$_pre_i_i_i72;label=85;break;
 case 84: 
 HEAP32[(($16)>>2)]=0;
 var $223=0;label=85;break;
 case 85: 
 var $223;
 var $224=($223|0)==0;
 if($71){label=91;break;}else{label=86;break;}
 case 86: 
 var $226=(($_pre_i3_i_i76+12)|0);
 var $227=HEAP32[(($226)>>2)];
 var $228=(($_pre_i3_i_i76+16)|0);
 var $229=HEAP32[(($228)>>2)];
 var $230=($227|0)==($229|0);
 if($230){label=88;break;}else{label=87;break;}
 case 87: 
 if($224){label=94;break;}else{label=93;break;}
 case 88: 
 var $231=$_pre_i3_i_i76;
 var $232=HEAP32[(($231)>>2)];
 var $233=(($232+36)|0);
 var $234=HEAP32[(($233)>>2)];
 var $235=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$234]($_pre_i3_i_i76) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=89;break; } else { label=7;break; }
 case 89: 
 var $236=($235|0)==-1;
 if($236){label=90;break;}else{label=92;break;}
 case 90: 
 HEAP32[(($17)>>2)]=0;
 label=91;break;
 case 91: 
 if($224){label=93;break;}else{label=94;break;}
 case 92: 
 if($224){label=94;break;}else{label=93;break;}
 case 93: 
 var $239=HEAP32[(($__err)>>2)];
 var $240=$239|2;
 HEAP32[(($__err)>>2)]=$240;
 label=94;break;
 case 94: 
 if($15){label=98;break;}else{var $__st_392=$__status_0;var $_093=$__kb;label=95;break;}
 case 95: 
 var $_093;
 var $__st_392;
 var $241=HEAP8[($__st_392)];
 var $242=(($241<<24)>>24)==2;
 if($242){var $_091=$_093;label=99;break;}else{label=96;break;}
 case 96: 
 var $244=(($_093+12)|0);
 var $245=($244|0)==($__ke|0);
 if($245){label=98;break;}else{label=97;break;}
 case 97: 
 var $246=(($__st_392+1)|0);
 var $__st_392=$246;var $_093=$244;label=95;break;
 case 98: 
 var $247=HEAP32[(($__err)>>2)];
 var $248=$247|4;
 HEAP32[(($__err)>>2)]=$248;
 var $_091=$__ke;label=99;break;
 case 99: 
 var $_091;
 var $249=($__stat_hold_sroa_0_0_load8285|0)==0;
 if($249){label=101;break;}else{label=100;break;}
 case 100: 
 _free($__stat_hold_sroa_0_0_load8285);
 label=101;break;
 case 101: 
 STACKTOP=sp;return $_091;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRl($agg_result,$this,$__b,$__e,$__iob,$__err,$__v){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+16)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var tempParam = $__b; $__b=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__b)>>2)]=HEAP32[((tempParam)>>2)];
 var tempParam = $__e; $__e=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];

 var $1=sp;
 var $2=(sp)+(8);
 var $3=(($__b)|0);
 var $4=HEAP32[(($3)>>2)];
 var $5=(($1)|0);
 HEAP32[(($5)>>2)]=$4;
 var $6=(($__e)|0);
 var $7=HEAP32[(($6)>>2)];
 var $8=(($2)|0);
 HEAP32[(($8)>>2)]=$7;
 __ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE15__do_get_signedIlEES4_S4_S4_RNS_8ios_baseERjRT_($agg_result,0,$1,$2,$__iob,$__err,$__v);
 STACKTOP=sp;return;
}


function __ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE15__do_get_signedIlEES4_S4_S4_RNS_8ios_baseERjRT_($agg_result,$this,$__b,$__e,$__iob,$__err,$__v){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+256)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var tempParam = $__b; $__b=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__b)>>2)]=HEAP32[((tempParam)>>2)];
 var tempParam = $__e; $__e=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $__atoms=sp;
 var $__thousands_sep=(sp)+(32);
 var $__grouping=(sp)+(40);
 var $__buf=(sp)+(56);
 var $__a_end=(sp)+(72);
 var $__g=(sp)+(80);
 var $__g_end=(sp)+(240);
 var $__dc=(sp)+(248);
 var $1=(($__iob+4)|0);
 var $2=HEAP32[(($1)>>2)];
 var $3=$2&74;
 if(($3|0)==8){ label=2;break;}else if(($3|0)==0){ label=3;break;}else if(($3|0)==64){ var $_0_i=8;label=5;break;}else{label=4;break;}
 case 2: 
 var $_0_i=16;label=5;break;
 case 3: 
 var $_0_i=0;label=5;break;
 case 4: 
 var $_0_i=10;label=5;break;
 case 5: 
 var $_0_i;
 var $7=(($__atoms)|0);
 __ZNSt3__19__num_getIcE17__stage2_int_prepERNS_8ios_baseEPcRc($__grouping,$__iob,$7,$__thousands_sep);
 var $this4_i_i_i=$__buf;
 HEAP32[(($this4_i_i_i)>>2)]=0; HEAP32[((($this4_i_i_i)+(4))>>2)]=0; HEAP32[((($this4_i_i_i)+(8))>>2)]=0;
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc($__buf,10,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=6;break; } else { label=38;break; }
 case 6: 
 var $8=HEAP8[($this4_i_i_i)];
 var $9=$8&1;
 var $10=(($9<<24)>>24)==0;
 if($10){label=8;break;}else{label=7;break;}
 case 7: 
 var $12=(($__buf+8)|0);
 var $13=HEAP32[(($12)>>2)];
 var $_pre43=$__buf;
 var $_pre44=(($_pre43+1)|0);
 var $17=$13;var $_pre_phi45=$_pre44;var $_pre_phi47=$12;label=9;break;
 case 8: 
 var $15=$__buf;
 var $16=(($15+1)|0);
 var $_pre46=(($__buf+8)|0);
 var $17=$16;var $_pre_phi45=$16;var $_pre_phi47=$_pre46;label=9;break;
 case 9: 
 var $_pre_phi47;
 var $_pre_phi45;
 var $17;
 HEAP32[(($__a_end)>>2)]=$17;
 var $18=(($__g)|0);
 HEAP32[(($__g_end)>>2)]=$18;
 HEAP32[(($__dc)>>2)]=0;
 var $19=(($__b)|0);
 var $20=(($__e)|0);
 var $21=(($__buf)|0);
 var $22=(($__buf+4)|0);
 var $23=HEAP8[($__thousands_sep)];
 var $_pre=HEAP32[(($19)>>2)];
 var $__a_0=$17;var $_pre_i_i_i17=$_pre;label=10;break;
 case 10: 
 var $_pre_i_i_i17;
 var $__a_0;
 var $24=($_pre_i_i_i17|0)==0;
 if($24){var $38=0;label=15;break;}else{label=11;break;}
 case 11: 
 var $26=(($_pre_i_i_i17+12)|0);
 var $27=HEAP32[(($26)>>2)];
 var $28=(($_pre_i_i_i17+16)|0);
 var $29=HEAP32[(($28)>>2)];
 var $30=($27|0)==($29|0);
 if($30){label=12;break;}else{var $38=$_pre_i_i_i17;label=15;break;}
 case 12: 
 var $31=$_pre_i_i_i17;
 var $32=HEAP32[(($31)>>2)];
 var $33=(($32+36)|0);
 var $34=HEAP32[(($33)>>2)];
 var $35=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$34]($_pre_i_i_i17) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=13;break; } else { label=37;break; }
 case 13: 
 var $36=($35|0)==-1;
 if($36){label=14;break;}else{var $38=$_pre_i_i_i17;label=15;break;}
 case 14: 
 HEAP32[(($19)>>2)]=0;
 var $38=0;label=15;break;
 case 15: 
 var $38;
 var $39=($38|0)==0;
 var $40=HEAP32[(($20)>>2)];
 var $41=($40|0)==0;
 if($41){label=21;break;}else{label=16;break;}
 case 16: 
 var $43=(($40+12)|0);
 var $44=HEAP32[(($43)>>2)];
 var $45=(($40+16)|0);
 var $46=HEAP32[(($45)>>2)];
 var $47=($44|0)==($46|0);
 if($47){label=18;break;}else{label=17;break;}
 case 17: 
 if($39){var $56=$40;label=23;break;}else{var $__a_2=$__a_0;var $_pre_i3_i_i=$40;label=48;break;}
 case 18: 
 var $48=$40;
 var $49=HEAP32[(($48)>>2)];
 var $50=(($49+36)|0);
 var $51=HEAP32[(($50)>>2)];
 var $52=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$51]($40) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=19;break; } else { label=37;break; }
 case 19: 
 var $53=($52|0)==-1;
 if($53){label=20;break;}else{label=22;break;}
 case 20: 
 HEAP32[(($20)>>2)]=0;
 label=21;break;
 case 21: 
 if($39){var $__a_2=$__a_0;var $_pre_i3_i_i=0;label=48;break;}else{var $56=0;label=23;break;}
 case 22: 
 if($39){var $56=$40;label=23;break;}else{var $__a_2=$__a_0;var $_pre_i3_i_i=$40;label=48;break;}
 case 23: 
 var $56;
 var $57=HEAP32[(($__a_end)>>2)];
 var $58=$57;
 var $59=$__a_0;
 var $60=((($58)-($59))|0);
 var $61=HEAP8[($this4_i_i_i)];
 var $62=$61&1;
 var $63=(($62<<24)>>24)==0;
 if($63){label=25;break;}else{label=24;break;}
 case 24: 
 var $65=HEAP32[(($22)>>2)];
 var $69=$65;label=26;break;
 case 25: 
 var $67=($61&255);
 var $68=$67>>>1;
 var $69=$68;label=26;break;
 case 26: 
 var $69;
 var $70=($60|0)==($69|0);
 if($70){label=27;break;}else{var $__a_1=$__a_0;label=40;break;}
 case 27: 
 if($63){label=29;break;}else{label=28;break;}
 case 28: 
 var $73=HEAP32[(($22)>>2)];
 var $80=$73;var $79=$73;label=30;break;
 case 29: 
 var $75=($61&255);
 var $76=$75>>>1;
 var $77=($61&255);
 var $78=$77>>>1;
 var $80=$78;var $79=$76;label=30;break;
 case 30: 
 var $79;
 var $80;
 var $81=$80<<1;
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc($__buf,$81,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=31;break; } else { label=37;break; }
 case 31: 
 var $82=HEAP8[($this4_i_i_i)];
 var $83=$82&1;
 var $84=(($83<<24)>>24)==0;
 if($84){var $88=10;label=33;break;}else{label=32;break;}
 case 32: 
 var $86=HEAP32[(($21)>>2)];
 var $87=$86&-2;
 var $phitmp_i32=((($87)-(1))|0);
 var $88=$phitmp_i32;label=33;break;
 case 33: 
 var $88;
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc($__buf,$88,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=34;break; } else { label=37;break; }
 case 34: 
 var $89=HEAP8[($this4_i_i_i)];
 var $90=$89&1;
 var $91=(($90<<24)>>24)==0;
 if($91){var $94=$_pre_phi45;label=36;break;}else{label=35;break;}
 case 35: 
 var $93=HEAP32[(($_pre_phi47)>>2)];
 var $94=$93;label=36;break;
 case 36: 
 var $94;
 var $95=(($94+$79)|0);
 HEAP32[(($__a_end)>>2)]=$95;
 var $__a_1=$94;label=40;break;
 case 37: 
 var $lpad_loopexit$0 = ___cxa_find_matching_catch(-1, -1); var $lpad_loopexit$1 = tempRet0;
 var $lpad_phi$1=$lpad_loopexit$1;var $lpad_phi$0=$lpad_loopexit$0;label=39;break;
 case 38: 
 var $lpad_nonloopexit$0 = ___cxa_find_matching_catch(-1, -1); var $lpad_nonloopexit$1 = tempRet0;
 var $lpad_phi$1=$lpad_nonloopexit$1;var $lpad_phi$0=$lpad_nonloopexit$0;label=39;break;
 case 39: 
 var $lpad_phi$0;
 var $lpad_phi$1;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__buf);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grouping);
 ___resumeException($lpad_phi$0)
 case 40: 
 var $__a_1;
 var $97=(($38+12)|0);
 var $98=HEAP32[(($97)>>2)];
 var $99=(($38+16)|0);
 var $100=HEAP32[(($99)>>2)];
 var $101=($98|0)==($100|0);
 if($101){label=41;break;}else{label=43;break;}
 case 41: 
 var $103=$38;
 var $104=HEAP32[(($103)>>2)];
 var $105=(($104+36)|0);
 var $106=HEAP32[(($105)>>2)];
 var $107=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$106]($38) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=42;break; } else { label=37;break; }
 case 42: 
 var $extract_t_i=(($107)&255);
 var $_0_i_off0_i=$extract_t_i;label=44;break;
 case 43: 
 var $109=HEAP8[($98)];
 var $_0_i_off0_i=$109;label=44;break;
 case 44: 
 var $_0_i_off0_i;
 var $111=__ZNSt3__19__num_getIcE17__stage2_int_loopEciPcRS2_RjcRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSD_S2_($_0_i_off0_i,$_0_i,$__a_1,$__a_end,$__dc,$23,$__grouping,$18,$__g_end,$7);
 var $112=($111|0)==0;
 if($112){label=45;break;}else{var $__a_2=$__a_1;var $_pre_i3_i_i=$56;label=48;break;}
 case 45: 
 var $114=HEAP32[(($97)>>2)];
 var $115=HEAP32[(($99)>>2)];
 var $116=($114|0)==($115|0);
 if($116){label=46;break;}else{label=47;break;}
 case 46: 
 var $118=$38;
 var $119=HEAP32[(($118)>>2)];
 var $120=(($119+40)|0);
 var $121=HEAP32[(($120)>>2)];
 var $122=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$121]($38) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $__a_0=$__a_1;var $_pre_i_i_i17=$38;label=10;break; } else { label=37;break; }
 case 47: 
 var $124=(($114+1)|0);
 HEAP32[(($97)>>2)]=$124;
 var $__a_0=$__a_1;var $_pre_i_i_i17=$38;label=10;break;
 case 48: 
 var $_pre_i3_i_i;
 var $__a_2;
 var $126=$__grouping;
 var $127=HEAP8[($126)];
 var $128=$127&1;
 var $129=(($128<<24)>>24)==0;
 if($129){label=50;break;}else{label=49;break;}
 case 49: 
 var $131=(($__grouping+4)|0);
 var $132=HEAP32[(($131)>>2)];
 var $136=$132;label=51;break;
 case 50: 
 var $134=($127&255);
 var $135=$134>>>1;
 var $136=$135;label=51;break;
 case 51: 
 var $136;
 var $137=($136|0)==0;
 if($137){label=54;break;}else{label=52;break;}
 case 52: 
 var $139=HEAP32[(($__g_end)>>2)];
 var $140=$139;
 var $141=$__g;
 var $142=((($140)-($141))|0);
 var $143=($142|0)<160;
 if($143){label=53;break;}else{label=54;break;}
 case 53: 
 var $145=HEAP32[(($__dc)>>2)];
 var $146=(($139+4)|0);
 HEAP32[(($__g_end)>>2)]=$146;
 HEAP32[(($139)>>2)]=$145;
 label=54;break;
 case 54: 
 var $147=HEAP32[(($__a_end)>>2)];
 var $148=(function() { try { __THREW__ = 0; return __ZNSt3__125__num_get_signed_integralIlEET_PKcS3_Rji($__a_2,$147,$__err,$_0_i) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=55;break; } else { label=38;break; }
 case 55: 
 HEAP32[(($__v)>>2)]=$148;
 var $150=HEAP32[(($__g_end)>>2)];
 __ZNSt3__116__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj($__grouping,$18,$150,$__err);
 var $151=($38|0)==0;
 if($151){var $165=0;label=60;break;}else{label=56;break;}
 case 56: 
 var $153=(($38+12)|0);
 var $154=HEAP32[(($153)>>2)];
 var $155=(($38+16)|0);
 var $156=HEAP32[(($155)>>2)];
 var $157=($154|0)==($156|0);
 if($157){label=57;break;}else{var $165=$38;label=60;break;}
 case 57: 
 var $158=$38;
 var $159=HEAP32[(($158)>>2)];
 var $160=(($159+36)|0);
 var $161=HEAP32[(($160)>>2)];
 var $162=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$161]($38) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=58;break; } else { label=38;break; }
 case 58: 
 var $163=($162|0)==-1;
 if($163){label=59;break;}else{var $165=$38;label=60;break;}
 case 59: 
 HEAP32[(($19)>>2)]=0;
 var $165=0;label=60;break;
 case 60: 
 var $165;
 var $166=($165|0)==0;
 var $167=($_pre_i3_i_i|0)==0;
 if($167){label=66;break;}else{label=61;break;}
 case 61: 
 var $169=(($_pre_i3_i_i+12)|0);
 var $170=HEAP32[(($169)>>2)];
 var $171=(($_pre_i3_i_i+16)|0);
 var $172=HEAP32[(($171)>>2)];
 var $173=($170|0)==($172|0);
 if($173){label=63;break;}else{label=62;break;}
 case 62: 
 if($166){label=69;break;}else{label=68;break;}
 case 63: 
 var $174=$_pre_i3_i_i;
 var $175=HEAP32[(($174)>>2)];
 var $176=(($175+36)|0);
 var $177=HEAP32[(($176)>>2)];
 var $178=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$177]($_pre_i3_i_i) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=64;break; } else { label=38;break; }
 case 64: 
 var $179=($178|0)==-1;
 if($179){label=65;break;}else{label=67;break;}
 case 65: 
 HEAP32[(($20)>>2)]=0;
 label=66;break;
 case 66: 
 if($166){label=68;break;}else{label=69;break;}
 case 67: 
 var $181=($_pre_i3_i_i|0)==0;
 var $tmp_i_i=$166^$181;
 if($tmp_i_i){label=69;break;}else{label=68;break;}
 case 68: 
 var $183=HEAP32[(($__err)>>2)];
 var $184=$183|2;
 HEAP32[(($__err)>>2)]=$184;
 label=69;break;
 case 69: 
 var $186=(($agg_result)|0);
 HEAP32[(($186)>>2)]=$165;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__buf);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grouping);
 STACKTOP=sp;return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRx($agg_result,$this,$__b,$__e,$__iob,$__err,$__v){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+16)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var tempParam = $__b; $__b=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__b)>>2)]=HEAP32[((tempParam)>>2)];
 var tempParam = $__e; $__e=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];

 var $1=sp;
 var $2=(sp)+(8);
 var $3=(($__b)|0);
 var $4=HEAP32[(($3)>>2)];
 var $5=(($1)|0);
 HEAP32[(($5)>>2)]=$4;
 var $6=(($__e)|0);
 var $7=HEAP32[(($6)>>2)];
 var $8=(($2)|0);
 HEAP32[(($8)>>2)]=$7;
 __ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE15__do_get_signedIxEES4_S4_S4_RNS_8ios_baseERjRT_($agg_result,0,$1,$2,$__iob,$__err,$__v);
 STACKTOP=sp;return;
}


function __ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE15__do_get_signedIxEES4_S4_S4_RNS_8ios_baseERjRT_($agg_result,$this,$__b,$__e,$__iob,$__err,$__v){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+256)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var tempParam = $__b; $__b=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__b)>>2)]=HEAP32[((tempParam)>>2)];
 var tempParam = $__e; $__e=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $__atoms=sp;
 var $__thousands_sep=(sp)+(32);
 var $__grouping=(sp)+(40);
 var $__buf=(sp)+(56);
 var $__a_end=(sp)+(72);
 var $__g=(sp)+(80);
 var $__g_end=(sp)+(240);
 var $__dc=(sp)+(248);
 var $1=(($__iob+4)|0);
 var $2=HEAP32[(($1)>>2)];
 var $3=$2&74;
 if(($3|0)==8){ label=2;break;}else if(($3|0)==0){ label=3;break;}else if(($3|0)==64){ var $_0_i=8;label=5;break;}else{label=4;break;}
 case 2: 
 var $_0_i=16;label=5;break;
 case 3: 
 var $_0_i=0;label=5;break;
 case 4: 
 var $_0_i=10;label=5;break;
 case 5: 
 var $_0_i;
 var $7=(($__atoms)|0);
 __ZNSt3__19__num_getIcE17__stage2_int_prepERNS_8ios_baseEPcRc($__grouping,$__iob,$7,$__thousands_sep);
 var $this4_i_i_i=$__buf;
 HEAP32[(($this4_i_i_i)>>2)]=0; HEAP32[((($this4_i_i_i)+(4))>>2)]=0; HEAP32[((($this4_i_i_i)+(8))>>2)]=0;
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc($__buf,10,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=6;break; } else { label=38;break; }
 case 6: 
 var $8=HEAP8[($this4_i_i_i)];
 var $9=$8&1;
 var $10=(($9<<24)>>24)==0;
 if($10){label=8;break;}else{label=7;break;}
 case 7: 
 var $12=(($__buf+8)|0);
 var $13=HEAP32[(($12)>>2)];
 var $_pre43=$__buf;
 var $_pre44=(($_pre43+1)|0);
 var $17=$13;var $_pre_phi45=$_pre44;var $_pre_phi47=$12;label=9;break;
 case 8: 
 var $15=$__buf;
 var $16=(($15+1)|0);
 var $_pre46=(($__buf+8)|0);
 var $17=$16;var $_pre_phi45=$16;var $_pre_phi47=$_pre46;label=9;break;
 case 9: 
 var $_pre_phi47;
 var $_pre_phi45;
 var $17;
 HEAP32[(($__a_end)>>2)]=$17;
 var $18=(($__g)|0);
 HEAP32[(($__g_end)>>2)]=$18;
 HEAP32[(($__dc)>>2)]=0;
 var $19=(($__b)|0);
 var $20=(($__e)|0);
 var $21=(($__buf)|0);
 var $22=(($__buf+4)|0);
 var $23=HEAP8[($__thousands_sep)];
 var $_pre=HEAP32[(($19)>>2)];
 var $__a_0=$17;var $_pre_i_i_i17=$_pre;label=10;break;
 case 10: 
 var $_pre_i_i_i17;
 var $__a_0;
 var $24=($_pre_i_i_i17|0)==0;
 if($24){var $38=0;label=15;break;}else{label=11;break;}
 case 11: 
 var $26=(($_pre_i_i_i17+12)|0);
 var $27=HEAP32[(($26)>>2)];
 var $28=(($_pre_i_i_i17+16)|0);
 var $29=HEAP32[(($28)>>2)];
 var $30=($27|0)==($29|0);
 if($30){label=12;break;}else{var $38=$_pre_i_i_i17;label=15;break;}
 case 12: 
 var $31=$_pre_i_i_i17;
 var $32=HEAP32[(($31)>>2)];
 var $33=(($32+36)|0);
 var $34=HEAP32[(($33)>>2)];
 var $35=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$34]($_pre_i_i_i17) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=13;break; } else { label=37;break; }
 case 13: 
 var $36=($35|0)==-1;
 if($36){label=14;break;}else{var $38=$_pre_i_i_i17;label=15;break;}
 case 14: 
 HEAP32[(($19)>>2)]=0;
 var $38=0;label=15;break;
 case 15: 
 var $38;
 var $39=($38|0)==0;
 var $40=HEAP32[(($20)>>2)];
 var $41=($40|0)==0;
 if($41){label=21;break;}else{label=16;break;}
 case 16: 
 var $43=(($40+12)|0);
 var $44=HEAP32[(($43)>>2)];
 var $45=(($40+16)|0);
 var $46=HEAP32[(($45)>>2)];
 var $47=($44|0)==($46|0);
 if($47){label=18;break;}else{label=17;break;}
 case 17: 
 if($39){var $56=$40;label=23;break;}else{var $__a_2=$__a_0;var $_pre_i3_i_i=$40;label=48;break;}
 case 18: 
 var $48=$40;
 var $49=HEAP32[(($48)>>2)];
 var $50=(($49+36)|0);
 var $51=HEAP32[(($50)>>2)];
 var $52=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$51]($40) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=19;break; } else { label=37;break; }
 case 19: 
 var $53=($52|0)==-1;
 if($53){label=20;break;}else{label=22;break;}
 case 20: 
 HEAP32[(($20)>>2)]=0;
 label=21;break;
 case 21: 
 if($39){var $__a_2=$__a_0;var $_pre_i3_i_i=0;label=48;break;}else{var $56=0;label=23;break;}
 case 22: 
 if($39){var $56=$40;label=23;break;}else{var $__a_2=$__a_0;var $_pre_i3_i_i=$40;label=48;break;}
 case 23: 
 var $56;
 var $57=HEAP32[(($__a_end)>>2)];
 var $58=$57;
 var $59=$__a_0;
 var $60=((($58)-($59))|0);
 var $61=HEAP8[($this4_i_i_i)];
 var $62=$61&1;
 var $63=(($62<<24)>>24)==0;
 if($63){label=25;break;}else{label=24;break;}
 case 24: 
 var $65=HEAP32[(($22)>>2)];
 var $69=$65;label=26;break;
 case 25: 
 var $67=($61&255);
 var $68=$67>>>1;
 var $69=$68;label=26;break;
 case 26: 
 var $69;
 var $70=($60|0)==($69|0);
 if($70){label=27;break;}else{var $__a_1=$__a_0;label=40;break;}
 case 27: 
 if($63){label=29;break;}else{label=28;break;}
 case 28: 
 var $73=HEAP32[(($22)>>2)];
 var $80=$73;var $79=$73;label=30;break;
 case 29: 
 var $75=($61&255);
 var $76=$75>>>1;
 var $77=($61&255);
 var $78=$77>>>1;
 var $80=$78;var $79=$76;label=30;break;
 case 30: 
 var $79;
 var $80;
 var $81=$80<<1;
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc($__buf,$81,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=31;break; } else { label=37;break; }
 case 31: 
 var $82=HEAP8[($this4_i_i_i)];
 var $83=$82&1;
 var $84=(($83<<24)>>24)==0;
 if($84){var $88=10;label=33;break;}else{label=32;break;}
 case 32: 
 var $86=HEAP32[(($21)>>2)];
 var $87=$86&-2;
 var $phitmp_i32=((($87)-(1))|0);
 var $88=$phitmp_i32;label=33;break;
 case 33: 
 var $88;
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc($__buf,$88,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=34;break; } else { label=37;break; }
 case 34: 
 var $89=HEAP8[($this4_i_i_i)];
 var $90=$89&1;
 var $91=(($90<<24)>>24)==0;
 if($91){var $94=$_pre_phi45;label=36;break;}else{label=35;break;}
 case 35: 
 var $93=HEAP32[(($_pre_phi47)>>2)];
 var $94=$93;label=36;break;
 case 36: 
 var $94;
 var $95=(($94+$79)|0);
 HEAP32[(($__a_end)>>2)]=$95;
 var $__a_1=$94;label=40;break;
 case 37: 
 var $lpad_loopexit$0 = ___cxa_find_matching_catch(-1, -1); var $lpad_loopexit$1 = tempRet0;
 var $lpad_phi$1=$lpad_loopexit$1;var $lpad_phi$0=$lpad_loopexit$0;label=39;break;
 case 38: 
 var $lpad_nonloopexit$0 = ___cxa_find_matching_catch(-1, -1); var $lpad_nonloopexit$1 = tempRet0;
 var $lpad_phi$1=$lpad_nonloopexit$1;var $lpad_phi$0=$lpad_nonloopexit$0;label=39;break;
 case 39: 
 var $lpad_phi$0;
 var $lpad_phi$1;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__buf);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grouping);
 ___resumeException($lpad_phi$0)
 case 40: 
 var $__a_1;
 var $97=(($38+12)|0);
 var $98=HEAP32[(($97)>>2)];
 var $99=(($38+16)|0);
 var $100=HEAP32[(($99)>>2)];
 var $101=($98|0)==($100|0);
 if($101){label=41;break;}else{label=43;break;}
 case 41: 
 var $103=$38;
 var $104=HEAP32[(($103)>>2)];
 var $105=(($104+36)|0);
 var $106=HEAP32[(($105)>>2)];
 var $107=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$106]($38) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=42;break; } else { label=37;break; }
 case 42: 
 var $extract_t_i=(($107)&255);
 var $_0_i_off0_i=$extract_t_i;label=44;break;
 case 43: 
 var $109=HEAP8[($98)];
 var $_0_i_off0_i=$109;label=44;break;
 case 44: 
 var $_0_i_off0_i;
 var $111=__ZNSt3__19__num_getIcE17__stage2_int_loopEciPcRS2_RjcRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSD_S2_($_0_i_off0_i,$_0_i,$__a_1,$__a_end,$__dc,$23,$__grouping,$18,$__g_end,$7);
 var $112=($111|0)==0;
 if($112){label=45;break;}else{var $__a_2=$__a_1;var $_pre_i3_i_i=$56;label=48;break;}
 case 45: 
 var $114=HEAP32[(($97)>>2)];
 var $115=HEAP32[(($99)>>2)];
 var $116=($114|0)==($115|0);
 if($116){label=46;break;}else{label=47;break;}
 case 46: 
 var $118=$38;
 var $119=HEAP32[(($118)>>2)];
 var $120=(($119+40)|0);
 var $121=HEAP32[(($120)>>2)];
 var $122=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$121]($38) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $__a_0=$__a_1;var $_pre_i_i_i17=$38;label=10;break; } else { label=37;break; }
 case 47: 
 var $124=(($114+1)|0);
 HEAP32[(($97)>>2)]=$124;
 var $__a_0=$__a_1;var $_pre_i_i_i17=$38;label=10;break;
 case 48: 
 var $_pre_i3_i_i;
 var $__a_2;
 var $126=$__grouping;
 var $127=HEAP8[($126)];
 var $128=$127&1;
 var $129=(($128<<24)>>24)==0;
 if($129){label=50;break;}else{label=49;break;}
 case 49: 
 var $131=(($__grouping+4)|0);
 var $132=HEAP32[(($131)>>2)];
 var $136=$132;label=51;break;
 case 50: 
 var $134=($127&255);
 var $135=$134>>>1;
 var $136=$135;label=51;break;
 case 51: 
 var $136;
 var $137=($136|0)==0;
 if($137){label=54;break;}else{label=52;break;}
 case 52: 
 var $139=HEAP32[(($__g_end)>>2)];
 var $140=$139;
 var $141=$__g;
 var $142=((($140)-($141))|0);
 var $143=($142|0)<160;
 if($143){label=53;break;}else{label=54;break;}
 case 53: 
 var $145=HEAP32[(($__dc)>>2)];
 var $146=(($139+4)|0);
 HEAP32[(($__g_end)>>2)]=$146;
 HEAP32[(($139)>>2)]=$145;
 label=54;break;
 case 54: 
 var $147=HEAP32[(($__a_end)>>2)];
 var $148$r=(function() { try { __THREW__ = 0; return __ZNSt3__125__num_get_signed_integralIxEET_PKcS3_Rji($__a_2,$147,$__err,$_0_i) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();var $148$0=$148$r;var $148$1=tempRet0;if (!__THREW__) { label=55;break; } else { label=38;break; }
 case 55: 
 var $st$0$0=(($__v)|0);
 HEAP32[(($st$0$0)>>2)]=$148$0;
 var $st$1$1=(($__v+4)|0);
 HEAP32[(($st$1$1)>>2)]=$148$1;
 var $150=HEAP32[(($__g_end)>>2)];
 __ZNSt3__116__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj($__grouping,$18,$150,$__err);
 var $151=($38|0)==0;
 if($151){var $165=0;label=60;break;}else{label=56;break;}
 case 56: 
 var $153=(($38+12)|0);
 var $154=HEAP32[(($153)>>2)];
 var $155=(($38+16)|0);
 var $156=HEAP32[(($155)>>2)];
 var $157=($154|0)==($156|0);
 if($157){label=57;break;}else{var $165=$38;label=60;break;}
 case 57: 
 var $158=$38;
 var $159=HEAP32[(($158)>>2)];
 var $160=(($159+36)|0);
 var $161=HEAP32[(($160)>>2)];
 var $162=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$161]($38) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=58;break; } else { label=38;break; }
 case 58: 
 var $163=($162|0)==-1;
 if($163){label=59;break;}else{var $165=$38;label=60;break;}
 case 59: 
 HEAP32[(($19)>>2)]=0;
 var $165=0;label=60;break;
 case 60: 
 var $165;
 var $166=($165|0)==0;
 var $167=($_pre_i3_i_i|0)==0;
 if($167){label=66;break;}else{label=61;break;}
 case 61: 
 var $169=(($_pre_i3_i_i+12)|0);
 var $170=HEAP32[(($169)>>2)];
 var $171=(($_pre_i3_i_i+16)|0);
 var $172=HEAP32[(($171)>>2)];
 var $173=($170|0)==($172|0);
 if($173){label=63;break;}else{label=62;break;}
 case 62: 
 if($166){label=69;break;}else{label=68;break;}
 case 63: 
 var $174=$_pre_i3_i_i;
 var $175=HEAP32[(($174)>>2)];
 var $176=(($175+36)|0);
 var $177=HEAP32[(($176)>>2)];
 var $178=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$177]($_pre_i3_i_i) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=64;break; } else { label=38;break; }
 case 64: 
 var $179=($178|0)==-1;
 if($179){label=65;break;}else{label=67;break;}
 case 65: 
 HEAP32[(($20)>>2)]=0;
 label=66;break;
 case 66: 
 if($166){label=68;break;}else{label=69;break;}
 case 67: 
 var $181=($_pre_i3_i_i|0)==0;
 var $tmp_i_i=$166^$181;
 if($tmp_i_i){label=69;break;}else{label=68;break;}
 case 68: 
 var $183=HEAP32[(($__err)>>2)];
 var $184=$183|2;
 HEAP32[(($__err)>>2)]=$184;
 label=69;break;
 case 69: 
 var $186=(($agg_result)|0);
 HEAP32[(($186)>>2)]=$165;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__buf);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grouping);
 STACKTOP=sp;return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRt($agg_result,$this,$__b,$__e,$__iob,$__err,$__v){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+16)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var tempParam = $__b; $__b=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__b)>>2)]=HEAP32[((tempParam)>>2)];
 var tempParam = $__e; $__e=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];

 var $1=sp;
 var $2=(sp)+(8);
 var $3=(($__b)|0);
 var $4=HEAP32[(($3)>>2)];
 var $5=(($1)|0);
 HEAP32[(($5)>>2)]=$4;
 var $6=(($__e)|0);
 var $7=HEAP32[(($6)>>2)];
 var $8=(($2)|0);
 HEAP32[(($8)>>2)]=$7;
 __ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE17__do_get_unsignedItEES4_S4_S4_RNS_8ios_baseERjRT_($agg_result,0,$1,$2,$__iob,$__err,$__v);
 STACKTOP=sp;return;
}


function __ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE17__do_get_unsignedItEES4_S4_S4_RNS_8ios_baseERjRT_($agg_result,$this,$__b,$__e,$__iob,$__err,$__v){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+256)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var tempParam = $__b; $__b=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__b)>>2)]=HEAP32[((tempParam)>>2)];
 var tempParam = $__e; $__e=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $__atoms=sp;
 var $__thousands_sep=(sp)+(32);
 var $__grouping=(sp)+(40);
 var $__buf=(sp)+(56);
 var $__a_end=(sp)+(72);
 var $__g=(sp)+(80);
 var $__g_end=(sp)+(240);
 var $__dc=(sp)+(248);
 var $1=(($__iob+4)|0);
 var $2=HEAP32[(($1)>>2)];
 var $3=$2&74;
 if(($3|0)==8){ label=2;break;}else if(($3|0)==0){ label=3;break;}else if(($3|0)==64){ var $_0_i=8;label=5;break;}else{label=4;break;}
 case 2: 
 var $_0_i=16;label=5;break;
 case 3: 
 var $_0_i=0;label=5;break;
 case 4: 
 var $_0_i=10;label=5;break;
 case 5: 
 var $_0_i;
 var $7=(($__atoms)|0);
 __ZNSt3__19__num_getIcE17__stage2_int_prepERNS_8ios_baseEPcRc($__grouping,$__iob,$7,$__thousands_sep);
 var $this4_i_i_i=$__buf;
 HEAP32[(($this4_i_i_i)>>2)]=0; HEAP32[((($this4_i_i_i)+(4))>>2)]=0; HEAP32[((($this4_i_i_i)+(8))>>2)]=0;
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc($__buf,10,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=6;break; } else { label=38;break; }
 case 6: 
 var $8=HEAP8[($this4_i_i_i)];
 var $9=$8&1;
 var $10=(($9<<24)>>24)==0;
 if($10){label=8;break;}else{label=7;break;}
 case 7: 
 var $12=(($__buf+8)|0);
 var $13=HEAP32[(($12)>>2)];
 var $_pre43=$__buf;
 var $_pre44=(($_pre43+1)|0);
 var $17=$13;var $_pre_phi45=$_pre44;var $_pre_phi47=$12;label=9;break;
 case 8: 
 var $15=$__buf;
 var $16=(($15+1)|0);
 var $_pre46=(($__buf+8)|0);
 var $17=$16;var $_pre_phi45=$16;var $_pre_phi47=$_pre46;label=9;break;
 case 9: 
 var $_pre_phi47;
 var $_pre_phi45;
 var $17;
 HEAP32[(($__a_end)>>2)]=$17;
 var $18=(($__g)|0);
 HEAP32[(($__g_end)>>2)]=$18;
 HEAP32[(($__dc)>>2)]=0;
 var $19=(($__b)|0);
 var $20=(($__e)|0);
 var $21=(($__buf)|0);
 var $22=(($__buf+4)|0);
 var $23=HEAP8[($__thousands_sep)];
 var $_pre=HEAP32[(($19)>>2)];
 var $__a_0=$17;var $_pre_i_i_i17=$_pre;label=10;break;
 case 10: 
 var $_pre_i_i_i17;
 var $__a_0;
 var $24=($_pre_i_i_i17|0)==0;
 if($24){var $38=0;label=15;break;}else{label=11;break;}
 case 11: 
 var $26=(($_pre_i_i_i17+12)|0);
 var $27=HEAP32[(($26)>>2)];
 var $28=(($_pre_i_i_i17+16)|0);
 var $29=HEAP32[(($28)>>2)];
 var $30=($27|0)==($29|0);
 if($30){label=12;break;}else{var $38=$_pre_i_i_i17;label=15;break;}
 case 12: 
 var $31=$_pre_i_i_i17;
 var $32=HEAP32[(($31)>>2)];
 var $33=(($32+36)|0);
 var $34=HEAP32[(($33)>>2)];
 var $35=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$34]($_pre_i_i_i17) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=13;break; } else { label=37;break; }
 case 13: 
 var $36=($35|0)==-1;
 if($36){label=14;break;}else{var $38=$_pre_i_i_i17;label=15;break;}
 case 14: 
 HEAP32[(($19)>>2)]=0;
 var $38=0;label=15;break;
 case 15: 
 var $38;
 var $39=($38|0)==0;
 var $40=HEAP32[(($20)>>2)];
 var $41=($40|0)==0;
 if($41){label=21;break;}else{label=16;break;}
 case 16: 
 var $43=(($40+12)|0);
 var $44=HEAP32[(($43)>>2)];
 var $45=(($40+16)|0);
 var $46=HEAP32[(($45)>>2)];
 var $47=($44|0)==($46|0);
 if($47){label=18;break;}else{label=17;break;}
 case 17: 
 if($39){var $56=$40;label=23;break;}else{var $__a_2=$__a_0;var $_pre_i3_i_i=$40;label=48;break;}
 case 18: 
 var $48=$40;
 var $49=HEAP32[(($48)>>2)];
 var $50=(($49+36)|0);
 var $51=HEAP32[(($50)>>2)];
 var $52=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$51]($40) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=19;break; } else { label=37;break; }
 case 19: 
 var $53=($52|0)==-1;
 if($53){label=20;break;}else{label=22;break;}
 case 20: 
 HEAP32[(($20)>>2)]=0;
 label=21;break;
 case 21: 
 if($39){var $__a_2=$__a_0;var $_pre_i3_i_i=0;label=48;break;}else{var $56=0;label=23;break;}
 case 22: 
 if($39){var $56=$40;label=23;break;}else{var $__a_2=$__a_0;var $_pre_i3_i_i=$40;label=48;break;}
 case 23: 
 var $56;
 var $57=HEAP32[(($__a_end)>>2)];
 var $58=$57;
 var $59=$__a_0;
 var $60=((($58)-($59))|0);
 var $61=HEAP8[($this4_i_i_i)];
 var $62=$61&1;
 var $63=(($62<<24)>>24)==0;
 if($63){label=25;break;}else{label=24;break;}
 case 24: 
 var $65=HEAP32[(($22)>>2)];
 var $69=$65;label=26;break;
 case 25: 
 var $67=($61&255);
 var $68=$67>>>1;
 var $69=$68;label=26;break;
 case 26: 
 var $69;
 var $70=($60|0)==($69|0);
 if($70){label=27;break;}else{var $__a_1=$__a_0;label=40;break;}
 case 27: 
 if($63){label=29;break;}else{label=28;break;}
 case 28: 
 var $73=HEAP32[(($22)>>2)];
 var $80=$73;var $79=$73;label=30;break;
 case 29: 
 var $75=($61&255);
 var $76=$75>>>1;
 var $77=($61&255);
 var $78=$77>>>1;
 var $80=$78;var $79=$76;label=30;break;
 case 30: 
 var $79;
 var $80;
 var $81=$80<<1;
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc($__buf,$81,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=31;break; } else { label=37;break; }
 case 31: 
 var $82=HEAP8[($this4_i_i_i)];
 var $83=$82&1;
 var $84=(($83<<24)>>24)==0;
 if($84){var $88=10;label=33;break;}else{label=32;break;}
 case 32: 
 var $86=HEAP32[(($21)>>2)];
 var $87=$86&-2;
 var $phitmp_i32=((($87)-(1))|0);
 var $88=$phitmp_i32;label=33;break;
 case 33: 
 var $88;
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc($__buf,$88,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=34;break; } else { label=37;break; }
 case 34: 
 var $89=HEAP8[($this4_i_i_i)];
 var $90=$89&1;
 var $91=(($90<<24)>>24)==0;
 if($91){var $94=$_pre_phi45;label=36;break;}else{label=35;break;}
 case 35: 
 var $93=HEAP32[(($_pre_phi47)>>2)];
 var $94=$93;label=36;break;
 case 36: 
 var $94;
 var $95=(($94+$79)|0);
 HEAP32[(($__a_end)>>2)]=$95;
 var $__a_1=$94;label=40;break;
 case 37: 
 var $lpad_loopexit$0 = ___cxa_find_matching_catch(-1, -1); var $lpad_loopexit$1 = tempRet0;
 var $lpad_phi$1=$lpad_loopexit$1;var $lpad_phi$0=$lpad_loopexit$0;label=39;break;
 case 38: 
 var $lpad_nonloopexit$0 = ___cxa_find_matching_catch(-1, -1); var $lpad_nonloopexit$1 = tempRet0;
 var $lpad_phi$1=$lpad_nonloopexit$1;var $lpad_phi$0=$lpad_nonloopexit$0;label=39;break;
 case 39: 
 var $lpad_phi$0;
 var $lpad_phi$1;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__buf);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grouping);
 ___resumeException($lpad_phi$0)
 case 40: 
 var $__a_1;
 var $97=(($38+12)|0);
 var $98=HEAP32[(($97)>>2)];
 var $99=(($38+16)|0);
 var $100=HEAP32[(($99)>>2)];
 var $101=($98|0)==($100|0);
 if($101){label=41;break;}else{label=43;break;}
 case 41: 
 var $103=$38;
 var $104=HEAP32[(($103)>>2)];
 var $105=(($104+36)|0);
 var $106=HEAP32[(($105)>>2)];
 var $107=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$106]($38) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=42;break; } else { label=37;break; }
 case 42: 
 var $extract_t_i=(($107)&255);
 var $_0_i_off0_i=$extract_t_i;label=44;break;
 case 43: 
 var $109=HEAP8[($98)];
 var $_0_i_off0_i=$109;label=44;break;
 case 44: 
 var $_0_i_off0_i;
 var $111=__ZNSt3__19__num_getIcE17__stage2_int_loopEciPcRS2_RjcRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSD_S2_($_0_i_off0_i,$_0_i,$__a_1,$__a_end,$__dc,$23,$__grouping,$18,$__g_end,$7);
 var $112=($111|0)==0;
 if($112){label=45;break;}else{var $__a_2=$__a_1;var $_pre_i3_i_i=$56;label=48;break;}
 case 45: 
 var $114=HEAP32[(($97)>>2)];
 var $115=HEAP32[(($99)>>2)];
 var $116=($114|0)==($115|0);
 if($116){label=46;break;}else{label=47;break;}
 case 46: 
 var $118=$38;
 var $119=HEAP32[(($118)>>2)];
 var $120=(($119+40)|0);
 var $121=HEAP32[(($120)>>2)];
 var $122=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$121]($38) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $__a_0=$__a_1;var $_pre_i_i_i17=$38;label=10;break; } else { label=37;break; }
 case 47: 
 var $124=(($114+1)|0);
 HEAP32[(($97)>>2)]=$124;
 var $__a_0=$__a_1;var $_pre_i_i_i17=$38;label=10;break;
 case 48: 
 var $_pre_i3_i_i;
 var $__a_2;
 var $126=$__grouping;
 var $127=HEAP8[($126)];
 var $128=$127&1;
 var $129=(($128<<24)>>24)==0;
 if($129){label=50;break;}else{label=49;break;}
 case 49: 
 var $131=(($__grouping+4)|0);
 var $132=HEAP32[(($131)>>2)];
 var $136=$132;label=51;break;
 case 50: 
 var $134=($127&255);
 var $135=$134>>>1;
 var $136=$135;label=51;break;
 case 51: 
 var $136;
 var $137=($136|0)==0;
 if($137){label=54;break;}else{label=52;break;}
 case 52: 
 var $139=HEAP32[(($__g_end)>>2)];
 var $140=$139;
 var $141=$__g;
 var $142=((($140)-($141))|0);
 var $143=($142|0)<160;
 if($143){label=53;break;}else{label=54;break;}
 case 53: 
 var $145=HEAP32[(($__dc)>>2)];
 var $146=(($139+4)|0);
 HEAP32[(($__g_end)>>2)]=$146;
 HEAP32[(($139)>>2)]=$145;
 label=54;break;
 case 54: 
 var $147=HEAP32[(($__a_end)>>2)];
 var $148=(function() { try { __THREW__ = 0; return __ZNSt3__127__num_get_unsigned_integralItEET_PKcS3_Rji($__a_2,$147,$__err,$_0_i) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=55;break; } else { label=38;break; }
 case 55: 
 HEAP16[(($__v)>>1)]=$148;
 var $150=HEAP32[(($__g_end)>>2)];
 __ZNSt3__116__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj($__grouping,$18,$150,$__err);
 var $151=($38|0)==0;
 if($151){var $165=0;label=60;break;}else{label=56;break;}
 case 56: 
 var $153=(($38+12)|0);
 var $154=HEAP32[(($153)>>2)];
 var $155=(($38+16)|0);
 var $156=HEAP32[(($155)>>2)];
 var $157=($154|0)==($156|0);
 if($157){label=57;break;}else{var $165=$38;label=60;break;}
 case 57: 
 var $158=$38;
 var $159=HEAP32[(($158)>>2)];
 var $160=(($159+36)|0);
 var $161=HEAP32[(($160)>>2)];
 var $162=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$161]($38) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=58;break; } else { label=38;break; }
 case 58: 
 var $163=($162|0)==-1;
 if($163){label=59;break;}else{var $165=$38;label=60;break;}
 case 59: 
 HEAP32[(($19)>>2)]=0;
 var $165=0;label=60;break;
 case 60: 
 var $165;
 var $166=($165|0)==0;
 var $167=($_pre_i3_i_i|0)==0;
 if($167){label=66;break;}else{label=61;break;}
 case 61: 
 var $169=(($_pre_i3_i_i+12)|0);
 var $170=HEAP32[(($169)>>2)];
 var $171=(($_pre_i3_i_i+16)|0);
 var $172=HEAP32[(($171)>>2)];
 var $173=($170|0)==($172|0);
 if($173){label=63;break;}else{label=62;break;}
 case 62: 
 if($166){label=69;break;}else{label=68;break;}
 case 63: 
 var $174=$_pre_i3_i_i;
 var $175=HEAP32[(($174)>>2)];
 var $176=(($175+36)|0);
 var $177=HEAP32[(($176)>>2)];
 var $178=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$177]($_pre_i3_i_i) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=64;break; } else { label=38;break; }
 case 64: 
 var $179=($178|0)==-1;
 if($179){label=65;break;}else{label=67;break;}
 case 65: 
 HEAP32[(($20)>>2)]=0;
 label=66;break;
 case 66: 
 if($166){label=68;break;}else{label=69;break;}
 case 67: 
 var $181=($_pre_i3_i_i|0)==0;
 var $tmp_i_i=$166^$181;
 if($tmp_i_i){label=69;break;}else{label=68;break;}
 case 68: 
 var $183=HEAP32[(($__err)>>2)];
 var $184=$183|2;
 HEAP32[(($__err)>>2)]=$184;
 label=69;break;
 case 69: 
 var $186=(($agg_result)|0);
 HEAP32[(($186)>>2)]=$165;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__buf);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grouping);
 STACKTOP=sp;return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjS8_($agg_result,$this,$__b,$__e,$__iob,$__err,$__v){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+16)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var tempParam = $__b; $__b=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__b)>>2)]=HEAP32[((tempParam)>>2)];
 var tempParam = $__e; $__e=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];

 var $1=sp;
 var $2=(sp)+(8);
 var $3=(($__b)|0);
 var $4=HEAP32[(($3)>>2)];
 var $5=(($1)|0);
 HEAP32[(($5)>>2)]=$4;
 var $6=(($__e)|0);
 var $7=HEAP32[(($6)>>2)];
 var $8=(($2)|0);
 HEAP32[(($8)>>2)]=$7;
 __ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE17__do_get_unsignedIjEES4_S4_S4_RNS_8ios_baseERjRT_($agg_result,0,$1,$2,$__iob,$__err,$__v);
 STACKTOP=sp;return;
}


function __ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE17__do_get_unsignedIjEES4_S4_S4_RNS_8ios_baseERjRT_($agg_result,$this,$__b,$__e,$__iob,$__err,$__v){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+256)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var tempParam = $__b; $__b=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__b)>>2)]=HEAP32[((tempParam)>>2)];
 var tempParam = $__e; $__e=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $__atoms=sp;
 var $__thousands_sep=(sp)+(32);
 var $__grouping=(sp)+(40);
 var $__buf=(sp)+(56);
 var $__a_end=(sp)+(72);
 var $__g=(sp)+(80);
 var $__g_end=(sp)+(240);
 var $__dc=(sp)+(248);
 var $1=(($__iob+4)|0);
 var $2=HEAP32[(($1)>>2)];
 var $3=$2&74;
 if(($3|0)==8){ label=2;break;}else if(($3|0)==0){ label=3;break;}else if(($3|0)==64){ var $_0_i=8;label=5;break;}else{label=4;break;}
 case 2: 
 var $_0_i=16;label=5;break;
 case 3: 
 var $_0_i=0;label=5;break;
 case 4: 
 var $_0_i=10;label=5;break;
 case 5: 
 var $_0_i;
 var $7=(($__atoms)|0);
 __ZNSt3__19__num_getIcE17__stage2_int_prepERNS_8ios_baseEPcRc($__grouping,$__iob,$7,$__thousands_sep);
 var $this4_i_i_i=$__buf;
 HEAP32[(($this4_i_i_i)>>2)]=0; HEAP32[((($this4_i_i_i)+(4))>>2)]=0; HEAP32[((($this4_i_i_i)+(8))>>2)]=0;
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc($__buf,10,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=6;break; } else { label=38;break; }
 case 6: 
 var $8=HEAP8[($this4_i_i_i)];
 var $9=$8&1;
 var $10=(($9<<24)>>24)==0;
 if($10){label=8;break;}else{label=7;break;}
 case 7: 
 var $12=(($__buf+8)|0);
 var $13=HEAP32[(($12)>>2)];
 var $_pre43=$__buf;
 var $_pre44=(($_pre43+1)|0);
 var $17=$13;var $_pre_phi45=$_pre44;var $_pre_phi47=$12;label=9;break;
 case 8: 
 var $15=$__buf;
 var $16=(($15+1)|0);
 var $_pre46=(($__buf+8)|0);
 var $17=$16;var $_pre_phi45=$16;var $_pre_phi47=$_pre46;label=9;break;
 case 9: 
 var $_pre_phi47;
 var $_pre_phi45;
 var $17;
 HEAP32[(($__a_end)>>2)]=$17;
 var $18=(($__g)|0);
 HEAP32[(($__g_end)>>2)]=$18;
 HEAP32[(($__dc)>>2)]=0;
 var $19=(($__b)|0);
 var $20=(($__e)|0);
 var $21=(($__buf)|0);
 var $22=(($__buf+4)|0);
 var $23=HEAP8[($__thousands_sep)];
 var $_pre=HEAP32[(($19)>>2)];
 var $__a_0=$17;var $_pre_i_i_i17=$_pre;label=10;break;
 case 10: 
 var $_pre_i_i_i17;
 var $__a_0;
 var $24=($_pre_i_i_i17|0)==0;
 if($24){var $38=0;label=15;break;}else{label=11;break;}
 case 11: 
 var $26=(($_pre_i_i_i17+12)|0);
 var $27=HEAP32[(($26)>>2)];
 var $28=(($_pre_i_i_i17+16)|0);
 var $29=HEAP32[(($28)>>2)];
 var $30=($27|0)==($29|0);
 if($30){label=12;break;}else{var $38=$_pre_i_i_i17;label=15;break;}
 case 12: 
 var $31=$_pre_i_i_i17;
 var $32=HEAP32[(($31)>>2)];
 var $33=(($32+36)|0);
 var $34=HEAP32[(($33)>>2)];
 var $35=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$34]($_pre_i_i_i17) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=13;break; } else { label=37;break; }
 case 13: 
 var $36=($35|0)==-1;
 if($36){label=14;break;}else{var $38=$_pre_i_i_i17;label=15;break;}
 case 14: 
 HEAP32[(($19)>>2)]=0;
 var $38=0;label=15;break;
 case 15: 
 var $38;
 var $39=($38|0)==0;
 var $40=HEAP32[(($20)>>2)];
 var $41=($40|0)==0;
 if($41){label=21;break;}else{label=16;break;}
 case 16: 
 var $43=(($40+12)|0);
 var $44=HEAP32[(($43)>>2)];
 var $45=(($40+16)|0);
 var $46=HEAP32[(($45)>>2)];
 var $47=($44|0)==($46|0);
 if($47){label=18;break;}else{label=17;break;}
 case 17: 
 if($39){var $56=$40;label=23;break;}else{var $__a_2=$__a_0;var $_pre_i3_i_i=$40;label=48;break;}
 case 18: 
 var $48=$40;
 var $49=HEAP32[(($48)>>2)];
 var $50=(($49+36)|0);
 var $51=HEAP32[(($50)>>2)];
 var $52=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$51]($40) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=19;break; } else { label=37;break; }
 case 19: 
 var $53=($52|0)==-1;
 if($53){label=20;break;}else{label=22;break;}
 case 20: 
 HEAP32[(($20)>>2)]=0;
 label=21;break;
 case 21: 
 if($39){var $__a_2=$__a_0;var $_pre_i3_i_i=0;label=48;break;}else{var $56=0;label=23;break;}
 case 22: 
 if($39){var $56=$40;label=23;break;}else{var $__a_2=$__a_0;var $_pre_i3_i_i=$40;label=48;break;}
 case 23: 
 var $56;
 var $57=HEAP32[(($__a_end)>>2)];
 var $58=$57;
 var $59=$__a_0;
 var $60=((($58)-($59))|0);
 var $61=HEAP8[($this4_i_i_i)];
 var $62=$61&1;
 var $63=(($62<<24)>>24)==0;
 if($63){label=25;break;}else{label=24;break;}
 case 24: 
 var $65=HEAP32[(($22)>>2)];
 var $69=$65;label=26;break;
 case 25: 
 var $67=($61&255);
 var $68=$67>>>1;
 var $69=$68;label=26;break;
 case 26: 
 var $69;
 var $70=($60|0)==($69|0);
 if($70){label=27;break;}else{var $__a_1=$__a_0;label=40;break;}
 case 27: 
 if($63){label=29;break;}else{label=28;break;}
 case 28: 
 var $73=HEAP32[(($22)>>2)];
 var $80=$73;var $79=$73;label=30;break;
 case 29: 
 var $75=($61&255);
 var $76=$75>>>1;
 var $77=($61&255);
 var $78=$77>>>1;
 var $80=$78;var $79=$76;label=30;break;
 case 30: 
 var $79;
 var $80;
 var $81=$80<<1;
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc($__buf,$81,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=31;break; } else { label=37;break; }
 case 31: 
 var $82=HEAP8[($this4_i_i_i)];
 var $83=$82&1;
 var $84=(($83<<24)>>24)==0;
 if($84){var $88=10;label=33;break;}else{label=32;break;}
 case 32: 
 var $86=HEAP32[(($21)>>2)];
 var $87=$86&-2;
 var $phitmp_i32=((($87)-(1))|0);
 var $88=$phitmp_i32;label=33;break;
 case 33: 
 var $88;
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc($__buf,$88,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=34;break; } else { label=37;break; }
 case 34: 
 var $89=HEAP8[($this4_i_i_i)];
 var $90=$89&1;
 var $91=(($90<<24)>>24)==0;
 if($91){var $94=$_pre_phi45;label=36;break;}else{label=35;break;}
 case 35: 
 var $93=HEAP32[(($_pre_phi47)>>2)];
 var $94=$93;label=36;break;
 case 36: 
 var $94;
 var $95=(($94+$79)|0);
 HEAP32[(($__a_end)>>2)]=$95;
 var $__a_1=$94;label=40;break;
 case 37: 
 var $lpad_loopexit$0 = ___cxa_find_matching_catch(-1, -1); var $lpad_loopexit$1 = tempRet0;
 var $lpad_phi$1=$lpad_loopexit$1;var $lpad_phi$0=$lpad_loopexit$0;label=39;break;
 case 38: 
 var $lpad_nonloopexit$0 = ___cxa_find_matching_catch(-1, -1); var $lpad_nonloopexit$1 = tempRet0;
 var $lpad_phi$1=$lpad_nonloopexit$1;var $lpad_phi$0=$lpad_nonloopexit$0;label=39;break;
 case 39: 
 var $lpad_phi$0;
 var $lpad_phi$1;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__buf);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grouping);
 ___resumeException($lpad_phi$0)
 case 40: 
 var $__a_1;
 var $97=(($38+12)|0);
 var $98=HEAP32[(($97)>>2)];
 var $99=(($38+16)|0);
 var $100=HEAP32[(($99)>>2)];
 var $101=($98|0)==($100|0);
 if($101){label=41;break;}else{label=43;break;}
 case 41: 
 var $103=$38;
 var $104=HEAP32[(($103)>>2)];
 var $105=(($104+36)|0);
 var $106=HEAP32[(($105)>>2)];
 var $107=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$106]($38) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=42;break; } else { label=37;break; }
 case 42: 
 var $extract_t_i=(($107)&255);
 var $_0_i_off0_i=$extract_t_i;label=44;break;
 case 43: 
 var $109=HEAP8[($98)];
 var $_0_i_off0_i=$109;label=44;break;
 case 44: 
 var $_0_i_off0_i;
 var $111=__ZNSt3__19__num_getIcE17__stage2_int_loopEciPcRS2_RjcRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSD_S2_($_0_i_off0_i,$_0_i,$__a_1,$__a_end,$__dc,$23,$__grouping,$18,$__g_end,$7);
 var $112=($111|0)==0;
 if($112){label=45;break;}else{var $__a_2=$__a_1;var $_pre_i3_i_i=$56;label=48;break;}
 case 45: 
 var $114=HEAP32[(($97)>>2)];
 var $115=HEAP32[(($99)>>2)];
 var $116=($114|0)==($115|0);
 if($116){label=46;break;}else{label=47;break;}
 case 46: 
 var $118=$38;
 var $119=HEAP32[(($118)>>2)];
 var $120=(($119+40)|0);
 var $121=HEAP32[(($120)>>2)];
 var $122=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$121]($38) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $__a_0=$__a_1;var $_pre_i_i_i17=$38;label=10;break; } else { label=37;break; }
 case 47: 
 var $124=(($114+1)|0);
 HEAP32[(($97)>>2)]=$124;
 var $__a_0=$__a_1;var $_pre_i_i_i17=$38;label=10;break;
 case 48: 
 var $_pre_i3_i_i;
 var $__a_2;
 var $126=$__grouping;
 var $127=HEAP8[($126)];
 var $128=$127&1;
 var $129=(($128<<24)>>24)==0;
 if($129){label=50;break;}else{label=49;break;}
 case 49: 
 var $131=(($__grouping+4)|0);
 var $132=HEAP32[(($131)>>2)];
 var $136=$132;label=51;break;
 case 50: 
 var $134=($127&255);
 var $135=$134>>>1;
 var $136=$135;label=51;break;
 case 51: 
 var $136;
 var $137=($136|0)==0;
 if($137){label=54;break;}else{label=52;break;}
 case 52: 
 var $139=HEAP32[(($__g_end)>>2)];
 var $140=$139;
 var $141=$__g;
 var $142=((($140)-($141))|0);
 var $143=($142|0)<160;
 if($143){label=53;break;}else{label=54;break;}
 case 53: 
 var $145=HEAP32[(($__dc)>>2)];
 var $146=(($139+4)|0);
 HEAP32[(($__g_end)>>2)]=$146;
 HEAP32[(($139)>>2)]=$145;
 label=54;break;
 case 54: 
 var $147=HEAP32[(($__a_end)>>2)];
 var $148=(function() { try { __THREW__ = 0; return __ZNSt3__127__num_get_unsigned_integralIjEET_PKcS3_Rji($__a_2,$147,$__err,$_0_i) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=55;break; } else { label=38;break; }
 case 55: 
 HEAP32[(($__v)>>2)]=$148;
 var $150=HEAP32[(($__g_end)>>2)];
 __ZNSt3__116__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj($__grouping,$18,$150,$__err);
 var $151=($38|0)==0;
 if($151){var $165=0;label=60;break;}else{label=56;break;}
 case 56: 
 var $153=(($38+12)|0);
 var $154=HEAP32[(($153)>>2)];
 var $155=(($38+16)|0);
 var $156=HEAP32[(($155)>>2)];
 var $157=($154|0)==($156|0);
 if($157){label=57;break;}else{var $165=$38;label=60;break;}
 case 57: 
 var $158=$38;
 var $159=HEAP32[(($158)>>2)];
 var $160=(($159+36)|0);
 var $161=HEAP32[(($160)>>2)];
 var $162=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$161]($38) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=58;break; } else { label=38;break; }
 case 58: 
 var $163=($162|0)==-1;
 if($163){label=59;break;}else{var $165=$38;label=60;break;}
 case 59: 
 HEAP32[(($19)>>2)]=0;
 var $165=0;label=60;break;
 case 60: 
 var $165;
 var $166=($165|0)==0;
 var $167=($_pre_i3_i_i|0)==0;
 if($167){label=66;break;}else{label=61;break;}
 case 61: 
 var $169=(($_pre_i3_i_i+12)|0);
 var $170=HEAP32[(($169)>>2)];
 var $171=(($_pre_i3_i_i+16)|0);
 var $172=HEAP32[(($171)>>2)];
 var $173=($170|0)==($172|0);
 if($173){label=63;break;}else{label=62;break;}
 case 62: 
 if($166){label=69;break;}else{label=68;break;}
 case 63: 
 var $174=$_pre_i3_i_i;
 var $175=HEAP32[(($174)>>2)];
 var $176=(($175+36)|0);
 var $177=HEAP32[(($176)>>2)];
 var $178=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$177]($_pre_i3_i_i) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=64;break; } else { label=38;break; }
 case 64: 
 var $179=($178|0)==-1;
 if($179){label=65;break;}else{label=67;break;}
 case 65: 
 HEAP32[(($20)>>2)]=0;
 label=66;break;
 case 66: 
 if($166){label=68;break;}else{label=69;break;}
 case 67: 
 var $181=($_pre_i3_i_i|0)==0;
 var $tmp_i_i=$166^$181;
 if($tmp_i_i){label=69;break;}else{label=68;break;}
 case 68: 
 var $183=HEAP32[(($__err)>>2)];
 var $184=$183|2;
 HEAP32[(($__err)>>2)]=$184;
 label=69;break;
 case 69: 
 var $186=(($agg_result)|0);
 HEAP32[(($186)>>2)]=$165;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__buf);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grouping);
 STACKTOP=sp;return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRm($agg_result,$this,$__b,$__e,$__iob,$__err,$__v){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+16)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var tempParam = $__b; $__b=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__b)>>2)]=HEAP32[((tempParam)>>2)];
 var tempParam = $__e; $__e=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];

 var $1=sp;
 var $2=(sp)+(8);
 var $3=(($__b)|0);
 var $4=HEAP32[(($3)>>2)];
 var $5=(($1)|0);
 HEAP32[(($5)>>2)]=$4;
 var $6=(($__e)|0);
 var $7=HEAP32[(($6)>>2)];
 var $8=(($2)|0);
 HEAP32[(($8)>>2)]=$7;
 __ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE17__do_get_unsignedImEES4_S4_S4_RNS_8ios_baseERjRT_($agg_result,0,$1,$2,$__iob,$__err,$__v);
 STACKTOP=sp;return;
}


function __ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE17__do_get_unsignedImEES4_S4_S4_RNS_8ios_baseERjRT_($agg_result,$this,$__b,$__e,$__iob,$__err,$__v){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+256)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var tempParam = $__b; $__b=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__b)>>2)]=HEAP32[((tempParam)>>2)];
 var tempParam = $__e; $__e=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $__atoms=sp;
 var $__thousands_sep=(sp)+(32);
 var $__grouping=(sp)+(40);
 var $__buf=(sp)+(56);
 var $__a_end=(sp)+(72);
 var $__g=(sp)+(80);
 var $__g_end=(sp)+(240);
 var $__dc=(sp)+(248);
 var $1=(($__iob+4)|0);
 var $2=HEAP32[(($1)>>2)];
 var $3=$2&74;
 if(($3|0)==8){ label=2;break;}else if(($3|0)==0){ label=3;break;}else if(($3|0)==64){ var $_0_i=8;label=5;break;}else{label=4;break;}
 case 2: 
 var $_0_i=16;label=5;break;
 case 3: 
 var $_0_i=0;label=5;break;
 case 4: 
 var $_0_i=10;label=5;break;
 case 5: 
 var $_0_i;
 var $7=(($__atoms)|0);
 __ZNSt3__19__num_getIcE17__stage2_int_prepERNS_8ios_baseEPcRc($__grouping,$__iob,$7,$__thousands_sep);
 var $this4_i_i_i=$__buf;
 HEAP32[(($this4_i_i_i)>>2)]=0; HEAP32[((($this4_i_i_i)+(4))>>2)]=0; HEAP32[((($this4_i_i_i)+(8))>>2)]=0;
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc($__buf,10,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=6;break; } else { label=38;break; }
 case 6: 
 var $8=HEAP8[($this4_i_i_i)];
 var $9=$8&1;
 var $10=(($9<<24)>>24)==0;
 if($10){label=8;break;}else{label=7;break;}
 case 7: 
 var $12=(($__buf+8)|0);
 var $13=HEAP32[(($12)>>2)];
 var $_pre43=$__buf;
 var $_pre44=(($_pre43+1)|0);
 var $17=$13;var $_pre_phi45=$_pre44;var $_pre_phi47=$12;label=9;break;
 case 8: 
 var $15=$__buf;
 var $16=(($15+1)|0);
 var $_pre46=(($__buf+8)|0);
 var $17=$16;var $_pre_phi45=$16;var $_pre_phi47=$_pre46;label=9;break;
 case 9: 
 var $_pre_phi47;
 var $_pre_phi45;
 var $17;
 HEAP32[(($__a_end)>>2)]=$17;
 var $18=(($__g)|0);
 HEAP32[(($__g_end)>>2)]=$18;
 HEAP32[(($__dc)>>2)]=0;
 var $19=(($__b)|0);
 var $20=(($__e)|0);
 var $21=(($__buf)|0);
 var $22=(($__buf+4)|0);
 var $23=HEAP8[($__thousands_sep)];
 var $_pre=HEAP32[(($19)>>2)];
 var $__a_0=$17;var $_pre_i_i_i17=$_pre;label=10;break;
 case 10: 
 var $_pre_i_i_i17;
 var $__a_0;
 var $24=($_pre_i_i_i17|0)==0;
 if($24){var $38=0;label=15;break;}else{label=11;break;}
 case 11: 
 var $26=(($_pre_i_i_i17+12)|0);
 var $27=HEAP32[(($26)>>2)];
 var $28=(($_pre_i_i_i17+16)|0);
 var $29=HEAP32[(($28)>>2)];
 var $30=($27|0)==($29|0);
 if($30){label=12;break;}else{var $38=$_pre_i_i_i17;label=15;break;}
 case 12: 
 var $31=$_pre_i_i_i17;
 var $32=HEAP32[(($31)>>2)];
 var $33=(($32+36)|0);
 var $34=HEAP32[(($33)>>2)];
 var $35=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$34]($_pre_i_i_i17) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=13;break; } else { label=37;break; }
 case 13: 
 var $36=($35|0)==-1;
 if($36){label=14;break;}else{var $38=$_pre_i_i_i17;label=15;break;}
 case 14: 
 HEAP32[(($19)>>2)]=0;
 var $38=0;label=15;break;
 case 15: 
 var $38;
 var $39=($38|0)==0;
 var $40=HEAP32[(($20)>>2)];
 var $41=($40|0)==0;
 if($41){label=21;break;}else{label=16;break;}
 case 16: 
 var $43=(($40+12)|0);
 var $44=HEAP32[(($43)>>2)];
 var $45=(($40+16)|0);
 var $46=HEAP32[(($45)>>2)];
 var $47=($44|0)==($46|0);
 if($47){label=18;break;}else{label=17;break;}
 case 17: 
 if($39){var $56=$40;label=23;break;}else{var $__a_2=$__a_0;var $_pre_i3_i_i=$40;label=48;break;}
 case 18: 
 var $48=$40;
 var $49=HEAP32[(($48)>>2)];
 var $50=(($49+36)|0);
 var $51=HEAP32[(($50)>>2)];
 var $52=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$51]($40) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=19;break; } else { label=37;break; }
 case 19: 
 var $53=($52|0)==-1;
 if($53){label=20;break;}else{label=22;break;}
 case 20: 
 HEAP32[(($20)>>2)]=0;
 label=21;break;
 case 21: 
 if($39){var $__a_2=$__a_0;var $_pre_i3_i_i=0;label=48;break;}else{var $56=0;label=23;break;}
 case 22: 
 if($39){var $56=$40;label=23;break;}else{var $__a_2=$__a_0;var $_pre_i3_i_i=$40;label=48;break;}
 case 23: 
 var $56;
 var $57=HEAP32[(($__a_end)>>2)];
 var $58=$57;
 var $59=$__a_0;
 var $60=((($58)-($59))|0);
 var $61=HEAP8[($this4_i_i_i)];
 var $62=$61&1;
 var $63=(($62<<24)>>24)==0;
 if($63){label=25;break;}else{label=24;break;}
 case 24: 
 var $65=HEAP32[(($22)>>2)];
 var $69=$65;label=26;break;
 case 25: 
 var $67=($61&255);
 var $68=$67>>>1;
 var $69=$68;label=26;break;
 case 26: 
 var $69;
 var $70=($60|0)==($69|0);
 if($70){label=27;break;}else{var $__a_1=$__a_0;label=40;break;}
 case 27: 
 if($63){label=29;break;}else{label=28;break;}
 case 28: 
 var $73=HEAP32[(($22)>>2)];
 var $80=$73;var $79=$73;label=30;break;
 case 29: 
 var $75=($61&255);
 var $76=$75>>>1;
 var $77=($61&255);
 var $78=$77>>>1;
 var $80=$78;var $79=$76;label=30;break;
 case 30: 
 var $79;
 var $80;
 var $81=$80<<1;
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc($__buf,$81,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=31;break; } else { label=37;break; }
 case 31: 
 var $82=HEAP8[($this4_i_i_i)];
 var $83=$82&1;
 var $84=(($83<<24)>>24)==0;
 if($84){var $88=10;label=33;break;}else{label=32;break;}
 case 32: 
 var $86=HEAP32[(($21)>>2)];
 var $87=$86&-2;
 var $phitmp_i32=((($87)-(1))|0);
 var $88=$phitmp_i32;label=33;break;
 case 33: 
 var $88;
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc($__buf,$88,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=34;break; } else { label=37;break; }
 case 34: 
 var $89=HEAP8[($this4_i_i_i)];
 var $90=$89&1;
 var $91=(($90<<24)>>24)==0;
 if($91){var $94=$_pre_phi45;label=36;break;}else{label=35;break;}
 case 35: 
 var $93=HEAP32[(($_pre_phi47)>>2)];
 var $94=$93;label=36;break;
 case 36: 
 var $94;
 var $95=(($94+$79)|0);
 HEAP32[(($__a_end)>>2)]=$95;
 var $__a_1=$94;label=40;break;
 case 37: 
 var $lpad_loopexit$0 = ___cxa_find_matching_catch(-1, -1); var $lpad_loopexit$1 = tempRet0;
 var $lpad_phi$1=$lpad_loopexit$1;var $lpad_phi$0=$lpad_loopexit$0;label=39;break;
 case 38: 
 var $lpad_nonloopexit$0 = ___cxa_find_matching_catch(-1, -1); var $lpad_nonloopexit$1 = tempRet0;
 var $lpad_phi$1=$lpad_nonloopexit$1;var $lpad_phi$0=$lpad_nonloopexit$0;label=39;break;
 case 39: 
 var $lpad_phi$0;
 var $lpad_phi$1;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__buf);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grouping);
 ___resumeException($lpad_phi$0)
 case 40: 
 var $__a_1;
 var $97=(($38+12)|0);
 var $98=HEAP32[(($97)>>2)];
 var $99=(($38+16)|0);
 var $100=HEAP32[(($99)>>2)];
 var $101=($98|0)==($100|0);
 if($101){label=41;break;}else{label=43;break;}
 case 41: 
 var $103=$38;
 var $104=HEAP32[(($103)>>2)];
 var $105=(($104+36)|0);
 var $106=HEAP32[(($105)>>2)];
 var $107=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$106]($38) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=42;break; } else { label=37;break; }
 case 42: 
 var $extract_t_i=(($107)&255);
 var $_0_i_off0_i=$extract_t_i;label=44;break;
 case 43: 
 var $109=HEAP8[($98)];
 var $_0_i_off0_i=$109;label=44;break;
 case 44: 
 var $_0_i_off0_i;
 var $111=__ZNSt3__19__num_getIcE17__stage2_int_loopEciPcRS2_RjcRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSD_S2_($_0_i_off0_i,$_0_i,$__a_1,$__a_end,$__dc,$23,$__grouping,$18,$__g_end,$7);
 var $112=($111|0)==0;
 if($112){label=45;break;}else{var $__a_2=$__a_1;var $_pre_i3_i_i=$56;label=48;break;}
 case 45: 
 var $114=HEAP32[(($97)>>2)];
 var $115=HEAP32[(($99)>>2)];
 var $116=($114|0)==($115|0);
 if($116){label=46;break;}else{label=47;break;}
 case 46: 
 var $118=$38;
 var $119=HEAP32[(($118)>>2)];
 var $120=(($119+40)|0);
 var $121=HEAP32[(($120)>>2)];
 var $122=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$121]($38) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $__a_0=$__a_1;var $_pre_i_i_i17=$38;label=10;break; } else { label=37;break; }
 case 47: 
 var $124=(($114+1)|0);
 HEAP32[(($97)>>2)]=$124;
 var $__a_0=$__a_1;var $_pre_i_i_i17=$38;label=10;break;
 case 48: 
 var $_pre_i3_i_i;
 var $__a_2;
 var $126=$__grouping;
 var $127=HEAP8[($126)];
 var $128=$127&1;
 var $129=(($128<<24)>>24)==0;
 if($129){label=50;break;}else{label=49;break;}
 case 49: 
 var $131=(($__grouping+4)|0);
 var $132=HEAP32[(($131)>>2)];
 var $136=$132;label=51;break;
 case 50: 
 var $134=($127&255);
 var $135=$134>>>1;
 var $136=$135;label=51;break;
 case 51: 
 var $136;
 var $137=($136|0)==0;
 if($137){label=54;break;}else{label=52;break;}
 case 52: 
 var $139=HEAP32[(($__g_end)>>2)];
 var $140=$139;
 var $141=$__g;
 var $142=((($140)-($141))|0);
 var $143=($142|0)<160;
 if($143){label=53;break;}else{label=54;break;}
 case 53: 
 var $145=HEAP32[(($__dc)>>2)];
 var $146=(($139+4)|0);
 HEAP32[(($__g_end)>>2)]=$146;
 HEAP32[(($139)>>2)]=$145;
 label=54;break;
 case 54: 
 var $147=HEAP32[(($__a_end)>>2)];
 var $148=(function() { try { __THREW__ = 0; return __ZNSt3__127__num_get_unsigned_integralImEET_PKcS3_Rji($__a_2,$147,$__err,$_0_i) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=55;break; } else { label=38;break; }
 case 55: 
 HEAP32[(($__v)>>2)]=$148;
 var $150=HEAP32[(($__g_end)>>2)];
 __ZNSt3__116__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj($__grouping,$18,$150,$__err);
 var $151=($38|0)==0;
 if($151){var $165=0;label=60;break;}else{label=56;break;}
 case 56: 
 var $153=(($38+12)|0);
 var $154=HEAP32[(($153)>>2)];
 var $155=(($38+16)|0);
 var $156=HEAP32[(($155)>>2)];
 var $157=($154|0)==($156|0);
 if($157){label=57;break;}else{var $165=$38;label=60;break;}
 case 57: 
 var $158=$38;
 var $159=HEAP32[(($158)>>2)];
 var $160=(($159+36)|0);
 var $161=HEAP32[(($160)>>2)];
 var $162=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$161]($38) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=58;break; } else { label=38;break; }
 case 58: 
 var $163=($162|0)==-1;
 if($163){label=59;break;}else{var $165=$38;label=60;break;}
 case 59: 
 HEAP32[(($19)>>2)]=0;
 var $165=0;label=60;break;
 case 60: 
 var $165;
 var $166=($165|0)==0;
 var $167=($_pre_i3_i_i|0)==0;
 if($167){label=66;break;}else{label=61;break;}
 case 61: 
 var $169=(($_pre_i3_i_i+12)|0);
 var $170=HEAP32[(($169)>>2)];
 var $171=(($_pre_i3_i_i+16)|0);
 var $172=HEAP32[(($171)>>2)];
 var $173=($170|0)==($172|0);
 if($173){label=63;break;}else{label=62;break;}
 case 62: 
 if($166){label=69;break;}else{label=68;break;}
 case 63: 
 var $174=$_pre_i3_i_i;
 var $175=HEAP32[(($174)>>2)];
 var $176=(($175+36)|0);
 var $177=HEAP32[(($176)>>2)];
 var $178=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$177]($_pre_i3_i_i) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=64;break; } else { label=38;break; }
 case 64: 
 var $179=($178|0)==-1;
 if($179){label=65;break;}else{label=67;break;}
 case 65: 
 HEAP32[(($20)>>2)]=0;
 label=66;break;
 case 66: 
 if($166){label=68;break;}else{label=69;break;}
 case 67: 
 var $181=($_pre_i3_i_i|0)==0;
 var $tmp_i_i=$166^$181;
 if($tmp_i_i){label=69;break;}else{label=68;break;}
 case 68: 
 var $183=HEAP32[(($__err)>>2)];
 var $184=$183|2;
 HEAP32[(($__err)>>2)]=$184;
 label=69;break;
 case 69: 
 var $186=(($agg_result)|0);
 HEAP32[(($186)>>2)]=$165;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__buf);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grouping);
 STACKTOP=sp;return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRy($agg_result,$this,$__b,$__e,$__iob,$__err,$__v){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+16)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var tempParam = $__b; $__b=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__b)>>2)]=HEAP32[((tempParam)>>2)];
 var tempParam = $__e; $__e=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];

 var $1=sp;
 var $2=(sp)+(8);
 var $3=(($__b)|0);
 var $4=HEAP32[(($3)>>2)];
 var $5=(($1)|0);
 HEAP32[(($5)>>2)]=$4;
 var $6=(($__e)|0);
 var $7=HEAP32[(($6)>>2)];
 var $8=(($2)|0);
 HEAP32[(($8)>>2)]=$7;
 __ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE17__do_get_unsignedIyEES4_S4_S4_RNS_8ios_baseERjRT_($agg_result,0,$1,$2,$__iob,$__err,$__v);
 STACKTOP=sp;return;
}


function __ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE17__do_get_unsignedIyEES4_S4_S4_RNS_8ios_baseERjRT_($agg_result,$this,$__b,$__e,$__iob,$__err,$__v){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+256)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var tempParam = $__b; $__b=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__b)>>2)]=HEAP32[((tempParam)>>2)];
 var tempParam = $__e; $__e=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $__atoms=sp;
 var $__thousands_sep=(sp)+(32);
 var $__grouping=(sp)+(40);
 var $__buf=(sp)+(56);
 var $__a_end=(sp)+(72);
 var $__g=(sp)+(80);
 var $__g_end=(sp)+(240);
 var $__dc=(sp)+(248);
 var $1=(($__iob+4)|0);
 var $2=HEAP32[(($1)>>2)];
 var $3=$2&74;
 if(($3|0)==8){ label=2;break;}else if(($3|0)==0){ label=3;break;}else if(($3|0)==64){ var $_0_i=8;label=5;break;}else{label=4;break;}
 case 2: 
 var $_0_i=16;label=5;break;
 case 3: 
 var $_0_i=0;label=5;break;
 case 4: 
 var $_0_i=10;label=5;break;
 case 5: 
 var $_0_i;
 var $7=(($__atoms)|0);
 __ZNSt3__19__num_getIcE17__stage2_int_prepERNS_8ios_baseEPcRc($__grouping,$__iob,$7,$__thousands_sep);
 var $this4_i_i_i=$__buf;
 HEAP32[(($this4_i_i_i)>>2)]=0; HEAP32[((($this4_i_i_i)+(4))>>2)]=0; HEAP32[((($this4_i_i_i)+(8))>>2)]=0;
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc($__buf,10,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=6;break; } else { label=38;break; }
 case 6: 
 var $8=HEAP8[($this4_i_i_i)];
 var $9=$8&1;
 var $10=(($9<<24)>>24)==0;
 if($10){label=8;break;}else{label=7;break;}
 case 7: 
 var $12=(($__buf+8)|0);
 var $13=HEAP32[(($12)>>2)];
 var $_pre43=$__buf;
 var $_pre44=(($_pre43+1)|0);
 var $17=$13;var $_pre_phi45=$_pre44;var $_pre_phi47=$12;label=9;break;
 case 8: 
 var $15=$__buf;
 var $16=(($15+1)|0);
 var $_pre46=(($__buf+8)|0);
 var $17=$16;var $_pre_phi45=$16;var $_pre_phi47=$_pre46;label=9;break;
 case 9: 
 var $_pre_phi47;
 var $_pre_phi45;
 var $17;
 HEAP32[(($__a_end)>>2)]=$17;
 var $18=(($__g)|0);
 HEAP32[(($__g_end)>>2)]=$18;
 HEAP32[(($__dc)>>2)]=0;
 var $19=(($__b)|0);
 var $20=(($__e)|0);
 var $21=(($__buf)|0);
 var $22=(($__buf+4)|0);
 var $23=HEAP8[($__thousands_sep)];
 var $_pre=HEAP32[(($19)>>2)];
 var $__a_0=$17;var $_pre_i_i_i17=$_pre;label=10;break;
 case 10: 
 var $_pre_i_i_i17;
 var $__a_0;
 var $24=($_pre_i_i_i17|0)==0;
 if($24){var $38=0;label=15;break;}else{label=11;break;}
 case 11: 
 var $26=(($_pre_i_i_i17+12)|0);
 var $27=HEAP32[(($26)>>2)];
 var $28=(($_pre_i_i_i17+16)|0);
 var $29=HEAP32[(($28)>>2)];
 var $30=($27|0)==($29|0);
 if($30){label=12;break;}else{var $38=$_pre_i_i_i17;label=15;break;}
 case 12: 
 var $31=$_pre_i_i_i17;
 var $32=HEAP32[(($31)>>2)];
 var $33=(($32+36)|0);
 var $34=HEAP32[(($33)>>2)];
 var $35=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$34]($_pre_i_i_i17) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=13;break; } else { label=37;break; }
 case 13: 
 var $36=($35|0)==-1;
 if($36){label=14;break;}else{var $38=$_pre_i_i_i17;label=15;break;}
 case 14: 
 HEAP32[(($19)>>2)]=0;
 var $38=0;label=15;break;
 case 15: 
 var $38;
 var $39=($38|0)==0;
 var $40=HEAP32[(($20)>>2)];
 var $41=($40|0)==0;
 if($41){label=21;break;}else{label=16;break;}
 case 16: 
 var $43=(($40+12)|0);
 var $44=HEAP32[(($43)>>2)];
 var $45=(($40+16)|0);
 var $46=HEAP32[(($45)>>2)];
 var $47=($44|0)==($46|0);
 if($47){label=18;break;}else{label=17;break;}
 case 17: 
 if($39){var $56=$40;label=23;break;}else{var $__a_2=$__a_0;var $_pre_i3_i_i=$40;label=48;break;}
 case 18: 
 var $48=$40;
 var $49=HEAP32[(($48)>>2)];
 var $50=(($49+36)|0);
 var $51=HEAP32[(($50)>>2)];
 var $52=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$51]($40) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=19;break; } else { label=37;break; }
 case 19: 
 var $53=($52|0)==-1;
 if($53){label=20;break;}else{label=22;break;}
 case 20: 
 HEAP32[(($20)>>2)]=0;
 label=21;break;
 case 21: 
 if($39){var $__a_2=$__a_0;var $_pre_i3_i_i=0;label=48;break;}else{var $56=0;label=23;break;}
 case 22: 
 if($39){var $56=$40;label=23;break;}else{var $__a_2=$__a_0;var $_pre_i3_i_i=$40;label=48;break;}
 case 23: 
 var $56;
 var $57=HEAP32[(($__a_end)>>2)];
 var $58=$57;
 var $59=$__a_0;
 var $60=((($58)-($59))|0);
 var $61=HEAP8[($this4_i_i_i)];
 var $62=$61&1;
 var $63=(($62<<24)>>24)==0;
 if($63){label=25;break;}else{label=24;break;}
 case 24: 
 var $65=HEAP32[(($22)>>2)];
 var $69=$65;label=26;break;
 case 25: 
 var $67=($61&255);
 var $68=$67>>>1;
 var $69=$68;label=26;break;
 case 26: 
 var $69;
 var $70=($60|0)==($69|0);
 if($70){label=27;break;}else{var $__a_1=$__a_0;label=40;break;}
 case 27: 
 if($63){label=29;break;}else{label=28;break;}
 case 28: 
 var $73=HEAP32[(($22)>>2)];
 var $80=$73;var $79=$73;label=30;break;
 case 29: 
 var $75=($61&255);
 var $76=$75>>>1;
 var $77=($61&255);
 var $78=$77>>>1;
 var $80=$78;var $79=$76;label=30;break;
 case 30: 
 var $79;
 var $80;
 var $81=$80<<1;
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc($__buf,$81,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=31;break; } else { label=37;break; }
 case 31: 
 var $82=HEAP8[($this4_i_i_i)];
 var $83=$82&1;
 var $84=(($83<<24)>>24)==0;
 if($84){var $88=10;label=33;break;}else{label=32;break;}
 case 32: 
 var $86=HEAP32[(($21)>>2)];
 var $87=$86&-2;
 var $phitmp_i32=((($87)-(1))|0);
 var $88=$phitmp_i32;label=33;break;
 case 33: 
 var $88;
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc($__buf,$88,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=34;break; } else { label=37;break; }
 case 34: 
 var $89=HEAP8[($this4_i_i_i)];
 var $90=$89&1;
 var $91=(($90<<24)>>24)==0;
 if($91){var $94=$_pre_phi45;label=36;break;}else{label=35;break;}
 case 35: 
 var $93=HEAP32[(($_pre_phi47)>>2)];
 var $94=$93;label=36;break;
 case 36: 
 var $94;
 var $95=(($94+$79)|0);
 HEAP32[(($__a_end)>>2)]=$95;
 var $__a_1=$94;label=40;break;
 case 37: 
 var $lpad_loopexit$0 = ___cxa_find_matching_catch(-1, -1); var $lpad_loopexit$1 = tempRet0;
 var $lpad_phi$1=$lpad_loopexit$1;var $lpad_phi$0=$lpad_loopexit$0;label=39;break;
 case 38: 
 var $lpad_nonloopexit$0 = ___cxa_find_matching_catch(-1, -1); var $lpad_nonloopexit$1 = tempRet0;
 var $lpad_phi$1=$lpad_nonloopexit$1;var $lpad_phi$0=$lpad_nonloopexit$0;label=39;break;
 case 39: 
 var $lpad_phi$0;
 var $lpad_phi$1;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__buf);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grouping);
 ___resumeException($lpad_phi$0)
 case 40: 
 var $__a_1;
 var $97=(($38+12)|0);
 var $98=HEAP32[(($97)>>2)];
 var $99=(($38+16)|0);
 var $100=HEAP32[(($99)>>2)];
 var $101=($98|0)==($100|0);
 if($101){label=41;break;}else{label=43;break;}
 case 41: 
 var $103=$38;
 var $104=HEAP32[(($103)>>2)];
 var $105=(($104+36)|0);
 var $106=HEAP32[(($105)>>2)];
 var $107=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$106]($38) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=42;break; } else { label=37;break; }
 case 42: 
 var $extract_t_i=(($107)&255);
 var $_0_i_off0_i=$extract_t_i;label=44;break;
 case 43: 
 var $109=HEAP8[($98)];
 var $_0_i_off0_i=$109;label=44;break;
 case 44: 
 var $_0_i_off0_i;
 var $111=__ZNSt3__19__num_getIcE17__stage2_int_loopEciPcRS2_RjcRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSD_S2_($_0_i_off0_i,$_0_i,$__a_1,$__a_end,$__dc,$23,$__grouping,$18,$__g_end,$7);
 var $112=($111|0)==0;
 if($112){label=45;break;}else{var $__a_2=$__a_1;var $_pre_i3_i_i=$56;label=48;break;}
 case 45: 
 var $114=HEAP32[(($97)>>2)];
 var $115=HEAP32[(($99)>>2)];
 var $116=($114|0)==($115|0);
 if($116){label=46;break;}else{label=47;break;}
 case 46: 
 var $118=$38;
 var $119=HEAP32[(($118)>>2)];
 var $120=(($119+40)|0);
 var $121=HEAP32[(($120)>>2)];
 var $122=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$121]($38) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $__a_0=$__a_1;var $_pre_i_i_i17=$38;label=10;break; } else { label=37;break; }
 case 47: 
 var $124=(($114+1)|0);
 HEAP32[(($97)>>2)]=$124;
 var $__a_0=$__a_1;var $_pre_i_i_i17=$38;label=10;break;
 case 48: 
 var $_pre_i3_i_i;
 var $__a_2;
 var $126=$__grouping;
 var $127=HEAP8[($126)];
 var $128=$127&1;
 var $129=(($128<<24)>>24)==0;
 if($129){label=50;break;}else{label=49;break;}
 case 49: 
 var $131=(($__grouping+4)|0);
 var $132=HEAP32[(($131)>>2)];
 var $136=$132;label=51;break;
 case 50: 
 var $134=($127&255);
 var $135=$134>>>1;
 var $136=$135;label=51;break;
 case 51: 
 var $136;
 var $137=($136|0)==0;
 if($137){label=54;break;}else{label=52;break;}
 case 52: 
 var $139=HEAP32[(($__g_end)>>2)];
 var $140=$139;
 var $141=$__g;
 var $142=((($140)-($141))|0);
 var $143=($142|0)<160;
 if($143){label=53;break;}else{label=54;break;}
 case 53: 
 var $145=HEAP32[(($__dc)>>2)];
 var $146=(($139+4)|0);
 HEAP32[(($__g_end)>>2)]=$146;
 HEAP32[(($139)>>2)]=$145;
 label=54;break;
 case 54: 
 var $147=HEAP32[(($__a_end)>>2)];
 var $148$r=(function() { try { __THREW__ = 0; return __ZNSt3__127__num_get_unsigned_integralIyEET_PKcS3_Rji($__a_2,$147,$__err,$_0_i) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();var $148$0=$148$r;var $148$1=tempRet0;if (!__THREW__) { label=55;break; } else { label=38;break; }
 case 55: 
 var $st$0$0=(($__v)|0);
 HEAP32[(($st$0$0)>>2)]=$148$0;
 var $st$1$1=(($__v+4)|0);
 HEAP32[(($st$1$1)>>2)]=$148$1;
 var $150=HEAP32[(($__g_end)>>2)];
 __ZNSt3__116__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj($__grouping,$18,$150,$__err);
 var $151=($38|0)==0;
 if($151){var $165=0;label=60;break;}else{label=56;break;}
 case 56: 
 var $153=(($38+12)|0);
 var $154=HEAP32[(($153)>>2)];
 var $155=(($38+16)|0);
 var $156=HEAP32[(($155)>>2)];
 var $157=($154|0)==($156|0);
 if($157){label=57;break;}else{var $165=$38;label=60;break;}
 case 57: 
 var $158=$38;
 var $159=HEAP32[(($158)>>2)];
 var $160=(($159+36)|0);
 var $161=HEAP32[(($160)>>2)];
 var $162=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$161]($38) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=58;break; } else { label=38;break; }
 case 58: 
 var $163=($162|0)==-1;
 if($163){label=59;break;}else{var $165=$38;label=60;break;}
 case 59: 
 HEAP32[(($19)>>2)]=0;
 var $165=0;label=60;break;
 case 60: 
 var $165;
 var $166=($165|0)==0;
 var $167=($_pre_i3_i_i|0)==0;
 if($167){label=66;break;}else{label=61;break;}
 case 61: 
 var $169=(($_pre_i3_i_i+12)|0);
 var $170=HEAP32[(($169)>>2)];
 var $171=(($_pre_i3_i_i+16)|0);
 var $172=HEAP32[(($171)>>2)];
 var $173=($170|0)==($172|0);
 if($173){label=63;break;}else{label=62;break;}
 case 62: 
 if($166){label=69;break;}else{label=68;break;}
 case 63: 
 var $174=$_pre_i3_i_i;
 var $175=HEAP32[(($174)>>2)];
 var $176=(($175+36)|0);
 var $177=HEAP32[(($176)>>2)];
 var $178=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$177]($_pre_i3_i_i) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=64;break; } else { label=38;break; }
 case 64: 
 var $179=($178|0)==-1;
 if($179){label=65;break;}else{label=67;break;}
 case 65: 
 HEAP32[(($20)>>2)]=0;
 label=66;break;
 case 66: 
 if($166){label=68;break;}else{label=69;break;}
 case 67: 
 var $181=($_pre_i3_i_i|0)==0;
 var $tmp_i_i=$166^$181;
 if($tmp_i_i){label=69;break;}else{label=68;break;}
 case 68: 
 var $183=HEAP32[(($__err)>>2)];
 var $184=$183|2;
 HEAP32[(($__err)>>2)]=$184;
 label=69;break;
 case 69: 
 var $186=(($agg_result)|0);
 HEAP32[(($186)>>2)]=$165;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__buf);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grouping);
 STACKTOP=sp;return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRf($agg_result,$this,$__b,$__e,$__iob,$__err,$__v){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+16)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var tempParam = $__b; $__b=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__b)>>2)]=HEAP32[((tempParam)>>2)];
 var tempParam = $__e; $__e=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];

 var $1=sp;
 var $2=(sp)+(8);
 var $3=(($__b)|0);
 var $4=HEAP32[(($3)>>2)];
 var $5=(($1)|0);
 HEAP32[(($5)>>2)]=$4;
 var $6=(($__e)|0);
 var $7=HEAP32[(($6)>>2)];
 var $8=(($2)|0);
 HEAP32[(($8)>>2)]=$7;
 __ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE23__do_get_floating_pointIfEES4_S4_S4_RNS_8ios_baseERjRT_($agg_result,0,$1,$2,$__iob,$__err,$__v);
 STACKTOP=sp;return;
}


function __ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE23__do_get_floating_pointIfEES4_S4_S4_RNS_8ios_baseERjRT_($agg_result,$this,$__b,$__e,$__iob,$__err,$__v){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+280)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var tempParam = $__b; $__b=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__b)>>2)]=HEAP32[((tempParam)>>2)];
 var tempParam = $__e; $__e=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $__atoms=sp;
 var $__decimal_point=(sp)+(32);
 var $__thousands_sep=(sp)+(40);
 var $__grouping=(sp)+(48);
 var $__buf=(sp)+(64);
 var $__a_end=(sp)+(80);
 var $__g=(sp)+(88);
 var $__g_end=(sp)+(248);
 var $__dc=(sp)+(256);
 var $__in_units=(sp)+(264);
 var $__exp=(sp)+(272);
 var $0=(($__atoms)|0);
 __ZNSt3__19__num_getIcE19__stage2_float_prepERNS_8ios_baseEPcRcS5_($__grouping,$__iob,$0,$__decimal_point,$__thousands_sep);
 var $this4_i_i_i=$__buf;
 HEAP32[(($this4_i_i_i)>>2)]=0; HEAP32[((($this4_i_i_i)+(4))>>2)]=0; HEAP32[((($this4_i_i_i)+(8))>>2)]=0;
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc($__buf,10,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=2;break; } else { label=34;break; }
 case 2: 
 var $1=HEAP8[($this4_i_i_i)];
 var $2=$1&1;
 var $3=(($2<<24)>>24)==0;
 if($3){label=4;break;}else{label=3;break;}
 case 3: 
 var $5=(($__buf+8)|0);
 var $6=HEAP32[(($5)>>2)];
 var $_pre42=$__buf;
 var $_pre43=(($_pre42+1)|0);
 var $10=$6;var $_pre_phi44=$_pre43;var $_pre_phi46=$5;label=5;break;
 case 4: 
 var $8=$__buf;
 var $9=(($8+1)|0);
 var $_pre45=(($__buf+8)|0);
 var $10=$9;var $_pre_phi44=$9;var $_pre_phi46=$_pre45;label=5;break;
 case 5: 
 var $_pre_phi46;
 var $_pre_phi44;
 var $10;
 HEAP32[(($__a_end)>>2)]=$10;
 var $11=(($__g)|0);
 HEAP32[(($__g_end)>>2)]=$11;
 HEAP32[(($__dc)>>2)]=0;
 HEAP8[($__in_units)]=1;
 HEAP8[($__exp)]=69;
 var $12=(($__b)|0);
 var $13=(($__e)|0);
 var $14=(($__buf)|0);
 var $15=(($__buf+4)|0);
 var $16=HEAP8[($__decimal_point)];
 var $17=HEAP8[($__thousands_sep)];
 var $_pre=HEAP32[(($12)>>2)];
 var $__a_0=$10;var $_pre_i_i_i15=$_pre;label=6;break;
 case 6: 
 var $_pre_i_i_i15;
 var $__a_0;
 var $18=($_pre_i_i_i15|0)==0;
 if($18){var $32=0;label=11;break;}else{label=7;break;}
 case 7: 
 var $20=(($_pre_i_i_i15+12)|0);
 var $21=HEAP32[(($20)>>2)];
 var $22=(($_pre_i_i_i15+16)|0);
 var $23=HEAP32[(($22)>>2)];
 var $24=($21|0)==($23|0);
 if($24){label=8;break;}else{var $32=$_pre_i_i_i15;label=11;break;}
 case 8: 
 var $25=$_pre_i_i_i15;
 var $26=HEAP32[(($25)>>2)];
 var $27=(($26+36)|0);
 var $28=HEAP32[(($27)>>2)];
 var $29=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$28]($_pre_i_i_i15) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=9;break; } else { label=33;break; }
 case 9: 
 var $30=($29|0)==-1;
 if($30){label=10;break;}else{var $32=$_pre_i_i_i15;label=11;break;}
 case 10: 
 HEAP32[(($12)>>2)]=0;
 var $32=0;label=11;break;
 case 11: 
 var $32;
 var $33=($32|0)==0;
 var $34=HEAP32[(($13)>>2)];
 var $35=($34|0)==0;
 if($35){label=17;break;}else{label=12;break;}
 case 12: 
 var $37=(($34+12)|0);
 var $38=HEAP32[(($37)>>2)];
 var $39=(($34+16)|0);
 var $40=HEAP32[(($39)>>2)];
 var $41=($38|0)==($40|0);
 if($41){label=14;break;}else{label=13;break;}
 case 13: 
 if($33){var $50=$34;label=19;break;}else{var $__a_2=$__a_0;var $_pre_i3_i_i=$34;label=44;break;}
 case 14: 
 var $42=$34;
 var $43=HEAP32[(($42)>>2)];
 var $44=(($43+36)|0);
 var $45=HEAP32[(($44)>>2)];
 var $46=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$45]($34) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=15;break; } else { label=33;break; }
 case 15: 
 var $47=($46|0)==-1;
 if($47){label=16;break;}else{label=18;break;}
 case 16: 
 HEAP32[(($13)>>2)]=0;
 label=17;break;
 case 17: 
 if($33){var $__a_2=$__a_0;var $_pre_i3_i_i=0;label=44;break;}else{var $50=0;label=19;break;}
 case 18: 
 if($33){var $50=$34;label=19;break;}else{var $__a_2=$__a_0;var $_pre_i3_i_i=$34;label=44;break;}
 case 19: 
 var $50;
 var $51=HEAP32[(($__a_end)>>2)];
 var $52=$51;
 var $53=$__a_0;
 var $54=((($52)-($53))|0);
 var $55=HEAP8[($this4_i_i_i)];
 var $56=$55&1;
 var $57=(($56<<24)>>24)==0;
 if($57){label=21;break;}else{label=20;break;}
 case 20: 
 var $59=HEAP32[(($15)>>2)];
 var $63=$59;label=22;break;
 case 21: 
 var $61=($55&255);
 var $62=$61>>>1;
 var $63=$62;label=22;break;
 case 22: 
 var $63;
 var $64=($54|0)==($63|0);
 if($64){label=23;break;}else{var $__a_1=$__a_0;label=36;break;}
 case 23: 
 if($57){label=25;break;}else{label=24;break;}
 case 24: 
 var $67=HEAP32[(($15)>>2)];
 var $74=$67;var $73=$67;label=26;break;
 case 25: 
 var $69=($55&255);
 var $70=$69>>>1;
 var $71=($55&255);
 var $72=$71>>>1;
 var $74=$72;var $73=$70;label=26;break;
 case 26: 
 var $73;
 var $74;
 var $75=$74<<1;
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc($__buf,$75,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=27;break; } else { label=33;break; }
 case 27: 
 var $76=HEAP8[($this4_i_i_i)];
 var $77=$76&1;
 var $78=(($77<<24)>>24)==0;
 if($78){var $82=10;label=29;break;}else{label=28;break;}
 case 28: 
 var $80=HEAP32[(($14)>>2)];
 var $81=$80&-2;
 var $phitmp_i30=((($81)-(1))|0);
 var $82=$phitmp_i30;label=29;break;
 case 29: 
 var $82;
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc($__buf,$82,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=30;break; } else { label=33;break; }
 case 30: 
 var $83=HEAP8[($this4_i_i_i)];
 var $84=$83&1;
 var $85=(($84<<24)>>24)==0;
 if($85){var $88=$_pre_phi44;label=32;break;}else{label=31;break;}
 case 31: 
 var $87=HEAP32[(($_pre_phi46)>>2)];
 var $88=$87;label=32;break;
 case 32: 
 var $88;
 var $89=(($88+$73)|0);
 HEAP32[(($__a_end)>>2)]=$89;
 var $__a_1=$88;label=36;break;
 case 33: 
 var $lpad_loopexit$0 = ___cxa_find_matching_catch(-1, -1); var $lpad_loopexit$1 = tempRet0;
 var $lpad_phi$1=$lpad_loopexit$1;var $lpad_phi$0=$lpad_loopexit$0;label=35;break;
 case 34: 
 var $lpad_nonloopexit$0 = ___cxa_find_matching_catch(-1, -1); var $lpad_nonloopexit$1 = tempRet0;
 var $lpad_phi$1=$lpad_nonloopexit$1;var $lpad_phi$0=$lpad_nonloopexit$0;label=35;break;
 case 35: 
 var $lpad_phi$0;
 var $lpad_phi$1;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__buf);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grouping);
 ___resumeException($lpad_phi$0)
 case 36: 
 var $__a_1;
 var $91=(($32+12)|0);
 var $92=HEAP32[(($91)>>2)];
 var $93=(($32+16)|0);
 var $94=HEAP32[(($93)>>2)];
 var $95=($92|0)==($94|0);
 if($95){label=37;break;}else{label=39;break;}
 case 37: 
 var $97=$32;
 var $98=HEAP32[(($97)>>2)];
 var $99=(($98+36)|0);
 var $100=HEAP32[(($99)>>2)];
 var $101=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$100]($32) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=38;break; } else { label=33;break; }
 case 38: 
 var $extract_t_i=(($101)&255);
 var $_0_i_off0_i=$extract_t_i;label=40;break;
 case 39: 
 var $103=HEAP8[($92)];
 var $_0_i_off0_i=$103;label=40;break;
 case 40: 
 var $_0_i_off0_i;
 var $105=__ZNSt3__19__num_getIcE19__stage2_float_loopEcRbRcPcRS4_ccRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSE_RjS4_($_0_i_off0_i,$__in_units,$__exp,$__a_1,$__a_end,$16,$17,$__grouping,$11,$__g_end,$__dc,$0);
 var $106=($105|0)==0;
 if($106){label=41;break;}else{var $__a_2=$__a_1;var $_pre_i3_i_i=$50;label=44;break;}
 case 41: 
 var $108=HEAP32[(($91)>>2)];
 var $109=HEAP32[(($93)>>2)];
 var $110=($108|0)==($109|0);
 if($110){label=42;break;}else{label=43;break;}
 case 42: 
 var $112=$32;
 var $113=HEAP32[(($112)>>2)];
 var $114=(($113+40)|0);
 var $115=HEAP32[(($114)>>2)];
 var $116=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$115]($32) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $__a_0=$__a_1;var $_pre_i_i_i15=$32;label=6;break; } else { label=33;break; }
 case 43: 
 var $118=(($108+1)|0);
 HEAP32[(($91)>>2)]=$118;
 var $__a_0=$__a_1;var $_pre_i_i_i15=$32;label=6;break;
 case 44: 
 var $_pre_i3_i_i;
 var $__a_2;
 var $120=$__grouping;
 var $121=HEAP8[($120)];
 var $122=$121&1;
 var $123=(($122<<24)>>24)==0;
 if($123){label=46;break;}else{label=45;break;}
 case 45: 
 var $125=(($__grouping+4)|0);
 var $126=HEAP32[(($125)>>2)];
 var $130=$126;label=47;break;
 case 46: 
 var $128=($121&255);
 var $129=$128>>>1;
 var $130=$129;label=47;break;
 case 47: 
 var $130;
 var $131=($130|0)==0;
 if($131){label=51;break;}else{label=48;break;}
 case 48: 
 var $133=HEAP8[($__in_units)];
 var $134=(($133<<24)>>24)==0;
 if($134){label=51;break;}else{label=49;break;}
 case 49: 
 var $136=HEAP32[(($__g_end)>>2)];
 var $137=$136;
 var $138=$__g;
 var $139=((($137)-($138))|0);
 var $140=($139|0)<160;
 if($140){label=50;break;}else{label=51;break;}
 case 50: 
 var $142=HEAP32[(($__dc)>>2)];
 var $143=(($136+4)|0);
 HEAP32[(($__g_end)>>2)]=$143;
 HEAP32[(($136)>>2)]=$142;
 label=51;break;
 case 51: 
 var $144=HEAP32[(($__a_end)>>2)];
 var $145=(function() { try { __THREW__ = 0; return __ZNSt3__115__num_get_floatIfEET_PKcS3_Rj($__a_2,$144,$__err) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=52;break; } else { label=34;break; }
 case 52: 
 HEAPF32[(($__v)>>2)]=$145;
 var $147=HEAP32[(($__g_end)>>2)];
 __ZNSt3__116__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj($__grouping,$11,$147,$__err);
 var $148=($32|0)==0;
 if($148){var $162=0;label=57;break;}else{label=53;break;}
 case 53: 
 var $150=(($32+12)|0);
 var $151=HEAP32[(($150)>>2)];
 var $152=(($32+16)|0);
 var $153=HEAP32[(($152)>>2)];
 var $154=($151|0)==($153|0);
 if($154){label=54;break;}else{var $162=$32;label=57;break;}
 case 54: 
 var $155=$32;
 var $156=HEAP32[(($155)>>2)];
 var $157=(($156+36)|0);
 var $158=HEAP32[(($157)>>2)];
 var $159=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$158]($32) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=55;break; } else { label=34;break; }
 case 55: 
 var $160=($159|0)==-1;
 if($160){label=56;break;}else{var $162=$32;label=57;break;}
 case 56: 
 HEAP32[(($12)>>2)]=0;
 var $162=0;label=57;break;
 case 57: 
 var $162;
 var $163=($162|0)==0;
 var $164=($_pre_i3_i_i|0)==0;
 if($164){label=63;break;}else{label=58;break;}
 case 58: 
 var $166=(($_pre_i3_i_i+12)|0);
 var $167=HEAP32[(($166)>>2)];
 var $168=(($_pre_i3_i_i+16)|0);
 var $169=HEAP32[(($168)>>2)];
 var $170=($167|0)==($169|0);
 if($170){label=60;break;}else{label=59;break;}
 case 59: 
 if($163){label=66;break;}else{label=65;break;}
 case 60: 
 var $171=$_pre_i3_i_i;
 var $172=HEAP32[(($171)>>2)];
 var $173=(($172+36)|0);
 var $174=HEAP32[(($173)>>2)];
 var $175=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$174]($_pre_i3_i_i) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=61;break; } else { label=34;break; }
 case 61: 
 var $176=($175|0)==-1;
 if($176){label=62;break;}else{label=64;break;}
 case 62: 
 HEAP32[(($13)>>2)]=0;
 label=63;break;
 case 63: 
 if($163){label=65;break;}else{label=66;break;}
 case 64: 
 var $178=($_pre_i3_i_i|0)==0;
 var $tmp_i_i=$163^$178;
 if($tmp_i_i){label=66;break;}else{label=65;break;}
 case 65: 
 var $180=HEAP32[(($__err)>>2)];
 var $181=$180|2;
 HEAP32[(($__err)>>2)]=$181;
 label=66;break;
 case 66: 
 var $183=(($agg_result)|0);
 HEAP32[(($183)>>2)]=$162;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__buf);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grouping);
 STACKTOP=sp;return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRd($agg_result,$this,$__b,$__e,$__iob,$__err,$__v){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+16)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var tempParam = $__b; $__b=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__b)>>2)]=HEAP32[((tempParam)>>2)];
 var tempParam = $__e; $__e=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];

 var $1=sp;
 var $2=(sp)+(8);
 var $3=(($__b)|0);
 var $4=HEAP32[(($3)>>2)];
 var $5=(($1)|0);
 HEAP32[(($5)>>2)]=$4;
 var $6=(($__e)|0);
 var $7=HEAP32[(($6)>>2)];
 var $8=(($2)|0);
 HEAP32[(($8)>>2)]=$7;
 __ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE23__do_get_floating_pointIdEES4_S4_S4_RNS_8ios_baseERjRT_($agg_result,0,$1,$2,$__iob,$__err,$__v);
 STACKTOP=sp;return;
}



function __ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE23__do_get_floating_pointIdEES4_S4_S4_RNS_8ios_baseERjRT_($agg_result,$this,$__b,$__e,$__iob,$__err,$__v){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+280)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var tempParam = $__b; $__b=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__b)>>2)]=HEAP32[((tempParam)>>2)];
 var tempParam = $__e; $__e=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $__atoms=sp;
 var $__decimal_point=(sp)+(32);
 var $__thousands_sep=(sp)+(40);
 var $__grouping=(sp)+(48);
 var $__buf=(sp)+(64);
 var $__a_end=(sp)+(80);
 var $__g=(sp)+(88);
 var $__g_end=(sp)+(248);
 var $__dc=(sp)+(256);
 var $__in_units=(sp)+(264);
 var $__exp=(sp)+(272);
 var $0=(($__atoms)|0);
 __ZNSt3__19__num_getIcE19__stage2_float_prepERNS_8ios_baseEPcRcS5_($__grouping,$__iob,$0,$__decimal_point,$__thousands_sep);
 var $this4_i_i_i=$__buf;
 HEAP32[(($this4_i_i_i)>>2)]=0; HEAP32[((($this4_i_i_i)+(4))>>2)]=0; HEAP32[((($this4_i_i_i)+(8))>>2)]=0;
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc($__buf,10,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=2;break; } else { label=34;break; }
 case 2: 
 var $1=HEAP8[($this4_i_i_i)];
 var $2=$1&1;
 var $3=(($2<<24)>>24)==0;
 if($3){label=4;break;}else{label=3;break;}
 case 3: 
 var $5=(($__buf+8)|0);
 var $6=HEAP32[(($5)>>2)];
 var $_pre42=$__buf;
 var $_pre43=(($_pre42+1)|0);
 var $10=$6;var $_pre_phi44=$_pre43;var $_pre_phi46=$5;label=5;break;
 case 4: 
 var $8=$__buf;
 var $9=(($8+1)|0);
 var $_pre45=(($__buf+8)|0);
 var $10=$9;var $_pre_phi44=$9;var $_pre_phi46=$_pre45;label=5;break;
 case 5: 
 var $_pre_phi46;
 var $_pre_phi44;
 var $10;
 HEAP32[(($__a_end)>>2)]=$10;
 var $11=(($__g)|0);
 HEAP32[(($__g_end)>>2)]=$11;
 HEAP32[(($__dc)>>2)]=0;
 HEAP8[($__in_units)]=1;
 HEAP8[($__exp)]=69;
 var $12=(($__b)|0);
 var $13=(($__e)|0);
 var $14=(($__buf)|0);
 var $15=(($__buf+4)|0);
 var $16=HEAP8[($__decimal_point)];
 var $17=HEAP8[($__thousands_sep)];
 var $_pre=HEAP32[(($12)>>2)];
 var $__a_0=$10;var $_pre_i_i_i15=$_pre;label=6;break;
 case 6: 
 var $_pre_i_i_i15;
 var $__a_0;
 var $18=($_pre_i_i_i15|0)==0;
 if($18){var $32=0;label=11;break;}else{label=7;break;}
 case 7: 
 var $20=(($_pre_i_i_i15+12)|0);
 var $21=HEAP32[(($20)>>2)];
 var $22=(($_pre_i_i_i15+16)|0);
 var $23=HEAP32[(($22)>>2)];
 var $24=($21|0)==($23|0);
 if($24){label=8;break;}else{var $32=$_pre_i_i_i15;label=11;break;}
 case 8: 
 var $25=$_pre_i_i_i15;
 var $26=HEAP32[(($25)>>2)];
 var $27=(($26+36)|0);
 var $28=HEAP32[(($27)>>2)];
 var $29=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$28]($_pre_i_i_i15) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=9;break; } else { label=33;break; }
 case 9: 
 var $30=($29|0)==-1;
 if($30){label=10;break;}else{var $32=$_pre_i_i_i15;label=11;break;}
 case 10: 
 HEAP32[(($12)>>2)]=0;
 var $32=0;label=11;break;
 case 11: 
 var $32;
 var $33=($32|0)==0;
 var $34=HEAP32[(($13)>>2)];
 var $35=($34|0)==0;
 if($35){label=17;break;}else{label=12;break;}
 case 12: 
 var $37=(($34+12)|0);
 var $38=HEAP32[(($37)>>2)];
 var $39=(($34+16)|0);
 var $40=HEAP32[(($39)>>2)];
 var $41=($38|0)==($40|0);
 if($41){label=14;break;}else{label=13;break;}
 case 13: 
 if($33){var $50=$34;label=19;break;}else{var $__a_2=$__a_0;var $_pre_i3_i_i=$34;label=44;break;}
 case 14: 
 var $42=$34;
 var $43=HEAP32[(($42)>>2)];
 var $44=(($43+36)|0);
 var $45=HEAP32[(($44)>>2)];
 var $46=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$45]($34) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=15;break; } else { label=33;break; }
 case 15: 
 var $47=($46|0)==-1;
 if($47){label=16;break;}else{label=18;break;}
 case 16: 
 HEAP32[(($13)>>2)]=0;
 label=17;break;
 case 17: 
 if($33){var $__a_2=$__a_0;var $_pre_i3_i_i=0;label=44;break;}else{var $50=0;label=19;break;}
 case 18: 
 if($33){var $50=$34;label=19;break;}else{var $__a_2=$__a_0;var $_pre_i3_i_i=$34;label=44;break;}
 case 19: 
 var $50;
 var $51=HEAP32[(($__a_end)>>2)];
 var $52=$51;
 var $53=$__a_0;
 var $54=((($52)-($53))|0);
 var $55=HEAP8[($this4_i_i_i)];
 var $56=$55&1;
 var $57=(($56<<24)>>24)==0;
 if($57){label=21;break;}else{label=20;break;}
 case 20: 
 var $59=HEAP32[(($15)>>2)];
 var $63=$59;label=22;break;
 case 21: 
 var $61=($55&255);
 var $62=$61>>>1;
 var $63=$62;label=22;break;
 case 22: 
 var $63;
 var $64=($54|0)==($63|0);
 if($64){label=23;break;}else{var $__a_1=$__a_0;label=36;break;}
 case 23: 
 if($57){label=25;break;}else{label=24;break;}
 case 24: 
 var $67=HEAP32[(($15)>>2)];
 var $74=$67;var $73=$67;label=26;break;
 case 25: 
 var $69=($55&255);
 var $70=$69>>>1;
 var $71=($55&255);
 var $72=$71>>>1;
 var $74=$72;var $73=$70;label=26;break;
 case 26: 
 var $73;
 var $74;
 var $75=$74<<1;
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc($__buf,$75,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=27;break; } else { label=33;break; }
 case 27: 
 var $76=HEAP8[($this4_i_i_i)];
 var $77=$76&1;
 var $78=(($77<<24)>>24)==0;
 if($78){var $82=10;label=29;break;}else{label=28;break;}
 case 28: 
 var $80=HEAP32[(($14)>>2)];
 var $81=$80&-2;
 var $phitmp_i30=((($81)-(1))|0);
 var $82=$phitmp_i30;label=29;break;
 case 29: 
 var $82;
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc($__buf,$82,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=30;break; } else { label=33;break; }
 case 30: 
 var $83=HEAP8[($this4_i_i_i)];
 var $84=$83&1;
 var $85=(($84<<24)>>24)==0;
 if($85){var $88=$_pre_phi44;label=32;break;}else{label=31;break;}
 case 31: 
 var $87=HEAP32[(($_pre_phi46)>>2)];
 var $88=$87;label=32;break;
 case 32: 
 var $88;
 var $89=(($88+$73)|0);
 HEAP32[(($__a_end)>>2)]=$89;
 var $__a_1=$88;label=36;break;
 case 33: 
 var $lpad_loopexit$0 = ___cxa_find_matching_catch(-1, -1); var $lpad_loopexit$1 = tempRet0;
 var $lpad_phi$1=$lpad_loopexit$1;var $lpad_phi$0=$lpad_loopexit$0;label=35;break;
 case 34: 
 var $lpad_nonloopexit$0 = ___cxa_find_matching_catch(-1, -1); var $lpad_nonloopexit$1 = tempRet0;
 var $lpad_phi$1=$lpad_nonloopexit$1;var $lpad_phi$0=$lpad_nonloopexit$0;label=35;break;
 case 35: 
 var $lpad_phi$0;
 var $lpad_phi$1;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__buf);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grouping);
 ___resumeException($lpad_phi$0)
 case 36: 
 var $__a_1;
 var $91=(($32+12)|0);
 var $92=HEAP32[(($91)>>2)];
 var $93=(($32+16)|0);
 var $94=HEAP32[(($93)>>2)];
 var $95=($92|0)==($94|0);
 if($95){label=37;break;}else{label=39;break;}
 case 37: 
 var $97=$32;
 var $98=HEAP32[(($97)>>2)];
 var $99=(($98+36)|0);
 var $100=HEAP32[(($99)>>2)];
 var $101=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$100]($32) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=38;break; } else { label=33;break; }
 case 38: 
 var $extract_t_i=(($101)&255);
 var $_0_i_off0_i=$extract_t_i;label=40;break;
 case 39: 
 var $103=HEAP8[($92)];
 var $_0_i_off0_i=$103;label=40;break;
 case 40: 
 var $_0_i_off0_i;
 var $105=__ZNSt3__19__num_getIcE19__stage2_float_loopEcRbRcPcRS4_ccRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSE_RjS4_($_0_i_off0_i,$__in_units,$__exp,$__a_1,$__a_end,$16,$17,$__grouping,$11,$__g_end,$__dc,$0);
 var $106=($105|0)==0;
 if($106){label=41;break;}else{var $__a_2=$__a_1;var $_pre_i3_i_i=$50;label=44;break;}
 case 41: 
 var $108=HEAP32[(($91)>>2)];
 var $109=HEAP32[(($93)>>2)];
 var $110=($108|0)==($109|0);
 if($110){label=42;break;}else{label=43;break;}
 case 42: 
 var $112=$32;
 var $113=HEAP32[(($112)>>2)];
 var $114=(($113+40)|0);
 var $115=HEAP32[(($114)>>2)];
 var $116=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$115]($32) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $__a_0=$__a_1;var $_pre_i_i_i15=$32;label=6;break; } else { label=33;break; }
 case 43: 
 var $118=(($108+1)|0);
 HEAP32[(($91)>>2)]=$118;
 var $__a_0=$__a_1;var $_pre_i_i_i15=$32;label=6;break;
 case 44: 
 var $_pre_i3_i_i;
 var $__a_2;
 var $120=$__grouping;
 var $121=HEAP8[($120)];
 var $122=$121&1;
 var $123=(($122<<24)>>24)==0;
 if($123){label=46;break;}else{label=45;break;}
 case 45: 
 var $125=(($__grouping+4)|0);
 var $126=HEAP32[(($125)>>2)];
 var $130=$126;label=47;break;
 case 46: 
 var $128=($121&255);
 var $129=$128>>>1;
 var $130=$129;label=47;break;
 case 47: 
 var $130;
 var $131=($130|0)==0;
 if($131){label=51;break;}else{label=48;break;}
 case 48: 
 var $133=HEAP8[($__in_units)];
 var $134=(($133<<24)>>24)==0;
 if($134){label=51;break;}else{label=49;break;}
 case 49: 
 var $136=HEAP32[(($__g_end)>>2)];
 var $137=$136;
 var $138=$__g;
 var $139=((($137)-($138))|0);
 var $140=($139|0)<160;
 if($140){label=50;break;}else{label=51;break;}
 case 50: 
 var $142=HEAP32[(($__dc)>>2)];
 var $143=(($136+4)|0);
 HEAP32[(($__g_end)>>2)]=$143;
 HEAP32[(($136)>>2)]=$142;
 label=51;break;
 case 51: 
 var $144=HEAP32[(($__a_end)>>2)];
 var $145=(function() { try { __THREW__ = 0; return __ZNSt3__115__num_get_floatIdEET_PKcS3_Rj($__a_2,$144,$__err) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=52;break; } else { label=34;break; }
 case 52: 
 HEAPF64[(($__v)>>3)]=$145;
 var $147=HEAP32[(($__g_end)>>2)];
 __ZNSt3__116__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj($__grouping,$11,$147,$__err);
 var $148=($32|0)==0;
 if($148){var $162=0;label=57;break;}else{label=53;break;}
 case 53: 
 var $150=(($32+12)|0);
 var $151=HEAP32[(($150)>>2)];
 var $152=(($32+16)|0);
 var $153=HEAP32[(($152)>>2)];
 var $154=($151|0)==($153|0);
 if($154){label=54;break;}else{var $162=$32;label=57;break;}
 case 54: 
 var $155=$32;
 var $156=HEAP32[(($155)>>2)];
 var $157=(($156+36)|0);
 var $158=HEAP32[(($157)>>2)];
 var $159=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$158]($32) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=55;break; } else { label=34;break; }
 case 55: 
 var $160=($159|0)==-1;
 if($160){label=56;break;}else{var $162=$32;label=57;break;}
 case 56: 
 HEAP32[(($12)>>2)]=0;
 var $162=0;label=57;break;
 case 57: 
 var $162;
 var $163=($162|0)==0;
 var $164=($_pre_i3_i_i|0)==0;
 if($164){label=63;break;}else{label=58;break;}
 case 58: 
 var $166=(($_pre_i3_i_i+12)|0);
 var $167=HEAP32[(($166)>>2)];
 var $168=(($_pre_i3_i_i+16)|0);
 var $169=HEAP32[(($168)>>2)];
 var $170=($167|0)==($169|0);
 if($170){label=60;break;}else{label=59;break;}
 case 59: 
 if($163){label=66;break;}else{label=65;break;}
 case 60: 
 var $171=$_pre_i3_i_i;
 var $172=HEAP32[(($171)>>2)];
 var $173=(($172+36)|0);
 var $174=HEAP32[(($173)>>2)];
 var $175=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$174]($_pre_i3_i_i) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=61;break; } else { label=34;break; }
 case 61: 
 var $176=($175|0)==-1;
 if($176){label=62;break;}else{label=64;break;}
 case 62: 
 HEAP32[(($13)>>2)]=0;
 label=63;break;
 case 63: 
 if($163){label=65;break;}else{label=66;break;}
 case 64: 
 var $178=($_pre_i3_i_i|0)==0;
 var $tmp_i_i=$163^$178;
 if($tmp_i_i){label=66;break;}else{label=65;break;}
 case 65: 
 var $180=HEAP32[(($__err)>>2)];
 var $181=$180|2;
 HEAP32[(($__err)>>2)]=$181;
 label=66;break;
 case 66: 
 var $183=(($agg_result)|0);
 HEAP32[(($183)>>2)]=$162;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__buf);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grouping);
 STACKTOP=sp;return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRe($agg_result,$this,$__b,$__e,$__iob,$__err,$__v){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+16)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var tempParam = $__b; $__b=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__b)>>2)]=HEAP32[((tempParam)>>2)];
 var tempParam = $__e; $__e=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];

 var $1=sp;
 var $2=(sp)+(8);
 var $3=(($__b)|0);
 var $4=HEAP32[(($3)>>2)];
 var $5=(($1)|0);
 HEAP32[(($5)>>2)]=$4;
 var $6=(($__e)|0);
 var $7=HEAP32[(($6)>>2)];
 var $8=(($2)|0);
 HEAP32[(($8)>>2)]=$7;
 __ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE23__do_get_floating_pointIeEES4_S4_S4_RNS_8ios_baseERjRT_($agg_result,0,$1,$2,$__iob,$__err,$__v);
 STACKTOP=sp;return;
}


function __ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE23__do_get_floating_pointIeEES4_S4_S4_RNS_8ios_baseERjRT_($agg_result,$this,$__b,$__e,$__iob,$__err,$__v){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+280)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var tempParam = $__b; $__b=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__b)>>2)]=HEAP32[((tempParam)>>2)];
 var tempParam = $__e; $__e=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $__atoms=sp;
 var $__decimal_point=(sp)+(32);
 var $__thousands_sep=(sp)+(40);
 var $__grouping=(sp)+(48);
 var $__buf=(sp)+(64);
 var $__a_end=(sp)+(80);
 var $__g=(sp)+(88);
 var $__g_end=(sp)+(248);
 var $__dc=(sp)+(256);
 var $__in_units=(sp)+(264);
 var $__exp=(sp)+(272);
 var $0=(($__atoms)|0);
 __ZNSt3__19__num_getIcE19__stage2_float_prepERNS_8ios_baseEPcRcS5_($__grouping,$__iob,$0,$__decimal_point,$__thousands_sep);
 var $this4_i_i_i=$__buf;
 HEAP32[(($this4_i_i_i)>>2)]=0; HEAP32[((($this4_i_i_i)+(4))>>2)]=0; HEAP32[((($this4_i_i_i)+(8))>>2)]=0;
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc($__buf,10,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=2;break; } else { label=34;break; }
 case 2: 
 var $1=HEAP8[($this4_i_i_i)];
 var $2=$1&1;
 var $3=(($2<<24)>>24)==0;
 if($3){label=4;break;}else{label=3;break;}
 case 3: 
 var $5=(($__buf+8)|0);
 var $6=HEAP32[(($5)>>2)];
 var $_pre42=$__buf;
 var $_pre43=(($_pre42+1)|0);
 var $10=$6;var $_pre_phi44=$_pre43;var $_pre_phi46=$5;label=5;break;
 case 4: 
 var $8=$__buf;
 var $9=(($8+1)|0);
 var $_pre45=(($__buf+8)|0);
 var $10=$9;var $_pre_phi44=$9;var $_pre_phi46=$_pre45;label=5;break;
 case 5: 
 var $_pre_phi46;
 var $_pre_phi44;
 var $10;
 HEAP32[(($__a_end)>>2)]=$10;
 var $11=(($__g)|0);
 HEAP32[(($__g_end)>>2)]=$11;
 HEAP32[(($__dc)>>2)]=0;
 HEAP8[($__in_units)]=1;
 HEAP8[($__exp)]=69;
 var $12=(($__b)|0);
 var $13=(($__e)|0);
 var $14=(($__buf)|0);
 var $15=(($__buf+4)|0);
 var $16=HEAP8[($__decimal_point)];
 var $17=HEAP8[($__thousands_sep)];
 var $_pre=HEAP32[(($12)>>2)];
 var $__a_0=$10;var $_pre_i_i_i15=$_pre;label=6;break;
 case 6: 
 var $_pre_i_i_i15;
 var $__a_0;
 var $18=($_pre_i_i_i15|0)==0;
 if($18){var $32=0;label=11;break;}else{label=7;break;}
 case 7: 
 var $20=(($_pre_i_i_i15+12)|0);
 var $21=HEAP32[(($20)>>2)];
 var $22=(($_pre_i_i_i15+16)|0);
 var $23=HEAP32[(($22)>>2)];
 var $24=($21|0)==($23|0);
 if($24){label=8;break;}else{var $32=$_pre_i_i_i15;label=11;break;}
 case 8: 
 var $25=$_pre_i_i_i15;
 var $26=HEAP32[(($25)>>2)];
 var $27=(($26+36)|0);
 var $28=HEAP32[(($27)>>2)];
 var $29=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$28]($_pre_i_i_i15) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=9;break; } else { label=33;break; }
 case 9: 
 var $30=($29|0)==-1;
 if($30){label=10;break;}else{var $32=$_pre_i_i_i15;label=11;break;}
 case 10: 
 HEAP32[(($12)>>2)]=0;
 var $32=0;label=11;break;
 case 11: 
 var $32;
 var $33=($32|0)==0;
 var $34=HEAP32[(($13)>>2)];
 var $35=($34|0)==0;
 if($35){label=17;break;}else{label=12;break;}
 case 12: 
 var $37=(($34+12)|0);
 var $38=HEAP32[(($37)>>2)];
 var $39=(($34+16)|0);
 var $40=HEAP32[(($39)>>2)];
 var $41=($38|0)==($40|0);
 if($41){label=14;break;}else{label=13;break;}
 case 13: 
 if($33){var $50=$34;label=19;break;}else{var $__a_2=$__a_0;var $_pre_i3_i_i=$34;label=44;break;}
 case 14: 
 var $42=$34;
 var $43=HEAP32[(($42)>>2)];
 var $44=(($43+36)|0);
 var $45=HEAP32[(($44)>>2)];
 var $46=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$45]($34) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=15;break; } else { label=33;break; }
 case 15: 
 var $47=($46|0)==-1;
 if($47){label=16;break;}else{label=18;break;}
 case 16: 
 HEAP32[(($13)>>2)]=0;
 label=17;break;
 case 17: 
 if($33){var $__a_2=$__a_0;var $_pre_i3_i_i=0;label=44;break;}else{var $50=0;label=19;break;}
 case 18: 
 if($33){var $50=$34;label=19;break;}else{var $__a_2=$__a_0;var $_pre_i3_i_i=$34;label=44;break;}
 case 19: 
 var $50;
 var $51=HEAP32[(($__a_end)>>2)];
 var $52=$51;
 var $53=$__a_0;
 var $54=((($52)-($53))|0);
 var $55=HEAP8[($this4_i_i_i)];
 var $56=$55&1;
 var $57=(($56<<24)>>24)==0;
 if($57){label=21;break;}else{label=20;break;}
 case 20: 
 var $59=HEAP32[(($15)>>2)];
 var $63=$59;label=22;break;
 case 21: 
 var $61=($55&255);
 var $62=$61>>>1;
 var $63=$62;label=22;break;
 case 22: 
 var $63;
 var $64=($54|0)==($63|0);
 if($64){label=23;break;}else{var $__a_1=$__a_0;label=36;break;}
 case 23: 
 if($57){label=25;break;}else{label=24;break;}
 case 24: 
 var $67=HEAP32[(($15)>>2)];
 var $74=$67;var $73=$67;label=26;break;
 case 25: 
 var $69=($55&255);
 var $70=$69>>>1;
 var $71=($55&255);
 var $72=$71>>>1;
 var $74=$72;var $73=$70;label=26;break;
 case 26: 
 var $73;
 var $74;
 var $75=$74<<1;
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc($__buf,$75,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=27;break; } else { label=33;break; }
 case 27: 
 var $76=HEAP8[($this4_i_i_i)];
 var $77=$76&1;
 var $78=(($77<<24)>>24)==0;
 if($78){var $82=10;label=29;break;}else{label=28;break;}
 case 28: 
 var $80=HEAP32[(($14)>>2)];
 var $81=$80&-2;
 var $phitmp_i30=((($81)-(1))|0);
 var $82=$phitmp_i30;label=29;break;
 case 29: 
 var $82;
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc($__buf,$82,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=30;break; } else { label=33;break; }
 case 30: 
 var $83=HEAP8[($this4_i_i_i)];
 var $84=$83&1;
 var $85=(($84<<24)>>24)==0;
 if($85){var $88=$_pre_phi44;label=32;break;}else{label=31;break;}
 case 31: 
 var $87=HEAP32[(($_pre_phi46)>>2)];
 var $88=$87;label=32;break;
 case 32: 
 var $88;
 var $89=(($88+$73)|0);
 HEAP32[(($__a_end)>>2)]=$89;
 var $__a_1=$88;label=36;break;
 case 33: 
 var $lpad_loopexit$0 = ___cxa_find_matching_catch(-1, -1); var $lpad_loopexit$1 = tempRet0;
 var $lpad_phi$1=$lpad_loopexit$1;var $lpad_phi$0=$lpad_loopexit$0;label=35;break;
 case 34: 
 var $lpad_nonloopexit$0 = ___cxa_find_matching_catch(-1, -1); var $lpad_nonloopexit$1 = tempRet0;
 var $lpad_phi$1=$lpad_nonloopexit$1;var $lpad_phi$0=$lpad_nonloopexit$0;label=35;break;
 case 35: 
 var $lpad_phi$0;
 var $lpad_phi$1;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__buf);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grouping);
 ___resumeException($lpad_phi$0)
 case 36: 
 var $__a_1;
 var $91=(($32+12)|0);
 var $92=HEAP32[(($91)>>2)];
 var $93=(($32+16)|0);
 var $94=HEAP32[(($93)>>2)];
 var $95=($92|0)==($94|0);
 if($95){label=37;break;}else{label=39;break;}
 case 37: 
 var $97=$32;
 var $98=HEAP32[(($97)>>2)];
 var $99=(($98+36)|0);
 var $100=HEAP32[(($99)>>2)];
 var $101=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$100]($32) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=38;break; } else { label=33;break; }
 case 38: 
 var $extract_t_i=(($101)&255);
 var $_0_i_off0_i=$extract_t_i;label=40;break;
 case 39: 
 var $103=HEAP8[($92)];
 var $_0_i_off0_i=$103;label=40;break;
 case 40: 
 var $_0_i_off0_i;
 var $105=__ZNSt3__19__num_getIcE19__stage2_float_loopEcRbRcPcRS4_ccRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSE_RjS4_($_0_i_off0_i,$__in_units,$__exp,$__a_1,$__a_end,$16,$17,$__grouping,$11,$__g_end,$__dc,$0);
 var $106=($105|0)==0;
 if($106){label=41;break;}else{var $__a_2=$__a_1;var $_pre_i3_i_i=$50;label=44;break;}
 case 41: 
 var $108=HEAP32[(($91)>>2)];
 var $109=HEAP32[(($93)>>2)];
 var $110=($108|0)==($109|0);
 if($110){label=42;break;}else{label=43;break;}
 case 42: 
 var $112=$32;
 var $113=HEAP32[(($112)>>2)];
 var $114=(($113+40)|0);
 var $115=HEAP32[(($114)>>2)];
 var $116=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$115]($32) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $__a_0=$__a_1;var $_pre_i_i_i15=$32;label=6;break; } else { label=33;break; }
 case 43: 
 var $118=(($108+1)|0);
 HEAP32[(($91)>>2)]=$118;
 var $__a_0=$__a_1;var $_pre_i_i_i15=$32;label=6;break;
 case 44: 
 var $_pre_i3_i_i;
 var $__a_2;
 var $120=$__grouping;
 var $121=HEAP8[($120)];
 var $122=$121&1;
 var $123=(($122<<24)>>24)==0;
 if($123){label=46;break;}else{label=45;break;}
 case 45: 
 var $125=(($__grouping+4)|0);
 var $126=HEAP32[(($125)>>2)];
 var $130=$126;label=47;break;
 case 46: 
 var $128=($121&255);
 var $129=$128>>>1;
 var $130=$129;label=47;break;
 case 47: 
 var $130;
 var $131=($130|0)==0;
 if($131){label=51;break;}else{label=48;break;}
 case 48: 
 var $133=HEAP8[($__in_units)];
 var $134=(($133<<24)>>24)==0;
 if($134){label=51;break;}else{label=49;break;}
 case 49: 
 var $136=HEAP32[(($__g_end)>>2)];
 var $137=$136;
 var $138=$__g;
 var $139=((($137)-($138))|0);
 var $140=($139|0)<160;
 if($140){label=50;break;}else{label=51;break;}
 case 50: 
 var $142=HEAP32[(($__dc)>>2)];
 var $143=(($136+4)|0);
 HEAP32[(($__g_end)>>2)]=$143;
 HEAP32[(($136)>>2)]=$142;
 label=51;break;
 case 51: 
 var $144=HEAP32[(($__a_end)>>2)];
 var $145=(function() { try { __THREW__ = 0; return __ZNSt3__115__num_get_floatIeEET_PKcS3_Rj($__a_2,$144,$__err) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=52;break; } else { label=34;break; }
 case 52: 
 HEAPF64[(($__v)>>3)]=$145;
 var $147=HEAP32[(($__g_end)>>2)];
 __ZNSt3__116__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj($__grouping,$11,$147,$__err);
 var $148=($32|0)==0;
 if($148){var $162=0;label=57;break;}else{label=53;break;}
 case 53: 
 var $150=(($32+12)|0);
 var $151=HEAP32[(($150)>>2)];
 var $152=(($32+16)|0);
 var $153=HEAP32[(($152)>>2)];
 var $154=($151|0)==($153|0);
 if($154){label=54;break;}else{var $162=$32;label=57;break;}
 case 54: 
 var $155=$32;
 var $156=HEAP32[(($155)>>2)];
 var $157=(($156+36)|0);
 var $158=HEAP32[(($157)>>2)];
 var $159=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$158]($32) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=55;break; } else { label=34;break; }
 case 55: 
 var $160=($159|0)==-1;
 if($160){label=56;break;}else{var $162=$32;label=57;break;}
 case 56: 
 HEAP32[(($12)>>2)]=0;
 var $162=0;label=57;break;
 case 57: 
 var $162;
 var $163=($162|0)==0;
 var $164=($_pre_i3_i_i|0)==0;
 if($164){label=63;break;}else{label=58;break;}
 case 58: 
 var $166=(($_pre_i3_i_i+12)|0);
 var $167=HEAP32[(($166)>>2)];
 var $168=(($_pre_i3_i_i+16)|0);
 var $169=HEAP32[(($168)>>2)];
 var $170=($167|0)==($169|0);
 if($170){label=60;break;}else{label=59;break;}
 case 59: 
 if($163){label=66;break;}else{label=65;break;}
 case 60: 
 var $171=$_pre_i3_i_i;
 var $172=HEAP32[(($171)>>2)];
 var $173=(($172+36)|0);
 var $174=HEAP32[(($173)>>2)];
 var $175=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$174]($_pre_i3_i_i) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=61;break; } else { label=34;break; }
 case 61: 
 var $176=($175|0)==-1;
 if($176){label=62;break;}else{label=64;break;}
 case 62: 
 HEAP32[(($13)>>2)]=0;
 label=63;break;
 case 63: 
 if($163){label=65;break;}else{label=66;break;}
 case 64: 
 var $178=($_pre_i3_i_i|0)==0;
 var $tmp_i_i=$163^$178;
 if($tmp_i_i){label=66;break;}else{label=65;break;}
 case 65: 
 var $180=HEAP32[(($__err)>>2)];
 var $181=$180|2;
 HEAP32[(($__err)>>2)]=$181;
 label=66;break;
 case 66: 
 var $183=(($agg_result)|0);
 HEAP32[(($183)>>2)]=$162;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__buf);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grouping);
 STACKTOP=sp;return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRPv($agg_result,$this,$__b,$__e,$__iob,$__err,$__v){
 var label=0;
 var tempVarArgs=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+272)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var tempParam = $__b; $__b=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__b)>>2)]=HEAP32[((tempParam)>>2)];
 var tempParam = $__e; $__e=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $__p_i_i_i_i=sp;
 var $__atoms=(sp)+(16);
 var $__grouping=(sp)+(48);
 var $1=(sp)+(64);
 var $__buf=(sp)+(72);
 var $__a_end=(sp)+(88);
 var $__g=(sp)+(96);
 var $__g_end=(sp)+(256);
 var $__dc=(sp)+(264);
 var $this4_i_i_i=$__grouping;
 HEAP32[(($this4_i_i_i)>>2)]=0; HEAP32[((($this4_i_i_i)+(4))>>2)]=0; HEAP32[((($this4_i_i_i)+(8))>>2)]=0;
 (function() { try { __THREW__ = 0; return __ZNKSt3__18ios_base6getlocEv($1,$__iob) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=2;break; } else { label=41;break; }
 case 2: 
 var $3=(($1)|0);
 var $4=HEAP32[(($3)>>2)];
 var $5=$__p_i_i_i_i;
 var $6=HEAP32[((14096)>>2)];
 var $7=($6|0)==-1;
 if($7){label=4;break;}else{label=3;break;}
 case 3: 
 var $_sroa_01_0___p67_i_idx_i_i_i=(($__p_i_i_i_i)|0);
 HEAP32[(($_sroa_01_0___p67_i_idx_i_i_i)>>2)]=14096;
 var $_sroa_12_4___p67_i_idx3_i_i_i=(($__p_i_i_i_i+4)|0);
 HEAP32[(($_sroa_12_4___p67_i_idx3_i_i_i)>>2)]=(28);
 var $_sroa_2_8___p67_i_idx4_i_i_i=(($__p_i_i_i_i+8)|0);
 HEAP32[(($_sroa_2_8___p67_i_idx4_i_i_i)>>2)]=0;
 (function() { try { __THREW__ = 0; return __ZNSt3__111__call_onceERVmPvPFvS2_E(14096,$5,260) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=4;break; } else { label=42;break; }
 case 4: 
 var $9=HEAP32[((14100)>>2)];
 var $10=((($9)-(1))|0);
 var $11=(($4+12)|0);
 var $12=HEAP32[(($11)>>2)];
 var $13=(($4+8)|0);
 var $14=HEAP32[(($13)>>2)];
 var $15=$12;
 var $16=$14;
 var $17=((($15)-($16))|0);
 var $18=$17>>2;
 var $19=($18>>>0)>($10>>>0);
 if($19){label=5;break;}else{label=6;break;}
 case 5: 
 var $20=(($14+($10<<2))|0);
 var $21=HEAP32[(($20)>>2)];
 var $22=($21|0)==0;
 if($22){label=6;break;}else{label=8;break;}
 case 6: 
 var $23=___cxa_allocate_exception(4);
 var $24=$23;
 __ZNSt8bad_castC2Ev($24);
 (function() { try { __THREW__ = 0; return ___cxa_throw($23,8960,(368)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=7;break; } else { label=42;break; }
 case 7: 
 throw "Reached an unreachable!";
 case 8: 
 var $26=$21;
 var $27=(($__atoms)|0);
 var $28=$21;
 var $29=HEAP32[(($28)>>2)];
 var $30=(($29+32)|0);
 var $31=HEAP32[(($30)>>2)];
 var $32=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$31]($26,10592,10618,$27) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=9;break; } else { label=42;break; }
 case 9: 
 var $33=HEAP32[(($3)>>2)];
 var $34=(($33)|0);
 var $35=__ZNSt3__114__shared_count16__release_sharedEv($34);
 var $this4_i_i_i17=$__buf;
 HEAP32[(($this4_i_i_i17)>>2)]=0; HEAP32[((($this4_i_i_i17)+(4))>>2)]=0; HEAP32[((($this4_i_i_i17)+(8))>>2)]=0;
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc($__buf,10,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=10;break; } else { label=44;break; }
 case 10: 
 var $36=HEAP8[($this4_i_i_i17)];
 var $37=$36&1;
 var $38=(($37<<24)>>24)==0;
 if($38){label=12;break;}else{label=11;break;}
 case 11: 
 var $40=(($__buf+8)|0);
 var $41=HEAP32[(($40)>>2)];
 var $_pre44=$__buf;
 var $_pre45=(($_pre44+1)|0);
 var $45=$41;var $_pre_phi46=$_pre45;var $_pre_phi48=$40;label=13;break;
 case 12: 
 var $43=$__buf;
 var $44=(($43+1)|0);
 var $_pre47=(($__buf+8)|0);
 var $45=$44;var $_pre_phi46=$44;var $_pre_phi48=$_pre47;label=13;break;
 case 13: 
 var $_pre_phi48;
 var $_pre_phi46;
 var $45;
 HEAP32[(($__a_end)>>2)]=$45;
 var $46=(($__g)|0);
 HEAP32[(($__g_end)>>2)]=$46;
 HEAP32[(($__dc)>>2)]=0;
 var $47=(($__b)|0);
 var $48=(($__e)|0);
 var $49=(($__buf)|0);
 var $50=(($__buf+4)|0);
 var $_pre=HEAP32[(($47)>>2)];
 var $__a_0=$45;var $_pre_i_i_i20=$_pre;label=14;break;
 case 14: 
 var $_pre_i_i_i20;
 var $__a_0;
 var $51=($_pre_i_i_i20|0)==0;
 if($51){var $65=0;label=19;break;}else{label=15;break;}
 case 15: 
 var $53=(($_pre_i_i_i20+12)|0);
 var $54=HEAP32[(($53)>>2)];
 var $55=(($_pre_i_i_i20+16)|0);
 var $56=HEAP32[(($55)>>2)];
 var $57=($54|0)==($56|0);
 if($57){label=16;break;}else{var $65=$_pre_i_i_i20;label=19;break;}
 case 16: 
 var $58=$_pre_i_i_i20;
 var $59=HEAP32[(($58)>>2)];
 var $60=(($59+36)|0);
 var $61=HEAP32[(($60)>>2)];
 var $62=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$61]($_pre_i_i_i20) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=17;break; } else { label=43;break; }
 case 17: 
 var $63=($62|0)==-1;
 if($63){label=18;break;}else{var $65=$_pre_i_i_i20;label=19;break;}
 case 18: 
 HEAP32[(($47)>>2)]=0;
 var $65=0;label=19;break;
 case 19: 
 var $65;
 var $66=($65|0)==0;
 var $67=HEAP32[(($48)>>2)];
 var $68=($67|0)==0;
 if($68){label=25;break;}else{label=20;break;}
 case 20: 
 var $70=(($67+12)|0);
 var $71=HEAP32[(($70)>>2)];
 var $72=(($67+16)|0);
 var $73=HEAP32[(($72)>>2)];
 var $74=($71|0)==($73|0);
 if($74){label=22;break;}else{label=21;break;}
 case 21: 
 if($66){label=27;break;}else{var $__a_2=$__a_0;label=54;break;}
 case 22: 
 var $75=$67;
 var $76=HEAP32[(($75)>>2)];
 var $77=(($76+36)|0);
 var $78=HEAP32[(($77)>>2)];
 var $79=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$78]($67) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=23;break; } else { label=43;break; }
 case 23: 
 var $80=($79|0)==-1;
 if($80){label=24;break;}else{label=26;break;}
 case 24: 
 HEAP32[(($48)>>2)]=0;
 label=25;break;
 case 25: 
 if($66){var $__a_2=$__a_0;label=54;break;}else{label=27;break;}
 case 26: 
 if($66){label=27;break;}else{var $__a_2=$__a_0;label=54;break;}
 case 27: 
 var $83=HEAP32[(($__a_end)>>2)];
 var $84=$83;
 var $85=$__a_0;
 var $86=((($84)-($85))|0);
 var $87=HEAP8[($this4_i_i_i17)];
 var $88=$87&1;
 var $89=(($88<<24)>>24)==0;
 if($89){label=29;break;}else{label=28;break;}
 case 28: 
 var $91=HEAP32[(($50)>>2)];
 var $95=$91;label=30;break;
 case 29: 
 var $93=($87&255);
 var $94=$93>>>1;
 var $95=$94;label=30;break;
 case 30: 
 var $95;
 var $96=($86|0)==($95|0);
 if($96){label=31;break;}else{var $__a_1=$__a_0;label=46;break;}
 case 31: 
 if($89){label=33;break;}else{label=32;break;}
 case 32: 
 var $99=HEAP32[(($50)>>2)];
 var $106=$99;var $105=$99;label=34;break;
 case 33: 
 var $101=($87&255);
 var $102=$101>>>1;
 var $103=($87&255);
 var $104=$103>>>1;
 var $106=$104;var $105=$102;label=34;break;
 case 34: 
 var $105;
 var $106;
 var $107=$106<<1;
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc($__buf,$107,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=35;break; } else { label=43;break; }
 case 35: 
 var $108=HEAP8[($this4_i_i_i17)];
 var $109=$108&1;
 var $110=(($109<<24)>>24)==0;
 if($110){var $114=10;label=37;break;}else{label=36;break;}
 case 36: 
 var $112=HEAP32[(($49)>>2)];
 var $113=$112&-2;
 var $phitmp_i33=((($113)-(1))|0);
 var $114=$phitmp_i33;label=37;break;
 case 37: 
 var $114;
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc($__buf,$114,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=38;break; } else { label=43;break; }
 case 38: 
 var $115=HEAP8[($this4_i_i_i17)];
 var $116=$115&1;
 var $117=(($116<<24)>>24)==0;
 if($117){var $120=$_pre_phi46;label=40;break;}else{label=39;break;}
 case 39: 
 var $119=HEAP32[(($_pre_phi48)>>2)];
 var $120=$119;label=40;break;
 case 40: 
 var $120;
 var $121=(($120+$105)|0);
 HEAP32[(($__a_end)>>2)]=$121;
 var $__a_1=$120;label=46;break;
 case 41: 
 var $123$0 = ___cxa_find_matching_catch(-1, -1); var $123$1 = tempRet0;
 var $124=$123$0;
 var $125=$123$1;
 var $_0=$124;var $_012=$125;label=77;break;
 case 42: 
 var $127$0 = ___cxa_find_matching_catch(-1, -1); var $127$1 = tempRet0;
 var $128=$127$0;
 var $129=$127$1;
 var $130=HEAP32[(($3)>>2)];
 var $131=(($130)|0);
 var $132=__ZNSt3__114__shared_count16__release_sharedEv($131);
 var $_0=$128;var $_012=$129;label=77;break;
 case 43: 
 var $lpad_loopexit$0 = ___cxa_find_matching_catch(-1, -1); var $lpad_loopexit$1 = tempRet0;
 var $eh_lpad_body$1=$lpad_loopexit$1;var $eh_lpad_body$0=$lpad_loopexit$0;label=45;break;
 case 44: 
 var $lpad_nonloopexit$0 = ___cxa_find_matching_catch(-1, -1); var $lpad_nonloopexit$1 = tempRet0;
 var $eh_lpad_body$1=$lpad_nonloopexit$1;var $eh_lpad_body$0=$lpad_nonloopexit$0;label=45;break;
 case 45: 
 var $eh_lpad_body$0;
 var $eh_lpad_body$1;
 var $133=$eh_lpad_body$0;
 var $134=$eh_lpad_body$1;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__buf);
 var $_0=$133;var $_012=$134;label=77;break;
 case 46: 
 var $__a_1;
 var $135=(($65+12)|0);
 var $136=HEAP32[(($135)>>2)];
 var $137=(($65+16)|0);
 var $138=HEAP32[(($137)>>2)];
 var $139=($136|0)==($138|0);
 if($139){label=47;break;}else{label=49;break;}
 case 47: 
 var $141=$65;
 var $142=HEAP32[(($141)>>2)];
 var $143=(($142+36)|0);
 var $144=HEAP32[(($143)>>2)];
 var $145=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$144]($65) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=48;break; } else { label=43;break; }
 case 48: 
 var $extract_t_i=(($145)&255);
 var $_0_i_off0_i=$extract_t_i;label=50;break;
 case 49: 
 var $147=HEAP8[($136)];
 var $_0_i_off0_i=$147;label=50;break;
 case 50: 
 var $_0_i_off0_i;
 var $149=__ZNSt3__19__num_getIcE17__stage2_int_loopEciPcRS2_RjcRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSD_S2_($_0_i_off0_i,16,$__a_1,$__a_end,$__dc,0,$__grouping,$46,$__g_end,$27);
 var $150=($149|0)==0;
 if($150){label=51;break;}else{var $__a_2=$__a_1;label=54;break;}
 case 51: 
 var $152=HEAP32[(($135)>>2)];
 var $153=HEAP32[(($137)>>2)];
 var $154=($152|0)==($153|0);
 if($154){label=52;break;}else{label=53;break;}
 case 52: 
 var $156=$65;
 var $157=HEAP32[(($156)>>2)];
 var $158=(($157+40)|0);
 var $159=HEAP32[(($158)>>2)];
 var $160=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$159]($65) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $__a_0=$__a_1;var $_pre_i_i_i20=$65;label=14;break; } else { label=43;break; }
 case 53: 
 var $162=(($152+1)|0);
 HEAP32[(($135)>>2)]=$162;
 var $__a_0=$__a_1;var $_pre_i_i_i20=$65;label=14;break;
 case 54: 
 var $__a_2;
 var $164=(($__a_2+3)|0);
 HEAP8[($164)]=0;
 var $165=HEAP8[(14656)];
 var $166=(($165<<24)>>24)==0;
 if($166){label=55;break;}else{label=59;break;}
 case 55: 
 var $168=___cxa_guard_acquire(14656);
 var $169=($168|0)==0;
 if($169){label=59;break;}else{label=56;break;}
 case 56: 
 var $171=(function() { try { __THREW__ = 0; return _newlocale(2147483647,1496,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=57;break; } else { label=58;break; }
 case 57: 
 HEAP32[((12664)>>2)]=$171;

 label=59;break;
 case 58: 
 var $174$0 = ___cxa_find_matching_catch(-1, -1); var $174$1 = tempRet0;

 var $eh_lpad_body$1=$174$1;var $eh_lpad_body$0=$174$0;label=45;break;
 case 59: 
 var $176=HEAP32[((12664)>>2)];
 var $177=(function() { try { __THREW__ = 0; return __ZNSt3__110__sscanf_lEPKcP15__locale_structS1_z($__a_2,$176,1152,(tempVarArgs=STACKTOP,STACKTOP = (STACKTOP + 8)|0,(assert((STACKTOP|0) < (STACK_MAX|0))|0),HEAP32[((tempVarArgs)>>2)]=$__v,tempVarArgs)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })(); STACKTOP=tempVarArgs;if (!__THREW__) { label=60;break; } else { label=44;break; }
 case 60: 
 var $179=($177|0)==1;
 if($179){label=62;break;}else{label=61;break;}
 case 61: 
 HEAP32[(($__err)>>2)]=4;
 label=62;break;
 case 62: 
 var $182=HEAP32[(($47)>>2)];
 var $183=($182|0)==0;
 if($183){var $197=0;label=67;break;}else{label=63;break;}
 case 63: 
 var $185=(($182+12)|0);
 var $186=HEAP32[(($185)>>2)];
 var $187=(($182+16)|0);
 var $188=HEAP32[(($187)>>2)];
 var $189=($186|0)==($188|0);
 if($189){label=64;break;}else{var $197=$182;label=67;break;}
 case 64: 
 var $190=$182;
 var $191=HEAP32[(($190)>>2)];
 var $192=(($191+36)|0);
 var $193=HEAP32[(($192)>>2)];
 var $194=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$193]($182) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=65;break; } else { label=44;break; }
 case 65: 
 var $195=($194|0)==-1;
 if($195){label=66;break;}else{var $197=$182;label=67;break;}
 case 66: 
 HEAP32[(($47)>>2)]=0;
 var $197=0;label=67;break;
 case 67: 
 var $197;
 var $198=($197|0)==0;
 var $199=HEAP32[(($48)>>2)];
 var $200=($199|0)==0;
 if($200){label=73;break;}else{label=68;break;}
 case 68: 
 var $202=(($199+12)|0);
 var $203=HEAP32[(($202)>>2)];
 var $204=(($199+16)|0);
 var $205=HEAP32[(($204)>>2)];
 var $206=($203|0)==($205|0);
 if($206){label=70;break;}else{label=69;break;}
 case 69: 
 if($198){label=76;break;}else{label=75;break;}
 case 70: 
 var $207=$199;
 var $208=HEAP32[(($207)>>2)];
 var $209=(($208+36)|0);
 var $210=HEAP32[(($209)>>2)];
 var $211=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$210]($199) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=71;break; } else { label=44;break; }
 case 71: 
 var $212=($211|0)==-1;
 if($212){label=72;break;}else{label=74;break;}
 case 72: 
 HEAP32[(($48)>>2)]=0;
 label=73;break;
 case 73: 
 if($198){label=75;break;}else{label=76;break;}
 case 74: 
 var $214=($199|0)==0;
 var $tmp_i_i=$198^$214;
 if($tmp_i_i){label=76;break;}else{label=75;break;}
 case 75: 
 var $216=HEAP32[(($__err)>>2)];
 var $217=$216|2;
 HEAP32[(($__err)>>2)]=$217;
 label=76;break;
 case 76: 
 var $219=(($agg_result)|0);
 HEAP32[(($219)>>2)]=$197;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__buf);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grouping);
 STACKTOP=sp;return;
 case 77: 
 var $_012;
 var $_0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grouping);
 var $221$0=$_0;
 var $221$1=0;
 var $222$0=$221$0;
 var $222$1=$_012;
 ___resumeException($222$0)
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__19__num_getIcE17__stage2_int_loopEciPcRS2_RjcRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSD_S2_($__ct,$__base,$__a,$__a_end,$__dc,$__thousands_sep,$__grouping,$__g,$__g_end,$__atoms){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=HEAP32[(($__a_end)>>2)];
 var $2=($1|0)==($__a|0);
 if($2){label=2;break;}else{label=5;break;}
 case 2: 
 var $4=(($__atoms+24)|0);
 var $5=HEAP8[($4)];
 var $6=(($5<<24)>>24)==(($__ct<<24)>>24);
 if($6){label=4;break;}else{label=3;break;}
 case 3: 
 var $8=(($__atoms+25)|0);
 var $9=HEAP8[($8)];
 var $10=(($9<<24)>>24)==(($__ct<<24)>>24);
 if($10){label=4;break;}else{label=5;break;}
 case 4: 
 var $12=($6?43:45);
 var $13=(($__a+1)|0);
 HEAP32[(($__a_end)>>2)]=$13;
 HEAP8[($__a)]=$12;
 HEAP32[(($__dc)>>2)]=0;
 var $_0=0;label=23;break;
 case 5: 
 var $15=$__grouping;
 var $16=HEAP8[($15)];
 var $17=$16&1;
 var $18=(($17<<24)>>24)==0;
 if($18){label=7;break;}else{label=6;break;}
 case 6: 
 var $20=(($__grouping+4)|0);
 var $21=HEAP32[(($20)>>2)];
 var $25=$21;label=8;break;
 case 7: 
 var $23=($16&255);
 var $24=$23>>>1;
 var $25=$24;label=8;break;
 case 8: 
 var $25;
 var $26=($25|0)!=0;
 var $27=(($__ct<<24)>>24)==(($__thousands_sep<<24)>>24);
 var $or_cond=$26&$27;
 if($or_cond){label=9;break;}else{label=11;break;}
 case 9: 
 var $29=HEAP32[(($__g_end)>>2)];
 var $30=$29;
 var $31=$__g;
 var $32=((($30)-($31))|0);
 var $33=($32|0)<160;
 if($33){label=10;break;}else{var $_0=0;label=23;break;}
 case 10: 
 var $35=HEAP32[(($__dc)>>2)];
 var $36=(($29+4)|0);
 HEAP32[(($__g_end)>>2)]=$36;
 HEAP32[(($29)>>2)]=$35;
 HEAP32[(($__dc)>>2)]=0;
 var $_0=0;label=23;break;
 case 11: 
 var $38=(($__atoms+26)|0);
 var $_0_i=$__atoms;label=12;break;
 case 12: 
 var $_0_i;
 var $40=($_0_i|0)==($38|0);
 if($40){var $_0_lcssa_i=$38;label=14;break;}else{label=13;break;}
 case 13: 
 var $42=HEAP8[($_0_i)];
 var $43=(($42<<24)>>24)==(($__ct<<24)>>24);
 var $44=(($_0_i+1)|0);
 if($43){var $_0_lcssa_i=$_0_i;label=14;break;}else{var $_0_i=$44;label=12;break;}
 case 14: 
 var $_0_lcssa_i;
 var $45=$_0_lcssa_i;
 var $46=$__atoms;
 var $47=((($45)-($46))|0);
 var $48=($47|0)>23;
 if($48){var $_0=-1;label=23;break;}else{label=15;break;}
 case 15: 
 if(($__base|0)==8|($__base|0)==10){ label=16;break;}else if(($__base|0)==16){ label=17;break;}else{label=22;break;}
 case 16: 
 var $51=($47|0)<($__base|0);
 if($51){label=22;break;}else{var $_0=-1;label=23;break;}
 case 17: 
 var $53=($47|0)<22;
 if($53){label=22;break;}else{label=18;break;}
 case 18: 
 if($2){var $_0=-1;label=23;break;}else{label=19;break;}
 case 19: 
 var $56=$1;
 var $57=$__a;
 var $58=((($56)-($57))|0);
 var $59=($58|0)<3;
 if($59){label=20;break;}else{var $_0=-1;label=23;break;}
 case 20: 
 var $61=((($1)-(1))|0);
 var $62=HEAP8[($61)];
 var $63=(($62<<24)>>24)==48;
 if($63){label=21;break;}else{var $_0=-1;label=23;break;}
 case 21: 
 HEAP32[(($__dc)>>2)]=0;
 var $65=((10592+$47)|0);
 var $66=HEAP8[($65)];
 var $67=(($1+1)|0);
 HEAP32[(($__a_end)>>2)]=$67;
 HEAP8[($1)]=$66;
 var $_0=0;label=23;break;
 case 22: 
 var $69=((10592+$47)|0);
 var $70=HEAP8[($69)];
 var $71=(($1+1)|0);
 HEAP32[(($__a_end)>>2)]=$71;
 HEAP8[($1)]=$70;
 var $72=HEAP32[(($__dc)>>2)];
 var $73=((($72)+(1))|0);
 HEAP32[(($__dc)>>2)]=$73;
 var $_0=0;label=23;break;
 case 23: 
 var $_0;
 return $_0;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__110__sscanf_lEPKcP15__locale_structS1_z($__s,$__l,$__format,varrp){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+16)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $__va=sp;
 var $1=(($__va)|0);
 var $2=$__va;
 HEAP32[(($2)>>2)]=varrp;HEAP32[((($2)+(4))>>2)]=0;
 var $3=_uselocale($__l);
 var $4=_vsscanf($__s,$__format,$1);

 var $5=($3|0)==0;
 if($5){label=4;break;}else{label=2;break;}
 case 2: 
 var $7=(function() { try { __THREW__ = 0; return _uselocale($3) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=4;break; } else { label=3;break; }
 case 3: 
 var $9$0 = ___cxa_find_matching_catch(-1, -1,0); var $9$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
 case 4: 
 STACKTOP=sp;return $4;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEED0Ev($this){
 var label=0;


 var $1=(($this)|0);
 __ZNSt3__114__shared_countD2Ev($1);
 var $2=$this;
 __ZdlPv($2);
 return;
}


function __ZNSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEED1Ev($this){
 var label=0;


 var $1=(($this)|0);
 __ZNSt3__114__shared_countD2Ev($1);
 return;
}


function __ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRb($agg_result,$this,$__b,$__e,$__iob,$__err,$__v){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+112)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var tempParam = $__b; $__b=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__b)>>2)]=HEAP32[((tempParam)>>2)];
 var tempParam = $__e; $__e=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $__p_i_i_i_i19=sp;
 var $__p_i_i_i_i=(sp)+(16);
 var $__lv=(sp)+(32);
 var $1=(sp)+(40);
 var $2=(sp)+(48);
 var $3=(sp)+(56);
 var $4=(sp)+(64);
 var $5=(sp)+(72);
 var $__names=(sp)+(80);
 var $6=(sp)+(104);
 var $7=(($__iob+4)|0);
 var $8=HEAP32[(($7)>>2)];
 var $9=$8&1;
 var $10=($9|0)==0;
 if($10){label=2;break;}else{label=7;break;}
 case 2: 
 HEAP32[(($__lv)>>2)]=-1;
 var $12=$this;
 var $13=HEAP32[(($12)>>2)];
 var $14=(($13+16)|0);
 var $15=HEAP32[(($14)>>2)];
 var $16=(($__b)|0);
 var $17=HEAP32[(($16)>>2)];
 var $18=(($2)|0);
 HEAP32[(($18)>>2)]=$17;
 var $19=(($__e)|0);
 var $20=HEAP32[(($19)>>2)];
 var $21=(($3)|0);
 HEAP32[(($21)>>2)]=$20;
 FUNCTION_TABLE[$15]($1,$this,$2,$3,$__iob,$__err,$__lv);
 var $22=(($1)|0);
 var $23=HEAP32[(($22)>>2)];
 HEAP32[(($16)>>2)]=$23;
 var $24=HEAP32[(($__lv)>>2)];
 if(($24|0)==0){ label=3;break;}else if(($24|0)==1){ label=4;break;}else{label=5;break;}
 case 3: 
 HEAP8[($__v)]=0;
 label=6;break;
 case 4: 
 HEAP8[($__v)]=1;
 label=6;break;
 case 5: 
 HEAP8[($__v)]=1;
 HEAP32[(($__err)>>2)]=4;
 label=6;break;
 case 6: 
 var $29=(($agg_result)|0);
 HEAP32[(($29)>>2)]=$23;
 label=28;break;
 case 7: 
 __ZNKSt3__18ios_base6getlocEv($4,$__iob);
 var $31=(($4)|0);
 var $32=HEAP32[(($31)>>2)];
 var $33=$__p_i_i_i_i;
 var $34=HEAP32[((14088)>>2)];
 var $35=($34|0)==-1;
 if($35){label=9;break;}else{label=8;break;}
 case 8: 
 var $_sroa_01_0___p67_i_idx_i_i_i=(($__p_i_i_i_i)|0);
 HEAP32[(($_sroa_01_0___p67_i_idx_i_i_i)>>2)]=14088;
 var $_sroa_12_4___p67_i_idx3_i_i_i=(($__p_i_i_i_i+4)|0);
 HEAP32[(($_sroa_12_4___p67_i_idx3_i_i_i)>>2)]=(28);
 var $_sroa_2_8___p67_i_idx4_i_i_i=(($__p_i_i_i_i+8)|0);
 HEAP32[(($_sroa_2_8___p67_i_idx4_i_i_i)>>2)]=0;
 (function() { try { __THREW__ = 0; return __ZNSt3__111__call_onceERVmPvPFvS2_E(14088,$33,260) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=9;break; } else { label=23;break; }
 case 9: 
 var $37=HEAP32[((14092)>>2)];
 var $38=((($37)-(1))|0);
 var $39=(($32+12)|0);
 var $40=HEAP32[(($39)>>2)];
 var $41=(($32+8)|0);
 var $42=HEAP32[(($41)>>2)];
 var $43=$40;
 var $44=$42;
 var $45=((($43)-($44))|0);
 var $46=$45>>2;
 var $47=($46>>>0)>($38>>>0);
 if($47){label=10;break;}else{label=11;break;}
 case 10: 
 var $48=(($42+($38<<2))|0);
 var $49=HEAP32[(($48)>>2)];
 var $50=($49|0)==0;
 if($50){label=11;break;}else{label=13;break;}
 case 11: 
 var $51=___cxa_allocate_exception(4);
 var $52=$51;
 __ZNSt8bad_castC2Ev($52);
 (function() { try { __THREW__ = 0; return ___cxa_throw($51,8960,(368)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=12;break; } else { label=23;break; }
 case 12: 
 throw "Reached an unreachable!";
 case 13: 
 var $54=$49;
 var $55=HEAP32[(($31)>>2)];
 var $56=(($55)|0);
 var $57=__ZNSt3__114__shared_count16__release_sharedEv($56);
 __ZNKSt3__18ios_base6getlocEv($5,$__iob);
 var $58=(($5)|0);
 var $59=HEAP32[(($58)>>2)];
 var $60=$__p_i_i_i_i19;
 var $61=HEAP32[((13704)>>2)];
 var $62=($61|0)==-1;
 if($62){label=15;break;}else{label=14;break;}
 case 14: 
 var $_sroa_01_0___p67_i_idx_i_i_i20=(($__p_i_i_i_i19)|0);
 HEAP32[(($_sroa_01_0___p67_i_idx_i_i_i20)>>2)]=13704;
 var $_sroa_12_4___p67_i_idx3_i_i_i21=(($__p_i_i_i_i19+4)|0);
 HEAP32[(($_sroa_12_4___p67_i_idx3_i_i_i21)>>2)]=(28);
 var $_sroa_2_8___p67_i_idx4_i_i_i22=(($__p_i_i_i_i19+8)|0);
 HEAP32[(($_sroa_2_8___p67_i_idx4_i_i_i22)>>2)]=0;
 (function() { try { __THREW__ = 0; return __ZNSt3__111__call_onceERVmPvPFvS2_E(13704,$60,260) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=15;break; } else { label=24;break; }
 case 15: 
 var $64=HEAP32[((13708)>>2)];
 var $65=((($64)-(1))|0);
 var $66=(($59+12)|0);
 var $67=HEAP32[(($66)>>2)];
 var $68=(($59+8)|0);
 var $69=HEAP32[(($68)>>2)];
 var $70=$67;
 var $71=$69;
 var $72=((($70)-($71))|0);
 var $73=$72>>2;
 var $74=($73>>>0)>($65>>>0);
 if($74){label=16;break;}else{label=17;break;}
 case 16: 
 var $75=(($69+($65<<2))|0);
 var $76=HEAP32[(($75)>>2)];
 var $77=($76|0)==0;
 if($77){label=17;break;}else{label=19;break;}
 case 17: 
 var $78=___cxa_allocate_exception(4);
 var $79=$78;
 __ZNSt8bad_castC2Ev($79);
 (function() { try { __THREW__ = 0; return ___cxa_throw($78,8960,(368)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=18;break; } else { label=24;break; }
 case 18: 
 throw "Reached an unreachable!";
 case 19: 
 var $81=$76;
 var $82=HEAP32[(($58)>>2)];
 var $83=(($82)|0);
 var $84=__ZNSt3__114__shared_count16__release_sharedEv($83);
 var $85=(($__names)|0);
 var $86=$76;
 var $87=HEAP32[(($86)>>2)];
 var $88=(($87+24)|0);
 var $89=HEAP32[(($88)>>2)];
 (function() { try { __THREW__ = 0; return FUNCTION_TABLE[$89]($85,$81) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=20;break; } else { var $_017=$85;label=25;break; }
 case 20: 
 var $90=(($__names+12)|0);
 var $91=HEAP32[(($86)>>2)];
 var $92=(($91+28)|0);
 var $93=HEAP32[(($92)>>2)];
 (function() { try { __THREW__ = 0; return FUNCTION_TABLE[$93]($90,$81) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=21;break; } else { var $_017=$90;label=25;break; }
 case 21: 
 var $94=(($__e)|0);
 var $95=HEAP32[(($94)>>2)];
 var $96=(($6)|0);
 HEAP32[(($96)>>2)]=$95;
 var $97=(($__names+24)|0);
 var $98=(function() { try { __THREW__ = 0; return __ZNSt3__114__scan_keywordINS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEPKNS_12basic_stringIwS3_NS_9allocatorIwEEEENS_5ctypeIwEEEET0_RT_SE_SD_SD_RKT1_Rjb($__b,$6,$85,$97,$54,$__err,1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=22;break; } else { label=27;break; }
 case 22: 
 var $99=($98|0)==($85|0);
 var $100=($99&1);
 HEAP8[($__v)]=$100;
 var $101=(($__b)|0);
 var $102=HEAP32[(($101)>>2)];
 var $103=(($agg_result)|0);
 HEAP32[(($103)>>2)]=$102;
 var $104=(($__names+12)|0);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev($104);
 var $105=(($__names)|0);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev($105);
 label=28;break;
 case 23: 
 var $107$0 = ___cxa_find_matching_catch(-1, -1); var $107$1 = tempRet0;
 var $108=$107$0;
 var $109=$107$1;
 var $110=HEAP32[(($31)>>2)];
 var $111=(($110)|0);
 var $112=__ZNSt3__114__shared_count16__release_sharedEv($111);
 var $_0=$108;var $_016=$109;label=29;break;
 case 24: 
 var $114$0 = ___cxa_find_matching_catch(-1, -1); var $114$1 = tempRet0;
 var $115=$114$0;
 var $116=$114$1;
 var $117=HEAP32[(($58)>>2)];
 var $118=(($117)|0);
 var $119=__ZNSt3__114__shared_count16__release_sharedEv($118);
 var $_0=$115;var $_016=$116;label=29;break;
 case 25: 
 var $_017;
 var $121$0 = ___cxa_find_matching_catch(-1, -1); var $121$1 = tempRet0;
 var $122=$121$0;
 var $123=$121$1;
 var $124=($85|0)==($_017|0);
 if($124){var $_0=$122;var $_016=$123;label=29;break;}else{var $125=$_017;label=26;break;}
 case 26: 
 var $125;
 var $126=((($125)-(12))|0);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev($126);
 var $127=($126|0)==($85|0);
 if($127){var $_0=$122;var $_016=$123;label=29;break;}else{var $125=$126;label=26;break;}
 case 27: 
 var $128$0 = ___cxa_find_matching_catch(-1, -1); var $128$1 = tempRet0;
 var $129=$128$0;
 var $130=(($__names+12)|0);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev($130);
 var $131=(($__names)|0);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev($131);
 var $132=$128$1;
 var $_0=$129;var $_016=$132;label=29;break;
 case 28: 
 STACKTOP=sp;return;
 case 29: 
 var $_016;
 var $_0;
 var $134$0=$_0;
 var $134$1=0;
 var $135$0=$134$0;
 var $135$1=$_016;
 ___resumeException($135$0)
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__114__scan_keywordINS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEPKNS_12basic_stringIwS3_NS_9allocatorIwEEEENS_5ctypeIwEEEET0_RT_SE_SD_SD_RKT1_Rjb($__b,$__e,$__kb,$__ke,$__ct,$__err,$__case_sensitive){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+104)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var tempParam = $__e; $__e=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $__statbuf=sp;
 var $1=$__ke;
 var $2=$__kb;
 var $3=((($1)-($2))|0);
 var $4=(((($3|0))/(12))&-1);
 var $5=(($__statbuf)|0);
 var $6=($4>>>0)>100;
 if($6){label=2;break;}else{var $__status_0=$5;var $__stat_hold_sroa_0_0_load8689=0;label=11;break;}
 case 2: 
 var $8=_malloc($4);
 var $9=($8|0)==0;
 if($9){label=3;break;}else{var $__status_0=$8;var $__stat_hold_sroa_0_0_load8689=$8;label=11;break;}
 case 3: 
 (function() { try { __THREW__ = 0; return __ZSt17__throw_bad_allocv() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $__status_0=0;var $__stat_hold_sroa_0_0_load8689=0;label=11;break; } else { label=4;break; }
 case 4: 
 var $11$0 = ___cxa_find_matching_catch(-1, -1); var $11$1 = tempRet0;
 var $14$1=$11$1;var $14$0=$11$0;label=10;break;
 case 5: 
 var $lpad_us_lcssa$0 = ___cxa_find_matching_catch(-1, -1); var $lpad_us_lcssa$1 = tempRet0;
 var $lpad_phi$1=$lpad_us_lcssa$1;var $lpad_phi$0=$lpad_us_lcssa$0;label=8;break;
 case 6: 
 var $lpad_loopexit$0 = ___cxa_find_matching_catch(-1, -1); var $lpad_loopexit$1 = tempRet0;
 var $lpad_phi$1=$lpad_loopexit$1;var $lpad_phi$0=$lpad_loopexit$0;label=8;break;
 case 7: 
 var $lpad_nonloopexit122$0 = ___cxa_find_matching_catch(-1, -1); var $lpad_nonloopexit122$1 = tempRet0;
 var $lpad_phi$1=$lpad_nonloopexit122$1;var $lpad_phi$0=$lpad_nonloopexit122$0;label=8;break;
 case 8: 
 var $lpad_phi$0;
 var $lpad_phi$1;
 var $12=($__stat_hold_sroa_0_0_load8689|0)==0;
 if($12){var $14$1=$lpad_phi$1;var $14$0=$lpad_phi$0;label=10;break;}else{label=9;break;}
 case 9: 
 _free($__stat_hold_sroa_0_0_load8689);
 var $14$1=$lpad_phi$1;var $14$0=$lpad_phi$0;label=10;break;
 case 10: 
 var $14$0;
 var $14$1;
 ___resumeException($14$0)
 case 11: 
 var $__stat_hold_sroa_0_0_load8689;
 var $__status_0;
 var $15=($__kb|0)==($__ke|0);
 if($15){var $__n_might_match_0_lcssa=$4;var $__n_does_match_0_lcssa=0;label=12;break;}else{var $__n_might_match_0132=$4;var $__n_does_match_0133=0;var $__st_0134=$__status_0;var $__ky_0135=$__kb;label=13;break;}
 case 12: 
 var $__n_does_match_0_lcssa;
 var $__n_might_match_0_lcssa;
 var $16=(($__b)|0);
 var $17=(($__e)|0);
 var $18=$__ct;
 var $__indx_0=0;var $__n_does_match_2=$__n_does_match_0_lcssa;var $__n_might_match_2=$__n_might_match_0_lcssa;label=20;break;
 case 13: 
 var $__ky_0135;
 var $__st_0134;
 var $__n_does_match_0133;
 var $__n_might_match_0132;
 var $19=$__ky_0135;
 var $20=HEAP8[($19)];
 var $21=$20&1;
 var $22=(($21<<24)>>24)==0;
 if($22){label=15;break;}else{label=14;break;}
 case 14: 
 var $24=(($__ky_0135+4)|0);
 var $25=HEAP32[(($24)>>2)];
 var $29=$25;label=16;break;
 case 15: 
 var $27=($20&255);
 var $28=$27>>>1;
 var $29=$28;label=16;break;
 case 16: 
 var $29;
 var $30=($29|0)==0;
 if($30){label=18;break;}else{label=17;break;}
 case 17: 
 HEAP8[($__st_0134)]=1;
 var $__n_does_match_1=$__n_does_match_0133;var $__n_might_match_1=$__n_might_match_0132;label=19;break;
 case 18: 
 HEAP8[($__st_0134)]=2;
 var $33=((($__n_might_match_0132)-(1))|0);
 var $34=((($__n_does_match_0133)+(1))|0);
 var $__n_does_match_1=$34;var $__n_might_match_1=$33;label=19;break;
 case 19: 
 var $__n_might_match_1;
 var $__n_does_match_1;
 var $36=(($__ky_0135+12)|0);
 var $37=(($__st_0134+1)|0);
 var $38=($36|0)==($__ke|0);
 if($38){var $__n_might_match_0_lcssa=$__n_might_match_1;var $__n_does_match_0_lcssa=$__n_does_match_1;label=12;break;}else{var $__n_might_match_0132=$__n_might_match_1;var $__n_does_match_0133=$__n_does_match_1;var $__st_0134=$37;var $__ky_0135=$36;label=13;break;}
 case 20: 
 var $__n_might_match_2;
 var $__n_does_match_2;
 var $__indx_0;
 var $39=HEAP32[(($16)>>2)];
 var $40=($39|0)==0;
 if($40){var $57=1;label=27;break;}else{label=21;break;}
 case 21: 
 var $42=(($39+12)|0);
 var $43=HEAP32[(($42)>>2)];
 var $44=(($39+16)|0);
 var $45=HEAP32[(($44)>>2)];
 var $46=($43|0)==($45|0);
 if($46){label=22;break;}else{label=23;break;}
 case 22: 
 var $48=$39;
 var $49=HEAP32[(($48)>>2)];
 var $50=(($49+36)|0);
 var $51=HEAP32[(($50)>>2)];
 var $52=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$51]($39) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $_0_i_i_i_i=$52;label=24;break; } else { label=6;break; }
 case 23: 
 var $54=HEAP32[(($43)>>2)];
 var $_0_i_i_i_i=$54;label=24;break;
 case 24: 
 var $_0_i_i_i_i;
 var $55=($_0_i_i_i_i|0)==-1;
 if($55){label=26;break;}else{label=25;break;}
 case 25: 
 var $_pre_i_i_i=HEAP32[(($16)>>2)];
 var $phitmp_i_i_i=($_pre_i_i_i|0)==0;
 var $57=$phitmp_i_i_i;label=27;break;
 case 26: 
 HEAP32[(($16)>>2)]=0;
 var $57=1;label=27;break;
 case 27: 
 var $57;
 var $58=HEAP32[(($17)>>2)];
 var $59=($58|0)==0;
 if($59){var $76=1;var $_pre_i4_i_i79=0;label=33;break;}else{label=28;break;}
 case 28: 
 var $61=(($58+12)|0);
 var $62=HEAP32[(($61)>>2)];
 var $63=(($58+16)|0);
 var $64=HEAP32[(($63)>>2)];
 var $65=($62|0)==($64|0);
 if($65){label=29;break;}else{label=30;break;}
 case 29: 
 var $67=$58;
 var $68=HEAP32[(($67)>>2)];
 var $69=(($68+36)|0);
 var $70=HEAP32[(($69)>>2)];
 var $71=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$70]($58) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $_0_i_i2_i_i=$71;label=31;break; } else { label=6;break; }
 case 30: 
 var $73=HEAP32[(($62)>>2)];
 var $_0_i_i2_i_i=$73;label=31;break;
 case 31: 
 var $_0_i_i2_i_i;
 var $74=($_0_i_i2_i_i|0)==-1;
 if($74){label=32;break;}else{var $76=0;var $_pre_i4_i_i79=$58;label=33;break;}
 case 32: 
 HEAP32[(($17)>>2)]=0;
 var $76=1;var $_pre_i4_i_i79=0;label=33;break;
 case 33: 
 var $_pre_i4_i_i79;
 var $76;
 var $tmp_i_i=$57^$76;
 var $77=($__n_might_match_2|0)!=0;
 var $_=$tmp_i_i&$77;
 var $78=HEAP32[(($16)>>2)];
 if($_){label=34;break;}else{label=80;break;}
 case 34: 
 var $80=(($78+12)|0);
 var $81=HEAP32[(($80)>>2)];
 var $82=(($78+16)|0);
 var $83=HEAP32[(($82)>>2)];
 var $84=($81|0)==($83|0);
 if($84){label=35;break;}else{label=36;break;}
 case 35: 
 var $86=$78;
 var $87=HEAP32[(($86)>>2)];
 var $88=(($87+36)|0);
 var $89=HEAP32[(($88)>>2)];
 var $90=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$89]($78) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $_0_i_i=$90;label=37;break; } else { label=6;break; }
 case 36: 
 var $92=HEAP32[(($81)>>2)];
 var $_0_i_i=$92;label=37;break;
 case 37: 
 var $_0_i_i;
 if($__case_sensitive){var $__c_0=$_0_i_i;label=39;break;}else{label=38;break;}
 case 38: 
 var $94=HEAP32[(($18)>>2)];
 var $95=(($94+28)|0);
 var $96=HEAP32[(($95)>>2)];
 var $97=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$96]($__ct,$_0_i_i) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $__c_0=$97;label=39;break; } else { label=6;break; }
 case 39: 
 var $__c_0;
 var $_pre=((($__indx_0)+(1))|0);
 if($15){var $__indx_0=$_pre;var $__n_does_match_2=$__n_does_match_2;var $__n_might_match_2=$__n_might_match_2;label=20;break;}else{label=40;break;}
 case 40: 
 if($__case_sensitive){var $__n_might_match_3102_us=$__n_might_match_2;var $__n_does_match_3103_us=$__n_does_match_2;var $__st_1104_us=$__status_0;var $__consume_0_off0106_us=0;var $__ky1_0107_us=$__kb;label=41;break;}else{var $__n_might_match_3102=$__n_might_match_2;var $__n_does_match_3103=$__n_does_match_2;var $__st_1104=$__status_0;var $__consume_0_off0106=0;var $__ky1_0107=$__kb;label=54;break;}
 case 41: 
 var $__ky1_0107_us;
 var $__consume_0_off0106_us;
 var $__st_1104_us;
 var $__n_does_match_3103_us;
 var $__n_might_match_3102_us;
 var $98=HEAP8[($__st_1104_us)];
 var $99=(($98<<24)>>24)==1;
 if($99){label=42;break;}else{var $__consume_1_off0_us=$__consume_0_off0106_us;var $__n_does_match_4_us=$__n_does_match_3103_us;var $__n_might_match_4_us=$__n_might_match_3102_us;label=52;break;}
 case 42: 
 var $101=$__ky1_0107_us;
 var $102=HEAP8[($101)];
 var $103=$102&1;
 var $104=(($103<<24)>>24)==0;
 if($104){label=44;break;}else{label=43;break;}
 case 43: 
 var $106=(($__ky1_0107_us+8)|0);
 var $107=HEAP32[(($106)>>2)];
 var $110=$107;label=45;break;
 case 44: 
 var $109=(($__ky1_0107_us+4)|0);
 var $110=$109;label=45;break;
 case 45: 
 var $110;
 var $111=(($110+($__indx_0<<2))|0);
 var $112=HEAP32[(($111)>>2)];
 var $113=($__c_0|0)==($112|0);
 if($113){label=47;break;}else{label=46;break;}
 case 46: 
 HEAP8[($__st_1104_us)]=0;
 var $115=((($__n_might_match_3102_us)-(1))|0);
 var $__consume_1_off0_us=$__consume_0_off0106_us;var $__n_does_match_4_us=$__n_does_match_3103_us;var $__n_might_match_4_us=$115;label=52;break;
 case 47: 
 if($104){label=49;break;}else{label=48;break;}
 case 48: 
 var $118=(($__ky1_0107_us+4)|0);
 var $119=HEAP32[(($118)>>2)];
 var $123=$119;label=50;break;
 case 49: 
 var $121=($102&255);
 var $122=$121>>>1;
 var $123=$122;label=50;break;
 case 50: 
 var $123;
 var $124=($123|0)==($_pre|0);
 if($124){label=51;break;}else{var $__consume_1_off0_us=1;var $__n_does_match_4_us=$__n_does_match_3103_us;var $__n_might_match_4_us=$__n_might_match_3102_us;label=52;break;}
 case 51: 
 HEAP8[($__st_1104_us)]=2;
 var $126=((($__n_might_match_3102_us)-(1))|0);
 var $127=((($__n_does_match_3103_us)+(1))|0);
 var $__consume_1_off0_us=1;var $__n_does_match_4_us=$127;var $__n_might_match_4_us=$126;label=52;break;
 case 52: 
 var $__n_might_match_4_us;
 var $__n_does_match_4_us;
 var $__consume_1_off0_us;
 var $129=(($__ky1_0107_us+12)|0);
 var $130=($129|0)==($__ke|0);
 if($130){var $__n_might_match_3_lcssa=$__n_might_match_4_us;var $__n_does_match_3_lcssa=$__n_does_match_4_us;var $__consume_0_off0_lcssa=$__consume_1_off0_us;label=68;break;}else{label=53;break;}
 case 53: 
 var $131=(($__st_1104_us+1)|0);
 var $__n_might_match_3102_us=$__n_might_match_4_us;var $__n_does_match_3103_us=$__n_does_match_4_us;var $__st_1104_us=$131;var $__consume_0_off0106_us=$__consume_1_off0_us;var $__ky1_0107_us=$129;label=41;break;
 case 54: 
 var $__ky1_0107;
 var $__consume_0_off0106;
 var $__st_1104;
 var $__n_does_match_3103;
 var $__n_might_match_3102;
 var $132=HEAP8[($__st_1104)];
 var $133=(($132<<24)>>24)==1;
 if($133){label=55;break;}else{var $__consume_1_off0=$__consume_0_off0106;var $__n_does_match_4=$__n_does_match_3103;var $__n_might_match_4=$__n_might_match_3102;label=66;break;}
 case 55: 
 var $135=$__ky1_0107;
 var $136=HEAP8[($135)];
 var $137=$136&1;
 var $138=(($137<<24)>>24)==0;
 if($138){label=57;break;}else{label=56;break;}
 case 56: 
 var $140=(($__ky1_0107+8)|0);
 var $141=HEAP32[(($140)>>2)];
 var $145=$141;label=58;break;
 case 57: 
 var $143=(($__ky1_0107+4)|0);
 var $145=$143;label=58;break;
 case 58: 
 var $145;
 var $146=(($145+($__indx_0<<2))|0);
 var $147=HEAP32[(($146)>>2)];
 var $148=HEAP32[(($18)>>2)];
 var $149=(($148+28)|0);
 var $150=HEAP32[(($149)>>2)];
 var $151=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$150]($__ct,$147) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=59;break; } else { label=5;break; }
 case 59: 
 var $152=($__c_0|0)==($151|0);
 if($152){label=60;break;}else{label=65;break;}
 case 60: 
 var $154=HEAP8[($135)];
 var $155=$154&1;
 var $156=(($155<<24)>>24)==0;
 if($156){label=62;break;}else{label=61;break;}
 case 61: 
 var $158=(($__ky1_0107+4)|0);
 var $159=HEAP32[(($158)>>2)];
 var $163=$159;label=63;break;
 case 62: 
 var $161=($154&255);
 var $162=$161>>>1;
 var $163=$162;label=63;break;
 case 63: 
 var $163;
 var $164=($163|0)==($_pre|0);
 if($164){label=64;break;}else{var $__consume_1_off0=1;var $__n_does_match_4=$__n_does_match_3103;var $__n_might_match_4=$__n_might_match_3102;label=66;break;}
 case 64: 
 HEAP8[($__st_1104)]=2;
 var $166=((($__n_might_match_3102)-(1))|0);
 var $167=((($__n_does_match_3103)+(1))|0);
 var $__consume_1_off0=1;var $__n_does_match_4=$167;var $__n_might_match_4=$166;label=66;break;
 case 65: 
 HEAP8[($__st_1104)]=0;
 var $169=((($__n_might_match_3102)-(1))|0);
 var $__consume_1_off0=$__consume_0_off0106;var $__n_does_match_4=$__n_does_match_3103;var $__n_might_match_4=$169;label=66;break;
 case 66: 
 var $__n_might_match_4;
 var $__n_does_match_4;
 var $__consume_1_off0;
 var $171=(($__ky1_0107+12)|0);
 var $172=($171|0)==($__ke|0);
 if($172){var $__n_might_match_3_lcssa=$__n_might_match_4;var $__n_does_match_3_lcssa=$__n_does_match_4;var $__consume_0_off0_lcssa=$__consume_1_off0;label=68;break;}else{label=67;break;}
 case 67: 
 var $173=(($__st_1104+1)|0);
 var $__n_might_match_3102=$__n_might_match_4;var $__n_does_match_3103=$__n_does_match_4;var $__st_1104=$173;var $__consume_0_off0106=$__consume_1_off0;var $__ky1_0107=$171;label=54;break;
 case 68: 
 var $__consume_0_off0_lcssa;
 var $__n_does_match_3_lcssa;
 var $__n_might_match_3_lcssa;
 if($__consume_0_off0_lcssa){label=69;break;}else{var $__indx_0=$_pre;var $__n_does_match_2=$__n_does_match_3_lcssa;var $__n_might_match_2=$__n_might_match_3_lcssa;label=20;break;}
 case 69: 
 var $175=HEAP32[(($16)>>2)];
 var $176=(($175+12)|0);
 var $177=HEAP32[(($176)>>2)];
 var $178=(($175+16)|0);
 var $179=HEAP32[(($178)>>2)];
 var $180=($177|0)==($179|0);
 if($180){label=70;break;}else{label=71;break;}
 case 70: 
 var $182=$175;
 var $183=HEAP32[(($182)>>2)];
 var $184=(($183+40)|0);
 var $185=HEAP32[(($184)>>2)];
 var $186=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$185]($175) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=72;break; } else { label=6;break; }
 case 71: 
 var $188=(($177+4)|0);
 HEAP32[(($176)>>2)]=$188;
 label=72;break;
 case 72: 
 var $189=((($__n_might_match_3_lcssa)+($__n_does_match_3_lcssa))|0);
 var $_not=($189>>>0)<2;
 if($_not){var $__indx_0=$_pre;var $__n_does_match_2=$__n_does_match_3_lcssa;var $__n_might_match_2=$__n_might_match_3_lcssa;label=20;break;}else{var $__n_does_match_5116=$__n_does_match_3_lcssa;var $__st_2117=$__status_0;var $__ky2_0118=$__kb;label=73;break;}
 case 73: 
 var $__ky2_0118;
 var $__st_2117;
 var $__n_does_match_5116;
 var $190=HEAP8[($__st_2117)];
 var $191=(($190<<24)>>24)==2;
 if($191){label=74;break;}else{var $__n_does_match_6=$__n_does_match_5116;label=79;break;}
 case 74: 
 var $193=$__ky2_0118;
 var $194=HEAP8[($193)];
 var $195=$194&1;
 var $196=(($195<<24)>>24)==0;
 if($196){label=76;break;}else{label=75;break;}
 case 75: 
 var $198=(($__ky2_0118+4)|0);
 var $199=HEAP32[(($198)>>2)];
 var $203=$199;label=77;break;
 case 76: 
 var $201=($194&255);
 var $202=$201>>>1;
 var $203=$202;label=77;break;
 case 77: 
 var $203;
 var $204=($203|0)==($_pre|0);
 if($204){var $__n_does_match_6=$__n_does_match_5116;label=79;break;}else{label=78;break;}
 case 78: 
 HEAP8[($__st_2117)]=0;
 var $206=((($__n_does_match_5116)-(1))|0);
 var $__n_does_match_6=$206;label=79;break;
 case 79: 
 var $__n_does_match_6;
 var $208=(($__ky2_0118+12)|0);
 var $209=(($__st_2117+1)|0);
 var $210=($208|0)==($__ke|0);
 if($210){var $__indx_0=$_pre;var $__n_does_match_2=$__n_does_match_6;var $__n_might_match_2=$__n_might_match_3_lcssa;label=20;break;}else{var $__n_does_match_5116=$__n_does_match_6;var $__st_2117=$209;var $__ky2_0118=$208;label=73;break;}
 case 80: 
 var $212=($78|0)==0;
 if($212){var $229=1;label=87;break;}else{label=81;break;}
 case 81: 
 var $214=(($78+12)|0);
 var $215=HEAP32[(($214)>>2)];
 var $216=(($78+16)|0);
 var $217=HEAP32[(($216)>>2)];
 var $218=($215|0)==($217|0);
 if($218){label=82;break;}else{label=83;break;}
 case 82: 
 var $220=$78;
 var $221=HEAP32[(($220)>>2)];
 var $222=(($221+36)|0);
 var $223=HEAP32[(($222)>>2)];
 var $224=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$223]($78) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $_0_i_i_i_i71=$224;label=84;break; } else { label=7;break; }
 case 83: 
 var $226=HEAP32[(($215)>>2)];
 var $_0_i_i_i_i71=$226;label=84;break;
 case 84: 
 var $_0_i_i_i_i71;
 var $227=($_0_i_i_i_i71|0)==-1;
 if($227){label=86;break;}else{label=85;break;}
 case 85: 
 var $_pre_i_i_i73=HEAP32[(($16)>>2)];
 var $phitmp_i_i_i74=($_pre_i_i_i73|0)==0;
 var $229=$phitmp_i_i_i74;label=87;break;
 case 86: 
 HEAP32[(($16)>>2)]=0;
 var $229=1;label=87;break;
 case 87: 
 var $229;
 var $230=($_pre_i4_i_i79|0)==0;
 if($230){label=93;break;}else{label=88;break;}
 case 88: 
 var $232=(($_pre_i4_i_i79+12)|0);
 var $233=HEAP32[(($232)>>2)];
 var $234=(($_pre_i4_i_i79+16)|0);
 var $235=HEAP32[(($234)>>2)];
 var $236=($233|0)==($235|0);
 if($236){label=89;break;}else{label=90;break;}
 case 89: 
 var $238=$_pre_i4_i_i79;
 var $239=HEAP32[(($238)>>2)];
 var $240=(($239+36)|0);
 var $241=HEAP32[(($240)>>2)];
 var $242=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$241]($_pre_i4_i_i79) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $_0_i_i2_i_i77=$242;label=91;break; } else { label=7;break; }
 case 90: 
 var $244=HEAP32[(($233)>>2)];
 var $_0_i_i2_i_i77=$244;label=91;break;
 case 91: 
 var $_0_i_i2_i_i77;
 var $245=($_0_i_i2_i_i77|0)==-1;
 if($245){label=92;break;}else{label=94;break;}
 case 92: 
 HEAP32[(($17)>>2)]=0;
 label=93;break;
 case 93: 
 if($229){label=95;break;}else{label=96;break;}
 case 94: 
 if($229){label=96;break;}else{label=95;break;}
 case 95: 
 var $248=HEAP32[(($__err)>>2)];
 var $249=$248|2;
 HEAP32[(($__err)>>2)]=$249;
 label=96;break;
 case 96: 
 if($15){label=100;break;}else{var $__st_396=$__status_0;var $_097=$__kb;label=97;break;}
 case 97: 
 var $_097;
 var $__st_396;
 var $250=HEAP8[($__st_396)];
 var $251=(($250<<24)>>24)==2;
 if($251){var $_095=$_097;label=101;break;}else{label=98;break;}
 case 98: 
 var $253=(($_097+12)|0);
 var $254=($253|0)==($__ke|0);
 if($254){label=100;break;}else{label=99;break;}
 case 99: 
 var $255=(($__st_396+1)|0);
 var $__st_396=$255;var $_097=$253;label=97;break;
 case 100: 
 var $256=HEAP32[(($__err)>>2)];
 var $257=$256|4;
 HEAP32[(($__err)>>2)]=$257;
 var $_095=$__ke;label=101;break;
 case 101: 
 var $_095;
 var $258=($__stat_hold_sroa_0_0_load8689|0)==0;
 if($258){label=103;break;}else{label=102;break;}
 case 102: 
 _free($__stat_hold_sroa_0_0_load8689);
 label=103;break;
 case 103: 
 STACKTOP=sp;return $_095;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRl($agg_result,$this,$__b,$__e,$__iob,$__err,$__v){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+16)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var tempParam = $__b; $__b=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__b)>>2)]=HEAP32[((tempParam)>>2)];
 var tempParam = $__e; $__e=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];

 var $1=sp;
 var $2=(sp)+(8);
 var $3=(($__b)|0);
 var $4=HEAP32[(($3)>>2)];
 var $5=(($1)|0);
 HEAP32[(($5)>>2)]=$4;
 var $6=(($__e)|0);
 var $7=HEAP32[(($6)>>2)];
 var $8=(($2)|0);
 HEAP32[(($8)>>2)]=$7;
 __ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE15__do_get_signedIlEES4_S4_S4_RNS_8ios_baseERjRT_($agg_result,0,$1,$2,$__iob,$__err,$__v);
 STACKTOP=sp;return;
}


function __ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE15__do_get_signedIlEES4_S4_S4_RNS_8ios_baseERjRT_($agg_result,$this,$__b,$__e,$__iob,$__err,$__v){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+328)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var tempParam = $__b; $__b=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__b)>>2)]=HEAP32[((tempParam)>>2)];
 var tempParam = $__e; $__e=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $__atoms=sp;
 var $__thousands_sep=(sp)+(104);
 var $__grouping=(sp)+(112);
 var $__buf=(sp)+(128);
 var $__a_end=(sp)+(144);
 var $__g=(sp)+(152);
 var $__g_end=(sp)+(312);
 var $__dc=(sp)+(320);
 var $1=(($__iob+4)|0);
 var $2=HEAP32[(($1)>>2)];
 var $3=$2&74;
 if(($3|0)==8){ label=2;break;}else if(($3|0)==0){ label=3;break;}else if(($3|0)==64){ var $_0_i=8;label=5;break;}else{label=4;break;}
 case 2: 
 var $_0_i=16;label=5;break;
 case 3: 
 var $_0_i=0;label=5;break;
 case 4: 
 var $_0_i=10;label=5;break;
 case 5: 
 var $_0_i;
 var $7=(($__atoms)|0);
 __ZNSt3__19__num_getIwE17__stage2_int_prepERNS_8ios_baseEPwRw($__grouping,$__iob,$7,$__thousands_sep);
 var $this4_i_i_i=$__buf;
 HEAP32[(($this4_i_i_i)>>2)]=0; HEAP32[((($this4_i_i_i)+(4))>>2)]=0; HEAP32[((($this4_i_i_i)+(8))>>2)]=0;
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc($__buf,10,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=6;break; } else { label=39;break; }
 case 6: 
 var $8=HEAP8[($this4_i_i_i)];
 var $9=$8&1;
 var $10=(($9<<24)>>24)==0;
 if($10){label=8;break;}else{label=7;break;}
 case 7: 
 var $12=(($__buf+8)|0);
 var $13=HEAP32[(($12)>>2)];
 var $_pre45=$__buf;
 var $_pre46=(($_pre45+1)|0);
 var $17=$13;var $_pre_phi47=$_pre46;var $_pre_phi49=$12;label=9;break;
 case 8: 
 var $15=$__buf;
 var $16=(($15+1)|0);
 var $_pre48=(($__buf+8)|0);
 var $17=$16;var $_pre_phi47=$16;var $_pre_phi49=$_pre48;label=9;break;
 case 9: 
 var $_pre_phi49;
 var $_pre_phi47;
 var $17;
 HEAP32[(($__a_end)>>2)]=$17;
 var $18=(($__g)|0);
 HEAP32[(($__g_end)>>2)]=$18;
 HEAP32[(($__dc)>>2)]=0;
 var $19=(($__b)|0);
 var $20=(($__e)|0);
 var $21=(($__buf)|0);
 var $22=(($__buf+4)|0);
 var $23=HEAP32[(($__thousands_sep)>>2)];
 var $_pre=HEAP32[(($19)>>2)];
 var $__a_0=$17;var $_pre_i_i_i18=$_pre;label=10;break;
 case 10: 
 var $_pre_i_i_i18;
 var $__a_0;
 var $24=($_pre_i_i_i18|0)==0;
 if($24){var $42=1;var $41=0;label=16;break;}else{label=11;break;}
 case 11: 
 var $26=(($_pre_i_i_i18+12)|0);
 var $27=HEAP32[(($26)>>2)];
 var $28=(($_pre_i_i_i18+16)|0);
 var $29=HEAP32[(($28)>>2)];
 var $30=($27|0)==($29|0);
 if($30){label=12;break;}else{label=13;break;}
 case 12: 
 var $32=$_pre_i_i_i18;
 var $33=HEAP32[(($32)>>2)];
 var $34=(($33+36)|0);
 var $35=HEAP32[(($34)>>2)];
 var $36=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$35]($_pre_i_i_i18) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $_0_i_i_i_i16=$36;label=14;break; } else { label=38;break; }
 case 13: 
 var $38=HEAP32[(($27)>>2)];
 var $_0_i_i_i_i16=$38;label=14;break;
 case 14: 
 var $_0_i_i_i_i16;
 var $39=($_0_i_i_i_i16|0)==-1;
 if($39){label=15;break;}else{var $42=0;var $41=$_pre_i_i_i18;label=16;break;}
 case 15: 
 HEAP32[(($19)>>2)]=0;
 var $42=1;var $41=0;label=16;break;
 case 16: 
 var $41;
 var $42;
 var $43=HEAP32[(($20)>>2)];
 var $44=($43|0)==0;
 if($44){label=22;break;}else{label=17;break;}
 case 17: 
 var $46=(($43+12)|0);
 var $47=HEAP32[(($46)>>2)];
 var $48=(($43+16)|0);
 var $49=HEAP32[(($48)>>2)];
 var $50=($47|0)==($49|0);
 if($50){label=18;break;}else{label=19;break;}
 case 18: 
 var $52=$43;
 var $53=HEAP32[(($52)>>2)];
 var $54=(($53+36)|0);
 var $55=HEAP32[(($54)>>2)];
 var $56=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$55]($43) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $_0_i_i2_i_i22=$56;label=20;break; } else { label=38;break; }
 case 19: 
 var $58=HEAP32[(($47)>>2)];
 var $_0_i_i2_i_i22=$58;label=20;break;
 case 20: 
 var $_0_i_i2_i_i22;
 var $59=($_0_i_i2_i_i22|0)==-1;
 if($59){label=21;break;}else{label=23;break;}
 case 21: 
 HEAP32[(($20)>>2)]=0;
 label=22;break;
 case 22: 
 if($42){var $__a_2=$__a_0;var $_pre_i4_i_i=0;label=48;break;}else{var $62=0;label=24;break;}
 case 23: 
 if($42){var $62=$43;label=24;break;}else{var $__a_2=$__a_0;var $_pre_i4_i_i=$43;label=48;break;}
 case 24: 
 var $62;
 var $63=HEAP32[(($__a_end)>>2)];
 var $64=$63;
 var $65=$__a_0;
 var $66=((($64)-($65))|0);
 var $67=HEAP8[($this4_i_i_i)];
 var $68=$67&1;
 var $69=(($68<<24)>>24)==0;
 if($69){label=26;break;}else{label=25;break;}
 case 25: 
 var $71=HEAP32[(($22)>>2)];
 var $75=$71;label=27;break;
 case 26: 
 var $73=($67&255);
 var $74=$73>>>1;
 var $75=$74;label=27;break;
 case 27: 
 var $75;
 var $76=($66|0)==($75|0);
 if($76){label=28;break;}else{var $__a_1=$__a_0;label=41;break;}
 case 28: 
 if($69){label=30;break;}else{label=29;break;}
 case 29: 
 var $79=HEAP32[(($22)>>2)];
 var $86=$79;var $85=$79;label=31;break;
 case 30: 
 var $81=($67&255);
 var $82=$81>>>1;
 var $83=($67&255);
 var $84=$83>>>1;
 var $86=$84;var $85=$82;label=31;break;
 case 31: 
 var $85;
 var $86;
 var $87=$86<<1;
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc($__buf,$87,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=32;break; } else { label=38;break; }
 case 32: 
 var $88=HEAP8[($this4_i_i_i)];
 var $89=$88&1;
 var $90=(($89<<24)>>24)==0;
 if($90){var $94=10;label=34;break;}else{label=33;break;}
 case 33: 
 var $92=HEAP32[(($21)>>2)];
 var $93=$92&-2;
 var $phitmp_i36=((($93)-(1))|0);
 var $94=$phitmp_i36;label=34;break;
 case 34: 
 var $94;
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc($__buf,$94,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=35;break; } else { label=38;break; }
 case 35: 
 var $95=HEAP8[($this4_i_i_i)];
 var $96=$95&1;
 var $97=(($96<<24)>>24)==0;
 if($97){var $100=$_pre_phi47;label=37;break;}else{label=36;break;}
 case 36: 
 var $99=HEAP32[(($_pre_phi49)>>2)];
 var $100=$99;label=37;break;
 case 37: 
 var $100;
 var $101=(($100+$85)|0);
 HEAP32[(($__a_end)>>2)]=$101;
 var $__a_1=$100;label=41;break;
 case 38: 
 var $lpad_loopexit$0 = ___cxa_find_matching_catch(-1, -1); var $lpad_loopexit$1 = tempRet0;
 var $lpad_phi$1=$lpad_loopexit$1;var $lpad_phi$0=$lpad_loopexit$0;label=40;break;
 case 39: 
 var $lpad_nonloopexit$0 = ___cxa_find_matching_catch(-1, -1); var $lpad_nonloopexit$1 = tempRet0;
 var $lpad_phi$1=$lpad_nonloopexit$1;var $lpad_phi$0=$lpad_nonloopexit$0;label=40;break;
 case 40: 
 var $lpad_phi$0;
 var $lpad_phi$1;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__buf);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grouping);
 ___resumeException($lpad_phi$0)
 case 41: 
 var $__a_1;
 var $103=(($41+12)|0);
 var $104=HEAP32[(($103)>>2)];
 var $105=(($41+16)|0);
 var $106=HEAP32[(($105)>>2)];
 var $107=($104|0)==($106|0);
 if($107){label=42;break;}else{label=43;break;}
 case 42: 
 var $109=$41;
 var $110=HEAP32[(($109)>>2)];
 var $111=(($110+36)|0);
 var $112=HEAP32[(($111)>>2)];
 var $113=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$112]($41) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $_0_i_i=$113;label=44;break; } else { label=38;break; }
 case 43: 
 var $115=HEAP32[(($104)>>2)];
 var $_0_i_i=$115;label=44;break;
 case 44: 
 var $_0_i_i;
 var $117=__ZNSt3__19__num_getIwE17__stage2_int_loopEwiPcRS2_RjwRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSD_Pw($_0_i_i,$_0_i,$__a_1,$__a_end,$__dc,$23,$__grouping,$18,$__g_end,$7);
 var $118=($117|0)==0;
 if($118){label=45;break;}else{var $__a_2=$__a_1;var $_pre_i4_i_i=$62;label=48;break;}
 case 45: 
 var $120=HEAP32[(($103)>>2)];
 var $121=HEAP32[(($105)>>2)];
 var $122=($120|0)==($121|0);
 if($122){label=46;break;}else{label=47;break;}
 case 46: 
 var $124=$41;
 var $125=HEAP32[(($124)>>2)];
 var $126=(($125+40)|0);
 var $127=HEAP32[(($126)>>2)];
 var $128=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$127]($41) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $__a_0=$__a_1;var $_pre_i_i_i18=$41;label=10;break; } else { label=38;break; }
 case 47: 
 var $130=(($120+4)|0);
 HEAP32[(($103)>>2)]=$130;
 var $__a_0=$__a_1;var $_pre_i_i_i18=$41;label=10;break;
 case 48: 
 var $_pre_i4_i_i;
 var $__a_2;
 var $132=$__grouping;
 var $133=HEAP8[($132)];
 var $134=$133&1;
 var $135=(($134<<24)>>24)==0;
 if($135){label=50;break;}else{label=49;break;}
 case 49: 
 var $137=(($__grouping+4)|0);
 var $138=HEAP32[(($137)>>2)];
 var $142=$138;label=51;break;
 case 50: 
 var $140=($133&255);
 var $141=$140>>>1;
 var $142=$141;label=51;break;
 case 51: 
 var $142;
 var $143=($142|0)==0;
 if($143){label=54;break;}else{label=52;break;}
 case 52: 
 var $145=HEAP32[(($__g_end)>>2)];
 var $146=$145;
 var $147=$__g;
 var $148=((($146)-($147))|0);
 var $149=($148|0)<160;
 if($149){label=53;break;}else{label=54;break;}
 case 53: 
 var $151=HEAP32[(($__dc)>>2)];
 var $152=(($145+4)|0);
 HEAP32[(($__g_end)>>2)]=$152;
 HEAP32[(($145)>>2)]=$151;
 label=54;break;
 case 54: 
 var $153=HEAP32[(($__a_end)>>2)];
 var $154=(function() { try { __THREW__ = 0; return __ZNSt3__125__num_get_signed_integralIlEET_PKcS3_Rji($__a_2,$153,$__err,$_0_i) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=55;break; } else { label=39;break; }
 case 55: 
 HEAP32[(($__v)>>2)]=$154;
 var $156=HEAP32[(($__g_end)>>2)];
 __ZNSt3__116__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj($__grouping,$18,$156,$__err);
 var $157=($41|0)==0;
 if($157){var $175=1;var $174=0;label=61;break;}else{label=56;break;}
 case 56: 
 var $159=(($41+12)|0);
 var $160=HEAP32[(($159)>>2)];
 var $161=(($41+16)|0);
 var $162=HEAP32[(($161)>>2)];
 var $163=($160|0)==($162|0);
 if($163){label=57;break;}else{label=58;break;}
 case 57: 
 var $165=$41;
 var $166=HEAP32[(($165)>>2)];
 var $167=(($166+36)|0);
 var $168=HEAP32[(($167)>>2)];
 var $169=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$168]($41) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $_0_i_i_i_i=$169;label=59;break; } else { label=39;break; }
 case 58: 
 var $171=HEAP32[(($160)>>2)];
 var $_0_i_i_i_i=$171;label=59;break;
 case 59: 
 var $_0_i_i_i_i;
 var $172=($_0_i_i_i_i|0)==-1;
 if($172){label=60;break;}else{var $175=0;var $174=$41;label=61;break;}
 case 60: 
 HEAP32[(($19)>>2)]=0;
 var $175=1;var $174=0;label=61;break;
 case 61: 
 var $174;
 var $175;
 var $176=($_pre_i4_i_i|0)==0;
 if($176){label=67;break;}else{label=62;break;}
 case 62: 
 var $178=(($_pre_i4_i_i+12)|0);
 var $179=HEAP32[(($178)>>2)];
 var $180=(($_pre_i4_i_i+16)|0);
 var $181=HEAP32[(($180)>>2)];
 var $182=($179|0)==($181|0);
 if($182){label=63;break;}else{label=64;break;}
 case 63: 
 var $184=$_pre_i4_i_i;
 var $185=HEAP32[(($184)>>2)];
 var $186=(($185+36)|0);
 var $187=HEAP32[(($186)>>2)];
 var $188=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$187]($_pre_i4_i_i) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $_0_i_i2_i_i=$188;label=65;break; } else { label=39;break; }
 case 64: 
 var $190=HEAP32[(($179)>>2)];
 var $_0_i_i2_i_i=$190;label=65;break;
 case 65: 
 var $_0_i_i2_i_i;
 var $191=($_0_i_i2_i_i|0)==-1;
 if($191){label=66;break;}else{label=68;break;}
 case 66: 
 HEAP32[(($20)>>2)]=0;
 label=67;break;
 case 67: 
 if($175){label=69;break;}else{label=70;break;}
 case 68: 
 if($175){label=70;break;}else{label=69;break;}
 case 69: 
 var $194=HEAP32[(($__err)>>2)];
 var $195=$194|2;
 HEAP32[(($__err)>>2)]=$195;
 label=70;break;
 case 70: 
 var $197=(($agg_result)|0);
 HEAP32[(($197)>>2)]=$174;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__buf);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grouping);
 STACKTOP=sp;return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRx($agg_result,$this,$__b,$__e,$__iob,$__err,$__v){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+16)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var tempParam = $__b; $__b=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__b)>>2)]=HEAP32[((tempParam)>>2)];
 var tempParam = $__e; $__e=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];

 var $1=sp;
 var $2=(sp)+(8);
 var $3=(($__b)|0);
 var $4=HEAP32[(($3)>>2)];
 var $5=(($1)|0);
 HEAP32[(($5)>>2)]=$4;
 var $6=(($__e)|0);
 var $7=HEAP32[(($6)>>2)];
 var $8=(($2)|0);
 HEAP32[(($8)>>2)]=$7;
 __ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE15__do_get_signedIxEES4_S4_S4_RNS_8ios_baseERjRT_($agg_result,0,$1,$2,$__iob,$__err,$__v);
 STACKTOP=sp;return;
}


function __ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE15__do_get_signedIxEES4_S4_S4_RNS_8ios_baseERjRT_($agg_result,$this,$__b,$__e,$__iob,$__err,$__v){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+328)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var tempParam = $__b; $__b=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__b)>>2)]=HEAP32[((tempParam)>>2)];
 var tempParam = $__e; $__e=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $__atoms=sp;
 var $__thousands_sep=(sp)+(104);
 var $__grouping=(sp)+(112);
 var $__buf=(sp)+(128);
 var $__a_end=(sp)+(144);
 var $__g=(sp)+(152);
 var $__g_end=(sp)+(312);
 var $__dc=(sp)+(320);
 var $1=(($__iob+4)|0);
 var $2=HEAP32[(($1)>>2)];
 var $3=$2&74;
 if(($3|0)==8){ label=2;break;}else if(($3|0)==0){ label=3;break;}else if(($3|0)==64){ var $_0_i=8;label=5;break;}else{label=4;break;}
 case 2: 
 var $_0_i=16;label=5;break;
 case 3: 
 var $_0_i=0;label=5;break;
 case 4: 
 var $_0_i=10;label=5;break;
 case 5: 
 var $_0_i;
 var $7=(($__atoms)|0);
 __ZNSt3__19__num_getIwE17__stage2_int_prepERNS_8ios_baseEPwRw($__grouping,$__iob,$7,$__thousands_sep);
 var $this4_i_i_i=$__buf;
 HEAP32[(($this4_i_i_i)>>2)]=0; HEAP32[((($this4_i_i_i)+(4))>>2)]=0; HEAP32[((($this4_i_i_i)+(8))>>2)]=0;
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc($__buf,10,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=6;break; } else { label=39;break; }
 case 6: 
 var $8=HEAP8[($this4_i_i_i)];
 var $9=$8&1;
 var $10=(($9<<24)>>24)==0;
 if($10){label=8;break;}else{label=7;break;}
 case 7: 
 var $12=(($__buf+8)|0);
 var $13=HEAP32[(($12)>>2)];
 var $_pre45=$__buf;
 var $_pre46=(($_pre45+1)|0);
 var $17=$13;var $_pre_phi47=$_pre46;var $_pre_phi49=$12;label=9;break;
 case 8: 
 var $15=$__buf;
 var $16=(($15+1)|0);
 var $_pre48=(($__buf+8)|0);
 var $17=$16;var $_pre_phi47=$16;var $_pre_phi49=$_pre48;label=9;break;
 case 9: 
 var $_pre_phi49;
 var $_pre_phi47;
 var $17;
 HEAP32[(($__a_end)>>2)]=$17;
 var $18=(($__g)|0);
 HEAP32[(($__g_end)>>2)]=$18;
 HEAP32[(($__dc)>>2)]=0;
 var $19=(($__b)|0);
 var $20=(($__e)|0);
 var $21=(($__buf)|0);
 var $22=(($__buf+4)|0);
 var $23=HEAP32[(($__thousands_sep)>>2)];
 var $_pre=HEAP32[(($19)>>2)];
 var $__a_0=$17;var $_pre_i_i_i18=$_pre;label=10;break;
 case 10: 
 var $_pre_i_i_i18;
 var $__a_0;
 var $24=($_pre_i_i_i18|0)==0;
 if($24){var $42=1;var $41=0;label=16;break;}else{label=11;break;}
 case 11: 
 var $26=(($_pre_i_i_i18+12)|0);
 var $27=HEAP32[(($26)>>2)];
 var $28=(($_pre_i_i_i18+16)|0);
 var $29=HEAP32[(($28)>>2)];
 var $30=($27|0)==($29|0);
 if($30){label=12;break;}else{label=13;break;}
 case 12: 
 var $32=$_pre_i_i_i18;
 var $33=HEAP32[(($32)>>2)];
 var $34=(($33+36)|0);
 var $35=HEAP32[(($34)>>2)];
 var $36=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$35]($_pre_i_i_i18) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $_0_i_i_i_i16=$36;label=14;break; } else { label=38;break; }
 case 13: 
 var $38=HEAP32[(($27)>>2)];
 var $_0_i_i_i_i16=$38;label=14;break;
 case 14: 
 var $_0_i_i_i_i16;
 var $39=($_0_i_i_i_i16|0)==-1;
 if($39){label=15;break;}else{var $42=0;var $41=$_pre_i_i_i18;label=16;break;}
 case 15: 
 HEAP32[(($19)>>2)]=0;
 var $42=1;var $41=0;label=16;break;
 case 16: 
 var $41;
 var $42;
 var $43=HEAP32[(($20)>>2)];
 var $44=($43|0)==0;
 if($44){label=22;break;}else{label=17;break;}
 case 17: 
 var $46=(($43+12)|0);
 var $47=HEAP32[(($46)>>2)];
 var $48=(($43+16)|0);
 var $49=HEAP32[(($48)>>2)];
 var $50=($47|0)==($49|0);
 if($50){label=18;break;}else{label=19;break;}
 case 18: 
 var $52=$43;
 var $53=HEAP32[(($52)>>2)];
 var $54=(($53+36)|0);
 var $55=HEAP32[(($54)>>2)];
 var $56=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$55]($43) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $_0_i_i2_i_i22=$56;label=20;break; } else { label=38;break; }
 case 19: 
 var $58=HEAP32[(($47)>>2)];
 var $_0_i_i2_i_i22=$58;label=20;break;
 case 20: 
 var $_0_i_i2_i_i22;
 var $59=($_0_i_i2_i_i22|0)==-1;
 if($59){label=21;break;}else{label=23;break;}
 case 21: 
 HEAP32[(($20)>>2)]=0;
 label=22;break;
 case 22: 
 if($42){var $__a_2=$__a_0;var $_pre_i4_i_i=0;label=48;break;}else{var $62=0;label=24;break;}
 case 23: 
 if($42){var $62=$43;label=24;break;}else{var $__a_2=$__a_0;var $_pre_i4_i_i=$43;label=48;break;}
 case 24: 
 var $62;
 var $63=HEAP32[(($__a_end)>>2)];
 var $64=$63;
 var $65=$__a_0;
 var $66=((($64)-($65))|0);
 var $67=HEAP8[($this4_i_i_i)];
 var $68=$67&1;
 var $69=(($68<<24)>>24)==0;
 if($69){label=26;break;}else{label=25;break;}
 case 25: 
 var $71=HEAP32[(($22)>>2)];
 var $75=$71;label=27;break;
 case 26: 
 var $73=($67&255);
 var $74=$73>>>1;
 var $75=$74;label=27;break;
 case 27: 
 var $75;
 var $76=($66|0)==($75|0);
 if($76){label=28;break;}else{var $__a_1=$__a_0;label=41;break;}
 case 28: 
 if($69){label=30;break;}else{label=29;break;}
 case 29: 
 var $79=HEAP32[(($22)>>2)];
 var $86=$79;var $85=$79;label=31;break;
 case 30: 
 var $81=($67&255);
 var $82=$81>>>1;
 var $83=($67&255);
 var $84=$83>>>1;
 var $86=$84;var $85=$82;label=31;break;
 case 31: 
 var $85;
 var $86;
 var $87=$86<<1;
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc($__buf,$87,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=32;break; } else { label=38;break; }
 case 32: 
 var $88=HEAP8[($this4_i_i_i)];
 var $89=$88&1;
 var $90=(($89<<24)>>24)==0;
 if($90){var $94=10;label=34;break;}else{label=33;break;}
 case 33: 
 var $92=HEAP32[(($21)>>2)];
 var $93=$92&-2;
 var $phitmp_i36=((($93)-(1))|0);
 var $94=$phitmp_i36;label=34;break;
 case 34: 
 var $94;
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc($__buf,$94,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=35;break; } else { label=38;break; }
 case 35: 
 var $95=HEAP8[($this4_i_i_i)];
 var $96=$95&1;
 var $97=(($96<<24)>>24)==0;
 if($97){var $100=$_pre_phi47;label=37;break;}else{label=36;break;}
 case 36: 
 var $99=HEAP32[(($_pre_phi49)>>2)];
 var $100=$99;label=37;break;
 case 37: 
 var $100;
 var $101=(($100+$85)|0);
 HEAP32[(($__a_end)>>2)]=$101;
 var $__a_1=$100;label=41;break;
 case 38: 
 var $lpad_loopexit$0 = ___cxa_find_matching_catch(-1, -1); var $lpad_loopexit$1 = tempRet0;
 var $lpad_phi$1=$lpad_loopexit$1;var $lpad_phi$0=$lpad_loopexit$0;label=40;break;
 case 39: 
 var $lpad_nonloopexit$0 = ___cxa_find_matching_catch(-1, -1); var $lpad_nonloopexit$1 = tempRet0;
 var $lpad_phi$1=$lpad_nonloopexit$1;var $lpad_phi$0=$lpad_nonloopexit$0;label=40;break;
 case 40: 
 var $lpad_phi$0;
 var $lpad_phi$1;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__buf);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grouping);
 ___resumeException($lpad_phi$0)
 case 41: 
 var $__a_1;
 var $103=(($41+12)|0);
 var $104=HEAP32[(($103)>>2)];
 var $105=(($41+16)|0);
 var $106=HEAP32[(($105)>>2)];
 var $107=($104|0)==($106|0);
 if($107){label=42;break;}else{label=43;break;}
 case 42: 
 var $109=$41;
 var $110=HEAP32[(($109)>>2)];
 var $111=(($110+36)|0);
 var $112=HEAP32[(($111)>>2)];
 var $113=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$112]($41) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $_0_i_i=$113;label=44;break; } else { label=38;break; }
 case 43: 
 var $115=HEAP32[(($104)>>2)];
 var $_0_i_i=$115;label=44;break;
 case 44: 
 var $_0_i_i;
 var $117=__ZNSt3__19__num_getIwE17__stage2_int_loopEwiPcRS2_RjwRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSD_Pw($_0_i_i,$_0_i,$__a_1,$__a_end,$__dc,$23,$__grouping,$18,$__g_end,$7);
 var $118=($117|0)==0;
 if($118){label=45;break;}else{var $__a_2=$__a_1;var $_pre_i4_i_i=$62;label=48;break;}
 case 45: 
 var $120=HEAP32[(($103)>>2)];
 var $121=HEAP32[(($105)>>2)];
 var $122=($120|0)==($121|0);
 if($122){label=46;break;}else{label=47;break;}
 case 46: 
 var $124=$41;
 var $125=HEAP32[(($124)>>2)];
 var $126=(($125+40)|0);
 var $127=HEAP32[(($126)>>2)];
 var $128=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$127]($41) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $__a_0=$__a_1;var $_pre_i_i_i18=$41;label=10;break; } else { label=38;break; }
 case 47: 
 var $130=(($120+4)|0);
 HEAP32[(($103)>>2)]=$130;
 var $__a_0=$__a_1;var $_pre_i_i_i18=$41;label=10;break;
 case 48: 
 var $_pre_i4_i_i;
 var $__a_2;
 var $132=$__grouping;
 var $133=HEAP8[($132)];
 var $134=$133&1;
 var $135=(($134<<24)>>24)==0;
 if($135){label=50;break;}else{label=49;break;}
 case 49: 
 var $137=(($__grouping+4)|0);
 var $138=HEAP32[(($137)>>2)];
 var $142=$138;label=51;break;
 case 50: 
 var $140=($133&255);
 var $141=$140>>>1;
 var $142=$141;label=51;break;
 case 51: 
 var $142;
 var $143=($142|0)==0;
 if($143){label=54;break;}else{label=52;break;}
 case 52: 
 var $145=HEAP32[(($__g_end)>>2)];
 var $146=$145;
 var $147=$__g;
 var $148=((($146)-($147))|0);
 var $149=($148|0)<160;
 if($149){label=53;break;}else{label=54;break;}
 case 53: 
 var $151=HEAP32[(($__dc)>>2)];
 var $152=(($145+4)|0);
 HEAP32[(($__g_end)>>2)]=$152;
 HEAP32[(($145)>>2)]=$151;
 label=54;break;
 case 54: 
 var $153=HEAP32[(($__a_end)>>2)];
 var $154$r=(function() { try { __THREW__ = 0; return __ZNSt3__125__num_get_signed_integralIxEET_PKcS3_Rji($__a_2,$153,$__err,$_0_i) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();var $154$0=$154$r;var $154$1=tempRet0;if (!__THREW__) { label=55;break; } else { label=39;break; }
 case 55: 
 var $st$0$0=(($__v)|0);
 HEAP32[(($st$0$0)>>2)]=$154$0;
 var $st$1$1=(($__v+4)|0);
 HEAP32[(($st$1$1)>>2)]=$154$1;
 var $156=HEAP32[(($__g_end)>>2)];
 __ZNSt3__116__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj($__grouping,$18,$156,$__err);
 var $157=($41|0)==0;
 if($157){var $175=1;var $174=0;label=61;break;}else{label=56;break;}
 case 56: 
 var $159=(($41+12)|0);
 var $160=HEAP32[(($159)>>2)];
 var $161=(($41+16)|0);
 var $162=HEAP32[(($161)>>2)];
 var $163=($160|0)==($162|0);
 if($163){label=57;break;}else{label=58;break;}
 case 57: 
 var $165=$41;
 var $166=HEAP32[(($165)>>2)];
 var $167=(($166+36)|0);
 var $168=HEAP32[(($167)>>2)];
 var $169=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$168]($41) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $_0_i_i_i_i=$169;label=59;break; } else { label=39;break; }
 case 58: 
 var $171=HEAP32[(($160)>>2)];
 var $_0_i_i_i_i=$171;label=59;break;
 case 59: 
 var $_0_i_i_i_i;
 var $172=($_0_i_i_i_i|0)==-1;
 if($172){label=60;break;}else{var $175=0;var $174=$41;label=61;break;}
 case 60: 
 HEAP32[(($19)>>2)]=0;
 var $175=1;var $174=0;label=61;break;
 case 61: 
 var $174;
 var $175;
 var $176=($_pre_i4_i_i|0)==0;
 if($176){label=67;break;}else{label=62;break;}
 case 62: 
 var $178=(($_pre_i4_i_i+12)|0);
 var $179=HEAP32[(($178)>>2)];
 var $180=(($_pre_i4_i_i+16)|0);
 var $181=HEAP32[(($180)>>2)];
 var $182=($179|0)==($181|0);
 if($182){label=63;break;}else{label=64;break;}
 case 63: 
 var $184=$_pre_i4_i_i;
 var $185=HEAP32[(($184)>>2)];
 var $186=(($185+36)|0);
 var $187=HEAP32[(($186)>>2)];
 var $188=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$187]($_pre_i4_i_i) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $_0_i_i2_i_i=$188;label=65;break; } else { label=39;break; }
 case 64: 
 var $190=HEAP32[(($179)>>2)];
 var $_0_i_i2_i_i=$190;label=65;break;
 case 65: 
 var $_0_i_i2_i_i;
 var $191=($_0_i_i2_i_i|0)==-1;
 if($191){label=66;break;}else{label=68;break;}
 case 66: 
 HEAP32[(($20)>>2)]=0;
 label=67;break;
 case 67: 
 if($175){label=69;break;}else{label=70;break;}
 case 68: 
 if($175){label=70;break;}else{label=69;break;}
 case 69: 
 var $194=HEAP32[(($__err)>>2)];
 var $195=$194|2;
 HEAP32[(($__err)>>2)]=$195;
 label=70;break;
 case 70: 
 var $197=(($agg_result)|0);
 HEAP32[(($197)>>2)]=$174;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__buf);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grouping);
 STACKTOP=sp;return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRt($agg_result,$this,$__b,$__e,$__iob,$__err,$__v){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+16)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var tempParam = $__b; $__b=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__b)>>2)]=HEAP32[((tempParam)>>2)];
 var tempParam = $__e; $__e=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];

 var $1=sp;
 var $2=(sp)+(8);
 var $3=(($__b)|0);
 var $4=HEAP32[(($3)>>2)];
 var $5=(($1)|0);
 HEAP32[(($5)>>2)]=$4;
 var $6=(($__e)|0);
 var $7=HEAP32[(($6)>>2)];
 var $8=(($2)|0);
 HEAP32[(($8)>>2)]=$7;
 __ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE17__do_get_unsignedItEES4_S4_S4_RNS_8ios_baseERjRT_($agg_result,0,$1,$2,$__iob,$__err,$__v);
 STACKTOP=sp;return;
}


function __ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE17__do_get_unsignedItEES4_S4_S4_RNS_8ios_baseERjRT_($agg_result,$this,$__b,$__e,$__iob,$__err,$__v){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+328)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var tempParam = $__b; $__b=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__b)>>2)]=HEAP32[((tempParam)>>2)];
 var tempParam = $__e; $__e=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $__atoms=sp;
 var $__thousands_sep=(sp)+(104);
 var $__grouping=(sp)+(112);
 var $__buf=(sp)+(128);
 var $__a_end=(sp)+(144);
 var $__g=(sp)+(152);
 var $__g_end=(sp)+(312);
 var $__dc=(sp)+(320);
 var $1=(($__iob+4)|0);
 var $2=HEAP32[(($1)>>2)];
 var $3=$2&74;
 if(($3|0)==8){ label=2;break;}else if(($3|0)==0){ label=3;break;}else if(($3|0)==64){ var $_0_i=8;label=5;break;}else{label=4;break;}
 case 2: 
 var $_0_i=16;label=5;break;
 case 3: 
 var $_0_i=0;label=5;break;
 case 4: 
 var $_0_i=10;label=5;break;
 case 5: 
 var $_0_i;
 var $7=(($__atoms)|0);
 __ZNSt3__19__num_getIwE17__stage2_int_prepERNS_8ios_baseEPwRw($__grouping,$__iob,$7,$__thousands_sep);
 var $this4_i_i_i=$__buf;
 HEAP32[(($this4_i_i_i)>>2)]=0; HEAP32[((($this4_i_i_i)+(4))>>2)]=0; HEAP32[((($this4_i_i_i)+(8))>>2)]=0;
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc($__buf,10,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=6;break; } else { label=39;break; }
 case 6: 
 var $8=HEAP8[($this4_i_i_i)];
 var $9=$8&1;
 var $10=(($9<<24)>>24)==0;
 if($10){label=8;break;}else{label=7;break;}
 case 7: 
 var $12=(($__buf+8)|0);
 var $13=HEAP32[(($12)>>2)];
 var $_pre45=$__buf;
 var $_pre46=(($_pre45+1)|0);
 var $17=$13;var $_pre_phi47=$_pre46;var $_pre_phi49=$12;label=9;break;
 case 8: 
 var $15=$__buf;
 var $16=(($15+1)|0);
 var $_pre48=(($__buf+8)|0);
 var $17=$16;var $_pre_phi47=$16;var $_pre_phi49=$_pre48;label=9;break;
 case 9: 
 var $_pre_phi49;
 var $_pre_phi47;
 var $17;
 HEAP32[(($__a_end)>>2)]=$17;
 var $18=(($__g)|0);
 HEAP32[(($__g_end)>>2)]=$18;
 HEAP32[(($__dc)>>2)]=0;
 var $19=(($__b)|0);
 var $20=(($__e)|0);
 var $21=(($__buf)|0);
 var $22=(($__buf+4)|0);
 var $23=HEAP32[(($__thousands_sep)>>2)];
 var $_pre=HEAP32[(($19)>>2)];
 var $__a_0=$17;var $_pre_i_i_i18=$_pre;label=10;break;
 case 10: 
 var $_pre_i_i_i18;
 var $__a_0;
 var $24=($_pre_i_i_i18|0)==0;
 if($24){var $42=1;var $41=0;label=16;break;}else{label=11;break;}
 case 11: 
 var $26=(($_pre_i_i_i18+12)|0);
 var $27=HEAP32[(($26)>>2)];
 var $28=(($_pre_i_i_i18+16)|0);
 var $29=HEAP32[(($28)>>2)];
 var $30=($27|0)==($29|0);
 if($30){label=12;break;}else{label=13;break;}
 case 12: 
 var $32=$_pre_i_i_i18;
 var $33=HEAP32[(($32)>>2)];
 var $34=(($33+36)|0);
 var $35=HEAP32[(($34)>>2)];
 var $36=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$35]($_pre_i_i_i18) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $_0_i_i_i_i16=$36;label=14;break; } else { label=38;break; }
 case 13: 
 var $38=HEAP32[(($27)>>2)];
 var $_0_i_i_i_i16=$38;label=14;break;
 case 14: 
 var $_0_i_i_i_i16;
 var $39=($_0_i_i_i_i16|0)==-1;
 if($39){label=15;break;}else{var $42=0;var $41=$_pre_i_i_i18;label=16;break;}
 case 15: 
 HEAP32[(($19)>>2)]=0;
 var $42=1;var $41=0;label=16;break;
 case 16: 
 var $41;
 var $42;
 var $43=HEAP32[(($20)>>2)];
 var $44=($43|0)==0;
 if($44){label=22;break;}else{label=17;break;}
 case 17: 
 var $46=(($43+12)|0);
 var $47=HEAP32[(($46)>>2)];
 var $48=(($43+16)|0);
 var $49=HEAP32[(($48)>>2)];
 var $50=($47|0)==($49|0);
 if($50){label=18;break;}else{label=19;break;}
 case 18: 
 var $52=$43;
 var $53=HEAP32[(($52)>>2)];
 var $54=(($53+36)|0);
 var $55=HEAP32[(($54)>>2)];
 var $56=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$55]($43) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $_0_i_i2_i_i22=$56;label=20;break; } else { label=38;break; }
 case 19: 
 var $58=HEAP32[(($47)>>2)];
 var $_0_i_i2_i_i22=$58;label=20;break;
 case 20: 
 var $_0_i_i2_i_i22;
 var $59=($_0_i_i2_i_i22|0)==-1;
 if($59){label=21;break;}else{label=23;break;}
 case 21: 
 HEAP32[(($20)>>2)]=0;
 label=22;break;
 case 22: 
 if($42){var $__a_2=$__a_0;var $_pre_i4_i_i=0;label=48;break;}else{var $62=0;label=24;break;}
 case 23: 
 if($42){var $62=$43;label=24;break;}else{var $__a_2=$__a_0;var $_pre_i4_i_i=$43;label=48;break;}
 case 24: 
 var $62;
 var $63=HEAP32[(($__a_end)>>2)];
 var $64=$63;
 var $65=$__a_0;
 var $66=((($64)-($65))|0);
 var $67=HEAP8[($this4_i_i_i)];
 var $68=$67&1;
 var $69=(($68<<24)>>24)==0;
 if($69){label=26;break;}else{label=25;break;}
 case 25: 
 var $71=HEAP32[(($22)>>2)];
 var $75=$71;label=27;break;
 case 26: 
 var $73=($67&255);
 var $74=$73>>>1;
 var $75=$74;label=27;break;
 case 27: 
 var $75;
 var $76=($66|0)==($75|0);
 if($76){label=28;break;}else{var $__a_1=$__a_0;label=41;break;}
 case 28: 
 if($69){label=30;break;}else{label=29;break;}
 case 29: 
 var $79=HEAP32[(($22)>>2)];
 var $86=$79;var $85=$79;label=31;break;
 case 30: 
 var $81=($67&255);
 var $82=$81>>>1;
 var $83=($67&255);
 var $84=$83>>>1;
 var $86=$84;var $85=$82;label=31;break;
 case 31: 
 var $85;
 var $86;
 var $87=$86<<1;
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc($__buf,$87,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=32;break; } else { label=38;break; }
 case 32: 
 var $88=HEAP8[($this4_i_i_i)];
 var $89=$88&1;
 var $90=(($89<<24)>>24)==0;
 if($90){var $94=10;label=34;break;}else{label=33;break;}
 case 33: 
 var $92=HEAP32[(($21)>>2)];
 var $93=$92&-2;
 var $phitmp_i36=((($93)-(1))|0);
 var $94=$phitmp_i36;label=34;break;
 case 34: 
 var $94;
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc($__buf,$94,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=35;break; } else { label=38;break; }
 case 35: 
 var $95=HEAP8[($this4_i_i_i)];
 var $96=$95&1;
 var $97=(($96<<24)>>24)==0;
 if($97){var $100=$_pre_phi47;label=37;break;}else{label=36;break;}
 case 36: 
 var $99=HEAP32[(($_pre_phi49)>>2)];
 var $100=$99;label=37;break;
 case 37: 
 var $100;
 var $101=(($100+$85)|0);
 HEAP32[(($__a_end)>>2)]=$101;
 var $__a_1=$100;label=41;break;
 case 38: 
 var $lpad_loopexit$0 = ___cxa_find_matching_catch(-1, -1); var $lpad_loopexit$1 = tempRet0;
 var $lpad_phi$1=$lpad_loopexit$1;var $lpad_phi$0=$lpad_loopexit$0;label=40;break;
 case 39: 
 var $lpad_nonloopexit$0 = ___cxa_find_matching_catch(-1, -1); var $lpad_nonloopexit$1 = tempRet0;
 var $lpad_phi$1=$lpad_nonloopexit$1;var $lpad_phi$0=$lpad_nonloopexit$0;label=40;break;
 case 40: 
 var $lpad_phi$0;
 var $lpad_phi$1;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__buf);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grouping);
 ___resumeException($lpad_phi$0)
 case 41: 
 var $__a_1;
 var $103=(($41+12)|0);
 var $104=HEAP32[(($103)>>2)];
 var $105=(($41+16)|0);
 var $106=HEAP32[(($105)>>2)];
 var $107=($104|0)==($106|0);
 if($107){label=42;break;}else{label=43;break;}
 case 42: 
 var $109=$41;
 var $110=HEAP32[(($109)>>2)];
 var $111=(($110+36)|0);
 var $112=HEAP32[(($111)>>2)];
 var $113=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$112]($41) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $_0_i_i=$113;label=44;break; } else { label=38;break; }
 case 43: 
 var $115=HEAP32[(($104)>>2)];
 var $_0_i_i=$115;label=44;break;
 case 44: 
 var $_0_i_i;
 var $117=__ZNSt3__19__num_getIwE17__stage2_int_loopEwiPcRS2_RjwRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSD_Pw($_0_i_i,$_0_i,$__a_1,$__a_end,$__dc,$23,$__grouping,$18,$__g_end,$7);
 var $118=($117|0)==0;
 if($118){label=45;break;}else{var $__a_2=$__a_1;var $_pre_i4_i_i=$62;label=48;break;}
 case 45: 
 var $120=HEAP32[(($103)>>2)];
 var $121=HEAP32[(($105)>>2)];
 var $122=($120|0)==($121|0);
 if($122){label=46;break;}else{label=47;break;}
 case 46: 
 var $124=$41;
 var $125=HEAP32[(($124)>>2)];
 var $126=(($125+40)|0);
 var $127=HEAP32[(($126)>>2)];
 var $128=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$127]($41) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $__a_0=$__a_1;var $_pre_i_i_i18=$41;label=10;break; } else { label=38;break; }
 case 47: 
 var $130=(($120+4)|0);
 HEAP32[(($103)>>2)]=$130;
 var $__a_0=$__a_1;var $_pre_i_i_i18=$41;label=10;break;
 case 48: 
 var $_pre_i4_i_i;
 var $__a_2;
 var $132=$__grouping;
 var $133=HEAP8[($132)];
 var $134=$133&1;
 var $135=(($134<<24)>>24)==0;
 if($135){label=50;break;}else{label=49;break;}
 case 49: 
 var $137=(($__grouping+4)|0);
 var $138=HEAP32[(($137)>>2)];
 var $142=$138;label=51;break;
 case 50: 
 var $140=($133&255);
 var $141=$140>>>1;
 var $142=$141;label=51;break;
 case 51: 
 var $142;
 var $143=($142|0)==0;
 if($143){label=54;break;}else{label=52;break;}
 case 52: 
 var $145=HEAP32[(($__g_end)>>2)];
 var $146=$145;
 var $147=$__g;
 var $148=((($146)-($147))|0);
 var $149=($148|0)<160;
 if($149){label=53;break;}else{label=54;break;}
 case 53: 
 var $151=HEAP32[(($__dc)>>2)];
 var $152=(($145+4)|0);
 HEAP32[(($__g_end)>>2)]=$152;
 HEAP32[(($145)>>2)]=$151;
 label=54;break;
 case 54: 
 var $153=HEAP32[(($__a_end)>>2)];
 var $154=(function() { try { __THREW__ = 0; return __ZNSt3__127__num_get_unsigned_integralItEET_PKcS3_Rji($__a_2,$153,$__err,$_0_i) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=55;break; } else { label=39;break; }
 case 55: 
 HEAP16[(($__v)>>1)]=$154;
 var $156=HEAP32[(($__g_end)>>2)];
 __ZNSt3__116__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj($__grouping,$18,$156,$__err);
 var $157=($41|0)==0;
 if($157){var $175=1;var $174=0;label=61;break;}else{label=56;break;}
 case 56: 
 var $159=(($41+12)|0);
 var $160=HEAP32[(($159)>>2)];
 var $161=(($41+16)|0);
 var $162=HEAP32[(($161)>>2)];
 var $163=($160|0)==($162|0);
 if($163){label=57;break;}else{label=58;break;}
 case 57: 
 var $165=$41;
 var $166=HEAP32[(($165)>>2)];
 var $167=(($166+36)|0);
 var $168=HEAP32[(($167)>>2)];
 var $169=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$168]($41) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $_0_i_i_i_i=$169;label=59;break; } else { label=39;break; }
 case 58: 
 var $171=HEAP32[(($160)>>2)];
 var $_0_i_i_i_i=$171;label=59;break;
 case 59: 
 var $_0_i_i_i_i;
 var $172=($_0_i_i_i_i|0)==-1;
 if($172){label=60;break;}else{var $175=0;var $174=$41;label=61;break;}
 case 60: 
 HEAP32[(($19)>>2)]=0;
 var $175=1;var $174=0;label=61;break;
 case 61: 
 var $174;
 var $175;
 var $176=($_pre_i4_i_i|0)==0;
 if($176){label=67;break;}else{label=62;break;}
 case 62: 
 var $178=(($_pre_i4_i_i+12)|0);
 var $179=HEAP32[(($178)>>2)];
 var $180=(($_pre_i4_i_i+16)|0);
 var $181=HEAP32[(($180)>>2)];
 var $182=($179|0)==($181|0);
 if($182){label=63;break;}else{label=64;break;}
 case 63: 
 var $184=$_pre_i4_i_i;
 var $185=HEAP32[(($184)>>2)];
 var $186=(($185+36)|0);
 var $187=HEAP32[(($186)>>2)];
 var $188=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$187]($_pre_i4_i_i) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $_0_i_i2_i_i=$188;label=65;break; } else { label=39;break; }
 case 64: 
 var $190=HEAP32[(($179)>>2)];
 var $_0_i_i2_i_i=$190;label=65;break;
 case 65: 
 var $_0_i_i2_i_i;
 var $191=($_0_i_i2_i_i|0)==-1;
 if($191){label=66;break;}else{label=68;break;}
 case 66: 
 HEAP32[(($20)>>2)]=0;
 label=67;break;
 case 67: 
 if($175){label=69;break;}else{label=70;break;}
 case 68: 
 if($175){label=70;break;}else{label=69;break;}
 case 69: 
 var $194=HEAP32[(($__err)>>2)];
 var $195=$194|2;
 HEAP32[(($__err)>>2)]=$195;
 label=70;break;
 case 70: 
 var $197=(($agg_result)|0);
 HEAP32[(($197)>>2)]=$174;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__buf);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grouping);
 STACKTOP=sp;return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjS8_($agg_result,$this,$__b,$__e,$__iob,$__err,$__v){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+16)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var tempParam = $__b; $__b=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__b)>>2)]=HEAP32[((tempParam)>>2)];
 var tempParam = $__e; $__e=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];

 var $1=sp;
 var $2=(sp)+(8);
 var $3=(($__b)|0);
 var $4=HEAP32[(($3)>>2)];
 var $5=(($1)|0);
 HEAP32[(($5)>>2)]=$4;
 var $6=(($__e)|0);
 var $7=HEAP32[(($6)>>2)];
 var $8=(($2)|0);
 HEAP32[(($8)>>2)]=$7;
 __ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE17__do_get_unsignedIjEES4_S4_S4_RNS_8ios_baseERjRT_($agg_result,0,$1,$2,$__iob,$__err,$__v);
 STACKTOP=sp;return;
}


function __ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE17__do_get_unsignedIjEES4_S4_S4_RNS_8ios_baseERjRT_($agg_result,$this,$__b,$__e,$__iob,$__err,$__v){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+328)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var tempParam = $__b; $__b=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__b)>>2)]=HEAP32[((tempParam)>>2)];
 var tempParam = $__e; $__e=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $__atoms=sp;
 var $__thousands_sep=(sp)+(104);
 var $__grouping=(sp)+(112);
 var $__buf=(sp)+(128);
 var $__a_end=(sp)+(144);
 var $__g=(sp)+(152);
 var $__g_end=(sp)+(312);
 var $__dc=(sp)+(320);
 var $1=(($__iob+4)|0);
 var $2=HEAP32[(($1)>>2)];
 var $3=$2&74;
 if(($3|0)==8){ label=2;break;}else if(($3|0)==0){ label=3;break;}else if(($3|0)==64){ var $_0_i=8;label=5;break;}else{label=4;break;}
 case 2: 
 var $_0_i=16;label=5;break;
 case 3: 
 var $_0_i=0;label=5;break;
 case 4: 
 var $_0_i=10;label=5;break;
 case 5: 
 var $_0_i;
 var $7=(($__atoms)|0);
 __ZNSt3__19__num_getIwE17__stage2_int_prepERNS_8ios_baseEPwRw($__grouping,$__iob,$7,$__thousands_sep);
 var $this4_i_i_i=$__buf;
 HEAP32[(($this4_i_i_i)>>2)]=0; HEAP32[((($this4_i_i_i)+(4))>>2)]=0; HEAP32[((($this4_i_i_i)+(8))>>2)]=0;
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc($__buf,10,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=6;break; } else { label=39;break; }
 case 6: 
 var $8=HEAP8[($this4_i_i_i)];
 var $9=$8&1;
 var $10=(($9<<24)>>24)==0;
 if($10){label=8;break;}else{label=7;break;}
 case 7: 
 var $12=(($__buf+8)|0);
 var $13=HEAP32[(($12)>>2)];
 var $_pre45=$__buf;
 var $_pre46=(($_pre45+1)|0);
 var $17=$13;var $_pre_phi47=$_pre46;var $_pre_phi49=$12;label=9;break;
 case 8: 
 var $15=$__buf;
 var $16=(($15+1)|0);
 var $_pre48=(($__buf+8)|0);
 var $17=$16;var $_pre_phi47=$16;var $_pre_phi49=$_pre48;label=9;break;
 case 9: 
 var $_pre_phi49;
 var $_pre_phi47;
 var $17;
 HEAP32[(($__a_end)>>2)]=$17;
 var $18=(($__g)|0);
 HEAP32[(($__g_end)>>2)]=$18;
 HEAP32[(($__dc)>>2)]=0;
 var $19=(($__b)|0);
 var $20=(($__e)|0);
 var $21=(($__buf)|0);
 var $22=(($__buf+4)|0);
 var $23=HEAP32[(($__thousands_sep)>>2)];
 var $_pre=HEAP32[(($19)>>2)];
 var $__a_0=$17;var $_pre_i_i_i18=$_pre;label=10;break;
 case 10: 
 var $_pre_i_i_i18;
 var $__a_0;
 var $24=($_pre_i_i_i18|0)==0;
 if($24){var $42=1;var $41=0;label=16;break;}else{label=11;break;}
 case 11: 
 var $26=(($_pre_i_i_i18+12)|0);
 var $27=HEAP32[(($26)>>2)];
 var $28=(($_pre_i_i_i18+16)|0);
 var $29=HEAP32[(($28)>>2)];
 var $30=($27|0)==($29|0);
 if($30){label=12;break;}else{label=13;break;}
 case 12: 
 var $32=$_pre_i_i_i18;
 var $33=HEAP32[(($32)>>2)];
 var $34=(($33+36)|0);
 var $35=HEAP32[(($34)>>2)];
 var $36=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$35]($_pre_i_i_i18) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $_0_i_i_i_i16=$36;label=14;break; } else { label=38;break; }
 case 13: 
 var $38=HEAP32[(($27)>>2)];
 var $_0_i_i_i_i16=$38;label=14;break;
 case 14: 
 var $_0_i_i_i_i16;
 var $39=($_0_i_i_i_i16|0)==-1;
 if($39){label=15;break;}else{var $42=0;var $41=$_pre_i_i_i18;label=16;break;}
 case 15: 
 HEAP32[(($19)>>2)]=0;
 var $42=1;var $41=0;label=16;break;
 case 16: 
 var $41;
 var $42;
 var $43=HEAP32[(($20)>>2)];
 var $44=($43|0)==0;
 if($44){label=22;break;}else{label=17;break;}
 case 17: 
 var $46=(($43+12)|0);
 var $47=HEAP32[(($46)>>2)];
 var $48=(($43+16)|0);
 var $49=HEAP32[(($48)>>2)];
 var $50=($47|0)==($49|0);
 if($50){label=18;break;}else{label=19;break;}
 case 18: 
 var $52=$43;
 var $53=HEAP32[(($52)>>2)];
 var $54=(($53+36)|0);
 var $55=HEAP32[(($54)>>2)];
 var $56=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$55]($43) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $_0_i_i2_i_i22=$56;label=20;break; } else { label=38;break; }
 case 19: 
 var $58=HEAP32[(($47)>>2)];
 var $_0_i_i2_i_i22=$58;label=20;break;
 case 20: 
 var $_0_i_i2_i_i22;
 var $59=($_0_i_i2_i_i22|0)==-1;
 if($59){label=21;break;}else{label=23;break;}
 case 21: 
 HEAP32[(($20)>>2)]=0;
 label=22;break;
 case 22: 
 if($42){var $__a_2=$__a_0;var $_pre_i4_i_i=0;label=48;break;}else{var $62=0;label=24;break;}
 case 23: 
 if($42){var $62=$43;label=24;break;}else{var $__a_2=$__a_0;var $_pre_i4_i_i=$43;label=48;break;}
 case 24: 
 var $62;
 var $63=HEAP32[(($__a_end)>>2)];
 var $64=$63;
 var $65=$__a_0;
 var $66=((($64)-($65))|0);
 var $67=HEAP8[($this4_i_i_i)];
 var $68=$67&1;
 var $69=(($68<<24)>>24)==0;
 if($69){label=26;break;}else{label=25;break;}
 case 25: 
 var $71=HEAP32[(($22)>>2)];
 var $75=$71;label=27;break;
 case 26: 
 var $73=($67&255);
 var $74=$73>>>1;
 var $75=$74;label=27;break;
 case 27: 
 var $75;
 var $76=($66|0)==($75|0);
 if($76){label=28;break;}else{var $__a_1=$__a_0;label=41;break;}
 case 28: 
 if($69){label=30;break;}else{label=29;break;}
 case 29: 
 var $79=HEAP32[(($22)>>2)];
 var $86=$79;var $85=$79;label=31;break;
 case 30: 
 var $81=($67&255);
 var $82=$81>>>1;
 var $83=($67&255);
 var $84=$83>>>1;
 var $86=$84;var $85=$82;label=31;break;
 case 31: 
 var $85;
 var $86;
 var $87=$86<<1;
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc($__buf,$87,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=32;break; } else { label=38;break; }
 case 32: 
 var $88=HEAP8[($this4_i_i_i)];
 var $89=$88&1;
 var $90=(($89<<24)>>24)==0;
 if($90){var $94=10;label=34;break;}else{label=33;break;}
 case 33: 
 var $92=HEAP32[(($21)>>2)];
 var $93=$92&-2;
 var $phitmp_i36=((($93)-(1))|0);
 var $94=$phitmp_i36;label=34;break;
 case 34: 
 var $94;
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc($__buf,$94,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=35;break; } else { label=38;break; }
 case 35: 
 var $95=HEAP8[($this4_i_i_i)];
 var $96=$95&1;
 var $97=(($96<<24)>>24)==0;
 if($97){var $100=$_pre_phi47;label=37;break;}else{label=36;break;}
 case 36: 
 var $99=HEAP32[(($_pre_phi49)>>2)];
 var $100=$99;label=37;break;
 case 37: 
 var $100;
 var $101=(($100+$85)|0);
 HEAP32[(($__a_end)>>2)]=$101;
 var $__a_1=$100;label=41;break;
 case 38: 
 var $lpad_loopexit$0 = ___cxa_find_matching_catch(-1, -1); var $lpad_loopexit$1 = tempRet0;
 var $lpad_phi$1=$lpad_loopexit$1;var $lpad_phi$0=$lpad_loopexit$0;label=40;break;
 case 39: 
 var $lpad_nonloopexit$0 = ___cxa_find_matching_catch(-1, -1); var $lpad_nonloopexit$1 = tempRet0;
 var $lpad_phi$1=$lpad_nonloopexit$1;var $lpad_phi$0=$lpad_nonloopexit$0;label=40;break;
 case 40: 
 var $lpad_phi$0;
 var $lpad_phi$1;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__buf);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grouping);
 ___resumeException($lpad_phi$0)
 case 41: 
 var $__a_1;
 var $103=(($41+12)|0);
 var $104=HEAP32[(($103)>>2)];
 var $105=(($41+16)|0);
 var $106=HEAP32[(($105)>>2)];
 var $107=($104|0)==($106|0);
 if($107){label=42;break;}else{label=43;break;}
 case 42: 
 var $109=$41;
 var $110=HEAP32[(($109)>>2)];
 var $111=(($110+36)|0);
 var $112=HEAP32[(($111)>>2)];
 var $113=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$112]($41) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $_0_i_i=$113;label=44;break; } else { label=38;break; }
 case 43: 
 var $115=HEAP32[(($104)>>2)];
 var $_0_i_i=$115;label=44;break;
 case 44: 
 var $_0_i_i;
 var $117=__ZNSt3__19__num_getIwE17__stage2_int_loopEwiPcRS2_RjwRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSD_Pw($_0_i_i,$_0_i,$__a_1,$__a_end,$__dc,$23,$__grouping,$18,$__g_end,$7);
 var $118=($117|0)==0;
 if($118){label=45;break;}else{var $__a_2=$__a_1;var $_pre_i4_i_i=$62;label=48;break;}
 case 45: 
 var $120=HEAP32[(($103)>>2)];
 var $121=HEAP32[(($105)>>2)];
 var $122=($120|0)==($121|0);
 if($122){label=46;break;}else{label=47;break;}
 case 46: 
 var $124=$41;
 var $125=HEAP32[(($124)>>2)];
 var $126=(($125+40)|0);
 var $127=HEAP32[(($126)>>2)];
 var $128=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$127]($41) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $__a_0=$__a_1;var $_pre_i_i_i18=$41;label=10;break; } else { label=38;break; }
 case 47: 
 var $130=(($120+4)|0);
 HEAP32[(($103)>>2)]=$130;
 var $__a_0=$__a_1;var $_pre_i_i_i18=$41;label=10;break;
 case 48: 
 var $_pre_i4_i_i;
 var $__a_2;
 var $132=$__grouping;
 var $133=HEAP8[($132)];
 var $134=$133&1;
 var $135=(($134<<24)>>24)==0;
 if($135){label=50;break;}else{label=49;break;}
 case 49: 
 var $137=(($__grouping+4)|0);
 var $138=HEAP32[(($137)>>2)];
 var $142=$138;label=51;break;
 case 50: 
 var $140=($133&255);
 var $141=$140>>>1;
 var $142=$141;label=51;break;
 case 51: 
 var $142;
 var $143=($142|0)==0;
 if($143){label=54;break;}else{label=52;break;}
 case 52: 
 var $145=HEAP32[(($__g_end)>>2)];
 var $146=$145;
 var $147=$__g;
 var $148=((($146)-($147))|0);
 var $149=($148|0)<160;
 if($149){label=53;break;}else{label=54;break;}
 case 53: 
 var $151=HEAP32[(($__dc)>>2)];
 var $152=(($145+4)|0);
 HEAP32[(($__g_end)>>2)]=$152;
 HEAP32[(($145)>>2)]=$151;
 label=54;break;
 case 54: 
 var $153=HEAP32[(($__a_end)>>2)];
 var $154=(function() { try { __THREW__ = 0; return __ZNSt3__127__num_get_unsigned_integralIjEET_PKcS3_Rji($__a_2,$153,$__err,$_0_i) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=55;break; } else { label=39;break; }
 case 55: 
 HEAP32[(($__v)>>2)]=$154;
 var $156=HEAP32[(($__g_end)>>2)];
 __ZNSt3__116__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj($__grouping,$18,$156,$__err);
 var $157=($41|0)==0;
 if($157){var $175=1;var $174=0;label=61;break;}else{label=56;break;}
 case 56: 
 var $159=(($41+12)|0);
 var $160=HEAP32[(($159)>>2)];
 var $161=(($41+16)|0);
 var $162=HEAP32[(($161)>>2)];
 var $163=($160|0)==($162|0);
 if($163){label=57;break;}else{label=58;break;}
 case 57: 
 var $165=$41;
 var $166=HEAP32[(($165)>>2)];
 var $167=(($166+36)|0);
 var $168=HEAP32[(($167)>>2)];
 var $169=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$168]($41) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $_0_i_i_i_i=$169;label=59;break; } else { label=39;break; }
 case 58: 
 var $171=HEAP32[(($160)>>2)];
 var $_0_i_i_i_i=$171;label=59;break;
 case 59: 
 var $_0_i_i_i_i;
 var $172=($_0_i_i_i_i|0)==-1;
 if($172){label=60;break;}else{var $175=0;var $174=$41;label=61;break;}
 case 60: 
 HEAP32[(($19)>>2)]=0;
 var $175=1;var $174=0;label=61;break;
 case 61: 
 var $174;
 var $175;
 var $176=($_pre_i4_i_i|0)==0;
 if($176){label=67;break;}else{label=62;break;}
 case 62: 
 var $178=(($_pre_i4_i_i+12)|0);
 var $179=HEAP32[(($178)>>2)];
 var $180=(($_pre_i4_i_i+16)|0);
 var $181=HEAP32[(($180)>>2)];
 var $182=($179|0)==($181|0);
 if($182){label=63;break;}else{label=64;break;}
 case 63: 
 var $184=$_pre_i4_i_i;
 var $185=HEAP32[(($184)>>2)];
 var $186=(($185+36)|0);
 var $187=HEAP32[(($186)>>2)];
 var $188=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$187]($_pre_i4_i_i) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $_0_i_i2_i_i=$188;label=65;break; } else { label=39;break; }
 case 64: 
 var $190=HEAP32[(($179)>>2)];
 var $_0_i_i2_i_i=$190;label=65;break;
 case 65: 
 var $_0_i_i2_i_i;
 var $191=($_0_i_i2_i_i|0)==-1;
 if($191){label=66;break;}else{label=68;break;}
 case 66: 
 HEAP32[(($20)>>2)]=0;
 label=67;break;
 case 67: 
 if($175){label=69;break;}else{label=70;break;}
 case 68: 
 if($175){label=70;break;}else{label=69;break;}
 case 69: 
 var $194=HEAP32[(($__err)>>2)];
 var $195=$194|2;
 HEAP32[(($__err)>>2)]=$195;
 label=70;break;
 case 70: 
 var $197=(($agg_result)|0);
 HEAP32[(($197)>>2)]=$174;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__buf);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grouping);
 STACKTOP=sp;return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRm($agg_result,$this,$__b,$__e,$__iob,$__err,$__v){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+16)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var tempParam = $__b; $__b=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__b)>>2)]=HEAP32[((tempParam)>>2)];
 var tempParam = $__e; $__e=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];

 var $1=sp;
 var $2=(sp)+(8);
 var $3=(($__b)|0);
 var $4=HEAP32[(($3)>>2)];
 var $5=(($1)|0);
 HEAP32[(($5)>>2)]=$4;
 var $6=(($__e)|0);
 var $7=HEAP32[(($6)>>2)];
 var $8=(($2)|0);
 HEAP32[(($8)>>2)]=$7;
 __ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE17__do_get_unsignedImEES4_S4_S4_RNS_8ios_baseERjRT_($agg_result,0,$1,$2,$__iob,$__err,$__v);
 STACKTOP=sp;return;
}


function __ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE17__do_get_unsignedImEES4_S4_S4_RNS_8ios_baseERjRT_($agg_result,$this,$__b,$__e,$__iob,$__err,$__v){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+328)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var tempParam = $__b; $__b=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__b)>>2)]=HEAP32[((tempParam)>>2)];
 var tempParam = $__e; $__e=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $__atoms=sp;
 var $__thousands_sep=(sp)+(104);
 var $__grouping=(sp)+(112);
 var $__buf=(sp)+(128);
 var $__a_end=(sp)+(144);
 var $__g=(sp)+(152);
 var $__g_end=(sp)+(312);
 var $__dc=(sp)+(320);
 var $1=(($__iob+4)|0);
 var $2=HEAP32[(($1)>>2)];
 var $3=$2&74;
 if(($3|0)==8){ label=2;break;}else if(($3|0)==0){ label=3;break;}else if(($3|0)==64){ var $_0_i=8;label=5;break;}else{label=4;break;}
 case 2: 
 var $_0_i=16;label=5;break;
 case 3: 
 var $_0_i=0;label=5;break;
 case 4: 
 var $_0_i=10;label=5;break;
 case 5: 
 var $_0_i;
 var $7=(($__atoms)|0);
 __ZNSt3__19__num_getIwE17__stage2_int_prepERNS_8ios_baseEPwRw($__grouping,$__iob,$7,$__thousands_sep);
 var $this4_i_i_i=$__buf;
 HEAP32[(($this4_i_i_i)>>2)]=0; HEAP32[((($this4_i_i_i)+(4))>>2)]=0; HEAP32[((($this4_i_i_i)+(8))>>2)]=0;
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc($__buf,10,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=6;break; } else { label=39;break; }
 case 6: 
 var $8=HEAP8[($this4_i_i_i)];
 var $9=$8&1;
 var $10=(($9<<24)>>24)==0;
 if($10){label=8;break;}else{label=7;break;}
 case 7: 
 var $12=(($__buf+8)|0);
 var $13=HEAP32[(($12)>>2)];
 var $_pre45=$__buf;
 var $_pre46=(($_pre45+1)|0);
 var $17=$13;var $_pre_phi47=$_pre46;var $_pre_phi49=$12;label=9;break;
 case 8: 
 var $15=$__buf;
 var $16=(($15+1)|0);
 var $_pre48=(($__buf+8)|0);
 var $17=$16;var $_pre_phi47=$16;var $_pre_phi49=$_pre48;label=9;break;
 case 9: 
 var $_pre_phi49;
 var $_pre_phi47;
 var $17;
 HEAP32[(($__a_end)>>2)]=$17;
 var $18=(($__g)|0);
 HEAP32[(($__g_end)>>2)]=$18;
 HEAP32[(($__dc)>>2)]=0;
 var $19=(($__b)|0);
 var $20=(($__e)|0);
 var $21=(($__buf)|0);
 var $22=(($__buf+4)|0);
 var $23=HEAP32[(($__thousands_sep)>>2)];
 var $_pre=HEAP32[(($19)>>2)];
 var $__a_0=$17;var $_pre_i_i_i18=$_pre;label=10;break;
 case 10: 
 var $_pre_i_i_i18;
 var $__a_0;
 var $24=($_pre_i_i_i18|0)==0;
 if($24){var $42=1;var $41=0;label=16;break;}else{label=11;break;}
 case 11: 
 var $26=(($_pre_i_i_i18+12)|0);
 var $27=HEAP32[(($26)>>2)];
 var $28=(($_pre_i_i_i18+16)|0);
 var $29=HEAP32[(($28)>>2)];
 var $30=($27|0)==($29|0);
 if($30){label=12;break;}else{label=13;break;}
 case 12: 
 var $32=$_pre_i_i_i18;
 var $33=HEAP32[(($32)>>2)];
 var $34=(($33+36)|0);
 var $35=HEAP32[(($34)>>2)];
 var $36=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$35]($_pre_i_i_i18) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $_0_i_i_i_i16=$36;label=14;break; } else { label=38;break; }
 case 13: 
 var $38=HEAP32[(($27)>>2)];
 var $_0_i_i_i_i16=$38;label=14;break;
 case 14: 
 var $_0_i_i_i_i16;
 var $39=($_0_i_i_i_i16|0)==-1;
 if($39){label=15;break;}else{var $42=0;var $41=$_pre_i_i_i18;label=16;break;}
 case 15: 
 HEAP32[(($19)>>2)]=0;
 var $42=1;var $41=0;label=16;break;
 case 16: 
 var $41;
 var $42;
 var $43=HEAP32[(($20)>>2)];
 var $44=($43|0)==0;
 if($44){label=22;break;}else{label=17;break;}
 case 17: 
 var $46=(($43+12)|0);
 var $47=HEAP32[(($46)>>2)];
 var $48=(($43+16)|0);
 var $49=HEAP32[(($48)>>2)];
 var $50=($47|0)==($49|0);
 if($50){label=18;break;}else{label=19;break;}
 case 18: 
 var $52=$43;
 var $53=HEAP32[(($52)>>2)];
 var $54=(($53+36)|0);
 var $55=HEAP32[(($54)>>2)];
 var $56=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$55]($43) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $_0_i_i2_i_i22=$56;label=20;break; } else { label=38;break; }
 case 19: 
 var $58=HEAP32[(($47)>>2)];
 var $_0_i_i2_i_i22=$58;label=20;break;
 case 20: 
 var $_0_i_i2_i_i22;
 var $59=($_0_i_i2_i_i22|0)==-1;
 if($59){label=21;break;}else{label=23;break;}
 case 21: 
 HEAP32[(($20)>>2)]=0;
 label=22;break;
 case 22: 
 if($42){var $__a_2=$__a_0;var $_pre_i4_i_i=0;label=48;break;}else{var $62=0;label=24;break;}
 case 23: 
 if($42){var $62=$43;label=24;break;}else{var $__a_2=$__a_0;var $_pre_i4_i_i=$43;label=48;break;}
 case 24: 
 var $62;
 var $63=HEAP32[(($__a_end)>>2)];
 var $64=$63;
 var $65=$__a_0;
 var $66=((($64)-($65))|0);
 var $67=HEAP8[($this4_i_i_i)];
 var $68=$67&1;
 var $69=(($68<<24)>>24)==0;
 if($69){label=26;break;}else{label=25;break;}
 case 25: 
 var $71=HEAP32[(($22)>>2)];
 var $75=$71;label=27;break;
 case 26: 
 var $73=($67&255);
 var $74=$73>>>1;
 var $75=$74;label=27;break;
 case 27: 
 var $75;
 var $76=($66|0)==($75|0);
 if($76){label=28;break;}else{var $__a_1=$__a_0;label=41;break;}
 case 28: 
 if($69){label=30;break;}else{label=29;break;}
 case 29: 
 var $79=HEAP32[(($22)>>2)];
 var $86=$79;var $85=$79;label=31;break;
 case 30: 
 var $81=($67&255);
 var $82=$81>>>1;
 var $83=($67&255);
 var $84=$83>>>1;
 var $86=$84;var $85=$82;label=31;break;
 case 31: 
 var $85;
 var $86;
 var $87=$86<<1;
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc($__buf,$87,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=32;break; } else { label=38;break; }
 case 32: 
 var $88=HEAP8[($this4_i_i_i)];
 var $89=$88&1;
 var $90=(($89<<24)>>24)==0;
 if($90){var $94=10;label=34;break;}else{label=33;break;}
 case 33: 
 var $92=HEAP32[(($21)>>2)];
 var $93=$92&-2;
 var $phitmp_i36=((($93)-(1))|0);
 var $94=$phitmp_i36;label=34;break;
 case 34: 
 var $94;
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc($__buf,$94,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=35;break; } else { label=38;break; }
 case 35: 
 var $95=HEAP8[($this4_i_i_i)];
 var $96=$95&1;
 var $97=(($96<<24)>>24)==0;
 if($97){var $100=$_pre_phi47;label=37;break;}else{label=36;break;}
 case 36: 
 var $99=HEAP32[(($_pre_phi49)>>2)];
 var $100=$99;label=37;break;
 case 37: 
 var $100;
 var $101=(($100+$85)|0);
 HEAP32[(($__a_end)>>2)]=$101;
 var $__a_1=$100;label=41;break;
 case 38: 
 var $lpad_loopexit$0 = ___cxa_find_matching_catch(-1, -1); var $lpad_loopexit$1 = tempRet0;
 var $lpad_phi$1=$lpad_loopexit$1;var $lpad_phi$0=$lpad_loopexit$0;label=40;break;
 case 39: 
 var $lpad_nonloopexit$0 = ___cxa_find_matching_catch(-1, -1); var $lpad_nonloopexit$1 = tempRet0;
 var $lpad_phi$1=$lpad_nonloopexit$1;var $lpad_phi$0=$lpad_nonloopexit$0;label=40;break;
 case 40: 
 var $lpad_phi$0;
 var $lpad_phi$1;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__buf);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grouping);
 ___resumeException($lpad_phi$0)
 case 41: 
 var $__a_1;
 var $103=(($41+12)|0);
 var $104=HEAP32[(($103)>>2)];
 var $105=(($41+16)|0);
 var $106=HEAP32[(($105)>>2)];
 var $107=($104|0)==($106|0);
 if($107){label=42;break;}else{label=43;break;}
 case 42: 
 var $109=$41;
 var $110=HEAP32[(($109)>>2)];
 var $111=(($110+36)|0);
 var $112=HEAP32[(($111)>>2)];
 var $113=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$112]($41) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $_0_i_i=$113;label=44;break; } else { label=38;break; }
 case 43: 
 var $115=HEAP32[(($104)>>2)];
 var $_0_i_i=$115;label=44;break;
 case 44: 
 var $_0_i_i;
 var $117=__ZNSt3__19__num_getIwE17__stage2_int_loopEwiPcRS2_RjwRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSD_Pw($_0_i_i,$_0_i,$__a_1,$__a_end,$__dc,$23,$__grouping,$18,$__g_end,$7);
 var $118=($117|0)==0;
 if($118){label=45;break;}else{var $__a_2=$__a_1;var $_pre_i4_i_i=$62;label=48;break;}
 case 45: 
 var $120=HEAP32[(($103)>>2)];
 var $121=HEAP32[(($105)>>2)];
 var $122=($120|0)==($121|0);
 if($122){label=46;break;}else{label=47;break;}
 case 46: 
 var $124=$41;
 var $125=HEAP32[(($124)>>2)];
 var $126=(($125+40)|0);
 var $127=HEAP32[(($126)>>2)];
 var $128=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$127]($41) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $__a_0=$__a_1;var $_pre_i_i_i18=$41;label=10;break; } else { label=38;break; }
 case 47: 
 var $130=(($120+4)|0);
 HEAP32[(($103)>>2)]=$130;
 var $__a_0=$__a_1;var $_pre_i_i_i18=$41;label=10;break;
 case 48: 
 var $_pre_i4_i_i;
 var $__a_2;
 var $132=$__grouping;
 var $133=HEAP8[($132)];
 var $134=$133&1;
 var $135=(($134<<24)>>24)==0;
 if($135){label=50;break;}else{label=49;break;}
 case 49: 
 var $137=(($__grouping+4)|0);
 var $138=HEAP32[(($137)>>2)];
 var $142=$138;label=51;break;
 case 50: 
 var $140=($133&255);
 var $141=$140>>>1;
 var $142=$141;label=51;break;
 case 51: 
 var $142;
 var $143=($142|0)==0;
 if($143){label=54;break;}else{label=52;break;}
 case 52: 
 var $145=HEAP32[(($__g_end)>>2)];
 var $146=$145;
 var $147=$__g;
 var $148=((($146)-($147))|0);
 var $149=($148|0)<160;
 if($149){label=53;break;}else{label=54;break;}
 case 53: 
 var $151=HEAP32[(($__dc)>>2)];
 var $152=(($145+4)|0);
 HEAP32[(($__g_end)>>2)]=$152;
 HEAP32[(($145)>>2)]=$151;
 label=54;break;
 case 54: 
 var $153=HEAP32[(($__a_end)>>2)];
 var $154=(function() { try { __THREW__ = 0; return __ZNSt3__127__num_get_unsigned_integralImEET_PKcS3_Rji($__a_2,$153,$__err,$_0_i) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=55;break; } else { label=39;break; }
 case 55: 
 HEAP32[(($__v)>>2)]=$154;
 var $156=HEAP32[(($__g_end)>>2)];
 __ZNSt3__116__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj($__grouping,$18,$156,$__err);
 var $157=($41|0)==0;
 if($157){var $175=1;var $174=0;label=61;break;}else{label=56;break;}
 case 56: 
 var $159=(($41+12)|0);
 var $160=HEAP32[(($159)>>2)];
 var $161=(($41+16)|0);
 var $162=HEAP32[(($161)>>2)];
 var $163=($160|0)==($162|0);
 if($163){label=57;break;}else{label=58;break;}
 case 57: 
 var $165=$41;
 var $166=HEAP32[(($165)>>2)];
 var $167=(($166+36)|0);
 var $168=HEAP32[(($167)>>2)];
 var $169=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$168]($41) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $_0_i_i_i_i=$169;label=59;break; } else { label=39;break; }
 case 58: 
 var $171=HEAP32[(($160)>>2)];
 var $_0_i_i_i_i=$171;label=59;break;
 case 59: 
 var $_0_i_i_i_i;
 var $172=($_0_i_i_i_i|0)==-1;
 if($172){label=60;break;}else{var $175=0;var $174=$41;label=61;break;}
 case 60: 
 HEAP32[(($19)>>2)]=0;
 var $175=1;var $174=0;label=61;break;
 case 61: 
 var $174;
 var $175;
 var $176=($_pre_i4_i_i|0)==0;
 if($176){label=67;break;}else{label=62;break;}
 case 62: 
 var $178=(($_pre_i4_i_i+12)|0);
 var $179=HEAP32[(($178)>>2)];
 var $180=(($_pre_i4_i_i+16)|0);
 var $181=HEAP32[(($180)>>2)];
 var $182=($179|0)==($181|0);
 if($182){label=63;break;}else{label=64;break;}
 case 63: 
 var $184=$_pre_i4_i_i;
 var $185=HEAP32[(($184)>>2)];
 var $186=(($185+36)|0);
 var $187=HEAP32[(($186)>>2)];
 var $188=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$187]($_pre_i4_i_i) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $_0_i_i2_i_i=$188;label=65;break; } else { label=39;break; }
 case 64: 
 var $190=HEAP32[(($179)>>2)];
 var $_0_i_i2_i_i=$190;label=65;break;
 case 65: 
 var $_0_i_i2_i_i;
 var $191=($_0_i_i2_i_i|0)==-1;
 if($191){label=66;break;}else{label=68;break;}
 case 66: 
 HEAP32[(($20)>>2)]=0;
 label=67;break;
 case 67: 
 if($175){label=69;break;}else{label=70;break;}
 case 68: 
 if($175){label=70;break;}else{label=69;break;}
 case 69: 
 var $194=HEAP32[(($__err)>>2)];
 var $195=$194|2;
 HEAP32[(($__err)>>2)]=$195;
 label=70;break;
 case 70: 
 var $197=(($agg_result)|0);
 HEAP32[(($197)>>2)]=$174;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__buf);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grouping);
 STACKTOP=sp;return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRy($agg_result,$this,$__b,$__e,$__iob,$__err,$__v){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+16)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var tempParam = $__b; $__b=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__b)>>2)]=HEAP32[((tempParam)>>2)];
 var tempParam = $__e; $__e=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];

 var $1=sp;
 var $2=(sp)+(8);
 var $3=(($__b)|0);
 var $4=HEAP32[(($3)>>2)];
 var $5=(($1)|0);
 HEAP32[(($5)>>2)]=$4;
 var $6=(($__e)|0);
 var $7=HEAP32[(($6)>>2)];
 var $8=(($2)|0);
 HEAP32[(($8)>>2)]=$7;
 __ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE17__do_get_unsignedIyEES4_S4_S4_RNS_8ios_baseERjRT_($agg_result,0,$1,$2,$__iob,$__err,$__v);
 STACKTOP=sp;return;
}


function __ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE17__do_get_unsignedIyEES4_S4_S4_RNS_8ios_baseERjRT_($agg_result,$this,$__b,$__e,$__iob,$__err,$__v){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+328)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var tempParam = $__b; $__b=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__b)>>2)]=HEAP32[((tempParam)>>2)];
 var tempParam = $__e; $__e=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $__atoms=sp;
 var $__thousands_sep=(sp)+(104);
 var $__grouping=(sp)+(112);
 var $__buf=(sp)+(128);
 var $__a_end=(sp)+(144);
 var $__g=(sp)+(152);
 var $__g_end=(sp)+(312);
 var $__dc=(sp)+(320);
 var $1=(($__iob+4)|0);
 var $2=HEAP32[(($1)>>2)];
 var $3=$2&74;
 if(($3|0)==8){ label=2;break;}else if(($3|0)==0){ label=3;break;}else if(($3|0)==64){ var $_0_i=8;label=5;break;}else{label=4;break;}
 case 2: 
 var $_0_i=16;label=5;break;
 case 3: 
 var $_0_i=0;label=5;break;
 case 4: 
 var $_0_i=10;label=5;break;
 case 5: 
 var $_0_i;
 var $7=(($__atoms)|0);
 __ZNSt3__19__num_getIwE17__stage2_int_prepERNS_8ios_baseEPwRw($__grouping,$__iob,$7,$__thousands_sep);
 var $this4_i_i_i=$__buf;
 HEAP32[(($this4_i_i_i)>>2)]=0; HEAP32[((($this4_i_i_i)+(4))>>2)]=0; HEAP32[((($this4_i_i_i)+(8))>>2)]=0;
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc($__buf,10,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=6;break; } else { label=39;break; }
 case 6: 
 var $8=HEAP8[($this4_i_i_i)];
 var $9=$8&1;
 var $10=(($9<<24)>>24)==0;
 if($10){label=8;break;}else{label=7;break;}
 case 7: 
 var $12=(($__buf+8)|0);
 var $13=HEAP32[(($12)>>2)];
 var $_pre45=$__buf;
 var $_pre46=(($_pre45+1)|0);
 var $17=$13;var $_pre_phi47=$_pre46;var $_pre_phi49=$12;label=9;break;
 case 8: 
 var $15=$__buf;
 var $16=(($15+1)|0);
 var $_pre48=(($__buf+8)|0);
 var $17=$16;var $_pre_phi47=$16;var $_pre_phi49=$_pre48;label=9;break;
 case 9: 
 var $_pre_phi49;
 var $_pre_phi47;
 var $17;
 HEAP32[(($__a_end)>>2)]=$17;
 var $18=(($__g)|0);
 HEAP32[(($__g_end)>>2)]=$18;
 HEAP32[(($__dc)>>2)]=0;
 var $19=(($__b)|0);
 var $20=(($__e)|0);
 var $21=(($__buf)|0);
 var $22=(($__buf+4)|0);
 var $23=HEAP32[(($__thousands_sep)>>2)];
 var $_pre=HEAP32[(($19)>>2)];
 var $__a_0=$17;var $_pre_i_i_i18=$_pre;label=10;break;
 case 10: 
 var $_pre_i_i_i18;
 var $__a_0;
 var $24=($_pre_i_i_i18|0)==0;
 if($24){var $42=1;var $41=0;label=16;break;}else{label=11;break;}
 case 11: 
 var $26=(($_pre_i_i_i18+12)|0);
 var $27=HEAP32[(($26)>>2)];
 var $28=(($_pre_i_i_i18+16)|0);
 var $29=HEAP32[(($28)>>2)];
 var $30=($27|0)==($29|0);
 if($30){label=12;break;}else{label=13;break;}
 case 12: 
 var $32=$_pre_i_i_i18;
 var $33=HEAP32[(($32)>>2)];
 var $34=(($33+36)|0);
 var $35=HEAP32[(($34)>>2)];
 var $36=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$35]($_pre_i_i_i18) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $_0_i_i_i_i16=$36;label=14;break; } else { label=38;break; }
 case 13: 
 var $38=HEAP32[(($27)>>2)];
 var $_0_i_i_i_i16=$38;label=14;break;
 case 14: 
 var $_0_i_i_i_i16;
 var $39=($_0_i_i_i_i16|0)==-1;
 if($39){label=15;break;}else{var $42=0;var $41=$_pre_i_i_i18;label=16;break;}
 case 15: 
 HEAP32[(($19)>>2)]=0;
 var $42=1;var $41=0;label=16;break;
 case 16: 
 var $41;
 var $42;
 var $43=HEAP32[(($20)>>2)];
 var $44=($43|0)==0;
 if($44){label=22;break;}else{label=17;break;}
 case 17: 
 var $46=(($43+12)|0);
 var $47=HEAP32[(($46)>>2)];
 var $48=(($43+16)|0);
 var $49=HEAP32[(($48)>>2)];
 var $50=($47|0)==($49|0);
 if($50){label=18;break;}else{label=19;break;}
 case 18: 
 var $52=$43;
 var $53=HEAP32[(($52)>>2)];
 var $54=(($53+36)|0);
 var $55=HEAP32[(($54)>>2)];
 var $56=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$55]($43) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $_0_i_i2_i_i22=$56;label=20;break; } else { label=38;break; }
 case 19: 
 var $58=HEAP32[(($47)>>2)];
 var $_0_i_i2_i_i22=$58;label=20;break;
 case 20: 
 var $_0_i_i2_i_i22;
 var $59=($_0_i_i2_i_i22|0)==-1;
 if($59){label=21;break;}else{label=23;break;}
 case 21: 
 HEAP32[(($20)>>2)]=0;
 label=22;break;
 case 22: 
 if($42){var $__a_2=$__a_0;var $_pre_i4_i_i=0;label=48;break;}else{var $62=0;label=24;break;}
 case 23: 
 if($42){var $62=$43;label=24;break;}else{var $__a_2=$__a_0;var $_pre_i4_i_i=$43;label=48;break;}
 case 24: 
 var $62;
 var $63=HEAP32[(($__a_end)>>2)];
 var $64=$63;
 var $65=$__a_0;
 var $66=((($64)-($65))|0);
 var $67=HEAP8[($this4_i_i_i)];
 var $68=$67&1;
 var $69=(($68<<24)>>24)==0;
 if($69){label=26;break;}else{label=25;break;}
 case 25: 
 var $71=HEAP32[(($22)>>2)];
 var $75=$71;label=27;break;
 case 26: 
 var $73=($67&255);
 var $74=$73>>>1;
 var $75=$74;label=27;break;
 case 27: 
 var $75;
 var $76=($66|0)==($75|0);
 if($76){label=28;break;}else{var $__a_1=$__a_0;label=41;break;}
 case 28: 
 if($69){label=30;break;}else{label=29;break;}
 case 29: 
 var $79=HEAP32[(($22)>>2)];
 var $86=$79;var $85=$79;label=31;break;
 case 30: 
 var $81=($67&255);
 var $82=$81>>>1;
 var $83=($67&255);
 var $84=$83>>>1;
 var $86=$84;var $85=$82;label=31;break;
 case 31: 
 var $85;
 var $86;
 var $87=$86<<1;
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc($__buf,$87,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=32;break; } else { label=38;break; }
 case 32: 
 var $88=HEAP8[($this4_i_i_i)];
 var $89=$88&1;
 var $90=(($89<<24)>>24)==0;
 if($90){var $94=10;label=34;break;}else{label=33;break;}
 case 33: 
 var $92=HEAP32[(($21)>>2)];
 var $93=$92&-2;
 var $phitmp_i36=((($93)-(1))|0);
 var $94=$phitmp_i36;label=34;break;
 case 34: 
 var $94;
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc($__buf,$94,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=35;break; } else { label=38;break; }
 case 35: 
 var $95=HEAP8[($this4_i_i_i)];
 var $96=$95&1;
 var $97=(($96<<24)>>24)==0;
 if($97){var $100=$_pre_phi47;label=37;break;}else{label=36;break;}
 case 36: 
 var $99=HEAP32[(($_pre_phi49)>>2)];
 var $100=$99;label=37;break;
 case 37: 
 var $100;
 var $101=(($100+$85)|0);
 HEAP32[(($__a_end)>>2)]=$101;
 var $__a_1=$100;label=41;break;
 case 38: 
 var $lpad_loopexit$0 = ___cxa_find_matching_catch(-1, -1); var $lpad_loopexit$1 = tempRet0;
 var $lpad_phi$1=$lpad_loopexit$1;var $lpad_phi$0=$lpad_loopexit$0;label=40;break;
 case 39: 
 var $lpad_nonloopexit$0 = ___cxa_find_matching_catch(-1, -1); var $lpad_nonloopexit$1 = tempRet0;
 var $lpad_phi$1=$lpad_nonloopexit$1;var $lpad_phi$0=$lpad_nonloopexit$0;label=40;break;
 case 40: 
 var $lpad_phi$0;
 var $lpad_phi$1;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__buf);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grouping);
 ___resumeException($lpad_phi$0)
 case 41: 
 var $__a_1;
 var $103=(($41+12)|0);
 var $104=HEAP32[(($103)>>2)];
 var $105=(($41+16)|0);
 var $106=HEAP32[(($105)>>2)];
 var $107=($104|0)==($106|0);
 if($107){label=42;break;}else{label=43;break;}
 case 42: 
 var $109=$41;
 var $110=HEAP32[(($109)>>2)];
 var $111=(($110+36)|0);
 var $112=HEAP32[(($111)>>2)];
 var $113=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$112]($41) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $_0_i_i=$113;label=44;break; } else { label=38;break; }
 case 43: 
 var $115=HEAP32[(($104)>>2)];
 var $_0_i_i=$115;label=44;break;
 case 44: 
 var $_0_i_i;
 var $117=__ZNSt3__19__num_getIwE17__stage2_int_loopEwiPcRS2_RjwRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSD_Pw($_0_i_i,$_0_i,$__a_1,$__a_end,$__dc,$23,$__grouping,$18,$__g_end,$7);
 var $118=($117|0)==0;
 if($118){label=45;break;}else{var $__a_2=$__a_1;var $_pre_i4_i_i=$62;label=48;break;}
 case 45: 
 var $120=HEAP32[(($103)>>2)];
 var $121=HEAP32[(($105)>>2)];
 var $122=($120|0)==($121|0);
 if($122){label=46;break;}else{label=47;break;}
 case 46: 
 var $124=$41;
 var $125=HEAP32[(($124)>>2)];
 var $126=(($125+40)|0);
 var $127=HEAP32[(($126)>>2)];
 var $128=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$127]($41) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $__a_0=$__a_1;var $_pre_i_i_i18=$41;label=10;break; } else { label=38;break; }
 case 47: 
 var $130=(($120+4)|0);
 HEAP32[(($103)>>2)]=$130;
 var $__a_0=$__a_1;var $_pre_i_i_i18=$41;label=10;break;
 case 48: 
 var $_pre_i4_i_i;
 var $__a_2;
 var $132=$__grouping;
 var $133=HEAP8[($132)];
 var $134=$133&1;
 var $135=(($134<<24)>>24)==0;
 if($135){label=50;break;}else{label=49;break;}
 case 49: 
 var $137=(($__grouping+4)|0);
 var $138=HEAP32[(($137)>>2)];
 var $142=$138;label=51;break;
 case 50: 
 var $140=($133&255);
 var $141=$140>>>1;
 var $142=$141;label=51;break;
 case 51: 
 var $142;
 var $143=($142|0)==0;
 if($143){label=54;break;}else{label=52;break;}
 case 52: 
 var $145=HEAP32[(($__g_end)>>2)];
 var $146=$145;
 var $147=$__g;
 var $148=((($146)-($147))|0);
 var $149=($148|0)<160;
 if($149){label=53;break;}else{label=54;break;}
 case 53: 
 var $151=HEAP32[(($__dc)>>2)];
 var $152=(($145+4)|0);
 HEAP32[(($__g_end)>>2)]=$152;
 HEAP32[(($145)>>2)]=$151;
 label=54;break;
 case 54: 
 var $153=HEAP32[(($__a_end)>>2)];
 var $154$r=(function() { try { __THREW__ = 0; return __ZNSt3__127__num_get_unsigned_integralIyEET_PKcS3_Rji($__a_2,$153,$__err,$_0_i) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();var $154$0=$154$r;var $154$1=tempRet0;if (!__THREW__) { label=55;break; } else { label=39;break; }
 case 55: 
 var $st$0$0=(($__v)|0);
 HEAP32[(($st$0$0)>>2)]=$154$0;
 var $st$1$1=(($__v+4)|0);
 HEAP32[(($st$1$1)>>2)]=$154$1;
 var $156=HEAP32[(($__g_end)>>2)];
 __ZNSt3__116__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj($__grouping,$18,$156,$__err);
 var $157=($41|0)==0;
 if($157){var $175=1;var $174=0;label=61;break;}else{label=56;break;}
 case 56: 
 var $159=(($41+12)|0);
 var $160=HEAP32[(($159)>>2)];
 var $161=(($41+16)|0);
 var $162=HEAP32[(($161)>>2)];
 var $163=($160|0)==($162|0);
 if($163){label=57;break;}else{label=58;break;}
 case 57: 
 var $165=$41;
 var $166=HEAP32[(($165)>>2)];
 var $167=(($166+36)|0);
 var $168=HEAP32[(($167)>>2)];
 var $169=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$168]($41) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $_0_i_i_i_i=$169;label=59;break; } else { label=39;break; }
 case 58: 
 var $171=HEAP32[(($160)>>2)];
 var $_0_i_i_i_i=$171;label=59;break;
 case 59: 
 var $_0_i_i_i_i;
 var $172=($_0_i_i_i_i|0)==-1;
 if($172){label=60;break;}else{var $175=0;var $174=$41;label=61;break;}
 case 60: 
 HEAP32[(($19)>>2)]=0;
 var $175=1;var $174=0;label=61;break;
 case 61: 
 var $174;
 var $175;
 var $176=($_pre_i4_i_i|0)==0;
 if($176){label=67;break;}else{label=62;break;}
 case 62: 
 var $178=(($_pre_i4_i_i+12)|0);
 var $179=HEAP32[(($178)>>2)];
 var $180=(($_pre_i4_i_i+16)|0);
 var $181=HEAP32[(($180)>>2)];
 var $182=($179|0)==($181|0);
 if($182){label=63;break;}else{label=64;break;}
 case 63: 
 var $184=$_pre_i4_i_i;
 var $185=HEAP32[(($184)>>2)];
 var $186=(($185+36)|0);
 var $187=HEAP32[(($186)>>2)];
 var $188=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$187]($_pre_i4_i_i) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $_0_i_i2_i_i=$188;label=65;break; } else { label=39;break; }
 case 64: 
 var $190=HEAP32[(($179)>>2)];
 var $_0_i_i2_i_i=$190;label=65;break;
 case 65: 
 var $_0_i_i2_i_i;
 var $191=($_0_i_i2_i_i|0)==-1;
 if($191){label=66;break;}else{label=68;break;}
 case 66: 
 HEAP32[(($20)>>2)]=0;
 label=67;break;
 case 67: 
 if($175){label=69;break;}else{label=70;break;}
 case 68: 
 if($175){label=70;break;}else{label=69;break;}
 case 69: 
 var $194=HEAP32[(($__err)>>2)];
 var $195=$194|2;
 HEAP32[(($__err)>>2)]=$195;
 label=70;break;
 case 70: 
 var $197=(($agg_result)|0);
 HEAP32[(($197)>>2)]=$174;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__buf);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grouping);
 STACKTOP=sp;return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRf($agg_result,$this,$__b,$__e,$__iob,$__err,$__v){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+16)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var tempParam = $__b; $__b=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__b)>>2)]=HEAP32[((tempParam)>>2)];
 var tempParam = $__e; $__e=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];

 var $1=sp;
 var $2=(sp)+(8);
 var $3=(($__b)|0);
 var $4=HEAP32[(($3)>>2)];
 var $5=(($1)|0);
 HEAP32[(($5)>>2)]=$4;
 var $6=(($__e)|0);
 var $7=HEAP32[(($6)>>2)];
 var $8=(($2)|0);
 HEAP32[(($8)>>2)]=$7;
 __ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE23__do_get_floating_pointIfEES4_S4_S4_RNS_8ios_baseERjRT_($agg_result,0,$1,$2,$__iob,$__err,$__v);
 STACKTOP=sp;return;
}


function __ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE23__do_get_floating_pointIfEES4_S4_S4_RNS_8ios_baseERjRT_($agg_result,$this,$__b,$__e,$__iob,$__err,$__v){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+376)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var tempParam = $__b; $__b=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__b)>>2)]=HEAP32[((tempParam)>>2)];
 var tempParam = $__e; $__e=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $__atoms=sp;
 var $__decimal_point=(sp)+(128);
 var $__thousands_sep=(sp)+(136);
 var $__grouping=(sp)+(144);
 var $__buf=(sp)+(160);
 var $__a_end=(sp)+(176);
 var $__g=(sp)+(184);
 var $__g_end=(sp)+(344);
 var $__dc=(sp)+(352);
 var $__in_units=(sp)+(360);
 var $__exp=(sp)+(368);
 var $0=(($__atoms)|0);
 __ZNSt3__19__num_getIwE19__stage2_float_prepERNS_8ios_baseEPwRwS5_($__grouping,$__iob,$0,$__decimal_point,$__thousands_sep);
 var $this4_i_i_i=$__buf;
 HEAP32[(($this4_i_i_i)>>2)]=0; HEAP32[((($this4_i_i_i)+(4))>>2)]=0; HEAP32[((($this4_i_i_i)+(8))>>2)]=0;
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc($__buf,10,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=2;break; } else { label=35;break; }
 case 2: 
 var $1=HEAP8[($this4_i_i_i)];
 var $2=$1&1;
 var $3=(($2<<24)>>24)==0;
 if($3){label=4;break;}else{label=3;break;}
 case 3: 
 var $5=(($__buf+8)|0);
 var $6=HEAP32[(($5)>>2)];
 var $_pre44=$__buf;
 var $_pre45=(($_pre44+1)|0);
 var $10=$6;var $_pre_phi46=$_pre45;var $_pre_phi48=$5;label=5;break;
 case 4: 
 var $8=$__buf;
 var $9=(($8+1)|0);
 var $_pre47=(($__buf+8)|0);
 var $10=$9;var $_pre_phi46=$9;var $_pre_phi48=$_pre47;label=5;break;
 case 5: 
 var $_pre_phi48;
 var $_pre_phi46;
 var $10;
 HEAP32[(($__a_end)>>2)]=$10;
 var $11=(($__g)|0);
 HEAP32[(($__g_end)>>2)]=$11;
 HEAP32[(($__dc)>>2)]=0;
 HEAP8[($__in_units)]=1;
 HEAP8[($__exp)]=69;
 var $12=(($__b)|0);
 var $13=(($__e)|0);
 var $14=(($__buf)|0);
 var $15=(($__buf+4)|0);
 var $16=HEAP32[(($__decimal_point)>>2)];
 var $17=HEAP32[(($__thousands_sep)>>2)];
 var $_pre=HEAP32[(($12)>>2)];
 var $__a_0=$10;var $_pre_i_i_i16=$_pre;label=6;break;
 case 6: 
 var $_pre_i_i_i16;
 var $__a_0;
 var $18=($_pre_i_i_i16|0)==0;
 if($18){var $36=1;var $35=0;label=12;break;}else{label=7;break;}
 case 7: 
 var $20=(($_pre_i_i_i16+12)|0);
 var $21=HEAP32[(($20)>>2)];
 var $22=(($_pre_i_i_i16+16)|0);
 var $23=HEAP32[(($22)>>2)];
 var $24=($21|0)==($23|0);
 if($24){label=8;break;}else{label=9;break;}
 case 8: 
 var $26=$_pre_i_i_i16;
 var $27=HEAP32[(($26)>>2)];
 var $28=(($27+36)|0);
 var $29=HEAP32[(($28)>>2)];
 var $30=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$29]($_pre_i_i_i16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $_0_i_i_i_i14=$30;label=10;break; } else { label=34;break; }
 case 9: 
 var $32=HEAP32[(($21)>>2)];
 var $_0_i_i_i_i14=$32;label=10;break;
 case 10: 
 var $_0_i_i_i_i14;
 var $33=($_0_i_i_i_i14|0)==-1;
 if($33){label=11;break;}else{var $36=0;var $35=$_pre_i_i_i16;label=12;break;}
 case 11: 
 HEAP32[(($12)>>2)]=0;
 var $36=1;var $35=0;label=12;break;
 case 12: 
 var $35;
 var $36;
 var $37=HEAP32[(($13)>>2)];
 var $38=($37|0)==0;
 if($38){label=18;break;}else{label=13;break;}
 case 13: 
 var $40=(($37+12)|0);
 var $41=HEAP32[(($40)>>2)];
 var $42=(($37+16)|0);
 var $43=HEAP32[(($42)>>2)];
 var $44=($41|0)==($43|0);
 if($44){label=14;break;}else{label=15;break;}
 case 14: 
 var $46=$37;
 var $47=HEAP32[(($46)>>2)];
 var $48=(($47+36)|0);
 var $49=HEAP32[(($48)>>2)];
 var $50=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$49]($37) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $_0_i_i2_i_i20=$50;label=16;break; } else { label=34;break; }
 case 15: 
 var $52=HEAP32[(($41)>>2)];
 var $_0_i_i2_i_i20=$52;label=16;break;
 case 16: 
 var $_0_i_i2_i_i20;
 var $53=($_0_i_i2_i_i20|0)==-1;
 if($53){label=17;break;}else{label=19;break;}
 case 17: 
 HEAP32[(($13)>>2)]=0;
 label=18;break;
 case 18: 
 if($36){var $__a_2=$__a_0;var $_pre_i4_i_i=0;label=44;break;}else{var $56=0;label=20;break;}
 case 19: 
 if($36){var $56=$37;label=20;break;}else{var $__a_2=$__a_0;var $_pre_i4_i_i=$37;label=44;break;}
 case 20: 
 var $56;
 var $57=HEAP32[(($__a_end)>>2)];
 var $58=$57;
 var $59=$__a_0;
 var $60=((($58)-($59))|0);
 var $61=HEAP8[($this4_i_i_i)];
 var $62=$61&1;
 var $63=(($62<<24)>>24)==0;
 if($63){label=22;break;}else{label=21;break;}
 case 21: 
 var $65=HEAP32[(($15)>>2)];
 var $69=$65;label=23;break;
 case 22: 
 var $67=($61&255);
 var $68=$67>>>1;
 var $69=$68;label=23;break;
 case 23: 
 var $69;
 var $70=($60|0)==($69|0);
 if($70){label=24;break;}else{var $__a_1=$__a_0;label=37;break;}
 case 24: 
 if($63){label=26;break;}else{label=25;break;}
 case 25: 
 var $73=HEAP32[(($15)>>2)];
 var $80=$73;var $79=$73;label=27;break;
 case 26: 
 var $75=($61&255);
 var $76=$75>>>1;
 var $77=($61&255);
 var $78=$77>>>1;
 var $80=$78;var $79=$76;label=27;break;
 case 27: 
 var $79;
 var $80;
 var $81=$80<<1;
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc($__buf,$81,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=28;break; } else { label=34;break; }
 case 28: 
 var $82=HEAP8[($this4_i_i_i)];
 var $83=$82&1;
 var $84=(($83<<24)>>24)==0;
 if($84){var $88=10;label=30;break;}else{label=29;break;}
 case 29: 
 var $86=HEAP32[(($14)>>2)];
 var $87=$86&-2;
 var $phitmp_i34=((($87)-(1))|0);
 var $88=$phitmp_i34;label=30;break;
 case 30: 
 var $88;
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc($__buf,$88,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=31;break; } else { label=34;break; }
 case 31: 
 var $89=HEAP8[($this4_i_i_i)];
 var $90=$89&1;
 var $91=(($90<<24)>>24)==0;
 if($91){var $94=$_pre_phi46;label=33;break;}else{label=32;break;}
 case 32: 
 var $93=HEAP32[(($_pre_phi48)>>2)];
 var $94=$93;label=33;break;
 case 33: 
 var $94;
 var $95=(($94+$79)|0);
 HEAP32[(($__a_end)>>2)]=$95;
 var $__a_1=$94;label=37;break;
 case 34: 
 var $lpad_loopexit$0 = ___cxa_find_matching_catch(-1, -1); var $lpad_loopexit$1 = tempRet0;
 var $lpad_phi$1=$lpad_loopexit$1;var $lpad_phi$0=$lpad_loopexit$0;label=36;break;
 case 35: 
 var $lpad_nonloopexit$0 = ___cxa_find_matching_catch(-1, -1); var $lpad_nonloopexit$1 = tempRet0;
 var $lpad_phi$1=$lpad_nonloopexit$1;var $lpad_phi$0=$lpad_nonloopexit$0;label=36;break;
 case 36: 
 var $lpad_phi$0;
 var $lpad_phi$1;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__buf);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grouping);
 ___resumeException($lpad_phi$0)
 case 37: 
 var $__a_1;
 var $97=(($35+12)|0);
 var $98=HEAP32[(($97)>>2)];
 var $99=(($35+16)|0);
 var $100=HEAP32[(($99)>>2)];
 var $101=($98|0)==($100|0);
 if($101){label=38;break;}else{label=39;break;}
 case 38: 
 var $103=$35;
 var $104=HEAP32[(($103)>>2)];
 var $105=(($104+36)|0);
 var $106=HEAP32[(($105)>>2)];
 var $107=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$106]($35) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $_0_i_i=$107;label=40;break; } else { label=34;break; }
 case 39: 
 var $109=HEAP32[(($98)>>2)];
 var $_0_i_i=$109;label=40;break;
 case 40: 
 var $_0_i_i;
 var $111=__ZNSt3__19__num_getIwE19__stage2_float_loopEwRbRcPcRS4_wwRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSE_RjPw($_0_i_i,$__in_units,$__exp,$__a_1,$__a_end,$16,$17,$__grouping,$11,$__g_end,$__dc,$0);
 var $112=($111|0)==0;
 if($112){label=41;break;}else{var $__a_2=$__a_1;var $_pre_i4_i_i=$56;label=44;break;}
 case 41: 
 var $114=HEAP32[(($97)>>2)];
 var $115=HEAP32[(($99)>>2)];
 var $116=($114|0)==($115|0);
 if($116){label=42;break;}else{label=43;break;}
 case 42: 
 var $118=$35;
 var $119=HEAP32[(($118)>>2)];
 var $120=(($119+40)|0);
 var $121=HEAP32[(($120)>>2)];
 var $122=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$121]($35) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $__a_0=$__a_1;var $_pre_i_i_i16=$35;label=6;break; } else { label=34;break; }
 case 43: 
 var $124=(($114+4)|0);
 HEAP32[(($97)>>2)]=$124;
 var $__a_0=$__a_1;var $_pre_i_i_i16=$35;label=6;break;
 case 44: 
 var $_pre_i4_i_i;
 var $__a_2;
 var $126=$__grouping;
 var $127=HEAP8[($126)];
 var $128=$127&1;
 var $129=(($128<<24)>>24)==0;
 if($129){label=46;break;}else{label=45;break;}
 case 45: 
 var $131=(($__grouping+4)|0);
 var $132=HEAP32[(($131)>>2)];
 var $136=$132;label=47;break;
 case 46: 
 var $134=($127&255);
 var $135=$134>>>1;
 var $136=$135;label=47;break;
 case 47: 
 var $136;
 var $137=($136|0)==0;
 if($137){label=51;break;}else{label=48;break;}
 case 48: 
 var $139=HEAP8[($__in_units)];
 var $140=(($139<<24)>>24)==0;
 if($140){label=51;break;}else{label=49;break;}
 case 49: 
 var $142=HEAP32[(($__g_end)>>2)];
 var $143=$142;
 var $144=$__g;
 var $145=((($143)-($144))|0);
 var $146=($145|0)<160;
 if($146){label=50;break;}else{label=51;break;}
 case 50: 
 var $148=HEAP32[(($__dc)>>2)];
 var $149=(($142+4)|0);
 HEAP32[(($__g_end)>>2)]=$149;
 HEAP32[(($142)>>2)]=$148;
 label=51;break;
 case 51: 
 var $150=HEAP32[(($__a_end)>>2)];
 var $151=(function() { try { __THREW__ = 0; return __ZNSt3__115__num_get_floatIfEET_PKcS3_Rj($__a_2,$150,$__err) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=52;break; } else { label=35;break; }
 case 52: 
 HEAPF32[(($__v)>>2)]=$151;
 var $153=HEAP32[(($__g_end)>>2)];
 __ZNSt3__116__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj($__grouping,$11,$153,$__err);
 var $154=($35|0)==0;
 if($154){var $172=1;var $171=0;label=58;break;}else{label=53;break;}
 case 53: 
 var $156=(($35+12)|0);
 var $157=HEAP32[(($156)>>2)];
 var $158=(($35+16)|0);
 var $159=HEAP32[(($158)>>2)];
 var $160=($157|0)==($159|0);
 if($160){label=54;break;}else{label=55;break;}
 case 54: 
 var $162=$35;
 var $163=HEAP32[(($162)>>2)];
 var $164=(($163+36)|0);
 var $165=HEAP32[(($164)>>2)];
 var $166=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$165]($35) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $_0_i_i_i_i=$166;label=56;break; } else { label=35;break; }
 case 55: 
 var $168=HEAP32[(($157)>>2)];
 var $_0_i_i_i_i=$168;label=56;break;
 case 56: 
 var $_0_i_i_i_i;
 var $169=($_0_i_i_i_i|0)==-1;
 if($169){label=57;break;}else{var $172=0;var $171=$35;label=58;break;}
 case 57: 
 HEAP32[(($12)>>2)]=0;
 var $172=1;var $171=0;label=58;break;
 case 58: 
 var $171;
 var $172;
 var $173=($_pre_i4_i_i|0)==0;
 if($173){label=64;break;}else{label=59;break;}
 case 59: 
 var $175=(($_pre_i4_i_i+12)|0);
 var $176=HEAP32[(($175)>>2)];
 var $177=(($_pre_i4_i_i+16)|0);
 var $178=HEAP32[(($177)>>2)];
 var $179=($176|0)==($178|0);
 if($179){label=60;break;}else{label=61;break;}
 case 60: 
 var $181=$_pre_i4_i_i;
 var $182=HEAP32[(($181)>>2)];
 var $183=(($182+36)|0);
 var $184=HEAP32[(($183)>>2)];
 var $185=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$184]($_pre_i4_i_i) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $_0_i_i2_i_i=$185;label=62;break; } else { label=35;break; }
 case 61: 
 var $187=HEAP32[(($176)>>2)];
 var $_0_i_i2_i_i=$187;label=62;break;
 case 62: 
 var $_0_i_i2_i_i;
 var $188=($_0_i_i2_i_i|0)==-1;
 if($188){label=63;break;}else{label=65;break;}
 case 63: 
 HEAP32[(($13)>>2)]=0;
 label=64;break;
 case 64: 
 if($172){label=66;break;}else{label=67;break;}
 case 65: 
 if($172){label=67;break;}else{label=66;break;}
 case 66: 
 var $191=HEAP32[(($__err)>>2)];
 var $192=$191|2;
 HEAP32[(($__err)>>2)]=$192;
 label=67;break;
 case 67: 
 var $194=(($agg_result)|0);
 HEAP32[(($194)>>2)]=$171;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__buf);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grouping);
 STACKTOP=sp;return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRd($agg_result,$this,$__b,$__e,$__iob,$__err,$__v){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+16)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var tempParam = $__b; $__b=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__b)>>2)]=HEAP32[((tempParam)>>2)];
 var tempParam = $__e; $__e=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];

 var $1=sp;
 var $2=(sp)+(8);
 var $3=(($__b)|0);
 var $4=HEAP32[(($3)>>2)];
 var $5=(($1)|0);
 HEAP32[(($5)>>2)]=$4;
 var $6=(($__e)|0);
 var $7=HEAP32[(($6)>>2)];
 var $8=(($2)|0);
 HEAP32[(($8)>>2)]=$7;
 __ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE23__do_get_floating_pointIdEES4_S4_S4_RNS_8ios_baseERjRT_($agg_result,0,$1,$2,$__iob,$__err,$__v);
 STACKTOP=sp;return;
}


function __ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE23__do_get_floating_pointIdEES4_S4_S4_RNS_8ios_baseERjRT_($agg_result,$this,$__b,$__e,$__iob,$__err,$__v){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+376)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var tempParam = $__b; $__b=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__b)>>2)]=HEAP32[((tempParam)>>2)];
 var tempParam = $__e; $__e=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $__atoms=sp;
 var $__decimal_point=(sp)+(128);
 var $__thousands_sep=(sp)+(136);
 var $__grouping=(sp)+(144);
 var $__buf=(sp)+(160);
 var $__a_end=(sp)+(176);
 var $__g=(sp)+(184);
 var $__g_end=(sp)+(344);
 var $__dc=(sp)+(352);
 var $__in_units=(sp)+(360);
 var $__exp=(sp)+(368);
 var $0=(($__atoms)|0);
 __ZNSt3__19__num_getIwE19__stage2_float_prepERNS_8ios_baseEPwRwS5_($__grouping,$__iob,$0,$__decimal_point,$__thousands_sep);
 var $this4_i_i_i=$__buf;
 HEAP32[(($this4_i_i_i)>>2)]=0; HEAP32[((($this4_i_i_i)+(4))>>2)]=0; HEAP32[((($this4_i_i_i)+(8))>>2)]=0;
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc($__buf,10,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=2;break; } else { label=35;break; }
 case 2: 
 var $1=HEAP8[($this4_i_i_i)];
 var $2=$1&1;
 var $3=(($2<<24)>>24)==0;
 if($3){label=4;break;}else{label=3;break;}
 case 3: 
 var $5=(($__buf+8)|0);
 var $6=HEAP32[(($5)>>2)];
 var $_pre44=$__buf;
 var $_pre45=(($_pre44+1)|0);
 var $10=$6;var $_pre_phi46=$_pre45;var $_pre_phi48=$5;label=5;break;
 case 4: 
 var $8=$__buf;
 var $9=(($8+1)|0);
 var $_pre47=(($__buf+8)|0);
 var $10=$9;var $_pre_phi46=$9;var $_pre_phi48=$_pre47;label=5;break;
 case 5: 
 var $_pre_phi48;
 var $_pre_phi46;
 var $10;
 HEAP32[(($__a_end)>>2)]=$10;
 var $11=(($__g)|0);
 HEAP32[(($__g_end)>>2)]=$11;
 HEAP32[(($__dc)>>2)]=0;
 HEAP8[($__in_units)]=1;
 HEAP8[($__exp)]=69;
 var $12=(($__b)|0);
 var $13=(($__e)|0);
 var $14=(($__buf)|0);
 var $15=(($__buf+4)|0);
 var $16=HEAP32[(($__decimal_point)>>2)];
 var $17=HEAP32[(($__thousands_sep)>>2)];
 var $_pre=HEAP32[(($12)>>2)];
 var $__a_0=$10;var $_pre_i_i_i16=$_pre;label=6;break;
 case 6: 
 var $_pre_i_i_i16;
 var $__a_0;
 var $18=($_pre_i_i_i16|0)==0;
 if($18){var $36=1;var $35=0;label=12;break;}else{label=7;break;}
 case 7: 
 var $20=(($_pre_i_i_i16+12)|0);
 var $21=HEAP32[(($20)>>2)];
 var $22=(($_pre_i_i_i16+16)|0);
 var $23=HEAP32[(($22)>>2)];
 var $24=($21|0)==($23|0);
 if($24){label=8;break;}else{label=9;break;}
 case 8: 
 var $26=$_pre_i_i_i16;
 var $27=HEAP32[(($26)>>2)];
 var $28=(($27+36)|0);
 var $29=HEAP32[(($28)>>2)];
 var $30=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$29]($_pre_i_i_i16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $_0_i_i_i_i14=$30;label=10;break; } else { label=34;break; }
 case 9: 
 var $32=HEAP32[(($21)>>2)];
 var $_0_i_i_i_i14=$32;label=10;break;
 case 10: 
 var $_0_i_i_i_i14;
 var $33=($_0_i_i_i_i14|0)==-1;
 if($33){label=11;break;}else{var $36=0;var $35=$_pre_i_i_i16;label=12;break;}
 case 11: 
 HEAP32[(($12)>>2)]=0;
 var $36=1;var $35=0;label=12;break;
 case 12: 
 var $35;
 var $36;
 var $37=HEAP32[(($13)>>2)];
 var $38=($37|0)==0;
 if($38){label=18;break;}else{label=13;break;}
 case 13: 
 var $40=(($37+12)|0);
 var $41=HEAP32[(($40)>>2)];
 var $42=(($37+16)|0);
 var $43=HEAP32[(($42)>>2)];
 var $44=($41|0)==($43|0);
 if($44){label=14;break;}else{label=15;break;}
 case 14: 
 var $46=$37;
 var $47=HEAP32[(($46)>>2)];
 var $48=(($47+36)|0);
 var $49=HEAP32[(($48)>>2)];
 var $50=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$49]($37) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $_0_i_i2_i_i20=$50;label=16;break; } else { label=34;break; }
 case 15: 
 var $52=HEAP32[(($41)>>2)];
 var $_0_i_i2_i_i20=$52;label=16;break;
 case 16: 
 var $_0_i_i2_i_i20;
 var $53=($_0_i_i2_i_i20|0)==-1;
 if($53){label=17;break;}else{label=19;break;}
 case 17: 
 HEAP32[(($13)>>2)]=0;
 label=18;break;
 case 18: 
 if($36){var $__a_2=$__a_0;var $_pre_i4_i_i=0;label=44;break;}else{var $56=0;label=20;break;}
 case 19: 
 if($36){var $56=$37;label=20;break;}else{var $__a_2=$__a_0;var $_pre_i4_i_i=$37;label=44;break;}
 case 20: 
 var $56;
 var $57=HEAP32[(($__a_end)>>2)];
 var $58=$57;
 var $59=$__a_0;
 var $60=((($58)-($59))|0);
 var $61=HEAP8[($this4_i_i_i)];
 var $62=$61&1;
 var $63=(($62<<24)>>24)==0;
 if($63){label=22;break;}else{label=21;break;}
 case 21: 
 var $65=HEAP32[(($15)>>2)];
 var $69=$65;label=23;break;
 case 22: 
 var $67=($61&255);
 var $68=$67>>>1;
 var $69=$68;label=23;break;
 case 23: 
 var $69;
 var $70=($60|0)==($69|0);
 if($70){label=24;break;}else{var $__a_1=$__a_0;label=37;break;}
 case 24: 
 if($63){label=26;break;}else{label=25;break;}
 case 25: 
 var $73=HEAP32[(($15)>>2)];
 var $80=$73;var $79=$73;label=27;break;
 case 26: 
 var $75=($61&255);
 var $76=$75>>>1;
 var $77=($61&255);
 var $78=$77>>>1;
 var $80=$78;var $79=$76;label=27;break;
 case 27: 
 var $79;
 var $80;
 var $81=$80<<1;
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc($__buf,$81,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=28;break; } else { label=34;break; }
 case 28: 
 var $82=HEAP8[($this4_i_i_i)];
 var $83=$82&1;
 var $84=(($83<<24)>>24)==0;
 if($84){var $88=10;label=30;break;}else{label=29;break;}
 case 29: 
 var $86=HEAP32[(($14)>>2)];
 var $87=$86&-2;
 var $phitmp_i34=((($87)-(1))|0);
 var $88=$phitmp_i34;label=30;break;
 case 30: 
 var $88;
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc($__buf,$88,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=31;break; } else { label=34;break; }
 case 31: 
 var $89=HEAP8[($this4_i_i_i)];
 var $90=$89&1;
 var $91=(($90<<24)>>24)==0;
 if($91){var $94=$_pre_phi46;label=33;break;}else{label=32;break;}
 case 32: 
 var $93=HEAP32[(($_pre_phi48)>>2)];
 var $94=$93;label=33;break;
 case 33: 
 var $94;
 var $95=(($94+$79)|0);
 HEAP32[(($__a_end)>>2)]=$95;
 var $__a_1=$94;label=37;break;
 case 34: 
 var $lpad_loopexit$0 = ___cxa_find_matching_catch(-1, -1); var $lpad_loopexit$1 = tempRet0;
 var $lpad_phi$1=$lpad_loopexit$1;var $lpad_phi$0=$lpad_loopexit$0;label=36;break;
 case 35: 
 var $lpad_nonloopexit$0 = ___cxa_find_matching_catch(-1, -1); var $lpad_nonloopexit$1 = tempRet0;
 var $lpad_phi$1=$lpad_nonloopexit$1;var $lpad_phi$0=$lpad_nonloopexit$0;label=36;break;
 case 36: 
 var $lpad_phi$0;
 var $lpad_phi$1;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__buf);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grouping);
 ___resumeException($lpad_phi$0)
 case 37: 
 var $__a_1;
 var $97=(($35+12)|0);
 var $98=HEAP32[(($97)>>2)];
 var $99=(($35+16)|0);
 var $100=HEAP32[(($99)>>2)];
 var $101=($98|0)==($100|0);
 if($101){label=38;break;}else{label=39;break;}
 case 38: 
 var $103=$35;
 var $104=HEAP32[(($103)>>2)];
 var $105=(($104+36)|0);
 var $106=HEAP32[(($105)>>2)];
 var $107=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$106]($35) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $_0_i_i=$107;label=40;break; } else { label=34;break; }
 case 39: 
 var $109=HEAP32[(($98)>>2)];
 var $_0_i_i=$109;label=40;break;
 case 40: 
 var $_0_i_i;
 var $111=__ZNSt3__19__num_getIwE19__stage2_float_loopEwRbRcPcRS4_wwRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSE_RjPw($_0_i_i,$__in_units,$__exp,$__a_1,$__a_end,$16,$17,$__grouping,$11,$__g_end,$__dc,$0);
 var $112=($111|0)==0;
 if($112){label=41;break;}else{var $__a_2=$__a_1;var $_pre_i4_i_i=$56;label=44;break;}
 case 41: 
 var $114=HEAP32[(($97)>>2)];
 var $115=HEAP32[(($99)>>2)];
 var $116=($114|0)==($115|0);
 if($116){label=42;break;}else{label=43;break;}
 case 42: 
 var $118=$35;
 var $119=HEAP32[(($118)>>2)];
 var $120=(($119+40)|0);
 var $121=HEAP32[(($120)>>2)];
 var $122=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$121]($35) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $__a_0=$__a_1;var $_pre_i_i_i16=$35;label=6;break; } else { label=34;break; }
 case 43: 
 var $124=(($114+4)|0);
 HEAP32[(($97)>>2)]=$124;
 var $__a_0=$__a_1;var $_pre_i_i_i16=$35;label=6;break;
 case 44: 
 var $_pre_i4_i_i;
 var $__a_2;
 var $126=$__grouping;
 var $127=HEAP8[($126)];
 var $128=$127&1;
 var $129=(($128<<24)>>24)==0;
 if($129){label=46;break;}else{label=45;break;}
 case 45: 
 var $131=(($__grouping+4)|0);
 var $132=HEAP32[(($131)>>2)];
 var $136=$132;label=47;break;
 case 46: 
 var $134=($127&255);
 var $135=$134>>>1;
 var $136=$135;label=47;break;
 case 47: 
 var $136;
 var $137=($136|0)==0;
 if($137){label=51;break;}else{label=48;break;}
 case 48: 
 var $139=HEAP8[($__in_units)];
 var $140=(($139<<24)>>24)==0;
 if($140){label=51;break;}else{label=49;break;}
 case 49: 
 var $142=HEAP32[(($__g_end)>>2)];
 var $143=$142;
 var $144=$__g;
 var $145=((($143)-($144))|0);
 var $146=($145|0)<160;
 if($146){label=50;break;}else{label=51;break;}
 case 50: 
 var $148=HEAP32[(($__dc)>>2)];
 var $149=(($142+4)|0);
 HEAP32[(($__g_end)>>2)]=$149;
 HEAP32[(($142)>>2)]=$148;
 label=51;break;
 case 51: 
 var $150=HEAP32[(($__a_end)>>2)];
 var $151=(function() { try { __THREW__ = 0; return __ZNSt3__115__num_get_floatIdEET_PKcS3_Rj($__a_2,$150,$__err) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=52;break; } else { label=35;break; }
 case 52: 
 HEAPF64[(($__v)>>3)]=$151;
 var $153=HEAP32[(($__g_end)>>2)];
 __ZNSt3__116__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj($__grouping,$11,$153,$__err);
 var $154=($35|0)==0;
 if($154){var $172=1;var $171=0;label=58;break;}else{label=53;break;}
 case 53: 
 var $156=(($35+12)|0);
 var $157=HEAP32[(($156)>>2)];
 var $158=(($35+16)|0);
 var $159=HEAP32[(($158)>>2)];
 var $160=($157|0)==($159|0);
 if($160){label=54;break;}else{label=55;break;}
 case 54: 
 var $162=$35;
 var $163=HEAP32[(($162)>>2)];
 var $164=(($163+36)|0);
 var $165=HEAP32[(($164)>>2)];
 var $166=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$165]($35) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $_0_i_i_i_i=$166;label=56;break; } else { label=35;break; }
 case 55: 
 var $168=HEAP32[(($157)>>2)];
 var $_0_i_i_i_i=$168;label=56;break;
 case 56: 
 var $_0_i_i_i_i;
 var $169=($_0_i_i_i_i|0)==-1;
 if($169){label=57;break;}else{var $172=0;var $171=$35;label=58;break;}
 case 57: 
 HEAP32[(($12)>>2)]=0;
 var $172=1;var $171=0;label=58;break;
 case 58: 
 var $171;
 var $172;
 var $173=($_pre_i4_i_i|0)==0;
 if($173){label=64;break;}else{label=59;break;}
 case 59: 
 var $175=(($_pre_i4_i_i+12)|0);
 var $176=HEAP32[(($175)>>2)];
 var $177=(($_pre_i4_i_i+16)|0);
 var $178=HEAP32[(($177)>>2)];
 var $179=($176|0)==($178|0);
 if($179){label=60;break;}else{label=61;break;}
 case 60: 
 var $181=$_pre_i4_i_i;
 var $182=HEAP32[(($181)>>2)];
 var $183=(($182+36)|0);
 var $184=HEAP32[(($183)>>2)];
 var $185=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$184]($_pre_i4_i_i) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $_0_i_i2_i_i=$185;label=62;break; } else { label=35;break; }
 case 61: 
 var $187=HEAP32[(($176)>>2)];
 var $_0_i_i2_i_i=$187;label=62;break;
 case 62: 
 var $_0_i_i2_i_i;
 var $188=($_0_i_i2_i_i|0)==-1;
 if($188){label=63;break;}else{label=65;break;}
 case 63: 
 HEAP32[(($13)>>2)]=0;
 label=64;break;
 case 64: 
 if($172){label=66;break;}else{label=67;break;}
 case 65: 
 if($172){label=67;break;}else{label=66;break;}
 case 66: 
 var $191=HEAP32[(($__err)>>2)];
 var $192=$191|2;
 HEAP32[(($__err)>>2)]=$192;
 label=67;break;
 case 67: 
 var $194=(($agg_result)|0);
 HEAP32[(($194)>>2)]=$171;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__buf);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grouping);
 STACKTOP=sp;return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRe($agg_result,$this,$__b,$__e,$__iob,$__err,$__v){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+16)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var tempParam = $__b; $__b=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__b)>>2)]=HEAP32[((tempParam)>>2)];
 var tempParam = $__e; $__e=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];

 var $1=sp;
 var $2=(sp)+(8);
 var $3=(($__b)|0);
 var $4=HEAP32[(($3)>>2)];
 var $5=(($1)|0);
 HEAP32[(($5)>>2)]=$4;
 var $6=(($__e)|0);
 var $7=HEAP32[(($6)>>2)];
 var $8=(($2)|0);
 HEAP32[(($8)>>2)]=$7;
 __ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE23__do_get_floating_pointIeEES4_S4_S4_RNS_8ios_baseERjRT_($agg_result,0,$1,$2,$__iob,$__err,$__v);
 STACKTOP=sp;return;
}


function __ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE23__do_get_floating_pointIeEES4_S4_S4_RNS_8ios_baseERjRT_($agg_result,$this,$__b,$__e,$__iob,$__err,$__v){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+376)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var tempParam = $__b; $__b=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__b)>>2)]=HEAP32[((tempParam)>>2)];
 var tempParam = $__e; $__e=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $__atoms=sp;
 var $__decimal_point=(sp)+(128);
 var $__thousands_sep=(sp)+(136);
 var $__grouping=(sp)+(144);
 var $__buf=(sp)+(160);
 var $__a_end=(sp)+(176);
 var $__g=(sp)+(184);
 var $__g_end=(sp)+(344);
 var $__dc=(sp)+(352);
 var $__in_units=(sp)+(360);
 var $__exp=(sp)+(368);
 var $0=(($__atoms)|0);
 __ZNSt3__19__num_getIwE19__stage2_float_prepERNS_8ios_baseEPwRwS5_($__grouping,$__iob,$0,$__decimal_point,$__thousands_sep);
 var $this4_i_i_i=$__buf;
 HEAP32[(($this4_i_i_i)>>2)]=0; HEAP32[((($this4_i_i_i)+(4))>>2)]=0; HEAP32[((($this4_i_i_i)+(8))>>2)]=0;
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc($__buf,10,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=2;break; } else { label=35;break; }
 case 2: 
 var $1=HEAP8[($this4_i_i_i)];
 var $2=$1&1;
 var $3=(($2<<24)>>24)==0;
 if($3){label=4;break;}else{label=3;break;}
 case 3: 
 var $5=(($__buf+8)|0);
 var $6=HEAP32[(($5)>>2)];
 var $_pre44=$__buf;
 var $_pre45=(($_pre44+1)|0);
 var $10=$6;var $_pre_phi46=$_pre45;var $_pre_phi48=$5;label=5;break;
 case 4: 
 var $8=$__buf;
 var $9=(($8+1)|0);
 var $_pre47=(($__buf+8)|0);
 var $10=$9;var $_pre_phi46=$9;var $_pre_phi48=$_pre47;label=5;break;
 case 5: 
 var $_pre_phi48;
 var $_pre_phi46;
 var $10;
 HEAP32[(($__a_end)>>2)]=$10;
 var $11=(($__g)|0);
 HEAP32[(($__g_end)>>2)]=$11;
 HEAP32[(($__dc)>>2)]=0;
 HEAP8[($__in_units)]=1;
 HEAP8[($__exp)]=69;
 var $12=(($__b)|0);
 var $13=(($__e)|0);
 var $14=(($__buf)|0);
 var $15=(($__buf+4)|0);
 var $16=HEAP32[(($__decimal_point)>>2)];
 var $17=HEAP32[(($__thousands_sep)>>2)];
 var $_pre=HEAP32[(($12)>>2)];
 var $__a_0=$10;var $_pre_i_i_i16=$_pre;label=6;break;
 case 6: 
 var $_pre_i_i_i16;
 var $__a_0;
 var $18=($_pre_i_i_i16|0)==0;
 if($18){var $36=1;var $35=0;label=12;break;}else{label=7;break;}
 case 7: 
 var $20=(($_pre_i_i_i16+12)|0);
 var $21=HEAP32[(($20)>>2)];
 var $22=(($_pre_i_i_i16+16)|0);
 var $23=HEAP32[(($22)>>2)];
 var $24=($21|0)==($23|0);
 if($24){label=8;break;}else{label=9;break;}
 case 8: 
 var $26=$_pre_i_i_i16;
 var $27=HEAP32[(($26)>>2)];
 var $28=(($27+36)|0);
 var $29=HEAP32[(($28)>>2)];
 var $30=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$29]($_pre_i_i_i16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $_0_i_i_i_i14=$30;label=10;break; } else { label=34;break; }
 case 9: 
 var $32=HEAP32[(($21)>>2)];
 var $_0_i_i_i_i14=$32;label=10;break;
 case 10: 
 var $_0_i_i_i_i14;
 var $33=($_0_i_i_i_i14|0)==-1;
 if($33){label=11;break;}else{var $36=0;var $35=$_pre_i_i_i16;label=12;break;}
 case 11: 
 HEAP32[(($12)>>2)]=0;
 var $36=1;var $35=0;label=12;break;
 case 12: 
 var $35;
 var $36;
 var $37=HEAP32[(($13)>>2)];
 var $38=($37|0)==0;
 if($38){label=18;break;}else{label=13;break;}
 case 13: 
 var $40=(($37+12)|0);
 var $41=HEAP32[(($40)>>2)];
 var $42=(($37+16)|0);
 var $43=HEAP32[(($42)>>2)];
 var $44=($41|0)==($43|0);
 if($44){label=14;break;}else{label=15;break;}
 case 14: 
 var $46=$37;
 var $47=HEAP32[(($46)>>2)];
 var $48=(($47+36)|0);
 var $49=HEAP32[(($48)>>2)];
 var $50=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$49]($37) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $_0_i_i2_i_i20=$50;label=16;break; } else { label=34;break; }
 case 15: 
 var $52=HEAP32[(($41)>>2)];
 var $_0_i_i2_i_i20=$52;label=16;break;
 case 16: 
 var $_0_i_i2_i_i20;
 var $53=($_0_i_i2_i_i20|0)==-1;
 if($53){label=17;break;}else{label=19;break;}
 case 17: 
 HEAP32[(($13)>>2)]=0;
 label=18;break;
 case 18: 
 if($36){var $__a_2=$__a_0;var $_pre_i4_i_i=0;label=44;break;}else{var $56=0;label=20;break;}
 case 19: 
 if($36){var $56=$37;label=20;break;}else{var $__a_2=$__a_0;var $_pre_i4_i_i=$37;label=44;break;}
 case 20: 
 var $56;
 var $57=HEAP32[(($__a_end)>>2)];
 var $58=$57;
 var $59=$__a_0;
 var $60=((($58)-($59))|0);
 var $61=HEAP8[($this4_i_i_i)];
 var $62=$61&1;
 var $63=(($62<<24)>>24)==0;
 if($63){label=22;break;}else{label=21;break;}
 case 21: 
 var $65=HEAP32[(($15)>>2)];
 var $69=$65;label=23;break;
 case 22: 
 var $67=($61&255);
 var $68=$67>>>1;
 var $69=$68;label=23;break;
 case 23: 
 var $69;
 var $70=($60|0)==($69|0);
 if($70){label=24;break;}else{var $__a_1=$__a_0;label=37;break;}
 case 24: 
 if($63){label=26;break;}else{label=25;break;}
 case 25: 
 var $73=HEAP32[(($15)>>2)];
 var $80=$73;var $79=$73;label=27;break;
 case 26: 
 var $75=($61&255);
 var $76=$75>>>1;
 var $77=($61&255);
 var $78=$77>>>1;
 var $80=$78;var $79=$76;label=27;break;
 case 27: 
 var $79;
 var $80;
 var $81=$80<<1;
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc($__buf,$81,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=28;break; } else { label=34;break; }
 case 28: 
 var $82=HEAP8[($this4_i_i_i)];
 var $83=$82&1;
 var $84=(($83<<24)>>24)==0;
 if($84){var $88=10;label=30;break;}else{label=29;break;}
 case 29: 
 var $86=HEAP32[(($14)>>2)];
 var $87=$86&-2;
 var $phitmp_i34=((($87)-(1))|0);
 var $88=$phitmp_i34;label=30;break;
 case 30: 
 var $88;
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc($__buf,$88,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=31;break; } else { label=34;break; }
 case 31: 
 var $89=HEAP8[($this4_i_i_i)];
 var $90=$89&1;
 var $91=(($90<<24)>>24)==0;
 if($91){var $94=$_pre_phi46;label=33;break;}else{label=32;break;}
 case 32: 
 var $93=HEAP32[(($_pre_phi48)>>2)];
 var $94=$93;label=33;break;
 case 33: 
 var $94;
 var $95=(($94+$79)|0);
 HEAP32[(($__a_end)>>2)]=$95;
 var $__a_1=$94;label=37;break;
 case 34: 
 var $lpad_loopexit$0 = ___cxa_find_matching_catch(-1, -1); var $lpad_loopexit$1 = tempRet0;
 var $lpad_phi$1=$lpad_loopexit$1;var $lpad_phi$0=$lpad_loopexit$0;label=36;break;
 case 35: 
 var $lpad_nonloopexit$0 = ___cxa_find_matching_catch(-1, -1); var $lpad_nonloopexit$1 = tempRet0;
 var $lpad_phi$1=$lpad_nonloopexit$1;var $lpad_phi$0=$lpad_nonloopexit$0;label=36;break;
 case 36: 
 var $lpad_phi$0;
 var $lpad_phi$1;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__buf);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grouping);
 ___resumeException($lpad_phi$0)
 case 37: 
 var $__a_1;
 var $97=(($35+12)|0);
 var $98=HEAP32[(($97)>>2)];
 var $99=(($35+16)|0);
 var $100=HEAP32[(($99)>>2)];
 var $101=($98|0)==($100|0);
 if($101){label=38;break;}else{label=39;break;}
 case 38: 
 var $103=$35;
 var $104=HEAP32[(($103)>>2)];
 var $105=(($104+36)|0);
 var $106=HEAP32[(($105)>>2)];
 var $107=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$106]($35) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $_0_i_i=$107;label=40;break; } else { label=34;break; }
 case 39: 
 var $109=HEAP32[(($98)>>2)];
 var $_0_i_i=$109;label=40;break;
 case 40: 
 var $_0_i_i;
 var $111=__ZNSt3__19__num_getIwE19__stage2_float_loopEwRbRcPcRS4_wwRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSE_RjPw($_0_i_i,$__in_units,$__exp,$__a_1,$__a_end,$16,$17,$__grouping,$11,$__g_end,$__dc,$0);
 var $112=($111|0)==0;
 if($112){label=41;break;}else{var $__a_2=$__a_1;var $_pre_i4_i_i=$56;label=44;break;}
 case 41: 
 var $114=HEAP32[(($97)>>2)];
 var $115=HEAP32[(($99)>>2)];
 var $116=($114|0)==($115|0);
 if($116){label=42;break;}else{label=43;break;}
 case 42: 
 var $118=$35;
 var $119=HEAP32[(($118)>>2)];
 var $120=(($119+40)|0);
 var $121=HEAP32[(($120)>>2)];
 var $122=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$121]($35) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $__a_0=$__a_1;var $_pre_i_i_i16=$35;label=6;break; } else { label=34;break; }
 case 43: 
 var $124=(($114+4)|0);
 HEAP32[(($97)>>2)]=$124;
 var $__a_0=$__a_1;var $_pre_i_i_i16=$35;label=6;break;
 case 44: 
 var $_pre_i4_i_i;
 var $__a_2;
 var $126=$__grouping;
 var $127=HEAP8[($126)];
 var $128=$127&1;
 var $129=(($128<<24)>>24)==0;
 if($129){label=46;break;}else{label=45;break;}
 case 45: 
 var $131=(($__grouping+4)|0);
 var $132=HEAP32[(($131)>>2)];
 var $136=$132;label=47;break;
 case 46: 
 var $134=($127&255);
 var $135=$134>>>1;
 var $136=$135;label=47;break;
 case 47: 
 var $136;
 var $137=($136|0)==0;
 if($137){label=51;break;}else{label=48;break;}
 case 48: 
 var $139=HEAP8[($__in_units)];
 var $140=(($139<<24)>>24)==0;
 if($140){label=51;break;}else{label=49;break;}
 case 49: 
 var $142=HEAP32[(($__g_end)>>2)];
 var $143=$142;
 var $144=$__g;
 var $145=((($143)-($144))|0);
 var $146=($145|0)<160;
 if($146){label=50;break;}else{label=51;break;}
 case 50: 
 var $148=HEAP32[(($__dc)>>2)];
 var $149=(($142+4)|0);
 HEAP32[(($__g_end)>>2)]=$149;
 HEAP32[(($142)>>2)]=$148;
 label=51;break;
 case 51: 
 var $150=HEAP32[(($__a_end)>>2)];
 var $151=(function() { try { __THREW__ = 0; return __ZNSt3__115__num_get_floatIeEET_PKcS3_Rj($__a_2,$150,$__err) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=52;break; } else { label=35;break; }
 case 52: 
 HEAPF64[(($__v)>>3)]=$151;
 var $153=HEAP32[(($__g_end)>>2)];
 __ZNSt3__116__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj($__grouping,$11,$153,$__err);
 var $154=($35|0)==0;
 if($154){var $172=1;var $171=0;label=58;break;}else{label=53;break;}
 case 53: 
 var $156=(($35+12)|0);
 var $157=HEAP32[(($156)>>2)];
 var $158=(($35+16)|0);
 var $159=HEAP32[(($158)>>2)];
 var $160=($157|0)==($159|0);
 if($160){label=54;break;}else{label=55;break;}
 case 54: 
 var $162=$35;
 var $163=HEAP32[(($162)>>2)];
 var $164=(($163+36)|0);
 var $165=HEAP32[(($164)>>2)];
 var $166=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$165]($35) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $_0_i_i_i_i=$166;label=56;break; } else { label=35;break; }
 case 55: 
 var $168=HEAP32[(($157)>>2)];
 var $_0_i_i_i_i=$168;label=56;break;
 case 56: 
 var $_0_i_i_i_i;
 var $169=($_0_i_i_i_i|0)==-1;
 if($169){label=57;break;}else{var $172=0;var $171=$35;label=58;break;}
 case 57: 
 HEAP32[(($12)>>2)]=0;
 var $172=1;var $171=0;label=58;break;
 case 58: 
 var $171;
 var $172;
 var $173=($_pre_i4_i_i|0)==0;
 if($173){label=64;break;}else{label=59;break;}
 case 59: 
 var $175=(($_pre_i4_i_i+12)|0);
 var $176=HEAP32[(($175)>>2)];
 var $177=(($_pre_i4_i_i+16)|0);
 var $178=HEAP32[(($177)>>2)];
 var $179=($176|0)==($178|0);
 if($179){label=60;break;}else{label=61;break;}
 case 60: 
 var $181=$_pre_i4_i_i;
 var $182=HEAP32[(($181)>>2)];
 var $183=(($182+36)|0);
 var $184=HEAP32[(($183)>>2)];
 var $185=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$184]($_pre_i4_i_i) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $_0_i_i2_i_i=$185;label=62;break; } else { label=35;break; }
 case 61: 
 var $187=HEAP32[(($176)>>2)];
 var $_0_i_i2_i_i=$187;label=62;break;
 case 62: 
 var $_0_i_i2_i_i;
 var $188=($_0_i_i2_i_i|0)==-1;
 if($188){label=63;break;}else{label=65;break;}
 case 63: 
 HEAP32[(($13)>>2)]=0;
 label=64;break;
 case 64: 
 if($172){label=66;break;}else{label=67;break;}
 case 65: 
 if($172){label=67;break;}else{label=66;break;}
 case 66: 
 var $191=HEAP32[(($__err)>>2)];
 var $192=$191|2;
 HEAP32[(($__err)>>2)]=$192;
 label=67;break;
 case 67: 
 var $194=(($agg_result)|0);
 HEAP32[(($194)>>2)]=$171;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__buf);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grouping);
 STACKTOP=sp;return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRPv($agg_result,$this,$__b,$__e,$__iob,$__err,$__v){
 var label=0;
 var tempVarArgs=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+344)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var tempParam = $__b; $__b=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__b)>>2)]=HEAP32[((tempParam)>>2)];
 var tempParam = $__e; $__e=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $__p_i_i_i_i=sp;
 var $__atoms=(sp)+(16);
 var $__grouping=(sp)+(120);
 var $1=(sp)+(136);
 var $__buf=(sp)+(144);
 var $__a_end=(sp)+(160);
 var $__g=(sp)+(168);
 var $__g_end=(sp)+(328);
 var $__dc=(sp)+(336);
 var $this4_i_i_i=$__grouping;
 HEAP32[(($this4_i_i_i)>>2)]=0; HEAP32[((($this4_i_i_i)+(4))>>2)]=0; HEAP32[((($this4_i_i_i)+(8))>>2)]=0;
 (function() { try { __THREW__ = 0; return __ZNKSt3__18ios_base6getlocEv($1,$__iob) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=2;break; } else { label=42;break; }
 case 2: 
 var $3=(($1)|0);
 var $4=HEAP32[(($3)>>2)];
 var $5=$__p_i_i_i_i;
 var $6=HEAP32[((14088)>>2)];
 var $7=($6|0)==-1;
 if($7){label=4;break;}else{label=3;break;}
 case 3: 
 var $_sroa_01_0___p67_i_idx_i_i_i=(($__p_i_i_i_i)|0);
 HEAP32[(($_sroa_01_0___p67_i_idx_i_i_i)>>2)]=14088;
 var $_sroa_12_4___p67_i_idx3_i_i_i=(($__p_i_i_i_i+4)|0);
 HEAP32[(($_sroa_12_4___p67_i_idx3_i_i_i)>>2)]=(28);
 var $_sroa_2_8___p67_i_idx4_i_i_i=(($__p_i_i_i_i+8)|0);
 HEAP32[(($_sroa_2_8___p67_i_idx4_i_i_i)>>2)]=0;
 (function() { try { __THREW__ = 0; return __ZNSt3__111__call_onceERVmPvPFvS2_E(14088,$5,260) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=4;break; } else { label=43;break; }
 case 4: 
 var $9=HEAP32[((14092)>>2)];
 var $10=((($9)-(1))|0);
 var $11=(($4+12)|0);
 var $12=HEAP32[(($11)>>2)];
 var $13=(($4+8)|0);
 var $14=HEAP32[(($13)>>2)];
 var $15=$12;
 var $16=$14;
 var $17=((($15)-($16))|0);
 var $18=$17>>2;
 var $19=($18>>>0)>($10>>>0);
 if($19){label=5;break;}else{label=6;break;}
 case 5: 
 var $20=(($14+($10<<2))|0);
 var $21=HEAP32[(($20)>>2)];
 var $22=($21|0)==0;
 if($22){label=6;break;}else{label=8;break;}
 case 6: 
 var $23=___cxa_allocate_exception(4);
 var $24=$23;
 __ZNSt8bad_castC2Ev($24);
 (function() { try { __THREW__ = 0; return ___cxa_throw($23,8960,(368)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=7;break; } else { label=43;break; }
 case 7: 
 throw "Reached an unreachable!";
 case 8: 
 var $26=$21;
 var $27=(($__atoms)|0);
 var $28=$21;
 var $29=HEAP32[(($28)>>2)];
 var $30=(($29+48)|0);
 var $31=HEAP32[(($30)>>2)];
 var $32=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$31]($26,10592,10618,$27) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=9;break; } else { label=43;break; }
 case 9: 
 var $33=HEAP32[(($3)>>2)];
 var $34=(($33)|0);
 var $35=__ZNSt3__114__shared_count16__release_sharedEv($34);
 var $this4_i_i_i17=$__buf;
 HEAP32[(($this4_i_i_i17)>>2)]=0; HEAP32[((($this4_i_i_i17)+(4))>>2)]=0; HEAP32[((($this4_i_i_i17)+(8))>>2)]=0;
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc($__buf,10,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=10;break; } else { label=45;break; }
 case 10: 
 var $36=HEAP8[($this4_i_i_i17)];
 var $37=$36&1;
 var $38=(($37<<24)>>24)==0;
 if($38){label=12;break;}else{label=11;break;}
 case 11: 
 var $40=(($__buf+8)|0);
 var $41=HEAP32[(($40)>>2)];
 var $_pre46=$__buf;
 var $_pre47=(($_pre46+1)|0);
 var $45=$41;var $_pre_phi48=$_pre47;var $_pre_phi50=$40;label=13;break;
 case 12: 
 var $43=$__buf;
 var $44=(($43+1)|0);
 var $_pre49=(($__buf+8)|0);
 var $45=$44;var $_pre_phi48=$44;var $_pre_phi50=$_pre49;label=13;break;
 case 13: 
 var $_pre_phi50;
 var $_pre_phi48;
 var $45;
 HEAP32[(($__a_end)>>2)]=$45;
 var $46=(($__g)|0);
 HEAP32[(($__g_end)>>2)]=$46;
 HEAP32[(($__dc)>>2)]=0;
 var $47=(($__b)|0);
 var $48=(($__e)|0);
 var $49=(($__buf)|0);
 var $50=(($__buf+4)|0);
 var $_pre=HEAP32[(($47)>>2)];
 var $__a_0=$45;var $_pre_i_i_i21=$_pre;label=14;break;
 case 14: 
 var $_pre_i_i_i21;
 var $__a_0;
 var $51=($_pre_i_i_i21|0)==0;
 if($51){var $69=1;var $68=0;label=20;break;}else{label=15;break;}
 case 15: 
 var $53=(($_pre_i_i_i21+12)|0);
 var $54=HEAP32[(($53)>>2)];
 var $55=(($_pre_i_i_i21+16)|0);
 var $56=HEAP32[(($55)>>2)];
 var $57=($54|0)==($56|0);
 if($57){label=16;break;}else{label=17;break;}
 case 16: 
 var $59=$_pre_i_i_i21;
 var $60=HEAP32[(($59)>>2)];
 var $61=(($60+36)|0);
 var $62=HEAP32[(($61)>>2)];
 var $63=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$62]($_pre_i_i_i21) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $_0_i_i_i_i19=$63;label=18;break; } else { label=44;break; }
 case 17: 
 var $65=HEAP32[(($54)>>2)];
 var $_0_i_i_i_i19=$65;label=18;break;
 case 18: 
 var $_0_i_i_i_i19;
 var $66=($_0_i_i_i_i19|0)==-1;
 if($66){label=19;break;}else{var $69=0;var $68=$_pre_i_i_i21;label=20;break;}
 case 19: 
 HEAP32[(($47)>>2)]=0;
 var $69=1;var $68=0;label=20;break;
 case 20: 
 var $68;
 var $69;
 var $70=HEAP32[(($48)>>2)];
 var $71=($70|0)==0;
 if($71){label=26;break;}else{label=21;break;}
 case 21: 
 var $73=(($70+12)|0);
 var $74=HEAP32[(($73)>>2)];
 var $75=(($70+16)|0);
 var $76=HEAP32[(($75)>>2)];
 var $77=($74|0)==($76|0);
 if($77){label=22;break;}else{label=23;break;}
 case 22: 
 var $79=$70;
 var $80=HEAP32[(($79)>>2)];
 var $81=(($80+36)|0);
 var $82=HEAP32[(($81)>>2)];
 var $83=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$82]($70) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $_0_i_i2_i_i25=$83;label=24;break; } else { label=44;break; }
 case 23: 
 var $85=HEAP32[(($74)>>2)];
 var $_0_i_i2_i_i25=$85;label=24;break;
 case 24: 
 var $_0_i_i2_i_i25;
 var $86=($_0_i_i2_i_i25|0)==-1;
 if($86){label=25;break;}else{label=27;break;}
 case 25: 
 HEAP32[(($48)>>2)]=0;
 label=26;break;
 case 26: 
 if($69){var $__a_2=$__a_0;label=54;break;}else{label=28;break;}
 case 27: 
 if($69){label=28;break;}else{var $__a_2=$__a_0;label=54;break;}
 case 28: 
 var $89=HEAP32[(($__a_end)>>2)];
 var $90=$89;
 var $91=$__a_0;
 var $92=((($90)-($91))|0);
 var $93=HEAP8[($this4_i_i_i17)];
 var $94=$93&1;
 var $95=(($94<<24)>>24)==0;
 if($95){label=30;break;}else{label=29;break;}
 case 29: 
 var $97=HEAP32[(($50)>>2)];
 var $101=$97;label=31;break;
 case 30: 
 var $99=($93&255);
 var $100=$99>>>1;
 var $101=$100;label=31;break;
 case 31: 
 var $101;
 var $102=($92|0)==($101|0);
 if($102){label=32;break;}else{var $__a_1=$__a_0;label=47;break;}
 case 32: 
 if($95){label=34;break;}else{label=33;break;}
 case 33: 
 var $105=HEAP32[(($50)>>2)];
 var $112=$105;var $111=$105;label=35;break;
 case 34: 
 var $107=($93&255);
 var $108=$107>>>1;
 var $109=($93&255);
 var $110=$109>>>1;
 var $112=$110;var $111=$108;label=35;break;
 case 35: 
 var $111;
 var $112;
 var $113=$112<<1;
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc($__buf,$113,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=36;break; } else { label=44;break; }
 case 36: 
 var $114=HEAP8[($this4_i_i_i17)];
 var $115=$114&1;
 var $116=(($115<<24)>>24)==0;
 if($116){var $120=10;label=38;break;}else{label=37;break;}
 case 37: 
 var $118=HEAP32[(($49)>>2)];
 var $119=$118&-2;
 var $phitmp_i37=((($119)-(1))|0);
 var $120=$phitmp_i37;label=38;break;
 case 38: 
 var $120;
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc($__buf,$120,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=39;break; } else { label=44;break; }
 case 39: 
 var $121=HEAP8[($this4_i_i_i17)];
 var $122=$121&1;
 var $123=(($122<<24)>>24)==0;
 if($123){var $126=$_pre_phi48;label=41;break;}else{label=40;break;}
 case 40: 
 var $125=HEAP32[(($_pre_phi50)>>2)];
 var $126=$125;label=41;break;
 case 41: 
 var $126;
 var $127=(($126+$111)|0);
 HEAP32[(($__a_end)>>2)]=$127;
 var $__a_1=$126;label=47;break;
 case 42: 
 var $129$0 = ___cxa_find_matching_catch(-1, -1); var $129$1 = tempRet0;
 var $130=$129$0;
 var $131=$129$1;
 var $_0=$130;var $_012=$131;label=78;break;
 case 43: 
 var $133$0 = ___cxa_find_matching_catch(-1, -1); var $133$1 = tempRet0;
 var $134=$133$0;
 var $135=$133$1;
 var $136=HEAP32[(($3)>>2)];
 var $137=(($136)|0);
 var $138=__ZNSt3__114__shared_count16__release_sharedEv($137);
 var $_0=$134;var $_012=$135;label=78;break;
 case 44: 
 var $lpad_loopexit$0 = ___cxa_find_matching_catch(-1, -1); var $lpad_loopexit$1 = tempRet0;
 var $eh_lpad_body$1=$lpad_loopexit$1;var $eh_lpad_body$0=$lpad_loopexit$0;label=46;break;
 case 45: 
 var $lpad_nonloopexit$0 = ___cxa_find_matching_catch(-1, -1); var $lpad_nonloopexit$1 = tempRet0;
 var $eh_lpad_body$1=$lpad_nonloopexit$1;var $eh_lpad_body$0=$lpad_nonloopexit$0;label=46;break;
 case 46: 
 var $eh_lpad_body$0;
 var $eh_lpad_body$1;
 var $139=$eh_lpad_body$0;
 var $140=$eh_lpad_body$1;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__buf);
 var $_0=$139;var $_012=$140;label=78;break;
 case 47: 
 var $__a_1;
 var $141=(($68+12)|0);
 var $142=HEAP32[(($141)>>2)];
 var $143=(($68+16)|0);
 var $144=HEAP32[(($143)>>2)];
 var $145=($142|0)==($144|0);
 if($145){label=48;break;}else{label=49;break;}
 case 48: 
 var $147=$68;
 var $148=HEAP32[(($147)>>2)];
 var $149=(($148+36)|0);
 var $150=HEAP32[(($149)>>2)];
 var $151=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$150]($68) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $_0_i_i=$151;label=50;break; } else { label=44;break; }
 case 49: 
 var $153=HEAP32[(($142)>>2)];
 var $_0_i_i=$153;label=50;break;
 case 50: 
 var $_0_i_i;
 var $155=__ZNSt3__19__num_getIwE17__stage2_int_loopEwiPcRS2_RjwRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSD_Pw($_0_i_i,16,$__a_1,$__a_end,$__dc,0,$__grouping,$46,$__g_end,$27);
 var $156=($155|0)==0;
 if($156){label=51;break;}else{var $__a_2=$__a_1;label=54;break;}
 case 51: 
 var $158=HEAP32[(($141)>>2)];
 var $159=HEAP32[(($143)>>2)];
 var $160=($158|0)==($159|0);
 if($160){label=52;break;}else{label=53;break;}
 case 52: 
 var $162=$68;
 var $163=HEAP32[(($162)>>2)];
 var $164=(($163+40)|0);
 var $165=HEAP32[(($164)>>2)];
 var $166=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$165]($68) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $__a_0=$__a_1;var $_pre_i_i_i21=$68;label=14;break; } else { label=44;break; }
 case 53: 
 var $168=(($158+4)|0);
 HEAP32[(($141)>>2)]=$168;
 var $__a_0=$__a_1;var $_pre_i_i_i21=$68;label=14;break;
 case 54: 
 var $__a_2;
 var $170=(($__a_2+3)|0);
 HEAP8[($170)]=0;
 var $171=HEAP8[(14656)];
 var $172=(($171<<24)>>24)==0;
 if($172){label=55;break;}else{label=59;break;}
 case 55: 
 var $174=___cxa_guard_acquire(14656);
 var $175=($174|0)==0;
 if($175){label=59;break;}else{label=56;break;}
 case 56: 
 var $177=(function() { try { __THREW__ = 0; return _newlocale(2147483647,1496,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=57;break; } else { label=58;break; }
 case 57: 
 HEAP32[((12664)>>2)]=$177;

 label=59;break;
 case 58: 
 var $180$0 = ___cxa_find_matching_catch(-1, -1); var $180$1 = tempRet0;

 var $eh_lpad_body$1=$180$1;var $eh_lpad_body$0=$180$0;label=46;break;
 case 59: 
 var $182=HEAP32[((12664)>>2)];
 var $183=(function() { try { __THREW__ = 0; return __ZNSt3__110__sscanf_lEPKcP15__locale_structS1_z($__a_2,$182,1152,(tempVarArgs=STACKTOP,STACKTOP = (STACKTOP + 8)|0,(assert((STACKTOP|0) < (STACK_MAX|0))|0),HEAP32[((tempVarArgs)>>2)]=$__v,tempVarArgs)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })(); STACKTOP=tempVarArgs;if (!__THREW__) { label=60;break; } else { label=45;break; }
 case 60: 
 var $185=($183|0)==1;
 if($185){label=62;break;}else{label=61;break;}
 case 61: 
 HEAP32[(($__err)>>2)]=4;
 label=62;break;
 case 62: 
 var $188=HEAP32[(($47)>>2)];
 var $189=($188|0)==0;
 if($189){var $207=1;var $206=0;label=68;break;}else{label=63;break;}
 case 63: 
 var $191=(($188+12)|0);
 var $192=HEAP32[(($191)>>2)];
 var $193=(($188+16)|0);
 var $194=HEAP32[(($193)>>2)];
 var $195=($192|0)==($194|0);
 if($195){label=64;break;}else{label=65;break;}
 case 64: 
 var $197=$188;
 var $198=HEAP32[(($197)>>2)];
 var $199=(($198+36)|0);
 var $200=HEAP32[(($199)>>2)];
 var $201=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$200]($188) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $_0_i_i_i_i=$201;label=66;break; } else { label=45;break; }
 case 65: 
 var $203=HEAP32[(($192)>>2)];
 var $_0_i_i_i_i=$203;label=66;break;
 case 66: 
 var $_0_i_i_i_i;
 var $204=($_0_i_i_i_i|0)==-1;
 if($204){label=67;break;}else{var $207=0;var $206=$188;label=68;break;}
 case 67: 
 HEAP32[(($47)>>2)]=0;
 var $207=1;var $206=0;label=68;break;
 case 68: 
 var $206;
 var $207;
 var $208=HEAP32[(($48)>>2)];
 var $209=($208|0)==0;
 if($209){label=74;break;}else{label=69;break;}
 case 69: 
 var $211=(($208+12)|0);
 var $212=HEAP32[(($211)>>2)];
 var $213=(($208+16)|0);
 var $214=HEAP32[(($213)>>2)];
 var $215=($212|0)==($214|0);
 if($215){label=70;break;}else{label=71;break;}
 case 70: 
 var $217=$208;
 var $218=HEAP32[(($217)>>2)];
 var $219=(($218+36)|0);
 var $220=HEAP32[(($219)>>2)];
 var $221=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$220]($208) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $_0_i_i2_i_i=$221;label=72;break; } else { label=45;break; }
 case 71: 
 var $223=HEAP32[(($212)>>2)];
 var $_0_i_i2_i_i=$223;label=72;break;
 case 72: 
 var $_0_i_i2_i_i;
 var $224=($_0_i_i2_i_i|0)==-1;
 if($224){label=73;break;}else{label=75;break;}
 case 73: 
 HEAP32[(($48)>>2)]=0;
 label=74;break;
 case 74: 
 if($207){label=76;break;}else{label=77;break;}
 case 75: 
 if($207){label=77;break;}else{label=76;break;}
 case 76: 
 var $227=HEAP32[(($__err)>>2)];
 var $228=$227|2;
 HEAP32[(($__err)>>2)]=$228;
 label=77;break;
 case 77: 
 var $230=(($agg_result)|0);
 HEAP32[(($230)>>2)]=$206;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__buf);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grouping);
 STACKTOP=sp;return;
 case 78: 
 var $_012;
 var $_0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grouping);
 var $232$0=$_0;
 var $232$1=0;
 var $233$0=$232$0;
 var $233$1=$_012;
 ___resumeException($233$0)
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__19__num_getIwE17__stage2_int_loopEwiPcRS2_RjwRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSD_Pw($__ct,$__base,$__a,$__a_end,$__dc,$__thousands_sep,$__grouping,$__g,$__g_end,$__atoms){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=HEAP32[(($__a_end)>>2)];
 var $2=($1|0)==($__a|0);
 if($2){label=2;break;}else{label=5;break;}
 case 2: 
 var $4=(($__atoms+96)|0);
 var $5=HEAP32[(($4)>>2)];
 var $6=($5|0)==($__ct|0);
 if($6){label=4;break;}else{label=3;break;}
 case 3: 
 var $8=(($__atoms+100)|0);
 var $9=HEAP32[(($8)>>2)];
 var $10=($9|0)==($__ct|0);
 if($10){label=4;break;}else{label=5;break;}
 case 4: 
 var $12=($6?43:45);
 var $13=(($__a+1)|0);
 HEAP32[(($__a_end)>>2)]=$13;
 HEAP8[($__a)]=$12;
 HEAP32[(($__dc)>>2)]=0;
 var $_0=0;label=23;break;
 case 5: 
 var $15=$__grouping;
 var $16=HEAP8[($15)];
 var $17=$16&1;
 var $18=(($17<<24)>>24)==0;
 if($18){label=7;break;}else{label=6;break;}
 case 6: 
 var $20=(($__grouping+4)|0);
 var $21=HEAP32[(($20)>>2)];
 var $25=$21;label=8;break;
 case 7: 
 var $23=($16&255);
 var $24=$23>>>1;
 var $25=$24;label=8;break;
 case 8: 
 var $25;
 var $26=($25|0)!=0;
 var $27=($__ct|0)==($__thousands_sep|0);
 var $or_cond=$26&$27;
 if($or_cond){label=9;break;}else{label=11;break;}
 case 9: 
 var $29=HEAP32[(($__g_end)>>2)];
 var $30=$29;
 var $31=$__g;
 var $32=((($30)-($31))|0);
 var $33=($32|0)<160;
 if($33){label=10;break;}else{var $_0=0;label=23;break;}
 case 10: 
 var $35=HEAP32[(($__dc)>>2)];
 var $36=(($29+4)|0);
 HEAP32[(($__g_end)>>2)]=$36;
 HEAP32[(($29)>>2)]=$35;
 HEAP32[(($__dc)>>2)]=0;
 var $_0=0;label=23;break;
 case 11: 
 var $38=(($__atoms+104)|0);
 var $_0_i=$__atoms;label=12;break;
 case 12: 
 var $_0_i;
 var $40=($_0_i|0)==($38|0);
 if($40){var $_0_lcssa_i=$38;label=14;break;}else{label=13;break;}
 case 13: 
 var $42=HEAP32[(($_0_i)>>2)];
 var $43=($42|0)==($__ct|0);
 var $44=(($_0_i+4)|0);
 if($43){var $_0_lcssa_i=$_0_i;label=14;break;}else{var $_0_i=$44;label=12;break;}
 case 14: 
 var $_0_lcssa_i;
 var $45=$_0_lcssa_i;
 var $46=$__atoms;
 var $47=((($45)-($46))|0);
 var $48=$47>>2;
 var $49=($47|0)>92;
 if($49){var $_0=-1;label=23;break;}else{label=15;break;}
 case 15: 
 if(($__base|0)==8|($__base|0)==10){ label=16;break;}else if(($__base|0)==16){ label=17;break;}else{label=22;break;}
 case 16: 
 var $52=($48|0)<($__base|0);
 if($52){label=22;break;}else{var $_0=-1;label=23;break;}
 case 17: 
 var $54=($47|0)<88;
 if($54){label=22;break;}else{label=18;break;}
 case 18: 
 if($2){var $_0=-1;label=23;break;}else{label=19;break;}
 case 19: 
 var $57=$1;
 var $58=$__a;
 var $59=((($57)-($58))|0);
 var $60=($59|0)<3;
 if($60){label=20;break;}else{var $_0=-1;label=23;break;}
 case 20: 
 var $62=((($1)-(1))|0);
 var $63=HEAP8[($62)];
 var $64=(($63<<24)>>24)==48;
 if($64){label=21;break;}else{var $_0=-1;label=23;break;}
 case 21: 
 HEAP32[(($__dc)>>2)]=0;
 var $66=((10592+$48)|0);
 var $67=HEAP8[($66)];
 var $68=(($1+1)|0);
 HEAP32[(($__a_end)>>2)]=$68;
 HEAP8[($1)]=$67;
 var $_0=0;label=23;break;
 case 22: 
 var $70=((10592+$48)|0);
 var $71=HEAP8[($70)];
 var $72=(($1+1)|0);
 HEAP32[(($__a_end)>>2)]=$72;
 HEAP8[($1)]=$71;
 var $73=HEAP32[(($__dc)>>2)];
 var $74=((($73)+(1))|0);
 HEAP32[(($__dc)>>2)]=$74;
 var $_0=0;label=23;break;
 case 23: 
 var $_0;
 return $_0;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__19__num_getIcE17__stage2_int_prepERNS_8ios_baseEPcRc($agg_result,$__iob,$__atoms,$__thousands_sep){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+40)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $__p_i_i_i_i8=sp;
 var $__p_i_i_i_i=(sp)+(16);
 var $__loc=(sp)+(32);
 __ZNKSt3__18ios_base6getlocEv($__loc,$__iob);
 var $1=(($__loc)|0);
 var $2=HEAP32[(($1)>>2)];
 var $3=$__p_i_i_i_i;
 var $4=HEAP32[((14096)>>2)];
 var $5=($4|0)==-1;
 if($5){label=3;break;}else{label=2;break;}
 case 2: 
 var $_sroa_01_0___p67_i_idx_i_i_i=(($__p_i_i_i_i)|0);
 HEAP32[(($_sroa_01_0___p67_i_idx_i_i_i)>>2)]=14096;
 var $_sroa_12_4___p67_i_idx3_i_i_i=(($__p_i_i_i_i+4)|0);
 HEAP32[(($_sroa_12_4___p67_i_idx3_i_i_i)>>2)]=(28);
 var $_sroa_2_8___p67_i_idx4_i_i_i=(($__p_i_i_i_i+8)|0);
 HEAP32[(($_sroa_2_8___p67_i_idx4_i_i_i)>>2)]=0;
 (function() { try { __THREW__ = 0; return __ZNSt3__111__call_onceERVmPvPFvS2_E(14096,$3,260) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=3;break; } else { label=17;break; }
 case 3: 
 var $7=HEAP32[((14100)>>2)];
 var $8=((($7)-(1))|0);
 var $9=(($2+12)|0);
 var $10=HEAP32[(($9)>>2)];
 var $11=(($2+8)|0);
 var $12=HEAP32[(($11)>>2)];
 var $13=$10;
 var $14=$12;
 var $15=((($13)-($14))|0);
 var $16=$15>>2;
 var $17=($16>>>0)>($8>>>0);
 if($17){label=4;break;}else{label=5;break;}
 case 4: 
 var $18=(($12+($8<<2))|0);
 var $19=HEAP32[(($18)>>2)];
 var $20=($19|0)==0;
 if($20){label=5;break;}else{label=7;break;}
 case 5: 
 var $21=___cxa_allocate_exception(4);
 var $22=$21;
 __ZNSt8bad_castC2Ev($22);
 (function() { try { __THREW__ = 0; return ___cxa_throw($21,8960,(368)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=6;break; } else { label=17;break; }
 case 6: 
 throw "Reached an unreachable!";
 case 7: 
 var $24=$19;
 var $25=$19;
 var $26=HEAP32[(($25)>>2)];
 var $27=(($26+32)|0);
 var $28=HEAP32[(($27)>>2)];
 var $29=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$28]($24,10592,10618,$__atoms) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=8;break; } else { label=17;break; }
 case 8: 
 var $30=HEAP32[(($1)>>2)];
 var $31=$__p_i_i_i_i8;
 var $32=HEAP32[((13712)>>2)];
 var $33=($32|0)==-1;
 if($33){label=10;break;}else{label=9;break;}
 case 9: 
 var $_sroa_01_0___p67_i_idx_i_i_i9=(($__p_i_i_i_i8)|0);
 HEAP32[(($_sroa_01_0___p67_i_idx_i_i_i9)>>2)]=13712;
 var $_sroa_12_4___p67_i_idx3_i_i_i10=(($__p_i_i_i_i8+4)|0);
 HEAP32[(($_sroa_12_4___p67_i_idx3_i_i_i10)>>2)]=(28);
 var $_sroa_2_8___p67_i_idx4_i_i_i11=(($__p_i_i_i_i8+8)|0);
 HEAP32[(($_sroa_2_8___p67_i_idx4_i_i_i11)>>2)]=0;
 (function() { try { __THREW__ = 0; return __ZNSt3__111__call_onceERVmPvPFvS2_E(13712,$31,260) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=10;break; } else { label=17;break; }
 case 10: 
 var $35=HEAP32[((13716)>>2)];
 var $36=((($35)-(1))|0);
 var $37=(($30+12)|0);
 var $38=HEAP32[(($37)>>2)];
 var $39=(($30+8)|0);
 var $40=HEAP32[(($39)>>2)];
 var $41=$38;
 var $42=$40;
 var $43=((($41)-($42))|0);
 var $44=$43>>2;
 var $45=($44>>>0)>($36>>>0);
 if($45){label=11;break;}else{label=12;break;}
 case 11: 
 var $46=(($40+($36<<2))|0);
 var $47=HEAP32[(($46)>>2)];
 var $48=($47|0)==0;
 if($48){label=12;break;}else{label=14;break;}
 case 12: 
 var $49=___cxa_allocate_exception(4);
 var $50=$49;
 __ZNSt8bad_castC2Ev($50);
 (function() { try { __THREW__ = 0; return ___cxa_throw($49,8960,(368)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=13;break; } else { label=17;break; }
 case 13: 
 throw "Reached an unreachable!";
 case 14: 
 var $52=$47;
 var $53=$47;
 var $54=HEAP32[(($53)>>2)];
 var $55=(($54+16)|0);
 var $56=HEAP32[(($55)>>2)];
 var $57=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$56]($52) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=15;break; } else { label=17;break; }
 case 15: 
 HEAP8[($__thousands_sep)]=$57;
 var $58=$47;
 var $59=HEAP32[(($58)>>2)];
 var $60=(($59+20)|0);
 var $61=HEAP32[(($60)>>2)];
 (function() { try { __THREW__ = 0; return FUNCTION_TABLE[$61]($agg_result,$52) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=16;break; } else { label=17;break; }
 case 16: 
 var $62=HEAP32[(($1)>>2)];
 var $63=(($62)|0);
 var $64=__ZNSt3__114__shared_count16__release_sharedEv($63);
 STACKTOP=sp;return;
 case 17: 
 var $66$0 = ___cxa_find_matching_catch(-1, -1); var $66$1 = tempRet0;
 var $67=HEAP32[(($1)>>2)];
 var $68=(($67)|0);
 var $69=__ZNSt3__114__shared_count16__release_sharedEv($68);
 ___resumeException($66$0)
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__19__num_getIcE19__stage2_float_prepERNS_8ios_baseEPcRcS5_($agg_result,$__iob,$__atoms,$__decimal_point,$__thousands_sep){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+40)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $__p_i_i_i_i10=sp;
 var $__p_i_i_i_i=(sp)+(16);
 var $__loc=(sp)+(32);
 __ZNKSt3__18ios_base6getlocEv($__loc,$__iob);
 var $1=(($__loc)|0);
 var $2=HEAP32[(($1)>>2)];
 var $3=$__p_i_i_i_i;
 var $4=HEAP32[((14096)>>2)];
 var $5=($4|0)==-1;
 if($5){label=3;break;}else{label=2;break;}
 case 2: 
 var $_sroa_01_0___p67_i_idx_i_i_i=(($__p_i_i_i_i)|0);
 HEAP32[(($_sroa_01_0___p67_i_idx_i_i_i)>>2)]=14096;
 var $_sroa_12_4___p67_i_idx3_i_i_i=(($__p_i_i_i_i+4)|0);
 HEAP32[(($_sroa_12_4___p67_i_idx3_i_i_i)>>2)]=(28);
 var $_sroa_2_8___p67_i_idx4_i_i_i=(($__p_i_i_i_i+8)|0);
 HEAP32[(($_sroa_2_8___p67_i_idx4_i_i_i)>>2)]=0;
 (function() { try { __THREW__ = 0; return __ZNSt3__111__call_onceERVmPvPFvS2_E(14096,$3,260) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=3;break; } else { label=18;break; }
 case 3: 
 var $7=HEAP32[((14100)>>2)];
 var $8=((($7)-(1))|0);
 var $9=(($2+12)|0);
 var $10=HEAP32[(($9)>>2)];
 var $11=(($2+8)|0);
 var $12=HEAP32[(($11)>>2)];
 var $13=$10;
 var $14=$12;
 var $15=((($13)-($14))|0);
 var $16=$15>>2;
 var $17=($16>>>0)>($8>>>0);
 if($17){label=4;break;}else{label=5;break;}
 case 4: 
 var $18=(($12+($8<<2))|0);
 var $19=HEAP32[(($18)>>2)];
 var $20=($19|0)==0;
 if($20){label=5;break;}else{label=7;break;}
 case 5: 
 var $21=___cxa_allocate_exception(4);
 var $22=$21;
 __ZNSt8bad_castC2Ev($22);
 (function() { try { __THREW__ = 0; return ___cxa_throw($21,8960,(368)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=6;break; } else { label=18;break; }
 case 6: 
 throw "Reached an unreachable!";
 case 7: 
 var $24=$19;
 var $25=$19;
 var $26=HEAP32[(($25)>>2)];
 var $27=(($26+32)|0);
 var $28=HEAP32[(($27)>>2)];
 var $29=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$28]($24,10592,10624,$__atoms) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=8;break; } else { label=18;break; }
 case 8: 
 var $30=HEAP32[(($1)>>2)];
 var $31=$__p_i_i_i_i10;
 var $32=HEAP32[((13712)>>2)];
 var $33=($32|0)==-1;
 if($33){label=10;break;}else{label=9;break;}
 case 9: 
 var $_sroa_01_0___p67_i_idx_i_i_i11=(($__p_i_i_i_i10)|0);
 HEAP32[(($_sroa_01_0___p67_i_idx_i_i_i11)>>2)]=13712;
 var $_sroa_12_4___p67_i_idx3_i_i_i12=(($__p_i_i_i_i10+4)|0);
 HEAP32[(($_sroa_12_4___p67_i_idx3_i_i_i12)>>2)]=(28);
 var $_sroa_2_8___p67_i_idx4_i_i_i13=(($__p_i_i_i_i10+8)|0);
 HEAP32[(($_sroa_2_8___p67_i_idx4_i_i_i13)>>2)]=0;
 (function() { try { __THREW__ = 0; return __ZNSt3__111__call_onceERVmPvPFvS2_E(13712,$31,260) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=10;break; } else { label=18;break; }
 case 10: 
 var $35=HEAP32[((13716)>>2)];
 var $36=((($35)-(1))|0);
 var $37=(($30+12)|0);
 var $38=HEAP32[(($37)>>2)];
 var $39=(($30+8)|0);
 var $40=HEAP32[(($39)>>2)];
 var $41=$38;
 var $42=$40;
 var $43=((($41)-($42))|0);
 var $44=$43>>2;
 var $45=($44>>>0)>($36>>>0);
 if($45){label=11;break;}else{label=12;break;}
 case 11: 
 var $46=(($40+($36<<2))|0);
 var $47=HEAP32[(($46)>>2)];
 var $48=($47|0)==0;
 if($48){label=12;break;}else{label=14;break;}
 case 12: 
 var $49=___cxa_allocate_exception(4);
 var $50=$49;
 __ZNSt8bad_castC2Ev($50);
 (function() { try { __THREW__ = 0; return ___cxa_throw($49,8960,(368)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=13;break; } else { label=18;break; }
 case 13: 
 throw "Reached an unreachable!";
 case 14: 
 var $52=$47;
 var $53=$47;
 var $54=HEAP32[(($53)>>2)];
 var $55=(($54+12)|0);
 var $56=HEAP32[(($55)>>2)];
 var $57=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$56]($52) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=15;break; } else { label=18;break; }
 case 15: 
 HEAP8[($__decimal_point)]=$57;
 var $58=HEAP32[(($53)>>2)];
 var $59=(($58+16)|0);
 var $60=HEAP32[(($59)>>2)];
 var $61=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$60]($52) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=16;break; } else { label=18;break; }
 case 16: 
 HEAP8[($__thousands_sep)]=$61;
 var $62=$47;
 var $63=HEAP32[(($62)>>2)];
 var $64=(($63+20)|0);
 var $65=HEAP32[(($64)>>2)];
 (function() { try { __THREW__ = 0; return FUNCTION_TABLE[$65]($agg_result,$52) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=17;break; } else { label=18;break; }
 case 17: 
 var $66=HEAP32[(($1)>>2)];
 var $67=(($66)|0);
 var $68=__ZNSt3__114__shared_count16__release_sharedEv($67);
 STACKTOP=sp;return;
 case 18: 
 var $70$0 = ___cxa_find_matching_catch(-1, -1); var $70$1 = tempRet0;
 var $71=HEAP32[(($1)>>2)];
 var $72=(($71)|0);
 var $73=__ZNSt3__114__shared_count16__release_sharedEv($72);
 ___resumeException($70$0)
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__19__num_getIcE19__stage2_float_loopEcRbRcPcRS4_ccRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSE_RjS4_($__ct,$__in_units,$__exp,$__a,$__a_end,$__decimal_point,$__thousands_sep,$__grouping,$__g,$__g_end,$__dc,$__atoms){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=(($__ct<<24)>>24)==(($__decimal_point<<24)>>24);
 if($1){label=2;break;}else{label=9;break;}
 case 2: 
 var $3=HEAP8[($__in_units)];
 var $4=(($3<<24)>>24)==0;
 if($4){var $_0=-1;label=36;break;}else{label=3;break;}
 case 3: 
 HEAP8[($__in_units)]=0;
 var $6=HEAP32[(($__a_end)>>2)];
 var $7=(($6+1)|0);
 HEAP32[(($__a_end)>>2)]=$7;
 HEAP8[($6)]=46;
 var $8=$__grouping;
 var $9=HEAP8[($8)];
 var $10=$9&1;
 var $11=(($10<<24)>>24)==0;
 if($11){label=5;break;}else{label=4;break;}
 case 4: 
 var $13=(($__grouping+4)|0);
 var $14=HEAP32[(($13)>>2)];
 var $18=$14;label=6;break;
 case 5: 
 var $16=($9&255);
 var $17=$16>>>1;
 var $18=$17;label=6;break;
 case 6: 
 var $18;
 var $19=($18|0)==0;
 if($19){var $_0=0;label=36;break;}else{label=7;break;}
 case 7: 
 var $21=HEAP32[(($__g_end)>>2)];
 var $22=$21;
 var $23=$__g;
 var $24=((($22)-($23))|0);
 var $25=($24|0)<160;
 if($25){label=8;break;}else{var $_0=0;label=36;break;}
 case 8: 
 var $27=HEAP32[(($__dc)>>2)];
 var $28=(($21+4)|0);
 HEAP32[(($__g_end)>>2)]=$28;
 HEAP32[(($21)>>2)]=$27;
 var $_0=0;label=36;break;
 case 9: 
 var $30=(($__ct<<24)>>24)==(($__thousands_sep<<24)>>24);
 if($30){label=10;break;}else{label=17;break;}
 case 10: 
 var $32=$__grouping;
 var $33=HEAP8[($32)];
 var $34=$33&1;
 var $35=(($34<<24)>>24)==0;
 if($35){label=12;break;}else{label=11;break;}
 case 11: 
 var $37=(($__grouping+4)|0);
 var $38=HEAP32[(($37)>>2)];
 var $42=$38;label=13;break;
 case 12: 
 var $40=($33&255);
 var $41=$40>>>1;
 var $42=$41;label=13;break;
 case 13: 
 var $42;
 var $43=($42|0)==0;
 if($43){label=17;break;}else{label=14;break;}
 case 14: 
 var $45=HEAP8[($__in_units)];
 var $46=(($45<<24)>>24)==0;
 if($46){var $_0=-1;label=36;break;}else{label=15;break;}
 case 15: 
 var $48=HEAP32[(($__g_end)>>2)];
 var $49=$48;
 var $50=$__g;
 var $51=((($49)-($50))|0);
 var $52=($51|0)<160;
 if($52){label=16;break;}else{var $_0=0;label=36;break;}
 case 16: 
 var $54=HEAP32[(($__dc)>>2)];
 var $55=(($48+4)|0);
 HEAP32[(($__g_end)>>2)]=$55;
 HEAP32[(($48)>>2)]=$54;
 HEAP32[(($__dc)>>2)]=0;
 var $_0=0;label=36;break;
 case 17: 
 var $57=(($__atoms+32)|0);
 var $_0_i=$__atoms;label=18;break;
 case 18: 
 var $_0_i;
 var $59=($_0_i|0)==($57|0);
 if($59){var $_0_lcssa_i=$57;label=20;break;}else{label=19;break;}
 case 19: 
 var $61=HEAP8[($_0_i)];
 var $62=(($61<<24)>>24)==(($__ct<<24)>>24);
 var $63=(($_0_i+1)|0);
 if($62){var $_0_lcssa_i=$_0_i;label=20;break;}else{var $_0_i=$63;label=18;break;}
 case 20: 
 var $_0_lcssa_i;
 var $64=$_0_lcssa_i;
 var $65=$__atoms;
 var $66=((($64)-($65))|0);
 var $67=($66|0)>31;
 if($67){var $_0=-1;label=36;break;}else{label=21;break;}
 case 21: 
 var $69=((10592+$66)|0);
 var $70=HEAP8[($69)];
 if(($66|0)==25|($66|0)==24){ label=22;break;}else if(($66|0)==22|($66|0)==23){ label=25;break;}else{label=26;break;}
 case 22: 
 var $72=HEAP32[(($__a_end)>>2)];
 var $73=($72|0)==($__a|0);
 if($73){label=24;break;}else{label=23;break;}
 case 23: 
 var $75=((($72)-(1))|0);
 var $76=HEAP8[($75)];
 var $77=($76&255);
 var $78=$77&95;
 var $79=HEAP8[($__exp)];
 var $80=($79&255);
 var $81=$80&127;
 var $82=($78|0)==($81|0);
 if($82){label=24;break;}else{var $_0=-1;label=36;break;}
 case 24: 
 var $84=(($72+1)|0);
 HEAP32[(($__a_end)>>2)]=$84;
 HEAP8[($72)]=$70;
 var $_0=0;label=36;break;
 case 25: 
 HEAP8[($__exp)]=80;
 var $85=HEAP32[(($__a_end)>>2)];
 var $86=(($85+1)|0);
 HEAP32[(($__a_end)>>2)]=$86;
 HEAP8[($85)]=$70;
 var $_0=0;label=36;break;
 case 26: 
 var $88=($70&255);
 var $89=$88&95;
 var $90=HEAP8[($__exp)];
 var $91=(($90<<24)>>24);
 var $92=($89|0)==($91|0);
 if($92){label=27;break;}else{label=34;break;}
 case 27: 
 var $94=$90|-128;
 HEAP8[($__exp)]=$94;
 var $95=HEAP8[($__in_units)];
 var $96=(($95<<24)>>24)==0;
 if($96){label=34;break;}else{label=28;break;}
 case 28: 
 HEAP8[($__in_units)]=0;
 var $98=$__grouping;
 var $99=HEAP8[($98)];
 var $100=$99&1;
 var $101=(($100<<24)>>24)==0;
 if($101){label=30;break;}else{label=29;break;}
 case 29: 
 var $103=(($__grouping+4)|0);
 var $104=HEAP32[(($103)>>2)];
 var $108=$104;label=31;break;
 case 30: 
 var $106=($99&255);
 var $107=$106>>>1;
 var $108=$107;label=31;break;
 case 31: 
 var $108;
 var $109=($108|0)==0;
 if($109){label=34;break;}else{label=32;break;}
 case 32: 
 var $111=HEAP32[(($__g_end)>>2)];
 var $112=$111;
 var $113=$__g;
 var $114=((($112)-($113))|0);
 var $115=($114|0)<160;
 if($115){label=33;break;}else{label=34;break;}
 case 33: 
 var $117=HEAP32[(($__dc)>>2)];
 var $118=(($111+4)|0);
 HEAP32[(($__g_end)>>2)]=$118;
 HEAP32[(($111)>>2)]=$117;
 label=34;break;
 case 34: 
 var $120=HEAP32[(($__a_end)>>2)];
 var $121=(($120+1)|0);
 HEAP32[(($__a_end)>>2)]=$121;
 HEAP8[($120)]=$70;
 var $122=($66|0)>21;
 if($122){var $_0=0;label=36;break;}else{label=35;break;}
 case 35: 
 var $124=HEAP32[(($__dc)>>2)];
 var $125=((($124)+(1))|0);
 HEAP32[(($__dc)>>2)]=$125;
 var $_0=0;label=36;break;
 case 36: 
 var $_0;
 return $_0;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__19__num_getIwE17__stage2_int_prepERNS_8ios_baseEPwRw($agg_result,$__iob,$__atoms,$__thousands_sep){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+40)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $__p_i_i_i_i8=sp;
 var $__p_i_i_i_i=(sp)+(16);
 var $__loc=(sp)+(32);
 __ZNKSt3__18ios_base6getlocEv($__loc,$__iob);
 var $1=(($__loc)|0);
 var $2=HEAP32[(($1)>>2)];
 var $3=$__p_i_i_i_i;
 var $4=HEAP32[((14088)>>2)];
 var $5=($4|0)==-1;
 if($5){label=3;break;}else{label=2;break;}
 case 2: 
 var $_sroa_01_0___p67_i_idx_i_i_i=(($__p_i_i_i_i)|0);
 HEAP32[(($_sroa_01_0___p67_i_idx_i_i_i)>>2)]=14088;
 var $_sroa_12_4___p67_i_idx3_i_i_i=(($__p_i_i_i_i+4)|0);
 HEAP32[(($_sroa_12_4___p67_i_idx3_i_i_i)>>2)]=(28);
 var $_sroa_2_8___p67_i_idx4_i_i_i=(($__p_i_i_i_i+8)|0);
 HEAP32[(($_sroa_2_8___p67_i_idx4_i_i_i)>>2)]=0;
 (function() { try { __THREW__ = 0; return __ZNSt3__111__call_onceERVmPvPFvS2_E(14088,$3,260) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=3;break; } else { label=17;break; }
 case 3: 
 var $7=HEAP32[((14092)>>2)];
 var $8=((($7)-(1))|0);
 var $9=(($2+12)|0);
 var $10=HEAP32[(($9)>>2)];
 var $11=(($2+8)|0);
 var $12=HEAP32[(($11)>>2)];
 var $13=$10;
 var $14=$12;
 var $15=((($13)-($14))|0);
 var $16=$15>>2;
 var $17=($16>>>0)>($8>>>0);
 if($17){label=4;break;}else{label=5;break;}
 case 4: 
 var $18=(($12+($8<<2))|0);
 var $19=HEAP32[(($18)>>2)];
 var $20=($19|0)==0;
 if($20){label=5;break;}else{label=7;break;}
 case 5: 
 var $21=___cxa_allocate_exception(4);
 var $22=$21;
 __ZNSt8bad_castC2Ev($22);
 (function() { try { __THREW__ = 0; return ___cxa_throw($21,8960,(368)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=6;break; } else { label=17;break; }
 case 6: 
 throw "Reached an unreachable!";
 case 7: 
 var $24=$19;
 var $25=$19;
 var $26=HEAP32[(($25)>>2)];
 var $27=(($26+48)|0);
 var $28=HEAP32[(($27)>>2)];
 var $29=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$28]($24,10592,10618,$__atoms) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=8;break; } else { label=17;break; }
 case 8: 
 var $30=HEAP32[(($1)>>2)];
 var $31=$__p_i_i_i_i8;
 var $32=HEAP32[((13704)>>2)];
 var $33=($32|0)==-1;
 if($33){label=10;break;}else{label=9;break;}
 case 9: 
 var $_sroa_01_0___p67_i_idx_i_i_i9=(($__p_i_i_i_i8)|0);
 HEAP32[(($_sroa_01_0___p67_i_idx_i_i_i9)>>2)]=13704;
 var $_sroa_12_4___p67_i_idx3_i_i_i10=(($__p_i_i_i_i8+4)|0);
 HEAP32[(($_sroa_12_4___p67_i_idx3_i_i_i10)>>2)]=(28);
 var $_sroa_2_8___p67_i_idx4_i_i_i11=(($__p_i_i_i_i8+8)|0);
 HEAP32[(($_sroa_2_8___p67_i_idx4_i_i_i11)>>2)]=0;
 (function() { try { __THREW__ = 0; return __ZNSt3__111__call_onceERVmPvPFvS2_E(13704,$31,260) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=10;break; } else { label=17;break; }
 case 10: 
 var $35=HEAP32[((13708)>>2)];
 var $36=((($35)-(1))|0);
 var $37=(($30+12)|0);
 var $38=HEAP32[(($37)>>2)];
 var $39=(($30+8)|0);
 var $40=HEAP32[(($39)>>2)];
 var $41=$38;
 var $42=$40;
 var $43=((($41)-($42))|0);
 var $44=$43>>2;
 var $45=($44>>>0)>($36>>>0);
 if($45){label=11;break;}else{label=12;break;}
 case 11: 
 var $46=(($40+($36<<2))|0);
 var $47=HEAP32[(($46)>>2)];
 var $48=($47|0)==0;
 if($48){label=12;break;}else{label=14;break;}
 case 12: 
 var $49=___cxa_allocate_exception(4);
 var $50=$49;
 __ZNSt8bad_castC2Ev($50);
 (function() { try { __THREW__ = 0; return ___cxa_throw($49,8960,(368)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=13;break; } else { label=17;break; }
 case 13: 
 throw "Reached an unreachable!";
 case 14: 
 var $52=$47;
 var $53=$47;
 var $54=HEAP32[(($53)>>2)];
 var $55=(($54+16)|0);
 var $56=HEAP32[(($55)>>2)];
 var $57=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$56]($52) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=15;break; } else { label=17;break; }
 case 15: 
 HEAP32[(($__thousands_sep)>>2)]=$57;
 var $58=$47;
 var $59=HEAP32[(($58)>>2)];
 var $60=(($59+20)|0);
 var $61=HEAP32[(($60)>>2)];
 (function() { try { __THREW__ = 0; return FUNCTION_TABLE[$61]($agg_result,$52) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=16;break; } else { label=17;break; }
 case 16: 
 var $62=HEAP32[(($1)>>2)];
 var $63=(($62)|0);
 var $64=__ZNSt3__114__shared_count16__release_sharedEv($63);
 STACKTOP=sp;return;
 case 17: 
 var $66$0 = ___cxa_find_matching_catch(-1, -1); var $66$1 = tempRet0;
 var $67=HEAP32[(($1)>>2)];
 var $68=(($67)|0);
 var $69=__ZNSt3__114__shared_count16__release_sharedEv($68);
 ___resumeException($66$0)
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__19__num_getIwE19__stage2_float_prepERNS_8ios_baseEPwRwS5_($agg_result,$__iob,$__atoms,$__decimal_point,$__thousands_sep){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+40)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $__p_i_i_i_i10=sp;
 var $__p_i_i_i_i=(sp)+(16);
 var $__loc=(sp)+(32);
 __ZNKSt3__18ios_base6getlocEv($__loc,$__iob);
 var $1=(($__loc)|0);
 var $2=HEAP32[(($1)>>2)];
 var $3=$__p_i_i_i_i;
 var $4=HEAP32[((14088)>>2)];
 var $5=($4|0)==-1;
 if($5){label=3;break;}else{label=2;break;}
 case 2: 
 var $_sroa_01_0___p67_i_idx_i_i_i=(($__p_i_i_i_i)|0);
 HEAP32[(($_sroa_01_0___p67_i_idx_i_i_i)>>2)]=14088;
 var $_sroa_12_4___p67_i_idx3_i_i_i=(($__p_i_i_i_i+4)|0);
 HEAP32[(($_sroa_12_4___p67_i_idx3_i_i_i)>>2)]=(28);
 var $_sroa_2_8___p67_i_idx4_i_i_i=(($__p_i_i_i_i+8)|0);
 HEAP32[(($_sroa_2_8___p67_i_idx4_i_i_i)>>2)]=0;
 (function() { try { __THREW__ = 0; return __ZNSt3__111__call_onceERVmPvPFvS2_E(14088,$3,260) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=3;break; } else { label=18;break; }
 case 3: 
 var $7=HEAP32[((14092)>>2)];
 var $8=((($7)-(1))|0);
 var $9=(($2+12)|0);
 var $10=HEAP32[(($9)>>2)];
 var $11=(($2+8)|0);
 var $12=HEAP32[(($11)>>2)];
 var $13=$10;
 var $14=$12;
 var $15=((($13)-($14))|0);
 var $16=$15>>2;
 var $17=($16>>>0)>($8>>>0);
 if($17){label=4;break;}else{label=5;break;}
 case 4: 
 var $18=(($12+($8<<2))|0);
 var $19=HEAP32[(($18)>>2)];
 var $20=($19|0)==0;
 if($20){label=5;break;}else{label=7;break;}
 case 5: 
 var $21=___cxa_allocate_exception(4);
 var $22=$21;
 __ZNSt8bad_castC2Ev($22);
 (function() { try { __THREW__ = 0; return ___cxa_throw($21,8960,(368)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=6;break; } else { label=18;break; }
 case 6: 
 throw "Reached an unreachable!";
 case 7: 
 var $24=$19;
 var $25=$19;
 var $26=HEAP32[(($25)>>2)];
 var $27=(($26+48)|0);
 var $28=HEAP32[(($27)>>2)];
 var $29=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$28]($24,10592,10624,$__atoms) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=8;break; } else { label=18;break; }
 case 8: 
 var $30=HEAP32[(($1)>>2)];
 var $31=$__p_i_i_i_i10;
 var $32=HEAP32[((13704)>>2)];
 var $33=($32|0)==-1;
 if($33){label=10;break;}else{label=9;break;}
 case 9: 
 var $_sroa_01_0___p67_i_idx_i_i_i11=(($__p_i_i_i_i10)|0);
 HEAP32[(($_sroa_01_0___p67_i_idx_i_i_i11)>>2)]=13704;
 var $_sroa_12_4___p67_i_idx3_i_i_i12=(($__p_i_i_i_i10+4)|0);
 HEAP32[(($_sroa_12_4___p67_i_idx3_i_i_i12)>>2)]=(28);
 var $_sroa_2_8___p67_i_idx4_i_i_i13=(($__p_i_i_i_i10+8)|0);
 HEAP32[(($_sroa_2_8___p67_i_idx4_i_i_i13)>>2)]=0;
 (function() { try { __THREW__ = 0; return __ZNSt3__111__call_onceERVmPvPFvS2_E(13704,$31,260) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=10;break; } else { label=18;break; }
 case 10: 
 var $35=HEAP32[((13708)>>2)];
 var $36=((($35)-(1))|0);
 var $37=(($30+12)|0);
 var $38=HEAP32[(($37)>>2)];
 var $39=(($30+8)|0);
 var $40=HEAP32[(($39)>>2)];
 var $41=$38;
 var $42=$40;
 var $43=((($41)-($42))|0);
 var $44=$43>>2;
 var $45=($44>>>0)>($36>>>0);
 if($45){label=11;break;}else{label=12;break;}
 case 11: 
 var $46=(($40+($36<<2))|0);
 var $47=HEAP32[(($46)>>2)];
 var $48=($47|0)==0;
 if($48){label=12;break;}else{label=14;break;}
 case 12: 
 var $49=___cxa_allocate_exception(4);
 var $50=$49;
 __ZNSt8bad_castC2Ev($50);
 (function() { try { __THREW__ = 0; return ___cxa_throw($49,8960,(368)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=13;break; } else { label=18;break; }
 case 13: 
 throw "Reached an unreachable!";
 case 14: 
 var $52=$47;
 var $53=$47;
 var $54=HEAP32[(($53)>>2)];
 var $55=(($54+12)|0);
 var $56=HEAP32[(($55)>>2)];
 var $57=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$56]($52) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=15;break; } else { label=18;break; }
 case 15: 
 HEAP32[(($__decimal_point)>>2)]=$57;
 var $58=HEAP32[(($53)>>2)];
 var $59=(($58+16)|0);
 var $60=HEAP32[(($59)>>2)];
 var $61=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$60]($52) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=16;break; } else { label=18;break; }
 case 16: 
 HEAP32[(($__thousands_sep)>>2)]=$61;
 var $62=$47;
 var $63=HEAP32[(($62)>>2)];
 var $64=(($63+20)|0);
 var $65=HEAP32[(($64)>>2)];
 (function() { try { __THREW__ = 0; return FUNCTION_TABLE[$65]($agg_result,$52) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=17;break; } else { label=18;break; }
 case 17: 
 var $66=HEAP32[(($1)>>2)];
 var $67=(($66)|0);
 var $68=__ZNSt3__114__shared_count16__release_sharedEv($67);
 STACKTOP=sp;return;
 case 18: 
 var $70$0 = ___cxa_find_matching_catch(-1, -1); var $70$1 = tempRet0;
 var $71=HEAP32[(($1)>>2)];
 var $72=(($71)|0);
 var $73=__ZNSt3__114__shared_count16__release_sharedEv($72);
 ___resumeException($70$0)
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__19__num_getIwE19__stage2_float_loopEwRbRcPcRS4_wwRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSE_RjPw($__ct,$__in_units,$__exp,$__a,$__a_end,$__decimal_point,$__thousands_sep,$__grouping,$__g,$__g_end,$__dc,$__atoms){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=($__ct|0)==($__decimal_point|0);
 if($1){label=2;break;}else{label=9;break;}
 case 2: 
 var $3=HEAP8[($__in_units)];
 var $4=(($3<<24)>>24)==0;
 if($4){var $_0=-1;label=36;break;}else{label=3;break;}
 case 3: 
 HEAP8[($__in_units)]=0;
 var $6=HEAP32[(($__a_end)>>2)];
 var $7=(($6+1)|0);
 HEAP32[(($__a_end)>>2)]=$7;
 HEAP8[($6)]=46;
 var $8=$__grouping;
 var $9=HEAP8[($8)];
 var $10=$9&1;
 var $11=(($10<<24)>>24)==0;
 if($11){label=5;break;}else{label=4;break;}
 case 4: 
 var $13=(($__grouping+4)|0);
 var $14=HEAP32[(($13)>>2)];
 var $18=$14;label=6;break;
 case 5: 
 var $16=($9&255);
 var $17=$16>>>1;
 var $18=$17;label=6;break;
 case 6: 
 var $18;
 var $19=($18|0)==0;
 if($19){var $_0=0;label=36;break;}else{label=7;break;}
 case 7: 
 var $21=HEAP32[(($__g_end)>>2)];
 var $22=$21;
 var $23=$__g;
 var $24=((($22)-($23))|0);
 var $25=($24|0)<160;
 if($25){label=8;break;}else{var $_0=0;label=36;break;}
 case 8: 
 var $27=HEAP32[(($__dc)>>2)];
 var $28=(($21+4)|0);
 HEAP32[(($__g_end)>>2)]=$28;
 HEAP32[(($21)>>2)]=$27;
 var $_0=0;label=36;break;
 case 9: 
 var $30=($__ct|0)==($__thousands_sep|0);
 if($30){label=10;break;}else{label=17;break;}
 case 10: 
 var $32=$__grouping;
 var $33=HEAP8[($32)];
 var $34=$33&1;
 var $35=(($34<<24)>>24)==0;
 if($35){label=12;break;}else{label=11;break;}
 case 11: 
 var $37=(($__grouping+4)|0);
 var $38=HEAP32[(($37)>>2)];
 var $42=$38;label=13;break;
 case 12: 
 var $40=($33&255);
 var $41=$40>>>1;
 var $42=$41;label=13;break;
 case 13: 
 var $42;
 var $43=($42|0)==0;
 if($43){label=17;break;}else{label=14;break;}
 case 14: 
 var $45=HEAP8[($__in_units)];
 var $46=(($45<<24)>>24)==0;
 if($46){var $_0=-1;label=36;break;}else{label=15;break;}
 case 15: 
 var $48=HEAP32[(($__g_end)>>2)];
 var $49=$48;
 var $50=$__g;
 var $51=((($49)-($50))|0);
 var $52=($51|0)<160;
 if($52){label=16;break;}else{var $_0=0;label=36;break;}
 case 16: 
 var $54=HEAP32[(($__dc)>>2)];
 var $55=(($48+4)|0);
 HEAP32[(($__g_end)>>2)]=$55;
 HEAP32[(($48)>>2)]=$54;
 HEAP32[(($__dc)>>2)]=0;
 var $_0=0;label=36;break;
 case 17: 
 var $57=(($__atoms+128)|0);
 var $_0_i=$__atoms;label=18;break;
 case 18: 
 var $_0_i;
 var $59=($_0_i|0)==($57|0);
 if($59){var $_0_lcssa_i=$57;label=20;break;}else{label=19;break;}
 case 19: 
 var $61=HEAP32[(($_0_i)>>2)];
 var $62=($61|0)==($__ct|0);
 var $63=(($_0_i+4)|0);
 if($62){var $_0_lcssa_i=$_0_i;label=20;break;}else{var $_0_i=$63;label=18;break;}
 case 20: 
 var $_0_lcssa_i;
 var $64=$_0_lcssa_i;
 var $65=$__atoms;
 var $66=((($64)-($65))|0);
 var $67=$66>>2;
 var $68=($66|0)>124;
 if($68){var $_0=-1;label=36;break;}else{label=21;break;}
 case 21: 
 var $70=((10592+$67)|0);
 var $71=HEAP8[($70)];
 if(($67|0)==25|($67|0)==24){ label=22;break;}else if(($67|0)==22|($67|0)==23){ label=25;break;}else{label=26;break;}
 case 22: 
 var $73=HEAP32[(($__a_end)>>2)];
 var $74=($73|0)==($__a|0);
 if($74){label=24;break;}else{label=23;break;}
 case 23: 
 var $76=((($73)-(1))|0);
 var $77=HEAP8[($76)];
 var $78=($77&255);
 var $79=$78&95;
 var $80=HEAP8[($__exp)];
 var $81=($80&255);
 var $82=$81&127;
 var $83=($79|0)==($82|0);
 if($83){label=24;break;}else{var $_0=-1;label=36;break;}
 case 24: 
 var $85=(($73+1)|0);
 HEAP32[(($__a_end)>>2)]=$85;
 HEAP8[($73)]=$71;
 var $_0=0;label=36;break;
 case 25: 
 HEAP8[($__exp)]=80;
 label=34;break;
 case 26: 
 var $88=($71&255);
 var $89=$88&95;
 var $90=HEAP8[($__exp)];
 var $91=(($90<<24)>>24);
 var $92=($89|0)==($91|0);
 if($92){label=27;break;}else{label=34;break;}
 case 27: 
 var $94=$90|-128;
 HEAP8[($__exp)]=$94;
 var $95=HEAP8[($__in_units)];
 var $96=(($95<<24)>>24)==0;
 if($96){label=34;break;}else{label=28;break;}
 case 28: 
 HEAP8[($__in_units)]=0;
 var $98=$__grouping;
 var $99=HEAP8[($98)];
 var $100=$99&1;
 var $101=(($100<<24)>>24)==0;
 if($101){label=30;break;}else{label=29;break;}
 case 29: 
 var $103=(($__grouping+4)|0);
 var $104=HEAP32[(($103)>>2)];
 var $108=$104;label=31;break;
 case 30: 
 var $106=($99&255);
 var $107=$106>>>1;
 var $108=$107;label=31;break;
 case 31: 
 var $108;
 var $109=($108|0)==0;
 if($109){label=34;break;}else{label=32;break;}
 case 32: 
 var $111=HEAP32[(($__g_end)>>2)];
 var $112=$111;
 var $113=$__g;
 var $114=((($112)-($113))|0);
 var $115=($114|0)<160;
 if($115){label=33;break;}else{label=34;break;}
 case 33: 
 var $117=HEAP32[(($__dc)>>2)];
 var $118=(($111+4)|0);
 HEAP32[(($__g_end)>>2)]=$118;
 HEAP32[(($111)>>2)]=$117;
 label=34;break;
 case 34: 
 var $120=HEAP32[(($__a_end)>>2)];
 var $121=(($120+1)|0);
 HEAP32[(($__a_end)>>2)]=$121;
 HEAP8[($120)]=$71;
 var $122=($66|0)>84;
 if($122){var $_0=0;label=36;break;}else{label=35;break;}
 case 35: 
 var $124=HEAP32[(($__dc)>>2)];
 var $125=((($124)+(1))|0);
 HEAP32[(($__dc)>>2)]=$125;
 var $_0=0;label=36;break;
 case 36: 
 var $_0;
 return $_0;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEED0Ev($this){
 var label=0;


 var $1=(($this)|0);
 __ZNSt3__114__shared_countD2Ev($1);
 var $2=$this;
 __ZdlPv($2);
 return;
}


function __ZNSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEED1Ev($this){
 var label=0;


 var $1=(($this)|0);
 __ZNSt3__114__shared_countD2Ev($1);
 return;
}


function __ZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcb($agg_result,$this,$__s,$__iob,$__fl,$__v){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+48)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var tempParam = $__s; $__s=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__s)>>2)]=HEAP32[((tempParam)>>2)];
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $__p_i_i_i_i=sp;
 var $1=(sp)+(16);
 var $2=(sp)+(24);
 var $__nm=(sp)+(32);
 var $3=(($__iob+4)|0);
 var $4=HEAP32[(($3)>>2)];
 var $5=$4&1;
 var $6=($5|0)==0;
 if($6){label=2;break;}else{label=3;break;}
 case 2: 
 var $8=$this;
 var $9=HEAP32[(($8)>>2)];
 var $10=(($9+24)|0);
 var $11=HEAP32[(($10)>>2)];
 var $12=(($__s)|0);
 var $13=HEAP32[(($12)>>2)];
 var $14=(($1)|0);
 HEAP32[(($14)>>2)]=$13;
 var $15=($__v&1);
 FUNCTION_TABLE[$11]($agg_result,$this,$1,$__iob,$__fl,$15);
 label=30;break;
 case 3: 
 __ZNKSt3__18ios_base6getlocEv($2,$__iob);
 var $17=(($2)|0);
 var $18=HEAP32[(($17)>>2)];
 var $19=$__p_i_i_i_i;
 var $20=HEAP32[((13712)>>2)];
 var $21=($20|0)==-1;
 if($21){label=5;break;}else{label=4;break;}
 case 4: 
 var $_sroa_01_0___p67_i_idx_i_i_i=(($__p_i_i_i_i)|0);
 HEAP32[(($_sroa_01_0___p67_i_idx_i_i_i)>>2)]=13712;
 var $_sroa_12_4___p67_i_idx3_i_i_i=(($__p_i_i_i_i+4)|0);
 HEAP32[(($_sroa_12_4___p67_i_idx3_i_i_i)>>2)]=(28);
 var $_sroa_2_8___p67_i_idx4_i_i_i=(($__p_i_i_i_i+8)|0);
 HEAP32[(($_sroa_2_8___p67_i_idx4_i_i_i)>>2)]=0;
 (function() { try { __THREW__ = 0; return __ZNSt3__111__call_onceERVmPvPFvS2_E(13712,$19,260) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=5;break; } else { label=27;break; }
 case 5: 
 var $23=HEAP32[((13716)>>2)];
 var $24=((($23)-(1))|0);
 var $25=(($18+12)|0);
 var $26=HEAP32[(($25)>>2)];
 var $27=(($18+8)|0);
 var $28=HEAP32[(($27)>>2)];
 var $29=$26;
 var $30=$28;
 var $31=((($29)-($30))|0);
 var $32=$31>>2;
 var $33=($32>>>0)>($24>>>0);
 if($33){label=6;break;}else{label=7;break;}
 case 6: 
 var $34=(($28+($24<<2))|0);
 var $35=HEAP32[(($34)>>2)];
 var $36=($35|0)==0;
 if($36){label=7;break;}else{label=9;break;}
 case 7: 
 var $37=___cxa_allocate_exception(4);
 var $38=$37;
 __ZNSt8bad_castC2Ev($38);
 (function() { try { __THREW__ = 0; return ___cxa_throw($37,8960,(368)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=8;break; } else { label=27;break; }
 case 8: 
 throw "Reached an unreachable!";
 case 9: 
 var $40=$35;
 var $41=HEAP32[(($17)>>2)];
 var $42=(($41)|0);
 var $43=__ZNSt3__114__shared_count16__release_sharedEv($42);
 var $44=$35;
 var $45=HEAP32[(($44)>>2)];
 if($__v){label=10;break;}else{label=11;break;}
 case 10: 
 var $47=(($45+24)|0);
 var $48=HEAP32[(($47)>>2)];
 FUNCTION_TABLE[$48]($__nm,$40);
 label=12;break;
 case 11: 
 var $50=(($45+28)|0);
 var $51=HEAP32[(($50)>>2)];
 FUNCTION_TABLE[$51]($__nm,$40);
 label=12;break;
 case 12: 
 var $53=$__nm;
 var $54=HEAP8[($53)];
 var $55=$54&1;
 var $56=(($55<<24)>>24)==0;
 if($56){label=14;break;}else{label=13;break;}
 case 13: 
 var $58=(($__nm+8)|0);
 var $59=HEAP32[(($58)>>2)];
 var $_pre14=$__nm;
 var $_pre15=(($_pre14+1)|0);
 var $_ph=$59;var $_pre_phi16=$_pre15;var $_pre_phi18=$58;label=15;break;
 case 14: 
 var $61=$__nm;
 var $62=(($61+1)|0);
 var $_pre17=(($__nm+8)|0);
 var $_ph=$62;var $_pre_phi16=$62;var $_pre_phi18=$_pre17;label=15;break;
 case 15: 
 var $_pre_phi18;
 var $_pre_phi16;
 var $_ph;
 var $63=(($__s)|0);
 var $64=(($__nm+4)|0);
 var $66=$_ph;var $65=$54;label=16;break;
 case 16: 
 var $65;
 var $66;
 var $67=$65&1;
 var $68=(($67<<24)>>24)==0;
 if($68){label=18;break;}else{label=17;break;}
 case 17: 
 var $70=HEAP32[(($_pre_phi18)>>2)];
 var $71=HEAP32[(($64)>>2)];
 var $76=$71;var $75=$70;label=19;break;
 case 18: 
 var $73=($65&255);
 var $74=$73>>>1;
 var $76=$74;var $75=$_pre_phi16;label=19;break;
 case 19: 
 var $75;
 var $76;
 var $77=(($75+$76)|0);
 var $78=($66|0)==($77|0);
 if($78){label=29;break;}else{label=20;break;}
 case 20: 
 var $80=HEAP8[($66)];
 var $81=HEAP32[(($63)>>2)];
 var $82=($81|0)==0;
 if($82){label=26;break;}else{label=21;break;}
 case 21: 
 var $84=(($81+24)|0);
 var $85=HEAP32[(($84)>>2)];
 var $86=(($81+28)|0);
 var $87=HEAP32[(($86)>>2)];
 var $88=($85|0)==($87|0);
 if($88){label=23;break;}else{label=22;break;}
 case 22: 
 var $89=(($85+1)|0);
 HEAP32[(($84)>>2)]=$89;
 HEAP8[($85)]=$80;
 label=26;break;
 case 23: 
 var $90=$81;
 var $91=HEAP32[(($90)>>2)];
 var $92=(($91+52)|0);
 var $93=HEAP32[(($92)>>2)];
 var $94=($80&255);
 var $95=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$93]($81,$94) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=24;break; } else { label=28;break; }
 case 24: 
 var $96=($95|0)==-1;
 if($96){label=25;break;}else{label=26;break;}
 case 25: 
 HEAP32[(($63)>>2)]=0;
 label=26;break;
 case 26: 
 var $98=(($66+1)|0);
 var $_pre=HEAP8[($53)];
 var $66=$98;var $65=$_pre;label=16;break;
 case 27: 
 var $100$0 = ___cxa_find_matching_catch(-1, -1); var $100$1 = tempRet0;
 var $101=$100$0;
 var $102=$100$1;
 var $103=HEAP32[(($17)>>2)];
 var $104=(($103)|0);
 var $105=__ZNSt3__114__shared_count16__release_sharedEv($104);
 var $_0=$101;var $_09=$102;label=31;break;
 case 28: 
 var $107$0 = ___cxa_find_matching_catch(-1, -1); var $107$1 = tempRet0;
 var $108=$107$0;
 var $109=$107$1;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__nm);
 var $_0=$108;var $_09=$109;label=31;break;
 case 29: 
 var $111=HEAP32[(($63)>>2)];
 var $112=(($agg_result)|0);
 HEAP32[(($112)>>2)]=$111;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__nm);
 label=30;break;
 case 30: 
 STACKTOP=sp;return;
 case 31: 
 var $_09;
 var $_0;
 var $115$0=$_0;
 var $115$1=0;
 var $116$0=$115$0;
 var $116$1=$_09;
 ___resumeException($116$0)
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcl($agg_result,$this,$__s,$__iob,$__fl,$__v){
 var label=0;
 var tempVarArgs=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+80)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var tempParam = $__s; $__s=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__s)>>2)]=HEAP32[((tempParam)>>2)];
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $__fmt=sp;
 var $__nar=(sp)+(8);
 var $__o=(sp)+(24);
 var $__op=(sp)+(48);
 var $__oe=(sp)+(56);
 var $1=(sp)+(64);
 var $2=(sp)+(72);
 var $3=(($__fmt)|0);
 assert(6 % 1 === 0);HEAP8[($3)]=HEAP8[(2904)];HEAP8[((($3)+(1))|0)]=HEAP8[(2905)];HEAP8[((($3)+(2))|0)]=HEAP8[(2906)];HEAP8[((($3)+(3))|0)]=HEAP8[(2907)];HEAP8[((($3)+(4))|0)]=HEAP8[(2908)];HEAP8[((($3)+(5))|0)]=HEAP8[(2909)];
 var $4=(($__fmt+1)|0);
 var $5=(($__iob+4)|0);
 var $6=HEAP32[(($5)>>2)];
 var $7=$6&2048;
 var $8=($7|0)==0;
 if($8){var $_0_i=$4;label=3;break;}else{label=2;break;}
 case 2: 
 var $10=(($__fmt+2)|0);
 HEAP8[($4)]=43;
 var $_0_i=$10;label=3;break;
 case 3: 
 var $_0_i;
 var $12=$6&512;
 var $13=($12|0)==0;
 if($13){var $_116_i_ph=$_0_i;label=5;break;}else{label=4;break;}
 case 4: 
 var $15=(($_0_i+1)|0);
 HEAP8[($_0_i)]=35;
 var $_116_i_ph=$15;label=5;break;
 case 5: 
 var $_116_i_ph;
 HEAP8[($_116_i_ph)]=108;
 var $scevgep=(($_116_i_ph+1)|0);
 var $16=$6&74;
 if(($16|0)==64){ label=6;break;}else if(($16|0)==8){ label=7;break;}else{label=10;break;}
 case 6: 
 HEAP8[($scevgep)]=111;
 label=11;break;
 case 7: 
 var $19=$6&16384;
 var $20=($19|0)==0;
 if($20){label=9;break;}else{label=8;break;}
 case 8: 
 HEAP8[($scevgep)]=88;
 label=11;break;
 case 9: 
 HEAP8[($scevgep)]=120;
 label=11;break;
 case 10: 
 HEAP8[($scevgep)]=100;
 label=11;break;
 case 11: 
 var $24=(($__nar)|0);
 var $25=HEAP8[(14656)];
 var $26=(($25<<24)>>24)==0;
 if($26){label=12;break;}else{label=16;break;}
 case 12: 
 var $28=___cxa_guard_acquire(14656);
 var $29=($28|0)==0;
 if($29){label=16;break;}else{label=13;break;}
 case 13: 
 var $31=(function() { try { __THREW__ = 0; return _newlocale(2147483647,1496,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=14;break; } else { label=15;break; }
 case 14: 
 HEAP32[((12664)>>2)]=$31;

 label=16;break;
 case 15: 
 var $34$0 = ___cxa_find_matching_catch(-1, -1); var $34$1 = tempRet0;

 ___resumeException($34$0)
 case 16: 
 var $35=HEAP32[((12664)>>2)];
 var $36=__ZNSt3__112__snprintf_lEPcjP15__locale_structPKcz($24,12,$35,$3,(tempVarArgs=STACKTOP,STACKTOP = (STACKTOP + 8)|0,(assert((STACKTOP|0) < (STACK_MAX|0))|0),HEAP32[((tempVarArgs)>>2)]=$__v,tempVarArgs)); STACKTOP=tempVarArgs;
 var $37=(($__nar+$36)|0);
 var $38=HEAP32[(($5)>>2)];
 var $39=$38&176;
 if(($39|0)==16){ label=17;break;}else if(($39|0)==32){ var $_0_i10=$37;label=23;break;}else{label=22;break;}
 case 17: 
 var $41=HEAP8[($24)];
 if((($41<<24)>>24)==45|(($41<<24)>>24)==43){ label=18;break;}else{label=19;break;}
 case 18: 
 var $43=(($__nar+1)|0);
 var $_0_i10=$43;label=23;break;
 case 19: 
 var $45=($36|0)>1;
 var $46=(($41<<24)>>24)==48;
 var $or_cond_i=$45&$46;
 if($or_cond_i){label=20;break;}else{label=22;break;}
 case 20: 
 var $48=(($__nar+1)|0);
 var $49=HEAP8[($48)];
 if((($49<<24)>>24)==120|(($49<<24)>>24)==88){ label=21;break;}else{label=22;break;}
 case 21: 
 var $51=(($__nar+2)|0);
 var $_0_i10=$51;label=23;break;
 case 22: 
 var $_0_i10=$24;label=23;break;
 case 23: 
 var $_0_i10;
 var $53=(($__o)|0);
 __ZNKSt3__18ios_base6getlocEv($1,$__iob);
 (function() { try { __THREW__ = 0; return __ZNSt3__19__num_putIcE21__widen_and_group_intEPcS2_S2_S2_RS2_S3_RKNS_6localeE($24,$_0_i10,$37,$53,$__op,$__oe,$1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=24;break; } else { label=25;break; }
 case 24: 
 var $55=(($1)|0);
 var $56=HEAP32[(($55)>>2)];
 var $57=(($56)|0);
 var $58=__ZNSt3__114__shared_count16__release_sharedEv($57);
 var $59=(($__s)|0);
 var $60=HEAP32[(($59)>>2)];
 var $61=(($2)|0);
 HEAP32[(($61)>>2)]=$60;
 var $62=HEAP32[(($__op)>>2)];
 var $63=HEAP32[(($__oe)>>2)];
 __ZNSt3__116__pad_and_outputIcNS_11char_traitsIcEEEENS_19ostreambuf_iteratorIT_T0_EES6_PKS4_S8_S8_RNS_8ios_baseES4_($agg_result,$2,$53,$62,$63,$__iob,$__fl);
 STACKTOP=sp;return;
 case 25: 
 var $65$0 = ___cxa_find_matching_catch(-1, -1); var $65$1 = tempRet0;
 var $66=(($1)|0);
 var $67=HEAP32[(($66)>>2)];
 var $68=(($67)|0);
 var $69=__ZNSt3__114__shared_count16__release_sharedEv($68);
 ___resumeException($65$0)
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__112__snprintf_lEPcjP15__locale_structPKcz($__s,$__n,$__l,$__format,varrp){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+16)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $__va=sp;
 var $1=(($__va)|0);
 var $2=$__va;
 HEAP32[(($2)>>2)]=varrp;HEAP32[((($2)+(4))>>2)]=0;
 var $3=_uselocale($__l);
 var $4=_vsnprintf($__s,$__n,$__format,$1);

 var $5=($3|0)==0;
 if($5){label=4;break;}else{label=2;break;}
 case 2: 
 var $7=(function() { try { __THREW__ = 0; return _uselocale($3) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=4;break; } else { label=3;break; }
 case 3: 
 var $9$0 = ___cxa_find_matching_catch(-1, -1,0); var $9$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
 case 4: 
 STACKTOP=sp;return $4;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__19__num_putIcE21__widen_and_group_intEPcS2_S2_S2_RS2_S3_RKNS_6localeE($__nb,$__np,$__ne,$__ob,$__op,$__oe,$__loc){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+48)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $__p_i_i_i_i55=sp;
 var $__p_i_i_i_i=(sp)+(16);
 var $__grouping=(sp)+(32);
 var $1=(($__loc)|0);
 var $2=HEAP32[(($1)>>2)];
 var $3=$__p_i_i_i_i;
 var $4=HEAP32[((14096)>>2)];
 var $5=($4|0)==-1;
 if($5){label=3;break;}else{label=2;break;}
 case 2: 
 var $_sroa_01_0___p67_i_idx_i_i_i=(($__p_i_i_i_i)|0);
 HEAP32[(($_sroa_01_0___p67_i_idx_i_i_i)>>2)]=14096;
 var $_sroa_12_4___p67_i_idx3_i_i_i=(($__p_i_i_i_i+4)|0);
 HEAP32[(($_sroa_12_4___p67_i_idx3_i_i_i)>>2)]=(28);
 var $_sroa_2_8___p67_i_idx4_i_i_i=(($__p_i_i_i_i+8)|0);
 HEAP32[(($_sroa_2_8___p67_i_idx4_i_i_i)>>2)]=0;
 __ZNSt3__111__call_onceERVmPvPFvS2_E(14096,$3,260);
 label=3;break;
 case 3: 
 var $7=HEAP32[((14100)>>2)];
 var $8=((($7)-(1))|0);
 var $9=(($2+12)|0);
 var $10=HEAP32[(($9)>>2)];
 var $11=(($2+8)|0);
 var $12=HEAP32[(($11)>>2)];
 var $13=$10;
 var $14=$12;
 var $15=((($13)-($14))|0);
 var $16=$15>>2;
 var $17=($16>>>0)>($8>>>0);
 if($17){label=4;break;}else{label=5;break;}
 case 4: 
 var $18=(($12+($8<<2))|0);
 var $19=HEAP32[(($18)>>2)];
 var $20=($19|0)==0;
 if($20){label=5;break;}else{label=6;break;}
 case 5: 
 var $21=___cxa_allocate_exception(4);
 var $22=$21;
 __ZNSt8bad_castC2Ev($22);
 ___cxa_throw($21,8960,(368));
 throw "Reached an unreachable!";
 case 6: 
 var $23=$19;
 var $24=HEAP32[(($1)>>2)];
 var $25=$__p_i_i_i_i55;
 var $26=HEAP32[((13712)>>2)];
 var $27=($26|0)==-1;
 if($27){label=8;break;}else{label=7;break;}
 case 7: 
 var $_sroa_01_0___p67_i_idx_i_i_i56=(($__p_i_i_i_i55)|0);
 HEAP32[(($_sroa_01_0___p67_i_idx_i_i_i56)>>2)]=13712;
 var $_sroa_12_4___p67_i_idx3_i_i_i57=(($__p_i_i_i_i55+4)|0);
 HEAP32[(($_sroa_12_4___p67_i_idx3_i_i_i57)>>2)]=(28);
 var $_sroa_2_8___p67_i_idx4_i_i_i58=(($__p_i_i_i_i55+8)|0);
 HEAP32[(($_sroa_2_8___p67_i_idx4_i_i_i58)>>2)]=0;
 __ZNSt3__111__call_onceERVmPvPFvS2_E(13712,$25,260);
 label=8;break;
 case 8: 
 var $29=HEAP32[((13716)>>2)];
 var $30=((($29)-(1))|0);
 var $31=(($24+12)|0);
 var $32=HEAP32[(($31)>>2)];
 var $33=(($24+8)|0);
 var $34=HEAP32[(($33)>>2)];
 var $35=$32;
 var $36=$34;
 var $37=((($35)-($36))|0);
 var $38=$37>>2;
 var $39=($38>>>0)>($30>>>0);
 if($39){label=9;break;}else{label=10;break;}
 case 9: 
 var $40=(($34+($30<<2))|0);
 var $41=HEAP32[(($40)>>2)];
 var $42=($41|0)==0;
 if($42){label=10;break;}else{label=11;break;}
 case 10: 
 var $43=___cxa_allocate_exception(4);
 var $44=$43;
 __ZNSt8bad_castC2Ev($44);
 ___cxa_throw($43,8960,(368));
 throw "Reached an unreachable!";
 case 11: 
 var $45=$41;
 var $46=$41;
 var $47=HEAP32[(($46)>>2)];
 var $48=(($47+20)|0);
 var $49=HEAP32[(($48)>>2)];
 FUNCTION_TABLE[$49]($__grouping,$45);
 var $50=$__grouping;
 var $51=HEAP8[($50)];
 var $52=$51&1;
 var $53=(($52<<24)>>24)==0;
 if($53){label=13;break;}else{label=12;break;}
 case 12: 
 var $55=(($__grouping+4)|0);
 var $56=HEAP32[(($55)>>2)];
 var $60=$56;label=14;break;
 case 13: 
 var $58=($51&255);
 var $59=$58>>>1;
 var $60=$59;label=14;break;
 case 14: 
 var $60;
 var $61=($60|0)==0;
 if($61){label=15;break;}else{label=20;break;}
 case 15: 
 var $63=$19;
 var $64=HEAP32[(($63)>>2)];
 var $65=(($64+32)|0);
 var $66=HEAP32[(($65)>>2)];
 var $67=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$66]($23,$__nb,$__ne,$__ob) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=16;break; } else { label=18;break; }
 case 16: 
 var $68=$__ne;
 var $69=$__nb;
 var $70=((($68)-($69))|0);
 var $71=(($__ob+$70)|0);
 HEAP32[(($__oe)>>2)]=$71;
 label=46;break;
 case 17: 
 var $lpad_loopexit$0 = ___cxa_find_matching_catch(-1, -1); var $lpad_loopexit$1 = tempRet0;
 var $lpad_phi$1=$lpad_loopexit$1;var $lpad_phi$0=$lpad_loopexit$0;label=19;break;
 case 18: 
 var $lpad_nonloopexit$0 = ___cxa_find_matching_catch(-1, -1); var $lpad_nonloopexit$1 = tempRet0;
 var $lpad_phi$1=$lpad_nonloopexit$1;var $lpad_phi$0=$lpad_nonloopexit$0;label=19;break;
 case 19: 
 var $lpad_phi$0;
 var $lpad_phi$1;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grouping);
 ___resumeException($lpad_phi$0)
 case 20: 
 HEAP32[(($__oe)>>2)]=$__ob;
 var $74=HEAP8[($__nb)];
 if((($74<<24)>>24)==45|(($74<<24)>>24)==43){ label=21;break;}else{var $__nf_0=$__nb;label=23;break;}
 case 21: 
 var $76=$19;
 var $77=HEAP32[(($76)>>2)];
 var $78=(($77+28)|0);
 var $79=HEAP32[(($78)>>2)];
 var $80=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$79]($23,$74) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=22;break; } else { label=18;break; }
 case 22: 
 var $81=(($__nb+1)|0);
 var $82=HEAP32[(($__oe)>>2)];
 var $83=(($82+1)|0);
 HEAP32[(($__oe)>>2)]=$83;
 HEAP8[($82)]=$80;
 var $__nf_0=$81;label=23;break;
 case 23: 
 var $__nf_0;
 var $85=$__ne;
 var $86=$__nf_0;
 var $87=((($85)-($86))|0);
 var $88=($87|0)>1;
 if($88){label=24;break;}else{var $__nf_1=$__nf_0;label=29;break;}
 case 24: 
 var $90=HEAP8[($__nf_0)];
 var $91=(($90<<24)>>24)==48;
 if($91){label=25;break;}else{var $__nf_1=$__nf_0;label=29;break;}
 case 25: 
 var $93=(($__nf_0+1)|0);
 var $94=HEAP8[($93)];
 if((($94<<24)>>24)==120|(($94<<24)>>24)==88){ label=26;break;}else{var $__nf_1=$__nf_0;label=29;break;}
 case 26: 
 var $96=$19;
 var $97=HEAP32[(($96)>>2)];
 var $98=(($97+28)|0);
 var $99=HEAP32[(($98)>>2)];
 var $100=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$99]($23,48) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=27;break; } else { label=18;break; }
 case 27: 
 var $101=HEAP32[(($__oe)>>2)];
 var $102=(($101+1)|0);
 HEAP32[(($__oe)>>2)]=$102;
 HEAP8[($101)]=$100;
 var $103=HEAP8[($93)];
 var $104=HEAP32[(($96)>>2)];
 var $105=(($104+28)|0);
 var $106=HEAP32[(($105)>>2)];
 var $107=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$106]($23,$103) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=28;break; } else { label=18;break; }
 case 28: 
 var $108=(($__nf_0+2)|0);
 var $109=HEAP32[(($__oe)>>2)];
 var $110=(($109+1)|0);
 HEAP32[(($__oe)>>2)]=$110;
 HEAP8[($109)]=$107;
 var $__nf_1=$108;label=29;break;
 case 29: 
 var $__nf_1;
 var $112=($__nf_1|0)==($__ne|0);
 if($112){label=32;break;}else{label=30;break;}
 case 30: 
 var $113=((($__ne)-(1))|0);
 var $114=($113>>>0)>($__nf_1>>>0);
 if($114){var $_078_i_i=$__nf_1;var $115=$113;label=31;break;}else{label=32;break;}
 case 31: 
 var $115;
 var $_078_i_i;
 var $116=HEAP8[($_078_i_i)];
 var $117=HEAP8[($115)];
 HEAP8[($_078_i_i)]=$117;
 HEAP8[($115)]=$116;
 var $118=(($_078_i_i+1)|0);
 var $119=((($115)-(1))|0);
 var $120=($118>>>0)<($119>>>0);
 if($120){var $_078_i_i=$118;var $115=$119;label=31;break;}else{label=32;break;}
 case 32: 
 var $121=$41;
 var $122=HEAP32[(($121)>>2)];
 var $123=(($122+16)|0);
 var $124=HEAP32[(($123)>>2)];
 var $125=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$124]($45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=33;break; } else { label=18;break; }
 case 33: 
 var $126=($__nf_1>>>0)<($__ne>>>0);
 if($126){label=34;break;}else{label=43;break;}
 case 34: 
 var $127=$__grouping;
 var $128=(($127+1)|0);
 var $129=$19;
 var $130=(($__grouping+4)|0);
 var $131=(($__grouping+8)|0);
 var $__dc_070=0;var $__dg_071=0;var $__p_072=$__nf_1;label=35;break;
 case 35: 
 var $__p_072;
 var $__dg_071;
 var $__dc_070;
 var $132=HEAP8[($50)];
 var $133=$132&1;
 var $134=(($133<<24)>>24)==0;
 var $135=HEAP32[(($131)>>2)];
 var $_=($134?$128:$135);
 var $136=(($_+$__dg_071)|0);
 var $137=HEAP8[($136)];
 var $138=(($137<<24)>>24)==0;
 if($138){var $__dg_1=$__dg_071;var $__dc_1=$__dc_070;label=41;break;}else{label=36;break;}
 case 36: 
 var $139=HEAP32[(($131)>>2)];
 var $_73=($134?$128:$139);
 var $140=(($_73+$__dg_071)|0);
 var $141=HEAP8[($140)];
 var $142=(($141<<24)>>24);
 var $143=($__dc_070|0)==($142|0);
 if($143){label=37;break;}else{var $__dg_1=$__dg_071;var $__dc_1=$__dc_070;label=41;break;}
 case 37: 
 var $145=HEAP32[(($__oe)>>2)];
 var $146=(($145+1)|0);
 HEAP32[(($__oe)>>2)]=$146;
 HEAP8[($145)]=$125;
 var $147=HEAP8[($50)];
 var $148=$147&1;
 var $149=(($148<<24)>>24)==0;
 if($149){label=39;break;}else{label=38;break;}
 case 38: 
 var $151=HEAP32[(($130)>>2)];
 var $155=$151;label=40;break;
 case 39: 
 var $153=($147&255);
 var $154=$153>>>1;
 var $155=$154;label=40;break;
 case 40: 
 var $155;
 var $156=((($155)-(1))|0);
 var $157=($__dg_071>>>0)<($156>>>0);
 var $158=($157&1);
 var $___dg_0=((($158)+($__dg_071))|0);
 var $__dg_1=$___dg_0;var $__dc_1=0;label=41;break;
 case 41: 
 var $__dc_1;
 var $__dg_1;
 var $160=HEAP8[($__p_072)];
 var $161=HEAP32[(($129)>>2)];
 var $162=(($161+28)|0);
 var $163=HEAP32[(($162)>>2)];
 var $164=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$163]($23,$160) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=42;break; } else { label=17;break; }
 case 42: 
 var $165=HEAP32[(($__oe)>>2)];
 var $166=(($165+1)|0);
 HEAP32[(($__oe)>>2)]=$166;
 HEAP8[($165)]=$164;
 var $167=((($__dc_1)+(1))|0);
 var $168=(($__p_072+1)|0);
 var $169=($168>>>0)<($__ne>>>0);
 if($169){var $__dc_070=$167;var $__dg_071=$__dg_1;var $__p_072=$168;label=35;break;}else{label=43;break;}
 case 43: 
 var $170=$__nf_1;
 var $171=$__nb;
 var $172=((($170)-($171))|0);
 var $173=(($__ob+$172)|0);
 var $174=HEAP32[(($__oe)>>2)];
 var $175=($173|0)==($174|0);
 if($175){label=46;break;}else{label=44;break;}
 case 44: 
 var $176=((($174)-(1))|0);
 var $177=($176>>>0)>($173>>>0);
 if($177){var $_078_i_i67=$173;var $178=$176;label=45;break;}else{label=46;break;}
 case 45: 
 var $178;
 var $_078_i_i67;
 var $179=HEAP8[($_078_i_i67)];
 var $180=HEAP8[($178)];
 HEAP8[($_078_i_i67)]=$180;
 HEAP8[($178)]=$179;
 var $181=(($_078_i_i67+1)|0);
 var $182=((($178)-(1))|0);
 var $183=($181>>>0)<($182>>>0);
 if($183){var $_078_i_i67=$181;var $178=$182;label=45;break;}else{label=46;break;}
 case 46: 
 var $184=($__np|0)==($__ne|0);
 if($184){label=47;break;}else{label=48;break;}
 case 47: 
 var $186=HEAP32[(($__oe)>>2)];
 var $storemerge=$186;label=49;break;
 case 48: 
 var $188=$__np;
 var $189=$__nb;
 var $190=((($188)-($189))|0);
 var $191=(($__ob+$190)|0);
 var $storemerge=$191;label=49;break;
 case 49: 
 var $storemerge;
 HEAP32[(($__op)>>2)]=$storemerge;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grouping);
 STACKTOP=sp;return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcx($agg_result,$this,$__s,$__iob,$__fl,$__v$0,$__v$1){
 var label=0;
 var tempVarArgs=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+112)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var tempParam = $__s; $__s=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__s)>>2)]=HEAP32[((tempParam)>>2)];
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $__fmt=sp;
 var $__nar=(sp)+(8);
 var $__o=(sp)+(32);
 var $__op=(sp)+(80);
 var $__oe=(sp)+(88);
 var $1=(sp)+(96);
 var $2=(sp)+(104);
 var $$etemp$0$0=37;
 var $$etemp$0$1=0;
 var $st$1$0=(($__fmt)|0);
 HEAP32[(($st$1$0)>>2)]=$$etemp$0$0;
 var $st$2$1=(($__fmt+4)|0);
 HEAP32[(($st$2$1)>>2)]=$$etemp$0$1;
 var $3=$__fmt;
 var $4=(($3+1)|0);
 var $5=(($__iob+4)|0);
 var $6=HEAP32[(($5)>>2)];
 var $7=$6&2048;
 var $8=($7|0)==0;
 if($8){var $_0_i=$4;label=3;break;}else{label=2;break;}
 case 2: 
 var $10=(($3+2)|0);
 HEAP8[($4)]=43;
 var $_0_i=$10;label=3;break;
 case 3: 
 var $_0_i;
 var $12=$6&512;
 var $13=($12|0)==0;
 if($13){var $_116_i_ph=$_0_i;label=5;break;}else{label=4;break;}
 case 4: 
 var $15=(($_0_i+1)|0);
 HEAP8[($_0_i)]=35;
 var $_116_i_ph=$15;label=5;break;
 case 5: 
 var $_116_i_ph;
 var $16=(($_116_i_ph+1)|0);
 HEAP8[($_116_i_ph)]=108;
 HEAP8[($16)]=108;
 var $scevgep=(($_116_i_ph+2)|0);
 var $17=$6&74;
 if(($17|0)==64){ label=6;break;}else if(($17|0)==8){ label=7;break;}else{label=10;break;}
 case 6: 
 HEAP8[($scevgep)]=111;
 label=11;break;
 case 7: 
 var $20=$6&16384;
 var $21=($20|0)==0;
 if($21){label=9;break;}else{label=8;break;}
 case 8: 
 HEAP8[($scevgep)]=88;
 label=11;break;
 case 9: 
 HEAP8[($scevgep)]=120;
 label=11;break;
 case 10: 
 HEAP8[($scevgep)]=100;
 label=11;break;
 case 11: 
 var $25=(($__nar)|0);
 var $26=HEAP8[(14656)];
 var $27=(($26<<24)>>24)==0;
 if($27){label=12;break;}else{label=16;break;}
 case 12: 
 var $29=___cxa_guard_acquire(14656);
 var $30=($29|0)==0;
 if($30){label=16;break;}else{label=13;break;}
 case 13: 
 var $32=(function() { try { __THREW__ = 0; return _newlocale(2147483647,1496,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=14;break; } else { label=15;break; }
 case 14: 
 HEAP32[((12664)>>2)]=$32;

 label=16;break;
 case 15: 
 var $35$0 = ___cxa_find_matching_catch(-1, -1); var $35$1 = tempRet0;

 ___resumeException($35$0)
 case 16: 
 var $36=HEAP32[((12664)>>2)];
 var $37=__ZNSt3__112__snprintf_lEPcjP15__locale_structPKcz($25,22,$36,$3,(tempVarArgs=STACKTOP,STACKTOP = (STACKTOP + 16)|0,(assert((STACKTOP|0) < (STACK_MAX|0))|0),HEAP32[((tempVarArgs)>>2)]=$__v$0,HEAP32[(((tempVarArgs)+(8))>>2)]=$__v$1,tempVarArgs)); STACKTOP=tempVarArgs;
 var $38=(($__nar+$37)|0);
 var $39=HEAP32[(($5)>>2)];
 var $40=$39&176;
 if(($40|0)==16){ label=17;break;}else if(($40|0)==32){ var $_0_i10=$38;label=23;break;}else{label=22;break;}
 case 17: 
 var $42=HEAP8[($25)];
 if((($42<<24)>>24)==45|(($42<<24)>>24)==43){ label=18;break;}else{label=19;break;}
 case 18: 
 var $44=(($__nar+1)|0);
 var $_0_i10=$44;label=23;break;
 case 19: 
 var $46=($37|0)>1;
 var $47=(($42<<24)>>24)==48;
 var $or_cond_i=$46&$47;
 if($or_cond_i){label=20;break;}else{label=22;break;}
 case 20: 
 var $49=(($__nar+1)|0);
 var $50=HEAP8[($49)];
 if((($50<<24)>>24)==120|(($50<<24)>>24)==88){ label=21;break;}else{label=22;break;}
 case 21: 
 var $52=(($__nar+2)|0);
 var $_0_i10=$52;label=23;break;
 case 22: 
 var $_0_i10=$25;label=23;break;
 case 23: 
 var $_0_i10;
 var $54=(($__o)|0);
 __ZNKSt3__18ios_base6getlocEv($1,$__iob);
 (function() { try { __THREW__ = 0; return __ZNSt3__19__num_putIcE21__widen_and_group_intEPcS2_S2_S2_RS2_S3_RKNS_6localeE($25,$_0_i10,$38,$54,$__op,$__oe,$1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=24;break; } else { label=25;break; }
 case 24: 
 var $56=(($1)|0);
 var $57=HEAP32[(($56)>>2)];
 var $58=(($57)|0);
 var $59=__ZNSt3__114__shared_count16__release_sharedEv($58);
 var $60=(($__s)|0);
 var $61=HEAP32[(($60)>>2)];
 var $62=(($2)|0);
 HEAP32[(($62)>>2)]=$61;
 var $63=HEAP32[(($__op)>>2)];
 var $64=HEAP32[(($__oe)>>2)];
 __ZNSt3__116__pad_and_outputIcNS_11char_traitsIcEEEENS_19ostreambuf_iteratorIT_T0_EES6_PKS4_S8_S8_RNS_8ios_baseES4_($agg_result,$2,$54,$63,$64,$__iob,$__fl);
 STACKTOP=sp;return;
 case 25: 
 var $66$0 = ___cxa_find_matching_catch(-1, -1); var $66$1 = tempRet0;
 var $67=(($1)|0);
 var $68=HEAP32[(($67)>>2)];
 var $69=(($68)|0);
 var $70=__ZNSt3__114__shared_count16__release_sharedEv($69);
 ___resumeException($66$0)
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcm($agg_result,$this,$__s,$__iob,$__fl,$__v){
 var label=0;
 var tempVarArgs=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+80)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var tempParam = $__s; $__s=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__s)>>2)]=HEAP32[((tempParam)>>2)];
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $__fmt=sp;
 var $__nar=(sp)+(8);
 var $__o=(sp)+(24);
 var $__op=(sp)+(48);
 var $__oe=(sp)+(56);
 var $1=(sp)+(64);
 var $2=(sp)+(72);
 var $3=(($__fmt)|0);
 assert(6 % 1 === 0);HEAP8[($3)]=HEAP8[(2904)];HEAP8[((($3)+(1))|0)]=HEAP8[(2905)];HEAP8[((($3)+(2))|0)]=HEAP8[(2906)];HEAP8[((($3)+(3))|0)]=HEAP8[(2907)];HEAP8[((($3)+(4))|0)]=HEAP8[(2908)];HEAP8[((($3)+(5))|0)]=HEAP8[(2909)];
 var $4=(($__fmt+1)|0);
 var $5=(($__iob+4)|0);
 var $6=HEAP32[(($5)>>2)];
 var $7=$6&2048;
 var $8=($7|0)==0;
 if($8){var $_0_i=$4;label=3;break;}else{label=2;break;}
 case 2: 
 var $10=(($__fmt+2)|0);
 HEAP8[($4)]=43;
 var $_0_i=$10;label=3;break;
 case 3: 
 var $_0_i;
 var $12=$6&512;
 var $13=($12|0)==0;
 if($13){var $_116_i_ph=$_0_i;label=5;break;}else{label=4;break;}
 case 4: 
 var $15=(($_0_i+1)|0);
 HEAP8[($_0_i)]=35;
 var $_116_i_ph=$15;label=5;break;
 case 5: 
 var $_116_i_ph;
 HEAP8[($_116_i_ph)]=108;
 var $scevgep=(($_116_i_ph+1)|0);
 var $16=$6&74;
 if(($16|0)==64){ label=6;break;}else if(($16|0)==8){ label=7;break;}else{label=10;break;}
 case 6: 
 HEAP8[($scevgep)]=111;
 label=11;break;
 case 7: 
 var $19=$6&16384;
 var $20=($19|0)==0;
 if($20){label=9;break;}else{label=8;break;}
 case 8: 
 HEAP8[($scevgep)]=88;
 label=11;break;
 case 9: 
 HEAP8[($scevgep)]=120;
 label=11;break;
 case 10: 
 HEAP8[($scevgep)]=117;
 label=11;break;
 case 11: 
 var $24=(($__nar)|0);
 var $25=HEAP8[(14656)];
 var $26=(($25<<24)>>24)==0;
 if($26){label=12;break;}else{label=16;break;}
 case 12: 
 var $28=___cxa_guard_acquire(14656);
 var $29=($28|0)==0;
 if($29){label=16;break;}else{label=13;break;}
 case 13: 
 var $31=(function() { try { __THREW__ = 0; return _newlocale(2147483647,1496,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=14;break; } else { label=15;break; }
 case 14: 
 HEAP32[((12664)>>2)]=$31;

 label=16;break;
 case 15: 
 var $34$0 = ___cxa_find_matching_catch(-1, -1); var $34$1 = tempRet0;

 ___resumeException($34$0)
 case 16: 
 var $35=HEAP32[((12664)>>2)];
 var $36=__ZNSt3__112__snprintf_lEPcjP15__locale_structPKcz($24,12,$35,$3,(tempVarArgs=STACKTOP,STACKTOP = (STACKTOP + 8)|0,(assert((STACKTOP|0) < (STACK_MAX|0))|0),HEAP32[((tempVarArgs)>>2)]=$__v,tempVarArgs)); STACKTOP=tempVarArgs;
 var $37=(($__nar+$36)|0);
 var $38=HEAP32[(($5)>>2)];
 var $39=$38&176;
 if(($39|0)==16){ label=17;break;}else if(($39|0)==32){ var $_0_i10=$37;label=23;break;}else{label=22;break;}
 case 17: 
 var $41=HEAP8[($24)];
 if((($41<<24)>>24)==45|(($41<<24)>>24)==43){ label=18;break;}else{label=19;break;}
 case 18: 
 var $43=(($__nar+1)|0);
 var $_0_i10=$43;label=23;break;
 case 19: 
 var $45=($36|0)>1;
 var $46=(($41<<24)>>24)==48;
 var $or_cond_i=$45&$46;
 if($or_cond_i){label=20;break;}else{label=22;break;}
 case 20: 
 var $48=(($__nar+1)|0);
 var $49=HEAP8[($48)];
 if((($49<<24)>>24)==120|(($49<<24)>>24)==88){ label=21;break;}else{label=22;break;}
 case 21: 
 var $51=(($__nar+2)|0);
 var $_0_i10=$51;label=23;break;
 case 22: 
 var $_0_i10=$24;label=23;break;
 case 23: 
 var $_0_i10;
 var $53=(($__o)|0);
 __ZNKSt3__18ios_base6getlocEv($1,$__iob);
 (function() { try { __THREW__ = 0; return __ZNSt3__19__num_putIcE21__widen_and_group_intEPcS2_S2_S2_RS2_S3_RKNS_6localeE($24,$_0_i10,$37,$53,$__op,$__oe,$1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=24;break; } else { label=25;break; }
 case 24: 
 var $55=(($1)|0);
 var $56=HEAP32[(($55)>>2)];
 var $57=(($56)|0);
 var $58=__ZNSt3__114__shared_count16__release_sharedEv($57);
 var $59=(($__s)|0);
 var $60=HEAP32[(($59)>>2)];
 var $61=(($2)|0);
 HEAP32[(($61)>>2)]=$60;
 var $62=HEAP32[(($__op)>>2)];
 var $63=HEAP32[(($__oe)>>2)];
 __ZNSt3__116__pad_and_outputIcNS_11char_traitsIcEEEENS_19ostreambuf_iteratorIT_T0_EES6_PKS4_S8_S8_RNS_8ios_baseES4_($agg_result,$2,$53,$62,$63,$__iob,$__fl);
 STACKTOP=sp;return;
 case 25: 
 var $65$0 = ___cxa_find_matching_catch(-1, -1); var $65$1 = tempRet0;
 var $66=(($1)|0);
 var $67=HEAP32[(($66)>>2)];
 var $68=(($67)|0);
 var $69=__ZNSt3__114__shared_count16__release_sharedEv($68);
 ___resumeException($65$0)
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcy($agg_result,$this,$__s,$__iob,$__fl,$__v$0,$__v$1){
 var label=0;
 var tempVarArgs=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+112)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var tempParam = $__s; $__s=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__s)>>2)]=HEAP32[((tempParam)>>2)];
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $__fmt=sp;
 var $__nar=(sp)+(8);
 var $__o=(sp)+(32);
 var $__op=(sp)+(80);
 var $__oe=(sp)+(88);
 var $1=(sp)+(96);
 var $2=(sp)+(104);
 var $$etemp$0$0=37;
 var $$etemp$0$1=0;
 var $st$1$0=(($__fmt)|0);
 HEAP32[(($st$1$0)>>2)]=$$etemp$0$0;
 var $st$2$1=(($__fmt+4)|0);
 HEAP32[(($st$2$1)>>2)]=$$etemp$0$1;
 var $3=$__fmt;
 var $4=(($3+1)|0);
 var $5=(($__iob+4)|0);
 var $6=HEAP32[(($5)>>2)];
 var $7=$6&2048;
 var $8=($7|0)==0;
 if($8){var $_0_i=$4;label=3;break;}else{label=2;break;}
 case 2: 
 var $10=(($3+2)|0);
 HEAP8[($4)]=43;
 var $_0_i=$10;label=3;break;
 case 3: 
 var $_0_i;
 var $12=$6&512;
 var $13=($12|0)==0;
 if($13){var $_116_i_ph=$_0_i;label=5;break;}else{label=4;break;}
 case 4: 
 var $15=(($_0_i+1)|0);
 HEAP8[($_0_i)]=35;
 var $_116_i_ph=$15;label=5;break;
 case 5: 
 var $_116_i_ph;
 var $16=(($_116_i_ph+1)|0);
 HEAP8[($_116_i_ph)]=108;
 HEAP8[($16)]=108;
 var $scevgep=(($_116_i_ph+2)|0);
 var $17=$6&74;
 if(($17|0)==64){ label=6;break;}else if(($17|0)==8){ label=7;break;}else{label=10;break;}
 case 6: 
 HEAP8[($scevgep)]=111;
 label=11;break;
 case 7: 
 var $20=$6&16384;
 var $21=($20|0)==0;
 if($21){label=9;break;}else{label=8;break;}
 case 8: 
 HEAP8[($scevgep)]=88;
 label=11;break;
 case 9: 
 HEAP8[($scevgep)]=120;
 label=11;break;
 case 10: 
 HEAP8[($scevgep)]=117;
 label=11;break;
 case 11: 
 var $25=(($__nar)|0);
 var $26=HEAP8[(14656)];
 var $27=(($26<<24)>>24)==0;
 if($27){label=12;break;}else{label=16;break;}
 case 12: 
 var $29=___cxa_guard_acquire(14656);
 var $30=($29|0)==0;
 if($30){label=16;break;}else{label=13;break;}
 case 13: 
 var $32=(function() { try { __THREW__ = 0; return _newlocale(2147483647,1496,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=14;break; } else { label=15;break; }
 case 14: 
 HEAP32[((12664)>>2)]=$32;

 label=16;break;
 case 15: 
 var $35$0 = ___cxa_find_matching_catch(-1, -1); var $35$1 = tempRet0;

 ___resumeException($35$0)
 case 16: 
 var $36=HEAP32[((12664)>>2)];
 var $37=__ZNSt3__112__snprintf_lEPcjP15__locale_structPKcz($25,23,$36,$3,(tempVarArgs=STACKTOP,STACKTOP = (STACKTOP + 16)|0,(assert((STACKTOP|0) < (STACK_MAX|0))|0),HEAP32[((tempVarArgs)>>2)]=$__v$0,HEAP32[(((tempVarArgs)+(8))>>2)]=$__v$1,tempVarArgs)); STACKTOP=tempVarArgs;
 var $38=(($__nar+$37)|0);
 var $39=HEAP32[(($5)>>2)];
 var $40=$39&176;
 if(($40|0)==16){ label=17;break;}else if(($40|0)==32){ var $_0_i10=$38;label=23;break;}else{label=22;break;}
 case 17: 
 var $42=HEAP8[($25)];
 if((($42<<24)>>24)==45|(($42<<24)>>24)==43){ label=18;break;}else{label=19;break;}
 case 18: 
 var $44=(($__nar+1)|0);
 var $_0_i10=$44;label=23;break;
 case 19: 
 var $46=($37|0)>1;
 var $47=(($42<<24)>>24)==48;
 var $or_cond_i=$46&$47;
 if($or_cond_i){label=20;break;}else{label=22;break;}
 case 20: 
 var $49=(($__nar+1)|0);
 var $50=HEAP8[($49)];
 if((($50<<24)>>24)==120|(($50<<24)>>24)==88){ label=21;break;}else{label=22;break;}
 case 21: 
 var $52=(($__nar+2)|0);
 var $_0_i10=$52;label=23;break;
 case 22: 
 var $_0_i10=$25;label=23;break;
 case 23: 
 var $_0_i10;
 var $54=(($__o)|0);
 __ZNKSt3__18ios_base6getlocEv($1,$__iob);
 (function() { try { __THREW__ = 0; return __ZNSt3__19__num_putIcE21__widen_and_group_intEPcS2_S2_S2_RS2_S3_RKNS_6localeE($25,$_0_i10,$38,$54,$__op,$__oe,$1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=24;break; } else { label=25;break; }
 case 24: 
 var $56=(($1)|0);
 var $57=HEAP32[(($56)>>2)];
 var $58=(($57)|0);
 var $59=__ZNSt3__114__shared_count16__release_sharedEv($58);
 var $60=(($__s)|0);
 var $61=HEAP32[(($60)>>2)];
 var $62=(($2)|0);
 HEAP32[(($62)>>2)]=$61;
 var $63=HEAP32[(($__op)>>2)];
 var $64=HEAP32[(($__oe)>>2)];
 __ZNSt3__116__pad_and_outputIcNS_11char_traitsIcEEEENS_19ostreambuf_iteratorIT_T0_EES6_PKS4_S8_S8_RNS_8ios_baseES4_($agg_result,$2,$54,$63,$64,$__iob,$__fl);
 STACKTOP=sp;return;
 case 25: 
 var $66$0 = ___cxa_find_matching_catch(-1, -1); var $66$1 = tempRet0;
 var $67=(($1)|0);
 var $68=HEAP32[(($67)>>2)];
 var $69=(($68)|0);
 var $70=__ZNSt3__114__shared_count16__release_sharedEv($69);
 ___resumeException($66$0)
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcd($agg_result,$this,$__s,$__iob,$__fl,$__v){
 var label=0;
 var tempVarArgs=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+152)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var tempParam = $__s; $__s=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__s)>>2)]=HEAP32[((tempParam)>>2)];
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $__fmt=sp;
 var $__nar=(sp)+(8);
 var $__nb=(sp)+(40);
 var $__o=(sp)+(48);
 var $__op=(sp)+(112);
 var $__oe=(sp)+(120);
 var $1=(sp)+(128);
 var $2=(sp)+(136);
 var $3=(sp)+(144);
 var $$etemp$0$0=37;
 var $$etemp$0$1=0;
 var $st$1$0=(($__fmt)|0);
 HEAP32[(($st$1$0)>>2)]=$$etemp$0$0;
 var $st$2$1=(($__fmt+4)|0);
 HEAP32[(($st$2$1)>>2)]=$$etemp$0$1;
 var $4=$__fmt;
 var $5=(($4+1)|0);
 var $6=(($__iob+4)|0);
 var $7=HEAP32[(($6)>>2)];
 var $8=$7&2048;
 var $9=($8|0)==0;
 if($9){var $_0_i=$5;label=3;break;}else{label=2;break;}
 case 2: 
 var $11=(($4+2)|0);
 HEAP8[($5)]=43;
 var $_0_i=$11;label=3;break;
 case 3: 
 var $_0_i;
 var $13=$7&1024;
 var $14=($13|0)==0;
 if($14){var $_1_i=$_0_i;label=5;break;}else{label=4;break;}
 case 4: 
 var $16=(($_0_i+1)|0);
 HEAP8[($_0_i)]=35;
 var $_1_i=$16;label=5;break;
 case 5: 
 var $_1_i;
 var $18=$7&260;
 var $19=$7>>>14;
 var $20=($18|0)==260;
 if($20){label=13;break;}else{label=6;break;}
 case 6: 
 var $21=(($_1_i+1)|0);
 HEAP8[($_1_i)]=46;
 var $22=(($_1_i+2)|0);
 HEAP8[($21)]=42;
 if(($18|0)==256){ label=10;break;}else if(($18|0)==4){ label=7;break;}else{label=16;break;}
 case 7: 
 var $24=$19&1;
 var $25=($24|0)==0;
 if($25){label=9;break;}else{label=8;break;}
 case 8: 
 HEAP8[($22)]=70;
 var $specify_precision_0_off0_ph_i46=1;label=19;break;
 case 9: 
 HEAP8[($22)]=102;
 var $specify_precision_0_off0_ph_i46=1;label=19;break;
 case 10: 
 var $29=$19&1;
 var $30=($29|0)==0;
 if($30){label=12;break;}else{label=11;break;}
 case 11: 
 HEAP8[($22)]=69;
 var $specify_precision_0_off0_ph_i46=1;label=19;break;
 case 12: 
 HEAP8[($22)]=101;
 var $specify_precision_0_off0_ph_i46=1;label=19;break;
 case 13: 
 var $34=$19&1;
 var $35=($34|0)==0;
 if($35){label=15;break;}else{label=14;break;}
 case 14: 
 HEAP8[($_1_i)]=65;
 var $specify_precision_0_off0_ph_i46=0;label=19;break;
 case 15: 
 HEAP8[($_1_i)]=97;
 var $specify_precision_0_off0_ph_i46=0;label=19;break;
 case 16: 
 var $39=$19&1;
 var $40=($39|0)==0;
 if($40){label=18;break;}else{label=17;break;}
 case 17: 
 HEAP8[($22)]=71;
 var $specify_precision_0_off0_ph_i46=1;label=19;break;
 case 18: 
 HEAP8[($22)]=103;
 var $specify_precision_0_off0_ph_i46=1;label=19;break;
 case 19: 
 var $specify_precision_0_off0_ph_i46;
 var $43=(($__nar)|0);
 HEAP32[(($__nb)>>2)]=$43;
 var $44=HEAP8[(14656)];
 var $45=(($44<<24)>>24)==0;
 if($45){label=20;break;}else{label=24;break;}
 case 20: 
 var $47=___cxa_guard_acquire(14656);
 var $48=($47|0)==0;
 if($48){label=24;break;}else{label=21;break;}
 case 21: 
 var $50=(function() { try { __THREW__ = 0; return _newlocale(2147483647,1496,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=22;break; } else { label=23;break; }
 case 22: 
 HEAP32[((12664)>>2)]=$50;

 label=24;break;
 case 23: 
 var $53$0 = ___cxa_find_matching_catch(-1, -1); var $53$1 = tempRet0;

 ___resumeException($53$0)
 case 24: 
 var $54=HEAP32[((12664)>>2)];
 if($specify_precision_0_off0_ph_i46){label=25;break;}else{label=26;break;}
 case 25: 
 var $56=(($__iob+8)|0);
 var $57=HEAP32[(($56)>>2)];
 var $58=__ZNSt3__112__snprintf_lEPcjP15__locale_structPKcz($43,30,$54,$4,(tempVarArgs=STACKTOP,STACKTOP = (STACKTOP + 16)|0,(assert((STACKTOP|0) < (STACK_MAX|0))|0),HEAP32[((tempVarArgs)>>2)]=$57,HEAPF64[(((tempVarArgs)+(8))>>3)]=$__v,tempVarArgs)); STACKTOP=tempVarArgs;
 var $__nc_0=$58;label=27;break;
 case 26: 
 var $60=__ZNSt3__112__snprintf_lEPcjP15__locale_structPKcz($43,30,$54,$4,(tempVarArgs=STACKTOP,STACKTOP = (STACKTOP + 8)|0,(assert((STACKTOP|0) < (STACK_MAX|0))|0),HEAPF64[((tempVarArgs)>>3)]=$__v,tempVarArgs)); STACKTOP=tempVarArgs;
 var $__nc_0=$60;label=27;break;
 case 27: 
 var $__nc_0;
 var $62=($__nc_0|0)>29;
 if($62){label=29;break;}else{label=28;break;}
 case 28: 
 var $_pre53=HEAP32[(($__nb)>>2)];
 var $__nc_2=$__nc_0;var $__nbh_sroa_0_0_load3944=0;var $102=$_pre53;label=47;break;
 case 29: 
 var $64=HEAP8[(14656)];
 var $65=(($64<<24)>>24)==0;
 if($specify_precision_0_off0_ph_i46){label=30;break;}else{label=38;break;}
 case 30: 
 if($65){label=31;break;}else{label=35;break;}
 case 31: 
 var $68=___cxa_guard_acquire(14656);
 var $69=($68|0)==0;
 if($69){label=35;break;}else{label=32;break;}
 case 32: 
 var $71=(function() { try { __THREW__ = 0; return _newlocale(2147483647,1496,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=33;break; } else { label=34;break; }
 case 33: 
 HEAP32[((12664)>>2)]=$71;

 label=35;break;
 case 34: 
 var $74$0 = ___cxa_find_matching_catch(-1, -1); var $74$1 = tempRet0;

 var $eh_lpad_body$1=$74$1;var $eh_lpad_body$0=$74$0;label=37;break;
 case 35: 
 var $76=HEAP32[((12664)>>2)];
 var $77=(($__iob+8)|0);
 var $78=HEAP32[(($77)>>2)];
 var $79=(function() { try { __THREW__ = 0; return __ZNSt3__112__asprintf_lEPPcP15__locale_structPKcz($__nb,$76,$4,(tempVarArgs=STACKTOP,STACKTOP = (STACKTOP + 16)|0,(assert((STACKTOP|0) < (STACK_MAX|0))|0),HEAP32[((tempVarArgs)>>2)]=$78,HEAPF64[(((tempVarArgs)+(8))>>3)]=$__v,tempVarArgs)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })(); STACKTOP=tempVarArgs;if (!__THREW__) { var $__nc_1=$79;label=44;break; } else { label=36;break; }
 case 36: 
 var $81$0 = ___cxa_find_matching_catch(-1, -1); var $81$1 = tempRet0;
 var $eh_lpad_body$1=$81$1;var $eh_lpad_body$0=$81$0;label=37;break;
 case 37: 
 var $eh_lpad_body$0;
 var $eh_lpad_body$1;
 var $82=$eh_lpad_body$0;
 var $83=$eh_lpad_body$1;
 var $_12351=$83;var $_152=$82;label=72;break;
 case 38: 
 if($65){label=39;break;}else{label=43;break;}
 case 39: 
 var $86=___cxa_guard_acquire(14656);
 var $87=($86|0)==0;
 if($87){label=43;break;}else{label=40;break;}
 case 40: 
 var $89=(function() { try { __THREW__ = 0; return _newlocale(2147483647,1496,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=41;break; } else { label=42;break; }
 case 41: 
 HEAP32[((12664)>>2)]=$89;

 label=43;break;
 case 42: 
 var $92$0 = ___cxa_find_matching_catch(-1, -1); var $92$1 = tempRet0;

 var $eh_lpad_body$1=$92$1;var $eh_lpad_body$0=$92$0;label=37;break;
 case 43: 
 var $94=HEAP32[((12664)>>2)];
 var $95=(($__iob+8)|0);
 var $96=HEAP32[(($95)>>2)];
 var $97=(function() { try { __THREW__ = 0; return __ZNSt3__112__asprintf_lEPPcP15__locale_structPKcz($__nb,$94,$4,(tempVarArgs=STACKTOP,STACKTOP = (STACKTOP + 16)|0,(assert((STACKTOP|0) < (STACK_MAX|0))|0),HEAP32[((tempVarArgs)>>2)]=$96,HEAPF64[(((tempVarArgs)+(8))>>3)]=$__v,tempVarArgs)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })(); STACKTOP=tempVarArgs;if (!__THREW__) { var $__nc_1=$97;label=44;break; } else { label=36;break; }
 case 44: 
 var $__nc_1;
 var $99=HEAP32[(($__nb)>>2)];
 var $100=($99|0)==0;
 if($100){label=45;break;}else{var $__nc_2=$__nc_1;var $__nbh_sroa_0_0_load3944=$99;var $102=$99;label=47;break;}
 case 45: 
 (function() { try { __THREW__ = 0; return __ZSt17__throw_bad_allocv() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=46;break; } else { label=36;break; }
 case 46: 
 var $_pre=HEAP32[(($__nb)>>2)];
 var $__nc_2=$__nc_1;var $__nbh_sroa_0_0_load3944=$_pre;var $102=$_pre;label=47;break;
 case 47: 
 var $102;
 var $__nbh_sroa_0_0_load3944;
 var $__nc_2;
 var $103=(($102+$__nc_2)|0);
 var $104=HEAP32[(($6)>>2)];
 var $105=$104&176;
 if(($105|0)==16){ label=48;break;}else if(($105|0)==32){ var $_0_i28=$103;label=54;break;}else{label=53;break;}
 case 48: 
 var $107=HEAP8[($102)];
 if((($107<<24)>>24)==45|(($107<<24)>>24)==43){ label=49;break;}else{label=50;break;}
 case 49: 
 var $109=(($102+1)|0);
 var $_0_i28=$109;label=54;break;
 case 50: 
 var $111=($__nc_2|0)>1;
 var $112=(($107<<24)>>24)==48;
 var $or_cond_i=$111&$112;
 if($or_cond_i){label=51;break;}else{label=53;break;}
 case 51: 
 var $114=(($102+1)|0);
 var $115=HEAP8[($114)];
 if((($115<<24)>>24)==120|(($115<<24)>>24)==88){ label=52;break;}else{label=53;break;}
 case 52: 
 var $117=(($102+2)|0);
 var $_0_i28=$117;label=54;break;
 case 53: 
 var $_0_i28=$102;label=54;break;
 case 54: 
 var $_0_i28;
 var $119=(($__o)|0);
 var $120=($102|0)==($43|0);
 if($120){var $__ob_0=$119;var $132=0;var $131=$43;label=59;break;}else{label=55;break;}
 case 55: 
 var $122=$__nc_2<<1;
 var $123=_malloc($122);
 var $124=($123|0)==0;
 if($124){label=56;break;}else{var $__ob_0=$123;var $132=$123;var $131=$102;label=59;break;}
 case 56: 
 (function() { try { __THREW__ = 0; return __ZSt17__throw_bad_allocv() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=57;break; } else { var $127=0;label=58;break; }
 case 57: 
 var $_pre54=HEAP32[(($__nb)>>2)];
 var $__ob_0=0;var $132=0;var $131=$_pre54;label=59;break;
 case 58: 
 var $127;
 var $128$0 = ___cxa_find_matching_catch(-1, -1); var $128$1 = tempRet0;
 var $129=$128$0;
 var $130=$128$1;
 var $_0=$129;var $_022=$130;var $161=$127;label=68;break;
 case 59: 
 var $131;
 var $132;
 var $__ob_0;
 (function() { try { __THREW__ = 0; return __ZNKSt3__18ios_base6getlocEv($1,$__iob) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=60;break; } else { var $127=$132;label=58;break; }
 case 60: 
 (function() { try { __THREW__ = 0; return __ZNSt3__19__num_putIcE23__widen_and_group_floatEPcS2_S2_S2_RS2_S3_RKNS_6localeE($131,$_0_i28,$103,$__ob_0,$__op,$__oe,$1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=61;break; } else { label=67;break; }
 case 61: 
 var $135=(($1)|0);
 var $136=HEAP32[(($135)>>2)];
 var $137=(($136)|0);
 var $138=__ZNSt3__114__shared_count16__release_sharedEv($137);
 var $139=(($__s)|0);
 var $140=HEAP32[(($139)>>2)];
 var $141=(($3)|0);
 HEAP32[(($141)>>2)]=$140;
 var $142=HEAP32[(($__op)>>2)];
 var $143=HEAP32[(($__oe)>>2)];
 (function() { try { __THREW__ = 0; return __ZNSt3__116__pad_and_outputIcNS_11char_traitsIcEEEENS_19ostreambuf_iteratorIT_T0_EES6_PKS4_S8_S8_RNS_8ios_baseES4_($2,$3,$__ob_0,$142,$143,$__iob,$__fl) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=62;break; } else { var $127=$132;label=58;break; }
 case 62: 
 var $145=(($2)|0);
 var $146=HEAP32[(($145)>>2)];
 HEAP32[(($139)>>2)]=$146;
 var $147=(($agg_result)|0);
 HEAP32[(($147)>>2)]=$146;
 var $148=($132|0)==0;
 if($148){label=64;break;}else{label=63;break;}
 case 63: 
 _free($132);
 label=64;break;
 case 64: 
 var $150=($__nbh_sroa_0_0_load3944|0)==0;
 if($150){label=66;break;}else{label=65;break;}
 case 65: 
 _free($__nbh_sroa_0_0_load3944);
 label=66;break;
 case 66: 
 STACKTOP=sp;return;
 case 67: 
 var $153$0 = ___cxa_find_matching_catch(-1, -1); var $153$1 = tempRet0;
 var $154=$153$0;
 var $155=$153$1;
 var $156=(($1)|0);
 var $157=HEAP32[(($156)>>2)];
 var $158=(($157)|0);
 var $159=__ZNSt3__114__shared_count16__release_sharedEv($158);
 var $_0=$154;var $_022=$155;var $161=$132;label=68;break;
 case 68: 
 var $161;
 var $_022;
 var $_0;
 var $162=($161|0)==0;
 if($162){label=70;break;}else{label=69;break;}
 case 69: 
 _free($161);
 label=70;break;
 case 70: 
 var $164=($__nbh_sroa_0_0_load3944|0)==0;
 if($164){var $_12351=$_022;var $_152=$_0;label=72;break;}else{label=71;break;}
 case 71: 
 _free($__nbh_sroa_0_0_load3944);
 var $_12351=$_022;var $_152=$_0;label=72;break;
 case 72: 
 var $_152;
 var $_12351;
 var $166$0=$_152;
 var $166$1=0;
 var $167$0=$166$0;
 var $167$1=$_12351;
 ___resumeException($167$0)
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__112__asprintf_lEPPcP15__locale_structPKcz($__s,$__l,$__format,varrp){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+16)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $__va=sp;
 var $1=(($__va)|0);
 var $2=$__va;
 HEAP32[(($2)>>2)]=varrp;HEAP32[((($2)+(4))>>2)]=0;
 var $3=_uselocale($__l);
 var $4=(function() { try { __THREW__ = 0; return _vasprintf($__s,$__format,$1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=2;break; } else { label=6;break; }
 case 2: 

 var $6=($3|0)==0;
 if($6){label=5;break;}else{label=3;break;}
 case 3: 
 var $8=(function() { try { __THREW__ = 0; return _uselocale($3) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=5;break; } else { label=4;break; }
 case 4: 
 var $10$0 = ___cxa_find_matching_catch(-1, -1,0); var $10$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
 case 5: 
 STACKTOP=sp;return $4;
 case 6: 
 var $12$0 = ___cxa_find_matching_catch(-1, -1); var $12$1 = tempRet0;
 var $13=($3|0)==0;
 if($13){label=9;break;}else{label=7;break;}
 case 7: 
 var $15=(function() { try { __THREW__ = 0; return _uselocale($3) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=9;break; } else { label=8;break; }
 case 8: 
 var $17$0 = ___cxa_find_matching_catch(-1, -1,0); var $17$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
 case 9: 
 ___resumeException($12$0)
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__19__num_putIcE23__widen_and_group_floatEPcS2_S2_S2_RS2_S3_RKNS_6localeE($__nb,$__np,$__ne,$__ob,$__op,$__oe,$__loc){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+48)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $__p_i_i_i_i81=sp;
 var $__p_i_i_i_i=(sp)+(16);
 var $__grouping=(sp)+(32);
 var $1=(($__loc)|0);
 var $2=HEAP32[(($1)>>2)];
 var $3=$__p_i_i_i_i;
 var $4=HEAP32[((14096)>>2)];
 var $5=($4|0)==-1;
 if($5){label=3;break;}else{label=2;break;}
 case 2: 
 var $_sroa_01_0___p67_i_idx_i_i_i=(($__p_i_i_i_i)|0);
 HEAP32[(($_sroa_01_0___p67_i_idx_i_i_i)>>2)]=14096;
 var $_sroa_12_4___p67_i_idx3_i_i_i=(($__p_i_i_i_i+4)|0);
 HEAP32[(($_sroa_12_4___p67_i_idx3_i_i_i)>>2)]=(28);
 var $_sroa_2_8___p67_i_idx4_i_i_i=(($__p_i_i_i_i+8)|0);
 HEAP32[(($_sroa_2_8___p67_i_idx4_i_i_i)>>2)]=0;
 __ZNSt3__111__call_onceERVmPvPFvS2_E(14096,$3,260);
 label=3;break;
 case 3: 
 var $7=HEAP32[((14100)>>2)];
 var $8=((($7)-(1))|0);
 var $9=(($2+12)|0);
 var $10=HEAP32[(($9)>>2)];
 var $11=(($2+8)|0);
 var $12=HEAP32[(($11)>>2)];
 var $13=$10;
 var $14=$12;
 var $15=((($13)-($14))|0);
 var $16=$15>>2;
 var $17=($16>>>0)>($8>>>0);
 if($17){label=4;break;}else{label=5;break;}
 case 4: 
 var $18=(($12+($8<<2))|0);
 var $19=HEAP32[(($18)>>2)];
 var $20=($19|0)==0;
 if($20){label=5;break;}else{label=6;break;}
 case 5: 
 var $21=___cxa_allocate_exception(4);
 var $22=$21;
 __ZNSt8bad_castC2Ev($22);
 ___cxa_throw($21,8960,(368));
 throw "Reached an unreachable!";
 case 6: 
 var $23=$19;
 var $24=HEAP32[(($1)>>2)];
 var $25=$__p_i_i_i_i81;
 var $26=HEAP32[((13712)>>2)];
 var $27=($26|0)==-1;
 if($27){label=8;break;}else{label=7;break;}
 case 7: 
 var $_sroa_01_0___p67_i_idx_i_i_i82=(($__p_i_i_i_i81)|0);
 HEAP32[(($_sroa_01_0___p67_i_idx_i_i_i82)>>2)]=13712;
 var $_sroa_12_4___p67_i_idx3_i_i_i83=(($__p_i_i_i_i81+4)|0);
 HEAP32[(($_sroa_12_4___p67_i_idx3_i_i_i83)>>2)]=(28);
 var $_sroa_2_8___p67_i_idx4_i_i_i84=(($__p_i_i_i_i81+8)|0);
 HEAP32[(($_sroa_2_8___p67_i_idx4_i_i_i84)>>2)]=0;
 __ZNSt3__111__call_onceERVmPvPFvS2_E(13712,$25,260);
 label=8;break;
 case 8: 
 var $29=HEAP32[((13716)>>2)];
 var $30=((($29)-(1))|0);
 var $31=(($24+12)|0);
 var $32=HEAP32[(($31)>>2)];
 var $33=(($24+8)|0);
 var $34=HEAP32[(($33)>>2)];
 var $35=$32;
 var $36=$34;
 var $37=((($35)-($36))|0);
 var $38=$37>>2;
 var $39=($38>>>0)>($30>>>0);
 if($39){label=9;break;}else{label=10;break;}
 case 9: 
 var $40=(($34+($30<<2))|0);
 var $41=HEAP32[(($40)>>2)];
 var $42=($41|0)==0;
 if($42){label=10;break;}else{label=11;break;}
 case 10: 
 var $43=___cxa_allocate_exception(4);
 var $44=$43;
 __ZNSt8bad_castC2Ev($44);
 ___cxa_throw($43,8960,(368));
 throw "Reached an unreachable!";
 case 11: 
 var $45=$41;
 var $46=$41;
 var $47=HEAP32[(($46)>>2)];
 var $48=(($47+20)|0);
 var $49=HEAP32[(($48)>>2)];
 FUNCTION_TABLE[$49]($__grouping,$45);
 HEAP32[(($__oe)>>2)]=$__ob;
 var $50=HEAP8[($__nb)];
 if((($50<<24)>>24)==45|(($50<<24)>>24)==43){ label=12;break;}else{var $__nf_0=$__nb;label=20;break;}
 case 12: 
 var $52=$19;
 var $53=HEAP32[(($52)>>2)];
 var $54=(($53+28)|0);
 var $55=HEAP32[(($54)>>2)];
 var $56=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$55]($23,$50) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=13;break; } else { label=18;break; }
 case 13: 
 var $57=(($__nb+1)|0);
 var $58=HEAP32[(($__oe)>>2)];
 var $59=(($58+1)|0);
 HEAP32[(($__oe)>>2)]=$59;
 HEAP8[($58)]=$56;
 var $__nf_0=$57;label=20;break;
 case 14: 
 var $lpad_loopexit$0 = ___cxa_find_matching_catch(-1, -1); var $lpad_loopexit$1 = tempRet0;
 var $eh_lpad_body$1=$lpad_loopexit$1;var $eh_lpad_body$0=$lpad_loopexit$0;label=19;break;
 case 15: 
 var $lpad_loopexit105$0 = ___cxa_find_matching_catch(-1, -1); var $lpad_loopexit105$1 = tempRet0;
 var $eh_lpad_body$1=$lpad_loopexit105$1;var $eh_lpad_body$0=$lpad_loopexit105$0;label=19;break;
 case 16: 
 var $lpad_loopexit113$0 = ___cxa_find_matching_catch(-1, -1); var $lpad_loopexit113$1 = tempRet0;
 var $eh_lpad_body$1=$lpad_loopexit113$1;var $eh_lpad_body$0=$lpad_loopexit113$0;label=19;break;
 case 17: 
 var $lpad_loopexit118$0 = ___cxa_find_matching_catch(-1, -1); var $lpad_loopexit118$1 = tempRet0;
 var $eh_lpad_body$1=$lpad_loopexit118$1;var $eh_lpad_body$0=$lpad_loopexit118$0;label=19;break;
 case 18: 
 var $lpad_nonloopexit119$0 = ___cxa_find_matching_catch(-1, -1); var $lpad_nonloopexit119$1 = tempRet0;
 var $eh_lpad_body$1=$lpad_nonloopexit119$1;var $eh_lpad_body$0=$lpad_nonloopexit119$0;label=19;break;
 case 19: 
 var $eh_lpad_body$0;
 var $eh_lpad_body$1;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grouping);
 ___resumeException($eh_lpad_body$0)
 case 20: 
 var $__nf_0;
 var $61=$__ne;
 var $62=$__nf_0;
 var $63=((($61)-($62))|0);
 var $64=($63|0)>1;
 if($64){label=21;break;}else{var $__ns_1=$__nf_0;label=34;break;}
 case 21: 
 var $66=HEAP8[($__nf_0)];
 var $67=(($66<<24)>>24)==48;
 if($67){label=22;break;}else{var $__ns_1=$__nf_0;label=34;break;}
 case 22: 
 var $69=(($__nf_0+1)|0);
 var $70=HEAP8[($69)];
 if((($70<<24)>>24)==120|(($70<<24)>>24)==88){ label=23;break;}else{var $__ns_1=$__nf_0;label=34;break;}
 case 23: 
 var $72=$19;
 var $73=HEAP32[(($72)>>2)];
 var $74=(($73+28)|0);
 var $75=HEAP32[(($74)>>2)];
 var $76=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$75]($23,48) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=24;break; } else { label=18;break; }
 case 24: 
 var $77=HEAP32[(($__oe)>>2)];
 var $78=(($77+1)|0);
 HEAP32[(($__oe)>>2)]=$78;
 HEAP8[($77)]=$76;
 var $79=(($__nf_0+2)|0);
 var $80=HEAP8[($69)];
 var $81=HEAP32[(($72)>>2)];
 var $82=(($81+28)|0);
 var $83=HEAP32[(($82)>>2)];
 var $84=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$83]($23,$80) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=25;break; } else { label=18;break; }
 case 25: 
 var $85=HEAP32[(($__oe)>>2)];
 var $86=(($85+1)|0);
 HEAP32[(($__oe)>>2)]=$86;
 HEAP8[($85)]=$84;
 var $__ns_0=$79;label=26;break;
 case 26: 
 var $__ns_0;
 var $88=($__ns_0>>>0)<($__ne>>>0);
 if($88){label=27;break;}else{var $__nf_1=$79;var $__ns_2=$__ns_0;label=42;break;}
 case 27: 
 var $90=HEAP8[($__ns_0)];
 var $91=HEAP8[(14656)];
 var $92=(($91<<24)>>24)==0;
 if($92){label=28;break;}else{label=32;break;}
 case 28: 
 var $94=___cxa_guard_acquire(14656);
 var $95=($94|0)==0;
 if($95){label=32;break;}else{label=29;break;}
 case 29: 
 var $97=(function() { try { __THREW__ = 0; return _newlocale(2147483647,1496,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=30;break; } else { label=31;break; }
 case 30: 
 HEAP32[((12664)>>2)]=$97;

 label=32;break;
 case 31: 
 var $100$0 = ___cxa_find_matching_catch(-1, -1); var $100$1 = tempRet0;

 var $eh_lpad_body$1=$100$1;var $eh_lpad_body$0=$100$0;label=19;break;
 case 32: 
 var $102=HEAP32[((12664)>>2)];
 var $103=(($90<<24)>>24);
 var $104=(function() { try { __THREW__ = 0; return _isxdigit_l($103,$102) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=33;break; } else { label=17;break; }
 case 33: 
 var $106=($104|0)==0;
 var $107=(($__ns_0+1)|0);
 if($106){var $__nf_1=$79;var $__ns_2=$__ns_0;label=42;break;}else{var $__ns_0=$107;label=26;break;}
 case 34: 
 var $__ns_1;
 var $108=($__ns_1>>>0)<($__ne>>>0);
 if($108){label=35;break;}else{var $__nf_1=$__nf_0;var $__ns_2=$__ns_1;label=42;break;}
 case 35: 
 var $110=HEAP8[($__ns_1)];
 var $111=HEAP8[(14656)];
 var $112=(($111<<24)>>24)==0;
 if($112){label=36;break;}else{label=40;break;}
 case 36: 
 var $114=___cxa_guard_acquire(14656);
 var $115=($114|0)==0;
 if($115){label=40;break;}else{label=37;break;}
 case 37: 
 var $117=(function() { try { __THREW__ = 0; return _newlocale(2147483647,1496,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=38;break; } else { label=39;break; }
 case 38: 
 HEAP32[((12664)>>2)]=$117;

 label=40;break;
 case 39: 
 var $120$0 = ___cxa_find_matching_catch(-1, -1); var $120$1 = tempRet0;

 var $eh_lpad_body$1=$120$1;var $eh_lpad_body$0=$120$0;label=19;break;
 case 40: 
 var $122=HEAP32[((12664)>>2)];
 var $123=(($110<<24)>>24);
 var $124=(function() { try { __THREW__ = 0; return _isdigit_l($123,$122) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=41;break; } else { label=16;break; }
 case 41: 
 var $126=($124|0)==0;
 var $127=(($__ns_1+1)|0);
 if($126){var $__nf_1=$__nf_0;var $__ns_2=$__ns_1;label=42;break;}else{var $__ns_1=$127;label=34;break;}
 case 42: 
 var $__ns_2;
 var $__nf_1;
 var $128=$__grouping;
 var $129=HEAP8[($128)];
 var $130=$129&1;
 var $131=(($130<<24)>>24)==0;
 if($131){label=44;break;}else{label=43;break;}
 case 43: 
 var $133=(($__grouping+4)|0);
 var $134=HEAP32[(($133)>>2)];
 var $138=$134;label=45;break;
 case 44: 
 var $136=($129&255);
 var $137=$136>>>1;
 var $138=$137;label=45;break;
 case 45: 
 var $138;
 var $139=($138|0)==0;
 if($139){label=46;break;}else{label=48;break;}
 case 46: 
 var $141=HEAP32[(($__oe)>>2)];
 var $142=$19;
 var $143=HEAP32[(($142)>>2)];
 var $144=(($143+32)|0);
 var $145=HEAP32[(($144)>>2)];
 var $146=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$145]($23,$__nf_1,$__ns_2,$141) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=47;break; } else { label=18;break; }
 case 47: 
 var $147=$__ns_2;
 var $148=$__nf_1;
 var $149=((($147)-($148))|0);
 var $150=HEAP32[(($__oe)>>2)];
 var $151=(($150+$149)|0);
 HEAP32[(($__oe)>>2)]=$151;
 label=65;break;
 case 48: 
 var $153=($__nf_1|0)==($__ns_2|0);
 if($153){label=51;break;}else{label=49;break;}
 case 49: 
 var $154=((($__ns_2)-(1))|0);
 var $155=($154>>>0)>($__nf_1>>>0);
 if($155){var $_078_i_i=$__nf_1;var $156=$154;label=50;break;}else{label=51;break;}
 case 50: 
 var $156;
 var $_078_i_i;
 var $157=HEAP8[($_078_i_i)];
 var $158=HEAP8[($156)];
 HEAP8[($_078_i_i)]=$158;
 HEAP8[($156)]=$157;
 var $159=(($_078_i_i+1)|0);
 var $160=((($156)-(1))|0);
 var $161=($159>>>0)<($160>>>0);
 if($161){var $_078_i_i=$159;var $156=$160;label=50;break;}else{label=51;break;}
 case 51: 
 var $162=$41;
 var $163=HEAP32[(($162)>>2)];
 var $164=(($163+16)|0);
 var $165=HEAP32[(($164)>>2)];
 var $166=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$165]($45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=52;break; } else { label=18;break; }
 case 52: 
 var $167=($__nf_1>>>0)<($__ns_2>>>0);
 if($167){label=53;break;}else{label=62;break;}
 case 53: 
 var $168=$__grouping;
 var $169=(($168+1)|0);
 var $170=(($__grouping+4)|0);
 var $171=(($__grouping+8)|0);
 var $172=$19;
 var $__dc_0108=0;var $__dg_0109=0;var $__p_0110=$__nf_1;label=54;break;
 case 54: 
 var $__p_0110;
 var $__dg_0109;
 var $__dc_0108;
 var $173=HEAP8[($128)];
 var $174=$173&1;
 var $175=(($174<<24)>>24)==0;
 var $176=HEAP32[(($171)>>2)];
 var $_=($175?$169:$176);
 var $177=(($_+$__dg_0109)|0);
 var $178=HEAP8[($177)];
 var $179=(($178<<24)>>24)>0;
 if($179){label=55;break;}else{var $__dg_1=$__dg_0109;var $__dc_1=$__dc_0108;label=60;break;}
 case 55: 
 var $180=HEAP32[(($171)>>2)];
 var $_129=($175?$169:$180);
 var $181=(($_129+$__dg_0109)|0);
 var $182=HEAP8[($181)];
 var $183=(($182<<24)>>24);
 var $184=($__dc_0108|0)==($183|0);
 if($184){label=56;break;}else{var $__dg_1=$__dg_0109;var $__dc_1=$__dc_0108;label=60;break;}
 case 56: 
 var $186=HEAP32[(($__oe)>>2)];
 var $187=(($186+1)|0);
 HEAP32[(($__oe)>>2)]=$187;
 HEAP8[($186)]=$166;
 var $188=HEAP8[($128)];
 var $189=$188&1;
 var $190=(($189<<24)>>24)==0;
 if($190){label=58;break;}else{label=57;break;}
 case 57: 
 var $192=HEAP32[(($170)>>2)];
 var $196=$192;label=59;break;
 case 58: 
 var $194=($188&255);
 var $195=$194>>>1;
 var $196=$195;label=59;break;
 case 59: 
 var $196;
 var $197=((($196)-(1))|0);
 var $198=($__dg_0109>>>0)<($197>>>0);
 var $199=($198&1);
 var $___dg_0=((($199)+($__dg_0109))|0);
 var $__dg_1=$___dg_0;var $__dc_1=0;label=60;break;
 case 60: 
 var $__dc_1;
 var $__dg_1;
 var $201=HEAP8[($__p_0110)];
 var $202=HEAP32[(($172)>>2)];
 var $203=(($202+28)|0);
 var $204=HEAP32[(($203)>>2)];
 var $205=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$204]($23,$201) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=61;break; } else { label=15;break; }
 case 61: 
 var $206=HEAP32[(($__oe)>>2)];
 var $207=(($206+1)|0);
 HEAP32[(($__oe)>>2)]=$207;
 HEAP8[($206)]=$205;
 var $208=((($__dc_1)+(1))|0);
 var $209=(($__p_0110+1)|0);
 var $210=($209>>>0)<($__ns_2>>>0);
 if($210){var $__dc_0108=$208;var $__dg_0109=$__dg_1;var $__p_0110=$209;label=54;break;}else{label=62;break;}
 case 62: 
 var $211=$__nf_1;
 var $212=$__nb;
 var $213=((($211)-($212))|0);
 var $214=(($__ob+$213)|0);
 var $215=HEAP32[(($__oe)>>2)];
 var $216=($214|0)==($215|0);
 if($216){label=65;break;}else{label=63;break;}
 case 63: 
 var $217=((($215)-(1))|0);
 var $218=($217>>>0)>($214>>>0);
 if($218){var $_078_i_i96=$214;var $219=$217;label=64;break;}else{label=65;break;}
 case 64: 
 var $219;
 var $_078_i_i96;
 var $220=HEAP8[($_078_i_i96)];
 var $221=HEAP8[($219)];
 HEAP8[($_078_i_i96)]=$221;
 HEAP8[($219)]=$220;
 var $222=(($_078_i_i96+1)|0);
 var $223=((($219)-(1))|0);
 var $224=($222>>>0)<($223>>>0);
 if($224){var $_078_i_i96=$222;var $219=$223;label=64;break;}else{label=65;break;}
 case 65: 
 var $225=($__ns_2>>>0)<($__ne>>>0);
 if($225){label=66;break;}else{var $__nf_3=$__ns_2;label=72;break;}
 case 66: 
 var $226=$19;
 var $__nf_2104=$__ns_2;label=67;break;
 case 67: 
 var $__nf_2104;
 var $228=HEAP8[($__nf_2104)];
 var $229=(($228<<24)>>24)==46;
 if($229){label=68;break;}else{label=70;break;}
 case 68: 
 var $231=$41;
 var $232=HEAP32[(($231)>>2)];
 var $233=(($232+12)|0);
 var $234=HEAP32[(($233)>>2)];
 var $235=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$234]($45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=69;break; } else { label=18;break; }
 case 69: 
 var $236=HEAP32[(($__oe)>>2)];
 var $237=(($236+1)|0);
 HEAP32[(($__oe)>>2)]=$237;
 HEAP8[($236)]=$235;
 var $238=(($__nf_2104+1)|0);
 var $__nf_3=$238;label=72;break;
 case 70: 
 var $240=HEAP32[(($226)>>2)];
 var $241=(($240+28)|0);
 var $242=HEAP32[(($241)>>2)];
 var $243=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$242]($23,$228) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=71;break; } else { label=14;break; }
 case 71: 
 var $244=HEAP32[(($__oe)>>2)];
 var $245=(($244+1)|0);
 HEAP32[(($__oe)>>2)]=$245;
 HEAP8[($244)]=$243;
 var $246=(($__nf_2104+1)|0);
 var $247=($246>>>0)<($__ne>>>0);
 if($247){var $__nf_2104=$246;label=67;break;}else{var $__nf_3=$246;label=72;break;}
 case 72: 
 var $__nf_3;
 var $248=HEAP32[(($__oe)>>2)];
 var $249=$19;
 var $250=HEAP32[(($249)>>2)];
 var $251=(($250+32)|0);
 var $252=HEAP32[(($251)>>2)];
 var $253=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$252]($23,$__nf_3,$__ne,$248) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=73;break; } else { label=18;break; }
 case 73: 
 var $254=$__nf_3;
 var $255=((($61)-($254))|0);
 var $256=HEAP32[(($__oe)>>2)];
 var $257=(($256+$255)|0);
 HEAP32[(($__oe)>>2)]=$257;
 var $258=($__np|0)==($__ne|0);
 if($258){var $storemerge=$257;label=75;break;}else{label=74;break;}
 case 74: 
 var $260=$__np;
 var $261=$__nb;
 var $262=((($260)-($261))|0);
 var $263=(($__ob+$262)|0);
 var $storemerge=$263;label=75;break;
 case 75: 
 var $storemerge;
 HEAP32[(($__op)>>2)]=$storemerge;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grouping);
 STACKTOP=sp;return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEce($agg_result,$this,$__s,$__iob,$__fl,$__v){
 var label=0;
 var tempVarArgs=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+152)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var tempParam = $__s; $__s=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__s)>>2)]=HEAP32[((tempParam)>>2)];
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $__fmt=sp;
 var $__nar=(sp)+(8);
 var $__nb=(sp)+(40);
 var $__o=(sp)+(48);
 var $__op=(sp)+(112);
 var $__oe=(sp)+(120);
 var $1=(sp)+(128);
 var $2=(sp)+(136);
 var $3=(sp)+(144);
 var $$etemp$0$0=37;
 var $$etemp$0$1=0;
 var $st$1$0=(($__fmt)|0);
 HEAP32[(($st$1$0)>>2)]=$$etemp$0$0;
 var $st$2$1=(($__fmt+4)|0);
 HEAP32[(($st$2$1)>>2)]=$$etemp$0$1;
 var $4=$__fmt;
 var $5=(($4+1)|0);
 var $6=(($__iob+4)|0);
 var $7=HEAP32[(($6)>>2)];
 var $8=$7&2048;
 var $9=($8|0)==0;
 if($9){var $_0_i=$5;label=3;break;}else{label=2;break;}
 case 2: 
 var $11=(($4+2)|0);
 HEAP8[($5)]=43;
 var $_0_i=$11;label=3;break;
 case 3: 
 var $_0_i;
 var $13=$7&1024;
 var $14=($13|0)==0;
 if($14){var $_1_i=$_0_i;label=5;break;}else{label=4;break;}
 case 4: 
 var $16=(($_0_i+1)|0);
 HEAP8[($_0_i)]=35;
 var $_1_i=$16;label=5;break;
 case 5: 
 var $_1_i;
 var $18=$7&260;
 var $19=$7>>>14;
 var $20=($18|0)==260;
 if($20){label=13;break;}else{label=6;break;}
 case 6: 
 var $21=(($_1_i+1)|0);
 HEAP8[($_1_i)]=46;
 var $22=(($_1_i+2)|0);
 HEAP8[($21)]=42;
 HEAP8[($22)]=76;
 var $scevgep=(($_1_i+3)|0);
 if(($18|0)==256){ label=10;break;}else if(($18|0)==4){ label=7;break;}else{label=16;break;}
 case 7: 
 var $24=$19&1;
 var $25=($24|0)==0;
 if($25){label=9;break;}else{label=8;break;}
 case 8: 
 HEAP8[($scevgep)]=70;
 var $specify_precision_0_off0_ph_i50=1;label=19;break;
 case 9: 
 HEAP8[($scevgep)]=102;
 var $specify_precision_0_off0_ph_i50=1;label=19;break;
 case 10: 
 var $29=$19&1;
 var $30=($29|0)==0;
 if($30){label=12;break;}else{label=11;break;}
 case 11: 
 HEAP8[($scevgep)]=69;
 var $specify_precision_0_off0_ph_i50=1;label=19;break;
 case 12: 
 HEAP8[($scevgep)]=101;
 var $specify_precision_0_off0_ph_i50=1;label=19;break;
 case 13: 
 HEAP8[($_1_i)]=76;
 var $scevgep49=(($_1_i+1)|0);
 var $34=$19&1;
 var $35=($34|0)==0;
 if($35){label=15;break;}else{label=14;break;}
 case 14: 
 HEAP8[($scevgep49)]=65;
 var $specify_precision_0_off0_ph_i50=0;label=19;break;
 case 15: 
 HEAP8[($scevgep49)]=97;
 var $specify_precision_0_off0_ph_i50=0;label=19;break;
 case 16: 
 var $39=$19&1;
 var $40=($39|0)==0;
 if($40){label=18;break;}else{label=17;break;}
 case 17: 
 HEAP8[($scevgep)]=71;
 var $specify_precision_0_off0_ph_i50=1;label=19;break;
 case 18: 
 HEAP8[($scevgep)]=103;
 var $specify_precision_0_off0_ph_i50=1;label=19;break;
 case 19: 
 var $specify_precision_0_off0_ph_i50;
 var $43=(($__nar)|0);
 HEAP32[(($__nb)>>2)]=$43;
 var $44=HEAP8[(14656)];
 var $45=(($44<<24)>>24)==0;
 if($45){label=20;break;}else{label=24;break;}
 case 20: 
 var $47=___cxa_guard_acquire(14656);
 var $48=($47|0)==0;
 if($48){label=24;break;}else{label=21;break;}
 case 21: 
 var $50=(function() { try { __THREW__ = 0; return _newlocale(2147483647,1496,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=22;break; } else { label=23;break; }
 case 22: 
 HEAP32[((12664)>>2)]=$50;

 label=24;break;
 case 23: 
 var $53$0 = ___cxa_find_matching_catch(-1, -1); var $53$1 = tempRet0;

 ___resumeException($53$0)
 case 24: 
 var $54=HEAP32[((12664)>>2)];
 if($specify_precision_0_off0_ph_i50){label=25;break;}else{label=26;break;}
 case 25: 
 var $56=(($__iob+8)|0);
 var $57=HEAP32[(($56)>>2)];
 var $58=__ZNSt3__112__snprintf_lEPcjP15__locale_structPKcz($43,30,$54,$4,(tempVarArgs=STACKTOP,STACKTOP = (STACKTOP + 16)|0,(assert((STACKTOP|0) < (STACK_MAX|0))|0),HEAP32[((tempVarArgs)>>2)]=$57,HEAPF64[(((tempVarArgs)+(8))>>3)]=$__v,tempVarArgs)); STACKTOP=tempVarArgs;
 var $__nc_0=$58;label=27;break;
 case 26: 
 var $60=__ZNSt3__112__snprintf_lEPcjP15__locale_structPKcz($43,30,$54,$4,(tempVarArgs=STACKTOP,STACKTOP = (STACKTOP + 8)|0,(assert((STACKTOP|0) < (STACK_MAX|0))|0),HEAPF64[((tempVarArgs)>>3)]=$__v,tempVarArgs)); STACKTOP=tempVarArgs;
 var $__nc_0=$60;label=27;break;
 case 27: 
 var $__nc_0;
 var $62=($__nc_0|0)>29;
 if($62){label=29;break;}else{label=28;break;}
 case 28: 
 var $_pre47=HEAP32[(($__nb)>>2)];
 var $__nc_2=$__nc_0;var $__nbh_sroa_0_0_load3843=0;var $100=$_pre47;label=47;break;
 case 29: 
 var $64=HEAP8[(14656)];
 var $65=(($64<<24)>>24)==0;
 if($specify_precision_0_off0_ph_i50){label=30;break;}else{label=38;break;}
 case 30: 
 if($65){label=31;break;}else{label=35;break;}
 case 31: 
 var $68=___cxa_guard_acquire(14656);
 var $69=($68|0)==0;
 if($69){label=35;break;}else{label=32;break;}
 case 32: 
 var $71=(function() { try { __THREW__ = 0; return _newlocale(2147483647,1496,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=33;break; } else { label=34;break; }
 case 33: 
 HEAP32[((12664)>>2)]=$71;

 label=35;break;
 case 34: 
 var $74$0 = ___cxa_find_matching_catch(-1, -1); var $74$1 = tempRet0;

 var $eh_lpad_body$1=$74$1;var $eh_lpad_body$0=$74$0;label=37;break;
 case 35: 
 var $76=HEAP32[((12664)>>2)];
 var $77=(($__iob+8)|0);
 var $78=HEAP32[(($77)>>2)];
 var $79=(function() { try { __THREW__ = 0; return __ZNSt3__112__asprintf_lEPPcP15__locale_structPKcz($__nb,$76,$4,(tempVarArgs=STACKTOP,STACKTOP = (STACKTOP + 16)|0,(assert((STACKTOP|0) < (STACK_MAX|0))|0),HEAP32[((tempVarArgs)>>2)]=$78,HEAPF64[(((tempVarArgs)+(8))>>3)]=$__v,tempVarArgs)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })(); STACKTOP=tempVarArgs;if (!__THREW__) { var $__nc_1=$79;label=44;break; } else { label=36;break; }
 case 36: 
 var $81$0 = ___cxa_find_matching_catch(-1, -1); var $81$1 = tempRet0;
 var $eh_lpad_body$1=$81$1;var $eh_lpad_body$0=$81$0;label=37;break;
 case 37: 
 var $eh_lpad_body$0;
 var $eh_lpad_body$1;
 var $82=$eh_lpad_body$0;
 var $83=$eh_lpad_body$1;
 var $_12245=$83;var $_146=$82;label=72;break;
 case 38: 
 if($65){label=39;break;}else{label=43;break;}
 case 39: 
 var $86=___cxa_guard_acquire(14656);
 var $87=($86|0)==0;
 if($87){label=43;break;}else{label=40;break;}
 case 40: 
 var $89=(function() { try { __THREW__ = 0; return _newlocale(2147483647,1496,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=41;break; } else { label=42;break; }
 case 41: 
 HEAP32[((12664)>>2)]=$89;

 label=43;break;
 case 42: 
 var $92$0 = ___cxa_find_matching_catch(-1, -1); var $92$1 = tempRet0;

 var $eh_lpad_body$1=$92$1;var $eh_lpad_body$0=$92$0;label=37;break;
 case 43: 
 var $94=HEAP32[((12664)>>2)];
 var $95=(function() { try { __THREW__ = 0; return __ZNSt3__112__asprintf_lEPPcP15__locale_structPKcz($__nb,$94,$4,(tempVarArgs=STACKTOP,STACKTOP = (STACKTOP + 8)|0,(assert((STACKTOP|0) < (STACK_MAX|0))|0),HEAPF64[((tempVarArgs)>>3)]=$__v,tempVarArgs)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })(); STACKTOP=tempVarArgs;if (!__THREW__) { var $__nc_1=$95;label=44;break; } else { label=36;break; }
 case 44: 
 var $__nc_1;
 var $97=HEAP32[(($__nb)>>2)];
 var $98=($97|0)==0;
 if($98){label=45;break;}else{var $__nc_2=$__nc_1;var $__nbh_sroa_0_0_load3843=$97;var $100=$97;label=47;break;}
 case 45: 
 (function() { try { __THREW__ = 0; return __ZSt17__throw_bad_allocv() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=46;break; } else { label=36;break; }
 case 46: 
 var $_pre=HEAP32[(($__nb)>>2)];
 var $__nc_2=$__nc_1;var $__nbh_sroa_0_0_load3843=$_pre;var $100=$_pre;label=47;break;
 case 47: 
 var $100;
 var $__nbh_sroa_0_0_load3843;
 var $__nc_2;
 var $101=(($100+$__nc_2)|0);
 var $102=HEAP32[(($6)>>2)];
 var $103=$102&176;
 if(($103|0)==16){ label=48;break;}else if(($103|0)==32){ var $_0_i27=$101;label=54;break;}else{label=53;break;}
 case 48: 
 var $105=HEAP8[($100)];
 if((($105<<24)>>24)==45|(($105<<24)>>24)==43){ label=49;break;}else{label=50;break;}
 case 49: 
 var $107=(($100+1)|0);
 var $_0_i27=$107;label=54;break;
 case 50: 
 var $109=($__nc_2|0)>1;
 var $110=(($105<<24)>>24)==48;
 var $or_cond_i=$109&$110;
 if($or_cond_i){label=51;break;}else{label=53;break;}
 case 51: 
 var $112=(($100+1)|0);
 var $113=HEAP8[($112)];
 if((($113<<24)>>24)==120|(($113<<24)>>24)==88){ label=52;break;}else{label=53;break;}
 case 52: 
 var $115=(($100+2)|0);
 var $_0_i27=$115;label=54;break;
 case 53: 
 var $_0_i27=$100;label=54;break;
 case 54: 
 var $_0_i27;
 var $117=(($__o)|0);
 var $118=($100|0)==($43|0);
 if($118){var $__ob_0=$117;var $130=0;var $129=$43;label=59;break;}else{label=55;break;}
 case 55: 
 var $120=$__nc_2<<1;
 var $121=_malloc($120);
 var $122=($121|0)==0;
 if($122){label=56;break;}else{var $__ob_0=$121;var $130=$121;var $129=$100;label=59;break;}
 case 56: 
 (function() { try { __THREW__ = 0; return __ZSt17__throw_bad_allocv() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=57;break; } else { var $125=0;label=58;break; }
 case 57: 
 var $_pre48=HEAP32[(($__nb)>>2)];
 var $__ob_0=0;var $130=0;var $129=$_pre48;label=59;break;
 case 58: 
 var $125;
 var $126$0 = ___cxa_find_matching_catch(-1, -1); var $126$1 = tempRet0;
 var $127=$126$0;
 var $128=$126$1;
 var $_0=$127;var $_021=$128;var $159=$125;label=68;break;
 case 59: 
 var $129;
 var $130;
 var $__ob_0;
 (function() { try { __THREW__ = 0; return __ZNKSt3__18ios_base6getlocEv($1,$__iob) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=60;break; } else { var $125=$130;label=58;break; }
 case 60: 
 (function() { try { __THREW__ = 0; return __ZNSt3__19__num_putIcE23__widen_and_group_floatEPcS2_S2_S2_RS2_S3_RKNS_6localeE($129,$_0_i27,$101,$__ob_0,$__op,$__oe,$1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=61;break; } else { label=67;break; }
 case 61: 
 var $133=(($1)|0);
 var $134=HEAP32[(($133)>>2)];
 var $135=(($134)|0);
 var $136=__ZNSt3__114__shared_count16__release_sharedEv($135);
 var $137=(($__s)|0);
 var $138=HEAP32[(($137)>>2)];
 var $139=(($3)|0);
 HEAP32[(($139)>>2)]=$138;
 var $140=HEAP32[(($__op)>>2)];
 var $141=HEAP32[(($__oe)>>2)];
 (function() { try { __THREW__ = 0; return __ZNSt3__116__pad_and_outputIcNS_11char_traitsIcEEEENS_19ostreambuf_iteratorIT_T0_EES6_PKS4_S8_S8_RNS_8ios_baseES4_($2,$3,$__ob_0,$140,$141,$__iob,$__fl) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=62;break; } else { var $125=$130;label=58;break; }
 case 62: 
 var $143=(($2)|0);
 var $144=HEAP32[(($143)>>2)];
 HEAP32[(($137)>>2)]=$144;
 var $145=(($agg_result)|0);
 HEAP32[(($145)>>2)]=$144;
 var $146=($130|0)==0;
 if($146){label=64;break;}else{label=63;break;}
 case 63: 
 _free($130);
 label=64;break;
 case 64: 
 var $148=($__nbh_sroa_0_0_load3843|0)==0;
 if($148){label=66;break;}else{label=65;break;}
 case 65: 
 _free($__nbh_sroa_0_0_load3843);
 label=66;break;
 case 66: 
 STACKTOP=sp;return;
 case 67: 
 var $151$0 = ___cxa_find_matching_catch(-1, -1); var $151$1 = tempRet0;
 var $152=$151$0;
 var $153=$151$1;
 var $154=(($1)|0);
 var $155=HEAP32[(($154)>>2)];
 var $156=(($155)|0);
 var $157=__ZNSt3__114__shared_count16__release_sharedEv($156);
 var $_0=$152;var $_021=$153;var $159=$130;label=68;break;
 case 68: 
 var $159;
 var $_021;
 var $_0;
 var $160=($159|0)==0;
 if($160){label=70;break;}else{label=69;break;}
 case 69: 
 _free($159);
 label=70;break;
 case 70: 
 var $162=($__nbh_sroa_0_0_load3843|0)==0;
 if($162){var $_12245=$_021;var $_146=$_0;label=72;break;}else{label=71;break;}
 case 71: 
 _free($__nbh_sroa_0_0_load3843);
 var $_12245=$_021;var $_146=$_0;label=72;break;
 case 72: 
 var $_146;
 var $_12245;
 var $164$0=$_146;
 var $164$1=0;
 var $165$0=$164$0;
 var $165$1=$_12245;
 ___resumeException($165$0)
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcPKv($agg_result,$this,$__s,$__iob,$__fl,$__v){
 var label=0;
 var tempVarArgs=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+104)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var tempParam = $__s; $__s=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__s)>>2)]=HEAP32[((tempParam)>>2)];
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $__p_i_i_i_i=sp;
 var $__fmt=(sp)+(16);
 var $__nar=(sp)+(24);
 var $__o=(sp)+(48);
 var $1=(sp)+(88);
 var $2=(sp)+(96);
 var $3=(($__fmt)|0);
 assert(6 % 1 === 0);HEAP8[($3)]=HEAP8[(2912)];HEAP8[((($3)+(1))|0)]=HEAP8[(2913)];HEAP8[((($3)+(2))|0)]=HEAP8[(2914)];HEAP8[((($3)+(3))|0)]=HEAP8[(2915)];HEAP8[((($3)+(4))|0)]=HEAP8[(2916)];HEAP8[((($3)+(5))|0)]=HEAP8[(2917)];
 var $4=(($__nar)|0);
 var $5=HEAP8[(14656)];
 var $6=(($5<<24)>>24)==0;
 if($6){label=2;break;}else{label=6;break;}
 case 2: 
 var $8=___cxa_guard_acquire(14656);
 var $9=($8|0)==0;
 if($9){label=6;break;}else{label=3;break;}
 case 3: 
 var $11=(function() { try { __THREW__ = 0; return _newlocale(2147483647,1496,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=4;break; } else { label=5;break; }
 case 4: 
 HEAP32[((12664)>>2)]=$11;

 label=6;break;
 case 5: 
 var $14$0 = ___cxa_find_matching_catch(-1, -1); var $14$1 = tempRet0;

 ___resumeException($14$0)
 case 6: 
 var $15=HEAP32[((12664)>>2)];
 var $16=__ZNSt3__112__snprintf_lEPcjP15__locale_structPKcz($4,20,$15,$3,(tempVarArgs=STACKTOP,STACKTOP = (STACKTOP + 8)|0,(assert((STACKTOP|0) < (STACK_MAX|0))|0),HEAP32[((tempVarArgs)>>2)]=$__v,tempVarArgs)); STACKTOP=tempVarArgs;
 var $17=(($__nar+$16)|0);
 var $18=(($__iob+4)|0);
 var $19=HEAP32[(($18)>>2)];
 var $20=$19&176;
 if(($20|0)==32){ var $_0_i=$17;label=13;break;}else if(($20|0)==16){ label=7;break;}else{label=12;break;}
 case 7: 
 var $22=HEAP8[($4)];
 if((($22<<24)>>24)==45|(($22<<24)>>24)==43){ label=8;break;}else{label=9;break;}
 case 8: 
 var $24=(($__nar+1)|0);
 var $_0_i=$24;label=13;break;
 case 9: 
 var $26=($16|0)>1;
 var $27=(($22<<24)>>24)==48;
 var $or_cond_i=$26&$27;
 if($or_cond_i){label=10;break;}else{label=12;break;}
 case 10: 
 var $29=(($__nar+1)|0);
 var $30=HEAP8[($29)];
 if((($30<<24)>>24)==120|(($30<<24)>>24)==88){ label=11;break;}else{label=12;break;}
 case 11: 
 var $32=(($__nar+2)|0);
 var $_0_i=$32;label=13;break;
 case 12: 
 var $_0_i=$4;label=13;break;
 case 13: 
 var $_0_i;
 __ZNKSt3__18ios_base6getlocEv($1,$__iob);
 var $34=(($1)|0);
 var $35=HEAP32[(($34)>>2)];
 var $36=$__p_i_i_i_i;
 var $37=HEAP32[((14096)>>2)];
 var $38=($37|0)==-1;
 if($38){label=15;break;}else{label=14;break;}
 case 14: 
 var $_sroa_01_0___p67_i_idx_i_i_i=(($__p_i_i_i_i)|0);
 HEAP32[(($_sroa_01_0___p67_i_idx_i_i_i)>>2)]=14096;
 var $_sroa_12_4___p67_i_idx3_i_i_i=(($__p_i_i_i_i+4)|0);
 HEAP32[(($_sroa_12_4___p67_i_idx3_i_i_i)>>2)]=(28);
 var $_sroa_2_8___p67_i_idx4_i_i_i=(($__p_i_i_i_i+8)|0);
 HEAP32[(($_sroa_2_8___p67_i_idx4_i_i_i)>>2)]=0;
 (function() { try { __THREW__ = 0; return __ZNSt3__111__call_onceERVmPvPFvS2_E(14096,$36,260) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=15;break; } else { label=20;break; }
 case 15: 
 var $40=HEAP32[((14100)>>2)];
 var $41=((($40)-(1))|0);
 var $42=(($35+12)|0);
 var $43=HEAP32[(($42)>>2)];
 var $44=(($35+8)|0);
 var $45=HEAP32[(($44)>>2)];
 var $46=$43;
 var $47=$45;
 var $48=((($46)-($47))|0);
 var $49=$48>>2;
 var $50=($49>>>0)>($41>>>0);
 if($50){label=16;break;}else{label=17;break;}
 case 16: 
 var $51=(($45+($41<<2))|0);
 var $52=HEAP32[(($51)>>2)];
 var $53=($52|0)==0;
 if($53){label=17;break;}else{label=19;break;}
 case 17: 
 var $54=___cxa_allocate_exception(4);
 var $55=$54;
 __ZNSt8bad_castC2Ev($55);
 (function() { try { __THREW__ = 0; return ___cxa_throw($54,8960,(368)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=18;break; } else { label=20;break; }
 case 18: 
 throw "Reached an unreachable!";
 case 19: 
 var $57=$52;
 var $58=HEAP32[(($34)>>2)];
 var $59=(($58)|0);
 var $60=__ZNSt3__114__shared_count16__release_sharedEv($59);
 var $61=(($__o)|0);
 var $62=$52;
 var $63=HEAP32[(($62)>>2)];
 var $64=(($63+32)|0);
 var $65=HEAP32[(($64)>>2)];
 var $66=FUNCTION_TABLE[$65]($57,$4,$17,$61);
 var $67=(($__o+$16)|0);
 var $68=($_0_i|0)==($17|0);
 if($68){var $__op_0=$67;label=22;break;}else{label=21;break;}
 case 20: 
 var $70$0 = ___cxa_find_matching_catch(-1, -1); var $70$1 = tempRet0;
 var $71=HEAP32[(($34)>>2)];
 var $72=(($71)|0);
 var $73=__ZNSt3__114__shared_count16__release_sharedEv($72);
 ___resumeException($70$0)
 case 21: 
 var $75=$__nar;
 var $76=$_0_i;
 var $77=((($76)-($75))|0);
 var $78=(($__o+$77)|0);
 var $__op_0=$78;label=22;break;
 case 22: 
 var $__op_0;
 var $80=(($__s)|0);
 var $81=HEAP32[(($80)>>2)];
 var $82=(($2)|0);
 HEAP32[(($82)>>2)]=$81;
 __ZNSt3__116__pad_and_outputIcNS_11char_traitsIcEEEENS_19ostreambuf_iteratorIT_T0_EES6_PKS4_S8_S8_RNS_8ios_baseES4_($agg_result,$2,$61,$__op_0,$67,$__iob,$__fl);
 STACKTOP=sp;return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEED0Ev($this){
 var label=0;


 var $1=(($this)|0);
 __ZNSt3__114__shared_countD2Ev($1);
 var $2=$this;
 __ZdlPv($2);
 return;
}


function __ZNSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEED1Ev($this){
 var label=0;


 var $1=(($this)|0);
 __ZNSt3__114__shared_countD2Ev($1);
 return;
}


function __ZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwb($agg_result,$this,$__s,$__iob,$__fl,$__v){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+48)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var tempParam = $__s; $__s=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__s)>>2)]=HEAP32[((tempParam)>>2)];
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $__p_i_i_i_i=sp;
 var $1=(sp)+(16);
 var $2=(sp)+(24);
 var $__nm=(sp)+(32);
 var $3=(($__iob+4)|0);
 var $4=HEAP32[(($3)>>2)];
 var $5=$4&1;
 var $6=($5|0)==0;
 if($6){label=2;break;}else{label=3;break;}
 case 2: 
 var $8=$this;
 var $9=HEAP32[(($8)>>2)];
 var $10=(($9+24)|0);
 var $11=HEAP32[(($10)>>2)];
 var $12=(($__s)|0);
 var $13=HEAP32[(($12)>>2)];
 var $14=(($1)|0);
 HEAP32[(($14)>>2)]=$13;
 var $15=($__v&1);
 FUNCTION_TABLE[$11]($agg_result,$this,$1,$__iob,$__fl,$15);
 label=30;break;
 case 3: 
 __ZNKSt3__18ios_base6getlocEv($2,$__iob);
 var $17=(($2)|0);
 var $18=HEAP32[(($17)>>2)];
 var $19=$__p_i_i_i_i;
 var $20=HEAP32[((13704)>>2)];
 var $21=($20|0)==-1;
 if($21){label=5;break;}else{label=4;break;}
 case 4: 
 var $_sroa_01_0___p67_i_idx_i_i_i=(($__p_i_i_i_i)|0);
 HEAP32[(($_sroa_01_0___p67_i_idx_i_i_i)>>2)]=13704;
 var $_sroa_12_4___p67_i_idx3_i_i_i=(($__p_i_i_i_i+4)|0);
 HEAP32[(($_sroa_12_4___p67_i_idx3_i_i_i)>>2)]=(28);
 var $_sroa_2_8___p67_i_idx4_i_i_i=(($__p_i_i_i_i+8)|0);
 HEAP32[(($_sroa_2_8___p67_i_idx4_i_i_i)>>2)]=0;
 (function() { try { __THREW__ = 0; return __ZNSt3__111__call_onceERVmPvPFvS2_E(13704,$19,260) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=5;break; } else { label=27;break; }
 case 5: 
 var $23=HEAP32[((13708)>>2)];
 var $24=((($23)-(1))|0);
 var $25=(($18+12)|0);
 var $26=HEAP32[(($25)>>2)];
 var $27=(($18+8)|0);
 var $28=HEAP32[(($27)>>2)];
 var $29=$26;
 var $30=$28;
 var $31=((($29)-($30))|0);
 var $32=$31>>2;
 var $33=($32>>>0)>($24>>>0);
 if($33){label=6;break;}else{label=7;break;}
 case 6: 
 var $34=(($28+($24<<2))|0);
 var $35=HEAP32[(($34)>>2)];
 var $36=($35|0)==0;
 if($36){label=7;break;}else{label=9;break;}
 case 7: 
 var $37=___cxa_allocate_exception(4);
 var $38=$37;
 __ZNSt8bad_castC2Ev($38);
 (function() { try { __THREW__ = 0; return ___cxa_throw($37,8960,(368)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=8;break; } else { label=27;break; }
 case 8: 
 throw "Reached an unreachable!";
 case 9: 
 var $40=$35;
 var $41=HEAP32[(($17)>>2)];
 var $42=(($41)|0);
 var $43=__ZNSt3__114__shared_count16__release_sharedEv($42);
 var $44=$35;
 var $45=HEAP32[(($44)>>2)];
 if($__v){label=10;break;}else{label=11;break;}
 case 10: 
 var $47=(($45+24)|0);
 var $48=HEAP32[(($47)>>2)];
 FUNCTION_TABLE[$48]($__nm,$40);
 label=12;break;
 case 11: 
 var $50=(($45+28)|0);
 var $51=HEAP32[(($50)>>2)];
 FUNCTION_TABLE[$51]($__nm,$40);
 label=12;break;
 case 12: 
 var $53=$__nm;
 var $54=HEAP8[($53)];
 var $55=$54&1;
 var $56=(($55<<24)>>24)==0;
 if($56){label=14;break;}else{label=13;break;}
 case 13: 
 var $58=(($__nm+8)|0);
 var $59=HEAP32[(($58)>>2)];
 var $_pre14=(($__nm+4)|0);
 var $_ph=$59;var $_pre_phi=$_pre14;var $_pre_phi16=$58;label=15;break;
 case 14: 
 var $61=(($__nm+4)|0);
 var $_pre15=(($__nm+8)|0);
 var $_ph=$61;var $_pre_phi=$61;var $_pre_phi16=$_pre15;label=15;break;
 case 15: 
 var $_pre_phi16;
 var $_pre_phi;
 var $_ph;
 var $62=(($__s)|0);
 var $64=$_ph;var $63=$54;label=16;break;
 case 16: 
 var $63;
 var $64;
 var $65=$63&1;
 var $66=(($65<<24)>>24)==0;
 if($66){label=18;break;}else{label=17;break;}
 case 17: 
 var $68=HEAP32[(($_pre_phi16)>>2)];
 var $69=HEAP32[(($_pre_phi)>>2)];
 var $74=$69;var $73=$68;label=19;break;
 case 18: 
 var $71=($63&255);
 var $72=$71>>>1;
 var $74=$72;var $73=$_pre_phi;label=19;break;
 case 19: 
 var $73;
 var $74;
 var $75=(($73+($74<<2))|0);
 var $76=($64|0)==($75|0);
 if($76){label=29;break;}else{label=20;break;}
 case 20: 
 var $78=HEAP32[(($64)>>2)];
 var $79=HEAP32[(($62)>>2)];
 var $80=($79|0)==0;
 if($80){label=26;break;}else{label=21;break;}
 case 21: 
 var $82=(($79+24)|0);
 var $83=HEAP32[(($82)>>2)];
 var $84=(($79+28)|0);
 var $85=HEAP32[(($84)>>2)];
 var $86=($83|0)==($85|0);
 if($86){label=22;break;}else{label=23;break;}
 case 22: 
 var $88=$79;
 var $89=HEAP32[(($88)>>2)];
 var $90=(($89+52)|0);
 var $91=HEAP32[(($90)>>2)];
 var $92=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$91]($79,$78) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $_0_i_i=$92;label=24;break; } else { label=28;break; }
 case 23: 
 var $94=(($83+4)|0);
 HEAP32[(($82)>>2)]=$94;
 HEAP32[(($83)>>2)]=$78;
 var $_0_i_i=$78;label=24;break;
 case 24: 
 var $_0_i_i;
 var $95=($_0_i_i|0)==-1;
 if($95){label=25;break;}else{label=26;break;}
 case 25: 
 HEAP32[(($62)>>2)]=0;
 label=26;break;
 case 26: 
 var $97=(($64+4)|0);
 var $_pre=HEAP8[($53)];
 var $64=$97;var $63=$_pre;label=16;break;
 case 27: 
 var $99$0 = ___cxa_find_matching_catch(-1, -1); var $99$1 = tempRet0;
 var $100=$99$0;
 var $101=$99$1;
 var $102=HEAP32[(($17)>>2)];
 var $103=(($102)|0);
 var $104=__ZNSt3__114__shared_count16__release_sharedEv($103);
 var $_0=$100;var $_09=$101;label=31;break;
 case 28: 
 var $106$0 = ___cxa_find_matching_catch(-1, -1); var $106$1 = tempRet0;
 var $107=$106$0;
 var $108=$106$1;
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev($__nm);
 var $_0=$107;var $_09=$108;label=31;break;
 case 29: 
 var $110=HEAP32[(($62)>>2)];
 var $111=(($agg_result)|0);
 HEAP32[(($111)>>2)]=$110;
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev($__nm);
 label=30;break;
 case 30: 
 STACKTOP=sp;return;
 case 31: 
 var $_09;
 var $_0;
 var $114$0=$_0;
 var $114$1=0;
 var $115$0=$114$0;
 var $115$1=$_09;
 ___resumeException($115$0)
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwl($agg_result,$this,$__s,$__iob,$__fl,$__v){
 var label=0;
 var tempVarArgs=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+144)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var tempParam = $__s; $__s=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__s)>>2)]=HEAP32[((tempParam)>>2)];
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $__fmt=sp;
 var $__nar=(sp)+(8);
 var $__o=(sp)+(24);
 var $__op=(sp)+(112);
 var $__oe=(sp)+(120);
 var $1=(sp)+(128);
 var $2=(sp)+(136);
 var $3=(($__fmt)|0);
 assert(6 % 1 === 0);HEAP8[($3)]=HEAP8[(2904)];HEAP8[((($3)+(1))|0)]=HEAP8[(2905)];HEAP8[((($3)+(2))|0)]=HEAP8[(2906)];HEAP8[((($3)+(3))|0)]=HEAP8[(2907)];HEAP8[((($3)+(4))|0)]=HEAP8[(2908)];HEAP8[((($3)+(5))|0)]=HEAP8[(2909)];
 var $4=(($__fmt+1)|0);
 var $5=(($__iob+4)|0);
 var $6=HEAP32[(($5)>>2)];
 var $7=$6&2048;
 var $8=($7|0)==0;
 if($8){var $_0_i=$4;label=3;break;}else{label=2;break;}
 case 2: 
 var $10=(($__fmt+2)|0);
 HEAP8[($4)]=43;
 var $_0_i=$10;label=3;break;
 case 3: 
 var $_0_i;
 var $12=$6&512;
 var $13=($12|0)==0;
 if($13){var $_116_i_ph=$_0_i;label=5;break;}else{label=4;break;}
 case 4: 
 var $15=(($_0_i+1)|0);
 HEAP8[($_0_i)]=35;
 var $_116_i_ph=$15;label=5;break;
 case 5: 
 var $_116_i_ph;
 HEAP8[($_116_i_ph)]=108;
 var $scevgep=(($_116_i_ph+1)|0);
 var $16=$6&74;
 if(($16|0)==64){ label=6;break;}else if(($16|0)==8){ label=7;break;}else{label=10;break;}
 case 6: 
 HEAP8[($scevgep)]=111;
 label=11;break;
 case 7: 
 var $19=$6&16384;
 var $20=($19|0)==0;
 if($20){label=9;break;}else{label=8;break;}
 case 8: 
 HEAP8[($scevgep)]=88;
 label=11;break;
 case 9: 
 HEAP8[($scevgep)]=120;
 label=11;break;
 case 10: 
 HEAP8[($scevgep)]=100;
 label=11;break;
 case 11: 
 var $24=(($__nar)|0);
 var $25=HEAP8[(14656)];
 var $26=(($25<<24)>>24)==0;
 if($26){label=12;break;}else{label=16;break;}
 case 12: 
 var $28=___cxa_guard_acquire(14656);
 var $29=($28|0)==0;
 if($29){label=16;break;}else{label=13;break;}
 case 13: 
 var $31=(function() { try { __THREW__ = 0; return _newlocale(2147483647,1496,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=14;break; } else { label=15;break; }
 case 14: 
 HEAP32[((12664)>>2)]=$31;

 label=16;break;
 case 15: 
 var $34$0 = ___cxa_find_matching_catch(-1, -1); var $34$1 = tempRet0;

 ___resumeException($34$0)
 case 16: 
 var $35=HEAP32[((12664)>>2)];
 var $36=__ZNSt3__112__snprintf_lEPcjP15__locale_structPKcz($24,12,$35,$3,(tempVarArgs=STACKTOP,STACKTOP = (STACKTOP + 8)|0,(assert((STACKTOP|0) < (STACK_MAX|0))|0),HEAP32[((tempVarArgs)>>2)]=$__v,tempVarArgs)); STACKTOP=tempVarArgs;
 var $37=(($__nar+$36)|0);
 var $38=HEAP32[(($5)>>2)];
 var $39=$38&176;
 if(($39|0)==16){ label=17;break;}else if(($39|0)==32){ var $_0_i10=$37;label=23;break;}else{label=22;break;}
 case 17: 
 var $41=HEAP8[($24)];
 if((($41<<24)>>24)==45|(($41<<24)>>24)==43){ label=18;break;}else{label=19;break;}
 case 18: 
 var $43=(($__nar+1)|0);
 var $_0_i10=$43;label=23;break;
 case 19: 
 var $45=($36|0)>1;
 var $46=(($41<<24)>>24)==48;
 var $or_cond_i=$45&$46;
 if($or_cond_i){label=20;break;}else{label=22;break;}
 case 20: 
 var $48=(($__nar+1)|0);
 var $49=HEAP8[($48)];
 if((($49<<24)>>24)==120|(($49<<24)>>24)==88){ label=21;break;}else{label=22;break;}
 case 21: 
 var $51=(($__nar+2)|0);
 var $_0_i10=$51;label=23;break;
 case 22: 
 var $_0_i10=$24;label=23;break;
 case 23: 
 var $_0_i10;
 var $53=(($__o)|0);
 __ZNKSt3__18ios_base6getlocEv($1,$__iob);
 (function() { try { __THREW__ = 0; return __ZNSt3__19__num_putIwE21__widen_and_group_intEPcS2_S2_PwRS3_S4_RKNS_6localeE($24,$_0_i10,$37,$53,$__op,$__oe,$1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=24;break; } else { label=25;break; }
 case 24: 
 var $55=(($1)|0);
 var $56=HEAP32[(($55)>>2)];
 var $57=(($56)|0);
 var $58=__ZNSt3__114__shared_count16__release_sharedEv($57);
 var $59=(($__s)|0);
 var $60=HEAP32[(($59)>>2)];
 var $61=(($2)|0);
 HEAP32[(($61)>>2)]=$60;
 var $62=HEAP32[(($__op)>>2)];
 var $63=HEAP32[(($__oe)>>2)];
 __ZNSt3__116__pad_and_outputIwNS_11char_traitsIwEEEENS_19ostreambuf_iteratorIT_T0_EES6_PKS4_S8_S8_RNS_8ios_baseES4_($agg_result,$2,$53,$62,$63,$__iob,$__fl);
 STACKTOP=sp;return;
 case 25: 
 var $65$0 = ___cxa_find_matching_catch(-1, -1); var $65$1 = tempRet0;
 var $66=(($1)|0);
 var $67=HEAP32[(($66)>>2)];
 var $68=(($67)|0);
 var $69=__ZNSt3__114__shared_count16__release_sharedEv($68);
 ___resumeException($65$0)
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__19__num_putIwE21__widen_and_group_intEPcS2_S2_PwRS3_S4_RKNS_6localeE($__nb,$__np,$__ne,$__ob,$__op,$__oe,$__loc){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+48)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $__p_i_i_i_i55=sp;
 var $__p_i_i_i_i=(sp)+(16);
 var $__grouping=(sp)+(32);
 var $1=(($__loc)|0);
 var $2=HEAP32[(($1)>>2)];
 var $3=$__p_i_i_i_i;
 var $4=HEAP32[((14088)>>2)];
 var $5=($4|0)==-1;
 if($5){label=3;break;}else{label=2;break;}
 case 2: 
 var $_sroa_01_0___p67_i_idx_i_i_i=(($__p_i_i_i_i)|0);
 HEAP32[(($_sroa_01_0___p67_i_idx_i_i_i)>>2)]=14088;
 var $_sroa_12_4___p67_i_idx3_i_i_i=(($__p_i_i_i_i+4)|0);
 HEAP32[(($_sroa_12_4___p67_i_idx3_i_i_i)>>2)]=(28);
 var $_sroa_2_8___p67_i_idx4_i_i_i=(($__p_i_i_i_i+8)|0);
 HEAP32[(($_sroa_2_8___p67_i_idx4_i_i_i)>>2)]=0;
 __ZNSt3__111__call_onceERVmPvPFvS2_E(14088,$3,260);
 label=3;break;
 case 3: 
 var $7=HEAP32[((14092)>>2)];
 var $8=((($7)-(1))|0);
 var $9=(($2+12)|0);
 var $10=HEAP32[(($9)>>2)];
 var $11=(($2+8)|0);
 var $12=HEAP32[(($11)>>2)];
 var $13=$10;
 var $14=$12;
 var $15=((($13)-($14))|0);
 var $16=$15>>2;
 var $17=($16>>>0)>($8>>>0);
 if($17){label=4;break;}else{label=5;break;}
 case 4: 
 var $18=(($12+($8<<2))|0);
 var $19=HEAP32[(($18)>>2)];
 var $20=($19|0)==0;
 if($20){label=5;break;}else{label=6;break;}
 case 5: 
 var $21=___cxa_allocate_exception(4);
 var $22=$21;
 __ZNSt8bad_castC2Ev($22);
 ___cxa_throw($21,8960,(368));
 throw "Reached an unreachable!";
 case 6: 
 var $23=$19;
 var $24=HEAP32[(($1)>>2)];
 var $25=$__p_i_i_i_i55;
 var $26=HEAP32[((13704)>>2)];
 var $27=($26|0)==-1;
 if($27){label=8;break;}else{label=7;break;}
 case 7: 
 var $_sroa_01_0___p67_i_idx_i_i_i56=(($__p_i_i_i_i55)|0);
 HEAP32[(($_sroa_01_0___p67_i_idx_i_i_i56)>>2)]=13704;
 var $_sroa_12_4___p67_i_idx3_i_i_i57=(($__p_i_i_i_i55+4)|0);
 HEAP32[(($_sroa_12_4___p67_i_idx3_i_i_i57)>>2)]=(28);
 var $_sroa_2_8___p67_i_idx4_i_i_i58=(($__p_i_i_i_i55+8)|0);
 HEAP32[(($_sroa_2_8___p67_i_idx4_i_i_i58)>>2)]=0;
 __ZNSt3__111__call_onceERVmPvPFvS2_E(13704,$25,260);
 label=8;break;
 case 8: 
 var $29=HEAP32[((13708)>>2)];
 var $30=((($29)-(1))|0);
 var $31=(($24+12)|0);
 var $32=HEAP32[(($31)>>2)];
 var $33=(($24+8)|0);
 var $34=HEAP32[(($33)>>2)];
 var $35=$32;
 var $36=$34;
 var $37=((($35)-($36))|0);
 var $38=$37>>2;
 var $39=($38>>>0)>($30>>>0);
 if($39){label=9;break;}else{label=10;break;}
 case 9: 
 var $40=(($34+($30<<2))|0);
 var $41=HEAP32[(($40)>>2)];
 var $42=($41|0)==0;
 if($42){label=10;break;}else{label=11;break;}
 case 10: 
 var $43=___cxa_allocate_exception(4);
 var $44=$43;
 __ZNSt8bad_castC2Ev($44);
 ___cxa_throw($43,8960,(368));
 throw "Reached an unreachable!";
 case 11: 
 var $45=$41;
 var $46=$41;
 var $47=HEAP32[(($46)>>2)];
 var $48=(($47+20)|0);
 var $49=HEAP32[(($48)>>2)];
 FUNCTION_TABLE[$49]($__grouping,$45);
 var $50=$__grouping;
 var $51=HEAP8[($50)];
 var $52=$51&1;
 var $53=(($52<<24)>>24)==0;
 if($53){label=13;break;}else{label=12;break;}
 case 12: 
 var $55=(($__grouping+4)|0);
 var $56=HEAP32[(($55)>>2)];
 var $60=$56;label=14;break;
 case 13: 
 var $58=($51&255);
 var $59=$58>>>1;
 var $60=$59;label=14;break;
 case 14: 
 var $60;
 var $61=($60|0)==0;
 if($61){label=15;break;}else{label=20;break;}
 case 15: 
 var $63=$19;
 var $64=HEAP32[(($63)>>2)];
 var $65=(($64+48)|0);
 var $66=HEAP32[(($65)>>2)];
 var $67=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$66]($23,$__nb,$__ne,$__ob) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=16;break; } else { label=18;break; }
 case 16: 
 var $68=$__ne;
 var $69=$__nb;
 var $70=((($68)-($69))|0);
 var $71=(($__ob+($70<<2))|0);
 HEAP32[(($__oe)>>2)]=$71;
 var $184=$71;label=47;break;
 case 17: 
 var $lpad_loopexit$0 = ___cxa_find_matching_catch(-1, -1); var $lpad_loopexit$1 = tempRet0;
 var $lpad_phi$1=$lpad_loopexit$1;var $lpad_phi$0=$lpad_loopexit$0;label=19;break;
 case 18: 
 var $lpad_nonloopexit$0 = ___cxa_find_matching_catch(-1, -1); var $lpad_nonloopexit$1 = tempRet0;
 var $lpad_phi$1=$lpad_nonloopexit$1;var $lpad_phi$0=$lpad_nonloopexit$0;label=19;break;
 case 19: 
 var $lpad_phi$0;
 var $lpad_phi$1;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grouping);
 ___resumeException($lpad_phi$0)
 case 20: 
 HEAP32[(($__oe)>>2)]=$__ob;
 var $74=HEAP8[($__nb)];
 if((($74<<24)>>24)==45|(($74<<24)>>24)==43){ label=21;break;}else{var $__nf_0=$__nb;label=23;break;}
 case 21: 
 var $76=$19;
 var $77=HEAP32[(($76)>>2)];
 var $78=(($77+44)|0);
 var $79=HEAP32[(($78)>>2)];
 var $80=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$79]($23,$74) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=22;break; } else { label=18;break; }
 case 22: 
 var $81=(($__nb+1)|0);
 var $82=HEAP32[(($__oe)>>2)];
 var $83=(($82+4)|0);
 HEAP32[(($__oe)>>2)]=$83;
 HEAP32[(($82)>>2)]=$80;
 var $__nf_0=$81;label=23;break;
 case 23: 
 var $__nf_0;
 var $85=$__ne;
 var $86=$__nf_0;
 var $87=((($85)-($86))|0);
 var $88=($87|0)>1;
 if($88){label=24;break;}else{var $__nf_1=$__nf_0;label=29;break;}
 case 24: 
 var $90=HEAP8[($__nf_0)];
 var $91=(($90<<24)>>24)==48;
 if($91){label=25;break;}else{var $__nf_1=$__nf_0;label=29;break;}
 case 25: 
 var $93=(($__nf_0+1)|0);
 var $94=HEAP8[($93)];
 if((($94<<24)>>24)==120|(($94<<24)>>24)==88){ label=26;break;}else{var $__nf_1=$__nf_0;label=29;break;}
 case 26: 
 var $96=$19;
 var $97=HEAP32[(($96)>>2)];
 var $98=(($97+44)|0);
 var $99=HEAP32[(($98)>>2)];
 var $100=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$99]($23,48) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=27;break; } else { label=18;break; }
 case 27: 
 var $101=HEAP32[(($__oe)>>2)];
 var $102=(($101+4)|0);
 HEAP32[(($__oe)>>2)]=$102;
 HEAP32[(($101)>>2)]=$100;
 var $103=HEAP8[($93)];
 var $104=HEAP32[(($96)>>2)];
 var $105=(($104+44)|0);
 var $106=HEAP32[(($105)>>2)];
 var $107=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$106]($23,$103) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=28;break; } else { label=18;break; }
 case 28: 
 var $108=(($__nf_0+2)|0);
 var $109=HEAP32[(($__oe)>>2)];
 var $110=(($109+4)|0);
 HEAP32[(($__oe)>>2)]=$110;
 HEAP32[(($109)>>2)]=$107;
 var $__nf_1=$108;label=29;break;
 case 29: 
 var $__nf_1;
 var $112=($__nf_1|0)==($__ne|0);
 if($112){label=32;break;}else{label=30;break;}
 case 30: 
 var $113=((($__ne)-(1))|0);
 var $114=($113>>>0)>($__nf_1>>>0);
 if($114){var $_078_i_i=$__nf_1;var $115=$113;label=31;break;}else{label=32;break;}
 case 31: 
 var $115;
 var $_078_i_i;
 var $116=HEAP8[($_078_i_i)];
 var $117=HEAP8[($115)];
 HEAP8[($_078_i_i)]=$117;
 HEAP8[($115)]=$116;
 var $118=(($_078_i_i+1)|0);
 var $119=((($115)-(1))|0);
 var $120=($118>>>0)<($119>>>0);
 if($120){var $_078_i_i=$118;var $115=$119;label=31;break;}else{label=32;break;}
 case 32: 
 var $121=$41;
 var $122=HEAP32[(($121)>>2)];
 var $123=(($122+16)|0);
 var $124=HEAP32[(($123)>>2)];
 var $125=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$124]($45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=33;break; } else { label=18;break; }
 case 33: 
 var $126=($__nf_1>>>0)<($__ne>>>0);
 if($126){label=35;break;}else{label=34;break;}
 case 34: 
 var $_pre=HEAP32[(($__oe)>>2)];
 var $170=$_pre;label=44;break;
 case 35: 
 var $127=$__grouping;
 var $128=(($127+1)|0);
 var $129=$19;
 var $130=(($__grouping+4)|0);
 var $131=(($__grouping+8)|0);
 var $__dc_069=0;var $__dg_070=0;var $__p_071=$__nf_1;label=36;break;
 case 36: 
 var $__p_071;
 var $__dg_070;
 var $__dc_069;
 var $132=HEAP8[($50)];
 var $133=$132&1;
 var $134=(($133<<24)>>24)==0;
 var $135=HEAP32[(($131)>>2)];
 var $_=($134?$128:$135);
 var $136=(($_+$__dg_070)|0);
 var $137=HEAP8[($136)];
 var $138=(($137<<24)>>24)==0;
 if($138){var $__dg_1=$__dg_070;var $__dc_1=$__dc_069;label=42;break;}else{label=37;break;}
 case 37: 
 var $139=HEAP32[(($131)>>2)];
 var $_72=($134?$128:$139);
 var $140=(($_72+$__dg_070)|0);
 var $141=HEAP8[($140)];
 var $142=(($141<<24)>>24);
 var $143=($__dc_069|0)==($142|0);
 if($143){label=38;break;}else{var $__dg_1=$__dg_070;var $__dc_1=$__dc_069;label=42;break;}
 case 38: 
 var $145=HEAP32[(($__oe)>>2)];
 var $146=(($145+4)|0);
 HEAP32[(($__oe)>>2)]=$146;
 HEAP32[(($145)>>2)]=$125;
 var $147=HEAP8[($50)];
 var $148=$147&1;
 var $149=(($148<<24)>>24)==0;
 if($149){label=40;break;}else{label=39;break;}
 case 39: 
 var $151=HEAP32[(($130)>>2)];
 var $155=$151;label=41;break;
 case 40: 
 var $153=($147&255);
 var $154=$153>>>1;
 var $155=$154;label=41;break;
 case 41: 
 var $155;
 var $156=((($155)-(1))|0);
 var $157=($__dg_070>>>0)<($156>>>0);
 var $158=($157&1);
 var $___dg_0=((($158)+($__dg_070))|0);
 var $__dg_1=$___dg_0;var $__dc_1=0;label=42;break;
 case 42: 
 var $__dc_1;
 var $__dg_1;
 var $160=HEAP8[($__p_071)];
 var $161=HEAP32[(($129)>>2)];
 var $162=(($161+44)|0);
 var $163=HEAP32[(($162)>>2)];
 var $164=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$163]($23,$160) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=43;break; } else { label=17;break; }
 case 43: 
 var $165=HEAP32[(($__oe)>>2)];
 var $166=(($165+4)|0);
 HEAP32[(($__oe)>>2)]=$166;
 HEAP32[(($165)>>2)]=$164;
 var $167=((($__dc_1)+(1))|0);
 var $168=(($__p_071+1)|0);
 var $169=($168>>>0)<($__ne>>>0);
 if($169){var $__dc_069=$167;var $__dg_070=$__dg_1;var $__p_071=$168;label=36;break;}else{var $170=$166;label=44;break;}
 case 44: 
 var $170;
 var $171=$__nf_1;
 var $172=$__nb;
 var $173=((($171)-($172))|0);
 var $174=(($__ob+($173<<2))|0);
 var $175=($174|0)==($170|0);
 if($175){var $184=$170;label=47;break;}else{label=45;break;}
 case 45: 
 var $176=((($170)-(4))|0);
 var $177=($176>>>0)>($174>>>0);
 if($177){var $_078_i_i67=$174;var $178=$176;label=46;break;}else{var $184=$170;label=47;break;}
 case 46: 
 var $178;
 var $_078_i_i67;
 var $179=HEAP32[(($_078_i_i67)>>2)];
 var $180=HEAP32[(($178)>>2)];
 HEAP32[(($_078_i_i67)>>2)]=$180;
 HEAP32[(($178)>>2)]=$179;
 var $181=(($_078_i_i67+4)|0);
 var $182=((($178)-(4))|0);
 var $183=($181>>>0)<($182>>>0);
 if($183){var $_078_i_i67=$181;var $178=$182;label=46;break;}else{var $184=$170;label=47;break;}
 case 47: 
 var $184;
 var $185=($__np|0)==($__ne|0);
 if($185){var $storemerge=$184;label=49;break;}else{label=48;break;}
 case 48: 
 var $187=$__np;
 var $188=$__nb;
 var $189=((($187)-($188))|0);
 var $190=(($__ob+($189<<2))|0);
 var $storemerge=$190;label=49;break;
 case 49: 
 var $storemerge;
 HEAP32[(($__op)>>2)]=$storemerge;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grouping);
 STACKTOP=sp;return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__116__pad_and_outputIwNS_11char_traitsIwEEEENS_19ostreambuf_iteratorIT_T0_EES6_PKS4_S8_S8_RNS_8ios_baseES4_($agg_result,$__s,$__ob,$__op,$__oe,$__iob,$__fl){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+16)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var tempParam = $__s; $__s=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__s)>>2)]=HEAP32[((tempParam)>>2)];
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $__sp=sp;
 var $1=(($__s)|0);
 var $2=HEAP32[(($1)>>2)];
 var $3=($2|0)==0;
 if($3){label=2;break;}else{label=3;break;}
 case 2: 
 var $5=(($agg_result)|0);
 HEAP32[(($5)>>2)]=0;
 label=19;break;
 case 3: 
 var $7=$__oe;
 var $8=$__ob;
 var $9=((($7)-($8))|0);
 var $10=$9>>2;
 var $11=(($__iob+12)|0);
 var $12=HEAP32[(($11)>>2)];
 var $13=($12|0)>($10|0);
 var $14=((($12)-($10))|0);
 var $__ns_0=($13?$14:0);
 var $15=$__op;
 var $16=((($15)-($8))|0);
 var $17=$16>>2;
 var $18=($16|0)>0;
 if($18){label=4;break;}else{label=6;break;}
 case 4: 
 var $20=$2;
 var $21=HEAP32[(($20)>>2)];
 var $22=(($21+48)|0);
 var $23=HEAP32[(($22)>>2)];
 var $24=FUNCTION_TABLE[$23]($2,$__ob,$17);
 var $25=($24|0)==($17|0);
 if($25){label=6;break;}else{label=5;break;}
 case 5: 
 HEAP32[(($1)>>2)]=0;
 var $27=(($agg_result)|0);
 HEAP32[(($27)>>2)]=0;
 label=19;break;
 case 6: 
 var $29=($__ns_0|0)>0;
 if($29){label=7;break;}else{label=15;break;}
 case 7: 
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6__initEjw($__sp,$__ns_0,$__fl);
 var $31=$__sp;
 var $32=HEAP8[($31)];
 var $33=$32&1;
 var $34=(($33<<24)>>24)==0;
 if($34){label=9;break;}else{label=8;break;}
 case 8: 
 var $36=(($__sp+8)|0);
 var $37=HEAP32[(($36)>>2)];
 var $40=$37;label=10;break;
 case 9: 
 var $39=(($__sp+4)|0);
 var $40=$39;label=10;break;
 case 10: 
 var $40;
 var $41=$2;
 var $42=HEAP32[(($41)>>2)];
 var $43=(($42+48)|0);
 var $44=HEAP32[(($43)>>2)];
 var $45=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$44]($2,$40,$__ns_0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=11;break; } else { label=13;break; }
 case 11: 
 var $46=($45|0)==($__ns_0|0);
 if($46){label=14;break;}else{label=12;break;}
 case 12: 
 HEAP32[(($1)>>2)]=0;
 var $47=(($agg_result)|0);
 HEAP32[(($47)>>2)]=0;
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev($__sp);
 label=19;break;
 case 13: 
 var $49$0 = ___cxa_find_matching_catch(-1, -1); var $49$1 = tempRet0;
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev($__sp);
 ___resumeException($49$0)
 case 14: 
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev($__sp);
 label=15;break;
 case 15: 
 var $52=((($7)-($15))|0);
 var $53=$52>>2;
 var $54=($52|0)>0;
 if($54){label=16;break;}else{label=18;break;}
 case 16: 
 var $56=$2;
 var $57=HEAP32[(($56)>>2)];
 var $58=(($57+48)|0);
 var $59=HEAP32[(($58)>>2)];
 var $60=FUNCTION_TABLE[$59]($2,$__op,$53);
 var $61=($60|0)==($53|0);
 if($61){label=18;break;}else{label=17;break;}
 case 17: 
 HEAP32[(($1)>>2)]=0;
 var $63=(($agg_result)|0);
 HEAP32[(($63)>>2)]=0;
 label=19;break;
 case 18: 
 HEAP32[(($11)>>2)]=0;
 var $65=(($agg_result)|0);
 HEAP32[(($65)>>2)]=$2;
 label=19;break;
 case 19: 
 STACKTOP=sp;return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwx($agg_result,$this,$__s,$__iob,$__fl,$__v$0,$__v$1){
 var label=0;
 var tempVarArgs=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+232)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var tempParam = $__s; $__s=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__s)>>2)]=HEAP32[((tempParam)>>2)];
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $__fmt=sp;
 var $__nar=(sp)+(8);
 var $__o=(sp)+(32);
 var $__op=(sp)+(200);
 var $__oe=(sp)+(208);
 var $1=(sp)+(216);
 var $2=(sp)+(224);
 var $$etemp$0$0=37;
 var $$etemp$0$1=0;
 var $st$1$0=(($__fmt)|0);
 HEAP32[(($st$1$0)>>2)]=$$etemp$0$0;
 var $st$2$1=(($__fmt+4)|0);
 HEAP32[(($st$2$1)>>2)]=$$etemp$0$1;
 var $3=$__fmt;
 var $4=(($3+1)|0);
 var $5=(($__iob+4)|0);
 var $6=HEAP32[(($5)>>2)];
 var $7=$6&2048;
 var $8=($7|0)==0;
 if($8){var $_0_i=$4;label=3;break;}else{label=2;break;}
 case 2: 
 var $10=(($3+2)|0);
 HEAP8[($4)]=43;
 var $_0_i=$10;label=3;break;
 case 3: 
 var $_0_i;
 var $12=$6&512;
 var $13=($12|0)==0;
 if($13){var $_116_i_ph=$_0_i;label=5;break;}else{label=4;break;}
 case 4: 
 var $15=(($_0_i+1)|0);
 HEAP8[($_0_i)]=35;
 var $_116_i_ph=$15;label=5;break;
 case 5: 
 var $_116_i_ph;
 var $16=(($_116_i_ph+1)|0);
 HEAP8[($_116_i_ph)]=108;
 HEAP8[($16)]=108;
 var $scevgep=(($_116_i_ph+2)|0);
 var $17=$6&74;
 if(($17|0)==64){ label=6;break;}else if(($17|0)==8){ label=7;break;}else{label=10;break;}
 case 6: 
 HEAP8[($scevgep)]=111;
 label=11;break;
 case 7: 
 var $20=$6&16384;
 var $21=($20|0)==0;
 if($21){label=9;break;}else{label=8;break;}
 case 8: 
 HEAP8[($scevgep)]=88;
 label=11;break;
 case 9: 
 HEAP8[($scevgep)]=120;
 label=11;break;
 case 10: 
 HEAP8[($scevgep)]=100;
 label=11;break;
 case 11: 
 var $25=(($__nar)|0);
 var $26=HEAP8[(14656)];
 var $27=(($26<<24)>>24)==0;
 if($27){label=12;break;}else{label=16;break;}
 case 12: 
 var $29=___cxa_guard_acquire(14656);
 var $30=($29|0)==0;
 if($30){label=16;break;}else{label=13;break;}
 case 13: 
 var $32=(function() { try { __THREW__ = 0; return _newlocale(2147483647,1496,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=14;break; } else { label=15;break; }
 case 14: 
 HEAP32[((12664)>>2)]=$32;

 label=16;break;
 case 15: 
 var $35$0 = ___cxa_find_matching_catch(-1, -1); var $35$1 = tempRet0;

 ___resumeException($35$0)
 case 16: 
 var $36=HEAP32[((12664)>>2)];
 var $37=__ZNSt3__112__snprintf_lEPcjP15__locale_structPKcz($25,22,$36,$3,(tempVarArgs=STACKTOP,STACKTOP = (STACKTOP + 16)|0,(assert((STACKTOP|0) < (STACK_MAX|0))|0),HEAP32[((tempVarArgs)>>2)]=$__v$0,HEAP32[(((tempVarArgs)+(8))>>2)]=$__v$1,tempVarArgs)); STACKTOP=tempVarArgs;
 var $38=(($__nar+$37)|0);
 var $39=HEAP32[(($5)>>2)];
 var $40=$39&176;
 if(($40|0)==16){ label=17;break;}else if(($40|0)==32){ var $_0_i10=$38;label=23;break;}else{label=22;break;}
 case 17: 
 var $42=HEAP8[($25)];
 if((($42<<24)>>24)==45|(($42<<24)>>24)==43){ label=18;break;}else{label=19;break;}
 case 18: 
 var $44=(($__nar+1)|0);
 var $_0_i10=$44;label=23;break;
 case 19: 
 var $46=($37|0)>1;
 var $47=(($42<<24)>>24)==48;
 var $or_cond_i=$46&$47;
 if($or_cond_i){label=20;break;}else{label=22;break;}
 case 20: 
 var $49=(($__nar+1)|0);
 var $50=HEAP8[($49)];
 if((($50<<24)>>24)==120|(($50<<24)>>24)==88){ label=21;break;}else{label=22;break;}
 case 21: 
 var $52=(($__nar+2)|0);
 var $_0_i10=$52;label=23;break;
 case 22: 
 var $_0_i10=$25;label=23;break;
 case 23: 
 var $_0_i10;
 var $54=(($__o)|0);
 __ZNKSt3__18ios_base6getlocEv($1,$__iob);
 (function() { try { __THREW__ = 0; return __ZNSt3__19__num_putIwE21__widen_and_group_intEPcS2_S2_PwRS3_S4_RKNS_6localeE($25,$_0_i10,$38,$54,$__op,$__oe,$1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=24;break; } else { label=25;break; }
 case 24: 
 var $56=(($1)|0);
 var $57=HEAP32[(($56)>>2)];
 var $58=(($57)|0);
 var $59=__ZNSt3__114__shared_count16__release_sharedEv($58);
 var $60=(($__s)|0);
 var $61=HEAP32[(($60)>>2)];
 var $62=(($2)|0);
 HEAP32[(($62)>>2)]=$61;
 var $63=HEAP32[(($__op)>>2)];
 var $64=HEAP32[(($__oe)>>2)];
 __ZNSt3__116__pad_and_outputIwNS_11char_traitsIwEEEENS_19ostreambuf_iteratorIT_T0_EES6_PKS4_S8_S8_RNS_8ios_baseES4_($agg_result,$2,$54,$63,$64,$__iob,$__fl);
 STACKTOP=sp;return;
 case 25: 
 var $66$0 = ___cxa_find_matching_catch(-1, -1); var $66$1 = tempRet0;
 var $67=(($1)|0);
 var $68=HEAP32[(($67)>>2)];
 var $69=(($68)|0);
 var $70=__ZNSt3__114__shared_count16__release_sharedEv($69);
 ___resumeException($66$0)
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwm($agg_result,$this,$__s,$__iob,$__fl,$__v){
 var label=0;
 var tempVarArgs=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+144)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var tempParam = $__s; $__s=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__s)>>2)]=HEAP32[((tempParam)>>2)];
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $__fmt=sp;
 var $__nar=(sp)+(8);
 var $__o=(sp)+(24);
 var $__op=(sp)+(112);
 var $__oe=(sp)+(120);
 var $1=(sp)+(128);
 var $2=(sp)+(136);
 var $3=(($__fmt)|0);
 assert(6 % 1 === 0);HEAP8[($3)]=HEAP8[(2904)];HEAP8[((($3)+(1))|0)]=HEAP8[(2905)];HEAP8[((($3)+(2))|0)]=HEAP8[(2906)];HEAP8[((($3)+(3))|0)]=HEAP8[(2907)];HEAP8[((($3)+(4))|0)]=HEAP8[(2908)];HEAP8[((($3)+(5))|0)]=HEAP8[(2909)];
 var $4=(($__fmt+1)|0);
 var $5=(($__iob+4)|0);
 var $6=HEAP32[(($5)>>2)];
 var $7=$6&2048;
 var $8=($7|0)==0;
 if($8){var $_0_i=$4;label=3;break;}else{label=2;break;}
 case 2: 
 var $10=(($__fmt+2)|0);
 HEAP8[($4)]=43;
 var $_0_i=$10;label=3;break;
 case 3: 
 var $_0_i;
 var $12=$6&512;
 var $13=($12|0)==0;
 if($13){var $_116_i_ph=$_0_i;label=5;break;}else{label=4;break;}
 case 4: 
 var $15=(($_0_i+1)|0);
 HEAP8[($_0_i)]=35;
 var $_116_i_ph=$15;label=5;break;
 case 5: 
 var $_116_i_ph;
 HEAP8[($_116_i_ph)]=108;
 var $scevgep=(($_116_i_ph+1)|0);
 var $16=$6&74;
 if(($16|0)==64){ label=6;break;}else if(($16|0)==8){ label=7;break;}else{label=10;break;}
 case 6: 
 HEAP8[($scevgep)]=111;
 label=11;break;
 case 7: 
 var $19=$6&16384;
 var $20=($19|0)==0;
 if($20){label=9;break;}else{label=8;break;}
 case 8: 
 HEAP8[($scevgep)]=88;
 label=11;break;
 case 9: 
 HEAP8[($scevgep)]=120;
 label=11;break;
 case 10: 
 HEAP8[($scevgep)]=117;
 label=11;break;
 case 11: 
 var $24=(($__nar)|0);
 var $25=HEAP8[(14656)];
 var $26=(($25<<24)>>24)==0;
 if($26){label=12;break;}else{label=16;break;}
 case 12: 
 var $28=___cxa_guard_acquire(14656);
 var $29=($28|0)==0;
 if($29){label=16;break;}else{label=13;break;}
 case 13: 
 var $31=(function() { try { __THREW__ = 0; return _newlocale(2147483647,1496,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=14;break; } else { label=15;break; }
 case 14: 
 HEAP32[((12664)>>2)]=$31;

 label=16;break;
 case 15: 
 var $34$0 = ___cxa_find_matching_catch(-1, -1); var $34$1 = tempRet0;

 ___resumeException($34$0)
 case 16: 
 var $35=HEAP32[((12664)>>2)];
 var $36=__ZNSt3__112__snprintf_lEPcjP15__locale_structPKcz($24,12,$35,$3,(tempVarArgs=STACKTOP,STACKTOP = (STACKTOP + 8)|0,(assert((STACKTOP|0) < (STACK_MAX|0))|0),HEAP32[((tempVarArgs)>>2)]=$__v,tempVarArgs)); STACKTOP=tempVarArgs;
 var $37=(($__nar+$36)|0);
 var $38=HEAP32[(($5)>>2)];
 var $39=$38&176;
 if(($39|0)==16){ label=17;break;}else if(($39|0)==32){ var $_0_i10=$37;label=23;break;}else{label=22;break;}
 case 17: 
 var $41=HEAP8[($24)];
 if((($41<<24)>>24)==45|(($41<<24)>>24)==43){ label=18;break;}else{label=19;break;}
 case 18: 
 var $43=(($__nar+1)|0);
 var $_0_i10=$43;label=23;break;
 case 19: 
 var $45=($36|0)>1;
 var $46=(($41<<24)>>24)==48;
 var $or_cond_i=$45&$46;
 if($or_cond_i){label=20;break;}else{label=22;break;}
 case 20: 
 var $48=(($__nar+1)|0);
 var $49=HEAP8[($48)];
 if((($49<<24)>>24)==120|(($49<<24)>>24)==88){ label=21;break;}else{label=22;break;}
 case 21: 
 var $51=(($__nar+2)|0);
 var $_0_i10=$51;label=23;break;
 case 22: 
 var $_0_i10=$24;label=23;break;
 case 23: 
 var $_0_i10;
 var $53=(($__o)|0);
 __ZNKSt3__18ios_base6getlocEv($1,$__iob);
 (function() { try { __THREW__ = 0; return __ZNSt3__19__num_putIwE21__widen_and_group_intEPcS2_S2_PwRS3_S4_RKNS_6localeE($24,$_0_i10,$37,$53,$__op,$__oe,$1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=24;break; } else { label=25;break; }
 case 24: 
 var $55=(($1)|0);
 var $56=HEAP32[(($55)>>2)];
 var $57=(($56)|0);
 var $58=__ZNSt3__114__shared_count16__release_sharedEv($57);
 var $59=(($__s)|0);
 var $60=HEAP32[(($59)>>2)];
 var $61=(($2)|0);
 HEAP32[(($61)>>2)]=$60;
 var $62=HEAP32[(($__op)>>2)];
 var $63=HEAP32[(($__oe)>>2)];
 __ZNSt3__116__pad_and_outputIwNS_11char_traitsIwEEEENS_19ostreambuf_iteratorIT_T0_EES6_PKS4_S8_S8_RNS_8ios_baseES4_($agg_result,$2,$53,$62,$63,$__iob,$__fl);
 STACKTOP=sp;return;
 case 25: 
 var $65$0 = ___cxa_find_matching_catch(-1, -1); var $65$1 = tempRet0;
 var $66=(($1)|0);
 var $67=HEAP32[(($66)>>2)];
 var $68=(($67)|0);
 var $69=__ZNSt3__114__shared_count16__release_sharedEv($68);
 ___resumeException($65$0)
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwy($agg_result,$this,$__s,$__iob,$__fl,$__v$0,$__v$1){
 var label=0;
 var tempVarArgs=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+240)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var tempParam = $__s; $__s=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__s)>>2)]=HEAP32[((tempParam)>>2)];
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $__fmt=sp;
 var $__nar=(sp)+(8);
 var $__o=(sp)+(32);
 var $__op=(sp)+(208);
 var $__oe=(sp)+(216);
 var $1=(sp)+(224);
 var $2=(sp)+(232);
 var $$etemp$0$0=37;
 var $$etemp$0$1=0;
 var $st$1$0=(($__fmt)|0);
 HEAP32[(($st$1$0)>>2)]=$$etemp$0$0;
 var $st$2$1=(($__fmt+4)|0);
 HEAP32[(($st$2$1)>>2)]=$$etemp$0$1;
 var $3=$__fmt;
 var $4=(($3+1)|0);
 var $5=(($__iob+4)|0);
 var $6=HEAP32[(($5)>>2)];
 var $7=$6&2048;
 var $8=($7|0)==0;
 if($8){var $_0_i=$4;label=3;break;}else{label=2;break;}
 case 2: 
 var $10=(($3+2)|0);
 HEAP8[($4)]=43;
 var $_0_i=$10;label=3;break;
 case 3: 
 var $_0_i;
 var $12=$6&512;
 var $13=($12|0)==0;
 if($13){var $_116_i_ph=$_0_i;label=5;break;}else{label=4;break;}
 case 4: 
 var $15=(($_0_i+1)|0);
 HEAP8[($_0_i)]=35;
 var $_116_i_ph=$15;label=5;break;
 case 5: 
 var $_116_i_ph;
 var $16=(($_116_i_ph+1)|0);
 HEAP8[($_116_i_ph)]=108;
 HEAP8[($16)]=108;
 var $scevgep=(($_116_i_ph+2)|0);
 var $17=$6&74;
 if(($17|0)==64){ label=6;break;}else if(($17|0)==8){ label=7;break;}else{label=10;break;}
 case 6: 
 HEAP8[($scevgep)]=111;
 label=11;break;
 case 7: 
 var $20=$6&16384;
 var $21=($20|0)==0;
 if($21){label=9;break;}else{label=8;break;}
 case 8: 
 HEAP8[($scevgep)]=88;
 label=11;break;
 case 9: 
 HEAP8[($scevgep)]=120;
 label=11;break;
 case 10: 
 HEAP8[($scevgep)]=117;
 label=11;break;
 case 11: 
 var $25=(($__nar)|0);
 var $26=HEAP8[(14656)];
 var $27=(($26<<24)>>24)==0;
 if($27){label=12;break;}else{label=16;break;}
 case 12: 
 var $29=___cxa_guard_acquire(14656);
 var $30=($29|0)==0;
 if($30){label=16;break;}else{label=13;break;}
 case 13: 
 var $32=(function() { try { __THREW__ = 0; return _newlocale(2147483647,1496,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=14;break; } else { label=15;break; }
 case 14: 
 HEAP32[((12664)>>2)]=$32;

 label=16;break;
 case 15: 
 var $35$0 = ___cxa_find_matching_catch(-1, -1); var $35$1 = tempRet0;

 ___resumeException($35$0)
 case 16: 
 var $36=HEAP32[((12664)>>2)];
 var $37=__ZNSt3__112__snprintf_lEPcjP15__locale_structPKcz($25,23,$36,$3,(tempVarArgs=STACKTOP,STACKTOP = (STACKTOP + 16)|0,(assert((STACKTOP|0) < (STACK_MAX|0))|0),HEAP32[((tempVarArgs)>>2)]=$__v$0,HEAP32[(((tempVarArgs)+(8))>>2)]=$__v$1,tempVarArgs)); STACKTOP=tempVarArgs;
 var $38=(($__nar+$37)|0);
 var $39=HEAP32[(($5)>>2)];
 var $40=$39&176;
 if(($40|0)==16){ label=17;break;}else if(($40|0)==32){ var $_0_i10=$38;label=23;break;}else{label=22;break;}
 case 17: 
 var $42=HEAP8[($25)];
 if((($42<<24)>>24)==45|(($42<<24)>>24)==43){ label=18;break;}else{label=19;break;}
 case 18: 
 var $44=(($__nar+1)|0);
 var $_0_i10=$44;label=23;break;
 case 19: 
 var $46=($37|0)>1;
 var $47=(($42<<24)>>24)==48;
 var $or_cond_i=$46&$47;
 if($or_cond_i){label=20;break;}else{label=22;break;}
 case 20: 
 var $49=(($__nar+1)|0);
 var $50=HEAP8[($49)];
 if((($50<<24)>>24)==120|(($50<<24)>>24)==88){ label=21;break;}else{label=22;break;}
 case 21: 
 var $52=(($__nar+2)|0);
 var $_0_i10=$52;label=23;break;
 case 22: 
 var $_0_i10=$25;label=23;break;
 case 23: 
 var $_0_i10;
 var $54=(($__o)|0);
 __ZNKSt3__18ios_base6getlocEv($1,$__iob);
 (function() { try { __THREW__ = 0; return __ZNSt3__19__num_putIwE21__widen_and_group_intEPcS2_S2_PwRS3_S4_RKNS_6localeE($25,$_0_i10,$38,$54,$__op,$__oe,$1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=24;break; } else { label=25;break; }
 case 24: 
 var $56=(($1)|0);
 var $57=HEAP32[(($56)>>2)];
 var $58=(($57)|0);
 var $59=__ZNSt3__114__shared_count16__release_sharedEv($58);
 var $60=(($__s)|0);
 var $61=HEAP32[(($60)>>2)];
 var $62=(($2)|0);
 HEAP32[(($62)>>2)]=$61;
 var $63=HEAP32[(($__op)>>2)];
 var $64=HEAP32[(($__oe)>>2)];
 __ZNSt3__116__pad_and_outputIwNS_11char_traitsIwEEEENS_19ostreambuf_iteratorIT_T0_EES6_PKS4_S8_S8_RNS_8ios_baseES4_($agg_result,$2,$54,$63,$64,$__iob,$__fl);
 STACKTOP=sp;return;
 case 25: 
 var $66$0 = ___cxa_find_matching_catch(-1, -1); var $66$1 = tempRet0;
 var $67=(($1)|0);
 var $68=HEAP32[(($67)>>2)];
 var $69=(($68)|0);
 var $70=__ZNSt3__114__shared_count16__release_sharedEv($69);
 ___resumeException($66$0)
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwd($agg_result,$this,$__s,$__iob,$__fl,$__v){
 var label=0;
 var tempVarArgs=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+320)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var tempParam = $__s; $__s=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__s)>>2)]=HEAP32[((tempParam)>>2)];
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $__fmt=sp;
 var $__nar=(sp)+(8);
 var $__nb=(sp)+(40);
 var $__o=(sp)+(48);
 var $__op=(sp)+(280);
 var $__oe=(sp)+(288);
 var $1=(sp)+(296);
 var $2=(sp)+(304);
 var $3=(sp)+(312);
 var $$etemp$0$0=37;
 var $$etemp$0$1=0;
 var $st$1$0=(($__fmt)|0);
 HEAP32[(($st$1$0)>>2)]=$$etemp$0$0;
 var $st$2$1=(($__fmt+4)|0);
 HEAP32[(($st$2$1)>>2)]=$$etemp$0$1;
 var $4=$__fmt;
 var $5=(($4+1)|0);
 var $6=(($__iob+4)|0);
 var $7=HEAP32[(($6)>>2)];
 var $8=$7&2048;
 var $9=($8|0)==0;
 if($9){var $_0_i=$5;label=3;break;}else{label=2;break;}
 case 2: 
 var $11=(($4+2)|0);
 HEAP8[($5)]=43;
 var $_0_i=$11;label=3;break;
 case 3: 
 var $_0_i;
 var $13=$7&1024;
 var $14=($13|0)==0;
 if($14){var $_1_i=$_0_i;label=5;break;}else{label=4;break;}
 case 4: 
 var $16=(($_0_i+1)|0);
 HEAP8[($_0_i)]=35;
 var $_1_i=$16;label=5;break;
 case 5: 
 var $_1_i;
 var $18=$7&260;
 var $19=$7>>>14;
 var $20=($18|0)==260;
 if($20){label=13;break;}else{label=6;break;}
 case 6: 
 var $21=(($_1_i+1)|0);
 HEAP8[($_1_i)]=46;
 var $22=(($_1_i+2)|0);
 HEAP8[($21)]=42;
 if(($18|0)==256){ label=10;break;}else if(($18|0)==4){ label=7;break;}else{label=16;break;}
 case 7: 
 var $24=$19&1;
 var $25=($24|0)==0;
 if($25){label=9;break;}else{label=8;break;}
 case 8: 
 HEAP8[($22)]=70;
 var $specify_precision_0_off0_ph_i44=1;label=19;break;
 case 9: 
 HEAP8[($22)]=102;
 var $specify_precision_0_off0_ph_i44=1;label=19;break;
 case 10: 
 var $29=$19&1;
 var $30=($29|0)==0;
 if($30){label=12;break;}else{label=11;break;}
 case 11: 
 HEAP8[($22)]=69;
 var $specify_precision_0_off0_ph_i44=1;label=19;break;
 case 12: 
 HEAP8[($22)]=101;
 var $specify_precision_0_off0_ph_i44=1;label=19;break;
 case 13: 
 var $34=$19&1;
 var $35=($34|0)==0;
 if($35){label=15;break;}else{label=14;break;}
 case 14: 
 HEAP8[($_1_i)]=65;
 var $specify_precision_0_off0_ph_i44=0;label=19;break;
 case 15: 
 HEAP8[($_1_i)]=97;
 var $specify_precision_0_off0_ph_i44=0;label=19;break;
 case 16: 
 var $39=$19&1;
 var $40=($39|0)==0;
 if($40){label=18;break;}else{label=17;break;}
 case 17: 
 HEAP8[($22)]=71;
 var $specify_precision_0_off0_ph_i44=1;label=19;break;
 case 18: 
 HEAP8[($22)]=103;
 var $specify_precision_0_off0_ph_i44=1;label=19;break;
 case 19: 
 var $specify_precision_0_off0_ph_i44;
 var $43=(($__nar)|0);
 HEAP32[(($__nb)>>2)]=$43;
 var $44=HEAP8[(14656)];
 var $45=(($44<<24)>>24)==0;
 if($45){label=20;break;}else{label=24;break;}
 case 20: 
 var $47=___cxa_guard_acquire(14656);
 var $48=($47|0)==0;
 if($48){label=24;break;}else{label=21;break;}
 case 21: 
 var $50=(function() { try { __THREW__ = 0; return _newlocale(2147483647,1496,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=22;break; } else { label=23;break; }
 case 22: 
 HEAP32[((12664)>>2)]=$50;

 label=24;break;
 case 23: 
 var $53$0 = ___cxa_find_matching_catch(-1, -1); var $53$1 = tempRet0;

 ___resumeException($53$0)
 case 24: 
 var $54=HEAP32[((12664)>>2)];
 if($specify_precision_0_off0_ph_i44){label=25;break;}else{label=26;break;}
 case 25: 
 var $56=(($__iob+8)|0);
 var $57=HEAP32[(($56)>>2)];
 var $58=__ZNSt3__112__snprintf_lEPcjP15__locale_structPKcz($43,30,$54,$4,(tempVarArgs=STACKTOP,STACKTOP = (STACKTOP + 16)|0,(assert((STACKTOP|0) < (STACK_MAX|0))|0),HEAP32[((tempVarArgs)>>2)]=$57,HEAPF64[(((tempVarArgs)+(8))>>3)]=$__v,tempVarArgs)); STACKTOP=tempVarArgs;
 var $__nc_0=$58;label=27;break;
 case 26: 
 var $60=__ZNSt3__112__snprintf_lEPcjP15__locale_structPKcz($43,30,$54,$4,(tempVarArgs=STACKTOP,STACKTOP = (STACKTOP + 8)|0,(assert((STACKTOP|0) < (STACK_MAX|0))|0),HEAPF64[((tempVarArgs)>>3)]=$__v,tempVarArgs)); STACKTOP=tempVarArgs;
 var $__nc_0=$60;label=27;break;
 case 27: 
 var $__nc_0;
 var $62=($__nc_0|0)>29;
 if($62){label=29;break;}else{label=28;break;}
 case 28: 
 var $_pre51=HEAP32[(($__nb)>>2)];
 var $__nc_2=$__nc_0;var $__nbh_sroa_0_0_load3742=0;var $102=$_pre51;label=47;break;
 case 29: 
 var $64=HEAP8[(14656)];
 var $65=(($64<<24)>>24)==0;
 if($specify_precision_0_off0_ph_i44){label=30;break;}else{label=38;break;}
 case 30: 
 if($65){label=31;break;}else{label=35;break;}
 case 31: 
 var $68=___cxa_guard_acquire(14656);
 var $69=($68|0)==0;
 if($69){label=35;break;}else{label=32;break;}
 case 32: 
 var $71=(function() { try { __THREW__ = 0; return _newlocale(2147483647,1496,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=33;break; } else { label=34;break; }
 case 33: 
 HEAP32[((12664)>>2)]=$71;

 label=35;break;
 case 34: 
 var $74$0 = ___cxa_find_matching_catch(-1, -1); var $74$1 = tempRet0;

 var $eh_lpad_body$1=$74$1;var $eh_lpad_body$0=$74$0;label=37;break;
 case 35: 
 var $76=HEAP32[((12664)>>2)];
 var $77=(($__iob+8)|0);
 var $78=HEAP32[(($77)>>2)];
 var $79=(function() { try { __THREW__ = 0; return __ZNSt3__112__asprintf_lEPPcP15__locale_structPKcz($__nb,$76,$4,(tempVarArgs=STACKTOP,STACKTOP = (STACKTOP + 16)|0,(assert((STACKTOP|0) < (STACK_MAX|0))|0),HEAP32[((tempVarArgs)>>2)]=$78,HEAPF64[(((tempVarArgs)+(8))>>3)]=$__v,tempVarArgs)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })(); STACKTOP=tempVarArgs;if (!__THREW__) { var $__nc_1=$79;label=44;break; } else { label=36;break; }
 case 36: 
 var $81$0 = ___cxa_find_matching_catch(-1, -1); var $81$1 = tempRet0;
 var $eh_lpad_body$1=$81$1;var $eh_lpad_body$0=$81$0;label=37;break;
 case 37: 
 var $eh_lpad_body$0;
 var $eh_lpad_body$1;
 var $82=$eh_lpad_body$0;
 var $83=$eh_lpad_body$1;
 var $_12349=$83;var $_150=$82;label=72;break;
 case 38: 
 if($65){label=39;break;}else{label=43;break;}
 case 39: 
 var $86=___cxa_guard_acquire(14656);
 var $87=($86|0)==0;
 if($87){label=43;break;}else{label=40;break;}
 case 40: 
 var $89=(function() { try { __THREW__ = 0; return _newlocale(2147483647,1496,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=41;break; } else { label=42;break; }
 case 41: 
 HEAP32[((12664)>>2)]=$89;

 label=43;break;
 case 42: 
 var $92$0 = ___cxa_find_matching_catch(-1, -1); var $92$1 = tempRet0;

 var $eh_lpad_body$1=$92$1;var $eh_lpad_body$0=$92$0;label=37;break;
 case 43: 
 var $94=HEAP32[((12664)>>2)];
 var $95=(($__iob+8)|0);
 var $96=HEAP32[(($95)>>2)];
 var $97=(function() { try { __THREW__ = 0; return __ZNSt3__112__asprintf_lEPPcP15__locale_structPKcz($__nb,$94,$4,(tempVarArgs=STACKTOP,STACKTOP = (STACKTOP + 16)|0,(assert((STACKTOP|0) < (STACK_MAX|0))|0),HEAP32[((tempVarArgs)>>2)]=$96,HEAPF64[(((tempVarArgs)+(8))>>3)]=$__v,tempVarArgs)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })(); STACKTOP=tempVarArgs;if (!__THREW__) { var $__nc_1=$97;label=44;break; } else { label=36;break; }
 case 44: 
 var $__nc_1;
 var $99=HEAP32[(($__nb)>>2)];
 var $100=($99|0)==0;
 if($100){label=45;break;}else{var $__nc_2=$__nc_1;var $__nbh_sroa_0_0_load3742=$99;var $102=$99;label=47;break;}
 case 45: 
 (function() { try { __THREW__ = 0; return __ZSt17__throw_bad_allocv() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=46;break; } else { label=36;break; }
 case 46: 
 var $_pre=HEAP32[(($__nb)>>2)];
 var $__nc_2=$__nc_1;var $__nbh_sroa_0_0_load3742=$_pre;var $102=$_pre;label=47;break;
 case 47: 
 var $102;
 var $__nbh_sroa_0_0_load3742;
 var $__nc_2;
 var $103=(($102+$__nc_2)|0);
 var $104=HEAP32[(($6)>>2)];
 var $105=$104&176;
 if(($105|0)==16){ label=48;break;}else if(($105|0)==32){ var $_0_i28=$103;label=54;break;}else{label=53;break;}
 case 48: 
 var $107=HEAP8[($102)];
 if((($107<<24)>>24)==45|(($107<<24)>>24)==43){ label=49;break;}else{label=50;break;}
 case 49: 
 var $109=(($102+1)|0);
 var $_0_i28=$109;label=54;break;
 case 50: 
 var $111=($__nc_2|0)>1;
 var $112=(($107<<24)>>24)==48;
 var $or_cond_i=$111&$112;
 if($or_cond_i){label=51;break;}else{label=53;break;}
 case 51: 
 var $114=(($102+1)|0);
 var $115=HEAP8[($114)];
 if((($115<<24)>>24)==120|(($115<<24)>>24)==88){ label=52;break;}else{label=53;break;}
 case 52: 
 var $117=(($102+2)|0);
 var $_0_i28=$117;label=54;break;
 case 53: 
 var $_0_i28=$102;label=54;break;
 case 54: 
 var $_0_i28;
 var $119=(($__o)|0);
 var $120=($102|0)==($43|0);
 if($120){var $__ob_0=$119;var $133=0;var $132=$43;label=59;break;}else{label=55;break;}
 case 55: 
 var $122=$__nc_2<<3;
 var $123=_malloc($122);
 var $124=$123;
 var $125=($123|0)==0;
 if($125){label=56;break;}else{var $__ob_0=$124;var $133=$124;var $132=$102;label=59;break;}
 case 56: 
 (function() { try { __THREW__ = 0; return __ZSt17__throw_bad_allocv() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=57;break; } else { var $128=0;label=58;break; }
 case 57: 
 var $_pre52=HEAP32[(($__nb)>>2)];
 var $__ob_0=$124;var $133=$124;var $132=$_pre52;label=59;break;
 case 58: 
 var $128;
 var $129$0 = ___cxa_find_matching_catch(-1, -1); var $129$1 = tempRet0;
 var $130=$129$0;
 var $131=$129$1;
 var $_0=$130;var $_022=$131;var $163=$128;label=68;break;
 case 59: 
 var $132;
 var $133;
 var $__ob_0;
 (function() { try { __THREW__ = 0; return __ZNKSt3__18ios_base6getlocEv($1,$__iob) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=60;break; } else { var $128=$133;label=58;break; }
 case 60: 
 (function() { try { __THREW__ = 0; return __ZNSt3__19__num_putIwE23__widen_and_group_floatEPcS2_S2_PwRS3_S4_RKNS_6localeE($132,$_0_i28,$103,$__ob_0,$__op,$__oe,$1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=61;break; } else { label=67;break; }
 case 61: 
 var $136=(($1)|0);
 var $137=HEAP32[(($136)>>2)];
 var $138=(($137)|0);
 var $139=__ZNSt3__114__shared_count16__release_sharedEv($138);
 var $140=(($__s)|0);
 var $141=HEAP32[(($140)>>2)];
 var $142=(($3)|0);
 HEAP32[(($142)>>2)]=$141;
 var $143=HEAP32[(($__op)>>2)];
 var $144=HEAP32[(($__oe)>>2)];
 (function() { try { __THREW__ = 0; return __ZNSt3__116__pad_and_outputIwNS_11char_traitsIwEEEENS_19ostreambuf_iteratorIT_T0_EES6_PKS4_S8_S8_RNS_8ios_baseES4_($2,$3,$__ob_0,$143,$144,$__iob,$__fl) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=62;break; } else { var $128=$133;label=58;break; }
 case 62: 
 var $146=(($2)|0);
 var $147=HEAP32[(($146)>>2)];
 HEAP32[(($140)>>2)]=$147;
 var $148=(($agg_result)|0);
 HEAP32[(($148)>>2)]=$147;
 var $149=($133|0)==0;
 if($149){label=64;break;}else{label=63;break;}
 case 63: 
 var $151=$133;
 _free($151);
 label=64;break;
 case 64: 
 var $152=($__nbh_sroa_0_0_load3742|0)==0;
 if($152){label=66;break;}else{label=65;break;}
 case 65: 
 _free($__nbh_sroa_0_0_load3742);
 label=66;break;
 case 66: 
 STACKTOP=sp;return;
 case 67: 
 var $155$0 = ___cxa_find_matching_catch(-1, -1); var $155$1 = tempRet0;
 var $156=$155$0;
 var $157=$155$1;
 var $158=(($1)|0);
 var $159=HEAP32[(($158)>>2)];
 var $160=(($159)|0);
 var $161=__ZNSt3__114__shared_count16__release_sharedEv($160);
 var $_0=$156;var $_022=$157;var $163=$133;label=68;break;
 case 68: 
 var $163;
 var $_022;
 var $_0;
 var $164=($163|0)==0;
 if($164){label=70;break;}else{label=69;break;}
 case 69: 
 var $166=$163;
 _free($166);
 label=70;break;
 case 70: 
 var $167=($__nbh_sroa_0_0_load3742|0)==0;
 if($167){var $_12349=$_022;var $_150=$_0;label=72;break;}else{label=71;break;}
 case 71: 
 _free($__nbh_sroa_0_0_load3742);
 var $_12349=$_022;var $_150=$_0;label=72;break;
 case 72: 
 var $_150;
 var $_12349;
 var $169$0=$_150;
 var $169$1=0;
 var $170$0=$169$0;
 var $170$1=$_12349;
 ___resumeException($170$0)
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__19__num_putIwE23__widen_and_group_floatEPcS2_S2_PwRS3_S4_RKNS_6localeE($__nb,$__np,$__ne,$__ob,$__op,$__oe,$__loc){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+48)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $__p_i_i_i_i81=sp;
 var $__p_i_i_i_i=(sp)+(16);
 var $__grouping=(sp)+(32);
 var $1=(($__loc)|0);
 var $2=HEAP32[(($1)>>2)];
 var $3=$__p_i_i_i_i;
 var $4=HEAP32[((14088)>>2)];
 var $5=($4|0)==-1;
 if($5){label=3;break;}else{label=2;break;}
 case 2: 
 var $_sroa_01_0___p67_i_idx_i_i_i=(($__p_i_i_i_i)|0);
 HEAP32[(($_sroa_01_0___p67_i_idx_i_i_i)>>2)]=14088;
 var $_sroa_12_4___p67_i_idx3_i_i_i=(($__p_i_i_i_i+4)|0);
 HEAP32[(($_sroa_12_4___p67_i_idx3_i_i_i)>>2)]=(28);
 var $_sroa_2_8___p67_i_idx4_i_i_i=(($__p_i_i_i_i+8)|0);
 HEAP32[(($_sroa_2_8___p67_i_idx4_i_i_i)>>2)]=0;
 __ZNSt3__111__call_onceERVmPvPFvS2_E(14088,$3,260);
 label=3;break;
 case 3: 
 var $7=HEAP32[((14092)>>2)];
 var $8=((($7)-(1))|0);
 var $9=(($2+12)|0);
 var $10=HEAP32[(($9)>>2)];
 var $11=(($2+8)|0);
 var $12=HEAP32[(($11)>>2)];
 var $13=$10;
 var $14=$12;
 var $15=((($13)-($14))|0);
 var $16=$15>>2;
 var $17=($16>>>0)>($8>>>0);
 if($17){label=4;break;}else{label=5;break;}
 case 4: 
 var $18=(($12+($8<<2))|0);
 var $19=HEAP32[(($18)>>2)];
 var $20=($19|0)==0;
 if($20){label=5;break;}else{label=6;break;}
 case 5: 
 var $21=___cxa_allocate_exception(4);
 var $22=$21;
 __ZNSt8bad_castC2Ev($22);
 ___cxa_throw($21,8960,(368));
 throw "Reached an unreachable!";
 case 6: 
 var $23=$19;
 var $24=HEAP32[(($1)>>2)];
 var $25=$__p_i_i_i_i81;
 var $26=HEAP32[((13704)>>2)];
 var $27=($26|0)==-1;
 if($27){label=8;break;}else{label=7;break;}
 case 7: 
 var $_sroa_01_0___p67_i_idx_i_i_i82=(($__p_i_i_i_i81)|0);
 HEAP32[(($_sroa_01_0___p67_i_idx_i_i_i82)>>2)]=13704;
 var $_sroa_12_4___p67_i_idx3_i_i_i83=(($__p_i_i_i_i81+4)|0);
 HEAP32[(($_sroa_12_4___p67_i_idx3_i_i_i83)>>2)]=(28);
 var $_sroa_2_8___p67_i_idx4_i_i_i84=(($__p_i_i_i_i81+8)|0);
 HEAP32[(($_sroa_2_8___p67_i_idx4_i_i_i84)>>2)]=0;
 __ZNSt3__111__call_onceERVmPvPFvS2_E(13704,$25,260);
 label=8;break;
 case 8: 
 var $29=HEAP32[((13708)>>2)];
 var $30=((($29)-(1))|0);
 var $31=(($24+12)|0);
 var $32=HEAP32[(($31)>>2)];
 var $33=(($24+8)|0);
 var $34=HEAP32[(($33)>>2)];
 var $35=$32;
 var $36=$34;
 var $37=((($35)-($36))|0);
 var $38=$37>>2;
 var $39=($38>>>0)>($30>>>0);
 if($39){label=9;break;}else{label=10;break;}
 case 9: 
 var $40=(($34+($30<<2))|0);
 var $41=HEAP32[(($40)>>2)];
 var $42=($41|0)==0;
 if($42){label=10;break;}else{label=11;break;}
 case 10: 
 var $43=___cxa_allocate_exception(4);
 var $44=$43;
 __ZNSt8bad_castC2Ev($44);
 ___cxa_throw($43,8960,(368));
 throw "Reached an unreachable!";
 case 11: 
 var $45=$41;
 var $46=$41;
 var $47=HEAP32[(($46)>>2)];
 var $48=(($47+20)|0);
 var $49=HEAP32[(($48)>>2)];
 FUNCTION_TABLE[$49]($__grouping,$45);
 HEAP32[(($__oe)>>2)]=$__ob;
 var $50=HEAP8[($__nb)];
 if((($50<<24)>>24)==45|(($50<<24)>>24)==43){ label=12;break;}else{var $__nf_0=$__nb;label=20;break;}
 case 12: 
 var $52=$19;
 var $53=HEAP32[(($52)>>2)];
 var $54=(($53+44)|0);
 var $55=HEAP32[(($54)>>2)];
 var $56=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$55]($23,$50) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=13;break; } else { label=18;break; }
 case 13: 
 var $57=(($__nb+1)|0);
 var $58=HEAP32[(($__oe)>>2)];
 var $59=(($58+4)|0);
 HEAP32[(($__oe)>>2)]=$59;
 HEAP32[(($58)>>2)]=$56;
 var $__nf_0=$57;label=20;break;
 case 14: 
 var $lpad_loopexit$0 = ___cxa_find_matching_catch(-1, -1); var $lpad_loopexit$1 = tempRet0;
 var $eh_lpad_body$1=$lpad_loopexit$1;var $eh_lpad_body$0=$lpad_loopexit$0;label=19;break;
 case 15: 
 var $lpad_loopexit104$0 = ___cxa_find_matching_catch(-1, -1); var $lpad_loopexit104$1 = tempRet0;
 var $eh_lpad_body$1=$lpad_loopexit104$1;var $eh_lpad_body$0=$lpad_loopexit104$0;label=19;break;
 case 16: 
 var $lpad_loopexit112$0 = ___cxa_find_matching_catch(-1, -1); var $lpad_loopexit112$1 = tempRet0;
 var $eh_lpad_body$1=$lpad_loopexit112$1;var $eh_lpad_body$0=$lpad_loopexit112$0;label=19;break;
 case 17: 
 var $lpad_loopexit117$0 = ___cxa_find_matching_catch(-1, -1); var $lpad_loopexit117$1 = tempRet0;
 var $eh_lpad_body$1=$lpad_loopexit117$1;var $eh_lpad_body$0=$lpad_loopexit117$0;label=19;break;
 case 18: 
 var $lpad_nonloopexit118$0 = ___cxa_find_matching_catch(-1, -1); var $lpad_nonloopexit118$1 = tempRet0;
 var $eh_lpad_body$1=$lpad_nonloopexit118$1;var $eh_lpad_body$0=$lpad_nonloopexit118$0;label=19;break;
 case 19: 
 var $eh_lpad_body$0;
 var $eh_lpad_body$1;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grouping);
 ___resumeException($eh_lpad_body$0)
 case 20: 
 var $__nf_0;
 var $61=$__ne;
 var $62=$__nf_0;
 var $63=((($61)-($62))|0);
 var $64=($63|0)>1;
 if($64){label=21;break;}else{var $__ns_1=$__nf_0;label=34;break;}
 case 21: 
 var $66=HEAP8[($__nf_0)];
 var $67=(($66<<24)>>24)==48;
 if($67){label=22;break;}else{var $__ns_1=$__nf_0;label=34;break;}
 case 22: 
 var $69=(($__nf_0+1)|0);
 var $70=HEAP8[($69)];
 if((($70<<24)>>24)==120|(($70<<24)>>24)==88){ label=23;break;}else{var $__ns_1=$__nf_0;label=34;break;}
 case 23: 
 var $72=$19;
 var $73=HEAP32[(($72)>>2)];
 var $74=(($73+44)|0);
 var $75=HEAP32[(($74)>>2)];
 var $76=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$75]($23,48) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=24;break; } else { label=18;break; }
 case 24: 
 var $77=HEAP32[(($__oe)>>2)];
 var $78=(($77+4)|0);
 HEAP32[(($__oe)>>2)]=$78;
 HEAP32[(($77)>>2)]=$76;
 var $79=(($__nf_0+2)|0);
 var $80=HEAP8[($69)];
 var $81=HEAP32[(($72)>>2)];
 var $82=(($81+44)|0);
 var $83=HEAP32[(($82)>>2)];
 var $84=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$83]($23,$80) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=25;break; } else { label=18;break; }
 case 25: 
 var $85=HEAP32[(($__oe)>>2)];
 var $86=(($85+4)|0);
 HEAP32[(($__oe)>>2)]=$86;
 HEAP32[(($85)>>2)]=$84;
 var $__ns_0=$79;label=26;break;
 case 26: 
 var $__ns_0;
 var $88=($__ns_0>>>0)<($__ne>>>0);
 if($88){label=27;break;}else{var $__nf_1=$79;var $__ns_2=$__ns_0;label=42;break;}
 case 27: 
 var $90=HEAP8[($__ns_0)];
 var $91=HEAP8[(14656)];
 var $92=(($91<<24)>>24)==0;
 if($92){label=28;break;}else{label=32;break;}
 case 28: 
 var $94=___cxa_guard_acquire(14656);
 var $95=($94|0)==0;
 if($95){label=32;break;}else{label=29;break;}
 case 29: 
 var $97=(function() { try { __THREW__ = 0; return _newlocale(2147483647,1496,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=30;break; } else { label=31;break; }
 case 30: 
 HEAP32[((12664)>>2)]=$97;

 label=32;break;
 case 31: 
 var $100$0 = ___cxa_find_matching_catch(-1, -1); var $100$1 = tempRet0;

 var $eh_lpad_body$1=$100$1;var $eh_lpad_body$0=$100$0;label=19;break;
 case 32: 
 var $102=HEAP32[((12664)>>2)];
 var $103=(($90<<24)>>24);
 var $104=(function() { try { __THREW__ = 0; return _isxdigit_l($103,$102) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=33;break; } else { label=17;break; }
 case 33: 
 var $106=($104|0)==0;
 var $107=(($__ns_0+1)|0);
 if($106){var $__nf_1=$79;var $__ns_2=$__ns_0;label=42;break;}else{var $__ns_0=$107;label=26;break;}
 case 34: 
 var $__ns_1;
 var $108=($__ns_1>>>0)<($__ne>>>0);
 if($108){label=35;break;}else{var $__nf_1=$__nf_0;var $__ns_2=$__ns_1;label=42;break;}
 case 35: 
 var $110=HEAP8[($__ns_1)];
 var $111=HEAP8[(14656)];
 var $112=(($111<<24)>>24)==0;
 if($112){label=36;break;}else{label=40;break;}
 case 36: 
 var $114=___cxa_guard_acquire(14656);
 var $115=($114|0)==0;
 if($115){label=40;break;}else{label=37;break;}
 case 37: 
 var $117=(function() { try { __THREW__ = 0; return _newlocale(2147483647,1496,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=38;break; } else { label=39;break; }
 case 38: 
 HEAP32[((12664)>>2)]=$117;

 label=40;break;
 case 39: 
 var $120$0 = ___cxa_find_matching_catch(-1, -1); var $120$1 = tempRet0;

 var $eh_lpad_body$1=$120$1;var $eh_lpad_body$0=$120$0;label=19;break;
 case 40: 
 var $122=HEAP32[((12664)>>2)];
 var $123=(($110<<24)>>24);
 var $124=(function() { try { __THREW__ = 0; return _isdigit_l($123,$122) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=41;break; } else { label=16;break; }
 case 41: 
 var $126=($124|0)==0;
 var $127=(($__ns_1+1)|0);
 if($126){var $__nf_1=$__nf_0;var $__ns_2=$__ns_1;label=42;break;}else{var $__ns_1=$127;label=34;break;}
 case 42: 
 var $__ns_2;
 var $__nf_1;
 var $128=$__grouping;
 var $129=HEAP8[($128)];
 var $130=$129&1;
 var $131=(($130<<24)>>24)==0;
 if($131){label=44;break;}else{label=43;break;}
 case 43: 
 var $133=(($__grouping+4)|0);
 var $134=HEAP32[(($133)>>2)];
 var $138=$134;label=45;break;
 case 44: 
 var $136=($129&255);
 var $137=$136>>>1;
 var $138=$137;label=45;break;
 case 45: 
 var $138;
 var $139=($138|0)==0;
 if($139){label=46;break;}else{label=48;break;}
 case 46: 
 var $141=HEAP32[(($__oe)>>2)];
 var $142=$19;
 var $143=HEAP32[(($142)>>2)];
 var $144=(($143+48)|0);
 var $145=HEAP32[(($144)>>2)];
 var $146=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$145]($23,$__nf_1,$__ns_2,$141) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=47;break; } else { label=18;break; }
 case 47: 
 var $147=$__ns_2;
 var $148=$__nf_1;
 var $149=((($147)-($148))|0);
 var $150=HEAP32[(($__oe)>>2)];
 var $151=(($150+($149<<2))|0);
 HEAP32[(($__oe)>>2)]=$151;
 var $225=$151;label=66;break;
 case 48: 
 var $153=($__nf_1|0)==($__ns_2|0);
 if($153){label=51;break;}else{label=49;break;}
 case 49: 
 var $154=((($__ns_2)-(1))|0);
 var $155=($154>>>0)>($__nf_1>>>0);
 if($155){var $_078_i_i=$__nf_1;var $156=$154;label=50;break;}else{label=51;break;}
 case 50: 
 var $156;
 var $_078_i_i;
 var $157=HEAP8[($_078_i_i)];
 var $158=HEAP8[($156)];
 HEAP8[($_078_i_i)]=$158;
 HEAP8[($156)]=$157;
 var $159=(($_078_i_i+1)|0);
 var $160=((($156)-(1))|0);
 var $161=($159>>>0)<($160>>>0);
 if($161){var $_078_i_i=$159;var $156=$160;label=50;break;}else{label=51;break;}
 case 51: 
 var $162=$41;
 var $163=HEAP32[(($162)>>2)];
 var $164=(($163+16)|0);
 var $165=HEAP32[(($164)>>2)];
 var $166=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$165]($45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=52;break; } else { label=18;break; }
 case 52: 
 var $167=($__nf_1>>>0)<($__ns_2>>>0);
 if($167){label=54;break;}else{label=53;break;}
 case 53: 
 var $_pre=HEAP32[(($__oe)>>2)];
 var $211=$_pre;label=63;break;
 case 54: 
 var $168=$__grouping;
 var $169=(($168+1)|0);
 var $170=(($__grouping+4)|0);
 var $171=(($__grouping+8)|0);
 var $172=$19;
 var $__dc_0107=0;var $__dg_0108=0;var $__p_0109=$__nf_1;label=55;break;
 case 55: 
 var $__p_0109;
 var $__dg_0108;
 var $__dc_0107;
 var $173=HEAP8[($128)];
 var $174=$173&1;
 var $175=(($174<<24)>>24)==0;
 var $176=HEAP32[(($171)>>2)];
 var $_=($175?$169:$176);
 var $177=(($_+$__dg_0108)|0);
 var $178=HEAP8[($177)];
 var $179=(($178<<24)>>24)>0;
 if($179){label=56;break;}else{var $__dg_1=$__dg_0108;var $__dc_1=$__dc_0107;label=61;break;}
 case 56: 
 var $180=HEAP32[(($171)>>2)];
 var $_128=($175?$169:$180);
 var $181=(($_128+$__dg_0108)|0);
 var $182=HEAP8[($181)];
 var $183=(($182<<24)>>24);
 var $184=($__dc_0107|0)==($183|0);
 if($184){label=57;break;}else{var $__dg_1=$__dg_0108;var $__dc_1=$__dc_0107;label=61;break;}
 case 57: 
 var $186=HEAP32[(($__oe)>>2)];
 var $187=(($186+4)|0);
 HEAP32[(($__oe)>>2)]=$187;
 HEAP32[(($186)>>2)]=$166;
 var $188=HEAP8[($128)];
 var $189=$188&1;
 var $190=(($189<<24)>>24)==0;
 if($190){label=59;break;}else{label=58;break;}
 case 58: 
 var $192=HEAP32[(($170)>>2)];
 var $196=$192;label=60;break;
 case 59: 
 var $194=($188&255);
 var $195=$194>>>1;
 var $196=$195;label=60;break;
 case 60: 
 var $196;
 var $197=((($196)-(1))|0);
 var $198=($__dg_0108>>>0)<($197>>>0);
 var $199=($198&1);
 var $___dg_0=((($199)+($__dg_0108))|0);
 var $__dg_1=$___dg_0;var $__dc_1=0;label=61;break;
 case 61: 
 var $__dc_1;
 var $__dg_1;
 var $201=HEAP8[($__p_0109)];
 var $202=HEAP32[(($172)>>2)];
 var $203=(($202+44)|0);
 var $204=HEAP32[(($203)>>2)];
 var $205=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$204]($23,$201) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=62;break; } else { label=15;break; }
 case 62: 
 var $206=HEAP32[(($__oe)>>2)];
 var $207=(($206+4)|0);
 HEAP32[(($__oe)>>2)]=$207;
 HEAP32[(($206)>>2)]=$205;
 var $208=((($__dc_1)+(1))|0);
 var $209=(($__p_0109+1)|0);
 var $210=($209>>>0)<($__ns_2>>>0);
 if($210){var $__dc_0107=$208;var $__dg_0108=$__dg_1;var $__p_0109=$209;label=55;break;}else{var $211=$207;label=63;break;}
 case 63: 
 var $211;
 var $212=$__nf_1;
 var $213=$__nb;
 var $214=((($212)-($213))|0);
 var $215=(($__ob+($214<<2))|0);
 var $216=($215|0)==($211|0);
 if($216){var $225=$211;label=66;break;}else{label=64;break;}
 case 64: 
 var $217=((($211)-(4))|0);
 var $218=($217>>>0)>($215>>>0);
 if($218){var $_078_i_i96=$215;var $219=$217;label=65;break;}else{var $225=$211;label=66;break;}
 case 65: 
 var $219;
 var $_078_i_i96;
 var $220=HEAP32[(($_078_i_i96)>>2)];
 var $221=HEAP32[(($219)>>2)];
 HEAP32[(($_078_i_i96)>>2)]=$221;
 HEAP32[(($219)>>2)]=$220;
 var $222=(($_078_i_i96+4)|0);
 var $223=((($219)-(4))|0);
 var $224=($222>>>0)<($223>>>0);
 if($224){var $_078_i_i96=$222;var $219=$223;label=65;break;}else{var $225=$211;label=66;break;}
 case 66: 
 var $225;
 var $226=($__ns_2>>>0)<($__ne>>>0);
 if($226){label=67;break;}else{var $__nf_3=$__ns_2;var $249=$225;label=73;break;}
 case 67: 
 var $227=$19;
 var $__nf_2103=$__ns_2;label=68;break;
 case 68: 
 var $__nf_2103;
 var $229=HEAP8[($__nf_2103)];
 var $230=(($229<<24)>>24)==46;
 if($230){label=69;break;}else{label=71;break;}
 case 69: 
 var $232=$41;
 var $233=HEAP32[(($232)>>2)];
 var $234=(($233+12)|0);
 var $235=HEAP32[(($234)>>2)];
 var $236=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$235]($45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=70;break; } else { label=18;break; }
 case 70: 
 var $237=HEAP32[(($__oe)>>2)];
 var $238=(($237+4)|0);
 HEAP32[(($__oe)>>2)]=$238;
 HEAP32[(($237)>>2)]=$236;
 var $239=(($__nf_2103+1)|0);
 var $__nf_3=$239;var $249=$238;label=73;break;
 case 71: 
 var $241=HEAP32[(($227)>>2)];
 var $242=(($241+44)|0);
 var $243=HEAP32[(($242)>>2)];
 var $244=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$243]($23,$229) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=72;break; } else { label=14;break; }
 case 72: 
 var $245=HEAP32[(($__oe)>>2)];
 var $246=(($245+4)|0);
 HEAP32[(($__oe)>>2)]=$246;
 HEAP32[(($245)>>2)]=$244;
 var $247=(($__nf_2103+1)|0);
 var $248=($247>>>0)<($__ne>>>0);
 if($248){var $__nf_2103=$247;label=68;break;}else{var $__nf_3=$247;var $249=$246;label=73;break;}
 case 73: 
 var $249;
 var $__nf_3;
 var $250=$19;
 var $251=HEAP32[(($250)>>2)];
 var $252=(($251+48)|0);
 var $253=HEAP32[(($252)>>2)];
 var $254=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$253]($23,$__nf_3,$__ne,$249) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=74;break; } else { label=18;break; }
 case 74: 
 var $255=$__nf_3;
 var $256=((($61)-($255))|0);
 var $257=HEAP32[(($__oe)>>2)];
 var $258=(($257+($256<<2))|0);
 HEAP32[(($__oe)>>2)]=$258;
 var $259=($__np|0)==($__ne|0);
 if($259){var $storemerge=$258;label=76;break;}else{label=75;break;}
 case 75: 
 var $261=$__np;
 var $262=$__nb;
 var $263=((($261)-($262))|0);
 var $264=(($__ob+($263<<2))|0);
 var $storemerge=$264;label=76;break;
 case 76: 
 var $storemerge;
 HEAP32[(($__op)>>2)]=$storemerge;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grouping);
 STACKTOP=sp;return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwe($agg_result,$this,$__s,$__iob,$__fl,$__v){
 var label=0;
 var tempVarArgs=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+320)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var tempParam = $__s; $__s=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__s)>>2)]=HEAP32[((tempParam)>>2)];
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $__fmt=sp;
 var $__nar=(sp)+(8);
 var $__nb=(sp)+(40);
 var $__o=(sp)+(48);
 var $__op=(sp)+(280);
 var $__oe=(sp)+(288);
 var $1=(sp)+(296);
 var $2=(sp)+(304);
 var $3=(sp)+(312);
 var $$etemp$0$0=37;
 var $$etemp$0$1=0;
 var $st$1$0=(($__fmt)|0);
 HEAP32[(($st$1$0)>>2)]=$$etemp$0$0;
 var $st$2$1=(($__fmt+4)|0);
 HEAP32[(($st$2$1)>>2)]=$$etemp$0$1;
 var $4=$__fmt;
 var $5=(($4+1)|0);
 var $6=(($__iob+4)|0);
 var $7=HEAP32[(($6)>>2)];
 var $8=$7&2048;
 var $9=($8|0)==0;
 if($9){var $_0_i=$5;label=3;break;}else{label=2;break;}
 case 2: 
 var $11=(($4+2)|0);
 HEAP8[($5)]=43;
 var $_0_i=$11;label=3;break;
 case 3: 
 var $_0_i;
 var $13=$7&1024;
 var $14=($13|0)==0;
 if($14){var $_1_i=$_0_i;label=5;break;}else{label=4;break;}
 case 4: 
 var $16=(($_0_i+1)|0);
 HEAP8[($_0_i)]=35;
 var $_1_i=$16;label=5;break;
 case 5: 
 var $_1_i;
 var $18=$7&260;
 var $19=$7>>>14;
 var $20=($18|0)==260;
 if($20){label=13;break;}else{label=6;break;}
 case 6: 
 var $21=(($_1_i+1)|0);
 HEAP8[($_1_i)]=46;
 var $22=(($_1_i+2)|0);
 HEAP8[($21)]=42;
 HEAP8[($22)]=76;
 var $scevgep=(($_1_i+3)|0);
 if(($18|0)==256){ label=10;break;}else if(($18|0)==4){ label=7;break;}else{label=16;break;}
 case 7: 
 var $24=$19&1;
 var $25=($24|0)==0;
 if($25){label=9;break;}else{label=8;break;}
 case 8: 
 HEAP8[($scevgep)]=70;
 var $specify_precision_0_off0_ph_i48=1;label=19;break;
 case 9: 
 HEAP8[($scevgep)]=102;
 var $specify_precision_0_off0_ph_i48=1;label=19;break;
 case 10: 
 var $29=$19&1;
 var $30=($29|0)==0;
 if($30){label=12;break;}else{label=11;break;}
 case 11: 
 HEAP8[($scevgep)]=69;
 var $specify_precision_0_off0_ph_i48=1;label=19;break;
 case 12: 
 HEAP8[($scevgep)]=101;
 var $specify_precision_0_off0_ph_i48=1;label=19;break;
 case 13: 
 HEAP8[($_1_i)]=76;
 var $scevgep47=(($_1_i+1)|0);
 var $34=$19&1;
 var $35=($34|0)==0;
 if($35){label=15;break;}else{label=14;break;}
 case 14: 
 HEAP8[($scevgep47)]=65;
 var $specify_precision_0_off0_ph_i48=0;label=19;break;
 case 15: 
 HEAP8[($scevgep47)]=97;
 var $specify_precision_0_off0_ph_i48=0;label=19;break;
 case 16: 
 var $39=$19&1;
 var $40=($39|0)==0;
 if($40){label=18;break;}else{label=17;break;}
 case 17: 
 HEAP8[($scevgep)]=71;
 var $specify_precision_0_off0_ph_i48=1;label=19;break;
 case 18: 
 HEAP8[($scevgep)]=103;
 var $specify_precision_0_off0_ph_i48=1;label=19;break;
 case 19: 
 var $specify_precision_0_off0_ph_i48;
 var $43=(($__nar)|0);
 HEAP32[(($__nb)>>2)]=$43;
 var $44=HEAP8[(14656)];
 var $45=(($44<<24)>>24)==0;
 if($45){label=20;break;}else{label=24;break;}
 case 20: 
 var $47=___cxa_guard_acquire(14656);
 var $48=($47|0)==0;
 if($48){label=24;break;}else{label=21;break;}
 case 21: 
 var $50=(function() { try { __THREW__ = 0; return _newlocale(2147483647,1496,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=22;break; } else { label=23;break; }
 case 22: 
 HEAP32[((12664)>>2)]=$50;

 label=24;break;
 case 23: 
 var $53$0 = ___cxa_find_matching_catch(-1, -1); var $53$1 = tempRet0;

 ___resumeException($53$0)
 case 24: 
 var $54=HEAP32[((12664)>>2)];
 if($specify_precision_0_off0_ph_i48){label=25;break;}else{label=26;break;}
 case 25: 
 var $56=(($__iob+8)|0);
 var $57=HEAP32[(($56)>>2)];
 var $58=__ZNSt3__112__snprintf_lEPcjP15__locale_structPKcz($43,30,$54,$4,(tempVarArgs=STACKTOP,STACKTOP = (STACKTOP + 16)|0,(assert((STACKTOP|0) < (STACK_MAX|0))|0),HEAP32[((tempVarArgs)>>2)]=$57,HEAPF64[(((tempVarArgs)+(8))>>3)]=$__v,tempVarArgs)); STACKTOP=tempVarArgs;
 var $__nc_0=$58;label=27;break;
 case 26: 
 var $60=__ZNSt3__112__snprintf_lEPcjP15__locale_structPKcz($43,30,$54,$4,(tempVarArgs=STACKTOP,STACKTOP = (STACKTOP + 8)|0,(assert((STACKTOP|0) < (STACK_MAX|0))|0),HEAPF64[((tempVarArgs)>>3)]=$__v,tempVarArgs)); STACKTOP=tempVarArgs;
 var $__nc_0=$60;label=27;break;
 case 27: 
 var $__nc_0;
 var $62=($__nc_0|0)>29;
 if($62){label=29;break;}else{label=28;break;}
 case 28: 
 var $_pre45=HEAP32[(($__nb)>>2)];
 var $__nc_2=$__nc_0;var $__nbh_sroa_0_0_load3641=0;var $100=$_pre45;label=47;break;
 case 29: 
 var $64=HEAP8[(14656)];
 var $65=(($64<<24)>>24)==0;
 if($specify_precision_0_off0_ph_i48){label=30;break;}else{label=38;break;}
 case 30: 
 if($65){label=31;break;}else{label=35;break;}
 case 31: 
 var $68=___cxa_guard_acquire(14656);
 var $69=($68|0)==0;
 if($69){label=35;break;}else{label=32;break;}
 case 32: 
 var $71=(function() { try { __THREW__ = 0; return _newlocale(2147483647,1496,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=33;break; } else { label=34;break; }
 case 33: 
 HEAP32[((12664)>>2)]=$71;

 label=35;break;
 case 34: 
 var $74$0 = ___cxa_find_matching_catch(-1, -1); var $74$1 = tempRet0;

 var $eh_lpad_body$1=$74$1;var $eh_lpad_body$0=$74$0;label=37;break;
 case 35: 
 var $76=HEAP32[((12664)>>2)];
 var $77=(($__iob+8)|0);
 var $78=HEAP32[(($77)>>2)];
 var $79=(function() { try { __THREW__ = 0; return __ZNSt3__112__asprintf_lEPPcP15__locale_structPKcz($__nb,$76,$4,(tempVarArgs=STACKTOP,STACKTOP = (STACKTOP + 16)|0,(assert((STACKTOP|0) < (STACK_MAX|0))|0),HEAP32[((tempVarArgs)>>2)]=$78,HEAPF64[(((tempVarArgs)+(8))>>3)]=$__v,tempVarArgs)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })(); STACKTOP=tempVarArgs;if (!__THREW__) { var $__nc_1=$79;label=44;break; } else { label=36;break; }
 case 36: 
 var $81$0 = ___cxa_find_matching_catch(-1, -1); var $81$1 = tempRet0;
 var $eh_lpad_body$1=$81$1;var $eh_lpad_body$0=$81$0;label=37;break;
 case 37: 
 var $eh_lpad_body$0;
 var $eh_lpad_body$1;
 var $82=$eh_lpad_body$0;
 var $83=$eh_lpad_body$1;
 var $_12243=$83;var $_144=$82;label=72;break;
 case 38: 
 if($65){label=39;break;}else{label=43;break;}
 case 39: 
 var $86=___cxa_guard_acquire(14656);
 var $87=($86|0)==0;
 if($87){label=43;break;}else{label=40;break;}
 case 40: 
 var $89=(function() { try { __THREW__ = 0; return _newlocale(2147483647,1496,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=41;break; } else { label=42;break; }
 case 41: 
 HEAP32[((12664)>>2)]=$89;

 label=43;break;
 case 42: 
 var $92$0 = ___cxa_find_matching_catch(-1, -1); var $92$1 = tempRet0;

 var $eh_lpad_body$1=$92$1;var $eh_lpad_body$0=$92$0;label=37;break;
 case 43: 
 var $94=HEAP32[((12664)>>2)];
 var $95=(function() { try { __THREW__ = 0; return __ZNSt3__112__asprintf_lEPPcP15__locale_structPKcz($__nb,$94,$4,(tempVarArgs=STACKTOP,STACKTOP = (STACKTOP + 8)|0,(assert((STACKTOP|0) < (STACK_MAX|0))|0),HEAPF64[((tempVarArgs)>>3)]=$__v,tempVarArgs)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })(); STACKTOP=tempVarArgs;if (!__THREW__) { var $__nc_1=$95;label=44;break; } else { label=36;break; }
 case 44: 
 var $__nc_1;
 var $97=HEAP32[(($__nb)>>2)];
 var $98=($97|0)==0;
 if($98){label=45;break;}else{var $__nc_2=$__nc_1;var $__nbh_sroa_0_0_load3641=$97;var $100=$97;label=47;break;}
 case 45: 
 (function() { try { __THREW__ = 0; return __ZSt17__throw_bad_allocv() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=46;break; } else { label=36;break; }
 case 46: 
 var $_pre=HEAP32[(($__nb)>>2)];
 var $__nc_2=$__nc_1;var $__nbh_sroa_0_0_load3641=$_pre;var $100=$_pre;label=47;break;
 case 47: 
 var $100;
 var $__nbh_sroa_0_0_load3641;
 var $__nc_2;
 var $101=(($100+$__nc_2)|0);
 var $102=HEAP32[(($6)>>2)];
 var $103=$102&176;
 if(($103|0)==16){ label=48;break;}else if(($103|0)==32){ var $_0_i27=$101;label=54;break;}else{label=53;break;}
 case 48: 
 var $105=HEAP8[($100)];
 if((($105<<24)>>24)==45|(($105<<24)>>24)==43){ label=49;break;}else{label=50;break;}
 case 49: 
 var $107=(($100+1)|0);
 var $_0_i27=$107;label=54;break;
 case 50: 
 var $109=($__nc_2|0)>1;
 var $110=(($105<<24)>>24)==48;
 var $or_cond_i=$109&$110;
 if($or_cond_i){label=51;break;}else{label=53;break;}
 case 51: 
 var $112=(($100+1)|0);
 var $113=HEAP8[($112)];
 if((($113<<24)>>24)==120|(($113<<24)>>24)==88){ label=52;break;}else{label=53;break;}
 case 52: 
 var $115=(($100+2)|0);
 var $_0_i27=$115;label=54;break;
 case 53: 
 var $_0_i27=$100;label=54;break;
 case 54: 
 var $_0_i27;
 var $117=(($__o)|0);
 var $118=($100|0)==($43|0);
 if($118){var $__ob_0=$117;var $131=0;var $130=$43;label=59;break;}else{label=55;break;}
 case 55: 
 var $120=$__nc_2<<3;
 var $121=_malloc($120);
 var $122=$121;
 var $123=($121|0)==0;
 if($123){label=56;break;}else{var $__ob_0=$122;var $131=$122;var $130=$100;label=59;break;}
 case 56: 
 (function() { try { __THREW__ = 0; return __ZSt17__throw_bad_allocv() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=57;break; } else { var $126=0;label=58;break; }
 case 57: 
 var $_pre46=HEAP32[(($__nb)>>2)];
 var $__ob_0=$122;var $131=$122;var $130=$_pre46;label=59;break;
 case 58: 
 var $126;
 var $127$0 = ___cxa_find_matching_catch(-1, -1); var $127$1 = tempRet0;
 var $128=$127$0;
 var $129=$127$1;
 var $_0=$128;var $_021=$129;var $161=$126;label=68;break;
 case 59: 
 var $130;
 var $131;
 var $__ob_0;
 (function() { try { __THREW__ = 0; return __ZNKSt3__18ios_base6getlocEv($1,$__iob) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=60;break; } else { var $126=$131;label=58;break; }
 case 60: 
 (function() { try { __THREW__ = 0; return __ZNSt3__19__num_putIwE23__widen_and_group_floatEPcS2_S2_PwRS3_S4_RKNS_6localeE($130,$_0_i27,$101,$__ob_0,$__op,$__oe,$1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=61;break; } else { label=67;break; }
 case 61: 
 var $134=(($1)|0);
 var $135=HEAP32[(($134)>>2)];
 var $136=(($135)|0);
 var $137=__ZNSt3__114__shared_count16__release_sharedEv($136);
 var $138=(($__s)|0);
 var $139=HEAP32[(($138)>>2)];
 var $140=(($3)|0);
 HEAP32[(($140)>>2)]=$139;
 var $141=HEAP32[(($__op)>>2)];
 var $142=HEAP32[(($__oe)>>2)];
 (function() { try { __THREW__ = 0; return __ZNSt3__116__pad_and_outputIwNS_11char_traitsIwEEEENS_19ostreambuf_iteratorIT_T0_EES6_PKS4_S8_S8_RNS_8ios_baseES4_($2,$3,$__ob_0,$141,$142,$__iob,$__fl) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=62;break; } else { var $126=$131;label=58;break; }
 case 62: 
 var $144=(($2)|0);
 var $145=HEAP32[(($144)>>2)];
 HEAP32[(($138)>>2)]=$145;
 var $146=(($agg_result)|0);
 HEAP32[(($146)>>2)]=$145;
 var $147=($131|0)==0;
 if($147){label=64;break;}else{label=63;break;}
 case 63: 
 var $149=$131;
 _free($149);
 label=64;break;
 case 64: 
 var $150=($__nbh_sroa_0_0_load3641|0)==0;
 if($150){label=66;break;}else{label=65;break;}
 case 65: 
 _free($__nbh_sroa_0_0_load3641);
 label=66;break;
 case 66: 
 STACKTOP=sp;return;
 case 67: 
 var $153$0 = ___cxa_find_matching_catch(-1, -1); var $153$1 = tempRet0;
 var $154=$153$0;
 var $155=$153$1;
 var $156=(($1)|0);
 var $157=HEAP32[(($156)>>2)];
 var $158=(($157)|0);
 var $159=__ZNSt3__114__shared_count16__release_sharedEv($158);
 var $_0=$154;var $_021=$155;var $161=$131;label=68;break;
 case 68: 
 var $161;
 var $_021;
 var $_0;
 var $162=($161|0)==0;
 if($162){label=70;break;}else{label=69;break;}
 case 69: 
 var $164=$161;
 _free($164);
 label=70;break;
 case 70: 
 var $165=($__nbh_sroa_0_0_load3641|0)==0;
 if($165){var $_12243=$_021;var $_144=$_0;label=72;break;}else{label=71;break;}
 case 71: 
 _free($__nbh_sroa_0_0_load3641);
 var $_12243=$_021;var $_144=$_0;label=72;break;
 case 72: 
 var $_144;
 var $_12243;
 var $167$0=$_144;
 var $167$1=0;
 var $168$0=$167$0;
 var $168$1=$_12243;
 ___resumeException($168$0)
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwPKv($agg_result,$this,$__s,$__iob,$__fl,$__v){
 var label=0;
 var tempVarArgs=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+216)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var tempParam = $__s; $__s=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__s)>>2)]=HEAP32[((tempParam)>>2)];
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $__p_i_i_i_i=sp;
 var $__fmt=(sp)+(16);
 var $__nar=(sp)+(24);
 var $__o=(sp)+(48);
 var $1=(sp)+(200);
 var $2=(sp)+(208);
 var $3=(($__fmt)|0);
 assert(6 % 1 === 0);HEAP8[($3)]=HEAP8[(2912)];HEAP8[((($3)+(1))|0)]=HEAP8[(2913)];HEAP8[((($3)+(2))|0)]=HEAP8[(2914)];HEAP8[((($3)+(3))|0)]=HEAP8[(2915)];HEAP8[((($3)+(4))|0)]=HEAP8[(2916)];HEAP8[((($3)+(5))|0)]=HEAP8[(2917)];
 var $4=(($__nar)|0);
 var $5=HEAP8[(14656)];
 var $6=(($5<<24)>>24)==0;
 if($6){label=2;break;}else{label=6;break;}
 case 2: 
 var $8=___cxa_guard_acquire(14656);
 var $9=($8|0)==0;
 if($9){label=6;break;}else{label=3;break;}
 case 3: 
 var $11=(function() { try { __THREW__ = 0; return _newlocale(2147483647,1496,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=4;break; } else { label=5;break; }
 case 4: 
 HEAP32[((12664)>>2)]=$11;

 label=6;break;
 case 5: 
 var $14$0 = ___cxa_find_matching_catch(-1, -1); var $14$1 = tempRet0;

 ___resumeException($14$0)
 case 6: 
 var $15=HEAP32[((12664)>>2)];
 var $16=__ZNSt3__112__snprintf_lEPcjP15__locale_structPKcz($4,20,$15,$3,(tempVarArgs=STACKTOP,STACKTOP = (STACKTOP + 8)|0,(assert((STACKTOP|0) < (STACK_MAX|0))|0),HEAP32[((tempVarArgs)>>2)]=$__v,tempVarArgs)); STACKTOP=tempVarArgs;
 var $17=(($__nar+$16)|0);
 var $18=(($__iob+4)|0);
 var $19=HEAP32[(($18)>>2)];
 var $20=$19&176;
 if(($20|0)==32){ var $_0_i=$17;label=13;break;}else if(($20|0)==16){ label=7;break;}else{label=12;break;}
 case 7: 
 var $22=HEAP8[($4)];
 if((($22<<24)>>24)==45|(($22<<24)>>24)==43){ label=8;break;}else{label=9;break;}
 case 8: 
 var $24=(($__nar+1)|0);
 var $_0_i=$24;label=13;break;
 case 9: 
 var $26=($16|0)>1;
 var $27=(($22<<24)>>24)==48;
 var $or_cond_i=$26&$27;
 if($or_cond_i){label=10;break;}else{label=12;break;}
 case 10: 
 var $29=(($__nar+1)|0);
 var $30=HEAP8[($29)];
 if((($30<<24)>>24)==120|(($30<<24)>>24)==88){ label=11;break;}else{label=12;break;}
 case 11: 
 var $32=(($__nar+2)|0);
 var $_0_i=$32;label=13;break;
 case 12: 
 var $_0_i=$4;label=13;break;
 case 13: 
 var $_0_i;
 __ZNKSt3__18ios_base6getlocEv($1,$__iob);
 var $34=(($1)|0);
 var $35=HEAP32[(($34)>>2)];
 var $36=$__p_i_i_i_i;
 var $37=HEAP32[((14088)>>2)];
 var $38=($37|0)==-1;
 if($38){label=15;break;}else{label=14;break;}
 case 14: 
 var $_sroa_01_0___p67_i_idx_i_i_i=(($__p_i_i_i_i)|0);
 HEAP32[(($_sroa_01_0___p67_i_idx_i_i_i)>>2)]=14088;
 var $_sroa_12_4___p67_i_idx3_i_i_i=(($__p_i_i_i_i+4)|0);
 HEAP32[(($_sroa_12_4___p67_i_idx3_i_i_i)>>2)]=(28);
 var $_sroa_2_8___p67_i_idx4_i_i_i=(($__p_i_i_i_i+8)|0);
 HEAP32[(($_sroa_2_8___p67_i_idx4_i_i_i)>>2)]=0;
 (function() { try { __THREW__ = 0; return __ZNSt3__111__call_onceERVmPvPFvS2_E(14088,$36,260) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=15;break; } else { label=20;break; }
 case 15: 
 var $40=HEAP32[((14092)>>2)];
 var $41=((($40)-(1))|0);
 var $42=(($35+12)|0);
 var $43=HEAP32[(($42)>>2)];
 var $44=(($35+8)|0);
 var $45=HEAP32[(($44)>>2)];
 var $46=$43;
 var $47=$45;
 var $48=((($46)-($47))|0);
 var $49=$48>>2;
 var $50=($49>>>0)>($41>>>0);
 if($50){label=16;break;}else{label=17;break;}
 case 16: 
 var $51=(($45+($41<<2))|0);
 var $52=HEAP32[(($51)>>2)];
 var $53=($52|0)==0;
 if($53){label=17;break;}else{label=19;break;}
 case 17: 
 var $54=___cxa_allocate_exception(4);
 var $55=$54;
 __ZNSt8bad_castC2Ev($55);
 (function() { try { __THREW__ = 0; return ___cxa_throw($54,8960,(368)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=18;break; } else { label=20;break; }
 case 18: 
 throw "Reached an unreachable!";
 case 19: 
 var $57=$52;
 var $58=HEAP32[(($34)>>2)];
 var $59=(($58)|0);
 var $60=__ZNSt3__114__shared_count16__release_sharedEv($59);
 var $61=(($__o)|0);
 var $62=$52;
 var $63=HEAP32[(($62)>>2)];
 var $64=(($63+48)|0);
 var $65=HEAP32[(($64)>>2)];
 var $66=FUNCTION_TABLE[$65]($57,$4,$17,$61);
 var $67=(($__o+($16<<2))|0);
 var $68=($_0_i|0)==($17|0);
 if($68){var $__op_0=$67;label=22;break;}else{label=21;break;}
 case 20: 
 var $70$0 = ___cxa_find_matching_catch(-1, -1); var $70$1 = tempRet0;
 var $71=HEAP32[(($34)>>2)];
 var $72=(($71)|0);
 var $73=__ZNSt3__114__shared_count16__release_sharedEv($72);
 ___resumeException($70$0)
 case 21: 
 var $75=$__nar;
 var $76=$_0_i;
 var $77=((($76)-($75))|0);
 var $78=(($__o+($77<<2))|0);
 var $__op_0=$78;label=22;break;
 case 22: 
 var $__op_0;
 var $80=(($__s)|0);
 var $81=HEAP32[(($80)>>2)];
 var $82=(($2)|0);
 HEAP32[(($82)>>2)]=$81;
 __ZNSt3__116__pad_and_outputIwNS_11char_traitsIwEEEENS_19ostreambuf_iteratorIT_T0_EES6_PKS4_S8_S8_RNS_8ios_baseES4_($agg_result,$2,$61,$__op_0,$67,$__iob,$__fl);
 STACKTOP=sp;return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3getES4_S4_RNS_8ios_baseERjP2tmPKcSC_($agg_result,$this,$__b,$__e,$__iob,$__err,$__tm,$__fmtb,$__fmte){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+48)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var tempParam = $__b; $__b=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__b)>>2)]=HEAP32[((tempParam)>>2)];
 var tempParam = $__e; $__e=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $__p_i_i_i_i=sp;
 var $1=(sp)+(16);
 var $2=(sp)+(24);
 var $3=(sp)+(32);
 var $4=(sp)+(40);
 __ZNKSt3__18ios_base6getlocEv($1,$__iob);
 var $5=(($1)|0);
 var $6=HEAP32[(($5)>>2)];
 var $7=$__p_i_i_i_i;
 var $8=HEAP32[((14096)>>2)];
 var $9=($8|0)==-1;
 if($9){label=3;break;}else{label=2;break;}
 case 2: 
 var $_sroa_01_0___p67_i_idx_i_i_i=(($__p_i_i_i_i)|0);
 HEAP32[(($_sroa_01_0___p67_i_idx_i_i_i)>>2)]=14096;
 var $_sroa_12_4___p67_i_idx3_i_i_i=(($__p_i_i_i_i+4)|0);
 HEAP32[(($_sroa_12_4___p67_i_idx3_i_i_i)>>2)]=(28);
 var $_sroa_2_8___p67_i_idx4_i_i_i=(($__p_i_i_i_i+8)|0);
 HEAP32[(($_sroa_2_8___p67_i_idx4_i_i_i)>>2)]=0;
 (function() { try { __THREW__ = 0; return __ZNSt3__111__call_onceERVmPvPFvS2_E(14096,$7,260) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=3;break; } else { label=22;break; }
 case 3: 
 var $11=HEAP32[((14100)>>2)];
 var $12=((($11)-(1))|0);
 var $13=(($6+12)|0);
 var $14=HEAP32[(($13)>>2)];
 var $15=(($6+8)|0);
 var $16=HEAP32[(($15)>>2)];
 var $17=$14;
 var $18=$16;
 var $19=((($17)-($18))|0);
 var $20=$19>>2;
 var $21=($20>>>0)>($12>>>0);
 if($21){label=4;break;}else{label=5;break;}
 case 4: 
 var $22=(($16+($12<<2))|0);
 var $23=HEAP32[(($22)>>2)];
 var $24=($23|0)==0;
 if($24){label=5;break;}else{label=7;break;}
 case 5: 
 var $25=___cxa_allocate_exception(4);
 var $26=$25;
 __ZNSt8bad_castC2Ev($26);
 (function() { try { __THREW__ = 0; return ___cxa_throw($25,8960,(368)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=6;break; } else { label=22;break; }
 case 6: 
 throw "Reached an unreachable!";
 case 7: 
 var $28=$23;
 var $29=HEAP32[(($5)>>2)];
 var $30=(($29)|0);
 var $31=__ZNSt3__114__shared_count16__release_sharedEv($30);
 HEAP32[(($__err)>>2)]=0;
 var $32=($__fmtb|0)==($__fmte|0);
 var $_phi_trans_insert_pre_pre=(($__b)|0);
 if($32){label=67;break;}else{label=8;break;}
 case 8: 
 var $33=(($__e)|0);
 var $34=$23;
 var $35=$23;
 var $36=(($23+8)|0);
 var $37=$36;
 var $38=$this;
 var $39=(($3)|0);
 var $40=(($4)|0);
 var $41=(($2)|0);
 var $_0_ph78=$__fmtb;var $_pre79=0;label=9;break;
 case 9: 
 var $_pre79;
 var $_0_ph78;
 var $43=$_pre79;label=10;break;
 case 10: 
 var $43;
 var $44=($43|0)==0;
 if($44){label=11;break;}else{label=67;break;}
 case 11: 
 var $46=HEAP32[(($_phi_trans_insert_pre_pre)>>2)];
 var $47=($46|0)==0;
 if($47){var $61=0;label=15;break;}else{label=12;break;}
 case 12: 
 var $49=(($46+12)|0);
 var $50=HEAP32[(($49)>>2)];
 var $51=(($46+16)|0);
 var $52=HEAP32[(($51)>>2)];
 var $53=($50|0)==($52|0);
 if($53){label=13;break;}else{var $61=$46;label=15;break;}
 case 13: 
 var $54=$46;
 var $55=HEAP32[(($54)>>2)];
 var $56=(($55+36)|0);
 var $57=HEAP32[(($56)>>2)];
 var $58=FUNCTION_TABLE[$57]($46);
 var $59=($58|0)==-1;
 if($59){label=14;break;}else{var $61=$46;label=15;break;}
 case 14: 
 HEAP32[(($_phi_trans_insert_pre_pre)>>2)]=0;
 var $61=0;label=15;break;
 case 15: 
 var $61;
 var $62=($61|0)==0;
 var $63=HEAP32[(($33)>>2)];
 var $64=($63|0)==0;
 if($64){label=20;break;}else{label=16;break;}
 case 16: 
 var $66=(($63+12)|0);
 var $67=HEAP32[(($66)>>2)];
 var $68=(($63+16)|0);
 var $69=HEAP32[(($68)>>2)];
 var $70=($67|0)==($69|0);
 if($70){label=17;break;}else{label=19;break;}
 case 17: 
 var $71=$63;
 var $72=HEAP32[(($71)>>2)];
 var $73=(($72+36)|0);
 var $74=HEAP32[(($73)>>2)];
 var $75=FUNCTION_TABLE[$74]($63);
 var $76=($75|0)==-1;
 if($76){label=18;break;}else{label=19;break;}
 case 18: 
 HEAP32[(($33)>>2)]=0;
 label=20;break;
 case 19: 
 if($62){var $85=$63;label=23;break;}else{label=21;break;}
 case 20: 
 if($62){label=21;break;}else{var $85=0;label=23;break;}
 case 21: 
 HEAP32[(($__err)>>2)]=4;
 var $_pre_i_i_i60=$61;label=68;break;
 case 22: 
 var $80$0 = ___cxa_find_matching_catch(-1, -1); var $80$1 = tempRet0;
 var $81=HEAP32[(($5)>>2)];
 var $82=(($81)|0);
 var $83=__ZNSt3__114__shared_count16__release_sharedEv($82);
 ___resumeException($80$0)
 case 23: 
 var $85;
 var $86=HEAP8[($_0_ph78)];
 var $87=HEAP32[(($34)>>2)];
 var $88=(($87+36)|0);
 var $89=HEAP32[(($88)>>2)];
 var $90=FUNCTION_TABLE[$89]($28,$86,0);
 var $91=(($90<<24)>>24)==37;
 if($91){label=24;break;}else{label=33;break;}
 case 24: 
 var $93=(($_0_ph78+1)|0);
 var $94=($93|0)==($__fmte|0);
 if($94){label=25;break;}else{label=26;break;}
 case 25: 
 HEAP32[(($__err)>>2)]=4;
 var $_pre_i_i_i60=$61;label=68;break;
 case 26: 
 var $97=HEAP8[($93)];
 var $98=HEAP32[(($34)>>2)];
 var $99=(($98+36)|0);
 var $100=HEAP32[(($99)>>2)];
 var $101=FUNCTION_TABLE[$100]($28,$97,0);
 if((($101<<24)>>24)==69|(($101<<24)>>24)==48){ label=27;break;}else{var $__opt_0=0;var $__cmd_0=$101;var $_1=$93;label=30;break;}
 case 27: 
 var $103=(($_0_ph78+2)|0);
 var $104=($103|0)==($__fmte|0);
 if($104){label=28;break;}else{label=29;break;}
 case 28: 
 HEAP32[(($__err)>>2)]=4;
 var $_pre_i_i_i60=$61;label=68;break;
 case 29: 
 var $107=HEAP8[($103)];
 var $108=HEAP32[(($34)>>2)];
 var $109=(($108+36)|0);
 var $110=HEAP32[(($109)>>2)];
 var $111=FUNCTION_TABLE[$110]($28,$107,0);
 var $__opt_0=$101;var $__cmd_0=$111;var $_1=$103;label=30;break;
 case 30: 
 var $_1;
 var $__cmd_0;
 var $__opt_0;
 var $113=HEAP32[(($38)>>2)];
 var $114=(($113+36)|0);
 var $115=HEAP32[(($114)>>2)];
 HEAP32[(($39)>>2)]=$61;
 HEAP32[(($40)>>2)]=$85;
 FUNCTION_TABLE[$115]($2,$this,$3,$4,$__iob,$__err,$__tm,$__cmd_0,$__opt_0);
 var $116=HEAP32[(($41)>>2)];
 HEAP32[(($_phi_trans_insert_pre_pre)>>2)]=$116;
 var $117=(($_1+1)|0);
 var $_0_ph_be=$117;label=31;break;
 case 31: 
 var $_0_ph_be;
 var $118=($_0_ph_be|0)==($__fmte|0);
 if($118){label=67;break;}else{label=32;break;}
 case 32: 
 var $_pre79_pre=HEAP32[(($__err)>>2)];
 var $_0_ph78=$_0_ph_be;var $_pre79=$_pre79_pre;label=9;break;
 case 33: 
 var $120=HEAP8[($_0_ph78)];
 var $121=(($120<<24)>>24)<0;
 if($121){label=58;break;}else{label=34;break;}
 case 34: 
 var $122=(($120<<24)>>24);
 var $123=HEAP32[(($37)>>2)];
 var $124=(($123+($122<<1))|0);
 var $125=HEAP16[(($124)>>1)];
 var $126=$125&8192;
 var $127=(($126<<16)>>16)==0;
 if($127){label=58;break;}else{var $_0_pn=$_0_ph78;label=35;break;}
 case 35: 
 var $_0_pn;
 var $_2=(($_0_pn+1)|0);
 var $128=($_2|0)==($__fmte|0);
 if($128){var $_2_lcssa=$__fmte;label=38;break;}else{label=36;break;}
 case 36: 
 var $130=HEAP8[($_2)];
 var $131=(($130<<24)>>24)<0;
 if($131){var $_2_lcssa=$_2;label=38;break;}else{label=37;break;}
 case 37: 
 var $132=(($130<<24)>>24);
 var $133=(($123+($132<<1))|0);
 var $134=HEAP16[(($133)>>1)];
 var $135=$134&8192;
 var $136=(($135<<16)>>16)==0;
 if($136){var $_2_lcssa=$_2;label=38;break;}else{var $_0_pn=$_2;label=35;break;}
 case 38: 
 var $_2_lcssa;
 var $_pre_i_i_i47=$61;var $137=$85;var $_pre_i3_i_i51=$85;label=39;break;
 case 39: 
 var $_pre_i3_i_i51;
 var $137;
 var $_pre_i_i_i47;
 var $138=($_pre_i_i_i47|0)==0;
 if($138){var $152=0;label=43;break;}else{label=40;break;}
 case 40: 
 var $140=(($_pre_i_i_i47+12)|0);
 var $141=HEAP32[(($140)>>2)];
 var $142=(($_pre_i_i_i47+16)|0);
 var $143=HEAP32[(($142)>>2)];
 var $144=($141|0)==($143|0);
 if($144){label=41;break;}else{var $152=$_pre_i_i_i47;label=43;break;}
 case 41: 
 var $145=$_pre_i_i_i47;
 var $146=HEAP32[(($145)>>2)];
 var $147=(($146+36)|0);
 var $148=HEAP32[(($147)>>2)];
 var $149=FUNCTION_TABLE[$148]($_pre_i_i_i47);
 var $150=($149|0)==-1;
 if($150){label=42;break;}else{var $152=$_pre_i_i_i47;label=43;break;}
 case 42: 
 HEAP32[(($_phi_trans_insert_pre_pre)>>2)]=0;
 var $152=0;label=43;break;
 case 43: 
 var $152;
 var $153=($152|0)==0;
 var $154=($137|0)==0;
 if($154){var $_pre_i3_i_i5181=$_pre_i3_i_i51;label=48;break;}else{label=44;break;}
 case 44: 
 var $156=(($137+12)|0);
 var $157=HEAP32[(($156)>>2)];
 var $158=(($137+16)|0);
 var $159=HEAP32[(($158)>>2)];
 var $160=($157|0)==($159|0);
 if($160){label=46;break;}else{label=45;break;}
 case 45: 
 if($153){var $169=$137;var $_pre_i3_i_i5180=$_pre_i3_i_i51;label=50;break;}else{var $_0_ph_be=$_2_lcssa;label=31;break;}
 case 46: 
 var $161=$137;
 var $162=HEAP32[(($161)>>2)];
 var $163=(($162+36)|0);
 var $164=HEAP32[(($163)>>2)];
 var $165=FUNCTION_TABLE[$164]($137);
 var $166=($165|0)==-1;
 if($166){label=47;break;}else{label=49;break;}
 case 47: 
 HEAP32[(($33)>>2)]=0;
 var $_pre_i3_i_i5181=0;label=48;break;
 case 48: 
 var $_pre_i3_i_i5181;
 if($153){var $_0_ph_be=$_2_lcssa;label=31;break;}else{var $169=0;var $_pre_i3_i_i5180=$_pre_i3_i_i5181;label=50;break;}
 case 49: 
 var $168=($_pre_i3_i_i51|0)==0;
 var $tmp_i_i53=$153^$168;
 if($tmp_i_i53){var $169=$_pre_i3_i_i51;var $_pre_i3_i_i5180=$_pre_i3_i_i51;label=50;break;}else{var $_0_ph_be=$_2_lcssa;label=31;break;}
 case 50: 
 var $_pre_i3_i_i5180;
 var $169;
 var $170=(($152+12)|0);
 var $171=HEAP32[(($170)>>2)];
 var $172=(($152+16)|0);
 var $173=HEAP32[(($172)>>2)];
 var $174=($171|0)==($173|0);
 if($174){label=51;break;}else{label=52;break;}
 case 51: 
 var $176=$152;
 var $177=HEAP32[(($176)>>2)];
 var $178=(($177+36)|0);
 var $179=HEAP32[(($178)>>2)];
 var $180=FUNCTION_TABLE[$179]($152);
 var $extract_t_i=(($180)&255);
 var $_0_i_off0_i=$extract_t_i;label=53;break;
 case 52: 
 var $182=HEAP8[($171)];
 var $_0_i_off0_i=$182;label=53;break;
 case 53: 
 var $_0_i_off0_i;
 var $183=(($_0_i_off0_i<<24)>>24)<0;
 if($183){var $_0_ph_be=$_2_lcssa;label=31;break;}else{label=54;break;}
 case 54: 
 var $184=(($_0_i_off0_i<<24)>>24);
 var $185=HEAP32[(($37)>>2)];
 var $186=(($185+($184<<1))|0);
 var $187=HEAP16[(($186)>>1)];
 var $188=$187&8192;
 var $189=(($188<<16)>>16)==0;
 if($189){var $_0_ph_be=$_2_lcssa;label=31;break;}else{label=55;break;}
 case 55: 
 var $191=HEAP32[(($170)>>2)];
 var $192=HEAP32[(($172)>>2)];
 var $193=($191|0)==($192|0);
 if($193){label=56;break;}else{label=57;break;}
 case 56: 
 var $195=$152;
 var $196=HEAP32[(($195)>>2)];
 var $197=(($196+40)|0);
 var $198=HEAP32[(($197)>>2)];
 var $199=FUNCTION_TABLE[$198]($152);
 var $_pre_i_i_i47=$152;var $137=$169;var $_pre_i3_i_i51=$_pre_i3_i_i5180;label=39;break;
 case 57: 
 var $201=(($191+1)|0);
 HEAP32[(($170)>>2)]=$201;
 var $_pre_i_i_i47=$152;var $137=$169;var $_pre_i3_i_i51=$_pre_i3_i_i5180;label=39;break;
 case 58: 
 var $202=(($61+12)|0);
 var $203=HEAP32[(($202)>>2)];
 var $204=(($61+16)|0);
 var $205=HEAP32[(($204)>>2)];
 var $206=($203|0)==($205|0);
 if($206){label=59;break;}else{label=60;break;}
 case 59: 
 var $208=$61;
 var $209=HEAP32[(($208)>>2)];
 var $210=(($209+36)|0);
 var $211=HEAP32[(($210)>>2)];
 var $212=FUNCTION_TABLE[$211]($61);
 var $extract_t_i55=(($212)&255);
 var $_0_i_off0_i56=$extract_t_i55;label=61;break;
 case 60: 
 var $214=HEAP8[($203)];
 var $_0_i_off0_i56=$214;label=61;break;
 case 61: 
 var $_0_i_off0_i56;
 var $215=HEAP32[(($35)>>2)];
 var $216=(($215+12)|0);
 var $217=HEAP32[(($216)>>2)];
 var $218=FUNCTION_TABLE[$217]($28,$_0_i_off0_i56);
 var $219=HEAP8[($_0_ph78)];
 var $220=HEAP32[(($35)>>2)];
 var $221=(($220+12)|0);
 var $222=HEAP32[(($221)>>2)];
 var $223=FUNCTION_TABLE[$222]($28,$219);
 var $224=(($218<<24)>>24)==(($223<<24)>>24);
 if($224){label=62;break;}else{label=66;break;}
 case 62: 
 var $226=HEAP32[(($202)>>2)];
 var $227=HEAP32[(($204)>>2)];
 var $228=($226|0)==($227|0);
 if($228){label=63;break;}else{label=64;break;}
 case 63: 
 var $230=$61;
 var $231=HEAP32[(($230)>>2)];
 var $232=(($231+40)|0);
 var $233=HEAP32[(($232)>>2)];
 var $234=FUNCTION_TABLE[$233]($61);
 label=65;break;
 case 64: 
 var $236=(($226+1)|0);
 HEAP32[(($202)>>2)]=$236;
 label=65;break;
 case 65: 
 var $237=(($_0_ph78+1)|0);
 var $_0_ph_be=$237;label=31;break;
 case 66: 
 HEAP32[(($__err)>>2)]=4;
 var $43=4;label=10;break;
 case 67: 
 var $_pre=HEAP32[(($_phi_trans_insert_pre_pre)>>2)];
 var $_pre_i_i_i60=$_pre;label=68;break;
 case 68: 
 var $_pre_i_i_i60;
 var $238=(($__b)|0);
 var $239=($_pre_i_i_i60|0)==0;
 if($239){var $253=0;label=72;break;}else{label=69;break;}
 case 69: 
 var $241=(($_pre_i_i_i60+12)|0);
 var $242=HEAP32[(($241)>>2)];
 var $243=(($_pre_i_i_i60+16)|0);
 var $244=HEAP32[(($243)>>2)];
 var $245=($242|0)==($244|0);
 if($245){label=70;break;}else{var $253=$_pre_i_i_i60;label=72;break;}
 case 70: 
 var $246=$_pre_i_i_i60;
 var $247=HEAP32[(($246)>>2)];
 var $248=(($247+36)|0);
 var $249=HEAP32[(($248)>>2)];
 var $250=FUNCTION_TABLE[$249]($_pre_i_i_i60);
 var $251=($250|0)==-1;
 if($251){label=71;break;}else{var $253=$_pre_i_i_i60;label=72;break;}
 case 71: 
 HEAP32[(($238)>>2)]=0;
 var $253=0;label=72;break;
 case 72: 
 var $253;
 var $254=($253|0)==0;
 var $255=(($__e)|0);
 var $256=HEAP32[(($255)>>2)];
 var $257=($256|0)==0;
 if($257){label=77;break;}else{label=73;break;}
 case 73: 
 var $259=(($256+12)|0);
 var $260=HEAP32[(($259)>>2)];
 var $261=(($256+16)|0);
 var $262=HEAP32[(($261)>>2)];
 var $263=($260|0)==($262|0);
 if($263){label=74;break;}else{label=76;break;}
 case 74: 
 var $264=$256;
 var $265=HEAP32[(($264)>>2)];
 var $266=(($265+36)|0);
 var $267=HEAP32[(($266)>>2)];
 var $268=FUNCTION_TABLE[$267]($256);
 var $269=($268|0)==-1;
 if($269){label=75;break;}else{label=76;break;}
 case 75: 
 HEAP32[(($255)>>2)]=0;
 label=77;break;
 case 76: 
 if($254){label=79;break;}else{label=78;break;}
 case 77: 
 if($254){label=78;break;}else{label=79;break;}
 case 78: 
 var $272=HEAP32[(($__err)>>2)];
 var $273=$272|2;
 HEAP32[(($__err)>>2)]=$273;
 label=79;break;
 case 79: 
 var $275=(($agg_result)|0);
 HEAP32[(($275)>>2)]=$253;
 STACKTOP=sp;return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEED0Ev($this){
 var label=0;


 var $1=(($this)|0);
 __ZNSt3__114__shared_countD2Ev($1);
 var $2=$this;
 __ZdlPv($2);
 return;
}


function __ZNSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEED1Ev($this){
 var label=0;


 var $1=(($this)|0);
 __ZNSt3__114__shared_countD2Ev($1);
 return;
}


function __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE13do_date_orderEv($this){
 var label=0;


 return 2;
}


function __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE11do_get_timeES4_S4_RNS_8ios_baseERjP2tm($agg_result,$this,$__b,$__e,$__iob,$__err,$__tm){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+16)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var tempParam = $__b; $__b=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__b)>>2)]=HEAP32[((tempParam)>>2)];
 var tempParam = $__e; $__e=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];

 var $1=sp;
 var $2=(sp)+(8);
 var $3=(($__b)|0);
 var $4=HEAP32[(($3)>>2)];
 var $5=(($1)|0);
 HEAP32[(($5)>>2)]=$4;
 var $6=(($__e)|0);
 var $7=HEAP32[(($6)>>2)];
 var $8=(($2)|0);
 HEAP32[(($8)>>2)]=$7;
 __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3getES4_S4_RNS_8ios_baseERjP2tmPKcSC_($agg_result,$this,$1,$2,$__iob,$__err,$__tm,2896,2904);
 STACKTOP=sp;return;
}


function __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE11do_get_dateES4_S4_RNS_8ios_baseERjP2tm($agg_result,$this,$__b,$__e,$__iob,$__err,$__tm){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+16)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var tempParam = $__b; $__b=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__b)>>2)]=HEAP32[((tempParam)>>2)];
 var tempParam = $__e; $__e=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=sp;
 var $2=(sp)+(8);
 var $3=(($this+8)|0);
 var $4=$3;
 var $5=HEAP32[(($4)>>2)];
 var $6=(($5+20)|0);
 var $7=HEAP32[(($6)>>2)];
 var $8=FUNCTION_TABLE[$7]($3);
 var $9=(($__b)|0);
 var $10=HEAP32[(($9)>>2)];
 var $11=(($1)|0);
 HEAP32[(($11)>>2)]=$10;
 var $12=(($__e)|0);
 var $13=HEAP32[(($12)>>2)];
 var $14=(($2)|0);
 HEAP32[(($14)>>2)]=$13;
 var $15=$8;
 var $16=HEAP8[($15)];
 var $17=$16&1;
 var $18=(($17<<24)>>24)==0;
 if($18){label=3;break;}else{label=2;break;}
 case 2: 
 var $20=(($8+8)|0);
 var $21=HEAP32[(($20)>>2)];
 var $22=(($8+4)|0);
 var $23=HEAP32[(($22)>>2)];
 var $33=$23;var $32=$21;var $31=$21;label=4;break;
 case 3: 
 var $25=$8;
 var $26=(($25+1)|0);
 var $27=$8;
 var $28=(($27+1)|0);
 var $29=($16&255);
 var $30=$29>>>1;
 var $33=$30;var $32=$26;var $31=$28;label=4;break;
 case 4: 
 var $31;
 var $32;
 var $33;
 var $34=(($31+$33)|0);
 __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3getES4_S4_RNS_8ios_baseERjP2tmPKcSC_($agg_result,$this,$1,$2,$__iob,$__err,$__tm,$32,$34);
 STACKTOP=sp;return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE14do_get_weekdayES4_S4_RNS_8ios_baseERjP2tm($agg_result,$this,$__b,$__e,$__iob,$__err,$__tm){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+32)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var tempParam = $__b; $__b=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__b)>>2)]=HEAP32[((tempParam)>>2)];
 var tempParam = $__e; $__e=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=sp;
 var $__p_i_i_i_i=(sp)+(8);
 var $2=(sp)+(24);
 __ZNKSt3__18ios_base6getlocEv($2,$__iob);
 var $3=(($2)|0);
 var $4=HEAP32[(($3)>>2)];
 var $5=$__p_i_i_i_i;
 var $6=HEAP32[((14096)>>2)];
 var $7=($6|0)==-1;
 if($7){label=3;break;}else{label=2;break;}
 case 2: 
 var $_sroa_01_0___p67_i_idx_i_i_i=(($__p_i_i_i_i)|0);
 HEAP32[(($_sroa_01_0___p67_i_idx_i_i_i)>>2)]=14096;
 var $_sroa_12_4___p67_i_idx3_i_i_i=(($__p_i_i_i_i+4)|0);
 HEAP32[(($_sroa_12_4___p67_i_idx3_i_i_i)>>2)]=(28);
 var $_sroa_2_8___p67_i_idx4_i_i_i=(($__p_i_i_i_i+8)|0);
 HEAP32[(($_sroa_2_8___p67_i_idx4_i_i_i)>>2)]=0;
 (function() { try { __THREW__ = 0; return __ZNSt3__111__call_onceERVmPvPFvS2_E(14096,$5,260) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=3;break; } else { label=10;break; }
 case 3: 
 var $9=HEAP32[((14100)>>2)];
 var $10=((($9)-(1))|0);
 var $11=(($4+12)|0);
 var $12=HEAP32[(($11)>>2)];
 var $13=(($4+8)|0);
 var $14=HEAP32[(($13)>>2)];
 var $15=$12;
 var $16=$14;
 var $17=((($15)-($16))|0);
 var $18=$17>>2;
 var $19=($18>>>0)>($10>>>0);
 if($19){label=4;break;}else{label=5;break;}
 case 4: 
 var $20=(($14+($10<<2))|0);
 var $21=HEAP32[(($20)>>2)];
 var $22=($21|0)==0;
 if($22){label=5;break;}else{label=7;break;}
 case 5: 
 var $23=___cxa_allocate_exception(4);
 var $24=$23;
 __ZNSt8bad_castC2Ev($24);
 (function() { try { __THREW__ = 0; return ___cxa_throw($23,8960,(368)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=6;break; } else { label=10;break; }
 case 6: 
 throw "Reached an unreachable!";
 case 7: 
 var $26=$21;
 var $27=HEAP32[(($3)>>2)];
 var $28=(($27)|0);
 var $29=__ZNSt3__114__shared_count16__release_sharedEv($28);
 var $30=(($__e)|0);
 var $31=HEAP32[(($30)>>2)];
 var $32=$1;
 var $33=(($this+8)|0);
 var $34=$33;
 var $35=HEAP32[(($34)>>2)];
 var $36=HEAP32[(($35)>>2)];
 var $37=FUNCTION_TABLE[$36]($33);
 var $38=(($1)|0);
 HEAP32[(($38)>>2)]=$31;
 var $39=(($37+168)|0);
 var $40=__ZNSt3__114__scan_keywordINS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEPKNS_12basic_stringIcS3_NS_9allocatorIcEEEENS_5ctypeIcEEEET0_RT_SE_SD_SD_RKT1_Rjb($__b,$1,$37,$39,$26,$__err,0);
 var $41=$40;
 var $42=$37;
 var $43=((($41)-($42))|0);
 var $44=($43|0)<168;
 if($44){label=8;break;}else{label=9;break;}
 case 8: 
 var $46=(($__tm+24)|0);
 var $47=(((($43|0))/(12))&-1);
 var $48=(((($47|0))%(7))&-1);
 HEAP32[(($46)>>2)]=$48;
 label=9;break;
 case 9: 
 var $49=(($__b)|0);
 var $50=HEAP32[(($49)>>2)];
 var $51=(($agg_result)|0);
 HEAP32[(($51)>>2)]=$50;
 STACKTOP=sp;return;
 case 10: 
 var $53$0 = ___cxa_find_matching_catch(-1, -1); var $53$1 = tempRet0;
 var $54=HEAP32[(($3)>>2)];
 var $55=(($54)|0);
 var $56=__ZNSt3__114__shared_count16__release_sharedEv($55);
 ___resumeException($53$0)
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE16do_get_monthnameES4_S4_RNS_8ios_baseERjP2tm($agg_result,$this,$__b,$__e,$__iob,$__err,$__tm){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+32)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var tempParam = $__b; $__b=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__b)>>2)]=HEAP32[((tempParam)>>2)];
 var tempParam = $__e; $__e=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=sp;
 var $__p_i_i_i_i=(sp)+(8);
 var $2=(sp)+(24);
 __ZNKSt3__18ios_base6getlocEv($2,$__iob);
 var $3=(($2)|0);
 var $4=HEAP32[(($3)>>2)];
 var $5=$__p_i_i_i_i;
 var $6=HEAP32[((14096)>>2)];
 var $7=($6|0)==-1;
 if($7){label=3;break;}else{label=2;break;}
 case 2: 
 var $_sroa_01_0___p67_i_idx_i_i_i=(($__p_i_i_i_i)|0);
 HEAP32[(($_sroa_01_0___p67_i_idx_i_i_i)>>2)]=14096;
 var $_sroa_12_4___p67_i_idx3_i_i_i=(($__p_i_i_i_i+4)|0);
 HEAP32[(($_sroa_12_4___p67_i_idx3_i_i_i)>>2)]=(28);
 var $_sroa_2_8___p67_i_idx4_i_i_i=(($__p_i_i_i_i+8)|0);
 HEAP32[(($_sroa_2_8___p67_i_idx4_i_i_i)>>2)]=0;
 (function() { try { __THREW__ = 0; return __ZNSt3__111__call_onceERVmPvPFvS2_E(14096,$5,260) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=3;break; } else { label=10;break; }
 case 3: 
 var $9=HEAP32[((14100)>>2)];
 var $10=((($9)-(1))|0);
 var $11=(($4+12)|0);
 var $12=HEAP32[(($11)>>2)];
 var $13=(($4+8)|0);
 var $14=HEAP32[(($13)>>2)];
 var $15=$12;
 var $16=$14;
 var $17=((($15)-($16))|0);
 var $18=$17>>2;
 var $19=($18>>>0)>($10>>>0);
 if($19){label=4;break;}else{label=5;break;}
 case 4: 
 var $20=(($14+($10<<2))|0);
 var $21=HEAP32[(($20)>>2)];
 var $22=($21|0)==0;
 if($22){label=5;break;}else{label=7;break;}
 case 5: 
 var $23=___cxa_allocate_exception(4);
 var $24=$23;
 __ZNSt8bad_castC2Ev($24);
 (function() { try { __THREW__ = 0; return ___cxa_throw($23,8960,(368)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=6;break; } else { label=10;break; }
 case 6: 
 throw "Reached an unreachable!";
 case 7: 
 var $26=$21;
 var $27=HEAP32[(($3)>>2)];
 var $28=(($27)|0);
 var $29=__ZNSt3__114__shared_count16__release_sharedEv($28);
 var $30=(($__e)|0);
 var $31=HEAP32[(($30)>>2)];
 var $32=$1;
 var $33=(($this+8)|0);
 var $34=$33;
 var $35=HEAP32[(($34)>>2)];
 var $36=(($35+4)|0);
 var $37=HEAP32[(($36)>>2)];
 var $38=FUNCTION_TABLE[$37]($33);
 var $39=(($1)|0);
 HEAP32[(($39)>>2)]=$31;
 var $40=(($38+288)|0);
 var $41=__ZNSt3__114__scan_keywordINS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEPKNS_12basic_stringIcS3_NS_9allocatorIcEEEENS_5ctypeIcEEEET0_RT_SE_SD_SD_RKT1_Rjb($__b,$1,$38,$40,$26,$__err,0);
 var $42=$41;
 var $43=$38;
 var $44=((($42)-($43))|0);
 var $45=($44|0)<288;
 if($45){label=8;break;}else{label=9;break;}
 case 8: 
 var $47=(($__tm+16)|0);
 var $48=(((($44|0))/(12))&-1);
 var $49=(((($48|0))%(12))&-1);
 HEAP32[(($47)>>2)]=$49;
 label=9;break;
 case 9: 
 var $50=(($__b)|0);
 var $51=HEAP32[(($50)>>2)];
 var $52=(($agg_result)|0);
 HEAP32[(($52)>>2)]=$51;
 STACKTOP=sp;return;
 case 10: 
 var $54$0 = ___cxa_find_matching_catch(-1, -1); var $54$1 = tempRet0;
 var $55=HEAP32[(($3)>>2)];
 var $56=(($55)|0);
 var $57=__ZNSt3__114__shared_count16__release_sharedEv($56);
 ___resumeException($54$0)
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE11do_get_yearES4_S4_RNS_8ios_baseERjP2tm($agg_result,$this,$__b,$__e,$__iob,$__err,$__tm){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+32)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var tempParam = $__b; $__b=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__b)>>2)]=HEAP32[((tempParam)>>2)];
 var tempParam = $__e; $__e=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=sp;
 var $__p_i_i_i_i=(sp)+(8);
 var $2=(sp)+(24);
 __ZNKSt3__18ios_base6getlocEv($2,$__iob);
 var $3=(($2)|0);
 var $4=HEAP32[(($3)>>2)];
 var $5=$__p_i_i_i_i;
 var $6=HEAP32[((14096)>>2)];
 var $7=($6|0)==-1;
 if($7){label=3;break;}else{label=2;break;}
 case 2: 
 var $_sroa_01_0___p67_i_idx_i_i_i=(($__p_i_i_i_i)|0);
 HEAP32[(($_sroa_01_0___p67_i_idx_i_i_i)>>2)]=14096;
 var $_sroa_12_4___p67_i_idx3_i_i_i=(($__p_i_i_i_i+4)|0);
 HEAP32[(($_sroa_12_4___p67_i_idx3_i_i_i)>>2)]=(28);
 var $_sroa_2_8___p67_i_idx4_i_i_i=(($__p_i_i_i_i+8)|0);
 HEAP32[(($_sroa_2_8___p67_i_idx4_i_i_i)>>2)]=0;
 (function() { try { __THREW__ = 0; return __ZNSt3__111__call_onceERVmPvPFvS2_E(14096,$5,260) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=3;break; } else { label=13;break; }
 case 3: 
 var $9=HEAP32[((14100)>>2)];
 var $10=((($9)-(1))|0);
 var $11=(($4+12)|0);
 var $12=HEAP32[(($11)>>2)];
 var $13=(($4+8)|0);
 var $14=HEAP32[(($13)>>2)];
 var $15=$12;
 var $16=$14;
 var $17=((($15)-($16))|0);
 var $18=$17>>2;
 var $19=($18>>>0)>($10>>>0);
 if($19){label=4;break;}else{label=5;break;}
 case 4: 
 var $20=(($14+($10<<2))|0);
 var $21=HEAP32[(($20)>>2)];
 var $22=($21|0)==0;
 if($22){label=5;break;}else{label=7;break;}
 case 5: 
 var $23=___cxa_allocate_exception(4);
 var $24=$23;
 __ZNSt8bad_castC2Ev($24);
 (function() { try { __THREW__ = 0; return ___cxa_throw($23,8960,(368)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=6;break; } else { label=13;break; }
 case 6: 
 throw "Reached an unreachable!";
 case 7: 
 var $26=$21;
 var $27=HEAP32[(($3)>>2)];
 var $28=(($27)|0);
 var $29=__ZNSt3__114__shared_count16__release_sharedEv($28);
 var $30=(($__tm+20)|0);
 var $31=(($__e)|0);
 var $32=HEAP32[(($31)>>2)];
 var $33=$1;
 var $34=(($1)|0);
 HEAP32[(($34)>>2)]=$32;
 var $35=__ZNSt3__120__get_up_to_n_digitsIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi($__b,$1,$__err,$26,4);
 var $36=HEAP32[(($__err)>>2)];
 var $37=$36&4;
 var $38=($37|0)==0;
 if($38){label=8;break;}else{label=12;break;}
 case 8: 
 var $40=($35|0)<69;
 if($40){label=9;break;}else{label=10;break;}
 case 9: 
 var $42=((($35)+(2000))|0);
 var $__t_0_i=$42;label=11;break;
 case 10: 
 var $_off_i=((($35)-(69))|0);
 var $44=($_off_i>>>0)<31;
 var $45=((($35)+(1900))|0);
 var $__i=($44?$45:$35);
 var $__t_0_i=$__i;label=11;break;
 case 11: 
 var $__t_0_i;
 var $47=((($__t_0_i)-(1900))|0);
 HEAP32[(($30)>>2)]=$47;
 label=12;break;
 case 12: 
 var $48=(($__b)|0);
 var $49=HEAP32[(($48)>>2)];
 var $50=(($agg_result)|0);
 HEAP32[(($50)>>2)]=$49;
 STACKTOP=sp;return;
 case 13: 
 var $52$0 = ___cxa_find_matching_catch(-1, -1); var $52$1 = tempRet0;
 var $53=HEAP32[(($3)>>2)];
 var $54=(($53)|0);
 var $55=__ZNSt3__114__shared_count16__release_sharedEv($54);
 ___resumeException($52$0)
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjP2tmcc($agg_result,$this,$__b,$__e,$__iob,$__err,$__tm,$__fmt,$0){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+328)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var tempParam = $__b; $__b=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__b)>>2)]=HEAP32[((tempParam)>>2)];
 var tempParam = $__e; $__e=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $2=sp;
 var $3=(sp)+(8);
 var $4=(sp)+(16);
 var $5=(sp)+(24);
 var $6=(sp)+(32);
 var $7=(sp)+(40);
 var $8=(sp)+(48);
 var $9=(sp)+(56);
 var $10=(sp)+(64);
 var $11=(sp)+(72);
 var $12=(sp)+(80);
 var $13=(sp)+(88);
 var $__p_i_i_i_i=(sp)+(96);
 var $14=(sp)+(112);
 var $15=(sp)+(120);
 var $16=(sp)+(128);
 var $17=(sp)+(136);
 var $18=(sp)+(144);
 var $19=(sp)+(152);
 var $20=(sp)+(160);
 var $21=(sp)+(168);
 var $22=(sp)+(176);
 var $23=(sp)+(184);
 var $24=(sp)+(192);
 var $25=(sp)+(200);
 var $26=(sp)+(208);
 var $27=(sp)+(216);
 var $28=(sp)+(224);
 var $29=(sp)+(232);
 var $30=(sp)+(240);
 var $31=(sp)+(248);
 var $32=(sp)+(256);
 var $33=(sp)+(264);
 var $34=(sp)+(272);
 var $35=(sp)+(280);
 var $36=(sp)+(288);
 var $37=(sp)+(296);
 var $38=(sp)+(304);
 var $39=(sp)+(312);
 var $40=(sp)+(320);
 HEAP32[(($__err)>>2)]=0;
 __ZNKSt3__18ios_base6getlocEv($14,$__iob);
 var $41=(($14)|0);
 var $42=HEAP32[(($41)>>2)];
 var $43=$__p_i_i_i_i;
 var $44=HEAP32[((14096)>>2)];
 var $45=($44|0)==-1;
 if($45){label=3;break;}else{label=2;break;}
 case 2: 
 var $_sroa_01_0___p67_i_idx_i_i_i=(($__p_i_i_i_i)|0);
 HEAP32[(($_sroa_01_0___p67_i_idx_i_i_i)>>2)]=14096;
 var $_sroa_12_4___p67_i_idx3_i_i_i=(($__p_i_i_i_i+4)|0);
 HEAP32[(($_sroa_12_4___p67_i_idx3_i_i_i)>>2)]=(28);
 var $_sroa_2_8___p67_i_idx4_i_i_i=(($__p_i_i_i_i+8)|0);
 HEAP32[(($_sroa_2_8___p67_i_idx4_i_i_i)>>2)]=0;
 (function() { try { __THREW__ = 0; return __ZNSt3__111__call_onceERVmPvPFvS2_E(14096,$43,260) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=3;break; } else { label=8;break; }
 case 3: 
 var $47=HEAP32[((14100)>>2)];
 var $48=((($47)-(1))|0);
 var $49=(($42+12)|0);
 var $50=HEAP32[(($49)>>2)];
 var $51=(($42+8)|0);
 var $52=HEAP32[(($51)>>2)];
 var $53=$50;
 var $54=$52;
 var $55=((($53)-($54))|0);
 var $56=$55>>2;
 var $57=($56>>>0)>($48>>>0);
 if($57){label=4;break;}else{label=5;break;}
 case 4: 
 var $58=(($52+($48<<2))|0);
 var $59=HEAP32[(($58)>>2)];
 var $60=($59|0)==0;
 if($60){label=5;break;}else{label=7;break;}
 case 5: 
 var $61=___cxa_allocate_exception(4);
 var $62=$61;
 __ZNSt8bad_castC2Ev($62);
 (function() { try { __THREW__ = 0; return ___cxa_throw($61,8960,(368)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=6;break; } else { label=8;break; }
 case 6: 
 throw "Reached an unreachable!";
 case 7: 
 var $64=$59;
 var $65=HEAP32[(($41)>>2)];
 var $66=(($65)|0);
 var $67=__ZNSt3__114__shared_count16__release_sharedEv($66);
 var $68=(($__fmt<<24)>>24);
 switch(($68|0)){case 98:case 66:case 104:{ label=11;break;}case 99:{ label=13;break;}case 100:case 101:{ label=17;break;}case 68:{ label=21;break;}case 70:{ label=22;break;}case 72:{ label=23;break;}case 73:{ label=26;break;}case 106:{ label=30;break;}case 109:{ label=33;break;}case 77:{ label=36;break;}case 110:case 116:{ label=39;break;}case 112:{ label=40;break;}case 114:{ label=41;break;}case 82:{ label=42;break;}case 83:{ label=43;break;}case 84:{ label=46;break;}case 119:{ label=47;break;}case 120:{ label=50;break;}case 88:{ label=51;break;}case 121:{ label=55;break;}case 89:{ label=60;break;}case 37:{ label=62;break;}case 97:case 65:{ label=9;break;}default:{label=63;break;}}break;
 case 8: 
 var $70$0 = ___cxa_find_matching_catch(-1, -1); var $70$1 = tempRet0;
 var $71=HEAP32[(($41)>>2)];
 var $72=(($71)|0);
 var $73=__ZNSt3__114__shared_count16__release_sharedEv($72);
 ___resumeException($70$0)
 case 9: 
 var $75=(($__e)|0);
 var $76=HEAP32[(($75)>>2)];
 var $77=$13;
 var $78=(($this+8)|0);
 var $79=$78;
 var $80=HEAP32[(($79)>>2)];
 var $81=HEAP32[(($80)>>2)];
 var $82=FUNCTION_TABLE[$81]($78);
 var $83=(($13)|0);
 HEAP32[(($83)>>2)]=$76;
 var $84=(($82+168)|0);
 var $85=__ZNSt3__114__scan_keywordINS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEPKNS_12basic_stringIcS3_NS_9allocatorIcEEEENS_5ctypeIcEEEET0_RT_SE_SD_SD_RKT1_Rjb($__b,$13,$82,$84,$64,$__err,0);
 var $86=$85;
 var $87=$82;
 var $88=((($86)-($87))|0);
 var $89=($88|0)<168;
 if($89){label=10;break;}else{label=64;break;}
 case 10: 
 var $91=(($__tm+24)|0);
 var $92=(((($88|0))/(12))&-1);
 var $93=(((($92|0))%(7))&-1);
 HEAP32[(($91)>>2)]=$93;
 label=64;break;
 case 11: 
 var $95=(($__e)|0);
 var $96=HEAP32[(($95)>>2)];
 var $97=$12;
 var $98=(($this+8)|0);
 var $99=$98;
 var $100=HEAP32[(($99)>>2)];
 var $101=(($100+4)|0);
 var $102=HEAP32[(($101)>>2)];
 var $103=FUNCTION_TABLE[$102]($98);
 var $104=(($12)|0);
 HEAP32[(($104)>>2)]=$96;
 var $105=(($103+288)|0);
 var $106=__ZNSt3__114__scan_keywordINS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEPKNS_12basic_stringIcS3_NS_9allocatorIcEEEENS_5ctypeIcEEEET0_RT_SE_SD_SD_RKT1_Rjb($__b,$12,$103,$105,$64,$__err,0);
 var $107=$106;
 var $108=$103;
 var $109=((($107)-($108))|0);
 var $110=($109|0)<288;
 if($110){label=12;break;}else{label=64;break;}
 case 12: 
 var $112=(($__tm+16)|0);
 var $113=(((($109|0))/(12))&-1);
 var $114=(((($113|0))%(12))&-1);
 HEAP32[(($112)>>2)]=$114;
 label=64;break;
 case 13: 
 var $116=(($this+8)|0);
 var $117=$116;
 var $118=HEAP32[(($117)>>2)];
 var $119=(($118+12)|0);
 var $120=HEAP32[(($119)>>2)];
 var $121=FUNCTION_TABLE[$120]($116);
 var $122=(($__b)|0);
 var $123=HEAP32[(($122)>>2)];
 var $124=(($16)|0);
 HEAP32[(($124)>>2)]=$123;
 var $125=(($__e)|0);
 var $126=HEAP32[(($125)>>2)];
 var $127=(($17)|0);
 HEAP32[(($127)>>2)]=$126;
 var $128=$121;
 var $129=HEAP8[($128)];
 var $130=$129&1;
 var $131=(($130<<24)>>24)==0;
 if($131){label=15;break;}else{label=14;break;}
 case 14: 
 var $133=(($121+8)|0);
 var $134=HEAP32[(($133)>>2)];
 var $135=(($121+4)|0);
 var $136=HEAP32[(($135)>>2)];
 var $146=$136;var $145=$134;var $144=$134;label=16;break;
 case 15: 
 var $138=$121;
 var $139=(($138+1)|0);
 var $140=$121;
 var $141=(($140+1)|0);
 var $142=($129&255);
 var $143=$142>>>1;
 var $146=$143;var $145=$139;var $144=$141;label=16;break;
 case 16: 
 var $144;
 var $145;
 var $146;
 var $147=(($144+$146)|0);
 __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3getES4_S4_RNS_8ios_baseERjP2tmPKcSC_($15,$this,$16,$17,$__iob,$__err,$__tm,$145,$147);
 var $148=(($15)|0);
 var $149=HEAP32[(($148)>>2)];
 HEAP32[(($122)>>2)]=$149;
 label=64;break;
 case 17: 
 var $151=(($__tm+12)|0);
 var $152=(($__e)|0);
 var $153=HEAP32[(($152)>>2)];
 var $154=$11;
 var $155=(($11)|0);
 HEAP32[(($155)>>2)]=$153;
 var $156=__ZNSt3__120__get_up_to_n_digitsIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi($__b,$11,$__err,$64,2);
 var $157=HEAP32[(($__err)>>2)];
 var $158=$157&4;
 var $159=($158|0)==0;
 if($159){label=18;break;}else{label=20;break;}
 case 18: 
 var $_off_i=((($156)-(1))|0);
 var $161=($_off_i>>>0)<31;
 if($161){label=19;break;}else{label=20;break;}
 case 19: 
 HEAP32[(($151)>>2)]=$156;
 label=64;break;
 case 20: 
 var $164=$157|4;
 HEAP32[(($__err)>>2)]=$164;
 label=64;break;
 case 21: 
 var $166=(($__b)|0);
 var $167=HEAP32[(($166)>>2)];
 var $168=(($19)|0);
 HEAP32[(($168)>>2)]=$167;
 var $169=(($__e)|0);
 var $170=HEAP32[(($169)>>2)];
 var $171=(($20)|0);
 HEAP32[(($171)>>2)]=$170;
 __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3getES4_S4_RNS_8ios_baseERjP2tmPKcSC_($18,$this,$19,$20,$__iob,$__err,$__tm,2888,2896);
 var $172=(($18)|0);
 var $173=HEAP32[(($172)>>2)];
 HEAP32[(($166)>>2)]=$173;
 label=64;break;
 case 22: 
 var $175=(($__b)|0);
 var $176=HEAP32[(($175)>>2)];
 var $177=(($22)|0);
 HEAP32[(($177)>>2)]=$176;
 var $178=(($__e)|0);
 var $179=HEAP32[(($178)>>2)];
 var $180=(($23)|0);
 HEAP32[(($180)>>2)]=$179;
 __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3getES4_S4_RNS_8ios_baseERjP2tmPKcSC_($21,$this,$22,$23,$__iob,$__err,$__tm,2880,2888);
 var $181=(($21)|0);
 var $182=HEAP32[(($181)>>2)];
 HEAP32[(($175)>>2)]=$182;
 label=64;break;
 case 23: 
 var $184=(($__e)|0);
 var $185=HEAP32[(($184)>>2)];
 var $186=$10;
 var $187=(($10)|0);
 HEAP32[(($187)>>2)]=$185;
 var $188=__ZNSt3__120__get_up_to_n_digitsIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi($__b,$10,$__err,$64,2);
 var $189=HEAP32[(($__err)>>2)];
 var $190=$189&4;
 var $191=($190|0)==0;
 var $192=($188|0)<24;
 var $or_cond_i=$191&$192;
 if($or_cond_i){label=24;break;}else{label=25;break;}
 case 24: 
 var $194=(($__tm+8)|0);
 HEAP32[(($194)>>2)]=$188;
 label=64;break;
 case 25: 
 var $196=$189|4;
 HEAP32[(($__err)>>2)]=$196;
 label=64;break;
 case 26: 
 var $198=(($__tm+8)|0);
 var $199=(($__e)|0);
 var $200=HEAP32[(($199)>>2)];
 var $201=$9;
 var $202=(($9)|0);
 HEAP32[(($202)>>2)]=$200;
 var $203=__ZNSt3__120__get_up_to_n_digitsIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi($__b,$9,$__err,$64,2);
 var $204=HEAP32[(($__err)>>2)];
 var $205=$204&4;
 var $206=($205|0)==0;
 if($206){label=27;break;}else{label=29;break;}
 case 27: 
 var $_off_i88=((($203)-(1))|0);
 var $208=($_off_i88>>>0)<12;
 if($208){label=28;break;}else{label=29;break;}
 case 28: 
 HEAP32[(($198)>>2)]=$203;
 label=64;break;
 case 29: 
 var $211=$204|4;
 HEAP32[(($__err)>>2)]=$211;
 label=64;break;
 case 30: 
 var $213=(($__e)|0);
 var $214=HEAP32[(($213)>>2)];
 var $215=$8;
 var $216=(($8)|0);
 HEAP32[(($216)>>2)]=$214;
 var $217=__ZNSt3__120__get_up_to_n_digitsIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi($__b,$8,$__err,$64,3);
 var $218=HEAP32[(($__err)>>2)];
 var $219=$218&4;
 var $220=($219|0)==0;
 var $221=($217|0)<366;
 var $or_cond_i91=$220&$221;
 if($or_cond_i91){label=31;break;}else{label=32;break;}
 case 31: 
 var $223=(($__tm+28)|0);
 HEAP32[(($223)>>2)]=$217;
 label=64;break;
 case 32: 
 var $225=$218|4;
 HEAP32[(($__err)>>2)]=$225;
 label=64;break;
 case 33: 
 var $227=(($__e)|0);
 var $228=HEAP32[(($227)>>2)];
 var $229=$7;
 var $230=(($7)|0);
 HEAP32[(($230)>>2)]=$228;
 var $231=__ZNSt3__120__get_up_to_n_digitsIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi($__b,$7,$__err,$64,2);
 var $232=((($231)-(1))|0);
 var $233=HEAP32[(($__err)>>2)];
 var $234=$233&4;
 var $235=($234|0)==0;
 var $236=($232|0)<12;
 var $or_cond_i94=$235&$236;
 if($or_cond_i94){label=34;break;}else{label=35;break;}
 case 34: 
 var $238=(($__tm+16)|0);
 HEAP32[(($238)>>2)]=$232;
 label=64;break;
 case 35: 
 var $240=$233|4;
 HEAP32[(($__err)>>2)]=$240;
 label=64;break;
 case 36: 
 var $242=(($__e)|0);
 var $243=HEAP32[(($242)>>2)];
 var $244=$6;
 var $245=(($6)|0);
 HEAP32[(($245)>>2)]=$243;
 var $246=__ZNSt3__120__get_up_to_n_digitsIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi($__b,$6,$__err,$64,2);
 var $247=HEAP32[(($__err)>>2)];
 var $248=$247&4;
 var $249=($248|0)==0;
 var $250=($246|0)<60;
 var $or_cond_i97=$249&$250;
 if($or_cond_i97){label=37;break;}else{label=38;break;}
 case 37: 
 var $252=(($__tm+4)|0);
 HEAP32[(($252)>>2)]=$246;
 label=64;break;
 case 38: 
 var $254=$247|4;
 HEAP32[(($__err)>>2)]=$254;
 label=64;break;
 case 39: 
 var $256=(($__e)|0);
 var $257=HEAP32[(($256)>>2)];
 var $258=(($24)|0);
 HEAP32[(($258)>>2)]=$257;
 __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE17__get_white_spaceERS4_S4_RjRKNS_5ctypeIcEE(0,$__b,$24,$__err,$64);
 label=64;break;
 case 40: 
 var $260=(($__tm+8)|0);
 var $261=(($__e)|0);
 var $262=HEAP32[(($261)>>2)];
 var $263=(($25)|0);
 HEAP32[(($263)>>2)]=$262;
 __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE11__get_am_pmERiRS4_S4_RjRKNS_5ctypeIcEE($this,$260,$__b,$25,$__err,$64);
 label=64;break;
 case 41: 
 var $265=(($__b)|0);
 var $266=HEAP32[(($265)>>2)];
 var $267=(($27)|0);
 HEAP32[(($267)>>2)]=$266;
 var $268=(($__e)|0);
 var $269=HEAP32[(($268)>>2)];
 var $270=(($28)|0);
 HEAP32[(($270)>>2)]=$269;
 __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3getES4_S4_RNS_8ios_baseERjP2tmPKcSC_($26,$this,$27,$28,$__iob,$__err,$__tm,2864,2875);
 var $271=(($26)|0);
 var $272=HEAP32[(($271)>>2)];
 HEAP32[(($265)>>2)]=$272;
 label=64;break;
 case 42: 
 var $274=(($__b)|0);
 var $275=HEAP32[(($274)>>2)];
 var $276=(($30)|0);
 HEAP32[(($276)>>2)]=$275;
 var $277=(($__e)|0);
 var $278=HEAP32[(($277)>>2)];
 var $279=(($31)|0);
 HEAP32[(($279)>>2)]=$278;
 __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3getES4_S4_RNS_8ios_baseERjP2tmPKcSC_($29,$this,$30,$31,$__iob,$__err,$__tm,2856,2861);
 var $280=(($29)|0);
 var $281=HEAP32[(($280)>>2)];
 HEAP32[(($274)>>2)]=$281;
 label=64;break;
 case 43: 
 var $283=(($__e)|0);
 var $284=HEAP32[(($283)>>2)];
 var $285=$5;
 var $286=(($5)|0);
 HEAP32[(($286)>>2)]=$284;
 var $287=__ZNSt3__120__get_up_to_n_digitsIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi($__b,$5,$__err,$64,2);
 var $288=HEAP32[(($__err)>>2)];
 var $289=$288&4;
 var $290=($289|0)==0;
 var $291=($287|0)<61;
 var $or_cond_i100=$290&$291;
 if($or_cond_i100){label=44;break;}else{label=45;break;}
 case 44: 
 var $293=(($__tm)|0);
 HEAP32[(($293)>>2)]=$287;
 label=64;break;
 case 45: 
 var $295=$288|4;
 HEAP32[(($__err)>>2)]=$295;
 label=64;break;
 case 46: 
 var $297=(($__b)|0);
 var $298=HEAP32[(($297)>>2)];
 var $299=(($33)|0);
 HEAP32[(($299)>>2)]=$298;
 var $300=(($__e)|0);
 var $301=HEAP32[(($300)>>2)];
 var $302=(($34)|0);
 HEAP32[(($302)>>2)]=$301;
 __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3getES4_S4_RNS_8ios_baseERjP2tmPKcSC_($32,$this,$33,$34,$__iob,$__err,$__tm,2848,2856);
 var $303=(($32)|0);
 var $304=HEAP32[(($303)>>2)];
 HEAP32[(($297)>>2)]=$304;
 label=64;break;
 case 47: 
 var $306=(($__e)|0);
 var $307=HEAP32[(($306)>>2)];
 var $308=$4;
 var $309=(($4)|0);
 HEAP32[(($309)>>2)]=$307;
 var $310=__ZNSt3__120__get_up_to_n_digitsIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi($__b,$4,$__err,$64,1);
 var $311=HEAP32[(($__err)>>2)];
 var $312=$311&4;
 var $313=($312|0)==0;
 var $314=($310|0)<7;
 var $or_cond_i103=$313&$314;
 if($or_cond_i103){label=48;break;}else{label=49;break;}
 case 48: 
 var $316=(($__tm+24)|0);
 HEAP32[(($316)>>2)]=$310;
 label=64;break;
 case 49: 
 var $318=$311|4;
 HEAP32[(($__err)>>2)]=$318;
 label=64;break;
 case 50: 
 var $320=$this;
 var $321=HEAP32[(($320)>>2)];
 var $322=(($321+20)|0);
 var $323=HEAP32[(($322)>>2)];
 var $324=(($__b)|0);
 var $325=HEAP32[(($324)>>2)];
 var $326=(($35)|0);
 HEAP32[(($326)>>2)]=$325;
 var $327=(($__e)|0);
 var $328=HEAP32[(($327)>>2)];
 var $329=(($36)|0);
 HEAP32[(($329)>>2)]=$328;
 FUNCTION_TABLE[$323]($agg_result,$this,$35,$36,$__iob,$__err,$__tm);
 label=65;break;
 case 51: 
 var $331=(($this+8)|0);
 var $332=$331;
 var $333=HEAP32[(($332)>>2)];
 var $334=(($333+24)|0);
 var $335=HEAP32[(($334)>>2)];
 var $336=FUNCTION_TABLE[$335]($331);
 var $337=(($__b)|0);
 var $338=HEAP32[(($337)>>2)];
 var $339=(($38)|0);
 HEAP32[(($339)>>2)]=$338;
 var $340=(($__e)|0);
 var $341=HEAP32[(($340)>>2)];
 var $342=(($39)|0);
 HEAP32[(($342)>>2)]=$341;
 var $343=$336;
 var $344=HEAP8[($343)];
 var $345=$344&1;
 var $346=(($345<<24)>>24)==0;
 if($346){label=53;break;}else{label=52;break;}
 case 52: 
 var $348=(($336+8)|0);
 var $349=HEAP32[(($348)>>2)];
 var $350=(($336+4)|0);
 var $351=HEAP32[(($350)>>2)];
 var $361=$351;var $360=$349;var $359=$349;label=54;break;
 case 53: 
 var $353=$336;
 var $354=(($353+1)|0);
 var $355=$336;
 var $356=(($355+1)|0);
 var $357=($344&255);
 var $358=$357>>>1;
 var $361=$358;var $360=$354;var $359=$356;label=54;break;
 case 54: 
 var $359;
 var $360;
 var $361;
 var $362=(($359+$361)|0);
 __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3getES4_S4_RNS_8ios_baseERjP2tmPKcSC_($37,$this,$38,$39,$__iob,$__err,$__tm,$360,$362);
 var $363=(($37)|0);
 var $364=HEAP32[(($363)>>2)];
 HEAP32[(($337)>>2)]=$364;
 label=64;break;
 case 55: 
 var $366=(($__tm+20)|0);
 var $367=(($__e)|0);
 var $368=HEAP32[(($367)>>2)];
 var $369=$3;
 var $370=(($3)|0);
 HEAP32[(($370)>>2)]=$368;
 var $371=__ZNSt3__120__get_up_to_n_digitsIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi($__b,$3,$__err,$64,4);
 var $372=HEAP32[(($__err)>>2)];
 var $373=$372&4;
 var $374=($373|0)==0;
 if($374){label=56;break;}else{label=64;break;}
 case 56: 
 var $376=($371|0)<69;
 if($376){label=57;break;}else{label=58;break;}
 case 57: 
 var $378=((($371)+(2000))|0);
 var $__t_0_i=$378;label=59;break;
 case 58: 
 var $_off_i109=((($371)-(69))|0);
 var $380=($_off_i109>>>0)<31;
 var $381=((($371)+(1900))|0);
 var $__i=($380?$381:$371);
 var $__t_0_i=$__i;label=59;break;
 case 59: 
 var $__t_0_i;
 var $383=((($__t_0_i)-(1900))|0);
 HEAP32[(($366)>>2)]=$383;
 label=64;break;
 case 60: 
 var $385=(($__e)|0);
 var $386=HEAP32[(($385)>>2)];
 var $387=$2;
 var $388=(($2)|0);
 HEAP32[(($388)>>2)]=$386;
 var $389=__ZNSt3__120__get_up_to_n_digitsIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi($__b,$2,$__err,$64,4);
 var $390=HEAP32[(($__err)>>2)];
 var $391=$390&4;
 var $392=($391|0)==0;
 if($392){label=61;break;}else{label=64;break;}
 case 61: 
 var $394=(($__tm+20)|0);
 var $395=((($389)-(1900))|0);
 HEAP32[(($394)>>2)]=$395;
 label=64;break;
 case 62: 
 var $397=(($__e)|0);
 var $398=HEAP32[(($397)>>2)];
 var $399=(($40)|0);
 HEAP32[(($399)>>2)]=$398;
 __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE13__get_percentERS4_S4_RjRKNS_5ctypeIcEE(0,$__b,$40,$__err,$64);
 label=64;break;
 case 63: 
 var $401=HEAP32[(($__err)>>2)];
 var $402=$401|4;
 HEAP32[(($__err)>>2)]=$402;
 label=64;break;
 case 64: 
 var $403=(($__b)|0);
 var $404=HEAP32[(($403)>>2)];
 var $405=(($agg_result)|0);
 HEAP32[(($405)>>2)]=$404;
 label=65;break;
 case 65: 
 STACKTOP=sp;return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE17__get_white_spaceERS4_S4_RjRKNS_5ctypeIcEE($this,$__b,$__e,$__err,$__ct){
 var label=0;
 var sp=STACKTOP; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var tempParam = $__e; $__e=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=(($__b)|0);
 var $2=(($__e)|0);
 var $3=(($__ct+8)|0);
 label=2;break;
 case 2: 
 var $4=HEAP32[(($1)>>2)];
 var $5=($4|0)==0;
 if($5){var $19=0;label=7;break;}else{label=3;break;}
 case 3: 
 var $7=(($4+12)|0);
 var $8=HEAP32[(($7)>>2)];
 var $9=(($4+16)|0);
 var $10=HEAP32[(($9)>>2)];
 var $11=($8|0)==($10|0);
 if($11){label=4;break;}else{var $19=$4;label=7;break;}
 case 4: 
 var $12=$4;
 var $13=HEAP32[(($12)>>2)];
 var $14=(($13+36)|0);
 var $15=HEAP32[(($14)>>2)];
 var $16=FUNCTION_TABLE[$15]($4);
 var $17=($16|0)==-1;
 if($17){label=6;break;}else{label=5;break;}
 case 5: 
 var $_pre_i_i_i=HEAP32[(($1)>>2)];
 var $19=$_pre_i_i_i;label=7;break;
 case 6: 
 HEAP32[(($1)>>2)]=0;
 var $19=0;label=7;break;
 case 7: 
 var $19;
 var $20=($19|0)==0;
 var $21=HEAP32[(($2)>>2)];
 var $22=($21|0)==0;
 if($22){label=12;break;}else{label=8;break;}
 case 8: 
 var $24=(($21+12)|0);
 var $25=HEAP32[(($24)>>2)];
 var $26=(($21+16)|0);
 var $27=HEAP32[(($26)>>2)];
 var $28=($25|0)==($27|0);
 if($28){label=10;break;}else{label=9;break;}
 case 9: 
 if($20){var $36=$21;label=14;break;}else{var $_pre_i3_i_i12=$21;label=22;break;}
 case 10: 
 var $29=$21;
 var $30=HEAP32[(($29)>>2)];
 var $31=(($30+36)|0);
 var $32=HEAP32[(($31)>>2)];
 var $33=FUNCTION_TABLE[$32]($21);
 var $34=($33|0)==-1;
 if($34){label=11;break;}else{label=13;break;}
 case 11: 
 HEAP32[(($2)>>2)]=0;
 label=12;break;
 case 12: 
 if($20){var $_pre_i3_i_i12=0;label=22;break;}else{var $36=0;label=14;break;}
 case 13: 
 if($20){var $36=$21;label=14;break;}else{var $_pre_i3_i_i12=$21;label=22;break;}
 case 14: 
 var $36;
 var $37=HEAP32[(($1)>>2)];
 var $38=(($37+12)|0);
 var $39=HEAP32[(($38)>>2)];
 var $40=(($37+16)|0);
 var $41=HEAP32[(($40)>>2)];
 var $42=($39|0)==($41|0);
 if($42){label=15;break;}else{label=16;break;}
 case 15: 
 var $44=$37;
 var $45=HEAP32[(($44)>>2)];
 var $46=(($45+36)|0);
 var $47=HEAP32[(($46)>>2)];
 var $48=FUNCTION_TABLE[$47]($37);
 var $extract_t_i=(($48)&255);
 var $_0_i_off0_i=$extract_t_i;label=17;break;
 case 16: 
 var $50=HEAP8[($39)];
 var $_0_i_off0_i=$50;label=17;break;
 case 17: 
 var $_0_i_off0_i;
 var $51=(($_0_i_off0_i<<24)>>24)<0;
 if($51){var $_pre_i3_i_i12=$36;label=22;break;}else{label=18;break;}
 case 18: 
 var $52=(($_0_i_off0_i<<24)>>24);
 var $53=HEAP32[(($3)>>2)];
 var $54=(($53+($52<<1))|0);
 var $55=HEAP16[(($54)>>1)];
 var $56=$55&8192;
 var $57=(($56<<16)>>16)==0;
 if($57){var $_pre_i3_i_i12=$36;label=22;break;}else{label=19;break;}
 case 19: 
 var $59=HEAP32[(($1)>>2)];
 var $60=(($59+12)|0);
 var $61=HEAP32[(($60)>>2)];
 var $62=(($59+16)|0);
 var $63=HEAP32[(($62)>>2)];
 var $64=($61|0)==($63|0);
 if($64){label=20;break;}else{label=21;break;}
 case 20: 
 var $66=$59;
 var $67=HEAP32[(($66)>>2)];
 var $68=(($67+40)|0);
 var $69=HEAP32[(($68)>>2)];
 var $70=FUNCTION_TABLE[$69]($59);
 label=2;break;
 case 21: 
 var $72=(($61+1)|0);
 HEAP32[(($60)>>2)]=$72;
 label=2;break;
 case 22: 
 var $_pre_i3_i_i12;
 var $73=HEAP32[(($1)>>2)];
 var $74=($73|0)==0;
 if($74){var $88=0;label=27;break;}else{label=23;break;}
 case 23: 
 var $76=(($73+12)|0);
 var $77=HEAP32[(($76)>>2)];
 var $78=(($73+16)|0);
 var $79=HEAP32[(($78)>>2)];
 var $80=($77|0)==($79|0);
 if($80){label=24;break;}else{var $88=$73;label=27;break;}
 case 24: 
 var $81=$73;
 var $82=HEAP32[(($81)>>2)];
 var $83=(($82+36)|0);
 var $84=HEAP32[(($83)>>2)];
 var $85=FUNCTION_TABLE[$84]($73);
 var $86=($85|0)==-1;
 if($86){label=26;break;}else{label=25;break;}
 case 25: 
 var $_pre_i_i_i8=HEAP32[(($1)>>2)];
 var $88=$_pre_i_i_i8;label=27;break;
 case 26: 
 HEAP32[(($1)>>2)]=0;
 var $88=0;label=27;break;
 case 27: 
 var $88;
 var $89=($88|0)==0;
 var $90=($_pre_i3_i_i12|0)==0;
 if($90){label=32;break;}else{label=28;break;}
 case 28: 
 var $92=(($_pre_i3_i_i12+12)|0);
 var $93=HEAP32[(($92)>>2)];
 var $94=(($_pre_i3_i_i12+16)|0);
 var $95=HEAP32[(($94)>>2)];
 var $96=($93|0)==($95|0);
 if($96){label=29;break;}else{label=31;break;}
 case 29: 
 var $97=$_pre_i3_i_i12;
 var $98=HEAP32[(($97)>>2)];
 var $99=(($98+36)|0);
 var $100=HEAP32[(($99)>>2)];
 var $101=FUNCTION_TABLE[$100]($_pre_i3_i_i12);
 var $102=($101|0)==-1;
 if($102){label=30;break;}else{label=31;break;}
 case 30: 
 HEAP32[(($2)>>2)]=0;
 label=32;break;
 case 31: 
 if($89){label=34;break;}else{label=33;break;}
 case 32: 
 if($89){label=33;break;}else{label=34;break;}
 case 33: 
 var $105=HEAP32[(($__err)>>2)];
 var $106=$105|2;
 HEAP32[(($__err)>>2)]=$106;
 label=34;break;
 case 34: 
 STACKTOP=sp;return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE11__get_am_pmERiRS4_S4_RjRKNS_5ctypeIcEE($this,$__h,$__b,$__e,$__err,$__ct){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+8)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var tempParam = $__e; $__e=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=sp;
 var $2=(($this+8)|0);
 var $3=$2;
 var $4=HEAP32[(($3)>>2)];
 var $5=(($4+8)|0);
 var $6=HEAP32[(($5)>>2)];
 var $7=FUNCTION_TABLE[$6]($2);
 var $8=$7;
 var $9=HEAP8[($8)];
 var $10=$9&1;
 var $11=(($10<<24)>>24)==0;
 if($11){label=3;break;}else{label=2;break;}
 case 2: 
 var $13=(($7+4)|0);
 var $14=HEAP32[(($13)>>2)];
 var $18=$14;label=4;break;
 case 3: 
 var $16=($9&255);
 var $17=$16>>>1;
 var $18=$17;label=4;break;
 case 4: 
 var $18;
 var $19=(($7+12)|0);
 var $20=$19;
 var $21=HEAP8[($20)];
 var $22=$21&1;
 var $23=(($22<<24)>>24)==0;
 if($23){label=6;break;}else{label=5;break;}
 case 5: 
 var $25=(($7+16)|0);
 var $26=HEAP32[(($25)>>2)];
 var $30=$26;label=7;break;
 case 6: 
 var $28=($21&255);
 var $29=$28>>>1;
 var $30=$29;label=7;break;
 case 7: 
 var $30;
 var $31=(((-$30))|0);
 var $32=($18|0)==($31|0);
 if($32){label=8;break;}else{label=9;break;}
 case 8: 
 var $34=HEAP32[(($__err)>>2)];
 var $35=$34|4;
 HEAP32[(($__err)>>2)]=$35;
 label=15;break;
 case 9: 
 var $37=(($__e)|0);
 var $38=HEAP32[(($37)>>2)];
 var $39=(($1)|0);
 HEAP32[(($39)>>2)]=$38;
 var $40=(($7+24)|0);
 var $41=__ZNSt3__114__scan_keywordINS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEPKNS_12basic_stringIcS3_NS_9allocatorIcEEEENS_5ctypeIcEEEET0_RT_SE_SD_SD_RKT1_Rjb($__b,$1,$7,$40,$__ct,$__err,0);
 var $42=$41;
 var $43=$7;
 var $44=((($42)-($43))|0);
 var $45=($41|0)==($7|0);
 if($45){label=10;break;}else{label=12;break;}
 case 10: 
 var $47=HEAP32[(($__h)>>2)];
 var $48=($47|0)==12;
 if($48){label=11;break;}else{label=12;break;}
 case 11: 
 HEAP32[(($__h)>>2)]=0;
 label=15;break;
 case 12: 
 var $51=($44|0)==12;
 if($51){label=13;break;}else{label=15;break;}
 case 13: 
 var $53=HEAP32[(($__h)>>2)];
 var $54=($53|0)<12;
 if($54){label=14;break;}else{label=15;break;}
 case 14: 
 var $56=((($53)+(12))|0);
 HEAP32[(($__h)>>2)]=$56;
 label=15;break;
 case 15: 
 STACKTOP=sp;return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE13__get_percentERS4_S4_RjRKNS_5ctypeIcEE($this,$__b,$__e,$__err,$__ct){
 var label=0;
 var sp=STACKTOP; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var tempParam = $__e; $__e=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=(($__b)|0);
 var $2=HEAP32[(($1)>>2)];
 var $3=($2|0)==0;
 if($3){var $17=0;label=6;break;}else{label=2;break;}
 case 2: 
 var $5=(($2+12)|0);
 var $6=HEAP32[(($5)>>2)];
 var $7=(($2+16)|0);
 var $8=HEAP32[(($7)>>2)];
 var $9=($6|0)==($8|0);
 if($9){label=3;break;}else{var $17=$2;label=6;break;}
 case 3: 
 var $10=$2;
 var $11=HEAP32[(($10)>>2)];
 var $12=(($11+36)|0);
 var $13=HEAP32[(($12)>>2)];
 var $14=FUNCTION_TABLE[$13]($2);
 var $15=($14|0)==-1;
 if($15){label=5;break;}else{label=4;break;}
 case 4: 
 var $_pre_i_i_i=HEAP32[(($1)>>2)];
 var $17=$_pre_i_i_i;label=6;break;
 case 5: 
 HEAP32[(($1)>>2)]=0;
 var $17=0;label=6;break;
 case 6: 
 var $17;
 var $18=($17|0)==0;
 var $19=(($__e)|0);
 var $20=HEAP32[(($19)>>2)];
 var $21=($20|0)==0;
 if($21){label=11;break;}else{label=7;break;}
 case 7: 
 var $23=(($20+12)|0);
 var $24=HEAP32[(($23)>>2)];
 var $25=(($20+16)|0);
 var $26=HEAP32[(($25)>>2)];
 var $27=($24|0)==($26|0);
 if($27){label=8;break;}else{label=10;break;}
 case 8: 
 var $28=$20;
 var $29=HEAP32[(($28)>>2)];
 var $30=(($29+36)|0);
 var $31=HEAP32[(($30)>>2)];
 var $32=FUNCTION_TABLE[$31]($20);
 var $33=($32|0)==-1;
 if($33){label=9;break;}else{label=10;break;}
 case 9: 
 HEAP32[(($19)>>2)]=0;
 label=11;break;
 case 10: 
 if($18){var $_pre_i3_i_i1318=$20;label=13;break;}else{label=12;break;}
 case 11: 
 if($18){label=12;break;}else{var $_pre_i3_i_i1318=0;label=13;break;}
 case 12: 
 var $36=HEAP32[(($__err)>>2)];
 var $37=$36|6;
 HEAP32[(($__err)>>2)]=$37;
 label=33;break;
 case 13: 
 var $_pre_i3_i_i1318;
 var $39=HEAP32[(($1)>>2)];
 var $40=(($39+12)|0);
 var $41=HEAP32[(($40)>>2)];
 var $42=(($39+16)|0);
 var $43=HEAP32[(($42)>>2)];
 var $44=($41|0)==($43|0);
 if($44){label=14;break;}else{label=15;break;}
 case 14: 
 var $46=$39;
 var $47=HEAP32[(($46)>>2)];
 var $48=(($47+36)|0);
 var $49=HEAP32[(($48)>>2)];
 var $50=FUNCTION_TABLE[$49]($39);
 var $extract_t_i=(($50)&255);
 var $_0_i_off0_i=$extract_t_i;label=16;break;
 case 15: 
 var $52=HEAP8[($41)];
 var $_0_i_off0_i=$52;label=16;break;
 case 16: 
 var $_0_i_off0_i;
 var $53=$__ct;
 var $54=HEAP32[(($53)>>2)];
 var $55=(($54+36)|0);
 var $56=HEAP32[(($55)>>2)];
 var $57=FUNCTION_TABLE[$56]($__ct,$_0_i_off0_i,0);
 var $58=(($57<<24)>>24)==37;
 if($58){label=18;break;}else{label=17;break;}
 case 17: 
 var $60=HEAP32[(($__err)>>2)];
 var $61=$60|4;
 HEAP32[(($__err)>>2)]=$61;
 label=33;break;
 case 18: 
 var $63=HEAP32[(($1)>>2)];
 var $64=(($63+12)|0);
 var $65=HEAP32[(($64)>>2)];
 var $66=(($63+16)|0);
 var $67=HEAP32[(($66)>>2)];
 var $68=($65|0)==($67|0);
 if($68){label=19;break;}else{label=20;break;}
 case 19: 
 var $70=$63;
 var $71=HEAP32[(($70)>>2)];
 var $72=(($71+40)|0);
 var $73=HEAP32[(($72)>>2)];
 var $74=FUNCTION_TABLE[$73]($63);
 label=21;break;
 case 20: 
 var $76=(($65+1)|0);
 HEAP32[(($64)>>2)]=$76;
 label=21;break;
 case 21: 
 var $77=HEAP32[(($1)>>2)];
 var $78=($77|0)==0;
 if($78){var $92=0;label=26;break;}else{label=22;break;}
 case 22: 
 var $80=(($77+12)|0);
 var $81=HEAP32[(($80)>>2)];
 var $82=(($77+16)|0);
 var $83=HEAP32[(($82)>>2)];
 var $84=($81|0)==($83|0);
 if($84){label=23;break;}else{var $92=$77;label=26;break;}
 case 23: 
 var $85=$77;
 var $86=HEAP32[(($85)>>2)];
 var $87=(($86+36)|0);
 var $88=HEAP32[(($87)>>2)];
 var $89=FUNCTION_TABLE[$88]($77);
 var $90=($89|0)==-1;
 if($90){label=25;break;}else{label=24;break;}
 case 24: 
 var $_pre_i_i_i9=HEAP32[(($1)>>2)];
 var $92=$_pre_i_i_i9;label=26;break;
 case 25: 
 HEAP32[(($1)>>2)]=0;
 var $92=0;label=26;break;
 case 26: 
 var $92;
 var $93=($92|0)==0;
 var $94=($_pre_i3_i_i1318|0)==0;
 if($94){label=31;break;}else{label=27;break;}
 case 27: 
 var $96=(($_pre_i3_i_i1318+12)|0);
 var $97=HEAP32[(($96)>>2)];
 var $98=(($_pre_i3_i_i1318+16)|0);
 var $99=HEAP32[(($98)>>2)];
 var $100=($97|0)==($99|0);
 if($100){label=28;break;}else{label=30;break;}
 case 28: 
 var $101=$_pre_i3_i_i1318;
 var $102=HEAP32[(($101)>>2)];
 var $103=(($102+36)|0);
 var $104=HEAP32[(($103)>>2)];
 var $105=FUNCTION_TABLE[$104]($_pre_i3_i_i1318);
 var $106=($105|0)==-1;
 if($106){label=29;break;}else{label=30;break;}
 case 29: 
 HEAP32[(($19)>>2)]=0;
 label=31;break;
 case 30: 
 if($93){label=33;break;}else{label=32;break;}
 case 31: 
 if($93){label=32;break;}else{label=33;break;}
 case 32: 
 var $109=HEAP32[(($__err)>>2)];
 var $110=$109|2;
 HEAP32[(($__err)>>2)]=$110;
 label=33;break;
 case 33: 
 STACKTOP=sp;return;
  default: assert(0, "bad label: " + label);
 }

}



function __ZNSt3__120__get_up_to_n_digitsIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi($__b,$__e,$__err,$__ct,$__n){
 var label=0;
 var sp=STACKTOP; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var tempParam = $__e; $__e=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=(($__b)|0);
 var $2=HEAP32[(($1)>>2)];
 var $3=($2|0)==0;
 if($3){var $17=0;label=6;break;}else{label=2;break;}
 case 2: 
 var $5=(($2+12)|0);
 var $6=HEAP32[(($5)>>2)];
 var $7=(($2+16)|0);
 var $8=HEAP32[(($7)>>2)];
 var $9=($6|0)==($8|0);
 if($9){label=3;break;}else{var $17=$2;label=6;break;}
 case 3: 
 var $10=$2;
 var $11=HEAP32[(($10)>>2)];
 var $12=(($11+36)|0);
 var $13=HEAP32[(($12)>>2)];
 var $14=FUNCTION_TABLE[$13]($2);
 var $15=($14|0)==-1;
 if($15){label=5;break;}else{label=4;break;}
 case 4: 
 var $_pre_i_i_i=HEAP32[(($1)>>2)];
 var $17=$_pre_i_i_i;label=6;break;
 case 5: 
 HEAP32[(($1)>>2)]=0;
 var $17=0;label=6;break;
 case 6: 
 var $17;
 var $18=($17|0)==0;
 var $19=(($__e)|0);
 var $20=HEAP32[(($19)>>2)];
 var $21=($20|0)==0;
 if($21){label=11;break;}else{label=7;break;}
 case 7: 
 var $23=(($20+12)|0);
 var $24=HEAP32[(($23)>>2)];
 var $25=(($20+16)|0);
 var $26=HEAP32[(($25)>>2)];
 var $27=($24|0)==($26|0);
 if($27){label=8;break;}else{label=10;break;}
 case 8: 
 var $28=$20;
 var $29=HEAP32[(($28)>>2)];
 var $30=(($29+36)|0);
 var $31=HEAP32[(($30)>>2)];
 var $32=FUNCTION_TABLE[$31]($20);
 var $33=($32|0)==-1;
 if($33){label=9;break;}else{label=10;break;}
 case 9: 
 HEAP32[(($19)>>2)]=0;
 label=11;break;
 case 10: 
 if($18){var $39=$20;label=13;break;}else{label=12;break;}
 case 11: 
 if($18){label=12;break;}else{var $39=0;label=13;break;}
 case 12: 
 var $36=HEAP32[(($__err)>>2)];
 var $37=$36|6;
 HEAP32[(($__err)>>2)]=$37;
 var $_021=0;label=52;break;
 case 13: 
 var $39;
 var $40=HEAP32[(($1)>>2)];
 var $41=(($40+12)|0);
 var $42=HEAP32[(($41)>>2)];
 var $43=(($40+16)|0);
 var $44=HEAP32[(($43)>>2)];
 var $45=($42|0)==($44|0);
 if($45){label=14;break;}else{label=15;break;}
 case 14: 
 var $47=$40;
 var $48=HEAP32[(($47)>>2)];
 var $49=(($48+36)|0);
 var $50=HEAP32[(($49)>>2)];
 var $51=FUNCTION_TABLE[$50]($40);
 var $extract_t_i=(($51)&255);
 var $_0_i_off0_i=$extract_t_i;label=16;break;
 case 15: 
 var $53=HEAP8[($42)];
 var $_0_i_off0_i=$53;label=16;break;
 case 16: 
 var $_0_i_off0_i;
 var $54=(($_0_i_off0_i<<24)>>24)<0;
 if($54){label=18;break;}else{label=17;break;}
 case 17: 
 var $55=(($_0_i_off0_i<<24)>>24);
 var $56=(($__ct+8)|0);
 var $57=HEAP32[(($56)>>2)];
 var $58=(($57+($55<<1))|0);
 var $59=HEAP16[(($58)>>1)];
 var $60=$59&2048;
 var $61=(($60<<16)>>16)==0;
 if($61){label=18;break;}else{label=19;break;}
 case 18: 
 var $62=HEAP32[(($__err)>>2)];
 var $63=$62|4;
 HEAP32[(($__err)>>2)]=$63;
 var $_021=0;label=52;break;
 case 19: 
 var $65=$__ct;
 var $66=HEAP32[(($65)>>2)];
 var $67=(($66+36)|0);
 var $68=HEAP32[(($67)>>2)];
 var $69=FUNCTION_TABLE[$68]($__ct,$_0_i_off0_i,0);
 var $70=(($69<<24)>>24);
 var $71=HEAP32[(($1)>>2)];
 var $72=(($71+12)|0);
 var $73=HEAP32[(($72)>>2)];
 var $74=(($71+16)|0);
 var $75=HEAP32[(($74)>>2)];
 var $76=($73|0)==($75|0);
 if($76){label=20;break;}else{label=21;break;}
 case 20: 
 var $78=$71;
 var $79=HEAP32[(($78)>>2)];
 var $80=(($79+40)|0);
 var $81=HEAP32[(($80)>>2)];
 var $82=FUNCTION_TABLE[$81]($71);
 var $__r_0_in=$70;var $_0_in=$__n;var $85=$39;var $_pre_i3_i_i27=$39;label=22;break;
 case 21: 
 var $84=(($73+1)|0);
 HEAP32[(($72)>>2)]=$84;
 var $__r_0_in=$70;var $_0_in=$__n;var $85=$39;var $_pre_i3_i_i27=$39;label=22;break;
 case 22: 
 var $_pre_i3_i_i27;
 var $85;
 var $_0_in;
 var $__r_0_in;
 var $__r_0=((($__r_0_in)-(48))|0);
 var $_0=((($_0_in)-(1))|0);
 var $86=HEAP32[(($1)>>2)];
 var $87=($86|0)==0;
 if($87){var $101=0;label=27;break;}else{label=23;break;}
 case 23: 
 var $89=(($86+12)|0);
 var $90=HEAP32[(($89)>>2)];
 var $91=(($86+16)|0);
 var $92=HEAP32[(($91)>>2)];
 var $93=($90|0)==($92|0);
 if($93){label=24;break;}else{var $101=$86;label=27;break;}
 case 24: 
 var $94=$86;
 var $95=HEAP32[(($94)>>2)];
 var $96=(($95+36)|0);
 var $97=HEAP32[(($96)>>2)];
 var $98=FUNCTION_TABLE[$97]($86);
 var $99=($98|0)==-1;
 if($99){label=26;break;}else{label=25;break;}
 case 25: 
 var $_pre_i_i_i23=HEAP32[(($1)>>2)];
 var $101=$_pre_i_i_i23;label=27;break;
 case 26: 
 HEAP32[(($1)>>2)]=0;
 var $101=0;label=27;break;
 case 27: 
 var $101;
 var $102=($101|0)==0;
 var $103=($85|0)==0;
 if($103){var $117=0;var $_pre_i3_i_i40=$_pre_i3_i_i27;label=31;break;}else{label=28;break;}
 case 28: 
 var $105=(($85+12)|0);
 var $106=HEAP32[(($105)>>2)];
 var $107=(($85+16)|0);
 var $108=HEAP32[(($107)>>2)];
 var $109=($106|0)==($108|0);
 if($109){label=29;break;}else{var $117=$85;var $_pre_i3_i_i40=$_pre_i3_i_i27;label=31;break;}
 case 29: 
 var $110=$85;
 var $111=HEAP32[(($110)>>2)];
 var $112=(($111+36)|0);
 var $113=HEAP32[(($112)>>2)];
 var $114=FUNCTION_TABLE[$113]($85);
 var $115=($114|0)==-1;
 if($115){label=30;break;}else{var $117=$_pre_i3_i_i27;var $_pre_i3_i_i40=$_pre_i3_i_i27;label=31;break;}
 case 30: 
 HEAP32[(($19)>>2)]=0;
 var $117=0;var $_pre_i3_i_i40=0;label=31;break;
 case 31: 
 var $_pre_i3_i_i40;
 var $117;
 var $118=($117|0)==0;
 var $tmp_i_i29=$102^$118;
 var $119=($_0|0)>0;
 var $_=$tmp_i_i29&$119;
 var $120=HEAP32[(($1)>>2)];
 if($_){label=32;break;}else{label=40;break;}
 case 32: 
 var $122=(($120+12)|0);
 var $123=HEAP32[(($122)>>2)];
 var $124=(($120+16)|0);
 var $125=HEAP32[(($124)>>2)];
 var $126=($123|0)==($125|0);
 if($126){label=33;break;}else{label=34;break;}
 case 33: 
 var $128=$120;
 var $129=HEAP32[(($128)>>2)];
 var $130=(($129+36)|0);
 var $131=HEAP32[(($130)>>2)];
 var $132=FUNCTION_TABLE[$131]($120);
 var $extract_t_i30=(($132)&255);
 var $_0_i_off0_i31=$extract_t_i30;label=35;break;
 case 34: 
 var $134=HEAP8[($123)];
 var $_0_i_off0_i31=$134;label=35;break;
 case 35: 
 var $_0_i_off0_i31;
 var $135=(($_0_i_off0_i31<<24)>>24)<0;
 if($135){var $_021=$__r_0;label=52;break;}else{label=36;break;}
 case 36: 
 var $136=(($_0_i_off0_i31<<24)>>24);
 var $137=HEAP32[(($56)>>2)];
 var $138=(($137+($136<<1))|0);
 var $139=HEAP16[(($138)>>1)];
 var $140=$139&2048;
 var $141=(($140<<16)>>16)==0;
 if($141){var $_021=$__r_0;label=52;break;}else{label=37;break;}
 case 37: 
 var $143=((($__r_0)*(10))&-1);
 var $144=HEAP32[(($65)>>2)];
 var $145=(($144+36)|0);
 var $146=HEAP32[(($145)>>2)];
 var $147=FUNCTION_TABLE[$146]($__ct,$_0_i_off0_i31,0);
 var $148=(($147<<24)>>24);
 var $149=((($148)+($143))|0);
 var $150=HEAP32[(($1)>>2)];
 var $151=(($150+12)|0);
 var $152=HEAP32[(($151)>>2)];
 var $153=(($150+16)|0);
 var $154=HEAP32[(($153)>>2)];
 var $155=($152|0)==($154|0);
 if($155){label=38;break;}else{label=39;break;}
 case 38: 
 var $157=$150;
 var $158=HEAP32[(($157)>>2)];
 var $159=(($158+40)|0);
 var $160=HEAP32[(($159)>>2)];
 var $161=FUNCTION_TABLE[$160]($150);
 var $__r_0_in=$149;var $_0_in=$_0;var $85=$117;var $_pre_i3_i_i27=$_pre_i3_i_i40;label=22;break;
 case 39: 
 var $163=(($152+1)|0);
 HEAP32[(($151)>>2)]=$163;
 var $__r_0_in=$149;var $_0_in=$_0;var $85=$117;var $_pre_i3_i_i27=$_pre_i3_i_i40;label=22;break;
 case 40: 
 var $165=($120|0)==0;
 if($165){var $179=0;label=45;break;}else{label=41;break;}
 case 41: 
 var $167=(($120+12)|0);
 var $168=HEAP32[(($167)>>2)];
 var $169=(($120+16)|0);
 var $170=HEAP32[(($169)>>2)];
 var $171=($168|0)==($170|0);
 if($171){label=42;break;}else{var $179=$120;label=45;break;}
 case 42: 
 var $172=$120;
 var $173=HEAP32[(($172)>>2)];
 var $174=(($173+36)|0);
 var $175=HEAP32[(($174)>>2)];
 var $176=FUNCTION_TABLE[$175]($120);
 var $177=($176|0)==-1;
 if($177){label=44;break;}else{label=43;break;}
 case 43: 
 var $_pre_i_i_i36=HEAP32[(($1)>>2)];
 var $179=$_pre_i_i_i36;label=45;break;
 case 44: 
 HEAP32[(($1)>>2)]=0;
 var $179=0;label=45;break;
 case 45: 
 var $179;
 var $180=($179|0)==0;
 var $181=($_pre_i3_i_i40|0)==0;
 if($181){label=50;break;}else{label=46;break;}
 case 46: 
 var $183=(($_pre_i3_i_i40+12)|0);
 var $184=HEAP32[(($183)>>2)];
 var $185=(($_pre_i3_i_i40+16)|0);
 var $186=HEAP32[(($185)>>2)];
 var $187=($184|0)==($186|0);
 if($187){label=47;break;}else{label=49;break;}
 case 47: 
 var $188=$_pre_i3_i_i40;
 var $189=HEAP32[(($188)>>2)];
 var $190=(($189+36)|0);
 var $191=HEAP32[(($190)>>2)];
 var $192=FUNCTION_TABLE[$191]($_pre_i3_i_i40);
 var $193=($192|0)==-1;
 if($193){label=48;break;}else{label=49;break;}
 case 48: 
 HEAP32[(($19)>>2)]=0;
 label=50;break;
 case 49: 
 if($180){var $_021=$__r_0;label=52;break;}else{label=51;break;}
 case 50: 
 if($180){label=51;break;}else{var $_021=$__r_0;label=52;break;}
 case 51: 
 var $196=HEAP32[(($__err)>>2)];
 var $197=$196|2;
 HEAP32[(($__err)>>2)]=$197;
 var $_021=$__r_0;label=52;break;
 case 52: 
 var $_021;
 STACKTOP=sp;return $_021;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3getES4_S4_RNS_8ios_baseERjP2tmPKwSC_($agg_result,$this,$__b,$__e,$__iob,$__err,$__tm,$__fmtb,$__fmte){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+48)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var tempParam = $__b; $__b=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__b)>>2)]=HEAP32[((tempParam)>>2)];
 var tempParam = $__e; $__e=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $__p_i_i_i_i=sp;
 var $1=(sp)+(16);
 var $2=(sp)+(24);
 var $3=(sp)+(32);
 var $4=(sp)+(40);
 __ZNKSt3__18ios_base6getlocEv($1,$__iob);
 var $5=(($1)|0);
 var $6=HEAP32[(($5)>>2)];
 var $7=$__p_i_i_i_i;
 var $8=HEAP32[((14088)>>2)];
 var $9=($8|0)==-1;
 if($9){label=3;break;}else{label=2;break;}
 case 2: 
 var $_sroa_01_0___p67_i_idx_i_i_i=(($__p_i_i_i_i)|0);
 HEAP32[(($_sroa_01_0___p67_i_idx_i_i_i)>>2)]=14088;
 var $_sroa_12_4___p67_i_idx3_i_i_i=(($__p_i_i_i_i+4)|0);
 HEAP32[(($_sroa_12_4___p67_i_idx3_i_i_i)>>2)]=(28);
 var $_sroa_2_8___p67_i_idx4_i_i_i=(($__p_i_i_i_i+8)|0);
 HEAP32[(($_sroa_2_8___p67_i_idx4_i_i_i)>>2)]=0;
 (function() { try { __THREW__ = 0; return __ZNSt3__111__call_onceERVmPvPFvS2_E(14088,$7,260) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=3;break; } else { label=26;break; }
 case 3: 
 var $11=HEAP32[((14092)>>2)];
 var $12=((($11)-(1))|0);
 var $13=(($6+12)|0);
 var $14=HEAP32[(($13)>>2)];
 var $15=(($6+8)|0);
 var $16=HEAP32[(($15)>>2)];
 var $17=$14;
 var $18=$16;
 var $19=((($17)-($18))|0);
 var $20=$19>>2;
 var $21=($20>>>0)>($12>>>0);
 if($21){label=4;break;}else{label=5;break;}
 case 4: 
 var $22=(($16+($12<<2))|0);
 var $23=HEAP32[(($22)>>2)];
 var $24=($23|0)==0;
 if($24){label=5;break;}else{label=7;break;}
 case 5: 
 var $25=___cxa_allocate_exception(4);
 var $26=$25;
 __ZNSt8bad_castC2Ev($26);
 (function() { try { __THREW__ = 0; return ___cxa_throw($25,8960,(368)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=6;break; } else { label=26;break; }
 case 6: 
 throw "Reached an unreachable!";
 case 7: 
 var $28=$23;
 var $29=HEAP32[(($5)>>2)];
 var $30=(($29)|0);
 var $31=__ZNSt3__114__shared_count16__release_sharedEv($30);
 HEAP32[(($__err)>>2)]=0;
 var $32=($__fmtb|0)==($__fmte|0);
 var $_phi_trans_insert_pre_pre=(($__b)|0);
 if($32){label=71;break;}else{label=8;break;}
 case 8: 
 var $33=(($__e)|0);
 var $34=$23;
 var $35=$23;
 var $36=$23;
 var $37=$this;
 var $38=(($3)|0);
 var $39=(($4)|0);
 var $40=(($2)|0);
 var $_0_ph84=$__fmtb;var $_pre85=0;label=9;break;
 case 9: 
 var $_pre85;
 var $_0_ph84;
 var $42=$_pre85;label=10;break;
 case 10: 
 var $42;
 var $43=($42|0)==0;
 if($43){label=11;break;}else{label=71;break;}
 case 11: 
 var $45=HEAP32[(($_phi_trans_insert_pre_pre)>>2)];
 var $46=($45|0)==0;
 if($46){var $64=1;var $63=0;label=17;break;}else{label=12;break;}
 case 12: 
 var $48=(($45+12)|0);
 var $49=HEAP32[(($48)>>2)];
 var $50=(($45+16)|0);
 var $51=HEAP32[(($50)>>2)];
 var $52=($49|0)==($51|0);
 if($52){label=13;break;}else{label=14;break;}
 case 13: 
 var $54=$45;
 var $55=HEAP32[(($54)>>2)];
 var $56=(($55+36)|0);
 var $57=HEAP32[(($56)>>2)];
 var $58=FUNCTION_TABLE[$57]($45);
 var $_0_i_i_i_i=$58;label=15;break;
 case 14: 
 var $60=HEAP32[(($49)>>2)];
 var $_0_i_i_i_i=$60;label=15;break;
 case 15: 
 var $_0_i_i_i_i;
 var $61=($_0_i_i_i_i|0)==-1;
 if($61){label=16;break;}else{var $64=0;var $63=$45;label=17;break;}
 case 16: 
 HEAP32[(($_phi_trans_insert_pre_pre)>>2)]=0;
 var $64=1;var $63=0;label=17;break;
 case 17: 
 var $63;
 var $64;
 var $65=HEAP32[(($33)>>2)];
 var $66=($65|0)==0;
 if($66){label=23;break;}else{label=18;break;}
 case 18: 
 var $68=(($65+12)|0);
 var $69=HEAP32[(($68)>>2)];
 var $70=(($65+16)|0);
 var $71=HEAP32[(($70)>>2)];
 var $72=($69|0)==($71|0);
 if($72){label=19;break;}else{label=20;break;}
 case 19: 
 var $74=$65;
 var $75=HEAP32[(($74)>>2)];
 var $76=(($75+36)|0);
 var $77=HEAP32[(($76)>>2)];
 var $78=FUNCTION_TABLE[$77]($65);
 var $_0_i_i2_i_i=$78;label=21;break;
 case 20: 
 var $80=HEAP32[(($69)>>2)];
 var $_0_i_i2_i_i=$80;label=21;break;
 case 21: 
 var $_0_i_i2_i_i;
 var $81=($_0_i_i2_i_i|0)==-1;
 if($81){label=22;break;}else{label=24;break;}
 case 22: 
 HEAP32[(($33)>>2)]=0;
 label=23;break;
 case 23: 
 if($64){label=25;break;}else{var $90=0;label=27;break;}
 case 24: 
 if($64){var $90=$65;label=27;break;}else{label=25;break;}
 case 25: 
 HEAP32[(($__err)>>2)]=4;
 var $_pre_i_i_i62=$63;label=72;break;
 case 26: 
 var $85$0 = ___cxa_find_matching_catch(-1, -1); var $85$1 = tempRet0;
 var $86=HEAP32[(($5)>>2)];
 var $87=(($86)|0);
 var $88=__ZNSt3__114__shared_count16__release_sharedEv($87);
 ___resumeException($85$0)
 case 27: 
 var $90;
 var $91=HEAP32[(($_0_ph84)>>2)];
 var $92=HEAP32[(($34)>>2)];
 var $93=(($92+52)|0);
 var $94=HEAP32[(($93)>>2)];
 var $95=FUNCTION_TABLE[$94]($28,$91,0);
 var $96=(($95<<24)>>24)==37;
 if($96){label=28;break;}else{label=37;break;}
 case 28: 
 var $98=(($_0_ph84+4)|0);
 var $99=($98|0)==($__fmte|0);
 if($99){label=29;break;}else{label=30;break;}
 case 29: 
 HEAP32[(($__err)>>2)]=4;
 var $_pre_i_i_i62=$63;label=72;break;
 case 30: 
 var $102=HEAP32[(($98)>>2)];
 var $103=HEAP32[(($34)>>2)];
 var $104=(($103+52)|0);
 var $105=HEAP32[(($104)>>2)];
 var $106=FUNCTION_TABLE[$105]($28,$102,0);
 if((($106<<24)>>24)==69|(($106<<24)>>24)==48){ label=31;break;}else{var $__opt_0=0;var $__cmd_0=$106;var $_1=$98;label=34;break;}
 case 31: 
 var $108=(($_0_ph84+8)|0);
 var $109=($108|0)==($__fmte|0);
 if($109){label=32;break;}else{label=33;break;}
 case 32: 
 HEAP32[(($__err)>>2)]=4;
 var $_pre_i_i_i62=$63;label=72;break;
 case 33: 
 var $112=HEAP32[(($108)>>2)];
 var $113=HEAP32[(($34)>>2)];
 var $114=(($113+52)|0);
 var $115=HEAP32[(($114)>>2)];
 var $116=FUNCTION_TABLE[$115]($28,$112,0);
 var $__opt_0=$106;var $__cmd_0=$116;var $_1=$108;label=34;break;
 case 34: 
 var $_1;
 var $__cmd_0;
 var $__opt_0;
 var $118=HEAP32[(($37)>>2)];
 var $119=(($118+36)|0);
 var $120=HEAP32[(($119)>>2)];
 HEAP32[(($38)>>2)]=$63;
 HEAP32[(($39)>>2)]=$90;
 FUNCTION_TABLE[$120]($2,$this,$3,$4,$__iob,$__err,$__tm,$__cmd_0,$__opt_0);
 var $121=HEAP32[(($40)>>2)];
 HEAP32[(($_phi_trans_insert_pre_pre)>>2)]=$121;
 var $122=(($_1+4)|0);
 var $_0_ph_be=$122;label=35;break;
 case 35: 
 var $_0_ph_be;
 var $123=($_0_ph_be|0)==($__fmte|0);
 if($123){label=71;break;}else{label=36;break;}
 case 36: 
 var $_pre85_pre=HEAP32[(($__err)>>2)];
 var $_0_ph84=$_0_ph_be;var $_pre85=$_pre85_pre;label=9;break;
 case 37: 
 var $125=HEAP32[(($_0_ph84)>>2)];
 var $126=HEAP32[(($35)>>2)];
 var $127=(($126+12)|0);
 var $128=HEAP32[(($127)>>2)];
 var $129=FUNCTION_TABLE[$128]($28,8192,$125);
 if($129){var $_0_pn=$_0_ph84;label=38;break;}else{label=62;break;}
 case 38: 
 var $_0_pn;
 var $_2=(($_0_pn+4)|0);
 var $130=($_2|0)==($__fmte|0);
 if($130){var $_2_lcssa=$__fmte;label=40;break;}else{label=39;break;}
 case 39: 
 var $132=HEAP32[(($_2)>>2)];
 var $133=HEAP32[(($35)>>2)];
 var $134=(($133+12)|0);
 var $135=HEAP32[(($134)>>2)];
 var $136=FUNCTION_TABLE[$135]($28,8192,$132);
 if($136){var $_0_pn=$_2;label=38;break;}else{var $_2_lcssa=$_2;label=40;break;}
 case 40: 
 var $_2_lcssa;
 var $_pre_i_i_i47=$63;var $137=$90;var $_pre_i4_i_i53=$90;label=41;break;
 case 41: 
 var $_pre_i4_i_i53;
 var $137;
 var $_pre_i_i_i47;
 var $138=($_pre_i_i_i47|0)==0;
 if($138){var $156=1;var $155=0;label=47;break;}else{label=42;break;}
 case 42: 
 var $140=(($_pre_i_i_i47+12)|0);
 var $141=HEAP32[(($140)>>2)];
 var $142=(($_pre_i_i_i47+16)|0);
 var $143=HEAP32[(($142)>>2)];
 var $144=($141|0)==($143|0);
 if($144){label=43;break;}else{label=44;break;}
 case 43: 
 var $146=$_pre_i_i_i47;
 var $147=HEAP32[(($146)>>2)];
 var $148=(($147+36)|0);
 var $149=HEAP32[(($148)>>2)];
 var $150=FUNCTION_TABLE[$149]($_pre_i_i_i47);
 var $_0_i_i_i_i45=$150;label=45;break;
 case 44: 
 var $152=HEAP32[(($141)>>2)];
 var $_0_i_i_i_i45=$152;label=45;break;
 case 45: 
 var $_0_i_i_i_i45;
 var $153=($_0_i_i_i_i45|0)==-1;
 if($153){label=46;break;}else{var $156=0;var $155=$_pre_i_i_i47;label=47;break;}
 case 46: 
 HEAP32[(($_phi_trans_insert_pre_pre)>>2)]=0;
 var $156=1;var $155=0;label=47;break;
 case 47: 
 var $155;
 var $156;
 var $157=($137|0)==0;
 if($157){var $_pre_i4_i_i5387=$_pre_i4_i_i53;label=53;break;}else{label=48;break;}
 case 48: 
 var $159=(($137+12)|0);
 var $160=HEAP32[(($159)>>2)];
 var $161=(($137+16)|0);
 var $162=HEAP32[(($161)>>2)];
 var $163=($160|0)==($162|0);
 if($163){label=49;break;}else{label=50;break;}
 case 49: 
 var $165=$137;
 var $166=HEAP32[(($165)>>2)];
 var $167=(($166+36)|0);
 var $168=HEAP32[(($167)>>2)];
 var $169=FUNCTION_TABLE[$168]($137);
 var $_0_i_i2_i_i51=$169;label=51;break;
 case 50: 
 var $171=HEAP32[(($160)>>2)];
 var $_0_i_i2_i_i51=$171;label=51;break;
 case 51: 
 var $_0_i_i2_i_i51;
 var $172=($_0_i_i2_i_i51|0)==-1;
 if($172){label=52;break;}else{label=54;break;}
 case 52: 
 HEAP32[(($33)>>2)]=0;
 var $_pre_i4_i_i5387=0;label=53;break;
 case 53: 
 var $_pre_i4_i_i5387;
 if($156){var $_0_ph_be=$_2_lcssa;label=35;break;}else{var $174=0;var $_pre_i4_i_i5386=$_pre_i4_i_i5387;label=55;break;}
 case 54: 
 var $phitmp_i5_i_i54=($_pre_i4_i_i53|0)==0;
 var $tmp_i_i56=$156^$phitmp_i5_i_i54;
 if($tmp_i_i56){var $174=$_pre_i4_i_i53;var $_pre_i4_i_i5386=$_pre_i4_i_i53;label=55;break;}else{var $_0_ph_be=$_2_lcssa;label=35;break;}
 case 55: 
 var $_pre_i4_i_i5386;
 var $174;
 var $175=(($155+12)|0);
 var $176=HEAP32[(($175)>>2)];
 var $177=(($155+16)|0);
 var $178=HEAP32[(($177)>>2)];
 var $179=($176|0)==($178|0);
 if($179){label=56;break;}else{label=57;break;}
 case 56: 
 var $181=$155;
 var $182=HEAP32[(($181)>>2)];
 var $183=(($182+36)|0);
 var $184=HEAP32[(($183)>>2)];
 var $185=FUNCTION_TABLE[$184]($155);
 var $_0_i_i=$185;label=58;break;
 case 57: 
 var $187=HEAP32[(($176)>>2)];
 var $_0_i_i=$187;label=58;break;
 case 58: 
 var $_0_i_i;
 var $188=HEAP32[(($35)>>2)];
 var $189=(($188+12)|0);
 var $190=HEAP32[(($189)>>2)];
 var $191=FUNCTION_TABLE[$190]($28,8192,$_0_i_i);
 if($191){label=59;break;}else{var $_0_ph_be=$_2_lcssa;label=35;break;}
 case 59: 
 var $193=HEAP32[(($175)>>2)];
 var $194=HEAP32[(($177)>>2)];
 var $195=($193|0)==($194|0);
 if($195){label=60;break;}else{label=61;break;}
 case 60: 
 var $197=$155;
 var $198=HEAP32[(($197)>>2)];
 var $199=(($198+40)|0);
 var $200=HEAP32[(($199)>>2)];
 var $201=FUNCTION_TABLE[$200]($155);
 var $_pre_i_i_i47=$155;var $137=$174;var $_pre_i4_i_i53=$_pre_i4_i_i5386;label=41;break;
 case 61: 
 var $203=(($193+4)|0);
 HEAP32[(($175)>>2)]=$203;
 var $_pre_i_i_i47=$155;var $137=$174;var $_pre_i4_i_i53=$_pre_i4_i_i5386;label=41;break;
 case 62: 
 var $205=(($63+12)|0);
 var $206=HEAP32[(($205)>>2)];
 var $207=(($63+16)|0);
 var $208=HEAP32[(($207)>>2)];
 var $209=($206|0)==($208|0);
 if($209){label=63;break;}else{label=64;break;}
 case 63: 
 var $211=$63;
 var $212=HEAP32[(($211)>>2)];
 var $213=(($212+36)|0);
 var $214=HEAP32[(($213)>>2)];
 var $215=FUNCTION_TABLE[$214]($63);
 var $_0_i_i57=$215;label=65;break;
 case 64: 
 var $217=HEAP32[(($206)>>2)];
 var $_0_i_i57=$217;label=65;break;
 case 65: 
 var $_0_i_i57;
 var $218=HEAP32[(($36)>>2)];
 var $219=(($218+28)|0);
 var $220=HEAP32[(($219)>>2)];
 var $221=FUNCTION_TABLE[$220]($28,$_0_i_i57);
 var $222=HEAP32[(($_0_ph84)>>2)];
 var $223=HEAP32[(($36)>>2)];
 var $224=(($223+28)|0);
 var $225=HEAP32[(($224)>>2)];
 var $226=FUNCTION_TABLE[$225]($28,$222);
 var $227=($221|0)==($226|0);
 if($227){label=66;break;}else{label=70;break;}
 case 66: 
 var $229=HEAP32[(($205)>>2)];
 var $230=HEAP32[(($207)>>2)];
 var $231=($229|0)==($230|0);
 if($231){label=67;break;}else{label=68;break;}
 case 67: 
 var $233=$63;
 var $234=HEAP32[(($233)>>2)];
 var $235=(($234+40)|0);
 var $236=HEAP32[(($235)>>2)];
 var $237=FUNCTION_TABLE[$236]($63);
 label=69;break;
 case 68: 
 var $239=(($229+4)|0);
 HEAP32[(($205)>>2)]=$239;
 label=69;break;
 case 69: 
 var $240=(($_0_ph84+4)|0);
 var $_0_ph_be=$240;label=35;break;
 case 70: 
 HEAP32[(($__err)>>2)]=4;
 var $42=4;label=10;break;
 case 71: 
 var $_pre=HEAP32[(($_phi_trans_insert_pre_pre)>>2)];
 var $_pre_i_i_i62=$_pre;label=72;break;
 case 72: 
 var $_pre_i_i_i62;
 var $241=(($__b)|0);
 var $242=($_pre_i_i_i62|0)==0;
 if($242){var $260=1;var $259=0;label=78;break;}else{label=73;break;}
 case 73: 
 var $244=(($_pre_i_i_i62+12)|0);
 var $245=HEAP32[(($244)>>2)];
 var $246=(($_pre_i_i_i62+16)|0);
 var $247=HEAP32[(($246)>>2)];
 var $248=($245|0)==($247|0);
 if($248){label=74;break;}else{label=75;break;}
 case 74: 
 var $250=$_pre_i_i_i62;
 var $251=HEAP32[(($250)>>2)];
 var $252=(($251+36)|0);
 var $253=HEAP32[(($252)>>2)];
 var $254=FUNCTION_TABLE[$253]($_pre_i_i_i62);
 var $_0_i_i_i_i60=$254;label=76;break;
 case 75: 
 var $256=HEAP32[(($245)>>2)];
 var $_0_i_i_i_i60=$256;label=76;break;
 case 76: 
 var $_0_i_i_i_i60;
 var $257=($_0_i_i_i_i60|0)==-1;
 if($257){label=77;break;}else{var $260=0;var $259=$_pre_i_i_i62;label=78;break;}
 case 77: 
 HEAP32[(($241)>>2)]=0;
 var $260=1;var $259=0;label=78;break;
 case 78: 
 var $259;
 var $260;
 var $261=(($__e)|0);
 var $262=HEAP32[(($261)>>2)];
 var $263=($262|0)==0;
 if($263){label=84;break;}else{label=79;break;}
 case 79: 
 var $265=(($262+12)|0);
 var $266=HEAP32[(($265)>>2)];
 var $267=(($262+16)|0);
 var $268=HEAP32[(($267)>>2)];
 var $269=($266|0)==($268|0);
 if($269){label=80;break;}else{label=81;break;}
 case 80: 
 var $271=$262;
 var $272=HEAP32[(($271)>>2)];
 var $273=(($272+36)|0);
 var $274=HEAP32[(($273)>>2)];
 var $275=FUNCTION_TABLE[$274]($262);
 var $_0_i_i2_i_i66=$275;label=82;break;
 case 81: 
 var $277=HEAP32[(($266)>>2)];
 var $_0_i_i2_i_i66=$277;label=82;break;
 case 82: 
 var $_0_i_i2_i_i66;
 var $278=($_0_i_i2_i_i66|0)==-1;
 if($278){label=83;break;}else{label=85;break;}
 case 83: 
 HEAP32[(($261)>>2)]=0;
 label=84;break;
 case 84: 
 if($260){label=86;break;}else{label=87;break;}
 case 85: 
 if($260){label=87;break;}else{label=86;break;}
 case 86: 
 var $281=HEAP32[(($__err)>>2)];
 var $282=$281|2;
 HEAP32[(($__err)>>2)]=$282;
 label=87;break;
 case 87: 
 var $284=(($agg_result)|0);
 HEAP32[(($284)>>2)]=$259;
 STACKTOP=sp;return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEED0Ev($this){
 var label=0;


 var $1=(($this)|0);
 __ZNSt3__114__shared_countD2Ev($1);
 var $2=$this;
 __ZdlPv($2);
 return;
}


function __ZNSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEED1Ev($this){
 var label=0;


 var $1=(($this)|0);
 __ZNSt3__114__shared_countD2Ev($1);
 return;
}


function __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE13do_date_orderEv($this){
 var label=0;


 return 2;
}


function __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE11do_get_timeES4_S4_RNS_8ios_baseERjP2tm($agg_result,$this,$__b,$__e,$__iob,$__err,$__tm){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+16)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var tempParam = $__b; $__b=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__b)>>2)]=HEAP32[((tempParam)>>2)];
 var tempParam = $__e; $__e=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];

 var $1=sp;
 var $2=(sp)+(8);
 var $3=(($__b)|0);
 var $4=HEAP32[(($3)>>2)];
 var $5=(($1)|0);
 HEAP32[(($5)>>2)]=$4;
 var $6=(($__e)|0);
 var $7=HEAP32[(($6)>>2)];
 var $8=(($2)|0);
 HEAP32[(($8)>>2)]=$7;
 __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3getES4_S4_RNS_8ios_baseERjP2tmPKwSC_($agg_result,$this,$1,$2,$__iob,$__err,$__tm,2816,2848);
 STACKTOP=sp;return;
}


function __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE11do_get_dateES4_S4_RNS_8ios_baseERjP2tm($agg_result,$this,$__b,$__e,$__iob,$__err,$__tm){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+16)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var tempParam = $__b; $__b=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__b)>>2)]=HEAP32[((tempParam)>>2)];
 var tempParam = $__e; $__e=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=sp;
 var $2=(sp)+(8);
 var $3=(($this+8)|0);
 var $4=$3;
 var $5=HEAP32[(($4)>>2)];
 var $6=(($5+20)|0);
 var $7=HEAP32[(($6)>>2)];
 var $8=FUNCTION_TABLE[$7]($3);
 var $9=(($__b)|0);
 var $10=HEAP32[(($9)>>2)];
 var $11=(($1)|0);
 HEAP32[(($11)>>2)]=$10;
 var $12=(($__e)|0);
 var $13=HEAP32[(($12)>>2)];
 var $14=(($2)|0);
 HEAP32[(($14)>>2)]=$13;
 var $15=$8;
 var $16=HEAP8[($15)];
 var $17=$16&1;
 var $18=(($17<<24)>>24)==0;
 if($18){label=3;break;}else{label=2;break;}
 case 2: 
 var $20=(($8+8)|0);
 var $21=HEAP32[(($20)>>2)];
 var $22=(($8+4)|0);
 var $23=HEAP32[(($22)>>2)];
 var $31=$23;var $30=$21;var $29=$21;label=4;break;
 case 3: 
 var $25=(($8+4)|0);
 var $26=(($8+4)|0);
 var $27=($16&255);
 var $28=$27>>>1;
 var $31=$28;var $30=$25;var $29=$26;label=4;break;
 case 4: 
 var $29;
 var $30;
 var $31;
 var $32=(($29+($31<<2))|0);
 __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3getES4_S4_RNS_8ios_baseERjP2tmPKwSC_($agg_result,$this,$1,$2,$__iob,$__err,$__tm,$30,$32);
 STACKTOP=sp;return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE14do_get_weekdayES4_S4_RNS_8ios_baseERjP2tm($agg_result,$this,$__b,$__e,$__iob,$__err,$__tm){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+32)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var tempParam = $__b; $__b=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__b)>>2)]=HEAP32[((tempParam)>>2)];
 var tempParam = $__e; $__e=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=sp;
 var $__p_i_i_i_i=(sp)+(8);
 var $2=(sp)+(24);
 __ZNKSt3__18ios_base6getlocEv($2,$__iob);
 var $3=(($2)|0);
 var $4=HEAP32[(($3)>>2)];
 var $5=$__p_i_i_i_i;
 var $6=HEAP32[((14088)>>2)];
 var $7=($6|0)==-1;
 if($7){label=3;break;}else{label=2;break;}
 case 2: 
 var $_sroa_01_0___p67_i_idx_i_i_i=(($__p_i_i_i_i)|0);
 HEAP32[(($_sroa_01_0___p67_i_idx_i_i_i)>>2)]=14088;
 var $_sroa_12_4___p67_i_idx3_i_i_i=(($__p_i_i_i_i+4)|0);
 HEAP32[(($_sroa_12_4___p67_i_idx3_i_i_i)>>2)]=(28);
 var $_sroa_2_8___p67_i_idx4_i_i_i=(($__p_i_i_i_i+8)|0);
 HEAP32[(($_sroa_2_8___p67_i_idx4_i_i_i)>>2)]=0;
 (function() { try { __THREW__ = 0; return __ZNSt3__111__call_onceERVmPvPFvS2_E(14088,$5,260) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=3;break; } else { label=10;break; }
 case 3: 
 var $9=HEAP32[((14092)>>2)];
 var $10=((($9)-(1))|0);
 var $11=(($4+12)|0);
 var $12=HEAP32[(($11)>>2)];
 var $13=(($4+8)|0);
 var $14=HEAP32[(($13)>>2)];
 var $15=$12;
 var $16=$14;
 var $17=((($15)-($16))|0);
 var $18=$17>>2;
 var $19=($18>>>0)>($10>>>0);
 if($19){label=4;break;}else{label=5;break;}
 case 4: 
 var $20=(($14+($10<<2))|0);
 var $21=HEAP32[(($20)>>2)];
 var $22=($21|0)==0;
 if($22){label=5;break;}else{label=7;break;}
 case 5: 
 var $23=___cxa_allocate_exception(4);
 var $24=$23;
 __ZNSt8bad_castC2Ev($24);
 (function() { try { __THREW__ = 0; return ___cxa_throw($23,8960,(368)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=6;break; } else { label=10;break; }
 case 6: 
 throw "Reached an unreachable!";
 case 7: 
 var $26=$21;
 var $27=HEAP32[(($3)>>2)];
 var $28=(($27)|0);
 var $29=__ZNSt3__114__shared_count16__release_sharedEv($28);
 var $30=(($__e)|0);
 var $31=HEAP32[(($30)>>2)];
 var $32=$1;
 var $33=(($this+8)|0);
 var $34=$33;
 var $35=HEAP32[(($34)>>2)];
 var $36=HEAP32[(($35)>>2)];
 var $37=FUNCTION_TABLE[$36]($33);
 var $38=(($1)|0);
 HEAP32[(($38)>>2)]=$31;
 var $39=(($37+168)|0);
 var $40=__ZNSt3__114__scan_keywordINS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEPKNS_12basic_stringIwS3_NS_9allocatorIwEEEENS_5ctypeIwEEEET0_RT_SE_SD_SD_RKT1_Rjb($__b,$1,$37,$39,$26,$__err,0);
 var $41=$40;
 var $42=$37;
 var $43=((($41)-($42))|0);
 var $44=($43|0)<168;
 if($44){label=8;break;}else{label=9;break;}
 case 8: 
 var $46=(($__tm+24)|0);
 var $47=(((($43|0))/(12))&-1);
 var $48=(((($47|0))%(7))&-1);
 HEAP32[(($46)>>2)]=$48;
 label=9;break;
 case 9: 
 var $49=(($__b)|0);
 var $50=HEAP32[(($49)>>2)];
 var $51=(($agg_result)|0);
 HEAP32[(($51)>>2)]=$50;
 STACKTOP=sp;return;
 case 10: 
 var $53$0 = ___cxa_find_matching_catch(-1, -1); var $53$1 = tempRet0;
 var $54=HEAP32[(($3)>>2)];
 var $55=(($54)|0);
 var $56=__ZNSt3__114__shared_count16__release_sharedEv($55);
 ___resumeException($53$0)
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE16do_get_monthnameES4_S4_RNS_8ios_baseERjP2tm($agg_result,$this,$__b,$__e,$__iob,$__err,$__tm){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+32)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var tempParam = $__b; $__b=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__b)>>2)]=HEAP32[((tempParam)>>2)];
 var tempParam = $__e; $__e=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=sp;
 var $__p_i_i_i_i=(sp)+(8);
 var $2=(sp)+(24);
 __ZNKSt3__18ios_base6getlocEv($2,$__iob);
 var $3=(($2)|0);
 var $4=HEAP32[(($3)>>2)];
 var $5=$__p_i_i_i_i;
 var $6=HEAP32[((14088)>>2)];
 var $7=($6|0)==-1;
 if($7){label=3;break;}else{label=2;break;}
 case 2: 
 var $_sroa_01_0___p67_i_idx_i_i_i=(($__p_i_i_i_i)|0);
 HEAP32[(($_sroa_01_0___p67_i_idx_i_i_i)>>2)]=14088;
 var $_sroa_12_4___p67_i_idx3_i_i_i=(($__p_i_i_i_i+4)|0);
 HEAP32[(($_sroa_12_4___p67_i_idx3_i_i_i)>>2)]=(28);
 var $_sroa_2_8___p67_i_idx4_i_i_i=(($__p_i_i_i_i+8)|0);
 HEAP32[(($_sroa_2_8___p67_i_idx4_i_i_i)>>2)]=0;
 (function() { try { __THREW__ = 0; return __ZNSt3__111__call_onceERVmPvPFvS2_E(14088,$5,260) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=3;break; } else { label=10;break; }
 case 3: 
 var $9=HEAP32[((14092)>>2)];
 var $10=((($9)-(1))|0);
 var $11=(($4+12)|0);
 var $12=HEAP32[(($11)>>2)];
 var $13=(($4+8)|0);
 var $14=HEAP32[(($13)>>2)];
 var $15=$12;
 var $16=$14;
 var $17=((($15)-($16))|0);
 var $18=$17>>2;
 var $19=($18>>>0)>($10>>>0);
 if($19){label=4;break;}else{label=5;break;}
 case 4: 
 var $20=(($14+($10<<2))|0);
 var $21=HEAP32[(($20)>>2)];
 var $22=($21|0)==0;
 if($22){label=5;break;}else{label=7;break;}
 case 5: 
 var $23=___cxa_allocate_exception(4);
 var $24=$23;
 __ZNSt8bad_castC2Ev($24);
 (function() { try { __THREW__ = 0; return ___cxa_throw($23,8960,(368)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=6;break; } else { label=10;break; }
 case 6: 
 throw "Reached an unreachable!";
 case 7: 
 var $26=$21;
 var $27=HEAP32[(($3)>>2)];
 var $28=(($27)|0);
 var $29=__ZNSt3__114__shared_count16__release_sharedEv($28);
 var $30=(($__e)|0);
 var $31=HEAP32[(($30)>>2)];
 var $32=$1;
 var $33=(($this+8)|0);
 var $34=$33;
 var $35=HEAP32[(($34)>>2)];
 var $36=(($35+4)|0);
 var $37=HEAP32[(($36)>>2)];
 var $38=FUNCTION_TABLE[$37]($33);
 var $39=(($1)|0);
 HEAP32[(($39)>>2)]=$31;
 var $40=(($38+288)|0);
 var $41=__ZNSt3__114__scan_keywordINS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEPKNS_12basic_stringIwS3_NS_9allocatorIwEEEENS_5ctypeIwEEEET0_RT_SE_SD_SD_RKT1_Rjb($__b,$1,$38,$40,$26,$__err,0);
 var $42=$41;
 var $43=$38;
 var $44=((($42)-($43))|0);
 var $45=($44|0)<288;
 if($45){label=8;break;}else{label=9;break;}
 case 8: 
 var $47=(($__tm+16)|0);
 var $48=(((($44|0))/(12))&-1);
 var $49=(((($48|0))%(12))&-1);
 HEAP32[(($47)>>2)]=$49;
 label=9;break;
 case 9: 
 var $50=(($__b)|0);
 var $51=HEAP32[(($50)>>2)];
 var $52=(($agg_result)|0);
 HEAP32[(($52)>>2)]=$51;
 STACKTOP=sp;return;
 case 10: 
 var $54$0 = ___cxa_find_matching_catch(-1, -1); var $54$1 = tempRet0;
 var $55=HEAP32[(($3)>>2)];
 var $56=(($55)|0);
 var $57=__ZNSt3__114__shared_count16__release_sharedEv($56);
 ___resumeException($54$0)
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE11do_get_yearES4_S4_RNS_8ios_baseERjP2tm($agg_result,$this,$__b,$__e,$__iob,$__err,$__tm){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+32)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var tempParam = $__b; $__b=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__b)>>2)]=HEAP32[((tempParam)>>2)];
 var tempParam = $__e; $__e=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=sp;
 var $__p_i_i_i_i=(sp)+(8);
 var $2=(sp)+(24);
 __ZNKSt3__18ios_base6getlocEv($2,$__iob);
 var $3=(($2)|0);
 var $4=HEAP32[(($3)>>2)];
 var $5=$__p_i_i_i_i;
 var $6=HEAP32[((14088)>>2)];
 var $7=($6|0)==-1;
 if($7){label=3;break;}else{label=2;break;}
 case 2: 
 var $_sroa_01_0___p67_i_idx_i_i_i=(($__p_i_i_i_i)|0);
 HEAP32[(($_sroa_01_0___p67_i_idx_i_i_i)>>2)]=14088;
 var $_sroa_12_4___p67_i_idx3_i_i_i=(($__p_i_i_i_i+4)|0);
 HEAP32[(($_sroa_12_4___p67_i_idx3_i_i_i)>>2)]=(28);
 var $_sroa_2_8___p67_i_idx4_i_i_i=(($__p_i_i_i_i+8)|0);
 HEAP32[(($_sroa_2_8___p67_i_idx4_i_i_i)>>2)]=0;
 (function() { try { __THREW__ = 0; return __ZNSt3__111__call_onceERVmPvPFvS2_E(14088,$5,260) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=3;break; } else { label=13;break; }
 case 3: 
 var $9=HEAP32[((14092)>>2)];
 var $10=((($9)-(1))|0);
 var $11=(($4+12)|0);
 var $12=HEAP32[(($11)>>2)];
 var $13=(($4+8)|0);
 var $14=HEAP32[(($13)>>2)];
 var $15=$12;
 var $16=$14;
 var $17=((($15)-($16))|0);
 var $18=$17>>2;
 var $19=($18>>>0)>($10>>>0);
 if($19){label=4;break;}else{label=5;break;}
 case 4: 
 var $20=(($14+($10<<2))|0);
 var $21=HEAP32[(($20)>>2)];
 var $22=($21|0)==0;
 if($22){label=5;break;}else{label=7;break;}
 case 5: 
 var $23=___cxa_allocate_exception(4);
 var $24=$23;
 __ZNSt8bad_castC2Ev($24);
 (function() { try { __THREW__ = 0; return ___cxa_throw($23,8960,(368)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=6;break; } else { label=13;break; }
 case 6: 
 throw "Reached an unreachable!";
 case 7: 
 var $26=$21;
 var $27=HEAP32[(($3)>>2)];
 var $28=(($27)|0);
 var $29=__ZNSt3__114__shared_count16__release_sharedEv($28);
 var $30=(($__tm+20)|0);
 var $31=(($__e)|0);
 var $32=HEAP32[(($31)>>2)];
 var $33=$1;
 var $34=(($1)|0);
 HEAP32[(($34)>>2)]=$32;
 var $35=__ZNSt3__120__get_up_to_n_digitsIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi($__b,$1,$__err,$26,4);
 var $36=HEAP32[(($__err)>>2)];
 var $37=$36&4;
 var $38=($37|0)==0;
 if($38){label=8;break;}else{label=12;break;}
 case 8: 
 var $40=($35|0)<69;
 if($40){label=9;break;}else{label=10;break;}
 case 9: 
 var $42=((($35)+(2000))|0);
 var $__t_0_i=$42;label=11;break;
 case 10: 
 var $_off_i=((($35)-(69))|0);
 var $44=($_off_i>>>0)<31;
 var $45=((($35)+(1900))|0);
 var $__i=($44?$45:$35);
 var $__t_0_i=$__i;label=11;break;
 case 11: 
 var $__t_0_i;
 var $47=((($__t_0_i)-(1900))|0);
 HEAP32[(($30)>>2)]=$47;
 label=12;break;
 case 12: 
 var $48=(($__b)|0);
 var $49=HEAP32[(($48)>>2)];
 var $50=(($agg_result)|0);
 HEAP32[(($50)>>2)]=$49;
 STACKTOP=sp;return;
 case 13: 
 var $52$0 = ___cxa_find_matching_catch(-1, -1); var $52$1 = tempRet0;
 var $53=HEAP32[(($3)>>2)];
 var $54=(($53)|0);
 var $55=__ZNSt3__114__shared_count16__release_sharedEv($54);
 ___resumeException($52$0)
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjP2tmcc($agg_result,$this,$__b,$__e,$__iob,$__err,$__tm,$__fmt,$0){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+328)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var tempParam = $__b; $__b=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__b)>>2)]=HEAP32[((tempParam)>>2)];
 var tempParam = $__e; $__e=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $2=sp;
 var $3=(sp)+(8);
 var $4=(sp)+(16);
 var $5=(sp)+(24);
 var $6=(sp)+(32);
 var $7=(sp)+(40);
 var $8=(sp)+(48);
 var $9=(sp)+(56);
 var $10=(sp)+(64);
 var $11=(sp)+(72);
 var $12=(sp)+(80);
 var $13=(sp)+(88);
 var $__p_i_i_i_i=(sp)+(96);
 var $14=(sp)+(112);
 var $15=(sp)+(120);
 var $16=(sp)+(128);
 var $17=(sp)+(136);
 var $18=(sp)+(144);
 var $19=(sp)+(152);
 var $20=(sp)+(160);
 var $21=(sp)+(168);
 var $22=(sp)+(176);
 var $23=(sp)+(184);
 var $24=(sp)+(192);
 var $25=(sp)+(200);
 var $26=(sp)+(208);
 var $27=(sp)+(216);
 var $28=(sp)+(224);
 var $29=(sp)+(232);
 var $30=(sp)+(240);
 var $31=(sp)+(248);
 var $32=(sp)+(256);
 var $33=(sp)+(264);
 var $34=(sp)+(272);
 var $35=(sp)+(280);
 var $36=(sp)+(288);
 var $37=(sp)+(296);
 var $38=(sp)+(304);
 var $39=(sp)+(312);
 var $40=(sp)+(320);
 HEAP32[(($__err)>>2)]=0;
 __ZNKSt3__18ios_base6getlocEv($14,$__iob);
 var $41=(($14)|0);
 var $42=HEAP32[(($41)>>2)];
 var $43=$__p_i_i_i_i;
 var $44=HEAP32[((14088)>>2)];
 var $45=($44|0)==-1;
 if($45){label=3;break;}else{label=2;break;}
 case 2: 
 var $_sroa_01_0___p67_i_idx_i_i_i=(($__p_i_i_i_i)|0);
 HEAP32[(($_sroa_01_0___p67_i_idx_i_i_i)>>2)]=14088;
 var $_sroa_12_4___p67_i_idx3_i_i_i=(($__p_i_i_i_i+4)|0);
 HEAP32[(($_sroa_12_4___p67_i_idx3_i_i_i)>>2)]=(28);
 var $_sroa_2_8___p67_i_idx4_i_i_i=(($__p_i_i_i_i+8)|0);
 HEAP32[(($_sroa_2_8___p67_i_idx4_i_i_i)>>2)]=0;
 (function() { try { __THREW__ = 0; return __ZNSt3__111__call_onceERVmPvPFvS2_E(14088,$43,260) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=3;break; } else { label=8;break; }
 case 3: 
 var $47=HEAP32[((14092)>>2)];
 var $48=((($47)-(1))|0);
 var $49=(($42+12)|0);
 var $50=HEAP32[(($49)>>2)];
 var $51=(($42+8)|0);
 var $52=HEAP32[(($51)>>2)];
 var $53=$50;
 var $54=$52;
 var $55=((($53)-($54))|0);
 var $56=$55>>2;
 var $57=($56>>>0)>($48>>>0);
 if($57){label=4;break;}else{label=5;break;}
 case 4: 
 var $58=(($52+($48<<2))|0);
 var $59=HEAP32[(($58)>>2)];
 var $60=($59|0)==0;
 if($60){label=5;break;}else{label=7;break;}
 case 5: 
 var $61=___cxa_allocate_exception(4);
 var $62=$61;
 __ZNSt8bad_castC2Ev($62);
 (function() { try { __THREW__ = 0; return ___cxa_throw($61,8960,(368)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=6;break; } else { label=8;break; }
 case 6: 
 throw "Reached an unreachable!";
 case 7: 
 var $64=$59;
 var $65=HEAP32[(($41)>>2)];
 var $66=(($65)|0);
 var $67=__ZNSt3__114__shared_count16__release_sharedEv($66);
 var $68=(($__fmt<<24)>>24);
 switch(($68|0)){case 98:case 66:case 104:{ label=11;break;}case 99:{ label=13;break;}case 100:case 101:{ label=17;break;}case 68:{ label=21;break;}case 70:{ label=22;break;}case 72:{ label=23;break;}case 73:{ label=26;break;}case 106:{ label=30;break;}case 109:{ label=33;break;}case 77:{ label=36;break;}case 110:case 116:{ label=39;break;}case 112:{ label=40;break;}case 114:{ label=41;break;}case 82:{ label=42;break;}case 83:{ label=43;break;}case 84:{ label=46;break;}case 119:{ label=47;break;}case 120:{ label=50;break;}case 88:{ label=51;break;}case 121:{ label=55;break;}case 89:{ label=60;break;}case 37:{ label=62;break;}case 97:case 65:{ label=9;break;}default:{label=63;break;}}break;
 case 8: 
 var $70$0 = ___cxa_find_matching_catch(-1, -1); var $70$1 = tempRet0;
 var $71=HEAP32[(($41)>>2)];
 var $72=(($71)|0);
 var $73=__ZNSt3__114__shared_count16__release_sharedEv($72);
 ___resumeException($70$0)
 case 9: 
 var $75=(($__e)|0);
 var $76=HEAP32[(($75)>>2)];
 var $77=$13;
 var $78=(($this+8)|0);
 var $79=$78;
 var $80=HEAP32[(($79)>>2)];
 var $81=HEAP32[(($80)>>2)];
 var $82=FUNCTION_TABLE[$81]($78);
 var $83=(($13)|0);
 HEAP32[(($83)>>2)]=$76;
 var $84=(($82+168)|0);
 var $85=__ZNSt3__114__scan_keywordINS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEPKNS_12basic_stringIwS3_NS_9allocatorIwEEEENS_5ctypeIwEEEET0_RT_SE_SD_SD_RKT1_Rjb($__b,$13,$82,$84,$64,$__err,0);
 var $86=$85;
 var $87=$82;
 var $88=((($86)-($87))|0);
 var $89=($88|0)<168;
 if($89){label=10;break;}else{label=64;break;}
 case 10: 
 var $91=(($__tm+24)|0);
 var $92=(((($88|0))/(12))&-1);
 var $93=(((($92|0))%(7))&-1);
 HEAP32[(($91)>>2)]=$93;
 label=64;break;
 case 11: 
 var $95=(($__e)|0);
 var $96=HEAP32[(($95)>>2)];
 var $97=$12;
 var $98=(($this+8)|0);
 var $99=$98;
 var $100=HEAP32[(($99)>>2)];
 var $101=(($100+4)|0);
 var $102=HEAP32[(($101)>>2)];
 var $103=FUNCTION_TABLE[$102]($98);
 var $104=(($12)|0);
 HEAP32[(($104)>>2)]=$96;
 var $105=(($103+288)|0);
 var $106=__ZNSt3__114__scan_keywordINS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEPKNS_12basic_stringIwS3_NS_9allocatorIwEEEENS_5ctypeIwEEEET0_RT_SE_SD_SD_RKT1_Rjb($__b,$12,$103,$105,$64,$__err,0);
 var $107=$106;
 var $108=$103;
 var $109=((($107)-($108))|0);
 var $110=($109|0)<288;
 if($110){label=12;break;}else{label=64;break;}
 case 12: 
 var $112=(($__tm+16)|0);
 var $113=(((($109|0))/(12))&-1);
 var $114=(((($113|0))%(12))&-1);
 HEAP32[(($112)>>2)]=$114;
 label=64;break;
 case 13: 
 var $116=(($this+8)|0);
 var $117=$116;
 var $118=HEAP32[(($117)>>2)];
 var $119=(($118+12)|0);
 var $120=HEAP32[(($119)>>2)];
 var $121=FUNCTION_TABLE[$120]($116);
 var $122=(($__b)|0);
 var $123=HEAP32[(($122)>>2)];
 var $124=(($16)|0);
 HEAP32[(($124)>>2)]=$123;
 var $125=(($__e)|0);
 var $126=HEAP32[(($125)>>2)];
 var $127=(($17)|0);
 HEAP32[(($127)>>2)]=$126;
 var $128=$121;
 var $129=HEAP8[($128)];
 var $130=$129&1;
 var $131=(($130<<24)>>24)==0;
 if($131){label=15;break;}else{label=14;break;}
 case 14: 
 var $133=(($121+8)|0);
 var $134=HEAP32[(($133)>>2)];
 var $135=(($121+4)|0);
 var $136=HEAP32[(($135)>>2)];
 var $144=$136;var $143=$134;var $142=$134;label=16;break;
 case 15: 
 var $138=(($121+4)|0);
 var $139=(($121+4)|0);
 var $140=($129&255);
 var $141=$140>>>1;
 var $144=$141;var $143=$138;var $142=$139;label=16;break;
 case 16: 
 var $142;
 var $143;
 var $144;
 var $145=(($142+($144<<2))|0);
 __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3getES4_S4_RNS_8ios_baseERjP2tmPKwSC_($15,$this,$16,$17,$__iob,$__err,$__tm,$143,$145);
 var $146=(($15)|0);
 var $147=HEAP32[(($146)>>2)];
 HEAP32[(($122)>>2)]=$147;
 label=64;break;
 case 17: 
 var $149=(($__tm+12)|0);
 var $150=(($__e)|0);
 var $151=HEAP32[(($150)>>2)];
 var $152=$11;
 var $153=(($11)|0);
 HEAP32[(($153)>>2)]=$151;
 var $154=__ZNSt3__120__get_up_to_n_digitsIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi($__b,$11,$__err,$64,2);
 var $155=HEAP32[(($__err)>>2)];
 var $156=$155&4;
 var $157=($156|0)==0;
 if($157){label=18;break;}else{label=20;break;}
 case 18: 
 var $_off_i=((($154)-(1))|0);
 var $159=($_off_i>>>0)<31;
 if($159){label=19;break;}else{label=20;break;}
 case 19: 
 HEAP32[(($149)>>2)]=$154;
 label=64;break;
 case 20: 
 var $162=$155|4;
 HEAP32[(($__err)>>2)]=$162;
 label=64;break;
 case 21: 
 var $164=(($__b)|0);
 var $165=HEAP32[(($164)>>2)];
 var $166=(($19)|0);
 HEAP32[(($166)>>2)]=$165;
 var $167=(($__e)|0);
 var $168=HEAP32[(($167)>>2)];
 var $169=(($20)|0);
 HEAP32[(($169)>>2)]=$168;
 __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3getES4_S4_RNS_8ios_baseERjP2tmPKwSC_($18,$this,$19,$20,$__iob,$__err,$__tm,2784,2816);
 var $170=(($18)|0);
 var $171=HEAP32[(($170)>>2)];
 HEAP32[(($164)>>2)]=$171;
 label=64;break;
 case 22: 
 var $173=(($__b)|0);
 var $174=HEAP32[(($173)>>2)];
 var $175=(($22)|0);
 HEAP32[(($175)>>2)]=$174;
 var $176=(($__e)|0);
 var $177=HEAP32[(($176)>>2)];
 var $178=(($23)|0);
 HEAP32[(($178)>>2)]=$177;
 __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3getES4_S4_RNS_8ios_baseERjP2tmPKwSC_($21,$this,$22,$23,$__iob,$__err,$__tm,2648,2680);
 var $179=(($21)|0);
 var $180=HEAP32[(($179)>>2)];
 HEAP32[(($173)>>2)]=$180;
 label=64;break;
 case 23: 
 var $182=(($__e)|0);
 var $183=HEAP32[(($182)>>2)];
 var $184=$10;
 var $185=(($10)|0);
 HEAP32[(($185)>>2)]=$183;
 var $186=__ZNSt3__120__get_up_to_n_digitsIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi($__b,$10,$__err,$64,2);
 var $187=HEAP32[(($__err)>>2)];
 var $188=$187&4;
 var $189=($188|0)==0;
 var $190=($186|0)<24;
 var $or_cond_i=$189&$190;
 if($or_cond_i){label=24;break;}else{label=25;break;}
 case 24: 
 var $192=(($__tm+8)|0);
 HEAP32[(($192)>>2)]=$186;
 label=64;break;
 case 25: 
 var $194=$187|4;
 HEAP32[(($__err)>>2)]=$194;
 label=64;break;
 case 26: 
 var $196=(($__tm+8)|0);
 var $197=(($__e)|0);
 var $198=HEAP32[(($197)>>2)];
 var $199=$9;
 var $200=(($9)|0);
 HEAP32[(($200)>>2)]=$198;
 var $201=__ZNSt3__120__get_up_to_n_digitsIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi($__b,$9,$__err,$64,2);
 var $202=HEAP32[(($__err)>>2)];
 var $203=$202&4;
 var $204=($203|0)==0;
 if($204){label=27;break;}else{label=29;break;}
 case 27: 
 var $_off_i88=((($201)-(1))|0);
 var $206=($_off_i88>>>0)<12;
 if($206){label=28;break;}else{label=29;break;}
 case 28: 
 HEAP32[(($196)>>2)]=$201;
 label=64;break;
 case 29: 
 var $209=$202|4;
 HEAP32[(($__err)>>2)]=$209;
 label=64;break;
 case 30: 
 var $211=(($__e)|0);
 var $212=HEAP32[(($211)>>2)];
 var $213=$8;
 var $214=(($8)|0);
 HEAP32[(($214)>>2)]=$212;
 var $215=__ZNSt3__120__get_up_to_n_digitsIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi($__b,$8,$__err,$64,3);
 var $216=HEAP32[(($__err)>>2)];
 var $217=$216&4;
 var $218=($217|0)==0;
 var $219=($215|0)<366;
 var $or_cond_i91=$218&$219;
 if($or_cond_i91){label=31;break;}else{label=32;break;}
 case 31: 
 var $221=(($__tm+28)|0);
 HEAP32[(($221)>>2)]=$215;
 label=64;break;
 case 32: 
 var $223=$216|4;
 HEAP32[(($__err)>>2)]=$223;
 label=64;break;
 case 33: 
 var $225=(($__e)|0);
 var $226=HEAP32[(($225)>>2)];
 var $227=$7;
 var $228=(($7)|0);
 HEAP32[(($228)>>2)]=$226;
 var $229=__ZNSt3__120__get_up_to_n_digitsIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi($__b,$7,$__err,$64,2);
 var $230=((($229)-(1))|0);
 var $231=HEAP32[(($__err)>>2)];
 var $232=$231&4;
 var $233=($232|0)==0;
 var $234=($230|0)<12;
 var $or_cond_i94=$233&$234;
 if($or_cond_i94){label=34;break;}else{label=35;break;}
 case 34: 
 var $236=(($__tm+16)|0);
 HEAP32[(($236)>>2)]=$230;
 label=64;break;
 case 35: 
 var $238=$231|4;
 HEAP32[(($__err)>>2)]=$238;
 label=64;break;
 case 36: 
 var $240=(($__e)|0);
 var $241=HEAP32[(($240)>>2)];
 var $242=$6;
 var $243=(($6)|0);
 HEAP32[(($243)>>2)]=$241;
 var $244=__ZNSt3__120__get_up_to_n_digitsIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi($__b,$6,$__err,$64,2);
 var $245=HEAP32[(($__err)>>2)];
 var $246=$245&4;
 var $247=($246|0)==0;
 var $248=($244|0)<60;
 var $or_cond_i97=$247&$248;
 if($or_cond_i97){label=37;break;}else{label=38;break;}
 case 37: 
 var $250=(($__tm+4)|0);
 HEAP32[(($250)>>2)]=$244;
 label=64;break;
 case 38: 
 var $252=$245|4;
 HEAP32[(($__err)>>2)]=$252;
 label=64;break;
 case 39: 
 var $254=(($__e)|0);
 var $255=HEAP32[(($254)>>2)];
 var $256=(($24)|0);
 HEAP32[(($256)>>2)]=$255;
 __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE17__get_white_spaceERS4_S4_RjRKNS_5ctypeIwEE(0,$__b,$24,$__err,$64);
 label=64;break;
 case 40: 
 var $258=(($__tm+8)|0);
 var $259=(($__e)|0);
 var $260=HEAP32[(($259)>>2)];
 var $261=(($25)|0);
 HEAP32[(($261)>>2)]=$260;
 __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE11__get_am_pmERiRS4_S4_RjRKNS_5ctypeIwEE($this,$258,$__b,$25,$__err,$64);
 label=64;break;
 case 41: 
 var $263=(($__b)|0);
 var $264=HEAP32[(($263)>>2)];
 var $265=(($27)|0);
 HEAP32[(($265)>>2)]=$264;
 var $266=(($__e)|0);
 var $267=HEAP32[(($266)>>2)];
 var $268=(($28)|0);
 HEAP32[(($268)>>2)]=$267;
 __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3getES4_S4_RNS_8ios_baseERjP2tmPKwSC_($26,$this,$27,$28,$__iob,$__err,$__tm,2736,2780);
 var $269=(($26)|0);
 var $270=HEAP32[(($269)>>2)];
 HEAP32[(($263)>>2)]=$270;
 label=64;break;
 case 42: 
 var $272=(($__b)|0);
 var $273=HEAP32[(($272)>>2)];
 var $274=(($30)|0);
 HEAP32[(($274)>>2)]=$273;
 var $275=(($__e)|0);
 var $276=HEAP32[(($275)>>2)];
 var $277=(($31)|0);
 HEAP32[(($277)>>2)]=$276;
 __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3getES4_S4_RNS_8ios_baseERjP2tmPKwSC_($29,$this,$30,$31,$__iob,$__err,$__tm,2712,2732);
 var $278=(($29)|0);
 var $279=HEAP32[(($278)>>2)];
 HEAP32[(($272)>>2)]=$279;
 label=64;break;
 case 43: 
 var $281=(($__e)|0);
 var $282=HEAP32[(($281)>>2)];
 var $283=$5;
 var $284=(($5)|0);
 HEAP32[(($284)>>2)]=$282;
 var $285=__ZNSt3__120__get_up_to_n_digitsIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi($__b,$5,$__err,$64,2);
 var $286=HEAP32[(($__err)>>2)];
 var $287=$286&4;
 var $288=($287|0)==0;
 var $289=($285|0)<61;
 var $or_cond_i100=$288&$289;
 if($or_cond_i100){label=44;break;}else{label=45;break;}
 case 44: 
 var $291=(($__tm)|0);
 HEAP32[(($291)>>2)]=$285;
 label=64;break;
 case 45: 
 var $293=$286|4;
 HEAP32[(($__err)>>2)]=$293;
 label=64;break;
 case 46: 
 var $295=(($__b)|0);
 var $296=HEAP32[(($295)>>2)];
 var $297=(($33)|0);
 HEAP32[(($297)>>2)]=$296;
 var $298=(($__e)|0);
 var $299=HEAP32[(($298)>>2)];
 var $300=(($34)|0);
 HEAP32[(($300)>>2)]=$299;
 __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3getES4_S4_RNS_8ios_baseERjP2tmPKwSC_($32,$this,$33,$34,$__iob,$__err,$__tm,2680,2712);
 var $301=(($32)|0);
 var $302=HEAP32[(($301)>>2)];
 HEAP32[(($295)>>2)]=$302;
 label=64;break;
 case 47: 
 var $304=(($__e)|0);
 var $305=HEAP32[(($304)>>2)];
 var $306=$4;
 var $307=(($4)|0);
 HEAP32[(($307)>>2)]=$305;
 var $308=__ZNSt3__120__get_up_to_n_digitsIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi($__b,$4,$__err,$64,1);
 var $309=HEAP32[(($__err)>>2)];
 var $310=$309&4;
 var $311=($310|0)==0;
 var $312=($308|0)<7;
 var $or_cond_i103=$311&$312;
 if($or_cond_i103){label=48;break;}else{label=49;break;}
 case 48: 
 var $314=(($__tm+24)|0);
 HEAP32[(($314)>>2)]=$308;
 label=64;break;
 case 49: 
 var $316=$309|4;
 HEAP32[(($__err)>>2)]=$316;
 label=64;break;
 case 50: 
 var $318=$this;
 var $319=HEAP32[(($318)>>2)];
 var $320=(($319+20)|0);
 var $321=HEAP32[(($320)>>2)];
 var $322=(($__b)|0);
 var $323=HEAP32[(($322)>>2)];
 var $324=(($35)|0);
 HEAP32[(($324)>>2)]=$323;
 var $325=(($__e)|0);
 var $326=HEAP32[(($325)>>2)];
 var $327=(($36)|0);
 HEAP32[(($327)>>2)]=$326;
 FUNCTION_TABLE[$321]($agg_result,$this,$35,$36,$__iob,$__err,$__tm);
 label=65;break;
 case 51: 
 var $329=(($this+8)|0);
 var $330=$329;
 var $331=HEAP32[(($330)>>2)];
 var $332=(($331+24)|0);
 var $333=HEAP32[(($332)>>2)];
 var $334=FUNCTION_TABLE[$333]($329);
 var $335=(($__b)|0);
 var $336=HEAP32[(($335)>>2)];
 var $337=(($38)|0);
 HEAP32[(($337)>>2)]=$336;
 var $338=(($__e)|0);
 var $339=HEAP32[(($338)>>2)];
 var $340=(($39)|0);
 HEAP32[(($340)>>2)]=$339;
 var $341=$334;
 var $342=HEAP8[($341)];
 var $343=$342&1;
 var $344=(($343<<24)>>24)==0;
 if($344){label=53;break;}else{label=52;break;}
 case 52: 
 var $346=(($334+8)|0);
 var $347=HEAP32[(($346)>>2)];
 var $348=(($334+4)|0);
 var $349=HEAP32[(($348)>>2)];
 var $357=$349;var $356=$347;var $355=$347;label=54;break;
 case 53: 
 var $351=(($334+4)|0);
 var $352=(($334+4)|0);
 var $353=($342&255);
 var $354=$353>>>1;
 var $357=$354;var $356=$351;var $355=$352;label=54;break;
 case 54: 
 var $355;
 var $356;
 var $357;
 var $358=(($355+($357<<2))|0);
 __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3getES4_S4_RNS_8ios_baseERjP2tmPKwSC_($37,$this,$38,$39,$__iob,$__err,$__tm,$356,$358);
 var $359=(($37)|0);
 var $360=HEAP32[(($359)>>2)];
 HEAP32[(($335)>>2)]=$360;
 label=64;break;
 case 55: 
 var $362=(($__tm+20)|0);
 var $363=(($__e)|0);
 var $364=HEAP32[(($363)>>2)];
 var $365=$3;
 var $366=(($3)|0);
 HEAP32[(($366)>>2)]=$364;
 var $367=__ZNSt3__120__get_up_to_n_digitsIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi($__b,$3,$__err,$64,4);
 var $368=HEAP32[(($__err)>>2)];
 var $369=$368&4;
 var $370=($369|0)==0;
 if($370){label=56;break;}else{label=64;break;}
 case 56: 
 var $372=($367|0)<69;
 if($372){label=57;break;}else{label=58;break;}
 case 57: 
 var $374=((($367)+(2000))|0);
 var $__t_0_i=$374;label=59;break;
 case 58: 
 var $_off_i109=((($367)-(69))|0);
 var $376=($_off_i109>>>0)<31;
 var $377=((($367)+(1900))|0);
 var $__i=($376?$377:$367);
 var $__t_0_i=$__i;label=59;break;
 case 59: 
 var $__t_0_i;
 var $379=((($__t_0_i)-(1900))|0);
 HEAP32[(($362)>>2)]=$379;
 label=64;break;
 case 60: 
 var $381=(($__e)|0);
 var $382=HEAP32[(($381)>>2)];
 var $383=$2;
 var $384=(($2)|0);
 HEAP32[(($384)>>2)]=$382;
 var $385=__ZNSt3__120__get_up_to_n_digitsIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi($__b,$2,$__err,$64,4);
 var $386=HEAP32[(($__err)>>2)];
 var $387=$386&4;
 var $388=($387|0)==0;
 if($388){label=61;break;}else{label=64;break;}
 case 61: 
 var $390=(($__tm+20)|0);
 var $391=((($385)-(1900))|0);
 HEAP32[(($390)>>2)]=$391;
 label=64;break;
 case 62: 
 var $393=(($__e)|0);
 var $394=HEAP32[(($393)>>2)];
 var $395=(($40)|0);
 HEAP32[(($395)>>2)]=$394;
 __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE13__get_percentERS4_S4_RjRKNS_5ctypeIwEE(0,$__b,$40,$__err,$64);
 label=64;break;
 case 63: 
 var $397=HEAP32[(($__err)>>2)];
 var $398=$397|4;
 HEAP32[(($__err)>>2)]=$398;
 label=64;break;
 case 64: 
 var $399=(($__b)|0);
 var $400=HEAP32[(($399)>>2)];
 var $401=(($agg_result)|0);
 HEAP32[(($401)>>2)]=$400;
 label=65;break;
 case 65: 
 STACKTOP=sp;return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE17__get_white_spaceERS4_S4_RjRKNS_5ctypeIwEE($this,$__b,$__e,$__err,$__ct){
 var label=0;
 var sp=STACKTOP; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var tempParam = $__e; $__e=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=(($__b)|0);
 var $2=(($__e)|0);
 var $3=$__ct;
 label=2;break;
 case 2: 
 var $4=HEAP32[(($1)>>2)];
 var $5=($4|0)==0;
 if($5){var $22=1;label=9;break;}else{label=3;break;}
 case 3: 
 var $7=(($4+12)|0);
 var $8=HEAP32[(($7)>>2)];
 var $9=(($4+16)|0);
 var $10=HEAP32[(($9)>>2)];
 var $11=($8|0)==($10|0);
 if($11){label=4;break;}else{label=5;break;}
 case 4: 
 var $13=$4;
 var $14=HEAP32[(($13)>>2)];
 var $15=(($14+36)|0);
 var $16=HEAP32[(($15)>>2)];
 var $17=FUNCTION_TABLE[$16]($4);
 var $_0_i_i_i_i=$17;label=6;break;
 case 5: 
 var $19=HEAP32[(($8)>>2)];
 var $_0_i_i_i_i=$19;label=6;break;
 case 6: 
 var $_0_i_i_i_i;
 var $20=($_0_i_i_i_i|0)==-1;
 if($20){label=8;break;}else{label=7;break;}
 case 7: 
 var $_pre_i_i_i=HEAP32[(($1)>>2)];
 var $phitmp_i_i_i=($_pre_i_i_i|0)==0;
 var $22=$phitmp_i_i_i;label=9;break;
 case 8: 
 HEAP32[(($1)>>2)]=0;
 var $22=1;label=9;break;
 case 9: 
 var $22;
 var $23=HEAP32[(($2)>>2)];
 var $24=($23|0)==0;
 if($24){label=15;break;}else{label=10;break;}
 case 10: 
 var $26=(($23+12)|0);
 var $27=HEAP32[(($26)>>2)];
 var $28=(($23+16)|0);
 var $29=HEAP32[(($28)>>2)];
 var $30=($27|0)==($29|0);
 if($30){label=11;break;}else{label=12;break;}
 case 11: 
 var $32=$23;
 var $33=HEAP32[(($32)>>2)];
 var $34=(($33+36)|0);
 var $35=HEAP32[(($34)>>2)];
 var $36=FUNCTION_TABLE[$35]($23);
 var $_0_i_i2_i_i=$36;label=13;break;
 case 12: 
 var $38=HEAP32[(($27)>>2)];
 var $_0_i_i2_i_i=$38;label=13;break;
 case 13: 
 var $_0_i_i2_i_i;
 var $39=($_0_i_i2_i_i|0)==-1;
 if($39){label=14;break;}else{label=16;break;}
 case 14: 
 HEAP32[(($2)>>2)]=0;
 label=15;break;
 case 15: 
 if($22){var $_pre_i4_i_i15=0;label=24;break;}else{var $41=0;label=17;break;}
 case 16: 
 if($22){var $41=$23;label=17;break;}else{var $_pre_i4_i_i15=$23;label=24;break;}
 case 17: 
 var $41;
 var $42=HEAP32[(($1)>>2)];
 var $43=(($42+12)|0);
 var $44=HEAP32[(($43)>>2)];
 var $45=(($42+16)|0);
 var $46=HEAP32[(($45)>>2)];
 var $47=($44|0)==($46|0);
 if($47){label=18;break;}else{label=19;break;}
 case 18: 
 var $49=$42;
 var $50=HEAP32[(($49)>>2)];
 var $51=(($50+36)|0);
 var $52=HEAP32[(($51)>>2)];
 var $53=FUNCTION_TABLE[$52]($42);
 var $_0_i_i=$53;label=20;break;
 case 19: 
 var $55=HEAP32[(($44)>>2)];
 var $_0_i_i=$55;label=20;break;
 case 20: 
 var $_0_i_i;
 var $56=HEAP32[(($3)>>2)];
 var $57=(($56+12)|0);
 var $58=HEAP32[(($57)>>2)];
 var $59=FUNCTION_TABLE[$58]($__ct,8192,$_0_i_i);
 if($59){label=21;break;}else{var $_pre_i4_i_i15=$41;label=24;break;}
 case 21: 
 var $61=HEAP32[(($1)>>2)];
 var $62=(($61+12)|0);
 var $63=HEAP32[(($62)>>2)];
 var $64=(($61+16)|0);
 var $65=HEAP32[(($64)>>2)];
 var $66=($63|0)==($65|0);
 if($66){label=22;break;}else{label=23;break;}
 case 22: 
 var $68=$61;
 var $69=HEAP32[(($68)>>2)];
 var $70=(($69+40)|0);
 var $71=HEAP32[(($70)>>2)];
 var $72=FUNCTION_TABLE[$71]($61);
 label=2;break;
 case 23: 
 var $74=(($63+4)|0);
 HEAP32[(($62)>>2)]=$74;
 label=2;break;
 case 24: 
 var $_pre_i4_i_i15;
 var $75=HEAP32[(($1)>>2)];
 var $76=($75|0)==0;
 if($76){var $93=1;label=31;break;}else{label=25;break;}
 case 25: 
 var $78=(($75+12)|0);
 var $79=HEAP32[(($78)>>2)];
 var $80=(($75+16)|0);
 var $81=HEAP32[(($80)>>2)];
 var $82=($79|0)==($81|0);
 if($82){label=26;break;}else{label=27;break;}
 case 26: 
 var $84=$75;
 var $85=HEAP32[(($84)>>2)];
 var $86=(($85+36)|0);
 var $87=HEAP32[(($86)>>2)];
 var $88=FUNCTION_TABLE[$87]($75);
 var $_0_i_i_i_i7=$88;label=28;break;
 case 27: 
 var $90=HEAP32[(($79)>>2)];
 var $_0_i_i_i_i7=$90;label=28;break;
 case 28: 
 var $_0_i_i_i_i7;
 var $91=($_0_i_i_i_i7|0)==-1;
 if($91){label=30;break;}else{label=29;break;}
 case 29: 
 var $_pre_i_i_i9=HEAP32[(($1)>>2)];
 var $phitmp_i_i_i10=($_pre_i_i_i9|0)==0;
 var $93=$phitmp_i_i_i10;label=31;break;
 case 30: 
 HEAP32[(($1)>>2)]=0;
 var $93=1;label=31;break;
 case 31: 
 var $93;
 var $94=($_pre_i4_i_i15|0)==0;
 if($94){label=37;break;}else{label=32;break;}
 case 32: 
 var $96=(($_pre_i4_i_i15+12)|0);
 var $97=HEAP32[(($96)>>2)];
 var $98=(($_pre_i4_i_i15+16)|0);
 var $99=HEAP32[(($98)>>2)];
 var $100=($97|0)==($99|0);
 if($100){label=33;break;}else{label=34;break;}
 case 33: 
 var $102=$_pre_i4_i_i15;
 var $103=HEAP32[(($102)>>2)];
 var $104=(($103+36)|0);
 var $105=HEAP32[(($104)>>2)];
 var $106=FUNCTION_TABLE[$105]($_pre_i4_i_i15);
 var $_0_i_i2_i_i13=$106;label=35;break;
 case 34: 
 var $108=HEAP32[(($97)>>2)];
 var $_0_i_i2_i_i13=$108;label=35;break;
 case 35: 
 var $_0_i_i2_i_i13;
 var $109=($_0_i_i2_i_i13|0)==-1;
 if($109){label=36;break;}else{label=38;break;}
 case 36: 
 HEAP32[(($2)>>2)]=0;
 label=37;break;
 case 37: 
 if($93){label=39;break;}else{label=40;break;}
 case 38: 
 if($93){label=40;break;}else{label=39;break;}
 case 39: 
 var $112=HEAP32[(($__err)>>2)];
 var $113=$112|2;
 HEAP32[(($__err)>>2)]=$113;
 label=40;break;
 case 40: 
 STACKTOP=sp;return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE11__get_am_pmERiRS4_S4_RjRKNS_5ctypeIwEE($this,$__h,$__b,$__e,$__err,$__ct){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+8)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var tempParam = $__e; $__e=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=sp;
 var $2=(($this+8)|0);
 var $3=$2;
 var $4=HEAP32[(($3)>>2)];
 var $5=(($4+8)|0);
 var $6=HEAP32[(($5)>>2)];
 var $7=FUNCTION_TABLE[$6]($2);
 var $8=$7;
 var $9=HEAP8[($8)];
 var $10=$9&1;
 var $11=(($10<<24)>>24)==0;
 if($11){label=3;break;}else{label=2;break;}
 case 2: 
 var $13=(($7+4)|0);
 var $14=HEAP32[(($13)>>2)];
 var $18=$14;label=4;break;
 case 3: 
 var $16=($9&255);
 var $17=$16>>>1;
 var $18=$17;label=4;break;
 case 4: 
 var $18;
 var $19=(($7+12)|0);
 var $20=$19;
 var $21=HEAP8[($20)];
 var $22=$21&1;
 var $23=(($22<<24)>>24)==0;
 if($23){label=6;break;}else{label=5;break;}
 case 5: 
 var $25=(($7+16)|0);
 var $26=HEAP32[(($25)>>2)];
 var $30=$26;label=7;break;
 case 6: 
 var $28=($21&255);
 var $29=$28>>>1;
 var $30=$29;label=7;break;
 case 7: 
 var $30;
 var $31=(((-$30))|0);
 var $32=($18|0)==($31|0);
 if($32){label=8;break;}else{label=9;break;}
 case 8: 
 var $34=HEAP32[(($__err)>>2)];
 var $35=$34|4;
 HEAP32[(($__err)>>2)]=$35;
 label=15;break;
 case 9: 
 var $37=(($__e)|0);
 var $38=HEAP32[(($37)>>2)];
 var $39=(($1)|0);
 HEAP32[(($39)>>2)]=$38;
 var $40=(($7+24)|0);
 var $41=__ZNSt3__114__scan_keywordINS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEPKNS_12basic_stringIwS3_NS_9allocatorIwEEEENS_5ctypeIwEEEET0_RT_SE_SD_SD_RKT1_Rjb($__b,$1,$7,$40,$__ct,$__err,0);
 var $42=$41;
 var $43=$7;
 var $44=((($42)-($43))|0);
 var $45=($41|0)==($7|0);
 if($45){label=10;break;}else{label=12;break;}
 case 10: 
 var $47=HEAP32[(($__h)>>2)];
 var $48=($47|0)==12;
 if($48){label=11;break;}else{label=12;break;}
 case 11: 
 HEAP32[(($__h)>>2)]=0;
 label=15;break;
 case 12: 
 var $51=($44|0)==12;
 if($51){label=13;break;}else{label=15;break;}
 case 13: 
 var $53=HEAP32[(($__h)>>2)];
 var $54=($53|0)<12;
 if($54){label=14;break;}else{label=15;break;}
 case 14: 
 var $56=((($53)+(12))|0);
 HEAP32[(($__h)>>2)]=$56;
 label=15;break;
 case 15: 
 STACKTOP=sp;return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE13__get_percentERS4_S4_RjRKNS_5ctypeIwEE($this,$__b,$__e,$__err,$__ct){
 var label=0;
 var sp=STACKTOP; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var tempParam = $__e; $__e=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=(($__b)|0);
 var $2=HEAP32[(($1)>>2)];
 var $3=($2|0)==0;
 if($3){var $20=1;label=8;break;}else{label=2;break;}
 case 2: 
 var $5=(($2+12)|0);
 var $6=HEAP32[(($5)>>2)];
 var $7=(($2+16)|0);
 var $8=HEAP32[(($7)>>2)];
 var $9=($6|0)==($8|0);
 if($9){label=3;break;}else{label=4;break;}
 case 3: 
 var $11=$2;
 var $12=HEAP32[(($11)>>2)];
 var $13=(($12+36)|0);
 var $14=HEAP32[(($13)>>2)];
 var $15=FUNCTION_TABLE[$14]($2);
 var $_0_i_i_i_i=$15;label=5;break;
 case 4: 
 var $17=HEAP32[(($6)>>2)];
 var $_0_i_i_i_i=$17;label=5;break;
 case 5: 
 var $_0_i_i_i_i;
 var $18=($_0_i_i_i_i|0)==-1;
 if($18){label=7;break;}else{label=6;break;}
 case 6: 
 var $_pre_i_i_i=HEAP32[(($1)>>2)];
 var $phitmp_i_i_i=($_pre_i_i_i|0)==0;
 var $20=$phitmp_i_i_i;label=8;break;
 case 7: 
 HEAP32[(($1)>>2)]=0;
 var $20=1;label=8;break;
 case 8: 
 var $20;
 var $21=(($__e)|0);
 var $22=HEAP32[(($21)>>2)];
 var $23=($22|0)==0;
 if($23){label=14;break;}else{label=9;break;}
 case 9: 
 var $25=(($22+12)|0);
 var $26=HEAP32[(($25)>>2)];
 var $27=(($22+16)|0);
 var $28=HEAP32[(($27)>>2)];
 var $29=($26|0)==($28|0);
 if($29){label=10;break;}else{label=11;break;}
 case 10: 
 var $31=$22;
 var $32=HEAP32[(($31)>>2)];
 var $33=(($32+36)|0);
 var $34=HEAP32[(($33)>>2)];
 var $35=FUNCTION_TABLE[$34]($22);
 var $_0_i_i2_i_i=$35;label=12;break;
 case 11: 
 var $37=HEAP32[(($26)>>2)];
 var $_0_i_i2_i_i=$37;label=12;break;
 case 12: 
 var $_0_i_i2_i_i;
 var $38=($_0_i_i2_i_i|0)==-1;
 if($38){label=13;break;}else{label=15;break;}
 case 13: 
 HEAP32[(($21)>>2)]=0;
 label=14;break;
 case 14: 
 if($20){label=16;break;}else{var $_pre_i4_i_i1622=0;label=17;break;}
 case 15: 
 if($20){var $_pre_i4_i_i1622=$22;label=17;break;}else{label=16;break;}
 case 16: 
 var $41=HEAP32[(($__err)>>2)];
 var $42=$41|6;
 HEAP32[(($__err)>>2)]=$42;
 label=41;break;
 case 17: 
 var $_pre_i4_i_i1622;
 var $44=HEAP32[(($1)>>2)];
 var $45=(($44+12)|0);
 var $46=HEAP32[(($45)>>2)];
 var $47=(($44+16)|0);
 var $48=HEAP32[(($47)>>2)];
 var $49=($46|0)==($48|0);
 if($49){label=18;break;}else{label=19;break;}
 case 18: 
 var $51=$44;
 var $52=HEAP32[(($51)>>2)];
 var $53=(($52+36)|0);
 var $54=HEAP32[(($53)>>2)];
 var $55=FUNCTION_TABLE[$54]($44);
 var $_0_i_i=$55;label=20;break;
 case 19: 
 var $57=HEAP32[(($46)>>2)];
 var $_0_i_i=$57;label=20;break;
 case 20: 
 var $_0_i_i;
 var $58=$__ct;
 var $59=HEAP32[(($58)>>2)];
 var $60=(($59+52)|0);
 var $61=HEAP32[(($60)>>2)];
 var $62=FUNCTION_TABLE[$61]($__ct,$_0_i_i,0);
 var $63=(($62<<24)>>24)==37;
 if($63){label=22;break;}else{label=21;break;}
 case 21: 
 var $65=HEAP32[(($__err)>>2)];
 var $66=$65|4;
 HEAP32[(($__err)>>2)]=$66;
 label=41;break;
 case 22: 
 var $68=HEAP32[(($1)>>2)];
 var $69=(($68+12)|0);
 var $70=HEAP32[(($69)>>2)];
 var $71=(($68+16)|0);
 var $72=HEAP32[(($71)>>2)];
 var $73=($70|0)==($72|0);
 if($73){label=23;break;}else{label=24;break;}
 case 23: 
 var $75=$68;
 var $76=HEAP32[(($75)>>2)];
 var $77=(($76+40)|0);
 var $78=HEAP32[(($77)>>2)];
 var $79=FUNCTION_TABLE[$78]($68);
 label=25;break;
 case 24: 
 var $81=(($70+4)|0);
 HEAP32[(($69)>>2)]=$81;
 label=25;break;
 case 25: 
 var $82=HEAP32[(($1)>>2)];
 var $83=($82|0)==0;
 if($83){var $100=1;label=32;break;}else{label=26;break;}
 case 26: 
 var $85=(($82+12)|0);
 var $86=HEAP32[(($85)>>2)];
 var $87=(($82+16)|0);
 var $88=HEAP32[(($87)>>2)];
 var $89=($86|0)==($88|0);
 if($89){label=27;break;}else{label=28;break;}
 case 27: 
 var $91=$82;
 var $92=HEAP32[(($91)>>2)];
 var $93=(($92+36)|0);
 var $94=HEAP32[(($93)>>2)];
 var $95=FUNCTION_TABLE[$94]($82);
 var $_0_i_i_i_i8=$95;label=29;break;
 case 28: 
 var $97=HEAP32[(($86)>>2)];
 var $_0_i_i_i_i8=$97;label=29;break;
 case 29: 
 var $_0_i_i_i_i8;
 var $98=($_0_i_i_i_i8|0)==-1;
 if($98){label=31;break;}else{label=30;break;}
 case 30: 
 var $_pre_i_i_i10=HEAP32[(($1)>>2)];
 var $phitmp_i_i_i11=($_pre_i_i_i10|0)==0;
 var $100=$phitmp_i_i_i11;label=32;break;
 case 31: 
 HEAP32[(($1)>>2)]=0;
 var $100=1;label=32;break;
 case 32: 
 var $100;
 var $101=($_pre_i4_i_i1622|0)==0;
 if($101){label=38;break;}else{label=33;break;}
 case 33: 
 var $103=(($_pre_i4_i_i1622+12)|0);
 var $104=HEAP32[(($103)>>2)];
 var $105=(($_pre_i4_i_i1622+16)|0);
 var $106=HEAP32[(($105)>>2)];
 var $107=($104|0)==($106|0);
 if($107){label=34;break;}else{label=35;break;}
 case 34: 
 var $109=$_pre_i4_i_i1622;
 var $110=HEAP32[(($109)>>2)];
 var $111=(($110+36)|0);
 var $112=HEAP32[(($111)>>2)];
 var $113=FUNCTION_TABLE[$112]($_pre_i4_i_i1622);
 var $_0_i_i2_i_i14=$113;label=36;break;
 case 35: 
 var $115=HEAP32[(($104)>>2)];
 var $_0_i_i2_i_i14=$115;label=36;break;
 case 36: 
 var $_0_i_i2_i_i14;
 var $116=($_0_i_i2_i_i14|0)==-1;
 if($116){label=37;break;}else{label=39;break;}
 case 37: 
 HEAP32[(($21)>>2)]=0;
 label=38;break;
 case 38: 
 if($100){label=40;break;}else{label=41;break;}
 case 39: 
 if($100){label=41;break;}else{label=40;break;}
 case 40: 
 var $119=HEAP32[(($__err)>>2)];
 var $120=$119|2;
 HEAP32[(($__err)>>2)]=$120;
 label=41;break;
 case 41: 
 STACKTOP=sp;return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__120__get_up_to_n_digitsIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi($__b,$__e,$__err,$__ct,$__n){
 var label=0;
 var sp=STACKTOP; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var tempParam = $__e; $__e=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=(($__b)|0);
 var $2=HEAP32[(($1)>>2)];
 var $3=($2|0)==0;
 if($3){var $20=1;label=8;break;}else{label=2;break;}
 case 2: 
 var $5=(($2+12)|0);
 var $6=HEAP32[(($5)>>2)];
 var $7=(($2+16)|0);
 var $8=HEAP32[(($7)>>2)];
 var $9=($6|0)==($8|0);
 if($9){label=3;break;}else{label=4;break;}
 case 3: 
 var $11=$2;
 var $12=HEAP32[(($11)>>2)];
 var $13=(($12+36)|0);
 var $14=HEAP32[(($13)>>2)];
 var $15=FUNCTION_TABLE[$14]($2);
 var $_0_i_i_i_i=$15;label=5;break;
 case 4: 
 var $17=HEAP32[(($6)>>2)];
 var $_0_i_i_i_i=$17;label=5;break;
 case 5: 
 var $_0_i_i_i_i;
 var $18=($_0_i_i_i_i|0)==-1;
 if($18){label=7;break;}else{label=6;break;}
 case 6: 
 var $_pre_i_i_i=HEAP32[(($1)>>2)];
 var $phitmp_i_i_i=($_pre_i_i_i|0)==0;
 var $20=$phitmp_i_i_i;label=8;break;
 case 7: 
 HEAP32[(($1)>>2)]=0;
 var $20=1;label=8;break;
 case 8: 
 var $20;
 var $21=(($__e)|0);
 var $22=HEAP32[(($21)>>2)];
 var $23=($22|0)==0;
 if($23){label=14;break;}else{label=9;break;}
 case 9: 
 var $25=(($22+12)|0);
 var $26=HEAP32[(($25)>>2)];
 var $27=(($22+16)|0);
 var $28=HEAP32[(($27)>>2)];
 var $29=($26|0)==($28|0);
 if($29){label=10;break;}else{label=11;break;}
 case 10: 
 var $31=$22;
 var $32=HEAP32[(($31)>>2)];
 var $33=(($32+36)|0);
 var $34=HEAP32[(($33)>>2)];
 var $35=FUNCTION_TABLE[$34]($22);
 var $_0_i_i2_i_i=$35;label=12;break;
 case 11: 
 var $37=HEAP32[(($26)>>2)];
 var $_0_i_i2_i_i=$37;label=12;break;
 case 12: 
 var $_0_i_i2_i_i;
 var $38=($_0_i_i2_i_i|0)==-1;
 if($38){label=13;break;}else{label=15;break;}
 case 13: 
 HEAP32[(($21)>>2)]=0;
 label=14;break;
 case 14: 
 if($20){label=16;break;}else{var $44=0;label=17;break;}
 case 15: 
 if($20){var $44=$22;label=17;break;}else{label=16;break;}
 case 16: 
 var $41=HEAP32[(($__err)>>2)];
 var $42=$41|6;
 HEAP32[(($__err)>>2)]=$42;
 var $_021=0;label=63;break;
 case 17: 
 var $44;
 var $45=HEAP32[(($1)>>2)];
 var $46=(($45+12)|0);
 var $47=HEAP32[(($46)>>2)];
 var $48=(($45+16)|0);
 var $49=HEAP32[(($48)>>2)];
 var $50=($47|0)==($49|0);
 if($50){label=18;break;}else{label=19;break;}
 case 18: 
 var $52=$45;
 var $53=HEAP32[(($52)>>2)];
 var $54=(($53+36)|0);
 var $55=HEAP32[(($54)>>2)];
 var $56=FUNCTION_TABLE[$55]($45);
 var $_0_i_i=$56;label=20;break;
 case 19: 
 var $58=HEAP32[(($47)>>2)];
 var $_0_i_i=$58;label=20;break;
 case 20: 
 var $_0_i_i;
 var $59=$__ct;
 var $60=HEAP32[(($59)>>2)];
 var $61=(($60+12)|0);
 var $62=HEAP32[(($61)>>2)];
 var $63=FUNCTION_TABLE[$62]($__ct,2048,$_0_i_i);
 if($63){label=22;break;}else{label=21;break;}
 case 21: 
 var $65=HEAP32[(($__err)>>2)];
 var $66=$65|4;
 HEAP32[(($__err)>>2)]=$66;
 var $_021=0;label=63;break;
 case 22: 
 var $68=$__ct;
 var $69=HEAP32[(($68)>>2)];
 var $70=(($69+52)|0);
 var $71=HEAP32[(($70)>>2)];
 var $72=FUNCTION_TABLE[$71]($__ct,$_0_i_i,0);
 var $73=(($72<<24)>>24);
 var $74=HEAP32[(($1)>>2)];
 var $75=(($74+12)|0);
 var $76=HEAP32[(($75)>>2)];
 var $77=(($74+16)|0);
 var $78=HEAP32[(($77)>>2)];
 var $79=($76|0)==($78|0);
 if($79){label=23;break;}else{label=24;break;}
 case 23: 
 var $81=$74;
 var $82=HEAP32[(($81)>>2)];
 var $83=(($82+40)|0);
 var $84=HEAP32[(($83)>>2)];
 var $85=FUNCTION_TABLE[$84]($74);
 var $__r_0_in=$73;var $_0_in=$__n;var $88=$44;var $_pre_i4_i_i30=$44;label=25;break;
 case 24: 
 var $87=(($76+4)|0);
 HEAP32[(($75)>>2)]=$87;
 var $__r_0_in=$73;var $_0_in=$__n;var $88=$44;var $_pre_i4_i_i30=$44;label=25;break;
 case 25: 
 var $_pre_i4_i_i30;
 var $88;
 var $_0_in;
 var $__r_0_in;
 var $__r_0=((($__r_0_in)-(48))|0);
 var $_0=((($_0_in)-(1))|0);
 var $89=HEAP32[(($1)>>2)];
 var $90=($89|0)==0;
 if($90){var $107=1;label=32;break;}else{label=26;break;}
 case 26: 
 var $92=(($89+12)|0);
 var $93=HEAP32[(($92)>>2)];
 var $94=(($89+16)|0);
 var $95=HEAP32[(($94)>>2)];
 var $96=($93|0)==($95|0);
 if($96){label=27;break;}else{label=28;break;}
 case 27: 
 var $98=$89;
 var $99=HEAP32[(($98)>>2)];
 var $100=(($99+36)|0);
 var $101=HEAP32[(($100)>>2)];
 var $102=FUNCTION_TABLE[$101]($89);
 var $_0_i_i_i_i22=$102;label=29;break;
 case 28: 
 var $104=HEAP32[(($93)>>2)];
 var $_0_i_i_i_i22=$104;label=29;break;
 case 29: 
 var $_0_i_i_i_i22;
 var $105=($_0_i_i_i_i22|0)==-1;
 if($105){label=31;break;}else{label=30;break;}
 case 30: 
 var $_pre_i_i_i24=HEAP32[(($1)>>2)];
 var $phitmp_i_i_i25=($_pre_i_i_i24|0)==0;
 var $107=$phitmp_i_i_i25;label=32;break;
 case 31: 
 HEAP32[(($1)>>2)]=0;
 var $107=1;label=32;break;
 case 32: 
 var $107;
 var $108=($88|0)==0;
 if($108){var $126=1;var $125=0;var $_pre_i4_i_i45=$_pre_i4_i_i30;label=39;break;}else{label=33;break;}
 case 33: 
 var $110=(($88+12)|0);
 var $111=HEAP32[(($110)>>2)];
 var $112=(($88+16)|0);
 var $113=HEAP32[(($112)>>2)];
 var $114=($111|0)==($113|0);
 if($114){label=34;break;}else{label=35;break;}
 case 34: 
 var $116=$88;
 var $117=HEAP32[(($116)>>2)];
 var $118=(($117+36)|0);
 var $119=HEAP32[(($118)>>2)];
 var $120=FUNCTION_TABLE[$119]($88);
 var $_0_i_i2_i_i28=$120;label=36;break;
 case 35: 
 var $122=HEAP32[(($111)>>2)];
 var $_0_i_i2_i_i28=$122;label=36;break;
 case 36: 
 var $_0_i_i2_i_i28;
 var $123=($_0_i_i2_i_i28|0)==-1;
 if($123){label=38;break;}else{label=37;break;}
 case 37: 
 var $phitmp_i5_i_i31=($_pre_i4_i_i30|0)==0;
 var $126=$phitmp_i5_i_i31;var $125=$_pre_i4_i_i30;var $_pre_i4_i_i45=$_pre_i4_i_i30;label=39;break;
 case 38: 
 HEAP32[(($21)>>2)]=0;
 var $126=1;var $125=0;var $_pre_i4_i_i45=0;label=39;break;
 case 39: 
 var $_pre_i4_i_i45;
 var $125;
 var $126;
 var $tmp_i_i33=$107^$126;
 var $127=($_0|0)>0;
 var $_=$tmp_i_i33&$127;
 var $128=HEAP32[(($1)>>2)];
 if($_){label=40;break;}else{label=47;break;}
 case 40: 
 var $130=(($128+12)|0);
 var $131=HEAP32[(($130)>>2)];
 var $132=(($128+16)|0);
 var $133=HEAP32[(($132)>>2)];
 var $134=($131|0)==($133|0);
 if($134){label=41;break;}else{label=42;break;}
 case 41: 
 var $136=$128;
 var $137=HEAP32[(($136)>>2)];
 var $138=(($137+36)|0);
 var $139=HEAP32[(($138)>>2)];
 var $140=FUNCTION_TABLE[$139]($128);
 var $_0_i_i34=$140;label=43;break;
 case 42: 
 var $142=HEAP32[(($131)>>2)];
 var $_0_i_i34=$142;label=43;break;
 case 43: 
 var $_0_i_i34;
 var $143=HEAP32[(($59)>>2)];
 var $144=(($143+12)|0);
 var $145=HEAP32[(($144)>>2)];
 var $146=FUNCTION_TABLE[$145]($__ct,2048,$_0_i_i34);
 if($146){label=44;break;}else{var $_021=$__r_0;label=63;break;}
 case 44: 
 var $148=((($__r_0)*(10))&-1);
 var $149=HEAP32[(($68)>>2)];
 var $150=(($149+52)|0);
 var $151=HEAP32[(($150)>>2)];
 var $152=FUNCTION_TABLE[$151]($__ct,$_0_i_i34,0);
 var $153=(($152<<24)>>24);
 var $154=((($153)+($148))|0);
 var $155=HEAP32[(($1)>>2)];
 var $156=(($155+12)|0);
 var $157=HEAP32[(($156)>>2)];
 var $158=(($155+16)|0);
 var $159=HEAP32[(($158)>>2)];
 var $160=($157|0)==($159|0);
 if($160){label=45;break;}else{label=46;break;}
 case 45: 
 var $162=$155;
 var $163=HEAP32[(($162)>>2)];
 var $164=(($163+40)|0);
 var $165=HEAP32[(($164)>>2)];
 var $166=FUNCTION_TABLE[$165]($155);
 var $__r_0_in=$154;var $_0_in=$_0;var $88=$125;var $_pre_i4_i_i30=$_pre_i4_i_i45;label=25;break;
 case 46: 
 var $168=(($157+4)|0);
 HEAP32[(($156)>>2)]=$168;
 var $__r_0_in=$154;var $_0_in=$_0;var $88=$125;var $_pre_i4_i_i30=$_pre_i4_i_i45;label=25;break;
 case 47: 
 var $170=($128|0)==0;
 if($170){var $187=1;label=54;break;}else{label=48;break;}
 case 48: 
 var $172=(($128+12)|0);
 var $173=HEAP32[(($172)>>2)];
 var $174=(($128+16)|0);
 var $175=HEAP32[(($174)>>2)];
 var $176=($173|0)==($175|0);
 if($176){label=49;break;}else{label=50;break;}
 case 49: 
 var $178=$128;
 var $179=HEAP32[(($178)>>2)];
 var $180=(($179+36)|0);
 var $181=HEAP32[(($180)>>2)];
 var $182=FUNCTION_TABLE[$181]($128);
 var $_0_i_i_i_i37=$182;label=51;break;
 case 50: 
 var $184=HEAP32[(($173)>>2)];
 var $_0_i_i_i_i37=$184;label=51;break;
 case 51: 
 var $_0_i_i_i_i37;
 var $185=($_0_i_i_i_i37|0)==-1;
 if($185){label=53;break;}else{label=52;break;}
 case 52: 
 var $_pre_i_i_i39=HEAP32[(($1)>>2)];
 var $phitmp_i_i_i40=($_pre_i_i_i39|0)==0;
 var $187=$phitmp_i_i_i40;label=54;break;
 case 53: 
 HEAP32[(($1)>>2)]=0;
 var $187=1;label=54;break;
 case 54: 
 var $187;
 var $188=($_pre_i4_i_i45|0)==0;
 if($188){label=60;break;}else{label=55;break;}
 case 55: 
 var $190=(($_pre_i4_i_i45+12)|0);
 var $191=HEAP32[(($190)>>2)];
 var $192=(($_pre_i4_i_i45+16)|0);
 var $193=HEAP32[(($192)>>2)];
 var $194=($191|0)==($193|0);
 if($194){label=56;break;}else{label=57;break;}
 case 56: 
 var $196=$_pre_i4_i_i45;
 var $197=HEAP32[(($196)>>2)];
 var $198=(($197+36)|0);
 var $199=HEAP32[(($198)>>2)];
 var $200=FUNCTION_TABLE[$199]($_pre_i4_i_i45);
 var $_0_i_i2_i_i43=$200;label=58;break;
 case 57: 
 var $202=HEAP32[(($191)>>2)];
 var $_0_i_i2_i_i43=$202;label=58;break;
 case 58: 
 var $_0_i_i2_i_i43;
 var $203=($_0_i_i2_i_i43|0)==-1;
 if($203){label=59;break;}else{label=61;break;}
 case 59: 
 HEAP32[(($21)>>2)]=0;
 label=60;break;
 case 60: 
 if($187){label=62;break;}else{var $_021=$__r_0;label=63;break;}
 case 61: 
 if($187){var $_021=$__r_0;label=63;break;}else{label=62;break;}
 case 62: 
 var $206=HEAP32[(($__err)>>2)];
 var $207=$206|2;
 HEAP32[(($__err)>>2)]=$207;
 var $_021=$__r_0;label=63;break;
 case 63: 
 var $_021;
 STACKTOP=sp;return $_021;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__18time_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEED0Ev($this){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=(($this+8)|0);
 var $2=HEAP32[(($1)>>2)];
 var $3=HEAP8[(14656)];
 var $4=(($3<<24)>>24)==0;
 if($4){label=2;break;}else{label=6;break;}
 case 2: 
 var $6=___cxa_guard_acquire(14656);
 var $7=($6|0)==0;
 if($7){label=6;break;}else{label=3;break;}
 case 3: 
 var $9=(function() { try { __THREW__ = 0; return _newlocale(2147483647,1496,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=4;break; } else { label=5;break; }
 case 4: 
 HEAP32[((12664)>>2)]=$9;

 label=6;break;
 case 5: 
 var $12$0 = ___cxa_find_matching_catch(-1, -1,0); var $12$1 = tempRet0;

 label=9;break;
 case 6: 
 var $14=HEAP32[((12664)>>2)];
 var $15=($2|0)==($14|0);
 if($15){label=10;break;}else{label=7;break;}
 case 7: 
 var $17=HEAP32[(($1)>>2)];
 (function() { try { __THREW__ = 0; return _freelocale($17) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=10;break; } else { label=8;break; }
 case 8: 
 var $19$0 = ___cxa_find_matching_catch(-1, -1,0); var $19$1 = tempRet0;
 label=9;break;
 case 9: 
 __ZSt9terminatev();
 throw "Reached an unreachable!";
 case 10: 
 var $20=(($this)|0);
 __ZNSt3__114__shared_countD2Ev($20);
 var $21=$this;
 __ZdlPv($21);
 return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__18time_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEED1Ev($this){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=(($this+8)|0);
 var $2=HEAP32[(($1)>>2)];
 var $3=HEAP8[(14656)];
 var $4=(($3<<24)>>24)==0;
 if($4){label=2;break;}else{label=6;break;}
 case 2: 
 var $6=___cxa_guard_acquire(14656);
 var $7=($6|0)==0;
 if($7){label=6;break;}else{label=3;break;}
 case 3: 
 var $9=(function() { try { __THREW__ = 0; return _newlocale(2147483647,1496,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=4;break; } else { label=5;break; }
 case 4: 
 HEAP32[((12664)>>2)]=$9;

 label=6;break;
 case 5: 
 var $12$0 = ___cxa_find_matching_catch(-1, -1,0); var $12$1 = tempRet0;

 label=9;break;
 case 6: 
 var $14=HEAP32[((12664)>>2)];
 var $15=($2|0)==($14|0);
 if($15){label=10;break;}else{label=7;break;}
 case 7: 
 var $17=HEAP32[(($1)>>2)];
 (function() { try { __THREW__ = 0; return _freelocale($17) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=10;break; } else { label=8;break; }
 case 8: 
 var $19$0 = ___cxa_find_matching_catch(-1, -1,0); var $19$1 = tempRet0;
 label=9;break;
 case 9: 
 __ZSt9terminatev();
 throw "Reached an unreachable!";
 case 10: 
 var $20=(($this)|0);
 __ZNSt3__114__shared_countD2Ev($20);
 return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__18time_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcPK2tmcc($agg_result,$this,$__s,$0,$1,$__tm,$__fmt,$__mod){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+112)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var tempParam = $__s; $__s=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__s)>>2)]=HEAP32[((tempParam)>>2)];
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $fmt_i=sp;
 var $__nar=(sp)+(8);
 var $3=(($__nar)|0);
 var $4=(($fmt_i)|0);
 HEAP8[($4)]=37;
 var $5=(($fmt_i+1)|0);
 HEAP8[($5)]=$__fmt;
 var $6=(($fmt_i+2)|0);
 HEAP8[($6)]=$__mod;
 var $7=(($fmt_i+3)|0);
 HEAP8[($7)]=0;
 var $8=(($__mod<<24)>>24)==0;
 if($8){label=3;break;}else{label=2;break;}
 case 2: 
 HEAP8[($5)]=$__mod;
 HEAP8[($6)]=$__fmt;
 label=3;break;
 case 3: 
 var $10=(($this+8)|0);
 var $11=HEAP32[(($10)>>2)];
 var $12=_strftime_l($3,100,$4,$__tm,$11);
 var $13=(($__nar+$12)|0);
 var $14=(($__s)|0);
 var $15=HEAP32[(($14)>>2)];
 var $16=($12|0)==0;
 if($16){var $39=$15;label=9;break;}else{var $_04_i_i=$3;var $18=$15;var $17=$15;label=4;break;}
 case 4: 
 var $17;
 var $18;
 var $_04_i_i;
 var $19=HEAP8[($_04_i_i)];
 var $20=($18|0)==0;
 if($20){var $36=0;var $35=$17;label=8;break;}else{label=5;break;}
 case 5: 
 var $22=(($18+24)|0);
 var $23=HEAP32[(($22)>>2)];
 var $24=(($18+28)|0);
 var $25=HEAP32[(($24)>>2)];
 var $26=($23|0)==($25|0);
 if($26){label=7;break;}else{label=6;break;}
 case 6: 
 var $27=(($23+1)|0);
 HEAP32[(($22)>>2)]=$27;
 HEAP8[($23)]=$19;
 var $36=$18;var $35=$17;label=8;break;
 case 7: 
 var $28=$18;
 var $29=HEAP32[(($28)>>2)];
 var $30=(($29+52)|0);
 var $31=HEAP32[(($30)>>2)];
 var $32=($19&255);
 var $33=FUNCTION_TABLE[$31]($18,$32);
 var $34=($33|0)==-1;
 var $__i=($34?0:$17);
 var $_8_i=($34?0:$18);
 var $36=$_8_i;var $35=$__i;label=8;break;
 case 8: 
 var $35;
 var $36;
 var $37=(($_04_i_i+1)|0);
 var $38=($37|0)==($13|0);
 if($38){var $39=$35;label=9;break;}else{var $_04_i_i=$37;var $18=$36;var $17=$35;label=4;break;}
 case 9: 
 var $39;
 var $40=(($agg_result)|0);
 HEAP32[(($40)>>2)]=$39;
 STACKTOP=sp;return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__18time_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEED0Ev($this){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=(($this+8)|0);
 var $2=HEAP32[(($1)>>2)];
 var $3=HEAP8[(14656)];
 var $4=(($3<<24)>>24)==0;
 if($4){label=2;break;}else{label=6;break;}
 case 2: 
 var $6=___cxa_guard_acquire(14656);
 var $7=($6|0)==0;
 if($7){label=6;break;}else{label=3;break;}
 case 3: 
 var $9=(function() { try { __THREW__ = 0; return _newlocale(2147483647,1496,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=4;break; } else { label=5;break; }
 case 4: 
 HEAP32[((12664)>>2)]=$9;

 label=6;break;
 case 5: 
 var $12$0 = ___cxa_find_matching_catch(-1, -1,0); var $12$1 = tempRet0;

 label=9;break;
 case 6: 
 var $14=HEAP32[((12664)>>2)];
 var $15=($2|0)==($14|0);
 if($15){label=10;break;}else{label=7;break;}
 case 7: 
 var $17=HEAP32[(($1)>>2)];
 (function() { try { __THREW__ = 0; return _freelocale($17) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=10;break; } else { label=8;break; }
 case 8: 
 var $19$0 = ___cxa_find_matching_catch(-1, -1,0); var $19$1 = tempRet0;
 label=9;break;
 case 9: 
 __ZSt9terminatev();
 throw "Reached an unreachable!";
 case 10: 
 var $20=(($this)|0);
 __ZNSt3__114__shared_countD2Ev($20);
 var $21=$this;
 __ZdlPv($21);
 return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__18time_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEED1Ev($this){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=(($this+8)|0);
 var $2=HEAP32[(($1)>>2)];
 var $3=HEAP8[(14656)];
 var $4=(($3<<24)>>24)==0;
 if($4){label=2;break;}else{label=6;break;}
 case 2: 
 var $6=___cxa_guard_acquire(14656);
 var $7=($6|0)==0;
 if($7){label=6;break;}else{label=3;break;}
 case 3: 
 var $9=(function() { try { __THREW__ = 0; return _newlocale(2147483647,1496,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=4;break; } else { label=5;break; }
 case 4: 
 HEAP32[((12664)>>2)]=$9;

 label=6;break;
 case 5: 
 var $12$0 = ___cxa_find_matching_catch(-1, -1,0); var $12$1 = tempRet0;

 label=9;break;
 case 6: 
 var $14=HEAP32[((12664)>>2)];
 var $15=($2|0)==($14|0);
 if($15){label=10;break;}else{label=7;break;}
 case 7: 
 var $17=HEAP32[(($1)>>2)];
 (function() { try { __THREW__ = 0; return _freelocale($17) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=10;break; } else { label=8;break; }
 case 8: 
 var $19$0 = ___cxa_find_matching_catch(-1, -1,0); var $19$1 = tempRet0;
 label=9;break;
 case 9: 
 __ZSt9terminatev();
 throw "Reached an unreachable!";
 case 10: 
 var $20=(($this)|0);
 __ZNSt3__114__shared_countD2Ev($20);
 return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__18time_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwPK2tmcc($agg_result,$this,$__s,$0,$1,$__tm,$__fmt,$__mod){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+408)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var tempParam = $__s; $__s=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__s)>>2)]=HEAP32[((tempParam)>>2)];
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $__nar=sp;
 var $__ne=(sp)+(400);
 var $3=(($__nar)|0);
 var $4=(($__nar+400)|0);
 HEAP32[(($__ne)>>2)]=$4;
 var $5=(($this+8)|0);
 __ZNKSt3__110__time_put8__do_putEPwRS1_PK2tmcc($5,$3,$__ne,$__tm,$__fmt,$__mod);
 var $6=HEAP32[(($__ne)>>2)];
 var $7=(($__s)|0);
 var $8=HEAP32[(($7)>>2)];
 var $9=($3|0)==($6|0);
 if($9){var $33=$8;label=8;break;}else{var $_04_i_i=$3;var $11=$8;var $10=$8;label=2;break;}
 case 2: 
 var $10;
 var $11;
 var $_04_i_i;
 var $12=HEAP32[(($_04_i_i)>>2)];
 var $13=($11|0)==0;
 if($13){var $30=0;var $29=$10;label=7;break;}else{label=3;break;}
 case 3: 
 var $15=(($11+24)|0);
 var $16=HEAP32[(($15)>>2)];
 var $17=(($11+28)|0);
 var $18=HEAP32[(($17)>>2)];
 var $19=($16|0)==($18|0);
 if($19){label=4;break;}else{label=5;break;}
 case 4: 
 var $21=$11;
 var $22=HEAP32[(($21)>>2)];
 var $23=(($22+52)|0);
 var $24=HEAP32[(($23)>>2)];
 var $25=FUNCTION_TABLE[$24]($11,$12);
 var $_0_i_i_i_i=$25;label=6;break;
 case 5: 
 var $27=(($16+4)|0);
 HEAP32[(($15)>>2)]=$27;
 HEAP32[(($16)>>2)]=$12;
 var $_0_i_i_i_i=$12;label=6;break;
 case 6: 
 var $_0_i_i_i_i;
 var $28=($_0_i_i_i_i|0)==-1;
 var $__i=($28?0:$10);
 var $_8_i=($28?0:$11);
 var $30=$_8_i;var $29=$__i;label=7;break;
 case 7: 
 var $29;
 var $30;
 var $31=(($_04_i_i+4)|0);
 var $32=($31|0)==($6|0);
 if($32){var $33=$29;label=8;break;}else{var $_04_i_i=$31;var $11=$30;var $10=$29;label=2;break;}
 case 8: 
 var $33;
 var $34=(($agg_result)|0);
 HEAP32[(($34)>>2)]=$33;
 STACKTOP=sp;return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__110__time_put8__do_putEPwRS1_PK2tmcc($this,$__wb,$__we,$__tm,$__fmt,$__mod){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+120)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $fmt_i=sp;
 var $__nar=(sp)+(8);
 var $mb=(sp)+(112);
 var $tmpcast=$mb;
 var $__nb=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var $1=(($__nar)|0);
 var $2=(($fmt_i)|0);
 HEAP8[($2)]=37;
 var $3=(($fmt_i+1)|0);
 HEAP8[($3)]=$__fmt;
 var $4=(($fmt_i+2)|0);
 HEAP8[($4)]=$__mod;
 var $5=(($fmt_i+3)|0);
 HEAP8[($5)]=0;
 var $6=(($__mod<<24)>>24)==0;
 if($6){label=3;break;}else{label=2;break;}
 case 2: 
 HEAP8[($3)]=$__mod;
 HEAP8[($4)]=$__fmt;
 label=3;break;
 case 3: 
 var $8=(($this)|0);
 var $9=HEAP32[(($8)>>2)];
 var $10=_strftime_l($1,100,$2,$__tm,$9);
 var $$etemp$0$0=0;
 var $$etemp$0$1=0;
 var $st$1$0=(($mb)|0);
 HEAP32[(($st$1$0)>>2)]=$$etemp$0$0;
 var $st$2$1=(($mb+4)|0);
 HEAP32[(($st$2$1)>>2)]=$$etemp$0$1;
 HEAP32[(($__nb)>>2)]=$1;
 var $11=HEAP32[(($__we)>>2)];
 var $12=$11;
 var $13=$__wb;
 var $14=((($12)-($13))|0);
 var $15=$14>>2;
 var $16=HEAP32[(($8)>>2)];
 var $17=_uselocale($16);
 var $18=(function() { try { __THREW__ = 0; return _mbsrtowcs($__wb,$__nb,$15,$tmpcast) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=4;break; } else { label=7;break; }
 case 4: 
 var $20=($17|0)==0;
 if($20){label=11;break;}else{label=5;break;}
 case 5: 
 var $22=(function() { try { __THREW__ = 0; return _uselocale($17) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=11;break; } else { label=6;break; }
 case 6: 
 var $24$0 = ___cxa_find_matching_catch(-1, -1,0); var $24$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
 case 7: 
 var $26$0 = ___cxa_find_matching_catch(-1, -1); var $26$1 = tempRet0;
 var $27=($17|0)==0;
 if($27){label=10;break;}else{label=8;break;}
 case 8: 
 var $29=(function() { try { __THREW__ = 0; return _uselocale($17) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=10;break; } else { label=9;break; }
 case 9: 
 var $31$0 = ___cxa_find_matching_catch(-1, -1,0); var $31$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
 case 10: 
 ___resumeException($26$0)
 case 11: 
 var $32=($18|0)==-1;
 if($32){label=12;break;}else{label=13;break;}
 case 12: 
 __ZNSt3__121__throw_runtime_errorEPKc(960);
 throw "Reached an unreachable!";
 case 13: 
 var $35=(($__wb+($18<<2))|0);
 HEAP32[(($__we)>>2)]=$35;
 STACKTOP=sp;return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__110moneypunctIcLb0EED0Ev($this){
 var label=0;


 var $1=(($this)|0);
 __ZNSt3__114__shared_countD2Ev($1);
 var $2=$this;
 __ZdlPv($2);
 return;
}


function __ZNSt3__110moneypunctIcLb0EED1Ev($this){
 var label=0;


 var $1=(($this)|0);
 __ZNSt3__114__shared_countD2Ev($1);
 return;
}


function __ZNKSt3__110moneypunctIcLb0EE16do_decimal_pointEv($this){
 var label=0;


 return 127;
}


function __ZNKSt3__110moneypunctIcLb0EE16do_thousands_sepEv($this){
 var label=0;


 return 127;
}


function __ZNKSt3__110moneypunctIcLb0EE11do_groupingEv($agg_result,$this){
 var label=0;


 var $this4_i_i_i=$agg_result;
 HEAP32[(($this4_i_i_i)>>2)]=0; HEAP32[((($this4_i_i_i)+(4))>>2)]=0; HEAP32[((($this4_i_i_i)+(8))>>2)]=0;
 return;
}


function __ZNKSt3__110moneypunctIcLb0EE14do_curr_symbolEv($agg_result,$this){
 var label=0;


 var $this4_i_i_i=$agg_result;
 HEAP32[(($this4_i_i_i)>>2)]=0; HEAP32[((($this4_i_i_i)+(4))>>2)]=0; HEAP32[((($this4_i_i_i)+(8))>>2)]=0;
 return;
}


function __ZNKSt3__110moneypunctIcLb0EE16do_positive_signEv($agg_result,$this){
 var label=0;


 var $this4_i_i_i=$agg_result;
 HEAP32[(($this4_i_i_i)>>2)]=0; HEAP32[((($this4_i_i_i)+(4))>>2)]=0; HEAP32[((($this4_i_i_i)+(8))>>2)]=0;
 return;
}


function __ZNKSt3__110moneypunctIcLb0EE16do_negative_signEv($agg_result,$this){
 var label=0;


 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEjc($agg_result,1,45);
 return;
}


function __ZNKSt3__110moneypunctIcLb0EE14do_frac_digitsEv($this){
 var label=0;


 return 0;
}


function __ZNKSt3__110moneypunctIcLb0EE13do_pos_formatEv($agg_result,$this){
 var label=0;


 var $1=$agg_result;
 tempBigInt=67109634;HEAP8[($1)]=tempBigInt&0xff;tempBigInt = tempBigInt>>8;HEAP8[((($1)+(1))|0)]=tempBigInt&0xff;tempBigInt = tempBigInt>>8;HEAP8[((($1)+(2))|0)]=tempBigInt&0xff;tempBigInt = tempBigInt>>8;HEAP8[((($1)+(3))|0)]=tempBigInt&0xff;
 return;
}


function __ZNKSt3__110moneypunctIcLb0EE13do_neg_formatEv($agg_result,$this){
 var label=0;


 var $1=$agg_result;
 tempBigInt=67109634;HEAP8[($1)]=tempBigInt&0xff;tempBigInt = tempBigInt>>8;HEAP8[((($1)+(1))|0)]=tempBigInt&0xff;tempBigInt = tempBigInt>>8;HEAP8[((($1)+(2))|0)]=tempBigInt&0xff;tempBigInt = tempBigInt>>8;HEAP8[((($1)+(3))|0)]=tempBigInt&0xff;
 return;
}


function __ZNSt3__110moneypunctIcLb1EED0Ev($this){
 var label=0;


 var $1=(($this)|0);
 __ZNSt3__114__shared_countD2Ev($1);
 var $2=$this;
 __ZdlPv($2);
 return;
}


function __ZNSt3__110moneypunctIcLb1EED1Ev($this){
 var label=0;


 var $1=(($this)|0);
 __ZNSt3__114__shared_countD2Ev($1);
 return;
}


function __ZNKSt3__110moneypunctIcLb1EE16do_decimal_pointEv($this){
 var label=0;


 return 127;
}


function __ZNKSt3__110moneypunctIcLb1EE16do_thousands_sepEv($this){
 var label=0;


 return 127;
}


function __ZNKSt3__110moneypunctIcLb1EE11do_groupingEv($agg_result,$this){
 var label=0;


 var $this4_i_i_i=$agg_result;
 HEAP32[(($this4_i_i_i)>>2)]=0; HEAP32[((($this4_i_i_i)+(4))>>2)]=0; HEAP32[((($this4_i_i_i)+(8))>>2)]=0;
 return;
}


function __ZNKSt3__110moneypunctIcLb1EE14do_curr_symbolEv($agg_result,$this){
 var label=0;


 var $this4_i_i_i=$agg_result;
 HEAP32[(($this4_i_i_i)>>2)]=0; HEAP32[((($this4_i_i_i)+(4))>>2)]=0; HEAP32[((($this4_i_i_i)+(8))>>2)]=0;
 return;
}


function __ZNKSt3__110moneypunctIcLb1EE16do_positive_signEv($agg_result,$this){
 var label=0;


 var $this4_i_i_i=$agg_result;
 HEAP32[(($this4_i_i_i)>>2)]=0; HEAP32[((($this4_i_i_i)+(4))>>2)]=0; HEAP32[((($this4_i_i_i)+(8))>>2)]=0;
 return;
}


function __ZNKSt3__110moneypunctIcLb1EE16do_negative_signEv($agg_result,$this){
 var label=0;


 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEjc($agg_result,1,45);
 return;
}


function __ZNKSt3__110moneypunctIcLb1EE14do_frac_digitsEv($this){
 var label=0;


 return 0;
}


function __ZNKSt3__110moneypunctIcLb1EE13do_pos_formatEv($agg_result,$this){
 var label=0;


 var $1=$agg_result;
 tempBigInt=67109634;HEAP8[($1)]=tempBigInt&0xff;tempBigInt = tempBigInt>>8;HEAP8[((($1)+(1))|0)]=tempBigInt&0xff;tempBigInt = tempBigInt>>8;HEAP8[((($1)+(2))|0)]=tempBigInt&0xff;tempBigInt = tempBigInt>>8;HEAP8[((($1)+(3))|0)]=tempBigInt&0xff;
 return;
}


function __ZNKSt3__110moneypunctIcLb1EE13do_neg_formatEv($agg_result,$this){
 var label=0;


 var $1=$agg_result;
 tempBigInt=67109634;HEAP8[($1)]=tempBigInt&0xff;tempBigInt = tempBigInt>>8;HEAP8[((($1)+(1))|0)]=tempBigInt&0xff;tempBigInt = tempBigInt>>8;HEAP8[((($1)+(2))|0)]=tempBigInt&0xff;tempBigInt = tempBigInt>>8;HEAP8[((($1)+(3))|0)]=tempBigInt&0xff;
 return;
}


function __ZNSt3__110moneypunctIwLb0EED0Ev($this){
 var label=0;


 var $1=(($this)|0);
 __ZNSt3__114__shared_countD2Ev($1);
 var $2=$this;
 __ZdlPv($2);
 return;
}


function __ZNSt3__110moneypunctIwLb0EED1Ev($this){
 var label=0;


 var $1=(($this)|0);
 __ZNSt3__114__shared_countD2Ev($1);
 return;
}


function __ZNKSt3__110moneypunctIwLb0EE16do_decimal_pointEv($this){
 var label=0;


 return 2147483647;
}


function __ZNKSt3__110moneypunctIwLb0EE16do_thousands_sepEv($this){
 var label=0;


 return 2147483647;
}


function __ZNKSt3__110moneypunctIwLb0EE11do_groupingEv($agg_result,$this){
 var label=0;


 var $this4_i_i_i=$agg_result;
 HEAP32[(($this4_i_i_i)>>2)]=0; HEAP32[((($this4_i_i_i)+(4))>>2)]=0; HEAP32[((($this4_i_i_i)+(8))>>2)]=0;
 return;
}


function __ZNKSt3__110moneypunctIwLb0EE14do_curr_symbolEv($agg_result,$this){
 var label=0;


 var $this4_i_i_i=$agg_result;
 HEAP32[(($this4_i_i_i)>>2)]=0; HEAP32[((($this4_i_i_i)+(4))>>2)]=0; HEAP32[((($this4_i_i_i)+(8))>>2)]=0;
 return;
}


function __ZNKSt3__110moneypunctIwLb0EE16do_positive_signEv($agg_result,$this){
 var label=0;


 var $this4_i_i_i=$agg_result;
 HEAP32[(($this4_i_i_i)>>2)]=0; HEAP32[((($this4_i_i_i)+(4))>>2)]=0; HEAP32[((($this4_i_i_i)+(8))>>2)]=0;
 return;
}


function __ZNKSt3__110moneypunctIwLb0EE16do_negative_signEv($agg_result,$this){
 var label=0;


 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6__initEjw($agg_result,1,45);
 return;
}


function __ZNKSt3__110moneypunctIwLb0EE14do_frac_digitsEv($this){
 var label=0;


 return 0;
}


function __ZNKSt3__110moneypunctIwLb0EE13do_pos_formatEv($agg_result,$this){
 var label=0;


 var $1=$agg_result;
 tempBigInt=67109634;HEAP8[($1)]=tempBigInt&0xff;tempBigInt = tempBigInt>>8;HEAP8[((($1)+(1))|0)]=tempBigInt&0xff;tempBigInt = tempBigInt>>8;HEAP8[((($1)+(2))|0)]=tempBigInt&0xff;tempBigInt = tempBigInt>>8;HEAP8[((($1)+(3))|0)]=tempBigInt&0xff;
 return;
}


function __ZNKSt3__110moneypunctIwLb0EE13do_neg_formatEv($agg_result,$this){
 var label=0;


 var $1=$agg_result;
 tempBigInt=67109634;HEAP8[($1)]=tempBigInt&0xff;tempBigInt = tempBigInt>>8;HEAP8[((($1)+(1))|0)]=tempBigInt&0xff;tempBigInt = tempBigInt>>8;HEAP8[((($1)+(2))|0)]=tempBigInt&0xff;tempBigInt = tempBigInt>>8;HEAP8[((($1)+(3))|0)]=tempBigInt&0xff;
 return;
}


function __ZNSt3__110moneypunctIwLb1EED0Ev($this){
 var label=0;


 var $1=(($this)|0);
 __ZNSt3__114__shared_countD2Ev($1);
 var $2=$this;
 __ZdlPv($2);
 return;
}


function __ZNSt3__110moneypunctIwLb1EED1Ev($this){
 var label=0;


 var $1=(($this)|0);
 __ZNSt3__114__shared_countD2Ev($1);
 return;
}


function __ZNKSt3__110moneypunctIwLb1EE16do_decimal_pointEv($this){
 var label=0;


 return 2147483647;
}


function __ZNKSt3__110moneypunctIwLb1EE16do_thousands_sepEv($this){
 var label=0;


 return 2147483647;
}


function __ZNKSt3__110moneypunctIwLb1EE11do_groupingEv($agg_result,$this){
 var label=0;


 var $this4_i_i_i=$agg_result;
 HEAP32[(($this4_i_i_i)>>2)]=0; HEAP32[((($this4_i_i_i)+(4))>>2)]=0; HEAP32[((($this4_i_i_i)+(8))>>2)]=0;
 return;
}


function __ZNKSt3__110moneypunctIwLb1EE14do_curr_symbolEv($agg_result,$this){
 var label=0;


 var $this4_i_i_i=$agg_result;
 HEAP32[(($this4_i_i_i)>>2)]=0; HEAP32[((($this4_i_i_i)+(4))>>2)]=0; HEAP32[((($this4_i_i_i)+(8))>>2)]=0;
 return;
}


function __ZNKSt3__110moneypunctIwLb1EE16do_positive_signEv($agg_result,$this){
 var label=0;


 var $this4_i_i_i=$agg_result;
 HEAP32[(($this4_i_i_i)>>2)]=0; HEAP32[((($this4_i_i_i)+(4))>>2)]=0; HEAP32[((($this4_i_i_i)+(8))>>2)]=0;
 return;
}


function __ZNKSt3__110moneypunctIwLb1EE16do_negative_signEv($agg_result,$this){
 var label=0;


 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6__initEjw($agg_result,1,45);
 return;
}


function __ZNKSt3__110moneypunctIwLb1EE14do_frac_digitsEv($this){
 var label=0;


 return 0;
}


function __ZNKSt3__110moneypunctIwLb1EE13do_pos_formatEv($agg_result,$this){
 var label=0;


 var $1=$agg_result;
 tempBigInt=67109634;HEAP8[($1)]=tempBigInt&0xff;tempBigInt = tempBigInt>>8;HEAP8[((($1)+(1))|0)]=tempBigInt&0xff;tempBigInt = tempBigInt>>8;HEAP8[((($1)+(2))|0)]=tempBigInt&0xff;tempBigInt = tempBigInt>>8;HEAP8[((($1)+(3))|0)]=tempBigInt&0xff;
 return;
}


function __ZNKSt3__110moneypunctIwLb1EE13do_neg_formatEv($agg_result,$this){
 var label=0;


 var $1=$agg_result;
 tempBigInt=67109634;HEAP8[($1)]=tempBigInt&0xff;tempBigInt = tempBigInt>>8;HEAP8[((($1)+(1))|0)]=tempBigInt&0xff;tempBigInt = tempBigInt>>8;HEAP8[((($1)+(2))|0)]=tempBigInt&0xff;tempBigInt = tempBigInt>>8;HEAP8[((($1)+(3))|0)]=tempBigInt&0xff;
 return;
}


function __ZNSt3__19money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEED0Ev($this){
 var label=0;


 var $1=(($this)|0);
 __ZNSt3__114__shared_countD2Ev($1);
 var $2=$this;
 __ZdlPv($2);
 return;
}


function __ZNSt3__19money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEED1Ev($this){
 var label=0;


 var $1=(($this)|0);
 __ZNSt3__114__shared_countD2Ev($1);
 return;
}


function __ZNKSt3__19money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_bRNS_8ios_baseERjRe($agg_result,$this,$__b,$__e,$__intl,$__iob,$__err,$__v){
 var label=0;
 var tempVarArgs=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+280)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var tempParam = $__b; $__b=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__b)>>2)]=HEAP32[((tempParam)>>2)];
 var tempParam = $__e; $__e=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $__p_i_i_i_i=sp;
 var $__wbuf=(sp)+(16);
 var $__wb=(sp)+(120);
 var $__wn=(sp)+(128);
 var $__loc=(sp)+(136);
 var $__neg=(sp)+(144);
 var $1=(sp)+(152);
 var $__atoms=(sp)+(160);
 var $__nbuf=(sp)+(176);
 var $2=(($__wbuf)|0);
 var $3=(($__wb)|0);
 HEAP32[(($3)>>2)]=$2;
 var $4=(($__wb+4)|0);
 HEAP32[(($4)>>2)]=440;
 var $5=(($__wbuf+100)|0);
 (function() { try { __THREW__ = 0; return __ZNKSt3__18ios_base6getlocEv($__loc,$__iob) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=2;break; } else { label=14;break; }
 case 2: 
 var $7=(($__loc)|0);
 var $8=HEAP32[(($7)>>2)];
 var $9=$__p_i_i_i_i;
 var $10=HEAP32[((14096)>>2)];
 var $11=($10|0)==-1;
 if($11){label=4;break;}else{label=3;break;}
 case 3: 
 var $_sroa_01_0___p67_i_idx_i_i_i=(($__p_i_i_i_i)|0);
 HEAP32[(($_sroa_01_0___p67_i_idx_i_i_i)>>2)]=14096;
 var $_sroa_12_4___p67_i_idx3_i_i_i=(($__p_i_i_i_i+4)|0);
 HEAP32[(($_sroa_12_4___p67_i_idx3_i_i_i)>>2)]=(28);
 var $_sroa_2_8___p67_i_idx4_i_i_i=(($__p_i_i_i_i+8)|0);
 HEAP32[(($_sroa_2_8___p67_i_idx4_i_i_i)>>2)]=0;
 (function() { try { __THREW__ = 0; return __ZNSt3__111__call_onceERVmPvPFvS2_E(14096,$9,260) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=4;break; } else { label=15;break; }
 case 4: 
 var $13=HEAP32[((14100)>>2)];
 var $14=((($13)-(1))|0);
 var $15=(($8+12)|0);
 var $16=HEAP32[(($15)>>2)];
 var $17=(($8+8)|0);
 var $18=HEAP32[(($17)>>2)];
 var $19=$16;
 var $20=$18;
 var $21=((($19)-($20))|0);
 var $22=$21>>2;
 var $23=($22>>>0)>($14>>>0);
 if($23){label=5;break;}else{label=6;break;}
 case 5: 
 var $24=(($18+($14<<2))|0);
 var $25=HEAP32[(($24)>>2)];
 var $26=($25|0)==0;
 if($26){label=6;break;}else{label=8;break;}
 case 6: 
 var $27=___cxa_allocate_exception(4);
 var $28=$27;
 __ZNSt8bad_castC2Ev($28);
 (function() { try { __THREW__ = 0; return ___cxa_throw($27,8960,(368)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=7;break; } else { label=15;break; }
 case 7: 
 throw "Reached an unreachable!";
 case 8: 
 var $30=$25;
 HEAP8[($__neg)]=0;
 var $31=(($__e)|0);
 var $32=HEAP32[(($31)>>2)];
 var $33=(($1)|0);
 HEAP32[(($33)>>2)]=$32;
 var $34=(($__iob+4)|0);
 var $35=HEAP32[(($34)>>2)];
 var $36=(function() { try { __THREW__ = 0; return __ZNSt3__19money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE8__do_getERS4_S4_bRKNS_6localeEjRjRbRKNS_5ctypeIcEERNS_10unique_ptrIcPFvPvEEERPcSM_($__b,$1,$__intl,$__loc,$35,$__err,$__neg,$30,$__wb,$__wn,$5) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=9;break; } else { label=15;break; }
 case 9: 
 if($36){label=10;break;}else{label=34;break;}
 case 10: 
 var $39=(($__atoms)|0);
 var $40=$25;
 var $41=HEAP32[(($40)>>2)];
 var $42=(($41+32)|0);
 var $43=HEAP32[(($42)>>2)];
 var $44=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$43]($30,2632,2642,$39) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=11;break; } else { label=15;break; }
 case 11: 
 var $45=(($__nbuf)|0);
 var $46=HEAP32[(($__wn)>>2)];
 var $47=HEAP32[(($3)>>2)];
 var $48=$46;
 var $49=$47;
 var $50=((($48)-($49))|0);
 var $51=($50|0)>98;
 if($51){label=12;break;}else{var $__nc_0=$45;var $72=0;label=19;break;}
 case 12: 
 var $52=((($50)+(2))|0);
 var $53=_malloc($52);
 var $54=($53|0)==0;
 if($54){label=13;break;}else{var $__nc_0=$53;var $72=$53;label=19;break;}
 case 13: 
 (function() { try { __THREW__ = 0; return __ZSt17__throw_bad_allocv() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $__nc_0=0;var $72=0;label=19;break; } else { var $64=0;label=16;break; }
 case 14: 
 var $56$0 = ___cxa_find_matching_catch(-1, -1); var $56$1 = tempRet0;
 var $57=$56$0;
 var $58=$56$1;
 HEAP32[(($3)>>2)]=0;
 var $161=$2;var $_11636=$58;var $_138=$57;var $160=440;label=54;break;
 case 15: 
 var $60$0 = ___cxa_find_matching_catch(-1, -1); var $60$1 = tempRet0;
 var $61=$60$0;
 var $62=$60$1;
 var $_0=$61;var $_015=$62;label=52;break;
 case 16: 
 var $64;
 var $65$0 = ___cxa_find_matching_catch(-1, -1); var $65$1 = tempRet0;
 var $eh_lpad_body$1=$65$1;var $eh_lpad_body$0=$65$0;var $66=$64;label=17;break;
 case 17: 
 var $66;
 var $eh_lpad_body$0;
 var $eh_lpad_body$1;
 var $67=$eh_lpad_body$0;
 var $68=$eh_lpad_body$1;
 var $69=($66|0)==0;
 if($69){var $_0=$67;var $_015=$68;label=52;break;}else{label=18;break;}
 case 18: 
 _free($66);
 var $_0=$67;var $_015=$68;label=52;break;
 case 19: 
 var $72;
 var $__nc_0;
 var $73=HEAP8[($__neg)];
 var $74=(($73<<24)>>24)==0;
 if($74){var $__nc_1=$__nc_0;label=21;break;}else{label=20;break;}
 case 20: 
 var $76=(($__nc_0+1)|0);
 HEAP8[($__nc_0)]=45;
 var $__nc_1=$76;label=21;break;
 case 21: 
 var $__nc_1;
 var $78=($47>>>0)<($46>>>0);
 if($78){label=22;break;}else{var $__nc_2_lcssa=$__nc_1;label=27;break;}
 case 22: 
 var $79=(($__atoms+10)|0);
 var $80=$__atoms;
 var $__nc_232=$__nc_1;var $__w_033=$47;label=23;break;
 case 23: 
 var $__w_033;
 var $__nc_232;
 var $_0_i=$39;label=24;break;
 case 24: 
 var $_0_i;
 var $83=($_0_i|0)==($79|0);
 if($83){var $_0_lcssa_i=$79;label=26;break;}else{label=25;break;}
 case 25: 
 var $85=HEAP8[($_0_i)];
 var $86=HEAP8[($__w_033)];
 var $87=(($85<<24)>>24)==(($86<<24)>>24);
 var $88=(($_0_i+1)|0);
 if($87){var $_0_lcssa_i=$_0_i;label=26;break;}else{var $_0_i=$88;label=24;break;}
 case 26: 
 var $_0_lcssa_i;
 var $89=$_0_lcssa_i;
 var $90=((($89)-($80))|0);
 var $91=((2632+$90)|0);
 var $92=HEAP8[($91)];
 HEAP8[($__nc_232)]=$92;
 var $93=(($__w_033+1)|0);
 var $94=(($__nc_232+1)|0);
 var $95=HEAP32[(($__wn)>>2)];
 var $96=($93>>>0)<($95>>>0);
 if($96){var $__nc_232=$94;var $__w_033=$93;label=23;break;}else{var $__nc_2_lcssa=$94;label=27;break;}
 case 27: 
 var $__nc_2_lcssa;
 HEAP8[($__nc_2_lcssa)]=0;
 var $97=_sscanf($45,1576,(tempVarArgs=STACKTOP,STACKTOP = (STACKTOP + 8)|0,(assert((STACKTOP|0) < (STACK_MAX|0))|0),HEAP32[((tempVarArgs)>>2)]=$__v,tempVarArgs)); STACKTOP=tempVarArgs;
 var $98=($97|0)==1;
 if($98){label=32;break;}else{label=28;break;}
 case 28: 
 var $100=___cxa_allocate_exception(8);
 var $101=$100;
 (function() { try { __THREW__ = 0; return __ZNSt13runtime_errorC2EPKc($101,1544) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=29;break; } else { label=31;break; }
 case 29: 
 (function() { try { __THREW__ = 0; return ___cxa_throw($100,8976,(46)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=30;break; } else { var $64=$72;label=16;break; }
 case 30: 
 throw "Reached an unreachable!";
 case 31: 
 var $104$0 = ___cxa_find_matching_catch(-1, -1); var $104$1 = tempRet0;
 ___cxa_free_exception($100);
 var $eh_lpad_body$1=$104$1;var $eh_lpad_body$0=$104$0;var $66=$72;label=17;break;
 case 32: 
 var $106=($72|0)==0;
 if($106){label=34;break;}else{label=33;break;}
 case 33: 
 _free($72);
 label=34;break;
 case 34: 
 var $108=(($__b)|0);
 var $109=HEAP32[(($108)>>2)];
 var $110=($109|0)==0;
 if($110){var $124=0;label=39;break;}else{label=35;break;}
 case 35: 
 var $112=(($109+12)|0);
 var $113=HEAP32[(($112)>>2)];
 var $114=(($109+16)|0);
 var $115=HEAP32[(($114)>>2)];
 var $116=($113|0)==($115|0);
 if($116){label=36;break;}else{var $124=$109;label=39;break;}
 case 36: 
 var $117=$109;
 var $118=HEAP32[(($117)>>2)];
 var $119=(($118+36)|0);
 var $120=HEAP32[(($119)>>2)];
 var $121=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$120]($109) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=37;break; } else { label=15;break; }
 case 37: 
 var $122=($121|0)==-1;
 if($122){label=38;break;}else{var $124=$109;label=39;break;}
 case 38: 
 HEAP32[(($108)>>2)]=0;
 var $124=0;label=39;break;
 case 39: 
 var $124;
 var $125=($124|0)==0;
 var $126=HEAP32[(($31)>>2)];
 var $127=($126|0)==0;
 if($127){label=45;break;}else{label=40;break;}
 case 40: 
 var $129=(($126+12)|0);
 var $130=HEAP32[(($129)>>2)];
 var $131=(($126+16)|0);
 var $132=HEAP32[(($131)>>2)];
 var $133=($130|0)==($132|0);
 if($133){label=42;break;}else{label=41;break;}
 case 41: 
 if($125){label=48;break;}else{label=47;break;}
 case 42: 
 var $134=$126;
 var $135=HEAP32[(($134)>>2)];
 var $136=(($135+36)|0);
 var $137=HEAP32[(($136)>>2)];
 var $138=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$137]($126) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=43;break; } else { label=15;break; }
 case 43: 
 var $139=($138|0)==-1;
 if($139){label=44;break;}else{label=46;break;}
 case 44: 
 HEAP32[(($31)>>2)]=0;
 label=45;break;
 case 45: 
 if($125){label=47;break;}else{label=48;break;}
 case 46: 
 if($125){label=48;break;}else{label=47;break;}
 case 47: 
 var $142=HEAP32[(($__err)>>2)];
 var $143=$142|2;
 HEAP32[(($__err)>>2)]=$143;
 label=48;break;
 case 48: 
 var $145=(($agg_result)|0);
 HEAP32[(($145)>>2)]=$124;
 var $146=HEAP32[(($7)>>2)];
 var $147=(($146)|0);
 var $148=__ZNSt3__114__shared_count16__release_sharedEv($147);
 var $149=HEAP32[(($3)>>2)];
 HEAP32[(($3)>>2)]=0;
 var $150=($149|0)==0;
 if($150){label=51;break;}else{label=49;break;}
 case 49: 
 var $152=HEAP32[(($4)>>2)];
 (function() { try { __THREW__ = 0; return FUNCTION_TABLE[$152]($149) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=51;break; } else { label=50;break; }
 case 50: 
 var $154$0 = ___cxa_find_matching_catch(-1, -1,0); var $154$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
 case 51: 
 STACKTOP=sp;return;
 case 52: 
 var $_015;
 var $_0;
 var $155=HEAP32[(($7)>>2)];
 var $156=(($155)|0);
 var $157=__ZNSt3__114__shared_count16__release_sharedEv($156);
 var $_pre=HEAP32[(($3)>>2)];
 HEAP32[(($3)>>2)]=0;
 var $158=($_pre|0)==0;
 if($158){var $_11637=$_015;var $_139=$_0;label=56;break;}else{label=53;break;}
 case 53: 
 var $_pre41=HEAP32[(($4)>>2)];
 var $161=$_pre;var $_11636=$_015;var $_138=$_0;var $160=$_pre41;label=54;break;
 case 54: 
 var $160;
 var $_138;
 var $_11636;
 var $161;
 (function() { try { __THREW__ = 0; return FUNCTION_TABLE[$160]($161) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $_11637=$_11636;var $_139=$_138;label=56;break; } else { label=55;break; }
 case 55: 
 var $163$0 = ___cxa_find_matching_catch(-1, -1,0); var $163$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
 case 56: 
 var $_139;
 var $_11637;
 var $164$0=$_139;
 var $164$1=0;
 var $165$0=$164$0;
 var $165$1=$_11637;
 ___resumeException($165$0)
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__112__do_nothingEPv($0){
 var label=0;


 return;
}


function __ZNSt3__19money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE8__do_getERS4_S4_bRKNS_6localeEjRjRbRKNS_5ctypeIcEERNS_10unique_ptrIcPFvPvEEERPcSM_($__b,$__e,$__intl,$__loc,$__flags,$__err,$__neg,$__ct,$__wb,$__wn,$__we){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+520)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var tempParam = $__e; $__e=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $__gbuf=sp;
 var $__pat=(sp)+(400);
 var $__dp=(sp)+(408);
 var $__ts=(sp)+(416);
 var $__grp=(sp)+(424);
 var $__sym=(sp)+(440);
 var $__psn=(sp)+(456);
 var $__nsn=(sp)+(472);
 var $__spaces=(sp)+(488);
 var $__fd=(sp)+(504);
 var $__et=(sp)+(512);
 var $1=(($__gbuf)|0);
 var $this4_i_i_i=$__grp;
 HEAP32[(($this4_i_i_i)>>2)]=0; HEAP32[((($this4_i_i_i)+(4))>>2)]=0; HEAP32[((($this4_i_i_i)+(8))>>2)]=0;
 var $this4_i_i_i92=$__sym;
 HEAP32[(($this4_i_i_i92)>>2)]=0; HEAP32[((($this4_i_i_i92)+(4))>>2)]=0; HEAP32[((($this4_i_i_i92)+(8))>>2)]=0;
 var $this4_i_i_i93=$__psn;
 HEAP32[(($this4_i_i_i93)>>2)]=0; HEAP32[((($this4_i_i_i93)+(4))>>2)]=0; HEAP32[((($this4_i_i_i93)+(8))>>2)]=0;
 var $this4_i_i_i95=$__nsn;
 HEAP32[(($this4_i_i_i95)>>2)]=0; HEAP32[((($this4_i_i_i95)+(4))>>2)]=0; HEAP32[((($this4_i_i_i95)+(8))>>2)]=0;
 var $this4_i_i_i98=$__spaces;
 HEAP32[(($this4_i_i_i98)>>2)]=0; HEAP32[((($this4_i_i_i98)+(4))>>2)]=0; HEAP32[((($this4_i_i_i98)+(8))>>2)]=0;
 (function() { try { __THREW__ = 0; return __ZNSt3__111__money_getIcE13__gather_infoEbRKNS_6localeERNS_10money_base7patternERcS8_RNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEESF_SF_SF_Ri($__intl,$__loc,$__pat,$__dp,$__ts,$__grp,$__sym,$__psn,$__nsn,$__fd) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=2;break; } else { label=24;break; }
 case 2: 
 var $3=(($__gbuf+400)|0);
 var $4=(($__wb)|0);
 var $5=HEAP32[(($4)>>2)];
 HEAP32[(($__wn)>>2)]=$5;
 var $6=(($__b)|0);
 var $7=(($__e)|0);
 var $8=(($__ct+8)|0);
 var $9=$__nsn;
 var $10=(($9+1)|0);
 var $11=(($__nsn+4)|0);
 var $12=(($__nsn+8)|0);
 var $13=$__psn;
 var $14=(($13+1)|0);
 var $15=(($__psn+4)|0);
 var $16=(($__psn+8)|0);
 var $17=$__flags&512;
 var $18=($17|0)!=0;
 var $19=$__sym;
 var $20=(($19+1)|0);
 var $21=(($__sym+8)|0);
 var $22=(($__sym+4)|0);
 var $23=$__spaces;
 var $24=(($23+1)|0);
 var $25=(($__spaces+8)|0);
 var $26=(($__spaces+4)|0);
 var $27=(($__pat+3)|0);
 var $28=(($__grp+4)|0);
 var $29=(($__wb+4)|0);
 var $__we350484=$__we;var $_ZNSt3__112__do_nothingEPv342487=440;var $31=$1;var $__gb_sroa_0_0_load317333491=$1;var $30=$3;var $__p_0495=0;var $__trailing_sign_0497=0;label=3;break;
 case 3: 
 var $__trailing_sign_0497;
 var $__p_0495;
 var $30;
 var $__gb_sroa_0_0_load317333491;
 var $31;
 var $_ZNSt3__112__do_nothingEPv342487;
 var $__we350484;
 var $32=HEAP32[(($6)>>2)];
 var $33=($32|0)==0;
 if($33){var $47=0;label=9;break;}else{label=4;break;}
 case 4: 
 var $35=(($32+12)|0);
 var $36=HEAP32[(($35)>>2)];
 var $37=(($32+16)|0);
 var $38=HEAP32[(($37)>>2)];
 var $39=($36|0)==($38|0);
 if($39){label=5;break;}else{var $47=$32;label=9;break;}
 case 5: 
 var $40=$32;
 var $41=HEAP32[(($40)>>2)];
 var $42=(($41+36)|0);
 var $43=HEAP32[(($42)>>2)];
 var $44=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$43]($32) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=6;break; } else { var $_ph_ph374_ph_ph_ph_ph=$31;var $_ZNSt3__112__do_nothingEPv346_ph_ph373_ph_ph_ph_ph=$_ZNSt3__112__do_nothingEPv342487;label=23;break; }
 case 6: 
 var $45=($44|0)==-1;
 if($45){label=8;break;}else{label=7;break;}
 case 7: 
 var $_pre_i_i_i102=HEAP32[(($6)>>2)];
 var $47=$_pre_i_i_i102;label=9;break;
 case 8: 
 HEAP32[(($6)>>2)]=0;
 var $47=0;label=9;break;
 case 9: 
 var $47;
 var $48=($47|0)==0;
 var $49=HEAP32[(($7)>>2)];
 var $50=($49|0)==0;
 if($50){label=15;break;}else{label=10;break;}
 case 10: 
 var $52=(($49+12)|0);
 var $53=HEAP32[(($52)>>2)];
 var $54=(($49+16)|0);
 var $55=HEAP32[(($54)>>2)];
 var $56=($53|0)==($55|0);
 if($56){label=12;break;}else{label=11;break;}
 case 11: 
 if($48){var $66=$49;label=17;break;}else{var $_ZNSt3__112__do_nothingEPv342_lcssa=$_ZNSt3__112__do_nothingEPv342487;var $_lcssa=$31;var $__gb_sroa_0_0_load317333_lcssa=$__gb_sroa_0_0_load317333491;var $__trailing_sign_0_lcssa=$__trailing_sign_0497;label=310;break;}
 case 12: 
 var $57=$49;
 var $58=HEAP32[(($57)>>2)];
 var $59=(($58+36)|0);
 var $60=HEAP32[(($59)>>2)];
 var $61=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$60]($49) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=13;break; } else { var $_ph_ph374_ph_ph_ph_ph=$31;var $_ZNSt3__112__do_nothingEPv346_ph_ph373_ph_ph_ph_ph=$_ZNSt3__112__do_nothingEPv342487;label=23;break; }
 case 13: 
 var $62=($61|0)==-1;
 if($62){label=14;break;}else{label=16;break;}
 case 14: 
 HEAP32[(($7)>>2)]=0;
 label=15;break;
 case 15: 
 if($48){var $_ZNSt3__112__do_nothingEPv342_lcssa=$_ZNSt3__112__do_nothingEPv342487;var $_lcssa=$31;var $__gb_sroa_0_0_load317333_lcssa=$__gb_sroa_0_0_load317333491;var $__trailing_sign_0_lcssa=$__trailing_sign_0497;label=310;break;}else{var $66=0;label=17;break;}
 case 16: 
 if($48){var $66=$49;label=17;break;}else{var $_ZNSt3__112__do_nothingEPv342_lcssa=$_ZNSt3__112__do_nothingEPv342487;var $_lcssa=$31;var $__gb_sroa_0_0_load317333_lcssa=$__gb_sroa_0_0_load317333491;var $__trailing_sign_0_lcssa=$__trailing_sign_0497;label=310;break;}
 case 17: 
 var $66;
 var $67=(($__pat+$__p_0495)|0);
 var $68=HEAP8[($67)];
 var $69=(($68<<24)>>24);
 switch(($69|0)){case 2:{ label=137;break;}case 4:{ var $__ng_0=0;var $580=$30;var $__gb_sroa_0_0_load317332=$__gb_sroa_0_0_load317333491;var $579=$31;var $_ZNSt3__112__do_nothingEPv341=$_ZNSt3__112__do_nothingEPv342487;var $__we349=$__we350484;label=190;break;}case 1:{ label=29;break;}case 0:{ label=42;break;}case 3:{ label=68;break;}default:{var $__trailing_sign_1=$__trailing_sign_0497;var $945=$30;var $__gb_sroa_0_0_load317334=$__gb_sroa_0_0_load317333491;var $944=$31;var $_ZNSt3__112__do_nothingEPv343=$_ZNSt3__112__do_nothingEPv342487;var $__we351=$__we350484;label=309;break;}}break;
 case 18: 
 var $lpad_loopexit$0 = ___cxa_find_matching_catch(-1, -1); var $lpad_loopexit$1 = tempRet0;
 var $lpad_phi$1=$lpad_loopexit$1;var $lpad_phi$0=$lpad_loopexit$0;var $70=$_lcssa;var $_ZNSt3__112__do_nothingEPv346=$_ZNSt3__112__do_nothingEPv342_lcssa;label=25;break;
 case 19: 
 var $_ZNSt3__112__do_nothingEPv346_ph_ph;
 var $_ph_ph;
 var $lpad_loopexit375$0 = ___cxa_find_matching_catch(-1, -1); var $lpad_loopexit375$1 = tempRet0;
 var $lpad_phi$1=$lpad_loopexit375$1;var $lpad_phi$0=$lpad_loopexit375$0;var $70=$_ph_ph;var $_ZNSt3__112__do_nothingEPv346=$_ZNSt3__112__do_nothingEPv346_ph_ph;label=25;break;
 case 20: 
 var $lpad_loopexit397$0 = ___cxa_find_matching_catch(-1, -1); var $lpad_loopexit397$1 = tempRet0;
 var $lpad_phi$1=$lpad_loopexit397$1;var $lpad_phi$0=$lpad_loopexit397$0;var $70=$749;var $_ZNSt3__112__do_nothingEPv346=$_ZNSt3__112__do_nothingEPv344;label=25;break;
 case 21: 
 var $lpad_loopexit403$0 = ___cxa_find_matching_catch(-1, -1); var $lpad_loopexit403$1 = tempRet0;
 var $lpad_phi$1=$lpad_loopexit403$1;var $lpad_phi$0=$lpad_loopexit403$0;var $70=$31;var $_ZNSt3__112__do_nothingEPv346=$_ZNSt3__112__do_nothingEPv342487;label=25;break;
 case 22: 
 var $lpad_loopexit408$0 = ___cxa_find_matching_catch(-1, -1); var $lpad_loopexit408$1 = tempRet0;
 var $lpad_phi$1=$lpad_loopexit408$1;var $lpad_phi$0=$lpad_loopexit408$0;var $70=$31;var $_ZNSt3__112__do_nothingEPv346=$_ZNSt3__112__do_nothingEPv342487;label=25;break;
 case 23: 
 var $_ZNSt3__112__do_nothingEPv346_ph_ph373_ph_ph_ph_ph;
 var $_ph_ph374_ph_ph_ph_ph;
 var $lpad_loopexit410$0 = ___cxa_find_matching_catch(-1, -1); var $lpad_loopexit410$1 = tempRet0;
 var $lpad_phi$1=$lpad_loopexit410$1;var $lpad_phi$0=$lpad_loopexit410$0;var $70=$_ph_ph374_ph_ph_ph_ph;var $_ZNSt3__112__do_nothingEPv346=$_ZNSt3__112__do_nothingEPv346_ph_ph373_ph_ph_ph_ph;label=25;break;
 case 24: 
 var $lpad_nonloopexit411$0 = ___cxa_find_matching_catch(-1, -1); var $lpad_nonloopexit411$1 = tempRet0;
 var $lpad_phi$1=$lpad_nonloopexit411$1;var $lpad_phi$0=$lpad_nonloopexit411$0;var $70=$1;var $_ZNSt3__112__do_nothingEPv346=440;label=25;break;
 case 25: 
 var $_ZNSt3__112__do_nothingEPv346;
 var $70;
 var $lpad_phi$0;
 var $lpad_phi$1;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__spaces);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__nsn);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__psn);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__sym);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grp);
 var $71=($70|0)==0;
 if($71){label=28;break;}else{label=26;break;}
 case 26: 
 var $73=$70;
 (function() { try { __THREW__ = 0; return FUNCTION_TABLE[$_ZNSt3__112__do_nothingEPv346]($73) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=28;break; } else { label=27;break; }
 case 27: 
 var $75$0 = ___cxa_find_matching_catch(-1, -1,0); var $75$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
 case 28: 
 ___resumeException($lpad_phi$0)
 case 29: 
 var $cond=($__p_0495|0)==3;
 if($cond){var $_ZNSt3__112__do_nothingEPv342_lcssa=$_ZNSt3__112__do_nothingEPv342487;var $_lcssa=$31;var $__gb_sroa_0_0_load317333_lcssa=$__gb_sroa_0_0_load317333491;var $__trailing_sign_0_lcssa=$__trailing_sign_0497;label=310;break;}else{label=30;break;}
 case 30: 
 var $78=HEAP32[(($6)>>2)];
 var $79=(($78+12)|0);
 var $80=HEAP32[(($79)>>2)];
 var $81=(($78+16)|0);
 var $82=HEAP32[(($81)>>2)];
 var $83=($80|0)==($82|0);
 if($83){label=31;break;}else{label=33;break;}
 case 31: 
 var $85=$78;
 var $86=HEAP32[(($85)>>2)];
 var $87=(($86+36)|0);
 var $88=HEAP32[(($87)>>2)];
 var $89=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$88]($78) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=32;break; } else { var $_ph_ph374_ph_ph_ph_ph=$31;var $_ZNSt3__112__do_nothingEPv346_ph_ph373_ph_ph_ph_ph=$_ZNSt3__112__do_nothingEPv342487;label=23;break; }
 case 32: 
 var $extract_t_i112=(($89)&255);
 var $_0_i_off0_i113=$extract_t_i112;label=34;break;
 case 33: 
 var $91=HEAP8[($80)];
 var $_0_i_off0_i113=$91;label=34;break;
 case 34: 
 var $_0_i_off0_i113;
 var $92=(($_0_i_off0_i113<<24)>>24)<0;
 if($92){label=41;break;}else{label=35;break;}
 case 35: 
 var $93=(($_0_i_off0_i113<<24)>>24);
 var $94=HEAP32[(($8)>>2)];
 var $95=(($94+($93<<1))|0);
 var $96=HEAP16[(($95)>>1)];
 var $97=$96&8192;
 var $98=(($97<<16)>>16)==0;
 if($98){label=41;break;}else{label=36;break;}
 case 36: 
 var $100=HEAP32[(($6)>>2)];
 var $101=(($100+12)|0);
 var $102=HEAP32[(($101)>>2)];
 var $103=(($100+16)|0);
 var $104=HEAP32[(($103)>>2)];
 var $105=($102|0)==($104|0);
 if($105){label=37;break;}else{label=39;break;}
 case 37: 
 var $107=$100;
 var $108=HEAP32[(($107)>>2)];
 var $109=(($108+40)|0);
 var $110=HEAP32[(($109)>>2)];
 var $111=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$110]($100) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=38;break; } else { var $_ph_ph374_ph_ph_ph_ph=$31;var $_ZNSt3__112__do_nothingEPv346_ph_ph373_ph_ph_ph_ph=$_ZNSt3__112__do_nothingEPv342487;label=23;break; }
 case 38: 
 var $extract_t_i116=(($111)&255);
 var $_0_i_off0_i117=$extract_t_i116;label=40;break;
 case 39: 
 var $113=(($102+1)|0);
 HEAP32[(($101)>>2)]=$113;
 var $114=HEAP8[($102)];
 var $_0_i_off0_i117=$114;label=40;break;
 case 40: 
 var $_0_i_off0_i117;
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9push_backEc($__spaces,$_0_i_off0_i117) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=42;break; } else { var $_ph_ph374_ph_ph_ph_ph=$31;var $_ZNSt3__112__do_nothingEPv346_ph_ph373_ph_ph_ph_ph=$_ZNSt3__112__do_nothingEPv342487;label=23;break; }
 case 41: 
 var $115=HEAP32[(($__err)>>2)];
 var $116=$115|4;
 HEAP32[(($__err)>>2)]=$116;
 var $_0=0;var $1047=$31;var $_ZNSt3__112__do_nothingEPv=$_ZNSt3__112__do_nothingEPv342487;label=344;break;
 case 42: 
 var $118=($__p_0495|0)==3;
 if($118){var $_ZNSt3__112__do_nothingEPv342_lcssa=$_ZNSt3__112__do_nothingEPv342487;var $_lcssa=$31;var $__gb_sroa_0_0_load317333_lcssa=$__gb_sroa_0_0_load317333491;var $__trailing_sign_0_lcssa=$__trailing_sign_0497;label=310;break;}else{var $119=$66;var $_pre_i3_i_i124=$66;label=43;break;}
 case 43: 
 var $_pre_i3_i_i124;
 var $119;
 var $120=HEAP32[(($6)>>2)];
 var $121=($120|0)==0;
 if($121){var $135=0;label=49;break;}else{label=44;break;}
 case 44: 
 var $123=(($120+12)|0);
 var $124=HEAP32[(($123)>>2)];
 var $125=(($120+16)|0);
 var $126=HEAP32[(($125)>>2)];
 var $127=($124|0)==($126|0);
 if($127){label=45;break;}else{var $135=$120;label=49;break;}
 case 45: 
 var $128=$120;
 var $129=HEAP32[(($128)>>2)];
 var $130=(($129+36)|0);
 var $131=HEAP32[(($130)>>2)];
 var $132=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$131]($120) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=46;break; } else { label=22;break; }
 case 46: 
 var $133=($132|0)==-1;
 if($133){label=48;break;}else{label=47;break;}
 case 47: 
 var $_pre_i_i_i120=HEAP32[(($6)>>2)];
 var $135=$_pre_i_i_i120;label=49;break;
 case 48: 
 HEAP32[(($6)>>2)]=0;
 var $135=0;label=49;break;
 case 49: 
 var $135;
 var $136=($135|0)==0;
 var $137=($119|0)==0;
 if($137){var $_pre_i3_i_i124561=$_pre_i3_i_i124;label=55;break;}else{label=50;break;}
 case 50: 
 var $139=(($119+12)|0);
 var $140=HEAP32[(($139)>>2)];
 var $141=(($119+16)|0);
 var $142=HEAP32[(($141)>>2)];
 var $143=($140|0)==($142|0);
 if($143){label=52;break;}else{label=51;break;}
 case 51: 
 if($136){var $153=$119;var $_pre_i3_i_i124563=$_pre_i3_i_i124;label=57;break;}else{var $__trailing_sign_1=$__trailing_sign_0497;var $945=$30;var $__gb_sroa_0_0_load317334=$__gb_sroa_0_0_load317333491;var $944=$31;var $_ZNSt3__112__do_nothingEPv343=$_ZNSt3__112__do_nothingEPv342487;var $__we351=$__we350484;label=309;break;}
 case 52: 
 var $144=$119;
 var $145=HEAP32[(($144)>>2)];
 var $146=(($145+36)|0);
 var $147=HEAP32[(($146)>>2)];
 var $148=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$147]($119) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=53;break; } else { label=22;break; }
 case 53: 
 var $149=($148|0)==-1;
 if($149){label=54;break;}else{label=56;break;}
 case 54: 
 HEAP32[(($7)>>2)]=0;
 var $_pre_i3_i_i124561=0;label=55;break;
 case 55: 
 var $_pre_i3_i_i124561;
 if($136){var $__trailing_sign_1=$__trailing_sign_0497;var $945=$30;var $__gb_sroa_0_0_load317334=$__gb_sroa_0_0_load317333491;var $944=$31;var $_ZNSt3__112__do_nothingEPv343=$_ZNSt3__112__do_nothingEPv342487;var $__we351=$__we350484;label=309;break;}else{var $153=0;var $_pre_i3_i_i124563=$_pre_i3_i_i124561;label=57;break;}
 case 56: 
 var $152=($_pre_i3_i_i124|0)==0;
 var $tmp_i_i126=$136^$152;
 if($tmp_i_i126){var $153=$_pre_i3_i_i124;var $_pre_i3_i_i124563=$_pre_i3_i_i124;label=57;break;}else{var $__trailing_sign_1=$__trailing_sign_0497;var $945=$30;var $__gb_sroa_0_0_load317334=$__gb_sroa_0_0_load317333491;var $944=$31;var $_ZNSt3__112__do_nothingEPv343=$_ZNSt3__112__do_nothingEPv342487;var $__we351=$__we350484;label=309;break;}
 case 57: 
 var $_pre_i3_i_i124563;
 var $153;
 var $154=HEAP32[(($6)>>2)];
 var $155=(($154+12)|0);
 var $156=HEAP32[(($155)>>2)];
 var $157=(($154+16)|0);
 var $158=HEAP32[(($157)>>2)];
 var $159=($156|0)==($158|0);
 if($159){label=58;break;}else{label=60;break;}
 case 58: 
 var $161=$154;
 var $162=HEAP32[(($161)>>2)];
 var $163=(($162+36)|0);
 var $164=HEAP32[(($163)>>2)];
 var $165=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$164]($154) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=59;break; } else { label=22;break; }
 case 59: 
 var $extract_t_i130=(($165)&255);
 var $_0_i_off0_i131=$extract_t_i130;label=61;break;
 case 60: 
 var $167=HEAP8[($156)];
 var $_0_i_off0_i131=$167;label=61;break;
 case 61: 
 var $_0_i_off0_i131;
 var $168=(($_0_i_off0_i131<<24)>>24)<0;
 if($168){var $__trailing_sign_1=$__trailing_sign_0497;var $945=$30;var $__gb_sroa_0_0_load317334=$__gb_sroa_0_0_load317333491;var $944=$31;var $_ZNSt3__112__do_nothingEPv343=$_ZNSt3__112__do_nothingEPv342487;var $__we351=$__we350484;label=309;break;}else{label=62;break;}
 case 62: 
 var $169=(($_0_i_off0_i131<<24)>>24);
 var $170=HEAP32[(($8)>>2)];
 var $171=(($170+($169<<1))|0);
 var $172=HEAP16[(($171)>>1)];
 var $173=$172&8192;
 var $174=(($173<<16)>>16)==0;
 if($174){var $__trailing_sign_1=$__trailing_sign_0497;var $945=$30;var $__gb_sroa_0_0_load317334=$__gb_sroa_0_0_load317333491;var $944=$31;var $_ZNSt3__112__do_nothingEPv343=$_ZNSt3__112__do_nothingEPv342487;var $__we351=$__we350484;label=309;break;}else{label=63;break;}
 case 63: 
 var $176=HEAP32[(($6)>>2)];
 var $177=(($176+12)|0);
 var $178=HEAP32[(($177)>>2)];
 var $179=(($176+16)|0);
 var $180=HEAP32[(($179)>>2)];
 var $181=($178|0)==($180|0);
 if($181){label=64;break;}else{label=66;break;}
 case 64: 
 var $183=$176;
 var $184=HEAP32[(($183)>>2)];
 var $185=(($184+40)|0);
 var $186=HEAP32[(($185)>>2)];
 var $187=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$186]($176) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=65;break; } else { label=22;break; }
 case 65: 
 var $extract_t_i135=(($187)&255);
 var $_0_i_off0_i136=$extract_t_i135;label=67;break;
 case 66: 
 var $189=(($178+1)|0);
 HEAP32[(($177)>>2)]=$189;
 var $190=HEAP8[($178)];
 var $_0_i_off0_i136=$190;label=67;break;
 case 67: 
 var $_0_i_off0_i136;
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9push_backEc($__spaces,$_0_i_off0_i136) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $119=$153;var $_pre_i3_i_i124=$_pre_i3_i_i124563;label=43;break; } else { label=22;break; }
 case 68: 
 var $192=HEAP8[($this4_i_i_i93)];
 var $193=$192&1;
 var $194=(($193<<24)>>24)==0;
 if($194){label=70;break;}else{label=69;break;}
 case 69: 
 var $196=HEAP32[(($15)>>2)];
 var $200=$196;label=71;break;
 case 70: 
 var $198=($192&255);
 var $199=$198>>>1;
 var $200=$199;label=71;break;
 case 71: 
 var $200;
 var $201=HEAP8[($this4_i_i_i95)];
 var $202=$201&1;
 var $203=(($202<<24)>>24)==0;
 if($203){label=73;break;}else{label=72;break;}
 case 72: 
 var $205=HEAP32[(($11)>>2)];
 var $209=$205;label=74;break;
 case 73: 
 var $207=($201&255);
 var $208=$207>>>1;
 var $209=$208;label=74;break;
 case 74: 
 var $209;
 var $210=(((-$209))|0);
 var $211=($200|0)==($210|0);
 if($211){var $__trailing_sign_1=$__trailing_sign_0497;var $945=$30;var $__gb_sroa_0_0_load317334=$__gb_sroa_0_0_load317333491;var $944=$31;var $_ZNSt3__112__do_nothingEPv343=$_ZNSt3__112__do_nothingEPv342487;var $__we351=$__we350484;label=309;break;}else{label=75;break;}
 case 75: 
 if($194){label=77;break;}else{label=76;break;}
 case 76: 
 var $214=HEAP32[(($15)>>2)];
 var $218=$214;label=78;break;
 case 77: 
 var $216=($192&255);
 var $217=$216>>>1;
 var $218=$217;label=78;break;
 case 78: 
 var $218;
 var $219=($218|0)==0;
 if($219){label=83;break;}else{label=79;break;}
 case 79: 
 if($203){label=81;break;}else{label=80;break;}
 case 80: 
 var $222=HEAP32[(($11)>>2)];
 var $226=$222;label=82;break;
 case 81: 
 var $224=($201&255);
 var $225=$224>>>1;
 var $226=$225;label=82;break;
 case 82: 
 var $226;
 var $227=($226|0)==0;
 if($227){label=83;break;}else{label=112;break;}
 case 83: 
 if($194){label=85;break;}else{label=84;break;}
 case 84: 
 var $230=HEAP32[(($15)>>2)];
 var $234=$230;label=86;break;
 case 85: 
 var $232=($192&255);
 var $233=$232>>>1;
 var $234=$233;label=86;break;
 case 86: 
 var $234;
 var $235=($234|0)==0;
 var $236=HEAP32[(($6)>>2)];
 var $237=(($236+12)|0);
 var $238=HEAP32[(($237)>>2)];
 var $239=(($236+16)|0);
 var $240=HEAP32[(($239)>>2)];
 var $241=($238|0)==($240|0);
 if($235){label=100;break;}else{label=87;break;}
 case 87: 
 if($241){label=88;break;}else{label=90;break;}
 case 88: 
 var $244=$236;
 var $245=HEAP32[(($244)>>2)];
 var $246=(($245+36)|0);
 var $247=HEAP32[(($246)>>2)];
 var $248=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$247]($236) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=89;break; } else { var $_ph_ph374_ph_ph_ph_ph=$31;var $_ZNSt3__112__do_nothingEPv346_ph_ph373_ph_ph_ph_ph=$_ZNSt3__112__do_nothingEPv342487;label=23;break; }
 case 89: 
 var $extract_t_i154=(($248)&255);
 var $_pre564=HEAP8[($this4_i_i_i93)];
 var $_0_i_off0_i155=$extract_t_i154;var $251=$_pre564;label=91;break;
 case 90: 
 var $250=HEAP8[($238)];
 var $_0_i_off0_i155=$250;var $251=$192;label=91;break;
 case 91: 
 var $251;
 var $_0_i_off0_i155;
 var $252=$251&1;
 var $253=(($252<<24)>>24)==0;
 var $254=HEAP32[(($16)>>2)];
 var $_=($253?$14:$254);
 var $255=HEAP8[($_)];
 var $256=(($_0_i_off0_i155<<24)>>24)==(($255<<24)>>24);
 if($256){label=92;break;}else{label=99;break;}
 case 92: 
 var $258=HEAP32[(($6)>>2)];
 var $259=(($258+12)|0);
 var $260=HEAP32[(($259)>>2)];
 var $261=(($258+16)|0);
 var $262=HEAP32[(($261)>>2)];
 var $263=($260|0)==($262|0);
 if($263){label=93;break;}else{label=94;break;}
 case 93: 
 var $265=$258;
 var $266=HEAP32[(($265)>>2)];
 var $267=(($266+40)|0);
 var $268=HEAP32[(($267)>>2)];
 var $269=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$268]($258) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=95;break; } else { var $_ph_ph374_ph_ph_ph_ph=$31;var $_ZNSt3__112__do_nothingEPv346_ph_ph373_ph_ph_ph_ph=$_ZNSt3__112__do_nothingEPv342487;label=23;break; }
 case 94: 
 var $271=(($260+1)|0);
 HEAP32[(($259)>>2)]=$271;
 label=95;break;
 case 95: 
 var $272=HEAP8[($this4_i_i_i93)];
 var $273=$272&1;
 var $274=(($273<<24)>>24)==0;
 if($274){label=97;break;}else{label=96;break;}
 case 96: 
 var $276=HEAP32[(($15)>>2)];
 var $280=$276;label=98;break;
 case 97: 
 var $278=($272&255);
 var $279=$278>>>1;
 var $280=$279;label=98;break;
 case 98: 
 var $280;
 var $281=($280>>>0)>1;
 var $__psn___trailing_sign_0=($281?$__psn:$__trailing_sign_0497);
 var $__trailing_sign_1=$__psn___trailing_sign_0;var $945=$30;var $__gb_sroa_0_0_load317334=$__gb_sroa_0_0_load317333491;var $944=$31;var $_ZNSt3__112__do_nothingEPv343=$_ZNSt3__112__do_nothingEPv342487;var $__we351=$__we350484;label=309;break;
 case 99: 
 HEAP8[($__neg)]=1;
 var $__trailing_sign_1=$__trailing_sign_0497;var $945=$30;var $__gb_sroa_0_0_load317334=$__gb_sroa_0_0_load317333491;var $944=$31;var $_ZNSt3__112__do_nothingEPv343=$_ZNSt3__112__do_nothingEPv342487;var $__we351=$__we350484;label=309;break;
 case 100: 
 if($241){label=101;break;}else{label=103;break;}
 case 101: 
 var $285=$236;
 var $286=HEAP32[(($285)>>2)];
 var $287=(($286+36)|0);
 var $288=HEAP32[(($287)>>2)];
 var $289=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$288]($236) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=102;break; } else { var $_ph_ph374_ph_ph_ph_ph=$31;var $_ZNSt3__112__do_nothingEPv346_ph_ph373_ph_ph_ph_ph=$_ZNSt3__112__do_nothingEPv342487;label=23;break; }
 case 102: 
 var $extract_t_i172=(($289)&255);
 var $_pre=HEAP8[($this4_i_i_i95)];
 var $_0_i_off0_i173=$extract_t_i172;var $292=$_pre;label=104;break;
 case 103: 
 var $291=HEAP8[($238)];
 var $_0_i_off0_i173=$291;var $292=$201;label=104;break;
 case 104: 
 var $292;
 var $_0_i_off0_i173;
 var $293=$292&1;
 var $294=(($293<<24)>>24)==0;
 var $295=HEAP32[(($12)>>2)];
 var $_591=($294?$10:$295);
 var $296=HEAP8[($_591)];
 var $297=(($_0_i_off0_i173<<24)>>24)==(($296<<24)>>24);
 if($297){label=105;break;}else{var $__trailing_sign_1=$__trailing_sign_0497;var $945=$30;var $__gb_sroa_0_0_load317334=$__gb_sroa_0_0_load317333491;var $944=$31;var $_ZNSt3__112__do_nothingEPv343=$_ZNSt3__112__do_nothingEPv342487;var $__we351=$__we350484;label=309;break;}
 case 105: 
 var $299=HEAP32[(($6)>>2)];
 var $300=(($299+12)|0);
 var $301=HEAP32[(($300)>>2)];
 var $302=(($299+16)|0);
 var $303=HEAP32[(($302)>>2)];
 var $304=($301|0)==($303|0);
 if($304){label=106;break;}else{label=107;break;}
 case 106: 
 var $306=$299;
 var $307=HEAP32[(($306)>>2)];
 var $308=(($307+40)|0);
 var $309=HEAP32[(($308)>>2)];
 var $310=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$309]($299) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=108;break; } else { var $_ph_ph374_ph_ph_ph_ph=$31;var $_ZNSt3__112__do_nothingEPv346_ph_ph373_ph_ph_ph_ph=$_ZNSt3__112__do_nothingEPv342487;label=23;break; }
 case 107: 
 var $312=(($301+1)|0);
 HEAP32[(($300)>>2)]=$312;
 label=108;break;
 case 108: 
 HEAP8[($__neg)]=1;
 var $313=HEAP8[($this4_i_i_i95)];
 var $314=$313&1;
 var $315=(($314<<24)>>24)==0;
 if($315){label=110;break;}else{label=109;break;}
 case 109: 
 var $317=HEAP32[(($11)>>2)];
 var $321=$317;label=111;break;
 case 110: 
 var $319=($313&255);
 var $320=$319>>>1;
 var $321=$320;label=111;break;
 case 111: 
 var $321;
 var $322=($321>>>0)>1;
 var $__nsn___trailing_sign_0=($322?$__nsn:$__trailing_sign_0497);
 var $__trailing_sign_1=$__nsn___trailing_sign_0;var $945=$30;var $__gb_sroa_0_0_load317334=$__gb_sroa_0_0_load317333491;var $944=$31;var $_ZNSt3__112__do_nothingEPv343=$_ZNSt3__112__do_nothingEPv342487;var $__we351=$__we350484;label=309;break;
 case 112: 
 var $324=HEAP32[(($6)>>2)];
 var $325=(($324+12)|0);
 var $326=HEAP32[(($325)>>2)];
 var $327=(($324+16)|0);
 var $328=HEAP32[(($327)>>2)];
 var $329=($326|0)==($328|0);
 if($329){label=113;break;}else{label=115;break;}
 case 113: 
 var $331=$324;
 var $332=HEAP32[(($331)>>2)];
 var $333=(($332+36)|0);
 var $334=HEAP32[(($333)>>2)];
 var $335=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$334]($324) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=114;break; } else { var $_ph_ph374_ph_ph_ph_ph=$31;var $_ZNSt3__112__do_nothingEPv346_ph_ph373_ph_ph_ph_ph=$_ZNSt3__112__do_nothingEPv342487;label=23;break; }
 case 114: 
 var $extract_t_i186=(($335)&255);
 var $_pre565=HEAP8[($this4_i_i_i93)];
 var $_pre703=HEAP32[(($6)>>2)];
 var $_phi_trans_insert=(($_pre703+12)|0);
 var $_pre704=HEAP32[(($_phi_trans_insert)>>2)];
 var $_phi_trans_insert705=(($_pre703+16)|0);
 var $_pre706=HEAP32[(($_phi_trans_insert705)>>2)];
 var $_0_i_off0_i187=$extract_t_i186;var $341=$_pre565;var $340=$_pre703;var $339=$_pre704;var $338=$_pre706;label=116;break;
 case 115: 
 var $337=HEAP8[($326)];
 var $_0_i_off0_i187=$337;var $341=$192;var $340=$324;var $339=$326;var $338=$328;label=116;break;
 case 116: 
 var $338;
 var $339;
 var $340;
 var $341;
 var $_0_i_off0_i187;
 var $342=$341&1;
 var $343=(($342<<24)>>24)==0;
 var $344=HEAP32[(($16)>>2)];
 var $_592=($343?$14:$344);
 var $345=HEAP8[($_592)];
 var $346=(($_0_i_off0_i187<<24)>>24)==(($345<<24)>>24);
 var $347=(($340+12)|0);
 var $348=($339|0)==($338|0);
 if($346){label=117;break;}else{label=124;break;}
 case 117: 
 if($348){label=118;break;}else{label=119;break;}
 case 118: 
 var $351=$340;
 var $352=HEAP32[(($351)>>2)];
 var $353=(($352+40)|0);
 var $354=HEAP32[(($353)>>2)];
 var $355=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$354]($340) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=120;break; } else { var $_ph_ph374_ph_ph_ph_ph=$31;var $_ZNSt3__112__do_nothingEPv346_ph_ph373_ph_ph_ph_ph=$_ZNSt3__112__do_nothingEPv342487;label=23;break; }
 case 119: 
 var $357=(($339+1)|0);
 HEAP32[(($347)>>2)]=$357;
 label=120;break;
 case 120: 
 var $358=HEAP8[($this4_i_i_i93)];
 var $359=$358&1;
 var $360=(($359<<24)>>24)==0;
 if($360){label=122;break;}else{label=121;break;}
 case 121: 
 var $362=HEAP32[(($15)>>2)];
 var $366=$362;label=123;break;
 case 122: 
 var $364=($358&255);
 var $365=$364>>>1;
 var $366=$365;label=123;break;
 case 123: 
 var $366;
 var $367=($366>>>0)>1;
 var $__psn___trailing_sign_088=($367?$__psn:$__trailing_sign_0497);
 var $__trailing_sign_1=$__psn___trailing_sign_088;var $945=$30;var $__gb_sroa_0_0_load317334=$__gb_sroa_0_0_load317333491;var $944=$31;var $_ZNSt3__112__do_nothingEPv343=$_ZNSt3__112__do_nothingEPv342487;var $__we351=$__we350484;label=309;break;
 case 124: 
 if($348){label=125;break;}else{label=127;break;}
 case 125: 
 var $370=$340;
 var $371=HEAP32[(($370)>>2)];
 var $372=(($371+36)|0);
 var $373=HEAP32[(($372)>>2)];
 var $374=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$373]($340) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=126;break; } else { var $_ph_ph374_ph_ph_ph_ph=$31;var $_ZNSt3__112__do_nothingEPv346_ph_ph373_ph_ph_ph_ph=$_ZNSt3__112__do_nothingEPv342487;label=23;break; }
 case 126: 
 var $extract_t_i205=(($374)&255);
 var $_0_i_off0_i206=$extract_t_i205;label=128;break;
 case 127: 
 var $376=HEAP8[($339)];
 var $_0_i_off0_i206=$376;label=128;break;
 case 128: 
 var $_0_i_off0_i206;
 var $377=HEAP8[($this4_i_i_i95)];
 var $378=$377&1;
 var $379=(($378<<24)>>24)==0;
 var $380=HEAP32[(($12)>>2)];
 var $_593=($379?$10:$380);
 var $381=HEAP8[($_593)];
 var $382=(($_0_i_off0_i206<<24)>>24)==(($381<<24)>>24);
 if($382){label=129;break;}else{label=136;break;}
 case 129: 
 var $384=HEAP32[(($6)>>2)];
 var $385=(($384+12)|0);
 var $386=HEAP32[(($385)>>2)];
 var $387=(($384+16)|0);
 var $388=HEAP32[(($387)>>2)];
 var $389=($386|0)==($388|0);
 if($389){label=130;break;}else{label=131;break;}
 case 130: 
 var $391=$384;
 var $392=HEAP32[(($391)>>2)];
 var $393=(($392+40)|0);
 var $394=HEAP32[(($393)>>2)];
 var $395=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$394]($384) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=132;break; } else { var $_ph_ph374_ph_ph_ph_ph=$31;var $_ZNSt3__112__do_nothingEPv346_ph_ph373_ph_ph_ph_ph=$_ZNSt3__112__do_nothingEPv342487;label=23;break; }
 case 131: 
 var $397=(($386+1)|0);
 HEAP32[(($385)>>2)]=$397;
 label=132;break;
 case 132: 
 HEAP8[($__neg)]=1;
 var $398=HEAP8[($this4_i_i_i95)];
 var $399=$398&1;
 var $400=(($399<<24)>>24)==0;
 if($400){label=134;break;}else{label=133;break;}
 case 133: 
 var $402=HEAP32[(($11)>>2)];
 var $406=$402;label=135;break;
 case 134: 
 var $404=($398&255);
 var $405=$404>>>1;
 var $406=$405;label=135;break;
 case 135: 
 var $406;
 var $407=($406>>>0)>1;
 var $__nsn___trailing_sign_089=($407?$__nsn:$__trailing_sign_0497);
 var $__trailing_sign_1=$__nsn___trailing_sign_089;var $945=$30;var $__gb_sroa_0_0_load317334=$__gb_sroa_0_0_load317333491;var $944=$31;var $_ZNSt3__112__do_nothingEPv343=$_ZNSt3__112__do_nothingEPv342487;var $__we351=$__we350484;label=309;break;
 case 136: 
 var $409=HEAP32[(($__err)>>2)];
 var $410=$409|4;
 HEAP32[(($__err)>>2)]=$410;
 var $_0=0;var $1047=$31;var $_ZNSt3__112__do_nothingEPv=$_ZNSt3__112__do_nothingEPv342487;label=344;break;
 case 137: 
 var $412=($__trailing_sign_0497|0)!=0;
 var $413=($__p_0495>>>0)<2;
 var $or_cond=$412|$413;
 if($or_cond){label=141;break;}else{label=138;break;}
 case 138: 
 var $415=($__p_0495|0)==2;
 if($415){label=139;break;}else{var $420=0;label=140;break;}
 case 139: 
 var $417=HEAP8[($27)];
 var $418=(($417<<24)>>24)!=0;
 var $420=$418;label=140;break;
 case 140: 
 var $420;
 var $brmerge=$18|$420;
 if($brmerge){label=141;break;}else{var $__trailing_sign_1=0;var $945=$30;var $__gb_sroa_0_0_load317334=$__gb_sroa_0_0_load317333491;var $944=$31;var $_ZNSt3__112__do_nothingEPv343=$_ZNSt3__112__do_nothingEPv342487;var $__we351=$__we350484;label=309;break;}
 case 141: 
 var $421=HEAP8[($this4_i_i_i92)];
 var $422=$421&1;
 var $423=(($422<<24)>>24)==0;
 var $424=HEAP32[(($21)>>2)];
 var $_594=($423?$20:$424);
 var $425=($__p_0495|0)==0;
 if($425){var $__sym_space_end_sroa_0_0_load292328=$_594;var $482=$421;var $481=$66;var $_pre_i3_i_i269=$66;label=157;break;}else{label=142;break;}
 case 142: 
 var $427=((($__p_0495)-(1))|0);
 var $428=(($__pat+$427)|0);
 var $429=HEAP8[($428)];
 var $switch=($429&255)<2;
 if($switch){label=143;break;}else{var $__sym_space_end_sroa_0_0_load292328=$_594;var $482=$421;var $481=$66;var $_pre_i3_i_i269=$66;label=157;break;}
 case 143: 
 var $430=($421&255);
 var $431=$430>>>1;
 var $432=HEAP32[(($22)>>2)];
 var $_596=($423?$431:$432);
 var $433=(($_594+$_596)|0);
 var $__sym_space_end_sroa_0_0_load292329=$_594;label=144;break;
 case 144: 
 var $__sym_space_end_sroa_0_0_load292329;
 var $434=($__sym_space_end_sroa_0_0_load292329|0)==($433|0);
 if($434){var $__sym_space_end_sroa_0_0_load292329_lcssa=$433;label=147;break;}else{label=145;break;}
 case 145: 
 var $436=HEAP8[($__sym_space_end_sroa_0_0_load292329)];
 var $437=(($436<<24)>>24)<0;
 if($437){var $__sym_space_end_sroa_0_0_load292329_lcssa=$__sym_space_end_sroa_0_0_load292329;label=147;break;}else{label=146;break;}
 case 146: 
 var $438=(($436<<24)>>24);
 var $439=HEAP32[(($8)>>2)];
 var $440=(($439+($438<<1))|0);
 var $441=HEAP16[(($440)>>1)];
 var $442=$441&8192;
 var $443=(($442<<16)>>16)==0;
 var $444=(($__sym_space_end_sroa_0_0_load292329+1)|0);
 if($443){var $__sym_space_end_sroa_0_0_load292329_lcssa=$__sym_space_end_sroa_0_0_load292329;label=147;break;}else{var $__sym_space_end_sroa_0_0_load292329=$444;label=144;break;}
 case 147: 
 var $__sym_space_end_sroa_0_0_load292329_lcssa;
 var $445=$__sym_space_end_sroa_0_0_load292329_lcssa;
 var $446=$_594;
 var $447=((($445)-($446))|0);
 var $448=HEAP8[($this4_i_i_i98)];
 var $449=$448&1;
 var $450=(($449<<24)>>24)==0;
 if($450){label=149;break;}else{label=148;break;}
 case 148: 
 var $452=HEAP32[(($26)>>2)];
 var $456=$452;label=150;break;
 case 149: 
 var $454=($448&255);
 var $455=$454>>>1;
 var $456=$455;label=150;break;
 case 150: 
 var $456;
 var $457=($447>>>0)>($456>>>0);
 if($457){var $__sym_space_end_sroa_0_0_load292328=$_594;var $482=$421;var $481=$66;var $_pre_i3_i_i269=$66;label=157;break;}else{label=151;break;}
 case 151: 
 if($450){label=153;break;}else{label=152;break;}
 case 152: 
 var $460=HEAP32[(($25)>>2)];
 var $461=HEAP32[(($26)>>2)];
 var $_sum=((($461)-($447))|0);
 var $462=(($460+$_sum)|0);
 var $469=$461;var $468=$460;var $467=$462;label=154;break;
 case 153: 
 var $464=($448&255);
 var $465=$464>>>1;
 var $_sum583=((($465)-($447))|0);
 var $466=(($23+1+$_sum583)|0);
 var $469=$465;var $468=$24;var $467=$466;label=154;break;
 case 154: 
 var $467;
 var $468;
 var $469;
 var $470=(($468+$469)|0);
 var $471=($467|0)==($470|0);
 if($471){var $__sym_space_end_sroa_0_0_load292328=$__sym_space_end_sroa_0_0_load292329_lcssa;var $482=$421;var $481=$66;var $_pre_i3_i_i269=$66;label=157;break;}else{var $473=$467;var $472=$_594;label=155;break;}
 case 155: 
 var $472;
 var $473;
 var $474=HEAP8[($473)];
 var $475=HEAP8[($472)];
 var $476=(($474<<24)>>24)==(($475<<24)>>24);
 if($476){label=156;break;}else{var $__sym_space_end_sroa_0_0_load292328=$_594;var $482=$421;var $481=$66;var $_pre_i3_i_i269=$66;label=157;break;}
 case 156: 
 var $478=(($473+1)|0);
 var $479=(($472+1)|0);
 var $480=($478|0)==($470|0);
 if($480){var $__sym_space_end_sroa_0_0_load292328=$__sym_space_end_sroa_0_0_load292329_lcssa;var $482=$421;var $481=$66;var $_pre_i3_i_i269=$66;label=157;break;}else{var $473=$478;var $472=$479;label=155;break;}
 case 157: 
 var $_pre_i3_i_i269;
 var $481;
 var $482;
 var $__sym_space_end_sroa_0_0_load292328;
 var $483=$482&1;
 var $484=(($483<<24)>>24)==0;
 if($484){label=159;break;}else{label=158;break;}
 case 158: 
 var $486=HEAP32[(($21)>>2)];
 var $487=HEAP32[(($22)>>2)];
 var $492=$487;var $491=$486;label=160;break;
 case 159: 
 var $489=($482&255);
 var $490=$489>>>1;
 var $492=$490;var $491=$20;label=160;break;
 case 160: 
 var $491;
 var $492;
 var $493=(($491+$492)|0);
 var $494=($__sym_space_end_sroa_0_0_load292328|0)==($493|0);
 if($494){label=184;break;}else{label=161;break;}
 case 161: 
 var $496=HEAP32[(($6)>>2)];
 var $497=($496|0)==0;
 if($497){var $511=0;label=167;break;}else{label=162;break;}
 case 162: 
 var $499=(($496+12)|0);
 var $500=HEAP32[(($499)>>2)];
 var $501=(($496+16)|0);
 var $502=HEAP32[(($501)>>2)];
 var $503=($500|0)==($502|0);
 if($503){label=163;break;}else{var $511=$496;label=167;break;}
 case 163: 
 var $504=$496;
 var $505=HEAP32[(($504)>>2)];
 var $506=(($505+36)|0);
 var $507=HEAP32[(($506)>>2)];
 var $508=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$507]($496) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=164;break; } else { label=21;break; }
 case 164: 
 var $509=($508|0)==-1;
 if($509){label=166;break;}else{label=165;break;}
 case 165: 
 var $_pre_i_i_i265=HEAP32[(($6)>>2)];
 var $511=$_pre_i_i_i265;label=167;break;
 case 166: 
 HEAP32[(($6)>>2)]=0;
 var $511=0;label=167;break;
 case 167: 
 var $511;
 var $512=($511|0)==0;
 var $513=($481|0)==0;
 if($513){var $_pre_i3_i_i269568=$_pre_i3_i_i269;label=173;break;}else{label=168;break;}
 case 168: 
 var $515=(($481+12)|0);
 var $516=HEAP32[(($515)>>2)];
 var $517=(($481+16)|0);
 var $518=HEAP32[(($517)>>2)];
 var $519=($516|0)==($518|0);
 if($519){label=170;break;}else{label=169;break;}
 case 169: 
 if($512){var $529=$481;var $_pre_i3_i_i269567=$_pre_i3_i_i269;label=175;break;}else{label=184;break;}
 case 170: 
 var $520=$481;
 var $521=HEAP32[(($520)>>2)];
 var $522=(($521+36)|0);
 var $523=HEAP32[(($522)>>2)];
 var $524=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$523]($481) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=171;break; } else { label=21;break; }
 case 171: 
 var $525=($524|0)==-1;
 if($525){label=172;break;}else{label=174;break;}
 case 172: 
 HEAP32[(($7)>>2)]=0;
 var $_pre_i3_i_i269568=0;label=173;break;
 case 173: 
 var $_pre_i3_i_i269568;
 if($512){label=184;break;}else{var $529=0;var $_pre_i3_i_i269567=$_pre_i3_i_i269568;label=175;break;}
 case 174: 
 var $528=($_pre_i3_i_i269|0)==0;
 var $tmp_i_i271=$512^$528;
 if($tmp_i_i271){var $529=$_pre_i3_i_i269;var $_pre_i3_i_i269567=$_pre_i3_i_i269;label=175;break;}else{label=184;break;}
 case 175: 
 var $_pre_i3_i_i269567;
 var $529;
 var $530=HEAP32[(($6)>>2)];
 var $531=(($530+12)|0);
 var $532=HEAP32[(($531)>>2)];
 var $533=(($530+16)|0);
 var $534=HEAP32[(($533)>>2)];
 var $535=($532|0)==($534|0);
 if($535){label=176;break;}else{label=178;break;}
 case 176: 
 var $537=$530;
 var $538=HEAP32[(($537)>>2)];
 var $539=(($538+36)|0);
 var $540=HEAP32[(($539)>>2)];
 var $541=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$540]($530) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=177;break; } else { label=21;break; }
 case 177: 
 var $extract_t_i260=(($541)&255);
 var $_0_i_off0_i261=$extract_t_i260;label=179;break;
 case 178: 
 var $543=HEAP8[($532)];
 var $_0_i_off0_i261=$543;label=179;break;
 case 179: 
 var $_0_i_off0_i261;
 var $544=HEAP8[($__sym_space_end_sroa_0_0_load292328)];
 var $545=(($_0_i_off0_i261<<24)>>24)==(($544<<24)>>24);
 if($545){label=180;break;}else{label=184;break;}
 case 180: 
 var $547=HEAP32[(($6)>>2)];
 var $548=(($547+12)|0);
 var $549=HEAP32[(($548)>>2)];
 var $550=(($547+16)|0);
 var $551=HEAP32[(($550)>>2)];
 var $552=($549|0)==($551|0);
 if($552){label=181;break;}else{label=182;break;}
 case 181: 
 var $554=$547;
 var $555=HEAP32[(($554)>>2)];
 var $556=(($555+40)|0);
 var $557=HEAP32[(($556)>>2)];
 var $558=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$557]($547) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=183;break; } else { label=21;break; }
 case 182: 
 var $560=(($549+1)|0);
 HEAP32[(($548)>>2)]=$560;
 label=183;break;
 case 183: 
 var $561=(($__sym_space_end_sroa_0_0_load292328+1)|0);
 var $_pre566=HEAP8[($this4_i_i_i92)];
 var $__sym_space_end_sroa_0_0_load292328=$561;var $482=$_pre566;var $481=$529;var $_pre_i3_i_i269=$_pre_i3_i_i269567;label=157;break;
 case 184: 
 if($18){label=185;break;}else{var $__trailing_sign_1=$__trailing_sign_0497;var $945=$30;var $__gb_sroa_0_0_load317334=$__gb_sroa_0_0_load317333491;var $944=$31;var $_ZNSt3__112__do_nothingEPv343=$_ZNSt3__112__do_nothingEPv342487;var $__we351=$__we350484;label=309;break;}
 case 185: 
 var $563=HEAP8[($this4_i_i_i92)];
 var $564=$563&1;
 var $565=(($564<<24)>>24)==0;
 if($565){label=187;break;}else{label=186;break;}
 case 186: 
 var $567=HEAP32[(($21)>>2)];
 var $568=HEAP32[(($22)>>2)];
 var $573=$568;var $572=$567;label=188;break;
 case 187: 
 var $570=($563&255);
 var $571=$570>>>1;
 var $573=$571;var $572=$20;label=188;break;
 case 188: 
 var $572;
 var $573;
 var $574=(($572+$573)|0);
 var $575=($__sym_space_end_sroa_0_0_load292328|0)==($574|0);
 if($575){var $__trailing_sign_1=$__trailing_sign_0497;var $945=$30;var $__gb_sroa_0_0_load317334=$__gb_sroa_0_0_load317333491;var $944=$31;var $_ZNSt3__112__do_nothingEPv343=$_ZNSt3__112__do_nothingEPv342487;var $__we351=$__we350484;label=309;break;}else{label=189;break;}
 case 189: 
 var $577=HEAP32[(($__err)>>2)];
 var $578=$577|4;
 HEAP32[(($__err)>>2)]=$578;
 var $_0=0;var $1047=$31;var $_ZNSt3__112__do_nothingEPv=$_ZNSt3__112__do_nothingEPv342487;label=344;break;
 case 190: 
 var $__we349;
 var $_ZNSt3__112__do_nothingEPv341;
 var $579;
 var $__gb_sroa_0_0_load317332;
 var $580;
 var $__ng_0;
 var $581=HEAP32[(($6)>>2)];
 var $582=($581|0)==0;
 if($582){var $596=0;label=196;break;}else{label=191;break;}
 case 191: 
 var $584=(($581+12)|0);
 var $585=HEAP32[(($584)>>2)];
 var $586=(($581+16)|0);
 var $587=HEAP32[(($586)>>2)];
 var $588=($585|0)==($587|0);
 if($588){label=192;break;}else{var $596=$581;label=196;break;}
 case 192: 
 var $589=$581;
 var $590=HEAP32[(($589)>>2)];
 var $591=(($590+36)|0);
 var $592=HEAP32[(($591)>>2)];
 var $593=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$592]($581) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=193;break; } else { var $_ph_ph=$579;var $_ZNSt3__112__do_nothingEPv346_ph_ph=$_ZNSt3__112__do_nothingEPv341;label=19;break; }
 case 193: 
 var $594=($593|0)==-1;
 if($594){label=195;break;}else{label=194;break;}
 case 194: 
 var $_pre_i_i_i245=HEAP32[(($6)>>2)];
 var $596=$_pre_i_i_i245;label=196;break;
 case 195: 
 HEAP32[(($6)>>2)]=0;
 var $596=0;label=196;break;
 case 196: 
 var $596;
 var $597=($596|0)==0;
 var $598=HEAP32[(($7)>>2)];
 var $599=($598|0)==0;
 if($599){label=202;break;}else{label=197;break;}
 case 197: 
 var $601=(($598+12)|0);
 var $602=HEAP32[(($601)>>2)];
 var $603=(($598+16)|0);
 var $604=HEAP32[(($603)>>2)];
 var $605=($602|0)==($604|0);
 if($605){label=199;break;}else{label=198;break;}
 case 198: 
 if($597){label=204;break;}else{label=236;break;}
 case 199: 
 var $606=$598;
 var $607=HEAP32[(($606)>>2)];
 var $608=(($607+36)|0);
 var $609=HEAP32[(($608)>>2)];
 var $610=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$609]($598) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=200;break; } else { var $_ph_ph=$579;var $_ZNSt3__112__do_nothingEPv346_ph_ph=$_ZNSt3__112__do_nothingEPv341;label=19;break; }
 case 200: 
 var $611=($610|0)==-1;
 if($611){label=201;break;}else{label=203;break;}
 case 201: 
 HEAP32[(($7)>>2)]=0;
 label=202;break;
 case 202: 
 if($597){label=236;break;}else{label=204;break;}
 case 203: 
 if($597){label=204;break;}else{label=236;break;}
 case 204: 
 var $614=HEAP32[(($6)>>2)];
 var $615=(($614+12)|0);
 var $616=HEAP32[(($615)>>2)];
 var $617=(($614+16)|0);
 var $618=HEAP32[(($617)>>2)];
 var $619=($616|0)==($618|0);
 if($619){label=205;break;}else{label=207;break;}
 case 205: 
 var $621=$614;
 var $622=HEAP32[(($621)>>2)];
 var $623=(($622+36)|0);
 var $624=HEAP32[(($623)>>2)];
 var $625=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$624]($614) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=206;break; } else { var $_ph_ph=$579;var $_ZNSt3__112__do_nothingEPv346_ph_ph=$_ZNSt3__112__do_nothingEPv341;label=19;break; }
 case 206: 
 var $extract_t_i239=(($625)&255);
 var $_0_i_off0_i240=$extract_t_i239;label=208;break;
 case 207: 
 var $627=HEAP8[($616)];
 var $_0_i_off0_i240=$627;label=208;break;
 case 208: 
 var $_0_i_off0_i240;
 var $628=(($_0_i_off0_i240<<24)>>24)<0;
 if($628){label=221;break;}else{label=209;break;}
 case 209: 
 var $629=(($_0_i_off0_i240<<24)>>24);
 var $630=HEAP32[(($8)>>2)];
 var $631=(($630+($629<<1))|0);
 var $632=HEAP16[(($631)>>1)];
 var $633=$632&2048;
 var $634=(($633<<16)>>16)==0;
 if($634){label=221;break;}else{label=210;break;}
 case 210: 
 var $636=HEAP32[(($__wn)>>2)];
 var $637=($636|0)==($__we349|0);
 if($637){label=211;break;}else{var $__we348=$__we349;var $662=$636;label=220;break;}
 case 211: 
 var $639=HEAP32[(($29)>>2)];
 var $640=($639|0)!=((440)|0);
 var $641=HEAP32[(($4)>>2)];
 var $642=$__we349;
 var $643=$641;
 var $644=((($642)-($643))|0);
 var $645=($644>>>0)<2147483647;
 var $646=$644<<1;
 var $647=($645?$646:-1);
 var $__i229=($640?$641:0);
 var $648=_realloc($__i229,$647);
 var $649=($648|0)==0;
 if($649){label=212;break;}else{label=213;break;}
 case 212: 
 (function() { try { __THREW__ = 0; return __ZSt17__throw_bad_allocv() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=213;break; } else { var $_ph_ph=$579;var $_ZNSt3__112__do_nothingEPv346_ph_ph=$_ZNSt3__112__do_nothingEPv341;label=19;break; }
 case 213: 
 if($640){label=214;break;}else{label=215;break;}
 case 214: 
 HEAP32[(($4)>>2)]=$648;
 var $657=$648;label=219;break;
 case 215: 
 var $_pr_i231=HEAP32[(($4)>>2)];
 HEAP32[(($4)>>2)]=$648;
 var $652=($_pr_i231|0)==0;
 if($652){var $657=$648;label=219;break;}else{label=216;break;}
 case 216: 
 var $654=HEAP32[(($29)>>2)];
 (function() { try { __THREW__ = 0; return FUNCTION_TABLE[$654]($_pr_i231) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=217;break; } else { label=218;break; }
 case 217: 
 var $_pre_i232=HEAP32[(($4)>>2)];
 var $657=$_pre_i232;label=219;break;
 case 218: 
 var $656$0 = ___cxa_find_matching_catch(-1, -1,0); var $656$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
 case 219: 
 var $657;
 HEAP32[(($29)>>2)]=222;
 var $658=(($657+$644)|0);
 HEAP32[(($__wn)>>2)]=$658;
 var $659=HEAP32[(($4)>>2)];
 var $660=(($659+$647)|0);
 var $__we348=$660;var $662=$658;label=220;break;
 case 220: 
 var $662;
 var $__we348;
 var $663=(($662+1)|0);
 HEAP32[(($__wn)>>2)]=$663;
 HEAP8[($662)]=$_0_i_off0_i240;
 var $664=((($__ng_0)+(1))|0);
 var $__ng_1=$664;var $706=$580;var $__gb_sroa_0_0_load317331=$__gb_sroa_0_0_load317332;var $705=$579;var $_ZNSt3__112__do_nothingEPv339=$_ZNSt3__112__do_nothingEPv341;var $__we347=$__we348;label=233;break;
 case 221: 
 var $665=HEAP8[($this4_i_i_i)];
 var $666=$665&1;
 var $667=(($666<<24)>>24)==0;
 if($667){label=223;break;}else{label=222;break;}
 case 222: 
 var $669=HEAP32[(($28)>>2)];
 var $673=$669;label=224;break;
 case 223: 
 var $671=($665&255);
 var $672=$671>>>1;
 var $673=$672;label=224;break;
 case 224: 
 var $673;
 var $674=($673|0)==0;
 var $675=($__ng_0|0)==0;
 var $or_cond90=$674|$675;
 if($or_cond90){label=236;break;}else{label=225;break;}
 case 225: 
 var $677=HEAP8[($__ts)];
 var $678=(($_0_i_off0_i240<<24)>>24)==(($677<<24)>>24);
 if($678){label=226;break;}else{label=236;break;}
 case 226: 
 var $680=($__gb_sroa_0_0_load317332|0)==($580|0);
 if($680){label=227;break;}else{var $702=$580;var $__gb_sroa_0_0_load317336=$__gb_sroa_0_0_load317332;var $701=$579;var $_ZNSt3__112__do_nothingEPv340=$_ZNSt3__112__do_nothingEPv341;label=232;break;}
 case 227: 
 var $682=($_ZNSt3__112__do_nothingEPv341|0)==((440)|0);
 var $683=$__gb_sroa_0_0_load317332;
 var $684=$579;
 var $685=((($683)-($684))|0);
 var $686=($685>>>0)<2147483647;
 var $687=$685<<1;
 var $688=($686?$687:-1);
 var $689=$685>>2;
 if($682){var $692=0;label=229;break;}else{label=228;break;}
 case 228: 
 var $phitmp_i219=$579;
 var $692=$phitmp_i219;label=229;break;
 case 229: 
 var $692;
 var $693=_realloc($692,$688);
 var $694=$693;
 var $695=($693|0)==0;
 if($695){label=230;break;}else{label=231;break;}
 case 230: 
 (function() { try { __THREW__ = 0; return __ZSt17__throw_bad_allocv() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=231;break; } else { var $_ph_ph=$579;var $_ZNSt3__112__do_nothingEPv346_ph_ph=$_ZNSt3__112__do_nothingEPv341;label=19;break; }
 case 231: 
 var $697=$688>>>2;
 var $698=(($694+($689<<2))|0);
 var $699=(($694+($697<<2))|0);
 var $702=$699;var $__gb_sroa_0_0_load317336=$698;var $701=$694;var $_ZNSt3__112__do_nothingEPv340=222;label=232;break;
 case 232: 
 var $_ZNSt3__112__do_nothingEPv340;
 var $701;
 var $__gb_sroa_0_0_load317336;
 var $702;
 var $703=(($__gb_sroa_0_0_load317336+4)|0);
 HEAP32[(($__gb_sroa_0_0_load317336)>>2)]=$__ng_0;
 var $__ng_1=0;var $706=$702;var $__gb_sroa_0_0_load317331=$703;var $705=$701;var $_ZNSt3__112__do_nothingEPv339=$_ZNSt3__112__do_nothingEPv340;var $__we347=$__we349;label=233;break;
 case 233: 
 var $__we347;
 var $_ZNSt3__112__do_nothingEPv339;
 var $705;
 var $__gb_sroa_0_0_load317331;
 var $706;
 var $__ng_1;
 var $707=HEAP32[(($6)>>2)];
 var $708=(($707+12)|0);
 var $709=HEAP32[(($708)>>2)];
 var $710=(($707+16)|0);
 var $711=HEAP32[(($710)>>2)];
 var $712=($709|0)==($711|0);
 if($712){label=234;break;}else{label=235;break;}
 case 234: 
 var $714=$707;
 var $715=HEAP32[(($714)>>2)];
 var $716=(($715+40)|0);
 var $717=HEAP32[(($716)>>2)];
 var $718=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$717]($707) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $__ng_0=$__ng_1;var $580=$706;var $__gb_sroa_0_0_load317332=$__gb_sroa_0_0_load317331;var $579=$705;var $_ZNSt3__112__do_nothingEPv341=$_ZNSt3__112__do_nothingEPv339;var $__we349=$__we347;label=190;break; } else { var $_ph_ph=$705;var $_ZNSt3__112__do_nothingEPv346_ph_ph=$_ZNSt3__112__do_nothingEPv339;label=19;break; }
 case 235: 
 var $720=(($709+1)|0);
 HEAP32[(($708)>>2)]=$720;
 var $__ng_0=$__ng_1;var $580=$706;var $__gb_sroa_0_0_load317332=$__gb_sroa_0_0_load317331;var $579=$705;var $_ZNSt3__112__do_nothingEPv341=$_ZNSt3__112__do_nothingEPv339;var $__we349=$__we347;label=190;break;
 case 236: 
 var $722=($579|0)==($__gb_sroa_0_0_load317332|0);
 var $723=($__ng_0|0)==0;
 var $or_cond91=$722|$723;
 if($or_cond91){var $750=$580;var $__gb_sroa_0_0_load317335=$__gb_sroa_0_0_load317332;var $749=$579;var $_ZNSt3__112__do_nothingEPv344=$_ZNSt3__112__do_nothingEPv341;label=244;break;}else{label=237;break;}
 case 237: 
 var $725=($__gb_sroa_0_0_load317332|0)==($580|0);
 if($725){label=238;break;}else{var $747=$580;var $__gb_sroa_0_0_load317337=$__gb_sroa_0_0_load317332;var $746=$579;var $_ZNSt3__112__do_nothingEPv345=$_ZNSt3__112__do_nothingEPv341;label=243;break;}
 case 238: 
 var $727=($_ZNSt3__112__do_nothingEPv341|0)==((440)|0);
 var $728=$__gb_sroa_0_0_load317332;
 var $729=$579;
 var $730=((($728)-($729))|0);
 var $731=($730>>>0)<2147483647;
 var $732=$730<<1;
 var $733=($731?$732:-1);
 var $734=$730>>2;
 if($727){var $737=0;label=240;break;}else{label=239;break;}
 case 239: 
 var $phitmp_i=$579;
 var $737=$phitmp_i;label=240;break;
 case 240: 
 var $737;
 var $738=_realloc($737,$733);
 var $739=$738;
 var $740=($738|0)==0;
 if($740){label=241;break;}else{label=242;break;}
 case 241: 
 (function() { try { __THREW__ = 0; return __ZSt17__throw_bad_allocv() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=242;break; } else { var $_ph_ph374_ph_ph_ph_ph=$579;var $_ZNSt3__112__do_nothingEPv346_ph_ph373_ph_ph_ph_ph=$_ZNSt3__112__do_nothingEPv341;label=23;break; }
 case 242: 
 var $742=$733>>>2;
 var $743=(($739+($734<<2))|0);
 var $744=(($739+($742<<2))|0);
 var $747=$744;var $__gb_sroa_0_0_load317337=$743;var $746=$739;var $_ZNSt3__112__do_nothingEPv345=222;label=243;break;
 case 243: 
 var $_ZNSt3__112__do_nothingEPv345;
 var $746;
 var $__gb_sroa_0_0_load317337;
 var $747;
 var $748=(($__gb_sroa_0_0_load317337+4)|0);
 HEAP32[(($__gb_sroa_0_0_load317337)>>2)]=$__ng_0;
 var $750=$747;var $__gb_sroa_0_0_load317335=$748;var $749=$746;var $_ZNSt3__112__do_nothingEPv344=$_ZNSt3__112__do_nothingEPv345;label=244;break;
 case 244: 
 var $_ZNSt3__112__do_nothingEPv344;
 var $749;
 var $__gb_sroa_0_0_load317335;
 var $750;
 var $751=HEAP32[(($__fd)>>2)];
 var $752=($751|0)>0;
 if($752){label=245;break;}else{var $__we352=$__we349;label=307;break;}
 case 245: 
 var $754=HEAP32[(($6)>>2)];
 var $755=($754|0)==0;
 if($755){var $769=0;label=251;break;}else{label=246;break;}
 case 246: 
 var $757=(($754+12)|0);
 var $758=HEAP32[(($757)>>2)];
 var $759=(($754+16)|0);
 var $760=HEAP32[(($759)>>2)];
 var $761=($758|0)==($760|0);
 if($761){label=247;break;}else{var $769=$754;label=251;break;}
 case 247: 
 var $762=$754;
 var $763=HEAP32[(($762)>>2)];
 var $764=(($763+36)|0);
 var $765=HEAP32[(($764)>>2)];
 var $766=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$765]($754) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=248;break; } else { var $_ph_ph374_ph_ph_ph_ph=$749;var $_ZNSt3__112__do_nothingEPv346_ph_ph373_ph_ph_ph_ph=$_ZNSt3__112__do_nothingEPv344;label=23;break; }
 case 248: 
 var $767=($766|0)==-1;
 if($767){label=250;break;}else{label=249;break;}
 case 249: 
 var $_pre_i_i_i192=HEAP32[(($6)>>2)];
 var $769=$_pre_i_i_i192;label=251;break;
 case 250: 
 HEAP32[(($6)>>2)]=0;
 var $769=0;label=251;break;
 case 251: 
 var $769;
 var $770=($769|0)==0;
 var $771=HEAP32[(($7)>>2)];
 var $772=($771|0)==0;
 if($772){label=257;break;}else{label=252;break;}
 case 252: 
 var $774=(($771+12)|0);
 var $775=HEAP32[(($774)>>2)];
 var $776=(($771+16)|0);
 var $777=HEAP32[(($776)>>2)];
 var $778=($775|0)==($777|0);
 if($778){label=254;break;}else{label=253;break;}
 case 253: 
 if($770){var $786=$771;label=259;break;}else{label=264;break;}
 case 254: 
 var $779=$771;
 var $780=HEAP32[(($779)>>2)];
 var $781=(($780+36)|0);
 var $782=HEAP32[(($781)>>2)];
 var $783=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$782]($771) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=255;break; } else { var $_ph_ph374_ph_ph_ph_ph=$749;var $_ZNSt3__112__do_nothingEPv346_ph_ph373_ph_ph_ph_ph=$_ZNSt3__112__do_nothingEPv344;label=23;break; }
 case 255: 
 var $784=($783|0)==-1;
 if($784){label=256;break;}else{label=258;break;}
 case 256: 
 HEAP32[(($7)>>2)]=0;
 label=257;break;
 case 257: 
 if($770){label=264;break;}else{var $786=0;label=259;break;}
 case 258: 
 if($770){var $786=$771;label=259;break;}else{label=264;break;}
 case 259: 
 var $786;
 var $787=HEAP32[(($6)>>2)];
 var $788=(($787+12)|0);
 var $789=HEAP32[(($788)>>2)];
 var $790=(($787+16)|0);
 var $791=HEAP32[(($790)>>2)];
 var $792=($789|0)==($791|0);
 if($792){label=260;break;}else{label=262;break;}
 case 260: 
 var $794=$787;
 var $795=HEAP32[(($794)>>2)];
 var $796=(($795+36)|0);
 var $797=HEAP32[(($796)>>2)];
 var $798=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$797]($787) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=261;break; } else { var $_ph_ph374_ph_ph_ph_ph=$749;var $_ZNSt3__112__do_nothingEPv346_ph_ph373_ph_ph_ph_ph=$_ZNSt3__112__do_nothingEPv344;label=23;break; }
 case 261: 
 var $extract_t_i182=(($798)&255);
 var $_0_i_off0_i183=$extract_t_i182;label=263;break;
 case 262: 
 var $800=HEAP8[($789)];
 var $_0_i_off0_i183=$800;label=263;break;
 case 263: 
 var $_0_i_off0_i183;
 var $801=HEAP8[($__dp)];
 var $802=(($_0_i_off0_i183<<24)>>24)==(($801<<24)>>24);
 if($802){label=265;break;}else{label=264;break;}
 case 264: 
 var $804=HEAP32[(($__err)>>2)];
 var $805=$804|4;
 HEAP32[(($__err)>>2)]=$805;
 var $_0=0;var $1047=$749;var $_ZNSt3__112__do_nothingEPv=$_ZNSt3__112__do_nothingEPv344;label=344;break;
 case 265: 
 var $807=HEAP32[(($6)>>2)];
 var $808=(($807+12)|0);
 var $809=HEAP32[(($808)>>2)];
 var $810=(($807+16)|0);
 var $811=HEAP32[(($810)>>2)];
 var $812=($809|0)==($811|0);
 if($812){label=266;break;}else{label=267;break;}
 case 266: 
 var $814=$807;
 var $815=HEAP32[(($814)>>2)];
 var $816=(($815+40)|0);
 var $817=HEAP32[(($816)>>2)];
 var $818=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$817]($807) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $__we353402=$__we349;var $821=$786;var $_pre_i3_i_i163=$786;label=268;break; } else { var $_ph_ph374_ph_ph_ph_ph=$749;var $_ZNSt3__112__do_nothingEPv346_ph_ph373_ph_ph_ph_ph=$_ZNSt3__112__do_nothingEPv344;label=23;break; }
 case 267: 
 var $820=(($809+1)|0);
 HEAP32[(($808)>>2)]=$820;
 var $__we353402=$__we349;var $821=$786;var $_pre_i3_i_i163=$786;label=268;break;
 case 268: 
 var $_pre_i3_i_i163;
 var $821;
 var $__we353402;
 var $822=HEAP32[(($6)>>2)];
 var $823=($822|0)==0;
 if($823){var $837=0;label=274;break;}else{label=269;break;}
 case 269: 
 var $825=(($822+12)|0);
 var $826=HEAP32[(($825)>>2)];
 var $827=(($822+16)|0);
 var $828=HEAP32[(($827)>>2)];
 var $829=($826|0)==($828|0);
 if($829){label=270;break;}else{var $837=$822;label=274;break;}
 case 270: 
 var $830=$822;
 var $831=HEAP32[(($830)>>2)];
 var $832=(($831+36)|0);
 var $833=HEAP32[(($832)>>2)];
 var $834=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$833]($822) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=271;break; } else { label=20;break; }
 case 271: 
 var $835=($834|0)==-1;
 if($835){label=273;break;}else{label=272;break;}
 case 272: 
 var $_pre_i_i_i159=HEAP32[(($6)>>2)];
 var $837=$_pre_i_i_i159;label=274;break;
 case 273: 
 HEAP32[(($6)>>2)]=0;
 var $837=0;label=274;break;
 case 274: 
 var $837;
 var $838=($837|0)==0;
 var $839=($821|0)==0;
 if($839){var $_pre_i3_i_i163572_ph=$_pre_i3_i_i163;label=280;break;}else{label=275;break;}
 case 275: 
 var $841=(($821+12)|0);
 var $842=HEAP32[(($841)>>2)];
 var $843=(($821+16)|0);
 var $844=HEAP32[(($843)>>2)];
 var $845=($842|0)==($844|0);
 if($845){label=277;break;}else{label=276;break;}
 case 276: 
 if($838){var $_pre_i3_i_i163572587=$_pre_i3_i_i163;var $854=$821;label=282;break;}else{label=288;break;}
 case 277: 
 var $846=$821;
 var $847=HEAP32[(($846)>>2)];
 var $848=(($847+36)|0);
 var $849=HEAP32[(($848)>>2)];
 var $850=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$849]($821) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=278;break; } else { label=20;break; }
 case 278: 
 var $851=($850|0)==-1;
 if($851){label=279;break;}else{label=281;break;}
 case 279: 
 HEAP32[(($7)>>2)]=0;
 var $_pre_i3_i_i163572_ph=0;label=280;break;
 case 280: 
 var $_pre_i3_i_i163572_ph;
 if($838){label=288;break;}else{var $_pre_i3_i_i163572587=$_pre_i3_i_i163572_ph;var $854=0;label=282;break;}
 case 281: 
 var $853=($_pre_i3_i_i163|0)==0;
 var $tmp_i_i165=$838^$853;
 if($tmp_i_i165){var $_pre_i3_i_i163572587=$_pre_i3_i_i163;var $854=$_pre_i3_i_i163;label=282;break;}else{label=288;break;}
 case 282: 
 var $854;
 var $_pre_i3_i_i163572587;
 var $855=HEAP32[(($6)>>2)];
 var $856=(($855+12)|0);
 var $857=HEAP32[(($856)>>2)];
 var $858=(($855+16)|0);
 var $859=HEAP32[(($858)>>2)];
 var $860=($857|0)==($859|0);
 if($860){label=283;break;}else{label=285;break;}
 case 283: 
 var $862=$855;
 var $863=HEAP32[(($862)>>2)];
 var $864=(($863+36)|0);
 var $865=HEAP32[(($864)>>2)];
 var $866=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$865]($855) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=284;break; } else { label=20;break; }
 case 284: 
 var $extract_t_i150=(($866)&255);
 var $_0_i_off0_i151=$extract_t_i150;label=286;break;
 case 285: 
 var $868=HEAP8[($857)];
 var $_0_i_off0_i151=$868;label=286;break;
 case 286: 
 var $_0_i_off0_i151;
 var $869=(($_0_i_off0_i151<<24)>>24)<0;
 if($869){label=288;break;}else{label=287;break;}
 case 287: 
 var $870=(($_0_i_off0_i151<<24)>>24);
 var $871=HEAP32[(($8)>>2)];
 var $872=(($871+($870<<1))|0);
 var $873=HEAP16[(($872)>>1)];
 var $874=$873&2048;
 var $875=(($874<<16)>>16)==0;
 if($875){label=288;break;}else{label=289;break;}
 case 288: 
 var $876=HEAP32[(($__err)>>2)];
 var $877=$876|4;
 HEAP32[(($__err)>>2)]=$877;
 var $_0=0;var $1047=$749;var $_ZNSt3__112__do_nothingEPv=$_ZNSt3__112__do_nothingEPv344;label=344;break;
 case 289: 
 var $879=HEAP32[(($__wn)>>2)];
 var $880=($879|0)==($__we353402|0);
 if($880){label=290;break;}else{var $__we354=$__we353402;var $904=$879;label=299;break;}
 case 290: 
 var $882=HEAP32[(($29)>>2)];
 var $883=($882|0)!=((440)|0);
 var $884=HEAP32[(($4)>>2)];
 var $885=$__we353402;
 var $886=$884;
 var $887=((($885)-($886))|0);
 var $888=($887>>>0)<2147483647;
 var $889=$887<<1;
 var $890=($888?$889:-1);
 var $__i=($883?$884:0);
 var $891=_realloc($__i,$890);
 var $892=($891|0)==0;
 if($892){label=291;break;}else{label=292;break;}
 case 291: 
 (function() { try { __THREW__ = 0; return __ZSt17__throw_bad_allocv() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=292;break; } else { label=20;break; }
 case 292: 
 if($883){label=293;break;}else{label=294;break;}
 case 293: 
 HEAP32[(($4)>>2)]=$891;
 var $900=$891;label=298;break;
 case 294: 
 var $_pr_i=HEAP32[(($4)>>2)];
 HEAP32[(($4)>>2)]=$891;
 var $895=($_pr_i|0)==0;
 if($895){var $900=$891;label=298;break;}else{label=295;break;}
 case 295: 
 var $897=HEAP32[(($29)>>2)];
 (function() { try { __THREW__ = 0; return FUNCTION_TABLE[$897]($_pr_i) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=296;break; } else { label=297;break; }
 case 296: 
 var $_pre_i=HEAP32[(($4)>>2)];
 var $900=$_pre_i;label=298;break;
 case 297: 
 var $899$0 = ___cxa_find_matching_catch(-1, -1,0); var $899$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
 case 298: 
 var $900;
 HEAP32[(($29)>>2)]=222;
 var $901=(($900+$887)|0);
 HEAP32[(($__wn)>>2)]=$901;
 var $902=HEAP32[(($4)>>2)];
 var $903=(($902+$890)|0);
 var $__we354=$903;var $904=$901;label=299;break;
 case 299: 
 var $904;
 var $__we354;
 var $905=HEAP32[(($6)>>2)];
 var $906=(($905+12)|0);
 var $907=HEAP32[(($906)>>2)];
 var $908=(($905+16)|0);
 var $909=HEAP32[(($908)>>2)];
 var $910=($907|0)==($909|0);
 if($910){label=300;break;}else{label=302;break;}
 case 300: 
 var $912=$905;
 var $913=HEAP32[(($912)>>2)];
 var $914=(($913+36)|0);
 var $915=HEAP32[(($914)>>2)];
 var $916=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$915]($905) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=301;break; } else { label=20;break; }
 case 301: 
 var $extract_t_i139=(($916)&255);
 var $_pre570=HEAP32[(($__wn)>>2)];
 var $_0_i_off0_i140=$extract_t_i139;var $919=$_pre570;label=303;break;
 case 302: 
 var $918=HEAP8[($907)];
 var $_0_i_off0_i140=$918;var $919=$904;label=303;break;
 case 303: 
 var $919;
 var $_0_i_off0_i140;
 var $920=(($919+1)|0);
 HEAP32[(($__wn)>>2)]=$920;
 HEAP8[($919)]=$_0_i_off0_i140;
 var $921=HEAP32[(($__fd)>>2)];
 var $922=((($921)-(1))|0);
 HEAP32[(($__fd)>>2)]=$922;
 var $923=HEAP32[(($6)>>2)];
 var $924=(($923+12)|0);
 var $925=HEAP32[(($924)>>2)];
 var $926=(($923+16)|0);
 var $927=HEAP32[(($926)>>2)];
 var $928=($925|0)==($927|0);
 if($928){label=304;break;}else{label=306;break;}
 case 304: 
 var $930=$923;
 var $931=HEAP32[(($930)>>2)];
 var $932=(($931+40)|0);
 var $933=HEAP32[(($932)>>2)];
 var $934=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$933]($923) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=305;break; } else { label=20;break; }
 case 305: 
 var $935=($922|0)>0;
 if($935){var $__we353402=$__we354;var $821=$854;var $_pre_i3_i_i163=$_pre_i3_i_i163572587;label=268;break;}else{var $__we352=$__we354;label=307;break;}
 case 306: 
 var $937=(($925+1)|0);
 HEAP32[(($924)>>2)]=$937;
 label=305;break;
 case 307: 
 var $__we352;
 var $938=HEAP32[(($__wn)>>2)];
 var $939=HEAP32[(($4)>>2)];
 var $940=($938|0)==($939|0);
 if($940){label=308;break;}else{var $__trailing_sign_1=$__trailing_sign_0497;var $945=$750;var $__gb_sroa_0_0_load317334=$__gb_sroa_0_0_load317335;var $944=$749;var $_ZNSt3__112__do_nothingEPv343=$_ZNSt3__112__do_nothingEPv344;var $__we351=$__we352;label=309;break;}
 case 308: 
 var $942=HEAP32[(($__err)>>2)];
 var $943=$942|4;
 HEAP32[(($__err)>>2)]=$943;
 var $_0=0;var $1047=$749;var $_ZNSt3__112__do_nothingEPv=$_ZNSt3__112__do_nothingEPv344;label=344;break;
 case 309: 
 var $__we351;
 var $_ZNSt3__112__do_nothingEPv343;
 var $944;
 var $__gb_sroa_0_0_load317334;
 var $945;
 var $__trailing_sign_1;
 var $946=((($__p_0495)+(1))|0);
 var $947=($946>>>0)<4;
 if($947){var $__we350484=$__we351;var $_ZNSt3__112__do_nothingEPv342487=$_ZNSt3__112__do_nothingEPv343;var $31=$944;var $__gb_sroa_0_0_load317333491=$__gb_sroa_0_0_load317334;var $30=$945;var $__p_0495=$946;var $__trailing_sign_0497=$__trailing_sign_1;label=3;break;}else{var $_ZNSt3__112__do_nothingEPv342_lcssa=$_ZNSt3__112__do_nothingEPv343;var $_lcssa=$944;var $__gb_sroa_0_0_load317333_lcssa=$__gb_sroa_0_0_load317334;var $__trailing_sign_0_lcssa=$__trailing_sign_1;label=310;break;}
 case 310: 
 var $__trailing_sign_0_lcssa;
 var $__gb_sroa_0_0_load317333_lcssa;
 var $_lcssa;
 var $_ZNSt3__112__do_nothingEPv342_lcssa;
 var $948=($__trailing_sign_0_lcssa|0)==0;
 if($948){label=341;break;}else{label=311;break;}
 case 311: 
 var $949=$__trailing_sign_0_lcssa;
 var $950=$__trailing_sign_0_lcssa;
 var $951=(($950+1)|0);
 var $952=(($__trailing_sign_0_lcssa+8)|0);
 var $953=(($__trailing_sign_0_lcssa+4)|0);
 var $__i_0=1;label=312;break;
 case 312: 
 var $__i_0;
 var $954=HEAP8[($949)];
 var $955=$954&1;
 var $956=(($955<<24)>>24)==0;
 if($956){label=314;break;}else{label=313;break;}
 case 313: 
 var $958=HEAP32[(($953)>>2)];
 var $962=$958;label=315;break;
 case 314: 
 var $960=($954&255);
 var $961=$960>>>1;
 var $962=$961;label=315;break;
 case 315: 
 var $962;
 var $963=($__i_0>>>0)<($962>>>0);
 if($963){label=316;break;}else{label=341;break;}
 case 316: 
 var $965=HEAP32[(($6)>>2)];
 var $966=($965|0)==0;
 if($966){var $980=0;label=322;break;}else{label=317;break;}
 case 317: 
 var $968=(($965+12)|0);
 var $969=HEAP32[(($968)>>2)];
 var $970=(($965+16)|0);
 var $971=HEAP32[(($970)>>2)];
 var $972=($969|0)==($971|0);
 if($972){label=318;break;}else{var $980=$965;label=322;break;}
 case 318: 
 var $973=$965;
 var $974=HEAP32[(($973)>>2)];
 var $975=(($974+36)|0);
 var $976=HEAP32[(($975)>>2)];
 var $977=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$976]($965) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=319;break; } else { label=18;break; }
 case 319: 
 var $978=($977|0)==-1;
 if($978){label=321;break;}else{label=320;break;}
 case 320: 
 var $_pre_i_i_i=HEAP32[(($6)>>2)];
 var $980=$_pre_i_i_i;label=322;break;
 case 321: 
 HEAP32[(($6)>>2)]=0;
 var $980=0;label=322;break;
 case 322: 
 var $980;
 var $981=($980|0)==0;
 var $982=HEAP32[(($7)>>2)];
 var $983=($982|0)==0;
 if($983){label=328;break;}else{label=323;break;}
 case 323: 
 var $985=(($982+12)|0);
 var $986=HEAP32[(($985)>>2)];
 var $987=(($982+16)|0);
 var $988=HEAP32[(($987)>>2)];
 var $989=($986|0)==($988|0);
 if($989){label=325;break;}else{label=324;break;}
 case 324: 
 if($981){label=330;break;}else{label=337;break;}
 case 325: 
 var $990=$982;
 var $991=HEAP32[(($990)>>2)];
 var $992=(($991+36)|0);
 var $993=HEAP32[(($992)>>2)];
 var $994=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$993]($982) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=326;break; } else { label=18;break; }
 case 326: 
 var $995=($994|0)==-1;
 if($995){label=327;break;}else{label=329;break;}
 case 327: 
 HEAP32[(($7)>>2)]=0;
 label=328;break;
 case 328: 
 if($981){label=337;break;}else{label=330;break;}
 case 329: 
 if($981){label=330;break;}else{label=337;break;}
 case 330: 
 var $997=HEAP32[(($6)>>2)];
 var $998=(($997+12)|0);
 var $999=HEAP32[(($998)>>2)];
 var $1000=(($997+16)|0);
 var $1001=HEAP32[(($1000)>>2)];
 var $1002=($999|0)==($1001|0);
 if($1002){label=331;break;}else{label=333;break;}
 case 331: 
 var $1004=$997;
 var $1005=HEAP32[(($1004)>>2)];
 var $1006=(($1005+36)|0);
 var $1007=HEAP32[(($1006)>>2)];
 var $1008=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$1007]($997) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=332;break; } else { label=18;break; }
 case 332: 
 var $extract_t_i=(($1008)&255);
 var $_0_i_off0_i=$extract_t_i;label=334;break;
 case 333: 
 var $1010=HEAP8[($999)];
 var $_0_i_off0_i=$1010;label=334;break;
 case 334: 
 var $_0_i_off0_i;
 var $1011=HEAP8[($949)];
 var $1012=$1011&1;
 var $1013=(($1012<<24)>>24)==0;
 if($1013){var $1016=$951;label=336;break;}else{label=335;break;}
 case 335: 
 var $1015=HEAP32[(($952)>>2)];
 var $1016=$1015;label=336;break;
 case 336: 
 var $1016;
 var $1017=(($1016+$__i_0)|0);
 var $1018=HEAP8[($1017)];
 var $1019=(($_0_i_off0_i<<24)>>24)==(($1018<<24)>>24);
 if($1019){label=338;break;}else{label=337;break;}
 case 337: 
 var $1021=HEAP32[(($__err)>>2)];
 var $1022=$1021|4;
 HEAP32[(($__err)>>2)]=$1022;
 var $_0=0;var $1047=$_lcssa;var $_ZNSt3__112__do_nothingEPv=$_ZNSt3__112__do_nothingEPv342_lcssa;label=344;break;
 case 338: 
 var $1024=((($__i_0)+(1))|0);
 var $1025=HEAP32[(($6)>>2)];
 var $1026=(($1025+12)|0);
 var $1027=HEAP32[(($1026)>>2)];
 var $1028=(($1025+16)|0);
 var $1029=HEAP32[(($1028)>>2)];
 var $1030=($1027|0)==($1029|0);
 if($1030){label=339;break;}else{label=340;break;}
 case 339: 
 var $1032=$1025;
 var $1033=HEAP32[(($1032)>>2)];
 var $1034=(($1033+40)|0);
 var $1035=HEAP32[(($1034)>>2)];
 var $1036=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$1035]($1025) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $__i_0=$1024;label=312;break; } else { label=18;break; }
 case 340: 
 var $1038=(($1027+1)|0);
 HEAP32[(($1026)>>2)]=$1038;
 var $__i_0=$1024;label=312;break;
 case 341: 
 var $1039=($_lcssa|0)==($__gb_sroa_0_0_load317333_lcssa|0);
 if($1039){var $_0=1;var $1047=$__gb_sroa_0_0_load317333_lcssa;var $_ZNSt3__112__do_nothingEPv=$_ZNSt3__112__do_nothingEPv342_lcssa;label=344;break;}else{label=342;break;}
 case 342: 
 HEAP32[(($__et)>>2)]=0;
 __ZNSt3__116__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj($__grp,$_lcssa,$__gb_sroa_0_0_load317333_lcssa,$__et);
 var $1041=HEAP32[(($__et)>>2)];
 var $1042=($1041|0)==0;
 if($1042){var $_0=1;var $1047=$_lcssa;var $_ZNSt3__112__do_nothingEPv=$_ZNSt3__112__do_nothingEPv342_lcssa;label=344;break;}else{label=343;break;}
 case 343: 
 var $1044=HEAP32[(($__err)>>2)];
 var $1045=$1044|4;
 HEAP32[(($__err)>>2)]=$1045;
 var $_0=0;var $1047=$_lcssa;var $_ZNSt3__112__do_nothingEPv=$_ZNSt3__112__do_nothingEPv342_lcssa;label=344;break;
 case 344: 
 var $_ZNSt3__112__do_nothingEPv;
 var $1047;
 var $_0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__spaces);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__nsn);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__psn);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__sym);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grp);
 var $1048=($1047|0)==0;
 if($1048){label=347;break;}else{label=345;break;}
 case 345: 
 var $1050=$1047;
 (function() { try { __THREW__ = 0; return FUNCTION_TABLE[$_ZNSt3__112__do_nothingEPv]($1050) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=347;break; } else { label=346;break; }
 case 346: 
 var $1052$0 = ___cxa_find_matching_catch(-1, -1,0); var $1052$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
 case 347: 
 STACKTOP=sp;return $_0;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__121__throw_runtime_errorEPKc($msg){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=___cxa_allocate_exception(8);
 var $2=$1;
 (function() { try { __THREW__ = 0; return __ZNSt13runtime_errorC2EPKc($2,$msg) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=2;break; } else { label=3;break; }
 case 2: 
 ___cxa_throw($1,8976,(46));
 throw "Reached an unreachable!";
 case 3: 
 var $5$0 = ___cxa_find_matching_catch(-1, -1); var $5$1 = tempRet0;
 ___cxa_free_exception($1);
 ___resumeException($5$0)
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__19money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_bRNS_8ios_baseERjRNS_12basic_stringIcS3_NS_9allocatorIcEEEE($agg_result,$this,$__b,$__e,$__intl,$__iob,$__err,$__v){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+160)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var tempParam = $__b; $__b=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__b)>>2)]=HEAP32[((tempParam)>>2)];
 var tempParam = $__e; $__e=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $__p_i_i_i_i=sp;
 var $__wbuf=(sp)+(16);
 var $__wb=(sp)+(120);
 var $__wn=(sp)+(128);
 var $__loc=(sp)+(136);
 var $__neg=(sp)+(144);
 var $1=(sp)+(152);
 var $2=(($__wbuf)|0);
 var $3=(($__wb)|0);
 HEAP32[(($3)>>2)]=$2;
 var $4=(($__wb+4)|0);
 HEAP32[(($4)>>2)]=440;
 var $5=(($__wbuf+100)|0);
 (function() { try { __THREW__ = 0; return __ZNKSt3__18ios_base6getlocEv($__loc,$__iob) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=2;break; } else { label=16;break; }
 case 2: 
 var $7=(($__loc)|0);
 var $8=HEAP32[(($7)>>2)];
 var $9=$__p_i_i_i_i;
 var $10=HEAP32[((14096)>>2)];
 var $11=($10|0)==-1;
 if($11){label=4;break;}else{label=3;break;}
 case 3: 
 var $_sroa_01_0___p67_i_idx_i_i_i=(($__p_i_i_i_i)|0);
 HEAP32[(($_sroa_01_0___p67_i_idx_i_i_i)>>2)]=14096;
 var $_sroa_12_4___p67_i_idx3_i_i_i=(($__p_i_i_i_i+4)|0);
 HEAP32[(($_sroa_12_4___p67_i_idx3_i_i_i)>>2)]=(28);
 var $_sroa_2_8___p67_i_idx4_i_i_i=(($__p_i_i_i_i+8)|0);
 HEAP32[(($_sroa_2_8___p67_i_idx4_i_i_i)>>2)]=0;
 (function() { try { __THREW__ = 0; return __ZNSt3__111__call_onceERVmPvPFvS2_E(14096,$9,260) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=4;break; } else { label=40;break; }
 case 4: 
 var $13=HEAP32[((14100)>>2)];
 var $14=((($13)-(1))|0);
 var $15=(($8+12)|0);
 var $16=HEAP32[(($15)>>2)];
 var $17=(($8+8)|0);
 var $18=HEAP32[(($17)>>2)];
 var $19=$16;
 var $20=$18;
 var $21=((($19)-($20))|0);
 var $22=$21>>2;
 var $23=($22>>>0)>($14>>>0);
 if($23){label=5;break;}else{label=6;break;}
 case 5: 
 var $24=(($18+($14<<2))|0);
 var $25=HEAP32[(($24)>>2)];
 var $26=($25|0)==0;
 if($26){label=6;break;}else{label=8;break;}
 case 6: 
 var $27=___cxa_allocate_exception(4);
 var $28=$27;
 __ZNSt8bad_castC2Ev($28);
 (function() { try { __THREW__ = 0; return ___cxa_throw($27,8960,(368)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=7;break; } else { label=40;break; }
 case 7: 
 throw "Reached an unreachable!";
 case 8: 
 var $30=$25;
 HEAP8[($__neg)]=0;
 var $31=(($__e)|0);
 var $32=HEAP32[(($31)>>2)];
 var $33=(($1)|0);
 HEAP32[(($33)>>2)]=$32;
 var $34=(($__iob+4)|0);
 var $35=HEAP32[(($34)>>2)];
 var $36=(function() { try { __THREW__ = 0; return __ZNSt3__19money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE8__do_getERS4_S4_bRKNS_6localeEjRjRbRKNS_5ctypeIcEERNS_10unique_ptrIcPFvPvEEERPcSM_($__b,$1,$__intl,$__loc,$35,$__err,$__neg,$30,$__wb,$__wn,$5) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=9;break; } else { label=40;break; }
 case 9: 
 if($36){label=10;break;}else{label=22;break;}
 case 10: 
 var $39=$__v;
 var $40=HEAP8[($39)];
 var $41=$40&1;
 var $42=(($41<<24)>>24)==0;
 if($42){label=12;break;}else{label=11;break;}
 case 11: 
 var $44=(($__v+8)|0);
 var $45=HEAP32[(($44)>>2)];
 HEAP8[($45)]=0;
 var $46=(($__v+4)|0);
 HEAP32[(($46)>>2)]=0;
 label=13;break;
 case 12: 
 var $48=$__v;
 var $49=(($48+1)|0);
 HEAP8[($49)]=0;
 HEAP8[($39)]=0;
 label=13;break;
 case 13: 
 var $50=HEAP8[($__neg)];
 var $51=(($50<<24)>>24)==0;
 var $_pre24=$25;
 if($51){label=17;break;}else{label=14;break;}
 case 14: 
 var $53=HEAP32[(($_pre24)>>2)];
 var $54=(($53+28)|0);
 var $55=HEAP32[(($54)>>2)];
 var $56=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$55]($30,45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=15;break; } else { label=40;break; }
 case 15: 
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9push_backEc($__v,$56) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=17;break; } else { label=40;break; }
 case 16: 
 var $57$0 = ___cxa_find_matching_catch(-1, -1); var $57$1 = tempRet0;
 var $58=$57$0;
 var $59=$57$1;
 HEAP32[(($3)>>2)]=0;
 var $131=$2;var $_01627=$59;var $_029=$58;label=41;break;
 case 17: 
 var $60=HEAP32[(($_pre24)>>2)];
 var $61=(($60+28)|0);
 var $62=HEAP32[(($61)>>2)];
 var $63=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$62]($30,48) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=18;break; } else { label=40;break; }
 case 18: 
 var $64=HEAP32[(($3)>>2)];
 var $65=HEAP32[(($__wn)>>2)];
 var $66=((($65)-(1))|0);
 var $__w_0=$64;label=19;break;
 case 19: 
 var $__w_0;
 var $68=($__w_0>>>0)<($66>>>0);
 if($68){label=20;break;}else{label=21;break;}
 case 20: 
 var $70=HEAP8[($__w_0)];
 var $71=(($70<<24)>>24)==(($63<<24)>>24);
 var $72=(($__w_0+1)|0);
 if($71){var $__w_0=$72;label=19;break;}else{label=21;break;}
 case 21: 
 var $74=(function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendIPcEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueERS5_E4typeES9_S9_($__v,$__w_0,$65) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=22;break; } else { label=40;break; }
 case 22: 
 var $76=(($__b)|0);
 var $77=HEAP32[(($76)>>2)];
 var $78=($77|0)==0;
 if($78){var $92=0;label=27;break;}else{label=23;break;}
 case 23: 
 var $80=(($77+12)|0);
 var $81=HEAP32[(($80)>>2)];
 var $82=(($77+16)|0);
 var $83=HEAP32[(($82)>>2)];
 var $84=($81|0)==($83|0);
 if($84){label=24;break;}else{var $92=$77;label=27;break;}
 case 24: 
 var $85=$77;
 var $86=HEAP32[(($85)>>2)];
 var $87=(($86+36)|0);
 var $88=HEAP32[(($87)>>2)];
 var $89=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$88]($77) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=25;break; } else { label=40;break; }
 case 25: 
 var $90=($89|0)==-1;
 if($90){label=26;break;}else{var $92=$77;label=27;break;}
 case 26: 
 HEAP32[(($76)>>2)]=0;
 var $92=0;label=27;break;
 case 27: 
 var $92;
 var $93=($92|0)==0;
 var $94=($32|0)==0;
 if($94){label=33;break;}else{label=28;break;}
 case 28: 
 var $96=(($32+12)|0);
 var $97=HEAP32[(($96)>>2)];
 var $98=(($32+16)|0);
 var $99=HEAP32[(($98)>>2)];
 var $100=($97|0)==($99|0);
 if($100){label=30;break;}else{label=29;break;}
 case 29: 
 if($93){label=36;break;}else{label=35;break;}
 case 30: 
 var $101=$32;
 var $102=HEAP32[(($101)>>2)];
 var $103=(($102+36)|0);
 var $104=HEAP32[(($103)>>2)];
 var $105=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$104]($32) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=31;break; } else { label=40;break; }
 case 31: 
 var $106=($105|0)==-1;
 if($106){label=32;break;}else{label=34;break;}
 case 32: 
 HEAP32[(($31)>>2)]=0;
 label=33;break;
 case 33: 
 if($93){label=35;break;}else{label=36;break;}
 case 34: 
 var $108=($32|0)==0;
 var $tmp_i_i=$93^$108;
 if($tmp_i_i){label=36;break;}else{label=35;break;}
 case 35: 
 var $110=HEAP32[(($__err)>>2)];
 var $111=$110|2;
 HEAP32[(($__err)>>2)]=$111;
 label=36;break;
 case 36: 
 var $112=(($agg_result)|0);
 HEAP32[(($112)>>2)]=$92;
 var $113=HEAP32[(($7)>>2)];
 var $114=(($113)|0);
 var $115=__ZNSt3__114__shared_count16__release_sharedEv($114);
 var $116=HEAP32[(($3)>>2)];
 HEAP32[(($3)>>2)]=0;
 var $117=($116|0)==0;
 if($117){label=39;break;}else{label=37;break;}
 case 37: 
 var $119=HEAP32[(($4)>>2)];
 (function() { try { __THREW__ = 0; return FUNCTION_TABLE[$119]($116) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=39;break; } else { label=38;break; }
 case 38: 
 var $121$0 = ___cxa_find_matching_catch(-1, -1,0); var $121$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
 case 39: 
 STACKTOP=sp;return;
 case 40: 
 var $123$0 = ___cxa_find_matching_catch(-1, -1); var $123$1 = tempRet0;
 var $124=$123$0;
 var $125=$123$1;
 var $126=HEAP32[(($7)>>2)];
 var $127=(($126)|0);
 var $128=__ZNSt3__114__shared_count16__release_sharedEv($127);
 var $_pre=HEAP32[(($3)>>2)];
 HEAP32[(($3)>>2)]=0;
 var $129=($_pre|0)==0;
 if($129){var $_01628=$125;var $_030=$124;label=43;break;}else{var $131=$_pre;var $_01627=$125;var $_029=$124;label=41;break;}
 case 41: 
 var $_029;
 var $_01627;
 var $131;
 var $132=HEAP32[(($4)>>2)];
 (function() { try { __THREW__ = 0; return FUNCTION_TABLE[$132]($131) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $_01628=$_01627;var $_030=$_029;label=43;break; } else { label=42;break; }
 case 42: 
 var $134$0 = ___cxa_find_matching_catch(-1, -1,0); var $134$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
 case 43: 
 var $_030;
 var $_01628;
 var $135$0=$_030;
 var $135$1=0;
 var $136$0=$135$0;
 var $136$1=$_01628;
 ___resumeException($136$0)
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendIPcEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueERS5_E4typeES9_S9_($this,$__first,$__last){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=$this;
 var $2=$__first;
 var $3=HEAP8[($1)];
 var $4=$3&1;
 var $5=(($4<<24)>>24)==0;
 if($5){label=2;break;}else{label=3;break;}
 case 2: 
 var $6=($3&255);
 var $7=$6>>>1;
 var $17=10;var $16=$3;var $15=$7;label=4;break;
 case 3: 
 var $9=(($this+4)|0);
 var $10=HEAP32[(($9)>>2)];
 var $11=(($this)|0);
 var $12=HEAP32[(($11)>>2)];
 var $13=$12&-2;
 var $phitmp_i=((($13)-(1))|0);
 var $14=(($12)&255);
 var $17=$phitmp_i;var $16=$14;var $15=$10;label=4;break;
 case 4: 
 var $15;
 var $16;
 var $17;
 var $18=$__last;
 var $19=((($18)-($2))|0);
 var $20=($__last|0)==($__first|0);
 if($20){label=15;break;}else{label=5;break;}
 case 5: 
 var $22=((($17)-($15))|0);
 var $23=($22>>>0)<($19>>>0);
 if($23){label=6;break;}else{var $28=$16;label=7;break;}
 case 6: 
 var $25=((($15)+($19))|0);
 var $26=((($25)-($17))|0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9__grow_byEjjjjjj($this,$17,$26,$15,$15,0,0);
 var $_pre=HEAP8[($1)];
 var $28=$_pre;label=7;break;
 case 7: 
 var $28;
 var $29=$28&1;
 var $30=(($29<<24)>>24)==0;
 if($30){label=9;break;}else{label=8;break;}
 case 8: 
 var $32=(($this+8)|0);
 var $33=HEAP32[(($32)>>2)];
 var $37=$33;label=10;break;
 case 9: 
 var $35=$this;
 var $36=(($35+1)|0);
 var $37=$36;label=10;break;
 case 10: 
 var $37;
 var $38=(($37+$15)|0);
 var $39=((($15)-($2))|0);
 var $scevgep=(($__last+$39)|0);
 var $scevgep20=$scevgep;
 var $_018=$__first;var $__p_019=$38;label=11;break;
 case 11: 
 var $__p_019;
 var $_018;
 var $41=HEAP8[($_018)];
 HEAP8[($__p_019)]=$41;
 var $42=(($__p_019+1)|0);
 var $43=(($_018+1)|0);
 var $44=($43|0)==($__last|0);
 if($44){label=12;break;}else{var $_018=$43;var $__p_019=$42;label=11;break;}
 case 12: 
 var $scevgep21=(($37+$scevgep20)|0);
 HEAP8[($scevgep21)]=0;
 var $46=((($15)+($19))|0);
 var $47=HEAP8[($1)];
 var $48=$47&1;
 var $49=(($48<<24)>>24)==0;
 if($49){label=14;break;}else{label=13;break;}
 case 13: 
 var $51=(($this+4)|0);
 HEAP32[(($51)>>2)]=$46;
 label=15;break;
 case 14: 
 var $53=$46<<1;
 var $54=(($53)&255);
 HEAP8[($1)]=$54;
 label=15;break;
 case 15: 
 return $this;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__111__money_getIcE13__gather_infoEbRKNS_6localeERNS_10money_base7patternERcS8_RNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEESF_SF_SF_Ri($__intl,$__loc,$__pat,$__dp,$__ts,$__grp,$__sym,$__psn,$__nsn,$__fd){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+176)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $__p_i_i_i_i39=sp;
 var $__p_i_i_i_i=(sp)+(16);
 var $1=(sp)+(32);
 var $2=(sp)+(40);
 var $3=(sp)+(56);
 var $4=(sp)+(72);
 var $5=(sp)+(88);
 var $6=(sp)+(104);
 var $7=(sp)+(112);
 var $8=(sp)+(128);
 var $9=(sp)+(144);
 var $10=(sp)+(160);
 if($__intl){label=2;break;}else{label=28;break;}
 case 2: 
 var $tmpcast32=$1;
 var $12=(($__loc)|0);
 var $13=HEAP32[(($12)>>2)];
 var $14=$__p_i_i_i_i;
 var $15=HEAP32[((14568)>>2)];
 var $16=($15|0)==-1;
 if($16){label=4;break;}else{label=3;break;}
 case 3: 
 var $_sroa_01_0___p67_i_idx_i_i_i=(($__p_i_i_i_i)|0);
 HEAP32[(($_sroa_01_0___p67_i_idx_i_i_i)>>2)]=14568;
 var $_sroa_12_4___p67_i_idx3_i_i_i=(($__p_i_i_i_i+4)|0);
 HEAP32[(($_sroa_12_4___p67_i_idx3_i_i_i)>>2)]=(28);
 var $_sroa_2_8___p67_i_idx4_i_i_i=(($__p_i_i_i_i+8)|0);
 HEAP32[(($_sroa_2_8___p67_i_idx4_i_i_i)>>2)]=0;
 __ZNSt3__111__call_onceERVmPvPFvS2_E(14568,$14,260);
 label=4;break;
 case 4: 
 var $18=HEAP32[((14572)>>2)];
 var $19=((($18)-(1))|0);
 var $20=(($13+12)|0);
 var $21=HEAP32[(($20)>>2)];
 var $22=(($13+8)|0);
 var $23=HEAP32[(($22)>>2)];
 var $24=$21;
 var $25=$23;
 var $26=((($24)-($25))|0);
 var $27=$26>>2;
 var $28=($27>>>0)>($19>>>0);
 if($28){label=5;break;}else{label=6;break;}
 case 5: 
 var $29=(($23+($19<<2))|0);
 var $30=HEAP32[(($29)>>2)];
 var $31=($30|0)==0;
 if($31){label=6;break;}else{label=7;break;}
 case 6: 
 var $32=___cxa_allocate_exception(4);
 var $33=$32;
 __ZNSt8bad_castC2Ev($33);
 ___cxa_throw($32,8960,(368));
 throw "Reached an unreachable!";
 case 7: 
 var $34=$30;
 var $35=$30;
 var $36=HEAP32[(($35)>>2)];
 var $37=(($36+44)|0);
 var $38=HEAP32[(($37)>>2)];
 FUNCTION_TABLE[$38]($tmpcast32,$34);
 var $39=$__pat;
 var $40=HEAP32[(($1)>>2)];
 tempBigInt=$40;HEAP8[($39)]=tempBigInt&0xff;tempBigInt = tempBigInt>>8;HEAP8[((($39)+(1))|0)]=tempBigInt&0xff;tempBigInt = tempBigInt>>8;HEAP8[((($39)+(2))|0)]=tempBigInt&0xff;tempBigInt = tempBigInt>>8;HEAP8[((($39)+(3))|0)]=tempBigInt&0xff;
 var $41=$30;
 var $42=HEAP32[(($41)>>2)];
 var $43=(($42+32)|0);
 var $44=HEAP32[(($43)>>2)];
 FUNCTION_TABLE[$44]($2,$34);
 var $45=$__nsn;
 var $46=HEAP8[($45)];
 var $47=$46&1;
 var $48=(($47<<24)>>24)==0;
 if($48){label=9;break;}else{label=8;break;}
 case 8: 
 var $50=(($__nsn+8)|0);
 var $51=HEAP32[(($50)>>2)];
 HEAP8[($51)]=0;
 var $52=(($__nsn+4)|0);
 HEAP32[(($52)>>2)]=0;
 label=10;break;
 case 9: 
 var $54=$__nsn;
 var $55=(($54+1)|0);
 HEAP8[($55)]=0;
 HEAP8[($45)]=0;
 label=10;break;
 case 10: 
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7reserveEj($__nsn,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=12;break; } else { label=11;break; }
 case 11: 
 var $57$0 = ___cxa_find_matching_catch(-1, -1,0); var $57$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
 case 12: 
 var $58=$2;
 assert(12 % 1 === 0);HEAP32[(($45)>>2)]=HEAP32[(($58)>>2)];HEAP32[((($45)+(4))>>2)]=HEAP32[((($58)+(4))>>2)];HEAP32[((($45)+(8))>>2)]=HEAP32[((($58)+(8))>>2)];
 HEAP32[(($58)>>2)]=0; HEAP32[((($58)+(4))>>2)]=0; HEAP32[((($58)+(8))>>2)]=0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($2);
 var $59=HEAP32[(($41)>>2)];
 var $60=(($59+28)|0);
 var $61=HEAP32[(($60)>>2)];
 FUNCTION_TABLE[$61]($3,$34);
 var $62=$__psn;
 var $63=HEAP8[($62)];
 var $64=$63&1;
 var $65=(($64<<24)>>24)==0;
 if($65){label=14;break;}else{label=13;break;}
 case 13: 
 var $67=(($__psn+8)|0);
 var $68=HEAP32[(($67)>>2)];
 HEAP8[($68)]=0;
 var $69=(($__psn+4)|0);
 HEAP32[(($69)>>2)]=0;
 label=15;break;
 case 14: 
 var $71=$__psn;
 var $72=(($71+1)|0);
 HEAP8[($72)]=0;
 HEAP8[($62)]=0;
 label=15;break;
 case 15: 
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7reserveEj($__psn,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=17;break; } else { label=16;break; }
 case 16: 
 var $74$0 = ___cxa_find_matching_catch(-1, -1,0); var $74$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
 case 17: 
 var $75=$3;
 assert(12 % 1 === 0);HEAP32[(($62)>>2)]=HEAP32[(($75)>>2)];HEAP32[((($62)+(4))>>2)]=HEAP32[((($75)+(4))>>2)];HEAP32[((($62)+(8))>>2)]=HEAP32[((($75)+(8))>>2)];
 HEAP32[(($75)>>2)]=0; HEAP32[((($75)+(4))>>2)]=0; HEAP32[((($75)+(8))>>2)]=0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($3);
 var $76=$30;
 var $77=HEAP32[(($76)>>2)];
 var $78=(($77+12)|0);
 var $79=HEAP32[(($78)>>2)];
 var $80=FUNCTION_TABLE[$79]($34);
 HEAP8[($__dp)]=$80;
 var $81=HEAP32[(($76)>>2)];
 var $82=(($81+16)|0);
 var $83=HEAP32[(($82)>>2)];
 var $84=FUNCTION_TABLE[$83]($34);
 HEAP8[($__ts)]=$84;
 var $85=HEAP32[(($41)>>2)];
 var $86=(($85+20)|0);
 var $87=HEAP32[(($86)>>2)];
 FUNCTION_TABLE[$87]($4,$34);
 var $88=$__grp;
 var $89=HEAP8[($88)];
 var $90=$89&1;
 var $91=(($90<<24)>>24)==0;
 if($91){label=19;break;}else{label=18;break;}
 case 18: 
 var $93=(($__grp+8)|0);
 var $94=HEAP32[(($93)>>2)];
 HEAP8[($94)]=0;
 var $95=(($__grp+4)|0);
 HEAP32[(($95)>>2)]=0;
 label=20;break;
 case 19: 
 var $97=$__grp;
 var $98=(($97+1)|0);
 HEAP8[($98)]=0;
 HEAP8[($88)]=0;
 label=20;break;
 case 20: 
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7reserveEj($__grp,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=22;break; } else { label=21;break; }
 case 21: 
 var $100$0 = ___cxa_find_matching_catch(-1, -1,0); var $100$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
 case 22: 
 var $101=$4;
 assert(12 % 1 === 0);HEAP32[(($88)>>2)]=HEAP32[(($101)>>2)];HEAP32[((($88)+(4))>>2)]=HEAP32[((($101)+(4))>>2)];HEAP32[((($88)+(8))>>2)]=HEAP32[((($101)+(8))>>2)];
 HEAP32[(($101)>>2)]=0; HEAP32[((($101)+(4))>>2)]=0; HEAP32[((($101)+(8))>>2)]=0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($4);
 var $102=HEAP32[(($41)>>2)];
 var $103=(($102+24)|0);
 var $104=HEAP32[(($103)>>2)];
 FUNCTION_TABLE[$104]($5,$34);
 var $105=$__sym;
 var $106=HEAP8[($105)];
 var $107=$106&1;
 var $108=(($107<<24)>>24)==0;
 if($108){label=24;break;}else{label=23;break;}
 case 23: 
 var $110=(($__sym+8)|0);
 var $111=HEAP32[(($110)>>2)];
 HEAP8[($111)]=0;
 var $112=(($__sym+4)|0);
 HEAP32[(($112)>>2)]=0;
 label=25;break;
 case 24: 
 var $114=$__sym;
 var $115=(($114+1)|0);
 HEAP8[($115)]=0;
 HEAP8[($105)]=0;
 label=25;break;
 case 25: 
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7reserveEj($__sym,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=27;break; } else { label=26;break; }
 case 26: 
 var $117$0 = ___cxa_find_matching_catch(-1, -1,0); var $117$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
 case 27: 
 var $118=$5;
 assert(12 % 1 === 0);HEAP32[(($105)>>2)]=HEAP32[(($118)>>2)];HEAP32[((($105)+(4))>>2)]=HEAP32[((($118)+(4))>>2)];HEAP32[((($105)+(8))>>2)]=HEAP32[((($118)+(8))>>2)];
 HEAP32[(($118)>>2)]=0; HEAP32[((($118)+(4))>>2)]=0; HEAP32[((($118)+(8))>>2)]=0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($5);
 var $119=$30;
 var $120=HEAP32[(($119)>>2)];
 var $121=(($120+36)|0);
 var $122=HEAP32[(($121)>>2)];
 var $123=FUNCTION_TABLE[$122]($34);
 var $storemerge=$123;label=54;break;
 case 28: 
 var $tmpcast=$6;
 var $125=(($__loc)|0);
 var $126=HEAP32[(($125)>>2)];
 var $127=$__p_i_i_i_i39;
 var $128=HEAP32[((14576)>>2)];
 var $129=($128|0)==-1;
 if($129){label=30;break;}else{label=29;break;}
 case 29: 
 var $_sroa_01_0___p67_i_idx_i_i_i40=(($__p_i_i_i_i39)|0);
 HEAP32[(($_sroa_01_0___p67_i_idx_i_i_i40)>>2)]=14576;
 var $_sroa_12_4___p67_i_idx3_i_i_i41=(($__p_i_i_i_i39+4)|0);
 HEAP32[(($_sroa_12_4___p67_i_idx3_i_i_i41)>>2)]=(28);
 var $_sroa_2_8___p67_i_idx4_i_i_i42=(($__p_i_i_i_i39+8)|0);
 HEAP32[(($_sroa_2_8___p67_i_idx4_i_i_i42)>>2)]=0;
 __ZNSt3__111__call_onceERVmPvPFvS2_E(14576,$127,260);
 label=30;break;
 case 30: 
 var $131=HEAP32[((14580)>>2)];
 var $132=((($131)-(1))|0);
 var $133=(($126+12)|0);
 var $134=HEAP32[(($133)>>2)];
 var $135=(($126+8)|0);
 var $136=HEAP32[(($135)>>2)];
 var $137=$134;
 var $138=$136;
 var $139=((($137)-($138))|0);
 var $140=$139>>2;
 var $141=($140>>>0)>($132>>>0);
 if($141){label=31;break;}else{label=32;break;}
 case 31: 
 var $142=(($136+($132<<2))|0);
 var $143=HEAP32[(($142)>>2)];
 var $144=($143|0)==0;
 if($144){label=32;break;}else{label=33;break;}
 case 32: 
 var $145=___cxa_allocate_exception(4);
 var $146=$145;
 __ZNSt8bad_castC2Ev($146);
 ___cxa_throw($145,8960,(368));
 throw "Reached an unreachable!";
 case 33: 
 var $147=$143;
 var $148=$143;
 var $149=HEAP32[(($148)>>2)];
 var $150=(($149+44)|0);
 var $151=HEAP32[(($150)>>2)];
 FUNCTION_TABLE[$151]($tmpcast,$147);
 var $152=$__pat;
 var $153=HEAP32[(($6)>>2)];
 tempBigInt=$153;HEAP8[($152)]=tempBigInt&0xff;tempBigInt = tempBigInt>>8;HEAP8[((($152)+(1))|0)]=tempBigInt&0xff;tempBigInt = tempBigInt>>8;HEAP8[((($152)+(2))|0)]=tempBigInt&0xff;tempBigInt = tempBigInt>>8;HEAP8[((($152)+(3))|0)]=tempBigInt&0xff;
 var $154=$143;
 var $155=HEAP32[(($154)>>2)];
 var $156=(($155+32)|0);
 var $157=HEAP32[(($156)>>2)];
 FUNCTION_TABLE[$157]($7,$147);
 var $158=$__nsn;
 var $159=HEAP8[($158)];
 var $160=$159&1;
 var $161=(($160<<24)>>24)==0;
 if($161){label=35;break;}else{label=34;break;}
 case 34: 
 var $163=(($__nsn+8)|0);
 var $164=HEAP32[(($163)>>2)];
 HEAP8[($164)]=0;
 var $165=(($__nsn+4)|0);
 HEAP32[(($165)>>2)]=0;
 label=36;break;
 case 35: 
 var $167=$__nsn;
 var $168=(($167+1)|0);
 HEAP8[($168)]=0;
 HEAP8[($158)]=0;
 label=36;break;
 case 36: 
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7reserveEj($__nsn,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=38;break; } else { label=37;break; }
 case 37: 
 var $170$0 = ___cxa_find_matching_catch(-1, -1,0); var $170$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
 case 38: 
 var $171=$7;
 assert(12 % 1 === 0);HEAP32[(($158)>>2)]=HEAP32[(($171)>>2)];HEAP32[((($158)+(4))>>2)]=HEAP32[((($171)+(4))>>2)];HEAP32[((($158)+(8))>>2)]=HEAP32[((($171)+(8))>>2)];
 HEAP32[(($171)>>2)]=0; HEAP32[((($171)+(4))>>2)]=0; HEAP32[((($171)+(8))>>2)]=0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($7);
 var $172=HEAP32[(($154)>>2)];
 var $173=(($172+28)|0);
 var $174=HEAP32[(($173)>>2)];
 FUNCTION_TABLE[$174]($8,$147);
 var $175=$__psn;
 var $176=HEAP8[($175)];
 var $177=$176&1;
 var $178=(($177<<24)>>24)==0;
 if($178){label=40;break;}else{label=39;break;}
 case 39: 
 var $180=(($__psn+8)|0);
 var $181=HEAP32[(($180)>>2)];
 HEAP8[($181)]=0;
 var $182=(($__psn+4)|0);
 HEAP32[(($182)>>2)]=0;
 label=41;break;
 case 40: 
 var $184=$__psn;
 var $185=(($184+1)|0);
 HEAP8[($185)]=0;
 HEAP8[($175)]=0;
 label=41;break;
 case 41: 
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7reserveEj($__psn,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=43;break; } else { label=42;break; }
 case 42: 
 var $187$0 = ___cxa_find_matching_catch(-1, -1,0); var $187$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
 case 43: 
 var $188=$8;
 assert(12 % 1 === 0);HEAP32[(($175)>>2)]=HEAP32[(($188)>>2)];HEAP32[((($175)+(4))>>2)]=HEAP32[((($188)+(4))>>2)];HEAP32[((($175)+(8))>>2)]=HEAP32[((($188)+(8))>>2)];
 HEAP32[(($188)>>2)]=0; HEAP32[((($188)+(4))>>2)]=0; HEAP32[((($188)+(8))>>2)]=0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($8);
 var $189=$143;
 var $190=HEAP32[(($189)>>2)];
 var $191=(($190+12)|0);
 var $192=HEAP32[(($191)>>2)];
 var $193=FUNCTION_TABLE[$192]($147);
 HEAP8[($__dp)]=$193;
 var $194=HEAP32[(($189)>>2)];
 var $195=(($194+16)|0);
 var $196=HEAP32[(($195)>>2)];
 var $197=FUNCTION_TABLE[$196]($147);
 HEAP8[($__ts)]=$197;
 var $198=HEAP32[(($154)>>2)];
 var $199=(($198+20)|0);
 var $200=HEAP32[(($199)>>2)];
 FUNCTION_TABLE[$200]($9,$147);
 var $201=$__grp;
 var $202=HEAP8[($201)];
 var $203=$202&1;
 var $204=(($203<<24)>>24)==0;
 if($204){label=45;break;}else{label=44;break;}
 case 44: 
 var $206=(($__grp+8)|0);
 var $207=HEAP32[(($206)>>2)];
 HEAP8[($207)]=0;
 var $208=(($__grp+4)|0);
 HEAP32[(($208)>>2)]=0;
 label=46;break;
 case 45: 
 var $210=$__grp;
 var $211=(($210+1)|0);
 HEAP8[($211)]=0;
 HEAP8[($201)]=0;
 label=46;break;
 case 46: 
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7reserveEj($__grp,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=48;break; } else { label=47;break; }
 case 47: 
 var $213$0 = ___cxa_find_matching_catch(-1, -1,0); var $213$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
 case 48: 
 var $214=$9;
 assert(12 % 1 === 0);HEAP32[(($201)>>2)]=HEAP32[(($214)>>2)];HEAP32[((($201)+(4))>>2)]=HEAP32[((($214)+(4))>>2)];HEAP32[((($201)+(8))>>2)]=HEAP32[((($214)+(8))>>2)];
 HEAP32[(($214)>>2)]=0; HEAP32[((($214)+(4))>>2)]=0; HEAP32[((($214)+(8))>>2)]=0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($9);
 var $215=HEAP32[(($154)>>2)];
 var $216=(($215+24)|0);
 var $217=HEAP32[(($216)>>2)];
 FUNCTION_TABLE[$217]($10,$147);
 var $218=$__sym;
 var $219=HEAP8[($218)];
 var $220=$219&1;
 var $221=(($220<<24)>>24)==0;
 if($221){label=50;break;}else{label=49;break;}
 case 49: 
 var $223=(($__sym+8)|0);
 var $224=HEAP32[(($223)>>2)];
 HEAP8[($224)]=0;
 var $225=(($__sym+4)|0);
 HEAP32[(($225)>>2)]=0;
 label=51;break;
 case 50: 
 var $227=$__sym;
 var $228=(($227+1)|0);
 HEAP8[($228)]=0;
 HEAP8[($218)]=0;
 label=51;break;
 case 51: 
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7reserveEj($__sym,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=53;break; } else { label=52;break; }
 case 52: 
 var $230$0 = ___cxa_find_matching_catch(-1, -1,0); var $230$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
 case 53: 
 var $231=$10;
 assert(12 % 1 === 0);HEAP32[(($218)>>2)]=HEAP32[(($231)>>2)];HEAP32[((($218)+(4))>>2)]=HEAP32[((($231)+(4))>>2)];HEAP32[((($218)+(8))>>2)]=HEAP32[((($231)+(8))>>2)];
 HEAP32[(($231)>>2)]=0; HEAP32[((($231)+(4))>>2)]=0; HEAP32[((($231)+(8))>>2)]=0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($10);
 var $232=$143;
 var $233=HEAP32[(($232)>>2)];
 var $234=(($233+36)|0);
 var $235=HEAP32[(($234)>>2)];
 var $236=FUNCTION_TABLE[$235]($147);
 var $storemerge=$236;label=54;break;
 case 54: 
 var $storemerge;
 HEAP32[(($__fd)>>2)]=$storemerge;
 STACKTOP=sp;return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__116__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj($__grouping,$__g,$__g_end,$__err){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=$__grouping;
 var $2=HEAP8[($1)];
 var $3=$2&1;
 var $4=(($3<<24)>>24)==0;
 if($4){label=3;break;}else{label=2;break;}
 case 2: 
 var $6=(($__grouping+4)|0);
 var $7=HEAP32[(($6)>>2)];
 var $11=$7;label=4;break;
 case 3: 
 var $9=($2&255);
 var $10=$9>>>1;
 var $11=$10;label=4;break;
 case 4: 
 var $11;
 var $12=($11|0)==0;
 if($12){label=21;break;}else{label=5;break;}
 case 5: 
 var $14=($__g|0)==($__g_end|0);
 if($14){var $23=$2;label=9;break;}else{label=6;break;}
 case 6: 
 var $15=((($__g_end)-(4))|0);
 var $16=($15>>>0)>($__g>>>0);
 if($16){var $_078_i_i=$__g;var $17=$15;label=7;break;}else{var $23=$2;label=9;break;}
 case 7: 
 var $17;
 var $_078_i_i;
 var $18=HEAP32[(($_078_i_i)>>2)];
 var $19=HEAP32[(($17)>>2)];
 HEAP32[(($_078_i_i)>>2)]=$19;
 HEAP32[(($17)>>2)]=$18;
 var $20=(($_078_i_i+4)|0);
 var $21=((($17)-(4))|0);
 var $22=($20>>>0)<($21>>>0);
 if($22){var $_078_i_i=$20;var $17=$21;label=7;break;}else{label=8;break;}
 case 8: 
 var $_pre=HEAP8[($1)];
 var $23=$_pre;label=9;break;
 case 9: 
 var $23;
 var $24=$23&1;
 var $25=(($24<<24)>>24)==0;
 if($25){label=11;break;}else{label=10;break;}
 case 10: 
 var $27=(($__grouping+8)|0);
 var $28=HEAP32[(($27)>>2)];
 var $29=(($__grouping+4)|0);
 var $30=HEAP32[(($29)>>2)];
 var $37=$30;var $36=$28;label=12;break;
 case 11: 
 var $32=$__grouping;
 var $33=(($32+1)|0);
 var $34=($23&255);
 var $35=$34>>>1;
 var $37=$35;var $36=$33;label=12;break;
 case 12: 
 var $36;
 var $37;
 var $38=((($__g_end)-(4))|0);
 var $39=($38>>>0)>($__g>>>0);
 var $40=HEAP8[($36)];
 var $_not28=(($40<<24)>>24)<1;
 var $41=(($40<<24)>>24)==127;
 var $or_cond2129=$_not28|$41;
 if($39){label=13;break;}else{var $_lcssa25=$40;var $or_cond21_lcssa=$or_cond2129;label=18;break;}
 case 13: 
 var $42=(($36+$37)|0);
 var $43=$42;
 var $__ig_030=$36;var $__r_031=$__g;var $45=$40;var $or_cond2132=$or_cond2129;label=14;break;
 case 14: 
 var $or_cond2132;
 var $45;
 var $__r_031;
 var $__ig_030;
 if($or_cond2132){label=17;break;}else{label=15;break;}
 case 15: 
 var $47=(($45<<24)>>24);
 var $48=HEAP32[(($__r_031)>>2)];
 var $49=($47|0)==($48|0);
 if($49){label=17;break;}else{label=16;break;}
 case 16: 
 HEAP32[(($__err)>>2)]=4;
 label=21;break;
 case 17: 
 var $52=$__ig_030;
 var $53=((($43)-($52))|0);
 var $54=($53|0)>1;
 var $55=(($__ig_030+1)|0);
 var $___ig_0=($54?$55:$__ig_030);
 var $56=(($__r_031+4)|0);
 var $57=($56>>>0)<($38>>>0);
 var $58=HEAP8[($___ig_0)];
 var $_not=(($58<<24)>>24)<1;
 var $59=(($58<<24)>>24)==127;
 var $or_cond21=$_not|$59;
 if($57){var $__ig_030=$___ig_0;var $__r_031=$56;var $45=$58;var $or_cond2132=$or_cond21;label=14;break;}else{var $_lcssa25=$58;var $or_cond21_lcssa=$or_cond21;label=18;break;}
 case 18: 
 var $or_cond21_lcssa;
 var $_lcssa25;
 if($or_cond21_lcssa){label=21;break;}else{label=19;break;}
 case 19: 
 var $61=(($_lcssa25<<24)>>24);
 var $62=HEAP32[(($38)>>2)];
 var $63=($61>>>0)<($62>>>0);
 var $64=($62|0)==0;
 var $or_cond=$63|$64;
 if($or_cond){label=20;break;}else{label=21;break;}
 case 20: 
 HEAP32[(($__err)>>2)]=4;
 label=21;break;
 case 21: 
 return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__19money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEED0Ev($this){
 var label=0;


 var $1=(($this)|0);
 __ZNSt3__114__shared_countD2Ev($1);
 var $2=$this;
 __ZdlPv($2);
 return;
}


function __ZNSt3__19money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEED1Ev($this){
 var label=0;


 var $1=(($this)|0);
 __ZNSt3__114__shared_countD2Ev($1);
 return;
}


function __ZNKSt3__19money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_bRNS_8ios_baseERjRe($agg_result,$this,$__b,$__e,$__intl,$__iob,$__err,$__v){
 var label=0;
 var tempVarArgs=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+600)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var tempParam = $__b; $__b=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__b)>>2)]=HEAP32[((tempParam)>>2)];
 var tempParam = $__e; $__e=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $__p_i_i_i_i=sp;
 var $__wbuf=(sp)+(16);
 var $__wb=(sp)+(416);
 var $__wn=(sp)+(424);
 var $__loc=(sp)+(432);
 var $__neg=(sp)+(440);
 var $1=(sp)+(448);
 var $__atoms=(sp)+(456);
 var $__nbuf=(sp)+(496);
 var $2=(($__wbuf)|0);
 var $3=(($__wb)|0);
 HEAP32[(($3)>>2)]=$2;
 var $4=(($__wb+4)|0);
 HEAP32[(($4)>>2)]=440;
 var $5=(($__wbuf+400)|0);
 (function() { try { __THREW__ = 0; return __ZNKSt3__18ios_base6getlocEv($__loc,$__iob) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=2;break; } else { label=14;break; }
 case 2: 
 var $7=(($__loc)|0);
 var $8=HEAP32[(($7)>>2)];
 var $9=$__p_i_i_i_i;
 var $10=HEAP32[((14088)>>2)];
 var $11=($10|0)==-1;
 if($11){label=4;break;}else{label=3;break;}
 case 3: 
 var $_sroa_01_0___p67_i_idx_i_i_i=(($__p_i_i_i_i)|0);
 HEAP32[(($_sroa_01_0___p67_i_idx_i_i_i)>>2)]=14088;
 var $_sroa_12_4___p67_i_idx3_i_i_i=(($__p_i_i_i_i+4)|0);
 HEAP32[(($_sroa_12_4___p67_i_idx3_i_i_i)>>2)]=(28);
 var $_sroa_2_8___p67_i_idx4_i_i_i=(($__p_i_i_i_i+8)|0);
 HEAP32[(($_sroa_2_8___p67_i_idx4_i_i_i)>>2)]=0;
 (function() { try { __THREW__ = 0; return __ZNSt3__111__call_onceERVmPvPFvS2_E(14088,$9,260) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=4;break; } else { label=15;break; }
 case 4: 
 var $13=HEAP32[((14092)>>2)];
 var $14=((($13)-(1))|0);
 var $15=(($8+12)|0);
 var $16=HEAP32[(($15)>>2)];
 var $17=(($8+8)|0);
 var $18=HEAP32[(($17)>>2)];
 var $19=$16;
 var $20=$18;
 var $21=((($19)-($20))|0);
 var $22=$21>>2;
 var $23=($22>>>0)>($14>>>0);
 if($23){label=5;break;}else{label=6;break;}
 case 5: 
 var $24=(($18+($14<<2))|0);
 var $25=HEAP32[(($24)>>2)];
 var $26=($25|0)==0;
 if($26){label=6;break;}else{label=8;break;}
 case 6: 
 var $27=___cxa_allocate_exception(4);
 var $28=$27;
 __ZNSt8bad_castC2Ev($28);
 (function() { try { __THREW__ = 0; return ___cxa_throw($27,8960,(368)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=7;break; } else { label=15;break; }
 case 7: 
 throw "Reached an unreachable!";
 case 8: 
 var $30=$25;
 HEAP8[($__neg)]=0;
 var $31=(($__e)|0);
 var $32=HEAP32[(($31)>>2)];
 var $33=(($1)|0);
 HEAP32[(($33)>>2)]=$32;
 var $34=(($__iob+4)|0);
 var $35=HEAP32[(($34)>>2)];
 var $36=(function() { try { __THREW__ = 0; return __ZNSt3__19money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE8__do_getERS4_S4_bRKNS_6localeEjRjRbRKNS_5ctypeIwEERNS_10unique_ptrIwPFvPvEEERPwSM_($__b,$1,$__intl,$__loc,$35,$__err,$__neg,$30,$__wb,$__wn,$5) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=9;break; } else { label=15;break; }
 case 9: 
 if($36){label=10;break;}else{label=34;break;}
 case 10: 
 var $39=(($__atoms)|0);
 var $40=$25;
 var $41=HEAP32[(($40)>>2)];
 var $42=(($41+48)|0);
 var $43=HEAP32[(($42)>>2)];
 var $44=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$43]($30,2616,2626,$39) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=11;break; } else { label=15;break; }
 case 11: 
 var $45=(($__nbuf)|0);
 var $46=HEAP32[(($__wn)>>2)];
 var $47=HEAP32[(($3)>>2)];
 var $48=$46;
 var $49=$47;
 var $50=((($48)-($49))|0);
 var $51=($50|0)>392;
 if($51){label=12;break;}else{var $__nc_0=$45;var $73=0;label=19;break;}
 case 12: 
 var $52=$50>>2;
 var $53=((($52)+(2))|0);
 var $54=_malloc($53);
 var $55=($54|0)==0;
 if($55){label=13;break;}else{var $__nc_0=$54;var $73=$54;label=19;break;}
 case 13: 
 (function() { try { __THREW__ = 0; return __ZSt17__throw_bad_allocv() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $__nc_0=0;var $73=0;label=19;break; } else { var $65=0;label=16;break; }
 case 14: 
 var $57$0 = ___cxa_find_matching_catch(-1, -1); var $57$1 = tempRet0;
 var $58=$57$0;
 var $59=$57$1;
 HEAP32[(($3)>>2)]=0;
 var $169=$2;var $_11635=$59;var $_137=$58;var $168=440;label=56;break;
 case 15: 
 var $61$0 = ___cxa_find_matching_catch(-1, -1); var $61$1 = tempRet0;
 var $62=$61$0;
 var $63=$61$1;
 var $_0=$62;var $_015=$63;label=54;break;
 case 16: 
 var $65;
 var $66$0 = ___cxa_find_matching_catch(-1, -1); var $66$1 = tempRet0;
 var $eh_lpad_body$1=$66$1;var $eh_lpad_body$0=$66$0;var $67=$65;label=17;break;
 case 17: 
 var $67;
 var $eh_lpad_body$0;
 var $eh_lpad_body$1;
 var $68=$eh_lpad_body$0;
 var $69=$eh_lpad_body$1;
 var $70=($67|0)==0;
 if($70){var $_0=$68;var $_015=$69;label=54;break;}else{label=18;break;}
 case 18: 
 _free($67);
 var $_0=$68;var $_015=$69;label=54;break;
 case 19: 
 var $73;
 var $__nc_0;
 var $74=HEAP8[($__neg)];
 var $75=(($74<<24)>>24)==0;
 if($75){var $__nc_1=$__nc_0;label=21;break;}else{label=20;break;}
 case 20: 
 var $77=(($__nc_0+1)|0);
 HEAP8[($__nc_0)]=45;
 var $__nc_1=$77;label=21;break;
 case 21: 
 var $__nc_1;
 var $79=($47>>>0)<($46>>>0);
 if($79){label=22;break;}else{var $__nc_2_lcssa=$__nc_1;label=27;break;}
 case 22: 
 var $80=(($__atoms+40)|0);
 var $81=$__atoms;
 var $__nc_231=$__nc_1;var $__w_032=$47;label=23;break;
 case 23: 
 var $__w_032;
 var $__nc_231;
 var $_0_i=$39;label=24;break;
 case 24: 
 var $_0_i;
 var $84=($_0_i|0)==($80|0);
 if($84){var $_0_lcssa_i=$80;label=26;break;}else{label=25;break;}
 case 25: 
 var $86=HEAP32[(($_0_i)>>2)];
 var $87=HEAP32[(($__w_032)>>2)];
 var $88=($86|0)==($87|0);
 var $89=(($_0_i+4)|0);
 if($88){var $_0_lcssa_i=$_0_i;label=26;break;}else{var $_0_i=$89;label=24;break;}
 case 26: 
 var $_0_lcssa_i;
 var $90=$_0_lcssa_i;
 var $91=((($90)-($81))|0);
 var $92=$91>>2;
 var $93=((2616+$92)|0);
 var $94=HEAP8[($93)];
 HEAP8[($__nc_231)]=$94;
 var $95=(($__w_032+4)|0);
 var $96=(($__nc_231+1)|0);
 var $97=HEAP32[(($__wn)>>2)];
 var $98=($95>>>0)<($97>>>0);
 if($98){var $__nc_231=$96;var $__w_032=$95;label=23;break;}else{var $__nc_2_lcssa=$96;label=27;break;}
 case 27: 
 var $__nc_2_lcssa;
 HEAP8[($__nc_2_lcssa)]=0;
 var $99=_sscanf($45,1576,(tempVarArgs=STACKTOP,STACKTOP = (STACKTOP + 8)|0,(assert((STACKTOP|0) < (STACK_MAX|0))|0),HEAP32[((tempVarArgs)>>2)]=$__v,tempVarArgs)); STACKTOP=tempVarArgs;
 var $100=($99|0)==1;
 if($100){label=32;break;}else{label=28;break;}
 case 28: 
 var $102=___cxa_allocate_exception(8);
 var $103=$102;
 (function() { try { __THREW__ = 0; return __ZNSt13runtime_errorC2EPKc($103,1544) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=29;break; } else { label=31;break; }
 case 29: 
 (function() { try { __THREW__ = 0; return ___cxa_throw($102,8976,(46)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=30;break; } else { var $65=$73;label=16;break; }
 case 30: 
 throw "Reached an unreachable!";
 case 31: 
 var $106$0 = ___cxa_find_matching_catch(-1, -1); var $106$1 = tempRet0;
 ___cxa_free_exception($102);
 var $eh_lpad_body$1=$106$1;var $eh_lpad_body$0=$106$0;var $67=$73;label=17;break;
 case 32: 
 var $108=($73|0)==0;
 if($108){label=34;break;}else{label=33;break;}
 case 33: 
 _free($73);
 label=34;break;
 case 34: 
 var $110=(($__b)|0);
 var $111=HEAP32[(($110)>>2)];
 var $112=($111|0)==0;
 if($112){var $129=1;label=41;break;}else{label=35;break;}
 case 35: 
 var $114=(($111+12)|0);
 var $115=HEAP32[(($114)>>2)];
 var $116=(($111+16)|0);
 var $117=HEAP32[(($116)>>2)];
 var $118=($115|0)==($117|0);
 if($118){label=36;break;}else{label=37;break;}
 case 36: 
 var $120=$111;
 var $121=HEAP32[(($120)>>2)];
 var $122=(($121+36)|0);
 var $123=HEAP32[(($122)>>2)];
 var $124=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$123]($111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $_0_i_i_i_i=$124;label=38;break; } else { label=15;break; }
 case 37: 
 var $126=HEAP32[(($115)>>2)];
 var $_0_i_i_i_i=$126;label=38;break;
 case 38: 
 var $_0_i_i_i_i;
 var $127=($_0_i_i_i_i|0)==-1;
 if($127){label=40;break;}else{label=39;break;}
 case 39: 
 var $_pre_i_i_i=HEAP32[(($110)>>2)];
 var $phitmp_i_i_i=($_pre_i_i_i|0)==0;
 var $129=$phitmp_i_i_i;label=41;break;
 case 40: 
 HEAP32[(($110)>>2)]=0;
 var $129=1;label=41;break;
 case 41: 
 var $129;
 var $130=HEAP32[(($31)>>2)];
 var $131=($130|0)==0;
 if($131){label=47;break;}else{label=42;break;}
 case 42: 
 var $133=(($130+12)|0);
 var $134=HEAP32[(($133)>>2)];
 var $135=(($130+16)|0);
 var $136=HEAP32[(($135)>>2)];
 var $137=($134|0)==($136|0);
 if($137){label=43;break;}else{label=44;break;}
 case 43: 
 var $139=$130;
 var $140=HEAP32[(($139)>>2)];
 var $141=(($140+36)|0);
 var $142=HEAP32[(($141)>>2)];
 var $143=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$142]($130) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $_0_i_i2_i_i=$143;label=45;break; } else { label=15;break; }
 case 44: 
 var $145=HEAP32[(($134)>>2)];
 var $_0_i_i2_i_i=$145;label=45;break;
 case 45: 
 var $_0_i_i2_i_i;
 var $146=($_0_i_i2_i_i|0)==-1;
 if($146){label=46;break;}else{label=48;break;}
 case 46: 
 HEAP32[(($31)>>2)]=0;
 label=47;break;
 case 47: 
 if($129){label=49;break;}else{label=50;break;}
 case 48: 
 if($129){label=50;break;}else{label=49;break;}
 case 49: 
 var $149=HEAP32[(($__err)>>2)];
 var $150=$149|2;
 HEAP32[(($__err)>>2)]=$150;
 label=50;break;
 case 50: 
 var $151=HEAP32[(($110)>>2)];
 var $152=(($agg_result)|0);
 HEAP32[(($152)>>2)]=$151;
 var $153=HEAP32[(($7)>>2)];
 var $154=(($153)|0);
 var $155=__ZNSt3__114__shared_count16__release_sharedEv($154);
 var $156=HEAP32[(($3)>>2)];
 HEAP32[(($3)>>2)]=0;
 var $157=($156|0)==0;
 if($157){label=53;break;}else{label=51;break;}
 case 51: 
 var $159=HEAP32[(($4)>>2)];
 var $160=$156;
 (function() { try { __THREW__ = 0; return FUNCTION_TABLE[$159]($160) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=53;break; } else { label=52;break; }
 case 52: 
 var $162$0 = ___cxa_find_matching_catch(-1, -1,0); var $162$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
 case 53: 
 STACKTOP=sp;return;
 case 54: 
 var $_015;
 var $_0;
 var $163=HEAP32[(($7)>>2)];
 var $164=(($163)|0);
 var $165=__ZNSt3__114__shared_count16__release_sharedEv($164);
 var $_pre=HEAP32[(($3)>>2)];
 HEAP32[(($3)>>2)]=0;
 var $166=($_pre|0)==0;
 if($166){var $_11636=$_015;var $_138=$_0;label=58;break;}else{label=55;break;}
 case 55: 
 var $_pre40=HEAP32[(($4)>>2)];
 var $169=$_pre;var $_11635=$_015;var $_137=$_0;var $168=$_pre40;label=56;break;
 case 56: 
 var $168;
 var $_137;
 var $_11635;
 var $169;
 var $170=$169;
 (function() { try { __THREW__ = 0; return FUNCTION_TABLE[$168]($170) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $_11636=$_11635;var $_138=$_137;label=58;break; } else { label=57;break; }
 case 57: 
 var $172$0 = ___cxa_find_matching_catch(-1, -1,0); var $172$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
 case 58: 
 var $_138;
 var $_11636;
 var $173$0=$_138;
 var $173$1=0;
 var $174$0=$173$0;
 var $174$1=$_11636;
 ___resumeException($174$0)
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__19money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE8__do_getERS4_S4_bRKNS_6localeEjRjRbRKNS_5ctypeIwEERNS_10unique_ptrIwPFvPvEEERPwSM_($__b,$__e,$__intl,$__loc,$__flags,$__err,$__neg,$__ct,$__wb,$__wn,$__we){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+528)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var tempParam = $__e; $__e=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=sp;
 var $__gbuf=(sp)+(8);
 var $__pat=(sp)+(408);
 var $__dp=(sp)+(416);
 var $__ts=(sp)+(424);
 var $__grp=(sp)+(432);
 var $__sym=(sp)+(448);
 var $__psn=(sp)+(464);
 var $__nsn=(sp)+(480);
 var $__spaces=(sp)+(496);
 var $__fd=(sp)+(512);
 var $__et=(sp)+(520);
 HEAP32[(($1)>>2)]=$__we;
 var $2=(($__gbuf)|0);
 var $this4_i_i_i=$__grp;
 HEAP32[(($this4_i_i_i)>>2)]=0; HEAP32[((($this4_i_i_i)+(4))>>2)]=0; HEAP32[((($this4_i_i_i)+(8))>>2)]=0;
 var $this4_i_i_i92=$__sym;
 HEAP32[(($this4_i_i_i92)>>2)]=0; HEAP32[((($this4_i_i_i92)+(4))>>2)]=0; HEAP32[((($this4_i_i_i92)+(8))>>2)]=0;
 var $this4_i_i_i93=$__psn;
 HEAP32[(($this4_i_i_i93)>>2)]=0; HEAP32[((($this4_i_i_i93)+(4))>>2)]=0; HEAP32[((($this4_i_i_i93)+(8))>>2)]=0;
 var $this4_i_i_i95=$__nsn;
 HEAP32[(($this4_i_i_i95)>>2)]=0; HEAP32[((($this4_i_i_i95)+(4))>>2)]=0; HEAP32[((($this4_i_i_i95)+(8))>>2)]=0;
 var $this4_i_i_i98=$__spaces;
 HEAP32[(($this4_i_i_i98)>>2)]=0; HEAP32[((($this4_i_i_i98)+(4))>>2)]=0; HEAP32[((($this4_i_i_i98)+(8))>>2)]=0;
 (function() { try { __THREW__ = 0; return __ZNSt3__111__money_getIwE13__gather_infoEbRKNS_6localeERNS_10money_base7patternERwS8_RNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERNS9_IwNSA_IwEENSC_IwEEEESJ_SJ_Ri($__intl,$__loc,$__pat,$__dp,$__ts,$__grp,$__sym,$__psn,$__nsn,$__fd) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=2;break; } else { label=26;break; }
 case 2: 
 var $4=(($__gbuf+400)|0);
 var $5=(($__wb)|0);
 var $6=HEAP32[(($5)>>2)];
 HEAP32[(($__wn)>>2)]=$6;
 var $7=(($__b)|0);
 var $8=(($__e)|0);
 var $9=$__ct;
 var $10=(($__nsn+4)|0);
 var $11=(($__nsn+8)|0);
 var $12=(($__psn+4)|0);
 var $13=(($__psn+8)|0);
 var $14=$__flags&512;
 var $15=($14|0)!=0;
 var $16=(($__sym+4)|0);
 var $17=(($__sym+8)|0);
 var $18=(($__spaces+4)|0);
 var $19=(($__spaces+8)|0);
 var $20=(($__pat+3)|0);
 var $21=(($__grp+4)|0);
 var $_ZNSt3__112__do_nothingEPv343455=440;var $23=$2;var $__gb_sroa_0_0_load322334460=$2;var $22=$4;var $__p_0465=0;var $__trailing_sign_0467=0;label=3;break;
 case 3: 
 var $__trailing_sign_0467;
 var $__p_0465;
 var $22;
 var $__gb_sroa_0_0_load322334460;
 var $23;
 var $_ZNSt3__112__do_nothingEPv343455;
 var $24=HEAP32[(($7)>>2)];
 var $25=($24|0)==0;
 if($25){var $42=1;label=10;break;}else{label=4;break;}
 case 4: 
 var $27=(($24+12)|0);
 var $28=HEAP32[(($27)>>2)];
 var $29=(($24+16)|0);
 var $30=HEAP32[(($29)>>2)];
 var $31=($28|0)==($30|0);
 if($31){label=5;break;}else{label=6;break;}
 case 5: 
 var $33=$24;
 var $34=HEAP32[(($33)>>2)];
 var $35=(($34+36)|0);
 var $36=HEAP32[(($35)>>2)];
 var $37=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$36]($24) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $_0_i_i_i_i101=$37;label=7;break; } else { var $_ph_ph360_ph_ph_ph_ph_ph=$23;var $_ZNSt3__112__do_nothingEPv347_ph_ph359_ph_ph_ph_ph_ph=$_ZNSt3__112__do_nothingEPv343455;label=25;break; }
 case 6: 
 var $39=HEAP32[(($28)>>2)];
 var $_0_i_i_i_i101=$39;label=7;break;
 case 7: 
 var $_0_i_i_i_i101;
 var $40=($_0_i_i_i_i101|0)==-1;
 if($40){label=9;break;}else{label=8;break;}
 case 8: 
 var $_pre_i_i_i103=HEAP32[(($7)>>2)];
 var $phitmp_i_i_i104=($_pre_i_i_i103|0)==0;
 var $42=$phitmp_i_i_i104;label=10;break;
 case 9: 
 HEAP32[(($7)>>2)]=0;
 var $42=1;label=10;break;
 case 10: 
 var $42;
 var $43=HEAP32[(($8)>>2)];
 var $44=($43|0)==0;
 if($44){label=16;break;}else{label=11;break;}
 case 11: 
 var $46=(($43+12)|0);
 var $47=HEAP32[(($46)>>2)];
 var $48=(($43+16)|0);
 var $49=HEAP32[(($48)>>2)];
 var $50=($47|0)==($49|0);
 if($50){label=12;break;}else{label=13;break;}
 case 12: 
 var $52=$43;
 var $53=HEAP32[(($52)>>2)];
 var $54=(($53+36)|0);
 var $55=HEAP32[(($54)>>2)];
 var $56=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$55]($43) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $_0_i_i2_i_i107=$56;label=14;break; } else { var $_ph_ph360_ph_ph_ph_ph_ph=$23;var $_ZNSt3__112__do_nothingEPv347_ph_ph359_ph_ph_ph_ph_ph=$_ZNSt3__112__do_nothingEPv343455;label=25;break; }
 case 13: 
 var $58=HEAP32[(($47)>>2)];
 var $_0_i_i2_i_i107=$58;label=14;break;
 case 14: 
 var $_0_i_i2_i_i107;
 var $59=($_0_i_i2_i_i107|0)==-1;
 if($59){label=15;break;}else{label=17;break;}
 case 15: 
 HEAP32[(($8)>>2)]=0;
 label=16;break;
 case 16: 
 if($42){var $_ZNSt3__112__do_nothingEPv343_lcssa=$_ZNSt3__112__do_nothingEPv343455;var $_lcssa=$23;var $__gb_sroa_0_0_load322334_lcssa=$__gb_sroa_0_0_load322334460;var $__trailing_sign_0_lcssa=$__trailing_sign_0467;label=302;break;}else{var $63=0;label=18;break;}
 case 17: 
 if($42){var $63=$43;label=18;break;}else{var $_ZNSt3__112__do_nothingEPv343_lcssa=$_ZNSt3__112__do_nothingEPv343455;var $_lcssa=$23;var $__gb_sroa_0_0_load322334_lcssa=$__gb_sroa_0_0_load322334460;var $__trailing_sign_0_lcssa=$__trailing_sign_0467;label=302;break;}
 case 18: 
 var $63;
 var $64=(($__pat+$__p_0465)|0);
 var $65=HEAP8[($64)];
 var $66=(($65<<24)>>24);
 switch(($66|0)){case 2:{ label=135;break;}case 4:{ var $__ng_0=0;var $595=$22;var $__gb_sroa_0_0_load322333=$__gb_sroa_0_0_load322334460;var $594=$23;var $_ZNSt3__112__do_nothingEPv342=$_ZNSt3__112__do_nothingEPv343455;label=194;break;}case 1:{ label=31;break;}case 0:{ label=42;break;}case 3:{ label=67;break;}default:{var $__trailing_sign_1=$__trailing_sign_0467;var $935=$22;var $__gb_sroa_0_0_load322335=$__gb_sroa_0_0_load322334460;var $934=$23;var $_ZNSt3__112__do_nothingEPv344=$_ZNSt3__112__do_nothingEPv343455;label=301;break;}}break;
 case 19: 
 var $lpad_loopexit$0 = ___cxa_find_matching_catch(-1, -1); var $lpad_loopexit$1 = tempRet0;
 var $lpad_phi$1=$lpad_loopexit$1;var $lpad_phi$0=$lpad_loopexit$0;var $67=$_lcssa;var $_ZNSt3__112__do_nothingEPv347=$_ZNSt3__112__do_nothingEPv343_lcssa;label=27;break;
 case 20: 
 var $_ZNSt3__112__do_nothingEPv347_ph_ph;
 var $_ph_ph;
 var $lpad_loopexit361$0 = ___cxa_find_matching_catch(-1, -1); var $lpad_loopexit361$1 = tempRet0;
 var $lpad_phi$1=$lpad_loopexit361$1;var $lpad_phi$0=$lpad_loopexit361$0;var $67=$_ph_ph;var $_ZNSt3__112__do_nothingEPv347=$_ZNSt3__112__do_nothingEPv347_ph_ph;label=27;break;
 case 21: 
 var $lpad_loopexit375$0 = ___cxa_find_matching_catch(-1, -1); var $lpad_loopexit375$1 = tempRet0;
 var $lpad_phi$1=$lpad_loopexit375$1;var $lpad_phi$0=$lpad_loopexit375$0;var $67=$750;var $_ZNSt3__112__do_nothingEPv347=$_ZNSt3__112__do_nothingEPv345;label=27;break;
 case 22: 
 var $lpad_loopexit377$0 = ___cxa_find_matching_catch(-1, -1); var $lpad_loopexit377$1 = tempRet0;
 var $lpad_phi$1=$lpad_loopexit377$1;var $lpad_phi$0=$lpad_loopexit377$0;var $67=$23;var $_ZNSt3__112__do_nothingEPv347=$_ZNSt3__112__do_nothingEPv343455;label=27;break;
 case 23: 
 var $lpad_loopexit381$0 = ___cxa_find_matching_catch(-1, -1); var $lpad_loopexit381$1 = tempRet0;
 var $lpad_phi$1=$lpad_loopexit381$1;var $lpad_phi$0=$lpad_loopexit381$0;var $67=$23;var $_ZNSt3__112__do_nothingEPv347=$_ZNSt3__112__do_nothingEPv343455;label=27;break;
 case 24: 
 var $lpad_loopexit385$0 = ___cxa_find_matching_catch(-1, -1); var $lpad_loopexit385$1 = tempRet0;
 var $lpad_phi$1=$lpad_loopexit385$1;var $lpad_phi$0=$lpad_loopexit385$0;var $67=$23;var $_ZNSt3__112__do_nothingEPv347=$_ZNSt3__112__do_nothingEPv343455;label=27;break;
 case 25: 
 var $_ZNSt3__112__do_nothingEPv347_ph_ph359_ph_ph_ph_ph_ph;
 var $_ph_ph360_ph_ph_ph_ph_ph;
 var $lpad_loopexit388$0 = ___cxa_find_matching_catch(-1, -1); var $lpad_loopexit388$1 = tempRet0;
 var $lpad_phi$1=$lpad_loopexit388$1;var $lpad_phi$0=$lpad_loopexit388$0;var $67=$_ph_ph360_ph_ph_ph_ph_ph;var $_ZNSt3__112__do_nothingEPv347=$_ZNSt3__112__do_nothingEPv347_ph_ph359_ph_ph_ph_ph_ph;label=27;break;
 case 26: 
 var $lpad_nonloopexit$0 = ___cxa_find_matching_catch(-1, -1); var $lpad_nonloopexit$1 = tempRet0;
 var $lpad_phi$1=$lpad_nonloopexit$1;var $lpad_phi$0=$lpad_nonloopexit$0;var $67=$2;var $_ZNSt3__112__do_nothingEPv347=440;label=27;break;
 case 27: 
 var $_ZNSt3__112__do_nothingEPv347;
 var $67;
 var $lpad_phi$0;
 var $lpad_phi$1;
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev($__spaces);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev($__nsn);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev($__psn);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev($__sym);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grp);
 var $68=($67|0)==0;
 if($68){label=30;break;}else{label=28;break;}
 case 28: 
 var $70=$67;
 (function() { try { __THREW__ = 0; return FUNCTION_TABLE[$_ZNSt3__112__do_nothingEPv347]($70) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=30;break; } else { label=29;break; }
 case 29: 
 var $72$0 = ___cxa_find_matching_catch(-1, -1,0); var $72$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
 case 30: 
 ___resumeException($lpad_phi$0)
 case 31: 
 var $cond=($__p_0465|0)==3;
 if($cond){var $_ZNSt3__112__do_nothingEPv343_lcssa=$_ZNSt3__112__do_nothingEPv343455;var $_lcssa=$23;var $__gb_sroa_0_0_load322334_lcssa=$__gb_sroa_0_0_load322334460;var $__trailing_sign_0_lcssa=$__trailing_sign_0467;label=302;break;}else{label=32;break;}
 case 32: 
 var $75=HEAP32[(($7)>>2)];
 var $76=(($75+12)|0);
 var $77=HEAP32[(($76)>>2)];
 var $78=(($75+16)|0);
 var $79=HEAP32[(($78)>>2)];
 var $80=($77|0)==($79|0);
 if($80){label=33;break;}else{label=34;break;}
 case 33: 
 var $82=$75;
 var $83=HEAP32[(($82)>>2)];
 var $84=(($83+36)|0);
 var $85=HEAP32[(($84)>>2)];
 var $86=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$85]($75) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $_0_i_i116=$86;label=35;break; } else { var $_ph_ph360_ph_ph_ph_ph_ph=$23;var $_ZNSt3__112__do_nothingEPv347_ph_ph359_ph_ph_ph_ph_ph=$_ZNSt3__112__do_nothingEPv343455;label=25;break; }
 case 34: 
 var $88=HEAP32[(($77)>>2)];
 var $_0_i_i116=$88;label=35;break;
 case 35: 
 var $_0_i_i116;
 var $89=HEAP32[(($9)>>2)];
 var $90=(($89+12)|0);
 var $91=HEAP32[(($90)>>2)];
 var $92=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$91]($__ct,8192,$_0_i_i116) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=36;break; } else { var $_ph_ph360_ph_ph_ph_ph_ph=$23;var $_ZNSt3__112__do_nothingEPv347_ph_ph359_ph_ph_ph_ph_ph=$_ZNSt3__112__do_nothingEPv343455;label=25;break; }
 case 36: 
 if($92){label=37;break;}else{label=41;break;}
 case 37: 
 var $94=HEAP32[(($7)>>2)];
 var $95=(($94+12)|0);
 var $96=HEAP32[(($95)>>2)];
 var $97=(($94+16)|0);
 var $98=HEAP32[(($97)>>2)];
 var $99=($96|0)==($98|0);
 if($99){label=38;break;}else{label=39;break;}
 case 38: 
 var $101=$94;
 var $102=HEAP32[(($101)>>2)];
 var $103=(($102+40)|0);
 var $104=HEAP32[(($103)>>2)];
 var $105=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$104]($94) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $_0_i_i120=$105;label=40;break; } else { var $_ph_ph360_ph_ph_ph_ph_ph=$23;var $_ZNSt3__112__do_nothingEPv347_ph_ph359_ph_ph_ph_ph_ph=$_ZNSt3__112__do_nothingEPv343455;label=25;break; }
 case 39: 
 var $107=(($96+4)|0);
 HEAP32[(($95)>>2)]=$107;
 var $108=HEAP32[(($96)>>2)];
 var $_0_i_i120=$108;label=40;break;
 case 40: 
 var $_0_i_i120;
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE9push_backEw($__spaces,$_0_i_i120) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=42;break; } else { var $_ph_ph360_ph_ph_ph_ph_ph=$23;var $_ZNSt3__112__do_nothingEPv347_ph_ph359_ph_ph_ph_ph_ph=$_ZNSt3__112__do_nothingEPv343455;label=25;break; }
 case 41: 
 var $110=HEAP32[(($__err)>>2)];
 var $111=$110|4;
 HEAP32[(($__err)>>2)]=$111;
 var $_0=0;var $1041=$23;var $_ZNSt3__112__do_nothingEPv=$_ZNSt3__112__do_nothingEPv343455;label=336;break;
 case 42: 
 var $113=($__p_0465|0)==3;
 if($113){var $_ZNSt3__112__do_nothingEPv343_lcssa=$_ZNSt3__112__do_nothingEPv343455;var $_lcssa=$23;var $__gb_sroa_0_0_load322334_lcssa=$__gb_sroa_0_0_load322334460;var $__trailing_sign_0_lcssa=$__trailing_sign_0467;label=302;break;}else{var $114=$63;var $_pre_i4_i_i130=$63;label=43;break;}
 case 43: 
 var $_pre_i4_i_i130;
 var $114;
 var $115=HEAP32[(($7)>>2)];
 var $116=($115|0)==0;
 if($116){var $133=1;label=50;break;}else{label=44;break;}
 case 44: 
 var $118=(($115+12)|0);
 var $119=HEAP32[(($118)>>2)];
 var $120=(($115+16)|0);
 var $121=HEAP32[(($120)>>2)];
 var $122=($119|0)==($121|0);
 if($122){label=45;break;}else{label=46;break;}
 case 45: 
 var $124=$115;
 var $125=HEAP32[(($124)>>2)];
 var $126=(($125+36)|0);
 var $127=HEAP32[(($126)>>2)];
 var $128=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$127]($115) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $_0_i_i_i_i122=$128;label=47;break; } else { label=24;break; }
 case 46: 
 var $130=HEAP32[(($119)>>2)];
 var $_0_i_i_i_i122=$130;label=47;break;
 case 47: 
 var $_0_i_i_i_i122;
 var $131=($_0_i_i_i_i122|0)==-1;
 if($131){label=49;break;}else{label=48;break;}
 case 48: 
 var $_pre_i_i_i124=HEAP32[(($7)>>2)];
 var $phitmp_i_i_i125=($_pre_i_i_i124|0)==0;
 var $133=$phitmp_i_i_i125;label=50;break;
 case 49: 
 HEAP32[(($7)>>2)]=0;
 var $133=1;label=50;break;
 case 50: 
 var $133;
 var $134=($114|0)==0;
 if($134){var $_pre_i4_i_i130521=$_pre_i4_i_i130;label=56;break;}else{label=51;break;}
 case 51: 
 var $136=(($114+12)|0);
 var $137=HEAP32[(($136)>>2)];
 var $138=(($114+16)|0);
 var $139=HEAP32[(($138)>>2)];
 var $140=($137|0)==($139|0);
 if($140){label=52;break;}else{label=53;break;}
 case 52: 
 var $142=$114;
 var $143=HEAP32[(($142)>>2)];
 var $144=(($143+36)|0);
 var $145=HEAP32[(($144)>>2)];
 var $146=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$145]($114) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $_0_i_i2_i_i128=$146;label=54;break; } else { label=24;break; }
 case 53: 
 var $148=HEAP32[(($137)>>2)];
 var $_0_i_i2_i_i128=$148;label=54;break;
 case 54: 
 var $_0_i_i2_i_i128;
 var $149=($_0_i_i2_i_i128|0)==-1;
 if($149){label=55;break;}else{label=57;break;}
 case 55: 
 HEAP32[(($8)>>2)]=0;
 var $_pre_i4_i_i130521=0;label=56;break;
 case 56: 
 var $_pre_i4_i_i130521;
 if($133){var $__trailing_sign_1=$__trailing_sign_0467;var $935=$22;var $__gb_sroa_0_0_load322335=$__gb_sroa_0_0_load322334460;var $934=$23;var $_ZNSt3__112__do_nothingEPv344=$_ZNSt3__112__do_nothingEPv343455;label=301;break;}else{var $152=0;var $_pre_i4_i_i130523=$_pre_i4_i_i130521;label=58;break;}
 case 57: 
 var $phitmp_i5_i_i131=($_pre_i4_i_i130|0)==0;
 var $tmp_i_i133=$133^$phitmp_i5_i_i131;
 if($tmp_i_i133){var $152=$_pre_i4_i_i130;var $_pre_i4_i_i130523=$_pre_i4_i_i130;label=58;break;}else{var $__trailing_sign_1=$__trailing_sign_0467;var $935=$22;var $__gb_sroa_0_0_load322335=$__gb_sroa_0_0_load322334460;var $934=$23;var $_ZNSt3__112__do_nothingEPv344=$_ZNSt3__112__do_nothingEPv343455;label=301;break;}
 case 58: 
 var $_pre_i4_i_i130523;
 var $152;
 var $153=HEAP32[(($7)>>2)];
 var $154=(($153+12)|0);
 var $155=HEAP32[(($154)>>2)];
 var $156=(($153+16)|0);
 var $157=HEAP32[(($156)>>2)];
 var $158=($155|0)==($157|0);
 if($158){label=59;break;}else{label=60;break;}
 case 59: 
 var $160=$153;
 var $161=HEAP32[(($160)>>2)];
 var $162=(($161+36)|0);
 var $163=HEAP32[(($162)>>2)];
 var $164=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$163]($153) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $_0_i_i137=$164;label=61;break; } else { label=24;break; }
 case 60: 
 var $166=HEAP32[(($155)>>2)];
 var $_0_i_i137=$166;label=61;break;
 case 61: 
 var $_0_i_i137;
 var $167=HEAP32[(($9)>>2)];
 var $168=(($167+12)|0);
 var $169=HEAP32[(($168)>>2)];
 var $170=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$169]($__ct,8192,$_0_i_i137) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=62;break; } else { label=24;break; }
 case 62: 
 if($170){label=63;break;}else{var $__trailing_sign_1=$__trailing_sign_0467;var $935=$22;var $__gb_sroa_0_0_load322335=$__gb_sroa_0_0_load322334460;var $934=$23;var $_ZNSt3__112__do_nothingEPv344=$_ZNSt3__112__do_nothingEPv343455;label=301;break;}
 case 63: 
 var $172=HEAP32[(($7)>>2)];
 var $173=(($172+12)|0);
 var $174=HEAP32[(($173)>>2)];
 var $175=(($172+16)|0);
 var $176=HEAP32[(($175)>>2)];
 var $177=($174|0)==($176|0);
 if($177){label=64;break;}else{label=65;break;}
 case 64: 
 var $179=$172;
 var $180=HEAP32[(($179)>>2)];
 var $181=(($180+40)|0);
 var $182=HEAP32[(($181)>>2)];
 var $183=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$182]($172) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $_0_i_i142=$183;label=66;break; } else { label=24;break; }
 case 65: 
 var $185=(($174+4)|0);
 HEAP32[(($173)>>2)]=$185;
 var $186=HEAP32[(($174)>>2)];
 var $_0_i_i142=$186;label=66;break;
 case 66: 
 var $_0_i_i142;
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE9push_backEw($__spaces,$_0_i_i142) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $114=$152;var $_pre_i4_i_i130=$_pre_i4_i_i130523;label=43;break; } else { label=24;break; }
 case 67: 
 var $188=HEAP8[($this4_i_i_i93)];
 var $189=$188&1;
 var $190=(($189<<24)>>24)==0;
 if($190){label=69;break;}else{label=68;break;}
 case 68: 
 var $192=HEAP32[(($12)>>2)];
 var $196=$192;label=70;break;
 case 69: 
 var $194=($188&255);
 var $195=$194>>>1;
 var $196=$195;label=70;break;
 case 70: 
 var $196;
 var $197=HEAP8[($this4_i_i_i95)];
 var $198=$197&1;
 var $199=(($198<<24)>>24)==0;
 if($199){label=72;break;}else{label=71;break;}
 case 71: 
 var $201=HEAP32[(($10)>>2)];
 var $205=$201;label=73;break;
 case 72: 
 var $203=($197&255);
 var $204=$203>>>1;
 var $205=$204;label=73;break;
 case 73: 
 var $205;
 var $206=(((-$205))|0);
 var $207=($196|0)==($206|0);
 if($207){var $__trailing_sign_1=$__trailing_sign_0467;var $935=$22;var $__gb_sroa_0_0_load322335=$__gb_sroa_0_0_load322334460;var $934=$23;var $_ZNSt3__112__do_nothingEPv344=$_ZNSt3__112__do_nothingEPv343455;label=301;break;}else{label=74;break;}
 case 74: 
 if($190){label=76;break;}else{label=75;break;}
 case 75: 
 var $210=HEAP32[(($12)>>2)];
 var $214=$210;label=77;break;
 case 76: 
 var $212=($188&255);
 var $213=$212>>>1;
 var $214=$213;label=77;break;
 case 77: 
 var $214;
 var $215=($214|0)==0;
 if($215){label=82;break;}else{label=78;break;}
 case 78: 
 if($199){label=80;break;}else{label=79;break;}
 case 79: 
 var $218=HEAP32[(($10)>>2)];
 var $222=$218;label=81;break;
 case 80: 
 var $220=($197&255);
 var $221=$220>>>1;
 var $222=$221;label=81;break;
 case 81: 
 var $222;
 var $223=($222|0)==0;
 if($223){label=82;break;}else{label=111;break;}
 case 82: 
 if($190){label=84;break;}else{label=83;break;}
 case 83: 
 var $226=HEAP32[(($12)>>2)];
 var $230=$226;label=85;break;
 case 84: 
 var $228=($188&255);
 var $229=$228>>>1;
 var $230=$229;label=85;break;
 case 85: 
 var $230;
 var $231=($230|0)==0;
 var $232=HEAP32[(($7)>>2)];
 var $233=(($232+12)|0);
 var $234=HEAP32[(($233)>>2)];
 var $235=(($232+16)|0);
 var $236=HEAP32[(($235)>>2)];
 var $237=($234|0)==($236|0);
 if($231){label=99;break;}else{label=86;break;}
 case 86: 
 if($237){label=87;break;}else{label=89;break;}
 case 87: 
 var $240=$232;
 var $241=HEAP32[(($240)>>2)];
 var $242=(($241+36)|0);
 var $243=HEAP32[(($242)>>2)];
 var $244=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$243]($232) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=88;break; } else { var $_ph_ph360_ph_ph_ph_ph_ph=$23;var $_ZNSt3__112__do_nothingEPv347_ph_ph359_ph_ph_ph_ph_ph=$_ZNSt3__112__do_nothingEPv343455;label=25;break; }
 case 88: 
 var $_pre536=HEAP8[($this4_i_i_i93)];
 var $_0_i_i158=$244;var $247=$_pre536;label=90;break;
 case 89: 
 var $246=HEAP32[(($234)>>2)];
 var $_0_i_i158=$246;var $247=$188;label=90;break;
 case 90: 
 var $247;
 var $_0_i_i158;
 var $248=$247&1;
 var $249=(($248<<24)>>24)==0;
 var $250=HEAP32[(($13)>>2)];
 var $_=($249?$12:$250);
 var $251=HEAP32[(($_)>>2)];
 var $252=($_0_i_i158|0)==($251|0);
 if($252){label=91;break;}else{label=98;break;}
 case 91: 
 var $254=HEAP32[(($7)>>2)];
 var $255=(($254+12)|0);
 var $256=HEAP32[(($255)>>2)];
 var $257=(($254+16)|0);
 var $258=HEAP32[(($257)>>2)];
 var $259=($256|0)==($258|0);
 if($259){label=92;break;}else{label=93;break;}
 case 92: 
 var $261=$254;
 var $262=HEAP32[(($261)>>2)];
 var $263=(($262+40)|0);
 var $264=HEAP32[(($263)>>2)];
 var $265=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$264]($254) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=94;break; } else { var $_ph_ph360_ph_ph_ph_ph_ph=$23;var $_ZNSt3__112__do_nothingEPv347_ph_ph359_ph_ph_ph_ph_ph=$_ZNSt3__112__do_nothingEPv343455;label=25;break; }
 case 93: 
 var $267=(($256+4)|0);
 HEAP32[(($255)>>2)]=$267;
 label=94;break;
 case 94: 
 var $268=HEAP8[($this4_i_i_i93)];
 var $269=$268&1;
 var $270=(($269<<24)>>24)==0;
 if($270){label=96;break;}else{label=95;break;}
 case 95: 
 var $272=HEAP32[(($12)>>2)];
 var $276=$272;label=97;break;
 case 96: 
 var $274=($268&255);
 var $275=$274>>>1;
 var $276=$275;label=97;break;
 case 97: 
 var $276;
 var $277=($276>>>0)>1;
 var $__psn___trailing_sign_0=($277?$__psn:$__trailing_sign_0467);
 var $__trailing_sign_1=$__psn___trailing_sign_0;var $935=$22;var $__gb_sroa_0_0_load322335=$__gb_sroa_0_0_load322334460;var $934=$23;var $_ZNSt3__112__do_nothingEPv344=$_ZNSt3__112__do_nothingEPv343455;label=301;break;
 case 98: 
 HEAP8[($__neg)]=1;
 var $__trailing_sign_1=$__trailing_sign_0467;var $935=$22;var $__gb_sroa_0_0_load322335=$__gb_sroa_0_0_load322334460;var $934=$23;var $_ZNSt3__112__do_nothingEPv344=$_ZNSt3__112__do_nothingEPv343455;label=301;break;
 case 99: 
 if($237){label=100;break;}else{label=102;break;}
 case 100: 
 var $281=$232;
 var $282=HEAP32[(($281)>>2)];
 var $283=(($282+36)|0);
 var $284=HEAP32[(($283)>>2)];
 var $285=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$284]($232) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=101;break; } else { var $_ph_ph360_ph_ph_ph_ph_ph=$23;var $_ZNSt3__112__do_nothingEPv347_ph_ph359_ph_ph_ph_ph_ph=$_ZNSt3__112__do_nothingEPv343455;label=25;break; }
 case 101: 
 var $_pre535=HEAP8[($this4_i_i_i95)];
 var $_0_i_i179=$285;var $288=$_pre535;label=103;break;
 case 102: 
 var $287=HEAP32[(($234)>>2)];
 var $_0_i_i179=$287;var $288=$197;label=103;break;
 case 103: 
 var $288;
 var $_0_i_i179;
 var $289=$288&1;
 var $290=(($289<<24)>>24)==0;
 var $291=HEAP32[(($11)>>2)];
 var $_547=($290?$10:$291);
 var $292=HEAP32[(($_547)>>2)];
 var $293=($_0_i_i179|0)==($292|0);
 if($293){label=104;break;}else{var $__trailing_sign_1=$__trailing_sign_0467;var $935=$22;var $__gb_sroa_0_0_load322335=$__gb_sroa_0_0_load322334460;var $934=$23;var $_ZNSt3__112__do_nothingEPv344=$_ZNSt3__112__do_nothingEPv343455;label=301;break;}
 case 104: 
 var $295=HEAP32[(($7)>>2)];
 var $296=(($295+12)|0);
 var $297=HEAP32[(($296)>>2)];
 var $298=(($295+16)|0);
 var $299=HEAP32[(($298)>>2)];
 var $300=($297|0)==($299|0);
 if($300){label=105;break;}else{label=106;break;}
 case 105: 
 var $302=$295;
 var $303=HEAP32[(($302)>>2)];
 var $304=(($303+40)|0);
 var $305=HEAP32[(($304)>>2)];
 var $306=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$305]($295) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=107;break; } else { var $_ph_ph360_ph_ph_ph_ph_ph=$23;var $_ZNSt3__112__do_nothingEPv347_ph_ph359_ph_ph_ph_ph_ph=$_ZNSt3__112__do_nothingEPv343455;label=25;break; }
 case 106: 
 var $308=(($297+4)|0);
 HEAP32[(($296)>>2)]=$308;
 label=107;break;
 case 107: 
 HEAP8[($__neg)]=1;
 var $309=HEAP8[($this4_i_i_i95)];
 var $310=$309&1;
 var $311=(($310<<24)>>24)==0;
 if($311){label=109;break;}else{label=108;break;}
 case 108: 
 var $313=HEAP32[(($10)>>2)];
 var $317=$313;label=110;break;
 case 109: 
 var $315=($309&255);
 var $316=$315>>>1;
 var $317=$316;label=110;break;
 case 110: 
 var $317;
 var $318=($317>>>0)>1;
 var $__nsn___trailing_sign_0=($318?$__nsn:$__trailing_sign_0467);
 var $__trailing_sign_1=$__nsn___trailing_sign_0;var $935=$22;var $__gb_sroa_0_0_load322335=$__gb_sroa_0_0_load322334460;var $934=$23;var $_ZNSt3__112__do_nothingEPv344=$_ZNSt3__112__do_nothingEPv343455;label=301;break;
 case 111: 
 var $320=HEAP32[(($7)>>2)];
 var $321=(($320+12)|0);
 var $322=HEAP32[(($321)>>2)];
 var $323=(($320+16)|0);
 var $324=HEAP32[(($323)>>2)];
 var $325=($322|0)==($324|0);
 if($325){label=112;break;}else{label=114;break;}
 case 112: 
 var $327=$320;
 var $328=HEAP32[(($327)>>2)];
 var $329=(($328+36)|0);
 var $330=HEAP32[(($329)>>2)];
 var $331=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$330]($320) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=113;break; } else { var $_ph_ph360_ph_ph_ph_ph_ph=$23;var $_ZNSt3__112__do_nothingEPv347_ph_ph359_ph_ph_ph_ph_ph=$_ZNSt3__112__do_nothingEPv343455;label=25;break; }
 case 113: 
 var $_pre537=HEAP8[($this4_i_i_i93)];
 var $_0_i_i191=$331;var $334=$_pre537;label=115;break;
 case 114: 
 var $333=HEAP32[(($322)>>2)];
 var $_0_i_i191=$333;var $334=$188;label=115;break;
 case 115: 
 var $334;
 var $_0_i_i191;
 var $335=$334&1;
 var $336=(($335<<24)>>24)==0;
 var $337=HEAP32[(($13)>>2)];
 var $_548=($336?$12:$337);
 var $338=HEAP32[(($_548)>>2)];
 var $339=($_0_i_i191|0)==($338|0);
 var $340=HEAP32[(($7)>>2)];
 var $341=(($340+12)|0);
 var $342=HEAP32[(($341)>>2)];
 var $343=(($340+16)|0);
 var $344=HEAP32[(($343)>>2)];
 var $345=($342|0)==($344|0);
 if($339){label=116;break;}else{label=123;break;}
 case 116: 
 if($345){label=117;break;}else{label=118;break;}
 case 117: 
 var $348=$340;
 var $349=HEAP32[(($348)>>2)];
 var $350=(($349+40)|0);
 var $351=HEAP32[(($350)>>2)];
 var $352=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$351]($340) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=119;break; } else { var $_ph_ph360_ph_ph_ph_ph_ph=$23;var $_ZNSt3__112__do_nothingEPv347_ph_ph359_ph_ph_ph_ph_ph=$_ZNSt3__112__do_nothingEPv343455;label=25;break; }
 case 118: 
 var $354=(($342+4)|0);
 HEAP32[(($341)>>2)]=$354;
 label=119;break;
 case 119: 
 var $355=HEAP8[($this4_i_i_i93)];
 var $356=$355&1;
 var $357=(($356<<24)>>24)==0;
 if($357){label=121;break;}else{label=120;break;}
 case 120: 
 var $359=HEAP32[(($12)>>2)];
 var $363=$359;label=122;break;
 case 121: 
 var $361=($355&255);
 var $362=$361>>>1;
 var $363=$362;label=122;break;
 case 122: 
 var $363;
 var $364=($363>>>0)>1;
 var $__psn___trailing_sign_088=($364?$__psn:$__trailing_sign_0467);
 var $__trailing_sign_1=$__psn___trailing_sign_088;var $935=$22;var $__gb_sroa_0_0_load322335=$__gb_sroa_0_0_load322334460;var $934=$23;var $_ZNSt3__112__do_nothingEPv344=$_ZNSt3__112__do_nothingEPv343455;label=301;break;
 case 123: 
 if($345){label=124;break;}else{label=125;break;}
 case 124: 
 var $367=$340;
 var $368=HEAP32[(($367)>>2)];
 var $369=(($368+36)|0);
 var $370=HEAP32[(($369)>>2)];
 var $371=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$370]($340) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $_0_i_i213=$371;label=126;break; } else { var $_ph_ph360_ph_ph_ph_ph_ph=$23;var $_ZNSt3__112__do_nothingEPv347_ph_ph359_ph_ph_ph_ph_ph=$_ZNSt3__112__do_nothingEPv343455;label=25;break; }
 case 125: 
 var $373=HEAP32[(($342)>>2)];
 var $_0_i_i213=$373;label=126;break;
 case 126: 
 var $_0_i_i213;
 var $374=HEAP8[($this4_i_i_i95)];
 var $375=$374&1;
 var $376=(($375<<24)>>24)==0;
 var $377=HEAP32[(($11)>>2)];
 var $_549=($376?$10:$377);
 var $378=HEAP32[(($_549)>>2)];
 var $379=($_0_i_i213|0)==($378|0);
 if($379){label=127;break;}else{label=134;break;}
 case 127: 
 var $381=HEAP32[(($7)>>2)];
 var $382=(($381+12)|0);
 var $383=HEAP32[(($382)>>2)];
 var $384=(($381+16)|0);
 var $385=HEAP32[(($384)>>2)];
 var $386=($383|0)==($385|0);
 if($386){label=128;break;}else{label=129;break;}
 case 128: 
 var $388=$381;
 var $389=HEAP32[(($388)>>2)];
 var $390=(($389+40)|0);
 var $391=HEAP32[(($390)>>2)];
 var $392=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$391]($381) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=130;break; } else { var $_ph_ph360_ph_ph_ph_ph_ph=$23;var $_ZNSt3__112__do_nothingEPv347_ph_ph359_ph_ph_ph_ph_ph=$_ZNSt3__112__do_nothingEPv343455;label=25;break; }
 case 129: 
 var $394=(($383+4)|0);
 HEAP32[(($382)>>2)]=$394;
 label=130;break;
 case 130: 
 HEAP8[($__neg)]=1;
 var $395=HEAP8[($this4_i_i_i95)];
 var $396=$395&1;
 var $397=(($396<<24)>>24)==0;
 if($397){label=132;break;}else{label=131;break;}
 case 131: 
 var $399=HEAP32[(($10)>>2)];
 var $403=$399;label=133;break;
 case 132: 
 var $401=($395&255);
 var $402=$401>>>1;
 var $403=$402;label=133;break;
 case 133: 
 var $403;
 var $404=($403>>>0)>1;
 var $__nsn___trailing_sign_089=($404?$__nsn:$__trailing_sign_0467);
 var $__trailing_sign_1=$__nsn___trailing_sign_089;var $935=$22;var $__gb_sroa_0_0_load322335=$__gb_sroa_0_0_load322334460;var $934=$23;var $_ZNSt3__112__do_nothingEPv344=$_ZNSt3__112__do_nothingEPv343455;label=301;break;
 case 134: 
 var $406=HEAP32[(($__err)>>2)];
 var $407=$406|4;
 HEAP32[(($__err)>>2)]=$407;
 var $_0=0;var $1041=$23;var $_ZNSt3__112__do_nothingEPv=$_ZNSt3__112__do_nothingEPv343455;label=336;break;
 case 135: 
 var $409=($__trailing_sign_0467|0)!=0;
 var $410=($__p_0465>>>0)<2;
 var $or_cond=$409|$410;
 if($or_cond){label=139;break;}else{label=136;break;}
 case 136: 
 var $412=($__p_0465|0)==2;
 if($412){label=137;break;}else{var $417=0;label=138;break;}
 case 137: 
 var $414=HEAP8[($20)];
 var $415=(($414<<24)>>24)!=0;
 var $417=$415;label=138;break;
 case 138: 
 var $417;
 var $brmerge=$15|$417;
 if($brmerge){label=139;break;}else{var $__trailing_sign_1=0;var $935=$22;var $__gb_sroa_0_0_load322335=$__gb_sroa_0_0_load322334460;var $934=$23;var $_ZNSt3__112__do_nothingEPv344=$_ZNSt3__112__do_nothingEPv343455;label=301;break;}
 case 139: 
 var $418=HEAP8[($this4_i_i_i92)];
 var $419=$418&1;
 var $420=(($419<<24)>>24)==0;
 var $421=HEAP32[(($17)>>2)];
 var $_550=($420?$16:$421);
 var $422=($__p_0465|0)==0;
 if($422){var $__sym_space_end_sroa_0_0_load297329=$_550;var $493=$418;var $492=$63;var $_pre_i4_i_i273=$63;label=161;break;}else{label=140;break;}
 case 140: 
 var $424=((($__p_0465)-(1))|0);
 var $425=(($__pat+$424)|0);
 var $426=HEAP8[($425)];
 var $switch=($426&255)<2;
 if($switch){var $__sym_space_end_sroa_0_0_load297330=$_550;var $427=$418;label=141;break;}else{var $__sym_space_end_sroa_0_0_load297329=$_550;var $493=$418;var $492=$63;var $_pre_i4_i_i273=$63;label=161;break;}
 case 141: 
 var $427;
 var $__sym_space_end_sroa_0_0_load297330;
 var $428=$427&1;
 var $429=(($428<<24)>>24)==0;
 if($429){label=143;break;}else{label=142;break;}
 case 142: 
 var $431=HEAP32[(($17)>>2)];
 var $432=HEAP32[(($16)>>2)];
 var $437=$432;var $436=$431;label=144;break;
 case 143: 
 var $434=($427&255);
 var $435=$434>>>1;
 var $437=$435;var $436=$16;label=144;break;
 case 144: 
 var $436;
 var $437;
 var $438=(($436+($437<<2))|0);
 var $439=($__sym_space_end_sroa_0_0_load297330|0)==($438|0);
 if($439){var $447=$427;label=149;break;}else{label=145;break;}
 case 145: 
 var $441=HEAP32[(($__sym_space_end_sroa_0_0_load297330)>>2)];
 var $442=HEAP32[(($9)>>2)];
 var $443=(($442+12)|0);
 var $444=HEAP32[(($443)>>2)];
 var $445=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$444]($__ct,8192,$441) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=146;break; } else { label=22;break; }
 case 146: 
 if($445){label=147;break;}else{label=148;break;}
 case 147: 
 var $446=(($__sym_space_end_sroa_0_0_load297330+4)|0);
 var $_pre538=HEAP8[($this4_i_i_i92)];
 var $__sym_space_end_sroa_0_0_load297330=$446;var $427=$_pre538;label=141;break;
 case 148: 
 var $_pre539=HEAP8[($this4_i_i_i92)];
 var $447=$_pre539;label=149;break;
 case 149: 
 var $447;
 var $448=$447&1;
 var $449=(($448<<24)>>24)==0;
 var $450=HEAP32[(($17)>>2)];
 var $_551=($449?$16:$450);
 var $451=$__sym_space_end_sroa_0_0_load297330;
 var $452=$_551;
 var $453=((($451)-($452))|0);
 var $454=$453>>2;
 var $455=HEAP8[($this4_i_i_i98)];
 var $456=$455&1;
 var $457=(($456<<24)>>24)==0;
 if($457){label=151;break;}else{label=150;break;}
 case 150: 
 var $459=HEAP32[(($18)>>2)];
 var $463=$459;label=152;break;
 case 151: 
 var $461=($455&255);
 var $462=$461>>>1;
 var $463=$462;label=152;break;
 case 152: 
 var $463;
 var $464=($454>>>0)>($463>>>0);
 if($464){label=160;break;}else{label=153;break;}
 case 153: 
 if($457){label=155;break;}else{label=154;break;}
 case 154: 
 var $467=HEAP32[(($19)>>2)];
 var $468=HEAP32[(($18)>>2)];
 var $_sum=((($468)-($454))|0);
 var $469=(($467+($_sum<<2))|0);
 var $478=$468;var $477=$467;var $476=$469;label=156;break;
 case 155: 
 var $471=($455&255);
 var $472=$471>>>1;
 var $_sum541=((($472)-($454))|0);
 var $473=(($18+($_sum541<<2))|0);
 var $474=($455&255);
 var $475=$474>>>1;
 var $478=$475;var $477=$18;var $476=$473;label=156;break;
 case 156: 
 var $476;
 var $477;
 var $478;
 var $479=(($477+($478<<2))|0);
 var $480=HEAP32[(($17)>>2)];
 var $_552=($449?$16:$480);
 var $481=($476|0)==($479|0);
 if($481){var $__sym_space_end_sroa_0_0_load297329=$__sym_space_end_sroa_0_0_load297330;var $493=$447;var $492=$63;var $_pre_i4_i_i273=$63;label=161;break;}else{var $483=$476;var $482=$_552;label=157;break;}
 case 157: 
 var $482;
 var $483;
 var $484=HEAP32[(($483)>>2)];
 var $485=HEAP32[(($482)>>2)];
 var $486=($484|0)==($485|0);
 if($486){label=158;break;}else{label=160;break;}
 case 158: 
 var $488=(($483+4)|0);
 var $489=($488|0)==($479|0);
 if($489){var $__sym_space_end_sroa_0_0_load297329=$__sym_space_end_sroa_0_0_load297330;var $493=$447;var $492=$63;var $_pre_i4_i_i273=$63;label=161;break;}else{label=159;break;}
 case 159: 
 var $490=(($482+4)|0);
 var $483=$488;var $482=$490;label=157;break;
 case 160: 
 var $491=HEAP32[(($17)>>2)];
 var $_553=($449?$16:$491);
 var $__sym_space_end_sroa_0_0_load297329=$_553;var $493=$447;var $492=$63;var $_pre_i4_i_i273=$63;label=161;break;
 case 161: 
 var $_pre_i4_i_i273;
 var $492;
 var $493;
 var $__sym_space_end_sroa_0_0_load297329;
 var $494=$493&1;
 var $495=(($494<<24)>>24)==0;
 if($495){label=163;break;}else{label=162;break;}
 case 162: 
 var $497=HEAP32[(($17)>>2)];
 var $498=HEAP32[(($16)>>2)];
 var $503=$498;var $502=$497;label=164;break;
 case 163: 
 var $500=($493&255);
 var $501=$500>>>1;
 var $503=$501;var $502=$16;label=164;break;
 case 164: 
 var $502;
 var $503;
 var $504=(($502+($503<<2))|0);
 var $505=($__sym_space_end_sroa_0_0_load297329|0)==($504|0);
 if($505){label=188;break;}else{label=165;break;}
 case 165: 
 var $507=HEAP32[(($7)>>2)];
 var $508=($507|0)==0;
 if($508){var $525=1;label=172;break;}else{label=166;break;}
 case 166: 
 var $510=(($507+12)|0);
 var $511=HEAP32[(($510)>>2)];
 var $512=(($507+16)|0);
 var $513=HEAP32[(($512)>>2)];
 var $514=($511|0)==($513|0);
 if($514){label=167;break;}else{label=168;break;}
 case 167: 
 var $516=$507;
 var $517=HEAP32[(($516)>>2)];
 var $518=(($517+36)|0);
 var $519=HEAP32[(($518)>>2)];
 var $520=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$519]($507) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $_0_i_i_i_i265=$520;label=169;break; } else { label=23;break; }
 case 168: 
 var $522=HEAP32[(($511)>>2)];
 var $_0_i_i_i_i265=$522;label=169;break;
 case 169: 
 var $_0_i_i_i_i265;
 var $523=($_0_i_i_i_i265|0)==-1;
 if($523){label=171;break;}else{label=170;break;}
 case 170: 
 var $_pre_i_i_i267=HEAP32[(($7)>>2)];
 var $phitmp_i_i_i268=($_pre_i_i_i267|0)==0;
 var $525=$phitmp_i_i_i268;label=172;break;
 case 171: 
 HEAP32[(($7)>>2)]=0;
 var $525=1;label=172;break;
 case 172: 
 var $525;
 var $526=($492|0)==0;
 if($526){var $_pre_i4_i_i273525=$_pre_i4_i_i273;label=178;break;}else{label=173;break;}
 case 173: 
 var $528=(($492+12)|0);
 var $529=HEAP32[(($528)>>2)];
 var $530=(($492+16)|0);
 var $531=HEAP32[(($530)>>2)];
 var $532=($529|0)==($531|0);
 if($532){label=174;break;}else{label=175;break;}
 case 174: 
 var $534=$492;
 var $535=HEAP32[(($534)>>2)];
 var $536=(($535+36)|0);
 var $537=HEAP32[(($536)>>2)];
 var $538=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$537]($492) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $_0_i_i2_i_i271=$538;label=176;break; } else { label=23;break; }
 case 175: 
 var $540=HEAP32[(($529)>>2)];
 var $_0_i_i2_i_i271=$540;label=176;break;
 case 176: 
 var $_0_i_i2_i_i271;
 var $541=($_0_i_i2_i_i271|0)==-1;
 if($541){label=177;break;}else{label=179;break;}
 case 177: 
 HEAP32[(($8)>>2)]=0;
 var $_pre_i4_i_i273525=0;label=178;break;
 case 178: 
 var $_pre_i4_i_i273525;
 if($525){label=188;break;}else{var $544=0;var $_pre_i4_i_i273524=$_pre_i4_i_i273525;label=180;break;}
 case 179: 
 var $phitmp_i5_i_i274=($_pre_i4_i_i273|0)==0;
 var $tmp_i_i276=$525^$phitmp_i5_i_i274;
 if($tmp_i_i276){var $544=$_pre_i4_i_i273;var $_pre_i4_i_i273524=$_pre_i4_i_i273;label=180;break;}else{label=188;break;}
 case 180: 
 var $_pre_i4_i_i273524;
 var $544;
 var $545=HEAP32[(($7)>>2)];
 var $546=(($545+12)|0);
 var $547=HEAP32[(($546)>>2)];
 var $548=(($545+16)|0);
 var $549=HEAP32[(($548)>>2)];
 var $550=($547|0)==($549|0);
 if($550){label=181;break;}else{label=182;break;}
 case 181: 
 var $552=$545;
 var $553=HEAP32[(($552)>>2)];
 var $554=(($553+36)|0);
 var $555=HEAP32[(($554)>>2)];
 var $556=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$555]($545) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $_0_i_i261=$556;label=183;break; } else { label=23;break; }
 case 182: 
 var $558=HEAP32[(($547)>>2)];
 var $_0_i_i261=$558;label=183;break;
 case 183: 
 var $_0_i_i261;
 var $559=HEAP32[(($__sym_space_end_sroa_0_0_load297329)>>2)];
 var $560=($_0_i_i261|0)==($559|0);
 if($560){label=184;break;}else{label=188;break;}
 case 184: 
 var $562=HEAP32[(($7)>>2)];
 var $563=(($562+12)|0);
 var $564=HEAP32[(($563)>>2)];
 var $565=(($562+16)|0);
 var $566=HEAP32[(($565)>>2)];
 var $567=($564|0)==($566|0);
 if($567){label=185;break;}else{label=186;break;}
 case 185: 
 var $569=$562;
 var $570=HEAP32[(($569)>>2)];
 var $571=(($570+40)|0);
 var $572=HEAP32[(($571)>>2)];
 var $573=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$572]($562) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=187;break; } else { label=23;break; }
 case 186: 
 var $575=(($564+4)|0);
 HEAP32[(($563)>>2)]=$575;
 label=187;break;
 case 187: 
 var $576=(($__sym_space_end_sroa_0_0_load297329+4)|0);
 var $_pre=HEAP8[($this4_i_i_i92)];
 var $__sym_space_end_sroa_0_0_load297329=$576;var $493=$_pre;var $492=$544;var $_pre_i4_i_i273=$_pre_i4_i_i273524;label=161;break;
 case 188: 
 if($15){label=189;break;}else{var $__trailing_sign_1=$__trailing_sign_0467;var $935=$22;var $__gb_sroa_0_0_load322335=$__gb_sroa_0_0_load322334460;var $934=$23;var $_ZNSt3__112__do_nothingEPv344=$_ZNSt3__112__do_nothingEPv343455;label=301;break;}
 case 189: 
 var $578=HEAP8[($this4_i_i_i92)];
 var $579=$578&1;
 var $580=(($579<<24)>>24)==0;
 if($580){label=191;break;}else{label=190;break;}
 case 190: 
 var $582=HEAP32[(($17)>>2)];
 var $583=HEAP32[(($16)>>2)];
 var $588=$583;var $587=$582;label=192;break;
 case 191: 
 var $585=($578&255);
 var $586=$585>>>1;
 var $588=$586;var $587=$16;label=192;break;
 case 192: 
 var $587;
 var $588;
 var $589=(($587+($588<<2))|0);
 var $590=($__sym_space_end_sroa_0_0_load297329|0)==($589|0);
 if($590){var $__trailing_sign_1=$__trailing_sign_0467;var $935=$22;var $__gb_sroa_0_0_load322335=$__gb_sroa_0_0_load322334460;var $934=$23;var $_ZNSt3__112__do_nothingEPv344=$_ZNSt3__112__do_nothingEPv343455;label=301;break;}else{label=193;break;}
 case 193: 
 var $592=HEAP32[(($__err)>>2)];
 var $593=$592|4;
 HEAP32[(($__err)>>2)]=$593;
 var $_0=0;var $1041=$23;var $_ZNSt3__112__do_nothingEPv=$_ZNSt3__112__do_nothingEPv343455;label=336;break;
 case 194: 
 var $_ZNSt3__112__do_nothingEPv342;
 var $594;
 var $__gb_sroa_0_0_load322333;
 var $595;
 var $__ng_0;
 var $596=HEAP32[(($7)>>2)];
 var $597=($596|0)==0;
 if($597){var $614=1;label=201;break;}else{label=195;break;}
 case 195: 
 var $599=(($596+12)|0);
 var $600=HEAP32[(($599)>>2)];
 var $601=(($596+16)|0);
 var $602=HEAP32[(($601)>>2)];
 var $603=($600|0)==($602|0);
 if($603){label=196;break;}else{label=197;break;}
 case 196: 
 var $605=$596;
 var $606=HEAP32[(($605)>>2)];
 var $607=(($606+36)|0);
 var $608=HEAP32[(($607)>>2)];
 var $609=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$608]($596) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $_0_i_i_i_i240=$609;label=198;break; } else { var $_ph_ph=$594;var $_ZNSt3__112__do_nothingEPv347_ph_ph=$_ZNSt3__112__do_nothingEPv342;label=20;break; }
 case 197: 
 var $611=HEAP32[(($600)>>2)];
 var $_0_i_i_i_i240=$611;label=198;break;
 case 198: 
 var $_0_i_i_i_i240;
 var $612=($_0_i_i_i_i240|0)==-1;
 if($612){label=200;break;}else{label=199;break;}
 case 199: 
 var $_pre_i_i_i242=HEAP32[(($7)>>2)];
 var $phitmp_i_i_i243=($_pre_i_i_i242|0)==0;
 var $614=$phitmp_i_i_i243;label=201;break;
 case 200: 
 HEAP32[(($7)>>2)]=0;
 var $614=1;label=201;break;
 case 201: 
 var $614;
 var $615=HEAP32[(($8)>>2)];
 var $616=($615|0)==0;
 if($616){label=207;break;}else{label=202;break;}
 case 202: 
 var $618=(($615+12)|0);
 var $619=HEAP32[(($618)>>2)];
 var $620=(($615+16)|0);
 var $621=HEAP32[(($620)>>2)];
 var $622=($619|0)==($621|0);
 if($622){label=203;break;}else{label=204;break;}
 case 203: 
 var $624=$615;
 var $625=HEAP32[(($624)>>2)];
 var $626=(($625+36)|0);
 var $627=HEAP32[(($626)>>2)];
 var $628=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$627]($615) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $_0_i_i2_i_i246=$628;label=205;break; } else { var $_ph_ph=$594;var $_ZNSt3__112__do_nothingEPv347_ph_ph=$_ZNSt3__112__do_nothingEPv342;label=20;break; }
 case 204: 
 var $630=HEAP32[(($619)>>2)];
 var $_0_i_i2_i_i246=$630;label=205;break;
 case 205: 
 var $_0_i_i2_i_i246;
 var $631=($_0_i_i2_i_i246|0)==-1;
 if($631){label=206;break;}else{label=208;break;}
 case 206: 
 HEAP32[(($8)>>2)]=0;
 label=207;break;
 case 207: 
 if($614){label=235;break;}else{label=209;break;}
 case 208: 
 if($614){label=209;break;}else{label=235;break;}
 case 209: 
 var $634=HEAP32[(($7)>>2)];
 var $635=(($634+12)|0);
 var $636=HEAP32[(($635)>>2)];
 var $637=(($634+16)|0);
 var $638=HEAP32[(($637)>>2)];
 var $639=($636|0)==($638|0);
 if($639){label=210;break;}else{label=211;break;}
 case 210: 
 var $641=$634;
 var $642=HEAP32[(($641)>>2)];
 var $643=(($642+36)|0);
 var $644=HEAP32[(($643)>>2)];
 var $645=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$644]($634) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $_0_i_i237=$645;label=212;break; } else { var $_ph_ph=$594;var $_ZNSt3__112__do_nothingEPv347_ph_ph=$_ZNSt3__112__do_nothingEPv342;label=20;break; }
 case 211: 
 var $647=HEAP32[(($636)>>2)];
 var $_0_i_i237=$647;label=212;break;
 case 212: 
 var $_0_i_i237;
 var $648=HEAP32[(($9)>>2)];
 var $649=(($648+12)|0);
 var $650=HEAP32[(($649)>>2)];
 var $651=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$650]($__ct,2048,$_0_i_i237) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=213;break; } else { var $_ph_ph=$594;var $_ZNSt3__112__do_nothingEPv347_ph_ph=$_ZNSt3__112__do_nothingEPv342;label=20;break; }
 case 213: 
 if($651){label=214;break;}else{label=218;break;}
 case 214: 
 var $653=HEAP32[(($__wn)>>2)];
 var $654=HEAP32[(($1)>>2)];
 var $655=($653|0)==($654|0);
 if($655){label=215;break;}else{var $658=$653;label=217;break;}
 case 215: 
 (function() { try { __THREW__ = 0; return __ZNSt3__119__double_or_nothingIwEEvRNS_10unique_ptrIT_PFvPvEEERPS2_S9_($__wb,$__wn,$1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=216;break; } else { var $_ph_ph=$594;var $_ZNSt3__112__do_nothingEPv347_ph_ph=$_ZNSt3__112__do_nothingEPv342;label=20;break; }
 case 216: 
 var $_pre540=HEAP32[(($__wn)>>2)];
 var $658=$_pre540;label=217;break;
 case 217: 
 var $658;
 var $659=(($658+4)|0);
 HEAP32[(($__wn)>>2)]=$659;
 HEAP32[(($658)>>2)]=$_0_i_i237;
 var $660=((($__ng_0)+(1))|0);
 var $__ng_1=$660;var $705=$595;var $__gb_sroa_0_0_load322332=$__gb_sroa_0_0_load322333;var $704=$594;var $_ZNSt3__112__do_nothingEPv340=$_ZNSt3__112__do_nothingEPv342;label=232;break;
 case 218: 
 var $662=HEAP8[($this4_i_i_i)];
 var $663=$662&1;
 var $664=(($663<<24)>>24)==0;
 if($664){label=220;break;}else{label=219;break;}
 case 219: 
 var $666=HEAP32[(($21)>>2)];
 var $670=$666;label=221;break;
 case 220: 
 var $668=($662&255);
 var $669=$668>>>1;
 var $670=$669;label=221;break;
 case 221: 
 var $670;
 var $671=($670|0)==0;
 var $672=($__ng_0|0)==0;
 var $or_cond90=$671|$672;
 if($or_cond90){label=235;break;}else{label=222;break;}
 case 222: 
 var $674=HEAP32[(($__ts)>>2)];
 var $675=($_0_i_i237|0)==($674|0);
 if($675){label=223;break;}else{label=235;break;}
 case 223: 
 var $677=($__gb_sroa_0_0_load322333|0)==($595|0);
 if($677){label=224;break;}else{var $701=$595;var $__gb_sroa_0_0_load322337=$__gb_sroa_0_0_load322333;var $700=$594;var $_ZNSt3__112__do_nothingEPv341=$_ZNSt3__112__do_nothingEPv342;label=231;break;}
 case 224: 
 var $679=($_ZNSt3__112__do_nothingEPv342|0)!=((440)|0);
 var $680=$__gb_sroa_0_0_load322333;
 var $681=$594;
 var $682=((($680)-($681))|0);
 var $683=($682>>>0)<2147483647;
 var $684=$682<<1;
 var $685=($683?$684:-1);
 var $686=$682>>2;
 if($679){label=225;break;}else{var $689=0;label=226;break;}
 case 225: 
 var $phitmp_i223=$594;
 var $689=$phitmp_i223;label=226;break;
 case 226: 
 var $689;
 var $690=_realloc($689,$685);
 var $691=$690;
 var $692=($690|0)==0;
 if($692){label=227;break;}else{label=228;break;}
 case 227: 
 (function() { try { __THREW__ = 0; return __ZSt17__throw_bad_allocv() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=228;break; } else { var $_ph_ph=$594;var $_ZNSt3__112__do_nothingEPv347_ph_ph=$_ZNSt3__112__do_nothingEPv342;label=20;break; }
 case 228: 
 var $694=($594|0)==0;
 var $or_cond356=$679|$694;
 if($or_cond356){label=230;break;}else{label=229;break;}
 case 229: 
 label=230;break;
 case 230: 
 var $696=$685>>>2;
 var $697=(($691+($686<<2))|0);
 var $698=(($691+($696<<2))|0);
 var $701=$698;var $__gb_sroa_0_0_load322337=$697;var $700=$691;var $_ZNSt3__112__do_nothingEPv341=222;label=231;break;
 case 231: 
 var $_ZNSt3__112__do_nothingEPv341;
 var $700;
 var $__gb_sroa_0_0_load322337;
 var $701;
 var $702=(($__gb_sroa_0_0_load322337+4)|0);
 HEAP32[(($__gb_sroa_0_0_load322337)>>2)]=$__ng_0;
 var $__ng_1=0;var $705=$701;var $__gb_sroa_0_0_load322332=$702;var $704=$700;var $_ZNSt3__112__do_nothingEPv340=$_ZNSt3__112__do_nothingEPv341;label=232;break;
 case 232: 
 var $_ZNSt3__112__do_nothingEPv340;
 var $704;
 var $__gb_sroa_0_0_load322332;
 var $705;
 var $__ng_1;
 var $706=HEAP32[(($7)>>2)];
 var $707=(($706+12)|0);
 var $708=HEAP32[(($707)>>2)];
 var $709=(($706+16)|0);
 var $710=HEAP32[(($709)>>2)];
 var $711=($708|0)==($710|0);
 if($711){label=233;break;}else{label=234;break;}
 case 233: 
 var $713=$706;
 var $714=HEAP32[(($713)>>2)];
 var $715=(($714+40)|0);
 var $716=HEAP32[(($715)>>2)];
 var $717=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$716]($706) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $__ng_0=$__ng_1;var $595=$705;var $__gb_sroa_0_0_load322333=$__gb_sroa_0_0_load322332;var $594=$704;var $_ZNSt3__112__do_nothingEPv342=$_ZNSt3__112__do_nothingEPv340;label=194;break; } else { var $_ph_ph=$704;var $_ZNSt3__112__do_nothingEPv347_ph_ph=$_ZNSt3__112__do_nothingEPv340;label=20;break; }
 case 234: 
 var $719=(($708+4)|0);
 HEAP32[(($707)>>2)]=$719;
 var $__ng_0=$__ng_1;var $595=$705;var $__gb_sroa_0_0_load322333=$__gb_sroa_0_0_load322332;var $594=$704;var $_ZNSt3__112__do_nothingEPv342=$_ZNSt3__112__do_nothingEPv340;label=194;break;
 case 235: 
 var $721=($594|0)==($__gb_sroa_0_0_load322333|0);
 var $722=($__ng_0|0)==0;
 var $or_cond91=$721|$722;
 if($or_cond91){var $751=$595;var $__gb_sroa_0_0_load322336=$__gb_sroa_0_0_load322333;var $750=$594;var $_ZNSt3__112__do_nothingEPv345=$_ZNSt3__112__do_nothingEPv342;label=245;break;}else{label=236;break;}
 case 236: 
 var $724=($__gb_sroa_0_0_load322333|0)==($595|0);
 if($724){label=237;break;}else{var $748=$595;var $__gb_sroa_0_0_load322338=$__gb_sroa_0_0_load322333;var $747=$594;var $_ZNSt3__112__do_nothingEPv346=$_ZNSt3__112__do_nothingEPv342;label=244;break;}
 case 237: 
 var $726=($_ZNSt3__112__do_nothingEPv342|0)!=((440)|0);
 var $727=$__gb_sroa_0_0_load322333;
 var $728=$594;
 var $729=((($727)-($728))|0);
 var $730=($729>>>0)<2147483647;
 var $731=$729<<1;
 var $732=($730?$731:-1);
 var $733=$729>>2;
 if($726){label=238;break;}else{var $736=0;label=239;break;}
 case 238: 
 var $phitmp_i=$594;
 var $736=$phitmp_i;label=239;break;
 case 239: 
 var $736;
 var $737=_realloc($736,$732);
 var $738=$737;
 var $739=($737|0)==0;
 if($739){label=240;break;}else{label=241;break;}
 case 240: 
 (function() { try { __THREW__ = 0; return __ZSt17__throw_bad_allocv() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=241;break; } else { var $_ph_ph360_ph_ph_ph_ph_ph=$594;var $_ZNSt3__112__do_nothingEPv347_ph_ph359_ph_ph_ph_ph_ph=$_ZNSt3__112__do_nothingEPv342;label=25;break; }
 case 241: 
 var $741=($594|0)==0;
 var $or_cond357=$726|$741;
 if($or_cond357){label=243;break;}else{label=242;break;}
 case 242: 
 label=243;break;
 case 243: 
 var $743=$732>>>2;
 var $744=(($738+($733<<2))|0);
 var $745=(($738+($743<<2))|0);
 var $748=$745;var $__gb_sroa_0_0_load322338=$744;var $747=$738;var $_ZNSt3__112__do_nothingEPv346=222;label=244;break;
 case 244: 
 var $_ZNSt3__112__do_nothingEPv346;
 var $747;
 var $__gb_sroa_0_0_load322338;
 var $748;
 var $749=(($__gb_sroa_0_0_load322338+4)|0);
 HEAP32[(($__gb_sroa_0_0_load322338)>>2)]=$__ng_0;
 var $751=$748;var $__gb_sroa_0_0_load322336=$749;var $750=$747;var $_ZNSt3__112__do_nothingEPv345=$_ZNSt3__112__do_nothingEPv346;label=245;break;
 case 245: 
 var $_ZNSt3__112__do_nothingEPv345;
 var $750;
 var $__gb_sroa_0_0_load322336;
 var $751;
 var $752=HEAP32[(($__fd)>>2)];
 var $753=($752|0)>0;
 if($753){label=246;break;}else{label=299;break;}
 case 246: 
 var $755=HEAP32[(($7)>>2)];
 var $756=($755|0)==0;
 if($756){var $773=1;label=253;break;}else{label=247;break;}
 case 247: 
 var $758=(($755+12)|0);
 var $759=HEAP32[(($758)>>2)];
 var $760=(($755+16)|0);
 var $761=HEAP32[(($760)>>2)];
 var $762=($759|0)==($761|0);
 if($762){label=248;break;}else{label=249;break;}
 case 248: 
 var $764=$755;
 var $765=HEAP32[(($764)>>2)];
 var $766=(($765+36)|0);
 var $767=HEAP32[(($766)>>2)];
 var $768=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$767]($755) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $_0_i_i_i_i195=$768;label=250;break; } else { var $_ph_ph360_ph_ph_ph_ph_ph=$750;var $_ZNSt3__112__do_nothingEPv347_ph_ph359_ph_ph_ph_ph_ph=$_ZNSt3__112__do_nothingEPv345;label=25;break; }
 case 249: 
 var $770=HEAP32[(($759)>>2)];
 var $_0_i_i_i_i195=$770;label=250;break;
 case 250: 
 var $_0_i_i_i_i195;
 var $771=($_0_i_i_i_i195|0)==-1;
 if($771){label=252;break;}else{label=251;break;}
 case 251: 
 var $_pre_i_i_i197=HEAP32[(($7)>>2)];
 var $phitmp_i_i_i198=($_pre_i_i_i197|0)==0;
 var $773=$phitmp_i_i_i198;label=253;break;
 case 252: 
 HEAP32[(($7)>>2)]=0;
 var $773=1;label=253;break;
 case 253: 
 var $773;
 var $774=HEAP32[(($8)>>2)];
 var $775=($774|0)==0;
 if($775){label=259;break;}else{label=254;break;}
 case 254: 
 var $777=(($774+12)|0);
 var $778=HEAP32[(($777)>>2)];
 var $779=(($774+16)|0);
 var $780=HEAP32[(($779)>>2)];
 var $781=($778|0)==($780|0);
 if($781){label=255;break;}else{label=256;break;}
 case 255: 
 var $783=$774;
 var $784=HEAP32[(($783)>>2)];
 var $785=(($784+36)|0);
 var $786=HEAP32[(($785)>>2)];
 var $787=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$786]($774) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $_0_i_i2_i_i201=$787;label=257;break; } else { var $_ph_ph360_ph_ph_ph_ph_ph=$750;var $_ZNSt3__112__do_nothingEPv347_ph_ph359_ph_ph_ph_ph_ph=$_ZNSt3__112__do_nothingEPv345;label=25;break; }
 case 256: 
 var $789=HEAP32[(($778)>>2)];
 var $_0_i_i2_i_i201=$789;label=257;break;
 case 257: 
 var $_0_i_i2_i_i201;
 var $790=($_0_i_i2_i_i201|0)==-1;
 if($790){label=258;break;}else{label=260;break;}
 case 258: 
 HEAP32[(($8)>>2)]=0;
 label=259;break;
 case 259: 
 if($773){label=265;break;}else{var $793=0;label=261;break;}
 case 260: 
 if($773){var $793=$774;label=261;break;}else{label=265;break;}
 case 261: 
 var $793;
 var $794=HEAP32[(($7)>>2)];
 var $795=(($794+12)|0);
 var $796=HEAP32[(($795)>>2)];
 var $797=(($794+16)|0);
 var $798=HEAP32[(($797)>>2)];
 var $799=($796|0)==($798|0);
 if($799){label=262;break;}else{label=263;break;}
 case 262: 
 var $801=$794;
 var $802=HEAP32[(($801)>>2)];
 var $803=(($802+36)|0);
 var $804=HEAP32[(($803)>>2)];
 var $805=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$804]($794) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $_0_i_i188=$805;label=264;break; } else { var $_ph_ph360_ph_ph_ph_ph_ph=$750;var $_ZNSt3__112__do_nothingEPv347_ph_ph359_ph_ph_ph_ph_ph=$_ZNSt3__112__do_nothingEPv345;label=25;break; }
 case 263: 
 var $807=HEAP32[(($796)>>2)];
 var $_0_i_i188=$807;label=264;break;
 case 264: 
 var $_0_i_i188;
 var $808=HEAP32[(($__dp)>>2)];
 var $809=($_0_i_i188|0)==($808|0);
 if($809){label=266;break;}else{label=265;break;}
 case 265: 
 var $811=HEAP32[(($__err)>>2)];
 var $812=$811|4;
 HEAP32[(($__err)>>2)]=$812;
 var $_0=0;var $1041=$750;var $_ZNSt3__112__do_nothingEPv=$_ZNSt3__112__do_nothingEPv345;label=336;break;
 case 266: 
 var $814=HEAP32[(($7)>>2)];
 var $815=(($814+12)|0);
 var $816=HEAP32[(($815)>>2)];
 var $817=(($814+16)|0);
 var $818=HEAP32[(($817)>>2)];
 var $819=($816|0)==($818|0);
 if($819){label=267;break;}else{label=268;break;}
 case 267: 
 var $821=$814;
 var $822=HEAP32[(($821)>>2)];
 var $823=(($822+40)|0);
 var $824=HEAP32[(($823)>>2)];
 var $825=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$824]($814) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $829=$793;var $828=$752;var $_pre_i4_i_i169=$793;label=269;break; } else { var $_ph_ph360_ph_ph_ph_ph_ph=$750;var $_ZNSt3__112__do_nothingEPv347_ph_ph359_ph_ph_ph_ph_ph=$_ZNSt3__112__do_nothingEPv345;label=25;break; }
 case 268: 
 var $827=(($816+4)|0);
 HEAP32[(($815)>>2)]=$827;
 var $829=$793;var $828=$752;var $_pre_i4_i_i169=$793;label=269;break;
 case 269: 
 var $_pre_i4_i_i169;
 var $828;
 var $829;
 var $830=HEAP32[(($7)>>2)];
 var $831=($830|0)==0;
 if($831){var $848=1;label=276;break;}else{label=270;break;}
 case 270: 
 var $833=(($830+12)|0);
 var $834=HEAP32[(($833)>>2)];
 var $835=(($830+16)|0);
 var $836=HEAP32[(($835)>>2)];
 var $837=($834|0)==($836|0);
 if($837){label=271;break;}else{label=272;break;}
 case 271: 
 var $839=$830;
 var $840=HEAP32[(($839)>>2)];
 var $841=(($840+36)|0);
 var $842=HEAP32[(($841)>>2)];
 var $843=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$842]($830) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $_0_i_i_i_i161=$843;label=273;break; } else { label=21;break; }
 case 272: 
 var $845=HEAP32[(($834)>>2)];
 var $_0_i_i_i_i161=$845;label=273;break;
 case 273: 
 var $_0_i_i_i_i161;
 var $846=($_0_i_i_i_i161|0)==-1;
 if($846){label=275;break;}else{label=274;break;}
 case 274: 
 var $_pre_i_i_i163=HEAP32[(($7)>>2)];
 var $phitmp_i_i_i164=($_pre_i_i_i163|0)==0;
 var $848=$phitmp_i_i_i164;label=276;break;
 case 275: 
 HEAP32[(($7)>>2)]=0;
 var $848=1;label=276;break;
 case 276: 
 var $848;
 var $849=($829|0)==0;
 if($849){var $_pre_i4_i_i169528_ph=$_pre_i4_i_i169;label=282;break;}else{label=277;break;}
 case 277: 
 var $851=(($829+12)|0);
 var $852=HEAP32[(($851)>>2)];
 var $853=(($829+16)|0);
 var $854=HEAP32[(($853)>>2)];
 var $855=($852|0)==($854|0);
 if($855){label=278;break;}else{label=279;break;}
 case 278: 
 var $857=$829;
 var $858=HEAP32[(($857)>>2)];
 var $859=(($858+36)|0);
 var $860=HEAP32[(($859)>>2)];
 var $861=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$860]($829) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $_0_i_i2_i_i167=$861;label=280;break; } else { label=21;break; }
 case 279: 
 var $863=HEAP32[(($852)>>2)];
 var $_0_i_i2_i_i167=$863;label=280;break;
 case 280: 
 var $_0_i_i2_i_i167;
 var $864=($_0_i_i2_i_i167|0)==-1;
 if($864){label=281;break;}else{label=283;break;}
 case 281: 
 HEAP32[(($8)>>2)]=0;
 var $_pre_i4_i_i169528_ph=0;label=282;break;
 case 282: 
 var $_pre_i4_i_i169528_ph;
 if($848){label=289;break;}else{var $_pre_i4_i_i169528545=$_pre_i4_i_i169528_ph;var $868=0;label=284;break;}
 case 283: 
 var $phitmp_i5_i_i170=($_pre_i4_i_i169|0)==0;
 var $tmp_i_i172=$848^$phitmp_i5_i_i170;
 if($tmp_i_i172){var $_pre_i4_i_i169528545=$_pre_i4_i_i169;var $868=$_pre_i4_i_i169;label=284;break;}else{label=289;break;}
 case 284: 
 var $868;
 var $_pre_i4_i_i169528545;
 var $869=HEAP32[(($7)>>2)];
 var $870=(($869+12)|0);
 var $871=HEAP32[(($870)>>2)];
 var $872=(($869+16)|0);
 var $873=HEAP32[(($872)>>2)];
 var $874=($871|0)==($873|0);
 if($874){label=285;break;}else{label=286;break;}
 case 285: 
 var $876=$869;
 var $877=HEAP32[(($876)>>2)];
 var $878=(($877+36)|0);
 var $879=HEAP32[(($878)>>2)];
 var $880=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$879]($869) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $_0_i_i155=$880;label=287;break; } else { label=21;break; }
 case 286: 
 var $882=HEAP32[(($871)>>2)];
 var $_0_i_i155=$882;label=287;break;
 case 287: 
 var $_0_i_i155;
 var $883=HEAP32[(($9)>>2)];
 var $884=(($883+12)|0);
 var $885=HEAP32[(($884)>>2)];
 var $886=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$885]($__ct,2048,$_0_i_i155) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=288;break; } else { label=21;break; }
 case 288: 
 if($886){label=290;break;}else{label=289;break;}
 case 289: 
 var $888=HEAP32[(($__err)>>2)];
 var $889=$888|4;
 HEAP32[(($__err)>>2)]=$889;
 var $_0=0;var $1041=$750;var $_ZNSt3__112__do_nothingEPv=$_ZNSt3__112__do_nothingEPv345;label=336;break;
 case 290: 
 var $891=HEAP32[(($__wn)>>2)];
 var $892=HEAP32[(($1)>>2)];
 var $893=($891|0)==($892|0);
 if($893){label=291;break;}else{label=292;break;}
 case 291: 
 (function() { try { __THREW__ = 0; return __ZNSt3__119__double_or_nothingIwEEvRNS_10unique_ptrIT_PFvPvEEERPS2_S9_($__wb,$__wn,$1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=292;break; } else { label=21;break; }
 case 292: 
 var $896=HEAP32[(($7)>>2)];
 var $897=(($896+12)|0);
 var $898=HEAP32[(($897)>>2)];
 var $899=(($896+16)|0);
 var $900=HEAP32[(($899)>>2)];
 var $901=($898|0)==($900|0);
 if($901){label=293;break;}else{label=294;break;}
 case 293: 
 var $903=$896;
 var $904=HEAP32[(($903)>>2)];
 var $905=(($904+36)|0);
 var $906=HEAP32[(($905)>>2)];
 var $907=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$906]($896) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $_0_i_i147=$907;label=295;break; } else { label=21;break; }
 case 294: 
 var $909=HEAP32[(($898)>>2)];
 var $_0_i_i147=$909;label=295;break;
 case 295: 
 var $_0_i_i147;
 var $910=HEAP32[(($__wn)>>2)];
 var $911=(($910+4)|0);
 HEAP32[(($__wn)>>2)]=$911;
 HEAP32[(($910)>>2)]=$_0_i_i147;
 var $912=((($828)-(1))|0);
 HEAP32[(($__fd)>>2)]=$912;
 var $913=HEAP32[(($7)>>2)];
 var $914=(($913+12)|0);
 var $915=HEAP32[(($914)>>2)];
 var $916=(($913+16)|0);
 var $917=HEAP32[(($916)>>2)];
 var $918=($915|0)==($917|0);
 if($918){label=296;break;}else{label=298;break;}
 case 296: 
 var $920=$913;
 var $921=HEAP32[(($920)>>2)];
 var $922=(($921+40)|0);
 var $923=HEAP32[(($922)>>2)];
 var $924=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$923]($913) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=297;break; } else { label=21;break; }
 case 297: 
 var $925=($912|0)>0;
 if($925){var $829=$868;var $828=$912;var $_pre_i4_i_i169=$_pre_i4_i_i169528545;label=269;break;}else{label=299;break;}
 case 298: 
 var $927=(($915+4)|0);
 HEAP32[(($914)>>2)]=$927;
 label=297;break;
 case 299: 
 var $928=HEAP32[(($__wn)>>2)];
 var $929=HEAP32[(($5)>>2)];
 var $930=($928|0)==($929|0);
 if($930){label=300;break;}else{var $__trailing_sign_1=$__trailing_sign_0467;var $935=$751;var $__gb_sroa_0_0_load322335=$__gb_sroa_0_0_load322336;var $934=$750;var $_ZNSt3__112__do_nothingEPv344=$_ZNSt3__112__do_nothingEPv345;label=301;break;}
 case 300: 
 var $932=HEAP32[(($__err)>>2)];
 var $933=$932|4;
 HEAP32[(($__err)>>2)]=$933;
 var $_0=0;var $1041=$750;var $_ZNSt3__112__do_nothingEPv=$_ZNSt3__112__do_nothingEPv345;label=336;break;
 case 301: 
 var $_ZNSt3__112__do_nothingEPv344;
 var $934;
 var $__gb_sroa_0_0_load322335;
 var $935;
 var $__trailing_sign_1;
 var $936=((($__p_0465)+(1))|0);
 var $937=($936>>>0)<4;
 if($937){var $_ZNSt3__112__do_nothingEPv343455=$_ZNSt3__112__do_nothingEPv344;var $23=$934;var $__gb_sroa_0_0_load322334460=$__gb_sroa_0_0_load322335;var $22=$935;var $__p_0465=$936;var $__trailing_sign_0467=$__trailing_sign_1;label=3;break;}else{var $_ZNSt3__112__do_nothingEPv343_lcssa=$_ZNSt3__112__do_nothingEPv344;var $_lcssa=$934;var $__gb_sroa_0_0_load322334_lcssa=$__gb_sroa_0_0_load322335;var $__trailing_sign_0_lcssa=$__trailing_sign_1;label=302;break;}
 case 302: 
 var $__trailing_sign_0_lcssa;
 var $__gb_sroa_0_0_load322334_lcssa;
 var $_lcssa;
 var $_ZNSt3__112__do_nothingEPv343_lcssa;
 var $938=($__trailing_sign_0_lcssa|0)==0;
 if($938){label=333;break;}else{label=303;break;}
 case 303: 
 var $939=$__trailing_sign_0_lcssa;
 var $940=(($__trailing_sign_0_lcssa+4)|0);
 var $941=(($__trailing_sign_0_lcssa+8)|0);
 var $__i_0=1;label=304;break;
 case 304: 
 var $__i_0;
 var $942=HEAP8[($939)];
 var $943=$942&1;
 var $944=(($943<<24)>>24)==0;
 if($944){label=306;break;}else{label=305;break;}
 case 305: 
 var $946=HEAP32[(($940)>>2)];
 var $950=$946;label=307;break;
 case 306: 
 var $948=($942&255);
 var $949=$948>>>1;
 var $950=$949;label=307;break;
 case 307: 
 var $950;
 var $951=($__i_0>>>0)<($950>>>0);
 if($951){label=308;break;}else{label=333;break;}
 case 308: 
 var $953=HEAP32[(($7)>>2)];
 var $954=($953|0)==0;
 if($954){var $971=1;label=315;break;}else{label=309;break;}
 case 309: 
 var $956=(($953+12)|0);
 var $957=HEAP32[(($956)>>2)];
 var $958=(($953+16)|0);
 var $959=HEAP32[(($958)>>2)];
 var $960=($957|0)==($959|0);
 if($960){label=310;break;}else{label=311;break;}
 case 310: 
 var $962=$953;
 var $963=HEAP32[(($962)>>2)];
 var $964=(($963+36)|0);
 var $965=HEAP32[(($964)>>2)];
 var $966=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$965]($953) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $_0_i_i_i_i=$966;label=312;break; } else { label=19;break; }
 case 311: 
 var $968=HEAP32[(($957)>>2)];
 var $_0_i_i_i_i=$968;label=312;break;
 case 312: 
 var $_0_i_i_i_i;
 var $969=($_0_i_i_i_i|0)==-1;
 if($969){label=314;break;}else{label=313;break;}
 case 313: 
 var $_pre_i_i_i=HEAP32[(($7)>>2)];
 var $phitmp_i_i_i=($_pre_i_i_i|0)==0;
 var $971=$phitmp_i_i_i;label=315;break;
 case 314: 
 HEAP32[(($7)>>2)]=0;
 var $971=1;label=315;break;
 case 315: 
 var $971;
 var $972=HEAP32[(($8)>>2)];
 var $973=($972|0)==0;
 if($973){label=321;break;}else{label=316;break;}
 case 316: 
 var $975=(($972+12)|0);
 var $976=HEAP32[(($975)>>2)];
 var $977=(($972+16)|0);
 var $978=HEAP32[(($977)>>2)];
 var $979=($976|0)==($978|0);
 if($979){label=317;break;}else{label=318;break;}
 case 317: 
 var $981=$972;
 var $982=HEAP32[(($981)>>2)];
 var $983=(($982+36)|0);
 var $984=HEAP32[(($983)>>2)];
 var $985=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$984]($972) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $_0_i_i2_i_i=$985;label=319;break; } else { label=19;break; }
 case 318: 
 var $987=HEAP32[(($976)>>2)];
 var $_0_i_i2_i_i=$987;label=319;break;
 case 319: 
 var $_0_i_i2_i_i;
 var $988=($_0_i_i2_i_i|0)==-1;
 if($988){label=320;break;}else{label=322;break;}
 case 320: 
 HEAP32[(($8)>>2)]=0;
 label=321;break;
 case 321: 
 if($971){label=329;break;}else{label=323;break;}
 case 322: 
 if($971){label=323;break;}else{label=329;break;}
 case 323: 
 var $991=HEAP32[(($7)>>2)];
 var $992=(($991+12)|0);
 var $993=HEAP32[(($992)>>2)];
 var $994=(($991+16)|0);
 var $995=HEAP32[(($994)>>2)];
 var $996=($993|0)==($995|0);
 if($996){label=324;break;}else{label=325;break;}
 case 324: 
 var $998=$991;
 var $999=HEAP32[(($998)>>2)];
 var $1000=(($999+36)|0);
 var $1001=HEAP32[(($1000)>>2)];
 var $1002=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$1001]($991) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $_0_i_i=$1002;label=326;break; } else { label=19;break; }
 case 325: 
 var $1004=HEAP32[(($993)>>2)];
 var $_0_i_i=$1004;label=326;break;
 case 326: 
 var $_0_i_i;
 var $1005=HEAP8[($939)];
 var $1006=$1005&1;
 var $1007=(($1006<<24)>>24)==0;
 if($1007){var $1010=$940;label=328;break;}else{label=327;break;}
 case 327: 
 var $1009=HEAP32[(($941)>>2)];
 var $1010=$1009;label=328;break;
 case 328: 
 var $1010;
 var $1011=(($1010+($__i_0<<2))|0);
 var $1012=HEAP32[(($1011)>>2)];
 var $1013=($_0_i_i|0)==($1012|0);
 if($1013){label=330;break;}else{label=329;break;}
 case 329: 
 var $1015=HEAP32[(($__err)>>2)];
 var $1016=$1015|4;
 HEAP32[(($__err)>>2)]=$1016;
 var $_0=0;var $1041=$_lcssa;var $_ZNSt3__112__do_nothingEPv=$_ZNSt3__112__do_nothingEPv343_lcssa;label=336;break;
 case 330: 
 var $1018=((($__i_0)+(1))|0);
 var $1019=HEAP32[(($7)>>2)];
 var $1020=(($1019+12)|0);
 var $1021=HEAP32[(($1020)>>2)];
 var $1022=(($1019+16)|0);
 var $1023=HEAP32[(($1022)>>2)];
 var $1024=($1021|0)==($1023|0);
 if($1024){label=331;break;}else{label=332;break;}
 case 331: 
 var $1026=$1019;
 var $1027=HEAP32[(($1026)>>2)];
 var $1028=(($1027+40)|0);
 var $1029=HEAP32[(($1028)>>2)];
 var $1030=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$1029]($1019) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $__i_0=$1018;label=304;break; } else { label=19;break; }
 case 332: 
 var $1032=(($1021+4)|0);
 HEAP32[(($1020)>>2)]=$1032;
 var $__i_0=$1018;label=304;break;
 case 333: 
 var $1033=($_lcssa|0)==($__gb_sroa_0_0_load322334_lcssa|0);
 if($1033){var $_0=1;var $1041=$__gb_sroa_0_0_load322334_lcssa;var $_ZNSt3__112__do_nothingEPv=$_ZNSt3__112__do_nothingEPv343_lcssa;label=336;break;}else{label=334;break;}
 case 334: 
 HEAP32[(($__et)>>2)]=0;
 __ZNSt3__116__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj($__grp,$_lcssa,$__gb_sroa_0_0_load322334_lcssa,$__et);
 var $1035=HEAP32[(($__et)>>2)];
 var $1036=($1035|0)==0;
 if($1036){var $_0=1;var $1041=$_lcssa;var $_ZNSt3__112__do_nothingEPv=$_ZNSt3__112__do_nothingEPv343_lcssa;label=336;break;}else{label=335;break;}
 case 335: 
 var $1038=HEAP32[(($__err)>>2)];
 var $1039=$1038|4;
 HEAP32[(($__err)>>2)]=$1039;
 var $_0=0;var $1041=$_lcssa;var $_ZNSt3__112__do_nothingEPv=$_ZNSt3__112__do_nothingEPv343_lcssa;label=336;break;
 case 336: 
 var $_ZNSt3__112__do_nothingEPv;
 var $1041;
 var $_0;
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev($__spaces);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev($__nsn);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev($__psn);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev($__sym);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grp);
 var $1042=($1041|0)==0;
 if($1042){label=339;break;}else{label=337;break;}
 case 337: 
 var $1044=$1041;
 (function() { try { __THREW__ = 0; return FUNCTION_TABLE[$_ZNSt3__112__do_nothingEPv]($1044) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=339;break; } else { label=338;break; }
 case 338: 
 var $1046$0 = ___cxa_find_matching_catch(-1, -1,0); var $1046$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
 case 339: 
 STACKTOP=sp;return $_0;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__19money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_bRNS_8ios_baseERjRNS_12basic_stringIwS3_NS_9allocatorIwEEEE($agg_result,$this,$__b,$__e,$__intl,$__iob,$__err,$__v){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+456)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var tempParam = $__b; $__b=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__b)>>2)]=HEAP32[((tempParam)>>2)];
 var tempParam = $__e; $__e=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $__p_i_i_i_i=sp;
 var $__wbuf=(sp)+(16);
 var $__wb=(sp)+(416);
 var $__wn=(sp)+(424);
 var $__loc=(sp)+(432);
 var $__neg=(sp)+(440);
 var $1=(sp)+(448);
 var $2=(($__wbuf)|0);
 var $3=(($__wb)|0);
 HEAP32[(($3)>>2)]=$2;
 var $4=(($__wb+4)|0);
 HEAP32[(($4)>>2)]=440;
 var $5=(($__wbuf+400)|0);
 (function() { try { __THREW__ = 0; return __ZNKSt3__18ios_base6getlocEv($__loc,$__iob) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=2;break; } else { label=16;break; }
 case 2: 
 var $7=(($__loc)|0);
 var $8=HEAP32[(($7)>>2)];
 var $9=$__p_i_i_i_i;
 var $10=HEAP32[((14088)>>2)];
 var $11=($10|0)==-1;
 if($11){label=4;break;}else{label=3;break;}
 case 3: 
 var $_sroa_01_0___p67_i_idx_i_i_i=(($__p_i_i_i_i)|0);
 HEAP32[(($_sroa_01_0___p67_i_idx_i_i_i)>>2)]=14088;
 var $_sroa_12_4___p67_i_idx3_i_i_i=(($__p_i_i_i_i+4)|0);
 HEAP32[(($_sroa_12_4___p67_i_idx3_i_i_i)>>2)]=(28);
 var $_sroa_2_8___p67_i_idx4_i_i_i=(($__p_i_i_i_i+8)|0);
 HEAP32[(($_sroa_2_8___p67_i_idx4_i_i_i)>>2)]=0;
 (function() { try { __THREW__ = 0; return __ZNSt3__111__call_onceERVmPvPFvS2_E(14088,$9,260) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=4;break; } else { label=42;break; }
 case 4: 
 var $13=HEAP32[((14092)>>2)];
 var $14=((($13)-(1))|0);
 var $15=(($8+12)|0);
 var $16=HEAP32[(($15)>>2)];
 var $17=(($8+8)|0);
 var $18=HEAP32[(($17)>>2)];
 var $19=$16;
 var $20=$18;
 var $21=((($19)-($20))|0);
 var $22=$21>>2;
 var $23=($22>>>0)>($14>>>0);
 if($23){label=5;break;}else{label=6;break;}
 case 5: 
 var $24=(($18+($14<<2))|0);
 var $25=HEAP32[(($24)>>2)];
 var $26=($25|0)==0;
 if($26){label=6;break;}else{label=8;break;}
 case 6: 
 var $27=___cxa_allocate_exception(4);
 var $28=$27;
 __ZNSt8bad_castC2Ev($28);
 (function() { try { __THREW__ = 0; return ___cxa_throw($27,8960,(368)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=7;break; } else { label=42;break; }
 case 7: 
 throw "Reached an unreachable!";
 case 8: 
 var $30=$25;
 HEAP8[($__neg)]=0;
 var $31=(($__e)|0);
 var $32=HEAP32[(($31)>>2)];
 var $33=(($1)|0);
 HEAP32[(($33)>>2)]=$32;
 var $34=(($__iob+4)|0);
 var $35=HEAP32[(($34)>>2)];
 var $36=(function() { try { __THREW__ = 0; return __ZNSt3__19money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE8__do_getERS4_S4_bRKNS_6localeEjRjRbRKNS_5ctypeIwEERNS_10unique_ptrIwPFvPvEEERPwSM_($__b,$1,$__intl,$__loc,$35,$__err,$__neg,$30,$__wb,$__wn,$5) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=9;break; } else { label=42;break; }
 case 9: 
 if($36){label=10;break;}else{label=22;break;}
 case 10: 
 var $39=$__v;
 var $40=HEAP8[($39)];
 var $41=$40&1;
 var $42=(($41<<24)>>24)==0;
 if($42){label=12;break;}else{label=11;break;}
 case 11: 
 var $44=(($__v+8)|0);
 var $45=HEAP32[(($44)>>2)];
 HEAP32[(($45)>>2)]=0;
 var $46=(($__v+4)|0);
 HEAP32[(($46)>>2)]=0;
 label=13;break;
 case 12: 
 var $48=(($__v+4)|0);
 HEAP32[(($48)>>2)]=0;
 HEAP8[($39)]=0;
 label=13;break;
 case 13: 
 var $49=HEAP8[($__neg)];
 var $50=(($49<<24)>>24)==0;
 var $_pre24=$25;
 if($50){label=17;break;}else{label=14;break;}
 case 14: 
 var $52=HEAP32[(($_pre24)>>2)];
 var $53=(($52+44)|0);
 var $54=HEAP32[(($53)>>2)];
 var $55=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$54]($30,45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=15;break; } else { label=42;break; }
 case 15: 
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE9push_backEw($__v,$55) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=17;break; } else { label=42;break; }
 case 16: 
 var $56$0 = ___cxa_find_matching_catch(-1, -1); var $56$1 = tempRet0;
 var $57=$56$0;
 var $58=$56$1;
 HEAP32[(($3)>>2)]=0;
 var $136=$2;var $_01626=$58;var $_028=$57;label=43;break;
 case 17: 
 var $59=HEAP32[(($_pre24)>>2)];
 var $60=(($59+44)|0);
 var $61=HEAP32[(($60)>>2)];
 var $62=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$61]($30,48) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=18;break; } else { label=42;break; }
 case 18: 
 var $63=HEAP32[(($3)>>2)];
 var $64=HEAP32[(($__wn)>>2)];
 var $65=((($64)-(4))|0);
 var $__w_0=$63;label=19;break;
 case 19: 
 var $__w_0;
 var $67=($__w_0>>>0)<($65>>>0);
 if($67){label=20;break;}else{label=21;break;}
 case 20: 
 var $69=HEAP32[(($__w_0)>>2)];
 var $70=($69|0)==($62|0);
 var $71=(($__w_0+4)|0);
 if($70){var $__w_0=$71;label=19;break;}else{label=21;break;}
 case 21: 
 var $73=(function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6appendIPwEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueERS5_E4typeES9_S9_($__v,$__w_0,$64) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=22;break; } else { label=42;break; }
 case 22: 
 var $75=(($__b)|0);
 var $76=HEAP32[(($75)>>2)];
 var $77=($76|0)==0;
 if($77){var $94=1;label=29;break;}else{label=23;break;}
 case 23: 
 var $79=(($76+12)|0);
 var $80=HEAP32[(($79)>>2)];
 var $81=(($76+16)|0);
 var $82=HEAP32[(($81)>>2)];
 var $83=($80|0)==($82|0);
 if($83){label=24;break;}else{label=25;break;}
 case 24: 
 var $85=$76;
 var $86=HEAP32[(($85)>>2)];
 var $87=(($86+36)|0);
 var $88=HEAP32[(($87)>>2)];
 var $89=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$88]($76) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $_0_i_i_i_i=$89;label=26;break; } else { label=42;break; }
 case 25: 
 var $91=HEAP32[(($80)>>2)];
 var $_0_i_i_i_i=$91;label=26;break;
 case 26: 
 var $_0_i_i_i_i;
 var $92=($_0_i_i_i_i|0)==-1;
 if($92){label=28;break;}else{label=27;break;}
 case 27: 
 var $_pre_i_i_i=HEAP32[(($75)>>2)];
 var $phitmp_i_i_i=($_pre_i_i_i|0)==0;
 var $94=$phitmp_i_i_i;label=29;break;
 case 28: 
 HEAP32[(($75)>>2)]=0;
 var $94=1;label=29;break;
 case 29: 
 var $94;
 var $95=($32|0)==0;
 if($95){label=35;break;}else{label=30;break;}
 case 30: 
 var $97=(($32+12)|0);
 var $98=HEAP32[(($97)>>2)];
 var $99=(($32+16)|0);
 var $100=HEAP32[(($99)>>2)];
 var $101=($98|0)==($100|0);
 if($101){label=31;break;}else{label=32;break;}
 case 31: 
 var $103=$32;
 var $104=HEAP32[(($103)>>2)];
 var $105=(($104+36)|0);
 var $106=HEAP32[(($105)>>2)];
 var $107=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$106]($32) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $_0_i_i2_i_i=$107;label=33;break; } else { label=42;break; }
 case 32: 
 var $109=HEAP32[(($98)>>2)];
 var $_0_i_i2_i_i=$109;label=33;break;
 case 33: 
 var $_0_i_i2_i_i;
 var $110=($_0_i_i2_i_i|0)==-1;
 if($110){label=34;break;}else{label=36;break;}
 case 34: 
 HEAP32[(($31)>>2)]=0;
 label=35;break;
 case 35: 
 if($94){label=37;break;}else{label=38;break;}
 case 36: 
 if($94){label=38;break;}else{label=37;break;}
 case 37: 
 var $113=HEAP32[(($__err)>>2)];
 var $114=$113|2;
 HEAP32[(($__err)>>2)]=$114;
 label=38;break;
 case 38: 
 var $115=HEAP32[(($75)>>2)];
 var $116=(($agg_result)|0);
 HEAP32[(($116)>>2)]=$115;
 var $117=HEAP32[(($7)>>2)];
 var $118=(($117)|0);
 var $119=__ZNSt3__114__shared_count16__release_sharedEv($118);
 var $120=HEAP32[(($3)>>2)];
 HEAP32[(($3)>>2)]=0;
 var $121=($120|0)==0;
 if($121){label=41;break;}else{label=39;break;}
 case 39: 
 var $123=HEAP32[(($4)>>2)];
 var $124=$120;
 (function() { try { __THREW__ = 0; return FUNCTION_TABLE[$123]($124) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=41;break; } else { label=40;break; }
 case 40: 
 var $126$0 = ___cxa_find_matching_catch(-1, -1,0); var $126$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
 case 41: 
 STACKTOP=sp;return;
 case 42: 
 var $128$0 = ___cxa_find_matching_catch(-1, -1); var $128$1 = tempRet0;
 var $129=$128$0;
 var $130=$128$1;
 var $131=HEAP32[(($7)>>2)];
 var $132=(($131)|0);
 var $133=__ZNSt3__114__shared_count16__release_sharedEv($132);
 var $_pre=HEAP32[(($3)>>2)];
 HEAP32[(($3)>>2)]=0;
 var $134=($_pre|0)==0;
 if($134){var $_01627=$130;var $_029=$129;label=45;break;}else{var $136=$_pre;var $_01626=$130;var $_028=$129;label=43;break;}
 case 43: 
 var $_028;
 var $_01626;
 var $136;
 var $137=HEAP32[(($4)>>2)];
 var $138=$136;
 (function() { try { __THREW__ = 0; return FUNCTION_TABLE[$137]($138) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $_01627=$_01626;var $_029=$_028;label=45;break; } else { label=44;break; }
 case 44: 
 var $140$0 = ___cxa_find_matching_catch(-1, -1,0); var $140$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
 case 45: 
 var $_029;
 var $_01627;
 var $141$0=$_029;
 var $141$1=0;
 var $142$0=$141$0;
 var $142$1=$_01627;
 ___resumeException($142$0)
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6appendIPwEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueERS5_E4typeES9_S9_($this,$__first,$__last){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=$this;
 var $2=$__first;
 var $3=HEAP8[($1)];
 var $4=$3&1;
 var $5=(($4<<24)>>24)==0;
 if($5){label=2;break;}else{label=3;break;}
 case 2: 
 var $6=($3&255);
 var $7=$6>>>1;
 var $17=1;var $16=$3;var $15=$7;label=4;break;
 case 3: 
 var $9=(($this+4)|0);
 var $10=HEAP32[(($9)>>2)];
 var $11=(($this)|0);
 var $12=HEAP32[(($11)>>2)];
 var $13=$12&-2;
 var $phitmp_i=((($13)-(1))|0);
 var $14=(($12)&255);
 var $17=$phitmp_i;var $16=$14;var $15=$10;label=4;break;
 case 4: 
 var $15;
 var $16;
 var $17;
 var $18=$__last;
 var $19=((($18)-($2))|0);
 var $20=$19>>2;
 var $21=($20|0)==0;
 if($21){label=17;break;}else{label=5;break;}
 case 5: 
 var $23=((($17)-($15))|0);
 var $24=($23>>>0)<($20>>>0);
 if($24){label=6;break;}else{var $29=$16;label=7;break;}
 case 6: 
 var $26=((($15)+($20))|0);
 var $27=((($26)-($17))|0);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE9__grow_byEjjjjjj($this,$17,$27,$15,$15,0,0);
 var $_pre=HEAP8[($1)];
 var $29=$_pre;label=7;break;
 case 7: 
 var $29;
 var $30=$29&1;
 var $31=(($30<<24)>>24)==0;
 if($31){label=9;break;}else{label=8;break;}
 case 8: 
 var $33=(($this+8)|0);
 var $34=HEAP32[(($33)>>2)];
 var $37=$34;label=10;break;
 case 9: 
 var $36=(($this+4)|0);
 var $37=$36;label=10;break;
 case 10: 
 var $37;
 var $38=(($37+($15<<2))|0);
 var $39=($__first|0)==($__last|0);
 if($39){var $__p_0_lcssa=$38;label=14;break;}else{label=11;break;}
 case 11: 
 var $scevgep=((($__last)-(4))|0);
 var $scevgep20=$scevgep;
 var $40=(((-$2))|0);
 var $uglygep=(($scevgep20+$40)|0);
 var $uglygep21=$uglygep;
 var $41=$uglygep21>>>2;
 var $42=((($15)+($41))|0);
 var $43=((($42)+(1))|0);
 var $_018=$__first;var $__p_019=$38;label=12;break;
 case 12: 
 var $__p_019;
 var $_018;
 var $45=HEAP32[(($_018)>>2)];
 HEAP32[(($__p_019)>>2)]=$45;
 var $46=(($__p_019+4)|0);
 var $47=(($_018+4)|0);
 var $48=($47|0)==($__last|0);
 if($48){label=13;break;}else{var $_018=$47;var $__p_019=$46;label=12;break;}
 case 13: 
 var $scevgep22=(($37+($43<<2))|0);
 var $__p_0_lcssa=$scevgep22;label=14;break;
 case 14: 
 var $__p_0_lcssa;
 HEAP32[(($__p_0_lcssa)>>2)]=0;
 var $50=((($15)+($20))|0);
 var $51=HEAP8[($1)];
 var $52=$51&1;
 var $53=(($52<<24)>>24)==0;
 if($53){label=16;break;}else{label=15;break;}
 case 15: 
 var $55=(($this+4)|0);
 HEAP32[(($55)>>2)]=$50;
 label=17;break;
 case 16: 
 var $57=$50<<1;
 var $58=(($57)&255);
 HEAP8[($1)]=$58;
 label=17;break;
 case 17: 
 return $this;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__111__money_getIwE13__gather_infoEbRKNS_6localeERNS_10money_base7patternERwS8_RNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERNS9_IwNSA_IwEENSC_IwEEEESJ_SJ_Ri($__intl,$__loc,$__pat,$__dp,$__ts,$__grp,$__sym,$__psn,$__nsn,$__fd){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+176)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $__p_i_i_i_i37=sp;
 var $__p_i_i_i_i=(sp)+(16);
 var $1=(sp)+(32);
 var $2=(sp)+(40);
 var $3=(sp)+(56);
 var $4=(sp)+(72);
 var $5=(sp)+(88);
 var $6=(sp)+(104);
 var $7=(sp)+(112);
 var $8=(sp)+(128);
 var $9=(sp)+(144);
 var $10=(sp)+(160);
 if($__intl){label=2;break;}else{label=28;break;}
 case 2: 
 var $tmpcast32=$1;
 var $12=(($__loc)|0);
 var $13=HEAP32[(($12)>>2)];
 var $14=$__p_i_i_i_i;
 var $15=HEAP32[((14552)>>2)];
 var $16=($15|0)==-1;
 if($16){label=4;break;}else{label=3;break;}
 case 3: 
 var $_sroa_01_0___p67_i_idx_i_i_i=(($__p_i_i_i_i)|0);
 HEAP32[(($_sroa_01_0___p67_i_idx_i_i_i)>>2)]=14552;
 var $_sroa_12_4___p67_i_idx3_i_i_i=(($__p_i_i_i_i+4)|0);
 HEAP32[(($_sroa_12_4___p67_i_idx3_i_i_i)>>2)]=(28);
 var $_sroa_2_8___p67_i_idx4_i_i_i=(($__p_i_i_i_i+8)|0);
 HEAP32[(($_sroa_2_8___p67_i_idx4_i_i_i)>>2)]=0;
 __ZNSt3__111__call_onceERVmPvPFvS2_E(14552,$14,260);
 label=4;break;
 case 4: 
 var $18=HEAP32[((14556)>>2)];
 var $19=((($18)-(1))|0);
 var $20=(($13+12)|0);
 var $21=HEAP32[(($20)>>2)];
 var $22=(($13+8)|0);
 var $23=HEAP32[(($22)>>2)];
 var $24=$21;
 var $25=$23;
 var $26=((($24)-($25))|0);
 var $27=$26>>2;
 var $28=($27>>>0)>($19>>>0);
 if($28){label=5;break;}else{label=6;break;}
 case 5: 
 var $29=(($23+($19<<2))|0);
 var $30=HEAP32[(($29)>>2)];
 var $31=($30|0)==0;
 if($31){label=6;break;}else{label=7;break;}
 case 6: 
 var $32=___cxa_allocate_exception(4);
 var $33=$32;
 __ZNSt8bad_castC2Ev($33);
 ___cxa_throw($32,8960,(368));
 throw "Reached an unreachable!";
 case 7: 
 var $34=$30;
 var $35=$30;
 var $36=HEAP32[(($35)>>2)];
 var $37=(($36+44)|0);
 var $38=HEAP32[(($37)>>2)];
 FUNCTION_TABLE[$38]($tmpcast32,$34);
 var $39=$__pat;
 var $40=HEAP32[(($1)>>2)];
 tempBigInt=$40;HEAP8[($39)]=tempBigInt&0xff;tempBigInt = tempBigInt>>8;HEAP8[((($39)+(1))|0)]=tempBigInt&0xff;tempBigInt = tempBigInt>>8;HEAP8[((($39)+(2))|0)]=tempBigInt&0xff;tempBigInt = tempBigInt>>8;HEAP8[((($39)+(3))|0)]=tempBigInt&0xff;
 var $41=$30;
 var $42=HEAP32[(($41)>>2)];
 var $43=(($42+32)|0);
 var $44=HEAP32[(($43)>>2)];
 FUNCTION_TABLE[$44]($2,$34);
 var $45=$__nsn;
 var $46=HEAP8[($45)];
 var $47=$46&1;
 var $48=(($47<<24)>>24)==0;
 if($48){label=9;break;}else{label=8;break;}
 case 8: 
 var $50=(($__nsn+8)|0);
 var $51=HEAP32[(($50)>>2)];
 HEAP32[(($51)>>2)]=0;
 var $52=(($__nsn+4)|0);
 HEAP32[(($52)>>2)]=0;
 label=10;break;
 case 9: 
 var $54=(($__nsn+4)|0);
 HEAP32[(($54)>>2)]=0;
 HEAP8[($45)]=0;
 label=10;break;
 case 10: 
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE7reserveEj($__nsn,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=12;break; } else { label=11;break; }
 case 11: 
 var $56$0 = ___cxa_find_matching_catch(-1, -1,0); var $56$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
 case 12: 
 var $57=$2;
 assert(12 % 1 === 0);HEAP32[(($45)>>2)]=HEAP32[(($57)>>2)];HEAP32[((($45)+(4))>>2)]=HEAP32[((($57)+(4))>>2)];HEAP32[((($45)+(8))>>2)]=HEAP32[((($57)+(8))>>2)];
 HEAP32[(($57)>>2)]=0; HEAP32[((($57)+(4))>>2)]=0; HEAP32[((($57)+(8))>>2)]=0;
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev($2);
 var $58=HEAP32[(($41)>>2)];
 var $59=(($58+28)|0);
 var $60=HEAP32[(($59)>>2)];
 FUNCTION_TABLE[$60]($3,$34);
 var $61=$__psn;
 var $62=HEAP8[($61)];
 var $63=$62&1;
 var $64=(($63<<24)>>24)==0;
 if($64){label=14;break;}else{label=13;break;}
 case 13: 
 var $66=(($__psn+8)|0);
 var $67=HEAP32[(($66)>>2)];
 HEAP32[(($67)>>2)]=0;
 var $68=(($__psn+4)|0);
 HEAP32[(($68)>>2)]=0;
 label=15;break;
 case 14: 
 var $70=(($__psn+4)|0);
 HEAP32[(($70)>>2)]=0;
 HEAP8[($61)]=0;
 label=15;break;
 case 15: 
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE7reserveEj($__psn,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=17;break; } else { label=16;break; }
 case 16: 
 var $72$0 = ___cxa_find_matching_catch(-1, -1,0); var $72$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
 case 17: 
 var $73=$3;
 assert(12 % 1 === 0);HEAP32[(($61)>>2)]=HEAP32[(($73)>>2)];HEAP32[((($61)+(4))>>2)]=HEAP32[((($73)+(4))>>2)];HEAP32[((($61)+(8))>>2)]=HEAP32[((($73)+(8))>>2)];
 HEAP32[(($73)>>2)]=0; HEAP32[((($73)+(4))>>2)]=0; HEAP32[((($73)+(8))>>2)]=0;
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev($3);
 var $74=$30;
 var $75=HEAP32[(($74)>>2)];
 var $76=(($75+12)|0);
 var $77=HEAP32[(($76)>>2)];
 var $78=FUNCTION_TABLE[$77]($34);
 HEAP32[(($__dp)>>2)]=$78;
 var $79=HEAP32[(($74)>>2)];
 var $80=(($79+16)|0);
 var $81=HEAP32[(($80)>>2)];
 var $82=FUNCTION_TABLE[$81]($34);
 HEAP32[(($__ts)>>2)]=$82;
 var $83=$30;
 var $84=HEAP32[(($83)>>2)];
 var $85=(($84+20)|0);
 var $86=HEAP32[(($85)>>2)];
 FUNCTION_TABLE[$86]($4,$34);
 var $87=$__grp;
 var $88=HEAP8[($87)];
 var $89=$88&1;
 var $90=(($89<<24)>>24)==0;
 if($90){label=19;break;}else{label=18;break;}
 case 18: 
 var $92=(($__grp+8)|0);
 var $93=HEAP32[(($92)>>2)];
 HEAP8[($93)]=0;
 var $94=(($__grp+4)|0);
 HEAP32[(($94)>>2)]=0;
 label=20;break;
 case 19: 
 var $96=$__grp;
 var $97=(($96+1)|0);
 HEAP8[($97)]=0;
 HEAP8[($87)]=0;
 label=20;break;
 case 20: 
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7reserveEj($__grp,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=22;break; } else { label=21;break; }
 case 21: 
 var $99$0 = ___cxa_find_matching_catch(-1, -1,0); var $99$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
 case 22: 
 var $100=$4;
 assert(12 % 1 === 0);HEAP32[(($87)>>2)]=HEAP32[(($100)>>2)];HEAP32[((($87)+(4))>>2)]=HEAP32[((($100)+(4))>>2)];HEAP32[((($87)+(8))>>2)]=HEAP32[((($100)+(8))>>2)];
 HEAP32[(($100)>>2)]=0; HEAP32[((($100)+(4))>>2)]=0; HEAP32[((($100)+(8))>>2)]=0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($4);
 var $101=HEAP32[(($41)>>2)];
 var $102=(($101+24)|0);
 var $103=HEAP32[(($102)>>2)];
 FUNCTION_TABLE[$103]($5,$34);
 var $104=$__sym;
 var $105=HEAP8[($104)];
 var $106=$105&1;
 var $107=(($106<<24)>>24)==0;
 if($107){label=24;break;}else{label=23;break;}
 case 23: 
 var $109=(($__sym+8)|0);
 var $110=HEAP32[(($109)>>2)];
 HEAP32[(($110)>>2)]=0;
 var $111=(($__sym+4)|0);
 HEAP32[(($111)>>2)]=0;
 label=25;break;
 case 24: 
 var $113=(($__sym+4)|0);
 HEAP32[(($113)>>2)]=0;
 HEAP8[($104)]=0;
 label=25;break;
 case 25: 
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE7reserveEj($__sym,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=27;break; } else { label=26;break; }
 case 26: 
 var $115$0 = ___cxa_find_matching_catch(-1, -1,0); var $115$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
 case 27: 
 var $116=$5;
 assert(12 % 1 === 0);HEAP32[(($104)>>2)]=HEAP32[(($116)>>2)];HEAP32[((($104)+(4))>>2)]=HEAP32[((($116)+(4))>>2)];HEAP32[((($104)+(8))>>2)]=HEAP32[((($116)+(8))>>2)];
 HEAP32[(($116)>>2)]=0; HEAP32[((($116)+(4))>>2)]=0; HEAP32[((($116)+(8))>>2)]=0;
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev($5);
 var $117=HEAP32[(($74)>>2)];
 var $118=(($117+36)|0);
 var $119=HEAP32[(($118)>>2)];
 var $120=FUNCTION_TABLE[$119]($34);
 var $storemerge=$120;label=54;break;
 case 28: 
 var $tmpcast=$6;
 var $122=(($__loc)|0);
 var $123=HEAP32[(($122)>>2)];
 var $124=$__p_i_i_i_i37;
 var $125=HEAP32[((14560)>>2)];
 var $126=($125|0)==-1;
 if($126){label=30;break;}else{label=29;break;}
 case 29: 
 var $_sroa_01_0___p67_i_idx_i_i_i38=(($__p_i_i_i_i37)|0);
 HEAP32[(($_sroa_01_0___p67_i_idx_i_i_i38)>>2)]=14560;
 var $_sroa_12_4___p67_i_idx3_i_i_i39=(($__p_i_i_i_i37+4)|0);
 HEAP32[(($_sroa_12_4___p67_i_idx3_i_i_i39)>>2)]=(28);
 var $_sroa_2_8___p67_i_idx4_i_i_i40=(($__p_i_i_i_i37+8)|0);
 HEAP32[(($_sroa_2_8___p67_i_idx4_i_i_i40)>>2)]=0;
 __ZNSt3__111__call_onceERVmPvPFvS2_E(14560,$124,260);
 label=30;break;
 case 30: 
 var $128=HEAP32[((14564)>>2)];
 var $129=((($128)-(1))|0);
 var $130=(($123+12)|0);
 var $131=HEAP32[(($130)>>2)];
 var $132=(($123+8)|0);
 var $133=HEAP32[(($132)>>2)];
 var $134=$131;
 var $135=$133;
 var $136=((($134)-($135))|0);
 var $137=$136>>2;
 var $138=($137>>>0)>($129>>>0);
 if($138){label=31;break;}else{label=32;break;}
 case 31: 
 var $139=(($133+($129<<2))|0);
 var $140=HEAP32[(($139)>>2)];
 var $141=($140|0)==0;
 if($141){label=32;break;}else{label=33;break;}
 case 32: 
 var $142=___cxa_allocate_exception(4);
 var $143=$142;
 __ZNSt8bad_castC2Ev($143);
 ___cxa_throw($142,8960,(368));
 throw "Reached an unreachable!";
 case 33: 
 var $144=$140;
 var $145=$140;
 var $146=HEAP32[(($145)>>2)];
 var $147=(($146+44)|0);
 var $148=HEAP32[(($147)>>2)];
 FUNCTION_TABLE[$148]($tmpcast,$144);
 var $149=$__pat;
 var $150=HEAP32[(($6)>>2)];
 tempBigInt=$150;HEAP8[($149)]=tempBigInt&0xff;tempBigInt = tempBigInt>>8;HEAP8[((($149)+(1))|0)]=tempBigInt&0xff;tempBigInt = tempBigInt>>8;HEAP8[((($149)+(2))|0)]=tempBigInt&0xff;tempBigInt = tempBigInt>>8;HEAP8[((($149)+(3))|0)]=tempBigInt&0xff;
 var $151=$140;
 var $152=HEAP32[(($151)>>2)];
 var $153=(($152+32)|0);
 var $154=HEAP32[(($153)>>2)];
 FUNCTION_TABLE[$154]($7,$144);
 var $155=$__nsn;
 var $156=HEAP8[($155)];
 var $157=$156&1;
 var $158=(($157<<24)>>24)==0;
 if($158){label=35;break;}else{label=34;break;}
 case 34: 
 var $160=(($__nsn+8)|0);
 var $161=HEAP32[(($160)>>2)];
 HEAP32[(($161)>>2)]=0;
 var $162=(($__nsn+4)|0);
 HEAP32[(($162)>>2)]=0;
 label=36;break;
 case 35: 
 var $164=(($__nsn+4)|0);
 HEAP32[(($164)>>2)]=0;
 HEAP8[($155)]=0;
 label=36;break;
 case 36: 
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE7reserveEj($__nsn,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=38;break; } else { label=37;break; }
 case 37: 
 var $166$0 = ___cxa_find_matching_catch(-1, -1,0); var $166$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
 case 38: 
 var $167=$7;
 assert(12 % 1 === 0);HEAP32[(($155)>>2)]=HEAP32[(($167)>>2)];HEAP32[((($155)+(4))>>2)]=HEAP32[((($167)+(4))>>2)];HEAP32[((($155)+(8))>>2)]=HEAP32[((($167)+(8))>>2)];
 HEAP32[(($167)>>2)]=0; HEAP32[((($167)+(4))>>2)]=0; HEAP32[((($167)+(8))>>2)]=0;
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev($7);
 var $168=HEAP32[(($151)>>2)];
 var $169=(($168+28)|0);
 var $170=HEAP32[(($169)>>2)];
 FUNCTION_TABLE[$170]($8,$144);
 var $171=$__psn;
 var $172=HEAP8[($171)];
 var $173=$172&1;
 var $174=(($173<<24)>>24)==0;
 if($174){label=40;break;}else{label=39;break;}
 case 39: 
 var $176=(($__psn+8)|0);
 var $177=HEAP32[(($176)>>2)];
 HEAP32[(($177)>>2)]=0;
 var $178=(($__psn+4)|0);
 HEAP32[(($178)>>2)]=0;
 label=41;break;
 case 40: 
 var $180=(($__psn+4)|0);
 HEAP32[(($180)>>2)]=0;
 HEAP8[($171)]=0;
 label=41;break;
 case 41: 
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE7reserveEj($__psn,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=43;break; } else { label=42;break; }
 case 42: 
 var $182$0 = ___cxa_find_matching_catch(-1, -1,0); var $182$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
 case 43: 
 var $183=$8;
 assert(12 % 1 === 0);HEAP32[(($171)>>2)]=HEAP32[(($183)>>2)];HEAP32[((($171)+(4))>>2)]=HEAP32[((($183)+(4))>>2)];HEAP32[((($171)+(8))>>2)]=HEAP32[((($183)+(8))>>2)];
 HEAP32[(($183)>>2)]=0; HEAP32[((($183)+(4))>>2)]=0; HEAP32[((($183)+(8))>>2)]=0;
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev($8);
 var $184=$140;
 var $185=HEAP32[(($184)>>2)];
 var $186=(($185+12)|0);
 var $187=HEAP32[(($186)>>2)];
 var $188=FUNCTION_TABLE[$187]($144);
 HEAP32[(($__dp)>>2)]=$188;
 var $189=HEAP32[(($184)>>2)];
 var $190=(($189+16)|0);
 var $191=HEAP32[(($190)>>2)];
 var $192=FUNCTION_TABLE[$191]($144);
 HEAP32[(($__ts)>>2)]=$192;
 var $193=$140;
 var $194=HEAP32[(($193)>>2)];
 var $195=(($194+20)|0);
 var $196=HEAP32[(($195)>>2)];
 FUNCTION_TABLE[$196]($9,$144);
 var $197=$__grp;
 var $198=HEAP8[($197)];
 var $199=$198&1;
 var $200=(($199<<24)>>24)==0;
 if($200){label=45;break;}else{label=44;break;}
 case 44: 
 var $202=(($__grp+8)|0);
 var $203=HEAP32[(($202)>>2)];
 HEAP8[($203)]=0;
 var $204=(($__grp+4)|0);
 HEAP32[(($204)>>2)]=0;
 label=46;break;
 case 45: 
 var $206=$__grp;
 var $207=(($206+1)|0);
 HEAP8[($207)]=0;
 HEAP8[($197)]=0;
 label=46;break;
 case 46: 
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7reserveEj($__grp,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=48;break; } else { label=47;break; }
 case 47: 
 var $209$0 = ___cxa_find_matching_catch(-1, -1,0); var $209$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
 case 48: 
 var $210=$9;
 assert(12 % 1 === 0);HEAP32[(($197)>>2)]=HEAP32[(($210)>>2)];HEAP32[((($197)+(4))>>2)]=HEAP32[((($210)+(4))>>2)];HEAP32[((($197)+(8))>>2)]=HEAP32[((($210)+(8))>>2)];
 HEAP32[(($210)>>2)]=0; HEAP32[((($210)+(4))>>2)]=0; HEAP32[((($210)+(8))>>2)]=0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($9);
 var $211=HEAP32[(($151)>>2)];
 var $212=(($211+24)|0);
 var $213=HEAP32[(($212)>>2)];
 FUNCTION_TABLE[$213]($10,$144);
 var $214=$__sym;
 var $215=HEAP8[($214)];
 var $216=$215&1;
 var $217=(($216<<24)>>24)==0;
 if($217){label=50;break;}else{label=49;break;}
 case 49: 
 var $219=(($__sym+8)|0);
 var $220=HEAP32[(($219)>>2)];
 HEAP32[(($220)>>2)]=0;
 var $221=(($__sym+4)|0);
 HEAP32[(($221)>>2)]=0;
 label=51;break;
 case 50: 
 var $223=(($__sym+4)|0);
 HEAP32[(($223)>>2)]=0;
 HEAP8[($214)]=0;
 label=51;break;
 case 51: 
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE7reserveEj($__sym,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=53;break; } else { label=52;break; }
 case 52: 
 var $225$0 = ___cxa_find_matching_catch(-1, -1,0); var $225$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
 case 53: 
 var $226=$10;
 assert(12 % 1 === 0);HEAP32[(($214)>>2)]=HEAP32[(($226)>>2)];HEAP32[((($214)+(4))>>2)]=HEAP32[((($226)+(4))>>2)];HEAP32[((($214)+(8))>>2)]=HEAP32[((($226)+(8))>>2)];
 HEAP32[(($226)>>2)]=0; HEAP32[((($226)+(4))>>2)]=0; HEAP32[((($226)+(8))>>2)]=0;
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev($10);
 var $227=HEAP32[(($184)>>2)];
 var $228=(($227+36)|0);
 var $229=HEAP32[(($228)>>2)];
 var $230=FUNCTION_TABLE[$229]($144);
 var $storemerge=$230;label=54;break;
 case 54: 
 var $storemerge;
 HEAP32[(($__fd)>>2)]=$storemerge;
 STACKTOP=sp;return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__119__double_or_nothingIwEEvRNS_10unique_ptrIT_PFvPvEEERPS2_S9_($__b,$__n,$__e){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=(($__b+4)|0);
 var $2=HEAP32[(($1)>>2)];
 var $3=($2|0)!=((440)|0);
 var $4=HEAP32[(($__e)>>2)];
 var $5=(($__b)|0);
 var $6=HEAP32[(($5)>>2)];
 var $7=$4;
 var $8=$6;
 var $9=((($7)-($8))|0);
 var $10=($9>>>0)<2147483647;
 var $11=$9<<1;
 var $12=($10?$11:-1);
 var $13=HEAP32[(($__n)>>2)];
 var $14=$13;
 var $15=((($14)-($8))|0);
 var $16=$15>>2;
 if($3){label=2;break;}else{var $19=0;label=3;break;}
 case 2: 
 var $phitmp=$6;
 var $19=$phitmp;label=3;break;
 case 3: 
 var $19;
 var $20=_realloc($19,$12);
 var $21=$20;
 var $22=($20|0)==0;
 if($22){label=4;break;}else{label=5;break;}
 case 4: 
 __ZSt17__throw_bad_allocv();
 label=5;break;
 case 5: 
 if($3){label=6;break;}else{label=7;break;}
 case 6: 
 HEAP32[(($5)>>2)]=$21;
 var $32=$21;label=11;break;
 case 7: 
 var $_pr=HEAP32[(($5)>>2)];
 HEAP32[(($5)>>2)]=$21;
 var $26=($_pr|0)==0;
 if($26){var $32=$21;label=11;break;}else{label=8;break;}
 case 8: 
 var $28=HEAP32[(($1)>>2)];
 var $29=$_pr;
 (function() { try { __THREW__ = 0; return FUNCTION_TABLE[$28]($29) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=9;break; } else { label=10;break; }
 case 9: 
 var $_pre=HEAP32[(($5)>>2)];
 var $32=$_pre;label=11;break;
 case 10: 
 var $31$0 = ___cxa_find_matching_catch(-1, -1,0); var $31$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
 case 11: 
 var $32;
 HEAP32[(($1)>>2)]=222;
 var $33=$12>>>2;
 var $34=(($32+($16<<2))|0);
 HEAP32[(($__n)>>2)]=$34;
 var $35=HEAP32[(($5)>>2)];
 var $36=(($35+($33<<2))|0);
 HEAP32[(($__e)>>2)]=$36;
 return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__19money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEED0Ev($this){
 var label=0;


 var $1=(($this)|0);
 __ZNSt3__114__shared_countD2Ev($1);
 var $2=$this;
 __ZdlPv($2);
 return;
}


function __ZNSt3__19money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEED1Ev($this){
 var label=0;


 var $1=(($this)|0);
 __ZNSt3__114__shared_countD2Ev($1);
 return;
}


function __ZNKSt3__19money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_bRNS_8ios_baseEce($agg_result,$this,$__s,$__intl,$__iob,$__fl,$__units){
 var label=0;
 var tempVarArgs=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+448)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var tempParam = $__s; $__s=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__s)>>2)]=HEAP32[((tempParam)>>2)];
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $__p_i_i_i_i=sp;
 var $__buf=(sp)+(16);
 var $__bb=(sp)+(120);
 var $__digits=(sp)+(128);
 var $__loc=(sp)+(232);
 var $__pat=(sp)+(240);
 var $__dp=(sp)+(248);
 var $__ts=(sp)+(256);
 var $__grp=(sp)+(264);
 var $__sym=(sp)+(280);
 var $__sn=(sp)+(296);
 var $__fd=(sp)+(312);
 var $__mbuf=(sp)+(320);
 var $__mi=(sp)+(424);
 var $__me=(sp)+(432);
 var $1=(sp)+(440);
 var $2=(($__buf)|0);
 HEAP32[(($__bb)>>2)]=$2;
 var $3=(($__digits)|0);
 var $4=_snprintf($2,100,1528,(tempVarArgs=STACKTOP,STACKTOP = (STACKTOP + 8)|0,(assert((STACKTOP|0) < (STACK_MAX|0))|0),HEAPF64[((tempVarArgs)>>3)]=$__units,tempVarArgs)); STACKTOP=tempVarArgs;
 var $5=($4>>>0)>99;
 if($5){label=2;break;}else{var $__db_0=$3;var $__n_0=$4;var $38=0;var $37=0;label=15;break;}
 case 2: 
 var $7=HEAP8[(14656)];
 var $8=(($7<<24)>>24)==0;
 if($8){label=3;break;}else{label=7;break;}
 case 3: 
 var $10=___cxa_guard_acquire(14656);
 var $11=($10|0)==0;
 if($11){label=7;break;}else{label=4;break;}
 case 4: 
 var $13=(function() { try { __THREW__ = 0; return _newlocale(2147483647,1496,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=5;break; } else { label=6;break; }
 case 5: 
 HEAP32[((12664)>>2)]=$13;

 label=7;break;
 case 6: 
 var $16$0 = ___cxa_find_matching_catch(-1, -1); var $16$1 = tempRet0;

 var $eh_lpad_body$1=$16$1;var $eh_lpad_body$0=$16$0;var $29=0;var $28=0;label=12;break;
 case 7: 
 var $18=HEAP32[((12664)>>2)];
 var $19=(function() { try { __THREW__ = 0; return __ZNSt3__112__asprintf_lEPPcP15__locale_structPKcz($__bb,$18,1528,(tempVarArgs=STACKTOP,STACKTOP = (STACKTOP + 8)|0,(assert((STACKTOP|0) < (STACK_MAX|0))|0),HEAPF64[((tempVarArgs)>>3)]=$__units,tempVarArgs)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })(); STACKTOP=tempVarArgs;if (!__THREW__) { label=8;break; } else { var $26=0;var $25=0;label=11;break; }
 case 8: 
 var $21=HEAP32[(($__bb)>>2)];
 var $22=($21|0)==0;
 if($22){label=9;break;}else{var $32=$21;label=13;break;}
 case 9: 
 (function() { try { __THREW__ = 0; return __ZSt17__throw_bad_allocv() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=10;break; } else { var $26=0;var $25=0;label=11;break; }
 case 10: 
 var $_pre=HEAP32[(($__bb)>>2)];
 var $32=$_pre;label=13;break;
 case 11: 
 var $25;
 var $26;
 var $27$0 = ___cxa_find_matching_catch(-1, -1); var $27$1 = tempRet0;
 var $eh_lpad_body$1=$27$1;var $eh_lpad_body$0=$27$0;var $29=$26;var $28=$25;label=12;break;
 case 12: 
 var $28;
 var $29;
 var $eh_lpad_body$0;
 var $eh_lpad_body$1;
 var $30=$eh_lpad_body$0;
 var $31=$eh_lpad_body$1;
 var $_2=$30;var $_225=$31;var $183=$29;var $182=$28;label=60;break;
 case 13: 
 var $32;
 var $33=_malloc($19);
 var $34=($33|0)==0;
 if($34){label=14;break;}else{var $__db_0=$33;var $__n_0=$19;var $38=$33;var $37=$32;label=15;break;}
 case 14: 
 (function() { try { __THREW__ = 0; return __ZSt17__throw_bad_allocv() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $__db_0=0;var $__n_0=$19;var $38=0;var $37=$32;label=15;break; } else { var $26=0;var $25=$32;label=11;break; }
 case 15: 
 var $37;
 var $38;
 var $__n_0;
 var $__db_0;
 (function() { try { __THREW__ = 0; return __ZNKSt3__18ios_base6getlocEv($__loc,$__iob) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=16;break; } else { var $26=$38;var $25=$37;label=11;break; }
 case 16: 
 var $40=(($__loc)|0);
 var $41=HEAP32[(($40)>>2)];
 var $42=$__p_i_i_i_i;
 var $43=HEAP32[((14096)>>2)];
 var $44=($43|0)==-1;
 if($44){label=18;break;}else{label=17;break;}
 case 17: 
 var $_sroa_01_0___p67_i_idx_i_i_i=(($__p_i_i_i_i)|0);
 HEAP32[(($_sroa_01_0___p67_i_idx_i_i_i)>>2)]=14096;
 var $_sroa_12_4___p67_i_idx3_i_i_i=(($__p_i_i_i_i+4)|0);
 HEAP32[(($_sroa_12_4___p67_i_idx3_i_i_i)>>2)]=(28);
 var $_sroa_2_8___p67_i_idx4_i_i_i=(($__p_i_i_i_i+8)|0);
 HEAP32[(($_sroa_2_8___p67_i_idx4_i_i_i)>>2)]=0;
 (function() { try { __THREW__ = 0; return __ZNSt3__111__call_onceERVmPvPFvS2_E(14096,$42,260) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=18;break; } else { label=45;break; }
 case 18: 
 var $46=HEAP32[((14100)>>2)];
 var $47=((($46)-(1))|0);
 var $48=(($41+12)|0);
 var $49=HEAP32[(($48)>>2)];
 var $50=(($41+8)|0);
 var $51=HEAP32[(($50)>>2)];
 var $52=$49;
 var $53=$51;
 var $54=((($52)-($53))|0);
 var $55=$54>>2;
 var $56=($55>>>0)>($47>>>0);
 if($56){label=19;break;}else{label=20;break;}
 case 19: 
 var $57=(($51+($47<<2))|0);
 var $58=HEAP32[(($57)>>2)];
 var $59=($58|0)==0;
 if($59){label=20;break;}else{label=22;break;}
 case 20: 
 var $60=___cxa_allocate_exception(4);
 var $61=$60;
 __ZNSt8bad_castC2Ev($61);
 (function() { try { __THREW__ = 0; return ___cxa_throw($60,8960,(368)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=21;break; } else { label=45;break; }
 case 21: 
 throw "Reached an unreachable!";
 case 22: 
 var $63=$58;
 var $64=HEAP32[(($__bb)>>2)];
 var $65=(($64+$__n_0)|0);
 var $66=$58;
 var $67=HEAP32[(($66)>>2)];
 var $68=(($67+32)|0);
 var $69=HEAP32[(($68)>>2)];
 var $70=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$69]($63,$64,$65,$__db_0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=23;break; } else { label=45;break; }
 case 23: 
 var $71=($__n_0|0)==0;
 if($71){var $77=0;label=25;break;}else{label=24;break;}
 case 24: 
 var $73=HEAP32[(($__bb)>>2)];
 var $74=HEAP8[($73)];
 var $75=(($74<<24)>>24)==45;
 var $77=$75;label=25;break;
 case 25: 
 var $77;
 var $this4_i_i_i=$__grp;
 HEAP32[(($this4_i_i_i)>>2)]=0; HEAP32[((($this4_i_i_i)+(4))>>2)]=0; HEAP32[((($this4_i_i_i)+(8))>>2)]=0;
 var $this4_i_i_i29=$__sym;
 HEAP32[(($this4_i_i_i29)>>2)]=0; HEAP32[((($this4_i_i_i29)+(4))>>2)]=0; HEAP32[((($this4_i_i_i29)+(8))>>2)]=0;
 var $this4_i_i_i30=$__sn;
 HEAP32[(($this4_i_i_i30)>>2)]=0; HEAP32[((($this4_i_i_i30)+(4))>>2)]=0; HEAP32[((($this4_i_i_i30)+(8))>>2)]=0;
 (function() { try { __THREW__ = 0; return __ZNSt3__111__money_putIcE13__gather_infoEbbRKNS_6localeERNS_10money_base7patternERcS8_RNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEESF_SF_Ri($__intl,$77,$__loc,$__pat,$__dp,$__ts,$__grp,$__sym,$__sn,$__fd) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=26;break; } else { label=46;break; }
 case 26: 
 var $79=(($__mbuf)|0);
 var $80=HEAP32[(($__fd)>>2)];
 var $81=($__n_0|0)>($80|0);
 if($81){label=27;break;}else{label=34;break;}
 case 27: 
 var $83=((($__n_0)-($80))|0);
 var $84=$83<<1;
 var $85=HEAP8[($this4_i_i_i30)];
 var $86=$85&1;
 var $87=(($86<<24)>>24)==0;
 if($87){label=29;break;}else{label=28;break;}
 case 28: 
 var $89=(($__sn+4)|0);
 var $90=HEAP32[(($89)>>2)];
 var $94=$90;label=30;break;
 case 29: 
 var $92=($85&255);
 var $93=$92>>>1;
 var $94=$93;label=30;break;
 case 30: 
 var $94;
 var $95=HEAP8[($this4_i_i_i29)];
 var $96=$95&1;
 var $97=(($96<<24)>>24)==0;
 if($97){label=32;break;}else{label=31;break;}
 case 31: 
 var $99=(($__sym+4)|0);
 var $100=HEAP32[(($99)>>2)];
 var $104=$100;label=33;break;
 case 32: 
 var $102=($95&255);
 var $103=$102>>>1;
 var $104=$103;label=33;break;
 case 33: 
 var $104;
 var $105=$84|1;
 var $106=((($94)+($105))|0);
 var $107=((($106)+($104))|0);
 var $_pn=$107;label=41;break;
 case 34: 
 var $109=HEAP8[($this4_i_i_i30)];
 var $110=$109&1;
 var $111=(($110<<24)>>24)==0;
 if($111){label=36;break;}else{label=35;break;}
 case 35: 
 var $113=(($__sn+4)|0);
 var $114=HEAP32[(($113)>>2)];
 var $118=$114;label=37;break;
 case 36: 
 var $116=($109&255);
 var $117=$116>>>1;
 var $118=$117;label=37;break;
 case 37: 
 var $118;
 var $119=HEAP8[($this4_i_i_i29)];
 var $120=$119&1;
 var $121=(($120<<24)>>24)==0;
 if($121){label=39;break;}else{label=38;break;}
 case 38: 
 var $123=(($__sym+4)|0);
 var $124=HEAP32[(($123)>>2)];
 var $128=$124;label=40;break;
 case 39: 
 var $126=($119&255);
 var $127=$126>>>1;
 var $128=$127;label=40;break;
 case 40: 
 var $128;
 var $129=((($118)+(2))|0);
 var $130=((($129)+($128))|0);
 var $_pn=$130;label=41;break;
 case 41: 
 var $_pn;
 var $132=((($_pn)+($80))|0);
 var $133=($132>>>0)>100;
 if($133){label=42;break;}else{var $__mb_0=$79;var $155=0;label=49;break;}
 case 42: 
 var $134=_malloc($132);
 var $135=($134|0)==0;
 if($135){label=43;break;}else{var $__mb_0=$134;var $155=$134;label=49;break;}
 case 43: 
 (function() { try { __THREW__ = 0; return __ZSt17__throw_bad_allocv() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $__mb_0=0;var $155=0;label=49;break; } else { label=44;break; }
 case 44: 
 var $137$0 = ___cxa_find_matching_catch(-1, -1); var $137$1 = tempRet0;
 var $138=$137$0;
 var $139=$137$1;
 var $_0=$138;var $_023=$139;label=58;break;
 case 45: 
 var $141$0 = ___cxa_find_matching_catch(-1, -1); var $141$1 = tempRet0;
 var $142=$141$0;
 var $143=$141$1;
 var $_1=$142;var $_124=$143;label=59;break;
 case 46: 
 var $145$0 = ___cxa_find_matching_catch(-1, -1); var $145$1 = tempRet0;
 var $146=$145$0;
 var $147=$145$1;
 var $_0=$146;var $_023=$147;label=58;break;
 case 47: 
 var $149$0 = ___cxa_find_matching_catch(-1, -1); var $149$1 = tempRet0;
 var $150=$149$0;
 var $151=$149$1;
 var $152=($155|0)==0;
 if($152){var $_0=$150;var $_023=$151;label=58;break;}else{label=48;break;}
 case 48: 
 _free($155);
 var $_0=$150;var $_023=$151;label=58;break;
 case 49: 
 var $155;
 var $__mb_0;
 var $156=(($__iob+4)|0);
 var $157=HEAP32[(($156)>>2)];
 var $158=(($__db_0+$__n_0)|0);
 var $159=HEAP8[($__dp)];
 var $160=HEAP8[($__ts)];
 (function() { try { __THREW__ = 0; return __ZNSt3__111__money_putIcE8__formatEPcRS2_S3_jPKcS5_RKNS_5ctypeIcEEbRKNS_10money_base7patternEccRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEESL_SL_i($__mb_0,$__mi,$__me,$157,$__db_0,$158,$63,$77,$__pat,$159,$160,$__grp,$__sym,$__sn,$80) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=50;break; } else { label=47;break; }
 case 50: 
 var $162=(($__s)|0);
 var $163=HEAP32[(($162)>>2)];
 var $164=(($1)|0);
 HEAP32[(($164)>>2)]=$163;
 var $165=HEAP32[(($__mi)>>2)];
 var $166=HEAP32[(($__me)>>2)];
 (function() { try { __THREW__ = 0; return __ZNSt3__116__pad_and_outputIcNS_11char_traitsIcEEEENS_19ostreambuf_iteratorIT_T0_EES6_PKS4_S8_S8_RNS_8ios_baseES4_($agg_result,$1,$__mb_0,$165,$166,$__iob,$__fl) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=51;break; } else { label=47;break; }
 case 51: 
 var $168=($155|0)==0;
 if($168){label=53;break;}else{label=52;break;}
 case 52: 
 _free($155);
 label=53;break;
 case 53: 
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__sn);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__sym);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grp);
 var $170=HEAP32[(($40)>>2)];
 var $171=(($170)|0);
 var $172=__ZNSt3__114__shared_count16__release_sharedEv($171);
 var $173=($38|0)==0;
 if($173){label=55;break;}else{label=54;break;}
 case 54: 
 _free($38);
 label=55;break;
 case 55: 
 var $175=($37|0)==0;
 if($175){label=57;break;}else{label=56;break;}
 case 56: 
 _free($37);
 label=57;break;
 case 57: 
 STACKTOP=sp;return;
 case 58: 
 var $_023;
 var $_0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__sn);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__sym);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grp);
 var $_1=$_0;var $_124=$_023;label=59;break;
 case 59: 
 var $_124;
 var $_1;
 var $178=HEAP32[(($40)>>2)];
 var $179=(($178)|0);
 var $180=__ZNSt3__114__shared_count16__release_sharedEv($179);
 var $_2=$_1;var $_225=$_124;var $183=$38;var $182=$37;label=60;break;
 case 60: 
 var $182;
 var $183;
 var $_225;
 var $_2;
 var $184=($183|0)==0;
 if($184){label=62;break;}else{label=61;break;}
 case 61: 
 _free($183);
 label=62;break;
 case 62: 
 var $186=($182|0)==0;
 if($186){label=64;break;}else{label=63;break;}
 case 63: 
 _free($182);
 label=64;break;
 case 64: 
 var $188$0=$_2;
 var $188$1=0;
 var $189$0=$188$0;
 var $189$1=$_225;
 ___resumeException($189$0)
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__111__money_putIcE13__gather_infoEbbRKNS_6localeERNS_10money_base7patternERcS8_RNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEESF_SF_Ri($__intl,$__neg,$__loc,$__pat,$__dp,$__ts,$__grp,$__sym,$__sn,$__fd){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+40)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $__p_i_i_i_i43=sp;
 var $__p_i_i_i_i=(sp)+(16);
 var $1=(sp)+(32);
 var $tmpcast36=$1;
 var $2=STACKTOP;STACKTOP = (STACKTOP + 12)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var $3=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var $tmpcast35=$3;
 var $4=STACKTOP;STACKTOP = (STACKTOP + 12)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var $5=STACKTOP;STACKTOP = (STACKTOP + 12)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var $6=STACKTOP;STACKTOP = (STACKTOP + 12)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var $7=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var $tmpcast34=$7;
 var $8=STACKTOP;STACKTOP = (STACKTOP + 12)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var $9=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var $tmpcast=$9;
 var $10=STACKTOP;STACKTOP = (STACKTOP + 12)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var $11=STACKTOP;STACKTOP = (STACKTOP + 12)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var $12=STACKTOP;STACKTOP = (STACKTOP + 12)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var $13=(($__loc)|0);
 var $14=HEAP32[(($13)>>2)];
 if($__intl){label=2;break;}else{label=31;break;}
 case 2: 
 var $16=$__p_i_i_i_i;
 var $17=HEAP32[((14568)>>2)];
 var $18=($17|0)==-1;
 if($18){label=4;break;}else{label=3;break;}
 case 3: 
 var $_sroa_01_0___p67_i_idx_i_i_i=(($__p_i_i_i_i)|0);
 HEAP32[(($_sroa_01_0___p67_i_idx_i_i_i)>>2)]=14568;
 var $_sroa_12_4___p67_i_idx3_i_i_i=(($__p_i_i_i_i+4)|0);
 HEAP32[(($_sroa_12_4___p67_i_idx3_i_i_i)>>2)]=(28);
 var $_sroa_2_8___p67_i_idx4_i_i_i=(($__p_i_i_i_i+8)|0);
 HEAP32[(($_sroa_2_8___p67_i_idx4_i_i_i)>>2)]=0;
 __ZNSt3__111__call_onceERVmPvPFvS2_E(14568,$16,260);
 label=4;break;
 case 4: 
 var $20=HEAP32[((14572)>>2)];
 var $21=((($20)-(1))|0);
 var $22=(($14+12)|0);
 var $23=HEAP32[(($22)>>2)];
 var $24=(($14+8)|0);
 var $25=HEAP32[(($24)>>2)];
 var $26=$23;
 var $27=$25;
 var $28=((($26)-($27))|0);
 var $29=$28>>2;
 var $30=($29>>>0)>($21>>>0);
 if($30){label=5;break;}else{label=6;break;}
 case 5: 
 var $31=(($25+($21<<2))|0);
 var $32=HEAP32[(($31)>>2)];
 var $33=($32|0)==0;
 if($33){label=6;break;}else{label=7;break;}
 case 6: 
 var $34=___cxa_allocate_exception(4);
 var $35=$34;
 __ZNSt8bad_castC2Ev($35);
 ___cxa_throw($34,8960,(368));
 throw "Reached an unreachable!";
 case 7: 
 var $36=$32;
 var $37=$32;
 var $38=HEAP32[(($37)>>2)];
 if($__neg){label=8;break;}else{label=14;break;}
 case 8: 
 var $40=(($38+44)|0);
 var $41=HEAP32[(($40)>>2)];
 FUNCTION_TABLE[$41]($tmpcast36,$36);
 var $42=$__pat;
 var $43=HEAP32[(($1)>>2)];
 tempBigInt=$43;HEAP8[($42)]=tempBigInt&0xff;tempBigInt = tempBigInt>>8;HEAP8[((($42)+(1))|0)]=tempBigInt&0xff;tempBigInt = tempBigInt>>8;HEAP8[((($42)+(2))|0)]=tempBigInt&0xff;tempBigInt = tempBigInt>>8;HEAP8[((($42)+(3))|0)]=tempBigInt&0xff;
 var $44=$32;
 var $45=HEAP32[(($44)>>2)];
 var $46=(($45+32)|0);
 var $47=HEAP32[(($46)>>2)];
 FUNCTION_TABLE[$47]($2,$36);
 var $48=$__sn;
 var $49=HEAP8[($48)];
 var $50=$49&1;
 var $51=(($50<<24)>>24)==0;
 if($51){label=10;break;}else{label=9;break;}
 case 9: 
 var $53=(($__sn+8)|0);
 var $54=HEAP32[(($53)>>2)];
 HEAP8[($54)]=0;
 var $55=(($__sn+4)|0);
 HEAP32[(($55)>>2)]=0;
 label=11;break;
 case 10: 
 var $57=$__sn;
 var $58=(($57+1)|0);
 HEAP8[($58)]=0;
 HEAP8[($48)]=0;
 label=11;break;
 case 11: 
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7reserveEj($__sn,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=13;break; } else { label=12;break; }
 case 12: 
 var $60$0 = ___cxa_find_matching_catch(-1, -1,0); var $60$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
 case 13: 
 var $61=$2;
 assert(12 % 1 === 0);HEAP32[(($48)>>2)]=HEAP32[(($61)>>2)];HEAP32[((($48)+(4))>>2)]=HEAP32[((($61)+(4))>>2)];HEAP32[((($48)+(8))>>2)]=HEAP32[((($61)+(8))>>2)];
 HEAP32[(($61)>>2)]=0; HEAP32[((($61)+(4))>>2)]=0; HEAP32[((($61)+(8))>>2)]=0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($2);
 label=20;break;
 case 14: 
 var $63=(($38+40)|0);
 var $64=HEAP32[(($63)>>2)];
 FUNCTION_TABLE[$64]($tmpcast35,$36);
 var $65=$__pat;
 var $66=HEAP32[(($3)>>2)];
 tempBigInt=$66;HEAP8[($65)]=tempBigInt&0xff;tempBigInt = tempBigInt>>8;HEAP8[((($65)+(1))|0)]=tempBigInt&0xff;tempBigInt = tempBigInt>>8;HEAP8[((($65)+(2))|0)]=tempBigInt&0xff;tempBigInt = tempBigInt>>8;HEAP8[((($65)+(3))|0)]=tempBigInt&0xff;
 var $67=$32;
 var $68=HEAP32[(($67)>>2)];
 var $69=(($68+28)|0);
 var $70=HEAP32[(($69)>>2)];
 FUNCTION_TABLE[$70]($4,$36);
 var $71=$__sn;
 var $72=HEAP8[($71)];
 var $73=$72&1;
 var $74=(($73<<24)>>24)==0;
 if($74){label=16;break;}else{label=15;break;}
 case 15: 
 var $76=(($__sn+8)|0);
 var $77=HEAP32[(($76)>>2)];
 HEAP8[($77)]=0;
 var $78=(($__sn+4)|0);
 HEAP32[(($78)>>2)]=0;
 label=17;break;
 case 16: 
 var $80=$__sn;
 var $81=(($80+1)|0);
 HEAP8[($81)]=0;
 HEAP8[($71)]=0;
 label=17;break;
 case 17: 
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7reserveEj($__sn,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=19;break; } else { label=18;break; }
 case 18: 
 var $83$0 = ___cxa_find_matching_catch(-1, -1,0); var $83$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
 case 19: 
 var $84=$4;
 assert(12 % 1 === 0);HEAP32[(($71)>>2)]=HEAP32[(($84)>>2)];HEAP32[((($71)+(4))>>2)]=HEAP32[((($84)+(4))>>2)];HEAP32[((($71)+(8))>>2)]=HEAP32[((($84)+(8))>>2)];
 HEAP32[(($84)>>2)]=0; HEAP32[((($84)+(4))>>2)]=0; HEAP32[((($84)+(8))>>2)]=0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($4);
 label=20;break;
 case 20: 
 var $86=$32;
 var $87=HEAP32[(($86)>>2)];
 var $88=(($87+12)|0);
 var $89=HEAP32[(($88)>>2)];
 var $90=FUNCTION_TABLE[$89]($36);
 HEAP8[($__dp)]=$90;
 var $91=HEAP32[(($86)>>2)];
 var $92=(($91+16)|0);
 var $93=HEAP32[(($92)>>2)];
 var $94=FUNCTION_TABLE[$93]($36);
 HEAP8[($__ts)]=$94;
 var $95=$32;
 var $96=HEAP32[(($95)>>2)];
 var $97=(($96+20)|0);
 var $98=HEAP32[(($97)>>2)];
 FUNCTION_TABLE[$98]($5,$36);
 var $99=$__grp;
 var $100=HEAP8[($99)];
 var $101=$100&1;
 var $102=(($101<<24)>>24)==0;
 if($102){label=22;break;}else{label=21;break;}
 case 21: 
 var $104=(($__grp+8)|0);
 var $105=HEAP32[(($104)>>2)];
 HEAP8[($105)]=0;
 var $106=(($__grp+4)|0);
 HEAP32[(($106)>>2)]=0;
 label=23;break;
 case 22: 
 var $108=$__grp;
 var $109=(($108+1)|0);
 HEAP8[($109)]=0;
 HEAP8[($99)]=0;
 label=23;break;
 case 23: 
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7reserveEj($__grp,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=25;break; } else { label=24;break; }
 case 24: 
 var $111$0 = ___cxa_find_matching_catch(-1, -1,0); var $111$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
 case 25: 
 var $112=$5;
 assert(12 % 1 === 0);HEAP32[(($99)>>2)]=HEAP32[(($112)>>2)];HEAP32[((($99)+(4))>>2)]=HEAP32[((($112)+(4))>>2)];HEAP32[((($99)+(8))>>2)]=HEAP32[((($112)+(8))>>2)];
 HEAP32[(($112)>>2)]=0; HEAP32[((($112)+(4))>>2)]=0; HEAP32[((($112)+(8))>>2)]=0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($5);
 var $113=HEAP32[(($95)>>2)];
 var $114=(($113+24)|0);
 var $115=HEAP32[(($114)>>2)];
 FUNCTION_TABLE[$115]($6,$36);
 var $116=$__sym;
 var $117=HEAP8[($116)];
 var $118=$117&1;
 var $119=(($118<<24)>>24)==0;
 if($119){label=27;break;}else{label=26;break;}
 case 26: 
 var $121=(($__sym+8)|0);
 var $122=HEAP32[(($121)>>2)];
 HEAP8[($122)]=0;
 var $123=(($__sym+4)|0);
 HEAP32[(($123)>>2)]=0;
 label=28;break;
 case 27: 
 var $125=$__sym;
 var $126=(($125+1)|0);
 HEAP8[($126)]=0;
 HEAP8[($116)]=0;
 label=28;break;
 case 28: 
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7reserveEj($__sym,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=30;break; } else { label=29;break; }
 case 29: 
 var $128$0 = ___cxa_find_matching_catch(-1, -1,0); var $128$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
 case 30: 
 var $129=$6;
 assert(12 % 1 === 0);HEAP32[(($116)>>2)]=HEAP32[(($129)>>2)];HEAP32[((($116)+(4))>>2)]=HEAP32[((($129)+(4))>>2)];HEAP32[((($116)+(8))>>2)]=HEAP32[((($129)+(8))>>2)];
 HEAP32[(($129)>>2)]=0; HEAP32[((($129)+(4))>>2)]=0; HEAP32[((($129)+(8))>>2)]=0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($6);
 var $130=$32;
 var $131=HEAP32[(($130)>>2)];
 var $132=(($131+36)|0);
 var $133=HEAP32[(($132)>>2)];
 var $134=FUNCTION_TABLE[$133]($36);
 var $storemerge=$134;label=60;break;
 case 31: 
 var $136=$__p_i_i_i_i43;
 var $137=HEAP32[((14576)>>2)];
 var $138=($137|0)==-1;
 if($138){label=33;break;}else{label=32;break;}
 case 32: 
 var $_sroa_01_0___p67_i_idx_i_i_i44=(($__p_i_i_i_i43)|0);
 HEAP32[(($_sroa_01_0___p67_i_idx_i_i_i44)>>2)]=14576;
 var $_sroa_12_4___p67_i_idx3_i_i_i45=(($__p_i_i_i_i43+4)|0);
 HEAP32[(($_sroa_12_4___p67_i_idx3_i_i_i45)>>2)]=(28);
 var $_sroa_2_8___p67_i_idx4_i_i_i46=(($__p_i_i_i_i43+8)|0);
 HEAP32[(($_sroa_2_8___p67_i_idx4_i_i_i46)>>2)]=0;
 __ZNSt3__111__call_onceERVmPvPFvS2_E(14576,$136,260);
 label=33;break;
 case 33: 
 var $140=HEAP32[((14580)>>2)];
 var $141=((($140)-(1))|0);
 var $142=(($14+12)|0);
 var $143=HEAP32[(($142)>>2)];
 var $144=(($14+8)|0);
 var $145=HEAP32[(($144)>>2)];
 var $146=$143;
 var $147=$145;
 var $148=((($146)-($147))|0);
 var $149=$148>>2;
 var $150=($149>>>0)>($141>>>0);
 if($150){label=34;break;}else{label=35;break;}
 case 34: 
 var $151=(($145+($141<<2))|0);
 var $152=HEAP32[(($151)>>2)];
 var $153=($152|0)==0;
 if($153){label=35;break;}else{label=36;break;}
 case 35: 
 var $154=___cxa_allocate_exception(4);
 var $155=$154;
 __ZNSt8bad_castC2Ev($155);
 ___cxa_throw($154,8960,(368));
 throw "Reached an unreachable!";
 case 36: 
 var $156=$152;
 var $157=$152;
 var $158=HEAP32[(($157)>>2)];
 if($__neg){label=37;break;}else{label=43;break;}
 case 37: 
 var $160=(($158+44)|0);
 var $161=HEAP32[(($160)>>2)];
 FUNCTION_TABLE[$161]($tmpcast34,$156);
 var $162=$__pat;
 var $163=HEAP32[(($7)>>2)];
 tempBigInt=$163;HEAP8[($162)]=tempBigInt&0xff;tempBigInt = tempBigInt>>8;HEAP8[((($162)+(1))|0)]=tempBigInt&0xff;tempBigInt = tempBigInt>>8;HEAP8[((($162)+(2))|0)]=tempBigInt&0xff;tempBigInt = tempBigInt>>8;HEAP8[((($162)+(3))|0)]=tempBigInt&0xff;
 var $164=$152;
 var $165=HEAP32[(($164)>>2)];
 var $166=(($165+32)|0);
 var $167=HEAP32[(($166)>>2)];
 FUNCTION_TABLE[$167]($8,$156);
 var $168=$__sn;
 var $169=HEAP8[($168)];
 var $170=$169&1;
 var $171=(($170<<24)>>24)==0;
 if($171){label=39;break;}else{label=38;break;}
 case 38: 
 var $173=(($__sn+8)|0);
 var $174=HEAP32[(($173)>>2)];
 HEAP8[($174)]=0;
 var $175=(($__sn+4)|0);
 HEAP32[(($175)>>2)]=0;
 label=40;break;
 case 39: 
 var $177=$__sn;
 var $178=(($177+1)|0);
 HEAP8[($178)]=0;
 HEAP8[($168)]=0;
 label=40;break;
 case 40: 
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7reserveEj($__sn,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=42;break; } else { label=41;break; }
 case 41: 
 var $180$0 = ___cxa_find_matching_catch(-1, -1,0); var $180$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
 case 42: 
 var $181=$8;
 assert(12 % 1 === 0);HEAP32[(($168)>>2)]=HEAP32[(($181)>>2)];HEAP32[((($168)+(4))>>2)]=HEAP32[((($181)+(4))>>2)];HEAP32[((($168)+(8))>>2)]=HEAP32[((($181)+(8))>>2)];
 HEAP32[(($181)>>2)]=0; HEAP32[((($181)+(4))>>2)]=0; HEAP32[((($181)+(8))>>2)]=0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($8);
 label=49;break;
 case 43: 
 var $183=(($158+40)|0);
 var $184=HEAP32[(($183)>>2)];
 FUNCTION_TABLE[$184]($tmpcast,$156);
 var $185=$__pat;
 var $186=HEAP32[(($9)>>2)];
 tempBigInt=$186;HEAP8[($185)]=tempBigInt&0xff;tempBigInt = tempBigInt>>8;HEAP8[((($185)+(1))|0)]=tempBigInt&0xff;tempBigInt = tempBigInt>>8;HEAP8[((($185)+(2))|0)]=tempBigInt&0xff;tempBigInt = tempBigInt>>8;HEAP8[((($185)+(3))|0)]=tempBigInt&0xff;
 var $187=$152;
 var $188=HEAP32[(($187)>>2)];
 var $189=(($188+28)|0);
 var $190=HEAP32[(($189)>>2)];
 FUNCTION_TABLE[$190]($10,$156);
 var $191=$__sn;
 var $192=HEAP8[($191)];
 var $193=$192&1;
 var $194=(($193<<24)>>24)==0;
 if($194){label=45;break;}else{label=44;break;}
 case 44: 
 var $196=(($__sn+8)|0);
 var $197=HEAP32[(($196)>>2)];
 HEAP8[($197)]=0;
 var $198=(($__sn+4)|0);
 HEAP32[(($198)>>2)]=0;
 label=46;break;
 case 45: 
 var $200=$__sn;
 var $201=(($200+1)|0);
 HEAP8[($201)]=0;
 HEAP8[($191)]=0;
 label=46;break;
 case 46: 
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7reserveEj($__sn,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=48;break; } else { label=47;break; }
 case 47: 
 var $203$0 = ___cxa_find_matching_catch(-1, -1,0); var $203$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
 case 48: 
 var $204=$10;
 assert(12 % 1 === 0);HEAP32[(($191)>>2)]=HEAP32[(($204)>>2)];HEAP32[((($191)+(4))>>2)]=HEAP32[((($204)+(4))>>2)];HEAP32[((($191)+(8))>>2)]=HEAP32[((($204)+(8))>>2)];
 HEAP32[(($204)>>2)]=0; HEAP32[((($204)+(4))>>2)]=0; HEAP32[((($204)+(8))>>2)]=0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($10);
 label=49;break;
 case 49: 
 var $206=$152;
 var $207=HEAP32[(($206)>>2)];
 var $208=(($207+12)|0);
 var $209=HEAP32[(($208)>>2)];
 var $210=FUNCTION_TABLE[$209]($156);
 HEAP8[($__dp)]=$210;
 var $211=HEAP32[(($206)>>2)];
 var $212=(($211+16)|0);
 var $213=HEAP32[(($212)>>2)];
 var $214=FUNCTION_TABLE[$213]($156);
 HEAP8[($__ts)]=$214;
 var $215=$152;
 var $216=HEAP32[(($215)>>2)];
 var $217=(($216+20)|0);
 var $218=HEAP32[(($217)>>2)];
 FUNCTION_TABLE[$218]($11,$156);
 var $219=$__grp;
 var $220=HEAP8[($219)];
 var $221=$220&1;
 var $222=(($221<<24)>>24)==0;
 if($222){label=51;break;}else{label=50;break;}
 case 50: 
 var $224=(($__grp+8)|0);
 var $225=HEAP32[(($224)>>2)];
 HEAP8[($225)]=0;
 var $226=(($__grp+4)|0);
 HEAP32[(($226)>>2)]=0;
 label=52;break;
 case 51: 
 var $228=$__grp;
 var $229=(($228+1)|0);
 HEAP8[($229)]=0;
 HEAP8[($219)]=0;
 label=52;break;
 case 52: 
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7reserveEj($__grp,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=54;break; } else { label=53;break; }
 case 53: 
 var $231$0 = ___cxa_find_matching_catch(-1, -1,0); var $231$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
 case 54: 
 var $232=$11;
 assert(12 % 1 === 0);HEAP32[(($219)>>2)]=HEAP32[(($232)>>2)];HEAP32[((($219)+(4))>>2)]=HEAP32[((($232)+(4))>>2)];HEAP32[((($219)+(8))>>2)]=HEAP32[((($232)+(8))>>2)];
 HEAP32[(($232)>>2)]=0; HEAP32[((($232)+(4))>>2)]=0; HEAP32[((($232)+(8))>>2)]=0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($11);
 var $233=HEAP32[(($215)>>2)];
 var $234=(($233+24)|0);
 var $235=HEAP32[(($234)>>2)];
 FUNCTION_TABLE[$235]($12,$156);
 var $236=$__sym;
 var $237=HEAP8[($236)];
 var $238=$237&1;
 var $239=(($238<<24)>>24)==0;
 if($239){label=56;break;}else{label=55;break;}
 case 55: 
 var $241=(($__sym+8)|0);
 var $242=HEAP32[(($241)>>2)];
 HEAP8[($242)]=0;
 var $243=(($__sym+4)|0);
 HEAP32[(($243)>>2)]=0;
 label=57;break;
 case 56: 
 var $245=$__sym;
 var $246=(($245+1)|0);
 HEAP8[($246)]=0;
 HEAP8[($236)]=0;
 label=57;break;
 case 57: 
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7reserveEj($__sym,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=59;break; } else { label=58;break; }
 case 58: 
 var $248$0 = ___cxa_find_matching_catch(-1, -1,0); var $248$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
 case 59: 
 var $249=$12;
 assert(12 % 1 === 0);HEAP32[(($236)>>2)]=HEAP32[(($249)>>2)];HEAP32[((($236)+(4))>>2)]=HEAP32[((($249)+(4))>>2)];HEAP32[((($236)+(8))>>2)]=HEAP32[((($249)+(8))>>2)];
 HEAP32[(($249)>>2)]=0; HEAP32[((($249)+(4))>>2)]=0; HEAP32[((($249)+(8))>>2)]=0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($12);
 var $250=$152;
 var $251=HEAP32[(($250)>>2)];
 var $252=(($251+36)|0);
 var $253=HEAP32[(($252)>>2)];
 var $254=FUNCTION_TABLE[$253]($156);
 var $storemerge=$254;label=60;break;
 case 60: 
 var $storemerge;
 HEAP32[(($__fd)>>2)]=$storemerge;
 STACKTOP=sp;return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__111__money_putIcE8__formatEPcRS2_S3_jPKcS5_RKNS_5ctypeIcEEbRKNS_10money_base7patternEccRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEESL_SL_i($__mb,$__mi,$__me,$__flags,$__db,$__de,$__ct,$__neg,$__pat,$__dp,$__ts,$__grp,$__sym,$__sn,$__fd){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 HEAP32[(($__me)>>2)]=$__mb;
 var $1=$__ct;
 var $2=$__sn;
 var $3=$__sn;
 var $4=(($3+1)|0);
 var $5=(($__sn+8)|0);
 var $6=(($__sn+4)|0);
 var $7=$__sym;
 var $8=$__flags&512;
 var $9=($8|0)==0;
 var $10=$__sym;
 var $11=(($10+1)|0);
 var $12=(($__sym+8)|0);
 var $13=(($__sym+4)|0);
 var $14=(($__ct+8)|0);
 var $15=($__fd|0)>0;
 var $16=$__grp;
 var $17=$__grp;
 var $18=(($17+1)|0);
 var $19=(($__grp+8)|0);
 var $20=(($__grp+4)|0);
 var $21=(((-$__fd))|0);
 var $__p_0118=0;var $_0119=$__db;label=2;break;
 case 2: 
 var $_0119;
 var $__p_0118;
 var $23=(($__pat+$__p_0118)|0);
 var $24=HEAP8[($23)];
 var $25=(($24<<24)>>24);
 switch(($25|0)){case 2:{ label=12;break;}case 4:{ label=22;break;}case 0:{ label=3;break;}case 1:{ label=4;break;}case 3:{ label=5;break;}default:{var $_2=$_0119;label=60;break;}}break;
 case 3: 
 var $27=HEAP32[(($__me)>>2)];
 HEAP32[(($__mi)>>2)]=$27;
 var $_2=$_0119;label=60;break;
 case 4: 
 var $29=HEAP32[(($__me)>>2)];
 HEAP32[(($__mi)>>2)]=$29;
 var $30=HEAP32[(($1)>>2)];
 var $31=(($30+28)|0);
 var $32=HEAP32[(($31)>>2)];
 var $33=FUNCTION_TABLE[$32]($__ct,32);
 var $34=HEAP32[(($__me)>>2)];
 var $35=(($34+1)|0);
 HEAP32[(($__me)>>2)]=$35;
 HEAP8[($34)]=$33;
 var $_2=$_0119;label=60;break;
 case 5: 
 var $37=HEAP8[($2)];
 var $38=$37&1;
 var $39=(($38<<24)>>24)==0;
 if($39){label=7;break;}else{label=6;break;}
 case 6: 
 var $41=HEAP32[(($6)>>2)];
 var $45=$41;label=8;break;
 case 7: 
 var $43=($37&255);
 var $44=$43>>>1;
 var $45=$44;label=8;break;
 case 8: 
 var $45;
 var $46=($45|0)==0;
 if($46){var $_2=$_0119;label=60;break;}else{label=9;break;}
 case 9: 
 if($39){var $50=$4;label=11;break;}else{label=10;break;}
 case 10: 
 var $49=HEAP32[(($5)>>2)];
 var $50=$49;label=11;break;
 case 11: 
 var $50;
 var $51=HEAP8[($50)];
 var $52=HEAP32[(($__me)>>2)];
 var $53=(($52+1)|0);
 HEAP32[(($__me)>>2)]=$53;
 HEAP8[($52)]=$51;
 var $_2=$_0119;label=60;break;
 case 12: 
 var $55=HEAP8[($7)];
 var $56=$55&1;
 var $57=(($56<<24)>>24)==0;
 if($57){label=14;break;}else{label=13;break;}
 case 13: 
 var $59=HEAP32[(($13)>>2)];
 var $63=$59;label=15;break;
 case 14: 
 var $61=($55&255);
 var $62=$61>>>1;
 var $63=$62;label=15;break;
 case 15: 
 var $63;
 var $64=($63|0)==0;
 var $brmerge=$64|$9;
 if($brmerge){var $_2=$_0119;label=60;break;}else{label=16;break;}
 case 16: 
 if($57){label=18;break;}else{label=17;break;}
 case 17: 
 var $67=HEAP32[(($12)>>2)];
 var $68=HEAP32[(($13)>>2)];
 var $74=$68;var $73=$67;var $72=$67;label=19;break;
 case 18: 
 var $70=($55&255);
 var $71=$70>>>1;
 var $74=$71;var $73=$11;var $72=$11;label=19;break;
 case 19: 
 var $72;
 var $73;
 var $74;
 var $75=(($73+$74)|0);
 var $76=HEAP32[(($__me)>>2)];
 var $77=($72|0)==($75|0);
 if($77){var $_0_lcssa_i_i89=$76;label=21;break;}else{var $_03_i_i87=$76;var $78=$72;label=20;break;}
 case 20: 
 var $78;
 var $_03_i_i87;
 var $79=HEAP8[($78)];
 HEAP8[($_03_i_i87)]=$79;
 var $80=(($78+1)|0);
 var $81=(($_03_i_i87+1)|0);
 var $82=($80|0)==($75|0);
 if($82){var $_0_lcssa_i_i89=$81;label=21;break;}else{var $_03_i_i87=$81;var $78=$80;label=20;break;}
 case 21: 
 var $_0_lcssa_i_i89;
 HEAP32[(($__me)>>2)]=$_0_lcssa_i_i89;
 var $_2=$_0119;label=60;break;
 case 22: 
 var $84=HEAP32[(($__me)>>2)];
 var $85=(($_0119+1)|0);
 var $__0=($__neg?$85:$_0119);
 var $__d_0=$__0;label=23;break;
 case 23: 
 var $__d_0;
 var $87=($__d_0>>>0)<($__de>>>0);
 if($87){label=24;break;}else{label=26;break;}
 case 24: 
 var $89=HEAP8[($__d_0)];
 var $90=(($89<<24)>>24)<0;
 if($90){label=26;break;}else{label=25;break;}
 case 25: 
 var $91=(($89<<24)>>24);
 var $92=HEAP32[(($14)>>2)];
 var $93=(($92+($91<<1))|0);
 var $94=HEAP16[(($93)>>1)];
 var $95=$94&2048;
 var $96=(($95<<16)>>16)==0;
 var $97=(($__d_0+1)|0);
 if($96){label=26;break;}else{var $__d_0=$97;label=23;break;}
 case 26: 
 var $__d_0_lcssa125=$__d_0;
 if($15){label=27;break;}else{var $__d_2=$__d_0;label=36;break;}
 case 27: 
 var $98=($__d_0>>>0)>($__0>>>0);
 if($98){label=28;break;}else{var $__f_0_lcssa139=$__fd;var $__d_1_lcssa141=$__d_0;label=32;break;}
 case 28: 
 var $99=(((-$__d_0_lcssa125))|0);
 var $scevgep=(($__0+$99)|0);
 var $scevgep126=$scevgep;
 var $100=($scevgep126>>>0)<($21>>>0);
 var $umax=($100?$21:$scevgep126);
 var $umax127=$umax;
 var $scevgep128=(($umax127+$__fd)|0);
 var $scevgep128129=$scevgep128;
 var $__d_1103=$__d_0;var $__f_0104=$__fd;var $102=$84;label=29;break;
 case 29: 
 var $102;
 var $__f_0104;
 var $__d_1103;
 var $103=((($__d_1103)-(1))|0);
 var $104=HEAP8[($103)];
 var $105=(($102+1)|0);
 HEAP32[(($__me)>>2)]=$105;
 HEAP8[($102)]=$104;
 var $106=((($__f_0104)-(1))|0);
 var $107=($103>>>0)>($__0>>>0);
 var $108=($106|0)>0;
 var $or_cond=$107&$108;
 if($or_cond){label=30;break;}else{label=31;break;}
 case 30: 
 var $_pre=HEAP32[(($__me)>>2)];
 var $__d_1103=$103;var $__f_0104=$106;var $102=$_pre;label=29;break;
 case 31: 
 var $scevgep130=(($__d_0+$umax)|0);
 if($108){var $__f_0_lcssa139=$scevgep128129;var $__d_1_lcssa141=$scevgep130;label=32;break;}else{var $113=0;var $__f_0_lcssa138=$scevgep128129;var $__d_1_lcssa140=$scevgep130;label=33;break;}
 case 32: 
 var $__d_1_lcssa141;
 var $__f_0_lcssa139;
 var $109=HEAP32[(($1)>>2)];
 var $110=(($109+28)|0);
 var $111=HEAP32[(($110)>>2)];
 var $112=FUNCTION_TABLE[$111]($__ct,48);
 var $113=$112;var $__f_0_lcssa138=$__f_0_lcssa139;var $__d_1_lcssa140=$__d_1_lcssa141;label=33;break;
 case 33: 
 var $__d_1_lcssa140;
 var $__f_0_lcssa138;
 var $113;
 var $114=($__f_0_lcssa138|0)>0;
 var $115=HEAP32[(($__me)>>2)];
 var $116=(($115+1)|0);
 HEAP32[(($__me)>>2)]=$116;
 if($114){var $__f_1108=$__f_0_lcssa138;var $117=$115;label=34;break;}else{var $_lcssa107=$115;label=35;break;}
 case 34: 
 var $117;
 var $__f_1108;
 HEAP8[($117)]=$113;
 var $118=((($__f_1108)-(1))|0);
 var $119=($118|0)>0;
 var $120=HEAP32[(($__me)>>2)];
 var $121=(($120+1)|0);
 HEAP32[(($__me)>>2)]=$121;
 if($119){var $__f_1108=$118;var $117=$120;label=34;break;}else{var $_lcssa107=$120;label=35;break;}
 case 35: 
 var $_lcssa107;
 HEAP8[($_lcssa107)]=$__dp;
 var $__d_2=$__d_1_lcssa140;label=36;break;
 case 36: 
 var $__d_2;
 var $123=($__d_2|0)==($__0|0);
 if($123){label=37;break;}else{label=38;break;}
 case 37: 
 var $125=HEAP32[(($1)>>2)];
 var $126=(($125+28)|0);
 var $127=HEAP32[(($126)>>2)];
 var $128=FUNCTION_TABLE[$127]($__ct,48);
 var $129=HEAP32[(($__me)>>2)];
 var $130=(($129+1)|0);
 HEAP32[(($__me)>>2)]=$130;
 HEAP8[($129)]=$128;
 label=57;break;
 case 38: 
 var $132=HEAP8[($16)];
 var $133=$132&1;
 var $134=(($133<<24)>>24)==0;
 if($134){label=40;break;}else{label=39;break;}
 case 39: 
 var $136=HEAP32[(($20)>>2)];
 var $140=$136;label=41;break;
 case 40: 
 var $138=($132&255);
 var $139=$138>>>1;
 var $140=$139;label=41;break;
 case 41: 
 var $140;
 var $141=($140|0)==0;
 if($141){var $__d_3112=$__d_2;var $__ng_0113=0;var $__ig_0114=0;var $__gl_0115=-1;label=45;break;}else{label=42;break;}
 case 42: 
 if($134){var $145=$18;label=44;break;}else{label=43;break;}
 case 43: 
 var $144=HEAP32[(($19)>>2)];
 var $145=$144;label=44;break;
 case 44: 
 var $145;
 var $146=HEAP8[($145)];
 var $147=(($146<<24)>>24);
 var $__d_3112=$__d_2;var $__ng_0113=0;var $__ig_0114=0;var $__gl_0115=$147;label=45;break;
 case 45: 
 var $__gl_0115;
 var $__ig_0114;
 var $__ng_0113;
 var $__d_3112;
 var $148=($__ng_0113|0)==($__gl_0115|0);
 if($148){label=46;break;}else{var $__gl_1=$__gl_0115;var $__ig_1=$__ig_0114;var $__ng_1=$__ng_0113;label=56;break;}
 case 46: 
 var $150=HEAP32[(($__me)>>2)];
 var $151=(($150+1)|0);
 HEAP32[(($__me)>>2)]=$151;
 HEAP8[($150)]=$__ts;
 var $152=((($__ig_0114)+(1))|0);
 var $153=HEAP8[($16)];
 var $154=$153&1;
 var $155=(($154<<24)>>24)==0;
 if($155){label=48;break;}else{label=47;break;}
 case 47: 
 var $157=HEAP32[(($20)>>2)];
 var $161=$157;label=49;break;
 case 48: 
 var $159=($153&255);
 var $160=$159>>>1;
 var $161=$160;label=49;break;
 case 49: 
 var $161;
 var $162=($152>>>0)<($161>>>0);
 if($162){label=50;break;}else{var $__gl_1=$__gl_0115;var $__ig_1=$152;var $__ng_1=0;label=56;break;}
 case 50: 
 if($155){var $166=$18;label=52;break;}else{label=51;break;}
 case 51: 
 var $165=HEAP32[(($19)>>2)];
 var $166=$165;label=52;break;
 case 52: 
 var $166;
 var $167=(($166+$152)|0);
 var $168=HEAP8[($167)];
 var $169=(($168<<24)>>24)==127;
 if($169){var $__gl_1=-1;var $__ig_1=$152;var $__ng_1=0;label=56;break;}else{label=53;break;}
 case 53: 
 if($155){var $173=$18;label=55;break;}else{label=54;break;}
 case 54: 
 var $172=HEAP32[(($19)>>2)];
 var $173=$172;label=55;break;
 case 55: 
 var $173;
 var $174=(($173+$152)|0);
 var $175=HEAP8[($174)];
 var $176=(($175<<24)>>24);
 var $__gl_1=$176;var $__ig_1=$152;var $__ng_1=0;label=56;break;
 case 56: 
 var $__ng_1;
 var $__ig_1;
 var $__gl_1;
 var $177=((($__d_3112)-(1))|0);
 var $178=HEAP8[($177)];
 var $179=HEAP32[(($__me)>>2)];
 var $180=(($179+1)|0);
 HEAP32[(($__me)>>2)]=$180;
 HEAP8[($179)]=$178;
 var $181=((($__ng_1)+(1))|0);
 var $182=($177|0)==($__0|0);
 if($182){label=57;break;}else{var $__d_3112=$177;var $__ng_0113=$181;var $__ig_0114=$__ig_1;var $__gl_0115=$__gl_1;label=45;break;}
 case 57: 
 var $183=HEAP32[(($__me)>>2)];
 var $184=($84|0)==($183|0);
 if($184){var $_2=$__0;label=60;break;}else{label=58;break;}
 case 58: 
 var $185=((($183)-(1))|0);
 var $186=($185>>>0)>($84>>>0);
 if($186){var $_078_i_i=$84;var $187=$185;label=59;break;}else{var $_2=$__0;label=60;break;}
 case 59: 
 var $187;
 var $_078_i_i;
 var $188=HEAP8[($_078_i_i)];
 var $189=HEAP8[($187)];
 HEAP8[($_078_i_i)]=$189;
 HEAP8[($187)]=$188;
 var $190=(($_078_i_i+1)|0);
 var $191=((($187)-(1))|0);
 var $192=($190>>>0)<($191>>>0);
 if($192){var $_078_i_i=$190;var $187=$191;label=59;break;}else{var $_2=$__0;label=60;break;}
 case 60: 
 var $_2;
 var $193=((($__p_0118)+(1))|0);
 var $194=($193>>>0)<4;
 if($194){var $__p_0118=$193;var $_0119=$_2;label=2;break;}else{label=61;break;}
 case 61: 
 var $196=HEAP8[($2)];
 var $197=$196&1;
 var $198=(($197<<24)>>24)==0;
 if($198){label=63;break;}else{label=62;break;}
 case 62: 
 var $200=HEAP32[(($6)>>2)];
 var $204=$200;label=64;break;
 case 63: 
 var $202=($196&255);
 var $203=$202>>>1;
 var $204=$203;label=64;break;
 case 64: 
 var $204;
 var $205=($204>>>0)>1;
 if($205){label=65;break;}else{label=71;break;}
 case 65: 
 if($198){label=67;break;}else{label=66;break;}
 case 66: 
 var $208=HEAP32[(($5)>>2)];
 var $209=HEAP32[(($6)>>2)];
 var $214=$209;var $213=$208;var $_pn=$208;label=68;break;
 case 67: 
 var $211=($196&255);
 var $212=$211>>>1;
 var $214=$212;var $213=$4;var $_pn=$4;label=68;break;
 case 68: 
 var $_pn;
 var $213;
 var $214;
 var $215=(($_pn+1)|0);
 var $216=(($213+$214)|0);
 var $217=HEAP32[(($__me)>>2)];
 var $218=($215|0)==($216|0);
 if($218){var $_0_lcssa_i_i=$217;label=70;break;}else{var $_03_i_i=$217;var $219=$215;label=69;break;}
 case 69: 
 var $219;
 var $_03_i_i;
 var $220=HEAP8[($219)];
 HEAP8[($_03_i_i)]=$220;
 var $221=(($219+1)|0);
 var $222=(($_03_i_i+1)|0);
 var $223=($221|0)==($216|0);
 if($223){var $_0_lcssa_i_i=$222;label=70;break;}else{var $_03_i_i=$222;var $219=$221;label=69;break;}
 case 70: 
 var $_0_lcssa_i_i;
 HEAP32[(($__me)>>2)]=$_0_lcssa_i_i;
 label=71;break;
 case 71: 
 var $225=$__flags&176;
 if(($225|0)==32){ label=72;break;}else if(($225|0)==16){ label=74;break;}else{label=73;break;}
 case 72: 
 var $227=HEAP32[(($__me)>>2)];
 HEAP32[(($__mi)>>2)]=$227;
 label=74;break;
 case 73: 
 HEAP32[(($__mi)>>2)]=$__mb;
 label=74;break;
 case 74: 
 return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__19money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_bRNS_8ios_baseEcRKNS_12basic_stringIcS3_NS_9allocatorIcEEEE($agg_result,$this,$__s,$__intl,$__iob,$__fl,$__digits){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+232)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var tempParam = $__s; $__s=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__s)>>2)]=HEAP32[((tempParam)>>2)];
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $__p_i_i_i_i=sp;
 var $__loc=(sp)+(16);
 var $__pat=(sp)+(24);
 var $__dp=(sp)+(32);
 var $__ts=(sp)+(40);
 var $__grp=(sp)+(48);
 var $__sym=(sp)+(64);
 var $__sn=(sp)+(80);
 var $__fd=(sp)+(96);
 var $__mbuf=(sp)+(104);
 var $__mi=(sp)+(208);
 var $__me=(sp)+(216);
 var $1=(sp)+(224);
 __ZNKSt3__18ios_base6getlocEv($__loc,$__iob);
 var $2=(($__loc)|0);
 var $3=HEAP32[(($2)>>2)];
 var $4=$__p_i_i_i_i;
 var $5=HEAP32[((14096)>>2)];
 var $6=($5|0)==-1;
 if($6){label=3;break;}else{label=2;break;}
 case 2: 
 var $_sroa_01_0___p67_i_idx_i_i_i=(($__p_i_i_i_i)|0);
 HEAP32[(($_sroa_01_0___p67_i_idx_i_i_i)>>2)]=14096;
 var $_sroa_12_4___p67_i_idx3_i_i_i=(($__p_i_i_i_i+4)|0);
 HEAP32[(($_sroa_12_4___p67_i_idx3_i_i_i)>>2)]=(28);
 var $_sroa_2_8___p67_i_idx4_i_i_i=(($__p_i_i_i_i+8)|0);
 HEAP32[(($_sroa_2_8___p67_i_idx4_i_i_i)>>2)]=0;
 (function() { try { __THREW__ = 0; return __ZNSt3__111__call_onceERVmPvPFvS2_E(14096,$4,260) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=3;break; } else { label=43;break; }
 case 3: 
 var $8=HEAP32[((14100)>>2)];
 var $9=((($8)-(1))|0);
 var $10=(($3+12)|0);
 var $11=HEAP32[(($10)>>2)];
 var $12=(($3+8)|0);
 var $13=HEAP32[(($12)>>2)];
 var $14=$11;
 var $15=$13;
 var $16=((($14)-($15))|0);
 var $17=$16>>2;
 var $18=($17>>>0)>($9>>>0);
 if($18){label=4;break;}else{label=5;break;}
 case 4: 
 var $19=(($13+($9<<2))|0);
 var $20=HEAP32[(($19)>>2)];
 var $21=($20|0)==0;
 if($21){label=5;break;}else{label=7;break;}
 case 5: 
 var $22=___cxa_allocate_exception(4);
 var $23=$22;
 __ZNSt8bad_castC2Ev($23);
 (function() { try { __THREW__ = 0; return ___cxa_throw($22,8960,(368)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=6;break; } else { label=43;break; }
 case 6: 
 throw "Reached an unreachable!";
 case 7: 
 var $25=$20;
 var $26=$__digits;
 var $27=HEAP8[($26)];
 var $28=$27&1;
 var $29=(($28<<24)>>24)==0;
 if($29){label=9;break;}else{label=8;break;}
 case 8: 
 var $31=(($__digits+4)|0);
 var $32=HEAP32[(($31)>>2)];
 var $36=$32;label=10;break;
 case 9: 
 var $34=($27&255);
 var $35=$34>>>1;
 var $36=$35;label=10;break;
 case 10: 
 var $36;
 var $37=($36|0)==0;
 if($37){var $54=0;label=16;break;}else{label=11;break;}
 case 11: 
 if($29){label=13;break;}else{label=12;break;}
 case 12: 
 var $40=(($__digits+8)|0);
 var $41=HEAP32[(($40)>>2)];
 var $45=$41;label=14;break;
 case 13: 
 var $43=$__digits;
 var $44=(($43+1)|0);
 var $45=$44;label=14;break;
 case 14: 
 var $45;
 var $46=HEAP8[($45)];
 var $47=$20;
 var $48=HEAP32[(($47)>>2)];
 var $49=(($48+28)|0);
 var $50=HEAP32[(($49)>>2)];
 var $51=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$50]($25,45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=15;break; } else { label=43;break; }
 case 15: 
 var $52=(($46<<24)>>24)==(($51<<24)>>24);
 var $54=$52;label=16;break;
 case 16: 
 var $54;
 var $this4_i_i_i=$__grp;
 HEAP32[(($this4_i_i_i)>>2)]=0; HEAP32[((($this4_i_i_i)+(4))>>2)]=0; HEAP32[((($this4_i_i_i)+(8))>>2)]=0;
 var $this4_i_i_i24=$__sym;
 HEAP32[(($this4_i_i_i24)>>2)]=0; HEAP32[((($this4_i_i_i24)+(4))>>2)]=0; HEAP32[((($this4_i_i_i24)+(8))>>2)]=0;
 var $this4_i_i_i25=$__sn;
 HEAP32[(($this4_i_i_i25)>>2)]=0; HEAP32[((($this4_i_i_i25)+(4))>>2)]=0; HEAP32[((($this4_i_i_i25)+(8))>>2)]=0;
 (function() { try { __THREW__ = 0; return __ZNSt3__111__money_putIcE13__gather_infoEbbRKNS_6localeERNS_10money_base7patternERcS8_RNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEESF_SF_Ri($__intl,$54,$__loc,$__pat,$__dp,$__ts,$__grp,$__sym,$__sn,$__fd) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=17;break; } else { label=44;break; }
 case 17: 
 var $56=(($__mbuf)|0);
 var $57=HEAP8[($26)];
 var $58=$57&1;
 var $59=(($58<<24)>>24)==0;
 if($59){label=19;break;}else{label=18;break;}
 case 18: 
 var $61=(($__digits+4)|0);
 var $62=HEAP32[(($61)>>2)];
 var $66=$62;label=20;break;
 case 19: 
 var $64=($57&255);
 var $65=$64>>>1;
 var $66=$65;label=20;break;
 case 20: 
 var $66;
 var $67=HEAP32[(($__fd)>>2)];
 var $68=($66|0)>($67|0);
 if($68){label=21;break;}else{label=31;break;}
 case 21: 
 if($59){label=23;break;}else{label=22;break;}
 case 22: 
 var $71=(($__digits+4)|0);
 var $72=HEAP32[(($71)>>2)];
 var $76=$72;label=24;break;
 case 23: 
 var $74=($57&255);
 var $75=$74>>>1;
 var $76=$75;label=24;break;
 case 24: 
 var $76;
 var $77=((($76)-($67))|0);
 var $78=$77<<1;
 var $79=HEAP8[($this4_i_i_i25)];
 var $80=$79&1;
 var $81=(($80<<24)>>24)==0;
 if($81){label=26;break;}else{label=25;break;}
 case 25: 
 var $83=(($__sn+4)|0);
 var $84=HEAP32[(($83)>>2)];
 var $88=$84;label=27;break;
 case 26: 
 var $86=($79&255);
 var $87=$86>>>1;
 var $88=$87;label=27;break;
 case 27: 
 var $88;
 var $89=HEAP8[($this4_i_i_i24)];
 var $90=$89&1;
 var $91=(($90<<24)>>24)==0;
 if($91){label=29;break;}else{label=28;break;}
 case 28: 
 var $93=(($__sym+4)|0);
 var $94=HEAP32[(($93)>>2)];
 var $98=$94;label=30;break;
 case 29: 
 var $96=($89&255);
 var $97=$96>>>1;
 var $98=$97;label=30;break;
 case 30: 
 var $98;
 var $99=$78|1;
 var $100=((($88)+($99))|0);
 var $101=((($100)+($98))|0);
 var $_pn=$101;label=38;break;
 case 31: 
 var $103=HEAP8[($this4_i_i_i25)];
 var $104=$103&1;
 var $105=(($104<<24)>>24)==0;
 if($105){label=33;break;}else{label=32;break;}
 case 32: 
 var $107=(($__sn+4)|0);
 var $108=HEAP32[(($107)>>2)];
 var $112=$108;label=34;break;
 case 33: 
 var $110=($103&255);
 var $111=$110>>>1;
 var $112=$111;label=34;break;
 case 34: 
 var $112;
 var $113=HEAP8[($this4_i_i_i24)];
 var $114=$113&1;
 var $115=(($114<<24)>>24)==0;
 if($115){label=36;break;}else{label=35;break;}
 case 35: 
 var $117=(($__sym+4)|0);
 var $118=HEAP32[(($117)>>2)];
 var $122=$118;label=37;break;
 case 36: 
 var $120=($113&255);
 var $121=$120>>>1;
 var $122=$121;label=37;break;
 case 37: 
 var $122;
 var $123=((($112)+(2))|0);
 var $124=((($123)+($122))|0);
 var $_pn=$124;label=38;break;
 case 38: 
 var $_pn;
 var $126=((($_pn)+($67))|0);
 var $127=($126>>>0)>100;
 if($127){label=39;break;}else{var $__mb_0=$56;var $150=0;var $149=$57;label=47;break;}
 case 39: 
 var $128=_malloc($126);
 var $129=($128|0)==0;
 if($129){label=40;break;}else{var $__mb_0=$128;var $150=$128;var $149=$57;label=47;break;}
 case 40: 
 (function() { try { __THREW__ = 0; return __ZSt17__throw_bad_allocv() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=41;break; } else { label=42;break; }
 case 41: 
 var $_pre=HEAP8[($26)];
 var $__mb_0=0;var $150=0;var $149=$_pre;label=47;break;
 case 42: 
 var $131$0 = ___cxa_find_matching_catch(-1, -1); var $131$1 = tempRet0;
 var $132=$131$0;
 var $133=$131$1;
 var $_0=$132;var $_020=$133;label=55;break;
 case 43: 
 var $135$0 = ___cxa_find_matching_catch(-1, -1); var $135$1 = tempRet0;
 var $136=$135$0;
 var $137=$135$1;
 var $_1=$136;var $_121=$137;label=56;break;
 case 44: 
 var $139$0 = ___cxa_find_matching_catch(-1, -1); var $139$1 = tempRet0;
 var $140=$139$0;
 var $141=$139$1;
 var $_0=$140;var $_020=$141;label=55;break;
 case 45: 
 var $143$0 = ___cxa_find_matching_catch(-1, -1); var $143$1 = tempRet0;
 var $144=$143$0;
 var $145=$143$1;
 var $146=($150|0)==0;
 if($146){var $_0=$144;var $_020=$145;label=55;break;}else{label=46;break;}
 case 46: 
 _free($150);
 var $_0=$144;var $_020=$145;label=55;break;
 case 47: 
 var $149;
 var $150;
 var $__mb_0;
 var $151=(($__iob+4)|0);
 var $152=HEAP32[(($151)>>2)];
 var $153=$149&1;
 var $154=(($153<<24)>>24)==0;
 if($154){label=49;break;}else{label=48;break;}
 case 48: 
 var $156=(($__digits+8)|0);
 var $157=HEAP32[(($156)>>2)];
 var $158=(($__digits+4)|0);
 var $159=HEAP32[(($158)>>2)];
 var $166=$159;var $165=$157;label=50;break;
 case 49: 
 var $161=$__digits;
 var $162=(($161+1)|0);
 var $163=($149&255);
 var $164=$163>>>1;
 var $166=$164;var $165=$162;label=50;break;
 case 50: 
 var $165;
 var $166;
 var $167=(($165+$166)|0);
 var $168=HEAP8[($__dp)];
 var $169=HEAP8[($__ts)];
 (function() { try { __THREW__ = 0; return __ZNSt3__111__money_putIcE8__formatEPcRS2_S3_jPKcS5_RKNS_5ctypeIcEEbRKNS_10money_base7patternEccRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEESL_SL_i($__mb_0,$__mi,$__me,$152,$165,$167,$25,$54,$__pat,$168,$169,$__grp,$__sym,$__sn,$67) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=51;break; } else { label=45;break; }
 case 51: 
 var $171=(($__s)|0);
 var $172=HEAP32[(($171)>>2)];
 var $173=(($1)|0);
 HEAP32[(($173)>>2)]=$172;
 var $174=HEAP32[(($__mi)>>2)];
 var $175=HEAP32[(($__me)>>2)];
 (function() { try { __THREW__ = 0; return __ZNSt3__116__pad_and_outputIcNS_11char_traitsIcEEEENS_19ostreambuf_iteratorIT_T0_EES6_PKS4_S8_S8_RNS_8ios_baseES4_($agg_result,$1,$__mb_0,$174,$175,$__iob,$__fl) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=52;break; } else { label=45;break; }
 case 52: 
 var $177=($150|0)==0;
 if($177){label=54;break;}else{label=53;break;}
 case 53: 
 _free($150);
 label=54;break;
 case 54: 
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__sn);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__sym);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grp);
 var $179=HEAP32[(($2)>>2)];
 var $180=(($179)|0);
 var $181=__ZNSt3__114__shared_count16__release_sharedEv($180);
 STACKTOP=sp;return;
 case 55: 
 var $_020;
 var $_0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__sn);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__sym);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grp);
 var $_1=$_0;var $_121=$_020;label=56;break;
 case 56: 
 var $_121;
 var $_1;
 var $183=HEAP32[(($2)>>2)];
 var $184=(($183)|0);
 var $185=__ZNSt3__114__shared_count16__release_sharedEv($184);
 var $186$0=$_1;
 var $186$1=0;
 var $187$0=$186$0;
 var $187$1=$_121;
 ___resumeException($187$0)
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__19money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEED0Ev($this){
 var label=0;


 var $1=(($this)|0);
 __ZNSt3__114__shared_countD2Ev($1);
 var $2=$this;
 __ZdlPv($2);
 return;
}


function __ZNSt3__19money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEED1Ev($this){
 var label=0;


 var $1=(($this)|0);
 __ZNSt3__114__shared_countD2Ev($1);
 return;
}


function __ZNKSt3__19money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_bRNS_8ios_baseEwe($agg_result,$this,$__s,$__intl,$__iob,$__fl,$__units){
 var label=0;
 var tempVarArgs=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+1040)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var tempParam = $__s; $__s=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__s)>>2)]=HEAP32[((tempParam)>>2)];
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $__p_i_i_i_i=sp;
 var $__buf=(sp)+(16);
 var $__bb=(sp)+(120);
 var $__digits=(sp)+(128);
 var $__loc=(sp)+(528);
 var $__pat=(sp)+(536);
 var $__dp=(sp)+(544);
 var $__ts=(sp)+(552);
 var $__grp=(sp)+(560);
 var $__sym=(sp)+(576);
 var $__sn=(sp)+(592);
 var $__fd=(sp)+(608);
 var $__mbuf=(sp)+(616);
 var $__mi=(sp)+(1016);
 var $__me=(sp)+(1024);
 var $1=(sp)+(1032);
 var $2=(($__buf)|0);
 HEAP32[(($__bb)>>2)]=$2;
 var $3=(($__digits)|0);
 var $4=_snprintf($2,100,1528,(tempVarArgs=STACKTOP,STACKTOP = (STACKTOP + 8)|0,(assert((STACKTOP|0) < (STACK_MAX|0))|0),HEAPF64[((tempVarArgs)>>3)]=$__units,tempVarArgs)); STACKTOP=tempVarArgs;
 var $5=($4>>>0)>99;
 if($5){label=2;break;}else{var $__db_0=$3;var $__n_0=$4;var $40=0;var $39=0;label=15;break;}
 case 2: 
 var $7=HEAP8[(14656)];
 var $8=(($7<<24)>>24)==0;
 if($8){label=3;break;}else{label=7;break;}
 case 3: 
 var $10=___cxa_guard_acquire(14656);
 var $11=($10|0)==0;
 if($11){label=7;break;}else{label=4;break;}
 case 4: 
 var $13=(function() { try { __THREW__ = 0; return _newlocale(2147483647,1496,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=5;break; } else { label=6;break; }
 case 5: 
 HEAP32[((12664)>>2)]=$13;

 label=7;break;
 case 6: 
 var $16$0 = ___cxa_find_matching_catch(-1, -1); var $16$1 = tempRet0;

 var $eh_lpad_body$1=$16$1;var $eh_lpad_body$0=$16$0;var $29=0;var $28=0;label=12;break;
 case 7: 
 var $18=HEAP32[((12664)>>2)];
 var $19=(function() { try { __THREW__ = 0; return __ZNSt3__112__asprintf_lEPPcP15__locale_structPKcz($__bb,$18,1528,(tempVarArgs=STACKTOP,STACKTOP = (STACKTOP + 8)|0,(assert((STACKTOP|0) < (STACK_MAX|0))|0),HEAPF64[((tempVarArgs)>>3)]=$__units,tempVarArgs)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })(); STACKTOP=tempVarArgs;if (!__THREW__) { label=8;break; } else { var $26=0;var $25=0;label=11;break; }
 case 8: 
 var $21=HEAP32[(($__bb)>>2)];
 var $22=($21|0)==0;
 if($22){label=9;break;}else{var $32=$21;label=13;break;}
 case 9: 
 (function() { try { __THREW__ = 0; return __ZSt17__throw_bad_allocv() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=10;break; } else { var $26=0;var $25=0;label=11;break; }
 case 10: 
 var $_pre=HEAP32[(($__bb)>>2)];
 var $32=$_pre;label=13;break;
 case 11: 
 var $25;
 var $26;
 var $27$0 = ___cxa_find_matching_catch(-1, -1); var $27$1 = tempRet0;
 var $eh_lpad_body$1=$27$1;var $eh_lpad_body$0=$27$0;var $29=$26;var $28=$25;label=12;break;
 case 12: 
 var $28;
 var $29;
 var $eh_lpad_body$0;
 var $eh_lpad_body$1;
 var $30=$eh_lpad_body$0;
 var $31=$eh_lpad_body$1;
 var $_2=$30;var $_225=$31;var $190=$29;var $189=$28;label=60;break;
 case 13: 
 var $32;
 var $33=$19<<2;
 var $34=_malloc($33);
 var $35=$34;
 var $36=($34|0)==0;
 if($36){label=14;break;}else{var $__db_0=$35;var $__n_0=$19;var $40=$35;var $39=$32;label=15;break;}
 case 14: 
 (function() { try { __THREW__ = 0; return __ZSt17__throw_bad_allocv() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $__db_0=0;var $__n_0=$19;var $40=0;var $39=$32;label=15;break; } else { var $26=0;var $25=$32;label=11;break; }
 case 15: 
 var $39;
 var $40;
 var $__n_0;
 var $__db_0;
 (function() { try { __THREW__ = 0; return __ZNKSt3__18ios_base6getlocEv($__loc,$__iob) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=16;break; } else { var $26=$40;var $25=$39;label=11;break; }
 case 16: 
 var $42=(($__loc)|0);
 var $43=HEAP32[(($42)>>2)];
 var $44=$__p_i_i_i_i;
 var $45=HEAP32[((14088)>>2)];
 var $46=($45|0)==-1;
 if($46){label=18;break;}else{label=17;break;}
 case 17: 
 var $_sroa_01_0___p67_i_idx_i_i_i=(($__p_i_i_i_i)|0);
 HEAP32[(($_sroa_01_0___p67_i_idx_i_i_i)>>2)]=14088;
 var $_sroa_12_4___p67_i_idx3_i_i_i=(($__p_i_i_i_i+4)|0);
 HEAP32[(($_sroa_12_4___p67_i_idx3_i_i_i)>>2)]=(28);
 var $_sroa_2_8___p67_i_idx4_i_i_i=(($__p_i_i_i_i+8)|0);
 HEAP32[(($_sroa_2_8___p67_i_idx4_i_i_i)>>2)]=0;
 (function() { try { __THREW__ = 0; return __ZNSt3__111__call_onceERVmPvPFvS2_E(14088,$44,260) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=18;break; } else { label=45;break; }
 case 18: 
 var $48=HEAP32[((14092)>>2)];
 var $49=((($48)-(1))|0);
 var $50=(($43+12)|0);
 var $51=HEAP32[(($50)>>2)];
 var $52=(($43+8)|0);
 var $53=HEAP32[(($52)>>2)];
 var $54=$51;
 var $55=$53;
 var $56=((($54)-($55))|0);
 var $57=$56>>2;
 var $58=($57>>>0)>($49>>>0);
 if($58){label=19;break;}else{label=20;break;}
 case 19: 
 var $59=(($53+($49<<2))|0);
 var $60=HEAP32[(($59)>>2)];
 var $61=($60|0)==0;
 if($61){label=20;break;}else{label=22;break;}
 case 20: 
 var $62=___cxa_allocate_exception(4);
 var $63=$62;
 __ZNSt8bad_castC2Ev($63);
 (function() { try { __THREW__ = 0; return ___cxa_throw($62,8960,(368)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=21;break; } else { label=45;break; }
 case 21: 
 throw "Reached an unreachable!";
 case 22: 
 var $65=$60;
 var $66=HEAP32[(($__bb)>>2)];
 var $67=(($66+$__n_0)|0);
 var $68=$60;
 var $69=HEAP32[(($68)>>2)];
 var $70=(($69+48)|0);
 var $71=HEAP32[(($70)>>2)];
 var $72=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$71]($65,$66,$67,$__db_0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=23;break; } else { label=45;break; }
 case 23: 
 var $73=($__n_0|0)==0;
 if($73){var $79=0;label=25;break;}else{label=24;break;}
 case 24: 
 var $75=HEAP32[(($__bb)>>2)];
 var $76=HEAP8[($75)];
 var $77=(($76<<24)>>24)==45;
 var $79=$77;label=25;break;
 case 25: 
 var $79;
 var $this4_i_i_i=$__grp;
 HEAP32[(($this4_i_i_i)>>2)]=0; HEAP32[((($this4_i_i_i)+(4))>>2)]=0; HEAP32[((($this4_i_i_i)+(8))>>2)]=0;
 var $this4_i_i_i28=$__sym;
 HEAP32[(($this4_i_i_i28)>>2)]=0; HEAP32[((($this4_i_i_i28)+(4))>>2)]=0; HEAP32[((($this4_i_i_i28)+(8))>>2)]=0;
 var $this4_i_i_i29=$__sn;
 HEAP32[(($this4_i_i_i29)>>2)]=0; HEAP32[((($this4_i_i_i29)+(4))>>2)]=0; HEAP32[((($this4_i_i_i29)+(8))>>2)]=0;
 (function() { try { __THREW__ = 0; return __ZNSt3__111__money_putIwE13__gather_infoEbbRKNS_6localeERNS_10money_base7patternERwS8_RNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERNS9_IwNSA_IwEENSC_IwEEEESJ_Ri($__intl,$79,$__loc,$__pat,$__dp,$__ts,$__grp,$__sym,$__sn,$__fd) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=26;break; } else { label=46;break; }
 case 26: 
 var $81=(($__mbuf)|0);
 var $82=HEAP32[(($__fd)>>2)];
 var $83=($__n_0|0)>($82|0);
 if($83){label=27;break;}else{label=34;break;}
 case 27: 
 var $85=((($__n_0)-($82))|0);
 var $86=$85<<1;
 var $87=HEAP8[($this4_i_i_i29)];
 var $88=$87&1;
 var $89=(($88<<24)>>24)==0;
 if($89){label=29;break;}else{label=28;break;}
 case 28: 
 var $91=(($__sn+4)|0);
 var $92=HEAP32[(($91)>>2)];
 var $96=$92;label=30;break;
 case 29: 
 var $94=($87&255);
 var $95=$94>>>1;
 var $96=$95;label=30;break;
 case 30: 
 var $96;
 var $97=HEAP8[($this4_i_i_i28)];
 var $98=$97&1;
 var $99=(($98<<24)>>24)==0;
 if($99){label=32;break;}else{label=31;break;}
 case 31: 
 var $101=(($__sym+4)|0);
 var $102=HEAP32[(($101)>>2)];
 var $106=$102;label=33;break;
 case 32: 
 var $104=($97&255);
 var $105=$104>>>1;
 var $106=$105;label=33;break;
 case 33: 
 var $106;
 var $107=$86|1;
 var $108=((($96)+($107))|0);
 var $109=((($108)+($106))|0);
 var $_pn=$109;label=41;break;
 case 34: 
 var $111=HEAP8[($this4_i_i_i29)];
 var $112=$111&1;
 var $113=(($112<<24)>>24)==0;
 if($113){label=36;break;}else{label=35;break;}
 case 35: 
 var $115=(($__sn+4)|0);
 var $116=HEAP32[(($115)>>2)];
 var $120=$116;label=37;break;
 case 36: 
 var $118=($111&255);
 var $119=$118>>>1;
 var $120=$119;label=37;break;
 case 37: 
 var $120;
 var $121=HEAP8[($this4_i_i_i28)];
 var $122=$121&1;
 var $123=(($122<<24)>>24)==0;
 if($123){label=39;break;}else{label=38;break;}
 case 38: 
 var $125=(($__sym+4)|0);
 var $126=HEAP32[(($125)>>2)];
 var $130=$126;label=40;break;
 case 39: 
 var $128=($121&255);
 var $129=$128>>>1;
 var $130=$129;label=40;break;
 case 40: 
 var $130;
 var $131=((($120)+(2))|0);
 var $132=((($131)+($130))|0);
 var $_pn=$132;label=41;break;
 case 41: 
 var $_pn;
 var $134=((($_pn)+($82))|0);
 var $135=($134>>>0)>100;
 if($135){label=42;break;}else{var $__mb_0=$81;var $160=0;label=49;break;}
 case 42: 
 var $136=$134<<2;
 var $137=_malloc($136);
 var $138=$137;
 var $139=($137|0)==0;
 if($139){label=43;break;}else{var $__mb_0=$138;var $160=$138;label=49;break;}
 case 43: 
 (function() { try { __THREW__ = 0; return __ZSt17__throw_bad_allocv() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $__mb_0=0;var $160=0;label=49;break; } else { label=44;break; }
 case 44: 
 var $141$0 = ___cxa_find_matching_catch(-1, -1); var $141$1 = tempRet0;
 var $142=$141$0;
 var $143=$141$1;
 var $_0=$142;var $_023=$143;label=58;break;
 case 45: 
 var $145$0 = ___cxa_find_matching_catch(-1, -1); var $145$1 = tempRet0;
 var $146=$145$0;
 var $147=$145$1;
 var $_1=$146;var $_124=$147;label=59;break;
 case 46: 
 var $149$0 = ___cxa_find_matching_catch(-1, -1); var $149$1 = tempRet0;
 var $150=$149$0;
 var $151=$149$1;
 var $_0=$150;var $_023=$151;label=58;break;
 case 47: 
 var $153$0 = ___cxa_find_matching_catch(-1, -1); var $153$1 = tempRet0;
 var $154=$153$0;
 var $155=$153$1;
 var $156=($160|0)==0;
 if($156){var $_0=$154;var $_023=$155;label=58;break;}else{label=48;break;}
 case 48: 
 var $158=$160;
 _free($158);
 var $_0=$154;var $_023=$155;label=58;break;
 case 49: 
 var $160;
 var $__mb_0;
 var $161=(($__iob+4)|0);
 var $162=HEAP32[(($161)>>2)];
 var $163=(($__db_0+($__n_0<<2))|0);
 var $164=HEAP32[(($__dp)>>2)];
 var $165=HEAP32[(($__ts)>>2)];
 (function() { try { __THREW__ = 0; return __ZNSt3__111__money_putIwE8__formatEPwRS2_S3_jPKwS5_RKNS_5ctypeIwEEbRKNS_10money_base7patternEwwRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERKNSE_IwNSF_IwEENSH_IwEEEESQ_i($__mb_0,$__mi,$__me,$162,$__db_0,$163,$65,$79,$__pat,$164,$165,$__grp,$__sym,$__sn,$82) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=50;break; } else { label=47;break; }
 case 50: 
 var $167=(($__s)|0);
 var $168=HEAP32[(($167)>>2)];
 var $169=(($1)|0);
 HEAP32[(($169)>>2)]=$168;
 var $170=HEAP32[(($__mi)>>2)];
 var $171=HEAP32[(($__me)>>2)];
 (function() { try { __THREW__ = 0; return __ZNSt3__116__pad_and_outputIwNS_11char_traitsIwEEEENS_19ostreambuf_iteratorIT_T0_EES6_PKS4_S8_S8_RNS_8ios_baseES4_($agg_result,$1,$__mb_0,$170,$171,$__iob,$__fl) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=51;break; } else { label=47;break; }
 case 51: 
 var $173=($160|0)==0;
 if($173){label=53;break;}else{label=52;break;}
 case 52: 
 var $175=$160;
 _free($175);
 label=53;break;
 case 53: 
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev($__sn);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev($__sym);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grp);
 var $176=HEAP32[(($42)>>2)];
 var $177=(($176)|0);
 var $178=__ZNSt3__114__shared_count16__release_sharedEv($177);
 var $179=($40|0)==0;
 if($179){label=55;break;}else{label=54;break;}
 case 54: 
 var $181=$40;
 _free($181);
 label=55;break;
 case 55: 
 var $182=($39|0)==0;
 if($182){label=57;break;}else{label=56;break;}
 case 56: 
 _free($39);
 label=57;break;
 case 57: 
 STACKTOP=sp;return;
 case 58: 
 var $_023;
 var $_0;
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev($__sn);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev($__sym);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grp);
 var $_1=$_0;var $_124=$_023;label=59;break;
 case 59: 
 var $_124;
 var $_1;
 var $185=HEAP32[(($42)>>2)];
 var $186=(($185)|0);
 var $187=__ZNSt3__114__shared_count16__release_sharedEv($186);
 var $_2=$_1;var $_225=$_124;var $190=$40;var $189=$39;label=60;break;
 case 60: 
 var $189;
 var $190;
 var $_225;
 var $_2;
 var $191=($190|0)==0;
 if($191){label=62;break;}else{label=61;break;}
 case 61: 
 var $193=$190;
 _free($193);
 label=62;break;
 case 62: 
 var $194=($189|0)==0;
 if($194){label=64;break;}else{label=63;break;}
 case 63: 
 _free($189);
 label=64;break;
 case 64: 
 var $196$0=$_2;
 var $196$1=0;
 var $197$0=$196$0;
 var $197$1=$_225;
 ___resumeException($197$0)
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__111__money_putIwE13__gather_infoEbbRKNS_6localeERNS_10money_base7patternERwS8_RNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERNS9_IwNSA_IwEENSC_IwEEEESJ_Ri($__intl,$__neg,$__loc,$__pat,$__dp,$__ts,$__grp,$__sym,$__sn,$__fd){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+40)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $__p_i_i_i_i41=sp;
 var $__p_i_i_i_i=(sp)+(16);
 var $1=(sp)+(32);
 var $tmpcast36=$1;
 var $2=STACKTOP;STACKTOP = (STACKTOP + 12)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var $3=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var $tmpcast35=$3;
 var $4=STACKTOP;STACKTOP = (STACKTOP + 12)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var $5=STACKTOP;STACKTOP = (STACKTOP + 12)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var $6=STACKTOP;STACKTOP = (STACKTOP + 12)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var $7=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var $tmpcast34=$7;
 var $8=STACKTOP;STACKTOP = (STACKTOP + 12)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var $9=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var $tmpcast=$9;
 var $10=STACKTOP;STACKTOP = (STACKTOP + 12)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var $11=STACKTOP;STACKTOP = (STACKTOP + 12)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var $12=STACKTOP;STACKTOP = (STACKTOP + 12)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var $13=(($__loc)|0);
 var $14=HEAP32[(($13)>>2)];
 if($__intl){label=2;break;}else{label=31;break;}
 case 2: 
 var $16=$__p_i_i_i_i;
 var $17=HEAP32[((14552)>>2)];
 var $18=($17|0)==-1;
 if($18){label=4;break;}else{label=3;break;}
 case 3: 
 var $_sroa_01_0___p67_i_idx_i_i_i=(($__p_i_i_i_i)|0);
 HEAP32[(($_sroa_01_0___p67_i_idx_i_i_i)>>2)]=14552;
 var $_sroa_12_4___p67_i_idx3_i_i_i=(($__p_i_i_i_i+4)|0);
 HEAP32[(($_sroa_12_4___p67_i_idx3_i_i_i)>>2)]=(28);
 var $_sroa_2_8___p67_i_idx4_i_i_i=(($__p_i_i_i_i+8)|0);
 HEAP32[(($_sroa_2_8___p67_i_idx4_i_i_i)>>2)]=0;
 __ZNSt3__111__call_onceERVmPvPFvS2_E(14552,$16,260);
 label=4;break;
 case 4: 
 var $20=HEAP32[((14556)>>2)];
 var $21=((($20)-(1))|0);
 var $22=(($14+12)|0);
 var $23=HEAP32[(($22)>>2)];
 var $24=(($14+8)|0);
 var $25=HEAP32[(($24)>>2)];
 var $26=$23;
 var $27=$25;
 var $28=((($26)-($27))|0);
 var $29=$28>>2;
 var $30=($29>>>0)>($21>>>0);
 if($30){label=5;break;}else{label=6;break;}
 case 5: 
 var $31=(($25+($21<<2))|0);
 var $32=HEAP32[(($31)>>2)];
 var $33=($32|0)==0;
 if($33){label=6;break;}else{label=7;break;}
 case 6: 
 var $34=___cxa_allocate_exception(4);
 var $35=$34;
 __ZNSt8bad_castC2Ev($35);
 ___cxa_throw($34,8960,(368));
 throw "Reached an unreachable!";
 case 7: 
 var $36=$32;
 var $37=$32;
 var $38=HEAP32[(($37)>>2)];
 if($__neg){label=8;break;}else{label=14;break;}
 case 8: 
 var $40=(($38+44)|0);
 var $41=HEAP32[(($40)>>2)];
 FUNCTION_TABLE[$41]($tmpcast36,$36);
 var $42=$__pat;
 var $43=HEAP32[(($1)>>2)];
 tempBigInt=$43;HEAP8[($42)]=tempBigInt&0xff;tempBigInt = tempBigInt>>8;HEAP8[((($42)+(1))|0)]=tempBigInt&0xff;tempBigInt = tempBigInt>>8;HEAP8[((($42)+(2))|0)]=tempBigInt&0xff;tempBigInt = tempBigInt>>8;HEAP8[((($42)+(3))|0)]=tempBigInt&0xff;
 var $44=$32;
 var $45=HEAP32[(($44)>>2)];
 var $46=(($45+32)|0);
 var $47=HEAP32[(($46)>>2)];
 FUNCTION_TABLE[$47]($2,$36);
 var $48=$__sn;
 var $49=HEAP8[($48)];
 var $50=$49&1;
 var $51=(($50<<24)>>24)==0;
 if($51){label=10;break;}else{label=9;break;}
 case 9: 
 var $53=(($__sn+8)|0);
 var $54=HEAP32[(($53)>>2)];
 HEAP32[(($54)>>2)]=0;
 var $55=(($__sn+4)|0);
 HEAP32[(($55)>>2)]=0;
 label=11;break;
 case 10: 
 var $57=(($__sn+4)|0);
 HEAP32[(($57)>>2)]=0;
 HEAP8[($48)]=0;
 label=11;break;
 case 11: 
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE7reserveEj($__sn,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=13;break; } else { label=12;break; }
 case 12: 
 var $59$0 = ___cxa_find_matching_catch(-1, -1,0); var $59$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
 case 13: 
 var $60=$2;
 assert(12 % 1 === 0);HEAP32[(($48)>>2)]=HEAP32[(($60)>>2)];HEAP32[((($48)+(4))>>2)]=HEAP32[((($60)+(4))>>2)];HEAP32[((($48)+(8))>>2)]=HEAP32[((($60)+(8))>>2)];
 HEAP32[(($60)>>2)]=0; HEAP32[((($60)+(4))>>2)]=0; HEAP32[((($60)+(8))>>2)]=0;
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev($2);
 label=20;break;
 case 14: 
 var $62=(($38+40)|0);
 var $63=HEAP32[(($62)>>2)];
 FUNCTION_TABLE[$63]($tmpcast35,$36);
 var $64=$__pat;
 var $65=HEAP32[(($3)>>2)];
 tempBigInt=$65;HEAP8[($64)]=tempBigInt&0xff;tempBigInt = tempBigInt>>8;HEAP8[((($64)+(1))|0)]=tempBigInt&0xff;tempBigInt = tempBigInt>>8;HEAP8[((($64)+(2))|0)]=tempBigInt&0xff;tempBigInt = tempBigInt>>8;HEAP8[((($64)+(3))|0)]=tempBigInt&0xff;
 var $66=$32;
 var $67=HEAP32[(($66)>>2)];
 var $68=(($67+28)|0);
 var $69=HEAP32[(($68)>>2)];
 FUNCTION_TABLE[$69]($4,$36);
 var $70=$__sn;
 var $71=HEAP8[($70)];
 var $72=$71&1;
 var $73=(($72<<24)>>24)==0;
 if($73){label=16;break;}else{label=15;break;}
 case 15: 
 var $75=(($__sn+8)|0);
 var $76=HEAP32[(($75)>>2)];
 HEAP32[(($76)>>2)]=0;
 var $77=(($__sn+4)|0);
 HEAP32[(($77)>>2)]=0;
 label=17;break;
 case 16: 
 var $79=(($__sn+4)|0);
 HEAP32[(($79)>>2)]=0;
 HEAP8[($70)]=0;
 label=17;break;
 case 17: 
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE7reserveEj($__sn,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=19;break; } else { label=18;break; }
 case 18: 
 var $81$0 = ___cxa_find_matching_catch(-1, -1,0); var $81$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
 case 19: 
 var $82=$4;
 assert(12 % 1 === 0);HEAP32[(($70)>>2)]=HEAP32[(($82)>>2)];HEAP32[((($70)+(4))>>2)]=HEAP32[((($82)+(4))>>2)];HEAP32[((($70)+(8))>>2)]=HEAP32[((($82)+(8))>>2)];
 HEAP32[(($82)>>2)]=0; HEAP32[((($82)+(4))>>2)]=0; HEAP32[((($82)+(8))>>2)]=0;
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev($4);
 label=20;break;
 case 20: 
 var $84=$32;
 var $85=HEAP32[(($84)>>2)];
 var $86=(($85+12)|0);
 var $87=HEAP32[(($86)>>2)];
 var $88=FUNCTION_TABLE[$87]($36);
 HEAP32[(($__dp)>>2)]=$88;
 var $89=HEAP32[(($84)>>2)];
 var $90=(($89+16)|0);
 var $91=HEAP32[(($90)>>2)];
 var $92=FUNCTION_TABLE[$91]($36);
 HEAP32[(($__ts)>>2)]=$92;
 var $93=$32;
 var $94=HEAP32[(($93)>>2)];
 var $95=(($94+20)|0);
 var $96=HEAP32[(($95)>>2)];
 FUNCTION_TABLE[$96]($5,$36);
 var $97=$__grp;
 var $98=HEAP8[($97)];
 var $99=$98&1;
 var $100=(($99<<24)>>24)==0;
 if($100){label=22;break;}else{label=21;break;}
 case 21: 
 var $102=(($__grp+8)|0);
 var $103=HEAP32[(($102)>>2)];
 HEAP8[($103)]=0;
 var $104=(($__grp+4)|0);
 HEAP32[(($104)>>2)]=0;
 label=23;break;
 case 22: 
 var $106=$__grp;
 var $107=(($106+1)|0);
 HEAP8[($107)]=0;
 HEAP8[($97)]=0;
 label=23;break;
 case 23: 
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7reserveEj($__grp,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=25;break; } else { label=24;break; }
 case 24: 
 var $109$0 = ___cxa_find_matching_catch(-1, -1,0); var $109$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
 case 25: 
 var $110=$5;
 assert(12 % 1 === 0);HEAP32[(($97)>>2)]=HEAP32[(($110)>>2)];HEAP32[((($97)+(4))>>2)]=HEAP32[((($110)+(4))>>2)];HEAP32[((($97)+(8))>>2)]=HEAP32[((($110)+(8))>>2)];
 HEAP32[(($110)>>2)]=0; HEAP32[((($110)+(4))>>2)]=0; HEAP32[((($110)+(8))>>2)]=0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($5);
 var $111=$32;
 var $112=HEAP32[(($111)>>2)];
 var $113=(($112+24)|0);
 var $114=HEAP32[(($113)>>2)];
 FUNCTION_TABLE[$114]($6,$36);
 var $115=$__sym;
 var $116=HEAP8[($115)];
 var $117=$116&1;
 var $118=(($117<<24)>>24)==0;
 if($118){label=27;break;}else{label=26;break;}
 case 26: 
 var $120=(($__sym+8)|0);
 var $121=HEAP32[(($120)>>2)];
 HEAP32[(($121)>>2)]=0;
 var $122=(($__sym+4)|0);
 HEAP32[(($122)>>2)]=0;
 label=28;break;
 case 27: 
 var $124=(($__sym+4)|0);
 HEAP32[(($124)>>2)]=0;
 HEAP8[($115)]=0;
 label=28;break;
 case 28: 
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE7reserveEj($__sym,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=30;break; } else { label=29;break; }
 case 29: 
 var $126$0 = ___cxa_find_matching_catch(-1, -1,0); var $126$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
 case 30: 
 var $127=$6;
 assert(12 % 1 === 0);HEAP32[(($115)>>2)]=HEAP32[(($127)>>2)];HEAP32[((($115)+(4))>>2)]=HEAP32[((($127)+(4))>>2)];HEAP32[((($115)+(8))>>2)]=HEAP32[((($127)+(8))>>2)];
 HEAP32[(($127)>>2)]=0; HEAP32[((($127)+(4))>>2)]=0; HEAP32[((($127)+(8))>>2)]=0;
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev($6);
 var $128=HEAP32[(($84)>>2)];
 var $129=(($128+36)|0);
 var $130=HEAP32[(($129)>>2)];
 var $131=FUNCTION_TABLE[$130]($36);
 var $storemerge=$131;label=60;break;
 case 31: 
 var $133=$__p_i_i_i_i41;
 var $134=HEAP32[((14560)>>2)];
 var $135=($134|0)==-1;
 if($135){label=33;break;}else{label=32;break;}
 case 32: 
 var $_sroa_01_0___p67_i_idx_i_i_i42=(($__p_i_i_i_i41)|0);
 HEAP32[(($_sroa_01_0___p67_i_idx_i_i_i42)>>2)]=14560;
 var $_sroa_12_4___p67_i_idx3_i_i_i43=(($__p_i_i_i_i41+4)|0);
 HEAP32[(($_sroa_12_4___p67_i_idx3_i_i_i43)>>2)]=(28);
 var $_sroa_2_8___p67_i_idx4_i_i_i44=(($__p_i_i_i_i41+8)|0);
 HEAP32[(($_sroa_2_8___p67_i_idx4_i_i_i44)>>2)]=0;
 __ZNSt3__111__call_onceERVmPvPFvS2_E(14560,$133,260);
 label=33;break;
 case 33: 
 var $137=HEAP32[((14564)>>2)];
 var $138=((($137)-(1))|0);
 var $139=(($14+12)|0);
 var $140=HEAP32[(($139)>>2)];
 var $141=(($14+8)|0);
 var $142=HEAP32[(($141)>>2)];
 var $143=$140;
 var $144=$142;
 var $145=((($143)-($144))|0);
 var $146=$145>>2;
 var $147=($146>>>0)>($138>>>0);
 if($147){label=34;break;}else{label=35;break;}
 case 34: 
 var $148=(($142+($138<<2))|0);
 var $149=HEAP32[(($148)>>2)];
 var $150=($149|0)==0;
 if($150){label=35;break;}else{label=36;break;}
 case 35: 
 var $151=___cxa_allocate_exception(4);
 var $152=$151;
 __ZNSt8bad_castC2Ev($152);
 ___cxa_throw($151,8960,(368));
 throw "Reached an unreachable!";
 case 36: 
 var $153=$149;
 var $154=$149;
 var $155=HEAP32[(($154)>>2)];
 if($__neg){label=37;break;}else{label=43;break;}
 case 37: 
 var $157=(($155+44)|0);
 var $158=HEAP32[(($157)>>2)];
 FUNCTION_TABLE[$158]($tmpcast34,$153);
 var $159=$__pat;
 var $160=HEAP32[(($7)>>2)];
 tempBigInt=$160;HEAP8[($159)]=tempBigInt&0xff;tempBigInt = tempBigInt>>8;HEAP8[((($159)+(1))|0)]=tempBigInt&0xff;tempBigInt = tempBigInt>>8;HEAP8[((($159)+(2))|0)]=tempBigInt&0xff;tempBigInt = tempBigInt>>8;HEAP8[((($159)+(3))|0)]=tempBigInt&0xff;
 var $161=$149;
 var $162=HEAP32[(($161)>>2)];
 var $163=(($162+32)|0);
 var $164=HEAP32[(($163)>>2)];
 FUNCTION_TABLE[$164]($8,$153);
 var $165=$__sn;
 var $166=HEAP8[($165)];
 var $167=$166&1;
 var $168=(($167<<24)>>24)==0;
 if($168){label=39;break;}else{label=38;break;}
 case 38: 
 var $170=(($__sn+8)|0);
 var $171=HEAP32[(($170)>>2)];
 HEAP32[(($171)>>2)]=0;
 var $172=(($__sn+4)|0);
 HEAP32[(($172)>>2)]=0;
 label=40;break;
 case 39: 
 var $174=(($__sn+4)|0);
 HEAP32[(($174)>>2)]=0;
 HEAP8[($165)]=0;
 label=40;break;
 case 40: 
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE7reserveEj($__sn,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=42;break; } else { label=41;break; }
 case 41: 
 var $176$0 = ___cxa_find_matching_catch(-1, -1,0); var $176$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
 case 42: 
 var $177=$8;
 assert(12 % 1 === 0);HEAP32[(($165)>>2)]=HEAP32[(($177)>>2)];HEAP32[((($165)+(4))>>2)]=HEAP32[((($177)+(4))>>2)];HEAP32[((($165)+(8))>>2)]=HEAP32[((($177)+(8))>>2)];
 HEAP32[(($177)>>2)]=0; HEAP32[((($177)+(4))>>2)]=0; HEAP32[((($177)+(8))>>2)]=0;
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev($8);
 label=49;break;
 case 43: 
 var $179=(($155+40)|0);
 var $180=HEAP32[(($179)>>2)];
 FUNCTION_TABLE[$180]($tmpcast,$153);
 var $181=$__pat;
 var $182=HEAP32[(($9)>>2)];
 tempBigInt=$182;HEAP8[($181)]=tempBigInt&0xff;tempBigInt = tempBigInt>>8;HEAP8[((($181)+(1))|0)]=tempBigInt&0xff;tempBigInt = tempBigInt>>8;HEAP8[((($181)+(2))|0)]=tempBigInt&0xff;tempBigInt = tempBigInt>>8;HEAP8[((($181)+(3))|0)]=tempBigInt&0xff;
 var $183=$149;
 var $184=HEAP32[(($183)>>2)];
 var $185=(($184+28)|0);
 var $186=HEAP32[(($185)>>2)];
 FUNCTION_TABLE[$186]($10,$153);
 var $187=$__sn;
 var $188=HEAP8[($187)];
 var $189=$188&1;
 var $190=(($189<<24)>>24)==0;
 if($190){label=45;break;}else{label=44;break;}
 case 44: 
 var $192=(($__sn+8)|0);
 var $193=HEAP32[(($192)>>2)];
 HEAP32[(($193)>>2)]=0;
 var $194=(($__sn+4)|0);
 HEAP32[(($194)>>2)]=0;
 label=46;break;
 case 45: 
 var $196=(($__sn+4)|0);
 HEAP32[(($196)>>2)]=0;
 HEAP8[($187)]=0;
 label=46;break;
 case 46: 
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE7reserveEj($__sn,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=48;break; } else { label=47;break; }
 case 47: 
 var $198$0 = ___cxa_find_matching_catch(-1, -1,0); var $198$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
 case 48: 
 var $199=$10;
 assert(12 % 1 === 0);HEAP32[(($187)>>2)]=HEAP32[(($199)>>2)];HEAP32[((($187)+(4))>>2)]=HEAP32[((($199)+(4))>>2)];HEAP32[((($187)+(8))>>2)]=HEAP32[((($199)+(8))>>2)];
 HEAP32[(($199)>>2)]=0; HEAP32[((($199)+(4))>>2)]=0; HEAP32[((($199)+(8))>>2)]=0;
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev($10);
 label=49;break;
 case 49: 
 var $201=$149;
 var $202=HEAP32[(($201)>>2)];
 var $203=(($202+12)|0);
 var $204=HEAP32[(($203)>>2)];
 var $205=FUNCTION_TABLE[$204]($153);
 HEAP32[(($__dp)>>2)]=$205;
 var $206=HEAP32[(($201)>>2)];
 var $207=(($206+16)|0);
 var $208=HEAP32[(($207)>>2)];
 var $209=FUNCTION_TABLE[$208]($153);
 HEAP32[(($__ts)>>2)]=$209;
 var $210=$149;
 var $211=HEAP32[(($210)>>2)];
 var $212=(($211+20)|0);
 var $213=HEAP32[(($212)>>2)];
 FUNCTION_TABLE[$213]($11,$153);
 var $214=$__grp;
 var $215=HEAP8[($214)];
 var $216=$215&1;
 var $217=(($216<<24)>>24)==0;
 if($217){label=51;break;}else{label=50;break;}
 case 50: 
 var $219=(($__grp+8)|0);
 var $220=HEAP32[(($219)>>2)];
 HEAP8[($220)]=0;
 var $221=(($__grp+4)|0);
 HEAP32[(($221)>>2)]=0;
 label=52;break;
 case 51: 
 var $223=$__grp;
 var $224=(($223+1)|0);
 HEAP8[($224)]=0;
 HEAP8[($214)]=0;
 label=52;break;
 case 52: 
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7reserveEj($__grp,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=54;break; } else { label=53;break; }
 case 53: 
 var $226$0 = ___cxa_find_matching_catch(-1, -1,0); var $226$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
 case 54: 
 var $227=$11;
 assert(12 % 1 === 0);HEAP32[(($214)>>2)]=HEAP32[(($227)>>2)];HEAP32[((($214)+(4))>>2)]=HEAP32[((($227)+(4))>>2)];HEAP32[((($214)+(8))>>2)]=HEAP32[((($227)+(8))>>2)];
 HEAP32[(($227)>>2)]=0; HEAP32[((($227)+(4))>>2)]=0; HEAP32[((($227)+(8))>>2)]=0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($11);
 var $228=$149;
 var $229=HEAP32[(($228)>>2)];
 var $230=(($229+24)|0);
 var $231=HEAP32[(($230)>>2)];
 FUNCTION_TABLE[$231]($12,$153);
 var $232=$__sym;
 var $233=HEAP8[($232)];
 var $234=$233&1;
 var $235=(($234<<24)>>24)==0;
 if($235){label=56;break;}else{label=55;break;}
 case 55: 
 var $237=(($__sym+8)|0);
 var $238=HEAP32[(($237)>>2)];
 HEAP32[(($238)>>2)]=0;
 var $239=(($__sym+4)|0);
 HEAP32[(($239)>>2)]=0;
 label=57;break;
 case 56: 
 var $241=(($__sym+4)|0);
 HEAP32[(($241)>>2)]=0;
 HEAP8[($232)]=0;
 label=57;break;
 case 57: 
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE7reserveEj($__sym,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=59;break; } else { label=58;break; }
 case 58: 
 var $243$0 = ___cxa_find_matching_catch(-1, -1,0); var $243$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
 case 59: 
 var $244=$12;
 assert(12 % 1 === 0);HEAP32[(($232)>>2)]=HEAP32[(($244)>>2)];HEAP32[((($232)+(4))>>2)]=HEAP32[((($244)+(4))>>2)];HEAP32[((($232)+(8))>>2)]=HEAP32[((($244)+(8))>>2)];
 HEAP32[(($244)>>2)]=0; HEAP32[((($244)+(4))>>2)]=0; HEAP32[((($244)+(8))>>2)]=0;
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev($12);
 var $245=HEAP32[(($201)>>2)];
 var $246=(($245+36)|0);
 var $247=HEAP32[(($246)>>2)];
 var $248=FUNCTION_TABLE[$247]($153);
 var $storemerge=$248;label=60;break;
 case 60: 
 var $storemerge;
 HEAP32[(($__fd)>>2)]=$storemerge;
 STACKTOP=sp;return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__111__money_putIwE8__formatEPwRS2_S3_jPKwS5_RKNS_5ctypeIwEEbRKNS_10money_base7patternEwwRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERKNSE_IwNSF_IwEENSH_IwEEEESQ_i($__mb,$__mi,$__me,$__flags,$__db,$__de,$__ct,$__neg,$__pat,$__dp,$__ts,$__grp,$__sym,$__sn,$__fd){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 HEAP32[(($__me)>>2)]=$__mb;
 var $1=$__ct;
 var $2=$__sn;
 var $3=(($__sn+4)|0);
 var $4=(($__sn+8)|0);
 var $5=$__sym;
 var $6=$__flags&512;
 var $7=($6|0)==0;
 var $8=(($__sym+4)|0);
 var $9=(($__sym+8)|0);
 var $10=$__ct;
 var $11=($__fd|0)>0;
 var $12=$__grp;
 var $13=$__grp;
 var $14=(($13+1)|0);
 var $15=(($__grp+8)|0);
 var $16=(($__grp+4)|0);
 var $__p_0124=0;var $_0125=$__db;label=2;break;
 case 2: 
 var $_0125;
 var $__p_0124;
 var $18=(($__pat+$__p_0124)|0);
 var $19=HEAP8[($18)];
 var $20=(($19<<24)>>24);
 switch(($20|0)){case 2:{ label=12;break;}case 4:{ label=25;break;}case 0:{ label=3;break;}case 1:{ label=4;break;}case 3:{ label=5;break;}default:{var $_2=$_0125;label=63;break;}}break;
 case 3: 
 var $22=HEAP32[(($__me)>>2)];
 HEAP32[(($__mi)>>2)]=$22;
 var $_2=$_0125;label=63;break;
 case 4: 
 var $24=HEAP32[(($__me)>>2)];
 HEAP32[(($__mi)>>2)]=$24;
 var $25=HEAP32[(($1)>>2)];
 var $26=(($25+44)|0);
 var $27=HEAP32[(($26)>>2)];
 var $28=FUNCTION_TABLE[$27]($__ct,32);
 var $29=HEAP32[(($__me)>>2)];
 var $30=(($29+4)|0);
 HEAP32[(($__me)>>2)]=$30;
 HEAP32[(($29)>>2)]=$28;
 var $_2=$_0125;label=63;break;
 case 5: 
 var $32=HEAP8[($2)];
 var $33=$32&1;
 var $34=(($33<<24)>>24)==0;
 if($34){label=7;break;}else{label=6;break;}
 case 6: 
 var $36=HEAP32[(($3)>>2)];
 var $40=$36;label=8;break;
 case 7: 
 var $38=($32&255);
 var $39=$38>>>1;
 var $40=$39;label=8;break;
 case 8: 
 var $40;
 var $41=($40|0)==0;
 if($41){var $_2=$_0125;label=63;break;}else{label=9;break;}
 case 9: 
 if($34){var $45=$3;label=11;break;}else{label=10;break;}
 case 10: 
 var $44=HEAP32[(($4)>>2)];
 var $45=$44;label=11;break;
 case 11: 
 var $45;
 var $46=HEAP32[(($45)>>2)];
 var $47=HEAP32[(($__me)>>2)];
 var $48=(($47+4)|0);
 HEAP32[(($__me)>>2)]=$48;
 HEAP32[(($47)>>2)]=$46;
 var $_2=$_0125;label=63;break;
 case 12: 
 var $50=HEAP8[($5)];
 var $51=$50&1;
 var $52=(($51<<24)>>24)==0;
 if($52){label=14;break;}else{label=13;break;}
 case 13: 
 var $54=HEAP32[(($8)>>2)];
 var $58=$54;label=15;break;
 case 14: 
 var $56=($50&255);
 var $57=$56>>>1;
 var $58=$57;label=15;break;
 case 15: 
 var $58;
 var $59=($58|0)==0;
 var $brmerge=$59|$7;
 if($brmerge){var $_2=$_0125;label=63;break;}else{label=16;break;}
 case 16: 
 if($52){label=18;break;}else{label=17;break;}
 case 17: 
 var $62=HEAP32[(($9)>>2)];
 var $63=HEAP32[(($8)>>2)];
 var $69=$63;var $68=$62;var $67=$62;label=19;break;
 case 18: 
 var $65=($50&255);
 var $66=$65>>>1;
 var $69=$66;var $68=$8;var $67=$8;label=19;break;
 case 19: 
 var $67;
 var $68;
 var $69;
 var $70=(($68+($69<<2))|0);
 var $71=HEAP32[(($__me)>>2)];
 var $72=($67|0)==($70|0);
 if($72){var $_0_lcssa_i_i94=$71;label=24;break;}else{label=20;break;}
 case 20: 
 var $_promoted6_i_i85=$67;
 var $_sum105=((($69)-(1))|0);
 var $scevgep_i_i86=(($68+($_sum105<<2))|0);
 var $scevgep5_i_i87=$scevgep_i_i86;
 var $73=(((-$_promoted6_i_i85))|0);
 var $uglygep_i_i88=(($scevgep5_i_i87+$73)|0);
 var $uglygep7_i_i89=$uglygep_i_i88;
 var $74=$uglygep7_i_i89>>>2;
 var $_03_i_i91=$71;var $76=$67;label=21;break;
 case 21: 
 var $76;
 var $_03_i_i91;
 var $77=HEAP32[(($76)>>2)];
 HEAP32[(($_03_i_i91)>>2)]=$77;
 var $78=(($76+4)|0);
 var $79=($78|0)==($70|0);
 if($79){label=23;break;}else{label=22;break;}
 case 22: 
 var $80=(($_03_i_i91+4)|0);
 var $_03_i_i91=$80;var $76=$78;label=21;break;
 case 23: 
 var $81=((($74)+(1))|0);
 var $scevgep8_i_i92=(($71+($81<<2))|0);
 var $_0_lcssa_i_i94=$scevgep8_i_i92;label=24;break;
 case 24: 
 var $_0_lcssa_i_i94;
 HEAP32[(($__me)>>2)]=$_0_lcssa_i_i94;
 var $_2=$_0125;label=63;break;
 case 25: 
 var $83=HEAP32[(($__me)>>2)];
 var $84=(($_0125+4)|0);
 var $__0=($__neg?$84:$_0125);
 var $__d_0=$__0;label=26;break;
 case 26: 
 var $__d_0;
 var $86=($__d_0>>>0)<($__de>>>0);
 if($86){label=27;break;}else{label=28;break;}
 case 27: 
 var $88=HEAP32[(($__d_0)>>2)];
 var $89=HEAP32[(($10)>>2)];
 var $90=(($89+12)|0);
 var $91=HEAP32[(($90)>>2)];
 var $92=FUNCTION_TABLE[$91]($__ct,2048,$88);
 var $93=(($__d_0+4)|0);
 if($92){var $__d_0=$93;label=26;break;}else{label=28;break;}
 case 28: 
 if($11){label=29;break;}else{var $__d_2=$__d_0;label=38;break;}
 case 29: 
 var $95=($__d_0>>>0)>($__0>>>0);
 if($95){label=30;break;}else{var $__f_0_lcssa138=$__fd;var $__d_1_lcssa140=$__d_0;label=34;break;}
 case 30: 
 var $__me_promoted=HEAP32[(($__me)>>2)];
 var $__d_1107=$__d_0;var $__f_0108=$__fd;var $97=$__me_promoted;label=31;break;
 case 31: 
 var $97;
 var $__f_0108;
 var $__d_1107;
 var $98=((($__d_1107)-(4))|0);
 var $99=HEAP32[(($98)>>2)];
 var $100=(($97+4)|0);
 HEAP32[(($97)>>2)]=$99;
 var $101=((($__f_0108)-(1))|0);
 var $102=($98>>>0)>($__0>>>0);
 var $103=($101|0)>0;
 var $or_cond=$102&$103;
 if($or_cond){var $__d_1107=$98;var $__f_0108=$101;var $97=$100;label=31;break;}else{label=32;break;}
 case 32: 
 HEAP32[(($__me)>>2)]=$100;
 if($103){var $__f_0_lcssa138=$101;var $__d_1_lcssa140=$98;label=34;break;}else{label=33;break;}
 case 33: 
 var $104=HEAP32[(($__me)>>2)];
 var $105=(($104+4)|0);
 HEAP32[(($__me)>>2)]=$105;
 var $_lcssa112=$104;var $__d_1_lcssa139141=$98;label=37;break;
 case 34: 
 var $__d_1_lcssa140;
 var $__f_0_lcssa138;
 var $106=HEAP32[(($1)>>2)];
 var $107=(($106+44)|0);
 var $108=HEAP32[(($107)>>2)];
 var $109=FUNCTION_TABLE[$108]($__ct,48);
 var $110=($__f_0_lcssa138|0)>0;
 var $111=HEAP32[(($__me)>>2)];
 var $112=(($111+4)|0);
 HEAP32[(($__me)>>2)]=$112;
 if($110){var $__f_1113=$__f_0_lcssa138;var $114=$111;var $113=$112;label=35;break;}else{var $_lcssa112=$111;var $__d_1_lcssa139141=$__d_1_lcssa140;label=37;break;}
 case 35: 
 var $113;
 var $114;
 var $__f_1113;
 HEAP32[(($114)>>2)]=$109;
 var $115=((($__f_1113)-(1))|0);
 var $116=($115|0)>0;
 var $117=(($113+4)|0);
 if($116){var $__f_1113=$115;var $114=$113;var $113=$117;label=35;break;}else{label=36;break;}
 case 36: 
 var $_sum136=((($__f_0_lcssa138)+(1))|0);
 var $scevgep=(($111+($_sum136<<2))|0);
 var $scevgep133=(($111+($__f_0_lcssa138<<2))|0);
 HEAP32[(($__me)>>2)]=$scevgep;
 var $_lcssa112=$scevgep133;var $__d_1_lcssa139141=$__d_1_lcssa140;label=37;break;
 case 37: 
 var $__d_1_lcssa139141;
 var $_lcssa112;
 HEAP32[(($_lcssa112)>>2)]=$__dp;
 var $__d_2=$__d_1_lcssa139141;label=38;break;
 case 38: 
 var $__d_2;
 var $120=($__d_2|0)==($__0|0);
 if($120){label=39;break;}else{label=40;break;}
 case 39: 
 var $122=HEAP32[(($1)>>2)];
 var $123=(($122+44)|0);
 var $124=HEAP32[(($123)>>2)];
 var $125=FUNCTION_TABLE[$124]($__ct,48);
 var $126=HEAP32[(($__me)>>2)];
 var $127=(($126+4)|0);
 HEAP32[(($__me)>>2)]=$127;
 HEAP32[(($126)>>2)]=$125;
 var $181=$127;label=60;break;
 case 40: 
 var $129=HEAP8[($12)];
 var $130=$129&1;
 var $131=(($130<<24)>>24)==0;
 if($131){label=42;break;}else{label=41;break;}
 case 41: 
 var $133=HEAP32[(($16)>>2)];
 var $137=$133;label=43;break;
 case 42: 
 var $135=($129&255);
 var $136=$135>>>1;
 var $137=$136;label=43;break;
 case 43: 
 var $137;
 var $138=($137|0)==0;
 if($138){var $__d_3119=$__d_2;var $__ng_0120=0;var $__ig_0121=0;var $__gl_0122=-1;label=47;break;}else{label=44;break;}
 case 44: 
 if($131){var $142=$14;label=46;break;}else{label=45;break;}
 case 45: 
 var $141=HEAP32[(($15)>>2)];
 var $142=$141;label=46;break;
 case 46: 
 var $142;
 var $143=HEAP8[($142)];
 var $144=(($143<<24)>>24);
 var $__d_3119=$__d_2;var $__ng_0120=0;var $__ig_0121=0;var $__gl_0122=$144;label=47;break;
 case 47: 
 var $__gl_0122;
 var $__ig_0121;
 var $__ng_0120;
 var $__d_3119;
 var $145=($__ng_0120|0)==($__gl_0122|0);
 if($145){label=48;break;}else{var $__gl_1=$__gl_0122;var $__ig_1=$__ig_0121;var $__ng_1=$__ng_0120;label=58;break;}
 case 48: 
 var $147=HEAP32[(($__me)>>2)];
 var $148=(($147+4)|0);
 HEAP32[(($__me)>>2)]=$148;
 HEAP32[(($147)>>2)]=$__ts;
 var $149=((($__ig_0121)+(1))|0);
 var $150=HEAP8[($12)];
 var $151=$150&1;
 var $152=(($151<<24)>>24)==0;
 if($152){label=50;break;}else{label=49;break;}
 case 49: 
 var $154=HEAP32[(($16)>>2)];
 var $158=$154;label=51;break;
 case 50: 
 var $156=($150&255);
 var $157=$156>>>1;
 var $158=$157;label=51;break;
 case 51: 
 var $158;
 var $159=($149>>>0)<($158>>>0);
 if($159){label=52;break;}else{var $__gl_1=$__gl_0122;var $__ig_1=$149;var $__ng_1=0;label=58;break;}
 case 52: 
 if($152){var $163=$14;label=54;break;}else{label=53;break;}
 case 53: 
 var $162=HEAP32[(($15)>>2)];
 var $163=$162;label=54;break;
 case 54: 
 var $163;
 var $164=(($163+$149)|0);
 var $165=HEAP8[($164)];
 var $166=(($165<<24)>>24)==127;
 if($166){var $__gl_1=-1;var $__ig_1=$149;var $__ng_1=0;label=58;break;}else{label=55;break;}
 case 55: 
 if($152){var $170=$14;label=57;break;}else{label=56;break;}
 case 56: 
 var $169=HEAP32[(($15)>>2)];
 var $170=$169;label=57;break;
 case 57: 
 var $170;
 var $171=(($170+$149)|0);
 var $172=HEAP8[($171)];
 var $173=(($172<<24)>>24);
 var $__gl_1=$173;var $__ig_1=$149;var $__ng_1=0;label=58;break;
 case 58: 
 var $__ng_1;
 var $__ig_1;
 var $__gl_1;
 var $174=((($__d_3119)-(4))|0);
 var $175=HEAP32[(($174)>>2)];
 var $176=HEAP32[(($__me)>>2)];
 var $177=(($176+4)|0);
 HEAP32[(($__me)>>2)]=$177;
 HEAP32[(($176)>>2)]=$175;
 var $178=((($__ng_1)+(1))|0);
 var $179=($174|0)==($__0|0);
 if($179){label=59;break;}else{var $__d_3119=$174;var $__ng_0120=$178;var $__ig_0121=$__ig_1;var $__gl_0122=$__gl_1;label=47;break;}
 case 59: 
 var $_pre=HEAP32[(($__me)>>2)];
 var $181=$_pre;label=60;break;
 case 60: 
 var $181;
 var $182=($83|0)==($181|0);
 if($182){var $_2=$__0;label=63;break;}else{label=61;break;}
 case 61: 
 var $183=((($181)-(4))|0);
 var $184=($183>>>0)>($83>>>0);
 if($184){var $_078_i_i=$83;var $185=$183;label=62;break;}else{var $_2=$__0;label=63;break;}
 case 62: 
 var $185;
 var $_078_i_i;
 var $186=HEAP32[(($_078_i_i)>>2)];
 var $187=HEAP32[(($185)>>2)];
 HEAP32[(($_078_i_i)>>2)]=$187;
 HEAP32[(($185)>>2)]=$186;
 var $188=(($_078_i_i+4)|0);
 var $189=((($185)-(4))|0);
 var $190=($188>>>0)<($189>>>0);
 if($190){var $_078_i_i=$188;var $185=$189;label=62;break;}else{var $_2=$__0;label=63;break;}
 case 63: 
 var $_2;
 var $191=((($__p_0124)+(1))|0);
 var $192=($191>>>0)<4;
 if($192){var $__p_0124=$191;var $_0125=$_2;label=2;break;}else{label=64;break;}
 case 64: 
 var $194=HEAP8[($2)];
 var $195=$194&1;
 var $196=(($195<<24)>>24)==0;
 if($196){label=66;break;}else{label=65;break;}
 case 65: 
 var $198=HEAP32[(($3)>>2)];
 var $202=$198;label=67;break;
 case 66: 
 var $200=($194&255);
 var $201=$200>>>1;
 var $202=$201;label=67;break;
 case 67: 
 var $202;
 var $203=($202>>>0)>1;
 if($203){label=68;break;}else{label=76;break;}
 case 68: 
 if($196){label=70;break;}else{label=69;break;}
 case 69: 
 var $206=HEAP32[(($4)>>2)];
 var $207=HEAP32[(($3)>>2)];
 var $212=$207;var $211=$206;var $_pn=$206;label=71;break;
 case 70: 
 var $209=($194&255);
 var $210=$209>>>1;
 var $212=$210;var $211=$3;var $_pn=$3;label=71;break;
 case 71: 
 var $_pn;
 var $211;
 var $212;
 var $213=(($_pn+4)|0);
 var $214=(($211+($212<<2))|0);
 var $215=HEAP32[(($__me)>>2)];
 var $216=($213|0)==($214|0);
 if($216){var $_0_lcssa_i_i=$215;label=75;break;}else{label=72;break;}
 case 72: 
 var $_promoted6_i_i=$213;
 var $_sum=((($212)-(1))|0);
 var $scevgep_i_i=(($211+($_sum<<2))|0);
 var $scevgep5_i_i=$scevgep_i_i;
 var $217=(((-$_promoted6_i_i))|0);
 var $uglygep_i_i=(($scevgep5_i_i+$217)|0);
 var $uglygep7_i_i=$uglygep_i_i;
 var $218=$uglygep7_i_i>>>2;
 var $_03_i_i=$215;var $220=$213;label=73;break;
 case 73: 
 var $220;
 var $_03_i_i;
 var $221=HEAP32[(($220)>>2)];
 HEAP32[(($_03_i_i)>>2)]=$221;
 var $222=(($220+4)|0);
 var $223=(($_03_i_i+4)|0);
 var $224=($222|0)==($214|0);
 if($224){label=74;break;}else{var $_03_i_i=$223;var $220=$222;label=73;break;}
 case 74: 
 var $225=((($218)+(1))|0);
 var $scevgep8_i_i=(($215+($225<<2))|0);
 var $_0_lcssa_i_i=$scevgep8_i_i;label=75;break;
 case 75: 
 var $_0_lcssa_i_i;
 HEAP32[(($__me)>>2)]=$_0_lcssa_i_i;
 label=76;break;
 case 76: 
 var $227=$__flags&176;
 if(($227|0)==32){ label=77;break;}else if(($227|0)==16){ label=79;break;}else{label=78;break;}
 case 77: 
 var $229=HEAP32[(($__me)>>2)];
 HEAP32[(($__mi)>>2)]=$229;
 label=79;break;
 case 78: 
 HEAP32[(($__mi)>>2)]=$__mb;
 label=79;break;
 case 79: 
 return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__19money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_bRNS_8ios_baseEwRKNS_12basic_stringIwS3_NS_9allocatorIwEEEE($agg_result,$this,$__s,$__intl,$__iob,$__fl,$__digits){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+528)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var tempParam = $__s; $__s=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);HEAP32[(($__s)>>2)]=HEAP32[((tempParam)>>2)];
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $__p_i_i_i_i=sp;
 var $__loc=(sp)+(16);
 var $__pat=(sp)+(24);
 var $__dp=(sp)+(32);
 var $__ts=(sp)+(40);
 var $__grp=(sp)+(48);
 var $__sym=(sp)+(64);
 var $__sn=(sp)+(80);
 var $__fd=(sp)+(96);
 var $__mbuf=(sp)+(104);
 var $__mi=(sp)+(504);
 var $__me=(sp)+(512);
 var $1=(sp)+(520);
 __ZNKSt3__18ios_base6getlocEv($__loc,$__iob);
 var $2=(($__loc)|0);
 var $3=HEAP32[(($2)>>2)];
 var $4=$__p_i_i_i_i;
 var $5=HEAP32[((14088)>>2)];
 var $6=($5|0)==-1;
 if($6){label=3;break;}else{label=2;break;}
 case 2: 
 var $_sroa_01_0___p67_i_idx_i_i_i=(($__p_i_i_i_i)|0);
 HEAP32[(($_sroa_01_0___p67_i_idx_i_i_i)>>2)]=14088;
 var $_sroa_12_4___p67_i_idx3_i_i_i=(($__p_i_i_i_i+4)|0);
 HEAP32[(($_sroa_12_4___p67_i_idx3_i_i_i)>>2)]=(28);
 var $_sroa_2_8___p67_i_idx4_i_i_i=(($__p_i_i_i_i+8)|0);
 HEAP32[(($_sroa_2_8___p67_i_idx4_i_i_i)>>2)]=0;
 (function() { try { __THREW__ = 0; return __ZNSt3__111__call_onceERVmPvPFvS2_E(14088,$4,260) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=3;break; } else { label=43;break; }
 case 3: 
 var $8=HEAP32[((14092)>>2)];
 var $9=((($8)-(1))|0);
 var $10=(($3+12)|0);
 var $11=HEAP32[(($10)>>2)];
 var $12=(($3+8)|0);
 var $13=HEAP32[(($12)>>2)];
 var $14=$11;
 var $15=$13;
 var $16=((($14)-($15))|0);
 var $17=$16>>2;
 var $18=($17>>>0)>($9>>>0);
 if($18){label=4;break;}else{label=5;break;}
 case 4: 
 var $19=(($13+($9<<2))|0);
 var $20=HEAP32[(($19)>>2)];
 var $21=($20|0)==0;
 if($21){label=5;break;}else{label=7;break;}
 case 5: 
 var $22=___cxa_allocate_exception(4);
 var $23=$22;
 __ZNSt8bad_castC2Ev($23);
 (function() { try { __THREW__ = 0; return ___cxa_throw($22,8960,(368)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=6;break; } else { label=43;break; }
 case 6: 
 throw "Reached an unreachable!";
 case 7: 
 var $25=$20;
 var $26=$__digits;
 var $27=HEAP8[($26)];
 var $28=$27&1;
 var $29=(($28<<24)>>24)==0;
 if($29){label=9;break;}else{label=8;break;}
 case 8: 
 var $31=(($__digits+4)|0);
 var $32=HEAP32[(($31)>>2)];
 var $36=$32;label=10;break;
 case 9: 
 var $34=($27&255);
 var $35=$34>>>1;
 var $36=$35;label=10;break;
 case 10: 
 var $36;
 var $37=($36|0)==0;
 if($37){var $53=0;label=16;break;}else{label=11;break;}
 case 11: 
 if($29){label=13;break;}else{label=12;break;}
 case 12: 
 var $40=(($__digits+8)|0);
 var $41=HEAP32[(($40)>>2)];
 var $44=$41;label=14;break;
 case 13: 
 var $43=(($__digits+4)|0);
 var $44=$43;label=14;break;
 case 14: 
 var $44;
 var $45=HEAP32[(($44)>>2)];
 var $46=$20;
 var $47=HEAP32[(($46)>>2)];
 var $48=(($47+44)|0);
 var $49=HEAP32[(($48)>>2)];
 var $50=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$49]($25,45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=15;break; } else { label=43;break; }
 case 15: 
 var $51=($45|0)==($50|0);
 var $53=$51;label=16;break;
 case 16: 
 var $53;
 var $this4_i_i_i=$__grp;
 HEAP32[(($this4_i_i_i)>>2)]=0; HEAP32[((($this4_i_i_i)+(4))>>2)]=0; HEAP32[((($this4_i_i_i)+(8))>>2)]=0;
 var $this4_i_i_i24=$__sym;
 HEAP32[(($this4_i_i_i24)>>2)]=0; HEAP32[((($this4_i_i_i24)+(4))>>2)]=0; HEAP32[((($this4_i_i_i24)+(8))>>2)]=0;
 var $this4_i_i_i25=$__sn;
 HEAP32[(($this4_i_i_i25)>>2)]=0; HEAP32[((($this4_i_i_i25)+(4))>>2)]=0; HEAP32[((($this4_i_i_i25)+(8))>>2)]=0;
 (function() { try { __THREW__ = 0; return __ZNSt3__111__money_putIwE13__gather_infoEbbRKNS_6localeERNS_10money_base7patternERwS8_RNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERNS9_IwNSA_IwEENSC_IwEEEESJ_Ri($__intl,$53,$__loc,$__pat,$__dp,$__ts,$__grp,$__sym,$__sn,$__fd) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=17;break; } else { label=44;break; }
 case 17: 
 var $55=(($__mbuf)|0);
 var $56=HEAP8[($26)];
 var $57=$56&1;
 var $58=(($57<<24)>>24)==0;
 if($58){label=19;break;}else{label=18;break;}
 case 18: 
 var $60=(($__digits+4)|0);
 var $61=HEAP32[(($60)>>2)];
 var $65=$61;label=20;break;
 case 19: 
 var $63=($56&255);
 var $64=$63>>>1;
 var $65=$64;label=20;break;
 case 20: 
 var $65;
 var $66=HEAP32[(($__fd)>>2)];
 var $67=($65|0)>($66|0);
 if($67){label=21;break;}else{label=31;break;}
 case 21: 
 if($58){label=23;break;}else{label=22;break;}
 case 22: 
 var $70=(($__digits+4)|0);
 var $71=HEAP32[(($70)>>2)];
 var $75=$71;label=24;break;
 case 23: 
 var $73=($56&255);
 var $74=$73>>>1;
 var $75=$74;label=24;break;
 case 24: 
 var $75;
 var $76=((($75)-($66))|0);
 var $77=$76<<1;
 var $78=HEAP8[($this4_i_i_i25)];
 var $79=$78&1;
 var $80=(($79<<24)>>24)==0;
 if($80){label=26;break;}else{label=25;break;}
 case 25: 
 var $82=(($__sn+4)|0);
 var $83=HEAP32[(($82)>>2)];
 var $87=$83;label=27;break;
 case 26: 
 var $85=($78&255);
 var $86=$85>>>1;
 var $87=$86;label=27;break;
 case 27: 
 var $87;
 var $88=HEAP8[($this4_i_i_i24)];
 var $89=$88&1;
 var $90=(($89<<24)>>24)==0;
 if($90){label=29;break;}else{label=28;break;}
 case 28: 
 var $92=(($__sym+4)|0);
 var $93=HEAP32[(($92)>>2)];
 var $97=$93;label=30;break;
 case 29: 
 var $95=($88&255);
 var $96=$95>>>1;
 var $97=$96;label=30;break;
 case 30: 
 var $97;
 var $98=$77|1;
 var $99=((($87)+($98))|0);
 var $100=((($99)+($97))|0);
 var $_pn=$100;label=38;break;
 case 31: 
 var $102=HEAP8[($this4_i_i_i25)];
 var $103=$102&1;
 var $104=(($103<<24)>>24)==0;
 if($104){label=33;break;}else{label=32;break;}
 case 32: 
 var $106=(($__sn+4)|0);
 var $107=HEAP32[(($106)>>2)];
 var $111=$107;label=34;break;
 case 33: 
 var $109=($102&255);
 var $110=$109>>>1;
 var $111=$110;label=34;break;
 case 34: 
 var $111;
 var $112=HEAP8[($this4_i_i_i24)];
 var $113=$112&1;
 var $114=(($113<<24)>>24)==0;
 if($114){label=36;break;}else{label=35;break;}
 case 35: 
 var $116=(($__sym+4)|0);
 var $117=HEAP32[(($116)>>2)];
 var $121=$117;label=37;break;
 case 36: 
 var $119=($112&255);
 var $120=$119>>>1;
 var $121=$120;label=37;break;
 case 37: 
 var $121;
 var $122=((($111)+(2))|0);
 var $123=((($122)+($121))|0);
 var $_pn=$123;label=38;break;
 case 38: 
 var $_pn;
 var $125=((($_pn)+($66))|0);
 var $126=($125>>>0)>100;
 if($126){label=39;break;}else{var $__mb_0=$55;var $152=0;var $151=$56;label=47;break;}
 case 39: 
 var $127=$125<<2;
 var $128=_malloc($127);
 var $129=$128;
 var $130=($128|0)==0;
 if($130){label=40;break;}else{var $__mb_0=$129;var $152=$129;var $151=$56;label=47;break;}
 case 40: 
 (function() { try { __THREW__ = 0; return __ZSt17__throw_bad_allocv() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=41;break; } else { label=42;break; }
 case 41: 
 var $_pre=HEAP8[($26)];
 var $__mb_0=0;var $152=0;var $151=$_pre;label=47;break;
 case 42: 
 var $132$0 = ___cxa_find_matching_catch(-1, -1); var $132$1 = tempRet0;
 var $133=$132$0;
 var $134=$132$1;
 var $_0=$133;var $_020=$134;label=55;break;
 case 43: 
 var $136$0 = ___cxa_find_matching_catch(-1, -1); var $136$1 = tempRet0;
 var $137=$136$0;
 var $138=$136$1;
 var $_1=$137;var $_121=$138;label=56;break;
 case 44: 
 var $140$0 = ___cxa_find_matching_catch(-1, -1); var $140$1 = tempRet0;
 var $141=$140$0;
 var $142=$140$1;
 var $_0=$141;var $_020=$142;label=55;break;
 case 45: 
 var $144$0 = ___cxa_find_matching_catch(-1, -1); var $144$1 = tempRet0;
 var $145=$144$0;
 var $146=$144$1;
 var $147=($152|0)==0;
 if($147){var $_0=$145;var $_020=$146;label=55;break;}else{label=46;break;}
 case 46: 
 var $149=$152;
 _free($149);
 var $_0=$145;var $_020=$146;label=55;break;
 case 47: 
 var $151;
 var $152;
 var $__mb_0;
 var $153=(($__iob+4)|0);
 var $154=HEAP32[(($153)>>2)];
 var $155=$151&1;
 var $156=(($155<<24)>>24)==0;
 if($156){label=49;break;}else{label=48;break;}
 case 48: 
 var $158=(($__digits+8)|0);
 var $159=HEAP32[(($158)>>2)];
 var $160=(($__digits+4)|0);
 var $161=HEAP32[(($160)>>2)];
 var $167=$161;var $166=$159;label=50;break;
 case 49: 
 var $163=(($__digits+4)|0);
 var $164=($151&255);
 var $165=$164>>>1;
 var $167=$165;var $166=$163;label=50;break;
 case 50: 
 var $166;
 var $167;
 var $168=(($166+($167<<2))|0);
 var $169=HEAP32[(($__dp)>>2)];
 var $170=HEAP32[(($__ts)>>2)];
 (function() { try { __THREW__ = 0; return __ZNSt3__111__money_putIwE8__formatEPwRS2_S3_jPKwS5_RKNS_5ctypeIwEEbRKNS_10money_base7patternEwwRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERKNSE_IwNSF_IwEENSH_IwEEEESQ_i($__mb_0,$__mi,$__me,$154,$166,$168,$25,$53,$__pat,$169,$170,$__grp,$__sym,$__sn,$66) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=51;break; } else { label=45;break; }
 case 51: 
 var $172=(($__s)|0);
 var $173=HEAP32[(($172)>>2)];
 var $174=(($1)|0);
 HEAP32[(($174)>>2)]=$173;
 var $175=HEAP32[(($__mi)>>2)];
 var $176=HEAP32[(($__me)>>2)];
 (function() { try { __THREW__ = 0; return __ZNSt3__116__pad_and_outputIwNS_11char_traitsIwEEEENS_19ostreambuf_iteratorIT_T0_EES6_PKS4_S8_S8_RNS_8ios_baseES4_($agg_result,$1,$__mb_0,$175,$176,$__iob,$__fl) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=52;break; } else { label=45;break; }
 case 52: 
 var $178=($152|0)==0;
 if($178){label=54;break;}else{label=53;break;}
 case 53: 
 var $180=$152;
 _free($180);
 label=54;break;
 case 54: 
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev($__sn);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev($__sym);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grp);
 var $181=HEAP32[(($2)>>2)];
 var $182=(($181)|0);
 var $183=__ZNSt3__114__shared_count16__release_sharedEv($182);
 STACKTOP=sp;return;
 case 55: 
 var $_020;
 var $_0;
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev($__sn);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev($__sym);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grp);
 var $_1=$_0;var $_121=$_020;label=56;break;
 case 56: 
 var $_121;
 var $_1;
 var $185=HEAP32[(($2)>>2)];
 var $186=(($185)|0);
 var $187=__ZNSt3__114__shared_count16__release_sharedEv($186);
 var $188$0=$_1;
 var $188$1=0;
 var $189$0=$188$0;
 var $189$1=$_121;
 ___resumeException($189$0)
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__18messagesIcED0Ev($this){
 var label=0;


 var $1=(($this)|0);
 __ZNSt3__114__shared_countD2Ev($1);
 var $2=$this;
 __ZdlPv($2);
 return;
}


function __ZNSt3__18messagesIcED1Ev($this){
 var label=0;


 var $1=(($this)|0);
 __ZNSt3__114__shared_countD2Ev($1);
 return;
}


function __ZNKSt3__18messagesIcE7do_openERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERKNS_6localeE($this,$__nm,$0){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $2=$__nm;
 var $3=HEAP8[($2)];
 var $4=$3&1;
 var $5=(($4<<24)>>24)==0;
 if($5){label=3;break;}else{label=2;break;}
 case 2: 
 var $7=(($__nm+8)|0);
 var $8=HEAP32[(($7)>>2)];
 var $12=$8;label=4;break;
 case 3: 
 var $10=$__nm;
 var $11=(($10+1)|0);
 var $12=$11;label=4;break;
 case 4: 
 var $12;
 var $13=_catopen($12,1);
 var $14=$13;
 var $not_=($13|0)!=-1;
 var $15=($not_&1);
 var $__cat_0=$14>>>($15>>>0);
 return $__cat_0;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__18messagesIcE6do_getEiiiRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE($agg_result,$this,$__c,$__set,$__msgid,$__dflt){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+16)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $__ndflt=sp;
 var $this4_i_i_i=$__ndflt;
 HEAP32[(($this4_i_i_i)>>2)]=0; HEAP32[((($this4_i_i_i)+(4))>>2)]=0; HEAP32[((($this4_i_i_i)+(8))>>2)]=0;
 var $1=$__dflt;
 var $2=HEAP8[($1)];
 var $3=$2&1;
 var $4=(($3<<24)>>24)==0;
 if($4){label=3;break;}else{label=2;break;}
 case 2: 
 var $6=(($__dflt+8)|0);
 var $7=HEAP32[(($6)>>2)];
 var $8=(($__dflt+4)|0);
 var $9=HEAP32[(($8)>>2)];
 var $19=$9;var $18=$7;var $17=$7;label=4;break;
 case 3: 
 var $11=$__dflt;
 var $12=(($11+1)|0);
 var $13=$__dflt;
 var $14=(($13+1)|0);
 var $15=($2&255);
 var $16=$15>>>1;
 var $19=$16;var $18=$12;var $17=$14;label=4;break;
 case 4: 
 var $17;
 var $18;
 var $19;
 var $20=(($17+$19)|0);
 var $21=($18>>>0)<($20>>>0);
 if($21){var $_05_i20=$18;label=6;break;}else{label=5;break;}
 case 5: 
 var $22=($__c|0)==-1;
 var $23=$__c<<1;
 var $24=$23;
 var $25=($22?-1:$24);
 var $37=$25;label=10;break;
 case 6: 
 var $_05_i20;
 var $26=HEAP8[($_05_i20)];
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9push_backEc($__ndflt,$26) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=7;break; } else { label=12;break; }
 case 7: 
 var $27=(($_05_i20+1)|0);
 var $28=($27>>>0)<($20>>>0);
 if($28){var $_05_i20=$27;label=6;break;}else{label=8;break;}
 case 8: 
 var $_pre=HEAP8[($this4_i_i_i)];
 var $phitmp=$_pre&1;
 var $phitmp30=(($phitmp<<24)>>24)==0;
 var $29=($__c|0)==-1;
 var $30=$__c<<1;
 var $31=$30;
 var $32=($29?-1:$31);
 if($phitmp30){var $37=$32;label=10;break;}else{label=9;break;}
 case 9: 
 var $34=(($__ndflt+8)|0);
 var $35=HEAP32[(($34)>>2)];
 var $41=$35;var $40=$32;label=11;break;
 case 10: 
 var $37;
 var $38=$__ndflt;
 var $39=(($38+1)|0);
 var $41=$39;var $40=$37;label=11;break;
 case 11: 
 var $40;
 var $41;
 var $42=(function() { try { __THREW__ = 0; return _catgets($40,$__set,$__msgid,$41) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=15;break; } else { label=13;break; }
 case 12: 
 var $lpad_loopexit$0 = ___cxa_find_matching_catch(-1, -1); var $lpad_loopexit$1 = tempRet0;
 var $lpad_phi$1=$lpad_loopexit$1;var $lpad_phi$0=$lpad_loopexit$0;label=14;break;
 case 13: 
 var $lpad_nonloopexit$0 = ___cxa_find_matching_catch(-1, -1); var $lpad_nonloopexit$1 = tempRet0;
 var $lpad_phi$1=$lpad_nonloopexit$1;var $lpad_phi$0=$lpad_nonloopexit$0;label=14;break;
 case 14: 
 var $lpad_phi$0;
 var $lpad_phi$1;
 var $44=$lpad_phi$0;
 var $45=$lpad_phi$1;
 var $_014=$44;var $_015=$45;label=20;break;
 case 15: 
 var $this4_i_i_i17=$agg_result;
 HEAP32[(($this4_i_i_i17)>>2)]=0; HEAP32[((($this4_i_i_i17)+(4))>>2)]=0; HEAP32[((($this4_i_i_i17)+(8))>>2)]=0;
 var $47=_strlen($42);
 var $48=(($42+$47)|0);
 var $49=($47|0)>0;
 if($49){var $_05_i=$42;label=16;break;}else{label=19;break;}
 case 16: 
 var $_05_i;
 var $50=HEAP8[($_05_i)];
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9push_backEc($agg_result,$50) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=17;break; } else { label=18;break; }
 case 17: 
 var $51=(($_05_i+1)|0);
 var $52=($51>>>0)<($48>>>0);
 if($52){var $_05_i=$51;label=16;break;}else{label=19;break;}
 case 18: 
 var $54$0 = ___cxa_find_matching_catch(-1, -1); var $54$1 = tempRet0;
 var $55=$54$0;
 var $56=$54$1;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($agg_result);
 var $_014=$55;var $_015=$56;label=20;break;
 case 19: 
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__ndflt);
 STACKTOP=sp;return;
 case 20: 
 var $_015;
 var $_014;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__ndflt);
 var $58$0=$_014;
 var $58$1=0;
 var $59$0=$58$0;
 var $59$1=$_015;
 ___resumeException($59$0)
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__18messagesIcE8do_closeEi($this,$__c){
 var label=0;


 var $1=($__c|0)==-1;
 var $2=$__c<<1;
 var $3=$2;
 var $4=($1?-1:$3);
 var $5=_catclose($4);
 return;
}


function __ZNSt3__18messagesIwED0Ev($this){
 var label=0;


 var $1=(($this)|0);
 __ZNSt3__114__shared_countD2Ev($1);
 var $2=$this;
 __ZdlPv($2);
 return;
}


function __ZNSt3__18messagesIwED1Ev($this){
 var label=0;


 var $1=(($this)|0);
 __ZNSt3__114__shared_countD2Ev($1);
 return;
}


function __ZNKSt3__18messagesIwE7do_openERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERKNS_6localeE($this,$__nm,$0){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $2=$__nm;
 var $3=HEAP8[($2)];
 var $4=$3&1;
 var $5=(($4<<24)>>24)==0;
 if($5){label=3;break;}else{label=2;break;}
 case 2: 
 var $7=(($__nm+8)|0);
 var $8=HEAP32[(($7)>>2)];
 var $12=$8;label=4;break;
 case 3: 
 var $10=$__nm;
 var $11=(($10+1)|0);
 var $12=$11;label=4;break;
 case 4: 
 var $12;
 var $13=_catopen($12,1);
 var $14=$13;
 var $not_=($13|0)!=-1;
 var $15=($not_&1);
 var $__cat_0=$14>>>($15>>>0);
 return $__cat_0;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__18messagesIwE6do_getEiiiRKNS_12basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEE($agg_result,$this,$__c,$__set,$__msgid,$__dflt){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+240)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $__mb_i24=sp;
 var $__buf_i25=(sp)+(8);
 var $__bn_i26=(sp)+(40);
 var $__wn_i=(sp)+(48);
 var $__mb_i=(sp)+(56);
 var $__buf_i=(sp)+(64);
 var $__bn_i=(sp)+(192);
 var $__nn_i=(sp)+(200);
 var $__ndflt=(sp)+(208);
 var $1=(sp)+(224);
 var $2=(sp)+(232);
 var $this4_i_i_i=$__ndflt;
 HEAP32[(($this4_i_i_i)>>2)]=0; HEAP32[((($this4_i_i_i)+(4))>>2)]=0; HEAP32[((($this4_i_i_i)+(8))>>2)]=0;
 var $3=(($1+4)|0);
 HEAP32[(($3)>>2)]=0;
 var $4=(($1)|0);
 HEAP32[(($4)>>2)]=4680;
 var $5=$__dflt;
 var $6=HEAP8[($5)];
 var $7=$6&1;
 var $8=(($7<<24)>>24)==0;
 if($8){label=3;break;}else{label=2;break;}
 case 2: 
 var $10=(($__dflt+8)|0);
 var $11=HEAP32[(($10)>>2)];
 var $12=(($__dflt+4)|0);
 var $13=HEAP32[(($12)>>2)];
 var $21=$13;var $20=$11;var $19=$11;label=4;break;
 case 3: 
 var $15=(($__dflt+4)|0);
 var $16=(($__dflt+4)|0);
 var $17=($6&255);
 var $18=$17>>>1;
 var $21=$18;var $20=$15;var $19=$16;label=4;break;
 case 4: 
 var $19;
 var $20;
 var $21;
 var $22=(($19+($21<<2))|0);
 var $23=$__mb_i24;
 var $24=(($__buf_i25)|0);
 var $25=$__bn_i26;
 var $26=$__wn_i;
 var $27=($20>>>0)<($22>>>0);
 if($27){label=5;break;}else{label=16;break;}
 case 5: 
 var $28=(($1)|0);
 var $29=$1;
 var $30=(($__buf_i25+32)|0);
 var $_013_i=$20;var $32=4680;label=6;break;
 case 6: 
 var $32;
 var $_013_i;
 HEAP32[(($__wn_i)>>2)]=$_013_i;
 var $33=(($32+12)|0);
 var $34=HEAP32[(($33)>>2)];
 var $35=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$34]($28,$__mb_i24,$_013_i,$22,$__wn_i,$24,$30,$__bn_i26) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=7;break; } else { label=22;break; }
 case 7: 
 var $36=($35|0)==2;
 var $37=HEAP32[(($__wn_i)>>2)];
 var $38=($37|0)==($_013_i|0);
 var $or_cond11_i=$36|$38;
 if($or_cond11_i){label=9;break;}else{label=8;break;}
 case 8: 
 var $39=HEAP32[(($__bn_i26)>>2)];
 var $40=($24>>>0)<($39>>>0);
 if($40){var $__p_012_i=$24;label=11;break;}else{var $47=$37;label=14;break;}
 case 9: 
 (function() { try { __THREW__ = 0; return __ZNSt3__121__throw_runtime_errorEPKc(960) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=10;break; } else { label=23;break; }
 case 10: 
 throw "Reached an unreachable!";
 case 11: 
 var $__p_012_i;
 var $42=HEAP8[($__p_012_i)];
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9push_backEc($__ndflt,$42) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=12;break; } else { label=21;break; }
 case 12: 
 var $43=(($__p_012_i+1)|0);
 var $44=HEAP32[(($__bn_i26)>>2)];
 var $45=($43>>>0)<($44>>>0);
 if($45){var $__p_012_i=$43;label=11;break;}else{label=13;break;}
 case 13: 
 var $_pre_i29=HEAP32[(($__wn_i)>>2)];
 var $47=$_pre_i29;label=14;break;
 case 14: 
 var $47;
 var $48=($47>>>0)<($22>>>0);
 if($48){label=15;break;}else{label=16;break;}
 case 15: 
 var $_pre=HEAP32[(($29)>>2)];
 var $_013_i=$47;var $32=$_pre;label=6;break;
 case 16: 
 var $49=(($1)|0);
 __ZNSt3__114__shared_countD2Ev($49);
 var $50=($__c|0)==-1;
 var $51=$__c<<1;
 var $52=$51;
 var $53=($50?-1:$52);
 var $54=HEAP8[($this4_i_i_i)];
 var $55=$54&1;
 var $56=(($55<<24)>>24)==0;
 if($56){label=18;break;}else{label=17;break;}
 case 17: 
 var $58=(($__ndflt+8)|0);
 var $59=HEAP32[(($58)>>2)];
 var $63=$59;label=19;break;
 case 18: 
 var $61=$__ndflt;
 var $62=(($61+1)|0);
 var $63=$62;label=19;break;
 case 19: 
 var $63;
 var $64=(function() { try { __THREW__ = 0; return _catgets($53,$__set,$__msgid,$63) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=25;break; } else { label=20;break; }
 case 20: 
 var $66$0 = ___cxa_find_matching_catch(-1, -1); var $66$1 = tempRet0;
 var $67=$66$0;
 var $68=$66$1;
 var $_1=$67;var $_116=$68;label=42;break;
 case 21: 
 var $lpad_loopexit48$0 = ___cxa_find_matching_catch(-1, -1); var $lpad_loopexit48$1 = tempRet0;
 var $lpad_phi49$1=$lpad_loopexit48$1;var $lpad_phi49$0=$lpad_loopexit48$0;label=24;break;
 case 22: 
 var $lpad_loopexit50$0 = ___cxa_find_matching_catch(-1, -1); var $lpad_loopexit50$1 = tempRet0;
 var $lpad_phi49$1=$lpad_loopexit50$1;var $lpad_phi49$0=$lpad_loopexit50$0;label=24;break;
 case 23: 
 var $lpad_nonloopexit51$0 = ___cxa_find_matching_catch(-1, -1); var $lpad_nonloopexit51$1 = tempRet0;
 var $lpad_phi49$1=$lpad_nonloopexit51$1;var $lpad_phi49$0=$lpad_nonloopexit51$0;label=24;break;
 case 24: 
 var $lpad_phi49$0;
 var $lpad_phi49$1;
 var $69=$lpad_phi49$0;
 var $70=$lpad_phi49$1;
 var $71=(($1)|0);
 __ZNSt3__114__shared_countD2Ev($71);
 var $_1=$69;var $_116=$70;label=42;break;
 case 25: 
 var $this4_i_i_i21=$agg_result;
 HEAP32[(($this4_i_i_i21)>>2)]=0; HEAP32[((($this4_i_i_i21)+(4))>>2)]=0; HEAP32[((($this4_i_i_i21)+(8))>>2)]=0;
 var $73=(($2+4)|0);
 HEAP32[(($73)>>2)]=0;
 var $74=(($2)|0);
 HEAP32[(($74)>>2)]=4624;
 var $75=_strlen($64);
 var $76=(($64+$75)|0);
 var $77=$__mb_i;
 var $78=$__buf_i;
 var $79=$__bn_i;
 var $80=$__nn_i;
 var $81=($75|0)>0;
 if($81){label=26;break;}else{label=37;break;}
 case 26: 
 var $82=(($2)|0);
 var $83=$2;
 var $84=$76;
 var $85=(($__buf_i)|0);
 var $86=(($__buf_i+128)|0);
 var $_016_i=$64;var $88=4624;label=27;break;
 case 27: 
 var $88;
 var $_016_i;
 HEAP32[(($__nn_i)>>2)]=$_016_i;
 var $89=(($88+16)|0);
 var $90=HEAP32[(($89)>>2)];
 var $91=$_016_i;
 var $92=((($84)-($91))|0);
 var $93=($92|0)>32;
 var $94=(($_016_i+32)|0);
 var $95=($93?$94:$76);
 var $96=(function() { try { __THREW__ = 0; return FUNCTION_TABLE[$90]($82,$__mb_i,$_016_i,$95,$__nn_i,$85,$86,$__bn_i) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=28;break; } else { label=39;break; }
 case 28: 
 var $97=($96|0)==2;
 var $98=HEAP32[(($__nn_i)>>2)];
 var $99=($98|0)==($_016_i|0);
 var $or_cond14_i=$97|$99;
 if($or_cond14_i){label=30;break;}else{label=29;break;}
 case 29: 
 var $100=HEAP32[(($__bn_i)>>2)];
 var $101=($85>>>0)<($100>>>0);
 if($101){var $__p_015_i=$85;label=32;break;}else{var $108=$98;label=35;break;}
 case 30: 
 (function() { try { __THREW__ = 0; return __ZNSt3__121__throw_runtime_errorEPKc(960) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=31;break; } else { label=40;break; }
 case 31: 
 throw "Reached an unreachable!";
 case 32: 
 var $__p_015_i;
 var $103=HEAP32[(($__p_015_i)>>2)];
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE9push_backEw($agg_result,$103) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=33;break; } else { label=38;break; }
 case 33: 
 var $104=(($__p_015_i+4)|0);
 var $105=HEAP32[(($__bn_i)>>2)];
 var $106=($104>>>0)<($105>>>0);
 if($106){var $__p_015_i=$104;label=32;break;}else{label=34;break;}
 case 34: 
 var $_pre_i=HEAP32[(($__nn_i)>>2)];
 var $108=$_pre_i;label=35;break;
 case 35: 
 var $108;
 var $109=($108>>>0)<($76>>>0);
 if($109){label=36;break;}else{label=37;break;}
 case 36: 
 var $_pre55=HEAP32[(($83)>>2)];
 var $_016_i=$108;var $88=$_pre55;label=27;break;
 case 37: 
 var $110=(($2)|0);
 __ZNSt3__114__shared_countD2Ev($110);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__ndflt);
 STACKTOP=sp;return;
 case 38: 
 var $lpad_loopexit$0 = ___cxa_find_matching_catch(-1, -1); var $lpad_loopexit$1 = tempRet0;
 var $lpad_phi$1=$lpad_loopexit$1;var $lpad_phi$0=$lpad_loopexit$0;label=41;break;
 case 39: 
 var $lpad_loopexit42$0 = ___cxa_find_matching_catch(-1, -1); var $lpad_loopexit42$1 = tempRet0;
 var $lpad_phi$1=$lpad_loopexit42$1;var $lpad_phi$0=$lpad_loopexit42$0;label=41;break;
 case 40: 
 var $lpad_nonloopexit43$0 = ___cxa_find_matching_catch(-1, -1); var $lpad_nonloopexit43$1 = tempRet0;
 var $lpad_phi$1=$lpad_nonloopexit43$1;var $lpad_phi$0=$lpad_nonloopexit43$0;label=41;break;
 case 41: 
 var $lpad_phi$0;
 var $lpad_phi$1;
 var $111=$lpad_phi$0;
 var $112=$lpad_phi$1;
 var $113=(($2)|0);
 __ZNSt3__114__shared_countD2Ev($113);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev($agg_result);
 var $_1=$111;var $_116=$112;label=42;break;
 case 42: 
 var $_116;
 var $_1;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__ndflt);
 var $115$0=$_1;
 var $115$1=0;
 var $116$0=$115$0;
 var $116$1=$_116;
 ___resumeException($116$0)
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__18messagesIwE8do_closeEi($this,$__c){
 var label=0;


 var $1=($__c|0)==-1;
 var $2=$__c<<1;
 var $3=$2;
 var $4=($1?-1:$3);
 var $5=_catclose($4);
 return;
}


function __ZNSt3__17codecvtIwc11__mbstate_tED2Ev($this){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=(($this)|0);
 HEAP32[(($1)>>2)]=4144;
 var $2=(($this+8)|0);
 var $3=HEAP32[(($2)>>2)];
 var $4=HEAP8[(14656)];
 var $5=(($4<<24)>>24)==0;
 if($5){label=2;break;}else{label=6;break;}
 case 2: 
 var $7=___cxa_guard_acquire(14656);
 var $8=($7|0)==0;
 if($8){label=6;break;}else{label=3;break;}
 case 3: 
 var $10=(function() { try { __THREW__ = 0; return _newlocale(2147483647,1496,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=4;break; } else { label=5;break; }
 case 4: 
 HEAP32[((12664)>>2)]=$10;

 label=6;break;
 case 5: 
 var $13$0 = ___cxa_find_matching_catch(-1, -1,0); var $13$1 = tempRet0;

 label=9;break;
 case 6: 
 var $15=HEAP32[((12664)>>2)];
 var $16=($3|0)==($15|0);
 if($16){label=10;break;}else{label=7;break;}
 case 7: 
 var $18=HEAP32[(($2)>>2)];
 (function() { try { __THREW__ = 0; return _freelocale($18) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=10;break; } else { label=8;break; }
 case 8: 
 var $20$0 = ___cxa_find_matching_catch(-1, -1,0); var $20$1 = tempRet0;
 label=9;break;
 case 9: 
 var $21=(($this)|0);
 __ZNSt3__114__shared_countD2Ev($21);
 __ZSt9terminatev();
 throw "Reached an unreachable!";
 case 10: 
 var $23=(($this)|0);
 __ZNSt3__114__shared_countD2Ev($23);
 return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__120__vector_base_commonILb1EE20__throw_length_errorEv($this){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=___cxa_allocate_exception(8);
 var $2=$1;
 (function() { try { __THREW__ = 0; return __ZNSt11logic_errorC2EPKc($2,1512) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=2;break; } else { label=3;break; }
 case 2: 
 var $4=$1;
 HEAP32[(($4)>>2)]=3056;
 ___cxa_throw($1,9008,(76));
 throw "Reached an unreachable!";
 case 3: 
 var $6$0 = ___cxa_find_matching_catch(-1, -1); var $6$1 = tempRet0;
 ___cxa_free_exception($1);
 ___resumeException($6$0)
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__120__vector_base_commonILb1EE20__throw_out_of_rangeEv($this){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=___cxa_allocate_exception(8);
 var $2=$1;
 (function() { try { __THREW__ = 0; return __ZNSt11logic_errorC2EPKc($2,1512) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=2;break; } else { label=3;break; }
 case 2: 
 var $4=$1;
 HEAP32[(($4)>>2)]=3024;
 ___cxa_throw($1,8992,(14));
 throw "Reached an unreachable!";
 case 3: 
 var $6$0 = ___cxa_find_matching_catch(-1, -1); var $6$1 = tempRet0;
 ___cxa_free_exception($1);
 ___resumeException($6$0)
  default: assert(0, "bad label: " + label);
 }

}



function __ZNSt3__16locale5__impC2Ej($this,$refs){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+448)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $__p_i_i_i194=sp;
 var $__p_i_i_i187=(sp)+(16);
 var $__p_i_i_i177=(sp)+(32);
 var $__p_i_i_i168=(sp)+(48);
 var $__p_i_i_i161=(sp)+(64);
 var $__p_i_i_i154=(sp)+(80);
 var $__p_i_i_i147=(sp)+(96);
 var $__p_i_i_i140=(sp)+(112);
 var $__p_i_i_i133=(sp)+(128);
 var $__p_i_i_i126=(sp)+(144);
 var $__p_i_i_i119=(sp)+(160);
 var $__p_i_i_i112=(sp)+(176);
 var $__p_i_i_i105=(sp)+(192);
 var $__p_i_i_i98=(sp)+(208);
 var $__p_i_i_i91=(sp)+(224);
 var $__p_i_i_i84=(sp)+(240);
 var $__p_i_i_i77=(sp)+(256);
 var $__p_i_i_i70=(sp)+(272);
 var $__p_i_i_i63=(sp)+(288);
 var $__p_i_i_i56=(sp)+(304);
 var $__p_i_i_i49=(sp)+(320);
 var $__p_i_i_i42=(sp)+(336);
 var $__p_i_i_i35=(sp)+(352);
 var $__p_i_i_i28=(sp)+(368);
 var $__p_i_i_i21=(sp)+(384);
 var $__p_i_i_i14=(sp)+(400);
 var $__p_i_i_i7=(sp)+(416);
 var $__p_i_i_i=(sp)+(432);
 var $1=((($refs)-(1))|0);
 var $2=(($this+4)|0);
 HEAP32[(($2)>>2)]=$1;
 var $3=(($this)|0);
 HEAP32[(($3)>>2)]=4400;
 var $4=(($this+8)|0);
 var $5=(($this+12)|0);
 var $6=(($this+16)|0);
 var $7=(($this+136)|0);
 var $8=(($this+24)|0);
 HEAP8[($7)]=1;
 var $9=$8;
 HEAP32[(($5)>>2)]=$9;
 HEAP32[(($4)>>2)]=$9;
 var $10=$7;
 HEAP32[(($6)>>2)]=$10;
 var $_0_i_i=28;var $12=$9;label=2;break;
 case 2: 
 var $12;
 var $_0_i_i;
 var $13=($12|0)==0;
 if($13){var $15=0;label=4;break;}else{label=3;break;}
 case 3: 
 HEAP32[(($12)>>2)]=0;
 var $_pre3_i_i=HEAP32[(($5)>>2)];
 var $15=$_pre3_i_i;label=4;break;
 case 4: 
 var $15;
 var $16=(($15+4)|0);
 HEAP32[(($5)>>2)]=$16;
 var $17=((($_0_i_i)-(1))|0);
 var $18=($17|0)==0;
 if($18){label=5;break;}else{var $_0_i_i=$17;var $12=$16;label=2;break;}
 case 5: 
 var $19=(($this+144)|0);
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj($19,1496,1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=6;break; } else { label=110;break; }
 case 6: 
 var $20=HEAP32[(($4)>>2)];
 var $21=HEAP32[(($5)>>2)];
 var $22=($21|0)==($20|0);
 if($22){label=8;break;}else{label=7;break;}
 case 7: 
 var $__new_last3_i_i_i=$20;
 var $scevgep_i_i_i=((($21)-(4))|0);
 var $scevgep2_i_i_i=$scevgep_i_i_i;
 var $23=(((-$__new_last3_i_i_i))|0);
 var $uglygep_i_i_i=(($scevgep2_i_i_i+$23)|0);
 var $uglygep4_i_i_i=$uglygep_i_i_i;
 var $24=$uglygep4_i_i_i>>>2;
 var $25=$24^-1;
 var $scevgep5_i_i_i=(($21+($25<<2))|0);
 HEAP32[(($5)>>2)]=$scevgep5_i_i_i;
 label=8;break;
 case 8: 
 HEAP32[((12796)>>2)]=0;
 HEAP32[((12792)>>2)]=4104;
 var $27=$__p_i_i_i7;
 var $28=HEAP32[((13776)>>2)];
 var $29=($28|0)==-1;
 if($29){label=10;break;}else{label=9;break;}
 case 9: 
 var $_sroa_01_0___p67_i_idx_i_i8=(($__p_i_i_i7)|0);
 HEAP32[(($_sroa_01_0___p67_i_idx_i_i8)>>2)]=13776;
 var $_sroa_12_4___p67_i_idx3_i_i9=(($__p_i_i_i7+4)|0);
 HEAP32[(($_sroa_12_4___p67_i_idx3_i_i9)>>2)]=(28);
 var $_sroa_2_8___p67_i_idx4_i_i10=(($__p_i_i_i7+8)|0);
 HEAP32[(($_sroa_2_8___p67_i_idx4_i_i10)>>2)]=0;
 (function() { try { __THREW__ = 0; return __ZNSt3__111__call_onceERVmPvPFvS2_E(13776,$27,260) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=10;break; } else { label=111;break; }
 case 10: 
 var $31=HEAP32[((13780)>>2)];
 var $32=((($31)-(1))|0);
 (function() { try { __THREW__ = 0; return __ZNSt3__16locale5__imp7installEPNS0_5facetEl($this,12792,$32) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=11;break; } else { label=111;break; }
 case 11: 
 HEAP32[((12788)>>2)]=0;
 HEAP32[((12784)>>2)]=4064;
 var $34=$__p_i_i_i14;
 var $35=HEAP32[((13768)>>2)];
 var $36=($35|0)==-1;
 if($36){label=13;break;}else{label=12;break;}
 case 12: 
 var $_sroa_01_0___p67_i_idx_i_i15=(($__p_i_i_i14)|0);
 HEAP32[(($_sroa_01_0___p67_i_idx_i_i15)>>2)]=13768;
 var $_sroa_12_4___p67_i_idx3_i_i16=(($__p_i_i_i14+4)|0);
 HEAP32[(($_sroa_12_4___p67_i_idx3_i_i16)>>2)]=(28);
 var $_sroa_2_8___p67_i_idx4_i_i17=(($__p_i_i_i14+8)|0);
 HEAP32[(($_sroa_2_8___p67_i_idx4_i_i17)>>2)]=0;
 (function() { try { __THREW__ = 0; return __ZNSt3__111__call_onceERVmPvPFvS2_E(13768,$34,260) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=13;break; } else { label=111;break; }
 case 13: 
 var $38=HEAP32[((13772)>>2)];
 var $39=((($38)-(1))|0);
 (function() { try { __THREW__ = 0; return __ZNSt3__16locale5__imp7installEPNS0_5facetEl($this,12784,$39) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=14;break; } else { label=111;break; }
 case 14: 
 HEAP32[((12996)>>2)]=0;
 HEAP32[((12992)>>2)]=4512;
 HEAP32[((13000)>>2)]=0;
 HEAP8[(13004)]=0;
 var $40=(function() { try { __THREW__ = 0; return ___ctype_b_loc() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=16;break; } else { label=15;break; }
 case 15: 
 var $42$0 = ___cxa_find_matching_catch(-1, -1,0); var $42$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
 case 16: 
 var $44=HEAP32[(($40)>>2)];
 HEAP32[((13000)>>2)]=$44;
 var $45=$__p_i_i_i21;
 var $46=HEAP32[((14096)>>2)];
 var $47=($46|0)==-1;
 if($47){label=18;break;}else{label=17;break;}
 case 17: 
 var $_sroa_01_0___p67_i_idx_i_i22=(($__p_i_i_i21)|0);
 HEAP32[(($_sroa_01_0___p67_i_idx_i_i22)>>2)]=14096;
 var $_sroa_12_4___p67_i_idx3_i_i23=(($__p_i_i_i21+4)|0);
 HEAP32[(($_sroa_12_4___p67_i_idx3_i_i23)>>2)]=(28);
 var $_sroa_2_8___p67_i_idx4_i_i24=(($__p_i_i_i21+8)|0);
 HEAP32[(($_sroa_2_8___p67_i_idx4_i_i24)>>2)]=0;
 (function() { try { __THREW__ = 0; return __ZNSt3__111__call_onceERVmPvPFvS2_E(14096,$45,260) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=18;break; } else { label=111;break; }
 case 18: 
 var $49=HEAP32[((14100)>>2)];
 var $50=((($49)-(1))|0);
 (function() { try { __THREW__ = 0; return __ZNSt3__16locale5__imp7installEPNS0_5facetEl($this,12992,$50) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=19;break; } else { label=111;break; }
 case 19: 
 HEAP32[((12988)>>2)]=0;
 HEAP32[((12984)>>2)]=4432;
 var $52=$__p_i_i_i28;
 var $53=HEAP32[((14088)>>2)];
 var $54=($53|0)==-1;
 if($54){label=21;break;}else{label=20;break;}
 case 20: 
 var $_sroa_01_0___p67_i_idx_i_i29=(($__p_i_i_i28)|0);
 HEAP32[(($_sroa_01_0___p67_i_idx_i_i29)>>2)]=14088;
 var $_sroa_12_4___p67_i_idx3_i_i30=(($__p_i_i_i28+4)|0);
 HEAP32[(($_sroa_12_4___p67_i_idx3_i_i30)>>2)]=(28);
 var $_sroa_2_8___p67_i_idx4_i_i31=(($__p_i_i_i28+8)|0);
 HEAP32[(($_sroa_2_8___p67_i_idx4_i_i31)>>2)]=0;
 (function() { try { __THREW__ = 0; return __ZNSt3__111__call_onceERVmPvPFvS2_E(14088,$52,260) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=21;break; } else { label=111;break; }
 case 21: 
 var $56=HEAP32[((14092)>>2)];
 var $57=((($56)-(1))|0);
 (function() { try { __THREW__ = 0; return __ZNSt3__16locale5__imp7installEPNS0_5facetEl($this,12984,$57) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=22;break; } else { label=111;break; }
 case 22: 
 HEAP32[((12804)>>2)]=0;
 HEAP32[((12800)>>2)]=4200;
 var $59=$__p_i_i_i35;
 var $60=HEAP32[((13792)>>2)];
 var $61=($60|0)==-1;
 if($61){label=24;break;}else{label=23;break;}
 case 23: 
 var $_sroa_01_0___p67_i_idx_i_i36=(($__p_i_i_i35)|0);
 HEAP32[(($_sroa_01_0___p67_i_idx_i_i36)>>2)]=13792;
 var $_sroa_12_4___p67_i_idx3_i_i37=(($__p_i_i_i35+4)|0);
 HEAP32[(($_sroa_12_4___p67_i_idx3_i_i37)>>2)]=(28);
 var $_sroa_2_8___p67_i_idx4_i_i38=(($__p_i_i_i35+8)|0);
 HEAP32[(($_sroa_2_8___p67_i_idx4_i_i38)>>2)]=0;
 (function() { try { __THREW__ = 0; return __ZNSt3__111__call_onceERVmPvPFvS2_E(13792,$59,260) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=24;break; } else { label=111;break; }
 case 24: 
 var $63=HEAP32[((13796)>>2)];
 var $64=((($63)-(1))|0);
 (function() { try { __THREW__ = 0; return __ZNSt3__16locale5__imp7installEPNS0_5facetEl($this,12800,$64) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=25;break; } else { label=111;break; }
 case 25: 
 HEAP32[((2604)>>2)]=0;
 HEAP32[((2600)>>2)]=4144;
 var $65=HEAP8[(14656)];
 var $66=(($65<<24)>>24)==0;
 if($66){label=26;break;}else{label=30;break;}
 case 26: 
 var $68=___cxa_guard_acquire(14656);
 var $69=($68|0)==0;
 if($69){label=30;break;}else{label=27;break;}
 case 27: 
 var $71=(function() { try { __THREW__ = 0; return _newlocale(2147483647,1496,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=28;break; } else { label=29;break; }
 case 28: 
 HEAP32[((12664)>>2)]=$71;

 label=30;break;
 case 29: 
 var $73$0 = ___cxa_find_matching_catch(-1, -1); var $73$1 = tempRet0;

 __ZNSt3__114__shared_countD2Ev(2600);
 var $eh_lpad_body$1=$73$1;var $eh_lpad_body$0=$73$0;label=112;break;
 case 30: 
 var $75=HEAP32[((12664)>>2)];
 HEAP32[((2608)>>2)]=$75;
 var $76=$__p_i_i_i42;
 var $77=HEAP32[((13784)>>2)];
 var $78=($77|0)==-1;
 if($78){label=32;break;}else{label=31;break;}
 case 31: 
 var $_sroa_01_0___p67_i_idx_i_i43=(($__p_i_i_i42)|0);
 HEAP32[(($_sroa_01_0___p67_i_idx_i_i43)>>2)]=13784;
 var $_sroa_12_4___p67_i_idx3_i_i44=(($__p_i_i_i42+4)|0);
 HEAP32[(($_sroa_12_4___p67_i_idx3_i_i44)>>2)]=(28);
 var $_sroa_2_8___p67_i_idx4_i_i45=(($__p_i_i_i42+8)|0);
 HEAP32[(($_sroa_2_8___p67_i_idx4_i_i45)>>2)]=0;
 (function() { try { __THREW__ = 0; return __ZNSt3__111__call_onceERVmPvPFvS2_E(13784,$76,260) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=32;break; } else { label=111;break; }
 case 32: 
 var $80=HEAP32[((13788)>>2)];
 var $81=((($80)-(1))|0);
 (function() { try { __THREW__ = 0; return __ZNSt3__16locale5__imp7installEPNS0_5facetEl($this,2600,$81) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=33;break; } else { label=111;break; }
 case 33: 
 HEAP32[((12812)>>2)]=0;
 HEAP32[((12808)>>2)]=4256;
 var $83=$__p_i_i_i49;
 var $84=HEAP32[((13800)>>2)];
 var $85=($84|0)==-1;
 if($85){label=35;break;}else{label=34;break;}
 case 34: 
 var $_sroa_01_0___p67_i_idx_i_i50=(($__p_i_i_i49)|0);
 HEAP32[(($_sroa_01_0___p67_i_idx_i_i50)>>2)]=13800;
 var $_sroa_12_4___p67_i_idx3_i_i51=(($__p_i_i_i49+4)|0);
 HEAP32[(($_sroa_12_4___p67_i_idx3_i_i51)>>2)]=(28);
 var $_sroa_2_8___p67_i_idx4_i_i52=(($__p_i_i_i49+8)|0);
 HEAP32[(($_sroa_2_8___p67_i_idx4_i_i52)>>2)]=0;
 (function() { try { __THREW__ = 0; return __ZNSt3__111__call_onceERVmPvPFvS2_E(13800,$83,260) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=35;break; } else { label=111;break; }
 case 35: 
 var $87=HEAP32[((13804)>>2)];
 var $88=((($87)-(1))|0);
 (function() { try { __THREW__ = 0; return __ZNSt3__16locale5__imp7installEPNS0_5facetEl($this,12808,$88) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=36;break; } else { label=111;break; }
 case 36: 
 HEAP32[((12820)>>2)]=0;
 HEAP32[((12816)>>2)]=4312;
 var $90=$__p_i_i_i56;
 var $91=HEAP32[((13808)>>2)];
 var $92=($91|0)==-1;
 if($92){label=38;break;}else{label=37;break;}
 case 37: 
 var $_sroa_01_0___p67_i_idx_i_i57=(($__p_i_i_i56)|0);
 HEAP32[(($_sroa_01_0___p67_i_idx_i_i57)>>2)]=13808;
 var $_sroa_12_4___p67_i_idx3_i_i58=(($__p_i_i_i56+4)|0);
 HEAP32[(($_sroa_12_4___p67_i_idx3_i_i58)>>2)]=(28);
 var $_sroa_2_8___p67_i_idx4_i_i59=(($__p_i_i_i56+8)|0);
 HEAP32[(($_sroa_2_8___p67_i_idx4_i_i59)>>2)]=0;
 (function() { try { __THREW__ = 0; return __ZNSt3__111__call_onceERVmPvPFvS2_E(13808,$90,260) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=38;break; } else { label=111;break; }
 case 38: 
 var $94=HEAP32[((13812)>>2)];
 var $95=((($94)-(1))|0);
 (function() { try { __THREW__ = 0; return __ZNSt3__16locale5__imp7installEPNS0_5facetEl($this,12816,$95) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=39;break; } else { label=111;break; }
 case 39: 
 HEAP32[((12716)>>2)]=0;
 HEAP32[((12712)>>2)]=3608;
 HEAP8[(12720)]=46;
 HEAP8[(12721)]=44;
 HEAP32[((12724)>>2)]=0; HEAP32[((12728)>>2)]=0; HEAP32[((12732)>>2)]=0;
 var $97=$__p_i_i_i63;
 var $98=HEAP32[((13712)>>2)];
 var $99=($98|0)==-1;
 if($99){label=41;break;}else{label=40;break;}
 case 40: 
 var $_sroa_01_0___p67_i_idx_i_i64=(($__p_i_i_i63)|0);
 HEAP32[(($_sroa_01_0___p67_i_idx_i_i64)>>2)]=13712;
 var $_sroa_12_4___p67_i_idx3_i_i65=(($__p_i_i_i63+4)|0);
 HEAP32[(($_sroa_12_4___p67_i_idx3_i_i65)>>2)]=(28);
 var $_sroa_2_8___p67_i_idx4_i_i66=(($__p_i_i_i63+8)|0);
 HEAP32[(($_sroa_2_8___p67_i_idx4_i_i66)>>2)]=0;
 (function() { try { __THREW__ = 0; return __ZNSt3__111__call_onceERVmPvPFvS2_E(13712,$97,260) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=41;break; } else { label=111;break; }
 case 41: 
 var $101=HEAP32[((13716)>>2)];
 var $102=((($101)-(1))|0);
 (function() { try { __THREW__ = 0; return __ZNSt3__16locale5__imp7installEPNS0_5facetEl($this,12712,$102) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=42;break; } else { label=111;break; }
 case 42: 
 HEAP32[((2572)>>2)]=0;
 HEAP32[((2568)>>2)]=3560;
 HEAP32[((2576)>>2)]=46;
 HEAP32[((2580)>>2)]=44;
 HEAP32[((2584)>>2)]=0; HEAP32[((2588)>>2)]=0; HEAP32[((2592)>>2)]=0;
 var $104=$__p_i_i_i70;
 var $105=HEAP32[((13704)>>2)];
 var $106=($105|0)==-1;
 if($106){label=44;break;}else{label=43;break;}
 case 43: 
 var $_sroa_01_0___p67_i_idx_i_i71=(($__p_i_i_i70)|0);
 HEAP32[(($_sroa_01_0___p67_i_idx_i_i71)>>2)]=13704;
 var $_sroa_12_4___p67_i_idx3_i_i72=(($__p_i_i_i70+4)|0);
 HEAP32[(($_sroa_12_4___p67_i_idx3_i_i72)>>2)]=(28);
 var $_sroa_2_8___p67_i_idx4_i_i73=(($__p_i_i_i70+8)|0);
 HEAP32[(($_sroa_2_8___p67_i_idx4_i_i73)>>2)]=0;
 (function() { try { __THREW__ = 0; return __ZNSt3__111__call_onceERVmPvPFvS2_E(13704,$104,260) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=44;break; } else { label=111;break; }
 case 44: 
 var $108=HEAP32[((13708)>>2)];
 var $109=((($108)-(1))|0);
 (function() { try { __THREW__ = 0; return __ZNSt3__16locale5__imp7installEPNS0_5facetEl($this,2568,$109) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=45;break; } else { label=111;break; }
 case 45: 
 HEAP32[((12780)>>2)]=0;
 HEAP32[((12776)>>2)]=3992;
 var $111=$__p_i_i_i77;
 var $112=HEAP32[((13760)>>2)];
 var $113=($112|0)==-1;
 if($113){label=47;break;}else{label=46;break;}
 case 46: 
 var $_sroa_01_0___p67_i_idx_i_i78=(($__p_i_i_i77)|0);
 HEAP32[(($_sroa_01_0___p67_i_idx_i_i78)>>2)]=13760;
 var $_sroa_12_4___p67_i_idx3_i_i79=(($__p_i_i_i77+4)|0);
 HEAP32[(($_sroa_12_4___p67_i_idx3_i_i79)>>2)]=(28);
 var $_sroa_2_8___p67_i_idx4_i_i80=(($__p_i_i_i77+8)|0);
 HEAP32[(($_sroa_2_8___p67_i_idx4_i_i80)>>2)]=0;
 (function() { try { __THREW__ = 0; return __ZNSt3__111__call_onceERVmPvPFvS2_E(13760,$111,260) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=47;break; } else { label=111;break; }
 case 47: 
 var $115=HEAP32[((13764)>>2)];
 var $116=((($115)-(1))|0);
 (function() { try { __THREW__ = 0; return __ZNSt3__16locale5__imp7installEPNS0_5facetEl($this,12776,$116) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=48;break; } else { label=111;break; }
 case 48: 
 HEAP32[((12772)>>2)]=0;
 HEAP32[((12768)>>2)]=3920;
 var $118=$__p_i_i_i84;
 var $119=HEAP32[((13752)>>2)];
 var $120=($119|0)==-1;
 if($120){label=50;break;}else{label=49;break;}
 case 49: 
 var $_sroa_01_0___p67_i_idx_i_i85=(($__p_i_i_i84)|0);
 HEAP32[(($_sroa_01_0___p67_i_idx_i_i85)>>2)]=13752;
 var $_sroa_12_4___p67_i_idx3_i_i86=(($__p_i_i_i84+4)|0);
 HEAP32[(($_sroa_12_4___p67_i_idx3_i_i86)>>2)]=(28);
 var $_sroa_2_8___p67_i_idx4_i_i87=(($__p_i_i_i84+8)|0);
 HEAP32[(($_sroa_2_8___p67_i_idx4_i_i87)>>2)]=0;
 (function() { try { __THREW__ = 0; return __ZNSt3__111__call_onceERVmPvPFvS2_E(13752,$118,260) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=50;break; } else { label=111;break; }
 case 50: 
 var $122=HEAP32[((13756)>>2)];
 var $123=((($122)-(1))|0);
 (function() { try { __THREW__ = 0; return __ZNSt3__16locale5__imp7installEPNS0_5facetEl($this,12768,$123) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=51;break; } else { label=111;break; }
 case 51: 
 HEAP32[((12764)>>2)]=0;
 HEAP32[((12760)>>2)]=3856;
 var $125=$__p_i_i_i91;
 var $126=HEAP32[((13744)>>2)];
 var $127=($126|0)==-1;
 if($127){label=53;break;}else{label=52;break;}
 case 52: 
 var $_sroa_01_0___p67_i_idx_i_i92=(($__p_i_i_i91)|0);
 HEAP32[(($_sroa_01_0___p67_i_idx_i_i92)>>2)]=13744;
 var $_sroa_12_4___p67_i_idx3_i_i93=(($__p_i_i_i91+4)|0);
 HEAP32[(($_sroa_12_4___p67_i_idx3_i_i93)>>2)]=(28);
 var $_sroa_2_8___p67_i_idx4_i_i94=(($__p_i_i_i91+8)|0);
 HEAP32[(($_sroa_2_8___p67_i_idx4_i_i94)>>2)]=0;
 (function() { try { __THREW__ = 0; return __ZNSt3__111__call_onceERVmPvPFvS2_E(13744,$125,260) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=53;break; } else { label=111;break; }
 case 53: 
 var $129=HEAP32[((13748)>>2)];
 var $130=((($129)-(1))|0);
 (function() { try { __THREW__ = 0; return __ZNSt3__16locale5__imp7installEPNS0_5facetEl($this,12760,$130) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=54;break; } else { label=111;break; }
 case 54: 
 HEAP32[((12756)>>2)]=0;
 HEAP32[((12752)>>2)]=3792;
 var $132=$__p_i_i_i98;
 var $133=HEAP32[((13736)>>2)];
 var $134=($133|0)==-1;
 if($134){label=56;break;}else{label=55;break;}
 case 55: 
 var $_sroa_01_0___p67_i_idx_i_i99=(($__p_i_i_i98)|0);
 HEAP32[(($_sroa_01_0___p67_i_idx_i_i99)>>2)]=13736;
 var $_sroa_12_4___p67_i_idx3_i_i100=(($__p_i_i_i98+4)|0);
 HEAP32[(($_sroa_12_4___p67_i_idx3_i_i100)>>2)]=(28);
 var $_sroa_2_8___p67_i_idx4_i_i101=(($__p_i_i_i98+8)|0);
 HEAP32[(($_sroa_2_8___p67_i_idx4_i_i101)>>2)]=0;
 (function() { try { __THREW__ = 0; return __ZNSt3__111__call_onceERVmPvPFvS2_E(13736,$132,260) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=56;break; } else { label=111;break; }
 case 56: 
 var $136=HEAP32[((13740)>>2)];
 var $137=((($136)-(1))|0);
 (function() { try { __THREW__ = 0; return __ZNSt3__16locale5__imp7installEPNS0_5facetEl($this,12752,$137) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=57;break; } else { label=111;break; }
 case 57: 
 HEAP32[((13036)>>2)]=0;
 HEAP32[((13032)>>2)]=5560;
 var $139=$__p_i_i_i105;
 var $140=HEAP32[((14576)>>2)];
 var $141=($140|0)==-1;
 if($141){label=59;break;}else{label=58;break;}
 case 58: 
 var $_sroa_01_0___p67_i_idx_i_i106=(($__p_i_i_i105)|0);
 HEAP32[(($_sroa_01_0___p67_i_idx_i_i106)>>2)]=14576;
 var $_sroa_12_4___p67_i_idx3_i_i107=(($__p_i_i_i105+4)|0);
 HEAP32[(($_sroa_12_4___p67_i_idx3_i_i107)>>2)]=(28);
 var $_sroa_2_8___p67_i_idx4_i_i108=(($__p_i_i_i105+8)|0);
 HEAP32[(($_sroa_2_8___p67_i_idx4_i_i108)>>2)]=0;
 (function() { try { __THREW__ = 0; return __ZNSt3__111__call_onceERVmPvPFvS2_E(14576,$139,260) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=59;break; } else { label=111;break; }
 case 59: 
 var $143=HEAP32[((14580)>>2)];
 var $144=((($143)-(1))|0);
 (function() { try { __THREW__ = 0; return __ZNSt3__16locale5__imp7installEPNS0_5facetEl($this,13032,$144) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=60;break; } else { label=111;break; }
 case 60: 
 HEAP32[((13028)>>2)]=0;
 HEAP32[((13024)>>2)]=5496;
 var $146=$__p_i_i_i112;
 var $147=HEAP32[((14568)>>2)];
 var $148=($147|0)==-1;
 if($148){label=62;break;}else{label=61;break;}
 case 61: 
 var $_sroa_01_0___p67_i_idx_i_i113=(($__p_i_i_i112)|0);
 HEAP32[(($_sroa_01_0___p67_i_idx_i_i113)>>2)]=14568;
 var $_sroa_12_4___p67_i_idx3_i_i114=(($__p_i_i_i112+4)|0);
 HEAP32[(($_sroa_12_4___p67_i_idx3_i_i114)>>2)]=(28);
 var $_sroa_2_8___p67_i_idx4_i_i115=(($__p_i_i_i112+8)|0);
 HEAP32[(($_sroa_2_8___p67_i_idx4_i_i115)>>2)]=0;
 (function() { try { __THREW__ = 0; return __ZNSt3__111__call_onceERVmPvPFvS2_E(14568,$146,260) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=62;break; } else { label=111;break; }
 case 62: 
 var $150=HEAP32[((14572)>>2)];
 var $151=((($150)-(1))|0);
 (function() { try { __THREW__ = 0; return __ZNSt3__16locale5__imp7installEPNS0_5facetEl($this,13024,$151) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=63;break; } else { label=111;break; }
 case 63: 
 HEAP32[((13020)>>2)]=0;
 HEAP32[((13016)>>2)]=5432;
 var $153=$__p_i_i_i119;
 var $154=HEAP32[((14560)>>2)];
 var $155=($154|0)==-1;
 if($155){label=65;break;}else{label=64;break;}
 case 64: 
 var $_sroa_01_0___p67_i_idx_i_i120=(($__p_i_i_i119)|0);
 HEAP32[(($_sroa_01_0___p67_i_idx_i_i120)>>2)]=14560;
 var $_sroa_12_4___p67_i_idx3_i_i121=(($__p_i_i_i119+4)|0);
 HEAP32[(($_sroa_12_4___p67_i_idx3_i_i121)>>2)]=(28);
 var $_sroa_2_8___p67_i_idx4_i_i122=(($__p_i_i_i119+8)|0);
 HEAP32[(($_sroa_2_8___p67_i_idx4_i_i122)>>2)]=0;
 (function() { try { __THREW__ = 0; return __ZNSt3__111__call_onceERVmPvPFvS2_E(14560,$153,260) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=65;break; } else { label=111;break; }
 case 65: 
 var $157=HEAP32[((14564)>>2)];
 var $158=((($157)-(1))|0);
 (function() { try { __THREW__ = 0; return __ZNSt3__16locale5__imp7installEPNS0_5facetEl($this,13016,$158) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=66;break; } else { label=111;break; }
 case 66: 
 HEAP32[((13012)>>2)]=0;
 HEAP32[((13008)>>2)]=5368;
 var $160=$__p_i_i_i126;
 var $161=HEAP32[((14552)>>2)];
 var $162=($161|0)==-1;
 if($162){label=68;break;}else{label=67;break;}
 case 67: 
 var $_sroa_01_0___p67_i_idx_i_i127=(($__p_i_i_i126)|0);
 HEAP32[(($_sroa_01_0___p67_i_idx_i_i127)>>2)]=14552;
 var $_sroa_12_4___p67_i_idx3_i_i128=(($__p_i_i_i126+4)|0);
 HEAP32[(($_sroa_12_4___p67_i_idx3_i_i128)>>2)]=(28);
 var $_sroa_2_8___p67_i_idx4_i_i129=(($__p_i_i_i126+8)|0);
 HEAP32[(($_sroa_2_8___p67_i_idx4_i_i129)>>2)]=0;
 (function() { try { __THREW__ = 0; return __ZNSt3__111__call_onceERVmPvPFvS2_E(14552,$160,260) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=68;break; } else { label=111;break; }
 case 68: 
 var $164=HEAP32[((14556)>>2)];
 var $165=((($164)-(1))|0);
 (function() { try { __THREW__ = 0; return __ZNSt3__16locale5__imp7installEPNS0_5facetEl($this,13008,$165) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=69;break; } else { label=111;break; }
 case 69: 
 HEAP32[((12708)>>2)]=0;
 HEAP32[((12704)>>2)]=3240;
 var $167=$__p_i_i_i133;
 var $168=HEAP32[((13664)>>2)];
 var $169=($168|0)==-1;
 if($169){label=71;break;}else{label=70;break;}
 case 70: 
 var $_sroa_01_0___p67_i_idx_i_i134=(($__p_i_i_i133)|0);
 HEAP32[(($_sroa_01_0___p67_i_idx_i_i134)>>2)]=13664;
 var $_sroa_12_4___p67_i_idx3_i_i135=(($__p_i_i_i133+4)|0);
 HEAP32[(($_sroa_12_4___p67_i_idx3_i_i135)>>2)]=(28);
 var $_sroa_2_8___p67_i_idx4_i_i136=(($__p_i_i_i133+8)|0);
 HEAP32[(($_sroa_2_8___p67_i_idx4_i_i136)>>2)]=0;
 (function() { try { __THREW__ = 0; return __ZNSt3__111__call_onceERVmPvPFvS2_E(13664,$167,260) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=71;break; } else { label=111;break; }
 case 71: 
 var $171=HEAP32[((13668)>>2)];
 var $172=((($171)-(1))|0);
 (function() { try { __THREW__ = 0; return __ZNSt3__16locale5__imp7installEPNS0_5facetEl($this,12704,$172) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=72;break; } else { label=111;break; }
 case 72: 
 HEAP32[((12700)>>2)]=0;
 HEAP32[((12696)>>2)]=3200;
 var $174=$__p_i_i_i140;
 var $175=HEAP32[((13656)>>2)];
 var $176=($175|0)==-1;
 if($176){label=74;break;}else{label=73;break;}
 case 73: 
 var $_sroa_01_0___p67_i_idx_i_i141=(($__p_i_i_i140)|0);
 HEAP32[(($_sroa_01_0___p67_i_idx_i_i141)>>2)]=13656;
 var $_sroa_12_4___p67_i_idx3_i_i142=(($__p_i_i_i140+4)|0);
 HEAP32[(($_sroa_12_4___p67_i_idx3_i_i142)>>2)]=(28);
 var $_sroa_2_8___p67_i_idx4_i_i143=(($__p_i_i_i140+8)|0);
 HEAP32[(($_sroa_2_8___p67_i_idx4_i_i143)>>2)]=0;
 (function() { try { __THREW__ = 0; return __ZNSt3__111__call_onceERVmPvPFvS2_E(13656,$174,260) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=74;break; } else { label=111;break; }
 case 74: 
 var $178=HEAP32[((13660)>>2)];
 var $179=((($178)-(1))|0);
 (function() { try { __THREW__ = 0; return __ZNSt3__16locale5__imp7installEPNS0_5facetEl($this,12696,$179) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=75;break; } else { label=111;break; }
 case 75: 
 HEAP32[((12692)>>2)]=0;
 HEAP32[((12688)>>2)]=3160;
 var $181=$__p_i_i_i147;
 var $182=HEAP32[((13648)>>2)];
 var $183=($182|0)==-1;
 if($183){label=77;break;}else{label=76;break;}
 case 76: 
 var $_sroa_01_0___p67_i_idx_i_i148=(($__p_i_i_i147)|0);
 HEAP32[(($_sroa_01_0___p67_i_idx_i_i148)>>2)]=13648;
 var $_sroa_12_4___p67_i_idx3_i_i149=(($__p_i_i_i147+4)|0);
 HEAP32[(($_sroa_12_4___p67_i_idx3_i_i149)>>2)]=(28);
 var $_sroa_2_8___p67_i_idx4_i_i150=(($__p_i_i_i147+8)|0);
 HEAP32[(($_sroa_2_8___p67_i_idx4_i_i150)>>2)]=0;
 (function() { try { __THREW__ = 0; return __ZNSt3__111__call_onceERVmPvPFvS2_E(13648,$181,260) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=77;break; } else { label=111;break; }
 case 77: 
 var $185=HEAP32[((13652)>>2)];
 var $186=((($185)-(1))|0);
 (function() { try { __THREW__ = 0; return __ZNSt3__16locale5__imp7installEPNS0_5facetEl($this,12688,$186) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=78;break; } else { label=111;break; }
 case 78: 
 HEAP32[((12684)>>2)]=0;
 HEAP32[((12680)>>2)]=3120;
 var $188=$__p_i_i_i154;
 var $189=HEAP32[((13640)>>2)];
 var $190=($189|0)==-1;
 if($190){label=80;break;}else{label=79;break;}
 case 79: 
 var $_sroa_01_0___p67_i_idx_i_i155=(($__p_i_i_i154)|0);
 HEAP32[(($_sroa_01_0___p67_i_idx_i_i155)>>2)]=13640;
 var $_sroa_12_4___p67_i_idx3_i_i156=(($__p_i_i_i154+4)|0);
 HEAP32[(($_sroa_12_4___p67_i_idx3_i_i156)>>2)]=(28);
 var $_sroa_2_8___p67_i_idx4_i_i157=(($__p_i_i_i154+8)|0);
 HEAP32[(($_sroa_2_8___p67_i_idx4_i_i157)>>2)]=0;
 (function() { try { __THREW__ = 0; return __ZNSt3__111__call_onceERVmPvPFvS2_E(13640,$188,260) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=80;break; } else { label=111;break; }
 case 80: 
 var $192=HEAP32[((13644)>>2)];
 var $193=((($192)-(1))|0);
 (function() { try { __THREW__ = 0; return __ZNSt3__16locale5__imp7installEPNS0_5facetEl($this,12680,$193) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=81;break; } else { label=111;break; }
 case 81: 
 HEAP32[((2556)>>2)]=0;
 HEAP32[((2552)>>2)]=3464;
 HEAP32[((2560)>>2)]=3512;
 var $195=$__p_i_i_i161;
 var $196=HEAP32[((13696)>>2)];
 var $197=($196|0)==-1;
 if($197){label=83;break;}else{label=82;break;}
 case 82: 
 var $_sroa_01_0___p67_i_idx_i_i162=(($__p_i_i_i161)|0);
 HEAP32[(($_sroa_01_0___p67_i_idx_i_i162)>>2)]=13696;
 var $_sroa_12_4___p67_i_idx3_i_i163=(($__p_i_i_i161+4)|0);
 HEAP32[(($_sroa_12_4___p67_i_idx3_i_i163)>>2)]=(28);
 var $_sroa_2_8___p67_i_idx4_i_i164=(($__p_i_i_i161+8)|0);
 HEAP32[(($_sroa_2_8___p67_i_idx4_i_i164)>>2)]=0;
 (function() { try { __THREW__ = 0; return __ZNSt3__111__call_onceERVmPvPFvS2_E(13696,$195,260) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=83;break; } else { label=111;break; }
 case 83: 
 var $199=HEAP32[((13700)>>2)];
 var $200=((($199)-(1))|0);
 (function() { try { __THREW__ = 0; return __ZNSt3__16locale5__imp7installEPNS0_5facetEl($this,2552,$200) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=84;break; } else { label=111;break; }
 case 84: 
 HEAP32[((2540)>>2)]=0;
 HEAP32[((2536)>>2)]=3368;
 HEAP32[((2544)>>2)]=3416;
 var $202=$__p_i_i_i168;
 var $203=HEAP32[((13688)>>2)];
 var $204=($203|0)==-1;
 if($204){label=86;break;}else{label=85;break;}
 case 85: 
 var $_sroa_01_0___p67_i_idx_i_i169=(($__p_i_i_i168)|0);
 HEAP32[(($_sroa_01_0___p67_i_idx_i_i169)>>2)]=13688;
 var $_sroa_12_4___p67_i_idx3_i_i170=(($__p_i_i_i168+4)|0);
 HEAP32[(($_sroa_12_4___p67_i_idx3_i_i170)>>2)]=(28);
 var $_sroa_2_8___p67_i_idx4_i_i171=(($__p_i_i_i168+8)|0);
 HEAP32[(($_sroa_2_8___p67_i_idx4_i_i171)>>2)]=0;
 (function() { try { __THREW__ = 0; return __ZNSt3__111__call_onceERVmPvPFvS2_E(13688,$202,260) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=86;break; } else { label=111;break; }
 case 86: 
 var $206=HEAP32[((13692)>>2)];
 var $207=((($206)-(1))|0);
 (function() { try { __THREW__ = 0; return __ZNSt3__16locale5__imp7installEPNS0_5facetEl($this,2536,$207) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=87;break; } else { label=111;break; }
 case 87: 
 HEAP32[((2524)>>2)]=0;
 HEAP32[((2520)>>2)]=4368;
 var $208=HEAP8[(14656)];
 var $209=(($208<<24)>>24)==0;
 if($209){label=88;break;}else{label=92;break;}
 case 88: 
 var $211=___cxa_guard_acquire(14656);
 var $212=($211|0)==0;
 if($212){label=92;break;}else{label=89;break;}
 case 89: 
 var $214=(function() { try { __THREW__ = 0; return _newlocale(2147483647,1496,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=90;break; } else { label=91;break; }
 case 90: 
 HEAP32[((12664)>>2)]=$214;

 label=92;break;
 case 91: 
 var $216$0 = ___cxa_find_matching_catch(-1, -1); var $216$1 = tempRet0;

 __ZNSt3__114__shared_countD2Ev(2520);
 var $eh_lpad_body$1=$216$1;var $eh_lpad_body$0=$216$0;label=112;break;
 case 92: 
 var $218=HEAP32[((12664)>>2)];
 HEAP32[((2528)>>2)]=$218;
 HEAP32[((2520)>>2)]=3336;
 var $219=$__p_i_i_i177;
 var $220=HEAP32[((13680)>>2)];
 var $221=($220|0)==-1;
 if($221){label=94;break;}else{label=93;break;}
 case 93: 
 var $_sroa_01_0___p67_i_idx_i_i178=(($__p_i_i_i177)|0);
 HEAP32[(($_sroa_01_0___p67_i_idx_i_i178)>>2)]=13680;
 var $_sroa_12_4___p67_i_idx3_i_i179=(($__p_i_i_i177+4)|0);
 HEAP32[(($_sroa_12_4___p67_i_idx3_i_i179)>>2)]=(28);
 var $_sroa_2_8___p67_i_idx4_i_i180=(($__p_i_i_i177+8)|0);
 HEAP32[(($_sroa_2_8___p67_i_idx4_i_i180)>>2)]=0;
 (function() { try { __THREW__ = 0; return __ZNSt3__111__call_onceERVmPvPFvS2_E(13680,$219,260) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=94;break; } else { label=111;break; }
 case 94: 
 var $223=HEAP32[((13684)>>2)];
 var $224=((($223)-(1))|0);
 (function() { try { __THREW__ = 0; return __ZNSt3__16locale5__imp7installEPNS0_5facetEl($this,2520,$224) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=95;break; } else { label=111;break; }
 case 95: 
 HEAP32[((2508)>>2)]=0;
 HEAP32[((2504)>>2)]=4368;
 var $225=HEAP8[(14656)];
 var $226=(($225<<24)>>24)==0;
 if($226){label=96;break;}else{label=100;break;}
 case 96: 
 var $228=___cxa_guard_acquire(14656);
 var $229=($228|0)==0;
 if($229){label=100;break;}else{label=97;break;}
 case 97: 
 var $231=(function() { try { __THREW__ = 0; return _newlocale(2147483647,1496,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=98;break; } else { label=99;break; }
 case 98: 
 HEAP32[((12664)>>2)]=$231;

 label=100;break;
 case 99: 
 var $233$0 = ___cxa_find_matching_catch(-1, -1); var $233$1 = tempRet0;

 __ZNSt3__114__shared_countD2Ev(2504);
 var $eh_lpad_body$1=$233$1;var $eh_lpad_body$0=$233$0;label=112;break;
 case 100: 
 var $235=HEAP32[((12664)>>2)];
 HEAP32[((2512)>>2)]=$235;
 HEAP32[((2504)>>2)]=3304;
 var $236=$__p_i_i_i187;
 var $237=HEAP32[((13672)>>2)];
 var $238=($237|0)==-1;
 if($238){label=102;break;}else{label=101;break;}
 case 101: 
 var $_sroa_01_0___p67_i_idx_i_i188=(($__p_i_i_i187)|0);
 HEAP32[(($_sroa_01_0___p67_i_idx_i_i188)>>2)]=13672;
 var $_sroa_12_4___p67_i_idx3_i_i189=(($__p_i_i_i187+4)|0);
 HEAP32[(($_sroa_12_4___p67_i_idx3_i_i189)>>2)]=(28);
 var $_sroa_2_8___p67_i_idx4_i_i190=(($__p_i_i_i187+8)|0);
 HEAP32[(($_sroa_2_8___p67_i_idx4_i_i190)>>2)]=0;
 (function() { try { __THREW__ = 0; return __ZNSt3__111__call_onceERVmPvPFvS2_E(13672,$236,260) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=102;break; } else { label=111;break; }
 case 102: 
 var $240=HEAP32[((13676)>>2)];
 var $241=((($240)-(1))|0);
 (function() { try { __THREW__ = 0; return __ZNSt3__16locale5__imp7installEPNS0_5facetEl($this,2504,$241) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=103;break; } else { label=111;break; }
 case 103: 
 HEAP32[((12748)>>2)]=0;
 HEAP32[((12744)>>2)]=3696;
 var $243=$__p_i_i_i194;
 var $244=HEAP32[((13728)>>2)];
 var $245=($244|0)==-1;
 if($245){label=105;break;}else{label=104;break;}
 case 104: 
 var $_sroa_01_0___p67_i_idx_i_i195=(($__p_i_i_i194)|0);
 HEAP32[(($_sroa_01_0___p67_i_idx_i_i195)>>2)]=13728;
 var $_sroa_12_4___p67_i_idx3_i_i196=(($__p_i_i_i194+4)|0);
 HEAP32[(($_sroa_12_4___p67_i_idx3_i_i196)>>2)]=(28);
 var $_sroa_2_8___p67_i_idx4_i_i197=(($__p_i_i_i194+8)|0);
 HEAP32[(($_sroa_2_8___p67_i_idx4_i_i197)>>2)]=0;
 (function() { try { __THREW__ = 0; return __ZNSt3__111__call_onceERVmPvPFvS2_E(13728,$243,260) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=105;break; } else { label=111;break; }
 case 105: 
 var $247=HEAP32[((13732)>>2)];
 var $248=((($247)-(1))|0);
 (function() { try { __THREW__ = 0; return __ZNSt3__16locale5__imp7installEPNS0_5facetEl($this,12744,$248) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=106;break; } else { label=111;break; }
 case 106: 
 HEAP32[((12740)>>2)]=0;
 HEAP32[((12736)>>2)]=3656;
 var $250=$__p_i_i_i;
 var $251=HEAP32[((13720)>>2)];
 var $252=($251|0)==-1;
 if($252){label=108;break;}else{label=107;break;}
 case 107: 
 var $_sroa_01_0___p67_i_idx_i_i=(($__p_i_i_i)|0);
 HEAP32[(($_sroa_01_0___p67_i_idx_i_i)>>2)]=13720;
 var $_sroa_12_4___p67_i_idx3_i_i=(($__p_i_i_i+4)|0);
 HEAP32[(($_sroa_12_4___p67_i_idx3_i_i)>>2)]=(28);
 var $_sroa_2_8___p67_i_idx4_i_i=(($__p_i_i_i+8)|0);
 HEAP32[(($_sroa_2_8___p67_i_idx4_i_i)>>2)]=0;
 (function() { try { __THREW__ = 0; return __ZNSt3__111__call_onceERVmPvPFvS2_E(13720,$250,260) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=108;break; } else { label=111;break; }
 case 108: 
 var $254=HEAP32[((13724)>>2)];
 var $255=((($254)-(1))|0);
 (function() { try { __THREW__ = 0; return __ZNSt3__16locale5__imp7installEPNS0_5facetEl($this,12736,$255) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=109;break; } else { label=111;break; }
 case 109: 
 STACKTOP=sp;return;
 case 110: 
 var $257$0 = ___cxa_find_matching_catch(-1, -1); var $257$1 = tempRet0;
 var $258=$257$0;
 var $259=$257$1;
 var $_0=$259;var $_04=$258;label=113;break;
 case 111: 
 var $261$0 = ___cxa_find_matching_catch(-1, -1); var $261$1 = tempRet0;
 var $eh_lpad_body$1=$261$1;var $eh_lpad_body$0=$261$0;label=112;break;
 case 112: 
 var $eh_lpad_body$0;
 var $eh_lpad_body$1;
 var $262=$eh_lpad_body$0;
 var $263=$eh_lpad_body$1;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($19);
 var $_0=$263;var $_04=$262;label=113;break;
 case 113: 
 var $_04;
 var $_0;
 var $265=HEAP32[(($4)>>2)];
 var $266=($265|0)==0;
 if($266){label=119;break;}else{label=114;break;}
 case 114: 
 var $268=HEAP32[(($5)>>2)];
 var $269=($268|0)==($265|0);
 if($269){label=116;break;}else{label=115;break;}
 case 115: 
 var $__new_last3_i_i_i_i_i=$265;
 var $scevgep_i_i_i_i_i=((($268)-(4))|0);
 var $scevgep2_i_i_i_i_i=$scevgep_i_i_i_i_i;
 var $270=(((-$__new_last3_i_i_i_i_i))|0);
 var $uglygep_i_i_i_i_i=(($scevgep2_i_i_i_i_i+$270)|0);
 var $uglygep4_i_i_i_i_i=$uglygep_i_i_i_i_i;
 var $271=$uglygep4_i_i_i_i_i>>>2;
 var $272=$271^-1;
 var $scevgep5_i_i_i_i_i=(($268+($272<<2))|0);
 HEAP32[(($5)>>2)]=$scevgep5_i_i_i_i_i;
 label=116;break;
 case 116: 
 var $273=($9|0)==($265|0);
 if($273){label=117;break;}else{label=118;break;}
 case 117: 
 HEAP8[($7)]=0;
 label=119;break;
 case 118: 
 var $276=$265;
 __ZdlPv($276);
 label=119;break;
 case 119: 
 var $277=(($this)|0);
 __ZNSt3__114__shared_countD2Ev($277);
 var $278$0=$_04;
 var $278$1=0;
 var $279$0=$278$0;
 var $279$1=$_0;
 ___resumeException($279$0)
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__16locale5__imp7installEPNS0_5facetEl($this,$f,$id){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=(($f)|0);
 __ZNSt3__114__shared_count12__add_sharedEv($1);
 var $2=(($this+8)|0);
 var $3=(($this+12)|0);
 var $4=HEAP32[(($3)>>2)];
 var $5=(($2)|0);
 var $6=HEAP32[(($5)>>2)];
 var $7=$4;
 var $8=$6;
 var $9=((($7)-($8))|0);
 var $10=$9>>2;
 var $11=($10>>>0)>($id>>>0);
 if($11){var $30=$6;label=11;break;}else{label=2;break;}
 case 2: 
 var $13=((($id)+(1))|0);
 var $14=($10>>>0)<($13>>>0);
 if($14){label=3;break;}else{label=5;break;}
 case 3: 
 var $16=((($13)-($10))|0);
 (function() { try { __THREW__ = 0; return __ZNSt3__16vectorIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEE8__appendEj($2,$16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=4;break; } else { label=8;break; }
 case 4: 
 var $_pre13=HEAP32[(($5)>>2)];
 var $30=$_pre13;label=11;break;
 case 5: 
 var $18=($10>>>0)>($13>>>0);
 if($18){label=6;break;}else{var $30=$6;label=11;break;}
 case 6: 
 var $20=(($6+($13<<2))|0);
 var $21=($4|0)==($20|0);
 if($21){var $30=$6;label=11;break;}else{label=7;break;}
 case 7: 
 var $__new_last3_i_i_i=$20;
 var $scevgep_i_i_i=((($4)-(4))|0);
 var $scevgep2_i_i_i=$scevgep_i_i_i;
 var $22=(((-$__new_last3_i_i_i))|0);
 var $uglygep_i_i_i=(($scevgep2_i_i_i+$22)|0);
 var $uglygep4_i_i_i=$uglygep_i_i_i;
 var $23=$uglygep4_i_i_i>>>2;
 var $24=$23^-1;
 var $scevgep5_i_i_i=(($4+($24<<2))|0);
 HEAP32[(($3)>>2)]=$scevgep5_i_i_i;
 var $30=$6;label=11;break;
 case 8: 
 var $26$0 = ___cxa_find_matching_catch(-1, -1); var $26$1 = tempRet0;
 var $27=($f|0)==0;
 if($27){label=10;break;}else{label=9;break;}
 case 9: 
 var $29=__ZNSt3__114__shared_count16__release_sharedEv($1);
 label=10;break;
 case 10: 
 ___resumeException($26$0)
 case 11: 
 var $30;
 var $31=(($30+($id<<2))|0);
 var $32=HEAP32[(($31)>>2)];
 var $33=($32|0)==0;
 if($33){var $37=$30;label=13;break;}else{label=12;break;}
 case 12: 
 var $35=(($32)|0);
 var $36=__ZNSt3__114__shared_count16__release_sharedEv($35);
 var $_pre=HEAP32[(($5)>>2)];
 var $37=$_pre;label=13;break;
 case 13: 
 var $37;
 var $38=(($37+($id<<2))|0);
 HEAP32[(($38)>>2)]=$f;
 return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__16locale5__impD0Ev($this){
 var label=0;


 __ZNSt3__16locale5__impD2Ev($this);
 var $1=$this;
 __ZdlPv($1);
 return;
}


function __ZNSt3__16locale5__impD2Ev($this){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=(($this)|0);
 HEAP32[(($1)>>2)]=4400;
 var $2=(($this+12)|0);
 var $3=HEAP32[(($2)>>2)];
 var $4=(($this+8)|0);
 var $5=HEAP32[(($4)>>2)];
 var $6=($3|0)==($5|0);
 if($6){label=5;break;}else{var $i_05=0;var $8=$5;var $7=$3;label=2;break;}
 case 2: 
 var $7;
 var $8;
 var $i_05;
 var $9=(($8+($i_05<<2))|0);
 var $10=HEAP32[(($9)>>2)];
 var $11=($10|0)==0;
 if($11){var $17=$7;var $16=$8;label=4;break;}else{label=3;break;}
 case 3: 
 var $13=(($10)|0);
 var $14=__ZNSt3__114__shared_count16__release_sharedEv($13);
 var $_pre=HEAP32[(($2)>>2)];
 var $_pre7=HEAP32[(($4)>>2)];
 var $17=$_pre;var $16=$_pre7;label=4;break;
 case 4: 
 var $16;
 var $17;
 var $18=((($i_05)+(1))|0);
 var $19=$17;
 var $20=$16;
 var $21=((($19)-($20))|0);
 var $22=$21>>2;
 var $23=($18>>>0)<($22>>>0);
 if($23){var $i_05=$18;var $8=$16;var $7=$17;label=2;break;}else{label=5;break;}
 case 5: 
 var $24=(($this+144)|0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($24);
 var $25=HEAP32[(($4)>>2)];
 var $26=($25|0)==0;
 if($26){label=11;break;}else{label=6;break;}
 case 6: 
 var $28=HEAP32[(($2)>>2)];
 var $29=($28|0)==($25|0);
 if($29){label=8;break;}else{label=7;break;}
 case 7: 
 var $__new_last3_i_i_i_i_i=$25;
 var $scevgep_i_i_i_i_i=((($28)-(4))|0);
 var $scevgep2_i_i_i_i_i=$scevgep_i_i_i_i_i;
 var $30=(((-$__new_last3_i_i_i_i_i))|0);
 var $uglygep_i_i_i_i_i=(($scevgep2_i_i_i_i_i+$30)|0);
 var $uglygep4_i_i_i_i_i=$uglygep_i_i_i_i_i;
 var $31=$uglygep4_i_i_i_i_i>>>2;
 var $32=$31^-1;
 var $scevgep5_i_i_i_i_i=(($28+($32<<2))|0);
 HEAP32[(($2)>>2)]=$scevgep5_i_i_i_i_i;
 label=8;break;
 case 8: 
 var $33=(($this+24)|0);
 var $34=$33;
 var $35=($34|0)==($25|0);
 if($35){label=9;break;}else{label=10;break;}
 case 9: 
 var $37=(($this+136)|0);
 HEAP8[($37)]=0;
 label=11;break;
 case 10: 
 var $39=$25;
 __ZdlPv($39);
 label=11;break;
 case 11: 
 var $40=(($this)|0);
 __ZNSt3__114__shared_countD2Ev($40);
 return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__16locale8__globalEv(){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=HEAP8[(14640)];
 var $2=(($1<<24)>>24)==0;
 if($2){label=2;break;}else{label=8;break;}
 case 2: 
 var $4=___cxa_guard_acquire(14640);
 var $5=($4|0)==0;
 if($5){label=8;break;}else{label=3;break;}
 case 3: 
 var $7=HEAP8[(14648)];
 var $8=(($7<<24)>>24)==0;
 if($8){label=4;break;}else{label=7;break;}
 case 4: 
 var $10=___cxa_guard_acquire(14648);
 var $11=($10|0)==0;
 if($11){label=7;break;}else{label=5;break;}
 case 5: 
 (function() { try { __THREW__ = 0; return __ZNSt3__16locale5__impC2Ej(12824,1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=6;break; } else { label=9;break; }
 case 6: 
 HEAP32[((12648)>>2)]=12824;
 HEAP32[((12640)>>2)]=12648;

 label=7;break;
 case 7: 
 var $15=HEAP32[((12640)>>2)];
 var $16=(($15)|0);
 var $17=HEAP32[(($16)>>2)];
 HEAP32[((12656)>>2)]=$17;
 var $18=(($17)|0);
 __ZNSt3__114__shared_count12__add_sharedEv($18);
 HEAP32[((12632)>>2)]=12656;

 label=8;break;
 case 8: 
 var $20=HEAP32[((12632)>>2)];
 return $20;
 case 9: 
 var $21$0 = ___cxa_find_matching_catch(-1, -1); var $21$1 = tempRet0;


 ___resumeException($21$0)
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__16localeC2Ev($this){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=(function() { try { __THREW__ = 0; return __ZNSt3__16locale8__globalEv() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=2;break; } else { label=3;break; }
 case 2: 
 var $3=(($this)|0);
 var $4=(($1)|0);
 var $5=HEAP32[(($4)>>2)];
 HEAP32[(($3)>>2)]=$5;
 var $6=(($5)|0);
 __ZNSt3__114__shared_count12__add_sharedEv($6);
 return;
 case 3: 
 var $8$0 = ___cxa_find_matching_catch(-1, -1,0); var $8$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__16localeC2ERKS0_($this,$l){
 var label=0;


 var $1=(($this)|0);
 var $2=(($l)|0);
 var $3=HEAP32[(($2)>>2)];
 HEAP32[(($1)>>2)]=$3;
 var $4=(($3)|0);
 __ZNSt3__114__shared_count12__add_sharedEv($4);
 return;
}


function __ZNSt3__16localeD2Ev($this){
 var label=0;


 var $1=(($this)|0);
 var $2=HEAP32[(($1)>>2)];
 var $3=(($2)|0);
 var $4=__ZNSt3__114__shared_count16__release_sharedEv($3);
 return;
}


function __ZNKSt3__16locale9has_facetERNS0_2idE($this,$x){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+16)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $__p_i_i=sp;
 var $1=(($this)|0);
 var $2=HEAP32[(($1)>>2)];
 var $3=$__p_i_i;
 var $4=(($x)|0);
 var $5=HEAP32[(($4)>>2)];
 var $6=($5|0)==-1;
 if($6){label=3;break;}else{label=2;break;}
 case 2: 
 var $_sroa_01_0___p67_i_idx_i=(($__p_i_i)|0);
 HEAP32[(($_sroa_01_0___p67_i_idx_i)>>2)]=$x;
 var $_sroa_12_4___p67_i_idx3_i=(($__p_i_i+4)|0);
 HEAP32[(($_sroa_12_4___p67_i_idx3_i)>>2)]=(28);
 var $_sroa_2_8___p67_i_idx4_i=(($__p_i_i+8)|0);
 HEAP32[(($_sroa_2_8___p67_i_idx4_i)>>2)]=0;
 __ZNSt3__111__call_onceERVmPvPFvS2_E($4,$3,260);
 label=3;break;
 case 3: 
 var $8=(($x+4)|0);
 var $9=HEAP32[(($8)>>2)];
 var $10=((($9)-(1))|0);
 var $11=(($2+12)|0);
 var $12=HEAP32[(($11)>>2)];
 var $13=(($2+8)|0);
 var $14=HEAP32[(($13)>>2)];
 var $15=$12;
 var $16=$14;
 var $17=((($15)-($16))|0);
 var $18=$17>>2;
 var $19=($18>>>0)>($10>>>0);
 if($19){label=4;break;}else{var $24=0;label=5;break;}
 case 4: 
 var $21=(($14+($10<<2))|0);
 var $22=HEAP32[(($21)>>2)];
 var $23=($22|0)!=0;
 var $24=$23;label=5;break;
 case 5: 
 var $24;
 STACKTOP=sp;return $24;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__16locale9use_facetERNS0_2idE($this,$x){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+16)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $__p_i_i=sp;
 var $1=(($this)|0);
 var $2=HEAP32[(($1)>>2)];
 var $3=$__p_i_i;
 var $4=(($x)|0);
 var $5=HEAP32[(($4)>>2)];
 var $6=($5|0)==-1;
 if($6){label=3;break;}else{label=2;break;}
 case 2: 
 var $_sroa_01_0___p67_i_idx_i=(($__p_i_i)|0);
 HEAP32[(($_sroa_01_0___p67_i_idx_i)>>2)]=$x;
 var $_sroa_12_4___p67_i_idx3_i=(($__p_i_i+4)|0);
 HEAP32[(($_sroa_12_4___p67_i_idx3_i)>>2)]=(28);
 var $_sroa_2_8___p67_i_idx4_i=(($__p_i_i+8)|0);
 HEAP32[(($_sroa_2_8___p67_i_idx4_i)>>2)]=0;
 __ZNSt3__111__call_onceERVmPvPFvS2_E($4,$3,260);
 label=3;break;
 case 3: 
 var $8=(($x+4)|0);
 var $9=HEAP32[(($8)>>2)];
 var $10=((($9)-(1))|0);
 var $11=(($2+12)|0);
 var $12=HEAP32[(($11)>>2)];
 var $13=(($2+8)|0);
 var $14=HEAP32[(($13)>>2)];
 var $15=$12;
 var $16=$14;
 var $17=((($15)-($16))|0);
 var $18=$17>>2;
 var $19=($18>>>0)>($10>>>0);
 if($19){label=4;break;}else{label=5;break;}
 case 4: 
 var $20=(($14+($10<<2))|0);
 var $21=HEAP32[(($20)>>2)];
 var $22=($21|0)==0;
 if($22){label=5;break;}else{label=6;break;}
 case 5: 
 var $23=___cxa_allocate_exception(4);
 var $24=$23;
 __ZNSt8bad_castC2Ev($24);
 ___cxa_throw($23,8960,(368));
 throw "Reached an unreachable!";
 case 6: 
 STACKTOP=sp;return $21;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__16locale5facetD0Ev($this){
 var label=0;


 var $1=(($this)|0);
 __ZNSt3__114__shared_countD2Ev($1);
 var $2=$this;
 __ZdlPv($2);
 return;
}


function __ZNSt3__16locale5facet16__on_zero_sharedEv($this){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=($this|0)==0;
 if($1){label=3;break;}else{label=2;break;}
 case 2: 
 var $3=$this;
 var $4=HEAP32[(($3)>>2)];
 var $5=(($4+4)|0);
 var $6=HEAP32[(($5)>>2)];
 FUNCTION_TABLE[$6]($this);
 label=3;break;
 case 3: 
 return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__16locale2id6__initEv($this){
 var label=0;


 var $1=(tempValue=HEAP32[((13816)>>2)],HEAP32[((13816)>>2)]=tempValue+1,tempValue);
 var $2=((($1)+(1))|0);
 var $3=(($this+4)|0);
 HEAP32[(($3)>>2)]=$2;
 return;
}


function __ZNSt3__15ctypeIwED0Ev($this){
 var label=0;


 var $1=(($this)|0);
 __ZNSt3__114__shared_countD2Ev($1);
 var $2=$this;
 __ZdlPv($2);
 return;
}


function __ZNKSt3__15ctypeIwE5do_isEtw($this,$m,$c){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $isascii=($c>>>0)<128;
 if($isascii){label=2;break;}else{var $11=0;label=5;break;}
 case 2: 
 var $2=(function() { try { __THREW__ = 0; return ___ctype_b_loc() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=4;break; } else { label=3;break; }
 case 3: 
 var $4$0 = ___cxa_find_matching_catch(-1, -1,0); var $4$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
 case 4: 
 var $5=HEAP32[(($2)>>2)];
 var $6=(($5+($c<<1))|0);
 var $7=HEAP16[(($6)>>1)];
 var $8=$7&$m;
 var $9=(($8<<16)>>16)!=0;
 var $11=$9;label=5;break;
 case 5: 
 var $11;
 return $11;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__15ctypeIwE5do_isEPKwS3_Pt($this,$low,$high,$vec){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=($low|0)==($high|0);
 if($1){var $_08_lcssa=$low;label=7;break;}else{var $_0810=$low;var $_011=$vec;label=2;break;}
 case 2: 
 var $_011;
 var $_0810;
 var $2=HEAP32[(($_0810)>>2)];
 var $isascii=($2>>>0)<128;
 if($isascii){label=3;break;}else{var $_off0=0;label=6;break;}
 case 3: 
 var $4=(function() { try { __THREW__ = 0; return ___ctype_b_loc() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=5;break; } else { label=4;break; }
 case 4: 
 var $6$0 = ___cxa_find_matching_catch(-1, -1,0); var $6$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
 case 5: 
 var $7=HEAP32[(($4)>>2)];
 var $8=(($7+($2<<1))|0);
 var $9=HEAP16[(($8)>>1)];
 var $_off0=$9;label=6;break;
 case 6: 
 var $_off0;
 HEAP16[(($_011)>>1)]=$_off0;
 var $11=(($_0810+4)|0);
 var $12=(($_011+2)|0);
 var $13=($11|0)==($high|0);
 if($13){var $_08_lcssa=$high;label=7;break;}else{var $_0810=$11;var $_011=$12;label=2;break;}
 case 7: 
 var $_08_lcssa;
 return $_08_lcssa;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__15ctypeIwE10do_scan_isEtPKwS3_($this,$m,$low,$high){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=($low|0)==($high|0);
 if($1){var $_0_lcssa=$low;label=7;break;}else{var $_09=$low;label=2;break;}
 case 2: 
 var $_09;
 var $2=HEAP32[(($_09)>>2)];
 var $isascii=($2>>>0)<128;
 if($isascii){label=3;break;}else{label=6;break;}
 case 3: 
 var $4=(function() { try { __THREW__ = 0; return ___ctype_b_loc() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=5;break; } else { label=4;break; }
 case 4: 
 var $6$0 = ___cxa_find_matching_catch(-1, -1,0); var $6$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
 case 5: 
 var $7=HEAP32[(($4)>>2)];
 var $8=(($7+($2<<1))|0);
 var $9=HEAP16[(($8)>>1)];
 var $10=$9&$m;
 var $11=(($10<<16)>>16)==0;
 if($11){label=6;break;}else{var $_0_lcssa=$_09;label=7;break;}
 case 6: 
 var $13=(($_09+4)|0);
 var $14=($13|0)==($high|0);
 if($14){var $_0_lcssa=$high;label=7;break;}else{var $_09=$13;label=2;break;}
 case 7: 
 var $_0_lcssa;
 return $_0_lcssa;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__15ctypeIwE11do_scan_notEtPKwS3_($this,$m,$low,$high){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $_0=$low;label=2;break;
 case 2: 
 var $_0;
 var $2=($_0|0)==($high|0);
 if($2){var $_0_lcssa=$high;label=7;break;}else{label=3;break;}
 case 3: 
 var $4=HEAP32[(($_0)>>2)];
 var $isascii=($4>>>0)<128;
 if($isascii){label=4;break;}else{var $_0_lcssa=$_0;label=7;break;}
 case 4: 
 var $6=(function() { try { __THREW__ = 0; return ___ctype_b_loc() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=6;break; } else { label=5;break; }
 case 5: 
 var $8$0 = ___cxa_find_matching_catch(-1, -1,0); var $8$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
 case 6: 
 var $9=HEAP32[(($6)>>2)];
 var $10=(($9+($4<<1))|0);
 var $11=HEAP16[(($10)>>1)];
 var $12=$11&$m;
 var $13=(($12<<16)>>16)==0;
 var $14=(($_0+4)|0);
 if($13){var $_0_lcssa=$_0;label=7;break;}else{var $_0=$14;label=2;break;}
 case 7: 
 var $_0_lcssa;
 return $_0_lcssa;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__15ctypeIwE10do_toupperEw($this,$c){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $isascii=($c>>>0)<128;
 if($isascii){label=2;break;}else{var $9=$c;label=5;break;}
 case 2: 
 var $2=(function() { try { __THREW__ = 0; return ___ctype_toupper_loc() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=4;break; } else { label=3;break; }
 case 3: 
 var $4$0 = ___cxa_find_matching_catch(-1, -1,0); var $4$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
 case 4: 
 var $5=HEAP32[(($2)>>2)];
 var $6=(($5+($c<<2))|0);
 var $7=HEAP32[(($6)>>2)];
 var $9=$7;label=5;break;
 case 5: 
 var $9;
 return $9;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__15ctypeIwE10do_toupperEPwPKw($this,$low,$high){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=($low|0)==($high|0);
 if($1){var $_0_lcssa=$low;label=7;break;}else{var $_08=$low;label=2;break;}
 case 2: 
 var $_08;
 var $2=HEAP32[(($_08)>>2)];
 var $isascii=($2>>>0)<128;
 if($isascii){label=3;break;}else{var $11=$2;label=6;break;}
 case 3: 
 var $4=(function() { try { __THREW__ = 0; return ___ctype_toupper_loc() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=5;break; } else { label=4;break; }
 case 4: 
 var $6$0 = ___cxa_find_matching_catch(-1, -1,0); var $6$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
 case 5: 
 var $7=HEAP32[(($4)>>2)];
 var $8=(($7+($2<<2))|0);
 var $9=HEAP32[(($8)>>2)];
 var $11=$9;label=6;break;
 case 6: 
 var $11;
 HEAP32[(($_08)>>2)]=$11;
 var $12=(($_08+4)|0);
 var $13=($12|0)==($high|0);
 if($13){var $_0_lcssa=$high;label=7;break;}else{var $_08=$12;label=2;break;}
 case 7: 
 var $_0_lcssa;
 return $_0_lcssa;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__15ctypeIwE10do_tolowerEw($this,$c){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $isascii=($c>>>0)<128;
 if($isascii){label=2;break;}else{var $9=$c;label=5;break;}
 case 2: 
 var $2=(function() { try { __THREW__ = 0; return ___ctype_tolower_loc() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=4;break; } else { label=3;break; }
 case 3: 
 var $4$0 = ___cxa_find_matching_catch(-1, -1,0); var $4$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
 case 4: 
 var $5=HEAP32[(($2)>>2)];
 var $6=(($5+($c<<2))|0);
 var $7=HEAP32[(($6)>>2)];
 var $9=$7;label=5;break;
 case 5: 
 var $9;
 return $9;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__15ctypeIwE10do_tolowerEPwPKw($this,$low,$high){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=($low|0)==($high|0);
 if($1){var $_0_lcssa=$low;label=7;break;}else{var $_08=$low;label=2;break;}
 case 2: 
 var $_08;
 var $2=HEAP32[(($_08)>>2)];
 var $isascii=($2>>>0)<128;
 if($isascii){label=3;break;}else{var $11=$2;label=6;break;}
 case 3: 
 var $4=(function() { try { __THREW__ = 0; return ___ctype_tolower_loc() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=5;break; } else { label=4;break; }
 case 4: 
 var $6$0 = ___cxa_find_matching_catch(-1, -1,0); var $6$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
 case 5: 
 var $7=HEAP32[(($4)>>2)];
 var $8=(($7+($2<<2))|0);
 var $9=HEAP32[(($8)>>2)];
 var $11=$9;label=6;break;
 case 6: 
 var $11;
 HEAP32[(($_08)>>2)]=$11;
 var $12=(($_08+4)|0);
 var $13=($12|0)==($high|0);
 if($13){var $_0_lcssa=$high;label=7;break;}else{var $_08=$12;label=2;break;}
 case 7: 
 var $_0_lcssa;
 return $_0_lcssa;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__15ctypeIwE8do_widenEc($this,$c){
 var label=0;


 var $1=(($c<<24)>>24);
 return $1;
}


function __ZNKSt3__15ctypeIwE8do_widenEPKcS3_Pw($this,$low,$high,$dest){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=($low|0)==($high|0);
 if($1){var $_07_lcssa=$low;label=3;break;}else{var $_078=$low;var $_09=$dest;label=2;break;}
 case 2: 
 var $_09;
 var $_078;
 var $2=HEAP8[($_078)];
 var $3=(($2<<24)>>24);
 HEAP32[(($_09)>>2)]=$3;
 var $4=(($_078+1)|0);
 var $5=(($_09+4)|0);
 var $6=($4|0)==($high|0);
 if($6){var $_07_lcssa=$high;label=3;break;}else{var $_078=$4;var $_09=$5;label=2;break;}
 case 3: 
 var $_07_lcssa;
 return $_07_lcssa;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__15ctypeIwE9do_narrowEwc($this,$c,$dfault){
 var label=0;


 var $isascii=($c>>>0)<128;
 var $1=(($c)&255);
 var $_0=($isascii?$1:$dfault);
 return $_0;
}


function __ZNKSt3__15ctypeIwE9do_narrowEPKwS3_cPc($this,$low,$high,$dfault,$dest){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=($low|0)==($high|0);
 if($1){var $_010_lcssa=$low;label=5;break;}else{label=2;break;}
 case 2: 
 var $low14=$low;
 var $scevgep=((($high)-(4))|0);
 var $scevgep13=$scevgep;
 var $2=(((-$low14))|0);
 var $uglygep=(($scevgep13+$2)|0);
 var $uglygep15=$uglygep;
 var $3=$uglygep15>>>2;
 var $4=((($3)+(1))|0);
 var $_01011=$low;var $_012=$dest;label=3;break;
 case 3: 
 var $_012;
 var $_01011;
 var $6=HEAP32[(($_01011)>>2)];
 var $isascii=($6>>>0)<128;
 var $7=(($6)&255);
 var $_dfault=($isascii?$7:$dfault);
 HEAP8[($_012)]=$_dfault;
 var $8=(($_01011+4)|0);
 var $9=(($_012+1)|0);
 var $10=($8|0)==($high|0);
 if($10){label=4;break;}else{var $_01011=$8;var $_012=$9;label=3;break;}
 case 4: 
 var $scevgep16=(($low+($4<<2))|0);
 var $_010_lcssa=$scevgep16;label=5;break;
 case 5: 
 var $_010_lcssa;
 return $_010_lcssa;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__15ctypeIcED0Ev($this){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=(($this)|0);
 HEAP32[(($1)>>2)]=4512;
 var $2=(($this+8)|0);
 var $3=HEAP32[(($2)>>2)];
 var $4=($3|0)==0;
 if($4){label=4;break;}else{label=2;break;}
 case 2: 
 var $6=(($this+12)|0);
 var $7=HEAP8[($6)];
 var $8=(($7<<24)>>24)==0;
 if($8){label=4;break;}else{label=3;break;}
 case 3: 
 var $10=$3;
 __ZdaPv($10);
 label=4;break;
 case 4: 
 var $11=(($this)|0);
 __ZNSt3__114__shared_countD2Ev($11);
 var $12=$this;
 __ZdlPv($12);
 return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__15ctypeIcED2Ev($this){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=(($this)|0);
 HEAP32[(($1)>>2)]=4512;
 var $2=(($this+8)|0);
 var $3=HEAP32[(($2)>>2)];
 var $4=($3|0)==0;
 if($4){label=4;break;}else{label=2;break;}
 case 2: 
 var $6=(($this+12)|0);
 var $7=HEAP8[($6)];
 var $8=(($7<<24)>>24)==0;
 if($8){label=4;break;}else{label=3;break;}
 case 3: 
 var $10=$3;
 __ZdaPv($10);
 label=4;break;
 case 4: 
 var $12=(($this)|0);
 __ZNSt3__114__shared_countD2Ev($12);
 return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__15ctypeIcE10do_toupperEc($this,$c){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=(($c<<24)>>24)<0;
 if($1){var $12=$c;label=5;break;}else{label=2;break;}
 case 2: 
 var $3=(function() { try { __THREW__ = 0; return ___ctype_toupper_loc() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=4;break; } else { label=3;break; }
 case 3: 
 var $5$0 = ___cxa_find_matching_catch(-1, -1,0); var $5$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
 case 4: 
 var $6=($c&255);
 var $7=HEAP32[(($3)>>2)];
 var $8=(($7+($6<<2))|0);
 var $9=HEAP32[(($8)>>2)];
 var $10=(($9)&255);
 var $12=$10;label=5;break;
 case 5: 
 var $12;
 return $12;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__15ctypeIcE10do_toupperEPcPKc($this,$low,$high){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=($low|0)==($high|0);
 if($1){var $_0_lcssa=$low;label=7;break;}else{var $_09=$low;label=2;break;}
 case 2: 
 var $_09;
 var $2=HEAP8[($_09)];
 var $3=(($2<<24)>>24)<0;
 if($3){var $14=$2;label=6;break;}else{label=3;break;}
 case 3: 
 var $5=(function() { try { __THREW__ = 0; return ___ctype_toupper_loc() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=5;break; } else { label=4;break; }
 case 4: 
 var $7$0 = ___cxa_find_matching_catch(-1, -1,0); var $7$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
 case 5: 
 var $8=(($2<<24)>>24);
 var $9=HEAP32[(($5)>>2)];
 var $10=(($9+($8<<2))|0);
 var $11=HEAP32[(($10)>>2)];
 var $12=(($11)&255);
 var $14=$12;label=6;break;
 case 6: 
 var $14;
 HEAP8[($_09)]=$14;
 var $15=(($_09+1)|0);
 var $16=($15|0)==($high|0);
 if($16){var $_0_lcssa=$high;label=7;break;}else{var $_09=$15;label=2;break;}
 case 7: 
 var $_0_lcssa;
 return $_0_lcssa;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__15ctypeIcE10do_tolowerEc($this,$c){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=(($c<<24)>>24);
 var $2=(($c<<24)>>24)<0;
 if($2){var $12=$c;label=5;break;}else{label=2;break;}
 case 2: 
 var $4=(function() { try { __THREW__ = 0; return ___ctype_tolower_loc() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=4;break; } else { label=3;break; }
 case 3: 
 var $6$0 = ___cxa_find_matching_catch(-1, -1,0); var $6$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
 case 4: 
 var $7=HEAP32[(($4)>>2)];
 var $8=(($7+($1<<2))|0);
 var $9=HEAP32[(($8)>>2)];
 var $10=(($9)&255);
 var $12=$10;label=5;break;
 case 5: 
 var $12;
 return $12;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__15ctypeIcE10do_tolowerEPcPKc($this,$low,$high){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=($low|0)==($high|0);
 if($1){var $_0_lcssa=$low;label=7;break;}else{var $_09=$low;label=2;break;}
 case 2: 
 var $_09;
 var $2=HEAP8[($_09)];
 var $3=(($2<<24)>>24)<0;
 if($3){var $14=$2;label=6;break;}else{label=3;break;}
 case 3: 
 var $5=(function() { try { __THREW__ = 0; return ___ctype_tolower_loc() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=5;break; } else { label=4;break; }
 case 4: 
 var $7$0 = ___cxa_find_matching_catch(-1, -1,0); var $7$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
 case 5: 
 var $8=(($2<<24)>>24);
 var $9=HEAP32[(($5)>>2)];
 var $10=(($9+($8<<2))|0);
 var $11=HEAP32[(($10)>>2)];
 var $12=(($11)&255);
 var $14=$12;label=6;break;
 case 6: 
 var $14;
 HEAP8[($_09)]=$14;
 var $15=(($_09+1)|0);
 var $16=($15|0)==($high|0);
 if($16){var $_0_lcssa=$high;label=7;break;}else{var $_09=$15;label=2;break;}
 case 7: 
 var $_0_lcssa;
 return $_0_lcssa;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__15ctypeIcE8do_widenEc($this,$c){
 var label=0;


 return $c;
}


function __ZNKSt3__15ctypeIcE8do_widenEPKcS3_Pc($this,$low,$high,$dest){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=($low|0)==($high|0);
 if($1){var $_07_lcssa=$low;label=3;break;}else{var $_078=$low;var $_09=$dest;label=2;break;}
 case 2: 
 var $_09;
 var $_078;
 var $2=HEAP8[($_078)];
 HEAP8[($_09)]=$2;
 var $3=(($_078+1)|0);
 var $4=(($_09+1)|0);
 var $5=($3|0)==($high|0);
 if($5){var $_07_lcssa=$high;label=3;break;}else{var $_078=$3;var $_09=$4;label=2;break;}
 case 3: 
 var $_07_lcssa;
 return $_07_lcssa;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__15ctypeIcE9do_narrowEcc($this,$c,$dfault){
 var label=0;


 var $1=(($c<<24)>>24)<0;
 var $dfault_c=($1?$dfault:$c);
 return $dfault_c;
}


function __ZNKSt3__15ctypeIcE9do_narrowEPKcS3_cPc($this,$low,$high,$dfault,$dest){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=($low|0)==($high|0);
 if($1){var $_010_lcssa=$low;label=3;break;}else{var $_01012=$low;var $_013=$dest;label=2;break;}
 case 2: 
 var $_013;
 var $_01012;
 var $2=HEAP8[($_01012)];
 var $3=(($2<<24)>>24)<0;
 var $dfault_=($3?$dfault:$2);
 HEAP8[($_013)]=$dfault_;
 var $4=(($_01012+1)|0);
 var $5=(($_013+1)|0);
 var $6=($4|0)==($high|0);
 if($6){var $_010_lcssa=$high;label=3;break;}else{var $_01012=$4;var $_013=$5;label=2;break;}
 case 3: 
 var $_010_lcssa;
 return $_010_lcssa;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__17codecvtIcc11__mbstate_tED0Ev($this){
 var label=0;


 var $1=(($this)|0);
 __ZNSt3__114__shared_countD2Ev($1);
 var $2=$this;
 __ZdlPv($2);
 return;
}


function __ZNKSt3__17codecvtIcc11__mbstate_tE6do_outERS1_PKcS5_RS5_PcS7_RS7_($this,$0,$frm,$1,$frm_nxt,$to,$2,$to_nxt){
 var label=0;


 HEAP32[(($frm_nxt)>>2)]=$frm;
 HEAP32[(($to_nxt)>>2)]=$to;
 return 3;
}


function __ZNKSt3__17codecvtIcc11__mbstate_tE5do_inERS1_PKcS5_RS5_PcS7_RS7_($this,$0,$frm,$1,$frm_nxt,$to,$2,$to_nxt){
 var label=0;


 HEAP32[(($frm_nxt)>>2)]=$frm;
 HEAP32[(($to_nxt)>>2)]=$to;
 return 3;
}


function __ZNKSt3__17codecvtIcc11__mbstate_tE10do_unshiftERS1_PcS4_RS4_($this,$0,$to,$1,$to_nxt){
 var label=0;


 HEAP32[(($to_nxt)>>2)]=$to;
 return 3;
}


function __ZNKSt3__17codecvtIcc11__mbstate_tE11do_encodingEv($this){
 var label=0;


 return 1;
}


function __ZNKSt3__17codecvtIcc11__mbstate_tE16do_always_noconvEv($this){
 var label=0;


 return 1;
}


function __ZNKSt3__17codecvtIcc11__mbstate_tE9do_lengthERS1_PKcS5_j($this,$0,$frm,$end,$mx){
 var label=0;


 var $2=$end;
 var $3=$frm;
 var $4=((($2)-($3))|0);
 var $5=($4>>>0)<($mx>>>0);
 var $_sroa_speculated=($5?$4:$mx);
 return $_sroa_speculated;
}


function __ZNKSt3__17codecvtIcc11__mbstate_tE13do_max_lengthEv($this){
 var label=0;


 return 1;
}


function __ZNSt3__17codecvtIwc11__mbstate_tED0Ev($this){
 var label=0;


 __ZNSt3__17codecvtIwc11__mbstate_tED2Ev($this);
 var $1=$this;
 __ZdlPv($1);
 return;
}


function __ZNKSt3__17codecvtIwc11__mbstate_tE6do_outERS1_PKwS5_RS5_PcS7_RS7_($this,$st,$frm,$frm_end,$frm_nxt,$to,$to_end,$to_nxt){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+8)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $save_state=sp;
 var $tmpcast=$save_state;
 var $tmp=STACKTOP;STACKTOP = (STACKTOP + 4)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0);
 var $fend_0=$frm;label=2;break;
 case 2: 
 var $fend_0;
 var $2=($fend_0|0)==($frm_end|0);
 if($2){var $fend_0_lcssa=$frm_end;label=4;break;}else{label=3;break;}
 case 3: 
 var $4=HEAP32[(($fend_0)>>2)];
 var $5=($4|0)==0;
 var $6=(($fend_0+4)|0);
 if($5){var $fend_0_lcssa=$fend_0;label=4;break;}else{var $fend_0=$6;label=2;break;}
 case 4: 
 var $fend_0_lcssa;
 HEAP32[(($to_nxt)>>2)]=$to;
 HEAP32[(($frm_nxt)>>2)]=$frm;
 var $8=($frm|0)==($frm_end|0);
 var $9=($to|0)==($to_end|0);
 var $or_cond100=$8|$9;
 if($or_cond100){var $115=$frm;label=49;break;}else{label=5;break;}
 case 5: 
 var $10=$st;
 var $11=$to_end;
 var $12=(($this+8)|0);
 var $13=(($tmp)|0);
 var $_060101=$to;var $_059102=$frm;var $fend_1103=$fend_0_lcssa;label=6;break;
 case 6: 
 var $fend_1103;
 var $_059102;
 var $_060101;
 var $ld$0$0=(($10)|0);
 var $15$0=HEAP32[(($ld$0$0)>>2)];
 var $ld$1$1=(($10+4)|0);
 var $15$1=HEAP32[(($ld$1$1)>>2)];
 var $st$2$0=(($save_state)|0);
 HEAP32[(($st$2$0)>>2)]=$15$0;
 var $st$3$1=(($save_state+4)|0);
 HEAP32[(($st$3$1)>>2)]=$15$1;
 var $16=$fend_1103;
 var $17=$_059102;
 var $18=((($16)-($17))|0);
 var $19=$18>>2;
 var $20=$_060101;
 var $21=((($11)-($20))|0);
 var $22=HEAP32[(($12)>>2)];
 var $23=_uselocale($22);
 var $24=(function() { try { __THREW__ = 0; return _wcsnrtombs($_060101,$frm_nxt,$19,$21,$st) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=7;break; } else { label=10;break; }
 case 7: 
 var $26=($23|0)==0;
 if($26){label=14;break;}else{label=8;break;}
 case 8: 
 var $28=(function() { try { __THREW__ = 0; return _uselocale($23) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=14;break; } else { label=9;break; }
 case 9: 
 var $30$0 = ___cxa_find_matching_catch(-1, -1,0); var $30$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
 case 10: 
 var $32$0 = ___cxa_find_matching_catch(-1, -1); var $32$1 = tempRet0;
 var $33=($23|0)==0;
 if($33){label=13;break;}else{label=11;break;}
 case 11: 
 var $35=(function() { try { __THREW__ = 0; return _uselocale($23) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=13;break; } else { label=12;break; }
 case 12: 
 var $37$0 = ___cxa_find_matching_catch(-1, -1,0); var $37$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
 case 13: 
 ___resumeException($32$0)
 case 14: 
 if(($24|0)==-1){ label=15;break;}else if(($24|0)==0){ var $_0=1;label=50;break;}else{label=27;break;}
 case 15: 
 HEAP32[(($to_nxt)>>2)]=$_060101;
 var $39=HEAP32[(($frm_nxt)>>2)];
 var $40=($_059102|0)==($39|0);
 if($40){var $_1_lcssa=$_059102;label=26;break;}else{var $_167=$_059102;var $41=$_060101;label=16;break;}
 case 16: 
 var $41;
 var $_167;
 var $42=HEAP32[(($_167)>>2)];
 var $43=HEAP32[(($12)>>2)];
 var $44=_uselocale($43);
 var $45=(function() { try { __THREW__ = 0; return _wcrtomb($41,$42,$tmpcast) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=17;break; } else { label=20;break; }
 case 17: 
 var $47=($44|0)==0;
 if($47){label=24;break;}else{label=18;break;}
 case 18: 
 var $49=(function() { try { __THREW__ = 0; return _uselocale($44) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=24;break; } else { label=19;break; }
 case 19: 
 var $51$0 = ___cxa_find_matching_catch(-1, -1,0); var $51$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
 case 20: 
 var $53$0 = ___cxa_find_matching_catch(-1, -1); var $53$1 = tempRet0;
 var $54=($44|0)==0;
 if($54){label=23;break;}else{label=21;break;}
 case 21: 
 var $56=(function() { try { __THREW__ = 0; return _uselocale($44) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=23;break; } else { label=22;break; }
 case 22: 
 var $58$0 = ___cxa_find_matching_catch(-1, -1,0); var $58$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
 case 23: 
 ___resumeException($53$0)
 case 24: 
 var $59=($45|0)==-1;
 if($59){var $_1_lcssa=$_167;label=26;break;}else{label=25;break;}
 case 25: 
 var $61=HEAP32[(($to_nxt)>>2)];
 var $62=(($61+$45)|0);
 HEAP32[(($to_nxt)>>2)]=$62;
 var $63=(($_167+4)|0);
 var $64=HEAP32[(($frm_nxt)>>2)];
 var $65=($63|0)==($64|0);
 if($65){var $_1_lcssa=$63;label=26;break;}else{var $_167=$63;var $41=$62;label=16;break;}
 case 26: 
 var $_1_lcssa;
 HEAP32[(($frm_nxt)>>2)]=$_1_lcssa;
 var $_0=2;label=50;break;
 case 27: 
 var $67=HEAP32[(($to_nxt)>>2)];
 var $68=(($67+$24)|0);
 HEAP32[(($to_nxt)>>2)]=$68;
 var $69=($68|0)==($to_end|0);
 if($69){label=48;break;}else{label=28;break;}
 case 28: 
 var $71=($fend_1103|0)==($frm_end|0);
 if($71){label=29;break;}else{label=30;break;}
 case 29: 
 var $_pre140=HEAP32[(($frm_nxt)>>2)];
 var $fend_3=$frm_end;var $112=$68;var $111=$_pre140;label=47;break;
 case 30: 
 var $73=HEAP32[(($12)>>2)];
 var $74=_uselocale($73);
 var $75=(function() { try { __THREW__ = 0; return _wcrtomb($13,0,$st) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=31;break; } else { label=34;break; }
 case 31: 
 var $77=($74|0)==0;
 if($77){label=38;break;}else{label=32;break;}
 case 32: 
 var $79=(function() { try { __THREW__ = 0; return _uselocale($74) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=38;break; } else { label=33;break; }
 case 33: 
 var $81$0 = ___cxa_find_matching_catch(-1, -1,0); var $81$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
 case 34: 
 var $83$0 = ___cxa_find_matching_catch(-1, -1); var $83$1 = tempRet0;
 var $84=($74|0)==0;
 if($84){label=37;break;}else{label=35;break;}
 case 35: 
 var $86=(function() { try { __THREW__ = 0; return _uselocale($74) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=37;break; } else { label=36;break; }
 case 36: 
 var $88$0 = ___cxa_find_matching_catch(-1, -1,0); var $88$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
 case 37: 
 ___resumeException($83$0)
 case 38: 
 var $89=($75|0)==-1;
 if($89){var $_0=2;label=50;break;}else{label=39;break;}
 case 39: 
 var $91=HEAP32[(($to_nxt)>>2)];
 var $92=$91;
 var $93=((($11)-($92))|0);
 var $94=($75>>>0)>($93>>>0);
 if($94){var $_0=1;label=50;break;}else{label=40;break;}
 case 40: 
 var $95=($75|0)==0;
 if($95){label=43;break;}else{var $n_069=$75;var $p_070=$13;var $96=$91;label=41;break;}
 case 41: 
 var $96;
 var $p_070;
 var $n_069;
 var $97=HEAP8[($p_070)];
 var $98=(($96+1)|0);
 HEAP32[(($to_nxt)>>2)]=$98;
 HEAP8[($96)]=$97;
 var $99=((($n_069)-(1))|0);
 var $100=($99|0)==0;
 if($100){label=43;break;}else{label=42;break;}
 case 42: 
 var $101=(($p_070+1)|0);
 var $_pre141=HEAP32[(($to_nxt)>>2)];
 var $n_069=$99;var $p_070=$101;var $96=$_pre141;label=41;break;
 case 43: 
 var $102=HEAP32[(($frm_nxt)>>2)];
 var $103=(($102+4)|0);
 HEAP32[(($frm_nxt)>>2)]=$103;
 var $fend_2=$103;label=44;break;
 case 44: 
 var $fend_2;
 var $105=($fend_2|0)==($frm_end|0);
 if($105){var $fend_2_lcssa=$frm_end;label=46;break;}else{label=45;break;}
 case 45: 
 var $107=HEAP32[(($fend_2)>>2)];
 var $108=($107|0)==0;
 var $109=(($fend_2+4)|0);
 if($108){var $fend_2_lcssa=$fend_2;label=46;break;}else{var $fend_2=$109;label=44;break;}
 case 46: 
 var $fend_2_lcssa;
 var $_pre137=HEAP32[(($to_nxt)>>2)];
 var $fend_3=$fend_2_lcssa;var $112=$_pre137;var $111=$103;label=47;break;
 case 47: 
 var $111;
 var $112;
 var $fend_3;
 var $113=($111|0)==($frm_end|0);
 var $114=($112|0)==($to_end|0);
 var $or_cond=$113|$114;
 if($or_cond){var $115=$111;label=49;break;}else{var $_060101=$112;var $_059102=$111;var $fend_1103=$fend_3;label=6;break;}
 case 48: 
 var $_pre=HEAP32[(($frm_nxt)>>2)];
 var $115=$_pre;label=49;break;
 case 49: 
 var $115;
 var $not_=($115|0)!=($frm_end|0);
 var $116=($not_&1);
 var $_0=$116;label=50;break;
 case 50: 
 var $_0;
 STACKTOP=sp;return $_0;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__17codecvtIwc11__mbstate_tE5do_inERS1_PKcS5_RS5_PwS7_RS7_($this,$st,$frm,$frm_end,$frm_nxt,$to,$to_end,$to_nxt){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+8)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $save_state=sp;
 var $tmpcast=$save_state;
 var $fend_0=$frm;label=2;break;
 case 2: 
 var $fend_0;
 var $2=($fend_0|0)==($frm_end|0);
 if($2){var $fend_0_lcssa=$frm_end;label=4;break;}else{label=3;break;}
 case 3: 
 var $4=HEAP8[($fend_0)];
 var $5=(($4<<24)>>24)==0;
 var $6=(($fend_0+1)|0);
 if($5){var $fend_0_lcssa=$fend_0;label=4;break;}else{var $fend_0=$6;label=2;break;}
 case 4: 
 var $fend_0_lcssa;
 HEAP32[(($to_nxt)>>2)]=$to;
 HEAP32[(($frm_nxt)>>2)]=$frm;
 var $8=($frm|0)==($frm_end|0);
 var $9=($to|0)==($to_end|0);
 var $or_cond113=$8|$9;
 if($or_cond113){var $108=$frm;label=48;break;}else{label=5;break;}
 case 5: 
 var $10=$st;
 var $11=$to_end;
 var $12=(($this+8)|0);
 var $_066114=$to;var $_065115=$frm;var $fend_1116=$fend_0_lcssa;label=6;break;
 case 6: 
 var $fend_1116;
 var $_065115;
 var $_066114;
 var $ld$0$0=(($10)|0);
 var $14$0=HEAP32[(($ld$0$0)>>2)];
 var $ld$1$1=(($10+4)|0);
 var $14$1=HEAP32[(($ld$1$1)>>2)];
 var $st$2$0=(($save_state)|0);
 HEAP32[(($st$2$0)>>2)]=$14$0;
 var $st$3$1=(($save_state+4)|0);
 HEAP32[(($st$3$1)>>2)]=$14$1;
 var $15=$fend_1116;
 var $16=$_065115;
 var $17=((($15)-($16))|0);
 var $18=$_066114;
 var $19=((($11)-($18))|0);
 var $20=$19>>2;
 var $21=HEAP32[(($12)>>2)];
 var $22=_uselocale($21);
 var $23=(function() { try { __THREW__ = 0; return _mbsnrtowcs($_066114,$frm_nxt,$17,$20,$st) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=7;break; } else { label=10;break; }
 case 7: 
 var $25=($22|0)==0;
 if($25){label=14;break;}else{label=8;break;}
 case 8: 
 var $27=(function() { try { __THREW__ = 0; return _uselocale($22) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=14;break; } else { label=9;break; }
 case 9: 
 var $29$0 = ___cxa_find_matching_catch(-1, -1,0); var $29$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
 case 10: 
 var $31$0 = ___cxa_find_matching_catch(-1, -1); var $31$1 = tempRet0;
 var $32=($22|0)==0;
 if($32){label=13;break;}else{label=11;break;}
 case 11: 
 var $34=(function() { try { __THREW__ = 0; return _uselocale($22) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=13;break; } else { label=12;break; }
 case 12: 
 var $36$0 = ___cxa_find_matching_catch(-1, -1,0); var $36$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
 case 13: 
 ___resumeException($31$0)
 case 14: 
 if(($23|0)==-1){ label=15;break;}else if(($23|0)==0){ var $_0=2;label=49;break;}else{label=31;break;}
 case 15: 
 HEAP32[(($to_nxt)>>2)]=$_066114;
 var $37=HEAP32[(($frm_nxt)>>2)];
 var $38=($_065115|0)==($37|0);
 if($38){var $_1_lcssa=$_065115;label=30;break;}else{var $storemerge78=$_066114;var $_179=$_065115;label=16;break;}
 case 16: 
 var $_179;
 var $storemerge78;
 var $39=$_179;
 var $40=((($15)-($39))|0);
 var $41=HEAP32[(($12)>>2)];
 var $42=_uselocale($41);
 var $43=(function() { try { __THREW__ = 0; return _mbrtowc($storemerge78,$_179,$40,$tmpcast) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=17;break; } else { label=20;break; }
 case 17: 
 var $45=($42|0)==0;
 if($45){label=24;break;}else{label=18;break;}
 case 18: 
 var $47=(function() { try { __THREW__ = 0; return _uselocale($42) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=24;break; } else { label=19;break; }
 case 19: 
 var $49$0 = ___cxa_find_matching_catch(-1, -1,0); var $49$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
 case 20: 
 var $51$0 = ___cxa_find_matching_catch(-1, -1); var $51$1 = tempRet0;
 var $52=($42|0)==0;
 if($52){label=23;break;}else{label=21;break;}
 case 21: 
 var $54=(function() { try { __THREW__ = 0; return _uselocale($42) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=23;break; } else { label=22;break; }
 case 22: 
 var $56$0 = ___cxa_find_matching_catch(-1, -1,0); var $56$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
 case 23: 
 ___resumeException($51$0)
 case 24: 
 if(($43|0)==0){ label=25;break;}else if(($43|0)==-1){ label=26;break;}else if(($43|0)==-2){ label=27;break;}else{label=28;break;}
 case 25: 
 var $58=(($_179+1)|0);
 var $_2=$58;label=29;break;
 case 26: 
 HEAP32[(($frm_nxt)>>2)]=$_179;
 var $_0=2;label=49;break;
 case 27: 
 HEAP32[(($frm_nxt)>>2)]=$_179;
 var $_0=1;label=49;break;
 case 28: 
 var $62=(($_179+$43)|0);
 var $_2=$62;label=29;break;
 case 29: 
 var $_2;
 var $64=HEAP32[(($to_nxt)>>2)];
 var $65=(($64+4)|0);
 HEAP32[(($to_nxt)>>2)]=$65;
 var $66=HEAP32[(($frm_nxt)>>2)];
 var $67=($_2|0)==($66|0);
 if($67){var $_1_lcssa=$_2;label=30;break;}else{var $storemerge78=$65;var $_179=$_2;label=16;break;}
 case 30: 
 var $_1_lcssa;
 HEAP32[(($frm_nxt)>>2)]=$_1_lcssa;
 var $not_67=($_1_lcssa|0)!=($frm_end|0);
 var $68=($not_67&1);
 var $_0=$68;label=49;break;
 case 31: 
 var $70=HEAP32[(($to_nxt)>>2)];
 var $71=(($70+($23<<2))|0);
 HEAP32[(($to_nxt)>>2)]=$71;
 var $72=($71|0)==($to_end|0);
 if($72){label=47;break;}else{label=32;break;}
 case 32: 
 var $74=($fend_1116|0)==($frm_end|0);
 var $_pre161=HEAP32[(($frm_nxt)>>2)];
 if($74){var $fend_3=$frm_end;var $105=$71;var $104=$_pre161;label=46;break;}else{label=33;break;}
 case 33: 
 var $76=HEAP32[(($12)>>2)];
 var $77=_uselocale($76);
 var $78=(function() { try { __THREW__ = 0; return _mbrtowc($71,$_pre161,1,$st) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=34;break; } else { label=37;break; }
 case 34: 
 var $80=($77|0)==0;
 if($80){label=41;break;}else{label=35;break;}
 case 35: 
 var $82=(function() { try { __THREW__ = 0; return _uselocale($77) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=41;break; } else { label=36;break; }
 case 36: 
 var $84$0 = ___cxa_find_matching_catch(-1, -1,0); var $84$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
 case 37: 
 var $86$0 = ___cxa_find_matching_catch(-1, -1); var $86$1 = tempRet0;
 var $87=($77|0)==0;
 if($87){label=40;break;}else{label=38;break;}
 case 38: 
 var $89=(function() { try { __THREW__ = 0; return _uselocale($77) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=40;break; } else { label=39;break; }
 case 39: 
 var $91$0 = ___cxa_find_matching_catch(-1, -1,0); var $91$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
 case 40: 
 ___resumeException($86$0)
 case 41: 
 var $92=($78|0)==0;
 if($92){label=42;break;}else{var $_0=2;label=49;break;}
 case 42: 
 var $94=HEAP32[(($to_nxt)>>2)];
 var $95=(($94+4)|0);
 HEAP32[(($to_nxt)>>2)]=$95;
 var $96=HEAP32[(($frm_nxt)>>2)];
 var $97=(($96+1)|0);
 HEAP32[(($frm_nxt)>>2)]=$97;
 var $fend_2=$97;label=43;break;
 case 43: 
 var $fend_2;
 var $99=($fend_2|0)==($frm_end|0);
 if($99){var $fend_2_lcssa=$frm_end;label=45;break;}else{label=44;break;}
 case 44: 
 var $101=HEAP8[($fend_2)];
 var $102=(($101<<24)>>24)==0;
 var $103=(($fend_2+1)|0);
 if($102){var $fend_2_lcssa=$fend_2;label=45;break;}else{var $fend_2=$103;label=43;break;}
 case 45: 
 var $fend_2_lcssa;
 var $_pre159=HEAP32[(($to_nxt)>>2)];
 var $fend_3=$fend_2_lcssa;var $105=$_pre159;var $104=$97;label=46;break;
 case 46: 
 var $104;
 var $105;
 var $fend_3;
 var $106=($104|0)==($frm_end|0);
 var $107=($105|0)==($to_end|0);
 var $or_cond=$106|$107;
 if($or_cond){var $108=$104;label=48;break;}else{var $_066114=$105;var $_065115=$104;var $fend_1116=$fend_3;label=6;break;}
 case 47: 
 var $_pre=HEAP32[(($frm_nxt)>>2)];
 var $108=$_pre;label=48;break;
 case 48: 
 var $108;
 var $not_=($108|0)!=($frm_end|0);
 var $109=($not_&1);
 var $_0=$109;label=49;break;
 case 49: 
 var $_0;
 STACKTOP=sp;return $_0;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__17codecvtIwc11__mbstate_tE10do_unshiftERS1_PcS4_RS4_($this,$st,$to,$to_end,$to_nxt){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+8)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $tmp=sp;
 HEAP32[(($to_nxt)>>2)]=$to;
 var $1=(($tmp)|0);
 var $2=(($this+8)|0);
 var $3=HEAP32[(($2)>>2)];
 var $4=_uselocale($3);
 var $5=(function() { try { __THREW__ = 0; return _wcrtomb($1,0,$st) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=2;break; } else { label=5;break; }
 case 2: 
 var $7=($4|0)==0;
 if($7){label=9;break;}else{label=3;break;}
 case 3: 
 var $9=(function() { try { __THREW__ = 0; return _uselocale($4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=9;break; } else { label=4;break; }
 case 4: 
 var $11$0 = ___cxa_find_matching_catch(-1, -1,0); var $11$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
 case 5: 
 var $13$0 = ___cxa_find_matching_catch(-1, -1); var $13$1 = tempRet0;
 var $14=($4|0)==0;
 if($14){label=8;break;}else{label=6;break;}
 case 6: 
 var $16=(function() { try { __THREW__ = 0; return _uselocale($4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=8;break; } else { label=7;break; }
 case 7: 
 var $18$0 = ___cxa_find_matching_catch(-1, -1,0); var $18$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
 case 8: 
 ___resumeException($13$0)
 case 9: 
 if(($5|0)==-1|($5|0)==0){ var $_0=2;label=14;break;}else{label=10;break;}
 case 10: 
 var $20=((($5)-(1))|0);
 var $21=HEAP32[(($to_nxt)>>2)];
 var $22=$to_end;
 var $23=$21;
 var $24=((($22)-($23))|0);
 var $25=($20>>>0)>($24>>>0);
 if($25){var $_0=1;label=14;break;}else{label=11;break;}
 case 11: 
 var $26=($20|0)==0;
 if($26){var $_0=0;label=14;break;}else{var $n_014=$20;var $p_015=$1;var $27=$21;label=12;break;}
 case 12: 
 var $27;
 var $p_015;
 var $n_014;
 var $28=HEAP8[($p_015)];
 var $29=(($27+1)|0);
 HEAP32[(($to_nxt)>>2)]=$29;
 HEAP8[($27)]=$28;
 var $30=((($n_014)-(1))|0);
 var $31=($30|0)==0;
 if($31){var $_0=0;label=14;break;}else{label=13;break;}
 case 13: 
 var $32=(($p_015+1)|0);
 var $_pre=HEAP32[(($to_nxt)>>2)];
 var $n_014=$30;var $p_015=$32;var $27=$_pre;label=12;break;
 case 14: 
 var $_0;
 STACKTOP=sp;return $_0;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__17codecvtIwc11__mbstate_tE11do_encodingEv($this){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=(($this+8)|0);
 var $2=HEAP32[(($1)>>2)];
 var $3=(function() { try { __THREW__ = 0; return _uselocale($2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=2;break; } else { label=16;break; }
 case 2: 
 var $4=(function() { try { __THREW__ = 0; return _mbtowc(0,0,4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=3;break; } else { label=6;break; }
 case 3: 
 var $6=($3|0)==0;
 if($6){label=9;break;}else{label=4;break;}
 case 4: 
 var $8=(function() { try { __THREW__ = 0; return _uselocale($3) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=9;break; } else { label=5;break; }
 case 5: 
 var $10$0 = ___cxa_find_matching_catch(-1, -1,0); var $10$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
 case 6: 
 var $12$0 = ___cxa_find_matching_catch(-1, -1,0); var $12$1 = tempRet0;
 var $13=($3|0)==0;
 if($13){label=17;break;}else{label=7;break;}
 case 7: 
 var $15=(function() { try { __THREW__ = 0; return _uselocale($3) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=17;break; } else { label=8;break; }
 case 8: 
 var $17$0 = ___cxa_find_matching_catch(-1, -1,0); var $17$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
 case 9: 
 var $18=($4|0)==0;
 if($18){label=10;break;}else{var $_0=-1;label=15;break;}
 case 10: 
 var $20=HEAP32[(($1)>>2)];
 var $21=($20|0)==0;
 if($21){var $_0=1;label=15;break;}else{label=11;break;}
 case 11: 
 var $23=(function() { try { __THREW__ = 0; return _uselocale($20) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=12;break; } else { label=16;break; }
 case 12: 
 var $24=($23|0)==0;
 if($24){var $_0=0;label=15;break;}else{label=13;break;}
 case 13: 
 var $26=(function() { try { __THREW__ = 0; return _uselocale($23) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $_0=0;label=15;break; } else { label=14;break; }
 case 14: 
 var $28$0 = ___cxa_find_matching_catch(-1, -1,0); var $28$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
 case 15: 
 var $_0;
 return $_0;
 case 16: 
 var $30$0 = ___cxa_find_matching_catch(-1, -1,0); var $30$1 = tempRet0;
 label=17;break;
 case 17: 
 __ZSt9terminatev();
 throw "Reached an unreachable!";
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__17codecvtIwc11__mbstate_tE16do_always_noconvEv($this){
 var label=0;


 return 0;
}


function __ZNKSt3__17codecvtIwc11__mbstate_tE9do_lengthERS1_PKcS5_j($this,$st,$frm,$frm_end,$mx){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=($mx|0)==0;
 var $2=($frm|0)==($frm_end|0);
 var $or_cond21=$1|$2;
 if($or_cond21){var $nbytes_0_lcssa=0;label=15;break;}else{label=2;break;}
 case 2: 
 var $3=$frm_end;
 var $4=(($this+8)|0);
 var $_01722=$frm;var $nbytes_023=0;var $nwchar_t_024=0;label=3;break;
 case 3: 
 var $nwchar_t_024;
 var $nbytes_023;
 var $_01722;
 var $6=$_01722;
 var $7=((($3)-($6))|0);
 var $8=HEAP32[(($4)>>2)];
 var $9=_uselocale($8);
 var $10=(function() { try { __THREW__ = 0; return _mbrlen($_01722,$7,$st) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=4;break; } else { label=7;break; }
 case 4: 
 var $12=($9|0)==0;
 if($12){label=11;break;}else{label=5;break;}
 case 5: 
 var $14=(function() { try { __THREW__ = 0; return _uselocale($9) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=11;break; } else { label=6;break; }
 case 6: 
 var $16$0 = ___cxa_find_matching_catch(-1, -1,0); var $16$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
 case 7: 
 var $18$0 = ___cxa_find_matching_catch(-1, -1); var $18$1 = tempRet0;
 var $19=($9|0)==0;
 if($19){label=10;break;}else{label=8;break;}
 case 8: 
 var $21=(function() { try { __THREW__ = 0; return _uselocale($9) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=10;break; } else { label=9;break; }
 case 9: 
 var $23$0 = ___cxa_find_matching_catch(-1, -1,0); var $23$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
 case 10: 
 ___resumeException($18$0)
 case 11: 
 if(($10|0)==0){ label=12;break;}else if(($10|0)==-1|($10|0)==-2){ var $nbytes_0_lcssa=$nbytes_023;label=15;break;}else{label=13;break;}
 case 12: 
 var $25=(($_01722+1)|0);
 var $_pn=1;var $_1=$25;label=14;break;
 case 13: 
 var $27=(($_01722+$10)|0);
 var $_pn=$10;var $_1=$27;label=14;break;
 case 14: 
 var $_1;
 var $_pn;
 var $nbytes_1=((($_pn)+($nbytes_023))|0);
 var $29=((($nwchar_t_024)+(1))|0);
 var $30=($29>>>0)>=($mx>>>0);
 var $31=($_1|0)==($frm_end|0);
 var $or_cond=$30|$31;
 if($or_cond){var $nbytes_0_lcssa=$nbytes_1;label=15;break;}else{var $_01722=$_1;var $nbytes_023=$nbytes_1;var $nwchar_t_024=$29;label=3;break;}
 case 15: 
 var $nbytes_0_lcssa;
 return $nbytes_0_lcssa;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__17codecvtIwc11__mbstate_tE13do_max_lengthEv($this){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=(($this+8)|0);
 var $2=HEAP32[(($1)>>2)];
 var $3=($2|0)==0;
 if($3){var $11=1;label=6;break;}else{label=2;break;}
 case 2: 
 var $5=(function() { try { __THREW__ = 0; return _uselocale($2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=3;break; } else { label=7;break; }
 case 3: 
 var $6=($5|0)==0;
 if($6){var $11=4;label=6;break;}else{label=4;break;}
 case 4: 
 var $8=(function() { try { __THREW__ = 0; return _uselocale($5) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { var $11=4;label=6;break; } else { label=5;break; }
 case 5: 
 var $10$0 = ___cxa_find_matching_catch(-1, -1,0); var $10$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
 case 6: 
 var $11;
 return $11;
 case 7: 
 var $13$0 = ___cxa_find_matching_catch(-1, -1,0); var $13$1 = tempRet0;
 __ZSt9terminatev();
 throw "Reached an unreachable!";
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__17codecvtIDsc11__mbstate_tED0Ev($this){
 var label=0;


 var $1=(($this)|0);
 __ZNSt3__114__shared_countD2Ev($1);
 var $2=$this;
 __ZdlPv($2);
 return;
}


function __ZNKSt3__17codecvtIDsc11__mbstate_tE6do_outERS1_PKDsS5_RS5_PcS7_RS7_($this,$0,$frm,$frm_end,$frm_nxt,$to,$to_end,$to_nxt){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+16)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);

 var $_frm_nxt=sp;
 var $_to_nxt=(sp)+(8);
 HEAP32[(($_frm_nxt)>>2)]=$frm;
 HEAP32[(($_to_nxt)>>2)]=$to;
 var $2=__ZNSt3__1L13utf16_to_utf8EPKtS1_RS1_PhS3_RS3_mNS_12codecvt_modeE($frm,$frm_end,$_frm_nxt,$to,$to_end,$_to_nxt,1114111,0);
 var $3=HEAP32[(($_frm_nxt)>>2)];
 var $4=$3;
 var $5=$frm;
 var $6=((($4)-($5))|0);
 var $7=$6>>1;
 var $8=(($frm+($7<<1))|0);
 HEAP32[(($frm_nxt)>>2)]=$8;
 var $9=HEAP32[(($_to_nxt)>>2)];
 var $10=$9;
 var $11=$to;
 var $12=((($10)-($11))|0);
 var $13=(($to+$12)|0);
 HEAP32[(($to_nxt)>>2)]=$13;
 STACKTOP=sp;return $2;
}


function __ZNSt3__1L13utf16_to_utf8EPKtS1_RS1_PhS3_RS3_mNS_12codecvt_modeE($frm,$frm_end,$frm_nxt,$to,$to_end,$to_nxt,$Maxcode,$mode){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 HEAP32[(($frm_nxt)>>2)]=$frm;
 HEAP32[(($to_nxt)>>2)]=$to;
 var $1=$mode&2;
 var $2=($1|0)==0;
 if($2){label=4;break;}else{label=2;break;}
 case 2: 
 var $4=$to_end;
 var $5=$to;
 var $6=((($4)-($5))|0);
 var $7=($6|0)<3;
 if($7){var $_0=1;label=26;break;}else{label=3;break;}
 case 3: 
 var $9=(($to+1)|0);
 HEAP32[(($to_nxt)>>2)]=$9;
 HEAP8[($to)]=-17;
 var $10=HEAP32[(($to_nxt)>>2)];
 var $11=(($10+1)|0);
 HEAP32[(($to_nxt)>>2)]=$11;
 HEAP8[($10)]=-69;
 var $12=HEAP32[(($to_nxt)>>2)];
 var $13=(($12+1)|0);
 HEAP32[(($to_nxt)>>2)]=$13;
 HEAP8[($12)]=-65;
 label=4;break;
 case 4: 
 var $14=$frm_end;
 var $15=HEAP32[(($frm_nxt)>>2)];
 var $16=($15>>>0)<($frm_end>>>0);
 if($16){label=5;break;}else{var $_0=0;label=26;break;}
 case 5: 
 var $17=$to_end;
 var $19=$15;label=6;break;
 case 6: 
 var $19;
 var $20=HEAP16[(($19)>>1)];
 var $21=($20&65535);
 var $22=($21>>>0)>($Maxcode>>>0);
 if($22){var $_0=2;label=26;break;}else{label=7;break;}
 case 7: 
 var $24=($20&65535)<128;
 if($24){label=8;break;}else{label=10;break;}
 case 8: 
 var $26=HEAP32[(($to_nxt)>>2)];
 var $27=$26;
 var $28=((($17)-($27))|0);
 var $29=($28|0)<1;
 if($29){var $_0=1;label=26;break;}else{label=9;break;}
 case 9: 
 var $31=(($20)&255);
 var $32=(($26+1)|0);
 HEAP32[(($to_nxt)>>2)]=$32;
 HEAP8[($26)]=$31;
 label=25;break;
 case 10: 
 var $34=($20&65535)<2048;
 if($34){label=11;break;}else{label=13;break;}
 case 11: 
 var $36=HEAP32[(($to_nxt)>>2)];
 var $37=$36;
 var $38=((($17)-($37))|0);
 var $39=($38|0)<2;
 if($39){var $_0=1;label=26;break;}else{label=12;break;}
 case 12: 
 var $41=$21>>>6;
 var $42=$41|192;
 var $43=(($42)&255);
 var $44=(($36+1)|0);
 HEAP32[(($to_nxt)>>2)]=$44;
 HEAP8[($36)]=$43;
 var $45=$21&63;
 var $46=$45|128;
 var $47=(($46)&255);
 var $48=HEAP32[(($to_nxt)>>2)];
 var $49=(($48+1)|0);
 HEAP32[(($to_nxt)>>2)]=$49;
 HEAP8[($48)]=$47;
 label=25;break;
 case 13: 
 var $51=($20&65535)<55296;
 if($51){label=14;break;}else{label=16;break;}
 case 14: 
 var $53=HEAP32[(($to_nxt)>>2)];
 var $54=$53;
 var $55=((($17)-($54))|0);
 var $56=($55|0)<3;
 if($56){var $_0=1;label=26;break;}else{label=15;break;}
 case 15: 
 var $58=$21>>>12;
 var $59=$58|224;
 var $60=(($59)&255);
 var $61=(($53+1)|0);
 HEAP32[(($to_nxt)>>2)]=$61;
 HEAP8[($53)]=$60;
 var $62=$21>>>6;
 var $63=$62&63;
 var $64=$63|128;
 var $65=(($64)&255);
 var $66=HEAP32[(($to_nxt)>>2)];
 var $67=(($66+1)|0);
 HEAP32[(($to_nxt)>>2)]=$67;
 HEAP8[($66)]=$65;
 var $68=$21&63;
 var $69=$68|128;
 var $70=(($69)&255);
 var $71=HEAP32[(($to_nxt)>>2)];
 var $72=(($71+1)|0);
 HEAP32[(($to_nxt)>>2)]=$72;
 HEAP8[($71)]=$70;
 label=25;break;
 case 16: 
 var $74=($20&65535)<56320;
 if($74){label=17;break;}else{label=22;break;}
 case 17: 
 var $76=$19;
 var $77=((($14)-($76))|0);
 var $78=($77|0)<4;
 if($78){var $_0=1;label=26;break;}else{label=18;break;}
 case 18: 
 var $80=(($19+2)|0);
 var $81=HEAP16[(($80)>>1)];
 var $82=($81&65535);
 var $83=$82&64512;
 var $84=($83|0)==56320;
 if($84){label=19;break;}else{var $_0=2;label=26;break;}
 case 19: 
 var $86=HEAP32[(($to_nxt)>>2)];
 var $87=$86;
 var $88=((($17)-($87))|0);
 var $89=($88|0)<4;
 if($89){var $_0=1;label=26;break;}else{label=20;break;}
 case 20: 
 var $91=$21&960;
 var $92=$91<<10;
 var $93=((($92)+(65536))|0);
 var $94=$21<<10;
 var $95=$94&64512;
 var $96=$93|$95;
 var $97=$82&1023;
 var $98=$96|$97;
 var $99=($98>>>0)>($Maxcode>>>0);
 if($99){var $_0=2;label=26;break;}else{label=21;break;}
 case 21: 
 HEAP32[(($frm_nxt)>>2)]=$80;
 var $101=$91>>>6;
 var $102=((($101)+(1))|0);
 var $103=$102>>>2;
 var $104=$103|240;
 var $105=(($104)&255);
 var $106=HEAP32[(($to_nxt)>>2)];
 var $107=(($106+1)|0);
 HEAP32[(($to_nxt)>>2)]=$107;
 HEAP8[($106)]=$105;
 var $108=$102<<4;
 var $109=$108&48;
 var $110=$21>>>2;
 var $111=$110&15;
 var $112=$111|$109;
 var $113=$112|128;
 var $114=(($113)&255);
 var $115=HEAP32[(($to_nxt)>>2)];
 var $116=(($115+1)|0);
 HEAP32[(($to_nxt)>>2)]=$116;
 HEAP8[($115)]=$114;
 var $117=$21<<4;
 var $118=$117&48;
 var $119=$82>>>6;
 var $120=$119&15;
 var $121=$118|$120;
 var $122=$121|128;
 var $123=(($122)&255);
 var $124=HEAP32[(($to_nxt)>>2)];
 var $125=(($124+1)|0);
 HEAP32[(($to_nxt)>>2)]=$125;
 HEAP8[($124)]=$123;
 var $126=$82&63;
 var $127=$126|128;
 var $128=(($127)&255);
 var $129=HEAP32[(($to_nxt)>>2)];
 var $130=(($129+1)|0);
 HEAP32[(($to_nxt)>>2)]=$130;
 HEAP8[($129)]=$128;
 label=25;break;
 case 22: 
 var $132=($20&65535)<57344;
 if($132){var $_0=2;label=26;break;}else{label=23;break;}
 case 23: 
 var $134=HEAP32[(($to_nxt)>>2)];
 var $135=$134;
 var $136=((($17)-($135))|0);
 var $137=($136|0)<3;
 if($137){var $_0=1;label=26;break;}else{label=24;break;}
 case 24: 
 var $139=$21>>>12;
 var $140=$139|224;
 var $141=(($140)&255);
 var $142=(($134+1)|0);
 HEAP32[(($to_nxt)>>2)]=$142;
 HEAP8[($134)]=$141;
 var $143=$21>>>6;
 var $144=$143&63;
 var $145=$144|128;
 var $146=(($145)&255);
 var $147=HEAP32[(($to_nxt)>>2)];
 var $148=(($147+1)|0);
 HEAP32[(($to_nxt)>>2)]=$148;
 HEAP8[($147)]=$146;
 var $149=$21&63;
 var $150=$149|128;
 var $151=(($150)&255);
 var $152=HEAP32[(($to_nxt)>>2)];
 var $153=(($152+1)|0);
 HEAP32[(($to_nxt)>>2)]=$153;
 HEAP8[($152)]=$151;
 label=25;break;
 case 25: 
 var $155=HEAP32[(($frm_nxt)>>2)];
 var $156=(($155+2)|0);
 HEAP32[(($frm_nxt)>>2)]=$156;
 var $157=($156>>>0)<($frm_end>>>0);
 if($157){var $19=$156;label=6;break;}else{var $_0=0;label=26;break;}
 case 26: 
 var $_0;
 return $_0;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__17codecvtIDsc11__mbstate_tE5do_inERS1_PKcS5_RS5_PDsS7_RS7_($this,$0,$frm,$frm_end,$frm_nxt,$to,$to_end,$to_nxt){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+16)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);

 var $_frm_nxt=sp;
 var $_to_nxt=(sp)+(8);
 HEAP32[(($_frm_nxt)>>2)]=$frm;
 HEAP32[(($_to_nxt)>>2)]=$to;
 var $2=__ZNSt3__1L13utf8_to_utf16EPKhS1_RS1_PtS3_RS3_mNS_12codecvt_modeE($frm,$frm_end,$_frm_nxt,$to,$to_end,$_to_nxt,1114111,0);
 var $3=HEAP32[(($_frm_nxt)>>2)];
 var $4=$3;
 var $5=$frm;
 var $6=((($4)-($5))|0);
 var $7=(($frm+$6)|0);
 HEAP32[(($frm_nxt)>>2)]=$7;
 var $8=HEAP32[(($_to_nxt)>>2)];
 var $9=$8;
 var $10=$to;
 var $11=((($9)-($10))|0);
 var $12=$11>>1;
 var $13=(($to+($12<<1))|0);
 HEAP32[(($to_nxt)>>2)]=$13;
 STACKTOP=sp;return $2;
}


function __ZNSt3__1L13utf8_to_utf16EPKhS1_RS1_PtS3_RS3_mNS_12codecvt_modeE($frm,$frm_end,$frm_nxt,$to,$to_end,$to_nxt,$Maxcode,$mode){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 HEAP32[(($frm_nxt)>>2)]=$frm;
 HEAP32[(($to_nxt)>>2)]=$to;
 var $1=$mode&4;
 var $2=($1|0)==0;
 var $_pre79=HEAP32[(($frm_nxt)>>2)];
 if($2){var $21=$_pre79;label=7;break;}else{label=2;break;}
 case 2: 
 var $4=$frm_end;
 var $5=$_pre79;
 var $6=((($4)-($5))|0);
 var $7=($6|0)>2;
 if($7){label=3;break;}else{var $21=$_pre79;label=7;break;}
 case 3: 
 var $9=HEAP8[($_pre79)];
 var $10=(($9<<24)>>24)==-17;
 if($10){label=4;break;}else{var $21=$_pre79;label=7;break;}
 case 4: 
 var $12=(($_pre79+1)|0);
 var $13=HEAP8[($12)];
 var $14=(($13<<24)>>24)==-69;
 if($14){label=5;break;}else{var $21=$_pre79;label=7;break;}
 case 5: 
 var $16=(($_pre79+2)|0);
 var $17=HEAP8[($16)];
 var $18=(($17<<24)>>24)==-65;
 if($18){label=6;break;}else{var $21=$_pre79;label=7;break;}
 case 6: 
 var $20=(($_pre79+3)|0);
 HEAP32[(($frm_nxt)>>2)]=$20;
 var $21=$20;label=7;break;
 case 7: 
 var $21;
 var $22=($21>>>0)<($frm_end>>>0);
 if($22){label=8;break;}else{var $171=$21;label=40;break;}
 case 8: 
 var $23=$frm_end;
 var $24=$to_end;
 var $_pre=HEAP32[(($to_nxt)>>2)];
 var $27=$_pre;var $26=$21;label=9;break;
 case 9: 
 var $26;
 var $27;
 var $28=($27>>>0)<($to_end>>>0);
 if($28){label=10;break;}else{var $171=$26;label=40;break;}
 case 10: 
 var $30=HEAP8[($26)];
 var $31=($30&255);
 var $32=($31>>>0)>($Maxcode>>>0);
 if($32){var $_0=2;label=41;break;}else{label=11;break;}
 case 11: 
 var $34=(($30<<24)>>24)>-1;
 if($34){label=12;break;}else{label=13;break;}
 case 12: 
 var $36=($30&255);
 HEAP16[(($27)>>1)]=$36;
 var $37=(($26+1)|0);
 HEAP32[(($frm_nxt)>>2)]=$37;
 label=39;break;
 case 13: 
 var $39=($30&255)<194;
 if($39){var $_0=2;label=41;break;}else{label=14;break;}
 case 14: 
 var $41=($30&255)<224;
 if($41){label=15;break;}else{label=19;break;}
 case 15: 
 var $43=$26;
 var $44=((($23)-($43))|0);
 var $45=($44|0)<2;
 if($45){var $_0=1;label=41;break;}else{label=16;break;}
 case 16: 
 var $47=(($26+1)|0);
 var $48=HEAP8[($47)];
 var $49=($48&255);
 var $50=$49&192;
 var $51=($50|0)==128;
 if($51){label=17;break;}else{var $_0=2;label=41;break;}
 case 17: 
 var $53=$31<<6;
 var $54=$53&1984;
 var $55=$49&63;
 var $56=$55|$54;
 var $57=($56>>>0)>($Maxcode>>>0);
 if($57){var $_0=2;label=41;break;}else{label=18;break;}
 case 18: 
 var $59=(($56)&65535);
 HEAP16[(($27)>>1)]=$59;
 var $60=(($26+2)|0);
 HEAP32[(($frm_nxt)>>2)]=$60;
 label=39;break;
 case 19: 
 var $62=($30&255)<240;
 if($62){label=20;break;}else{label=28;break;}
 case 20: 
 var $64=$26;
 var $65=((($23)-($64))|0);
 var $66=($65|0)<3;
 if($66){var $_0=1;label=41;break;}else{label=21;break;}
 case 21: 
 var $68=(($26+1)|0);
 var $69=HEAP8[($68)];
 var $70=(($26+2)|0);
 var $71=HEAP8[($70)];
 if(($31|0)==224){ label=22;break;}else if(($31|0)==237){ label=23;break;}else{label=24;break;}
 case 22: 
 var $73=$69&-32;
 var $74=(($73<<24)>>24)==-96;
 if($74){label=25;break;}else{var $_0=2;label=41;break;}
 case 23: 
 var $76=$69&-32;
 var $77=(($76<<24)>>24)==-128;
 if($77){label=25;break;}else{var $_0=2;label=41;break;}
 case 24: 
 var $79=$69&-64;
 var $80=(($79<<24)>>24)==-128;
 if($80){label=25;break;}else{var $_0=2;label=41;break;}
 case 25: 
 var $82=($71&255);
 var $83=$82&192;
 var $84=($83|0)==128;
 if($84){label=26;break;}else{var $_0=2;label=41;break;}
 case 26: 
 var $86=$31<<12;
 var $87=($69&255);
 var $88=$87<<6;
 var $89=$88&4032;
 var $90=$89|$86;
 var $91=$82&63;
 var $92=$90|$91;
 var $93=$92&65535;
 var $94=($93>>>0)>($Maxcode>>>0);
 if($94){var $_0=2;label=41;break;}else{label=27;break;}
 case 27: 
 var $96=(($92)&65535);
 HEAP16[(($27)>>1)]=$96;
 var $97=(($26+3)|0);
 HEAP32[(($frm_nxt)>>2)]=$97;
 label=39;break;
 case 28: 
 var $99=($30&255)<245;
 if($99){label=29;break;}else{var $_0=2;label=41;break;}
 case 29: 
 var $101=$26;
 var $102=((($23)-($101))|0);
 var $103=($102|0)<4;
 if($103){var $_0=1;label=41;break;}else{label=30;break;}
 case 30: 
 var $105=(($26+1)|0);
 var $106=HEAP8[($105)];
 var $107=(($26+2)|0);
 var $108=HEAP8[($107)];
 var $109=(($26+3)|0);
 var $110=HEAP8[($109)];
 if(($31|0)==240){ label=31;break;}else if(($31|0)==244){ label=32;break;}else{label=33;break;}
 case 31: 
 var $_off=((($106)+(112))&255);
 var $112=($_off&255)<48;
 if($112){label=34;break;}else{var $_0=2;label=41;break;}
 case 32: 
 var $114=$106&-16;
 var $115=(($114<<24)>>24)==-128;
 if($115){label=34;break;}else{var $_0=2;label=41;break;}
 case 33: 
 var $117=$106&-64;
 var $118=(($117<<24)>>24)==-128;
 if($118){label=34;break;}else{var $_0=2;label=41;break;}
 case 34: 
 var $120=($108&255);
 var $121=$120&192;
 var $122=($121|0)==128;
 if($122){label=35;break;}else{var $_0=2;label=41;break;}
 case 35: 
 var $124=($110&255);
 var $125=$124&192;
 var $126=($125|0)==128;
 if($126){label=36;break;}else{var $_0=2;label=41;break;}
 case 36: 
 var $128=$27;
 var $129=((($24)-($128))|0);
 var $130=($129|0)<4;
 if($130){var $_0=1;label=41;break;}else{label=37;break;}
 case 37: 
 var $132=$31&7;
 var $133=$132<<18;
 var $134=($106&255);
 var $135=$134<<12;
 var $136=$135&258048;
 var $137=$136|$133;
 var $138=$120<<6;
 var $139=$138&4032;
 var $140=$137|$139;
 var $141=$124&63;
 var $142=$140|$141;
 var $143=($142>>>0)>($Maxcode>>>0);
 if($143){var $_0=2;label=41;break;}else{label=38;break;}
 case 38: 
 var $145=$132<<2;
 var $146=$134>>>4;
 var $147=$146&3;
 var $148=$147|$145;
 var $149=$148<<6;
 var $150=((($149)+(16320))|0);
 var $151=$134<<2;
 var $152=$151&60;
 var $153=$120>>>4;
 var $154=$153&3;
 var $155=$152|$154;
 var $156=$155|$150;
 var $157=$156|55296;
 var $158=(($157)&65535);
 HEAP16[(($27)>>1)]=$158;
 var $159=$138&960;
 var $160=$141|$159;
 var $161=$160|56320;
 var $162=(($161)&65535);
 var $163=(($27+2)|0);
 HEAP32[(($to_nxt)>>2)]=$163;
 HEAP16[(($163)>>1)]=$162;
 var $164=HEAP32[(($frm_nxt)>>2)];
 var $165=(($164+4)|0);
 HEAP32[(($frm_nxt)>>2)]=$165;
 label=39;break;
 case 39: 
 var $167=HEAP32[(($to_nxt)>>2)];
 var $168=(($167+2)|0);
 HEAP32[(($to_nxt)>>2)]=$168;
 var $169=HEAP32[(($frm_nxt)>>2)];
 var $170=($169>>>0)<($frm_end>>>0);
 if($170){var $27=$168;var $26=$169;label=9;break;}else{var $171=$169;label=40;break;}
 case 40: 
 var $171;
 var $172=($171>>>0)<($frm_end>>>0);
 var $173=($172&1);
 var $_0=$173;label=41;break;
 case 41: 
 var $_0;
 return $_0;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__17codecvtIDsc11__mbstate_tE10do_unshiftERS1_PcS4_RS4_($this,$0,$to,$1,$to_nxt){
 var label=0;


 HEAP32[(($to_nxt)>>2)]=$to;
 return 3;
}


function __ZNKSt3__17codecvtIDsc11__mbstate_tE11do_encodingEv($this){
 var label=0;


 return 0;
}


function __ZNKSt3__17codecvtIDsc11__mbstate_tE16do_always_noconvEv($this){
 var label=0;


 return 0;
}


function __ZNKSt3__17codecvtIDsc11__mbstate_tE9do_lengthERS1_PKcS5_j($this,$0,$frm,$frm_end,$mx){
 var label=0;


 var $2=__ZNSt3__1L20utf8_to_utf16_lengthEPKhS1_jmNS_12codecvt_modeE($frm,$frm_end,$mx,1114111,0);
 return $2;
}


function __ZNSt3__1L20utf8_to_utf16_lengthEPKhS1_jmNS_12codecvt_modeE($frm,$frm_end,$mx,$Maxcode,$mode){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=$mode&4;
 var $2=($1|0)==0;
 if($2){var $frm_nxt_1_ph=$frm;label=6;break;}else{label=2;break;}
 case 2: 
 var $4=$frm_end;
 var $5=$frm;
 var $6=((($4)-($5))|0);
 var $7=($6|0)>2;
 if($7){label=3;break;}else{var $frm_nxt_1_ph=$frm;label=6;break;}
 case 3: 
 var $9=HEAP8[($frm)];
 var $10=(($9<<24)>>24)==-17;
 if($10){label=4;break;}else{var $frm_nxt_1_ph=$frm;label=6;break;}
 case 4: 
 var $12=(($frm+1)|0);
 var $13=HEAP8[($12)];
 var $14=(($13<<24)>>24)==-69;
 if($14){label=5;break;}else{var $frm_nxt_1_ph=$frm;label=6;break;}
 case 5: 
 var $16=(($frm+2)|0);
 var $17=HEAP8[($16)];
 var $18=(($17<<24)>>24)==-65;
 var $19=(($frm+3)|0);
 var $_frm=($18?$19:$frm);
 var $frm_nxt_1_ph=$_frm;label=6;break;
 case 6: 
 var $frm_nxt_1_ph;
 var $20=($frm_nxt_1_ph>>>0)<($frm_end>>>0);
 var $21=($mx|0)!=0;
 var $or_cond83=$20&$21;
 if($or_cond83){label=7;break;}else{var $frm_nxt_1_lcssa=$frm_nxt_1_ph;label=44;break;}
 case 7: 
 var $22=$frm_end;
 var $nchar16_t_084=0;var $frm_nxt_185=$frm_nxt_1_ph;label=8;break;
 case 8: 
 var $frm_nxt_185;
 var $nchar16_t_084;
 var $23=HEAP8[($frm_nxt_185)];
 var $24=($23&255);
 var $25=($24>>>0)>($Maxcode>>>0);
 if($25){var $frm_nxt_1_lcssa=$frm_nxt_185;label=44;break;}else{label=9;break;}
 case 9: 
 var $27=(($23<<24)>>24)>-1;
 if($27){label=10;break;}else{label=11;break;}
 case 10: 
 var $29=(($frm_nxt_185+1)|0);
 var $frm_nxt_2=$29;var $nchar16_t_1=$nchar16_t_084;label=43;break;
 case 11: 
 var $31=($23&255)<194;
 if($31){var $frm_nxt_1_lcssa=$frm_nxt_185;label=44;break;}else{label=12;break;}
 case 12: 
 var $33=($23&255)<224;
 if($33){label=13;break;}else{label=17;break;}
 case 13: 
 var $35=$frm_nxt_185;
 var $36=((($22)-($35))|0);
 var $37=($36|0)<2;
 if($37){var $frm_nxt_1_lcssa=$frm_nxt_185;label=44;break;}else{label=14;break;}
 case 14: 
 var $39=(($frm_nxt_185+1)|0);
 var $40=HEAP8[($39)];
 var $41=($40&255);
 var $42=$41&192;
 var $43=($42|0)==128;
 if($43){label=15;break;}else{var $frm_nxt_1_lcssa=$frm_nxt_185;label=44;break;}
 case 15: 
 var $45=$24<<6;
 var $46=$45&1984;
 var $47=$41&63;
 var $48=$47|$46;
 var $49=($48>>>0)>($Maxcode>>>0);
 if($49){var $frm_nxt_1_lcssa=$frm_nxt_185;label=44;break;}else{label=16;break;}
 case 16: 
 var $51=(($frm_nxt_185+2)|0);
 var $frm_nxt_2=$51;var $nchar16_t_1=$nchar16_t_084;label=43;break;
 case 17: 
 var $53=($23&255)<240;
 if($53){label=18;break;}else{label=29;break;}
 case 18: 
 var $55=$frm_nxt_185;
 var $56=((($22)-($55))|0);
 var $57=($56|0)<3;
 if($57){var $frm_nxt_1_lcssa=$frm_nxt_185;label=44;break;}else{label=19;break;}
 case 19: 
 var $59=(($frm_nxt_185+1)|0);
 var $60=HEAP8[($59)];
 var $61=(($frm_nxt_185+2)|0);
 var $62=HEAP8[($61)];
 if(($24|0)==224){ label=20;break;}else if(($24|0)==237){ label=22;break;}else{label=24;break;}
 case 20: 
 var $64=$60&-32;
 var $65=(($64<<24)>>24)==-96;
 if($65){label=26;break;}else{label=21;break;}
 case 21: 
 var $67=$frm;
 var $68=((($55)-($67))|0);
 var $_0=$68;label=45;break;
 case 22: 
 var $70=$60&-32;
 var $71=(($70<<24)>>24)==-128;
 if($71){label=26;break;}else{label=23;break;}
 case 23: 
 var $73=$frm;
 var $74=((($55)-($73))|0);
 var $_0=$74;label=45;break;
 case 24: 
 var $76=$60&-64;
 var $77=(($76<<24)>>24)==-128;
 if($77){label=26;break;}else{label=25;break;}
 case 25: 
 var $79=$frm;
 var $80=((($55)-($79))|0);
 var $_0=$80;label=45;break;
 case 26: 
 var $82=($62&255);
 var $83=$82&192;
 var $84=($83|0)==128;
 if($84){label=27;break;}else{var $frm_nxt_1_lcssa=$frm_nxt_185;label=44;break;}
 case 27: 
 var $86=$24<<12;
 var $87=$86&61440;
 var $88=($60&255);
 var $89=$88<<6;
 var $90=$89&4032;
 var $91=$90|$87;
 var $92=$82&63;
 var $93=$91|$92;
 var $94=($93>>>0)>($Maxcode>>>0);
 if($94){var $frm_nxt_1_lcssa=$frm_nxt_185;label=44;break;}else{label=28;break;}
 case 28: 
 var $96=(($frm_nxt_185+3)|0);
 var $frm_nxt_2=$96;var $nchar16_t_1=$nchar16_t_084;label=43;break;
 case 29: 
 var $98=($23&255)<245;
 if($98){label=30;break;}else{var $frm_nxt_1_lcssa=$frm_nxt_185;label=44;break;}
 case 30: 
 var $100=$frm_nxt_185;
 var $101=((($22)-($100))|0);
 var $102=($101|0)<4;
 if($102){var $frm_nxt_1_lcssa=$frm_nxt_185;label=44;break;}else{label=31;break;}
 case 31: 
 var $104=((($mx)-($nchar16_t_084))|0);
 var $105=($104>>>0)<2;
 if($105){var $frm_nxt_1_lcssa=$frm_nxt_185;label=44;break;}else{label=32;break;}
 case 32: 
 var $107=(($frm_nxt_185+1)|0);
 var $108=HEAP8[($107)];
 var $109=(($frm_nxt_185+2)|0);
 var $110=HEAP8[($109)];
 var $111=(($frm_nxt_185+3)|0);
 var $112=HEAP8[($111)];
 if(($24|0)==240){ label=33;break;}else if(($24|0)==244){ label=35;break;}else{label=37;break;}
 case 33: 
 var $_off=((($108)+(112))&255);
 var $114=($_off&255)<48;
 if($114){label=39;break;}else{label=34;break;}
 case 34: 
 var $116=$frm;
 var $117=((($100)-($116))|0);
 var $_0=$117;label=45;break;
 case 35: 
 var $119=$108&-16;
 var $120=(($119<<24)>>24)==-128;
 if($120){label=39;break;}else{label=36;break;}
 case 36: 
 var $122=$frm;
 var $123=((($100)-($122))|0);
 var $_0=$123;label=45;break;
 case 37: 
 var $125=$108&-64;
 var $126=(($125<<24)>>24)==-128;
 if($126){label=39;break;}else{label=38;break;}
 case 38: 
 var $128=$frm;
 var $129=((($100)-($128))|0);
 var $_0=$129;label=45;break;
 case 39: 
 var $131=($110&255);
 var $132=$131&192;
 var $133=($132|0)==128;
 if($133){label=40;break;}else{var $frm_nxt_1_lcssa=$frm_nxt_185;label=44;break;}
 case 40: 
 var $135=($112&255);
 var $136=$135&192;
 var $137=($136|0)==128;
 if($137){label=41;break;}else{var $frm_nxt_1_lcssa=$frm_nxt_185;label=44;break;}
 case 41: 
 var $139=$24<<18;
 var $140=$139&1835008;
 var $141=($108&255);
 var $142=$141<<12;
 var $143=$142&258048;
 var $144=$143|$140;
 var $145=$131<<6;
 var $146=$145&4032;
 var $147=$144|$146;
 var $148=$135&63;
 var $149=$147|$148;
 var $150=($149>>>0)>($Maxcode>>>0);
 if($150){var $frm_nxt_1_lcssa=$frm_nxt_185;label=44;break;}else{label=42;break;}
 case 42: 
 var $152=((($nchar16_t_084)+(1))|0);
 var $153=(($frm_nxt_185+4)|0);
 var $frm_nxt_2=$153;var $nchar16_t_1=$152;label=43;break;
 case 43: 
 var $nchar16_t_1;
 var $frm_nxt_2;
 var $155=((($nchar16_t_1)+(1))|0);
 var $156=($frm_nxt_2>>>0)<($frm_end>>>0);
 var $157=($155>>>0)<($mx>>>0);
 var $or_cond=$156&$157;
 if($or_cond){var $nchar16_t_084=$155;var $frm_nxt_185=$frm_nxt_2;label=8;break;}else{var $frm_nxt_1_lcssa=$frm_nxt_2;label=44;break;}
 case 44: 
 var $frm_nxt_1_lcssa;
 var $158=$frm_nxt_1_lcssa;
 var $159=$frm;
 var $160=((($158)-($159))|0);
 var $_0=$160;label=45;break;
 case 45: 
 var $_0;
 return $_0;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__17codecvtIDsc11__mbstate_tE13do_max_lengthEv($this){
 var label=0;


 return 4;
}


function __ZNSt3__17codecvtIDic11__mbstate_tED0Ev($this){
 var label=0;


 var $1=(($this)|0);
 __ZNSt3__114__shared_countD2Ev($1);
 var $2=$this;
 __ZdlPv($2);
 return;
}


function __ZNKSt3__17codecvtIDic11__mbstate_tE6do_outERS1_PKDiS5_RS5_PcS7_RS7_($this,$0,$frm,$frm_end,$frm_nxt,$to,$to_end,$to_nxt){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+16)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);

 var $_frm_nxt=sp;
 var $_to_nxt=(sp)+(8);
 HEAP32[(($_frm_nxt)>>2)]=$frm;
 HEAP32[(($_to_nxt)>>2)]=$to;
 var $2=__ZNSt3__1L12ucs4_to_utf8EPKjS1_RS1_PhS3_RS3_mNS_12codecvt_modeE($frm,$frm_end,$_frm_nxt,$to,$to_end,$_to_nxt,1114111,0);
 var $3=HEAP32[(($_frm_nxt)>>2)];
 var $4=$3;
 var $5=$frm;
 var $6=((($4)-($5))|0);
 var $7=$6>>2;
 var $8=(($frm+($7<<2))|0);
 HEAP32[(($frm_nxt)>>2)]=$8;
 var $9=HEAP32[(($_to_nxt)>>2)];
 var $10=$9;
 var $11=$to;
 var $12=((($10)-($11))|0);
 var $13=(($to+$12)|0);
 HEAP32[(($to_nxt)>>2)]=$13;
 STACKTOP=sp;return $2;
}


function __ZNSt3__1L12ucs4_to_utf8EPKjS1_RS1_PhS3_RS3_mNS_12codecvt_modeE($frm,$frm_end,$frm_nxt,$to,$to_end,$to_nxt,$Maxcode,$mode){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 HEAP32[(($frm_nxt)>>2)]=$frm;
 HEAP32[(($to_nxt)>>2)]=$to;
 var $1=$mode&2;
 var $2=($1|0)==0;
 if($2){label=4;break;}else{label=2;break;}
 case 2: 
 var $4=$to_end;
 var $5=$to;
 var $6=((($4)-($5))|0);
 var $7=($6|0)<3;
 if($7){var $_0=1;label=19;break;}else{label=3;break;}
 case 3: 
 var $9=(($to+1)|0);
 HEAP32[(($to_nxt)>>2)]=$9;
 HEAP8[($to)]=-17;
 var $10=HEAP32[(($to_nxt)>>2)];
 var $11=(($10+1)|0);
 HEAP32[(($to_nxt)>>2)]=$11;
 HEAP8[($10)]=-69;
 var $12=HEAP32[(($to_nxt)>>2)];
 var $13=(($12+1)|0);
 HEAP32[(($to_nxt)>>2)]=$13;
 HEAP8[($12)]=-65;
 label=4;break;
 case 4: 
 var $14=HEAP32[(($frm_nxt)>>2)];
 var $15=($14>>>0)<($frm_end>>>0);
 if($15){label=5;break;}else{var $_0=0;label=19;break;}
 case 5: 
 var $16=$to_end;
 var $18=$14;label=6;break;
 case 6: 
 var $18;
 var $19=HEAP32[(($18)>>2)];
 var $20=$19&-2048;
 var $21=($20|0)==55296;
 var $22=($19>>>0)>($Maxcode>>>0);
 var $or_cond=$21|$22;
 if($or_cond){var $_0=2;label=19;break;}else{label=7;break;}
 case 7: 
 var $24=($19>>>0)<128;
 if($24){label=8;break;}else{label=10;break;}
 case 8: 
 var $26=HEAP32[(($to_nxt)>>2)];
 var $27=$26;
 var $28=((($16)-($27))|0);
 var $29=($28|0)<1;
 if($29){var $_0=1;label=19;break;}else{label=9;break;}
 case 9: 
 var $31=(($19)&255);
 var $32=(($26+1)|0);
 HEAP32[(($to_nxt)>>2)]=$32;
 HEAP8[($26)]=$31;
 label=18;break;
 case 10: 
 var $34=($19>>>0)<2048;
 if($34){label=11;break;}else{label=13;break;}
 case 11: 
 var $36=HEAP32[(($to_nxt)>>2)];
 var $37=$36;
 var $38=((($16)-($37))|0);
 var $39=($38|0)<2;
 if($39){var $_0=1;label=19;break;}else{label=12;break;}
 case 12: 
 var $41=$19>>>6;
 var $42=$41|192;
 var $43=(($42)&255);
 var $44=(($36+1)|0);
 HEAP32[(($to_nxt)>>2)]=$44;
 HEAP8[($36)]=$43;
 var $45=$19&63;
 var $46=$45|128;
 var $47=(($46)&255);
 var $48=HEAP32[(($to_nxt)>>2)];
 var $49=(($48+1)|0);
 HEAP32[(($to_nxt)>>2)]=$49;
 HEAP8[($48)]=$47;
 label=18;break;
 case 13: 
 var $51=($19>>>0)<65536;
 var $52=HEAP32[(($to_nxt)>>2)];
 var $53=$52;
 var $54=((($16)-($53))|0);
 if($51){label=14;break;}else{label=16;break;}
 case 14: 
 var $56=($54|0)<3;
 if($56){var $_0=1;label=19;break;}else{label=15;break;}
 case 15: 
 var $58=$19>>>12;
 var $59=$58|224;
 var $60=(($59)&255);
 var $61=(($52+1)|0);
 HEAP32[(($to_nxt)>>2)]=$61;
 HEAP8[($52)]=$60;
 var $62=$19>>>6;
 var $63=$62&63;
 var $64=$63|128;
 var $65=(($64)&255);
 var $66=HEAP32[(($to_nxt)>>2)];
 var $67=(($66+1)|0);
 HEAP32[(($to_nxt)>>2)]=$67;
 HEAP8[($66)]=$65;
 var $68=$19&63;
 var $69=$68|128;
 var $70=(($69)&255);
 var $71=HEAP32[(($to_nxt)>>2)];
 var $72=(($71+1)|0);
 HEAP32[(($to_nxt)>>2)]=$72;
 HEAP8[($71)]=$70;
 label=18;break;
 case 16: 
 var $74=($54|0)<4;
 if($74){var $_0=1;label=19;break;}else{label=17;break;}
 case 17: 
 var $76=$19>>>18;
 var $77=$76|240;
 var $78=(($77)&255);
 var $79=(($52+1)|0);
 HEAP32[(($to_nxt)>>2)]=$79;
 HEAP8[($52)]=$78;
 var $80=$19>>>12;
 var $81=$80&63;
 var $82=$81|128;
 var $83=(($82)&255);
 var $84=HEAP32[(($to_nxt)>>2)];
 var $85=(($84+1)|0);
 HEAP32[(($to_nxt)>>2)]=$85;
 HEAP8[($84)]=$83;
 var $86=$19>>>6;
 var $87=$86&63;
 var $88=$87|128;
 var $89=(($88)&255);
 var $90=HEAP32[(($to_nxt)>>2)];
 var $91=(($90+1)|0);
 HEAP32[(($to_nxt)>>2)]=$91;
 HEAP8[($90)]=$89;
 var $92=$19&63;
 var $93=$92|128;
 var $94=(($93)&255);
 var $95=HEAP32[(($to_nxt)>>2)];
 var $96=(($95+1)|0);
 HEAP32[(($to_nxt)>>2)]=$96;
 HEAP8[($95)]=$94;
 label=18;break;
 case 18: 
 var $98=HEAP32[(($frm_nxt)>>2)];
 var $99=(($98+4)|0);
 HEAP32[(($frm_nxt)>>2)]=$99;
 var $100=($99>>>0)<($frm_end>>>0);
 if($100){var $18=$99;label=6;break;}else{var $_0=0;label=19;break;}
 case 19: 
 var $_0;
 return $_0;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__17codecvtIDic11__mbstate_tE5do_inERS1_PKcS5_RS5_PDiS7_RS7_($this,$0,$frm,$frm_end,$frm_nxt,$to,$to_end,$to_nxt){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+16)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);

 var $_frm_nxt=sp;
 var $_to_nxt=(sp)+(8);
 HEAP32[(($_frm_nxt)>>2)]=$frm;
 HEAP32[(($_to_nxt)>>2)]=$to;
 var $2=__ZNSt3__1L12utf8_to_ucs4EPKhS1_RS1_PjS3_RS3_mNS_12codecvt_modeE($frm,$frm_end,$_frm_nxt,$to,$to_end,$_to_nxt,1114111,0);
 var $3=HEAP32[(($_frm_nxt)>>2)];
 var $4=$3;
 var $5=$frm;
 var $6=((($4)-($5))|0);
 var $7=(($frm+$6)|0);
 HEAP32[(($frm_nxt)>>2)]=$7;
 var $8=HEAP32[(($_to_nxt)>>2)];
 var $9=$8;
 var $10=$to;
 var $11=((($9)-($10))|0);
 var $12=$11>>2;
 var $13=(($to+($12<<2))|0);
 HEAP32[(($to_nxt)>>2)]=$13;
 STACKTOP=sp;return $2;
}


function __ZNSt3__1L12utf8_to_ucs4EPKhS1_RS1_PjS3_RS3_mNS_12codecvt_modeE($frm,$frm_end,$frm_nxt,$to,$to_end,$to_nxt,$Maxcode,$mode){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 HEAP32[(($frm_nxt)>>2)]=$frm;
 HEAP32[(($to_nxt)>>2)]=$to;
 var $1=$mode&4;
 var $2=($1|0)==0;
 var $_pre71=HEAP32[(($frm_nxt)>>2)];
 if($2){var $21=$_pre71;label=7;break;}else{label=2;break;}
 case 2: 
 var $4=$frm_end;
 var $5=$_pre71;
 var $6=((($4)-($5))|0);
 var $7=($6|0)>2;
 if($7){label=3;break;}else{var $21=$_pre71;label=7;break;}
 case 3: 
 var $9=HEAP8[($_pre71)];
 var $10=(($9<<24)>>24)==-17;
 if($10){label=4;break;}else{var $21=$_pre71;label=7;break;}
 case 4: 
 var $12=(($_pre71+1)|0);
 var $13=HEAP8[($12)];
 var $14=(($13<<24)>>24)==-69;
 if($14){label=5;break;}else{var $21=$_pre71;label=7;break;}
 case 5: 
 var $16=(($_pre71+2)|0);
 var $17=HEAP8[($16)];
 var $18=(($17<<24)>>24)==-65;
 if($18){label=6;break;}else{var $21=$_pre71;label=7;break;}
 case 6: 
 var $20=(($_pre71+3)|0);
 HEAP32[(($frm_nxt)>>2)]=$20;
 var $21=$20;label=7;break;
 case 7: 
 var $21;
 var $22=($21>>>0)<($frm_end>>>0);
 if($22){label=8;break;}else{var $143=$21;label=39;break;}
 case 8: 
 var $23=$frm_end;
 var $_pre=HEAP32[(($to_nxt)>>2)];
 var $26=$_pre;var $25=$21;label=9;break;
 case 9: 
 var $25;
 var $26;
 var $27=($26>>>0)<($to_end>>>0);
 if($27){label=10;break;}else{var $143=$25;label=39;break;}
 case 10: 
 var $29=HEAP8[($25)];
 var $30=($29&255);
 var $31=(($29<<24)>>24)>-1;
 if($31){label=11;break;}else{label=13;break;}
 case 11: 
 var $33=($30>>>0)>($Maxcode>>>0);
 if($33){var $_0=2;label=40;break;}else{label=12;break;}
 case 12: 
 HEAP32[(($26)>>2)]=$30;
 var $35=(($25+1)|0);
 HEAP32[(($frm_nxt)>>2)]=$35;
 label=38;break;
 case 13: 
 var $37=($29&255)<194;
 if($37){var $_0=2;label=40;break;}else{label=14;break;}
 case 14: 
 var $39=($29&255)<224;
 if($39){label=15;break;}else{label=19;break;}
 case 15: 
 var $41=$25;
 var $42=((($23)-($41))|0);
 var $43=($42|0)<2;
 if($43){var $_0=1;label=40;break;}else{label=16;break;}
 case 16: 
 var $45=(($25+1)|0);
 var $46=HEAP8[($45)];
 var $47=($46&255);
 var $48=$47&192;
 var $49=($48|0)==128;
 if($49){label=17;break;}else{var $_0=2;label=40;break;}
 case 17: 
 var $51=$30<<6;
 var $52=$51&1984;
 var $53=$47&63;
 var $54=$53|$52;
 var $55=($54>>>0)>($Maxcode>>>0);
 if($55){var $_0=2;label=40;break;}else{label=18;break;}
 case 18: 
 HEAP32[(($26)>>2)]=$54;
 var $57=(($25+2)|0);
 HEAP32[(($frm_nxt)>>2)]=$57;
 label=38;break;
 case 19: 
 var $59=($29&255)<240;
 if($59){label=20;break;}else{label=28;break;}
 case 20: 
 var $61=$25;
 var $62=((($23)-($61))|0);
 var $63=($62|0)<3;
 if($63){var $_0=1;label=40;break;}else{label=21;break;}
 case 21: 
 var $65=(($25+1)|0);
 var $66=HEAP8[($65)];
 var $67=(($25+2)|0);
 var $68=HEAP8[($67)];
 if(($30|0)==224){ label=22;break;}else if(($30|0)==237){ label=23;break;}else{label=24;break;}
 case 22: 
 var $70=$66&-32;
 var $71=(($70<<24)>>24)==-96;
 if($71){label=25;break;}else{var $_0=2;label=40;break;}
 case 23: 
 var $73=$66&-32;
 var $74=(($73<<24)>>24)==-128;
 if($74){label=25;break;}else{var $_0=2;label=40;break;}
 case 24: 
 var $76=$66&-64;
 var $77=(($76<<24)>>24)==-128;
 if($77){label=25;break;}else{var $_0=2;label=40;break;}
 case 25: 
 var $79=($68&255);
 var $80=$79&192;
 var $81=($80|0)==128;
 if($81){label=26;break;}else{var $_0=2;label=40;break;}
 case 26: 
 var $83=$30<<12;
 var $84=$83&61440;
 var $85=($66&255);
 var $86=$85<<6;
 var $87=$86&4032;
 var $88=$87|$84;
 var $89=$79&63;
 var $90=$88|$89;
 var $91=($90>>>0)>($Maxcode>>>0);
 if($91){var $_0=2;label=40;break;}else{label=27;break;}
 case 27: 
 HEAP32[(($26)>>2)]=$90;
 var $93=(($25+3)|0);
 HEAP32[(($frm_nxt)>>2)]=$93;
 label=38;break;
 case 28: 
 var $95=($29&255)<245;
 if($95){label=29;break;}else{var $_0=2;label=40;break;}
 case 29: 
 var $97=$25;
 var $98=((($23)-($97))|0);
 var $99=($98|0)<4;
 if($99){var $_0=1;label=40;break;}else{label=30;break;}
 case 30: 
 var $101=(($25+1)|0);
 var $102=HEAP8[($101)];
 var $103=(($25+2)|0);
 var $104=HEAP8[($103)];
 var $105=(($25+3)|0);
 var $106=HEAP8[($105)];
 if(($30|0)==240){ label=31;break;}else if(($30|0)==244){ label=32;break;}else{label=33;break;}
 case 31: 
 var $_off=((($102)+(112))&255);
 var $108=($_off&255)<48;
 if($108){label=34;break;}else{var $_0=2;label=40;break;}
 case 32: 
 var $110=$102&-16;
 var $111=(($110<<24)>>24)==-128;
 if($111){label=34;break;}else{var $_0=2;label=40;break;}
 case 33: 
 var $113=$102&-64;
 var $114=(($113<<24)>>24)==-128;
 if($114){label=34;break;}else{var $_0=2;label=40;break;}
 case 34: 
 var $116=($104&255);
 var $117=$116&192;
 var $118=($117|0)==128;
 if($118){label=35;break;}else{var $_0=2;label=40;break;}
 case 35: 
 var $120=($106&255);
 var $121=$120&192;
 var $122=($121|0)==128;
 if($122){label=36;break;}else{var $_0=2;label=40;break;}
 case 36: 
 var $124=$30<<18;
 var $125=$124&1835008;
 var $126=($102&255);
 var $127=$126<<12;
 var $128=$127&258048;
 var $129=$128|$125;
 var $130=$116<<6;
 var $131=$130&4032;
 var $132=$129|$131;
 var $133=$120&63;
 var $134=$132|$133;
 var $135=($134>>>0)>($Maxcode>>>0);
 if($135){var $_0=2;label=40;break;}else{label=37;break;}
 case 37: 
 HEAP32[(($26)>>2)]=$134;
 var $137=(($25+4)|0);
 HEAP32[(($frm_nxt)>>2)]=$137;
 label=38;break;
 case 38: 
 var $139=HEAP32[(($to_nxt)>>2)];
 var $140=(($139+4)|0);
 HEAP32[(($to_nxt)>>2)]=$140;
 var $141=HEAP32[(($frm_nxt)>>2)];
 var $142=($141>>>0)<($frm_end>>>0);
 if($142){var $26=$140;var $25=$141;label=9;break;}else{var $143=$141;label=39;break;}
 case 39: 
 var $143;
 var $144=($143>>>0)<($frm_end>>>0);
 var $145=($144&1);
 var $_0=$145;label=40;break;
 case 40: 
 var $_0;
 return $_0;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__17codecvtIDic11__mbstate_tE10do_unshiftERS1_PcS4_RS4_($this,$0,$to,$1,$to_nxt){
 var label=0;


 HEAP32[(($to_nxt)>>2)]=$to;
 return 3;
}


function __ZNKSt3__17codecvtIDic11__mbstate_tE11do_encodingEv($this){
 var label=0;


 return 0;
}


function __ZNKSt3__17codecvtIDic11__mbstate_tE16do_always_noconvEv($this){
 var label=0;


 return 0;
}


function __ZNKSt3__17codecvtIDic11__mbstate_tE9do_lengthERS1_PKcS5_j($this,$0,$frm,$frm_end,$mx){
 var label=0;


 var $2=__ZNSt3__1L19utf8_to_ucs4_lengthEPKhS1_jmNS_12codecvt_modeE($frm,$frm_end,$mx,1114111,0);
 return $2;
}


function __ZNSt3__1L19utf8_to_ucs4_lengthEPKhS1_jmNS_12codecvt_modeE($frm,$frm_end,$mx,$Maxcode,$mode){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=$mode&4;
 var $2=($1|0)==0;
 if($2){var $frm_nxt_1_ph=$frm;label=6;break;}else{label=2;break;}
 case 2: 
 var $4=$frm_end;
 var $5=$frm;
 var $6=((($4)-($5))|0);
 var $7=($6|0)>2;
 if($7){label=3;break;}else{var $frm_nxt_1_ph=$frm;label=6;break;}
 case 3: 
 var $9=HEAP8[($frm)];
 var $10=(($9<<24)>>24)==-17;
 if($10){label=4;break;}else{var $frm_nxt_1_ph=$frm;label=6;break;}
 case 4: 
 var $12=(($frm+1)|0);
 var $13=HEAP8[($12)];
 var $14=(($13<<24)>>24)==-69;
 if($14){label=5;break;}else{var $frm_nxt_1_ph=$frm;label=6;break;}
 case 5: 
 var $16=(($frm+2)|0);
 var $17=HEAP8[($16)];
 var $18=(($17<<24)>>24)==-65;
 var $19=(($frm+3)|0);
 var $_frm=($18?$19:$frm);
 var $frm_nxt_1_ph=$_frm;label=6;break;
 case 6: 
 var $frm_nxt_1_ph;
 var $20=($frm_nxt_1_ph>>>0)<($frm_end>>>0);
 var $21=($mx|0)!=0;
 var $or_cond79=$20&$21;
 if($or_cond79){label=7;break;}else{var $frm_nxt_1_lcssa=$frm_nxt_1_ph;label=44;break;}
 case 7: 
 var $22=$frm_end;
 var $nchar32_t_080=1;var $frm_nxt_181=$frm_nxt_1_ph;label=8;break;
 case 8: 
 var $frm_nxt_181;
 var $nchar32_t_080;
 var $24=HEAP8[($frm_nxt_181)];
 var $25=($24&255);
 var $26=(($24<<24)>>24)>-1;
 if($26){label=9;break;}else{label=11;break;}
 case 9: 
 var $28=($25>>>0)>($Maxcode>>>0);
 if($28){var $frm_nxt_1_lcssa=$frm_nxt_181;label=44;break;}else{label=10;break;}
 case 10: 
 var $30=(($frm_nxt_181+1)|0);
 var $frm_nxt_2=$30;label=42;break;
 case 11: 
 var $32=($24&255)<194;
 if($32){var $frm_nxt_1_lcssa=$frm_nxt_181;label=44;break;}else{label=12;break;}
 case 12: 
 var $34=($24&255)<224;
 if($34){label=13;break;}else{label=17;break;}
 case 13: 
 var $36=$frm_nxt_181;
 var $37=((($22)-($36))|0);
 var $38=($37|0)<2;
 if($38){var $frm_nxt_1_lcssa=$frm_nxt_181;label=44;break;}else{label=14;break;}
 case 14: 
 var $40=(($frm_nxt_181+1)|0);
 var $41=HEAP8[($40)];
 var $42=($41&255);
 var $43=$42&192;
 var $44=($43|0)==128;
 if($44){label=15;break;}else{var $frm_nxt_1_lcssa=$frm_nxt_181;label=44;break;}
 case 15: 
 var $46=$25<<6;
 var $47=$46&1984;
 var $48=$42&63;
 var $49=$48|$47;
 var $50=($49>>>0)>($Maxcode>>>0);
 if($50){var $frm_nxt_1_lcssa=$frm_nxt_181;label=44;break;}else{label=16;break;}
 case 16: 
 var $52=(($frm_nxt_181+2)|0);
 var $frm_nxt_2=$52;label=42;break;
 case 17: 
 var $54=($24&255)<240;
 if($54){label=18;break;}else{label=29;break;}
 case 18: 
 var $56=$frm_nxt_181;
 var $57=((($22)-($56))|0);
 var $58=($57|0)<3;
 if($58){var $frm_nxt_1_lcssa=$frm_nxt_181;label=44;break;}else{label=19;break;}
 case 19: 
 var $60=(($frm_nxt_181+1)|0);
 var $61=HEAP8[($60)];
 var $62=(($frm_nxt_181+2)|0);
 var $63=HEAP8[($62)];
 if(($25|0)==224){ label=20;break;}else if(($25|0)==237){ label=22;break;}else{label=24;break;}
 case 20: 
 var $65=$61&-32;
 var $66=(($65<<24)>>24)==-96;
 if($66){label=26;break;}else{label=21;break;}
 case 21: 
 var $68=$frm;
 var $69=((($56)-($68))|0);
 var $_0=$69;label=45;break;
 case 22: 
 var $71=$61&-32;
 var $72=(($71<<24)>>24)==-128;
 if($72){label=26;break;}else{label=23;break;}
 case 23: 
 var $74=$frm;
 var $75=((($56)-($74))|0);
 var $_0=$75;label=45;break;
 case 24: 
 var $77=$61&-64;
 var $78=(($77<<24)>>24)==-128;
 if($78){label=26;break;}else{label=25;break;}
 case 25: 
 var $80=$frm;
 var $81=((($56)-($80))|0);
 var $_0=$81;label=45;break;
 case 26: 
 var $83=($63&255);
 var $84=$83&192;
 var $85=($84|0)==128;
 if($85){label=27;break;}else{var $frm_nxt_1_lcssa=$frm_nxt_181;label=44;break;}
 case 27: 
 var $87=$25<<12;
 var $88=$87&61440;
 var $89=($61&255);
 var $90=$89<<6;
 var $91=$90&4032;
 var $92=$91|$88;
 var $93=$83&63;
 var $94=$92|$93;
 var $95=($94>>>0)>($Maxcode>>>0);
 if($95){var $frm_nxt_1_lcssa=$frm_nxt_181;label=44;break;}else{label=28;break;}
 case 28: 
 var $97=(($frm_nxt_181+3)|0);
 var $frm_nxt_2=$97;label=42;break;
 case 29: 
 var $99=($24&255)<245;
 if($99){label=30;break;}else{var $frm_nxt_1_lcssa=$frm_nxt_181;label=44;break;}
 case 30: 
 var $101=$frm_nxt_181;
 var $102=((($22)-($101))|0);
 var $103=($102|0)<4;
 if($103){var $frm_nxt_1_lcssa=$frm_nxt_181;label=44;break;}else{label=31;break;}
 case 31: 
 var $105=(($frm_nxt_181+1)|0);
 var $106=HEAP8[($105)];
 var $107=(($frm_nxt_181+2)|0);
 var $108=HEAP8[($107)];
 var $109=(($frm_nxt_181+3)|0);
 var $110=HEAP8[($109)];
 if(($25|0)==240){ label=32;break;}else if(($25|0)==244){ label=34;break;}else{label=36;break;}
 case 32: 
 var $_off=((($106)+(112))&255);
 var $112=($_off&255)<48;
 if($112){label=38;break;}else{label=33;break;}
 case 33: 
 var $114=$frm;
 var $115=((($101)-($114))|0);
 var $_0=$115;label=45;break;
 case 34: 
 var $117=$106&-16;
 var $118=(($117<<24)>>24)==-128;
 if($118){label=38;break;}else{label=35;break;}
 case 35: 
 var $120=$frm;
 var $121=((($101)-($120))|0);
 var $_0=$121;label=45;break;
 case 36: 
 var $123=$106&-64;
 var $124=(($123<<24)>>24)==-128;
 if($124){label=38;break;}else{label=37;break;}
 case 37: 
 var $126=$frm;
 var $127=((($101)-($126))|0);
 var $_0=$127;label=45;break;
 case 38: 
 var $129=($108&255);
 var $130=$129&192;
 var $131=($130|0)==128;
 if($131){label=39;break;}else{var $frm_nxt_1_lcssa=$frm_nxt_181;label=44;break;}
 case 39: 
 var $133=($110&255);
 var $134=$133&192;
 var $135=($134|0)==128;
 if($135){label=40;break;}else{var $frm_nxt_1_lcssa=$frm_nxt_181;label=44;break;}
 case 40: 
 var $137=$25<<18;
 var $138=$137&1835008;
 var $139=($106&255);
 var $140=$139<<12;
 var $141=$140&258048;
 var $142=$141|$138;
 var $143=$129<<6;
 var $144=$143&4032;
 var $145=$142|$144;
 var $146=$133&63;
 var $147=$145|$146;
 var $148=($147>>>0)>($Maxcode>>>0);
 if($148){var $frm_nxt_1_lcssa=$frm_nxt_181;label=44;break;}else{label=41;break;}
 case 41: 
 var $150=(($frm_nxt_181+4)|0);
 var $frm_nxt_2=$150;label=42;break;
 case 42: 
 var $frm_nxt_2;
 var $152=($frm_nxt_2>>>0)<($frm_end>>>0);
 var $153=($nchar32_t_080>>>0)<($mx>>>0);
 var $or_cond=$152&$153;
 if($or_cond){label=43;break;}else{var $frm_nxt_1_lcssa=$frm_nxt_2;label=44;break;}
 case 43: 
 var $phitmp=((($nchar32_t_080)+(1))|0);
 var $nchar32_t_080=$phitmp;var $frm_nxt_181=$frm_nxt_2;label=8;break;
 case 44: 
 var $frm_nxt_1_lcssa;
 var $154=$frm_nxt_1_lcssa;
 var $155=$frm;
 var $156=((($154)-($155))|0);
 var $_0=$156;label=45;break;
 case 45: 
 var $_0;
 return $_0;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__17codecvtIDic11__mbstate_tE13do_max_lengthEv($this){
 var label=0;


 return 4;
}


function __ZNSt3__116__narrow_to_utf8ILj32EED0Ev($this){
 var label=0;


 var $1=(($this)|0);
 __ZNSt3__114__shared_countD2Ev($1);
 var $2=$this;
 __ZdlPv($2);
 return;
}


function __ZNSt3__117__widen_from_utf8ILj32EED0Ev($this){
 var label=0;


 var $1=(($this)|0);
 __ZNSt3__114__shared_countD2Ev($1);
 var $2=$this;
 __ZdlPv($2);
 return;
}


function __ZNSt3__18numpunctIcED0Ev($this){
 var label=0;


 var $1=(($this)|0);
 HEAP32[(($1)>>2)]=3608;
 var $2=(($this+12)|0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($2);
 var $3=(($this)|0);
 __ZNSt3__114__shared_countD2Ev($3);
 var $4=$this;
 __ZdlPv($4);
 return;
}


function __ZNSt3__18numpunctIcED2Ev($this){
 var label=0;


 var $1=(($this)|0);
 HEAP32[(($1)>>2)]=3608;
 var $2=(($this+12)|0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($2);
 var $3=(($this)|0);
 __ZNSt3__114__shared_countD2Ev($3);
 return;
}


function __ZNSt3__18numpunctIwED0Ev($this){
 var label=0;


 var $1=(($this)|0);
 HEAP32[(($1)>>2)]=3560;
 var $2=(($this+16)|0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($2);
 var $3=(($this)|0);
 __ZNSt3__114__shared_countD2Ev($3);
 var $4=$this;
 __ZdlPv($4);
 return;
}


function __ZNSt3__18numpunctIwED2Ev($this){
 var label=0;


 var $1=(($this)|0);
 HEAP32[(($1)>>2)]=3560;
 var $2=(($this+16)|0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($2);
 var $3=(($this)|0);
 __ZNSt3__114__shared_countD2Ev($3);
 return;
}


function __ZNKSt3__18numpunctIcE16do_decimal_pointEv($this){
 var label=0;


 var $1=(($this+8)|0);
 var $2=HEAP8[($1)];
 return $2;
}


function __ZNKSt3__18numpunctIwE16do_decimal_pointEv($this){
 var label=0;


 var $1=(($this+8)|0);
 var $2=HEAP32[(($1)>>2)];
 return $2;
}


function __ZNKSt3__18numpunctIcE16do_thousands_sepEv($this){
 var label=0;


 var $1=(($this+9)|0);
 var $2=HEAP8[($1)];
 return $2;
}


function __ZNKSt3__18numpunctIwE16do_thousands_sepEv($this){
 var label=0;


 var $1=(($this+12)|0);
 var $2=HEAP32[(($1)>>2)];
 return $2;
}


function __ZNKSt3__18numpunctIcE11do_groupingEv($agg_result,$this){
 var label=0;


 var $1=(($this+12)|0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC1ERKS5_($agg_result,$1);
 return;
}


function __ZNKSt3__18numpunctIwE11do_groupingEv($agg_result,$this){
 var label=0;


 var $1=(($this+16)|0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC1ERKS5_($agg_result,$1);
 return;
}


function __ZNKSt3__18numpunctIcE11do_truenameEv($agg_result,$this){
 var label=0;


 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj($agg_result,1384,4);
 return;
}


function __ZNKSt3__18numpunctIwE11do_truenameEv($agg_result,$this){
 var label=0;


 var $1=_wcslen(1360);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6__initEPKwj($agg_result,1360,$1);
 return;
}


function __ZNKSt3__18numpunctIcE12do_falsenameEv($agg_result,$this){
 var label=0;


 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj($agg_result,1344,5);
 return;
}


function __ZNKSt3__18numpunctIwE12do_falsenameEv($agg_result,$this){
 var label=0;


 var $1=_wcslen(1320);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6__initEPKwj($agg_result,1320,$1);
 return;
}


function __ZNKSt3__120__time_get_c_storageIcE7__weeksEv($this){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=HEAP8[(14736)];
 var $2=(($1<<24)>>24)==0;
 if($2){label=2;break;}else{label=21;break;}
 case 2: 
 var $4=___cxa_guard_acquire(14736);
 var $5=($4|0)==0;
 if($5){label=21;break;}else{label=3;break;}
 case 3: 
 var $7=HEAP8[(14624)];
 var $8=(($7<<24)>>24)==0;
 if($8){label=4;break;}else{label=6;break;}
 case 4: 
 var $10=___cxa_guard_acquire(14624);
 var $11=($10|0)==0;
 if($11){label=6;break;}else{label=5;break;}
 case 5: 
 _memset(12176, 0, 168)|0;
 var $12=_atexit(784,0,___dso_handle);

 label=6;break;
 case 6: 
 var $14=(function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(12176,1728) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=7;break; } else { label=22;break; }
 case 7: 
 var $15=(function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(12188,1720) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=8;break; } else { label=22;break; }
 case 8: 
 var $16=(function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(12200,1696) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=9;break; } else { label=22;break; }
 case 9: 
 var $17=(function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(12212,1680) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=10;break; } else { label=22;break; }
 case 10: 
 var $18=(function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(12224,1664) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=11;break; } else { label=22;break; }
 case 11: 
 var $19=(function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(12236,1656) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=12;break; } else { label=22;break; }
 case 12: 
 var $20=(function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(12248,1640) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=13;break; } else { label=22;break; }
 case 13: 
 var $21=(function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(12260,1632) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=14;break; } else { label=22;break; }
 case 14: 
 var $22=(function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(12272,1624) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=15;break; } else { label=22;break; }
 case 15: 
 var $23=(function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(12284,1608) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=16;break; } else { label=22;break; }
 case 16: 
 var $24=(function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(12296,1600) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=17;break; } else { label=22;break; }
 case 17: 
 var $25=(function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(12308,1592) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=18;break; } else { label=22;break; }
 case 18: 
 var $26=(function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(12320,1584) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=19;break; } else { label=22;break; }
 case 19: 
 var $27=(function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(12332,1568) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=20;break; } else { label=22;break; }
 case 20: 
 HEAP32[((13136)>>2)]=12176;

 label=21;break;
 case 21: 
 var $29=HEAP32[((13136)>>2)];
 return $29;
 case 22: 
 var $31$0 = ___cxa_find_matching_catch(-1, -1); var $31$1 = tempRet0;

 ___resumeException($31$0)
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__120__time_get_c_storageIwE7__weeksEv($this){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=HEAP8[(14680)];
 var $2=(($1<<24)>>24)==0;
 if($2){label=2;break;}else{label=21;break;}
 case 2: 
 var $4=___cxa_guard_acquire(14680);
 var $5=($4|0)==0;
 if($5){label=21;break;}else{label=3;break;}
 case 3: 
 var $7=HEAP8[(14600)];
 var $8=(($7<<24)>>24)==0;
 if($8){label=4;break;}else{label=6;break;}
 case 4: 
 var $10=___cxa_guard_acquire(14600);
 var $11=($10|0)==0;
 if($11){label=6;break;}else{label=5;break;}
 case 5: 
 _memset(11432, 0, 168)|0;
 var $12=_atexit(398,0,___dso_handle);

 label=6;break;
 case 6: 
 var $14=(function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw(11432,2120) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=7;break; } else { label=22;break; }
 case 7: 
 var $15=(function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw(11444,2088) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=8;break; } else { label=22;break; }
 case 8: 
 var $16=(function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw(11456,2056) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=9;break; } else { label=22;break; }
 case 9: 
 var $17=(function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw(11468,2016) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=10;break; } else { label=22;break; }
 case 10: 
 var $18=(function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw(11480,1968) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=11;break; } else { label=22;break; }
 case 11: 
 var $19=(function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw(11492,1936) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=12;break; } else { label=22;break; }
 case 12: 
 var $20=(function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw(11504,1896) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=13;break; } else { label=22;break; }
 case 13: 
 var $21=(function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw(11516,1880) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=14;break; } else { label=22;break; }
 case 14: 
 var $22=(function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw(11528,1864) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=15;break; } else { label=22;break; }
 case 15: 
 var $23=(function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw(11540,1848) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=16;break; } else { label=22;break; }
 case 16: 
 var $24=(function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw(11552,1832) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=17;break; } else { label=22;break; }
 case 17: 
 var $25=(function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw(11564,1816) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=18;break; } else { label=22;break; }
 case 18: 
 var $26=(function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw(11576,1800) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=19;break; } else { label=22;break; }
 case 19: 
 var $27=(function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw(11588,1744) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=20;break; } else { label=22;break; }
 case 20: 
 HEAP32[((13048)>>2)]=11432;

 label=21;break;
 case 21: 
 var $29=HEAP32[((13048)>>2)];
 return $29;
 case 22: 
 var $31$0 = ___cxa_find_matching_catch(-1, -1); var $31$1 = tempRet0;

 ___resumeException($31$0)
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__120__time_get_c_storageIcE8__monthsEv($this){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=HEAP8[(14728)];
 var $2=(($1<<24)>>24)==0;
 if($2){label=2;break;}else{label=31;break;}
 case 2: 
 var $4=___cxa_guard_acquire(14728);
 var $5=($4|0)==0;
 if($5){label=31;break;}else{label=3;break;}
 case 3: 
 var $7=HEAP8[(14616)];
 var $8=(($7<<24)>>24)==0;
 if($8){label=4;break;}else{label=6;break;}
 case 4: 
 var $10=___cxa_guard_acquire(14616);
 var $11=($10|0)==0;
 if($11){label=6;break;}else{label=5;break;}
 case 5: 
 _memset(11888, 0, 288)|0;
 var $12=_atexit(444,0,___dso_handle);

 label=6;break;
 case 6: 
 var $14=(function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(11888,264) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=7;break; } else { label=32;break; }
 case 7: 
 var $15=(function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(11900,248) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=8;break; } else { label=32;break; }
 case 8: 
 var $16=(function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(11912,240) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=9;break; } else { label=32;break; }
 case 9: 
 var $17=(function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(11924,232) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=10;break; } else { label=32;break; }
 case 10: 
 var $18=(function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(11936,224) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=11;break; } else { label=32;break; }
 case 11: 
 var $19=(function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(11948,216) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=12;break; } else { label=32;break; }
 case 12: 
 var $20=(function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(11960,208) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=13;break; } else { label=32;break; }
 case 13: 
 var $21=(function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(11972,200) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=14;break; } else { label=32;break; }
 case 14: 
 var $22=(function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(11984,176) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=15;break; } else { label=32;break; }
 case 15: 
 var $23=(function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(11996,168) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=16;break; } else { label=32;break; }
 case 16: 
 var $24=(function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(12008,152) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=17;break; } else { label=32;break; }
 case 17: 
 var $25=(function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(12020,136) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=18;break; } else { label=32;break; }
 case 18: 
 var $26=(function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(12032,88) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=19;break; } else { label=32;break; }
 case 19: 
 var $27=(function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(12044,80) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=20;break; } else { label=32;break; }
 case 20: 
 var $28=(function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(12056,72) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=21;break; } else { label=32;break; }
 case 21: 
 var $29=(function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(12068,64) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=22;break; } else { label=32;break; }
 case 22: 
 var $30=(function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(12080,224) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=23;break; } else { label=32;break; }
 case 23: 
 var $31=(function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(12092,56) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=24;break; } else { label=32;break; }
 case 24: 
 var $32=(function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(12104,48) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=25;break; } else { label=32;break; }
 case 25: 
 var $33=(function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(12116,2184) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=26;break; } else { label=32;break; }
 case 26: 
 var $34=(function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(12128,2176) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=27;break; } else { label=32;break; }
 case 27: 
 var $35=(function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(12140,2168) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=28;break; } else { label=32;break; }
 case 28: 
 var $36=(function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(12152,2160) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=29;break; } else { label=32;break; }
 case 29: 
 var $37=(function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(12164,2152) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=30;break; } else { label=32;break; }
 case 30: 
 HEAP32[((13128)>>2)]=11888;

 label=31;break;
 case 31: 
 var $39=HEAP32[((13128)>>2)];
 return $39;
 case 32: 
 var $41$0 = ___cxa_find_matching_catch(-1, -1); var $41$1 = tempRet0;

 ___resumeException($41$0)
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__120__time_get_c_storageIwE8__monthsEv($this){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=HEAP8[(14672)];
 var $2=(($1<<24)>>24)==0;
 if($2){label=2;break;}else{label=31;break;}
 case 2: 
 var $4=___cxa_guard_acquire(14672);
 var $5=($4|0)==0;
 if($5){label=31;break;}else{label=3;break;}
 case 3: 
 var $7=HEAP8[(14592)];
 var $8=(($7<<24)>>24)==0;
 if($8){label=4;break;}else{label=6;break;}
 case 4: 
 var $10=___cxa_guard_acquire(14592);
 var $11=($10|0)==0;
 if($11){label=6;break;}else{label=5;break;}
 case 5: 
 _memset(11144, 0, 288)|0;
 var $12=_atexit(338,0,___dso_handle);

 label=6;break;
 case 6: 
 var $14=(function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw(11144,840) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=7;break; } else { label=32;break; }
 case 7: 
 var $15=(function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw(11156,800) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=8;break; } else { label=32;break; }
 case 8: 
 var $16=(function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw(11168,776) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=9;break; } else { label=32;break; }
 case 9: 
 var $17=(function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw(11180,736) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=10;break; } else { label=32;break; }
 case 10: 
 var $18=(function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw(11192,392) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=11;break; } else { label=32;break; }
 case 11: 
 var $19=(function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw(11204,712) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=12;break; } else { label=32;break; }
 case 12: 
 var $20=(function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw(11216,688) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=13;break; } else { label=32;break; }
 case 13: 
 var $21=(function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw(11228,656) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=14;break; } else { label=32;break; }
 case 14: 
 var $22=(function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw(11240,600) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=15;break; } else { label=32;break; }
 case 15: 
 var $23=(function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw(11252,568) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=16;break; } else { label=32;break; }
 case 16: 
 var $24=(function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw(11264,528) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=17;break; } else { label=32;break; }
 case 17: 
 var $25=(function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw(11276,488) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=18;break; } else { label=32;break; }
 case 18: 
 var $26=(function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw(11288,472) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=19;break; } else { label=32;break; }
 case 19: 
 var $27=(function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw(11300,440) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=20;break; } else { label=32;break; }
 case 20: 
 var $28=(function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw(11312,424) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=21;break; } else { label=32;break; }
 case 21: 
 var $29=(function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw(11324,408) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=22;break; } else { label=32;break; }
 case 22: 
 var $30=(function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw(11336,392) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=23;break; } else { label=32;break; }
 case 23: 
 var $31=(function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw(11348,376) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=24;break; } else { label=32;break; }
 case 24: 
 var $32=(function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw(11360,360) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=25;break; } else { label=32;break; }
 case 25: 
 var $33=(function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw(11372,344) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=26;break; } else { label=32;break; }
 case 26: 
 var $34=(function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw(11384,328) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=27;break; } else { label=32;break; }
 case 27: 
 var $35=(function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw(11396,312) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=28;break; } else { label=32;break; }
 case 28: 
 var $36=(function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw(11408,296) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=29;break; } else { label=32;break; }
 case 29: 
 var $37=(function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw(11420,272) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=30;break; } else { label=32;break; }
 case 30: 
 HEAP32[((13040)>>2)]=11144;

 label=31;break;
 case 31: 
 var $39=HEAP32[((13040)>>2)];
 return $39;
 case 32: 
 var $41$0 = ___cxa_find_matching_catch(-1, -1); var $41$1 = tempRet0;

 ___resumeException($41$0)
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__120__time_get_c_storageIcE7__am_pmEv($this){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=HEAP8[(14744)];
 var $2=(($1<<24)>>24)==0;
 if($2){label=2;break;}else{label=9;break;}
 case 2: 
 var $4=___cxa_guard_acquire(14744);
 var $5=($4|0)==0;
 if($5){label=9;break;}else{label=3;break;}
 case 3: 
 var $7=HEAP8[(14632)];
 var $8=(($7<<24)>>24)==0;
 if($8){label=4;break;}else{label=6;break;}
 case 4: 
 var $10=___cxa_guard_acquire(14632);
 var $11=($10|0)==0;
 if($11){label=6;break;}else{label=5;break;}
 case 5: 
 _memset(12344, 0, 288)|0;
 var $12=_atexit(332,0,___dso_handle);

 label=6;break;
 case 6: 
 var $14=(function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(12344,880) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=7;break; } else { label=10;break; }
 case 7: 
 var $15=(function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(12356,872) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=8;break; } else { label=10;break; }
 case 8: 
 HEAP32[((13144)>>2)]=12344;

 label=9;break;
 case 9: 
 var $17=HEAP32[((13144)>>2)];
 return $17;
 case 10: 
 var $19$0 = ___cxa_find_matching_catch(-1, -1); var $19$1 = tempRet0;

 ___resumeException($19$0)
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__120__time_get_c_storageIwE7__am_pmEv($this){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=HEAP8[(14688)];
 var $2=(($1<<24)>>24)==0;
 if($2){label=2;break;}else{label=9;break;}
 case 2: 
 var $4=___cxa_guard_acquire(14688);
 var $5=($4|0)==0;
 if($5){label=9;break;}else{label=3;break;}
 case 3: 
 var $7=HEAP8[(14608)];
 var $8=(($7<<24)>>24)==0;
 if($8){label=4;break;}else{label=6;break;}
 case 4: 
 var $10=___cxa_guard_acquire(14608);
 var $11=($10|0)==0;
 if($11){label=6;break;}else{label=5;break;}
 case 5: 
 _memset(11600, 0, 288)|0;
 var $12=_atexit(742,0,___dso_handle);

 label=6;break;
 case 6: 
 var $14=(function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw(11600,904) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=7;break; } else { label=10;break; }
 case 7: 
 var $15=(function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw(11612,888) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=8;break; } else { label=10;break; }
 case 8: 
 HEAP32[((13056)>>2)]=11600;

 label=9;break;
 case 9: 
 var $17=HEAP32[((13056)>>2)];
 return $17;
 case 10: 
 var $19$0 = ___cxa_find_matching_catch(-1, -1); var $19$1 = tempRet0;

 ___resumeException($19$0)
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__120__time_get_c_storageIcE3__xEv($this){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=HEAP8[(14752)];
 var $2=(($1<<24)>>24)==0;
 if($2){label=2;break;}else{label=5;break;}
 case 2: 
 var $4=___cxa_guard_acquire(14752);
 var $5=($4|0)==0;
 if($5){label=5;break;}else{label=3;break;}
 case 3: 
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(13152,1296,8) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=4;break; } else { label=6;break; }
 case 4: 
 var $7=_atexit((776),13152,___dso_handle);

 label=5;break;
 case 5: 
 return 13152;
 case 6: 
 var $10$0 = ___cxa_find_matching_catch(-1, -1); var $10$1 = tempRet0;

 ___resumeException($10$0)
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__120__time_get_c_storageIwE3__xEv($this){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=HEAP8[(14696)];
 var $2=(($1<<24)>>24)==0;
 if($2){label=2;break;}else{label=6;break;}
 case 2: 
 var $4=___cxa_guard_acquire(14696);
 var $5=($4|0)==0;
 if($5){label=6;break;}else{label=3;break;}
 case 3: 
 var $7=(function() { try { __THREW__ = 0; return _wcslen(1240) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=4;break; } else { label=7;break; }
 case 4: 
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6__initEPKwj(13064,1240,$7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=5;break; } else { label=7;break; }
 case 5: 
 var $8=_atexit((518),13064,___dso_handle);

 label=6;break;
 case 6: 
 return 13064;
 case 7: 
 var $11$0 = ___cxa_find_matching_catch(-1, -1); var $11$1 = tempRet0;

 ___resumeException($11$0)
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__120__time_get_c_storageIcE3__XEv($this){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=HEAP8[(14776)];
 var $2=(($1<<24)>>24)==0;
 if($2){label=2;break;}else{label=5;break;}
 case 2: 
 var $4=___cxa_guard_acquire(14776);
 var $5=($4|0)==0;
 if($5){label=5;break;}else{label=3;break;}
 case 3: 
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(13200,1224,8) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=4;break; } else { label=6;break; }
 case 4: 
 var $7=_atexit((776),13200,___dso_handle);

 label=5;break;
 case 5: 
 return 13200;
 case 6: 
 var $10$0 = ___cxa_find_matching_catch(-1, -1); var $10$1 = tempRet0;

 ___resumeException($10$0)
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__120__time_get_c_storageIwE3__XEv($this){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=HEAP8[(14720)];
 var $2=(($1<<24)>>24)==0;
 if($2){label=2;break;}else{label=6;break;}
 case 2: 
 var $4=___cxa_guard_acquire(14720);
 var $5=($4|0)==0;
 if($5){label=6;break;}else{label=3;break;}
 case 3: 
 var $7=(function() { try { __THREW__ = 0; return _wcslen(1184) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=4;break; } else { label=7;break; }
 case 4: 
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6__initEPKwj(13112,1184,$7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=5;break; } else { label=7;break; }
 case 5: 
 var $8=_atexit((518),13112,___dso_handle);

 label=6;break;
 case 6: 
 return 13112;
 case 7: 
 var $11$0 = ___cxa_find_matching_catch(-1, -1); var $11$1 = tempRet0;

 ___resumeException($11$0)
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__120__time_get_c_storageIcE3__cEv($this){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=HEAP8[(14768)];
 var $2=(($1<<24)>>24)==0;
 if($2){label=2;break;}else{label=5;break;}
 case 2: 
 var $4=___cxa_guard_acquire(14768);
 var $5=($4|0)==0;
 if($5){label=5;break;}else{label=3;break;}
 case 3: 
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(13184,1160,20) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=4;break; } else { label=6;break; }
 case 4: 
 var $7=_atexit((776),13184,___dso_handle);

 label=5;break;
 case 5: 
 return 13184;
 case 6: 
 var $10$0 = ___cxa_find_matching_catch(-1, -1); var $10$1 = tempRet0;

 ___resumeException($10$0)
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__120__time_get_c_storageIwE3__cEv($this){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=HEAP8[(14712)];
 var $2=(($1<<24)>>24)==0;
 if($2){label=2;break;}else{label=6;break;}
 case 2: 
 var $4=___cxa_guard_acquire(14712);
 var $5=($4|0)==0;
 if($5){label=6;break;}else{label=3;break;}
 case 3: 
 var $7=(function() { try { __THREW__ = 0; return _wcslen(1048) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=4;break; } else { label=7;break; }
 case 4: 
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6__initEPKwj(13096,1048,$7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=5;break; } else { label=7;break; }
 case 5: 
 var $8=_atexit((518),13096,___dso_handle);

 label=6;break;
 case 6: 
 return 13096;
 case 7: 
 var $11$0 = ___cxa_find_matching_catch(-1, -1); var $11$1 = tempRet0;

 ___resumeException($11$0)
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__120__time_get_c_storageIcE3__rEv($this){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=HEAP8[(14760)];
 var $2=(($1<<24)>>24)==0;
 if($2){label=2;break;}else{label=5;break;}
 case 2: 
 var $4=___cxa_guard_acquire(14760);
 var $5=($4|0)==0;
 if($5){label=5;break;}else{label=3;break;}
 case 3: 
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(13168,1032,11) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=4;break; } else { label=6;break; }
 case 4: 
 var $7=_atexit((776),13168,___dso_handle);

 label=5;break;
 case 5: 
 return 13168;
 case 6: 
 var $10$0 = ___cxa_find_matching_catch(-1, -1); var $10$1 = tempRet0;

 ___resumeException($10$0)
  default: assert(0, "bad label: " + label);
 }

}


function __ZNKSt3__120__time_get_c_storageIwE3__rEv($this){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=HEAP8[(14704)];
 var $2=(($1<<24)>>24)==0;
 if($2){label=2;break;}else{label=6;break;}
 case 2: 
 var $4=___cxa_guard_acquire(14704);
 var $5=($4|0)==0;
 if($5){label=6;break;}else{label=3;break;}
 case 3: 
 var $7=(function() { try { __THREW__ = 0; return _wcslen(984) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=4;break; } else { label=7;break; }
 case 4: 
 (function() { try { __THREW__ = 0; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6__initEPKwj(13080,984,$7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=5;break; } else { label=7;break; }
 case 5: 
 var $8=_atexit((518),13080,___dso_handle);

 label=6;break;
 case 6: 
 return 13080;
 case 7: 
 var $11$0 = ___cxa_find_matching_catch(-1, -1); var $11$1 = tempRet0;

 ___resumeException($11$0)
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__115__num_get_floatIeEET_PKcS3_Rj($__a,$__a_end,$__err){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+8)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $__p2=sp;
 var $1=($__a|0)==($__a_end|0);
 if($1){label=13;break;}else{label=2;break;}
 case 2: 
 var $3=___errno_location();
 var $4=HEAP32[(($3)>>2)];
 HEAP32[(($3)>>2)]=0;
 var $5=HEAP8[(14656)];
 var $6=(($5<<24)>>24)==0;
 if($6){label=3;break;}else{label=7;break;}
 case 3: 
 var $8=___cxa_guard_acquire(14656);
 var $9=($8|0)==0;
 if($9){label=7;break;}else{label=4;break;}
 case 4: 
 var $11=(function() { try { __THREW__ = 0; return _newlocale(2147483647,1496,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=5;break; } else { label=6;break; }
 case 5: 
 HEAP32[((12664)>>2)]=$11;

 label=7;break;
 case 6: 
 var $14$0 = ___cxa_find_matching_catch(-1, -1); var $14$1 = tempRet0;

 ___resumeException($14$0)
 case 7: 
 var $15=HEAP32[((12664)>>2)];
 var $16=_strtold_l($__a,$__p2,$15);
 var $17=HEAP32[(($3)>>2)];
 var $18=($17|0)==0;
 if($18){label=8;break;}else{label=9;break;}
 case 8: 
 HEAP32[(($3)>>2)]=$4;
 label=9;break;
 case 9: 
 var $21=HEAP32[(($__p2)>>2)];
 var $22=($21|0)==($__a_end|0);
 if($22){label=11;break;}else{label=10;break;}
 case 10: 
 HEAP32[(($__err)>>2)]=4;
 var $_0=0;label=14;break;
 case 11: 
 var $25=($17|0)==34;
 if($25){label=12;break;}else{var $_0=$16;label=14;break;}
 case 12: 
 HEAP32[(($__err)>>2)]=4;
 var $_0=$16;label=14;break;
 case 13: 
 HEAP32[(($__err)>>2)]=4;
 var $_0=0;label=14;break;
 case 14: 
 var $_0;
 STACKTOP=sp;return $_0;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__115__num_get_floatIdEET_PKcS3_Rj($__a,$__a_end,$__err){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+8)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $__p2=sp;
 var $1=($__a|0)==($__a_end|0);
 if($1){label=13;break;}else{label=2;break;}
 case 2: 
 var $3=___errno_location();
 var $4=HEAP32[(($3)>>2)];
 HEAP32[(($3)>>2)]=0;
 var $5=HEAP8[(14656)];
 var $6=(($5<<24)>>24)==0;
 if($6){label=3;break;}else{label=7;break;}
 case 3: 
 var $8=___cxa_guard_acquire(14656);
 var $9=($8|0)==0;
 if($9){label=7;break;}else{label=4;break;}
 case 4: 
 var $11=(function() { try { __THREW__ = 0; return _newlocale(2147483647,1496,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=5;break; } else { label=6;break; }
 case 5: 
 HEAP32[((12664)>>2)]=$11;

 label=7;break;
 case 6: 
 var $14$0 = ___cxa_find_matching_catch(-1, -1); var $14$1 = tempRet0;

 ___resumeException($14$0)
 case 7: 
 var $15=HEAP32[((12664)>>2)];
 var $16=_strtold_l($__a,$__p2,$15);
 var $17=HEAP32[(($3)>>2)];
 var $18=($17|0)==0;
 if($18){label=8;break;}else{label=9;break;}
 case 8: 
 HEAP32[(($3)>>2)]=$4;
 label=9;break;
 case 9: 
 var $21=HEAP32[(($__p2)>>2)];
 var $22=($21|0)==($__a_end|0);
 if($22){label=11;break;}else{label=10;break;}
 case 10: 
 HEAP32[(($__err)>>2)]=4;
 var $_0=0;label=14;break;
 case 11: 
 var $25=($17|0)==34;
 if($25){label=12;break;}else{var $_0=$16;label=14;break;}
 case 12: 
 HEAP32[(($__err)>>2)]=4;
 var $_0=$16;label=14;break;
 case 13: 
 HEAP32[(($__err)>>2)]=4;
 var $_0=0;label=14;break;
 case 14: 
 var $_0;
 STACKTOP=sp;return $_0;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__115__num_get_floatIfEET_PKcS3_Rj($__a,$__a_end,$__err){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+8)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $__p2=sp;
 var $1=($__a|0)==($__a_end|0);
 if($1){label=14;break;}else{label=2;break;}
 case 2: 
 var $3=___errno_location();
 var $4=HEAP32[(($3)>>2)];
 HEAP32[(($3)>>2)]=0;
 var $5=HEAP8[(14656)];
 var $6=(($5<<24)>>24)==0;
 if($6){label=3;break;}else{label=7;break;}
 case 3: 
 var $8=___cxa_guard_acquire(14656);
 var $9=($8|0)==0;
 if($9){label=7;break;}else{label=4;break;}
 case 4: 
 var $11=(function() { try { __THREW__ = 0; return _newlocale(2147483647,1496,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=5;break; } else { label=6;break; }
 case 5: 
 HEAP32[((12664)>>2)]=$11;

 label=7;break;
 case 6: 
 var $14$0 = ___cxa_find_matching_catch(-1, -1); var $14$1 = tempRet0;

 ___resumeException($14$0)
 case 7: 
 var $15=HEAP32[((12664)>>2)];
 var $16=_strtold_l($__a,$__p2,$15);
 var $17=HEAP32[(($3)>>2)];
 var $18=($17|0)==0;
 if($18){label=8;break;}else{label=9;break;}
 case 8: 
 HEAP32[(($3)>>2)]=$4;
 label=9;break;
 case 9: 
 var $21=HEAP32[(($__p2)>>2)];
 var $22=($21|0)==($__a_end|0);
 if($22){label=11;break;}else{label=10;break;}
 case 10: 
 HEAP32[(($__err)>>2)]=4;
 var $_0=0;label=15;break;
 case 11: 
 var $25=($17|0)==34;
 if($25){label=12;break;}else{label=13;break;}
 case 12: 
 HEAP32[(($__err)>>2)]=4;
 label=13;break;
 case 13: 
 var $28=$16;
 var $_0=$28;label=15;break;
 case 14: 
 HEAP32[(($__err)>>2)]=4;
 var $_0=0;label=15;break;
 case 15: 
 var $_0;
 STACKTOP=sp;return $_0;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__127__num_get_unsigned_integralIyEET_PKcS3_Rji($__a,$__a_end,$__err,$__base){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+8)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $__p2=sp;
 var $1=($__a|0)==($__a_end|0);
 if($1){label=15;break;}else{label=2;break;}
 case 2: 
 var $3=HEAP8[($__a)];
 var $4=(($3<<24)>>24)==45;
 if($4){label=3;break;}else{label=4;break;}
 case 3: 
 HEAP32[(($__err)>>2)]=4;
 var $_0$1=0;var $_0$0=0;label=16;break;
 case 4: 
 var $7=___errno_location();
 var $8=HEAP32[(($7)>>2)];
 HEAP32[(($7)>>2)]=0;
 var $9=HEAP8[(14656)];
 var $10=(($9<<24)>>24)==0;
 if($10){label=5;break;}else{label=9;break;}
 case 5: 
 var $12=___cxa_guard_acquire(14656);
 var $13=($12|0)==0;
 if($13){label=9;break;}else{label=6;break;}
 case 6: 
 var $15=(function() { try { __THREW__ = 0; return _newlocale(2147483647,1496,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=7;break; } else { label=8;break; }
 case 7: 
 HEAP32[((12664)>>2)]=$15;

 label=9;break;
 case 8: 
 var $18$0 = ___cxa_find_matching_catch(-1, -1); var $18$1 = tempRet0;

 ___resumeException($18$0)
 case 9: 
 var $19=HEAP32[((12664)>>2)];
 var $20$0=_strtoull_l($__a,$__p2,$__base,$19);
 var $20$1=tempRet0;
 var $21=HEAP32[(($7)>>2)];
 var $22=($21|0)==0;
 if($22){label=10;break;}else{label=11;break;}
 case 10: 
 HEAP32[(($7)>>2)]=$8;
 label=11;break;
 case 11: 
 var $25=HEAP32[(($__p2)>>2)];
 var $26=($25|0)==($__a_end|0);
 if($26){label=13;break;}else{label=12;break;}
 case 12: 
 HEAP32[(($__err)>>2)]=4;
 var $_0$1=0;var $_0$0=0;label=16;break;
 case 13: 
 var $29=($21|0)==34;
 if($29){label=14;break;}else{var $_0$1=$20$1;var $_0$0=$20$0;label=16;break;}
 case 14: 
 HEAP32[(($__err)>>2)]=4;
 var $_0$1=-1;var $_0$0=-1;label=16;break;
 case 15: 
 HEAP32[(($__err)>>2)]=4;
 var $_0$1=0;var $_0$0=0;label=16;break;
 case 16: 
 var $_0$0;
 var $_0$1;
 STACKTOP=sp;return (tempRet0=$_0$1,$_0$0);
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__127__num_get_unsigned_integralImEET_PKcS3_Rji($__a,$__a_end,$__err,$__base){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+8)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $__p2=sp;
 var $1=($__a|0)==($__a_end|0);
 if($1){label=16;break;}else{label=2;break;}
 case 2: 
 var $3=HEAP8[($__a)];
 var $4=(($3<<24)>>24)==45;
 if($4){label=3;break;}else{label=4;break;}
 case 3: 
 HEAP32[(($__err)>>2)]=4;
 var $_0=0;label=17;break;
 case 4: 
 var $7=___errno_location();
 var $8=HEAP32[(($7)>>2)];
 HEAP32[(($7)>>2)]=0;
 var $9=HEAP8[(14656)];
 var $10=(($9<<24)>>24)==0;
 if($10){label=5;break;}else{label=9;break;}
 case 5: 
 var $12=___cxa_guard_acquire(14656);
 var $13=($12|0)==0;
 if($13){label=9;break;}else{label=6;break;}
 case 6: 
 var $15=(function() { try { __THREW__ = 0; return _newlocale(2147483647,1496,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=7;break; } else { label=8;break; }
 case 7: 
 HEAP32[((12664)>>2)]=$15;

 label=9;break;
 case 8: 
 var $18$0 = ___cxa_find_matching_catch(-1, -1); var $18$1 = tempRet0;

 ___resumeException($18$0)
 case 9: 
 var $19=HEAP32[((12664)>>2)];
 var $20$0=_strtoull_l($__a,$__p2,$__base,$19);
 var $20$1=tempRet0;
 var $21=HEAP32[(($7)>>2)];
 var $22=($21|0)==0;
 if($22){label=10;break;}else{label=11;break;}
 case 10: 
 HEAP32[(($7)>>2)]=$8;
 label=11;break;
 case 11: 
 var $25=HEAP32[(($__p2)>>2)];
 var $26=($25|0)==($__a_end|0);
 if($26){label=13;break;}else{label=12;break;}
 case 12: 
 HEAP32[(($__err)>>2)]=4;
 var $_0=0;label=17;break;
 case 13: 
 var $29=($21|0)==34;
 var $$etemp$0$0=-1;
 var $$etemp$0$1=0;
 var $30=(($20$1>>>0) > ($$etemp$0$1>>>0)) | (((($20$1>>>0) == ($$etemp$0$1>>>0) & ($20$0>>>0) >  ($$etemp$0$0>>>0))));
 var $or_cond=$29|$30;
 if($or_cond){label=14;break;}else{label=15;break;}
 case 14: 
 HEAP32[(($__err)>>2)]=4;
 var $_0=-1;label=17;break;
 case 15: 
 var $33$0=$20$0;
 var $33=$33$0;
 var $_0=$33;label=17;break;
 case 16: 
 HEAP32[(($__err)>>2)]=4;
 var $_0=0;label=17;break;
 case 17: 
 var $_0;
 STACKTOP=sp;return $_0;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__127__num_get_unsigned_integralIjEET_PKcS3_Rji($__a,$__a_end,$__err,$__base){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+8)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $__p2=sp;
 var $1=($__a|0)==($__a_end|0);
 if($1){label=16;break;}else{label=2;break;}
 case 2: 
 var $3=HEAP8[($__a)];
 var $4=(($3<<24)>>24)==45;
 if($4){label=3;break;}else{label=4;break;}
 case 3: 
 HEAP32[(($__err)>>2)]=4;
 var $_0=0;label=17;break;
 case 4: 
 var $7=___errno_location();
 var $8=HEAP32[(($7)>>2)];
 HEAP32[(($7)>>2)]=0;
 var $9=HEAP8[(14656)];
 var $10=(($9<<24)>>24)==0;
 if($10){label=5;break;}else{label=9;break;}
 case 5: 
 var $12=___cxa_guard_acquire(14656);
 var $13=($12|0)==0;
 if($13){label=9;break;}else{label=6;break;}
 case 6: 
 var $15=(function() { try { __THREW__ = 0; return _newlocale(2147483647,1496,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=7;break; } else { label=8;break; }
 case 7: 
 HEAP32[((12664)>>2)]=$15;

 label=9;break;
 case 8: 
 var $18$0 = ___cxa_find_matching_catch(-1, -1); var $18$1 = tempRet0;

 ___resumeException($18$0)
 case 9: 
 var $19=HEAP32[((12664)>>2)];
 var $20$0=_strtoull_l($__a,$__p2,$__base,$19);
 var $20$1=tempRet0;
 var $21=HEAP32[(($7)>>2)];
 var $22=($21|0)==0;
 if($22){label=10;break;}else{label=11;break;}
 case 10: 
 HEAP32[(($7)>>2)]=$8;
 label=11;break;
 case 11: 
 var $25=HEAP32[(($__p2)>>2)];
 var $26=($25|0)==($__a_end|0);
 if($26){label=13;break;}else{label=12;break;}
 case 12: 
 HEAP32[(($__err)>>2)]=4;
 var $_0=0;label=17;break;
 case 13: 
 var $29=($21|0)==34;
 var $$etemp$0$0=-1;
 var $$etemp$0$1=0;
 var $30=(($20$1>>>0) > ($$etemp$0$1>>>0)) | (((($20$1>>>0) == ($$etemp$0$1>>>0) & ($20$0>>>0) >  ($$etemp$0$0>>>0))));
 var $or_cond=$29|$30;
 if($or_cond){label=14;break;}else{label=15;break;}
 case 14: 
 HEAP32[(($__err)>>2)]=4;
 var $_0=-1;label=17;break;
 case 15: 
 var $33$0=$20$0;
 var $33=$33$0;
 var $_0=$33;label=17;break;
 case 16: 
 HEAP32[(($__err)>>2)]=4;
 var $_0=0;label=17;break;
 case 17: 
 var $_0;
 STACKTOP=sp;return $_0;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__127__num_get_unsigned_integralItEET_PKcS3_Rji($__a,$__a_end,$__err,$__base){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+8)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $__p2=sp;
 var $1=($__a|0)==($__a_end|0);
 if($1){label=16;break;}else{label=2;break;}
 case 2: 
 var $3=HEAP8[($__a)];
 var $4=(($3<<24)>>24)==45;
 if($4){label=3;break;}else{label=4;break;}
 case 3: 
 HEAP32[(($__err)>>2)]=4;
 var $_0=0;label=17;break;
 case 4: 
 var $7=___errno_location();
 var $8=HEAP32[(($7)>>2)];
 HEAP32[(($7)>>2)]=0;
 var $9=HEAP8[(14656)];
 var $10=(($9<<24)>>24)==0;
 if($10){label=5;break;}else{label=9;break;}
 case 5: 
 var $12=___cxa_guard_acquire(14656);
 var $13=($12|0)==0;
 if($13){label=9;break;}else{label=6;break;}
 case 6: 
 var $15=(function() { try { __THREW__ = 0; return _newlocale(2147483647,1496,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=7;break; } else { label=8;break; }
 case 7: 
 HEAP32[((12664)>>2)]=$15;

 label=9;break;
 case 8: 
 var $18$0 = ___cxa_find_matching_catch(-1, -1); var $18$1 = tempRet0;

 ___resumeException($18$0)
 case 9: 
 var $19=HEAP32[((12664)>>2)];
 var $20$0=_strtoull_l($__a,$__p2,$__base,$19);
 var $20$1=tempRet0;
 var $21=HEAP32[(($7)>>2)];
 var $22=($21|0)==0;
 if($22){label=10;break;}else{label=11;break;}
 case 10: 
 HEAP32[(($7)>>2)]=$8;
 label=11;break;
 case 11: 
 var $25=HEAP32[(($__p2)>>2)];
 var $26=($25|0)==($__a_end|0);
 if($26){label=13;break;}else{label=12;break;}
 case 12: 
 HEAP32[(($__err)>>2)]=4;
 var $_0=0;label=17;break;
 case 13: 
 var $29=($21|0)==34;
 var $$etemp$0$0=65535;
 var $$etemp$0$1=0;
 var $30=(($20$1>>>0) > ($$etemp$0$1>>>0)) | (((($20$1>>>0) == ($$etemp$0$1>>>0) & ($20$0>>>0) >  ($$etemp$0$0>>>0))));
 var $or_cond=$29|$30;
 if($or_cond){label=14;break;}else{label=15;break;}
 case 14: 
 HEAP32[(($__err)>>2)]=4;
 var $_0=-1;label=17;break;
 case 15: 
 var $33$0=$20$0;
 var $33=$33$0&65535;
 var $_0=$33;label=17;break;
 case 16: 
 HEAP32[(($__err)>>2)]=4;
 var $_0=0;label=17;break;
 case 17: 
 var $_0;
 STACKTOP=sp;return $_0;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__125__num_get_signed_integralIxEET_PKcS3_Rji($__a,$__a_end,$__err,$__base){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+8)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $__p2=sp;
 var $1=($__a|0)==($__a_end|0);
 if($1){label=13;break;}else{label=2;break;}
 case 2: 
 var $3=___errno_location();
 var $4=HEAP32[(($3)>>2)];
 HEAP32[(($3)>>2)]=0;
 var $5=HEAP8[(14656)];
 var $6=(($5<<24)>>24)==0;
 if($6){label=3;break;}else{label=7;break;}
 case 3: 
 var $8=___cxa_guard_acquire(14656);
 var $9=($8|0)==0;
 if($9){label=7;break;}else{label=4;break;}
 case 4: 
 var $11=(function() { try { __THREW__ = 0; return _newlocale(2147483647,1496,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=5;break; } else { label=6;break; }
 case 5: 
 HEAP32[((12664)>>2)]=$11;

 label=7;break;
 case 6: 
 var $14$0 = ___cxa_find_matching_catch(-1, -1); var $14$1 = tempRet0;

 ___resumeException($14$0)
 case 7: 
 var $15=HEAP32[((12664)>>2)];
 var $16$0=_strtoll_l($__a,$__p2,$__base,$15);
 var $16$1=tempRet0;
 var $17=HEAP32[(($3)>>2)];
 var $18=($17|0)==0;
 if($18){label=8;break;}else{label=9;break;}
 case 8: 
 HEAP32[(($3)>>2)]=$4;
 label=9;break;
 case 9: 
 var $21=HEAP32[(($__p2)>>2)];
 var $22=($21|0)==($__a_end|0);
 if($22){label=11;break;}else{label=10;break;}
 case 10: 
 HEAP32[(($__err)>>2)]=4;
 var $_0$1=0;var $_0$0=0;label=14;break;
 case 11: 
 var $25=($17|0)==34;
 if($25){label=12;break;}else{var $_0$1=$16$1;var $_0$0=$16$0;label=14;break;}
 case 12: 
 HEAP32[(($__err)>>2)]=4;
 var $$etemp$0$0=0;
 var $$etemp$0$1=0;
 var $27=(($16$1|0) > ($$etemp$0$1|0)) | (((($16$1|0) == ($$etemp$0$1|0) & ($16$0>>>0) >  ($$etemp$0$0>>>0))));
 var $$etemp$2$0=0;
 var $$etemp$2$1=-2147483648;
 var $$etemp$1$0=-1;
 var $$etemp$1$1=2147483647;
 var $_$0=($27?$$etemp$1$0:$$etemp$2$0);
 var $_$1=($27?$$etemp$1$1:$$etemp$2$1);
 STACKTOP=sp;return (tempRet0=$_$1,$_$0);
 case 13: 
 HEAP32[(($__err)>>2)]=4;
 var $_0$1=0;var $_0$0=0;label=14;break;
 case 14: 
 var $_0$0;
 var $_0$1;
 STACKTOP=sp;return (tempRet0=$_0$1,$_0$0);
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__125__num_get_signed_integralIlEET_PKcS3_Rji($__a,$__a_end,$__err,$__base){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+8)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $__p2=sp;
 var $1=($__a|0)==($__a_end|0);
 if($1){label=19;break;}else{label=2;break;}
 case 2: 
 var $3=___errno_location();
 var $4=HEAP32[(($3)>>2)];
 HEAP32[(($3)>>2)]=0;
 var $5=HEAP8[(14656)];
 var $6=(($5<<24)>>24)==0;
 if($6){label=3;break;}else{label=7;break;}
 case 3: 
 var $8=___cxa_guard_acquire(14656);
 var $9=($8|0)==0;
 if($9){label=7;break;}else{label=4;break;}
 case 4: 
 var $11=(function() { try { __THREW__ = 0; return _newlocale(2147483647,1496,0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=5;break; } else { label=6;break; }
 case 5: 
 HEAP32[((12664)>>2)]=$11;

 label=7;break;
 case 6: 
 var $14$0 = ___cxa_find_matching_catch(-1, -1); var $14$1 = tempRet0;

 ___resumeException($14$0)
 case 7: 
 var $15=HEAP32[((12664)>>2)];
 var $16$0=_strtoll_l($__a,$__p2,$__base,$15);
 var $16$1=tempRet0;
 var $17=HEAP32[(($3)>>2)];
 var $18=($17|0)==0;
 if($18){label=8;break;}else{label=9;break;}
 case 8: 
 HEAP32[(($3)>>2)]=$4;
 label=9;break;
 case 9: 
 var $21=HEAP32[(($__p2)>>2)];
 var $22=($21|0)==($__a_end|0);
 if($22){label=11;break;}else{label=10;break;}
 case 10: 
 HEAP32[(($__err)>>2)]=4;
 var $_0=0;label=20;break;
 case 11: 
 var $25=($17|0)==34;
 if($25){label=16;break;}else{label=12;break;}
 case 12: 
 var $$etemp$0$0=-2147483648;
 var $$etemp$0$1=-1;
 var $27=(($16$1|0) < ($$etemp$0$1|0)) | (((($16$1|0) == ($$etemp$0$1|0) & ($16$0>>>0) <  ($$etemp$0$0>>>0))));
 if($27){label=13;break;}else{label=14;break;}
 case 13: 
 HEAP32[(($__err)>>2)]=4;
 label=17;break;
 case 14: 
 var $$etemp$1$0=2147483647;
 var $$etemp$1$1=0;
 var $29=(($16$1|0) > ($$etemp$1$1|0)) | (((($16$1|0) == ($$etemp$1$1|0) & ($16$0>>>0) >  ($$etemp$1$0>>>0))));
 if($29){label=15;break;}else{label=18;break;}
 case 15: 
 HEAP32[(($__err)>>2)]=4;
 var $_0=2147483647;label=20;break;
 case 16: 
 HEAP32[(($__err)>>2)]=4;
 var $$etemp$2$0=0;
 var $$etemp$2$1=0;
 var $31=(($16$1|0) > ($$etemp$2$1|0)) | (((($16$1|0) == ($$etemp$2$1|0) & ($16$0>>>0) >  ($$etemp$2$0>>>0))));
 if($31){var $_0=2147483647;label=20;break;}else{label=17;break;}
 case 17: 
 var $_0=-2147483648;label=20;break;
 case 18: 
 var $34$0=$16$0;
 var $34=$34$0;
 var $_0=$34;label=20;break;
 case 19: 
 HEAP32[(($__err)>>2)]=4;
 var $_0=0;label=20;break;
 case 20: 
 var $_0;
 STACKTOP=sp;return $_0;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__117__call_once_proxyINS_5tupleIJNS_12_GLOBAL__N_111__fake_bindEEEEEEvPv($__vp){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $_idx=$__vp;
 var $_idx_val=HEAP32[(($_idx)>>2)];
 var $_idx1=(($__vp+4)|0);
 var $1=$_idx1;
 var $ld$0$0=(($1)|0);
 var $_idx1_val$0=HEAP32[(($ld$0$0)>>2)];
 var $ld$1$1=(($1+4)|0);
 var $_idx1_val$1=HEAP32[(($ld$1$1)>>2)];
 var $2=$_idx1_val$1;
 var $3=$_idx_val;
 var $4=(($3+$2)|0);
 var $5=$4;
 var $6=$_idx1_val$0;
 var $7=$6&1;
 var $8=($7|0)==0;
 if($8){label=3;break;}else{label=2;break;}
 case 2: 
 var $10=$4;
 var $11=HEAP32[(($10)>>2)];
 var $12=((($6)-(1))|0);
 var $13=(($11+$12)|0);
 var $14=$13;
 var $15=HEAP32[(($14)>>2)];
 var $18=$15;label=4;break;
 case 3: 
 var $17=$6;
 var $18=$17;label=4;break;
 case 4: 
 var $18;
 FUNCTION_TABLE[$18]($5);
 return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt3__16vectorIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEE8__appendEj($this,$__n){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=(($this+8)|0);
 var $2=HEAP32[(($1)>>2)];
 var $3=(($this+4)|0);
 var $4=HEAP32[(($3)>>2)];
 var $5=$2;
 var $6=$4;
 var $7=((($5)-($6))|0);
 var $8=$7>>2;
 var $9=($8>>>0)<($__n>>>0);
 if($9){label=5;break;}else{var $_0_i=$__n;var $10=$4;label=2;break;}
 case 2: 
 var $10;
 var $_0_i;
 var $11=($10|0)==0;
 if($11){var $13=0;label=4;break;}else{label=3;break;}
 case 3: 
 HEAP32[(($10)>>2)]=0;
 var $_pre3_i=HEAP32[(($3)>>2)];
 var $13=$_pre3_i;label=4;break;
 case 4: 
 var $13;
 var $14=(($13+4)|0);
 HEAP32[(($3)>>2)]=$14;
 var $15=((($_0_i)-(1))|0);
 var $16=($15|0)==0;
 if($16){label=20;break;}else{var $_0_i=$15;var $10=$14;label=2;break;}
 case 5: 
 var $18=(($this+16)|0);
 var $19=(($this)|0);
 var $20=HEAP32[(($19)>>2)];
 var $21=$20;
 var $22=((($6)-($21))|0);
 var $23=$22>>2;
 var $24=((($23)+($__n))|0);
 var $25=($24>>>0)>1073741823;
 if($25){label=6;break;}else{label=7;break;}
 case 6: 
 __ZNKSt3__120__vector_base_commonILb1EE20__throw_length_errorEv(0);
 throw "Reached an unreachable!";
 case 7: 
 var $28=((($5)-($21))|0);
 var $29=$28>>2;
 var $30=($29>>>0)<536870911;
 if($30){label=8;break;}else{var $_0_i111821=1073741823;label=11;break;}
 case 8: 
 var $31=$28>>1;
 var $32=($31>>>0)<($24>>>0);
 var $_sroa_speculated_i=($32?$24:$31);
 var $33=($_sroa_speculated_i|0)==0;
 if($33){var $44=0;var $_0_i1119=0;label=12;break;}else{label=9;break;}
 case 9: 
 var $35=(($this+128)|0);
 var $36=HEAP8[($35)];
 var $37=(($36<<24)>>24)==0;
 var $38=($_sroa_speculated_i>>>0)<29;
 var $or_cond_i_i_i_i=$37&$38;
 if($or_cond_i_i_i_i){label=10;break;}else{var $_0_i111821=$_sroa_speculated_i;label=11;break;}
 case 10: 
 HEAP8[($35)]=1;
 var $40=$18;
 var $44=$40;var $_0_i1119=$_sroa_speculated_i;label=12;break;
 case 11: 
 var $_0_i111821;
 var $41=$_0_i111821<<2;
 var $42=__Znwj($41);
 var $43=$42;
 var $44=$43;var $_0_i1119=$_0_i111821;label=12;break;
 case 12: 
 var $_0_i1119;
 var $44;
 var $45=(($44+($23<<2))|0);
 var $_0_i8=$__n;var $47=$45;label=13;break;
 case 13: 
 var $47;
 var $_0_i8;
 var $48=($47|0)==0;
 if($48){var $50=0;label=15;break;}else{label=14;break;}
 case 14: 
 HEAP32[(($47)>>2)]=0;
 var $50=$47;label=15;break;
 case 15: 
 var $50;
 var $51=(($50+4)|0);
 var $52=((($_0_i8)-(1))|0);
 var $53=($52|0)==0;
 if($53){label=16;break;}else{var $_0_i8=$52;var $47=$51;label=13;break;}
 case 16: 
 var $54=(($44+($_0_i1119<<2))|0);
 var $55=HEAP32[(($19)>>2)];
 var $56=HEAP32[(($3)>>2)];
 var $57=$56;
 var $58=$55;
 var $59=((($57)-($58))|0);
 var $60=$59>>2;
 var $_sum=((($23)-($60))|0);
 var $61=(($44+($_sum<<2))|0);
 var $62=$61;
 var $63=$55;
 assert($59 % 1 === 0);(_memcpy($62, $63, $59)|0);
 HEAP32[(($19)>>2)]=$61;
 HEAP32[(($3)>>2)]=$51;
 HEAP32[(($1)>>2)]=$54;
 var $64=($55|0)==0;
 if($64){label=20;break;}else{label=17;break;}
 case 17: 
 var $66=$18;
 var $67=($66|0)==($55|0);
 if($67){label=18;break;}else{label=19;break;}
 case 18: 
 var $69=(($this+128)|0);
 HEAP8[($69)]=0;
 label=20;break;
 case 19: 
 __ZdlPv($63);
 label=20;break;
 case 20: 
 return;
  default: assert(0, "bad label: " + label);
 }

}


function ___cxx_global_array_dtor($0){
 var label=0;


 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(11876);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(11864);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(11852);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(11840);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(11828);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(11816);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(11804);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(11792);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(11780);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(11768);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(11756);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(11744);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(11732);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(11720);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(11708);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(11696);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(11684);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(11672);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(11660);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(11648);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(11636);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(11624);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(11612);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(11600);
 return;
}


function ___cxx_global_array_dtor53($0){
 var label=0;


 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(12620);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(12608);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(12596);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(12584);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(12572);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(12560);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(12548);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(12536);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(12524);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(12512);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(12500);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(12488);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(12476);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(12464);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(12452);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(12440);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(12428);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(12416);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(12404);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(12392);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(12380);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(12368);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(12356);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(12344);
 return;
}


function ___cxx_global_array_dtor56($0){
 var label=0;


 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(11420);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(11408);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(11396);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(11384);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(11372);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(11360);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(11348);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(11336);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(11324);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(11312);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(11300);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(11288);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(11276);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(11264);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(11252);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(11240);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(11228);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(11216);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(11204);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(11192);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(11180);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(11168);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(11156);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(11144);
 return;
}


function ___cxx_global_array_dtor81($0){
 var label=0;


 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(12164);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(12152);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(12140);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(12128);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(12116);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(12104);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(12092);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(12080);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(12068);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(12056);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(12044);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(12032);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(12020);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(12008);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(11996);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(11984);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(11972);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(11960);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(11948);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(11936);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(11924);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(11912);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(11900);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(11888);
 return;
}


function ___cxx_global_array_dtor105($0){
 var label=0;


 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(11588);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(11576);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(11564);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(11552);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(11540);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(11528);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(11516);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(11504);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(11492);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(11480);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(11468);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(11456);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(11444);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(11432);
 return;
}


function ___cxx_global_array_dtor120($0){
 var label=0;


 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(12332);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(12320);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(12308);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(12296);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(12284);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(12272);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(12260);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(12248);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(12236);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(12224);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(12212);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(12200);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(12188);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(12176);
 return;
}


function _mbrlen($s,$n,$st){
 var label=0;


 var $1=($st|0)!=0;
 var $2=($1?$st:10664);
 var $3=_mbrtowc(0,$s,$n,$2);
 return $3;
}


function _mbrtowc($wc,$src,$n,$st){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+8)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=sp;
 HEAP32[(($1)>>2)]=$wc;
 var $2=($st|0)==0;
 var $_027=($2?10656:$st);
 var $3=(($_027)|0);
 var $4=HEAP32[(($3)>>2)];
 var $5=($src|0)==0;
 if($5){label=2;break;}else{label=3;break;}
 case 2: 
 var $7=($4|0)==0;
 if($7){var $_0=0;label=19;break;}else{label=18;break;}
 case 3: 
 var $9=($wc|0)==0;
 if($9){label=4;break;}else{var $13=$wc;label=5;break;}
 case 4: 
 var $11=$1;
 HEAP32[(($1)>>2)]=$11;
 var $13=$11;label=5;break;
 case 5: 
 var $13;
 var $14=($n|0)==0;
 if($14){var $_0=-2;label=19;break;}else{label=6;break;}
 case 6: 
 var $16=($4|0)==0;
 if($16){label=7;break;}else{var $s_0=$src;var $c_0=$4;var $_028=$n;label=11;break;}
 case 7: 
 var $18=HEAP8[($src)];
 var $19=($18&255);
 var $20=(($18<<24)>>24)>-1;
 if($20){label=8;break;}else{label=9;break;}
 case 8: 
 HEAP32[(($13)>>2)]=$19;
 var $22=(($18<<24)>>24)!=0;
 var $23=($22&1);
 var $_0=$23;label=19;break;
 case 9: 
 var $25=((($19)-(194))|0);
 var $26=($25>>>0)>50;
 if($26){label=18;break;}else{label=10;break;}
 case 10: 
 var $28=(($src+1)|0);
 var $29=((2296+($25<<2))|0);
 var $30=HEAP32[(($29)>>2)];
 var $31=((($n)-(1))|0);
 var $s_0=$28;var $c_0=$30;var $_028=$31;label=11;break;
 case 11: 
 var $_028;
 var $c_0;
 var $s_0;
 var $33=($_028|0)==0;
 if($33){var $c_2=$c_0;label=17;break;}else{label=12;break;}
 case 12: 
 var $35=HEAP8[($s_0)];
 var $36=($35&255);
 var $37=$36>>>3;
 var $38=((($37)-(16))|0);
 var $39=$c_0>>26;
 var $40=((($37)+($39))|0);
 var $41=$38|$40;
 var $42=($41>>>0)>7;
 if($42){label=18;break;}else{var $s_1=$s_0;var $c_1=$c_0;var $_1=$_028;var $43=$35;label=13;break;}
 case 13: 
 var $43;
 var $_1;
 var $c_1;
 var $s_1;
 var $44=$c_1<<6;
 var $45=(($s_1+1)|0);
 var $46=($43&255);
 var $47=((($46)-(128))|0);
 var $48=$47|$44;
 var $49=((($_1)-(1))|0);
 var $50=($48|0)<0;
 if($50){label=15;break;}else{label=14;break;}
 case 14: 
 HEAP32[(($3)>>2)]=0;
 HEAP32[(($13)>>2)]=$48;
 var $52=((($n)-($49))|0);
 var $_0=$52;label=19;break;
 case 15: 
 var $54=($49|0)==0;
 if($54){var $c_2=$48;label=17;break;}else{label=16;break;}
 case 16: 
 var $56=HEAP8[($45)];
 var $57=($56&255);
 var $58=((($57)-(128))|0);
 var $59=($58>>>0)>63;
 if($59){label=18;break;}else{var $s_1=$45;var $c_1=$48;var $_1=$49;var $43=$56;label=13;break;}
 case 17: 
 var $c_2;
 HEAP32[(($3)>>2)]=$c_2;
 var $_0=-2;label=19;break;
 case 18: 
 HEAP32[(($3)>>2)]=0;
 var $60=___errno_location();
 HEAP32[(($60)>>2)]=84;
 var $_0=-1;label=19;break;
 case 19: 
 var $_0;
 STACKTOP=sp;return $_0;
  default: assert(0, "bad label: " + label);
 }

}


function _mbsnrtowcs($wcs,$src,$n,$wn,$st){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+1032)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $wbuf=sp;
 var $s=(sp)+(1024);
 var $0=HEAP32[(($src)>>2)];
 HEAP32[(($s)>>2)]=$0;
 var $1=($wcs|0)!=0;
 var $2=(($wbuf)|0);
 var $_040_ph=($1?$wn:256);
 var $ws_0_ph=($1?$wcs:$2);
 var $3=($0|0)==0;
 var $4=($_040_ph|0)==0;
 var $or_cond59=$3|$4;
 if($or_cond59){var $cnt_1=0;var $_1=$n;var $_242=$_040_ph;var $ws_056=$ws_0_ph;var $23=$0;label=9;break;}else{label=2;break;}
 case 2: 
 var $5=(($wbuf)|0);
 var $_04060=$_040_ph;var $_061=$n;var $cnt_062=0;var $ws_063=$ws_0_ph;var $_pr78=$0;label=3;break;
 case 3: 
 var $_pr78;
 var $ws_063;
 var $cnt_062;
 var $_061;
 var $_04060;
 var $7=$_061>>>2;
 var $8=($7>>>0)>=($_04060>>>0);
 var $9=($_061>>>0)>131;
 var $or_cond43=$8|$9;
 if($or_cond43){label=4;break;}else{var $cnt_1=$cnt_062;var $_1=$_061;var $_242=$_04060;var $ws_056=$ws_063;var $23=$_pr78;label=9;break;}
 case 4: 
 var $_040_=($8?$_04060:$7);
 var $10=((($_061)-($_040_))|0);
 var $11=_mbsrtowcs($ws_063,$s,$_040_,$st);
 var $12=($11|0)==-1;
 if($12){label=5;break;}else{label=6;break;}
 case 5: 
 var $_pr_pre=HEAP32[(($s)>>2)];
 var $cnt_1=-1;var $_1=$10;var $_242=0;var $ws_056=$ws_063;var $23=$_pr_pre;label=9;break;
 case 6: 
 var $14=($ws_063|0)==($5|0);
 if($14){var $ws_1=$5;var $_141=$_04060;label=8;break;}else{label=7;break;}
 case 7: 
 var $16=(($ws_063+($11<<2))|0);
 var $17=((($_04060)-($11))|0);
 var $ws_1=$16;var $_141=$17;label=8;break;
 case 8: 
 var $_141;
 var $ws_1;
 var $19=((($11)+($cnt_062))|0);
 var $20=HEAP32[(($s)>>2)];
 var $21=($20|0)==0;
 var $22=($_141|0)==0;
 var $or_cond=$21|$22;
 if($or_cond){var $cnt_1=$19;var $_1=$10;var $_242=$_141;var $ws_056=$ws_1;var $23=$20;label=9;break;}else{var $_04060=$_141;var $_061=$10;var $cnt_062=$19;var $ws_063=$ws_1;var $_pr78=$20;label=3;break;}
 case 9: 
 var $23;
 var $ws_056;
 var $_242;
 var $_1;
 var $cnt_1;
 var $24=($23|0)==0;
 if($24){var $cnt_3=$cnt_1;label=16;break;}else{label=10;break;}
 case 10: 
 var $25=($_242|0)==0;
 var $26=($_1|0)==0;
 var $or_cond4446=$25|$26;
 if($or_cond4446){var $cnt_3=$cnt_1;label=16;break;}else{var $_347=$_242;var $_248=$_1;var $cnt_249=$cnt_1;var $ws_250=$ws_056;var $27=$23;label=11;break;}
 case 11: 
 var $27;
 var $ws_250;
 var $cnt_249;
 var $_248;
 var $_347;
 var $28=_mbrtowc($ws_250,$27,$_248,$st);
 var $29=((($28)+(2))|0);
 var $30=($29>>>0)<3;
 if($30){label=12;break;}else{label=15;break;}
 case 12: 
 if(($28|0)==0){ label=13;break;}else if(($28|0)==-1){ var $cnt_3=-1;label=16;break;}else{label=14;break;}
 case 13: 
 HEAP32[(($s)>>2)]=0;
 var $cnt_3=$cnt_249;label=16;break;
 case 14: 
 var $34=(($st)|0);
 HEAP32[(($34)>>2)]=0;
 var $cnt_3=$cnt_249;label=16;break;
 case 15: 
 var $36=HEAP32[(($s)>>2)];
 var $37=(($36+$28)|0);
 HEAP32[(($s)>>2)]=$37;
 var $38=((($_248)-($28))|0);
 var $39=(($ws_250+4)|0);
 var $40=((($_347)-(1))|0);
 var $41=((($cnt_249)+(1))|0);
 var $42=($40|0)==0;
 var $43=($_248|0)==($28|0);
 var $or_cond44=$42|$43;
 if($or_cond44){var $cnt_3=$41;label=16;break;}else{var $_347=$40;var $_248=$38;var $cnt_249=$41;var $ws_250=$39;var $27=$37;label=11;break;}
 case 16: 
 var $cnt_3;
 if($1){label=17;break;}else{label=18;break;}
 case 17: 
 var $45=HEAP32[(($s)>>2)];
 HEAP32[(($src)>>2)]=$45;
 label=18;break;
 case 18: 
 STACKTOP=sp;return $cnt_3;
  default: assert(0, "bad label: " + label);
 }

}


function _mbsrtowcs($ws,$src,$wn,$st){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=HEAP32[(($src)>>2)];
 var $2=($st|0)==0;
 if($2){label=5;break;}else{label=2;break;}
 case 2: 
 var $4=(($st)|0);
 var $5=HEAP32[(($4)>>2)];
 var $6=($5|0)==0;
 if($6){label=5;break;}else{label=3;break;}
 case 3: 
 var $8=($ws|0)==0;
 if($8){var $c_2=$5;var $s_3=$1;var $_380=$wn;label=16;break;}else{label=4;break;}
 case 4: 
 HEAP32[(($4)>>2)]=0;
 var $c_4=$5;var $s_8=$1;var $_3=$ws;var $_7=$wn;label=36;break;
 case 5: 
 var $11=($ws|0)==0;
 if($11){var $s_0=$1;var $_077=$wn;label=7;break;}else{var $s_5_ph=$1;var $_076_ph=$ws;var $_481_ph=$wn;label=6;break;}
 case 6: 
 var $_481_ph;
 var $_076_ph;
 var $s_5_ph;
 var $12=($_481_ph|0)==0;
 if($12){var $_0=$wn;label=53;break;}else{var $_48197=$_481_ph;var $_07698=$_076_ph;var $s_599=$s_5_ph;label=26;break;}
 case 7: 
 var $_077;
 var $s_0;
 var $13=HEAP8[($s_0)];
 var $14=($13&255);
 var $15=((($14)-(1))|0);
 var $16=($15>>>0)<127;
 if($16){label=8;break;}else{var $s_2=$s_0;var $_279=$_077;var $37=$13;label=12;break;}
 case 8: 
 var $18=$s_0;
 var $19=$18&3;
 var $20=($19|0)==0;
 if($20){label=9;break;}else{var $s_2=$s_0;var $_279=$_077;var $37=$13;label=12;break;}
 case 9: 
 var $21=$s_0;
 var $22=HEAP32[(($21)>>2)];
 var $23=((($22)-(16843009))|0);
 var $24=$23|$22;
 var $25=$24&-2139062144;
 var $26=($25|0)==0;
 var $27=(($22)&255);
 if($26){var $_17882=$_077;var $s_183=$s_0;label=10;break;}else{var $s_2=$s_0;var $_279=$_077;var $37=$27;label=12;break;}
 case 10: 
 var $s_183;
 var $_17882;
 var $28=(($s_183+4)|0);
 var $29=((($_17882)-(4))|0);
 var $30=$28;
 var $31=HEAP32[(($30)>>2)];
 var $32=((($31)-(16843009))|0);
 var $33=$32|$31;
 var $34=$33&-2139062144;
 var $35=($34|0)==0;
 if($35){var $_17882=$29;var $s_183=$28;label=10;break;}else{label=11;break;}
 case 11: 
 var $36=(($31)&255);
 var $s_2=$28;var $_279=$29;var $37=$36;label=12;break;
 case 12: 
 var $37;
 var $_279;
 var $s_2;
 var $38=($37&255);
 var $39=((($38)-(1))|0);
 var $40=($39>>>0)<127;
 if($40){label=13;break;}else{label=14;break;}
 case 13: 
 var $42=(($s_2+1)|0);
 var $43=((($_279)-(1))|0);
 var $s_0=$42;var $_077=$43;label=7;break;
 case 14: 
 var $45=((($38)-(194))|0);
 var $46=($45>>>0)>50;
 if($46){var $_8115=$_279;var $_4117=$ws;var $s_10119=$s_2;label=47;break;}else{label=15;break;}
 case 15: 
 var $48=(($s_2+1)|0);
 var $49=((2296+($45<<2))|0);
 var $50=HEAP32[(($49)>>2)];
 var $c_2=$50;var $s_3=$48;var $_380=$_279;label=16;break;
 case 16: 
 var $_380;
 var $s_3;
 var $c_2;
 var $52=HEAP8[($s_3)];
 var $53=($52&255);
 var $54=$53>>>3;
 var $55=((($54)-(16))|0);
 var $56=$c_2>>26;
 var $57=((($54)+($56))|0);
 var $58=$55|$57;
 var $59=($58>>>0)>7;
 if($59){label=17;break;}else{label=18;break;}
 case 17: 
 var $61=((($s_3)-(1))|0);
 var $c_6=$c_2;var $s_10=$61;var $_4=$ws;var $_8=$_380;label=46;break;
 case 18: 
 var $63=(($s_3+1)|0);
 var $64=$c_2&33554432;
 var $65=($64|0)==0;
 if($65){var $s_4=$63;label=25;break;}else{label=19;break;}
 case 19: 
 var $67=HEAP8[($63)];
 var $68=($67&255);
 var $69=((($68)-(128))|0);
 var $70=($69>>>0)>63;
 if($70){label=20;break;}else{label=21;break;}
 case 20: 
 var $72=((($s_3)-(1))|0);
 var $c_6=$c_2;var $s_10=$72;var $_4=$ws;var $_8=$_380;label=46;break;
 case 21: 
 var $74=(($s_3+2)|0);
 var $75=$c_2&524288;
 var $76=($75|0)==0;
 if($76){var $s_4=$74;label=25;break;}else{label=22;break;}
 case 22: 
 var $78=HEAP8[($74)];
 var $79=($78&255);
 var $80=((($79)-(128))|0);
 var $81=($80>>>0)>63;
 if($81){label=23;break;}else{label=24;break;}
 case 23: 
 var $83=((($s_3)-(1))|0);
 var $c_6=$c_2;var $s_10=$83;var $_4=$ws;var $_8=$_380;label=46;break;
 case 24: 
 var $85=(($s_3+3)|0);
 var $s_4=$85;label=25;break;
 case 25: 
 var $s_4;
 var $87=((($_380)-(1))|0);
 var $s_0=$s_4;var $_077=$87;label=7;break;
 case 26: 
 var $s_599;
 var $_07698;
 var $_48197;
 var $88=HEAP8[($s_599)];
 var $89=($88&255);
 var $90=((($89)-(1))|0);
 var $91=($90>>>0)<127;
 if($91){label=27;break;}else{var $s_7=$s_599;var $_2=$_07698;var $_6=$_48197;var $122=$88;label=32;break;}
 case 27: 
 var $93=$s_599;
 var $94=$93&3;
 var $95=($94|0)==0;
 var $96=($_48197>>>0)>3;
 var $or_cond=$95&$96;
 if($or_cond){var $_587=$_48197;var $_188=$_07698;var $s_689=$s_599;label=28;break;}else{var $s_7=$s_599;var $_2=$_07698;var $_6=$_48197;var $122=$88;label=32;break;}
 case 28: 
 var $s_689;
 var $_188;
 var $_587;
 var $97=$s_689;
 var $98=HEAP32[(($97)>>2)];
 var $99=((($98)-(16843009))|0);
 var $100=$99|$98;
 var $101=$100&-2139062144;
 var $102=($101|0)==0;
 if($102){label=29;break;}else{label=30;break;}
 case 29: 
 var $104=(($s_689+1)|0);
 var $105=$98&255;
 var $106=(($_188+4)|0);
 HEAP32[(($_188)>>2)]=$105;
 var $107=(($s_689+2)|0);
 var $108=HEAP8[($104)];
 var $109=($108&255);
 var $110=(($_188+8)|0);
 HEAP32[(($106)>>2)]=$109;
 var $111=(($s_689+3)|0);
 var $112=HEAP8[($107)];
 var $113=($112&255);
 var $114=(($_188+12)|0);
 HEAP32[(($110)>>2)]=$113;
 var $115=(($s_689+4)|0);
 var $116=HEAP8[($111)];
 var $117=($116&255);
 var $118=(($_188+16)|0);
 HEAP32[(($114)>>2)]=$117;
 var $119=((($_587)-(4))|0);
 var $120=($119>>>0)>3;
 if($120){var $_587=$119;var $_188=$118;var $s_689=$115;label=28;break;}else{label=31;break;}
 case 30: 
 var $121=(($98)&255);
 var $s_7=$s_689;var $_2=$_188;var $_6=$_587;var $122=$121;label=32;break;
 case 31: 
 var $_pre_pre=HEAP8[($115)];
 var $s_7=$115;var $_2=$118;var $_6=$119;var $122=$_pre_pre;label=32;break;
 case 32: 
 var $122;
 var $_6;
 var $_2;
 var $s_7;
 var $123=($122&255);
 var $124=((($123)-(1))|0);
 var $125=($124>>>0)<127;
 if($125){label=33;break;}else{label=34;break;}
 case 33: 
 var $127=(($s_7+1)|0);
 var $128=(($_2+4)|0);
 HEAP32[(($_2)>>2)]=$123;
 var $129=((($_6)-(1))|0);
 var $130=($129|0)==0;
 if($130){var $_0=$wn;label=53;break;}else{var $_48197=$129;var $_07698=$128;var $s_599=$127;label=26;break;}
 case 34: 
 var $132=((($123)-(194))|0);
 var $133=($132>>>0)>50;
 if($133){var $_8115=$_6;var $_4117=$_2;var $s_10119=$s_7;label=47;break;}else{label=35;break;}
 case 35: 
 var $135=(($s_7+1)|0);
 var $136=((2296+($132<<2))|0);
 var $137=HEAP32[(($136)>>2)];
 var $c_4=$137;var $s_8=$135;var $_3=$_2;var $_7=$_6;label=36;break;
 case 36: 
 var $_7;
 var $_3;
 var $s_8;
 var $c_4;
 var $139=HEAP8[($s_8)];
 var $140=($139&255);
 var $141=$140>>>3;
 var $142=((($141)-(16))|0);
 var $143=$c_4>>26;
 var $144=((($141)+($143))|0);
 var $145=$142|$144;
 var $146=($145>>>0)>7;
 if($146){label=37;break;}else{label=38;break;}
 case 37: 
 var $148=((($s_8)-(1))|0);
 var $c_6=$c_4;var $s_10=$148;var $_4=$_3;var $_8=$_7;label=46;break;
 case 38: 
 var $150=$c_4<<6;
 var $151=(($s_8+1)|0);
 var $152=((($140)-(128))|0);
 var $153=$152|$150;
 var $154=($153|0)<0;
 if($154){label=39;break;}else{var $c_5=$153;var $s_9=$151;label=45;break;}
 case 39: 
 var $156=HEAP8[($151)];
 var $157=($156&255);
 var $158=((($157)-(128))|0);
 var $159=($158>>>0)>63;
 if($159){label=40;break;}else{label=41;break;}
 case 40: 
 var $161=((($s_8)-(1))|0);
 var $c_6=$153;var $s_10=$161;var $_4=$_3;var $_8=$_7;label=46;break;
 case 41: 
 var $163=$153<<6;
 var $164=(($s_8+2)|0);
 var $165=$158|$163;
 var $166=($165|0)<0;
 if($166){label=42;break;}else{var $c_5=$165;var $s_9=$164;label=45;break;}
 case 42: 
 var $168=HEAP8[($164)];
 var $169=($168&255);
 var $170=((($169)-(128))|0);
 var $171=($170>>>0)>63;
 if($171){label=43;break;}else{label=44;break;}
 case 43: 
 var $173=((($s_8)-(1))|0);
 var $c_6=$165;var $s_10=$173;var $_4=$_3;var $_8=$_7;label=46;break;
 case 44: 
 var $175=$165<<6;
 var $176=(($s_8+3)|0);
 var $177=$170|$175;
 var $c_5=$177;var $s_9=$176;label=45;break;
 case 45: 
 var $s_9;
 var $c_5;
 var $179=(($_3+4)|0);
 HEAP32[(($_3)>>2)]=$c_5;
 var $180=((($_7)-(1))|0);
 var $s_5_ph=$s_9;var $_076_ph=$179;var $_481_ph=$180;label=6;break;
 case 46: 
 var $_8;
 var $_4;
 var $s_10;
 var $c_6;
 var $182=($c_6|0)==0;
 if($182){var $_8115=$_8;var $_4117=$_4;var $s_10119=$s_10;label=47;break;}else{var $_4116=$_4;var $s_10118=$s_10;label=51;break;}
 case 47: 
 var $s_10119;
 var $_4117;
 var $_8115;
 var $183=HEAP8[($s_10119)];
 var $184=(($183<<24)>>24)==0;
 if($184){label=48;break;}else{var $_4116=$_4117;var $s_10118=$s_10119;label=51;break;}
 case 48: 
 var $186=($_4117|0)==0;
 if($186){label=50;break;}else{label=49;break;}
 case 49: 
 HEAP32[(($_4117)>>2)]=0;
 HEAP32[(($src)>>2)]=0;
 label=50;break;
 case 50: 
 var $189=((($wn)-($_8115))|0);
 var $_0=$189;label=53;break;
 case 51: 
 var $s_10118;
 var $_4116;
 var $191=___errno_location();
 HEAP32[(($191)>>2)]=84;
 var $192=($_4116|0)==0;
 if($192){var $_0=-1;label=53;break;}else{label=52;break;}
 case 52: 
 HEAP32[(($src)>>2)]=$s_10118;
 var $_0=-1;label=53;break;
 case 53: 
 var $_0;
 return $_0;
  default: assert(0, "bad label: " + label);
 }

}


function _mbtowc($wc,$src,$n){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+8)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=sp;
 HEAP32[(($1)>>2)]=$wc;
 var $2=($src|0)==0;
 if($2){var $_0=0;label=19;break;}else{label=2;break;}
 case 2: 
 var $4=($n|0)==0;
 if($4){label=18;break;}else{label=3;break;}
 case 3: 
 var $6=($wc|0)==0;
 if($6){label=4;break;}else{var $10=$wc;label=5;break;}
 case 4: 
 var $8=$1;
 HEAP32[(($1)>>2)]=$8;
 var $10=$8;label=5;break;
 case 5: 
 var $10;
 var $11=HEAP8[($src)];
 var $12=($11&255);
 var $13=(($11<<24)>>24)>-1;
 if($13){label=6;break;}else{label=7;break;}
 case 6: 
 HEAP32[(($10)>>2)]=$12;
 var $15=(($11<<24)>>24)!=0;
 var $16=($15&1);
 var $_0=$16;label=19;break;
 case 7: 
 var $18=((($12)-(194))|0);
 var $19=($18>>>0)>50;
 if($19){label=18;break;}else{label=8;break;}
 case 8: 
 var $21=(($src+1)|0);
 var $22=((2296+($18<<2))|0);
 var $23=HEAP32[(($22)>>2)];
 var $24=($n>>>0)<4;
 if($24){label=9;break;}else{label=10;break;}
 case 9: 
 var $26=((($n)*(6))&-1);
 var $27=((($26)-(6))|0);
 var $28=-2147483648>>>($27>>>0);
 var $29=$23&$28;
 var $30=($29|0)==0;
 if($30){label=10;break;}else{label=18;break;}
 case 10: 
 var $32=HEAP8[($21)];
 var $33=($32&255);
 var $34=$33>>>3;
 var $35=((($34)-(16))|0);
 var $36=$23>>26;
 var $37=((($34)+($36))|0);
 var $38=$35|$37;
 var $39=($38>>>0)>7;
 if($39){label=18;break;}else{label=11;break;}
 case 11: 
 var $41=$23<<6;
 var $42=((($33)-(128))|0);
 var $43=$42|$41;
 var $44=($43|0)<0;
 if($44){label=13;break;}else{label=12;break;}
 case 12: 
 HEAP32[(($10)>>2)]=$43;
 var $_0=2;label=19;break;
 case 13: 
 var $47=(($src+2)|0);
 var $48=HEAP8[($47)];
 var $49=($48&255);
 var $50=((($49)-(128))|0);
 var $51=($50>>>0)>63;
 if($51){label=18;break;}else{label=14;break;}
 case 14: 
 var $53=$43<<6;
 var $54=$50|$53;
 var $55=($54|0)<0;
 if($55){label=16;break;}else{label=15;break;}
 case 15: 
 HEAP32[(($10)>>2)]=$54;
 var $_0=3;label=19;break;
 case 16: 
 var $58=(($src+3)|0);
 var $59=HEAP8[($58)];
 var $60=($59&255);
 var $61=((($60)-(128))|0);
 var $62=($61>>>0)>63;
 if($62){label=18;break;}else{label=17;break;}
 case 17: 
 var $64=$54<<6;
 var $65=$61|$64;
 HEAP32[(($10)>>2)]=$65;
 var $_0=4;label=19;break;
 case 18: 
 var $67=___errno_location();
 HEAP32[(($67)>>2)]=84;
 var $_0=-1;label=19;break;
 case 19: 
 var $_0;
 STACKTOP=sp;return $_0;
  default: assert(0, "bad label: " + label);
 }

}


function _wcrtomb($s,$wc,$st){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=($s|0)==0;
 if($1){var $_0=1;label=11;break;}else{label=2;break;}
 case 2: 
 var $3=($wc>>>0)<128;
 if($3){label=3;break;}else{label=4;break;}
 case 3: 
 var $5=(($wc)&255);
 HEAP8[($s)]=$5;
 var $_0=1;label=11;break;
 case 4: 
 var $7=($wc>>>0)<2048;
 if($7){label=5;break;}else{label=6;break;}
 case 5: 
 var $9=$wc>>>6;
 var $10=$9|192;
 var $11=(($10)&255);
 var $12=(($s+1)|0);
 HEAP8[($s)]=$11;
 var $13=$wc&63;
 var $14=$13|128;
 var $15=(($14)&255);
 HEAP8[($12)]=$15;
 var $_0=2;label=11;break;
 case 6: 
 var $17=($wc>>>0)<55296;
 var $18=((($wc)-(57344))|0);
 var $19=($18>>>0)<8192;
 var $or_cond=$17|$19;
 if($or_cond){label=7;break;}else{label=8;break;}
 case 7: 
 var $21=$wc>>>12;
 var $22=$21|224;
 var $23=(($22)&255);
 var $24=(($s+1)|0);
 HEAP8[($s)]=$23;
 var $25=$wc>>>6;
 var $26=$25&63;
 var $27=$26|128;
 var $28=(($27)&255);
 var $29=(($s+2)|0);
 HEAP8[($24)]=$28;
 var $30=$wc&63;
 var $31=$30|128;
 var $32=(($31)&255);
 HEAP8[($29)]=$32;
 var $_0=3;label=11;break;
 case 8: 
 var $34=((($wc)-(65536))|0);
 var $35=($34>>>0)<1048576;
 if($35){label=9;break;}else{label=10;break;}
 case 9: 
 var $37=$wc>>>18;
 var $38=$37|240;
 var $39=(($38)&255);
 var $40=(($s+1)|0);
 HEAP8[($s)]=$39;
 var $41=$wc>>>12;
 var $42=$41&63;
 var $43=$42|128;
 var $44=(($43)&255);
 var $45=(($s+2)|0);
 HEAP8[($40)]=$44;
 var $46=$wc>>>6;
 var $47=$46&63;
 var $48=$47|128;
 var $49=(($48)&255);
 var $50=(($s+3)|0);
 HEAP8[($45)]=$49;
 var $51=$wc&63;
 var $52=$51|128;
 var $53=(($52)&255);
 HEAP8[($50)]=$53;
 var $_0=4;label=11;break;
 case 10: 
 var $55=___errno_location();
 HEAP32[(($55)>>2)]=84;
 var $_0=-1;label=11;break;
 case 11: 
 var $_0;
 return $_0;
  default: assert(0, "bad label: " + label);
 }

}


function _wcsnrtombs($dst,$wcs,$wn,$n,$st){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+264)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $buf=sp;
 var $ws=(sp)+(256);
 var $0=HEAP32[(($wcs)>>2)];
 HEAP32[(($ws)>>2)]=$0;
 var $1=($dst|0)!=0;
 var $2=(($buf)|0);
 var $_037_ph=($1?$n:256);
 var $s_0_ph=($1?$dst:$2);
 var $3=($0|0)==0;
 var $4=($_037_ph|0)==0;
 var $or_cond56=$3|$4;
 if($or_cond56){var $cnt_1=0;var $_1=$wn;var $_239=$_037_ph;var $s_053=$s_0_ph;var $22=$0;label=9;break;}else{label=2;break;}
 case 2: 
 var $5=(($buf)|0);
 var $_03757=$_037_ph;var $_058=$wn;var $cnt_059=0;var $s_060=$s_0_ph;var $_pr75=$0;label=3;break;
 case 3: 
 var $_pr75;
 var $s_060;
 var $cnt_059;
 var $_058;
 var $_03757;
 var $7=($_058>>>0)>=($_03757>>>0);
 var $8=($_058>>>0)>32;
 var $or_cond40=$7|$8;
 if($or_cond40){label=4;break;}else{var $cnt_1=$cnt_059;var $_1=$_058;var $_239=$_03757;var $s_053=$s_060;var $22=$_pr75;label=9;break;}
 case 4: 
 var $_037__0=($7?$_03757:$_058);
 var $9=((($_058)-($_037__0))|0);
 var $10=_wcsrtombs($s_060,$ws,$_037__0,0);
 var $11=($10|0)==-1;
 if($11){label=5;break;}else{label=6;break;}
 case 5: 
 var $_pr_pre=HEAP32[(($ws)>>2)];
 var $cnt_1=-1;var $_1=$9;var $_239=0;var $s_053=$s_060;var $22=$_pr_pre;label=9;break;
 case 6: 
 var $13=($s_060|0)==($5|0);
 if($13){var $s_1=$5;var $_138=$_03757;label=8;break;}else{label=7;break;}
 case 7: 
 var $15=(($s_060+$10)|0);
 var $16=((($_03757)-($10))|0);
 var $s_1=$15;var $_138=$16;label=8;break;
 case 8: 
 var $_138;
 var $s_1;
 var $18=((($10)+($cnt_059))|0);
 var $19=HEAP32[(($ws)>>2)];
 var $20=($19|0)==0;
 var $21=($_138|0)==0;
 var $or_cond=$20|$21;
 if($or_cond){var $cnt_1=$18;var $_1=$9;var $_239=$_138;var $s_053=$s_1;var $22=$19;label=9;break;}else{var $_03757=$_138;var $_058=$9;var $cnt_059=$18;var $s_060=$s_1;var $_pr75=$19;label=3;break;}
 case 9: 
 var $22;
 var $s_053;
 var $_239;
 var $_1;
 var $cnt_1;
 var $23=($22|0)==0;
 if($23){var $cnt_3=$cnt_1;label=15;break;}else{label=10;break;}
 case 10: 
 var $24=($_239|0)==0;
 var $25=($_1|0)==0;
 var $or_cond4143=$24|$25;
 if($or_cond4143){var $cnt_3=$cnt_1;label=15;break;}else{var $_344=$_239;var $_245=$_1;var $cnt_246=$cnt_1;var $s_247=$s_053;var $26=$22;label=11;break;}
 case 11: 
 var $26;
 var $s_247;
 var $cnt_246;
 var $_245;
 var $_344;
 var $27=HEAP32[(($26)>>2)];
 var $28=_wcrtomb($s_247,$27,0);
 var $29=((($28)+(1))|0);
 var $30=($29>>>0)<2;
 if($30){label=12;break;}else{label=14;break;}
 case 12: 
 var $32=($28|0)==0;
 if($32){label=13;break;}else{var $cnt_3=-1;label=15;break;}
 case 13: 
 HEAP32[(($ws)>>2)]=0;
 var $cnt_3=$cnt_246;label=15;break;
 case 14: 
 var $35=HEAP32[(($ws)>>2)];
 var $36=(($35+4)|0);
 HEAP32[(($ws)>>2)]=$36;
 var $37=((($_245)-(1))|0);
 var $38=(($s_247+$28)|0);
 var $39=((($_344)-($28))|0);
 var $40=((($cnt_246)+(1))|0);
 var $41=($_344|0)==($28|0);
 var $42=($37|0)==0;
 var $or_cond41=$41|$42;
 if($or_cond41){var $cnt_3=$40;label=15;break;}else{var $_344=$39;var $_245=$37;var $cnt_246=$40;var $s_247=$38;var $26=$36;label=11;break;}
 case 15: 
 var $cnt_3;
 if($1){label=16;break;}else{label=17;break;}
 case 16: 
 var $44=HEAP32[(($ws)>>2)];
 HEAP32[(($wcs)>>2)]=$44;
 label=17;break;
 case 17: 
 STACKTOP=sp;return $cnt_3;
  default: assert(0, "bad label: " + label);
 }

}


function _wcsrtombs($s,$ws,$n,$st){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+8)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $buf=sp;
 var $1=($s|0)==0;
 if($1){label=4;break;}else{label=2;break;}
 case 2: 
 var $2=($n>>>0)>3;
 if($2){label=3;break;}else{var $_252_lcssa=$n;var $_049_lcssa=$s;label=9;break;}
 case 3: 
 var $_pre88=HEAP32[(($ws)>>2)];
 var $_25272=$n;var $_04973=$s;var $18=$_pre88;label=8;break;
 case 4: 
 var $4=HEAP32[(($ws)>>2)];
 var $5=(($buf)|0);
 var $6=HEAP32[(($4)>>2)];
 var $7=($6|0)==0;
 if($7){var $_0=0;label=26;break;}else{var $_05055=0;var $ws2_056=$4;var $8=$6;label=5;break;}
 case 5: 
 var $8;
 var $ws2_056;
 var $_05055;
 var $9=($8>>>0)>127;
 if($9){label=6;break;}else{var $_pn=1;label=7;break;}
 case 6: 
 var $11=_wcrtomb($5,$8,0);
 var $12=($11|0)==-1;
 if($12){var $_0=-1;label=26;break;}else{var $_pn=$11;label=7;break;}
 case 7: 
 var $_pn;
 var $_151=((($_pn)+($_05055))|0);
 var $14=(($ws2_056+4)|0);
 var $15=HEAP32[(($14)>>2)];
 var $16=($15|0)==0;
 if($16){var $_0=$_151;label=26;break;}else{var $_05055=$_151;var $ws2_056=$14;var $8=$15;label=5;break;}
 case 8: 
 var $18;
 var $_04973;
 var $_25272;
 var $19=HEAP32[(($18)>>2)];
 var $20=($19|0)==0;
 if($20){var $_252_lcssa=$_25272;var $_049_lcssa=$_04973;label=9;break;}else{label=11;break;}
 case 9: 
 var $_049_lcssa;
 var $_252_lcssa;
 var $21=($_252_lcssa|0)==0;
 if($21){var $_461=0;label=25;break;}else{label=10;break;}
 case 10: 
 var $22=(($buf)|0);
 var $_pre=HEAP32[(($ws)>>2)];
 var $_465=$_252_lcssa;var $_266=$_049_lcssa;var $40=$_pre;label=16;break;
 case 11: 
 var $24=($19>>>0)>127;
 if($24){label=12;break;}else{label=14;break;}
 case 12: 
 var $26=_wcrtomb($_04973,$19,0);
 var $27=($26|0)==-1;
 if($27){var $_0=-1;label=26;break;}else{label=13;break;}
 case 13: 
 var $29=(($_04973+$26)|0);
 var $30=((($_25272)-($26))|0);
 var $_1=$29;var $_353=$30;var $36=$18;label=15;break;
 case 14: 
 var $32=(($19)&255);
 var $33=(($_04973+1)|0);
 HEAP8[($_04973)]=$32;
 var $34=((($_25272)-(1))|0);
 var $_pre89=HEAP32[(($ws)>>2)];
 var $_1=$33;var $_353=$34;var $36=$_pre89;label=15;break;
 case 15: 
 var $36;
 var $_353;
 var $_1;
 var $37=(($36+4)|0);
 HEAP32[(($ws)>>2)]=$37;
 var $38=($_353>>>0)>3;
 if($38){var $_25272=$_353;var $_04973=$_1;var $18=$37;label=8;break;}else{var $_252_lcssa=$_353;var $_049_lcssa=$_1;label=9;break;}
 case 16: 
 var $40;
 var $_266;
 var $_465;
 var $41=HEAP32[(($40)>>2)];
 var $42=($41|0)==0;
 if($42){label=24;break;}else{label=17;break;}
 case 17: 
 var $44=($41>>>0)>127;
 if($44){label=18;break;}else{label=22;break;}
 case 18: 
 var $46=_wcrtomb($22,$41,0);
 var $47=($46|0)==-1;
 if($47){var $_0=-1;label=26;break;}else{label=19;break;}
 case 19: 
 var $49=($46>>>0)>($_465>>>0);
 if($49){label=20;break;}else{label=21;break;}
 case 20: 
 var $51=((($n)-($_465))|0);
 var $_0=$51;label=26;break;
 case 21: 
 var $53=HEAP32[(($40)>>2)];
 var $54=_wcrtomb($_266,$53,0);
 var $55=(($_266+$46)|0);
 var $56=((($_465)-($46))|0);
 var $_3=$55;var $_5=$56;var $61=$40;label=23;break;
 case 22: 
 var $58=(($41)&255);
 var $59=(($_266+1)|0);
 HEAP8[($_266)]=$58;
 var $60=((($_465)-(1))|0);
 var $_pre87=HEAP32[(($ws)>>2)];
 var $_3=$59;var $_5=$60;var $61=$_pre87;label=23;break;
 case 23: 
 var $61;
 var $_5;
 var $_3;
 var $62=(($61+4)|0);
 HEAP32[(($ws)>>2)]=$62;
 var $63=($_5|0)==0;
 if($63){var $_461=0;label=25;break;}else{var $_465=$_5;var $_266=$_3;var $40=$62;label=16;break;}
 case 24: 
 HEAP8[($_266)]=0;
 var $_461=$_465;label=25;break;
 case 25: 
 var $_461;
 HEAP32[(($ws)>>2)]=0;
 var $65=((($n)-($_461))|0);
 var $_0=$65;label=26;break;
 case 26: 
 var $_0;
 STACKTOP=sp;return $_0;
  default: assert(0, "bad label: " + label);
 }

}


function _wcslen($s){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $_0=$s;label=2;break;
 case 2: 
 var $_0;
 var $2=HEAP32[(($_0)>>2)];
 var $3=($2|0)==0;
 var $4=(($_0+4)|0);
 if($3){label=3;break;}else{var $_0=$4;label=2;break;}
 case 3: 
 var $6=$_0;
 var $7=$s;
 var $8=((($6)-($7))|0);
 var $9=$8>>2;
 return $9;
  default: assert(0, "bad label: " + label);
 }

}


function _wmemcpy($d,$s,$n){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=($n|0)==0;
 if($1){label=3;break;}else{var $_056=$s;var $_047=$n;var $_08=$d;label=2;break;}
 case 2: 
 var $_08;
 var $_047;
 var $_056;
 var $2=((($_047)-(1))|0);
 var $3=(($_056+4)|0);
 var $4=HEAP32[(($_056)>>2)];
 var $5=(($_08+4)|0);
 HEAP32[(($_08)>>2)]=$4;
 var $6=($2|0)==0;
 if($6){label=3;break;}else{var $_056=$3;var $_047=$2;var $_08=$5;label=2;break;}
 case 3: 
 return $d;
  default: assert(0, "bad label: " + label);
 }

}


function _wmemmove($d,$s,$n){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=$d;
 var $2=$s;
 var $3=((($1)-($2))|0);
 var $4=$3>>2;
 var $5=($4>>>0)<($n>>>0);
 var $6=($n|0)==0;
 if($5){label=3;break;}else{label=2;break;}
 case 2: 
 if($6){label=6;break;}else{var $_01316=$s;var $_117=$n;var $_018=$d;label=5;break;}
 case 3: 
 if($6){label=6;break;}else{var $_in=$n;label=4;break;}
 case 4: 
 var $_in;
 var $7=((($_in)-(1))|0);
 var $8=(($s+($7<<2))|0);
 var $9=HEAP32[(($8)>>2)];
 var $10=(($d+($7<<2))|0);
 HEAP32[(($10)>>2)]=$9;
 var $11=($7|0)==0;
 if($11){label=6;break;}else{var $_in=$7;label=4;break;}
 case 5: 
 var $_018;
 var $_117;
 var $_01316;
 var $12=((($_117)-(1))|0);
 var $13=(($_01316+4)|0);
 var $14=HEAP32[(($_01316)>>2)];
 var $15=(($_018+4)|0);
 HEAP32[(($_018)>>2)]=$14;
 var $16=($12|0)==0;
 if($16){label=6;break;}else{var $_01316=$13;var $_117=$12;var $_018=$15;label=5;break;}
 case 6: 
 return $d;
  default: assert(0, "bad label: " + label);
 }

}


function _wmemset($d,$c,$n){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=($n|0)==0;
 if($1){label=3;break;}else{var $_045=$n;var $_06=$d;label=2;break;}
 case 2: 
 var $_06;
 var $_045;
 var $2=((($_045)-(1))|0);
 var $3=(($_06+4)|0);
 HEAP32[(($_06)>>2)]=$c;
 var $4=($2|0)==0;
 if($4){label=3;break;}else{var $_045=$2;var $_06=$3;label=2;break;}
 case 3: 
 return $d;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNSt9type_infoD2Ev($this){
 var label=0;


 return;
}


function __ZNSt8bad_castC2Ev($this){
 var label=0;


 var $1=(($this)|0);
 HEAP32[(($1)>>2)]=2960;
 return;
}


function __ZNSt8bad_castD0Ev($this){
 var label=0;


 var $1=(($this)|0);

 var $2=$this;
 __ZdlPv($2);
 return;
}


function __ZNSt8bad_castD2Ev($this){
 var label=0;


 var $1=(($this)|0);

 return;
}


function __ZNKSt8bad_cast4whatEv($this){
 var label=0;


 return 1280;
}


function __ZN10__cxxabiv116__shim_type_infoD2Ev($this){
 var label=0;


 var $1=(($this)|0);
 __ZNSt9type_infoD2Ev($1);
 return;
}


function __ZNK10__cxxabiv116__shim_type_info5noop1Ev($this){
 var label=0;


 return;
}


function __ZNK10__cxxabiv116__shim_type_info5noop2Ev($this){
 var label=0;


 return;
}


function __ZN10__cxxabiv117__class_type_infoD0Ev($this){
 var label=0;


 var $1=(($this)|0);
 __ZNSt9type_infoD2Ev($1);
 var $2=$this;
 __ZdlPv($2);
 return;
}


function __ZN10__cxxabiv120__si_class_type_infoD0Ev($this){
 var label=0;


 var $1=(($this)|0);
 __ZNSt9type_infoD2Ev($1);
 var $2=$this;
 __ZdlPv($2);
 return;
}


function __ZN10__cxxabiv121__vmi_class_type_infoD0Ev($this){
 var label=0;


 var $1=(($this)|0);
 __ZNSt9type_infoD2Ev($1);
 var $2=$this;
 __ZdlPv($2);
 return;
}


function __ZNK10__cxxabiv117__class_type_info9can_catchEPKNS_16__shim_type_infoERPv($this,$thrown_type,$adjustedPtr){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+56)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $info=sp;
 var $1=(($this)|0);
 var $2=(($thrown_type)|0);
 var $3=($1|0)==($2|0);
 if($3){var $_0=1;label=6;break;}else{label=2;break;}
 case 2: 
 var $5=($thrown_type|0)==0;
 if($5){var $_0=0;label=6;break;}else{label=3;break;}
 case 3: 
 var $7=$thrown_type;
 var $8=___dynamic_cast($7,10536,10520,-1);
 var $9=$8;
 var $10=($8|0)==0;
 if($10){var $_0=0;label=6;break;}else{label=4;break;}
 case 4: 
 var $12=$info;
 _memset($12, 0, 56)|0;
 var $13=(($info)|0);
 HEAP32[(($13)>>2)]=$9;
 var $14=(($info+8)|0);
 HEAP32[(($14)>>2)]=$this;
 var $15=(($info+12)|0);
 HEAP32[(($15)>>2)]=-1;
 var $16=(($info+48)|0);
 HEAP32[(($16)>>2)]=1;
 var $17=$8;
 var $18=HEAP32[(($17)>>2)];
 var $19=(($18+28)|0);
 var $20=HEAP32[(($19)>>2)];
 var $21=HEAP32[(($adjustedPtr)>>2)];
 FUNCTION_TABLE[$20]($9,$info,$21,1);
 var $22=(($info+24)|0);
 var $23=HEAP32[(($22)>>2)];
 var $24=($23|0)==1;
 if($24){label=5;break;}else{var $_0=0;label=6;break;}
 case 5: 
 var $26=(($info+16)|0);
 var $27=HEAP32[(($26)>>2)];
 HEAP32[(($adjustedPtr)>>2)]=$27;
 var $_0=1;label=6;break;
 case 6: 
 var $_0;
 STACKTOP=sp;return $_0;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNK10__cxxabiv117__class_type_info27has_unambiguous_public_baseEPNS_19__dynamic_cast_infoEPvi($this,$info,$adjustedPtr,$path_below){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=(($info+8)|0);
 var $2=HEAP32[(($1)>>2)];
 var $3=($2|0)==($this|0);
 if($3){label=2;break;}else{label=8;break;}
 case 2: 
 var $5=(($info+16)|0);
 var $6=HEAP32[(($5)>>2)];
 var $7=($6|0)==0;
 if($7){label=3;break;}else{label=4;break;}
 case 3: 
 HEAP32[(($5)>>2)]=$adjustedPtr;
 var $9=(($info+24)|0);
 HEAP32[(($9)>>2)]=$path_below;
 var $10=(($info+36)|0);
 HEAP32[(($10)>>2)]=1;
 label=8;break;
 case 4: 
 var $12=($6|0)==($adjustedPtr|0);
 if($12){label=5;break;}else{label=7;break;}
 case 5: 
 var $14=(($info+24)|0);
 var $15=HEAP32[(($14)>>2)];
 var $16=($15|0)==2;
 if($16){label=6;break;}else{label=8;break;}
 case 6: 
 HEAP32[(($14)>>2)]=$path_below;
 label=8;break;
 case 7: 
 var $19=(($info+36)|0);
 var $20=HEAP32[(($19)>>2)];
 var $21=((($20)+(1))|0);
 HEAP32[(($19)>>2)]=$21;
 var $22=(($info+24)|0);
 HEAP32[(($22)>>2)]=2;
 var $23=(($info+54)|0);
 HEAP8[($23)]=1;
 label=8;break;
 case 8: 
 return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNK10__cxxabiv120__si_class_type_info27has_unambiguous_public_baseEPNS_19__dynamic_cast_infoEPvi($this,$info,$adjustedPtr,$path_below){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=(($this)|0);
 var $2=(($info+8)|0);
 var $3=HEAP32[(($2)>>2)];
 var $4=(($3)|0);
 var $5=($1|0)==($4|0);
 if($5){label=2;break;}else{label=8;break;}
 case 2: 
 var $7=(($info+16)|0);
 var $8=HEAP32[(($7)>>2)];
 var $9=($8|0)==0;
 if($9){label=3;break;}else{label=4;break;}
 case 3: 
 HEAP32[(($7)>>2)]=$adjustedPtr;
 var $11=(($info+24)|0);
 HEAP32[(($11)>>2)]=$path_below;
 var $12=(($info+36)|0);
 HEAP32[(($12)>>2)]=1;
 label=9;break;
 case 4: 
 var $14=($8|0)==($adjustedPtr|0);
 if($14){label=5;break;}else{label=7;break;}
 case 5: 
 var $16=(($info+24)|0);
 var $17=HEAP32[(($16)>>2)];
 var $18=($17|0)==2;
 if($18){label=6;break;}else{label=9;break;}
 case 6: 
 HEAP32[(($16)>>2)]=$path_below;
 label=9;break;
 case 7: 
 var $21=(($info+36)|0);
 var $22=HEAP32[(($21)>>2)];
 var $23=((($22)+(1))|0);
 HEAP32[(($21)>>2)]=$23;
 var $24=(($info+24)|0);
 HEAP32[(($24)>>2)]=2;
 var $25=(($info+54)|0);
 HEAP8[($25)]=1;
 label=9;break;
 case 8: 
 var $27=(($this+8)|0);
 var $28=HEAP32[(($27)>>2)];
 var $29=$28;
 var $30=HEAP32[(($29)>>2)];
 var $31=(($30+28)|0);
 var $32=HEAP32[(($31)>>2)];
 FUNCTION_TABLE[$32]($28,$info,$adjustedPtr,$path_below);
 label=9;break;
 case 9: 
 return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNK10__cxxabiv121__vmi_class_type_info27has_unambiguous_public_baseEPNS_19__dynamic_cast_infoEPvi($this,$info,$adjustedPtr,$path_below){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=(($this)|0);
 var $2=(($info+8)|0);
 var $3=HEAP32[(($2)>>2)];
 var $4=(($3)|0);
 var $5=($1|0)==($4|0);
 if($5){label=2;break;}else{label=8;break;}
 case 2: 
 var $7=(($info+16)|0);
 var $8=HEAP32[(($7)>>2)];
 var $9=($8|0)==0;
 if($9){label=3;break;}else{label=4;break;}
 case 3: 
 HEAP32[(($7)>>2)]=$adjustedPtr;
 var $11=(($info+24)|0);
 HEAP32[(($11)>>2)]=$path_below;
 var $12=(($info+36)|0);
 HEAP32[(($12)>>2)]=1;
 label=16;break;
 case 4: 
 var $14=($8|0)==($adjustedPtr|0);
 if($14){label=5;break;}else{label=7;break;}
 case 5: 
 var $16=(($info+24)|0);
 var $17=HEAP32[(($16)>>2)];
 var $18=($17|0)==2;
 if($18){label=6;break;}else{label=16;break;}
 case 6: 
 HEAP32[(($16)>>2)]=$path_below;
 label=16;break;
 case 7: 
 var $21=(($info+36)|0);
 var $22=HEAP32[(($21)>>2)];
 var $23=((($22)+(1))|0);
 HEAP32[(($21)>>2)]=$23;
 var $24=(($info+24)|0);
 HEAP32[(($24)>>2)]=2;
 var $25=(($info+54)|0);
 HEAP8[($25)]=1;
 label=16;break;
 case 8: 
 var $27=(($this+12)|0);
 var $28=HEAP32[(($27)>>2)];
 var $29=(($this+16+($28<<3))|0);
 var $30=(($this+20)|0);
 var $31=HEAP32[(($30)>>2)];
 var $32=$31>>8;
 var $33=$31&1;
 var $34=($33|0)==0;
 if($34){var $offset_to_base_0_i16=$32;label=10;break;}else{label=9;break;}
 case 9: 
 var $36=$adjustedPtr;
 var $37=HEAP32[(($36)>>2)];
 var $38=(($37+$32)|0);
 var $39=$38;
 var $40=HEAP32[(($39)>>2)];
 var $offset_to_base_0_i16=$40;label=10;break;
 case 10: 
 var $offset_to_base_0_i16;
 var $41=(($this+16)|0);
 var $42=HEAP32[(($41)>>2)];
 var $43=$42;
 var $44=HEAP32[(($43)>>2)];
 var $45=(($44+28)|0);
 var $46=HEAP32[(($45)>>2)];
 var $47=(($adjustedPtr+$offset_to_base_0_i16)|0);
 var $48=$31&2;
 var $49=($48|0)!=0;
 var $50=($49?$path_below:2);
 FUNCTION_TABLE[$46]($42,$info,$47,$50);
 var $51=($28|0)>1;
 if($51){label=11;break;}else{label=16;break;}
 case 11: 
 var $52=(($this+24)|0);
 var $53=(($info+54)|0);
 var $54=$adjustedPtr;
 var $p_0=$52;label=12;break;
 case 12: 
 var $p_0;
 var $56=(($p_0+4)|0);
 var $57=HEAP32[(($56)>>2)];
 var $58=$57>>8;
 var $59=$57&1;
 var $60=($59|0)==0;
 if($60){var $offset_to_base_0_i=$58;label=14;break;}else{label=13;break;}
 case 13: 
 var $62=HEAP32[(($54)>>2)];
 var $63=(($62+$58)|0);
 var $64=$63;
 var $65=HEAP32[(($64)>>2)];
 var $offset_to_base_0_i=$65;label=14;break;
 case 14: 
 var $offset_to_base_0_i;
 var $66=(($p_0)|0);
 var $67=HEAP32[(($66)>>2)];
 var $68=$67;
 var $69=HEAP32[(($68)>>2)];
 var $70=(($69+28)|0);
 var $71=HEAP32[(($70)>>2)];
 var $72=(($adjustedPtr+$offset_to_base_0_i)|0);
 var $73=$57&2;
 var $74=($73|0)!=0;
 var $75=($74?$path_below:2);
 FUNCTION_TABLE[$71]($67,$info,$72,$75);
 var $76=HEAP8[($53)];
 var $77=(($76<<24)>>24)==0;
 if($77){label=15;break;}else{label=16;break;}
 case 15: 
 var $79=(($p_0+8)|0);
 var $80=($79>>>0)<($29>>>0);
 if($80){var $p_0=$79;label=12;break;}else{label=16;break;}
 case 16: 
 return;
  default: assert(0, "bad label: " + label);
 }

}


function ___dynamic_cast($static_ptr,$static_type,$dst_type,$src2dst_offset){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+56)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $info=sp;
 var $1=$static_ptr;
 var $2=HEAP32[(($1)>>2)];
 var $3=((($2)-(8))|0);
 var $4=HEAP32[(($3)>>2)];
 var $5=$4;
 var $6=(($static_ptr+$5)|0);
 var $7=((($2)-(4))|0);
 var $8=HEAP32[(($7)>>2)];
 var $9=$8;
 var $10=(($info)|0);
 HEAP32[(($10)>>2)]=$dst_type;
 var $11=(($info+4)|0);
 HEAP32[(($11)>>2)]=$static_ptr;
 var $12=(($info+8)|0);
 HEAP32[(($12)>>2)]=$static_type;
 var $13=(($info+12)|0);
 HEAP32[(($13)>>2)]=$src2dst_offset;
 var $14=(($info+16)|0);
 var $15=(($info+20)|0);
 var $16=(($info+24)|0);
 var $17=(($info+28)|0);
 var $18=(($info+32)|0);
 var $19=(($info+40)|0);
 var $20=$8;
 var $21=(($dst_type)|0);
 var $22=($20|0)==($21|0);
 var $23=$14;
 _memset($23, 0, 39)|0;
 if($22){label=2;break;}else{label=3;break;}
 case 2: 
 var $25=(($info+48)|0);
 HEAP32[(($25)>>2)]=1;
 var $26=$8;
 var $27=HEAP32[(($26)>>2)];
 var $28=(($27+20)|0);
 var $29=HEAP32[(($28)>>2)];
 FUNCTION_TABLE[$29]($9,$info,$6,$6,1,0);
 var $30=HEAP32[(($16)>>2)];
 var $31=($30|0)==1;
 var $_=($31?$6:0);
 STACKTOP=sp;return $_;
 case 3: 
 var $33=(($info+36)|0);
 var $34=$8;
 var $35=HEAP32[(($34)>>2)];
 var $36=(($35+24)|0);
 var $37=HEAP32[(($36)>>2)];
 FUNCTION_TABLE[$37]($9,$info,$6,1,0);
 var $38=HEAP32[(($33)>>2)];
 if(($38|0)==0){ label=4;break;}else if(($38|0)==1){ label=7;break;}else{var $dst_ptr_0=0;label=12;break;}
 case 4: 
 var $40=HEAP32[(($19)>>2)];
 var $41=($40|0)==1;
 if($41){label=5;break;}else{var $dst_ptr_0=0;label=12;break;}
 case 5: 
 var $43=HEAP32[(($17)>>2)];
 var $44=($43|0)==1;
 if($44){label=6;break;}else{var $dst_ptr_0=0;label=12;break;}
 case 6: 
 var $46=HEAP32[(($18)>>2)];
 var $47=($46|0)==1;
 var $48=HEAP32[(($15)>>2)];
 var $_13=($47?$48:0);
 var $dst_ptr_0=$_13;label=12;break;
 case 7: 
 var $50=HEAP32[(($16)>>2)];
 var $51=($50|0)==1;
 if($51){label=11;break;}else{label=8;break;}
 case 8: 
 var $53=HEAP32[(($19)>>2)];
 var $54=($53|0)==0;
 if($54){label=9;break;}else{var $dst_ptr_0=0;label=12;break;}
 case 9: 
 var $56=HEAP32[(($17)>>2)];
 var $57=($56|0)==1;
 if($57){label=10;break;}else{var $dst_ptr_0=0;label=12;break;}
 case 10: 
 var $59=HEAP32[(($18)>>2)];
 var $60=($59|0)==1;
 if($60){label=11;break;}else{var $dst_ptr_0=0;label=12;break;}
 case 11: 
 var $62=HEAP32[(($14)>>2)];
 var $dst_ptr_0=$62;label=12;break;
 case 12: 
 var $dst_ptr_0;
 STACKTOP=sp;return $dst_ptr_0;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNK10__cxxabiv121__vmi_class_type_info16search_below_dstEPNS_19__dynamic_cast_infoEPKvib($this,$info,$current_ptr,$path_below,$use_strcmp){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=(($this)|0);
 var $2=(($info+8)|0);
 var $3=HEAP32[(($2)>>2)];
 var $4=(($3)|0);
 var $5=($1|0)==($4|0);
 if($5){label=2;break;}else{label=5;break;}
 case 2: 
 var $7=(($info+4)|0);
 var $8=HEAP32[(($7)>>2)];
 var $9=($8|0)==($current_ptr|0);
 if($9){label=3;break;}else{label=53;break;}
 case 3: 
 var $11=(($info+28)|0);
 var $12=HEAP32[(($11)>>2)];
 var $13=($12|0)==1;
 if($13){label=53;break;}else{label=4;break;}
 case 4: 
 HEAP32[(($11)>>2)]=$path_below;
 label=53;break;
 case 5: 
 var $16=(($info)|0);
 var $17=HEAP32[(($16)>>2)];
 var $18=(($17)|0);
 var $19=($1|0)==($18|0);
 if($19){label=6;break;}else{label=29;break;}
 case 6: 
 var $21=(($info+16)|0);
 var $22=HEAP32[(($21)>>2)];
 var $23=($22|0)==($current_ptr|0);
 if($23){label=8;break;}else{label=7;break;}
 case 7: 
 var $25=(($info+20)|0);
 var $26=HEAP32[(($25)>>2)];
 var $27=($26|0)==($current_ptr|0);
 if($27){label=8;break;}else{label=10;break;}
 case 8: 
 var $29=($path_below|0)==1;
 if($29){label=9;break;}else{label=53;break;}
 case 9: 
 var $31=(($info+32)|0);
 HEAP32[(($31)>>2)]=1;
 label=53;break;
 case 10: 
 var $33=(($info+32)|0);
 HEAP32[(($33)>>2)]=$path_below;
 var $34=(($info+44)|0);
 var $35=HEAP32[(($34)>>2)];
 var $36=($35|0)==4;
 if($36){label=53;break;}else{label=11;break;}
 case 11: 
 var $38=(($this+12)|0);
 var $39=HEAP32[(($38)>>2)];
 var $40=(($this+16+($39<<3))|0);
 var $41=($39|0)>0;
 if($41){label=12;break;}else{var $is_dst_type_derived_from_static_type_2_off098=0;label=23;break;}
 case 12: 
 var $42=(($this+16)|0);
 var $43=(($info+52)|0);
 var $44=(($info+53)|0);
 var $45=(($info+54)|0);
 var $46=(($this+8)|0);
 var $47=(($info+24)|0);
 var $48=$current_ptr;
 var $does_dst_type_point_to_our_static_type_0_off087=0;var $p_088=$42;var $is_dst_type_derived_from_static_type_0_off089=0;label=13;break;
 case 13: 
 var $is_dst_type_derived_from_static_type_0_off089;
 var $p_088;
 var $does_dst_type_point_to_our_static_type_0_off087;
 HEAP8[($43)]=0;
 HEAP8[($44)]=0;
 var $50=(($p_088+4)|0);
 var $51=HEAP32[(($50)>>2)];
 var $52=$51>>8;
 var $53=$51&1;
 var $54=($53|0)==0;
 if($54){var $offset_to_base_0_i81=$52;label=15;break;}else{label=14;break;}
 case 14: 
 var $56=HEAP32[(($48)>>2)];
 var $57=(($56+$52)|0);
 var $58=$57;
 var $59=HEAP32[(($58)>>2)];
 var $offset_to_base_0_i81=$59;label=15;break;
 case 15: 
 var $offset_to_base_0_i81;
 var $60=(($p_088)|0);
 var $61=HEAP32[(($60)>>2)];
 var $62=$61;
 var $63=HEAP32[(($62)>>2)];
 var $64=(($63+20)|0);
 var $65=HEAP32[(($64)>>2)];
 var $66=(($current_ptr+$offset_to_base_0_i81)|0);
 var $67=$51>>>1;
 var $68=$67&1;
 var $69=(((2)-($68))|0);
 FUNCTION_TABLE[$65]($61,$info,$current_ptr,$66,$69,$use_strcmp);
 var $70=HEAP8[($45)];
 var $71=(($70<<24)>>24)==0;
 if($71){label=16;break;}else{var $is_dst_type_derived_from_static_type_2_off0=$is_dst_type_derived_from_static_type_0_off089;var $does_dst_type_point_to_our_static_type_0_off0_lcssa=$does_dst_type_point_to_our_static_type_0_off087;label=22;break;}
 case 16: 
 var $73=HEAP8[($44)];
 var $74=(($73<<24)>>24)==0;
 if($74){var $is_dst_type_derived_from_static_type_1_off0=$is_dst_type_derived_from_static_type_0_off089;var $does_dst_type_point_to_our_static_type_1_off0=$does_dst_type_point_to_our_static_type_0_off087;label=21;break;}else{label=17;break;}
 case 17: 
 var $76=HEAP8[($43)];
 var $77=(($76<<24)>>24)==0;
 if($77){label=20;break;}else{label=18;break;}
 case 18: 
 var $79=HEAP32[(($47)>>2)];
 var $80=($79|0)==1;
 if($80){label=27;break;}else{label=19;break;}
 case 19: 
 var $82=HEAP32[(($46)>>2)];
 var $83=$82&2;
 var $84=($83|0)==0;
 if($84){label=27;break;}else{var $is_dst_type_derived_from_static_type_1_off0=1;var $does_dst_type_point_to_our_static_type_1_off0=1;label=21;break;}
 case 20: 
 var $86=HEAP32[(($46)>>2)];
 var $87=$86&1;
 var $88=($87|0)==0;
 if($88){var $is_dst_type_derived_from_static_type_2_off0=1;var $does_dst_type_point_to_our_static_type_0_off0_lcssa=$does_dst_type_point_to_our_static_type_0_off087;label=22;break;}else{var $is_dst_type_derived_from_static_type_1_off0=1;var $does_dst_type_point_to_our_static_type_1_off0=$does_dst_type_point_to_our_static_type_0_off087;label=21;break;}
 case 21: 
 var $does_dst_type_point_to_our_static_type_1_off0;
 var $is_dst_type_derived_from_static_type_1_off0;
 var $90=(($p_088+8)|0);
 var $91=($90>>>0)<($40>>>0);
 if($91){var $does_dst_type_point_to_our_static_type_0_off087=$does_dst_type_point_to_our_static_type_1_off0;var $p_088=$90;var $is_dst_type_derived_from_static_type_0_off089=$is_dst_type_derived_from_static_type_1_off0;label=13;break;}else{var $is_dst_type_derived_from_static_type_2_off0=$is_dst_type_derived_from_static_type_1_off0;var $does_dst_type_point_to_our_static_type_0_off0_lcssa=$does_dst_type_point_to_our_static_type_1_off0;label=22;break;}
 case 22: 
 var $does_dst_type_point_to_our_static_type_0_off0_lcssa;
 var $is_dst_type_derived_from_static_type_2_off0;
 if($does_dst_type_point_to_our_static_type_0_off0_lcssa){var $is_dst_type_derived_from_static_type_2_off099=$is_dst_type_derived_from_static_type_2_off0;label=26;break;}else{var $is_dst_type_derived_from_static_type_2_off098=$is_dst_type_derived_from_static_type_2_off0;label=23;break;}
 case 23: 
 var $is_dst_type_derived_from_static_type_2_off098;
 HEAP32[(($25)>>2)]=$current_ptr;
 var $92=(($info+40)|0);
 var $93=HEAP32[(($92)>>2)];
 var $94=((($93)+(1))|0);
 HEAP32[(($92)>>2)]=$94;
 var $95=(($info+36)|0);
 var $96=HEAP32[(($95)>>2)];
 var $97=($96|0)==1;
 if($97){label=24;break;}else{var $is_dst_type_derived_from_static_type_2_off099=$is_dst_type_derived_from_static_type_2_off098;label=26;break;}
 case 24: 
 var $99=(($info+24)|0);
 var $100=HEAP32[(($99)>>2)];
 var $101=($100|0)==2;
 if($101){label=25;break;}else{var $is_dst_type_derived_from_static_type_2_off099=$is_dst_type_derived_from_static_type_2_off098;label=26;break;}
 case 25: 
 var $103=(($info+54)|0);
 HEAP8[($103)]=1;
 if($is_dst_type_derived_from_static_type_2_off098){label=27;break;}else{label=28;break;}
 case 26: 
 var $is_dst_type_derived_from_static_type_2_off099;
 if($is_dst_type_derived_from_static_type_2_off099){label=27;break;}else{label=28;break;}
 case 27: 
 HEAP32[(($34)>>2)]=3;
 label=53;break;
 case 28: 
 HEAP32[(($34)>>2)]=4;
 label=53;break;
 case 29: 
 var $107=(($this+12)|0);
 var $108=HEAP32[(($107)>>2)];
 var $109=(($this+16+($108<<3))|0);
 var $110=(($this+20)|0);
 var $111=HEAP32[(($110)>>2)];
 var $112=$111>>8;
 var $113=$111&1;
 var $114=($113|0)==0;
 if($114){var $offset_to_base_0_i82=$112;label=31;break;}else{label=30;break;}
 case 30: 
 var $116=$current_ptr;
 var $117=HEAP32[(($116)>>2)];
 var $118=(($117+$112)|0);
 var $119=$118;
 var $120=HEAP32[(($119)>>2)];
 var $offset_to_base_0_i82=$120;label=31;break;
 case 31: 
 var $offset_to_base_0_i82;
 var $121=(($this+16)|0);
 var $122=HEAP32[(($121)>>2)];
 var $123=$122;
 var $124=HEAP32[(($123)>>2)];
 var $125=(($124+24)|0);
 var $126=HEAP32[(($125)>>2)];
 var $127=(($current_ptr+$offset_to_base_0_i82)|0);
 var $128=$111&2;
 var $129=($128|0)!=0;
 var $130=($129?$path_below:2);
 FUNCTION_TABLE[$126]($122,$info,$127,$130,$use_strcmp);
 var $131=(($this+24)|0);
 var $132=($108|0)>1;
 if($132){label=32;break;}else{label=53;break;}
 case 32: 
 var $134=(($this+8)|0);
 var $135=HEAP32[(($134)>>2)];
 var $136=$135&2;
 var $137=($136|0)==0;
 if($137){label=33;break;}else{label=34;break;}
 case 33: 
 var $139=(($info+36)|0);
 var $140=HEAP32[(($139)>>2)];
 var $141=($140|0)==1;
 if($141){label=34;break;}else{label=39;break;}
 case 34: 
 var $142=(($info+54)|0);
 var $143=$current_ptr;
 var $p2_0=$131;label=35;break;
 case 35: 
 var $p2_0;
 var $145=HEAP8[($142)];
 var $146=(($145<<24)>>24)==0;
 if($146){label=36;break;}else{label=53;break;}
 case 36: 
 var $148=(($p2_0+4)|0);
 var $149=HEAP32[(($148)>>2)];
 var $150=$149>>8;
 var $151=$149&1;
 var $152=($151|0)==0;
 if($152){var $offset_to_base_0_i79=$150;label=38;break;}else{label=37;break;}
 case 37: 
 var $154=HEAP32[(($143)>>2)];
 var $155=(($154+$150)|0);
 var $156=$155;
 var $157=HEAP32[(($156)>>2)];
 var $offset_to_base_0_i79=$157;label=38;break;
 case 38: 
 var $offset_to_base_0_i79;
 var $158=(($p2_0)|0);
 var $159=HEAP32[(($158)>>2)];
 var $160=$159;
 var $161=HEAP32[(($160)>>2)];
 var $162=(($161+24)|0);
 var $163=HEAP32[(($162)>>2)];
 var $164=(($current_ptr+$offset_to_base_0_i79)|0);
 var $165=$149&2;
 var $166=($165|0)!=0;
 var $167=($166?$path_below:2);
 FUNCTION_TABLE[$163]($159,$info,$164,$167,$use_strcmp);
 var $168=(($p2_0+8)|0);
 var $169=($168>>>0)<($109>>>0);
 if($169){var $p2_0=$168;label=35;break;}else{label=53;break;}
 case 39: 
 var $171=$135&1;
 var $172=($171|0)==0;
 if($172){label=41;break;}else{label=40;break;}
 case 40: 
 var $173=(($info+24)|0);
 var $174=(($info+54)|0);
 var $175=$current_ptr;
 var $p2_1=$131;label=42;break;
 case 41: 
 var $176=(($info+54)|0);
 var $177=$current_ptr;
 var $p2_2=$131;label=48;break;
 case 42: 
 var $p2_1;
 var $179=HEAP8[($174)];
 var $180=(($179<<24)>>24)==0;
 if($180){label=43;break;}else{label=53;break;}
 case 43: 
 var $182=HEAP32[(($139)>>2)];
 var $183=($182|0)==1;
 if($183){label=44;break;}else{label=45;break;}
 case 44: 
 var $185=HEAP32[(($173)>>2)];
 var $186=($185|0)==1;
 if($186){label=53;break;}else{label=45;break;}
 case 45: 
 var $188=(($p2_1+4)|0);
 var $189=HEAP32[(($188)>>2)];
 var $190=$189>>8;
 var $191=$189&1;
 var $192=($191|0)==0;
 if($192){var $offset_to_base_0_i77=$190;label=47;break;}else{label=46;break;}
 case 46: 
 var $194=HEAP32[(($175)>>2)];
 var $195=(($194+$190)|0);
 var $196=$195;
 var $197=HEAP32[(($196)>>2)];
 var $offset_to_base_0_i77=$197;label=47;break;
 case 47: 
 var $offset_to_base_0_i77;
 var $198=(($p2_1)|0);
 var $199=HEAP32[(($198)>>2)];
 var $200=$199;
 var $201=HEAP32[(($200)>>2)];
 var $202=(($201+24)|0);
 var $203=HEAP32[(($202)>>2)];
 var $204=(($current_ptr+$offset_to_base_0_i77)|0);
 var $205=$189&2;
 var $206=($205|0)!=0;
 var $207=($206?$path_below:2);
 FUNCTION_TABLE[$203]($199,$info,$204,$207,$use_strcmp);
 var $208=(($p2_1+8)|0);
 var $209=($208>>>0)<($109>>>0);
 if($209){var $p2_1=$208;label=42;break;}else{label=53;break;}
 case 48: 
 var $p2_2;
 var $211=HEAP8[($176)];
 var $212=(($211<<24)>>24)==0;
 if($212){label=49;break;}else{label=53;break;}
 case 49: 
 var $214=HEAP32[(($139)>>2)];
 var $215=($214|0)==1;
 if($215){label=53;break;}else{label=50;break;}
 case 50: 
 var $217=(($p2_2+4)|0);
 var $218=HEAP32[(($217)>>2)];
 var $219=$218>>8;
 var $220=$218&1;
 var $221=($220|0)==0;
 if($221){var $offset_to_base_0_i=$219;label=52;break;}else{label=51;break;}
 case 51: 
 var $223=HEAP32[(($177)>>2)];
 var $224=(($223+$219)|0);
 var $225=$224;
 var $226=HEAP32[(($225)>>2)];
 var $offset_to_base_0_i=$226;label=52;break;
 case 52: 
 var $offset_to_base_0_i;
 var $227=(($p2_2)|0);
 var $228=HEAP32[(($227)>>2)];
 var $229=$228;
 var $230=HEAP32[(($229)>>2)];
 var $231=(($230+24)|0);
 var $232=HEAP32[(($231)>>2)];
 var $233=(($current_ptr+$offset_to_base_0_i)|0);
 var $234=$218&2;
 var $235=($234|0)!=0;
 var $236=($235?$path_below:2);
 FUNCTION_TABLE[$232]($228,$info,$233,$236,$use_strcmp);
 var $237=(($p2_2+8)|0);
 var $238=($237>>>0)<($109>>>0);
 if($238){var $p2_2=$237;label=48;break;}else{label=53;break;}
 case 53: 
 return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNK10__cxxabiv120__si_class_type_info16search_below_dstEPNS_19__dynamic_cast_infoEPKvib($this,$info,$current_ptr,$path_below,$use_strcmp){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=(($this)|0);
 var $2=(($info+8)|0);
 var $3=HEAP32[(($2)>>2)];
 var $4=(($3)|0);
 var $5=($1|0)==($4|0);
 if($5){label=2;break;}else{label=5;break;}
 case 2: 
 var $7=(($info+4)|0);
 var $8=HEAP32[(($7)>>2)];
 var $9=($8|0)==($current_ptr|0);
 if($9){label=3;break;}else{label=20;break;}
 case 3: 
 var $11=(($info+28)|0);
 var $12=HEAP32[(($11)>>2)];
 var $13=($12|0)==1;
 if($13){label=20;break;}else{label=4;break;}
 case 4: 
 HEAP32[(($11)>>2)]=$path_below;
 label=20;break;
 case 5: 
 var $16=(($info)|0);
 var $17=HEAP32[(($16)>>2)];
 var $18=(($17)|0);
 var $19=($1|0)==($18|0);
 if($19){label=6;break;}else{label=19;break;}
 case 6: 
 var $21=(($info+16)|0);
 var $22=HEAP32[(($21)>>2)];
 var $23=($22|0)==($current_ptr|0);
 if($23){label=8;break;}else{label=7;break;}
 case 7: 
 var $25=(($info+20)|0);
 var $26=HEAP32[(($25)>>2)];
 var $27=($26|0)==($current_ptr|0);
 if($27){label=8;break;}else{label=10;break;}
 case 8: 
 var $29=($path_below|0)==1;
 if($29){label=9;break;}else{label=20;break;}
 case 9: 
 var $31=(($info+32)|0);
 HEAP32[(($31)>>2)]=1;
 label=20;break;
 case 10: 
 var $33=(($info+32)|0);
 HEAP32[(($33)>>2)]=$path_below;
 var $34=(($info+44)|0);
 var $35=HEAP32[(($34)>>2)];
 var $36=($35|0)==4;
 if($36){label=20;break;}else{label=11;break;}
 case 11: 
 var $38=(($info+52)|0);
 HEAP8[($38)]=0;
 var $39=(($info+53)|0);
 HEAP8[($39)]=0;
 var $40=(($this+8)|0);
 var $41=HEAP32[(($40)>>2)];
 var $42=$41;
 var $43=HEAP32[(($42)>>2)];
 var $44=(($43+20)|0);
 var $45=HEAP32[(($44)>>2)];
 FUNCTION_TABLE[$45]($41,$info,$current_ptr,$current_ptr,1,$use_strcmp);
 var $46=HEAP8[($39)];
 var $47=(($46<<24)>>24)==0;
 if($47){var $is_dst_type_derived_from_static_type_0_off036=0;label=13;break;}else{label=12;break;}
 case 12: 
 var $49=HEAP8[($38)];
 var $not_=(($49<<24)>>24)==0;
 if($not_){var $is_dst_type_derived_from_static_type_0_off036=1;label=13;break;}else{label=17;break;}
 case 13: 
 var $is_dst_type_derived_from_static_type_0_off036;
 HEAP32[(($25)>>2)]=$current_ptr;
 var $50=(($info+40)|0);
 var $51=HEAP32[(($50)>>2)];
 var $52=((($51)+(1))|0);
 HEAP32[(($50)>>2)]=$52;
 var $53=(($info+36)|0);
 var $54=HEAP32[(($53)>>2)];
 var $55=($54|0)==1;
 if($55){label=14;break;}else{label=16;break;}
 case 14: 
 var $57=(($info+24)|0);
 var $58=HEAP32[(($57)>>2)];
 var $59=($58|0)==2;
 if($59){label=15;break;}else{label=16;break;}
 case 15: 
 var $61=(($info+54)|0);
 HEAP8[($61)]=1;
 if($is_dst_type_derived_from_static_type_0_off036){label=17;break;}else{label=18;break;}
 case 16: 
 if($is_dst_type_derived_from_static_type_0_off036){label=17;break;}else{label=18;break;}
 case 17: 
 HEAP32[(($34)>>2)]=3;
 label=20;break;
 case 18: 
 HEAP32[(($34)>>2)]=4;
 label=20;break;
 case 19: 
 var $65=(($this+8)|0);
 var $66=HEAP32[(($65)>>2)];
 var $67=$66;
 var $68=HEAP32[(($67)>>2)];
 var $69=(($68+24)|0);
 var $70=HEAP32[(($69)>>2)];
 FUNCTION_TABLE[$70]($66,$info,$current_ptr,$path_below,$use_strcmp);
 label=20;break;
 case 20: 
 return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNK10__cxxabiv117__class_type_info16search_below_dstEPNS_19__dynamic_cast_infoEPKvib($this,$info,$current_ptr,$path_below,$use_strcmp){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=(($info+8)|0);
 var $2=HEAP32[(($1)>>2)];
 var $3=($2|0)==($this|0);
 if($3){label=2;break;}else{label=5;break;}
 case 2: 
 var $5=(($info+4)|0);
 var $6=HEAP32[(($5)>>2)];
 var $7=($6|0)==($current_ptr|0);
 if($7){label=3;break;}else{label=14;break;}
 case 3: 
 var $9=(($info+28)|0);
 var $10=HEAP32[(($9)>>2)];
 var $11=($10|0)==1;
 if($11){label=14;break;}else{label=4;break;}
 case 4: 
 HEAP32[(($9)>>2)]=$path_below;
 label=14;break;
 case 5: 
 var $14=(($info)|0);
 var $15=HEAP32[(($14)>>2)];
 var $16=($15|0)==($this|0);
 if($16){label=6;break;}else{label=14;break;}
 case 6: 
 var $18=(($info+16)|0);
 var $19=HEAP32[(($18)>>2)];
 var $20=($19|0)==($current_ptr|0);
 if($20){label=8;break;}else{label=7;break;}
 case 7: 
 var $22=(($info+20)|0);
 var $23=HEAP32[(($22)>>2)];
 var $24=($23|0)==($current_ptr|0);
 if($24){label=8;break;}else{label=10;break;}
 case 8: 
 var $26=($path_below|0)==1;
 if($26){label=9;break;}else{label=14;break;}
 case 9: 
 var $28=(($info+32)|0);
 HEAP32[(($28)>>2)]=1;
 label=14;break;
 case 10: 
 var $30=(($info+32)|0);
 HEAP32[(($30)>>2)]=$path_below;
 HEAP32[(($22)>>2)]=$current_ptr;
 var $31=(($info+40)|0);
 var $32=HEAP32[(($31)>>2)];
 var $33=((($32)+(1))|0);
 HEAP32[(($31)>>2)]=$33;
 var $34=(($info+36)|0);
 var $35=HEAP32[(($34)>>2)];
 var $36=($35|0)==1;
 if($36){label=11;break;}else{label=13;break;}
 case 11: 
 var $38=(($info+24)|0);
 var $39=HEAP32[(($38)>>2)];
 var $40=($39|0)==2;
 if($40){label=12;break;}else{label=13;break;}
 case 12: 
 var $42=(($info+54)|0);
 HEAP8[($42)]=1;
 label=13;break;
 case 13: 
 var $44=(($info+44)|0);
 HEAP32[(($44)>>2)]=4;
 label=14;break;
 case 14: 
 return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNK10__cxxabiv121__vmi_class_type_info16search_above_dstEPNS_19__dynamic_cast_infoEPKvS4_ib($this,$info,$dst_ptr,$current_ptr,$path_below,$use_strcmp){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=(($this)|0);
 var $2=(($info+8)|0);
 var $3=HEAP32[(($2)>>2)];
 var $4=(($3)|0);
 var $5=($1|0)==($4|0);
 if($5){label=2;break;}else{label=12;break;}
 case 2: 
 var $7=(($info+53)|0);
 HEAP8[($7)]=1;
 var $8=(($info+4)|0);
 var $9=HEAP32[(($8)>>2)];
 var $10=($9|0)==($current_ptr|0);
 if($10){label=3;break;}else{label=26;break;}
 case 3: 
 var $12=(($info+52)|0);
 HEAP8[($12)]=1;
 var $13=(($info+16)|0);
 var $14=HEAP32[(($13)>>2)];
 var $15=($14|0)==0;
 if($15){label=4;break;}else{label=6;break;}
 case 4: 
 HEAP32[(($13)>>2)]=$dst_ptr;
 var $17=(($info+24)|0);
 HEAP32[(($17)>>2)]=$path_below;
 var $18=(($info+36)|0);
 HEAP32[(($18)>>2)]=1;
 var $19=(($info+48)|0);
 var $20=HEAP32[(($19)>>2)];
 var $21=($20|0)==1;
 var $22=($path_below|0)==1;
 var $or_cond_i=$21&$22;
 if($or_cond_i){label=5;break;}else{label=26;break;}
 case 5: 
 var $24=(($info+54)|0);
 HEAP8[($24)]=1;
 label=26;break;
 case 6: 
 var $26=($14|0)==($dst_ptr|0);
 if($26){label=7;break;}else{label=11;break;}
 case 7: 
 var $28=(($info+24)|0);
 var $29=HEAP32[(($28)>>2)];
 var $30=($29|0)==2;
 if($30){label=8;break;}else{var $33=$29;label=9;break;}
 case 8: 
 HEAP32[(($28)>>2)]=$path_below;
 var $33=$path_below;label=9;break;
 case 9: 
 var $33;
 var $34=(($info+48)|0);
 var $35=HEAP32[(($34)>>2)];
 var $36=($35|0)==1;
 var $37=($33|0)==1;
 var $or_cond23_i=$36&$37;
 if($or_cond23_i){label=10;break;}else{label=26;break;}
 case 10: 
 var $39=(($info+54)|0);
 HEAP8[($39)]=1;
 label=26;break;
 case 11: 
 var $41=(($info+36)|0);
 var $42=HEAP32[(($41)>>2)];
 var $43=((($42)+(1))|0);
 HEAP32[(($41)>>2)]=$43;
 var $44=(($info+54)|0);
 HEAP8[($44)]=1;
 label=26;break;
 case 12: 
 var $46=(($info+52)|0);
 var $47=HEAP8[($46)];
 var $48=(($info+53)|0);
 var $49=HEAP8[($48)];
 var $50=(($this+12)|0);
 var $51=HEAP32[(($50)>>2)];
 var $52=(($this+16+($51<<3))|0);
 HEAP8[($46)]=0;
 HEAP8[($48)]=0;
 var $53=(($this+20)|0);
 var $54=HEAP32[(($53)>>2)];
 var $55=$54>>8;
 var $56=$54&1;
 var $57=($56|0)==0;
 if($57){var $offset_to_base_0_i32=$55;label=14;break;}else{label=13;break;}
 case 13: 
 var $59=$current_ptr;
 var $60=HEAP32[(($59)>>2)];
 var $61=(($60+$55)|0);
 var $62=$61;
 var $63=HEAP32[(($62)>>2)];
 var $offset_to_base_0_i32=$63;label=14;break;
 case 14: 
 var $offset_to_base_0_i32;
 var $64=(($this+16)|0);
 var $65=HEAP32[(($64)>>2)];
 var $66=$65;
 var $67=HEAP32[(($66)>>2)];
 var $68=(($67+20)|0);
 var $69=HEAP32[(($68)>>2)];
 var $70=(($current_ptr+$offset_to_base_0_i32)|0);
 var $71=$54&2;
 var $72=($71|0)!=0;
 var $73=($72?$path_below:2);
 FUNCTION_TABLE[$69]($65,$info,$dst_ptr,$70,$73,$use_strcmp);
 var $74=($51|0)>1;
 if($74){label=15;break;}else{label=25;break;}
 case 15: 
 var $75=(($this+24)|0);
 var $76=(($info+24)|0);
 var $77=(($this+8)|0);
 var $78=(($info+54)|0);
 var $79=$current_ptr;
 var $p_0=$75;label=16;break;
 case 16: 
 var $p_0;
 var $81=HEAP8[($78)];
 var $82=(($81<<24)>>24)==0;
 if($82){label=17;break;}else{label=25;break;}
 case 17: 
 var $84=HEAP8[($46)];
 var $85=(($84<<24)>>24)==0;
 if($85){label=20;break;}else{label=18;break;}
 case 18: 
 var $87=HEAP32[(($76)>>2)];
 var $88=($87|0)==1;
 if($88){label=25;break;}else{label=19;break;}
 case 19: 
 var $90=HEAP32[(($77)>>2)];
 var $91=$90&2;
 var $92=($91|0)==0;
 if($92){label=25;break;}else{label=22;break;}
 case 20: 
 var $94=HEAP8[($48)];
 var $95=(($94<<24)>>24)==0;
 if($95){label=22;break;}else{label=21;break;}
 case 21: 
 var $97=HEAP32[(($77)>>2)];
 var $98=$97&1;
 var $99=($98|0)==0;
 if($99){label=25;break;}else{label=22;break;}
 case 22: 
 HEAP8[($46)]=0;
 HEAP8[($48)]=0;
 var $101=(($p_0+4)|0);
 var $102=HEAP32[(($101)>>2)];
 var $103=$102>>8;
 var $104=$102&1;
 var $105=($104|0)==0;
 if($105){var $offset_to_base_0_i=$103;label=24;break;}else{label=23;break;}
 case 23: 
 var $107=HEAP32[(($79)>>2)];
 var $108=(($107+$103)|0);
 var $109=$108;
 var $110=HEAP32[(($109)>>2)];
 var $offset_to_base_0_i=$110;label=24;break;
 case 24: 
 var $offset_to_base_0_i;
 var $111=(($p_0)|0);
 var $112=HEAP32[(($111)>>2)];
 var $113=$112;
 var $114=HEAP32[(($113)>>2)];
 var $115=(($114+20)|0);
 var $116=HEAP32[(($115)>>2)];
 var $117=(($current_ptr+$offset_to_base_0_i)|0);
 var $118=$102&2;
 var $119=($118|0)!=0;
 var $120=($119?$path_below:2);
 FUNCTION_TABLE[$116]($112,$info,$dst_ptr,$117,$120,$use_strcmp);
 var $121=(($p_0+8)|0);
 var $122=($121>>>0)<($52>>>0);
 if($122){var $p_0=$121;label=16;break;}else{label=25;break;}
 case 25: 
 HEAP8[($46)]=$47;
 HEAP8[($48)]=$49;
 label=26;break;
 case 26: 
 return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNK10__cxxabiv120__si_class_type_info16search_above_dstEPNS_19__dynamic_cast_infoEPKvS4_ib($this,$info,$dst_ptr,$current_ptr,$path_below,$use_strcmp){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=(($this)|0);
 var $2=(($info+8)|0);
 var $3=HEAP32[(($2)>>2)];
 var $4=(($3)|0);
 var $5=($1|0)==($4|0);
 if($5){label=2;break;}else{label=12;break;}
 case 2: 
 var $7=(($info+53)|0);
 HEAP8[($7)]=1;
 var $8=(($info+4)|0);
 var $9=HEAP32[(($8)>>2)];
 var $10=($9|0)==($current_ptr|0);
 if($10){label=3;break;}else{label=13;break;}
 case 3: 
 var $12=(($info+52)|0);
 HEAP8[($12)]=1;
 var $13=(($info+16)|0);
 var $14=HEAP32[(($13)>>2)];
 var $15=($14|0)==0;
 if($15){label=4;break;}else{label=6;break;}
 case 4: 
 HEAP32[(($13)>>2)]=$dst_ptr;
 var $17=(($info+24)|0);
 HEAP32[(($17)>>2)]=$path_below;
 var $18=(($info+36)|0);
 HEAP32[(($18)>>2)]=1;
 var $19=(($info+48)|0);
 var $20=HEAP32[(($19)>>2)];
 var $21=($20|0)==1;
 var $22=($path_below|0)==1;
 var $or_cond_i=$21&$22;
 if($or_cond_i){label=5;break;}else{label=13;break;}
 case 5: 
 var $24=(($info+54)|0);
 HEAP8[($24)]=1;
 label=13;break;
 case 6: 
 var $26=($14|0)==($dst_ptr|0);
 if($26){label=7;break;}else{label=11;break;}
 case 7: 
 var $28=(($info+24)|0);
 var $29=HEAP32[(($28)>>2)];
 var $30=($29|0)==2;
 if($30){label=8;break;}else{var $33=$29;label=9;break;}
 case 8: 
 HEAP32[(($28)>>2)]=$path_below;
 var $33=$path_below;label=9;break;
 case 9: 
 var $33;
 var $34=(($info+48)|0);
 var $35=HEAP32[(($34)>>2)];
 var $36=($35|0)==1;
 var $37=($33|0)==1;
 var $or_cond23_i=$36&$37;
 if($or_cond23_i){label=10;break;}else{label=13;break;}
 case 10: 
 var $39=(($info+54)|0);
 HEAP8[($39)]=1;
 label=13;break;
 case 11: 
 var $41=(($info+36)|0);
 var $42=HEAP32[(($41)>>2)];
 var $43=((($42)+(1))|0);
 HEAP32[(($41)>>2)]=$43;
 var $44=(($info+54)|0);
 HEAP8[($44)]=1;
 label=13;break;
 case 12: 
 var $46=(($this+8)|0);
 var $47=HEAP32[(($46)>>2)];
 var $48=$47;
 var $49=HEAP32[(($48)>>2)];
 var $50=(($49+20)|0);
 var $51=HEAP32[(($50)>>2)];
 FUNCTION_TABLE[$51]($47,$info,$dst_ptr,$current_ptr,$path_below,$use_strcmp);
 label=13;break;
 case 13: 
 return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZNK10__cxxabiv117__class_type_info16search_above_dstEPNS_19__dynamic_cast_infoEPKvS4_ib($this,$info,$dst_ptr,$current_ptr,$path_below,$use_strcmp){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=(($info+8)|0);
 var $2=HEAP32[(($1)>>2)];
 var $3=($2|0)==($this|0);
 if($3){label=2;break;}else{label=12;break;}
 case 2: 
 var $5=(($info+53)|0);
 HEAP8[($5)]=1;
 var $6=(($info+4)|0);
 var $7=HEAP32[(($6)>>2)];
 var $8=($7|0)==($current_ptr|0);
 if($8){label=3;break;}else{label=12;break;}
 case 3: 
 var $10=(($info+52)|0);
 HEAP8[($10)]=1;
 var $11=(($info+16)|0);
 var $12=HEAP32[(($11)>>2)];
 var $13=($12|0)==0;
 if($13){label=4;break;}else{label=6;break;}
 case 4: 
 HEAP32[(($11)>>2)]=$dst_ptr;
 var $15=(($info+24)|0);
 HEAP32[(($15)>>2)]=$path_below;
 var $16=(($info+36)|0);
 HEAP32[(($16)>>2)]=1;
 var $17=(($info+48)|0);
 var $18=HEAP32[(($17)>>2)];
 var $19=($18|0)==1;
 var $20=($path_below|0)==1;
 var $or_cond_i=$19&$20;
 if($or_cond_i){label=5;break;}else{label=12;break;}
 case 5: 
 var $22=(($info+54)|0);
 HEAP8[($22)]=1;
 label=12;break;
 case 6: 
 var $24=($12|0)==($dst_ptr|0);
 if($24){label=7;break;}else{label=11;break;}
 case 7: 
 var $26=(($info+24)|0);
 var $27=HEAP32[(($26)>>2)];
 var $28=($27|0)==2;
 if($28){label=8;break;}else{var $31=$27;label=9;break;}
 case 8: 
 HEAP32[(($26)>>2)]=$path_below;
 var $31=$path_below;label=9;break;
 case 9: 
 var $31;
 var $32=(($info+48)|0);
 var $33=HEAP32[(($32)>>2)];
 var $34=($33|0)==1;
 var $35=($31|0)==1;
 var $or_cond23_i=$34&$35;
 if($or_cond23_i){label=10;break;}else{label=12;break;}
 case 10: 
 var $37=(($info+54)|0);
 HEAP8[($37)]=1;
 label=12;break;
 case 11: 
 var $39=(($info+36)|0);
 var $40=HEAP32[(($39)>>2)];
 var $41=((($40)+(1))|0);
 HEAP32[(($39)>>2)]=$41;
 var $42=(($info+54)|0);
 HEAP8[($42)]=1;
 label=12;break;
 case 12: 
 return;
  default: assert(0, "bad label: " + label);
 }

}


function _malloc($bytes){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=($bytes>>>0)<245;
 if($1){label=2;break;}else{label=78;break;}
 case 2: 
 var $3=($bytes>>>0)<11;
 if($3){var $8=16;label=4;break;}else{label=3;break;}
 case 3: 
 var $5=((($bytes)+(11))|0);
 var $6=$5&-8;
 var $8=$6;label=4;break;
 case 4: 
 var $8;
 var $9=$8>>>3;
 var $10=HEAP32[((10672)>>2)];
 var $11=$10>>>($9>>>0);
 var $12=$11&3;
 var $13=($12|0)==0;
 if($13){label=12;break;}else{label=5;break;}
 case 5: 
 var $15=$11&1;
 var $16=$15^1;
 var $17=((($16)+($9))|0);
 var $18=$17<<1;
 var $19=((10712+($18<<2))|0);
 var $20=$19;
 var $_sum111=((($18)+(2))|0);
 var $21=((10712+($_sum111<<2))|0);
 var $22=HEAP32[(($21)>>2)];
 var $23=(($22+8)|0);
 var $24=HEAP32[(($23)>>2)];
 var $25=($20|0)==($24|0);
 if($25){label=6;break;}else{label=7;break;}
 case 6: 
 var $27=1<<$17;
 var $28=$27^-1;
 var $29=$10&$28;
 HEAP32[((10672)>>2)]=$29;
 label=11;break;
 case 7: 
 var $31=$24;
 var $32=HEAP32[((10688)>>2)];
 var $33=($31>>>0)<($32>>>0);
 if($33){label=10;break;}else{label=8;break;}
 case 8: 
 var $35=(($24+12)|0);
 var $36=HEAP32[(($35)>>2)];
 var $37=($36|0)==($22|0);
 if($37){label=9;break;}else{label=10;break;}
 case 9: 
 HEAP32[(($35)>>2)]=$20;
 HEAP32[(($21)>>2)]=$24;
 label=11;break;
 case 10: 
 _abort();
 throw "Reached an unreachable!";
 case 11: 
 var $40=$17<<3;
 var $41=$40|3;
 var $42=(($22+4)|0);
 HEAP32[(($42)>>2)]=$41;
 var $43=$22;
 var $_sum113114=$40|4;
 var $44=(($43+$_sum113114)|0);
 var $45=$44;
 var $46=HEAP32[(($45)>>2)];
 var $47=$46|1;
 HEAP32[(($45)>>2)]=$47;
 var $48=$23;
 var $mem_0=$48;label=341;break;
 case 12: 
 var $50=HEAP32[((10680)>>2)];
 var $51=($8>>>0)>($50>>>0);
 if($51){label=13;break;}else{var $nb_0=$8;label=160;break;}
 case 13: 
 var $53=($11|0)==0;
 if($53){label=27;break;}else{label=14;break;}
 case 14: 
 var $55=$11<<$9;
 var $56=2<<$9;
 var $57=(((-$56))|0);
 var $58=$56|$57;
 var $59=$55&$58;
 var $60=(((-$59))|0);
 var $61=$59&$60;
 var $62=((($61)-(1))|0);
 var $63=$62>>>12;
 var $64=$63&16;
 var $65=$62>>>($64>>>0);
 var $66=$65>>>5;
 var $67=$66&8;
 var $68=$67|$64;
 var $69=$65>>>($67>>>0);
 var $70=$69>>>2;
 var $71=$70&4;
 var $72=$68|$71;
 var $73=$69>>>($71>>>0);
 var $74=$73>>>1;
 var $75=$74&2;
 var $76=$72|$75;
 var $77=$73>>>($75>>>0);
 var $78=$77>>>1;
 var $79=$78&1;
 var $80=$76|$79;
 var $81=$77>>>($79>>>0);
 var $82=((($80)+($81))|0);
 var $83=$82<<1;
 var $84=((10712+($83<<2))|0);
 var $85=$84;
 var $_sum104=((($83)+(2))|0);
 var $86=((10712+($_sum104<<2))|0);
 var $87=HEAP32[(($86)>>2)];
 var $88=(($87+8)|0);
 var $89=HEAP32[(($88)>>2)];
 var $90=($85|0)==($89|0);
 if($90){label=15;break;}else{label=16;break;}
 case 15: 
 var $92=1<<$82;
 var $93=$92^-1;
 var $94=$10&$93;
 HEAP32[((10672)>>2)]=$94;
 label=20;break;
 case 16: 
 var $96=$89;
 var $97=HEAP32[((10688)>>2)];
 var $98=($96>>>0)<($97>>>0);
 if($98){label=19;break;}else{label=17;break;}
 case 17: 
 var $100=(($89+12)|0);
 var $101=HEAP32[(($100)>>2)];
 var $102=($101|0)==($87|0);
 if($102){label=18;break;}else{label=19;break;}
 case 18: 
 HEAP32[(($100)>>2)]=$85;
 HEAP32[(($86)>>2)]=$89;
 label=20;break;
 case 19: 
 _abort();
 throw "Reached an unreachable!";
 case 20: 
 var $105=$82<<3;
 var $106=((($105)-($8))|0);
 var $107=$8|3;
 var $108=(($87+4)|0);
 HEAP32[(($108)>>2)]=$107;
 var $109=$87;
 var $110=(($109+$8)|0);
 var $111=$110;
 var $112=$106|1;
 var $_sum106107=$8|4;
 var $113=(($109+$_sum106107)|0);
 var $114=$113;
 HEAP32[(($114)>>2)]=$112;
 var $115=(($109+$105)|0);
 var $116=$115;
 HEAP32[(($116)>>2)]=$106;
 var $117=HEAP32[((10680)>>2)];
 var $118=($117|0)==0;
 if($118){label=26;break;}else{label=21;break;}
 case 21: 
 var $120=HEAP32[((10692)>>2)];
 var $121=$117>>>3;
 var $122=$121<<1;
 var $123=((10712+($122<<2))|0);
 var $124=$123;
 var $125=HEAP32[((10672)>>2)];
 var $126=1<<$121;
 var $127=$125&$126;
 var $128=($127|0)==0;
 if($128){label=22;break;}else{label=23;break;}
 case 22: 
 var $130=$125|$126;
 HEAP32[((10672)>>2)]=$130;
 var $_sum109_pre=((($122)+(2))|0);
 var $_pre=((10712+($_sum109_pre<<2))|0);
 var $F4_0=$124;var $_pre_phi=$_pre;label=25;break;
 case 23: 
 var $_sum110=((($122)+(2))|0);
 var $132=((10712+($_sum110<<2))|0);
 var $133=HEAP32[(($132)>>2)];
 var $134=$133;
 var $135=HEAP32[((10688)>>2)];
 var $136=($134>>>0)<($135>>>0);
 if($136){label=24;break;}else{var $F4_0=$133;var $_pre_phi=$132;label=25;break;}
 case 24: 
 _abort();
 throw "Reached an unreachable!";
 case 25: 
 var $_pre_phi;
 var $F4_0;
 HEAP32[(($_pre_phi)>>2)]=$120;
 var $139=(($F4_0+12)|0);
 HEAP32[(($139)>>2)]=$120;
 var $140=(($120+8)|0);
 HEAP32[(($140)>>2)]=$F4_0;
 var $141=(($120+12)|0);
 HEAP32[(($141)>>2)]=$124;
 label=26;break;
 case 26: 
 HEAP32[((10680)>>2)]=$106;
 HEAP32[((10692)>>2)]=$111;
 var $143=$88;
 var $mem_0=$143;label=341;break;
 case 27: 
 var $145=HEAP32[((10676)>>2)];
 var $146=($145|0)==0;
 if($146){var $nb_0=$8;label=160;break;}else{label=28;break;}
 case 28: 
 var $148=(((-$145))|0);
 var $149=$145&$148;
 var $150=((($149)-(1))|0);
 var $151=$150>>>12;
 var $152=$151&16;
 var $153=$150>>>($152>>>0);
 var $154=$153>>>5;
 var $155=$154&8;
 var $156=$155|$152;
 var $157=$153>>>($155>>>0);
 var $158=$157>>>2;
 var $159=$158&4;
 var $160=$156|$159;
 var $161=$157>>>($159>>>0);
 var $162=$161>>>1;
 var $163=$162&2;
 var $164=$160|$163;
 var $165=$161>>>($163>>>0);
 var $166=$165>>>1;
 var $167=$166&1;
 var $168=$164|$167;
 var $169=$165>>>($167>>>0);
 var $170=((($168)+($169))|0);
 var $171=((10976+($170<<2))|0);
 var $172=HEAP32[(($171)>>2)];
 var $173=(($172+4)|0);
 var $174=HEAP32[(($173)>>2)];
 var $175=$174&-8;
 var $176=((($175)-($8))|0);
 var $t_0_i=$172;var $v_0_i=$172;var $rsize_0_i=$176;label=29;break;
 case 29: 
 var $rsize_0_i;
 var $v_0_i;
 var $t_0_i;
 var $178=(($t_0_i+16)|0);
 var $179=HEAP32[(($178)>>2)];
 var $180=($179|0)==0;
 if($180){label=30;break;}else{var $185=$179;label=31;break;}
 case 30: 
 var $182=(($t_0_i+20)|0);
 var $183=HEAP32[(($182)>>2)];
 var $184=($183|0)==0;
 if($184){label=32;break;}else{var $185=$183;label=31;break;}
 case 31: 
 var $185;
 var $186=(($185+4)|0);
 var $187=HEAP32[(($186)>>2)];
 var $188=$187&-8;
 var $189=((($188)-($8))|0);
 var $190=($189>>>0)<($rsize_0_i>>>0);
 var $_rsize_0_i=($190?$189:$rsize_0_i);
 var $_v_0_i=($190?$185:$v_0_i);
 var $t_0_i=$185;var $v_0_i=$_v_0_i;var $rsize_0_i=$_rsize_0_i;label=29;break;
 case 32: 
 var $192=$v_0_i;
 var $193=HEAP32[((10688)>>2)];
 var $194=($192>>>0)<($193>>>0);
 if($194){label=76;break;}else{label=33;break;}
 case 33: 
 var $196=(($192+$8)|0);
 var $197=$196;
 var $198=($192>>>0)<($196>>>0);
 if($198){label=34;break;}else{label=76;break;}
 case 34: 
 var $200=(($v_0_i+24)|0);
 var $201=HEAP32[(($200)>>2)];
 var $202=(($v_0_i+12)|0);
 var $203=HEAP32[(($202)>>2)];
 var $204=($203|0)==($v_0_i|0);
 if($204){label=40;break;}else{label=35;break;}
 case 35: 
 var $206=(($v_0_i+8)|0);
 var $207=HEAP32[(($206)>>2)];
 var $208=$207;
 var $209=($208>>>0)<($193>>>0);
 if($209){label=39;break;}else{label=36;break;}
 case 36: 
 var $211=(($207+12)|0);
 var $212=HEAP32[(($211)>>2)];
 var $213=($212|0)==($v_0_i|0);
 if($213){label=37;break;}else{label=39;break;}
 case 37: 
 var $215=(($203+8)|0);
 var $216=HEAP32[(($215)>>2)];
 var $217=($216|0)==($v_0_i|0);
 if($217){label=38;break;}else{label=39;break;}
 case 38: 
 HEAP32[(($211)>>2)]=$203;
 HEAP32[(($215)>>2)]=$207;
 var $R_1_i=$203;label=47;break;
 case 39: 
 _abort();
 throw "Reached an unreachable!";
 case 40: 
 var $220=(($v_0_i+20)|0);
 var $221=HEAP32[(($220)>>2)];
 var $222=($221|0)==0;
 if($222){label=41;break;}else{var $R_0_i=$221;var $RP_0_i=$220;label=42;break;}
 case 41: 
 var $224=(($v_0_i+16)|0);
 var $225=HEAP32[(($224)>>2)];
 var $226=($225|0)==0;
 if($226){var $R_1_i=0;label=47;break;}else{var $R_0_i=$225;var $RP_0_i=$224;label=42;break;}
 case 42: 
 var $RP_0_i;
 var $R_0_i;
 var $227=(($R_0_i+20)|0);
 var $228=HEAP32[(($227)>>2)];
 var $229=($228|0)==0;
 if($229){label=43;break;}else{var $R_0_i=$228;var $RP_0_i=$227;label=42;break;}
 case 43: 
 var $231=(($R_0_i+16)|0);
 var $232=HEAP32[(($231)>>2)];
 var $233=($232|0)==0;
 if($233){label=44;break;}else{var $R_0_i=$232;var $RP_0_i=$231;label=42;break;}
 case 44: 
 var $235=$RP_0_i;
 var $236=($235>>>0)<($193>>>0);
 if($236){label=46;break;}else{label=45;break;}
 case 45: 
 HEAP32[(($RP_0_i)>>2)]=0;
 var $R_1_i=$R_0_i;label=47;break;
 case 46: 
 _abort();
 throw "Reached an unreachable!";
 case 47: 
 var $R_1_i;
 var $240=($201|0)==0;
 if($240){label=67;break;}else{label=48;break;}
 case 48: 
 var $242=(($v_0_i+28)|0);
 var $243=HEAP32[(($242)>>2)];
 var $244=((10976+($243<<2))|0);
 var $245=HEAP32[(($244)>>2)];
 var $246=($v_0_i|0)==($245|0);
 if($246){label=49;break;}else{label=51;break;}
 case 49: 
 HEAP32[(($244)>>2)]=$R_1_i;
 var $cond_i=($R_1_i|0)==0;
 if($cond_i){label=50;break;}else{label=57;break;}
 case 50: 
 var $248=1<<$243;
 var $249=$248^-1;
 var $250=HEAP32[((10676)>>2)];
 var $251=$250&$249;
 HEAP32[((10676)>>2)]=$251;
 label=67;break;
 case 51: 
 var $253=$201;
 var $254=HEAP32[((10688)>>2)];
 var $255=($253>>>0)<($254>>>0);
 if($255){label=55;break;}else{label=52;break;}
 case 52: 
 var $257=(($201+16)|0);
 var $258=HEAP32[(($257)>>2)];
 var $259=($258|0)==($v_0_i|0);
 if($259){label=53;break;}else{label=54;break;}
 case 53: 
 HEAP32[(($257)>>2)]=$R_1_i;
 label=56;break;
 case 54: 
 var $262=(($201+20)|0);
 HEAP32[(($262)>>2)]=$R_1_i;
 label=56;break;
 case 55: 
 _abort();
 throw "Reached an unreachable!";
 case 56: 
 var $265=($R_1_i|0)==0;
 if($265){label=67;break;}else{label=57;break;}
 case 57: 
 var $267=$R_1_i;
 var $268=HEAP32[((10688)>>2)];
 var $269=($267>>>0)<($268>>>0);
 if($269){label=66;break;}else{label=58;break;}
 case 58: 
 var $271=(($R_1_i+24)|0);
 HEAP32[(($271)>>2)]=$201;
 var $272=(($v_0_i+16)|0);
 var $273=HEAP32[(($272)>>2)];
 var $274=($273|0)==0;
 if($274){label=62;break;}else{label=59;break;}
 case 59: 
 var $276=$273;
 var $277=HEAP32[((10688)>>2)];
 var $278=($276>>>0)<($277>>>0);
 if($278){label=61;break;}else{label=60;break;}
 case 60: 
 var $280=(($R_1_i+16)|0);
 HEAP32[(($280)>>2)]=$273;
 var $281=(($273+24)|0);
 HEAP32[(($281)>>2)]=$R_1_i;
 label=62;break;
 case 61: 
 _abort();
 throw "Reached an unreachable!";
 case 62: 
 var $284=(($v_0_i+20)|0);
 var $285=HEAP32[(($284)>>2)];
 var $286=($285|0)==0;
 if($286){label=67;break;}else{label=63;break;}
 case 63: 
 var $288=$285;
 var $289=HEAP32[((10688)>>2)];
 var $290=($288>>>0)<($289>>>0);
 if($290){label=65;break;}else{label=64;break;}
 case 64: 
 var $292=(($R_1_i+20)|0);
 HEAP32[(($292)>>2)]=$285;
 var $293=(($285+24)|0);
 HEAP32[(($293)>>2)]=$R_1_i;
 label=67;break;
 case 65: 
 _abort();
 throw "Reached an unreachable!";
 case 66: 
 _abort();
 throw "Reached an unreachable!";
 case 67: 
 var $297=($rsize_0_i>>>0)<16;
 if($297){label=68;break;}else{label=69;break;}
 case 68: 
 var $299=((($rsize_0_i)+($8))|0);
 var $300=$299|3;
 var $301=(($v_0_i+4)|0);
 HEAP32[(($301)>>2)]=$300;
 var $_sum4_i=((($299)+(4))|0);
 var $302=(($192+$_sum4_i)|0);
 var $303=$302;
 var $304=HEAP32[(($303)>>2)];
 var $305=$304|1;
 HEAP32[(($303)>>2)]=$305;
 label=77;break;
 case 69: 
 var $307=$8|3;
 var $308=(($v_0_i+4)|0);
 HEAP32[(($308)>>2)]=$307;
 var $309=$rsize_0_i|1;
 var $_sum_i137=$8|4;
 var $310=(($192+$_sum_i137)|0);
 var $311=$310;
 HEAP32[(($311)>>2)]=$309;
 var $_sum1_i=((($rsize_0_i)+($8))|0);
 var $312=(($192+$_sum1_i)|0);
 var $313=$312;
 HEAP32[(($313)>>2)]=$rsize_0_i;
 var $314=HEAP32[((10680)>>2)];
 var $315=($314|0)==0;
 if($315){label=75;break;}else{label=70;break;}
 case 70: 
 var $317=HEAP32[((10692)>>2)];
 var $318=$314>>>3;
 var $319=$318<<1;
 var $320=((10712+($319<<2))|0);
 var $321=$320;
 var $322=HEAP32[((10672)>>2)];
 var $323=1<<$318;
 var $324=$322&$323;
 var $325=($324|0)==0;
 if($325){label=71;break;}else{label=72;break;}
 case 71: 
 var $327=$322|$323;
 HEAP32[((10672)>>2)]=$327;
 var $_sum2_pre_i=((($319)+(2))|0);
 var $_pre_i=((10712+($_sum2_pre_i<<2))|0);
 var $F1_0_i=$321;var $_pre_phi_i=$_pre_i;label=74;break;
 case 72: 
 var $_sum3_i=((($319)+(2))|0);
 var $329=((10712+($_sum3_i<<2))|0);
 var $330=HEAP32[(($329)>>2)];
 var $331=$330;
 var $332=HEAP32[((10688)>>2)];
 var $333=($331>>>0)<($332>>>0);
 if($333){label=73;break;}else{var $F1_0_i=$330;var $_pre_phi_i=$329;label=74;break;}
 case 73: 
 _abort();
 throw "Reached an unreachable!";
 case 74: 
 var $_pre_phi_i;
 var $F1_0_i;
 HEAP32[(($_pre_phi_i)>>2)]=$317;
 var $336=(($F1_0_i+12)|0);
 HEAP32[(($336)>>2)]=$317;
 var $337=(($317+8)|0);
 HEAP32[(($337)>>2)]=$F1_0_i;
 var $338=(($317+12)|0);
 HEAP32[(($338)>>2)]=$321;
 label=75;break;
 case 75: 
 HEAP32[((10680)>>2)]=$rsize_0_i;
 HEAP32[((10692)>>2)]=$197;
 label=77;break;
 case 76: 
 _abort();
 throw "Reached an unreachable!";
 case 77: 
 var $341=(($v_0_i+8)|0);
 var $342=$341;
 var $343=($341|0)==0;
 if($343){var $nb_0=$8;label=160;break;}else{var $mem_0=$342;label=341;break;}
 case 78: 
 var $345=($bytes>>>0)>4294967231;
 if($345){var $nb_0=-1;label=160;break;}else{label=79;break;}
 case 79: 
 var $347=((($bytes)+(11))|0);
 var $348=$347&-8;
 var $349=HEAP32[((10676)>>2)];
 var $350=($349|0)==0;
 if($350){var $nb_0=$348;label=160;break;}else{label=80;break;}
 case 80: 
 var $352=(((-$348))|0);
 var $353=$347>>>8;
 var $354=($353|0)==0;
 if($354){var $idx_0_i=0;label=83;break;}else{label=81;break;}
 case 81: 
 var $356=($348>>>0)>16777215;
 if($356){var $idx_0_i=31;label=83;break;}else{label=82;break;}
 case 82: 
 var $358=((($353)+(1048320))|0);
 var $359=$358>>>16;
 var $360=$359&8;
 var $361=$353<<$360;
 var $362=((($361)+(520192))|0);
 var $363=$362>>>16;
 var $364=$363&4;
 var $365=$364|$360;
 var $366=$361<<$364;
 var $367=((($366)+(245760))|0);
 var $368=$367>>>16;
 var $369=$368&2;
 var $370=$365|$369;
 var $371=(((14)-($370))|0);
 var $372=$366<<$369;
 var $373=$372>>>15;
 var $374=((($371)+($373))|0);
 var $375=$374<<1;
 var $376=((($374)+(7))|0);
 var $377=$348>>>($376>>>0);
 var $378=$377&1;
 var $379=$378|$375;
 var $idx_0_i=$379;label=83;break;
 case 83: 
 var $idx_0_i;
 var $381=((10976+($idx_0_i<<2))|0);
 var $382=HEAP32[(($381)>>2)];
 var $383=($382|0)==0;
 if($383){var $v_2_i=0;var $rsize_2_i=$352;var $t_1_i=0;label=90;break;}else{label=84;break;}
 case 84: 
 var $385=($idx_0_i|0)==31;
 if($385){var $390=0;label=86;break;}else{label=85;break;}
 case 85: 
 var $387=$idx_0_i>>>1;
 var $388=(((25)-($387))|0);
 var $390=$388;label=86;break;
 case 86: 
 var $390;
 var $391=$348<<$390;
 var $v_0_i118=0;var $rsize_0_i117=$352;var $t_0_i116=$382;var $sizebits_0_i=$391;var $rst_0_i=0;label=87;break;
 case 87: 
 var $rst_0_i;
 var $sizebits_0_i;
 var $t_0_i116;
 var $rsize_0_i117;
 var $v_0_i118;
 var $393=(($t_0_i116+4)|0);
 var $394=HEAP32[(($393)>>2)];
 var $395=$394&-8;
 var $396=((($395)-($348))|0);
 var $397=($396>>>0)<($rsize_0_i117>>>0);
 if($397){label=88;break;}else{var $v_1_i=$v_0_i118;var $rsize_1_i=$rsize_0_i117;label=89;break;}
 case 88: 
 var $399=($395|0)==($348|0);
 if($399){var $v_2_i=$t_0_i116;var $rsize_2_i=$396;var $t_1_i=$t_0_i116;label=90;break;}else{var $v_1_i=$t_0_i116;var $rsize_1_i=$396;label=89;break;}
 case 89: 
 var $rsize_1_i;
 var $v_1_i;
 var $401=(($t_0_i116+20)|0);
 var $402=HEAP32[(($401)>>2)];
 var $403=$sizebits_0_i>>>31;
 var $404=(($t_0_i116+16+($403<<2))|0);
 var $405=HEAP32[(($404)>>2)];
 var $406=($402|0)==0;
 var $407=($402|0)==($405|0);
 var $or_cond_i=$406|$407;
 var $rst_1_i=($or_cond_i?$rst_0_i:$402);
 var $408=($405|0)==0;
 var $409=$sizebits_0_i<<1;
 if($408){var $v_2_i=$v_1_i;var $rsize_2_i=$rsize_1_i;var $t_1_i=$rst_1_i;label=90;break;}else{var $v_0_i118=$v_1_i;var $rsize_0_i117=$rsize_1_i;var $t_0_i116=$405;var $sizebits_0_i=$409;var $rst_0_i=$rst_1_i;label=87;break;}
 case 90: 
 var $t_1_i;
 var $rsize_2_i;
 var $v_2_i;
 var $410=($t_1_i|0)==0;
 var $411=($v_2_i|0)==0;
 var $or_cond21_i=$410&$411;
 if($or_cond21_i){label=91;break;}else{var $t_2_ph_i=$t_1_i;label=93;break;}
 case 91: 
 var $413=2<<$idx_0_i;
 var $414=(((-$413))|0);
 var $415=$413|$414;
 var $416=$349&$415;
 var $417=($416|0)==0;
 if($417){var $nb_0=$348;label=160;break;}else{label=92;break;}
 case 92: 
 var $419=(((-$416))|0);
 var $420=$416&$419;
 var $421=((($420)-(1))|0);
 var $422=$421>>>12;
 var $423=$422&16;
 var $424=$421>>>($423>>>0);
 var $425=$424>>>5;
 var $426=$425&8;
 var $427=$426|$423;
 var $428=$424>>>($426>>>0);
 var $429=$428>>>2;
 var $430=$429&4;
 var $431=$427|$430;
 var $432=$428>>>($430>>>0);
 var $433=$432>>>1;
 var $434=$433&2;
 var $435=$431|$434;
 var $436=$432>>>($434>>>0);
 var $437=$436>>>1;
 var $438=$437&1;
 var $439=$435|$438;
 var $440=$436>>>($438>>>0);
 var $441=((($439)+($440))|0);
 var $442=((10976+($441<<2))|0);
 var $443=HEAP32[(($442)>>2)];
 var $t_2_ph_i=$443;label=93;break;
 case 93: 
 var $t_2_ph_i;
 var $444=($t_2_ph_i|0)==0;
 if($444){var $rsize_3_lcssa_i=$rsize_2_i;var $v_3_lcssa_i=$v_2_i;label=96;break;}else{var $t_228_i=$t_2_ph_i;var $rsize_329_i=$rsize_2_i;var $v_330_i=$v_2_i;label=94;break;}
 case 94: 
 var $v_330_i;
 var $rsize_329_i;
 var $t_228_i;
 var $445=(($t_228_i+4)|0);
 var $446=HEAP32[(($445)>>2)];
 var $447=$446&-8;
 var $448=((($447)-($348))|0);
 var $449=($448>>>0)<($rsize_329_i>>>0);
 var $_rsize_3_i=($449?$448:$rsize_329_i);
 var $t_2_v_3_i=($449?$t_228_i:$v_330_i);
 var $450=(($t_228_i+16)|0);
 var $451=HEAP32[(($450)>>2)];
 var $452=($451|0)==0;
 if($452){label=95;break;}else{var $t_228_i=$451;var $rsize_329_i=$_rsize_3_i;var $v_330_i=$t_2_v_3_i;label=94;break;}
 case 95: 
 var $453=(($t_228_i+20)|0);
 var $454=HEAP32[(($453)>>2)];
 var $455=($454|0)==0;
 if($455){var $rsize_3_lcssa_i=$_rsize_3_i;var $v_3_lcssa_i=$t_2_v_3_i;label=96;break;}else{var $t_228_i=$454;var $rsize_329_i=$_rsize_3_i;var $v_330_i=$t_2_v_3_i;label=94;break;}
 case 96: 
 var $v_3_lcssa_i;
 var $rsize_3_lcssa_i;
 var $456=($v_3_lcssa_i|0)==0;
 if($456){var $nb_0=$348;label=160;break;}else{label=97;break;}
 case 97: 
 var $458=HEAP32[((10680)>>2)];
 var $459=((($458)-($348))|0);
 var $460=($rsize_3_lcssa_i>>>0)<($459>>>0);
 if($460){label=98;break;}else{var $nb_0=$348;label=160;break;}
 case 98: 
 var $462=$v_3_lcssa_i;
 var $463=HEAP32[((10688)>>2)];
 var $464=($462>>>0)<($463>>>0);
 if($464){label=158;break;}else{label=99;break;}
 case 99: 
 var $466=(($462+$348)|0);
 var $467=$466;
 var $468=($462>>>0)<($466>>>0);
 if($468){label=100;break;}else{label=158;break;}
 case 100: 
 var $470=(($v_3_lcssa_i+24)|0);
 var $471=HEAP32[(($470)>>2)];
 var $472=(($v_3_lcssa_i+12)|0);
 var $473=HEAP32[(($472)>>2)];
 var $474=($473|0)==($v_3_lcssa_i|0);
 if($474){label=106;break;}else{label=101;break;}
 case 101: 
 var $476=(($v_3_lcssa_i+8)|0);
 var $477=HEAP32[(($476)>>2)];
 var $478=$477;
 var $479=($478>>>0)<($463>>>0);
 if($479){label=105;break;}else{label=102;break;}
 case 102: 
 var $481=(($477+12)|0);
 var $482=HEAP32[(($481)>>2)];
 var $483=($482|0)==($v_3_lcssa_i|0);
 if($483){label=103;break;}else{label=105;break;}
 case 103: 
 var $485=(($473+8)|0);
 var $486=HEAP32[(($485)>>2)];
 var $487=($486|0)==($v_3_lcssa_i|0);
 if($487){label=104;break;}else{label=105;break;}
 case 104: 
 HEAP32[(($481)>>2)]=$473;
 HEAP32[(($485)>>2)]=$477;
 var $R_1_i122=$473;label=113;break;
 case 105: 
 _abort();
 throw "Reached an unreachable!";
 case 106: 
 var $490=(($v_3_lcssa_i+20)|0);
 var $491=HEAP32[(($490)>>2)];
 var $492=($491|0)==0;
 if($492){label=107;break;}else{var $R_0_i120=$491;var $RP_0_i119=$490;label=108;break;}
 case 107: 
 var $494=(($v_3_lcssa_i+16)|0);
 var $495=HEAP32[(($494)>>2)];
 var $496=($495|0)==0;
 if($496){var $R_1_i122=0;label=113;break;}else{var $R_0_i120=$495;var $RP_0_i119=$494;label=108;break;}
 case 108: 
 var $RP_0_i119;
 var $R_0_i120;
 var $497=(($R_0_i120+20)|0);
 var $498=HEAP32[(($497)>>2)];
 var $499=($498|0)==0;
 if($499){label=109;break;}else{var $R_0_i120=$498;var $RP_0_i119=$497;label=108;break;}
 case 109: 
 var $501=(($R_0_i120+16)|0);
 var $502=HEAP32[(($501)>>2)];
 var $503=($502|0)==0;
 if($503){label=110;break;}else{var $R_0_i120=$502;var $RP_0_i119=$501;label=108;break;}
 case 110: 
 var $505=$RP_0_i119;
 var $506=($505>>>0)<($463>>>0);
 if($506){label=112;break;}else{label=111;break;}
 case 111: 
 HEAP32[(($RP_0_i119)>>2)]=0;
 var $R_1_i122=$R_0_i120;label=113;break;
 case 112: 
 _abort();
 throw "Reached an unreachable!";
 case 113: 
 var $R_1_i122;
 var $510=($471|0)==0;
 if($510){label=133;break;}else{label=114;break;}
 case 114: 
 var $512=(($v_3_lcssa_i+28)|0);
 var $513=HEAP32[(($512)>>2)];
 var $514=((10976+($513<<2))|0);
 var $515=HEAP32[(($514)>>2)];
 var $516=($v_3_lcssa_i|0)==($515|0);
 if($516){label=115;break;}else{label=117;break;}
 case 115: 
 HEAP32[(($514)>>2)]=$R_1_i122;
 var $cond_i123=($R_1_i122|0)==0;
 if($cond_i123){label=116;break;}else{label=123;break;}
 case 116: 
 var $518=1<<$513;
 var $519=$518^-1;
 var $520=HEAP32[((10676)>>2)];
 var $521=$520&$519;
 HEAP32[((10676)>>2)]=$521;
 label=133;break;
 case 117: 
 var $523=$471;
 var $524=HEAP32[((10688)>>2)];
 var $525=($523>>>0)<($524>>>0);
 if($525){label=121;break;}else{label=118;break;}
 case 118: 
 var $527=(($471+16)|0);
 var $528=HEAP32[(($527)>>2)];
 var $529=($528|0)==($v_3_lcssa_i|0);
 if($529){label=119;break;}else{label=120;break;}
 case 119: 
 HEAP32[(($527)>>2)]=$R_1_i122;
 label=122;break;
 case 120: 
 var $532=(($471+20)|0);
 HEAP32[(($532)>>2)]=$R_1_i122;
 label=122;break;
 case 121: 
 _abort();
 throw "Reached an unreachable!";
 case 122: 
 var $535=($R_1_i122|0)==0;
 if($535){label=133;break;}else{label=123;break;}
 case 123: 
 var $537=$R_1_i122;
 var $538=HEAP32[((10688)>>2)];
 var $539=($537>>>0)<($538>>>0);
 if($539){label=132;break;}else{label=124;break;}
 case 124: 
 var $541=(($R_1_i122+24)|0);
 HEAP32[(($541)>>2)]=$471;
 var $542=(($v_3_lcssa_i+16)|0);
 var $543=HEAP32[(($542)>>2)];
 var $544=($543|0)==0;
 if($544){label=128;break;}else{label=125;break;}
 case 125: 
 var $546=$543;
 var $547=HEAP32[((10688)>>2)];
 var $548=($546>>>0)<($547>>>0);
 if($548){label=127;break;}else{label=126;break;}
 case 126: 
 var $550=(($R_1_i122+16)|0);
 HEAP32[(($550)>>2)]=$543;
 var $551=(($543+24)|0);
 HEAP32[(($551)>>2)]=$R_1_i122;
 label=128;break;
 case 127: 
 _abort();
 throw "Reached an unreachable!";
 case 128: 
 var $554=(($v_3_lcssa_i+20)|0);
 var $555=HEAP32[(($554)>>2)];
 var $556=($555|0)==0;
 if($556){label=133;break;}else{label=129;break;}
 case 129: 
 var $558=$555;
 var $559=HEAP32[((10688)>>2)];
 var $560=($558>>>0)<($559>>>0);
 if($560){label=131;break;}else{label=130;break;}
 case 130: 
 var $562=(($R_1_i122+20)|0);
 HEAP32[(($562)>>2)]=$555;
 var $563=(($555+24)|0);
 HEAP32[(($563)>>2)]=$R_1_i122;
 label=133;break;
 case 131: 
 _abort();
 throw "Reached an unreachable!";
 case 132: 
 _abort();
 throw "Reached an unreachable!";
 case 133: 
 var $567=($rsize_3_lcssa_i>>>0)<16;
 if($567){label=134;break;}else{label=135;break;}
 case 134: 
 var $569=((($rsize_3_lcssa_i)+($348))|0);
 var $570=$569|3;
 var $571=(($v_3_lcssa_i+4)|0);
 HEAP32[(($571)>>2)]=$570;
 var $_sum19_i=((($569)+(4))|0);
 var $572=(($462+$_sum19_i)|0);
 var $573=$572;
 var $574=HEAP32[(($573)>>2)];
 var $575=$574|1;
 HEAP32[(($573)>>2)]=$575;
 label=159;break;
 case 135: 
 var $577=$348|3;
 var $578=(($v_3_lcssa_i+4)|0);
 HEAP32[(($578)>>2)]=$577;
 var $579=$rsize_3_lcssa_i|1;
 var $_sum_i125136=$348|4;
 var $580=(($462+$_sum_i125136)|0);
 var $581=$580;
 HEAP32[(($581)>>2)]=$579;
 var $_sum1_i126=((($rsize_3_lcssa_i)+($348))|0);
 var $582=(($462+$_sum1_i126)|0);
 var $583=$582;
 HEAP32[(($583)>>2)]=$rsize_3_lcssa_i;
 var $584=$rsize_3_lcssa_i>>>3;
 var $585=($rsize_3_lcssa_i>>>0)<256;
 if($585){label=136;break;}else{label=141;break;}
 case 136: 
 var $587=$584<<1;
 var $588=((10712+($587<<2))|0);
 var $589=$588;
 var $590=HEAP32[((10672)>>2)];
 var $591=1<<$584;
 var $592=$590&$591;
 var $593=($592|0)==0;
 if($593){label=137;break;}else{label=138;break;}
 case 137: 
 var $595=$590|$591;
 HEAP32[((10672)>>2)]=$595;
 var $_sum15_pre_i=((($587)+(2))|0);
 var $_pre_i127=((10712+($_sum15_pre_i<<2))|0);
 var $F5_0_i=$589;var $_pre_phi_i128=$_pre_i127;label=140;break;
 case 138: 
 var $_sum18_i=((($587)+(2))|0);
 var $597=((10712+($_sum18_i<<2))|0);
 var $598=HEAP32[(($597)>>2)];
 var $599=$598;
 var $600=HEAP32[((10688)>>2)];
 var $601=($599>>>0)<($600>>>0);
 if($601){label=139;break;}else{var $F5_0_i=$598;var $_pre_phi_i128=$597;label=140;break;}
 case 139: 
 _abort();
 throw "Reached an unreachable!";
 case 140: 
 var $_pre_phi_i128;
 var $F5_0_i;
 HEAP32[(($_pre_phi_i128)>>2)]=$467;
 var $604=(($F5_0_i+12)|0);
 HEAP32[(($604)>>2)]=$467;
 var $_sum16_i=((($348)+(8))|0);
 var $605=(($462+$_sum16_i)|0);
 var $606=$605;
 HEAP32[(($606)>>2)]=$F5_0_i;
 var $_sum17_i=((($348)+(12))|0);
 var $607=(($462+$_sum17_i)|0);
 var $608=$607;
 HEAP32[(($608)>>2)]=$589;
 label=159;break;
 case 141: 
 var $610=$466;
 var $611=$rsize_3_lcssa_i>>>8;
 var $612=($611|0)==0;
 if($612){var $I7_0_i=0;label=144;break;}else{label=142;break;}
 case 142: 
 var $614=($rsize_3_lcssa_i>>>0)>16777215;
 if($614){var $I7_0_i=31;label=144;break;}else{label=143;break;}
 case 143: 
 var $616=((($611)+(1048320))|0);
 var $617=$616>>>16;
 var $618=$617&8;
 var $619=$611<<$618;
 var $620=((($619)+(520192))|0);
 var $621=$620>>>16;
 var $622=$621&4;
 var $623=$622|$618;
 var $624=$619<<$622;
 var $625=((($624)+(245760))|0);
 var $626=$625>>>16;
 var $627=$626&2;
 var $628=$623|$627;
 var $629=(((14)-($628))|0);
 var $630=$624<<$627;
 var $631=$630>>>15;
 var $632=((($629)+($631))|0);
 var $633=$632<<1;
 var $634=((($632)+(7))|0);
 var $635=$rsize_3_lcssa_i>>>($634>>>0);
 var $636=$635&1;
 var $637=$636|$633;
 var $I7_0_i=$637;label=144;break;
 case 144: 
 var $I7_0_i;
 var $639=((10976+($I7_0_i<<2))|0);
 var $_sum2_i=((($348)+(28))|0);
 var $640=(($462+$_sum2_i)|0);
 var $641=$640;
 HEAP32[(($641)>>2)]=$I7_0_i;
 var $_sum3_i129=((($348)+(16))|0);
 var $642=(($462+$_sum3_i129)|0);
 var $_sum4_i130=((($348)+(20))|0);
 var $643=(($462+$_sum4_i130)|0);
 var $644=$643;
 HEAP32[(($644)>>2)]=0;
 var $645=$642;
 HEAP32[(($645)>>2)]=0;
 var $646=HEAP32[((10676)>>2)];
 var $647=1<<$I7_0_i;
 var $648=$646&$647;
 var $649=($648|0)==0;
 if($649){label=145;break;}else{label=146;break;}
 case 145: 
 var $651=$646|$647;
 HEAP32[((10676)>>2)]=$651;
 HEAP32[(($639)>>2)]=$610;
 var $652=$639;
 var $_sum5_i=((($348)+(24))|0);
 var $653=(($462+$_sum5_i)|0);
 var $654=$653;
 HEAP32[(($654)>>2)]=$652;
 var $_sum6_i=((($348)+(12))|0);
 var $655=(($462+$_sum6_i)|0);
 var $656=$655;
 HEAP32[(($656)>>2)]=$610;
 var $_sum7_i=((($348)+(8))|0);
 var $657=(($462+$_sum7_i)|0);
 var $658=$657;
 HEAP32[(($658)>>2)]=$610;
 label=159;break;
 case 146: 
 var $660=HEAP32[(($639)>>2)];
 var $661=($I7_0_i|0)==31;
 if($661){var $666=0;label=148;break;}else{label=147;break;}
 case 147: 
 var $663=$I7_0_i>>>1;
 var $664=(((25)-($663))|0);
 var $666=$664;label=148;break;
 case 148: 
 var $666;
 var $667=$rsize_3_lcssa_i<<$666;
 var $K12_0_i=$667;var $T_0_i=$660;label=149;break;
 case 149: 
 var $T_0_i;
 var $K12_0_i;
 var $669=(($T_0_i+4)|0);
 var $670=HEAP32[(($669)>>2)];
 var $671=$670&-8;
 var $672=($671|0)==($rsize_3_lcssa_i|0);
 if($672){label=154;break;}else{label=150;break;}
 case 150: 
 var $674=$K12_0_i>>>31;
 var $675=(($T_0_i+16+($674<<2))|0);
 var $676=HEAP32[(($675)>>2)];
 var $677=($676|0)==0;
 var $678=$K12_0_i<<1;
 if($677){label=151;break;}else{var $K12_0_i=$678;var $T_0_i=$676;label=149;break;}
 case 151: 
 var $680=$675;
 var $681=HEAP32[((10688)>>2)];
 var $682=($680>>>0)<($681>>>0);
 if($682){label=153;break;}else{label=152;break;}
 case 152: 
 HEAP32[(($675)>>2)]=$610;
 var $_sum12_i=((($348)+(24))|0);
 var $684=(($462+$_sum12_i)|0);
 var $685=$684;
 HEAP32[(($685)>>2)]=$T_0_i;
 var $_sum13_i=((($348)+(12))|0);
 var $686=(($462+$_sum13_i)|0);
 var $687=$686;
 HEAP32[(($687)>>2)]=$610;
 var $_sum14_i=((($348)+(8))|0);
 var $688=(($462+$_sum14_i)|0);
 var $689=$688;
 HEAP32[(($689)>>2)]=$610;
 label=159;break;
 case 153: 
 _abort();
 throw "Reached an unreachable!";
 case 154: 
 var $692=(($T_0_i+8)|0);
 var $693=HEAP32[(($692)>>2)];
 var $694=$T_0_i;
 var $695=HEAP32[((10688)>>2)];
 var $696=($694>>>0)<($695>>>0);
 if($696){label=157;break;}else{label=155;break;}
 case 155: 
 var $698=$693;
 var $699=($698>>>0)<($695>>>0);
 if($699){label=157;break;}else{label=156;break;}
 case 156: 
 var $701=(($693+12)|0);
 HEAP32[(($701)>>2)]=$610;
 HEAP32[(($692)>>2)]=$610;
 var $_sum9_i=((($348)+(8))|0);
 var $702=(($462+$_sum9_i)|0);
 var $703=$702;
 HEAP32[(($703)>>2)]=$693;
 var $_sum10_i=((($348)+(12))|0);
 var $704=(($462+$_sum10_i)|0);
 var $705=$704;
 HEAP32[(($705)>>2)]=$T_0_i;
 var $_sum11_i=((($348)+(24))|0);
 var $706=(($462+$_sum11_i)|0);
 var $707=$706;
 HEAP32[(($707)>>2)]=0;
 label=159;break;
 case 157: 
 _abort();
 throw "Reached an unreachable!";
 case 158: 
 _abort();
 throw "Reached an unreachable!";
 case 159: 
 var $709=(($v_3_lcssa_i+8)|0);
 var $710=$709;
 var $711=($709|0)==0;
 if($711){var $nb_0=$348;label=160;break;}else{var $mem_0=$710;label=341;break;}
 case 160: 
 var $nb_0;
 var $712=HEAP32[((10680)>>2)];
 var $713=($nb_0>>>0)>($712>>>0);
 if($713){label=165;break;}else{label=161;break;}
 case 161: 
 var $715=((($712)-($nb_0))|0);
 var $716=HEAP32[((10692)>>2)];
 var $717=($715>>>0)>15;
 if($717){label=162;break;}else{label=163;break;}
 case 162: 
 var $719=$716;
 var $720=(($719+$nb_0)|0);
 var $721=$720;
 HEAP32[((10692)>>2)]=$721;
 HEAP32[((10680)>>2)]=$715;
 var $722=$715|1;
 var $_sum102=((($nb_0)+(4))|0);
 var $723=(($719+$_sum102)|0);
 var $724=$723;
 HEAP32[(($724)>>2)]=$722;
 var $725=(($719+$712)|0);
 var $726=$725;
 HEAP32[(($726)>>2)]=$715;
 var $727=$nb_0|3;
 var $728=(($716+4)|0);
 HEAP32[(($728)>>2)]=$727;
 label=164;break;
 case 163: 
 HEAP32[((10680)>>2)]=0;
 HEAP32[((10692)>>2)]=0;
 var $730=$712|3;
 var $731=(($716+4)|0);
 HEAP32[(($731)>>2)]=$730;
 var $732=$716;
 var $_sum101=((($712)+(4))|0);
 var $733=(($732+$_sum101)|0);
 var $734=$733;
 var $735=HEAP32[(($734)>>2)];
 var $736=$735|1;
 HEAP32[(($734)>>2)]=$736;
 label=164;break;
 case 164: 
 var $738=(($716+8)|0);
 var $739=$738;
 var $mem_0=$739;label=341;break;
 case 165: 
 var $741=HEAP32[((10684)>>2)];
 var $742=($nb_0>>>0)<($741>>>0);
 if($742){label=166;break;}else{label=167;break;}
 case 166: 
 var $744=((($741)-($nb_0))|0);
 HEAP32[((10684)>>2)]=$744;
 var $745=HEAP32[((10696)>>2)];
 var $746=$745;
 var $747=(($746+$nb_0)|0);
 var $748=$747;
 HEAP32[((10696)>>2)]=$748;
 var $749=$744|1;
 var $_sum=((($nb_0)+(4))|0);
 var $750=(($746+$_sum)|0);
 var $751=$750;
 HEAP32[(($751)>>2)]=$749;
 var $752=$nb_0|3;
 var $753=(($745+4)|0);
 HEAP32[(($753)>>2)]=$752;
 var $754=(($745+8)|0);
 var $755=$754;
 var $mem_0=$755;label=341;break;
 case 167: 
 var $757=HEAP32[((10632)>>2)];
 var $758=($757|0)==0;
 if($758){label=168;break;}else{label=171;break;}
 case 168: 
 var $760=_sysconf(30);
 var $761=((($760)-(1))|0);
 var $762=$761&$760;
 var $763=($762|0)==0;
 if($763){label=170;break;}else{label=169;break;}
 case 169: 
 _abort();
 throw "Reached an unreachable!";
 case 170: 
 HEAP32[((10640)>>2)]=$760;
 HEAP32[((10636)>>2)]=$760;
 HEAP32[((10644)>>2)]=-1;
 HEAP32[((10648)>>2)]=-1;
 HEAP32[((10652)>>2)]=0;
 HEAP32[((11116)>>2)]=0;
 var $765=_time(0);
 var $766=$765&-16;
 var $767=$766^1431655768;
 HEAP32[((10632)>>2)]=$767;
 label=171;break;
 case 171: 
 var $769=((($nb_0)+(48))|0);
 var $770=HEAP32[((10640)>>2)];
 var $771=((($nb_0)+(47))|0);
 var $772=((($770)+($771))|0);
 var $773=(((-$770))|0);
 var $774=$772&$773;
 var $775=($774>>>0)>($nb_0>>>0);
 if($775){label=172;break;}else{var $mem_0=0;label=341;break;}
 case 172: 
 var $777=HEAP32[((11112)>>2)];
 var $778=($777|0)==0;
 if($778){label=174;break;}else{label=173;break;}
 case 173: 
 var $780=HEAP32[((11104)>>2)];
 var $781=((($780)+($774))|0);
 var $782=($781>>>0)<=($780>>>0);
 var $783=($781>>>0)>($777>>>0);
 var $or_cond1_i=$782|$783;
 if($or_cond1_i){var $mem_0=0;label=341;break;}else{label=174;break;}
 case 174: 
 var $785=HEAP32[((11116)>>2)];
 var $786=$785&4;
 var $787=($786|0)==0;
 if($787){label=175;break;}else{var $tsize_1_i=0;label=198;break;}
 case 175: 
 var $789=HEAP32[((10696)>>2)];
 var $790=($789|0)==0;
 if($790){label=181;break;}else{label=176;break;}
 case 176: 
 var $792=$789;
 var $sp_0_i_i=11120;label=177;break;
 case 177: 
 var $sp_0_i_i;
 var $794=(($sp_0_i_i)|0);
 var $795=HEAP32[(($794)>>2)];
 var $796=($795>>>0)>($792>>>0);
 if($796){label=179;break;}else{label=178;break;}
 case 178: 
 var $798=(($sp_0_i_i+4)|0);
 var $799=HEAP32[(($798)>>2)];
 var $800=(($795+$799)|0);
 var $801=($800>>>0)>($792>>>0);
 if($801){label=180;break;}else{label=179;break;}
 case 179: 
 var $803=(($sp_0_i_i+8)|0);
 var $804=HEAP32[(($803)>>2)];
 var $805=($804|0)==0;
 if($805){label=181;break;}else{var $sp_0_i_i=$804;label=177;break;}
 case 180: 
 var $806=($sp_0_i_i|0)==0;
 if($806){label=181;break;}else{label=188;break;}
 case 181: 
 var $807=_sbrk(0);
 var $808=($807|0)==-1;
 if($808){var $tsize_0303639_i=0;label=197;break;}else{label=182;break;}
 case 182: 
 var $810=$807;
 var $811=HEAP32[((10636)>>2)];
 var $812=((($811)-(1))|0);
 var $813=$812&$810;
 var $814=($813|0)==0;
 if($814){var $ssize_0_i=$774;label=184;break;}else{label=183;break;}
 case 183: 
 var $816=((($812)+($810))|0);
 var $817=(((-$811))|0);
 var $818=$816&$817;
 var $819=((($774)-($810))|0);
 var $820=((($819)+($818))|0);
 var $ssize_0_i=$820;label=184;break;
 case 184: 
 var $ssize_0_i;
 var $822=HEAP32[((11104)>>2)];
 var $823=((($822)+($ssize_0_i))|0);
 var $824=($ssize_0_i>>>0)>($nb_0>>>0);
 var $825=($ssize_0_i>>>0)<2147483647;
 var $or_cond_i131=$824&$825;
 if($or_cond_i131){label=185;break;}else{var $tsize_0303639_i=0;label=197;break;}
 case 185: 
 var $827=HEAP32[((11112)>>2)];
 var $828=($827|0)==0;
 if($828){label=187;break;}else{label=186;break;}
 case 186: 
 var $830=($823>>>0)<=($822>>>0);
 var $831=($823>>>0)>($827>>>0);
 var $or_cond2_i=$830|$831;
 if($or_cond2_i){var $tsize_0303639_i=0;label=197;break;}else{label=187;break;}
 case 187: 
 var $833=_sbrk($ssize_0_i);
 var $834=($833|0)==($807|0);
 var $ssize_0__i=($834?$ssize_0_i:0);
 var $__i=($834?$807:-1);
 var $tbase_0_i=$__i;var $tsize_0_i=$ssize_0__i;var $br_0_i=$833;var $ssize_1_i=$ssize_0_i;label=190;break;
 case 188: 
 var $836=HEAP32[((10684)>>2)];
 var $837=((($772)-($836))|0);
 var $838=$837&$773;
 var $839=($838>>>0)<2147483647;
 if($839){label=189;break;}else{var $tsize_0303639_i=0;label=197;break;}
 case 189: 
 var $841=_sbrk($838);
 var $842=HEAP32[(($794)>>2)];
 var $843=HEAP32[(($798)>>2)];
 var $844=(($842+$843)|0);
 var $845=($841|0)==($844|0);
 var $_3_i=($845?$838:0);
 var $_4_i=($845?$841:-1);
 var $tbase_0_i=$_4_i;var $tsize_0_i=$_3_i;var $br_0_i=$841;var $ssize_1_i=$838;label=190;break;
 case 190: 
 var $ssize_1_i;
 var $br_0_i;
 var $tsize_0_i;
 var $tbase_0_i;
 var $847=(((-$ssize_1_i))|0);
 var $848=($tbase_0_i|0)==-1;
 if($848){label=191;break;}else{var $tsize_244_i=$tsize_0_i;var $tbase_245_i=$tbase_0_i;label=201;break;}
 case 191: 
 var $850=($br_0_i|0)!=-1;
 var $851=($ssize_1_i>>>0)<2147483647;
 var $or_cond5_i=$850&$851;
 var $852=($ssize_1_i>>>0)<($769>>>0);
 var $or_cond6_i=$or_cond5_i&$852;
 if($or_cond6_i){label=192;break;}else{var $ssize_2_i=$ssize_1_i;label=196;break;}
 case 192: 
 var $854=HEAP32[((10640)>>2)];
 var $855=((($771)-($ssize_1_i))|0);
 var $856=((($855)+($854))|0);
 var $857=(((-$854))|0);
 var $858=$856&$857;
 var $859=($858>>>0)<2147483647;
 if($859){label=193;break;}else{var $ssize_2_i=$ssize_1_i;label=196;break;}
 case 193: 
 var $861=_sbrk($858);
 var $862=($861|0)==-1;
 if($862){label=195;break;}else{label=194;break;}
 case 194: 
 var $864=((($858)+($ssize_1_i))|0);
 var $ssize_2_i=$864;label=196;break;
 case 195: 
 var $866=_sbrk($847);
 var $tsize_0303639_i=$tsize_0_i;label=197;break;
 case 196: 
 var $ssize_2_i;
 var $868=($br_0_i|0)==-1;
 if($868){var $tsize_0303639_i=$tsize_0_i;label=197;break;}else{var $tsize_244_i=$ssize_2_i;var $tbase_245_i=$br_0_i;label=201;break;}
 case 197: 
 var $tsize_0303639_i;
 var $869=HEAP32[((11116)>>2)];
 var $870=$869|4;
 HEAP32[((11116)>>2)]=$870;
 var $tsize_1_i=$tsize_0303639_i;label=198;break;
 case 198: 
 var $tsize_1_i;
 var $872=($774>>>0)<2147483647;
 if($872){label=199;break;}else{label=340;break;}
 case 199: 
 var $874=_sbrk($774);
 var $875=_sbrk(0);
 var $notlhs_i=($874|0)!=-1;
 var $notrhs_i=($875|0)!=-1;
 var $or_cond8_not_i=$notrhs_i&$notlhs_i;
 var $876=($874>>>0)<($875>>>0);
 var $or_cond9_i=$or_cond8_not_i&$876;
 if($or_cond9_i){label=200;break;}else{label=340;break;}
 case 200: 
 var $877=$875;
 var $878=$874;
 var $879=((($877)-($878))|0);
 var $880=((($nb_0)+(40))|0);
 var $881=($879>>>0)>($880>>>0);
 var $_tsize_1_i=($881?$879:$tsize_1_i);
 var $_tbase_1_i=($881?$874:-1);
 var $882=($_tbase_1_i|0)==-1;
 if($882){label=340;break;}else{var $tsize_244_i=$_tsize_1_i;var $tbase_245_i=$_tbase_1_i;label=201;break;}
 case 201: 
 var $tbase_245_i;
 var $tsize_244_i;
 var $883=HEAP32[((11104)>>2)];
 var $884=((($883)+($tsize_244_i))|0);
 HEAP32[((11104)>>2)]=$884;
 var $885=HEAP32[((11108)>>2)];
 var $886=($884>>>0)>($885>>>0);
 if($886){label=202;break;}else{label=203;break;}
 case 202: 
 HEAP32[((11108)>>2)]=$884;
 label=203;break;
 case 203: 
 var $888=HEAP32[((10696)>>2)];
 var $889=($888|0)==0;
 if($889){label=204;break;}else{var $sp_067_i=11120;label=211;break;}
 case 204: 
 var $891=HEAP32[((10688)>>2)];
 var $892=($891|0)==0;
 var $893=($tbase_245_i>>>0)<($891>>>0);
 var $or_cond10_i=$892|$893;
 if($or_cond10_i){label=205;break;}else{label=206;break;}
 case 205: 
 HEAP32[((10688)>>2)]=$tbase_245_i;
 label=206;break;
 case 206: 
 HEAP32[((11120)>>2)]=$tbase_245_i;
 HEAP32[((11124)>>2)]=$tsize_244_i;
 HEAP32[((11132)>>2)]=0;
 var $895=HEAP32[((10632)>>2)];
 HEAP32[((10708)>>2)]=$895;
 HEAP32[((10704)>>2)]=-1;
 var $i_02_i_i=0;label=207;break;
 case 207: 
 var $i_02_i_i;
 var $897=$i_02_i_i<<1;
 var $898=((10712+($897<<2))|0);
 var $899=$898;
 var $_sum_i_i=((($897)+(3))|0);
 var $900=((10712+($_sum_i_i<<2))|0);
 HEAP32[(($900)>>2)]=$899;
 var $_sum1_i_i=((($897)+(2))|0);
 var $901=((10712+($_sum1_i_i<<2))|0);
 HEAP32[(($901)>>2)]=$899;
 var $902=((($i_02_i_i)+(1))|0);
 var $903=($902>>>0)<32;
 if($903){var $i_02_i_i=$902;label=207;break;}else{label=208;break;}
 case 208: 
 var $904=((($tsize_244_i)-(40))|0);
 var $905=(($tbase_245_i+8)|0);
 var $906=$905;
 var $907=$906&7;
 var $908=($907|0)==0;
 if($908){var $912=0;label=210;break;}else{label=209;break;}
 case 209: 
 var $910=(((-$906))|0);
 var $911=$910&7;
 var $912=$911;label=210;break;
 case 210: 
 var $912;
 var $913=(($tbase_245_i+$912)|0);
 var $914=$913;
 var $915=((($904)-($912))|0);
 HEAP32[((10696)>>2)]=$914;
 HEAP32[((10684)>>2)]=$915;
 var $916=$915|1;
 var $_sum_i14_i=((($912)+(4))|0);
 var $917=(($tbase_245_i+$_sum_i14_i)|0);
 var $918=$917;
 HEAP32[(($918)>>2)]=$916;
 var $_sum2_i_i=((($tsize_244_i)-(36))|0);
 var $919=(($tbase_245_i+$_sum2_i_i)|0);
 var $920=$919;
 HEAP32[(($920)>>2)]=40;
 var $921=HEAP32[((10648)>>2)];
 HEAP32[((10700)>>2)]=$921;
 label=338;break;
 case 211: 
 var $sp_067_i;
 var $922=(($sp_067_i)|0);
 var $923=HEAP32[(($922)>>2)];
 var $924=(($sp_067_i+4)|0);
 var $925=HEAP32[(($924)>>2)];
 var $926=(($923+$925)|0);
 var $927=($tbase_245_i|0)==($926|0);
 if($927){label=213;break;}else{label=212;break;}
 case 212: 
 var $929=(($sp_067_i+8)|0);
 var $930=HEAP32[(($929)>>2)];
 var $931=($930|0)==0;
 if($931){label=218;break;}else{var $sp_067_i=$930;label=211;break;}
 case 213: 
 var $932=(($sp_067_i+12)|0);
 var $933=HEAP32[(($932)>>2)];
 var $934=$933&8;
 var $935=($934|0)==0;
 if($935){label=214;break;}else{label=218;break;}
 case 214: 
 var $937=$888;
 var $938=($937>>>0)>=($923>>>0);
 var $939=($937>>>0)<($tbase_245_i>>>0);
 var $or_cond47_i=$938&$939;
 if($or_cond47_i){label=215;break;}else{label=218;break;}
 case 215: 
 var $941=((($925)+($tsize_244_i))|0);
 HEAP32[(($924)>>2)]=$941;
 var $942=HEAP32[((10684)>>2)];
 var $943=((($942)+($tsize_244_i))|0);
 var $944=(($888+8)|0);
 var $945=$944;
 var $946=$945&7;
 var $947=($946|0)==0;
 if($947){var $951=0;label=217;break;}else{label=216;break;}
 case 216: 
 var $949=(((-$945))|0);
 var $950=$949&7;
 var $951=$950;label=217;break;
 case 217: 
 var $951;
 var $952=(($937+$951)|0);
 var $953=$952;
 var $954=((($943)-($951))|0);
 HEAP32[((10696)>>2)]=$953;
 HEAP32[((10684)>>2)]=$954;
 var $955=$954|1;
 var $_sum_i18_i=((($951)+(4))|0);
 var $956=(($937+$_sum_i18_i)|0);
 var $957=$956;
 HEAP32[(($957)>>2)]=$955;
 var $_sum2_i19_i=((($943)+(4))|0);
 var $958=(($937+$_sum2_i19_i)|0);
 var $959=$958;
 HEAP32[(($959)>>2)]=40;
 var $960=HEAP32[((10648)>>2)];
 HEAP32[((10700)>>2)]=$960;
 label=338;break;
 case 218: 
 var $961=HEAP32[((10688)>>2)];
 var $962=($tbase_245_i>>>0)<($961>>>0);
 if($962){label=219;break;}else{label=220;break;}
 case 219: 
 HEAP32[((10688)>>2)]=$tbase_245_i;
 label=220;break;
 case 220: 
 var $964=(($tbase_245_i+$tsize_244_i)|0);
 var $sp_160_i=11120;label=221;break;
 case 221: 
 var $sp_160_i;
 var $966=(($sp_160_i)|0);
 var $967=HEAP32[(($966)>>2)];
 var $968=($967|0)==($964|0);
 if($968){label=223;break;}else{label=222;break;}
 case 222: 
 var $970=(($sp_160_i+8)|0);
 var $971=HEAP32[(($970)>>2)];
 var $972=($971|0)==0;
 if($972){label=304;break;}else{var $sp_160_i=$971;label=221;break;}
 case 223: 
 var $973=(($sp_160_i+12)|0);
 var $974=HEAP32[(($973)>>2)];
 var $975=$974&8;
 var $976=($975|0)==0;
 if($976){label=224;break;}else{label=304;break;}
 case 224: 
 HEAP32[(($966)>>2)]=$tbase_245_i;
 var $978=(($sp_160_i+4)|0);
 var $979=HEAP32[(($978)>>2)];
 var $980=((($979)+($tsize_244_i))|0);
 HEAP32[(($978)>>2)]=$980;
 var $981=(($tbase_245_i+8)|0);
 var $982=$981;
 var $983=$982&7;
 var $984=($983|0)==0;
 if($984){var $989=0;label=226;break;}else{label=225;break;}
 case 225: 
 var $986=(((-$982))|0);
 var $987=$986&7;
 var $989=$987;label=226;break;
 case 226: 
 var $989;
 var $990=(($tbase_245_i+$989)|0);
 var $_sum93_i=((($tsize_244_i)+(8))|0);
 var $991=(($tbase_245_i+$_sum93_i)|0);
 var $992=$991;
 var $993=$992&7;
 var $994=($993|0)==0;
 if($994){var $999=0;label=228;break;}else{label=227;break;}
 case 227: 
 var $996=(((-$992))|0);
 var $997=$996&7;
 var $999=$997;label=228;break;
 case 228: 
 var $999;
 var $_sum94_i=((($999)+($tsize_244_i))|0);
 var $1000=(($tbase_245_i+$_sum94_i)|0);
 var $1001=$1000;
 var $1002=$1000;
 var $1003=$990;
 var $1004=((($1002)-($1003))|0);
 var $_sum_i21_i=((($989)+($nb_0))|0);
 var $1005=(($tbase_245_i+$_sum_i21_i)|0);
 var $1006=$1005;
 var $1007=((($1004)-($nb_0))|0);
 var $1008=$nb_0|3;
 var $_sum1_i22_i=((($989)+(4))|0);
 var $1009=(($tbase_245_i+$_sum1_i22_i)|0);
 var $1010=$1009;
 HEAP32[(($1010)>>2)]=$1008;
 var $1011=HEAP32[((10696)>>2)];
 var $1012=($1001|0)==($1011|0);
 if($1012){label=229;break;}else{label=230;break;}
 case 229: 
 var $1014=HEAP32[((10684)>>2)];
 var $1015=((($1014)+($1007))|0);
 HEAP32[((10684)>>2)]=$1015;
 HEAP32[((10696)>>2)]=$1006;
 var $1016=$1015|1;
 var $_sum46_i_i=((($_sum_i21_i)+(4))|0);
 var $1017=(($tbase_245_i+$_sum46_i_i)|0);
 var $1018=$1017;
 HEAP32[(($1018)>>2)]=$1016;
 label=303;break;
 case 230: 
 var $1020=HEAP32[((10692)>>2)];
 var $1021=($1001|0)==($1020|0);
 if($1021){label=231;break;}else{label=232;break;}
 case 231: 
 var $1023=HEAP32[((10680)>>2)];
 var $1024=((($1023)+($1007))|0);
 HEAP32[((10680)>>2)]=$1024;
 HEAP32[((10692)>>2)]=$1006;
 var $1025=$1024|1;
 var $_sum44_i_i=((($_sum_i21_i)+(4))|0);
 var $1026=(($tbase_245_i+$_sum44_i_i)|0);
 var $1027=$1026;
 HEAP32[(($1027)>>2)]=$1025;
 var $_sum45_i_i=((($1024)+($_sum_i21_i))|0);
 var $1028=(($tbase_245_i+$_sum45_i_i)|0);
 var $1029=$1028;
 HEAP32[(($1029)>>2)]=$1024;
 label=303;break;
 case 232: 
 var $_sum2_i23_i=((($tsize_244_i)+(4))|0);
 var $_sum95_i=((($_sum2_i23_i)+($999))|0);
 var $1031=(($tbase_245_i+$_sum95_i)|0);
 var $1032=$1031;
 var $1033=HEAP32[(($1032)>>2)];
 var $1034=$1033&3;
 var $1035=($1034|0)==1;
 if($1035){label=233;break;}else{var $oldfirst_0_i_i=$1001;var $qsize_0_i_i=$1007;label=280;break;}
 case 233: 
 var $1037=$1033&-8;
 var $1038=$1033>>>3;
 var $1039=($1033>>>0)<256;
 if($1039){label=234;break;}else{label=246;break;}
 case 234: 
 var $_sum3940_i_i=$999|8;
 var $_sum105_i=((($_sum3940_i_i)+($tsize_244_i))|0);
 var $1041=(($tbase_245_i+$_sum105_i)|0);
 var $1042=$1041;
 var $1043=HEAP32[(($1042)>>2)];
 var $_sum41_i_i=((($tsize_244_i)+(12))|0);
 var $_sum106_i=((($_sum41_i_i)+($999))|0);
 var $1044=(($tbase_245_i+$_sum106_i)|0);
 var $1045=$1044;
 var $1046=HEAP32[(($1045)>>2)];
 var $1047=$1038<<1;
 var $1048=((10712+($1047<<2))|0);
 var $1049=$1048;
 var $1050=($1043|0)==($1049|0);
 if($1050){label=237;break;}else{label=235;break;}
 case 235: 
 var $1052=$1043;
 var $1053=HEAP32[((10688)>>2)];
 var $1054=($1052>>>0)<($1053>>>0);
 if($1054){label=245;break;}else{label=236;break;}
 case 236: 
 var $1056=(($1043+12)|0);
 var $1057=HEAP32[(($1056)>>2)];
 var $1058=($1057|0)==($1001|0);
 if($1058){label=237;break;}else{label=245;break;}
 case 237: 
 var $1059=($1046|0)==($1043|0);
 if($1059){label=238;break;}else{label=239;break;}
 case 238: 
 var $1061=1<<$1038;
 var $1062=$1061^-1;
 var $1063=HEAP32[((10672)>>2)];
 var $1064=$1063&$1062;
 HEAP32[((10672)>>2)]=$1064;
 label=279;break;
 case 239: 
 var $1066=($1046|0)==($1049|0);
 if($1066){label=240;break;}else{label=241;break;}
 case 240: 
 var $_pre56_i_i=(($1046+8)|0);
 var $_pre_phi57_i_i=$_pre56_i_i;label=243;break;
 case 241: 
 var $1068=$1046;
 var $1069=HEAP32[((10688)>>2)];
 var $1070=($1068>>>0)<($1069>>>0);
 if($1070){label=244;break;}else{label=242;break;}
 case 242: 
 var $1072=(($1046+8)|0);
 var $1073=HEAP32[(($1072)>>2)];
 var $1074=($1073|0)==($1001|0);
 if($1074){var $_pre_phi57_i_i=$1072;label=243;break;}else{label=244;break;}
 case 243: 
 var $_pre_phi57_i_i;
 var $1075=(($1043+12)|0);
 HEAP32[(($1075)>>2)]=$1046;
 HEAP32[(($_pre_phi57_i_i)>>2)]=$1043;
 label=279;break;
 case 244: 
 _abort();
 throw "Reached an unreachable!";
 case 245: 
 _abort();
 throw "Reached an unreachable!";
 case 246: 
 var $1077=$1000;
 var $_sum34_i_i=$999|24;
 var $_sum96_i=((($_sum34_i_i)+($tsize_244_i))|0);
 var $1078=(($tbase_245_i+$_sum96_i)|0);
 var $1079=$1078;
 var $1080=HEAP32[(($1079)>>2)];
 var $_sum5_i_i=((($tsize_244_i)+(12))|0);
 var $_sum97_i=((($_sum5_i_i)+($999))|0);
 var $1081=(($tbase_245_i+$_sum97_i)|0);
 var $1082=$1081;
 var $1083=HEAP32[(($1082)>>2)];
 var $1084=($1083|0)==($1077|0);
 if($1084){label=252;break;}else{label=247;break;}
 case 247: 
 var $_sum3637_i_i=$999|8;
 var $_sum98_i=((($_sum3637_i_i)+($tsize_244_i))|0);
 var $1086=(($tbase_245_i+$_sum98_i)|0);
 var $1087=$1086;
 var $1088=HEAP32[(($1087)>>2)];
 var $1089=$1088;
 var $1090=HEAP32[((10688)>>2)];
 var $1091=($1089>>>0)<($1090>>>0);
 if($1091){label=251;break;}else{label=248;break;}
 case 248: 
 var $1093=(($1088+12)|0);
 var $1094=HEAP32[(($1093)>>2)];
 var $1095=($1094|0)==($1077|0);
 if($1095){label=249;break;}else{label=251;break;}
 case 249: 
 var $1097=(($1083+8)|0);
 var $1098=HEAP32[(($1097)>>2)];
 var $1099=($1098|0)==($1077|0);
 if($1099){label=250;break;}else{label=251;break;}
 case 250: 
 HEAP32[(($1093)>>2)]=$1083;
 HEAP32[(($1097)>>2)]=$1088;
 var $R_1_i_i=$1083;label=259;break;
 case 251: 
 _abort();
 throw "Reached an unreachable!";
 case 252: 
 var $_sum67_i_i=$999|16;
 var $_sum103_i=((($_sum2_i23_i)+($_sum67_i_i))|0);
 var $1102=(($tbase_245_i+$_sum103_i)|0);
 var $1103=$1102;
 var $1104=HEAP32[(($1103)>>2)];
 var $1105=($1104|0)==0;
 if($1105){label=253;break;}else{var $R_0_i_i=$1104;var $RP_0_i_i=$1103;label=254;break;}
 case 253: 
 var $_sum104_i=((($_sum67_i_i)+($tsize_244_i))|0);
 var $1107=(($tbase_245_i+$_sum104_i)|0);
 var $1108=$1107;
 var $1109=HEAP32[(($1108)>>2)];
 var $1110=($1109|0)==0;
 if($1110){var $R_1_i_i=0;label=259;break;}else{var $R_0_i_i=$1109;var $RP_0_i_i=$1108;label=254;break;}
 case 254: 
 var $RP_0_i_i;
 var $R_0_i_i;
 var $1111=(($R_0_i_i+20)|0);
 var $1112=HEAP32[(($1111)>>2)];
 var $1113=($1112|0)==0;
 if($1113){label=255;break;}else{var $R_0_i_i=$1112;var $RP_0_i_i=$1111;label=254;break;}
 case 255: 
 var $1115=(($R_0_i_i+16)|0);
 var $1116=HEAP32[(($1115)>>2)];
 var $1117=($1116|0)==0;
 if($1117){label=256;break;}else{var $R_0_i_i=$1116;var $RP_0_i_i=$1115;label=254;break;}
 case 256: 
 var $1119=$RP_0_i_i;
 var $1120=HEAP32[((10688)>>2)];
 var $1121=($1119>>>0)<($1120>>>0);
 if($1121){label=258;break;}else{label=257;break;}
 case 257: 
 HEAP32[(($RP_0_i_i)>>2)]=0;
 var $R_1_i_i=$R_0_i_i;label=259;break;
 case 258: 
 _abort();
 throw "Reached an unreachable!";
 case 259: 
 var $R_1_i_i;
 var $1125=($1080|0)==0;
 if($1125){label=279;break;}else{label=260;break;}
 case 260: 
 var $_sum31_i_i=((($tsize_244_i)+(28))|0);
 var $_sum99_i=((($_sum31_i_i)+($999))|0);
 var $1127=(($tbase_245_i+$_sum99_i)|0);
 var $1128=$1127;
 var $1129=HEAP32[(($1128)>>2)];
 var $1130=((10976+($1129<<2))|0);
 var $1131=HEAP32[(($1130)>>2)];
 var $1132=($1077|0)==($1131|0);
 if($1132){label=261;break;}else{label=263;break;}
 case 261: 
 HEAP32[(($1130)>>2)]=$R_1_i_i;
 var $cond_i_i=($R_1_i_i|0)==0;
 if($cond_i_i){label=262;break;}else{label=269;break;}
 case 262: 
 var $1134=1<<$1129;
 var $1135=$1134^-1;
 var $1136=HEAP32[((10676)>>2)];
 var $1137=$1136&$1135;
 HEAP32[((10676)>>2)]=$1137;
 label=279;break;
 case 263: 
 var $1139=$1080;
 var $1140=HEAP32[((10688)>>2)];
 var $1141=($1139>>>0)<($1140>>>0);
 if($1141){label=267;break;}else{label=264;break;}
 case 264: 
 var $1143=(($1080+16)|0);
 var $1144=HEAP32[(($1143)>>2)];
 var $1145=($1144|0)==($1077|0);
 if($1145){label=265;break;}else{label=266;break;}
 case 265: 
 HEAP32[(($1143)>>2)]=$R_1_i_i;
 label=268;break;
 case 266: 
 var $1148=(($1080+20)|0);
 HEAP32[(($1148)>>2)]=$R_1_i_i;
 label=268;break;
 case 267: 
 _abort();
 throw "Reached an unreachable!";
 case 268: 
 var $1151=($R_1_i_i|0)==0;
 if($1151){label=279;break;}else{label=269;break;}
 case 269: 
 var $1153=$R_1_i_i;
 var $1154=HEAP32[((10688)>>2)];
 var $1155=($1153>>>0)<($1154>>>0);
 if($1155){label=278;break;}else{label=270;break;}
 case 270: 
 var $1157=(($R_1_i_i+24)|0);
 HEAP32[(($1157)>>2)]=$1080;
 var $_sum3233_i_i=$999|16;
 var $_sum100_i=((($_sum3233_i_i)+($tsize_244_i))|0);
 var $1158=(($tbase_245_i+$_sum100_i)|0);
 var $1159=$1158;
 var $1160=HEAP32[(($1159)>>2)];
 var $1161=($1160|0)==0;
 if($1161){label=274;break;}else{label=271;break;}
 case 271: 
 var $1163=$1160;
 var $1164=HEAP32[((10688)>>2)];
 var $1165=($1163>>>0)<($1164>>>0);
 if($1165){label=273;break;}else{label=272;break;}
 case 272: 
 var $1167=(($R_1_i_i+16)|0);
 HEAP32[(($1167)>>2)]=$1160;
 var $1168=(($1160+24)|0);
 HEAP32[(($1168)>>2)]=$R_1_i_i;
 label=274;break;
 case 273: 
 _abort();
 throw "Reached an unreachable!";
 case 274: 
 var $_sum101_i=((($_sum2_i23_i)+($_sum3233_i_i))|0);
 var $1171=(($tbase_245_i+$_sum101_i)|0);
 var $1172=$1171;
 var $1173=HEAP32[(($1172)>>2)];
 var $1174=($1173|0)==0;
 if($1174){label=279;break;}else{label=275;break;}
 case 275: 
 var $1176=$1173;
 var $1177=HEAP32[((10688)>>2)];
 var $1178=($1176>>>0)<($1177>>>0);
 if($1178){label=277;break;}else{label=276;break;}
 case 276: 
 var $1180=(($R_1_i_i+20)|0);
 HEAP32[(($1180)>>2)]=$1173;
 var $1181=(($1173+24)|0);
 HEAP32[(($1181)>>2)]=$R_1_i_i;
 label=279;break;
 case 277: 
 _abort();
 throw "Reached an unreachable!";
 case 278: 
 _abort();
 throw "Reached an unreachable!";
 case 279: 
 var $_sum9_i_i=$1037|$999;
 var $_sum102_i=((($_sum9_i_i)+($tsize_244_i))|0);
 var $1185=(($tbase_245_i+$_sum102_i)|0);
 var $1186=$1185;
 var $1187=((($1037)+($1007))|0);
 var $oldfirst_0_i_i=$1186;var $qsize_0_i_i=$1187;label=280;break;
 case 280: 
 var $qsize_0_i_i;
 var $oldfirst_0_i_i;
 var $1189=(($oldfirst_0_i_i+4)|0);
 var $1190=HEAP32[(($1189)>>2)];
 var $1191=$1190&-2;
 HEAP32[(($1189)>>2)]=$1191;
 var $1192=$qsize_0_i_i|1;
 var $_sum10_i_i=((($_sum_i21_i)+(4))|0);
 var $1193=(($tbase_245_i+$_sum10_i_i)|0);
 var $1194=$1193;
 HEAP32[(($1194)>>2)]=$1192;
 var $_sum11_i_i=((($qsize_0_i_i)+($_sum_i21_i))|0);
 var $1195=(($tbase_245_i+$_sum11_i_i)|0);
 var $1196=$1195;
 HEAP32[(($1196)>>2)]=$qsize_0_i_i;
 var $1197=$qsize_0_i_i>>>3;
 var $1198=($qsize_0_i_i>>>0)<256;
 if($1198){label=281;break;}else{label=286;break;}
 case 281: 
 var $1200=$1197<<1;
 var $1201=((10712+($1200<<2))|0);
 var $1202=$1201;
 var $1203=HEAP32[((10672)>>2)];
 var $1204=1<<$1197;
 var $1205=$1203&$1204;
 var $1206=($1205|0)==0;
 if($1206){label=282;break;}else{label=283;break;}
 case 282: 
 var $1208=$1203|$1204;
 HEAP32[((10672)>>2)]=$1208;
 var $_sum27_pre_i_i=((($1200)+(2))|0);
 var $_pre_i24_i=((10712+($_sum27_pre_i_i<<2))|0);
 var $F4_0_i_i=$1202;var $_pre_phi_i25_i=$_pre_i24_i;label=285;break;
 case 283: 
 var $_sum30_i_i=((($1200)+(2))|0);
 var $1210=((10712+($_sum30_i_i<<2))|0);
 var $1211=HEAP32[(($1210)>>2)];
 var $1212=$1211;
 var $1213=HEAP32[((10688)>>2)];
 var $1214=($1212>>>0)<($1213>>>0);
 if($1214){label=284;break;}else{var $F4_0_i_i=$1211;var $_pre_phi_i25_i=$1210;label=285;break;}
 case 284: 
 _abort();
 throw "Reached an unreachable!";
 case 285: 
 var $_pre_phi_i25_i;
 var $F4_0_i_i;
 HEAP32[(($_pre_phi_i25_i)>>2)]=$1006;
 var $1217=(($F4_0_i_i+12)|0);
 HEAP32[(($1217)>>2)]=$1006;
 var $_sum28_i_i=((($_sum_i21_i)+(8))|0);
 var $1218=(($tbase_245_i+$_sum28_i_i)|0);
 var $1219=$1218;
 HEAP32[(($1219)>>2)]=$F4_0_i_i;
 var $_sum29_i_i=((($_sum_i21_i)+(12))|0);
 var $1220=(($tbase_245_i+$_sum29_i_i)|0);
 var $1221=$1220;
 HEAP32[(($1221)>>2)]=$1202;
 label=303;break;
 case 286: 
 var $1223=$1005;
 var $1224=$qsize_0_i_i>>>8;
 var $1225=($1224|0)==0;
 if($1225){var $I7_0_i_i=0;label=289;break;}else{label=287;break;}
 case 287: 
 var $1227=($qsize_0_i_i>>>0)>16777215;
 if($1227){var $I7_0_i_i=31;label=289;break;}else{label=288;break;}
 case 288: 
 var $1229=((($1224)+(1048320))|0);
 var $1230=$1229>>>16;
 var $1231=$1230&8;
 var $1232=$1224<<$1231;
 var $1233=((($1232)+(520192))|0);
 var $1234=$1233>>>16;
 var $1235=$1234&4;
 var $1236=$1235|$1231;
 var $1237=$1232<<$1235;
 var $1238=((($1237)+(245760))|0);
 var $1239=$1238>>>16;
 var $1240=$1239&2;
 var $1241=$1236|$1240;
 var $1242=(((14)-($1241))|0);
 var $1243=$1237<<$1240;
 var $1244=$1243>>>15;
 var $1245=((($1242)+($1244))|0);
 var $1246=$1245<<1;
 var $1247=((($1245)+(7))|0);
 var $1248=$qsize_0_i_i>>>($1247>>>0);
 var $1249=$1248&1;
 var $1250=$1249|$1246;
 var $I7_0_i_i=$1250;label=289;break;
 case 289: 
 var $I7_0_i_i;
 var $1252=((10976+($I7_0_i_i<<2))|0);
 var $_sum12_i26_i=((($_sum_i21_i)+(28))|0);
 var $1253=(($tbase_245_i+$_sum12_i26_i)|0);
 var $1254=$1253;
 HEAP32[(($1254)>>2)]=$I7_0_i_i;
 var $_sum13_i_i=((($_sum_i21_i)+(16))|0);
 var $1255=(($tbase_245_i+$_sum13_i_i)|0);
 var $_sum14_i_i=((($_sum_i21_i)+(20))|0);
 var $1256=(($tbase_245_i+$_sum14_i_i)|0);
 var $1257=$1256;
 HEAP32[(($1257)>>2)]=0;
 var $1258=$1255;
 HEAP32[(($1258)>>2)]=0;
 var $1259=HEAP32[((10676)>>2)];
 var $1260=1<<$I7_0_i_i;
 var $1261=$1259&$1260;
 var $1262=($1261|0)==0;
 if($1262){label=290;break;}else{label=291;break;}
 case 290: 
 var $1264=$1259|$1260;
 HEAP32[((10676)>>2)]=$1264;
 HEAP32[(($1252)>>2)]=$1223;
 var $1265=$1252;
 var $_sum15_i_i=((($_sum_i21_i)+(24))|0);
 var $1266=(($tbase_245_i+$_sum15_i_i)|0);
 var $1267=$1266;
 HEAP32[(($1267)>>2)]=$1265;
 var $_sum16_i_i=((($_sum_i21_i)+(12))|0);
 var $1268=(($tbase_245_i+$_sum16_i_i)|0);
 var $1269=$1268;
 HEAP32[(($1269)>>2)]=$1223;
 var $_sum17_i_i=((($_sum_i21_i)+(8))|0);
 var $1270=(($tbase_245_i+$_sum17_i_i)|0);
 var $1271=$1270;
 HEAP32[(($1271)>>2)]=$1223;
 label=303;break;
 case 291: 
 var $1273=HEAP32[(($1252)>>2)];
 var $1274=($I7_0_i_i|0)==31;
 if($1274){var $1279=0;label=293;break;}else{label=292;break;}
 case 292: 
 var $1276=$I7_0_i_i>>>1;
 var $1277=(((25)-($1276))|0);
 var $1279=$1277;label=293;break;
 case 293: 
 var $1279;
 var $1280=$qsize_0_i_i<<$1279;
 var $K8_0_i_i=$1280;var $T_0_i27_i=$1273;label=294;break;
 case 294: 
 var $T_0_i27_i;
 var $K8_0_i_i;
 var $1282=(($T_0_i27_i+4)|0);
 var $1283=HEAP32[(($1282)>>2)];
 var $1284=$1283&-8;
 var $1285=($1284|0)==($qsize_0_i_i|0);
 if($1285){label=299;break;}else{label=295;break;}
 case 295: 
 var $1287=$K8_0_i_i>>>31;
 var $1288=(($T_0_i27_i+16+($1287<<2))|0);
 var $1289=HEAP32[(($1288)>>2)];
 var $1290=($1289|0)==0;
 var $1291=$K8_0_i_i<<1;
 if($1290){label=296;break;}else{var $K8_0_i_i=$1291;var $T_0_i27_i=$1289;label=294;break;}
 case 296: 
 var $1293=$1288;
 var $1294=HEAP32[((10688)>>2)];
 var $1295=($1293>>>0)<($1294>>>0);
 if($1295){label=298;break;}else{label=297;break;}
 case 297: 
 HEAP32[(($1288)>>2)]=$1223;
 var $_sum24_i_i=((($_sum_i21_i)+(24))|0);
 var $1297=(($tbase_245_i+$_sum24_i_i)|0);
 var $1298=$1297;
 HEAP32[(($1298)>>2)]=$T_0_i27_i;
 var $_sum25_i_i=((($_sum_i21_i)+(12))|0);
 var $1299=(($tbase_245_i+$_sum25_i_i)|0);
 var $1300=$1299;
 HEAP32[(($1300)>>2)]=$1223;
 var $_sum26_i_i=((($_sum_i21_i)+(8))|0);
 var $1301=(($tbase_245_i+$_sum26_i_i)|0);
 var $1302=$1301;
 HEAP32[(($1302)>>2)]=$1223;
 label=303;break;
 case 298: 
 _abort();
 throw "Reached an unreachable!";
 case 299: 
 var $1305=(($T_0_i27_i+8)|0);
 var $1306=HEAP32[(($1305)>>2)];
 var $1307=$T_0_i27_i;
 var $1308=HEAP32[((10688)>>2)];
 var $1309=($1307>>>0)<($1308>>>0);
 if($1309){label=302;break;}else{label=300;break;}
 case 300: 
 var $1311=$1306;
 var $1312=($1311>>>0)<($1308>>>0);
 if($1312){label=302;break;}else{label=301;break;}
 case 301: 
 var $1314=(($1306+12)|0);
 HEAP32[(($1314)>>2)]=$1223;
 HEAP32[(($1305)>>2)]=$1223;
 var $_sum21_i_i=((($_sum_i21_i)+(8))|0);
 var $1315=(($tbase_245_i+$_sum21_i_i)|0);
 var $1316=$1315;
 HEAP32[(($1316)>>2)]=$1306;
 var $_sum22_i_i=((($_sum_i21_i)+(12))|0);
 var $1317=(($tbase_245_i+$_sum22_i_i)|0);
 var $1318=$1317;
 HEAP32[(($1318)>>2)]=$T_0_i27_i;
 var $_sum23_i_i=((($_sum_i21_i)+(24))|0);
 var $1319=(($tbase_245_i+$_sum23_i_i)|0);
 var $1320=$1319;
 HEAP32[(($1320)>>2)]=0;
 label=303;break;
 case 302: 
 _abort();
 throw "Reached an unreachable!";
 case 303: 
 var $_sum1819_i_i=$989|8;
 var $1321=(($tbase_245_i+$_sum1819_i_i)|0);
 var $mem_0=$1321;label=341;break;
 case 304: 
 var $1322=$888;
 var $sp_0_i_i_i=11120;label=305;break;
 case 305: 
 var $sp_0_i_i_i;
 var $1324=(($sp_0_i_i_i)|0);
 var $1325=HEAP32[(($1324)>>2)];
 var $1326=($1325>>>0)>($1322>>>0);
 if($1326){label=307;break;}else{label=306;break;}
 case 306: 
 var $1328=(($sp_0_i_i_i+4)|0);
 var $1329=HEAP32[(($1328)>>2)];
 var $1330=(($1325+$1329)|0);
 var $1331=($1330>>>0)>($1322>>>0);
 if($1331){label=308;break;}else{label=307;break;}
 case 307: 
 var $1333=(($sp_0_i_i_i+8)|0);
 var $1334=HEAP32[(($1333)>>2)];
 var $sp_0_i_i_i=$1334;label=305;break;
 case 308: 
 var $_sum_i15_i=((($1329)-(47))|0);
 var $_sum1_i16_i=((($1329)-(39))|0);
 var $1335=(($1325+$_sum1_i16_i)|0);
 var $1336=$1335;
 var $1337=$1336&7;
 var $1338=($1337|0)==0;
 if($1338){var $1343=0;label=310;break;}else{label=309;break;}
 case 309: 
 var $1340=(((-$1336))|0);
 var $1341=$1340&7;
 var $1343=$1341;label=310;break;
 case 310: 
 var $1343;
 var $_sum2_i17_i=((($_sum_i15_i)+($1343))|0);
 var $1344=(($1325+$_sum2_i17_i)|0);
 var $1345=(($888+16)|0);
 var $1346=$1345;
 var $1347=($1344>>>0)<($1346>>>0);
 var $1348=($1347?$1322:$1344);
 var $1349=(($1348+8)|0);
 var $1350=$1349;
 var $1351=((($tsize_244_i)-(40))|0);
 var $1352=(($tbase_245_i+8)|0);
 var $1353=$1352;
 var $1354=$1353&7;
 var $1355=($1354|0)==0;
 if($1355){var $1359=0;label=312;break;}else{label=311;break;}
 case 311: 
 var $1357=(((-$1353))|0);
 var $1358=$1357&7;
 var $1359=$1358;label=312;break;
 case 312: 
 var $1359;
 var $1360=(($tbase_245_i+$1359)|0);
 var $1361=$1360;
 var $1362=((($1351)-($1359))|0);
 HEAP32[((10696)>>2)]=$1361;
 HEAP32[((10684)>>2)]=$1362;
 var $1363=$1362|1;
 var $_sum_i_i_i=((($1359)+(4))|0);
 var $1364=(($tbase_245_i+$_sum_i_i_i)|0);
 var $1365=$1364;
 HEAP32[(($1365)>>2)]=$1363;
 var $_sum2_i_i_i=((($tsize_244_i)-(36))|0);
 var $1366=(($tbase_245_i+$_sum2_i_i_i)|0);
 var $1367=$1366;
 HEAP32[(($1367)>>2)]=40;
 var $1368=HEAP32[((10648)>>2)];
 HEAP32[((10700)>>2)]=$1368;
 var $1369=(($1348+4)|0);
 var $1370=$1369;
 HEAP32[(($1370)>>2)]=27;
 assert(16 % 1 === 0);HEAP32[(($1349)>>2)]=HEAP32[((11120)>>2)];HEAP32[((($1349)+(4))>>2)]=HEAP32[((11124)>>2)];HEAP32[((($1349)+(8))>>2)]=HEAP32[((11128)>>2)];HEAP32[((($1349)+(12))>>2)]=HEAP32[((11132)>>2)];
 HEAP32[((11120)>>2)]=$tbase_245_i;
 HEAP32[((11124)>>2)]=$tsize_244_i;
 HEAP32[((11132)>>2)]=0;
 HEAP32[((11128)>>2)]=$1350;
 var $1371=(($1348+28)|0);
 var $1372=$1371;
 HEAP32[(($1372)>>2)]=7;
 var $1373=(($1348+32)|0);
 var $1374=($1373>>>0)<($1330>>>0);
 if($1374){var $1375=$1372;label=313;break;}else{label=314;break;}
 case 313: 
 var $1375;
 var $1376=(($1375+4)|0);
 HEAP32[(($1376)>>2)]=7;
 var $1377=(($1375+8)|0);
 var $1378=$1377;
 var $1379=($1378>>>0)<($1330>>>0);
 if($1379){var $1375=$1376;label=313;break;}else{label=314;break;}
 case 314: 
 var $1380=($1348|0)==($1322|0);
 if($1380){label=338;break;}else{label=315;break;}
 case 315: 
 var $1382=$1348;
 var $1383=$888;
 var $1384=((($1382)-($1383))|0);
 var $1385=(($1322+$1384)|0);
 var $_sum3_i_i=((($1384)+(4))|0);
 var $1386=(($1322+$_sum3_i_i)|0);
 var $1387=$1386;
 var $1388=HEAP32[(($1387)>>2)];
 var $1389=$1388&-2;
 HEAP32[(($1387)>>2)]=$1389;
 var $1390=$1384|1;
 var $1391=(($888+4)|0);
 HEAP32[(($1391)>>2)]=$1390;
 var $1392=$1385;
 HEAP32[(($1392)>>2)]=$1384;
 var $1393=$1384>>>3;
 var $1394=($1384>>>0)<256;
 if($1394){label=316;break;}else{label=321;break;}
 case 316: 
 var $1396=$1393<<1;
 var $1397=((10712+($1396<<2))|0);
 var $1398=$1397;
 var $1399=HEAP32[((10672)>>2)];
 var $1400=1<<$1393;
 var $1401=$1399&$1400;
 var $1402=($1401|0)==0;
 if($1402){label=317;break;}else{label=318;break;}
 case 317: 
 var $1404=$1399|$1400;
 HEAP32[((10672)>>2)]=$1404;
 var $_sum11_pre_i_i=((($1396)+(2))|0);
 var $_pre_i_i=((10712+($_sum11_pre_i_i<<2))|0);
 var $F_0_i_i=$1398;var $_pre_phi_i_i=$_pre_i_i;label=320;break;
 case 318: 
 var $_sum12_i_i=((($1396)+(2))|0);
 var $1406=((10712+($_sum12_i_i<<2))|0);
 var $1407=HEAP32[(($1406)>>2)];
 var $1408=$1407;
 var $1409=HEAP32[((10688)>>2)];
 var $1410=($1408>>>0)<($1409>>>0);
 if($1410){label=319;break;}else{var $F_0_i_i=$1407;var $_pre_phi_i_i=$1406;label=320;break;}
 case 319: 
 _abort();
 throw "Reached an unreachable!";
 case 320: 
 var $_pre_phi_i_i;
 var $F_0_i_i;
 HEAP32[(($_pre_phi_i_i)>>2)]=$888;
 var $1413=(($F_0_i_i+12)|0);
 HEAP32[(($1413)>>2)]=$888;
 var $1414=(($888+8)|0);
 HEAP32[(($1414)>>2)]=$F_0_i_i;
 var $1415=(($888+12)|0);
 HEAP32[(($1415)>>2)]=$1398;
 label=338;break;
 case 321: 
 var $1417=$888;
 var $1418=$1384>>>8;
 var $1419=($1418|0)==0;
 if($1419){var $I1_0_i_i=0;label=324;break;}else{label=322;break;}
 case 322: 
 var $1421=($1384>>>0)>16777215;
 if($1421){var $I1_0_i_i=31;label=324;break;}else{label=323;break;}
 case 323: 
 var $1423=((($1418)+(1048320))|0);
 var $1424=$1423>>>16;
 var $1425=$1424&8;
 var $1426=$1418<<$1425;
 var $1427=((($1426)+(520192))|0);
 var $1428=$1427>>>16;
 var $1429=$1428&4;
 var $1430=$1429|$1425;
 var $1431=$1426<<$1429;
 var $1432=((($1431)+(245760))|0);
 var $1433=$1432>>>16;
 var $1434=$1433&2;
 var $1435=$1430|$1434;
 var $1436=(((14)-($1435))|0);
 var $1437=$1431<<$1434;
 var $1438=$1437>>>15;
 var $1439=((($1436)+($1438))|0);
 var $1440=$1439<<1;
 var $1441=((($1439)+(7))|0);
 var $1442=$1384>>>($1441>>>0);
 var $1443=$1442&1;
 var $1444=$1443|$1440;
 var $I1_0_i_i=$1444;label=324;break;
 case 324: 
 var $I1_0_i_i;
 var $1446=((10976+($I1_0_i_i<<2))|0);
 var $1447=(($888+28)|0);
 var $I1_0_c_i_i=$I1_0_i_i;
 HEAP32[(($1447)>>2)]=$I1_0_c_i_i;
 var $1448=(($888+20)|0);
 HEAP32[(($1448)>>2)]=0;
 var $1449=(($888+16)|0);
 HEAP32[(($1449)>>2)]=0;
 var $1450=HEAP32[((10676)>>2)];
 var $1451=1<<$I1_0_i_i;
 var $1452=$1450&$1451;
 var $1453=($1452|0)==0;
 if($1453){label=325;break;}else{label=326;break;}
 case 325: 
 var $1455=$1450|$1451;
 HEAP32[((10676)>>2)]=$1455;
 HEAP32[(($1446)>>2)]=$1417;
 var $1456=(($888+24)|0);
 var $_c_i_i=$1446;
 HEAP32[(($1456)>>2)]=$_c_i_i;
 var $1457=(($888+12)|0);
 HEAP32[(($1457)>>2)]=$888;
 var $1458=(($888+8)|0);
 HEAP32[(($1458)>>2)]=$888;
 label=338;break;
 case 326: 
 var $1460=HEAP32[(($1446)>>2)];
 var $1461=($I1_0_i_i|0)==31;
 if($1461){var $1466=0;label=328;break;}else{label=327;break;}
 case 327: 
 var $1463=$I1_0_i_i>>>1;
 var $1464=(((25)-($1463))|0);
 var $1466=$1464;label=328;break;
 case 328: 
 var $1466;
 var $1467=$1384<<$1466;
 var $K2_0_i_i=$1467;var $T_0_i_i=$1460;label=329;break;
 case 329: 
 var $T_0_i_i;
 var $K2_0_i_i;
 var $1469=(($T_0_i_i+4)|0);
 var $1470=HEAP32[(($1469)>>2)];
 var $1471=$1470&-8;
 var $1472=($1471|0)==($1384|0);
 if($1472){label=334;break;}else{label=330;break;}
 case 330: 
 var $1474=$K2_0_i_i>>>31;
 var $1475=(($T_0_i_i+16+($1474<<2))|0);
 var $1476=HEAP32[(($1475)>>2)];
 var $1477=($1476|0)==0;
 var $1478=$K2_0_i_i<<1;
 if($1477){label=331;break;}else{var $K2_0_i_i=$1478;var $T_0_i_i=$1476;label=329;break;}
 case 331: 
 var $1480=$1475;
 var $1481=HEAP32[((10688)>>2)];
 var $1482=($1480>>>0)<($1481>>>0);
 if($1482){label=333;break;}else{label=332;break;}
 case 332: 
 HEAP32[(($1475)>>2)]=$1417;
 var $1484=(($888+24)|0);
 var $T_0_c8_i_i=$T_0_i_i;
 HEAP32[(($1484)>>2)]=$T_0_c8_i_i;
 var $1485=(($888+12)|0);
 HEAP32[(($1485)>>2)]=$888;
 var $1486=(($888+8)|0);
 HEAP32[(($1486)>>2)]=$888;
 label=338;break;
 case 333: 
 _abort();
 throw "Reached an unreachable!";
 case 334: 
 var $1489=(($T_0_i_i+8)|0);
 var $1490=HEAP32[(($1489)>>2)];
 var $1491=$T_0_i_i;
 var $1492=HEAP32[((10688)>>2)];
 var $1493=($1491>>>0)<($1492>>>0);
 if($1493){label=337;break;}else{label=335;break;}
 case 335: 
 var $1495=$1490;
 var $1496=($1495>>>0)<($1492>>>0);
 if($1496){label=337;break;}else{label=336;break;}
 case 336: 
 var $1498=(($1490+12)|0);
 HEAP32[(($1498)>>2)]=$1417;
 HEAP32[(($1489)>>2)]=$1417;
 var $1499=(($888+8)|0);
 var $_c7_i_i=$1490;
 HEAP32[(($1499)>>2)]=$_c7_i_i;
 var $1500=(($888+12)|0);
 var $T_0_c_i_i=$T_0_i_i;
 HEAP32[(($1500)>>2)]=$T_0_c_i_i;
 var $1501=(($888+24)|0);
 HEAP32[(($1501)>>2)]=0;
 label=338;break;
 case 337: 
 _abort();
 throw "Reached an unreachable!";
 case 338: 
 var $1502=HEAP32[((10684)>>2)];
 var $1503=($1502>>>0)>($nb_0>>>0);
 if($1503){label=339;break;}else{label=340;break;}
 case 339: 
 var $1505=((($1502)-($nb_0))|0);
 HEAP32[((10684)>>2)]=$1505;
 var $1506=HEAP32[((10696)>>2)];
 var $1507=$1506;
 var $1508=(($1507+$nb_0)|0);
 var $1509=$1508;
 HEAP32[((10696)>>2)]=$1509;
 var $1510=$1505|1;
 var $_sum_i134=((($nb_0)+(4))|0);
 var $1511=(($1507+$_sum_i134)|0);
 var $1512=$1511;
 HEAP32[(($1512)>>2)]=$1510;
 var $1513=$nb_0|3;
 var $1514=(($1506+4)|0);
 HEAP32[(($1514)>>2)]=$1513;
 var $1515=(($1506+8)|0);
 var $1516=$1515;
 var $mem_0=$1516;label=341;break;
 case 340: 
 var $1517=___errno_location();
 HEAP32[(($1517)>>2)]=12;
 var $mem_0=0;label=341;break;
 case 341: 
 var $mem_0;
 return $mem_0;
  default: assert(0, "bad label: " + label);
 }

}
Module["_malloc"] = _malloc;

function _free($mem){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=($mem|0)==0;
 if($1){label=140;break;}else{label=2;break;}
 case 2: 
 var $3=((($mem)-(8))|0);
 var $4=$3;
 var $5=HEAP32[((10688)>>2)];
 var $6=($3>>>0)<($5>>>0);
 if($6){label=139;break;}else{label=3;break;}
 case 3: 
 var $8=((($mem)-(4))|0);
 var $9=$8;
 var $10=HEAP32[(($9)>>2)];
 var $11=$10&3;
 var $12=($11|0)==1;
 if($12){label=139;break;}else{label=4;break;}
 case 4: 
 var $14=$10&-8;
 var $_sum=((($14)-(8))|0);
 var $15=(($mem+$_sum)|0);
 var $16=$15;
 var $17=$10&1;
 var $18=($17|0)==0;
 if($18){label=5;break;}else{var $p_0=$4;var $psize_0=$14;label=56;break;}
 case 5: 
 var $20=$3;
 var $21=HEAP32[(($20)>>2)];
 var $22=($11|0)==0;
 if($22){label=140;break;}else{label=6;break;}
 case 6: 
 var $_sum232=(((-8)-($21))|0);
 var $24=(($mem+$_sum232)|0);
 var $25=$24;
 var $26=((($21)+($14))|0);
 var $27=($24>>>0)<($5>>>0);
 if($27){label=139;break;}else{label=7;break;}
 case 7: 
 var $29=HEAP32[((10692)>>2)];
 var $30=($25|0)==($29|0);
 if($30){label=54;break;}else{label=8;break;}
 case 8: 
 var $32=$21>>>3;
 var $33=($21>>>0)<256;
 if($33){label=9;break;}else{label=21;break;}
 case 9: 
 var $_sum276=((($_sum232)+(8))|0);
 var $35=(($mem+$_sum276)|0);
 var $36=$35;
 var $37=HEAP32[(($36)>>2)];
 var $_sum277=((($_sum232)+(12))|0);
 var $38=(($mem+$_sum277)|0);
 var $39=$38;
 var $40=HEAP32[(($39)>>2)];
 var $41=$32<<1;
 var $42=((10712+($41<<2))|0);
 var $43=$42;
 var $44=($37|0)==($43|0);
 if($44){label=12;break;}else{label=10;break;}
 case 10: 
 var $46=$37;
 var $47=($46>>>0)<($5>>>0);
 if($47){label=20;break;}else{label=11;break;}
 case 11: 
 var $49=(($37+12)|0);
 var $50=HEAP32[(($49)>>2)];
 var $51=($50|0)==($25|0);
 if($51){label=12;break;}else{label=20;break;}
 case 12: 
 var $52=($40|0)==($37|0);
 if($52){label=13;break;}else{label=14;break;}
 case 13: 
 var $54=1<<$32;
 var $55=$54^-1;
 var $56=HEAP32[((10672)>>2)];
 var $57=$56&$55;
 HEAP32[((10672)>>2)]=$57;
 var $p_0=$25;var $psize_0=$26;label=56;break;
 case 14: 
 var $59=($40|0)==($43|0);
 if($59){label=15;break;}else{label=16;break;}
 case 15: 
 var $_pre307=(($40+8)|0);
 var $_pre_phi308=$_pre307;label=18;break;
 case 16: 
 var $61=$40;
 var $62=($61>>>0)<($5>>>0);
 if($62){label=19;break;}else{label=17;break;}
 case 17: 
 var $64=(($40+8)|0);
 var $65=HEAP32[(($64)>>2)];
 var $66=($65|0)==($25|0);
 if($66){var $_pre_phi308=$64;label=18;break;}else{label=19;break;}
 case 18: 
 var $_pre_phi308;
 var $67=(($37+12)|0);
 HEAP32[(($67)>>2)]=$40;
 HEAP32[(($_pre_phi308)>>2)]=$37;
 var $p_0=$25;var $psize_0=$26;label=56;break;
 case 19: 
 _abort();
 throw "Reached an unreachable!";
 case 20: 
 _abort();
 throw "Reached an unreachable!";
 case 21: 
 var $69=$24;
 var $_sum266=((($_sum232)+(24))|0);
 var $70=(($mem+$_sum266)|0);
 var $71=$70;
 var $72=HEAP32[(($71)>>2)];
 var $_sum267=((($_sum232)+(12))|0);
 var $73=(($mem+$_sum267)|0);
 var $74=$73;
 var $75=HEAP32[(($74)>>2)];
 var $76=($75|0)==($69|0);
 if($76){label=27;break;}else{label=22;break;}
 case 22: 
 var $_sum273=((($_sum232)+(8))|0);
 var $78=(($mem+$_sum273)|0);
 var $79=$78;
 var $80=HEAP32[(($79)>>2)];
 var $81=$80;
 var $82=($81>>>0)<($5>>>0);
 if($82){label=26;break;}else{label=23;break;}
 case 23: 
 var $84=(($80+12)|0);
 var $85=HEAP32[(($84)>>2)];
 var $86=($85|0)==($69|0);
 if($86){label=24;break;}else{label=26;break;}
 case 24: 
 var $88=(($75+8)|0);
 var $89=HEAP32[(($88)>>2)];
 var $90=($89|0)==($69|0);
 if($90){label=25;break;}else{label=26;break;}
 case 25: 
 HEAP32[(($84)>>2)]=$75;
 HEAP32[(($88)>>2)]=$80;
 var $R_1=$75;label=34;break;
 case 26: 
 _abort();
 throw "Reached an unreachable!";
 case 27: 
 var $_sum269=((($_sum232)+(20))|0);
 var $93=(($mem+$_sum269)|0);
 var $94=$93;
 var $95=HEAP32[(($94)>>2)];
 var $96=($95|0)==0;
 if($96){label=28;break;}else{var $R_0=$95;var $RP_0=$94;label=29;break;}
 case 28: 
 var $_sum268=((($_sum232)+(16))|0);
 var $98=(($mem+$_sum268)|0);
 var $99=$98;
 var $100=HEAP32[(($99)>>2)];
 var $101=($100|0)==0;
 if($101){var $R_1=0;label=34;break;}else{var $R_0=$100;var $RP_0=$99;label=29;break;}
 case 29: 
 var $RP_0;
 var $R_0;
 var $102=(($R_0+20)|0);
 var $103=HEAP32[(($102)>>2)];
 var $104=($103|0)==0;
 if($104){label=30;break;}else{var $R_0=$103;var $RP_0=$102;label=29;break;}
 case 30: 
 var $106=(($R_0+16)|0);
 var $107=HEAP32[(($106)>>2)];
 var $108=($107|0)==0;
 if($108){label=31;break;}else{var $R_0=$107;var $RP_0=$106;label=29;break;}
 case 31: 
 var $110=$RP_0;
 var $111=($110>>>0)<($5>>>0);
 if($111){label=33;break;}else{label=32;break;}
 case 32: 
 HEAP32[(($RP_0)>>2)]=0;
 var $R_1=$R_0;label=34;break;
 case 33: 
 _abort();
 throw "Reached an unreachable!";
 case 34: 
 var $R_1;
 var $115=($72|0)==0;
 if($115){var $p_0=$25;var $psize_0=$26;label=56;break;}else{label=35;break;}
 case 35: 
 var $_sum270=((($_sum232)+(28))|0);
 var $117=(($mem+$_sum270)|0);
 var $118=$117;
 var $119=HEAP32[(($118)>>2)];
 var $120=((10976+($119<<2))|0);
 var $121=HEAP32[(($120)>>2)];
 var $122=($69|0)==($121|0);
 if($122){label=36;break;}else{label=38;break;}
 case 36: 
 HEAP32[(($120)>>2)]=$R_1;
 var $cond=($R_1|0)==0;
 if($cond){label=37;break;}else{label=44;break;}
 case 37: 
 var $124=1<<$119;
 var $125=$124^-1;
 var $126=HEAP32[((10676)>>2)];
 var $127=$126&$125;
 HEAP32[((10676)>>2)]=$127;
 var $p_0=$25;var $psize_0=$26;label=56;break;
 case 38: 
 var $129=$72;
 var $130=HEAP32[((10688)>>2)];
 var $131=($129>>>0)<($130>>>0);
 if($131){label=42;break;}else{label=39;break;}
 case 39: 
 var $133=(($72+16)|0);
 var $134=HEAP32[(($133)>>2)];
 var $135=($134|0)==($69|0);
 if($135){label=40;break;}else{label=41;break;}
 case 40: 
 HEAP32[(($133)>>2)]=$R_1;
 label=43;break;
 case 41: 
 var $138=(($72+20)|0);
 HEAP32[(($138)>>2)]=$R_1;
 label=43;break;
 case 42: 
 _abort();
 throw "Reached an unreachable!";
 case 43: 
 var $141=($R_1|0)==0;
 if($141){var $p_0=$25;var $psize_0=$26;label=56;break;}else{label=44;break;}
 case 44: 
 var $143=$R_1;
 var $144=HEAP32[((10688)>>2)];
 var $145=($143>>>0)<($144>>>0);
 if($145){label=53;break;}else{label=45;break;}
 case 45: 
 var $147=(($R_1+24)|0);
 HEAP32[(($147)>>2)]=$72;
 var $_sum271=((($_sum232)+(16))|0);
 var $148=(($mem+$_sum271)|0);
 var $149=$148;
 var $150=HEAP32[(($149)>>2)];
 var $151=($150|0)==0;
 if($151){label=49;break;}else{label=46;break;}
 case 46: 
 var $153=$150;
 var $154=HEAP32[((10688)>>2)];
 var $155=($153>>>0)<($154>>>0);
 if($155){label=48;break;}else{label=47;break;}
 case 47: 
 var $157=(($R_1+16)|0);
 HEAP32[(($157)>>2)]=$150;
 var $158=(($150+24)|0);
 HEAP32[(($158)>>2)]=$R_1;
 label=49;break;
 case 48: 
 _abort();
 throw "Reached an unreachable!";
 case 49: 
 var $_sum272=((($_sum232)+(20))|0);
 var $161=(($mem+$_sum272)|0);
 var $162=$161;
 var $163=HEAP32[(($162)>>2)];
 var $164=($163|0)==0;
 if($164){var $p_0=$25;var $psize_0=$26;label=56;break;}else{label=50;break;}
 case 50: 
 var $166=$163;
 var $167=HEAP32[((10688)>>2)];
 var $168=($166>>>0)<($167>>>0);
 if($168){label=52;break;}else{label=51;break;}
 case 51: 
 var $170=(($R_1+20)|0);
 HEAP32[(($170)>>2)]=$163;
 var $171=(($163+24)|0);
 HEAP32[(($171)>>2)]=$R_1;
 var $p_0=$25;var $psize_0=$26;label=56;break;
 case 52: 
 _abort();
 throw "Reached an unreachable!";
 case 53: 
 _abort();
 throw "Reached an unreachable!";
 case 54: 
 var $_sum233=((($14)-(4))|0);
 var $175=(($mem+$_sum233)|0);
 var $176=$175;
 var $177=HEAP32[(($176)>>2)];
 var $178=$177&3;
 var $179=($178|0)==3;
 if($179){label=55;break;}else{var $p_0=$25;var $psize_0=$26;label=56;break;}
 case 55: 
 HEAP32[((10680)>>2)]=$26;
 var $181=HEAP32[(($176)>>2)];
 var $182=$181&-2;
 HEAP32[(($176)>>2)]=$182;
 var $183=$26|1;
 var $_sum264=((($_sum232)+(4))|0);
 var $184=(($mem+$_sum264)|0);
 var $185=$184;
 HEAP32[(($185)>>2)]=$183;
 var $186=$15;
 HEAP32[(($186)>>2)]=$26;
 label=140;break;
 case 56: 
 var $psize_0;
 var $p_0;
 var $188=$p_0;
 var $189=($188>>>0)<($15>>>0);
 if($189){label=57;break;}else{label=139;break;}
 case 57: 
 var $_sum263=((($14)-(4))|0);
 var $191=(($mem+$_sum263)|0);
 var $192=$191;
 var $193=HEAP32[(($192)>>2)];
 var $194=$193&1;
 var $phitmp=($194|0)==0;
 if($phitmp){label=139;break;}else{label=58;break;}
 case 58: 
 var $196=$193&2;
 var $197=($196|0)==0;
 if($197){label=59;break;}else{label=112;break;}
 case 59: 
 var $199=HEAP32[((10696)>>2)];
 var $200=($16|0)==($199|0);
 if($200){label=60;break;}else{label=62;break;}
 case 60: 
 var $202=HEAP32[((10684)>>2)];
 var $203=((($202)+($psize_0))|0);
 HEAP32[((10684)>>2)]=$203;
 HEAP32[((10696)>>2)]=$p_0;
 var $204=$203|1;
 var $205=(($p_0+4)|0);
 HEAP32[(($205)>>2)]=$204;
 var $206=HEAP32[((10692)>>2)];
 var $207=($p_0|0)==($206|0);
 if($207){label=61;break;}else{label=140;break;}
 case 61: 
 HEAP32[((10692)>>2)]=0;
 HEAP32[((10680)>>2)]=0;
 label=140;break;
 case 62: 
 var $210=HEAP32[((10692)>>2)];
 var $211=($16|0)==($210|0);
 if($211){label=63;break;}else{label=64;break;}
 case 63: 
 var $213=HEAP32[((10680)>>2)];
 var $214=((($213)+($psize_0))|0);
 HEAP32[((10680)>>2)]=$214;
 HEAP32[((10692)>>2)]=$p_0;
 var $215=$214|1;
 var $216=(($p_0+4)|0);
 HEAP32[(($216)>>2)]=$215;
 var $217=(($188+$214)|0);
 var $218=$217;
 HEAP32[(($218)>>2)]=$214;
 label=140;break;
 case 64: 
 var $220=$193&-8;
 var $221=((($220)+($psize_0))|0);
 var $222=$193>>>3;
 var $223=($193>>>0)<256;
 if($223){label=65;break;}else{label=77;break;}
 case 65: 
 var $225=(($mem+$14)|0);
 var $226=$225;
 var $227=HEAP32[(($226)>>2)];
 var $_sum257258=$14|4;
 var $228=(($mem+$_sum257258)|0);
 var $229=$228;
 var $230=HEAP32[(($229)>>2)];
 var $231=$222<<1;
 var $232=((10712+($231<<2))|0);
 var $233=$232;
 var $234=($227|0)==($233|0);
 if($234){label=68;break;}else{label=66;break;}
 case 66: 
 var $236=$227;
 var $237=HEAP32[((10688)>>2)];
 var $238=($236>>>0)<($237>>>0);
 if($238){label=76;break;}else{label=67;break;}
 case 67: 
 var $240=(($227+12)|0);
 var $241=HEAP32[(($240)>>2)];
 var $242=($241|0)==($16|0);
 if($242){label=68;break;}else{label=76;break;}
 case 68: 
 var $243=($230|0)==($227|0);
 if($243){label=69;break;}else{label=70;break;}
 case 69: 
 var $245=1<<$222;
 var $246=$245^-1;
 var $247=HEAP32[((10672)>>2)];
 var $248=$247&$246;
 HEAP32[((10672)>>2)]=$248;
 label=110;break;
 case 70: 
 var $250=($230|0)==($233|0);
 if($250){label=71;break;}else{label=72;break;}
 case 71: 
 var $_pre305=(($230+8)|0);
 var $_pre_phi306=$_pre305;label=74;break;
 case 72: 
 var $252=$230;
 var $253=HEAP32[((10688)>>2)];
 var $254=($252>>>0)<($253>>>0);
 if($254){label=75;break;}else{label=73;break;}
 case 73: 
 var $256=(($230+8)|0);
 var $257=HEAP32[(($256)>>2)];
 var $258=($257|0)==($16|0);
 if($258){var $_pre_phi306=$256;label=74;break;}else{label=75;break;}
 case 74: 
 var $_pre_phi306;
 var $259=(($227+12)|0);
 HEAP32[(($259)>>2)]=$230;
 HEAP32[(($_pre_phi306)>>2)]=$227;
 label=110;break;
 case 75: 
 _abort();
 throw "Reached an unreachable!";
 case 76: 
 _abort();
 throw "Reached an unreachable!";
 case 77: 
 var $261=$15;
 var $_sum235=((($14)+(16))|0);
 var $262=(($mem+$_sum235)|0);
 var $263=$262;
 var $264=HEAP32[(($263)>>2)];
 var $_sum236237=$14|4;
 var $265=(($mem+$_sum236237)|0);
 var $266=$265;
 var $267=HEAP32[(($266)>>2)];
 var $268=($267|0)==($261|0);
 if($268){label=83;break;}else{label=78;break;}
 case 78: 
 var $270=(($mem+$14)|0);
 var $271=$270;
 var $272=HEAP32[(($271)>>2)];
 var $273=$272;
 var $274=HEAP32[((10688)>>2)];
 var $275=($273>>>0)<($274>>>0);
 if($275){label=82;break;}else{label=79;break;}
 case 79: 
 var $277=(($272+12)|0);
 var $278=HEAP32[(($277)>>2)];
 var $279=($278|0)==($261|0);
 if($279){label=80;break;}else{label=82;break;}
 case 80: 
 var $281=(($267+8)|0);
 var $282=HEAP32[(($281)>>2)];
 var $283=($282|0)==($261|0);
 if($283){label=81;break;}else{label=82;break;}
 case 81: 
 HEAP32[(($277)>>2)]=$267;
 HEAP32[(($281)>>2)]=$272;
 var $R7_1=$267;label=90;break;
 case 82: 
 _abort();
 throw "Reached an unreachable!";
 case 83: 
 var $_sum239=((($14)+(12))|0);
 var $286=(($mem+$_sum239)|0);
 var $287=$286;
 var $288=HEAP32[(($287)>>2)];
 var $289=($288|0)==0;
 if($289){label=84;break;}else{var $R7_0=$288;var $RP9_0=$287;label=85;break;}
 case 84: 
 var $_sum238=((($14)+(8))|0);
 var $291=(($mem+$_sum238)|0);
 var $292=$291;
 var $293=HEAP32[(($292)>>2)];
 var $294=($293|0)==0;
 if($294){var $R7_1=0;label=90;break;}else{var $R7_0=$293;var $RP9_0=$292;label=85;break;}
 case 85: 
 var $RP9_0;
 var $R7_0;
 var $295=(($R7_0+20)|0);
 var $296=HEAP32[(($295)>>2)];
 var $297=($296|0)==0;
 if($297){label=86;break;}else{var $R7_0=$296;var $RP9_0=$295;label=85;break;}
 case 86: 
 var $299=(($R7_0+16)|0);
 var $300=HEAP32[(($299)>>2)];
 var $301=($300|0)==0;
 if($301){label=87;break;}else{var $R7_0=$300;var $RP9_0=$299;label=85;break;}
 case 87: 
 var $303=$RP9_0;
 var $304=HEAP32[((10688)>>2)];
 var $305=($303>>>0)<($304>>>0);
 if($305){label=89;break;}else{label=88;break;}
 case 88: 
 HEAP32[(($RP9_0)>>2)]=0;
 var $R7_1=$R7_0;label=90;break;
 case 89: 
 _abort();
 throw "Reached an unreachable!";
 case 90: 
 var $R7_1;
 var $309=($264|0)==0;
 if($309){label=110;break;}else{label=91;break;}
 case 91: 
 var $_sum250=((($14)+(20))|0);
 var $311=(($mem+$_sum250)|0);
 var $312=$311;
 var $313=HEAP32[(($312)>>2)];
 var $314=((10976+($313<<2))|0);
 var $315=HEAP32[(($314)>>2)];
 var $316=($261|0)==($315|0);
 if($316){label=92;break;}else{label=94;break;}
 case 92: 
 HEAP32[(($314)>>2)]=$R7_1;
 var $cond298=($R7_1|0)==0;
 if($cond298){label=93;break;}else{label=100;break;}
 case 93: 
 var $318=1<<$313;
 var $319=$318^-1;
 var $320=HEAP32[((10676)>>2)];
 var $321=$320&$319;
 HEAP32[((10676)>>2)]=$321;
 label=110;break;
 case 94: 
 var $323=$264;
 var $324=HEAP32[((10688)>>2)];
 var $325=($323>>>0)<($324>>>0);
 if($325){label=98;break;}else{label=95;break;}
 case 95: 
 var $327=(($264+16)|0);
 var $328=HEAP32[(($327)>>2)];
 var $329=($328|0)==($261|0);
 if($329){label=96;break;}else{label=97;break;}
 case 96: 
 HEAP32[(($327)>>2)]=$R7_1;
 label=99;break;
 case 97: 
 var $332=(($264+20)|0);
 HEAP32[(($332)>>2)]=$R7_1;
 label=99;break;
 case 98: 
 _abort();
 throw "Reached an unreachable!";
 case 99: 
 var $335=($R7_1|0)==0;
 if($335){label=110;break;}else{label=100;break;}
 case 100: 
 var $337=$R7_1;
 var $338=HEAP32[((10688)>>2)];
 var $339=($337>>>0)<($338>>>0);
 if($339){label=109;break;}else{label=101;break;}
 case 101: 
 var $341=(($R7_1+24)|0);
 HEAP32[(($341)>>2)]=$264;
 var $_sum251=((($14)+(8))|0);
 var $342=(($mem+$_sum251)|0);
 var $343=$342;
 var $344=HEAP32[(($343)>>2)];
 var $345=($344|0)==0;
 if($345){label=105;break;}else{label=102;break;}
 case 102: 
 var $347=$344;
 var $348=HEAP32[((10688)>>2)];
 var $349=($347>>>0)<($348>>>0);
 if($349){label=104;break;}else{label=103;break;}
 case 103: 
 var $351=(($R7_1+16)|0);
 HEAP32[(($351)>>2)]=$344;
 var $352=(($344+24)|0);
 HEAP32[(($352)>>2)]=$R7_1;
 label=105;break;
 case 104: 
 _abort();
 throw "Reached an unreachable!";
 case 105: 
 var $_sum252=((($14)+(12))|0);
 var $355=(($mem+$_sum252)|0);
 var $356=$355;
 var $357=HEAP32[(($356)>>2)];
 var $358=($357|0)==0;
 if($358){label=110;break;}else{label=106;break;}
 case 106: 
 var $360=$357;
 var $361=HEAP32[((10688)>>2)];
 var $362=($360>>>0)<($361>>>0);
 if($362){label=108;break;}else{label=107;break;}
 case 107: 
 var $364=(($R7_1+20)|0);
 HEAP32[(($364)>>2)]=$357;
 var $365=(($357+24)|0);
 HEAP32[(($365)>>2)]=$R7_1;
 label=110;break;
 case 108: 
 _abort();
 throw "Reached an unreachable!";
 case 109: 
 _abort();
 throw "Reached an unreachable!";
 case 110: 
 var $368=$221|1;
 var $369=(($p_0+4)|0);
 HEAP32[(($369)>>2)]=$368;
 var $370=(($188+$221)|0);
 var $371=$370;
 HEAP32[(($371)>>2)]=$221;
 var $372=HEAP32[((10692)>>2)];
 var $373=($p_0|0)==($372|0);
 if($373){label=111;break;}else{var $psize_1=$221;label=113;break;}
 case 111: 
 HEAP32[((10680)>>2)]=$221;
 label=140;break;
 case 112: 
 var $376=$193&-2;
 HEAP32[(($192)>>2)]=$376;
 var $377=$psize_0|1;
 var $378=(($p_0+4)|0);
 HEAP32[(($378)>>2)]=$377;
 var $379=(($188+$psize_0)|0);
 var $380=$379;
 HEAP32[(($380)>>2)]=$psize_0;
 var $psize_1=$psize_0;label=113;break;
 case 113: 
 var $psize_1;
 var $382=$psize_1>>>3;
 var $383=($psize_1>>>0)<256;
 if($383){label=114;break;}else{label=119;break;}
 case 114: 
 var $385=$382<<1;
 var $386=((10712+($385<<2))|0);
 var $387=$386;
 var $388=HEAP32[((10672)>>2)];
 var $389=1<<$382;
 var $390=$388&$389;
 var $391=($390|0)==0;
 if($391){label=115;break;}else{label=116;break;}
 case 115: 
 var $393=$388|$389;
 HEAP32[((10672)>>2)]=$393;
 var $_sum248_pre=((($385)+(2))|0);
 var $_pre=((10712+($_sum248_pre<<2))|0);
 var $F16_0=$387;var $_pre_phi=$_pre;label=118;break;
 case 116: 
 var $_sum249=((($385)+(2))|0);
 var $395=((10712+($_sum249<<2))|0);
 var $396=HEAP32[(($395)>>2)];
 var $397=$396;
 var $398=HEAP32[((10688)>>2)];
 var $399=($397>>>0)<($398>>>0);
 if($399){label=117;break;}else{var $F16_0=$396;var $_pre_phi=$395;label=118;break;}
 case 117: 
 _abort();
 throw "Reached an unreachable!";
 case 118: 
 var $_pre_phi;
 var $F16_0;
 HEAP32[(($_pre_phi)>>2)]=$p_0;
 var $402=(($F16_0+12)|0);
 HEAP32[(($402)>>2)]=$p_0;
 var $403=(($p_0+8)|0);
 HEAP32[(($403)>>2)]=$F16_0;
 var $404=(($p_0+12)|0);
 HEAP32[(($404)>>2)]=$387;
 label=140;break;
 case 119: 
 var $406=$p_0;
 var $407=$psize_1>>>8;
 var $408=($407|0)==0;
 if($408){var $I18_0=0;label=122;break;}else{label=120;break;}
 case 120: 
 var $410=($psize_1>>>0)>16777215;
 if($410){var $I18_0=31;label=122;break;}else{label=121;break;}
 case 121: 
 var $412=((($407)+(1048320))|0);
 var $413=$412>>>16;
 var $414=$413&8;
 var $415=$407<<$414;
 var $416=((($415)+(520192))|0);
 var $417=$416>>>16;
 var $418=$417&4;
 var $419=$418|$414;
 var $420=$415<<$418;
 var $421=((($420)+(245760))|0);
 var $422=$421>>>16;
 var $423=$422&2;
 var $424=$419|$423;
 var $425=(((14)-($424))|0);
 var $426=$420<<$423;
 var $427=$426>>>15;
 var $428=((($425)+($427))|0);
 var $429=$428<<1;
 var $430=((($428)+(7))|0);
 var $431=$psize_1>>>($430>>>0);
 var $432=$431&1;
 var $433=$432|$429;
 var $I18_0=$433;label=122;break;
 case 122: 
 var $I18_0;
 var $435=((10976+($I18_0<<2))|0);
 var $436=(($p_0+28)|0);
 var $I18_0_c=$I18_0;
 HEAP32[(($436)>>2)]=$I18_0_c;
 var $437=(($p_0+20)|0);
 HEAP32[(($437)>>2)]=0;
 var $438=(($p_0+16)|0);
 HEAP32[(($438)>>2)]=0;
 var $439=HEAP32[((10676)>>2)];
 var $440=1<<$I18_0;
 var $441=$439&$440;
 var $442=($441|0)==0;
 if($442){label=123;break;}else{label=124;break;}
 case 123: 
 var $444=$439|$440;
 HEAP32[((10676)>>2)]=$444;
 HEAP32[(($435)>>2)]=$406;
 var $445=(($p_0+24)|0);
 var $_c=$435;
 HEAP32[(($445)>>2)]=$_c;
 var $446=(($p_0+12)|0);
 HEAP32[(($446)>>2)]=$p_0;
 var $447=(($p_0+8)|0);
 HEAP32[(($447)>>2)]=$p_0;
 label=136;break;
 case 124: 
 var $449=HEAP32[(($435)>>2)];
 var $450=($I18_0|0)==31;
 if($450){var $455=0;label=126;break;}else{label=125;break;}
 case 125: 
 var $452=$I18_0>>>1;
 var $453=(((25)-($452))|0);
 var $455=$453;label=126;break;
 case 126: 
 var $455;
 var $456=$psize_1<<$455;
 var $K19_0=$456;var $T_0=$449;label=127;break;
 case 127: 
 var $T_0;
 var $K19_0;
 var $458=(($T_0+4)|0);
 var $459=HEAP32[(($458)>>2)];
 var $460=$459&-8;
 var $461=($460|0)==($psize_1|0);
 if($461){label=132;break;}else{label=128;break;}
 case 128: 
 var $463=$K19_0>>>31;
 var $464=(($T_0+16+($463<<2))|0);
 var $465=HEAP32[(($464)>>2)];
 var $466=($465|0)==0;
 var $467=$K19_0<<1;
 if($466){label=129;break;}else{var $K19_0=$467;var $T_0=$465;label=127;break;}
 case 129: 
 var $469=$464;
 var $470=HEAP32[((10688)>>2)];
 var $471=($469>>>0)<($470>>>0);
 if($471){label=131;break;}else{label=130;break;}
 case 130: 
 HEAP32[(($464)>>2)]=$406;
 var $473=(($p_0+24)|0);
 var $T_0_c245=$T_0;
 HEAP32[(($473)>>2)]=$T_0_c245;
 var $474=(($p_0+12)|0);
 HEAP32[(($474)>>2)]=$p_0;
 var $475=(($p_0+8)|0);
 HEAP32[(($475)>>2)]=$p_0;
 label=136;break;
 case 131: 
 _abort();
 throw "Reached an unreachable!";
 case 132: 
 var $478=(($T_0+8)|0);
 var $479=HEAP32[(($478)>>2)];
 var $480=$T_0;
 var $481=HEAP32[((10688)>>2)];
 var $482=($480>>>0)<($481>>>0);
 if($482){label=135;break;}else{label=133;break;}
 case 133: 
 var $484=$479;
 var $485=($484>>>0)<($481>>>0);
 if($485){label=135;break;}else{label=134;break;}
 case 134: 
 var $487=(($479+12)|0);
 HEAP32[(($487)>>2)]=$406;
 HEAP32[(($478)>>2)]=$406;
 var $488=(($p_0+8)|0);
 var $_c244=$479;
 HEAP32[(($488)>>2)]=$_c244;
 var $489=(($p_0+12)|0);
 var $T_0_c=$T_0;
 HEAP32[(($489)>>2)]=$T_0_c;
 var $490=(($p_0+24)|0);
 HEAP32[(($490)>>2)]=0;
 label=136;break;
 case 135: 
 _abort();
 throw "Reached an unreachable!";
 case 136: 
 var $492=HEAP32[((10704)>>2)];
 var $493=((($492)-(1))|0);
 HEAP32[((10704)>>2)]=$493;
 var $494=($493|0)==0;
 if($494){var $sp_0_in_i=11128;label=137;break;}else{label=140;break;}
 case 137: 
 var $sp_0_in_i;
 var $sp_0_i=HEAP32[(($sp_0_in_i)>>2)];
 var $495=($sp_0_i|0)==0;
 var $496=(($sp_0_i+8)|0);
 if($495){label=138;break;}else{var $sp_0_in_i=$496;label=137;break;}
 case 138: 
 HEAP32[((10704)>>2)]=-1;
 label=140;break;
 case 139: 
 _abort();
 throw "Reached an unreachable!";
 case 140: 
 return;
  default: assert(0, "bad label: " + label);
 }

}
Module["_free"] = _free;

function _realloc($oldmem,$bytes){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=($oldmem|0)==0;
 if($1){label=2;break;}else{label=3;break;}
 case 2: 
 var $3=_malloc($bytes);
 var $mem_0=$3;label=11;break;
 case 3: 
 var $5=($bytes>>>0)>4294967231;
 if($5){label=4;break;}else{label=5;break;}
 case 4: 
 var $7=___errno_location();
 HEAP32[(($7)>>2)]=12;
 var $mem_0=0;label=11;break;
 case 5: 
 var $9=($bytes>>>0)<11;
 if($9){var $14=16;label=7;break;}else{label=6;break;}
 case 6: 
 var $11=((($bytes)+(11))|0);
 var $12=$11&-8;
 var $14=$12;label=7;break;
 case 7: 
 var $14;
 var $15=((($oldmem)-(8))|0);
 var $16=$15;
 var $17=_try_realloc_chunk($16,$14);
 var $18=($17|0)==0;
 if($18){label=9;break;}else{label=8;break;}
 case 8: 
 var $20=(($17+8)|0);
 var $21=$20;
 var $mem_0=$21;label=11;break;
 case 9: 
 var $23=_malloc($bytes);
 var $24=($23|0)==0;
 if($24){var $mem_0=0;label=11;break;}else{label=10;break;}
 case 10: 
 var $26=((($oldmem)-(4))|0);
 var $27=$26;
 var $28=HEAP32[(($27)>>2)];
 var $29=$28&-8;
 var $30=$28&3;
 var $31=($30|0)==0;
 var $32=($31?8:4);
 var $33=((($29)-($32))|0);
 var $34=($33>>>0)<($bytes>>>0);
 var $35=($34?$33:$bytes);
 assert($35 % 1 === 0);(_memcpy($23, $oldmem, $35)|0);
 _free($oldmem);
 var $mem_0=$23;label=11;break;
 case 11: 
 var $mem_0;
 return $mem_0;
  default: assert(0, "bad label: " + label);
 }

}
Module["_realloc"] = _realloc;

function _try_realloc_chunk($p,$nb){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=(($p+4)|0);
 var $2=HEAP32[(($1)>>2)];
 var $3=$2&-8;
 var $4=$p;
 var $5=(($4+$3)|0);
 var $6=$5;
 var $7=HEAP32[((10688)>>2)];
 var $8=($4>>>0)<($7>>>0);
 if($8){label=72;break;}else{label=2;break;}
 case 2: 
 var $10=$2&3;
 var $11=($10|0)!=1;
 var $12=($4>>>0)<($5>>>0);
 var $or_cond=$11&$12;
 if($or_cond){label=3;break;}else{label=72;break;}
 case 3: 
 var $_sum3334=$3|4;
 var $14=(($4+$_sum3334)|0);
 var $15=$14;
 var $16=HEAP32[(($15)>>2)];
 var $17=$16&1;
 var $phitmp=($17|0)==0;
 if($phitmp){label=72;break;}else{label=4;break;}
 case 4: 
 var $19=($10|0)==0;
 if($19){label=5;break;}else{label=9;break;}
 case 5: 
 var $21=($nb>>>0)<256;
 if($21){var $newp_0=0;label=73;break;}else{label=6;break;}
 case 6: 
 var $23=((($nb)+(4))|0);
 var $24=($3>>>0)<($23>>>0);
 if($24){label=8;break;}else{label=7;break;}
 case 7: 
 var $26=((($3)-($nb))|0);
 var $27=HEAP32[((10640)>>2)];
 var $28=$27<<1;
 var $29=($26>>>0)>($28>>>0);
 if($29){label=8;break;}else{var $newp_0=$p;label=73;break;}
 case 8: 
 var $newp_0=0;label=73;break;
 case 9: 
 var $32=($3>>>0)<($nb>>>0);
 if($32){label=12;break;}else{label=10;break;}
 case 10: 
 var $34=((($3)-($nb))|0);
 var $35=($34>>>0)>15;
 if($35){label=11;break;}else{var $newp_0=$p;label=73;break;}
 case 11: 
 var $37=(($4+$nb)|0);
 var $38=$37;
 var $39=$2&1;
 var $40=$39|$nb;
 var $41=$40|2;
 HEAP32[(($1)>>2)]=$41;
 var $_sum29=((($nb)+(4))|0);
 var $42=(($4+$_sum29)|0);
 var $43=$42;
 var $44=$34|3;
 HEAP32[(($43)>>2)]=$44;
 var $45=HEAP32[(($15)>>2)];
 var $46=$45|1;
 HEAP32[(($15)>>2)]=$46;
 _dispose_chunk($38,$34);
 var $newp_0=$p;label=73;break;
 case 12: 
 var $48=HEAP32[((10696)>>2)];
 var $49=($6|0)==($48|0);
 if($49){label=13;break;}else{label=15;break;}
 case 13: 
 var $51=HEAP32[((10684)>>2)];
 var $52=((($51)+($3))|0);
 var $53=($52>>>0)>($nb>>>0);
 if($53){label=14;break;}else{var $newp_0=0;label=73;break;}
 case 14: 
 var $55=((($52)-($nb))|0);
 var $56=(($4+$nb)|0);
 var $57=$56;
 var $58=$2&1;
 var $59=$58|$nb;
 var $60=$59|2;
 HEAP32[(($1)>>2)]=$60;
 var $_sum28=((($nb)+(4))|0);
 var $61=(($4+$_sum28)|0);
 var $62=$61;
 var $63=$55|1;
 HEAP32[(($62)>>2)]=$63;
 HEAP32[((10696)>>2)]=$57;
 HEAP32[((10684)>>2)]=$55;
 var $newp_0=$p;label=73;break;
 case 15: 
 var $65=HEAP32[((10692)>>2)];
 var $66=($6|0)==($65|0);
 if($66){label=16;break;}else{label=21;break;}
 case 16: 
 var $68=HEAP32[((10680)>>2)];
 var $69=((($68)+($3))|0);
 var $70=($69>>>0)<($nb>>>0);
 if($70){var $newp_0=0;label=73;break;}else{label=17;break;}
 case 17: 
 var $72=((($69)-($nb))|0);
 var $73=($72>>>0)>15;
 if($73){label=18;break;}else{label=19;break;}
 case 18: 
 var $75=(($4+$nb)|0);
 var $76=$75;
 var $77=(($4+$69)|0);
 var $78=$2&1;
 var $79=$78|$nb;
 var $80=$79|2;
 HEAP32[(($1)>>2)]=$80;
 var $_sum25=((($nb)+(4))|0);
 var $81=(($4+$_sum25)|0);
 var $82=$81;
 var $83=$72|1;
 HEAP32[(($82)>>2)]=$83;
 var $84=$77;
 HEAP32[(($84)>>2)]=$72;
 var $_sum26=((($69)+(4))|0);
 var $85=(($4+$_sum26)|0);
 var $86=$85;
 var $87=HEAP32[(($86)>>2)];
 var $88=$87&-2;
 HEAP32[(($86)>>2)]=$88;
 var $storemerge=$76;var $storemerge27=$72;label=20;break;
 case 19: 
 var $90=$2&1;
 var $91=$90|$69;
 var $92=$91|2;
 HEAP32[(($1)>>2)]=$92;
 var $_sum23=((($69)+(4))|0);
 var $93=(($4+$_sum23)|0);
 var $94=$93;
 var $95=HEAP32[(($94)>>2)];
 var $96=$95|1;
 HEAP32[(($94)>>2)]=$96;
 var $storemerge=0;var $storemerge27=0;label=20;break;
 case 20: 
 var $storemerge27;
 var $storemerge;
 HEAP32[((10680)>>2)]=$storemerge27;
 HEAP32[((10692)>>2)]=$storemerge;
 var $newp_0=$p;label=73;break;
 case 21: 
 var $99=$16&2;
 var $100=($99|0)==0;
 if($100){label=22;break;}else{var $newp_0=0;label=73;break;}
 case 22: 
 var $102=$16&-8;
 var $103=((($102)+($3))|0);
 var $104=($103>>>0)<($nb>>>0);
 if($104){var $newp_0=0;label=73;break;}else{label=23;break;}
 case 23: 
 var $106=((($103)-($nb))|0);
 var $107=$16>>>3;
 var $108=($16>>>0)<256;
 if($108){label=24;break;}else{label=36;break;}
 case 24: 
 var $_sum17=((($3)+(8))|0);
 var $110=(($4+$_sum17)|0);
 var $111=$110;
 var $112=HEAP32[(($111)>>2)];
 var $_sum18=((($3)+(12))|0);
 var $113=(($4+$_sum18)|0);
 var $114=$113;
 var $115=HEAP32[(($114)>>2)];
 var $116=$107<<1;
 var $117=((10712+($116<<2))|0);
 var $118=$117;
 var $119=($112|0)==($118|0);
 if($119){label=27;break;}else{label=25;break;}
 case 25: 
 var $121=$112;
 var $122=($121>>>0)<($7>>>0);
 if($122){label=35;break;}else{label=26;break;}
 case 26: 
 var $124=(($112+12)|0);
 var $125=HEAP32[(($124)>>2)];
 var $126=($125|0)==($6|0);
 if($126){label=27;break;}else{label=35;break;}
 case 27: 
 var $127=($115|0)==($112|0);
 if($127){label=28;break;}else{label=29;break;}
 case 28: 
 var $129=1<<$107;
 var $130=$129^-1;
 var $131=HEAP32[((10672)>>2)];
 var $132=$131&$130;
 HEAP32[((10672)>>2)]=$132;
 label=69;break;
 case 29: 
 var $134=($115|0)==($118|0);
 if($134){label=30;break;}else{label=31;break;}
 case 30: 
 var $_pre=(($115+8)|0);
 var $_pre_phi=$_pre;label=33;break;
 case 31: 
 var $136=$115;
 var $137=($136>>>0)<($7>>>0);
 if($137){label=34;break;}else{label=32;break;}
 case 32: 
 var $139=(($115+8)|0);
 var $140=HEAP32[(($139)>>2)];
 var $141=($140|0)==($6|0);
 if($141){var $_pre_phi=$139;label=33;break;}else{label=34;break;}
 case 33: 
 var $_pre_phi;
 var $142=(($112+12)|0);
 HEAP32[(($142)>>2)]=$115;
 HEAP32[(($_pre_phi)>>2)]=$112;
 label=69;break;
 case 34: 
 _abort();
 throw "Reached an unreachable!";
 case 35: 
 _abort();
 throw "Reached an unreachable!";
 case 36: 
 var $144=$5;
 var $_sum=((($3)+(24))|0);
 var $145=(($4+$_sum)|0);
 var $146=$145;
 var $147=HEAP32[(($146)>>2)];
 var $_sum2=((($3)+(12))|0);
 var $148=(($4+$_sum2)|0);
 var $149=$148;
 var $150=HEAP32[(($149)>>2)];
 var $151=($150|0)==($144|0);
 if($151){label=42;break;}else{label=37;break;}
 case 37: 
 var $_sum14=((($3)+(8))|0);
 var $153=(($4+$_sum14)|0);
 var $154=$153;
 var $155=HEAP32[(($154)>>2)];
 var $156=$155;
 var $157=($156>>>0)<($7>>>0);
 if($157){label=41;break;}else{label=38;break;}
 case 38: 
 var $159=(($155+12)|0);
 var $160=HEAP32[(($159)>>2)];
 var $161=($160|0)==($144|0);
 if($161){label=39;break;}else{label=41;break;}
 case 39: 
 var $163=(($150+8)|0);
 var $164=HEAP32[(($163)>>2)];
 var $165=($164|0)==($144|0);
 if($165){label=40;break;}else{label=41;break;}
 case 40: 
 HEAP32[(($159)>>2)]=$150;
 HEAP32[(($163)>>2)]=$155;
 var $R_1=$150;label=49;break;
 case 41: 
 _abort();
 throw "Reached an unreachable!";
 case 42: 
 var $_sum4=((($3)+(20))|0);
 var $168=(($4+$_sum4)|0);
 var $169=$168;
 var $170=HEAP32[(($169)>>2)];
 var $171=($170|0)==0;
 if($171){label=43;break;}else{var $R_0=$170;var $RP_0=$169;label=44;break;}
 case 43: 
 var $_sum3=((($3)+(16))|0);
 var $173=(($4+$_sum3)|0);
 var $174=$173;
 var $175=HEAP32[(($174)>>2)];
 var $176=($175|0)==0;
 if($176){var $R_1=0;label=49;break;}else{var $R_0=$175;var $RP_0=$174;label=44;break;}
 case 44: 
 var $RP_0;
 var $R_0;
 var $177=(($R_0+20)|0);
 var $178=HEAP32[(($177)>>2)];
 var $179=($178|0)==0;
 if($179){label=45;break;}else{var $R_0=$178;var $RP_0=$177;label=44;break;}
 case 45: 
 var $181=(($R_0+16)|0);
 var $182=HEAP32[(($181)>>2)];
 var $183=($182|0)==0;
 if($183){label=46;break;}else{var $R_0=$182;var $RP_0=$181;label=44;break;}
 case 46: 
 var $185=$RP_0;
 var $186=($185>>>0)<($7>>>0);
 if($186){label=48;break;}else{label=47;break;}
 case 47: 
 HEAP32[(($RP_0)>>2)]=0;
 var $R_1=$R_0;label=49;break;
 case 48: 
 _abort();
 throw "Reached an unreachable!";
 case 49: 
 var $R_1;
 var $190=($147|0)==0;
 if($190){label=69;break;}else{label=50;break;}
 case 50: 
 var $_sum11=((($3)+(28))|0);
 var $192=(($4+$_sum11)|0);
 var $193=$192;
 var $194=HEAP32[(($193)>>2)];
 var $195=((10976+($194<<2))|0);
 var $196=HEAP32[(($195)>>2)];
 var $197=($144|0)==($196|0);
 if($197){label=51;break;}else{label=53;break;}
 case 51: 
 HEAP32[(($195)>>2)]=$R_1;
 var $cond=($R_1|0)==0;
 if($cond){label=52;break;}else{label=59;break;}
 case 52: 
 var $199=1<<$194;
 var $200=$199^-1;
 var $201=HEAP32[((10676)>>2)];
 var $202=$201&$200;
 HEAP32[((10676)>>2)]=$202;
 label=69;break;
 case 53: 
 var $204=$147;
 var $205=HEAP32[((10688)>>2)];
 var $206=($204>>>0)<($205>>>0);
 if($206){label=57;break;}else{label=54;break;}
 case 54: 
 var $208=(($147+16)|0);
 var $209=HEAP32[(($208)>>2)];
 var $210=($209|0)==($144|0);
 if($210){label=55;break;}else{label=56;break;}
 case 55: 
 HEAP32[(($208)>>2)]=$R_1;
 label=58;break;
 case 56: 
 var $213=(($147+20)|0);
 HEAP32[(($213)>>2)]=$R_1;
 label=58;break;
 case 57: 
 _abort();
 throw "Reached an unreachable!";
 case 58: 
 var $216=($R_1|0)==0;
 if($216){label=69;break;}else{label=59;break;}
 case 59: 
 var $218=$R_1;
 var $219=HEAP32[((10688)>>2)];
 var $220=($218>>>0)<($219>>>0);
 if($220){label=68;break;}else{label=60;break;}
 case 60: 
 var $222=(($R_1+24)|0);
 HEAP32[(($222)>>2)]=$147;
 var $_sum12=((($3)+(16))|0);
 var $223=(($4+$_sum12)|0);
 var $224=$223;
 var $225=HEAP32[(($224)>>2)];
 var $226=($225|0)==0;
 if($226){label=64;break;}else{label=61;break;}
 case 61: 
 var $228=$225;
 var $229=HEAP32[((10688)>>2)];
 var $230=($228>>>0)<($229>>>0);
 if($230){label=63;break;}else{label=62;break;}
 case 62: 
 var $232=(($R_1+16)|0);
 HEAP32[(($232)>>2)]=$225;
 var $233=(($225+24)|0);
 HEAP32[(($233)>>2)]=$R_1;
 label=64;break;
 case 63: 
 _abort();
 throw "Reached an unreachable!";
 case 64: 
 var $_sum13=((($3)+(20))|0);
 var $236=(($4+$_sum13)|0);
 var $237=$236;
 var $238=HEAP32[(($237)>>2)];
 var $239=($238|0)==0;
 if($239){label=69;break;}else{label=65;break;}
 case 65: 
 var $241=$238;
 var $242=HEAP32[((10688)>>2)];
 var $243=($241>>>0)<($242>>>0);
 if($243){label=67;break;}else{label=66;break;}
 case 66: 
 var $245=(($R_1+20)|0);
 HEAP32[(($245)>>2)]=$238;
 var $246=(($238+24)|0);
 HEAP32[(($246)>>2)]=$R_1;
 label=69;break;
 case 67: 
 _abort();
 throw "Reached an unreachable!";
 case 68: 
 _abort();
 throw "Reached an unreachable!";
 case 69: 
 var $250=($106>>>0)<16;
 if($250){label=70;break;}else{label=71;break;}
 case 70: 
 var $252=HEAP32[(($1)>>2)];
 var $253=$252&1;
 var $254=$103|$253;
 var $255=$254|2;
 HEAP32[(($1)>>2)]=$255;
 var $_sum910=$103|4;
 var $256=(($4+$_sum910)|0);
 var $257=$256;
 var $258=HEAP32[(($257)>>2)];
 var $259=$258|1;
 HEAP32[(($257)>>2)]=$259;
 var $newp_0=$p;label=73;break;
 case 71: 
 var $261=(($4+$nb)|0);
 var $262=$261;
 var $263=HEAP32[(($1)>>2)];
 var $264=$263&1;
 var $265=$264|$nb;
 var $266=$265|2;
 HEAP32[(($1)>>2)]=$266;
 var $_sum5=((($nb)+(4))|0);
 var $267=(($4+$_sum5)|0);
 var $268=$267;
 var $269=$106|3;
 HEAP32[(($268)>>2)]=$269;
 var $_sum78=$103|4;
 var $270=(($4+$_sum78)|0);
 var $271=$270;
 var $272=HEAP32[(($271)>>2)];
 var $273=$272|1;
 HEAP32[(($271)>>2)]=$273;
 _dispose_chunk($262,$106);
 var $newp_0=$p;label=73;break;
 case 72: 
 _abort();
 throw "Reached an unreachable!";
 case 73: 
 var $newp_0;
 return $newp_0;
  default: assert(0, "bad label: " + label);
 }

}


function _dispose_chunk($p,$psize){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=$p;
 var $2=(($1+$psize)|0);
 var $3=$2;
 var $4=(($p+4)|0);
 var $5=HEAP32[(($4)>>2)];
 var $6=$5&1;
 var $7=($6|0)==0;
 if($7){label=2;break;}else{var $_0=$p;var $_0277=$psize;label=54;break;}
 case 2: 
 var $9=(($p)|0);
 var $10=HEAP32[(($9)>>2)];
 var $11=$5&3;
 var $12=($11|0)==0;
 if($12){label=134;break;}else{label=3;break;}
 case 3: 
 var $14=(((-$10))|0);
 var $15=(($1+$14)|0);
 var $16=$15;
 var $17=((($10)+($psize))|0);
 var $18=HEAP32[((10688)>>2)];
 var $19=($15>>>0)<($18>>>0);
 if($19){label=53;break;}else{label=4;break;}
 case 4: 
 var $21=HEAP32[((10692)>>2)];
 var $22=($16|0)==($21|0);
 if($22){label=51;break;}else{label=5;break;}
 case 5: 
 var $24=$10>>>3;
 var $25=($10>>>0)<256;
 if($25){label=6;break;}else{label=18;break;}
 case 6: 
 var $_sum35=(((8)-($10))|0);
 var $27=(($1+$_sum35)|0);
 var $28=$27;
 var $29=HEAP32[(($28)>>2)];
 var $_sum36=(((12)-($10))|0);
 var $30=(($1+$_sum36)|0);
 var $31=$30;
 var $32=HEAP32[(($31)>>2)];
 var $33=$24<<1;
 var $34=((10712+($33<<2))|0);
 var $35=$34;
 var $36=($29|0)==($35|0);
 if($36){label=9;break;}else{label=7;break;}
 case 7: 
 var $38=$29;
 var $39=($38>>>0)<($18>>>0);
 if($39){label=17;break;}else{label=8;break;}
 case 8: 
 var $41=(($29+12)|0);
 var $42=HEAP32[(($41)>>2)];
 var $43=($42|0)==($16|0);
 if($43){label=9;break;}else{label=17;break;}
 case 9: 
 var $44=($32|0)==($29|0);
 if($44){label=10;break;}else{label=11;break;}
 case 10: 
 var $46=1<<$24;
 var $47=$46^-1;
 var $48=HEAP32[((10672)>>2)];
 var $49=$48&$47;
 HEAP32[((10672)>>2)]=$49;
 var $_0=$16;var $_0277=$17;label=54;break;
 case 11: 
 var $51=($32|0)==($35|0);
 if($51){label=12;break;}else{label=13;break;}
 case 12: 
 var $_pre65=(($32+8)|0);
 var $_pre_phi66=$_pre65;label=15;break;
 case 13: 
 var $53=$32;
 var $54=($53>>>0)<($18>>>0);
 if($54){label=16;break;}else{label=14;break;}
 case 14: 
 var $56=(($32+8)|0);
 var $57=HEAP32[(($56)>>2)];
 var $58=($57|0)==($16|0);
 if($58){var $_pre_phi66=$56;label=15;break;}else{label=16;break;}
 case 15: 
 var $_pre_phi66;
 var $59=(($29+12)|0);
 HEAP32[(($59)>>2)]=$32;
 HEAP32[(($_pre_phi66)>>2)]=$29;
 var $_0=$16;var $_0277=$17;label=54;break;
 case 16: 
 _abort();
 throw "Reached an unreachable!";
 case 17: 
 _abort();
 throw "Reached an unreachable!";
 case 18: 
 var $61=$15;
 var $_sum26=(((24)-($10))|0);
 var $62=(($1+$_sum26)|0);
 var $63=$62;
 var $64=HEAP32[(($63)>>2)];
 var $_sum27=(((12)-($10))|0);
 var $65=(($1+$_sum27)|0);
 var $66=$65;
 var $67=HEAP32[(($66)>>2)];
 var $68=($67|0)==($61|0);
 if($68){label=24;break;}else{label=19;break;}
 case 19: 
 var $_sum33=(((8)-($10))|0);
 var $70=(($1+$_sum33)|0);
 var $71=$70;
 var $72=HEAP32[(($71)>>2)];
 var $73=$72;
 var $74=($73>>>0)<($18>>>0);
 if($74){label=23;break;}else{label=20;break;}
 case 20: 
 var $76=(($72+12)|0);
 var $77=HEAP32[(($76)>>2)];
 var $78=($77|0)==($61|0);
 if($78){label=21;break;}else{label=23;break;}
 case 21: 
 var $80=(($67+8)|0);
 var $81=HEAP32[(($80)>>2)];
 var $82=($81|0)==($61|0);
 if($82){label=22;break;}else{label=23;break;}
 case 22: 
 HEAP32[(($76)>>2)]=$67;
 HEAP32[(($80)>>2)]=$72;
 var $R_1=$67;label=31;break;
 case 23: 
 _abort();
 throw "Reached an unreachable!";
 case 24: 
 var $_sum28=(((16)-($10))|0);
 var $_sum29=((($_sum28)+(4))|0);
 var $85=(($1+$_sum29)|0);
 var $86=$85;
 var $87=HEAP32[(($86)>>2)];
 var $88=($87|0)==0;
 if($88){label=25;break;}else{var $R_0=$87;var $RP_0=$86;label=26;break;}
 case 25: 
 var $90=(($1+$_sum28)|0);
 var $91=$90;
 var $92=HEAP32[(($91)>>2)];
 var $93=($92|0)==0;
 if($93){var $R_1=0;label=31;break;}else{var $R_0=$92;var $RP_0=$91;label=26;break;}
 case 26: 
 var $RP_0;
 var $R_0;
 var $94=(($R_0+20)|0);
 var $95=HEAP32[(($94)>>2)];
 var $96=($95|0)==0;
 if($96){label=27;break;}else{var $R_0=$95;var $RP_0=$94;label=26;break;}
 case 27: 
 var $98=(($R_0+16)|0);
 var $99=HEAP32[(($98)>>2)];
 var $100=($99|0)==0;
 if($100){label=28;break;}else{var $R_0=$99;var $RP_0=$98;label=26;break;}
 case 28: 
 var $102=$RP_0;
 var $103=($102>>>0)<($18>>>0);
 if($103){label=30;break;}else{label=29;break;}
 case 29: 
 HEAP32[(($RP_0)>>2)]=0;
 var $R_1=$R_0;label=31;break;
 case 30: 
 _abort();
 throw "Reached an unreachable!";
 case 31: 
 var $R_1;
 var $107=($64|0)==0;
 if($107){var $_0=$16;var $_0277=$17;label=54;break;}else{label=32;break;}
 case 32: 
 var $_sum30=(((28)-($10))|0);
 var $109=(($1+$_sum30)|0);
 var $110=$109;
 var $111=HEAP32[(($110)>>2)];
 var $112=((10976+($111<<2))|0);
 var $113=HEAP32[(($112)>>2)];
 var $114=($61|0)==($113|0);
 if($114){label=33;break;}else{label=35;break;}
 case 33: 
 HEAP32[(($112)>>2)]=$R_1;
 var $cond=($R_1|0)==0;
 if($cond){label=34;break;}else{label=41;break;}
 case 34: 
 var $116=1<<$111;
 var $117=$116^-1;
 var $118=HEAP32[((10676)>>2)];
 var $119=$118&$117;
 HEAP32[((10676)>>2)]=$119;
 var $_0=$16;var $_0277=$17;label=54;break;
 case 35: 
 var $121=$64;
 var $122=HEAP32[((10688)>>2)];
 var $123=($121>>>0)<($122>>>0);
 if($123){label=39;break;}else{label=36;break;}
 case 36: 
 var $125=(($64+16)|0);
 var $126=HEAP32[(($125)>>2)];
 var $127=($126|0)==($61|0);
 if($127){label=37;break;}else{label=38;break;}
 case 37: 
 HEAP32[(($125)>>2)]=$R_1;
 label=40;break;
 case 38: 
 var $130=(($64+20)|0);
 HEAP32[(($130)>>2)]=$R_1;
 label=40;break;
 case 39: 
 _abort();
 throw "Reached an unreachable!";
 case 40: 
 var $133=($R_1|0)==0;
 if($133){var $_0=$16;var $_0277=$17;label=54;break;}else{label=41;break;}
 case 41: 
 var $135=$R_1;
 var $136=HEAP32[((10688)>>2)];
 var $137=($135>>>0)<($136>>>0);
 if($137){label=50;break;}else{label=42;break;}
 case 42: 
 var $139=(($R_1+24)|0);
 HEAP32[(($139)>>2)]=$64;
 var $_sum31=(((16)-($10))|0);
 var $140=(($1+$_sum31)|0);
 var $141=$140;
 var $142=HEAP32[(($141)>>2)];
 var $143=($142|0)==0;
 if($143){label=46;break;}else{label=43;break;}
 case 43: 
 var $145=$142;
 var $146=HEAP32[((10688)>>2)];
 var $147=($145>>>0)<($146>>>0);
 if($147){label=45;break;}else{label=44;break;}
 case 44: 
 var $149=(($R_1+16)|0);
 HEAP32[(($149)>>2)]=$142;
 var $150=(($142+24)|0);
 HEAP32[(($150)>>2)]=$R_1;
 label=46;break;
 case 45: 
 _abort();
 throw "Reached an unreachable!";
 case 46: 
 var $_sum32=((($_sum31)+(4))|0);
 var $153=(($1+$_sum32)|0);
 var $154=$153;
 var $155=HEAP32[(($154)>>2)];
 var $156=($155|0)==0;
 if($156){var $_0=$16;var $_0277=$17;label=54;break;}else{label=47;break;}
 case 47: 
 var $158=$155;
 var $159=HEAP32[((10688)>>2)];
 var $160=($158>>>0)<($159>>>0);
 if($160){label=49;break;}else{label=48;break;}
 case 48: 
 var $162=(($R_1+20)|0);
 HEAP32[(($162)>>2)]=$155;
 var $163=(($155+24)|0);
 HEAP32[(($163)>>2)]=$R_1;
 var $_0=$16;var $_0277=$17;label=54;break;
 case 49: 
 _abort();
 throw "Reached an unreachable!";
 case 50: 
 _abort();
 throw "Reached an unreachable!";
 case 51: 
 var $_sum=((($psize)+(4))|0);
 var $167=(($1+$_sum)|0);
 var $168=$167;
 var $169=HEAP32[(($168)>>2)];
 var $170=$169&3;
 var $171=($170|0)==3;
 if($171){label=52;break;}else{var $_0=$16;var $_0277=$17;label=54;break;}
 case 52: 
 HEAP32[((10680)>>2)]=$17;
 var $173=HEAP32[(($168)>>2)];
 var $174=$173&-2;
 HEAP32[(($168)>>2)]=$174;
 var $175=$17|1;
 var $_sum24=(((4)-($10))|0);
 var $176=(($1+$_sum24)|0);
 var $177=$176;
 HEAP32[(($177)>>2)]=$175;
 var $178=$2;
 HEAP32[(($178)>>2)]=$17;
 label=134;break;
 case 53: 
 _abort();
 throw "Reached an unreachable!";
 case 54: 
 var $_0277;
 var $_0;
 var $180=HEAP32[((10688)>>2)];
 var $181=($2>>>0)<($180>>>0);
 if($181){label=133;break;}else{label=55;break;}
 case 55: 
 var $_sum1=((($psize)+(4))|0);
 var $183=(($1+$_sum1)|0);
 var $184=$183;
 var $185=HEAP32[(($184)>>2)];
 var $186=$185&2;
 var $187=($186|0)==0;
 if($187){label=56;break;}else{label=109;break;}
 case 56: 
 var $189=HEAP32[((10696)>>2)];
 var $190=($3|0)==($189|0);
 if($190){label=57;break;}else{label=59;break;}
 case 57: 
 var $192=HEAP32[((10684)>>2)];
 var $193=((($192)+($_0277))|0);
 HEAP32[((10684)>>2)]=$193;
 HEAP32[((10696)>>2)]=$_0;
 var $194=$193|1;
 var $195=(($_0+4)|0);
 HEAP32[(($195)>>2)]=$194;
 var $196=HEAP32[((10692)>>2)];
 var $197=($_0|0)==($196|0);
 if($197){label=58;break;}else{label=134;break;}
 case 58: 
 HEAP32[((10692)>>2)]=0;
 HEAP32[((10680)>>2)]=0;
 label=134;break;
 case 59: 
 var $200=HEAP32[((10692)>>2)];
 var $201=($3|0)==($200|0);
 if($201){label=60;break;}else{label=61;break;}
 case 60: 
 var $203=HEAP32[((10680)>>2)];
 var $204=((($203)+($_0277))|0);
 HEAP32[((10680)>>2)]=$204;
 HEAP32[((10692)>>2)]=$_0;
 var $205=$204|1;
 var $206=(($_0+4)|0);
 HEAP32[(($206)>>2)]=$205;
 var $207=$_0;
 var $208=(($207+$204)|0);
 var $209=$208;
 HEAP32[(($209)>>2)]=$204;
 label=134;break;
 case 61: 
 var $211=$185&-8;
 var $212=((($211)+($_0277))|0);
 var $213=$185>>>3;
 var $214=($185>>>0)<256;
 if($214){label=62;break;}else{label=74;break;}
 case 62: 
 var $_sum20=((($psize)+(8))|0);
 var $216=(($1+$_sum20)|0);
 var $217=$216;
 var $218=HEAP32[(($217)>>2)];
 var $_sum21=((($psize)+(12))|0);
 var $219=(($1+$_sum21)|0);
 var $220=$219;
 var $221=HEAP32[(($220)>>2)];
 var $222=$213<<1;
 var $223=((10712+($222<<2))|0);
 var $224=$223;
 var $225=($218|0)==($224|0);
 if($225){label=65;break;}else{label=63;break;}
 case 63: 
 var $227=$218;
 var $228=($227>>>0)<($180>>>0);
 if($228){label=73;break;}else{label=64;break;}
 case 64: 
 var $230=(($218+12)|0);
 var $231=HEAP32[(($230)>>2)];
 var $232=($231|0)==($3|0);
 if($232){label=65;break;}else{label=73;break;}
 case 65: 
 var $233=($221|0)==($218|0);
 if($233){label=66;break;}else{label=67;break;}
 case 66: 
 var $235=1<<$213;
 var $236=$235^-1;
 var $237=HEAP32[((10672)>>2)];
 var $238=$237&$236;
 HEAP32[((10672)>>2)]=$238;
 label=107;break;
 case 67: 
 var $240=($221|0)==($224|0);
 if($240){label=68;break;}else{label=69;break;}
 case 68: 
 var $_pre63=(($221+8)|0);
 var $_pre_phi64=$_pre63;label=71;break;
 case 69: 
 var $242=$221;
 var $243=($242>>>0)<($180>>>0);
 if($243){label=72;break;}else{label=70;break;}
 case 70: 
 var $245=(($221+8)|0);
 var $246=HEAP32[(($245)>>2)];
 var $247=($246|0)==($3|0);
 if($247){var $_pre_phi64=$245;label=71;break;}else{label=72;break;}
 case 71: 
 var $_pre_phi64;
 var $248=(($218+12)|0);
 HEAP32[(($248)>>2)]=$221;
 HEAP32[(($_pre_phi64)>>2)]=$218;
 label=107;break;
 case 72: 
 _abort();
 throw "Reached an unreachable!";
 case 73: 
 _abort();
 throw "Reached an unreachable!";
 case 74: 
 var $250=$2;
 var $_sum2=((($psize)+(24))|0);
 var $251=(($1+$_sum2)|0);
 var $252=$251;
 var $253=HEAP32[(($252)>>2)];
 var $_sum3=((($psize)+(12))|0);
 var $254=(($1+$_sum3)|0);
 var $255=$254;
 var $256=HEAP32[(($255)>>2)];
 var $257=($256|0)==($250|0);
 if($257){label=80;break;}else{label=75;break;}
 case 75: 
 var $_sum18=((($psize)+(8))|0);
 var $259=(($1+$_sum18)|0);
 var $260=$259;
 var $261=HEAP32[(($260)>>2)];
 var $262=$261;
 var $263=($262>>>0)<($180>>>0);
 if($263){label=79;break;}else{label=76;break;}
 case 76: 
 var $265=(($261+12)|0);
 var $266=HEAP32[(($265)>>2)];
 var $267=($266|0)==($250|0);
 if($267){label=77;break;}else{label=79;break;}
 case 77: 
 var $269=(($256+8)|0);
 var $270=HEAP32[(($269)>>2)];
 var $271=($270|0)==($250|0);
 if($271){label=78;break;}else{label=79;break;}
 case 78: 
 HEAP32[(($265)>>2)]=$256;
 HEAP32[(($269)>>2)]=$261;
 var $R7_1=$256;label=87;break;
 case 79: 
 _abort();
 throw "Reached an unreachable!";
 case 80: 
 var $_sum5=((($psize)+(20))|0);
 var $274=(($1+$_sum5)|0);
 var $275=$274;
 var $276=HEAP32[(($275)>>2)];
 var $277=($276|0)==0;
 if($277){label=81;break;}else{var $R7_0=$276;var $RP9_0=$275;label=82;break;}
 case 81: 
 var $_sum4=((($psize)+(16))|0);
 var $279=(($1+$_sum4)|0);
 var $280=$279;
 var $281=HEAP32[(($280)>>2)];
 var $282=($281|0)==0;
 if($282){var $R7_1=0;label=87;break;}else{var $R7_0=$281;var $RP9_0=$280;label=82;break;}
 case 82: 
 var $RP9_0;
 var $R7_0;
 var $283=(($R7_0+20)|0);
 var $284=HEAP32[(($283)>>2)];
 var $285=($284|0)==0;
 if($285){label=83;break;}else{var $R7_0=$284;var $RP9_0=$283;label=82;break;}
 case 83: 
 var $287=(($R7_0+16)|0);
 var $288=HEAP32[(($287)>>2)];
 var $289=($288|0)==0;
 if($289){label=84;break;}else{var $R7_0=$288;var $RP9_0=$287;label=82;break;}
 case 84: 
 var $291=$RP9_0;
 var $292=($291>>>0)<($180>>>0);
 if($292){label=86;break;}else{label=85;break;}
 case 85: 
 HEAP32[(($RP9_0)>>2)]=0;
 var $R7_1=$R7_0;label=87;break;
 case 86: 
 _abort();
 throw "Reached an unreachable!";
 case 87: 
 var $R7_1;
 var $296=($253|0)==0;
 if($296){label=107;break;}else{label=88;break;}
 case 88: 
 var $_sum15=((($psize)+(28))|0);
 var $298=(($1+$_sum15)|0);
 var $299=$298;
 var $300=HEAP32[(($299)>>2)];
 var $301=((10976+($300<<2))|0);
 var $302=HEAP32[(($301)>>2)];
 var $303=($250|0)==($302|0);
 if($303){label=89;break;}else{label=91;break;}
 case 89: 
 HEAP32[(($301)>>2)]=$R7_1;
 var $cond53=($R7_1|0)==0;
 if($cond53){label=90;break;}else{label=97;break;}
 case 90: 
 var $305=1<<$300;
 var $306=$305^-1;
 var $307=HEAP32[((10676)>>2)];
 var $308=$307&$306;
 HEAP32[((10676)>>2)]=$308;
 label=107;break;
 case 91: 
 var $310=$253;
 var $311=HEAP32[((10688)>>2)];
 var $312=($310>>>0)<($311>>>0);
 if($312){label=95;break;}else{label=92;break;}
 case 92: 
 var $314=(($253+16)|0);
 var $315=HEAP32[(($314)>>2)];
 var $316=($315|0)==($250|0);
 if($316){label=93;break;}else{label=94;break;}
 case 93: 
 HEAP32[(($314)>>2)]=$R7_1;
 label=96;break;
 case 94: 
 var $319=(($253+20)|0);
 HEAP32[(($319)>>2)]=$R7_1;
 label=96;break;
 case 95: 
 _abort();
 throw "Reached an unreachable!";
 case 96: 
 var $322=($R7_1|0)==0;
 if($322){label=107;break;}else{label=97;break;}
 case 97: 
 var $324=$R7_1;
 var $325=HEAP32[((10688)>>2)];
 var $326=($324>>>0)<($325>>>0);
 if($326){label=106;break;}else{label=98;break;}
 case 98: 
 var $328=(($R7_1+24)|0);
 HEAP32[(($328)>>2)]=$253;
 var $_sum16=((($psize)+(16))|0);
 var $329=(($1+$_sum16)|0);
 var $330=$329;
 var $331=HEAP32[(($330)>>2)];
 var $332=($331|0)==0;
 if($332){label=102;break;}else{label=99;break;}
 case 99: 
 var $334=$331;
 var $335=HEAP32[((10688)>>2)];
 var $336=($334>>>0)<($335>>>0);
 if($336){label=101;break;}else{label=100;break;}
 case 100: 
 var $338=(($R7_1+16)|0);
 HEAP32[(($338)>>2)]=$331;
 var $339=(($331+24)|0);
 HEAP32[(($339)>>2)]=$R7_1;
 label=102;break;
 case 101: 
 _abort();
 throw "Reached an unreachable!";
 case 102: 
 var $_sum17=((($psize)+(20))|0);
 var $342=(($1+$_sum17)|0);
 var $343=$342;
 var $344=HEAP32[(($343)>>2)];
 var $345=($344|0)==0;
 if($345){label=107;break;}else{label=103;break;}
 case 103: 
 var $347=$344;
 var $348=HEAP32[((10688)>>2)];
 var $349=($347>>>0)<($348>>>0);
 if($349){label=105;break;}else{label=104;break;}
 case 104: 
 var $351=(($R7_1+20)|0);
 HEAP32[(($351)>>2)]=$344;
 var $352=(($344+24)|0);
 HEAP32[(($352)>>2)]=$R7_1;
 label=107;break;
 case 105: 
 _abort();
 throw "Reached an unreachable!";
 case 106: 
 _abort();
 throw "Reached an unreachable!";
 case 107: 
 var $355=$212|1;
 var $356=(($_0+4)|0);
 HEAP32[(($356)>>2)]=$355;
 var $357=$_0;
 var $358=(($357+$212)|0);
 var $359=$358;
 HEAP32[(($359)>>2)]=$212;
 var $360=HEAP32[((10692)>>2)];
 var $361=($_0|0)==($360|0);
 if($361){label=108;break;}else{var $_1=$212;label=110;break;}
 case 108: 
 HEAP32[((10680)>>2)]=$212;
 label=134;break;
 case 109: 
 var $364=$185&-2;
 HEAP32[(($184)>>2)]=$364;
 var $365=$_0277|1;
 var $366=(($_0+4)|0);
 HEAP32[(($366)>>2)]=$365;
 var $367=$_0;
 var $368=(($367+$_0277)|0);
 var $369=$368;
 HEAP32[(($369)>>2)]=$_0277;
 var $_1=$_0277;label=110;break;
 case 110: 
 var $_1;
 var $371=$_1>>>3;
 var $372=($_1>>>0)<256;
 if($372){label=111;break;}else{label=116;break;}
 case 111: 
 var $374=$371<<1;
 var $375=((10712+($374<<2))|0);
 var $376=$375;
 var $377=HEAP32[((10672)>>2)];
 var $378=1<<$371;
 var $379=$377&$378;
 var $380=($379|0)==0;
 if($380){label=112;break;}else{label=113;break;}
 case 112: 
 var $382=$377|$378;
 HEAP32[((10672)>>2)]=$382;
 var $_sum13_pre=((($374)+(2))|0);
 var $_pre=((10712+($_sum13_pre<<2))|0);
 var $F16_0=$376;var $_pre_phi=$_pre;label=115;break;
 case 113: 
 var $_sum14=((($374)+(2))|0);
 var $384=((10712+($_sum14<<2))|0);
 var $385=HEAP32[(($384)>>2)];
 var $386=$385;
 var $387=HEAP32[((10688)>>2)];
 var $388=($386>>>0)<($387>>>0);
 if($388){label=114;break;}else{var $F16_0=$385;var $_pre_phi=$384;label=115;break;}
 case 114: 
 _abort();
 throw "Reached an unreachable!";
 case 115: 
 var $_pre_phi;
 var $F16_0;
 HEAP32[(($_pre_phi)>>2)]=$_0;
 var $391=(($F16_0+12)|0);
 HEAP32[(($391)>>2)]=$_0;
 var $392=(($_0+8)|0);
 HEAP32[(($392)>>2)]=$F16_0;
 var $393=(($_0+12)|0);
 HEAP32[(($393)>>2)]=$376;
 label=134;break;
 case 116: 
 var $395=$_0;
 var $396=$_1>>>8;
 var $397=($396|0)==0;
 if($397){var $I19_0=0;label=119;break;}else{label=117;break;}
 case 117: 
 var $399=($_1>>>0)>16777215;
 if($399){var $I19_0=31;label=119;break;}else{label=118;break;}
 case 118: 
 var $401=((($396)+(1048320))|0);
 var $402=$401>>>16;
 var $403=$402&8;
 var $404=$396<<$403;
 var $405=((($404)+(520192))|0);
 var $406=$405>>>16;
 var $407=$406&4;
 var $408=$407|$403;
 var $409=$404<<$407;
 var $410=((($409)+(245760))|0);
 var $411=$410>>>16;
 var $412=$411&2;
 var $413=$408|$412;
 var $414=(((14)-($413))|0);
 var $415=$409<<$412;
 var $416=$415>>>15;
 var $417=((($414)+($416))|0);
 var $418=$417<<1;
 var $419=((($417)+(7))|0);
 var $420=$_1>>>($419>>>0);
 var $421=$420&1;
 var $422=$421|$418;
 var $I19_0=$422;label=119;break;
 case 119: 
 var $I19_0;
 var $424=((10976+($I19_0<<2))|0);
 var $425=(($_0+28)|0);
 var $I19_0_c=$I19_0;
 HEAP32[(($425)>>2)]=$I19_0_c;
 var $426=(($_0+20)|0);
 HEAP32[(($426)>>2)]=0;
 var $427=(($_0+16)|0);
 HEAP32[(($427)>>2)]=0;
 var $428=HEAP32[((10676)>>2)];
 var $429=1<<$I19_0;
 var $430=$428&$429;
 var $431=($430|0)==0;
 if($431){label=120;break;}else{label=121;break;}
 case 120: 
 var $433=$428|$429;
 HEAP32[((10676)>>2)]=$433;
 HEAP32[(($424)>>2)]=$395;
 var $434=(($_0+24)|0);
 var $_c=$424;
 HEAP32[(($434)>>2)]=$_c;
 var $435=(($_0+12)|0);
 HEAP32[(($435)>>2)]=$_0;
 var $436=(($_0+8)|0);
 HEAP32[(($436)>>2)]=$_0;
 label=134;break;
 case 121: 
 var $438=HEAP32[(($424)>>2)];
 var $439=($I19_0|0)==31;
 if($439){var $444=0;label=123;break;}else{label=122;break;}
 case 122: 
 var $441=$I19_0>>>1;
 var $442=(((25)-($441))|0);
 var $444=$442;label=123;break;
 case 123: 
 var $444;
 var $445=$_1<<$444;
 var $K20_0=$445;var $T_0=$438;label=124;break;
 case 124: 
 var $T_0;
 var $K20_0;
 var $447=(($T_0+4)|0);
 var $448=HEAP32[(($447)>>2)];
 var $449=$448&-8;
 var $450=($449|0)==($_1|0);
 if($450){label=129;break;}else{label=125;break;}
 case 125: 
 var $452=$K20_0>>>31;
 var $453=(($T_0+16+($452<<2))|0);
 var $454=HEAP32[(($453)>>2)];
 var $455=($454|0)==0;
 var $456=$K20_0<<1;
 if($455){label=126;break;}else{var $K20_0=$456;var $T_0=$454;label=124;break;}
 case 126: 
 var $458=$453;
 var $459=HEAP32[((10688)>>2)];
 var $460=($458>>>0)<($459>>>0);
 if($460){label=128;break;}else{label=127;break;}
 case 127: 
 HEAP32[(($453)>>2)]=$395;
 var $462=(($_0+24)|0);
 var $T_0_c10=$T_0;
 HEAP32[(($462)>>2)]=$T_0_c10;
 var $463=(($_0+12)|0);
 HEAP32[(($463)>>2)]=$_0;
 var $464=(($_0+8)|0);
 HEAP32[(($464)>>2)]=$_0;
 label=134;break;
 case 128: 
 _abort();
 throw "Reached an unreachable!";
 case 129: 
 var $467=(($T_0+8)|0);
 var $468=HEAP32[(($467)>>2)];
 var $469=$T_0;
 var $470=HEAP32[((10688)>>2)];
 var $471=($469>>>0)<($470>>>0);
 if($471){label=132;break;}else{label=130;break;}
 case 130: 
 var $473=$468;
 var $474=($473>>>0)<($470>>>0);
 if($474){label=132;break;}else{label=131;break;}
 case 131: 
 var $476=(($468+12)|0);
 HEAP32[(($476)>>2)]=$395;
 HEAP32[(($467)>>2)]=$395;
 var $477=(($_0+8)|0);
 var $_c9=$468;
 HEAP32[(($477)>>2)]=$_c9;
 var $478=(($_0+12)|0);
 var $T_0_c=$T_0;
 HEAP32[(($478)>>2)]=$T_0_c;
 var $479=(($_0+24)|0);
 HEAP32[(($479)>>2)]=0;
 label=134;break;
 case 132: 
 _abort();
 throw "Reached an unreachable!";
 case 133: 
 _abort();
 throw "Reached an unreachable!";
 case 134: 
 return;
  default: assert(0, "bad label: " + label);
 }

}


function __Znwj($size){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=($size|0)==0;
 var $_size=($1?1:$size);
 label=2;break;
 case 2: 
 var $3=_malloc($_size);
 var $4=($3|0)==0;
 if($4){label=3;break;}else{label=10;break;}
 case 3: 
 var $6=(tempValue=HEAP32[((14584)>>2)],HEAP32[((14584)>>2)]=tempValue+0,tempValue);
 var $7=($6|0)==0;
 if($7){label=9;break;}else{label=4;break;}
 case 4: 
 var $9=$6;
 (function() { try { __THREW__ = 0; return FUNCTION_TABLE[$9]() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=2;break; } else { label=5;break; }
 case 5: 
 var $lpad_loopexit$0 = ___cxa_find_matching_catch(-1, -1); var $lpad_loopexit$1 = tempRet0;
 var $lpad_phi$1=$lpad_loopexit$1;var $lpad_phi$0=$lpad_loopexit$0;label=7;break;
 case 6: 
 var $lpad_nonloopexit$0 = ___cxa_find_matching_catch(-1, -1); var $lpad_nonloopexit$1 = tempRet0;
 var $lpad_phi$1=$lpad_nonloopexit$1;var $lpad_phi$0=$lpad_nonloopexit$0;label=7;break;
 case 7: 
 var $lpad_phi$0;
 var $lpad_phi$1;
 var $11=$lpad_phi$1;
 var $12=($11|0)<0;
 if($12){label=8;break;}else{label=11;break;}
 case 8: 
 var $14=$lpad_phi$0;
 ___cxa_call_unexpected($14);
 throw "Reached an unreachable!";
 case 9: 
 var $16=___cxa_allocate_exception(4);
 var $17=$16;
 HEAP32[(($17)>>2)]=2928;
 (function() { try { __THREW__ = 0; return ___cxa_throw($16,8944,(72)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=12;break; } else { label=6;break; }
 case 10: 
 return $3;
 case 11: 
 ___resumeException($lpad_phi$0)
 case 12: 
 throw "Reached an unreachable!";
  default: assert(0, "bad label: " + label);
 }

}


function __Znaj($size){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=(function() { try { __THREW__ = 0; return __Znwj($size) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = 1; return null } })();if (!__THREW__) { label=2;break; } else { label=3;break; }
 case 2: 
 return $1;
 case 3: 
 var $4$0 = ___cxa_find_matching_catch(-1, -1); var $4$1 = tempRet0;
 var $5=$4$1;
 var $6=($5|0)<0;
 if($6){label=4;break;}else{label=5;break;}
 case 4: 
 var $8=$4$0;
 ___cxa_call_unexpected($8);
 throw "Reached an unreachable!";
 case 5: 
 ___resumeException($4$0)
  default: assert(0, "bad label: " + label);
 }

}


function __ZdlPv($ptr){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=($ptr|0)==0;
 if($1){label=3;break;}else{label=2;break;}
 case 2: 
 _free($ptr);
 label=3;break;
 case 3: 
 return;
  default: assert(0, "bad label: " + label);
 }

}


function __ZdaPv($ptr){
 var label=0;


 __ZdlPv($ptr);
 return;
}


function __ZNSt9bad_allocD0Ev($this){
 var label=0;


 var $1=(($this)|0);

 var $2=$this;
 __ZdlPv($2);
 return;
}


function __ZNSt9bad_allocD2Ev($this){
 var label=0;


 var $1=(($this)|0);

 return;
}


function __ZNKSt9bad_alloc4whatEv($this){
 var label=0;


 return 1136;
}


function __ZSt17__throw_bad_allocv(){
 var label=0;


 var $1=___cxa_allocate_exception(4);
 var $2=$1;
 HEAP32[(($2)>>2)]=2928;
 ___cxa_throw($1,8944,(72));
 throw "Reached an unreachable!";
}


function ___floatscan($f,$prec,$pok){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+512)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $x_i=sp;
 if(($prec|0)==1){ label=2;break;}else if(($prec|0)==2){ label=3;break;}else if(($prec|0)==0){ var $emin_0_ph=-149;var $bits_0_ph=24;label=4;break;}else{var $_0=0;label=271;break;}
 case 2: 
 var $emin_0_ph=-1074;var $bits_0_ph=53;label=4;break;
 case 3: 
 var $emin_0_ph=-1074;var $bits_0_ph=53;label=4;break;
 case 4: 
 var $bits_0_ph;
 var $emin_0_ph;
 var $3=(($f+4)|0);
 var $4=(($f+100)|0);
 label=5;break;
 case 5: 
 var $6=HEAP32[(($3)>>2)];
 var $7=HEAP32[(($4)>>2)];
 var $8=($6>>>0)<($7>>>0);
 if($8){label=6;break;}else{label=7;break;}
 case 6: 
 var $10=(($6+1)|0);
 HEAP32[(($3)>>2)]=$10;
 var $11=HEAP8[($6)];
 var $12=($11&255);
 var $16=$12;label=8;break;
 case 7: 
 var $14=___shgetc($f);
 var $16=$14;label=8;break;
 case 8: 
 var $16;
 var $17=_isspace($16);
 var $18=($17|0)==0;
 if($18){label=9;break;}else{label=5;break;}
 case 9: 
 var $20=($16|0)==45;
 if(($16|0)==45|($16|0)==43){ label=10;break;}else{var $c_0=$16;var $sign_0=1;label=13;break;}
 case 10: 
 var $22=($20&1);
 var $23=$22<<1;
 var $24=(((1)-($23))|0);
 var $25=HEAP32[(($3)>>2)];
 var $26=HEAP32[(($4)>>2)];
 var $27=($25>>>0)<($26>>>0);
 if($27){label=11;break;}else{label=12;break;}
 case 11: 
 var $29=(($25+1)|0);
 HEAP32[(($3)>>2)]=$29;
 var $30=HEAP8[($25)];
 var $31=($30&255);
 var $c_0=$31;var $sign_0=$24;label=13;break;
 case 12: 
 var $33=___shgetc($f);
 var $c_0=$33;var $sign_0=$24;label=13;break;
 case 13: 
 var $sign_0;
 var $c_0;
 var $i_0148=0;var $c_1149=$c_0;label=14;break;
 case 14: 
 var $c_1149;
 var $i_0148;
 var $36=$c_1149|32;
 var $37=((640+$i_0148)|0);
 var $38=HEAP8[($37)];
 var $39=(($38<<24)>>24);
 var $40=($36|0)==($39|0);
 if($40){label=15;break;}else{var $i_0_lcssa=$i_0148;var $c_1_lcssa=$c_1149;label=20;break;}
 case 15: 
 var $42=($i_0148>>>0)<7;
 if($42){label=16;break;}else{var $c_2=$c_1149;label=19;break;}
 case 16: 
 var $44=HEAP32[(($3)>>2)];
 var $45=HEAP32[(($4)>>2)];
 var $46=($44>>>0)<($45>>>0);
 if($46){label=17;break;}else{label=18;break;}
 case 17: 
 var $48=(($44+1)|0);
 HEAP32[(($3)>>2)]=$48;
 var $49=HEAP8[($44)];
 var $50=($49&255);
 var $c_2=$50;label=19;break;
 case 18: 
 var $52=___shgetc($f);
 var $c_2=$52;label=19;break;
 case 19: 
 var $c_2;
 var $54=((($i_0148)+(1))|0);
 var $55=($54>>>0)<8;
 if($55){var $i_0148=$54;var $c_1149=$c_2;label=14;break;}else{var $i_0_lcssa=$54;var $c_1_lcssa=$c_2;label=20;break;}
 case 20: 
 var $c_1_lcssa;
 var $i_0_lcssa;
 if(($i_0_lcssa|0)==3){ label=23;break;}else if(($i_0_lcssa|0)==8){ label=27;break;}else{label=21;break;}
 case 21: 
 var $57=($i_0_lcssa>>>0)<4;
 var $58=($pok|0)==0;
 var $or_cond=$57|$58;
 if($or_cond){label=28;break;}else{label=22;break;}
 case 22: 
 var $60=($i_0_lcssa|0)==8;
 if($60){label=27;break;}else{label=23;break;}
 case 23: 
 var $61=HEAP32[(($4)>>2)];
 var $62=($61|0)==0;
 if($62){label=25;break;}else{label=24;break;}
 case 24: 
 var $64=HEAP32[(($3)>>2)];
 var $65=((($64)-(1))|0);
 HEAP32[(($3)>>2)]=$65;
 label=25;break;
 case 25: 
 var $notlhs=($pok|0)==0;
 var $notrhs=($i_0_lcssa>>>0)<4;
 var $or_cond189_not=$notrhs|$notlhs;
 var $brmerge=$or_cond189_not|$62;
 if($brmerge){label=27;break;}else{var $i_1146=$i_0_lcssa;label=26;break;}
 case 26: 
 var $i_1146;
 var $68=HEAP32[(($3)>>2)];
 var $69=((($68)-(1))|0);
 HEAP32[(($3)>>2)]=$69;
 var $70=((($i_1146)-(1))|0);
 var $71=($70>>>0)>3;
 if($71){var $i_1146=$70;label=26;break;}else{label=27;break;}
 case 27: 
 var $72=($sign_0|0);
 var $73=($72)*(Infinity);
 var $74=$73;
 var $_0=$74;label=271;break;
 case 28: 
 var $76=($i_0_lcssa|0)==0;
 if($76){label=29;break;}else{label=53;break;}
 case 29: 
 var $77=$c_1_lcssa|32;
 var $78=($77|0)==110;
 if($78){label=30;break;}else{label=56;break;}
 case 30: 
 var $80=HEAP32[(($3)>>2)];
 var $81=HEAP32[(($4)>>2)];
 var $82=($80>>>0)<($81>>>0);
 if($82){label=31;break;}else{label=32;break;}
 case 31: 
 var $84=(($80+1)|0);
 HEAP32[(($3)>>2)]=$84;
 var $85=HEAP8[($80)];
 var $86=($85&255);
 var $c_4=$86;label=33;break;
 case 32: 
 var $88=___shgetc($f);
 var $c_4=$88;label=33;break;
 case 33: 
 var $c_4;
 var $90=$c_4|32;
 var $91=($90|0)==97;
 if($91){label=272;break;}else{label=53;break;}
 case 34: 
 var $92=HEAP32[(($3)>>2)];
 var $93=HEAP32[(($4)>>2)];
 var $94=($92>>>0)<($93>>>0);
 if($94){label=35;break;}else{label=36;break;}
 case 35: 
 var $96=(($92+1)|0);
 HEAP32[(($3)>>2)]=$96;
 var $97=HEAP8[($92)];
 var $98=($97&255);
 var $102=$98;label=37;break;
 case 36: 
 var $100=___shgetc($f);
 var $102=$100;label=37;break;
 case 37: 
 var $102;
 var $103=($102|0)==40;
 if($103){var $i_4=1;label=40;break;}else{label=38;break;}
 case 38: 
 var $105=HEAP32[(($4)>>2)];
 var $106=($105|0)==0;
 if($106){var $_0=NaN;label=271;break;}else{label=39;break;}
 case 39: 
 var $108=HEAP32[(($3)>>2)];
 var $109=((($108)-(1))|0);
 HEAP32[(($3)>>2)]=$109;
 var $_0=NaN;label=271;break;
 case 40: 
 var $i_4;
 var $110=HEAP32[(($3)>>2)];
 var $111=HEAP32[(($4)>>2)];
 var $112=($110>>>0)<($111>>>0);
 if($112){label=41;break;}else{label=42;break;}
 case 41: 
 var $114=(($110+1)|0);
 HEAP32[(($3)>>2)]=$114;
 var $115=HEAP8[($110)];
 var $116=($115&255);
 var $120=$116;label=43;break;
 case 42: 
 var $118=___shgetc($f);
 var $120=$118;label=43;break;
 case 43: 
 var $120;
 var $121=((($120)-(48))|0);
 var $122=($121>>>0)<10;
 var $123=((($120)-(65))|0);
 var $124=($123>>>0)<26;
 var $or_cond89=$122|$124;
 if($or_cond89){label=52;break;}else{label=44;break;}
 case 44: 
 var $126=((($120)-(97))|0);
 var $127=($126>>>0)<26;
 var $128=($120|0)==95;
 var $or_cond5=$127|$128;
 if($or_cond5){label=52;break;}else{label=45;break;}
 case 45: 
 var $130=($120|0)==41;
 if($130){var $_0=NaN;label=271;break;}else{label=46;break;}
 case 46: 
 var $132=HEAP32[(($4)>>2)];
 var $133=($132|0)==0;
 if($133){label=48;break;}else{label=47;break;}
 case 47: 
 var $135=HEAP32[(($3)>>2)];
 var $136=((($135)-(1))|0);
 HEAP32[(($3)>>2)]=$136;
 label=48;break;
 case 48: 
 if($58){label=50;break;}else{label=49;break;}
 case 49: 
 var $138=($i_4|0)==0;
 var $brmerge190=$138|$133;
 if($brmerge190){var $_0=NaN;label=271;break;}else{var $_in=$i_4;label=51;break;}
 case 50: 
 var $140=___errno_location();
 HEAP32[(($140)>>2)]=22;
 ___shlim($f,0);
 var $_0=0;label=271;break;
 case 51: 
 var $_in;
 var $141=((($_in)-(1))|0);
 var $142=HEAP32[(($3)>>2)];
 var $143=((($142)-(1))|0);
 HEAP32[(($3)>>2)]=$143;
 var $144=($141|0)==0;
 if($144){var $_0=NaN;label=271;break;}else{var $_in=$141;label=51;break;}
 case 52: 
 var $146=((($i_4)+(1))|0);
 var $i_4=$146;label=40;break;
 case 53: 
 var $147=HEAP32[(($4)>>2)];
 var $148=($147|0)==0;
 if($148){label=55;break;}else{label=54;break;}
 case 54: 
 var $150=HEAP32[(($3)>>2)];
 var $151=((($150)-(1))|0);
 HEAP32[(($3)>>2)]=$151;
 label=55;break;
 case 55: 
 var $153=___errno_location();
 HEAP32[(($153)>>2)]=22;
 ___shlim($f,0);
 var $_0=0;label=271;break;
 case 56: 
 var $154=($c_1_lcssa|0)==48;
 if($154){label=57;break;}else{var $c_6=$c_1_lcssa;label=132;break;}
 case 57: 
 var $156=HEAP32[(($3)>>2)];
 var $157=HEAP32[(($4)>>2)];
 var $158=($156>>>0)<($157>>>0);
 if($158){label=58;break;}else{label=59;break;}
 case 58: 
 var $160=(($156+1)|0);
 HEAP32[(($3)>>2)]=$160;
 var $161=HEAP8[($156)];
 var $162=($161&255);
 var $166=$162;label=60;break;
 case 59: 
 var $164=___shgetc($f);
 var $166=$164;label=60;break;
 case 60: 
 var $166;
 var $167=$166|32;
 var $168=($167|0)==120;
 if($168){label=61;break;}else{label=130;break;}
 case 61: 
 var $170=HEAP32[(($3)>>2)];
 var $171=HEAP32[(($4)>>2)];
 var $172=($170>>>0)<($171>>>0);
 if($172){label=62;break;}else{label=63;break;}
 case 62: 
 var $174=(($170+1)|0);
 HEAP32[(($3)>>2)]=$174;
 var $175=HEAP8[($170)];
 var $176=($175&255);
 var $c_0_i=$176;var $gotdig_0_i=0;label=64;break;
 case 63: 
 var $178=___shgetc($f);
 var $c_0_i=$178;var $gotdig_0_i=0;label=64;break;
 case 64: 
 var $gotdig_0_i;
 var $c_0_i;
 if(($c_0_i|0)==48){ label=65;break;}else if(($c_0_i|0)==46){ label=68;break;}else{var $c_2_i=$c_0_i;var $dc_0_i$1=0;var $dc_0_i$0=0;var $rp_1_i$1=0;var $rp_1_i$0=0;var $gotdig_2_i=$gotdig_0_i;var $gotrad_0_i=0;var $gottail_0_i=0;var $scale_0_i=1;var $y_0_i=0;var $x_0_i=0;label=77;break;}
 case 65: 
 var $180=HEAP32[(($3)>>2)];
 var $181=HEAP32[(($4)>>2)];
 var $182=($180>>>0)<($181>>>0);
 if($182){label=66;break;}else{label=67;break;}
 case 66: 
 var $184=(($180+1)|0);
 HEAP32[(($3)>>2)]=$184;
 var $185=HEAP8[($180)];
 var $186=($185&255);
 var $c_0_i=$186;var $gotdig_0_i=1;label=64;break;
 case 67: 
 var $188=___shgetc($f);
 var $c_0_i=$188;var $gotdig_0_i=1;label=64;break;
 case 68: 
 var $190=HEAP32[(($3)>>2)];
 var $191=HEAP32[(($4)>>2)];
 var $192=($190>>>0)<($191>>>0);
 if($192){label=69;break;}else{label=70;break;}
 case 69: 
 var $194=(($190+1)|0);
 HEAP32[(($3)>>2)]=$194;
 var $195=HEAP8[($190)];
 var $196=($195&255);
 var $c_1_ph_i=$196;label=71;break;
 case 70: 
 var $198=___shgetc($f);
 var $c_1_ph_i=$198;label=71;break;
 case 71: 
 var $c_1_ph_i;
 var $199=($c_1_ph_i|0)==48;
 if($199){var $rp_0113_i$1=-1;var $rp_0113_i$0=-1;label=72;break;}else{var $c_2_i=$c_1_ph_i;var $dc_0_i$1=0;var $dc_0_i$0=0;var $rp_1_i$1=0;var $rp_1_i$0=0;var $gotdig_2_i=$gotdig_0_i;var $gotrad_0_i=1;var $gottail_0_i=0;var $scale_0_i=1;var $y_0_i=0;var $x_0_i=0;label=77;break;}
 case 72: 
 var $rp_0113_i$0;
 var $rp_0113_i$1;
 var $200=HEAP32[(($3)>>2)];
 var $201=HEAP32[(($4)>>2)];
 var $202=($200>>>0)<($201>>>0);
 if($202){label=73;break;}else{label=74;break;}
 case 73: 
 var $204=(($200+1)|0);
 HEAP32[(($3)>>2)]=$204;
 var $205=HEAP8[($200)];
 var $206=($205&255);
 var $210=$206;label=75;break;
 case 74: 
 var $208=___shgetc($f);
 var $210=$208;label=75;break;
 case 75: 
 var $210;
 var $211=($210|0)==48;
 if($211){label=76;break;}else{var $c_2_i=$210;var $dc_0_i$1=0;var $dc_0_i$0=0;var $rp_1_i$1=$rp_0113_i$1;var $rp_1_i$0=$rp_0113_i$0;var $gotdig_2_i=1;var $gotrad_0_i=1;var $gottail_0_i=0;var $scale_0_i=1;var $y_0_i=0;var $x_0_i=0;label=77;break;}
 case 76: 
 var $$etemp$0$0=-1;
 var $$etemp$0$1=-1;
 var $phitmp_i$0=_i64Add($rp_0113_i$0,$rp_0113_i$1,$$etemp$0$0,$$etemp$0$1);var $phitmp_i$1=tempRet0;
 var $rp_0113_i$1=$phitmp_i$1;var $rp_0113_i$0=$phitmp_i$0;label=72;break;
 case 77: 
 var $x_0_i;
 var $y_0_i;
 var $scale_0_i;
 var $gottail_0_i;
 var $gotrad_0_i;
 var $gotdig_2_i;
 var $rp_1_i$0;
 var $rp_1_i$1;
 var $dc_0_i$0;
 var $dc_0_i$1;
 var $c_2_i;
 var $212=((($c_2_i)-(48))|0);
 var $213=($212>>>0)<10;
 if($213){var $d_0_i=$212;label=82;break;}else{label=78;break;}
 case 78: 
 var $215=$c_2_i|32;
 var $216=((($215)-(97))|0);
 var $217=($216>>>0)<6;
 var $218=($c_2_i|0)==46;
 var $or_cond_i=$217|$218;
 if($or_cond_i){label=79;break;}else{var $c_2_lcssa_i=$c_2_i;label=92;break;}
 case 79: 
 if($218){label=80;break;}else{label=81;break;}
 case 80: 
 var $220=($gotrad_0_i|0)==0;
 if($220){var $dc_1_i$1=$dc_0_i$1;var $dc_1_i$0=$dc_0_i$0;var $rp_2_i$1=$dc_0_i$1;var $rp_2_i$0=$dc_0_i$0;var $gotdig_3_i=$gotdig_2_i;var $gotrad_1_i=1;var $gottail_2_i=$gottail_0_i;var $scale_2_i=$scale_0_i;var $y_2_i=$y_0_i;var $x_2_i=$x_0_i;label=89;break;}else{var $c_2_lcssa_i=46;label=92;break;}
 case 81: 
 var $222=($c_2_i|0)>57;
 var $223=((($215)-(87))|0);
 var $_130_i=($222?$223:$212);
 var $d_0_i=$_130_i;label=82;break;
 case 82: 
 var $d_0_i;
 var $$etemp$1$0=8;
 var $$etemp$1$1=0;
 var $224=(($dc_0_i$1|0) < ($$etemp$1$1|0)) | (((($dc_0_i$1|0) == ($$etemp$1$1|0) & ($dc_0_i$0>>>0) <  ($$etemp$1$0>>>0))));
 if($224){label=83;break;}else{label=84;break;}
 case 83: 
 var $226=$x_0_i<<4;
 var $227=((($d_0_i)+($226))|0);
 var $gottail_1_i=$gottail_0_i;var $scale_1_i=$scale_0_i;var $y_1_i=$y_0_i;var $x_1_i=$227;label=88;break;
 case 84: 
 var $$etemp$2$0=14;
 var $$etemp$2$1=0;
 var $229=(($dc_0_i$1|0) < ($$etemp$2$1|0)) | (((($dc_0_i$1|0) == ($$etemp$2$1|0) & ($dc_0_i$0>>>0) <  ($$etemp$2$0>>>0))));
 if($229){label=85;break;}else{label=86;break;}
 case 85: 
 var $231=($d_0_i|0);
 var $232=($scale_0_i)*((0.0625));
 var $233=($232)*($231);
 var $234=($y_0_i)+($233);
 var $gottail_1_i=$gottail_0_i;var $scale_1_i=$232;var $y_1_i=$234;var $x_1_i=$x_0_i;label=88;break;
 case 86: 
 var $236=($d_0_i|0)!=0;
 var $237=($gottail_0_i|0)==0;
 var $or_cond95_i=$236&$237;
 if($or_cond95_i){label=87;break;}else{var $gottail_1_i=$gottail_0_i;var $scale_1_i=$scale_0_i;var $y_1_i=$y_0_i;var $x_1_i=$x_0_i;label=88;break;}
 case 87: 
 var $239=($scale_0_i)*((0.5));
 var $240=($y_0_i)+($239);
 var $gottail_1_i=1;var $scale_1_i=$scale_0_i;var $y_1_i=$240;var $x_1_i=$x_0_i;label=88;break;
 case 88: 
 var $x_1_i;
 var $y_1_i;
 var $scale_1_i;
 var $gottail_1_i;
 var $$etemp$3$0=1;
 var $$etemp$3$1=0;
 var $242$0=_i64Add($dc_0_i$0,$dc_0_i$1,$$etemp$3$0,$$etemp$3$1);var $242$1=tempRet0;
 var $dc_1_i$1=$242$1;var $dc_1_i$0=$242$0;var $rp_2_i$1=$rp_1_i$1;var $rp_2_i$0=$rp_1_i$0;var $gotdig_3_i=1;var $gotrad_1_i=$gotrad_0_i;var $gottail_2_i=$gottail_1_i;var $scale_2_i=$scale_1_i;var $y_2_i=$y_1_i;var $x_2_i=$x_1_i;label=89;break;
 case 89: 
 var $x_2_i;
 var $y_2_i;
 var $scale_2_i;
 var $gottail_2_i;
 var $gotrad_1_i;
 var $gotdig_3_i;
 var $rp_2_i$0;
 var $rp_2_i$1;
 var $dc_1_i$0;
 var $dc_1_i$1;
 var $243=HEAP32[(($3)>>2)];
 var $244=HEAP32[(($4)>>2)];
 var $245=($243>>>0)<($244>>>0);
 if($245){label=90;break;}else{label=91;break;}
 case 90: 
 var $247=(($243+1)|0);
 HEAP32[(($3)>>2)]=$247;
 var $248=HEAP8[($243)];
 var $249=($248&255);
 var $c_2_i=$249;var $dc_0_i$1=$dc_1_i$1;var $dc_0_i$0=$dc_1_i$0;var $rp_1_i$1=$rp_2_i$1;var $rp_1_i$0=$rp_2_i$0;var $gotdig_2_i=$gotdig_3_i;var $gotrad_0_i=$gotrad_1_i;var $gottail_0_i=$gottail_2_i;var $scale_0_i=$scale_2_i;var $y_0_i=$y_2_i;var $x_0_i=$x_2_i;label=77;break;
 case 91: 
 var $251=___shgetc($f);
 var $c_2_i=$251;var $dc_0_i$1=$dc_1_i$1;var $dc_0_i$0=$dc_1_i$0;var $rp_1_i$1=$rp_2_i$1;var $rp_1_i$0=$rp_2_i$0;var $gotdig_2_i=$gotdig_3_i;var $gotrad_0_i=$gotrad_1_i;var $gottail_0_i=$gottail_2_i;var $scale_0_i=$scale_2_i;var $y_0_i=$y_2_i;var $x_0_i=$x_2_i;label=77;break;
 case 92: 
 var $c_2_lcssa_i;
 var $253=($gotdig_2_i|0)==0;
 if($253){label=93;break;}else{label=101;break;}
 case 93: 
 var $255=HEAP32[(($4)>>2)];
 var $256=($255|0)==0;
 if($256){label=95;break;}else{label=94;break;}
 case 94: 
 var $258=HEAP32[(($3)>>2)];
 var $259=((($258)-(1))|0);
 HEAP32[(($3)>>2)]=$259;
 label=95;break;
 case 95: 
 if($58){label=99;break;}else{label=96;break;}
 case 96: 
 if($256){label=100;break;}else{label=97;break;}
 case 97: 
 var $263=HEAP32[(($3)>>2)];
 var $264=((($263)-(1))|0);
 HEAP32[(($3)>>2)]=$264;
 var $265=($gotrad_0_i|0)==0;
 if($265){label=100;break;}else{label=98;break;}
 case 98: 
 var $267=((($263)-(2))|0);
 HEAP32[(($3)>>2)]=$267;
 label=100;break;
 case 99: 
 ___shlim($f,0);
 label=100;break;
 case 100: 
 var $269=($sign_0|0);
 var $270=($269)*(0);
 var $_0=$270;label=271;break;
 case 101: 
 var $272=($gotrad_0_i|0)==0;
 var $dc_0_rp_1_i$0=($272?$dc_0_i$0:$rp_1_i$0);
 var $dc_0_rp_1_i$1=($272?$dc_0_i$1:$rp_1_i$1);
 var $$etemp$4$0=8;
 var $$etemp$4$1=0;
 var $273=(($dc_0_i$1|0) < ($$etemp$4$1|0)) | (((($dc_0_i$1|0) == ($$etemp$4$1|0) & ($dc_0_i$0>>>0) <  ($$etemp$4$0>>>0))));
 if($273){var $x_3105_i=$x_0_i;var $dc_2106_i$1=$dc_0_i$1;var $dc_2106_i$0=$dc_0_i$0;label=102;break;}else{var $x_3_lcssa_i=$x_0_i;label=103;break;}
 case 102: 
 var $dc_2106_i$0;
 var $dc_2106_i$1;
 var $x_3105_i;
 var $274=$x_3105_i<<4;
 var $$etemp$5$0=1;
 var $$etemp$5$1=0;
 var $275$0=_i64Add($dc_2106_i$0,$dc_2106_i$1,$$etemp$5$0,$$etemp$5$1);var $275$1=tempRet0;
 var $$etemp$6$0=8;
 var $$etemp$6$1=0;
 var $276=(($275$1|0) < ($$etemp$6$1|0)) | (((($275$1|0) == ($$etemp$6$1|0) & ($275$0>>>0) <  ($$etemp$6$0>>>0))));
 if($276){var $x_3105_i=$274;var $dc_2106_i$1=$275$1;var $dc_2106_i$0=$275$0;label=102;break;}else{var $x_3_lcssa_i=$274;label=103;break;}
 case 103: 
 var $x_3_lcssa_i;
 var $277=$c_2_lcssa_i|32;
 var $278=($277|0)==112;
 if($278){label=104;break;}else{label=109;break;}
 case 104: 
 var $280$0=_scanexp($f,$pok);
 var $280$1=tempRet0;
 var $$etemp$7$0=0;
 var $$etemp$7$1=-2147483648;
 var $281=(($280$0|0) == ($$etemp$7$0|0)) & (($280$1|0) == ($$etemp$7$1|0));
 if($281){label=105;break;}else{var $e2_0_i$1=$280$1;var $e2_0_i$0=$280$0;label=111;break;}
 case 105: 
 if($58){label=108;break;}else{label=106;break;}
 case 106: 
 var $284=HEAP32[(($4)>>2)];
 var $285=($284|0)==0;
 if($285){var $e2_0_i$1=0;var $e2_0_i$0=0;label=111;break;}else{label=107;break;}
 case 107: 
 var $287=HEAP32[(($3)>>2)];
 var $288=((($287)-(1))|0);
 HEAP32[(($3)>>2)]=$288;
 var $e2_0_i$1=0;var $e2_0_i$0=0;label=111;break;
 case 108: 
 ___shlim($f,0);
 var $_0=0;label=271;break;
 case 109: 
 var $291=HEAP32[(($4)>>2)];
 var $292=($291|0)==0;
 if($292){var $e2_0_i$1=0;var $e2_0_i$0=0;label=111;break;}else{label=110;break;}
 case 110: 
 var $294=HEAP32[(($3)>>2)];
 var $295=((($294)-(1))|0);
 HEAP32[(($3)>>2)]=$295;
 var $e2_0_i$1=0;var $e2_0_i$0=0;label=111;break;
 case 111: 
 var $e2_0_i$0;
 var $e2_0_i$1;
 var $297$0=($dc_0_rp_1_i$0<<2)|(0>>>30);
 var $297$1=($dc_0_rp_1_i$1<<2)|($dc_0_rp_1_i$0>>>30);
 var $$etemp$8$0=-32;
 var $$etemp$8$1=-1;
 var $298$0=_i64Add($297$0,$297$1,$$etemp$8$0,$$etemp$8$1);var $298$1=tempRet0;
 var $299$0=_i64Add($298$0,$298$1,$e2_0_i$0,$e2_0_i$1);var $299$1=tempRet0;
 var $300=($x_3_lcssa_i|0)==0;
 if($300){label=112;break;}else{label=113;break;}
 case 112: 
 var $302=($sign_0|0);
 var $303=($302)*(0);
 var $_0=$303;label=271;break;
 case 113: 
 var $305=(((-$emin_0_ph))|0);
 var $306$0=$305;
 var $306$1=0;
 var $307=(($299$1|0) > ($306$1|0)) | (((($299$1|0) == ($306$1|0) & ($299$0>>>0) >  ($306$0>>>0))));
 if($307){label=114;break;}else{label=115;break;}
 case 114: 
 var $309=___errno_location();
 HEAP32[(($309)>>2)]=34;
 var $310=($sign_0|0);
 var $311=($310)*((1.7976931348623157e+308));
 var $312=($311)*((1.7976931348623157e+308));
 var $_0=$312;label=271;break;
 case 115: 
 var $314=((($emin_0_ph)-(106))|0);
 var $315$0=$314;
 var $315$1=((((($314|0)<0))|0)?-1:0);
 var $316=(($299$1|0) < ($315$1|0)) | (((($299$1|0) == ($315$1|0) & ($299$0>>>0) <  ($315$0>>>0))));
 if($316){label=117;break;}else{label=116;break;}
 case 116: 
 var $317=($x_3_lcssa_i|0)>-1;
 if($317){var $x_4100_i=$x_3_lcssa_i;var $y_3101_i=$y_0_i;var $e2_1102_i$1=$299$1;var $e2_1102_i$0=$299$0;label=118;break;}else{var $x_4_lcssa_i=$x_3_lcssa_i;var $y_3_lcssa_i=$y_0_i;var $e2_1_lcssa_i$1=$299$1;var $e2_1_lcssa_i$0=$299$0;label=121;break;}
 case 117: 
 var $319=___errno_location();
 HEAP32[(($319)>>2)]=34;
 var $320=($sign_0|0);
 var $321=($320)*((2.2250738585072014e-308));
 var $322=($321)*((2.2250738585072014e-308));
 var $_0=$322;label=271;break;
 case 118: 
 var $e2_1102_i$0;
 var $e2_1102_i$1;
 var $y_3101_i;
 var $x_4100_i;
 var $323=$y_3101_i<(0.5);
 var $324=$x_4100_i<<1;
 if($323){var $_pn_i=$y_3101_i;var $x_5_i=$324;label=120;break;}else{label=119;break;}
 case 119: 
 var $326=$324|1;
 var $327=($y_3101_i)-(1);
 var $_pn_i=$327;var $x_5_i=$326;label=120;break;
 case 120: 
 var $x_5_i;
 var $_pn_i;
 var $y_4_i=($y_3101_i)+($_pn_i);
 var $$etemp$9$0=-1;
 var $$etemp$9$1=-1;
 var $329$0=_i64Add($e2_1102_i$0,$e2_1102_i$1,$$etemp$9$0,$$etemp$9$1);var $329$1=tempRet0;
 var $330=($x_5_i|0)>-1;
 if($330){var $x_4100_i=$x_5_i;var $y_3101_i=$y_4_i;var $e2_1102_i$1=$329$1;var $e2_1102_i$0=$329$0;label=118;break;}else{var $x_4_lcssa_i=$x_5_i;var $y_3_lcssa_i=$y_4_i;var $e2_1_lcssa_i$1=$329$1;var $e2_1_lcssa_i$0=$329$0;label=121;break;}
 case 121: 
 var $e2_1_lcssa_i$0;
 var $e2_1_lcssa_i$1;
 var $y_3_lcssa_i;
 var $x_4_lcssa_i;
 var $331$0=$bits_0_ph;
 var $331$1=0;
 var $332$0=$emin_0_ph;
 var $332$1=((((($emin_0_ph|0)<0))|0)?-1:0);
 var $$etemp$10$0=32;
 var $$etemp$10$1=0;
 var $333$0=_i64Subtract($$etemp$10$0,$$etemp$10$1,$332$0,$332$1);var $333$1=tempRet0;
 var $334$0=_i64Add($e2_1_lcssa_i$0,$e2_1_lcssa_i$1,$333$0,$333$1);var $334$1=tempRet0;
 var $335=(($331$1|0) > ($334$1|0)) | (((($331$1|0) == ($334$1|0) & ($331$0>>>0) >  ($334$0>>>0))));
 if($335){label=122;break;}else{var $_094_i=$bits_0_ph;label=123;break;}
 case 122: 
 var $337$0=$334$0;
 var $337=$337$0;
 var $338=($337|0)<0;
 var $__i=($338?0:$337);
 var $_094_i=$__i;label=123;break;
 case 123: 
 var $_094_i;
 var $340=($_094_i|0)<53;
 if($340){label=125;break;}else{label=124;break;}
 case 124: 
 var $_pre_i=($sign_0|0);
 var $y_5_i=$y_3_lcssa_i;var $x_6_i=$x_4_lcssa_i;var $bias_099_i=0;var $_pre_phi_i=$_pre_i;label=127;break;
 case 125: 
 var $342=(((84)-($_094_i))|0);
 var $343=_scalbn(1,$342);
 var $344=($sign_0|0);
 var $345=_copysign($343,$344);
 var $346=($_094_i|0)<32;
 var $347=$y_3_lcssa_i!=0;
 var $or_cond96_i=$346&$347;
 if($or_cond96_i){label=126;break;}else{var $y_5_i=$y_3_lcssa_i;var $x_6_i=$x_4_lcssa_i;var $bias_099_i=$345;var $_pre_phi_i=$344;label=127;break;}
 case 126: 
 var $349=$x_4_lcssa_i&1;
 var $350=($349|0)==0;
 var $351=$349^1;
 var $_x_4_i=((($351)+($x_4_lcssa_i))|0);
 var $_y_3_i=($350?0:$y_3_lcssa_i);
 var $y_5_i=$_y_3_i;var $x_6_i=$_x_4_i;var $bias_099_i=$345;var $_pre_phi_i=$344;label=127;break;
 case 127: 
 var $_pre_phi_i;
 var $bias_099_i;
 var $x_6_i;
 var $y_5_i;
 var $352=($x_6_i>>>0);
 var $353=($_pre_phi_i)*($352);
 var $354=($bias_099_i)+($353);
 var $355=($_pre_phi_i)*($y_5_i);
 var $356=($355)+($354);
 var $357=($356)-($bias_099_i);
 var $358=$357!=0;
 if($358){label=129;break;}else{label=128;break;}
 case 128: 
 var $360=___errno_location();
 HEAP32[(($360)>>2)]=34;
 label=129;break;
 case 129: 
 var $362$0=$e2_1_lcssa_i$0;
 var $362=$362$0;
 var $363=_scalbnl($357,$362);
 var $_0=$363;label=271;break;
 case 130: 
 var $365=HEAP32[(($4)>>2)];
 var $366=($365|0)==0;
 if($366){var $c_6=48;label=132;break;}else{label=131;break;}
 case 131: 
 var $368=HEAP32[(($3)>>2)];
 var $369=((($368)-(1))|0);
 HEAP32[(($3)>>2)]=$369;
 var $c_6=48;label=132;break;
 case 132: 
 var $c_6;
 var $371=$x_i;
 var $sum_i=((($emin_0_ph)+($bits_0_ph))|0);
 var $372=(((3)-($sum_i))|0);
 var $_0234_i=$c_6;var $gotdig_0_i90=0;label=133;break;
 case 133: 
 var $gotdig_0_i90;
 var $_0234_i;
 if(($_0234_i|0)==48){ label=134;break;}else if(($_0234_i|0)==46){ label=137;break;}else{var $_2_i=$_0234_i;var $gotrad_0_i93=0;var $gotdig_2_i92=$gotdig_0_i90;var $lrp_1_i$1=0;var $lrp_1_i$0=0;label=146;break;}
 case 134: 
 var $374=HEAP32[(($3)>>2)];
 var $375=HEAP32[(($4)>>2)];
 var $376=($374>>>0)<($375>>>0);
 if($376){label=135;break;}else{label=136;break;}
 case 135: 
 var $378=(($374+1)|0);
 HEAP32[(($3)>>2)]=$378;
 var $379=HEAP8[($374)];
 var $380=($379&255);
 var $_0234_i=$380;var $gotdig_0_i90=1;label=133;break;
 case 136: 
 var $382=___shgetc($f);
 var $_0234_i=$382;var $gotdig_0_i90=1;label=133;break;
 case 137: 
 var $384=HEAP32[(($3)>>2)];
 var $385=HEAP32[(($4)>>2)];
 var $386=($384>>>0)<($385>>>0);
 if($386){label=138;break;}else{label=139;break;}
 case 138: 
 var $388=(($384+1)|0);
 HEAP32[(($3)>>2)]=$388;
 var $389=HEAP8[($384)];
 var $390=($389&255);
 var $_1_ph_i=$390;label=140;break;
 case 139: 
 var $392=___shgetc($f);
 var $_1_ph_i=$392;label=140;break;
 case 140: 
 var $_1_ph_i;
 var $393=($_1_ph_i|0)==48;
 if($393){var $lrp_0336_i$1=-1;var $lrp_0336_i$0=-1;label=141;break;}else{var $_2_i=$_1_ph_i;var $gotrad_0_i93=1;var $gotdig_2_i92=$gotdig_0_i90;var $lrp_1_i$1=0;var $lrp_1_i$0=0;label=146;break;}
 case 141: 
 var $lrp_0336_i$0;
 var $lrp_0336_i$1;
 var $394=HEAP32[(($3)>>2)];
 var $395=HEAP32[(($4)>>2)];
 var $396=($394>>>0)<($395>>>0);
 if($396){label=142;break;}else{label=143;break;}
 case 142: 
 var $398=(($394+1)|0);
 HEAP32[(($3)>>2)]=$398;
 var $399=HEAP8[($394)];
 var $400=($399&255);
 var $_1_be_i=$400;label=144;break;
 case 143: 
 var $402=___shgetc($f);
 var $_1_be_i=$402;label=144;break;
 case 144: 
 var $_1_be_i;
 var $403=($_1_be_i|0)==48;
 if($403){label=145;break;}else{var $_2_i=$_1_be_i;var $gotrad_0_i93=1;var $gotdig_2_i92=1;var $lrp_1_i$1=$lrp_0336_i$1;var $lrp_1_i$0=$lrp_0336_i$0;label=146;break;}
 case 145: 
 var $$etemp$11$0=-1;
 var $$etemp$11$1=-1;
 var $phitmp_i91$0=_i64Add($lrp_0336_i$0,$lrp_0336_i$1,$$etemp$11$0,$$etemp$11$1);var $phitmp_i91$1=tempRet0;
 var $lrp_0336_i$1=$phitmp_i91$1;var $lrp_0336_i$0=$phitmp_i91$0;label=141;break;
 case 146: 
 var $lrp_1_i$0;
 var $lrp_1_i$1;
 var $gotdig_2_i92;
 var $gotrad_0_i93;
 var $_2_i;
 var $404=(($x_i)|0);
 HEAP32[(($404)>>2)]=0;
 var $405=((($_2_i)-(48))|0);
 var $406=($405>>>0)<10;
 var $407=($_2_i|0)==46;
 var $or_cond7315_i=$406|$407;
 if($or_cond7315_i){label=147;break;}else{var $lrp_2_lcssa_i$1=$lrp_1_i$1;var $lrp_2_lcssa_i$0=$lrp_1_i$0;var $dc_0_lcssa_i$1=0;var $dc_0_lcssa_i$0=0;var $lnz_0_lcssa_i=0;var $gotdig_3_lcssa_i=$gotdig_2_i92;var $gotrad_1_lcssa_i=$gotrad_0_i93;var $k_0_lcssa_i=0;var $j_0_lcssa_i=0;var $_3_lcssa_i=$_2_i;label=160;break;}
 case 147: 
 var $408=(($x_i+496)|0);
 var $lrp_2316_i$1=$lrp_1_i$1;var $lrp_2316_i$0=$lrp_1_i$0;var $dc_0317_i$1=0;var $dc_0317_i$0=0;var $lnz_0318_i=0;var $gotdig_3319_i=$gotdig_2_i92;var $gotrad_1320_i=$gotrad_0_i93;var $k_0321_i=0;var $j_0322_i=0;var $_3323_i=$_2_i;var $410=$405;var $409=$407;label=148;break;
 case 148: 
 var $409;
 var $410;
 var $_3323_i;
 var $j_0322_i;
 var $k_0321_i;
 var $gotrad_1320_i;
 var $gotdig_3319_i;
 var $lnz_0318_i;
 var $dc_0317_i$0;
 var $dc_0317_i$1;
 var $lrp_2316_i$0;
 var $lrp_2316_i$1;
 if($409){label=149;break;}else{label=150;break;}
 case 149: 
 var $cond_i=($gotrad_1320_i|0)==0;
 if($cond_i){var $j_2_i=$j_0322_i;var $k_2_i=$k_0321_i;var $gotrad_2_i=1;var $gotdig_4_i=$gotdig_3319_i;var $lnz_2_i=$lnz_0318_i;var $dc_1_i96$1=$dc_0317_i$1;var $dc_1_i96$0=$dc_0317_i$0;var $lrp_3_i$1=$dc_0317_i$1;var $lrp_3_i$0=$dc_0317_i$0;label=156;break;}else{var $lrp_4_i$1=$lrp_2316_i$1;var $lrp_4_i$0=$lrp_2316_i$0;var $dc_0303_i$1=$dc_0317_i$1;var $dc_0303_i$0=$dc_0317_i$0;var $lnz_0305_i=$lnz_0318_i;var $gotdig_3307_i=$gotdig_3319_i;var $k_0310_i=$k_0321_i;var $j_0312_i=$j_0322_i;var $_3314_i=$_3323_i;label=161;break;}
 case 150: 
 var $413=($k_0321_i|0)<125;
 var $$etemp$12$0=1;
 var $$etemp$12$1=0;
 var $414$0=_i64Add($dc_0317_i$0,$dc_0317_i$1,$$etemp$12$0,$$etemp$12$1);var $414$1=tempRet0;
 var $415=($_3323_i|0)!=48;
 if($413){label=151;break;}else{label=154;break;}
 case 151: 
 var $417$0=$414$0;
 var $417=$417$0;
 var $_lnz_0_i=($415?$417:$lnz_0318_i);
 var $418=($j_0322_i|0)==0;
 var $419=(($x_i+($k_0321_i<<2))|0);
 if($418){var $storemerge_i=$410;label=153;break;}else{label=152;break;}
 case 152: 
 var $421=HEAP32[(($419)>>2)];
 var $422=((($421)*(10))&-1);
 var $423=((($_3323_i)-(48))|0);
 var $424=((($423)+($422))|0);
 var $storemerge_i=$424;label=153;break;
 case 153: 
 var $storemerge_i;
 HEAP32[(($419)>>2)]=$storemerge_i;
 var $426=((($j_0322_i)+(1))|0);
 var $427=($426|0)==9;
 var $428=($427&1);
 var $_k_0_i=((($428)+($k_0321_i))|0);
 var $__i95=($427?0:$426);
 var $j_2_i=$__i95;var $k_2_i=$_k_0_i;var $gotrad_2_i=$gotrad_1320_i;var $gotdig_4_i=1;var $lnz_2_i=$_lnz_0_i;var $dc_1_i96$1=$414$1;var $dc_1_i96$0=$414$0;var $lrp_3_i$1=$lrp_2316_i$1;var $lrp_3_i$0=$lrp_2316_i$0;label=156;break;
 case 154: 
 if($415){label=155;break;}else{var $j_2_i=$j_0322_i;var $k_2_i=$k_0321_i;var $gotrad_2_i=$gotrad_1320_i;var $gotdig_4_i=$gotdig_3319_i;var $lnz_2_i=$lnz_0318_i;var $dc_1_i96$1=$414$1;var $dc_1_i96$0=$414$0;var $lrp_3_i$1=$lrp_2316_i$1;var $lrp_3_i$0=$lrp_2316_i$0;label=156;break;}
 case 155: 
 var $431=HEAP32[(($408)>>2)];
 var $432=$431|1;
 HEAP32[(($408)>>2)]=$432;
 var $j_2_i=$j_0322_i;var $k_2_i=$k_0321_i;var $gotrad_2_i=$gotrad_1320_i;var $gotdig_4_i=$gotdig_3319_i;var $lnz_2_i=$lnz_0318_i;var $dc_1_i96$1=$414$1;var $dc_1_i96$0=$414$0;var $lrp_3_i$1=$lrp_2316_i$1;var $lrp_3_i$0=$lrp_2316_i$0;label=156;break;
 case 156: 
 var $lrp_3_i$0;
 var $lrp_3_i$1;
 var $dc_1_i96$0;
 var $dc_1_i96$1;
 var $lnz_2_i;
 var $gotdig_4_i;
 var $gotrad_2_i;
 var $k_2_i;
 var $j_2_i;
 var $433=HEAP32[(($3)>>2)];
 var $434=HEAP32[(($4)>>2)];
 var $435=($433>>>0)<($434>>>0);
 if($435){label=157;break;}else{label=158;break;}
 case 157: 
 var $437=(($433+1)|0);
 HEAP32[(($3)>>2)]=$437;
 var $438=HEAP8[($433)];
 var $439=($438&255);
 var $_3_be_i=$439;label=159;break;
 case 158: 
 var $441=___shgetc($f);
 var $_3_be_i=$441;label=159;break;
 case 159: 
 var $_3_be_i;
 var $442=((($_3_be_i)-(48))|0);
 var $443=($442>>>0)<10;
 var $444=($_3_be_i|0)==46;
 var $or_cond7_i=$443|$444;
 if($or_cond7_i){var $lrp_2316_i$1=$lrp_3_i$1;var $lrp_2316_i$0=$lrp_3_i$0;var $dc_0317_i$1=$dc_1_i96$1;var $dc_0317_i$0=$dc_1_i96$0;var $lnz_0318_i=$lnz_2_i;var $gotdig_3319_i=$gotdig_4_i;var $gotrad_1320_i=$gotrad_2_i;var $k_0321_i=$k_2_i;var $j_0322_i=$j_2_i;var $_3323_i=$_3_be_i;var $410=$442;var $409=$444;label=148;break;}else{var $lrp_2_lcssa_i$1=$lrp_3_i$1;var $lrp_2_lcssa_i$0=$lrp_3_i$0;var $dc_0_lcssa_i$1=$dc_1_i96$1;var $dc_0_lcssa_i$0=$dc_1_i96$0;var $lnz_0_lcssa_i=$lnz_2_i;var $gotdig_3_lcssa_i=$gotdig_4_i;var $gotrad_1_lcssa_i=$gotrad_2_i;var $k_0_lcssa_i=$k_2_i;var $j_0_lcssa_i=$j_2_i;var $_3_lcssa_i=$_3_be_i;label=160;break;}
 case 160: 
 var $_3_lcssa_i;
 var $j_0_lcssa_i;
 var $k_0_lcssa_i;
 var $gotrad_1_lcssa_i;
 var $gotdig_3_lcssa_i;
 var $lnz_0_lcssa_i;
 var $dc_0_lcssa_i$0;
 var $dc_0_lcssa_i$1;
 var $lrp_2_lcssa_i$0;
 var $lrp_2_lcssa_i$1;
 var $445=($gotrad_1_lcssa_i|0)==0;
 var $dc_0_lrp_2_i$0=($445?$dc_0_lcssa_i$0:$lrp_2_lcssa_i$0);
 var $dc_0_lrp_2_i$1=($445?$dc_0_lcssa_i$1:$lrp_2_lcssa_i$1);
 var $lrp_4_i$1=$dc_0_lrp_2_i$1;var $lrp_4_i$0=$dc_0_lrp_2_i$0;var $dc_0303_i$1=$dc_0_lcssa_i$1;var $dc_0303_i$0=$dc_0_lcssa_i$0;var $lnz_0305_i=$lnz_0_lcssa_i;var $gotdig_3307_i=$gotdig_3_lcssa_i;var $k_0310_i=$k_0_lcssa_i;var $j_0312_i=$j_0_lcssa_i;var $_3314_i=$_3_lcssa_i;label=161;break;
 case 161: 
 var $_3314_i;
 var $j_0312_i;
 var $k_0310_i;
 var $gotdig_3307_i;
 var $lnz_0305_i;
 var $dc_0303_i$0;
 var $dc_0303_i$1;
 var $lrp_4_i$0;
 var $lrp_4_i$1;
 var $446=($gotdig_3307_i|0)!=0;
 if($446){label=162;break;}else{label=169;break;}
 case 162: 
 var $448=$_3314_i|32;
 var $449=($448|0)==101;
 if($449){label=163;break;}else{label=169;break;}
 case 163: 
 var $451$0=_scanexp($f,$pok);
 var $451$1=tempRet0;
 var $$etemp$13$0=0;
 var $$etemp$13$1=-2147483648;
 var $452=(($451$0|0) == ($$etemp$13$0|0)) & (($451$1|0) == ($$etemp$13$1|0));
 if($452){label=164;break;}else{var $e10_0_i$1=$451$1;var $e10_0_i$0=$451$0;label=168;break;}
 case 164: 
 if($58){label=167;break;}else{label=165;break;}
 case 165: 
 var $455=HEAP32[(($4)>>2)];
 var $456=($455|0)==0;
 if($456){var $e10_0_i$1=0;var $e10_0_i$0=0;label=168;break;}else{label=166;break;}
 case 166: 
 var $458=HEAP32[(($3)>>2)];
 var $459=((($458)-(1))|0);
 HEAP32[(($3)>>2)]=$459;
 var $e10_0_i$1=0;var $e10_0_i$0=0;label=168;break;
 case 167: 
 ___shlim($f,0);
 var $_0=0;label=271;break;
 case 168: 
 var $e10_0_i$0;
 var $e10_0_i$1;
 var $462$0=_i64Add($e10_0_i$0,$e10_0_i$1,$lrp_4_i$0,$lrp_4_i$1);var $462$1=tempRet0;
 var $lrp_5_i$1=$462$1;var $lrp_5_i$0=$462$0;label=172;break;
 case 169: 
 var $464=($_3314_i|0)>-1;
 if($464){label=170;break;}else{var $lrp_5_i$1=$lrp_4_i$1;var $lrp_5_i$0=$lrp_4_i$0;label=172;break;}
 case 170: 
 var $466=HEAP32[(($4)>>2)];
 var $467=($466|0)==0;
 if($467){var $lrp_5_i$1=$lrp_4_i$1;var $lrp_5_i$0=$lrp_4_i$0;label=172;break;}else{label=171;break;}
 case 171: 
 var $469=HEAP32[(($3)>>2)];
 var $470=((($469)-(1))|0);
 HEAP32[(($3)>>2)]=$470;
 var $lrp_5_i$1=$lrp_4_i$1;var $lrp_5_i$0=$lrp_4_i$0;label=172;break;
 case 172: 
 var $lrp_5_i$0;
 var $lrp_5_i$1;
 if($446){label=174;break;}else{label=173;break;}
 case 173: 
 var $473=___errno_location();
 HEAP32[(($473)>>2)]=22;
 ___shlim($f,0);
 var $_0=0;label=271;break;
 case 174: 
 var $475=HEAP32[(($404)>>2)];
 var $476=($475|0)==0;
 if($476){label=175;break;}else{label=176;break;}
 case 175: 
 var $478=($sign_0|0);
 var $479=($478)*(0);
 var $_0=$479;label=271;break;
 case 176: 
 var $481=(($lrp_5_i$0|0) == ($dc_0303_i$0|0)) & (($lrp_5_i$1|0) == ($dc_0303_i$1|0));
 var $$etemp$14$0=10;
 var $$etemp$14$1=0;
 var $482=(($dc_0303_i$1|0) < ($$etemp$14$1|0)) | (((($dc_0303_i$1|0) == ($$etemp$14$1|0) & ($dc_0303_i$0>>>0) <  ($$etemp$14$0>>>0))));
 var $or_cond_i97=$481&$482;
 if($or_cond_i97){label=177;break;}else{label=180;break;}
 case 177: 
 var $484=($bits_0_ph>>>0)>30;
 if($484){label=179;break;}else{label=178;break;}
 case 178: 
 var $486=$475>>>($bits_0_ph>>>0);
 var $487=($486|0)==0;
 if($487){label=179;break;}else{label=180;break;}
 case 179: 
 var $489=($sign_0|0);
 var $490=($475>>>0);
 var $491=($489)*($490);
 var $_0=$491;label=271;break;
 case 180: 
 var $493=(((($emin_0_ph|0))/(-2))&-1);
 var $494$0=$493;
 var $494$1=((((($493|0)<0))|0)?-1:0);
 var $495=(($lrp_5_i$1|0) > ($494$1|0)) | (((($lrp_5_i$1|0) == ($494$1|0) & ($lrp_5_i$0>>>0) >  ($494$0>>>0))));
 if($495){label=181;break;}else{label=182;break;}
 case 181: 
 var $497=___errno_location();
 HEAP32[(($497)>>2)]=34;
 var $498=($sign_0|0);
 var $499=($498)*((1.7976931348623157e+308));
 var $500=($499)*((1.7976931348623157e+308));
 var $_0=$500;label=271;break;
 case 182: 
 var $502=((($emin_0_ph)-(106))|0);
 var $503$0=$502;
 var $503$1=((((($502|0)<0))|0)?-1:0);
 var $504=(($lrp_5_i$1|0) < ($503$1|0)) | (((($lrp_5_i$1|0) == ($503$1|0) & ($lrp_5_i$0>>>0) <  ($503$0>>>0))));
 if($504){label=183;break;}else{label=184;break;}
 case 183: 
 var $506=___errno_location();
 HEAP32[(($506)>>2)]=34;
 var $507=($sign_0|0);
 var $508=($507)*((2.2250738585072014e-308));
 var $509=($508)*((2.2250738585072014e-308));
 var $_0=$509;label=271;break;
 case 184: 
 var $511=($j_0312_i|0)==0;
 if($511){var $k_3_i=$k_0310_i;label=190;break;}else{label=185;break;}
 case 185: 
 var $512=($j_0312_i|0)<9;
 if($512){label=186;break;}else{label=189;break;}
 case 186: 
 var $513=(($x_i+($k_0310_i<<2))|0);
 var $_promoted_i=HEAP32[(($513)>>2)];
 var $j_3297_i=$j_0312_i;var $515=$_promoted_i;label=187;break;
 case 187: 
 var $515;
 var $j_3297_i;
 var $516=((($515)*(10))&-1);
 var $517=((($j_3297_i)+(1))|0);
 var $518=($517|0)<9;
 if($518){var $j_3297_i=$517;var $515=$516;label=187;break;}else{label=188;break;}
 case 188: 
 HEAP32[(($513)>>2)]=$516;
 label=189;break;
 case 189: 
 var $520=((($k_0310_i)+(1))|0);
 var $k_3_i=$520;label=190;break;
 case 190: 
 var $k_3_i;
 var $522$0=$lrp_5_i$0;
 var $522=$522$0;
 var $523=($lnz_0305_i|0)<9;
 if($523){label=191;break;}else{label=199;break;}
 case 191: 
 var $525=($lnz_0305_i|0)<=($522|0);
 var $526=($522|0)<18;
 var $or_cond3_i=$525&$526;
 if($or_cond3_i){label=192;break;}else{label=199;break;}
 case 192: 
 var $528=($522|0)==9;
 if($528){label=193;break;}else{label=194;break;}
 case 193: 
 var $530=($sign_0|0);
 var $531=HEAP32[(($404)>>2)];
 var $532=($531>>>0);
 var $533=($530)*($532);
 var $_0=$533;label=271;break;
 case 194: 
 var $535=($522|0)<9;
 if($535){label=195;break;}else{label=196;break;}
 case 195: 
 var $537=($sign_0|0);
 var $538=HEAP32[(($404)>>2)];
 var $539=($538>>>0);
 var $540=($537)*($539);
 var $541=(((8)-($522))|0);
 var $542=((16+($541<<2))|0);
 var $543=HEAP32[(($542)>>2)];
 var $544=($543|0);
 var $545=($540)/($544);
 var $_0=$545;label=271;break;
 case 196: 
 var $547=((($522)*(-3))&-1);
 var $_neg247_i=((($bits_0_ph)+(27))|0);
 var $548=((($_neg247_i)+($547))|0);
 var $549=($548|0)>30;
 var $_pre_i98=HEAP32[(($404)>>2)];
 if($549){label=198;break;}else{label=197;break;}
 case 197: 
 var $551=$_pre_i98>>>($548>>>0);
 var $552=($551|0)==0;
 if($552){label=198;break;}else{label=199;break;}
 case 198: 
 var $553=($sign_0|0);
 var $554=($_pre_i98>>>0);
 var $555=($553)*($554);
 var $556=((($522)-(10))|0);
 var $557=((16+($556<<2))|0);
 var $558=HEAP32[(($557)>>2)];
 var $559=($558|0);
 var $560=($555)*($559);
 var $_0=$560;label=271;break;
 case 199: 
 var $562=(((($522|0))%(9))&-1);
 var $563=($562|0)==0;
 if($563){var $a_2_ph266_i=0;var $z_1_ph265_i=$k_3_i;var $e2_0_ph_i=0;var $rp_2_ph264_i=$522;label=208;break;}else{label=200;break;}
 case 200: 
 var $565=($522|0)>-1;
 var $566=((($562)+(9))|0);
 var $567=($565?$562:$566);
 var $568=(((8)-($567))|0);
 var $569=((16+($568<<2))|0);
 var $570=HEAP32[(($569)>>2)];
 var $571=($k_3_i|0)==0;
 if($571){var $z_0_i=0;var $a_0_lcssa387_i=0;var $rp_0_lcssa388_i=$522;label=207;break;}else{label=201;break;}
 case 201: 
 var $572=(((1000000000)/(($570|0)))&-1);
 var $rp_0286_i=$522;var $a_0287_i=0;var $k_4288_i=0;var $carry_0289_i=0;label=202;break;
 case 202: 
 var $carry_0289_i;
 var $k_4288_i;
 var $a_0287_i;
 var $rp_0286_i;
 var $573=(($x_i+($k_4288_i<<2))|0);
 var $574=HEAP32[(($573)>>2)];
 var $575=(((($574>>>0))%(($570>>>0)))&-1);
 var $576=(((($574>>>0))/(($570>>>0)))&-1);
 var $577=((($576)+($carry_0289_i))|0);
 HEAP32[(($573)>>2)]=$577;
 var $578=(Math_imul($575,$572)|0);
 var $579=($k_4288_i|0)==($a_0287_i|0);
 var $580=($577|0)==0;
 var $or_cond237_i=$579&$580;
 var $581=((($k_4288_i)+(1))|0);
 if($or_cond237_i){label=203;break;}else{var $a_1_i=$a_0287_i;var $rp_1_i99=$rp_0286_i;label=204;break;}
 case 203: 
 var $583=$581&127;
 var $584=((($rp_0286_i)-(9))|0);
 var $a_1_i=$583;var $rp_1_i99=$584;label=204;break;
 case 204: 
 var $rp_1_i99;
 var $a_1_i;
 var $585=($581|0)==($k_3_i|0);
 if($585){label=205;break;}else{var $rp_0286_i=$rp_1_i99;var $a_0287_i=$a_1_i;var $k_4288_i=$581;var $carry_0289_i=$578;label=202;break;}
 case 205: 
 var $586=($578|0)==0;
 if($586){var $z_0_i=$k_3_i;var $a_0_lcssa387_i=$a_1_i;var $rp_0_lcssa388_i=$rp_1_i99;label=207;break;}else{label=206;break;}
 case 206: 
 var $588=((($k_3_i)+(1))|0);
 var $589=(($x_i+($k_3_i<<2))|0);
 HEAP32[(($589)>>2)]=$578;
 var $z_0_i=$588;var $a_0_lcssa387_i=$a_1_i;var $rp_0_lcssa388_i=$rp_1_i99;label=207;break;
 case 207: 
 var $rp_0_lcssa388_i;
 var $a_0_lcssa387_i;
 var $z_0_i;
 var $590=(((9)-($567))|0);
 var $591=((($590)+($rp_0_lcssa388_i))|0);
 var $a_2_ph266_i=$a_0_lcssa387_i;var $z_1_ph265_i=$z_0_i;var $e2_0_ph_i=0;var $rp_2_ph264_i=$591;label=208;break;
 case 208: 
 var $rp_2_ph264_i;
 var $e2_0_ph_i;
 var $z_1_ph265_i;
 var $a_2_ph266_i;
 var $592=($rp_2_ph264_i|0)<18;
 var $593=(($x_i+($a_2_ph266_i<<2))|0);
 if($592){var $z_1_us_i=$z_1_ph265_i;var $e2_0_us_i=$e2_0_ph_i;label=210;break;}else{label=209;break;}
 case 209: 
 var $594=($rp_2_ph264_i|0)==18;
 if($594){var $z_1_us271_i=$z_1_ph265_i;var $e2_0_us270_i=$e2_0_ph_i;label=217;break;}else{var $a_3_ph_i=$a_2_ph266_i;var $z_5_ph_i=$z_1_ph265_i;var $e2_1_ph_i=$e2_0_ph_i;var $rp_3_ph259_i=$rp_2_ph264_i;label=241;break;}
 case 210: 
 var $e2_0_us_i;
 var $z_1_us_i;
 var $595=((($z_1_us_i)+(127))|0);
 var $carry1_0_us_i=0;var $k_5_in_us_i=$595;var $z_2_us_i=$z_1_us_i;label=211;break;
 case 211: 
 var $z_2_us_i;
 var $k_5_in_us_i;
 var $carry1_0_us_i;
 var $k_5_us_i=$k_5_in_us_i&127;
 var $597=(($x_i+($k_5_us_i<<2))|0);
 var $598=HEAP32[(($597)>>2)];
 var $599$0=$598;
 var $599$1=0;
 var $600$0=($599$0<<29)|(0>>>3);
 var $600$1=($599$1<<29)|($599$0>>>3);
 var $601$0=$carry1_0_us_i;
 var $601$1=0;
 var $602$0=_i64Add($600$0,$600$1,$601$0,$601$1);var $602$1=tempRet0;
 var $$etemp$15$0=1000000000;
 var $$etemp$15$1=0;
 var $603=(($602$1>>>0) > ($$etemp$15$1>>>0)) | (((($602$1>>>0) == ($$etemp$15$1>>>0) & ($602$0>>>0) >  ($$etemp$15$0>>>0))));
 var $extract_t246_us_i$0=$602$0;
 var $extract_t246_us_i=$extract_t246_us_i$0;
 if($603){label=212;break;}else{var $carry1_1_us_i=0;var $_sink_off0_us_i=$extract_t246_us_i;label=213;break;}
 case 212: 
 var $$etemp$16$0=1000000000;
 var $$etemp$16$1=0;
 var $605$0=___udivdi3($602$0,$602$1,$$etemp$16$0,$$etemp$16$1);var $605$1=tempRet0;
 var $606$0=$605$0;
 var $606=$606$0;
 var $$etemp$17$0=1000000000;
 var $$etemp$17$1=0;
 var $607$0=___uremdi3($602$0,$602$1,$$etemp$17$0,$$etemp$17$1);var $607$1=tempRet0;
 var $extract_t_us_i$0=$607$0;
 var $extract_t_us_i=$extract_t_us_i$0;
 var $carry1_1_us_i=$606;var $_sink_off0_us_i=$extract_t_us_i;label=213;break;
 case 213: 
 var $_sink_off0_us_i;
 var $carry1_1_us_i;
 HEAP32[(($597)>>2)]=$_sink_off0_us_i;
 var $609=((($z_2_us_i)+(127))|0);
 var $610=$609&127;
 var $611=($k_5_us_i|0)!=($610|0);
 var $612=($k_5_us_i|0)==($a_2_ph266_i|0);
 var $or_cond238_us_i=$611|$612;
 if($or_cond238_us_i){var $z_3_us_i=$z_2_us_i;label=215;break;}else{label=214;break;}
 case 214: 
 var $614=($_sink_off0_us_i|0)==0;
 var $k_5_z_2_us_i=($614?$k_5_us_i:$z_2_us_i);
 var $z_3_us_i=$k_5_z_2_us_i;label=215;break;
 case 215: 
 var $z_3_us_i;
 var $616=((($k_5_us_i)-(1))|0);
 if($612){label=216;break;}else{var $carry1_0_us_i=$carry1_1_us_i;var $k_5_in_us_i=$616;var $z_2_us_i=$z_3_us_i;label=211;break;}
 case 216: 
 var $618=((($e2_0_us_i)-(29))|0);
 var $619=($carry1_1_us_i|0)==0;
 if($619){var $z_1_us_i=$z_3_us_i;var $e2_0_us_i=$618;label=210;break;}else{var $_lcssa269_i=$618;var $z_3_lcssa_lcssa_i=$z_3_us_i;var $carry1_1_lcssa_lcssa_i=$carry1_1_us_i;label=225;break;}
 case 217: 
 var $e2_0_us270_i;
 var $z_1_us271_i;
 var $620=HEAP32[(($593)>>2)];
 var $621=($620>>>0)<9007199;
 if($621){label=218;break;}else{var $a_3_ph_i=$a_2_ph266_i;var $z_5_ph_i=$z_1_us271_i;var $e2_1_ph_i=$e2_0_us270_i;var $rp_3_ph259_i=18;label=241;break;}
 case 218: 
 var $622=((($z_1_us271_i)+(127))|0);
 var $carry1_0_us275_i=0;var $k_5_in_us274_i=$622;var $z_2_us273_i=$z_1_us271_i;label=219;break;
 case 219: 
 var $z_2_us273_i;
 var $k_5_in_us274_i;
 var $carry1_0_us275_i;
 var $k_5_us276_i=$k_5_in_us274_i&127;
 var $624=(($x_i+($k_5_us276_i<<2))|0);
 var $625=HEAP32[(($624)>>2)];
 var $626$0=$625;
 var $626$1=0;
 var $627$0=($626$0<<29)|(0>>>3);
 var $627$1=($626$1<<29)|($626$0>>>3);
 var $628$0=$carry1_0_us275_i;
 var $628$1=0;
 var $629$0=_i64Add($627$0,$627$1,$628$0,$628$1);var $629$1=tempRet0;
 var $$etemp$18$0=1000000000;
 var $$etemp$18$1=0;
 var $630=(($629$1>>>0) > ($$etemp$18$1>>>0)) | (((($629$1>>>0) == ($$etemp$18$1>>>0) & ($629$0>>>0) >  ($$etemp$18$0>>>0))));
 var $extract_t246_us277_i$0=$629$0;
 var $extract_t246_us277_i=$extract_t246_us277_i$0;
 if($630){label=220;break;}else{var $carry1_1_us280_i=0;var $_sink_off0_us279_i=$extract_t246_us277_i;label=221;break;}
 case 220: 
 var $$etemp$19$0=1000000000;
 var $$etemp$19$1=0;
 var $632$0=___udivdi3($629$0,$629$1,$$etemp$19$0,$$etemp$19$1);var $632$1=tempRet0;
 var $633$0=$632$0;
 var $633=$633$0;
 var $$etemp$20$0=1000000000;
 var $$etemp$20$1=0;
 var $634$0=___uremdi3($629$0,$629$1,$$etemp$20$0,$$etemp$20$1);var $634$1=tempRet0;
 var $extract_t_us278_i$0=$634$0;
 var $extract_t_us278_i=$extract_t_us278_i$0;
 var $carry1_1_us280_i=$633;var $_sink_off0_us279_i=$extract_t_us278_i;label=221;break;
 case 221: 
 var $_sink_off0_us279_i;
 var $carry1_1_us280_i;
 HEAP32[(($624)>>2)]=$_sink_off0_us279_i;
 var $636=((($z_2_us273_i)+(127))|0);
 var $637=$636&127;
 var $638=($k_5_us276_i|0)!=($637|0);
 var $639=($k_5_us276_i|0)==($a_2_ph266_i|0);
 var $or_cond238_us281_i=$638|$639;
 if($or_cond238_us281_i){var $z_3_us283_i=$z_2_us273_i;label=223;break;}else{label=222;break;}
 case 222: 
 var $641=($_sink_off0_us279_i|0)==0;
 var $k_5_z_2_us282_i=($641?$k_5_us276_i:$z_2_us273_i);
 var $z_3_us283_i=$k_5_z_2_us282_i;label=223;break;
 case 223: 
 var $z_3_us283_i;
 var $643=((($k_5_us276_i)-(1))|0);
 if($639){label=224;break;}else{var $carry1_0_us275_i=$carry1_1_us280_i;var $k_5_in_us274_i=$643;var $z_2_us273_i=$z_3_us283_i;label=219;break;}
 case 224: 
 var $645=((($e2_0_us270_i)-(29))|0);
 var $646=($carry1_1_us280_i|0)==0;
 if($646){var $z_1_us271_i=$z_3_us283_i;var $e2_0_us270_i=$645;label=217;break;}else{var $_lcssa269_i=$645;var $z_3_lcssa_lcssa_i=$z_3_us283_i;var $carry1_1_lcssa_lcssa_i=$carry1_1_us280_i;label=225;break;}
 case 225: 
 var $carry1_1_lcssa_lcssa_i;
 var $z_3_lcssa_lcssa_i;
 var $_lcssa269_i;
 var $647=((($rp_2_ph264_i)+(9))|0);
 var $648=((($a_2_ph266_i)+(127))|0);
 var $649=$648&127;
 var $650=($649|0)==($z_3_lcssa_lcssa_i|0);
 if($650){label=226;break;}else{var $z_4_i=$z_3_lcssa_lcssa_i;label=227;break;}
 case 226: 
 var $652=((($z_3_lcssa_lcssa_i)+(127))|0);
 var $653=$652&127;
 var $654=(($x_i+($653<<2))|0);
 var $655=HEAP32[(($654)>>2)];
 var $656=((($z_3_lcssa_lcssa_i)+(126))|0);
 var $657=$656&127;
 var $658=(($x_i+($657<<2))|0);
 var $659=HEAP32[(($658)>>2)];
 var $660=$659|$655;
 HEAP32[(($658)>>2)]=$660;
 var $z_4_i=$653;label=227;break;
 case 227: 
 var $z_4_i;
 var $662=(($x_i+($649<<2))|0);
 HEAP32[(($662)>>2)]=$carry1_1_lcssa_lcssa_i;
 var $a_2_ph266_i=$649;var $z_1_ph265_i=$z_4_i;var $e2_0_ph_i=$_lcssa269_i;var $rp_2_ph264_i=$647;label=208;break;
 case 228: 
 var $e2_1_i;
 var $a_3_i;
 var $i_0_i=0;label=229;break;
 case 229: 
 var $i_0_i;
 var $664=($i_0_i|0)<2;
 if($664){label=230;break;}else{var $i_1_i=$i_0_i;label=233;break;}
 case 230: 
 var $666=((($i_0_i)+($a_3_i))|0);
 var $667=$666&127;
 var $668=($667|0)==($z_5_ph_i|0);
 if($668){var $i_1_i=2;label=233;break;}else{label=231;break;}
 case 231: 
 var $670=(($x_i+($667<<2))|0);
 var $671=HEAP32[(($670)>>2)];
 var $672=((8+($i_0_i<<2))|0);
 var $673=HEAP32[(($672)>>2)];
 var $674=($671>>>0)<($673>>>0);
 if($674){var $i_1_i=2;label=233;break;}else{label=232;break;}
 case 232: 
 var $676=($671>>>0)>($673>>>0);
 var $677=((($i_0_i)+(1))|0);
 if($676){var $i_1_i=$i_0_i;label=233;break;}else{var $i_0_i=$677;label=229;break;}
 case 233: 
 var $i_1_i;
 var $679=($i_1_i|0)==2;
 var $or_cond239_i=$679&$710;
 if($or_cond239_i){label=234;break;}else{label=235;break;}
 case 234: 
 var $680=$a_3_i&127;
 var $681=($680|0)==($z_5_ph_i|0);
 if($681){label=244;break;}else{var $z_7_i=$z_5_ph_i;label=245;break;}
 case 235: 
 var $683=((($_240_i)+($e2_1_i))|0);
 var $684=($a_3_i|0)==($z_5_ph_i|0);
 if($684){var $a_3_i=$z_5_ph_i;var $e2_1_i=$683;label=228;break;}else{label=236;break;}
 case 236: 
 var $685=1<<$_240_i;
 var $686=((($685)-(1))|0);
 var $687=1000000000>>>($_240_i>>>0);
 var $rp_4252_i=$rp_3_i_ph;var $a_4253_i=$a_3_i;var $k_6254_i=$a_3_i;var $carry3_0256_i=0;label=237;break;
 case 237: 
 var $carry3_0256_i;
 var $k_6254_i;
 var $a_4253_i;
 var $rp_4252_i;
 var $688=(($x_i+($k_6254_i<<2))|0);
 var $689=HEAP32[(($688)>>2)];
 var $690=$689&$686;
 var $691=$689>>>($_240_i>>>0);
 var $692=((($691)+($carry3_0256_i))|0);
 HEAP32[(($688)>>2)]=$692;
 var $693=(Math_imul($690,$687)|0);
 var $694=($k_6254_i|0)==($a_4253_i|0);
 var $695=($692|0)==0;
 var $or_cond241_i=$694&$695;
 var $696=((($k_6254_i)+(1))|0);
 var $697=$696&127;
 var $698=((($rp_4252_i)-(9))|0);
 var $rp_5_i=($or_cond241_i?$698:$rp_4252_i);
 var $a_5_i=($or_cond241_i?$697:$a_4253_i);
 var $699=($697|0)==($z_5_ph_i|0);
 if($699){label=238;break;}else{var $rp_4252_i=$rp_5_i;var $a_4253_i=$a_5_i;var $k_6254_i=$697;var $carry3_0256_i=$693;label=237;break;}
 case 238: 
 var $700=($693|0)==0;
 if($700){var $a_3_i_ph=$a_5_i;var $e2_1_i_ph=$683;var $rp_3_i_ph=$rp_5_i;label=242;break;}else{label=239;break;}
 case 239: 
 var $702=($706|0)==($a_5_i|0);
 if($702){label=243;break;}else{label=240;break;}
 case 240: 
 var $704=(($x_i+($z_5_ph_i<<2))|0);
 HEAP32[(($704)>>2)]=$693;
 var $a_3_ph_i=$a_5_i;var $z_5_ph_i=$706;var $e2_1_ph_i=$683;var $rp_3_ph259_i=$rp_5_i;label=241;break;
 case 241: 
 var $rp_3_ph259_i;
 var $e2_1_ph_i;
 var $z_5_ph_i;
 var $a_3_ph_i;
 var $705=((($z_5_ph_i)+(1))|0);
 var $706=$705&127;
 var $707=((($z_5_ph_i)+(127))|0);
 var $708=$707&127;
 var $709=(($x_i+($708<<2))|0);
 var $a_3_i_ph=$a_3_ph_i;var $e2_1_i_ph=$e2_1_ph_i;var $rp_3_i_ph=$rp_3_ph259_i;label=242;break;
 case 242: 
 var $rp_3_i_ph;
 var $e2_1_i_ph;
 var $a_3_i_ph;
 var $710=($rp_3_i_ph|0)==18;
 var $711=($rp_3_i_ph|0)>27;
 var $_240_i=($711?9:1);
 var $a_3_i=$a_3_i_ph;var $e2_1_i=$e2_1_i_ph;label=228;break;
 case 243: 
 var $713=HEAP32[(($709)>>2)];
 var $714=$713|1;
 HEAP32[(($709)>>2)]=$714;
 var $a_3_i_ph=$a_5_i;var $e2_1_i_ph=$683;var $rp_3_i_ph=$rp_5_i;label=242;break;
 case 244: 
 var $716=((($706)-(1))|0);
 var $717=(($x_i+($716<<2))|0);
 HEAP32[(($717)>>2)]=0;
 var $z_7_i=$706;label=245;break;
 case 245: 
 var $z_7_i;
 var $719=(($x_i+($680<<2))|0);
 var $720=HEAP32[(($719)>>2)];
 var $721=($720>>>0);
 var $722=((($a_3_i)+(1))|0);
 var $723=$722&127;
 var $724=($723|0)==($z_7_i|0);
 if($724){label=269;break;}else{var $z_7_1_i=$z_7_i;label=270;break;}
 case 246: 
 var $726=($816|0)<0;
 var $_242_i=($726?0:$816);
 var $_1236_i=$_242_i;var $denormal_0_i=1;label=247;break;
 case 247: 
 var $denormal_0_i;
 var $_1236_i;
 var $728=($_1236_i|0)<53;
 if($728){label=248;break;}else{var $bias_0_i=0;var $frac_0_i=0;var $y_1_i103=$814;label=249;break;}
 case 248: 
 var $730=(((105)-($_1236_i))|0);
 var $731=_scalbn(1,$730);
 var $732=_copysign($731,$814);
 var $733=(((53)-($_1236_i))|0);
 var $734=_scalbn(1,$733);
 var $735=_fmod($814,$734);
 var $736=($814)-($735);
 var $737=($732)+($736);
 var $bias_0_i=$732;var $frac_0_i=$735;var $y_1_i103=$737;label=249;break;
 case 249: 
 var $y_1_i103;
 var $frac_0_i;
 var $bias_0_i;
 var $739=((($a_3_i)+(2))|0);
 var $740=$739&127;
 var $741=($740|0)==($z_7_1_i|0);
 if($741){var $frac_2_i=$frac_0_i;label=262;break;}else{label=250;break;}
 case 250: 
 var $743=(($x_i+($740<<2))|0);
 var $744=HEAP32[(($743)>>2)];
 var $745=($744>>>0)<500000000;
 if($745){label=251;break;}else{label=254;break;}
 case 251: 
 var $747=($744|0)==0;
 if($747){label=252;break;}else{label=253;break;}
 case 252: 
 var $749=((($a_3_i)+(3))|0);
 var $750=$749&127;
 var $751=($750|0)==($z_7_1_i|0);
 if($751){var $frac_1_i=$frac_0_i;label=259;break;}else{label=253;break;}
 case 253: 
 var $753=($813)*((0.25));
 var $754=($753)+($frac_0_i);
 var $frac_1_i=$754;label=259;break;
 case 254: 
 var $756=($744>>>0)>500000000;
 if($756){label=255;break;}else{label=256;break;}
 case 255: 
 var $758=($813)*((0.75));
 var $759=($758)+($frac_0_i);
 var $frac_1_i=$759;label=259;break;
 case 256: 
 var $761=((($a_3_i)+(3))|0);
 var $762=$761&127;
 var $763=($762|0)==($z_7_1_i|0);
 if($763){label=257;break;}else{label=258;break;}
 case 257: 
 var $765=($813)*((0.5));
 var $766=($765)+($frac_0_i);
 var $frac_1_i=$766;label=259;break;
 case 258: 
 var $768=($813)*((0.75));
 var $769=($768)+($frac_0_i);
 var $frac_1_i=$769;label=259;break;
 case 259: 
 var $frac_1_i;
 var $771=(((53)-($_1236_i))|0);
 var $772=($771|0)>1;
 if($772){label=260;break;}else{var $frac_2_i=$frac_1_i;label=262;break;}
 case 260: 
 var $774=_fmod($frac_1_i,1);
 var $775=$774!=0;
 if($775){var $frac_2_i=$frac_1_i;label=262;break;}else{label=261;break;}
 case 261: 
 var $777=($frac_1_i)+(1);
 var $frac_2_i=$777;label=262;break;
 case 262: 
 var $frac_2_i;
 var $779=($y_1_i103)+($frac_2_i);
 var $780=($779)-($bias_0_i);
 var $781=$815&2147483647;
 var $782=(((-2)-($sum_i))|0);
 var $783=($781|0)>($782|0);
 if($783){label=263;break;}else{var $y_3_i=$780;var $e2_3_i=$e2_1_i;label=268;break;}
 case 263: 
 var $785=Math_abs($780);
 var $786=$785<9007199254740992;
 if($786){var $y_2_i104=$780;var $denormal_2_i=$denormal_0_i;var $e2_2_i=$e2_1_i;label=265;break;}else{label=264;break;}
 case 264: 
 var $788=($denormal_0_i|0)!=0;
 var $789=($_1236_i|0)==($816|0);
 var $or_cond243_i=$788&$789;
 var $denormal_1_i=($or_cond243_i?0:$denormal_0_i);
 var $790=($780)*((0.5));
 var $791=((($e2_1_i)+(1))|0);
 var $y_2_i104=$790;var $denormal_2_i=$denormal_1_i;var $e2_2_i=$791;label=265;break;
 case 265: 
 var $e2_2_i;
 var $denormal_2_i;
 var $y_2_i104;
 var $793=((($e2_2_i)+(53))|0);
 var $794=($793|0)>($372|0);
 if($794){label=267;break;}else{label=266;break;}
 case 266: 
 var $796=($denormal_2_i|0)!=0;
 var $797=$frac_2_i!=0;
 var $or_cond244_i=$796&$797;
 if($or_cond244_i){label=267;break;}else{var $y_3_i=$y_2_i104;var $e2_3_i=$e2_2_i;label=268;break;}
 case 267: 
 var $799=___errno_location();
 HEAP32[(($799)>>2)]=34;
 var $y_3_i=$y_2_i104;var $e2_3_i=$e2_2_i;label=268;break;
 case 268: 
 var $e2_3_i;
 var $y_3_i;
 var $801=_scalbnl($y_3_i,$e2_3_i);
 var $_0=$801;label=271;break;
 case 269: 
 var $803=((($z_7_i)+(1))|0);
 var $804=$803&127;
 var $805=((($804)-(1))|0);
 var $806=(($x_i+($805<<2))|0);
 HEAP32[(($806)>>2)]=0;
 var $z_7_1_i=$804;label=270;break;
 case 270: 
 var $z_7_1_i;
 var $808=($721)*(1000000000);
 var $809=(($x_i+($723<<2))|0);
 var $810=HEAP32[(($809)>>2)];
 var $811=($810>>>0);
 var $812=($808)+($811);
 var $813=($sign_0|0);
 var $814=($813)*($812);
 var $815=((($e2_1_i)+(53))|0);
 var $816=((($815)-($emin_0_ph))|0);
 var $817=($816|0)<($bits_0_ph|0);
 if($817){label=246;break;}else{var $_1236_i=$bits_0_ph;var $denormal_0_i=0;label=247;break;}
 case 271: 
 var $_0;
 STACKTOP=sp;return $_0;
 case 272: 
 var $819=HEAP32[(($3)>>2)];
 var $820=HEAP32[(($4)>>2)];
 var $821=($819>>>0)<($820>>>0);
 if($821){label=274;break;}else{label=273;break;}
 case 273: 
 var $823=___shgetc($f);
 var $c_4_1=$823;label=275;break;
 case 274: 
 var $825=(($819+1)|0);
 HEAP32[(($3)>>2)]=$825;
 var $826=HEAP8[($819)];
 var $827=($826&255);
 var $c_4_1=$827;label=275;break;
 case 275: 
 var $c_4_1;
 var $829=$c_4_1|32;
 var $830=($829|0)==110;
 if($830){label=34;break;}else{label=53;break;}
  default: assert(0, "bad label: " + label);
 }

}


function _scanexp($f,$pok){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=(($f+4)|0);
 var $2=HEAP32[(($1)>>2)];
 var $3=(($f+100)|0);
 var $4=HEAP32[(($3)>>2)];
 var $5=($2>>>0)<($4>>>0);
 if($5){label=2;break;}else{label=3;break;}
 case 2: 
 var $7=(($2+1)|0);
 HEAP32[(($1)>>2)]=$7;
 var $8=HEAP8[($2)];
 var $9=($8&255);
 var $13=$9;label=4;break;
 case 3: 
 var $11=___shgetc($f);
 var $13=$11;label=4;break;
 case 4: 
 var $13;
 var $14=($13|0)==45;
 if(($13|0)==45|($13|0)==43){ label=5;break;}else{var $neg_0=0;var $c_0=$13;label=11;break;}
 case 5: 
 var $15=($14&1);
 var $16=HEAP32[(($1)>>2)];
 var $17=HEAP32[(($3)>>2)];
 var $18=($16>>>0)<($17>>>0);
 if($18){label=6;break;}else{label=7;break;}
 case 6: 
 var $20=(($16+1)|0);
 HEAP32[(($1)>>2)]=$20;
 var $21=HEAP8[($16)];
 var $22=($21&255);
 var $26=$22;label=8;break;
 case 7: 
 var $24=___shgetc($f);
 var $26=$24;label=8;break;
 case 8: 
 var $26;
 var $27=((($26)-(48))|0);
 var $28=($27>>>0)<10;
 var $29=($pok|0)==0;
 var $or_cond=$28|$29;
 if($or_cond){var $neg_0=$15;var $c_0=$26;label=11;break;}else{label=9;break;}
 case 9: 
 var $31=HEAP32[(($3)>>2)];
 var $32=($31|0)==0;
 if($32){var $neg_0=$15;var $c_0=$26;label=11;break;}else{label=10;break;}
 case 10: 
 var $34=HEAP32[(($1)>>2)];
 var $35=((($34)-(1))|0);
 HEAP32[(($1)>>2)]=$35;
 var $neg_0=$15;var $c_0=$26;label=11;break;
 case 11: 
 var $c_0;
 var $neg_0;
 var $37=((($c_0)-(48))|0);
 var $38=($37>>>0)>9;
 if($38){label=12;break;}else{var $c_141=$c_0;var $x_042=0;label=14;break;}
 case 12: 
 var $40=HEAP32[(($3)>>2)];
 var $41=($40|0)==0;
 if($41){var $_0$1=-2147483648;var $_0$0=0;label=32;break;}else{label=13;break;}
 case 13: 
 var $43=HEAP32[(($1)>>2)];
 var $44=((($43)-(1))|0);
 HEAP32[(($1)>>2)]=$44;
 var $_0$1=-2147483648;var $_0$0=0;label=32;break;
 case 14: 
 var $x_042;
 var $c_141;
 var $45=((($c_141)-(48))|0);
 var $46=((($45)+($x_042))|0);
 var $47=HEAP32[(($1)>>2)];
 var $48=HEAP32[(($3)>>2)];
 var $49=($47>>>0)<($48>>>0);
 if($49){label=15;break;}else{label=16;break;}
 case 15: 
 var $51=(($47+1)|0);
 HEAP32[(($1)>>2)]=$51;
 var $52=HEAP8[($47)];
 var $53=($52&255);
 var $c_1_be=$53;label=17;break;
 case 16: 
 var $55=___shgetc($f);
 var $c_1_be=$55;label=17;break;
 case 17: 
 var $c_1_be;
 var $56=((($c_1_be)-(48))|0);
 var $57=($56>>>0)<10;
 var $58=($46|0)<214748364;
 var $59=$57&$58;
 if($59){label=18;break;}else{label=19;break;}
 case 18: 
 var $phitmp49=((($46)*(10))&-1);
 var $c_141=$c_1_be;var $x_042=$phitmp49;label=14;break;
 case 19: 
 var $phitmp$0=$46;
 var $phitmp$1=((((($46|0)<0))|0)?-1:0);
 var $61=((($c_1_be)-(48))|0);
 var $62=($61>>>0)<10;
 if($62){var $c_236=$c_1_be;var $y_037$1=$phitmp$1;var $y_037$0=$phitmp$0;label=21;break;}else{var $c_2_lcssa=$c_1_be;var $y_0_lcssa$1=$phitmp$1;var $y_0_lcssa$0=$phitmp$0;label=20;break;}
 case 20: 
 var $y_0_lcssa$0;
 var $y_0_lcssa$1;
 var $c_2_lcssa;
 var $63=((($c_2_lcssa)-(48))|0);
 var $64=($63>>>0)<10;
 if($64){label=25;break;}else{label=29;break;}
 case 21: 
 var $y_037$0;
 var $y_037$1;
 var $c_236;
 var $$etemp$0$0=10;
 var $$etemp$0$1=0;
 var $65$0=___muldi3($y_037$0,$y_037$1,$$etemp$0$0,$$etemp$0$1);var $65$1=tempRet0;
 var $66$0=$c_236;
 var $66$1=((((($c_236|0)<0))|0)?-1:0);
 var $$etemp$1$0=-48;
 var $$etemp$1$1=-1;
 var $67$0=_i64Add($66$0,$66$1,$$etemp$1$0,$$etemp$1$1);var $67$1=tempRet0;
 var $68$0=_i64Add($67$0,$67$1,$65$0,$65$1);var $68$1=tempRet0;
 var $69=HEAP32[(($1)>>2)];
 var $70=HEAP32[(($3)>>2)];
 var $71=($69>>>0)<($70>>>0);
 if($71){label=22;break;}else{label=23;break;}
 case 22: 
 var $73=(($69+1)|0);
 HEAP32[(($1)>>2)]=$73;
 var $74=HEAP8[($69)];
 var $75=($74&255);
 var $c_2_be=$75;label=24;break;
 case 23: 
 var $77=___shgetc($f);
 var $c_2_be=$77;label=24;break;
 case 24: 
 var $c_2_be;
 var $78=((($c_2_be)-(48))|0);
 var $79=($78>>>0)<10;
 var $$etemp$2$0=2061584302;
 var $$etemp$2$1=21474836;
 var $80=(($68$1|0) < ($$etemp$2$1|0)) | (((($68$1|0) == ($$etemp$2$1|0) & ($68$0>>>0) <  ($$etemp$2$0>>>0))));
 var $or_cond35=$79&$80;
 if($or_cond35){var $c_236=$c_2_be;var $y_037$1=$68$1;var $y_037$0=$68$0;label=21;break;}else{var $c_2_lcssa=$c_2_be;var $y_0_lcssa$1=$68$1;var $y_0_lcssa$0=$68$0;label=20;break;}
 case 25: 
 var $81=HEAP32[(($1)>>2)];
 var $82=HEAP32[(($3)>>2)];
 var $83=($81>>>0)<($82>>>0);
 if($83){label=26;break;}else{label=27;break;}
 case 26: 
 var $85=(($81+1)|0);
 HEAP32[(($1)>>2)]=$85;
 var $86=HEAP8[($81)];
 var $87=($86&255);
 var $c_3_be=$87;label=28;break;
 case 27: 
 var $89=___shgetc($f);
 var $c_3_be=$89;label=28;break;
 case 28: 
 var $c_3_be;
 var $90=((($c_3_be)-(48))|0);
 var $91=($90>>>0)<10;
 if($91){label=25;break;}else{label=29;break;}
 case 29: 
 var $92=HEAP32[(($3)>>2)];
 var $93=($92|0)==0;
 if($93){label=31;break;}else{label=30;break;}
 case 30: 
 var $95=HEAP32[(($1)>>2)];
 var $96=((($95)-(1))|0);
 HEAP32[(($1)>>2)]=$96;
 label=31;break;
 case 31: 
 var $98=($neg_0|0)!=0;
 var $$etemp$3$0=0;
 var $$etemp$3$1=0;
 var $99$0=_i64Subtract($$etemp$3$0,$$etemp$3$1,$y_0_lcssa$0,$y_0_lcssa$1);var $99$1=tempRet0;
 var $100$0=($98?$99$0:$y_0_lcssa$0);
 var $100$1=($98?$99$1:$y_0_lcssa$1);
 var $_0$1=$100$1;var $_0$0=$100$0;label=32;break;
 case 32: 
 var $_0$0;
 var $_0$1;
 return (tempRet0=$_0$1,$_0$0);
  default: assert(0, "bad label: " + label);
 }

}


function ___shlim($f,$lim){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=(($f+104)|0);
 HEAP32[(($1)>>2)]=$lim;
 var $2=(($f+8)|0);
 var $3=HEAP32[(($2)>>2)];
 var $4=(($f+4)|0);
 var $5=HEAP32[(($4)>>2)];
 var $6=$3;
 var $7=$5;
 var $8=((($6)-($7))|0);
 var $9=(($f+108)|0);
 HEAP32[(($9)>>2)]=$8;
 var $10=($lim|0)!=0;
 var $11=($8|0)>($lim|0);
 var $or_cond=$10&$11;
 if($or_cond){label=2;break;}else{label=3;break;}
 case 2: 
 var $13=(($5+$lim)|0);
 var $14=(($f+100)|0);
 HEAP32[(($14)>>2)]=$13;
 label=4;break;
 case 3: 
 var $16=(($f+100)|0);
 HEAP32[(($16)>>2)]=$3;
 label=4;break;
 case 4: 
 return;
  default: assert(0, "bad label: " + label);
 }

}


function ___shgetc($f){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=(($f+104)|0);
 var $2=HEAP32[(($1)>>2)];
 var $3=($2|0)==0;
 if($3){label=3;break;}else{label=2;break;}
 case 2: 
 var $5=(($f+108)|0);
 var $6=HEAP32[(($5)>>2)];
 var $7=($6|0)<($2|0);
 if($7){label=3;break;}else{label=4;break;}
 case 3: 
 var $9=___uflow($f);
 var $10=($9|0)<0;
 if($10){label=4;break;}else{label=5;break;}
 case 4: 
 var $12=(($f+100)|0);
 HEAP32[(($12)>>2)]=0;
 var $_0=-1;label=13;break;
 case 5: 
 var $14=HEAP32[(($1)>>2)];
 var $15=($14|0)==0;
 var $_phi_trans_insert=(($f+8)|0);
 var $_pre=HEAP32[(($_phi_trans_insert)>>2)];
 if($15){label=8;break;}else{label=6;break;}
 case 6: 
 var $17=(($f+4)|0);
 var $18=HEAP32[(($17)>>2)];
 var $19=$_pre;
 var $20=$18;
 var $21=((($19)-($20))|0);
 var $22=(($f+108)|0);
 var $23=HEAP32[(($22)>>2)];
 var $24=((($14)-($23))|0);
 var $25=((($24)-(1))|0);
 var $26=($21|0)>($25|0);
 if($26){label=7;break;}else{label=8;break;}
 case 7: 
 var $28=(($18+$25)|0);
 var $29=(($f+100)|0);
 HEAP32[(($29)>>2)]=$28;
 label=9;break;
 case 8: 
 var $30=(($f+100)|0);
 HEAP32[(($30)>>2)]=$_pre;
 label=9;break;
 case 9: 
 var $32=($_pre|0)==0;
 var $_phi_trans_insert26=(($f+4)|0);
 var $_pre27=HEAP32[(($_phi_trans_insert26)>>2)];
 if($32){label=11;break;}else{label=10;break;}
 case 10: 
 var $34=$_pre;
 var $35=$_pre27;
 var $36=(($f+108)|0);
 var $37=HEAP32[(($36)>>2)];
 var $38=((($34)+(1))|0);
 var $39=((($38)-($35))|0);
 var $40=((($39)+($37))|0);
 HEAP32[(($36)>>2)]=$40;
 label=11;break;
 case 11: 
 var $41=((($_pre27)-(1))|0);
 var $42=HEAP8[($41)];
 var $43=($42&255);
 var $44=($43|0)==($9|0);
 if($44){var $_0=$9;label=13;break;}else{label=12;break;}
 case 12: 
 var $46=(($9)&255);
 HEAP8[($41)]=$46;
 var $_0=$9;label=13;break;
 case 13: 
 var $_0;
 return $_0;
  default: assert(0, "bad label: " + label);
 }

}


function _scalbn($x,$n){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=($n|0)>1023;
 if($1){label=2;break;}else{label=4;break;}
 case 2: 
 var $3=($x)*((8.98846567431158e+307));
 var $4=((($n)-(1023))|0);
 var $5=($4|0)>1023;
 if($5){label=3;break;}else{var $y_0=$3;var $_0=$4;label=7;break;}
 case 3: 
 var $7=($3)*((8.98846567431158e+307));
 var $8=((($n)-(2046))|0);
 var $9=($8|0)>1023;
 var $_=($9?1023:$8);
 var $y_0=$7;var $_0=$_;label=7;break;
 case 4: 
 var $11=($n|0)<-1022;
 if($11){label=5;break;}else{var $y_0=$x;var $_0=$n;label=7;break;}
 case 5: 
 var $13=($x)*((2.2250738585072014e-308));
 var $14=((($n)+(1022))|0);
 var $15=($14|0)<-1022;
 if($15){label=6;break;}else{var $y_0=$13;var $_0=$14;label=7;break;}
 case 6: 
 var $17=($13)*((2.2250738585072014e-308));
 var $18=((($n)+(2044))|0);
 var $19=($18|0)<-1022;
 var $_17=($19?-1022:$18);
 var $y_0=$17;var $_0=$_17;label=7;break;
 case 7: 
 var $_0;
 var $y_0;
 var $21=((($_0)+(1023))|0);
 var $22$0=$21;
 var $22$1=0;
 var $23$0=(0<<20)|(0>>>12);
 var $23$1=($22$0<<20)|(0>>>12);
 var $24=(HEAP32[((tempDoublePtr)>>2)]=$23$0, HEAP32[(((tempDoublePtr)+(4))>>2)]=$23$1, HEAPF64[(tempDoublePtr)>>3]);
 var $25=($y_0)*($24);
 return $25;
  default: assert(0, "bad label: " + label);
 }

}


function _scalbnl($x,$n){
 var label=0;


 var $1=_scalbn($x,$n);
 return $1;
}


function ___toread($f){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $1=(($f+74)|0);
 var $2=HEAP8[($1)];
 var $3=((($2)-(1))&255);
 var $4=$3|$2;
 HEAP8[($1)]=$4;
 var $5=(($f+20)|0);
 var $6=HEAP32[(($5)>>2)];
 var $7=(($f+44)|0);
 var $8=HEAP32[(($7)>>2)];
 var $9=($6>>>0)>($8>>>0);
 if($9){label=2;break;}else{label=3;break;}
 case 2: 
 var $11=(($f+36)|0);
 var $12=HEAP32[(($11)>>2)];
 var $13=FUNCTION_TABLE[$12]($f,0,0);
 label=3;break;
 case 3: 
 var $15=(($f+16)|0);
 HEAP32[(($15)>>2)]=0;
 var $16=(($f+28)|0);
 HEAP32[(($16)>>2)]=0;
 HEAP32[(($5)>>2)]=0;
 var $17=(($f)|0);
 var $18=HEAP32[(($17)>>2)];
 var $19=$18&20;
 var $20=($19|0)==0;
 if($20){label=6;break;}else{label=4;break;}
 case 4: 
 var $22=$18&4;
 var $23=($22|0)==0;
 if($23){var $_0=-1;label=7;break;}else{label=5;break;}
 case 5: 
 var $25=$18|32;
 HEAP32[(($17)>>2)]=$25;
 var $_0=-1;label=7;break;
 case 6: 
 var $27=HEAP32[(($7)>>2)];
 var $28=(($f+8)|0);
 HEAP32[(($28)>>2)]=$27;
 var $29=(($f+4)|0);
 HEAP32[(($29)>>2)]=$27;
 var $_0=0;label=7;break;
 case 7: 
 var $_0;
 return $_0;
  default: assert(0, "bad label: " + label);
 }

}


function ___uflow($f){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+8)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $c=sp;
 var $1=(($f+8)|0);
 var $2=HEAP32[(($1)>>2)];
 var $3=($2|0)==0;
 if($3){label=2;break;}else{label=3;break;}
 case 2: 
 var $5=___toread($f);
 var $6=($5|0)==0;
 if($6){label=3;break;}else{var $_0=-1;label=5;break;}
 case 3: 
 var $8=(($f+32)|0);
 var $9=HEAP32[(($8)>>2)];
 var $10=FUNCTION_TABLE[$9]($f,$c,1);
 var $11=($10|0)==1;
 if($11){label=4;break;}else{var $_0=-1;label=5;break;}
 case 4: 
 var $13=HEAP8[($c)];
 var $14=($13&255);
 var $_0=$14;label=5;break;
 case 5: 
 var $_0;
 STACKTOP=sp;return $_0;
  default: assert(0, "bad label: " + label);
 }

}


function _strtold_l($s,$p,$loc){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+112)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $f_i_i=sp;
 var $1=$f_i_i;
 _memset($1, 0, 112)|0;
 var $2=(($f_i_i+4)|0);
 HEAP32[(($2)>>2)]=$s;
 var $3=(($f_i_i+8)|0);
 HEAP32[(($3)>>2)]=-1;
 var $4=(($f_i_i+44)|0);
 HEAP32[(($4)>>2)]=$s;
 var $5=(($f_i_i+76)|0);
 HEAP32[(($5)>>2)]=-1;
 ___shlim($f_i_i,0);
 var $6=___floatscan($f_i_i,2,1);
 var $7=(($f_i_i+108)|0);
 var $8=HEAP32[(($7)>>2)];
 var $9=HEAP32[(($2)>>2)];
 var $10=HEAP32[(($3)>>2)];
 var $11=$9;
 var $12=$10;
 var $13=((($11)-($12))|0);
 var $14=((($13)+($8))|0);
 var $15=($p|0)==0;
 if($15){label=5;break;}else{label=2;break;}
 case 2: 
 var $17=($14|0)==0;
 if($17){var $21=$s;label=4;break;}else{label=3;break;}
 case 3: 
 var $19=(($s+$14)|0);
 var $21=$19;label=4;break;
 case 4: 
 var $21;
 HEAP32[(($p)>>2)]=$21;
 label=5;break;
 case 5: 
 STACKTOP=sp;return $6;
  default: assert(0, "bad label: " + label);
 }

}



// EMSCRIPTEN_END_FUNCS
function _i64Add(a, b, c, d) {
    /*
      x = a + b*2^32
      y = c + d*2^32
      result = l + h*2^32
    */
    a = a|0; b = b|0; c = c|0; d = d|0;
    var l = 0, h = 0;
    l = (a + c)>>>0;
    h = (b + d + (((l>>>0) < (a>>>0))|0))>>>0; // Add carry from low word to high word on overflow.
    return tempRet0 = h,l|0;
  }
function _i64Subtract(a, b, c, d) {
    a = a|0; b = b|0; c = c|0; d = d|0;
    var l = 0, h = 0;
    l = (a - c)>>>0;
    h = (b - d)>>>0;
    h = (b - d - (((c>>>0) > (a>>>0))|0))>>>0; // Borrow one from high word to low word on underflow.
    return tempRet0 = h,l|0;
  }
function _bitshift64Shl(low, high, bits) {
    low = low|0; high = high|0; bits = bits|0;
    var ander = 0;
    if ((bits|0) < 32) {
      ander = ((1 << bits) - 1)|0;
      tempRet0 = (high << bits) | ((low&(ander << (32 - bits))) >>> (32 - bits));
      return low << bits;
    }
    tempRet0 = low << (bits - 32);
    return 0;
  }
function _bitshift64Lshr(low, high, bits) {
    low = low|0; high = high|0; bits = bits|0;
    var ander = 0;
    if ((bits|0) < 32) {
      ander = ((1 << bits) - 1)|0;
      tempRet0 = high >>> bits;
      return (low >>> bits) | ((high&ander) << (32 - bits));
    }
    tempRet0 = 0;
    return (high >>> (bits - 32))|0;
  }
function _bitshift64Ashr(low, high, bits) {
    low = low|0; high = high|0; bits = bits|0;
    var ander = 0;
    if ((bits|0) < 32) {
      ander = ((1 << bits) - 1)|0;
      tempRet0 = high >> bits;
      return (low >>> bits) | ((high&ander) << (32 - bits));
    }
    tempRet0 = (high|0) < 0 ? -1 : 0;
    return (high >> (bits - 32))|0;
  }
function _llvm_ctlz_i32(x) {
    x = x|0;
    var ret = 0;
    ret = HEAP8[(((ctlz_i8)+(x >>> 24))|0)];
    if ((ret|0) < 8) return ret|0;
    ret = HEAP8[(((ctlz_i8)+((x >> 16)&0xff))|0)];
    if ((ret|0) < 8) return (ret + 8)|0;
    ret = HEAP8[(((ctlz_i8)+((x >> 8)&0xff))|0)];
    if ((ret|0) < 8) return (ret + 16)|0;
    return (HEAP8[(((ctlz_i8)+(x&0xff))|0)] + 24)|0;
  }
/* PRE_ASM */ var ctlz_i8 = allocate([8,7,6,6,5,5,5,5,4,4,4,4,4,4,4,4,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0], "i8", ALLOC_DYNAMIC);

function _llvm_cttz_i32(x) {
    x = x|0;
    var ret = 0;
    ret = HEAP8[(((cttz_i8)+(x & 0xff))|0)];
    if ((ret|0) < 8) return ret|0;
    ret = HEAP8[(((cttz_i8)+((x >> 8)&0xff))|0)];
    if ((ret|0) < 8) return (ret + 8)|0;
    ret = HEAP8[(((cttz_i8)+((x >> 16)&0xff))|0)];
    if ((ret|0) < 8) return (ret + 16)|0;
    return (HEAP8[(((cttz_i8)+(x >>> 24))|0)] + 24)|0;
  }
/* PRE_ASM */ var cttz_i8 = allocate([8,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,6,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,7,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,6,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0], "i8", ALLOC_DYNAMIC);

// ======== compiled code from system/lib/compiler-rt , see readme therein
function ___muldsi3($a, $b) {
  $a = $a | 0;
  $b = $b | 0;
  var $1 = 0, $2 = 0, $3 = 0, $6 = 0, $8 = 0, $11 = 0, $12 = 0;
  $1 = $a & 65535;
  $2 = $b & 65535;
  $3 = Math_imul($2, $1) | 0;
  $6 = $a >>> 16;
  $8 = ($3 >>> 16) + (Math_imul($2, $6) | 0) | 0;
  $11 = $b >>> 16;
  $12 = Math_imul($11, $1) | 0;
  return (tempRet0 = (($8 >>> 16) + (Math_imul($11, $6) | 0) | 0) + ((($8 & 65535) + $12 | 0) >>> 16) | 0, 0 | ($8 + $12 << 16 | $3 & 65535)) | 0;
}
function ___divdi3($a$0, $a$1, $b$0, $b$1) {
  $a$0 = $a$0 | 0;
  $a$1 = $a$1 | 0;
  $b$0 = $b$0 | 0;
  $b$1 = $b$1 | 0;
  var $1$0 = 0, $1$1 = 0, $2$0 = 0, $2$1 = 0, $4$0 = 0, $4$1 = 0, $6$0 = 0, $7$0 = 0, $7$1 = 0, $8$0 = 0, $10$0 = 0;
  $1$0 = $a$1 >> 31 | (($a$1 | 0) < 0 ? -1 : 0) << 1;
  $1$1 = (($a$1 | 0) < 0 ? -1 : 0) >> 31 | (($a$1 | 0) < 0 ? -1 : 0) << 1;
  $2$0 = $b$1 >> 31 | (($b$1 | 0) < 0 ? -1 : 0) << 1;
  $2$1 = (($b$1 | 0) < 0 ? -1 : 0) >> 31 | (($b$1 | 0) < 0 ? -1 : 0) << 1;
  $4$0 = _i64Subtract($1$0 ^ $a$0, $1$1 ^ $a$1, $1$0, $1$1) | 0;
  $4$1 = tempRet0;
  $6$0 = _i64Subtract($2$0 ^ $b$0, $2$1 ^ $b$1, $2$0, $2$1) | 0;
  $7$0 = $2$0 ^ $1$0;
  $7$1 = $2$1 ^ $1$1;
  $8$0 = ___udivmoddi4($4$0, $4$1, $6$0, tempRet0, 0) | 0;
  $10$0 = _i64Subtract($8$0 ^ $7$0, tempRet0 ^ $7$1, $7$0, $7$1) | 0;
  return (tempRet0 = tempRet0, $10$0) | 0;
}
function ___remdi3($a$0, $a$1, $b$0, $b$1) {
  $a$0 = $a$0 | 0;
  $a$1 = $a$1 | 0;
  $b$0 = $b$0 | 0;
  $b$1 = $b$1 | 0;
  var $rem = 0, $1$0 = 0, $1$1 = 0, $2$0 = 0, $2$1 = 0, $4$0 = 0, $4$1 = 0, $6$0 = 0, $10$0 = 0, $10$1 = 0, __stackBase__ = 0;
  __stackBase__ = STACKTOP;
  STACKTOP = STACKTOP + 8 | 0;
  $rem = __stackBase__ | 0;
  $1$0 = $a$1 >> 31 | (($a$1 | 0) < 0 ? -1 : 0) << 1;
  $1$1 = (($a$1 | 0) < 0 ? -1 : 0) >> 31 | (($a$1 | 0) < 0 ? -1 : 0) << 1;
  $2$0 = $b$1 >> 31 | (($b$1 | 0) < 0 ? -1 : 0) << 1;
  $2$1 = (($b$1 | 0) < 0 ? -1 : 0) >> 31 | (($b$1 | 0) < 0 ? -1 : 0) << 1;
  $4$0 = _i64Subtract($1$0 ^ $a$0, $1$1 ^ $a$1, $1$0, $1$1) | 0;
  $4$1 = tempRet0;
  $6$0 = _i64Subtract($2$0 ^ $b$0, $2$1 ^ $b$1, $2$0, $2$1) | 0;
  ___udivmoddi4($4$0, $4$1, $6$0, tempRet0, $rem) | 0;
  $10$0 = _i64Subtract(HEAP32[$rem >> 2] ^ $1$0, HEAP32[$rem + 4 >> 2] ^ $1$1, $1$0, $1$1) | 0;
  $10$1 = tempRet0;
  STACKTOP = __stackBase__;
  return (tempRet0 = $10$1, $10$0) | 0;
}
function ___muldi3($a$0, $a$1, $b$0, $b$1) {
  $a$0 = $a$0 | 0;
  $a$1 = $a$1 | 0;
  $b$0 = $b$0 | 0;
  $b$1 = $b$1 | 0;
  var $x_sroa_0_0_extract_trunc = 0, $y_sroa_0_0_extract_trunc = 0, $1$0 = 0, $1$1 = 0, $2 = 0;
  $x_sroa_0_0_extract_trunc = $a$0;
  $y_sroa_0_0_extract_trunc = $b$0;
  $1$0 = ___muldsi3($x_sroa_0_0_extract_trunc, $y_sroa_0_0_extract_trunc) | 0;
  $1$1 = tempRet0;
  $2 = Math_imul($a$1, $y_sroa_0_0_extract_trunc) | 0;
  return (tempRet0 = ((Math_imul($b$1, $x_sroa_0_0_extract_trunc) | 0) + $2 | 0) + $1$1 | $1$1 & 0, 0 | $1$0 & -1) | 0;
}
function ___udivdi3($a$0, $a$1, $b$0, $b$1) {
  $a$0 = $a$0 | 0;
  $a$1 = $a$1 | 0;
  $b$0 = $b$0 | 0;
  $b$1 = $b$1 | 0;
  var $1$0 = 0;
  $1$0 = ___udivmoddi4($a$0, $a$1, $b$0, $b$1, 0) | 0;
  return (tempRet0 = tempRet0, $1$0) | 0;
}
function ___uremdi3($a$0, $a$1, $b$0, $b$1) {
  $a$0 = $a$0 | 0;
  $a$1 = $a$1 | 0;
  $b$0 = $b$0 | 0;
  $b$1 = $b$1 | 0;
  var $rem = 0, __stackBase__ = 0;
  __stackBase__ = STACKTOP;
  STACKTOP = STACKTOP + 8 | 0;
  $rem = __stackBase__ | 0;
  ___udivmoddi4($a$0, $a$1, $b$0, $b$1, $rem) | 0;
  STACKTOP = __stackBase__;
  return (tempRet0 = HEAP32[$rem + 4 >> 2] | 0, HEAP32[$rem >> 2] | 0) | 0;
}
function ___udivmoddi4($a$0, $a$1, $b$0, $b$1, $rem) {
  $a$0 = $a$0 | 0;
  $a$1 = $a$1 | 0;
  $b$0 = $b$0 | 0;
  $b$1 = $b$1 | 0;
  $rem = $rem | 0;
  var $n_sroa_0_0_extract_trunc = 0, $n_sroa_1_4_extract_shift$0 = 0, $n_sroa_1_4_extract_trunc = 0, $d_sroa_0_0_extract_trunc = 0, $d_sroa_1_4_extract_shift$0 = 0, $d_sroa_1_4_extract_trunc = 0, $4 = 0, $17 = 0, $37 = 0, $49 = 0, $51 = 0, $57 = 0, $58 = 0, $66 = 0, $78 = 0, $86 = 0, $88 = 0, $89 = 0, $91 = 0, $92 = 0, $95 = 0, $105 = 0, $117 = 0, $119 = 0, $125 = 0, $126 = 0, $130 = 0, $q_sroa_1_1_ph = 0, $q_sroa_0_1_ph = 0, $r_sroa_1_1_ph = 0, $r_sroa_0_1_ph = 0, $sr_1_ph = 0, $d_sroa_0_0_insert_insert99$0 = 0, $d_sroa_0_0_insert_insert99$1 = 0, $137$0 = 0, $137$1 = 0, $carry_0203 = 0, $sr_1202 = 0, $r_sroa_0_1201 = 0, $r_sroa_1_1200 = 0, $q_sroa_0_1199 = 0, $q_sroa_1_1198 = 0, $147 = 0, $149 = 0, $r_sroa_0_0_insert_insert42$0 = 0, $r_sroa_0_0_insert_insert42$1 = 0, $150$1 = 0, $151$0 = 0, $152 = 0, $154$0 = 0, $r_sroa_0_0_extract_trunc = 0, $r_sroa_1_4_extract_trunc = 0, $155 = 0, $carry_0_lcssa$0 = 0, $carry_0_lcssa$1 = 0, $r_sroa_0_1_lcssa = 0, $r_sroa_1_1_lcssa = 0, $q_sroa_0_1_lcssa = 0, $q_sroa_1_1_lcssa = 0, $q_sroa_0_0_insert_ext75$0 = 0, $q_sroa_0_0_insert_ext75$1 = 0, $q_sroa_0_0_insert_insert77$1 = 0, $_0$0 = 0, $_0$1 = 0;
  $n_sroa_0_0_extract_trunc = $a$0;
  $n_sroa_1_4_extract_shift$0 = $a$1;
  $n_sroa_1_4_extract_trunc = $n_sroa_1_4_extract_shift$0;
  $d_sroa_0_0_extract_trunc = $b$0;
  $d_sroa_1_4_extract_shift$0 = $b$1;
  $d_sroa_1_4_extract_trunc = $d_sroa_1_4_extract_shift$0;
  if (($n_sroa_1_4_extract_trunc | 0) == 0) {
    $4 = ($rem | 0) != 0;
    if (($d_sroa_1_4_extract_trunc | 0) == 0) {
      if ($4) {
        HEAP32[$rem >> 2] = ($n_sroa_0_0_extract_trunc >>> 0) % ($d_sroa_0_0_extract_trunc >>> 0);
        HEAP32[$rem + 4 >> 2] = 0;
      }
      $_0$1 = 0;
      $_0$0 = ($n_sroa_0_0_extract_trunc >>> 0) / ($d_sroa_0_0_extract_trunc >>> 0) >>> 0;
      return (tempRet0 = $_0$1, $_0$0) | 0;
    } else {
      if (!$4) {
        $_0$1 = 0;
        $_0$0 = 0;
        return (tempRet0 = $_0$1, $_0$0) | 0;
      }
      HEAP32[$rem >> 2] = $a$0 & -1;
      HEAP32[$rem + 4 >> 2] = $a$1 & 0;
      $_0$1 = 0;
      $_0$0 = 0;
      return (tempRet0 = $_0$1, $_0$0) | 0;
    }
  }
  $17 = ($d_sroa_1_4_extract_trunc | 0) == 0;
  do {
    if (($d_sroa_0_0_extract_trunc | 0) == 0) {
      if ($17) {
        if (($rem | 0) != 0) {
          HEAP32[$rem >> 2] = ($n_sroa_1_4_extract_trunc >>> 0) % ($d_sroa_0_0_extract_trunc >>> 0);
          HEAP32[$rem + 4 >> 2] = 0;
        }
        $_0$1 = 0;
        $_0$0 = ($n_sroa_1_4_extract_trunc >>> 0) / ($d_sroa_0_0_extract_trunc >>> 0) >>> 0;
        return (tempRet0 = $_0$1, $_0$0) | 0;
      }
      if (($n_sroa_0_0_extract_trunc | 0) == 0) {
        if (($rem | 0) != 0) {
          HEAP32[$rem >> 2] = 0;
          HEAP32[$rem + 4 >> 2] = ($n_sroa_1_4_extract_trunc >>> 0) % ($d_sroa_1_4_extract_trunc >>> 0);
        }
        $_0$1 = 0;
        $_0$0 = ($n_sroa_1_4_extract_trunc >>> 0) / ($d_sroa_1_4_extract_trunc >>> 0) >>> 0;
        return (tempRet0 = $_0$1, $_0$0) | 0;
      }
      $37 = $d_sroa_1_4_extract_trunc - 1 | 0;
      if (($37 & $d_sroa_1_4_extract_trunc | 0) == 0) {
        if (($rem | 0) != 0) {
          HEAP32[$rem >> 2] = 0 | $a$0 & -1;
          HEAP32[$rem + 4 >> 2] = $37 & $n_sroa_1_4_extract_trunc | $a$1 & 0;
        }
        $_0$1 = 0;
        $_0$0 = $n_sroa_1_4_extract_trunc >>> ((_llvm_cttz_i32($d_sroa_1_4_extract_trunc | 0) | 0) >>> 0);
        return (tempRet0 = $_0$1, $_0$0) | 0;
      }
      $49 = _llvm_ctlz_i32($d_sroa_1_4_extract_trunc | 0) | 0;
      $51 = $49 - (_llvm_ctlz_i32($n_sroa_1_4_extract_trunc | 0) | 0) | 0;
      if ($51 >>> 0 <= 30) {
        $57 = $51 + 1 | 0;
        $58 = 31 - $51 | 0;
        $sr_1_ph = $57;
        $r_sroa_0_1_ph = $n_sroa_1_4_extract_trunc << $58 | $n_sroa_0_0_extract_trunc >>> ($57 >>> 0);
        $r_sroa_1_1_ph = $n_sroa_1_4_extract_trunc >>> ($57 >>> 0);
        $q_sroa_0_1_ph = 0;
        $q_sroa_1_1_ph = $n_sroa_0_0_extract_trunc << $58;
        break;
      }
      if (($rem | 0) == 0) {
        $_0$1 = 0;
        $_0$0 = 0;
        return (tempRet0 = $_0$1, $_0$0) | 0;
      }
      HEAP32[$rem >> 2] = 0 | $a$0 & -1;
      HEAP32[$rem + 4 >> 2] = $n_sroa_1_4_extract_shift$0 | $a$1 & 0;
      $_0$1 = 0;
      $_0$0 = 0;
      return (tempRet0 = $_0$1, $_0$0) | 0;
    } else {
      if (!$17) {
        $117 = _llvm_ctlz_i32($d_sroa_1_4_extract_trunc | 0) | 0;
        $119 = $117 - (_llvm_ctlz_i32($n_sroa_1_4_extract_trunc | 0) | 0) | 0;
        if ($119 >>> 0 <= 31) {
          $125 = $119 + 1 | 0;
          $126 = 31 - $119 | 0;
          $130 = $119 - 31 >> 31;
          $sr_1_ph = $125;
          $r_sroa_0_1_ph = $n_sroa_0_0_extract_trunc >>> ($125 >>> 0) & $130 | $n_sroa_1_4_extract_trunc << $126;
          $r_sroa_1_1_ph = $n_sroa_1_4_extract_trunc >>> ($125 >>> 0) & $130;
          $q_sroa_0_1_ph = 0;
          $q_sroa_1_1_ph = $n_sroa_0_0_extract_trunc << $126;
          break;
        }
        if (($rem | 0) == 0) {
          $_0$1 = 0;
          $_0$0 = 0;
          return (tempRet0 = $_0$1, $_0$0) | 0;
        }
        HEAP32[$rem >> 2] = 0 | $a$0 & -1;
        HEAP32[$rem + 4 >> 2] = $n_sroa_1_4_extract_shift$0 | $a$1 & 0;
        $_0$1 = 0;
        $_0$0 = 0;
        return (tempRet0 = $_0$1, $_0$0) | 0;
      }
      $66 = $d_sroa_0_0_extract_trunc - 1 | 0;
      if (($66 & $d_sroa_0_0_extract_trunc | 0) != 0) {
        $86 = (_llvm_ctlz_i32($d_sroa_0_0_extract_trunc | 0) | 0) + 33 | 0;
        $88 = $86 - (_llvm_ctlz_i32($n_sroa_1_4_extract_trunc | 0) | 0) | 0;
        $89 = 64 - $88 | 0;
        $91 = 32 - $88 | 0;
        $92 = $91 >> 31;
        $95 = $88 - 32 | 0;
        $105 = $95 >> 31;
        $sr_1_ph = $88;
        $r_sroa_0_1_ph = $91 - 1 >> 31 & $n_sroa_1_4_extract_trunc >>> ($95 >>> 0) | ($n_sroa_1_4_extract_trunc << $91 | $n_sroa_0_0_extract_trunc >>> ($88 >>> 0)) & $105;
        $r_sroa_1_1_ph = $105 & $n_sroa_1_4_extract_trunc >>> ($88 >>> 0);
        $q_sroa_0_1_ph = $n_sroa_0_0_extract_trunc << $89 & $92;
        $q_sroa_1_1_ph = ($n_sroa_1_4_extract_trunc << $89 | $n_sroa_0_0_extract_trunc >>> ($95 >>> 0)) & $92 | $n_sroa_0_0_extract_trunc << $91 & $88 - 33 >> 31;
        break;
      }
      if (($rem | 0) != 0) {
        HEAP32[$rem >> 2] = $66 & $n_sroa_0_0_extract_trunc;
        HEAP32[$rem + 4 >> 2] = 0;
      }
      if (($d_sroa_0_0_extract_trunc | 0) == 1) {
        $_0$1 = $n_sroa_1_4_extract_shift$0 | $a$1 & 0;
        $_0$0 = 0 | $a$0 & -1;
        return (tempRet0 = $_0$1, $_0$0) | 0;
      } else {
        $78 = _llvm_cttz_i32($d_sroa_0_0_extract_trunc | 0) | 0;
        $_0$1 = 0 | $n_sroa_1_4_extract_trunc >>> ($78 >>> 0);
        $_0$0 = $n_sroa_1_4_extract_trunc << 32 - $78 | $n_sroa_0_0_extract_trunc >>> ($78 >>> 0) | 0;
        return (tempRet0 = $_0$1, $_0$0) | 0;
      }
    }
  } while (0);
  if (($sr_1_ph | 0) == 0) {
    $q_sroa_1_1_lcssa = $q_sroa_1_1_ph;
    $q_sroa_0_1_lcssa = $q_sroa_0_1_ph;
    $r_sroa_1_1_lcssa = $r_sroa_1_1_ph;
    $r_sroa_0_1_lcssa = $r_sroa_0_1_ph;
    $carry_0_lcssa$1 = 0;
    $carry_0_lcssa$0 = 0;
  } else {
    $d_sroa_0_0_insert_insert99$0 = 0 | $b$0 & -1;
    $d_sroa_0_0_insert_insert99$1 = $d_sroa_1_4_extract_shift$0 | $b$1 & 0;
    $137$0 = _i64Add($d_sroa_0_0_insert_insert99$0, $d_sroa_0_0_insert_insert99$1, -1, -1) | 0;
    $137$1 = tempRet0;
    $q_sroa_1_1198 = $q_sroa_1_1_ph;
    $q_sroa_0_1199 = $q_sroa_0_1_ph;
    $r_sroa_1_1200 = $r_sroa_1_1_ph;
    $r_sroa_0_1201 = $r_sroa_0_1_ph;
    $sr_1202 = $sr_1_ph;
    $carry_0203 = 0;
    while (1) {
      $147 = $q_sroa_0_1199 >>> 31 | $q_sroa_1_1198 << 1;
      $149 = $carry_0203 | $q_sroa_0_1199 << 1;
      $r_sroa_0_0_insert_insert42$0 = 0 | ($r_sroa_0_1201 << 1 | $q_sroa_1_1198 >>> 31);
      $r_sroa_0_0_insert_insert42$1 = $r_sroa_0_1201 >>> 31 | $r_sroa_1_1200 << 1 | 0;
      _i64Subtract($137$0, $137$1, $r_sroa_0_0_insert_insert42$0, $r_sroa_0_0_insert_insert42$1) | 0;
      $150$1 = tempRet0;
      $151$0 = $150$1 >> 31 | (($150$1 | 0) < 0 ? -1 : 0) << 1;
      $152 = $151$0 & 1;
      $154$0 = _i64Subtract($r_sroa_0_0_insert_insert42$0, $r_sroa_0_0_insert_insert42$1, $151$0 & $d_sroa_0_0_insert_insert99$0, ((($150$1 | 0) < 0 ? -1 : 0) >> 31 | (($150$1 | 0) < 0 ? -1 : 0) << 1) & $d_sroa_0_0_insert_insert99$1) | 0;
      $r_sroa_0_0_extract_trunc = $154$0;
      $r_sroa_1_4_extract_trunc = tempRet0;
      $155 = $sr_1202 - 1 | 0;
      if (($155 | 0) == 0) {
        break;
      } else {
        $q_sroa_1_1198 = $147;
        $q_sroa_0_1199 = $149;
        $r_sroa_1_1200 = $r_sroa_1_4_extract_trunc;
        $r_sroa_0_1201 = $r_sroa_0_0_extract_trunc;
        $sr_1202 = $155;
        $carry_0203 = $152;
      }
    }
    $q_sroa_1_1_lcssa = $147;
    $q_sroa_0_1_lcssa = $149;
    $r_sroa_1_1_lcssa = $r_sroa_1_4_extract_trunc;
    $r_sroa_0_1_lcssa = $r_sroa_0_0_extract_trunc;
    $carry_0_lcssa$1 = 0;
    $carry_0_lcssa$0 = $152;
  }
  $q_sroa_0_0_insert_ext75$0 = $q_sroa_0_1_lcssa;
  $q_sroa_0_0_insert_ext75$1 = 0;
  $q_sroa_0_0_insert_insert77$1 = $q_sroa_1_1_lcssa | $q_sroa_0_0_insert_ext75$1;
  if (($rem | 0) != 0) {
    HEAP32[$rem >> 2] = 0 | $r_sroa_0_1_lcssa;
    HEAP32[$rem + 4 >> 2] = $r_sroa_1_1_lcssa | 0;
  }
  $_0$1 = (0 | $q_sroa_0_0_insert_ext75$0) >>> 31 | $q_sroa_0_0_insert_insert77$1 << 1 | ($q_sroa_0_0_insert_ext75$1 << 1 | $q_sroa_0_0_insert_ext75$0 >>> 31) & 0 | $carry_0_lcssa$1;
  $_0$0 = ($q_sroa_0_0_insert_ext75$0 << 1 | 0 >>> 31) & -2 | $carry_0_lcssa$0;
  return (tempRet0 = $_0$1, $_0$0) | 0;
}
// =======================================================================


// EMSCRIPTEN_END_FUNCS

// TODO: strip out parts of this we do not need

//======= begin closure i64 code =======

// Copyright 2009 The Closure Library Authors. All Rights Reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS-IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/**
 * @fileoverview Defines a Long class for representing a 64-bit two's-complement
 * integer value, which faithfully simulates the behavior of a Java "long". This
 * implementation is derived from LongLib in GWT.
 *
 */

var i64Math = (function() { // Emscripten wrapper
  var goog = { math: {} };


  /**
   * Constructs a 64-bit two's-complement integer, given its low and high 32-bit
   * values as *signed* integers.  See the from* functions below for more
   * convenient ways of constructing Longs.
   *
   * The internal representation of a long is the two given signed, 32-bit values.
   * We use 32-bit pieces because these are the size of integers on which
   * Javascript performs bit-operations.  For operations like addition and
   * multiplication, we split each number into 16-bit pieces, which can easily be
   * multiplied within Javascript's floating-point representation without overflow
   * or change in sign.
   *
   * In the algorithms below, we frequently reduce the negative case to the
   * positive case by negating the input(s) and then post-processing the result.
   * Note that we must ALWAYS check specially whether those values are MIN_VALUE
   * (-2^63) because -MIN_VALUE == MIN_VALUE (since 2^63 cannot be represented as
   * a positive number, it overflows back into a negative).  Not handling this
   * case would often result in infinite recursion.
   *
   * @param {number} low  The low (signed) 32 bits of the long.
   * @param {number} high  The high (signed) 32 bits of the long.
   * @constructor
   */
  goog.math.Long = function(low, high) {
    /**
     * @type {number}
     * @private
     */
    this.low_ = low | 0;  // force into 32 signed bits.

    /**
     * @type {number}
     * @private
     */
    this.high_ = high | 0;  // force into 32 signed bits.
  };


  // NOTE: Common constant values ZERO, ONE, NEG_ONE, etc. are defined below the
  // from* methods on which they depend.


  /**
   * A cache of the Long representations of small integer values.
   * @type {!Object}
   * @private
   */
  goog.math.Long.IntCache_ = {};


  /**
   * Returns a Long representing the given (32-bit) integer value.
   * @param {number} value The 32-bit integer in question.
   * @return {!goog.math.Long} The corresponding Long value.
   */
  goog.math.Long.fromInt = function(value) {
    if (-128 <= value && value < 128) {
      var cachedObj = goog.math.Long.IntCache_[value];
      if (cachedObj) {
        return cachedObj;
      }
    }

    var obj = new goog.math.Long(value | 0, value < 0 ? -1 : 0);
    if (-128 <= value && value < 128) {
      goog.math.Long.IntCache_[value] = obj;
    }
    return obj;
  };


  /**
   * Returns a Long representing the given value, provided that it is a finite
   * number.  Otherwise, zero is returned.
   * @param {number} value The number in question.
   * @return {!goog.math.Long} The corresponding Long value.
   */
  goog.math.Long.fromNumber = function(value) {
    if (isNaN(value) || !isFinite(value)) {
      return goog.math.Long.ZERO;
    } else if (value <= -goog.math.Long.TWO_PWR_63_DBL_) {
      return goog.math.Long.MIN_VALUE;
    } else if (value + 1 >= goog.math.Long.TWO_PWR_63_DBL_) {
      return goog.math.Long.MAX_VALUE;
    } else if (value < 0) {
      return goog.math.Long.fromNumber(-value).negate();
    } else {
      return new goog.math.Long(
          (value % goog.math.Long.TWO_PWR_32_DBL_) | 0,
          (value / goog.math.Long.TWO_PWR_32_DBL_) | 0);
    }
  };


  /**
   * Returns a Long representing the 64-bit integer that comes by concatenating
   * the given high and low bits.  Each is assumed to use 32 bits.
   * @param {number} lowBits The low 32-bits.
   * @param {number} highBits The high 32-bits.
   * @return {!goog.math.Long} The corresponding Long value.
   */
  goog.math.Long.fromBits = function(lowBits, highBits) {
    return new goog.math.Long(lowBits, highBits);
  };


  /**
   * Returns a Long representation of the given string, written using the given
   * radix.
   * @param {string} str The textual representation of the Long.
   * @param {number=} opt_radix The radix in which the text is written.
   * @return {!goog.math.Long} The corresponding Long value.
   */
  goog.math.Long.fromString = function(str, opt_radix) {
    if (str.length == 0) {
      throw Error('number format error: empty string');
    }

    var radix = opt_radix || 10;
    if (radix < 2 || 36 < radix) {
      throw Error('radix out of range: ' + radix);
    }

    if (str.charAt(0) == '-') {
      return goog.math.Long.fromString(str.substring(1), radix).negate();
    } else if (str.indexOf('-') >= 0) {
      throw Error('number format error: interior "-" character: ' + str);
    }

    // Do several (8) digits each time through the loop, so as to
    // minimize the calls to the very expensive emulated div.
    var radixToPower = goog.math.Long.fromNumber(Math.pow(radix, 8));

    var result = goog.math.Long.ZERO;
    for (var i = 0; i < str.length; i += 8) {
      var size = Math.min(8, str.length - i);
      var value = parseInt(str.substring(i, i + size), radix);
      if (size < 8) {
        var power = goog.math.Long.fromNumber(Math.pow(radix, size));
        result = result.multiply(power).add(goog.math.Long.fromNumber(value));
      } else {
        result = result.multiply(radixToPower);
        result = result.add(goog.math.Long.fromNumber(value));
      }
    }
    return result;
  };


  // NOTE: the compiler should inline these constant values below and then remove
  // these variables, so there should be no runtime penalty for these.


  /**
   * Number used repeated below in calculations.  This must appear before the
   * first call to any from* function below.
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_16_DBL_ = 1 << 16;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_24_DBL_ = 1 << 24;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_32_DBL_ =
      goog.math.Long.TWO_PWR_16_DBL_ * goog.math.Long.TWO_PWR_16_DBL_;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_31_DBL_ =
      goog.math.Long.TWO_PWR_32_DBL_ / 2;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_48_DBL_ =
      goog.math.Long.TWO_PWR_32_DBL_ * goog.math.Long.TWO_PWR_16_DBL_;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_64_DBL_ =
      goog.math.Long.TWO_PWR_32_DBL_ * goog.math.Long.TWO_PWR_32_DBL_;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_63_DBL_ =
      goog.math.Long.TWO_PWR_64_DBL_ / 2;


  /** @type {!goog.math.Long} */
  goog.math.Long.ZERO = goog.math.Long.fromInt(0);


  /** @type {!goog.math.Long} */
  goog.math.Long.ONE = goog.math.Long.fromInt(1);


  /** @type {!goog.math.Long} */
  goog.math.Long.NEG_ONE = goog.math.Long.fromInt(-1);


  /** @type {!goog.math.Long} */
  goog.math.Long.MAX_VALUE =
      goog.math.Long.fromBits(0xFFFFFFFF | 0, 0x7FFFFFFF | 0);


  /** @type {!goog.math.Long} */
  goog.math.Long.MIN_VALUE = goog.math.Long.fromBits(0, 0x80000000 | 0);


  /**
   * @type {!goog.math.Long}
   * @private
   */
  goog.math.Long.TWO_PWR_24_ = goog.math.Long.fromInt(1 << 24);


  /** @return {number} The value, assuming it is a 32-bit integer. */
  goog.math.Long.prototype.toInt = function() {
    return this.low_;
  };


  /** @return {number} The closest floating-point representation to this value. */
  goog.math.Long.prototype.toNumber = function() {
    return this.high_ * goog.math.Long.TWO_PWR_32_DBL_ +
           this.getLowBitsUnsigned();
  };


  /**
   * @param {number=} opt_radix The radix in which the text should be written.
   * @return {string} The textual representation of this value.
   */
  goog.math.Long.prototype.toString = function(opt_radix) {
    var radix = opt_radix || 10;
    if (radix < 2 || 36 < radix) {
      throw Error('radix out of range: ' + radix);
    }

    if (this.isZero()) {
      return '0';
    }

    if (this.isNegative()) {
      if (this.equals(goog.math.Long.MIN_VALUE)) {
        // We need to change the Long value before it can be negated, so we remove
        // the bottom-most digit in this base and then recurse to do the rest.
        var radixLong = goog.math.Long.fromNumber(radix);
        var div = this.div(radixLong);
        var rem = div.multiply(radixLong).subtract(this);
        return div.toString(radix) + rem.toInt().toString(radix);
      } else {
        return '-' + this.negate().toString(radix);
      }
    }

    // Do several (6) digits each time through the loop, so as to
    // minimize the calls to the very expensive emulated div.
    var radixToPower = goog.math.Long.fromNumber(Math.pow(radix, 6));

    var rem = this;
    var result = '';
    while (true) {
      var remDiv = rem.div(radixToPower);
      var intval = rem.subtract(remDiv.multiply(radixToPower)).toInt();
      var digits = intval.toString(radix);

      rem = remDiv;
      if (rem.isZero()) {
        return digits + result;
      } else {
        while (digits.length < 6) {
          digits = '0' + digits;
        }
        result = '' + digits + result;
      }
    }
  };


  /** @return {number} The high 32-bits as a signed value. */
  goog.math.Long.prototype.getHighBits = function() {
    return this.high_;
  };


  /** @return {number} The low 32-bits as a signed value. */
  goog.math.Long.prototype.getLowBits = function() {
    return this.low_;
  };


  /** @return {number} The low 32-bits as an unsigned value. */
  goog.math.Long.prototype.getLowBitsUnsigned = function() {
    return (this.low_ >= 0) ?
        this.low_ : goog.math.Long.TWO_PWR_32_DBL_ + this.low_;
  };


  /**
   * @return {number} Returns the number of bits needed to represent the absolute
   *     value of this Long.
   */
  goog.math.Long.prototype.getNumBitsAbs = function() {
    if (this.isNegative()) {
      if (this.equals(goog.math.Long.MIN_VALUE)) {
        return 64;
      } else {
        return this.negate().getNumBitsAbs();
      }
    } else {
      var val = this.high_ != 0 ? this.high_ : this.low_;
      for (var bit = 31; bit > 0; bit--) {
        if ((val & (1 << bit)) != 0) {
          break;
        }
      }
      return this.high_ != 0 ? bit + 33 : bit + 1;
    }
  };


  /** @return {boolean} Whether this value is zero. */
  goog.math.Long.prototype.isZero = function() {
    return this.high_ == 0 && this.low_ == 0;
  };


  /** @return {boolean} Whether this value is negative. */
  goog.math.Long.prototype.isNegative = function() {
    return this.high_ < 0;
  };


  /** @return {boolean} Whether this value is odd. */
  goog.math.Long.prototype.isOdd = function() {
    return (this.low_ & 1) == 1;
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long equals the other.
   */
  goog.math.Long.prototype.equals = function(other) {
    return (this.high_ == other.high_) && (this.low_ == other.low_);
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long does not equal the other.
   */
  goog.math.Long.prototype.notEquals = function(other) {
    return (this.high_ != other.high_) || (this.low_ != other.low_);
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long is less than the other.
   */
  goog.math.Long.prototype.lessThan = function(other) {
    return this.compare(other) < 0;
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long is less than or equal to the other.
   */
  goog.math.Long.prototype.lessThanOrEqual = function(other) {
    return this.compare(other) <= 0;
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long is greater than the other.
   */
  goog.math.Long.prototype.greaterThan = function(other) {
    return this.compare(other) > 0;
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long is greater than or equal to the other.
   */
  goog.math.Long.prototype.greaterThanOrEqual = function(other) {
    return this.compare(other) >= 0;
  };


  /**
   * Compares this Long with the given one.
   * @param {goog.math.Long} other Long to compare against.
   * @return {number} 0 if they are the same, 1 if the this is greater, and -1
   *     if the given one is greater.
   */
  goog.math.Long.prototype.compare = function(other) {
    if (this.equals(other)) {
      return 0;
    }

    var thisNeg = this.isNegative();
    var otherNeg = other.isNegative();
    if (thisNeg && !otherNeg) {
      return -1;
    }
    if (!thisNeg && otherNeg) {
      return 1;
    }

    // at this point, the signs are the same, so subtraction will not overflow
    if (this.subtract(other).isNegative()) {
      return -1;
    } else {
      return 1;
    }
  };


  /** @return {!goog.math.Long} The negation of this value. */
  goog.math.Long.prototype.negate = function() {
    if (this.equals(goog.math.Long.MIN_VALUE)) {
      return goog.math.Long.MIN_VALUE;
    } else {
      return this.not().add(goog.math.Long.ONE);
    }
  };


  /**
   * Returns the sum of this and the given Long.
   * @param {goog.math.Long} other Long to add to this one.
   * @return {!goog.math.Long} The sum of this and the given Long.
   */
  goog.math.Long.prototype.add = function(other) {
    // Divide each number into 4 chunks of 16 bits, and then sum the chunks.

    var a48 = this.high_ >>> 16;
    var a32 = this.high_ & 0xFFFF;
    var a16 = this.low_ >>> 16;
    var a00 = this.low_ & 0xFFFF;

    var b48 = other.high_ >>> 16;
    var b32 = other.high_ & 0xFFFF;
    var b16 = other.low_ >>> 16;
    var b00 = other.low_ & 0xFFFF;

    var c48 = 0, c32 = 0, c16 = 0, c00 = 0;
    c00 += a00 + b00;
    c16 += c00 >>> 16;
    c00 &= 0xFFFF;
    c16 += a16 + b16;
    c32 += c16 >>> 16;
    c16 &= 0xFFFF;
    c32 += a32 + b32;
    c48 += c32 >>> 16;
    c32 &= 0xFFFF;
    c48 += a48 + b48;
    c48 &= 0xFFFF;
    return goog.math.Long.fromBits((c16 << 16) | c00, (c48 << 16) | c32);
  };


  /**
   * Returns the difference of this and the given Long.
   * @param {goog.math.Long} other Long to subtract from this.
   * @return {!goog.math.Long} The difference of this and the given Long.
   */
  goog.math.Long.prototype.subtract = function(other) {
    return this.add(other.negate());
  };


  /**
   * Returns the product of this and the given long.
   * @param {goog.math.Long} other Long to multiply with this.
   * @return {!goog.math.Long} The product of this and the other.
   */
  goog.math.Long.prototype.multiply = function(other) {
    if (this.isZero()) {
      return goog.math.Long.ZERO;
    } else if (other.isZero()) {
      return goog.math.Long.ZERO;
    }

    if (this.equals(goog.math.Long.MIN_VALUE)) {
      return other.isOdd() ? goog.math.Long.MIN_VALUE : goog.math.Long.ZERO;
    } else if (other.equals(goog.math.Long.MIN_VALUE)) {
      return this.isOdd() ? goog.math.Long.MIN_VALUE : goog.math.Long.ZERO;
    }

    if (this.isNegative()) {
      if (other.isNegative()) {
        return this.negate().multiply(other.negate());
      } else {
        return this.negate().multiply(other).negate();
      }
    } else if (other.isNegative()) {
      return this.multiply(other.negate()).negate();
    }

    // If both longs are small, use float multiplication
    if (this.lessThan(goog.math.Long.TWO_PWR_24_) &&
        other.lessThan(goog.math.Long.TWO_PWR_24_)) {
      return goog.math.Long.fromNumber(this.toNumber() * other.toNumber());
    }

    // Divide each long into 4 chunks of 16 bits, and then add up 4x4 products.
    // We can skip products that would overflow.

    var a48 = this.high_ >>> 16;
    var a32 = this.high_ & 0xFFFF;
    var a16 = this.low_ >>> 16;
    var a00 = this.low_ & 0xFFFF;

    var b48 = other.high_ >>> 16;
    var b32 = other.high_ & 0xFFFF;
    var b16 = other.low_ >>> 16;
    var b00 = other.low_ & 0xFFFF;

    var c48 = 0, c32 = 0, c16 = 0, c00 = 0;
    c00 += a00 * b00;
    c16 += c00 >>> 16;
    c00 &= 0xFFFF;
    c16 += a16 * b00;
    c32 += c16 >>> 16;
    c16 &= 0xFFFF;
    c16 += a00 * b16;
    c32 += c16 >>> 16;
    c16 &= 0xFFFF;
    c32 += a32 * b00;
    c48 += c32 >>> 16;
    c32 &= 0xFFFF;
    c32 += a16 * b16;
    c48 += c32 >>> 16;
    c32 &= 0xFFFF;
    c32 += a00 * b32;
    c48 += c32 >>> 16;
    c32 &= 0xFFFF;
    c48 += a48 * b00 + a32 * b16 + a16 * b32 + a00 * b48;
    c48 &= 0xFFFF;
    return goog.math.Long.fromBits((c16 << 16) | c00, (c48 << 16) | c32);
  };


  /**
   * Returns this Long divided by the given one.
   * @param {goog.math.Long} other Long by which to divide.
   * @return {!goog.math.Long} This Long divided by the given one.
   */
  goog.math.Long.prototype.div = function(other) {
    if (other.isZero()) {
      throw Error('division by zero');
    } else if (this.isZero()) {
      return goog.math.Long.ZERO;
    }

    if (this.equals(goog.math.Long.MIN_VALUE)) {
      if (other.equals(goog.math.Long.ONE) ||
          other.equals(goog.math.Long.NEG_ONE)) {
        return goog.math.Long.MIN_VALUE;  // recall that -MIN_VALUE == MIN_VALUE
      } else if (other.equals(goog.math.Long.MIN_VALUE)) {
        return goog.math.Long.ONE;
      } else {
        // At this point, we have |other| >= 2, so |this/other| < |MIN_VALUE|.
        var halfThis = this.shiftRight(1);
        var approx = halfThis.div(other).shiftLeft(1);
        if (approx.equals(goog.math.Long.ZERO)) {
          return other.isNegative() ? goog.math.Long.ONE : goog.math.Long.NEG_ONE;
        } else {
          var rem = this.subtract(other.multiply(approx));
          var result = approx.add(rem.div(other));
          return result;
        }
      }
    } else if (other.equals(goog.math.Long.MIN_VALUE)) {
      return goog.math.Long.ZERO;
    }

    if (this.isNegative()) {
      if (other.isNegative()) {
        return this.negate().div(other.negate());
      } else {
        return this.negate().div(other).negate();
      }
    } else if (other.isNegative()) {
      return this.div(other.negate()).negate();
    }

    // Repeat the following until the remainder is less than other:  find a
    // floating-point that approximates remainder / other *from below*, add this
    // into the result, and subtract it from the remainder.  It is critical that
    // the approximate value is less than or equal to the real value so that the
    // remainder never becomes negative.
    var res = goog.math.Long.ZERO;
    var rem = this;
    while (rem.greaterThanOrEqual(other)) {
      // Approximate the result of division. This may be a little greater or
      // smaller than the actual value.
      var approx = Math.max(1, Math.floor(rem.toNumber() / other.toNumber()));

      // We will tweak the approximate result by changing it in the 48-th digit or
      // the smallest non-fractional digit, whichever is larger.
      var log2 = Math.ceil(Math.log(approx) / Math.LN2);
      var delta = (log2 <= 48) ? 1 : Math.pow(2, log2 - 48);

      // Decrease the approximation until it is smaller than the remainder.  Note
      // that if it is too large, the product overflows and is negative.
      var approxRes = goog.math.Long.fromNumber(approx);
      var approxRem = approxRes.multiply(other);
      while (approxRem.isNegative() || approxRem.greaterThan(rem)) {
        approx -= delta;
        approxRes = goog.math.Long.fromNumber(approx);
        approxRem = approxRes.multiply(other);
      }

      // We know the answer can't be zero... and actually, zero would cause
      // infinite recursion since we would make no progress.
      if (approxRes.isZero()) {
        approxRes = goog.math.Long.ONE;
      }

      res = res.add(approxRes);
      rem = rem.subtract(approxRem);
    }
    return res;
  };


  /**
   * Returns this Long modulo the given one.
   * @param {goog.math.Long} other Long by which to mod.
   * @return {!goog.math.Long} This Long modulo the given one.
   */
  goog.math.Long.prototype.modulo = function(other) {
    return this.subtract(this.div(other).multiply(other));
  };


  /** @return {!goog.math.Long} The bitwise-NOT of this value. */
  goog.math.Long.prototype.not = function() {
    return goog.math.Long.fromBits(~this.low_, ~this.high_);
  };


  /**
   * Returns the bitwise-AND of this Long and the given one.
   * @param {goog.math.Long} other The Long with which to AND.
   * @return {!goog.math.Long} The bitwise-AND of this and the other.
   */
  goog.math.Long.prototype.and = function(other) {
    return goog.math.Long.fromBits(this.low_ & other.low_,
                                   this.high_ & other.high_);
  };


  /**
   * Returns the bitwise-OR of this Long and the given one.
   * @param {goog.math.Long} other The Long with which to OR.
   * @return {!goog.math.Long} The bitwise-OR of this and the other.
   */
  goog.math.Long.prototype.or = function(other) {
    return goog.math.Long.fromBits(this.low_ | other.low_,
                                   this.high_ | other.high_);
  };


  /**
   * Returns the bitwise-XOR of this Long and the given one.
   * @param {goog.math.Long} other The Long with which to XOR.
   * @return {!goog.math.Long} The bitwise-XOR of this and the other.
   */
  goog.math.Long.prototype.xor = function(other) {
    return goog.math.Long.fromBits(this.low_ ^ other.low_,
                                   this.high_ ^ other.high_);
  };


  /**
   * Returns this Long with bits shifted to the left by the given amount.
   * @param {number} numBits The number of bits by which to shift.
   * @return {!goog.math.Long} This shifted to the left by the given amount.
   */
  goog.math.Long.prototype.shiftLeft = function(numBits) {
    numBits &= 63;
    if (numBits == 0) {
      return this;
    } else {
      var low = this.low_;
      if (numBits < 32) {
        var high = this.high_;
        return goog.math.Long.fromBits(
            low << numBits,
            (high << numBits) | (low >>> (32 - numBits)));
      } else {
        return goog.math.Long.fromBits(0, low << (numBits - 32));
      }
    }
  };


  /**
   * Returns this Long with bits shifted to the right by the given amount.
   * @param {number} numBits The number of bits by which to shift.
   * @return {!goog.math.Long} This shifted to the right by the given amount.
   */
  goog.math.Long.prototype.shiftRight = function(numBits) {
    numBits &= 63;
    if (numBits == 0) {
      return this;
    } else {
      var high = this.high_;
      if (numBits < 32) {
        var low = this.low_;
        return goog.math.Long.fromBits(
            (low >>> numBits) | (high << (32 - numBits)),
            high >> numBits);
      } else {
        return goog.math.Long.fromBits(
            high >> (numBits - 32),
            high >= 0 ? 0 : -1);
      }
    }
  };


  /**
   * Returns this Long with bits shifted to the right by the given amount, with
   * the new top bits matching the current sign bit.
   * @param {number} numBits The number of bits by which to shift.
   * @return {!goog.math.Long} This shifted to the right by the given amount, with
   *     zeros placed into the new leading bits.
   */
  goog.math.Long.prototype.shiftRightUnsigned = function(numBits) {
    numBits &= 63;
    if (numBits == 0) {
      return this;
    } else {
      var high = this.high_;
      if (numBits < 32) {
        var low = this.low_;
        return goog.math.Long.fromBits(
            (low >>> numBits) | (high << (32 - numBits)),
            high >>> numBits);
      } else if (numBits == 32) {
        return goog.math.Long.fromBits(high, 0);
      } else {
        return goog.math.Long.fromBits(high >>> (numBits - 32), 0);
      }
    }
  };

  //======= begin jsbn =======

  var navigator = { appName: 'Modern Browser' }; // polyfill a little

  // Copyright (c) 2005  Tom Wu
  // All Rights Reserved.
  // http://www-cs-students.stanford.edu/~tjw/jsbn/

  /*
   * Copyright (c) 2003-2005  Tom Wu
   * All Rights Reserved.
   *
   * Permission is hereby granted, free of charge, to any person obtaining
   * a copy of this software and associated documentation files (the
   * "Software"), to deal in the Software without restriction, including
   * without limitation the rights to use, copy, modify, merge, publish,
   * distribute, sublicense, and/or sell copies of the Software, and to
   * permit persons to whom the Software is furnished to do so, subject to
   * the following conditions:
   *
   * The above copyright notice and this permission notice shall be
   * included in all copies or substantial portions of the Software.
   *
   * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
   * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
   * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
   *
   * IN NO EVENT SHALL TOM WU BE LIABLE FOR ANY SPECIAL, INCIDENTAL,
   * INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND, OR ANY DAMAGES WHATSOEVER
   * RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER OR NOT ADVISED OF
   * THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF LIABILITY, ARISING OUT
   * OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
   *
   * In addition, the following condition applies:
   *
   * All redistributions must retain an intact copy of this copyright notice
   * and disclaimer.
   */

  // Basic JavaScript BN library - subset useful for RSA encryption.

  // Bits per digit
  var dbits;

  // JavaScript engine analysis
  var canary = 0xdeadbeefcafe;
  var j_lm = ((canary&0xffffff)==0xefcafe);

  // (public) Constructor
  function BigInteger(a,b,c) {
    if(a != null)
      if("number" == typeof a) this.fromNumber(a,b,c);
      else if(b == null && "string" != typeof a) this.fromString(a,256);
      else this.fromString(a,b);
  }

  // return new, unset BigInteger
  function nbi() { return new BigInteger(null); }

  // am: Compute w_j += (x*this_i), propagate carries,
  // c is initial carry, returns final carry.
  // c < 3*dvalue, x < 2*dvalue, this_i < dvalue
  // We need to select the fastest one that works in this environment.

  // am1: use a single mult and divide to get the high bits,
  // max digit bits should be 26 because
  // max internal value = 2*dvalue^2-2*dvalue (< 2^53)
  function am1(i,x,w,j,c,n) {
    while(--n >= 0) {
      var v = x*this[i++]+w[j]+c;
      c = Math.floor(v/0x4000000);
      w[j++] = v&0x3ffffff;
    }
    return c;
  }
  // am2 avoids a big mult-and-extract completely.
  // Max digit bits should be <= 30 because we do bitwise ops
  // on values up to 2*hdvalue^2-hdvalue-1 (< 2^31)
  function am2(i,x,w,j,c,n) {
    var xl = x&0x7fff, xh = x>>15;
    while(--n >= 0) {
      var l = this[i]&0x7fff;
      var h = this[i++]>>15;
      var m = xh*l+h*xl;
      l = xl*l+((m&0x7fff)<<15)+w[j]+(c&0x3fffffff);
      c = (l>>>30)+(m>>>15)+xh*h+(c>>>30);
      w[j++] = l&0x3fffffff;
    }
    return c;
  }
  // Alternately, set max digit bits to 28 since some
  // browsers slow down when dealing with 32-bit numbers.
  function am3(i,x,w,j,c,n) {
    var xl = x&0x3fff, xh = x>>14;
    while(--n >= 0) {
      var l = this[i]&0x3fff;
      var h = this[i++]>>14;
      var m = xh*l+h*xl;
      l = xl*l+((m&0x3fff)<<14)+w[j]+c;
      c = (l>>28)+(m>>14)+xh*h;
      w[j++] = l&0xfffffff;
    }
    return c;
  }
  if(j_lm && (navigator.appName == "Microsoft Internet Explorer")) {
    BigInteger.prototype.am = am2;
    dbits = 30;
  }
  else if(j_lm && (navigator.appName != "Netscape")) {
    BigInteger.prototype.am = am1;
    dbits = 26;
  }
  else { // Mozilla/Netscape seems to prefer am3
    BigInteger.prototype.am = am3;
    dbits = 28;
  }

  BigInteger.prototype.DB = dbits;
  BigInteger.prototype.DM = ((1<<dbits)-1);
  BigInteger.prototype.DV = (1<<dbits);

  var BI_FP = 52;
  BigInteger.prototype.FV = Math.pow(2,BI_FP);
  BigInteger.prototype.F1 = BI_FP-dbits;
  BigInteger.prototype.F2 = 2*dbits-BI_FP;

  // Digit conversions
  var BI_RM = "0123456789abcdefghijklmnopqrstuvwxyz";
  var BI_RC = new Array();
  var rr,vv;
  rr = "0".charCodeAt(0);
  for(vv = 0; vv <= 9; ++vv) BI_RC[rr++] = vv;
  rr = "a".charCodeAt(0);
  for(vv = 10; vv < 36; ++vv) BI_RC[rr++] = vv;
  rr = "A".charCodeAt(0);
  for(vv = 10; vv < 36; ++vv) BI_RC[rr++] = vv;

  function int2char(n) { return BI_RM.charAt(n); }
  function intAt(s,i) {
    var c = BI_RC[s.charCodeAt(i)];
    return (c==null)?-1:c;
  }

  // (protected) copy this to r
  function bnpCopyTo(r) {
    for(var i = this.t-1; i >= 0; --i) r[i] = this[i];
    r.t = this.t;
    r.s = this.s;
  }

  // (protected) set from integer value x, -DV <= x < DV
  function bnpFromInt(x) {
    this.t = 1;
    this.s = (x<0)?-1:0;
    if(x > 0) this[0] = x;
    else if(x < -1) this[0] = x+DV;
    else this.t = 0;
  }

  // return bigint initialized to value
  function nbv(i) { var r = nbi(); r.fromInt(i); return r; }

  // (protected) set from string and radix
  function bnpFromString(s,b) {
    var k;
    if(b == 16) k = 4;
    else if(b == 8) k = 3;
    else if(b == 256) k = 8; // byte array
    else if(b == 2) k = 1;
    else if(b == 32) k = 5;
    else if(b == 4) k = 2;
    else { this.fromRadix(s,b); return; }
    this.t = 0;
    this.s = 0;
    var i = s.length, mi = false, sh = 0;
    while(--i >= 0) {
      var x = (k==8)?s[i]&0xff:intAt(s,i);
      if(x < 0) {
        if(s.charAt(i) == "-") mi = true;
        continue;
      }
      mi = false;
      if(sh == 0)
        this[this.t++] = x;
      else if(sh+k > this.DB) {
        this[this.t-1] |= (x&((1<<(this.DB-sh))-1))<<sh;
        this[this.t++] = (x>>(this.DB-sh));
      }
      else
        this[this.t-1] |= x<<sh;
      sh += k;
      if(sh >= this.DB) sh -= this.DB;
    }
    if(k == 8 && (s[0]&0x80) != 0) {
      this.s = -1;
      if(sh > 0) this[this.t-1] |= ((1<<(this.DB-sh))-1)<<sh;
    }
    this.clamp();
    if(mi) BigInteger.ZERO.subTo(this,this);
  }

  // (protected) clamp off excess high words
  function bnpClamp() {
    var c = this.s&this.DM;
    while(this.t > 0 && this[this.t-1] == c) --this.t;
  }

  // (public) return string representation in given radix
  function bnToString(b) {
    if(this.s < 0) return "-"+this.negate().toString(b);
    var k;
    if(b == 16) k = 4;
    else if(b == 8) k = 3;
    else if(b == 2) k = 1;
    else if(b == 32) k = 5;
    else if(b == 4) k = 2;
    else return this.toRadix(b);
    var km = (1<<k)-1, d, m = false, r = "", i = this.t;
    var p = this.DB-(i*this.DB)%k;
    if(i-- > 0) {
      if(p < this.DB && (d = this[i]>>p) > 0) { m = true; r = int2char(d); }
      while(i >= 0) {
        if(p < k) {
          d = (this[i]&((1<<p)-1))<<(k-p);
          d |= this[--i]>>(p+=this.DB-k);
        }
        else {
          d = (this[i]>>(p-=k))&km;
          if(p <= 0) { p += this.DB; --i; }
        }
        if(d > 0) m = true;
        if(m) r += int2char(d);
      }
    }
    return m?r:"0";
  }

  // (public) -this
  function bnNegate() { var r = nbi(); BigInteger.ZERO.subTo(this,r); return r; }

  // (public) |this|
  function bnAbs() { return (this.s<0)?this.negate():this; }

  // (public) return + if this > a, - if this < a, 0 if equal
  function bnCompareTo(a) {
    var r = this.s-a.s;
    if(r != 0) return r;
    var i = this.t;
    r = i-a.t;
    if(r != 0) return (this.s<0)?-r:r;
    while(--i >= 0) if((r=this[i]-a[i]) != 0) return r;
    return 0;
  }

  // returns bit length of the integer x
  function nbits(x) {
    var r = 1, t;
    if((t=x>>>16) != 0) { x = t; r += 16; }
    if((t=x>>8) != 0) { x = t; r += 8; }
    if((t=x>>4) != 0) { x = t; r += 4; }
    if((t=x>>2) != 0) { x = t; r += 2; }
    if((t=x>>1) != 0) { x = t; r += 1; }
    return r;
  }

  // (public) return the number of bits in "this"
  function bnBitLength() {
    if(this.t <= 0) return 0;
    return this.DB*(this.t-1)+nbits(this[this.t-1]^(this.s&this.DM));
  }

  // (protected) r = this << n*DB
  function bnpDLShiftTo(n,r) {
    var i;
    for(i = this.t-1; i >= 0; --i) r[i+n] = this[i];
    for(i = n-1; i >= 0; --i) r[i] = 0;
    r.t = this.t+n;
    r.s = this.s;
  }

  // (protected) r = this >> n*DB
  function bnpDRShiftTo(n,r) {
    for(var i = n; i < this.t; ++i) r[i-n] = this[i];
    r.t = Math.max(this.t-n,0);
    r.s = this.s;
  }

  // (protected) r = this << n
  function bnpLShiftTo(n,r) {
    var bs = n%this.DB;
    var cbs = this.DB-bs;
    var bm = (1<<cbs)-1;
    var ds = Math.floor(n/this.DB), c = (this.s<<bs)&this.DM, i;
    for(i = this.t-1; i >= 0; --i) {
      r[i+ds+1] = (this[i]>>cbs)|c;
      c = (this[i]&bm)<<bs;
    }
    for(i = ds-1; i >= 0; --i) r[i] = 0;
    r[ds] = c;
    r.t = this.t+ds+1;
    r.s = this.s;
    r.clamp();
  }

  // (protected) r = this >> n
  function bnpRShiftTo(n,r) {
    r.s = this.s;
    var ds = Math.floor(n/this.DB);
    if(ds >= this.t) { r.t = 0; return; }
    var bs = n%this.DB;
    var cbs = this.DB-bs;
    var bm = (1<<bs)-1;
    r[0] = this[ds]>>bs;
    for(var i = ds+1; i < this.t; ++i) {
      r[i-ds-1] |= (this[i]&bm)<<cbs;
      r[i-ds] = this[i]>>bs;
    }
    if(bs > 0) r[this.t-ds-1] |= (this.s&bm)<<cbs;
    r.t = this.t-ds;
    r.clamp();
  }

  // (protected) r = this - a
  function bnpSubTo(a,r) {
    var i = 0, c = 0, m = Math.min(a.t,this.t);
    while(i < m) {
      c += this[i]-a[i];
      r[i++] = c&this.DM;
      c >>= this.DB;
    }
    if(a.t < this.t) {
      c -= a.s;
      while(i < this.t) {
        c += this[i];
        r[i++] = c&this.DM;
        c >>= this.DB;
      }
      c += this.s;
    }
    else {
      c += this.s;
      while(i < a.t) {
        c -= a[i];
        r[i++] = c&this.DM;
        c >>= this.DB;
      }
      c -= a.s;
    }
    r.s = (c<0)?-1:0;
    if(c < -1) r[i++] = this.DV+c;
    else if(c > 0) r[i++] = c;
    r.t = i;
    r.clamp();
  }

  // (protected) r = this * a, r != this,a (HAC 14.12)
  // "this" should be the larger one if appropriate.
  function bnpMultiplyTo(a,r) {
    var x = this.abs(), y = a.abs();
    var i = x.t;
    r.t = i+y.t;
    while(--i >= 0) r[i] = 0;
    for(i = 0; i < y.t; ++i) r[i+x.t] = x.am(0,y[i],r,i,0,x.t);
    r.s = 0;
    r.clamp();
    if(this.s != a.s) BigInteger.ZERO.subTo(r,r);
  }

  // (protected) r = this^2, r != this (HAC 14.16)
  function bnpSquareTo(r) {
    var x = this.abs();
    var i = r.t = 2*x.t;
    while(--i >= 0) r[i] = 0;
    for(i = 0; i < x.t-1; ++i) {
      var c = x.am(i,x[i],r,2*i,0,1);
      if((r[i+x.t]+=x.am(i+1,2*x[i],r,2*i+1,c,x.t-i-1)) >= x.DV) {
        r[i+x.t] -= x.DV;
        r[i+x.t+1] = 1;
      }
    }
    if(r.t > 0) r[r.t-1] += x.am(i,x[i],r,2*i,0,1);
    r.s = 0;
    r.clamp();
  }

  // (protected) divide this by m, quotient and remainder to q, r (HAC 14.20)
  // r != q, this != m.  q or r may be null.
  function bnpDivRemTo(m,q,r) {
    var pm = m.abs();
    if(pm.t <= 0) return;
    var pt = this.abs();
    if(pt.t < pm.t) {
      if(q != null) q.fromInt(0);
      if(r != null) this.copyTo(r);
      return;
    }
    if(r == null) r = nbi();
    var y = nbi(), ts = this.s, ms = m.s;
    var nsh = this.DB-nbits(pm[pm.t-1]);	// normalize modulus
    if(nsh > 0) { pm.lShiftTo(nsh,y); pt.lShiftTo(nsh,r); }
    else { pm.copyTo(y); pt.copyTo(r); }
    var ys = y.t;
    var y0 = y[ys-1];
    if(y0 == 0) return;
    var yt = y0*(1<<this.F1)+((ys>1)?y[ys-2]>>this.F2:0);
    var d1 = this.FV/yt, d2 = (1<<this.F1)/yt, e = 1<<this.F2;
    var i = r.t, j = i-ys, t = (q==null)?nbi():q;
    y.dlShiftTo(j,t);
    if(r.compareTo(t) >= 0) {
      r[r.t++] = 1;
      r.subTo(t,r);
    }
    BigInteger.ONE.dlShiftTo(ys,t);
    t.subTo(y,y);	// "negative" y so we can replace sub with am later
    while(y.t < ys) y[y.t++] = 0;
    while(--j >= 0) {
      // Estimate quotient digit
      var qd = (r[--i]==y0)?this.DM:Math.floor(r[i]*d1+(r[i-1]+e)*d2);
      if((r[i]+=y.am(0,qd,r,j,0,ys)) < qd) {	// Try it out
        y.dlShiftTo(j,t);
        r.subTo(t,r);
        while(r[i] < --qd) r.subTo(t,r);
      }
    }
    if(q != null) {
      r.drShiftTo(ys,q);
      if(ts != ms) BigInteger.ZERO.subTo(q,q);
    }
    r.t = ys;
    r.clamp();
    if(nsh > 0) r.rShiftTo(nsh,r);	// Denormalize remainder
    if(ts < 0) BigInteger.ZERO.subTo(r,r);
  }

  // (public) this mod a
  function bnMod(a) {
    var r = nbi();
    this.abs().divRemTo(a,null,r);
    if(this.s < 0 && r.compareTo(BigInteger.ZERO) > 0) a.subTo(r,r);
    return r;
  }

  // Modular reduction using "classic" algorithm
  function Classic(m) { this.m = m; }
  function cConvert(x) {
    if(x.s < 0 || x.compareTo(this.m) >= 0) return x.mod(this.m);
    else return x;
  }
  function cRevert(x) { return x; }
  function cReduce(x) { x.divRemTo(this.m,null,x); }
  function cMulTo(x,y,r) { x.multiplyTo(y,r); this.reduce(r); }
  function cSqrTo(x,r) { x.squareTo(r); this.reduce(r); }

  Classic.prototype.convert = cConvert;
  Classic.prototype.revert = cRevert;
  Classic.prototype.reduce = cReduce;
  Classic.prototype.mulTo = cMulTo;
  Classic.prototype.sqrTo = cSqrTo;

  // (protected) return "-1/this % 2^DB"; useful for Mont. reduction
  // justification:
  //         xy == 1 (mod m)
  //         xy =  1+km
  //   xy(2-xy) = (1+km)(1-km)
  // x[y(2-xy)] = 1-k^2m^2
  // x[y(2-xy)] == 1 (mod m^2)
  // if y is 1/x mod m, then y(2-xy) is 1/x mod m^2
  // should reduce x and y(2-xy) by m^2 at each step to keep size bounded.
  // JS multiply "overflows" differently from C/C++, so care is needed here.
  function bnpInvDigit() {
    if(this.t < 1) return 0;
    var x = this[0];
    if((x&1) == 0) return 0;
    var y = x&3;		// y == 1/x mod 2^2
    y = (y*(2-(x&0xf)*y))&0xf;	// y == 1/x mod 2^4
    y = (y*(2-(x&0xff)*y))&0xff;	// y == 1/x mod 2^8
    y = (y*(2-(((x&0xffff)*y)&0xffff)))&0xffff;	// y == 1/x mod 2^16
    // last step - calculate inverse mod DV directly;
    // assumes 16 < DB <= 32 and assumes ability to handle 48-bit ints
    y = (y*(2-x*y%this.DV))%this.DV;		// y == 1/x mod 2^dbits
    // we really want the negative inverse, and -DV < y < DV
    return (y>0)?this.DV-y:-y;
  }

  // Montgomery reduction
  function Montgomery(m) {
    this.m = m;
    this.mp = m.invDigit();
    this.mpl = this.mp&0x7fff;
    this.mph = this.mp>>15;
    this.um = (1<<(m.DB-15))-1;
    this.mt2 = 2*m.t;
  }

  // xR mod m
  function montConvert(x) {
    var r = nbi();
    x.abs().dlShiftTo(this.m.t,r);
    r.divRemTo(this.m,null,r);
    if(x.s < 0 && r.compareTo(BigInteger.ZERO) > 0) this.m.subTo(r,r);
    return r;
  }

  // x/R mod m
  function montRevert(x) {
    var r = nbi();
    x.copyTo(r);
    this.reduce(r);
    return r;
  }

  // x = x/R mod m (HAC 14.32)
  function montReduce(x) {
    while(x.t <= this.mt2)	// pad x so am has enough room later
      x[x.t++] = 0;
    for(var i = 0; i < this.m.t; ++i) {
      // faster way of calculating u0 = x[i]*mp mod DV
      var j = x[i]&0x7fff;
      var u0 = (j*this.mpl+(((j*this.mph+(x[i]>>15)*this.mpl)&this.um)<<15))&x.DM;
      // use am to combine the multiply-shift-add into one call
      j = i+this.m.t;
      x[j] += this.m.am(0,u0,x,i,0,this.m.t);
      // propagate carry
      while(x[j] >= x.DV) { x[j] -= x.DV; x[++j]++; }
    }
    x.clamp();
    x.drShiftTo(this.m.t,x);
    if(x.compareTo(this.m) >= 0) x.subTo(this.m,x);
  }

  // r = "x^2/R mod m"; x != r
  function montSqrTo(x,r) { x.squareTo(r); this.reduce(r); }

  // r = "xy/R mod m"; x,y != r
  function montMulTo(x,y,r) { x.multiplyTo(y,r); this.reduce(r); }

  Montgomery.prototype.convert = montConvert;
  Montgomery.prototype.revert = montRevert;
  Montgomery.prototype.reduce = montReduce;
  Montgomery.prototype.mulTo = montMulTo;
  Montgomery.prototype.sqrTo = montSqrTo;

  // (protected) true iff this is even
  function bnpIsEven() { return ((this.t>0)?(this[0]&1):this.s) == 0; }

  // (protected) this^e, e < 2^32, doing sqr and mul with "r" (HAC 14.79)
  function bnpExp(e,z) {
    if(e > 0xffffffff || e < 1) return BigInteger.ONE;
    var r = nbi(), r2 = nbi(), g = z.convert(this), i = nbits(e)-1;
    g.copyTo(r);
    while(--i >= 0) {
      z.sqrTo(r,r2);
      if((e&(1<<i)) > 0) z.mulTo(r2,g,r);
      else { var t = r; r = r2; r2 = t; }
    }
    return z.revert(r);
  }

  // (public) this^e % m, 0 <= e < 2^32
  function bnModPowInt(e,m) {
    var z;
    if(e < 256 || m.isEven()) z = new Classic(m); else z = new Montgomery(m);
    return this.exp(e,z);
  }

  // protected
  BigInteger.prototype.copyTo = bnpCopyTo;
  BigInteger.prototype.fromInt = bnpFromInt;
  BigInteger.prototype.fromString = bnpFromString;
  BigInteger.prototype.clamp = bnpClamp;
  BigInteger.prototype.dlShiftTo = bnpDLShiftTo;
  BigInteger.prototype.drShiftTo = bnpDRShiftTo;
  BigInteger.prototype.lShiftTo = bnpLShiftTo;
  BigInteger.prototype.rShiftTo = bnpRShiftTo;
  BigInteger.prototype.subTo = bnpSubTo;
  BigInteger.prototype.multiplyTo = bnpMultiplyTo;
  BigInteger.prototype.squareTo = bnpSquareTo;
  BigInteger.prototype.divRemTo = bnpDivRemTo;
  BigInteger.prototype.invDigit = bnpInvDigit;
  BigInteger.prototype.isEven = bnpIsEven;
  BigInteger.prototype.exp = bnpExp;

  // public
  BigInteger.prototype.toString = bnToString;
  BigInteger.prototype.negate = bnNegate;
  BigInteger.prototype.abs = bnAbs;
  BigInteger.prototype.compareTo = bnCompareTo;
  BigInteger.prototype.bitLength = bnBitLength;
  BigInteger.prototype.mod = bnMod;
  BigInteger.prototype.modPowInt = bnModPowInt;

  // "constants"
  BigInteger.ZERO = nbv(0);
  BigInteger.ONE = nbv(1);

  // jsbn2 stuff

  // (protected) convert from radix string
  function bnpFromRadix(s,b) {
    this.fromInt(0);
    if(b == null) b = 10;
    var cs = this.chunkSize(b);
    var d = Math.pow(b,cs), mi = false, j = 0, w = 0;
    for(var i = 0; i < s.length; ++i) {
      var x = intAt(s,i);
      if(x < 0) {
        if(s.charAt(i) == "-" && this.signum() == 0) mi = true;
        continue;
      }
      w = b*w+x;
      if(++j >= cs) {
        this.dMultiply(d);
        this.dAddOffset(w,0);
        j = 0;
        w = 0;
      }
    }
    if(j > 0) {
      this.dMultiply(Math.pow(b,j));
      this.dAddOffset(w,0);
    }
    if(mi) BigInteger.ZERO.subTo(this,this);
  }

  // (protected) return x s.t. r^x < DV
  function bnpChunkSize(r) { return Math.floor(Math.LN2*this.DB/Math.log(r)); }

  // (public) 0 if this == 0, 1 if this > 0
  function bnSigNum() {
    if(this.s < 0) return -1;
    else if(this.t <= 0 || (this.t == 1 && this[0] <= 0)) return 0;
    else return 1;
  }

  // (protected) this *= n, this >= 0, 1 < n < DV
  function bnpDMultiply(n) {
    this[this.t] = this.am(0,n-1,this,0,0,this.t);
    ++this.t;
    this.clamp();
  }

  // (protected) this += n << w words, this >= 0
  function bnpDAddOffset(n,w) {
    if(n == 0) return;
    while(this.t <= w) this[this.t++] = 0;
    this[w] += n;
    while(this[w] >= this.DV) {
      this[w] -= this.DV;
      if(++w >= this.t) this[this.t++] = 0;
      ++this[w];
    }
  }

  // (protected) convert to radix string
  function bnpToRadix(b) {
    if(b == null) b = 10;
    if(this.signum() == 0 || b < 2 || b > 36) return "0";
    var cs = this.chunkSize(b);
    var a = Math.pow(b,cs);
    var d = nbv(a), y = nbi(), z = nbi(), r = "";
    this.divRemTo(d,y,z);
    while(y.signum() > 0) {
      r = (a+z.intValue()).toString(b).substr(1) + r;
      y.divRemTo(d,y,z);
    }
    return z.intValue().toString(b) + r;
  }

  // (public) return value as integer
  function bnIntValue() {
    if(this.s < 0) {
      if(this.t == 1) return this[0]-this.DV;
      else if(this.t == 0) return -1;
    }
    else if(this.t == 1) return this[0];
    else if(this.t == 0) return 0;
    // assumes 16 < DB < 32
    return ((this[1]&((1<<(32-this.DB))-1))<<this.DB)|this[0];
  }

  // (protected) r = this + a
  function bnpAddTo(a,r) {
    var i = 0, c = 0, m = Math.min(a.t,this.t);
    while(i < m) {
      c += this[i]+a[i];
      r[i++] = c&this.DM;
      c >>= this.DB;
    }
    if(a.t < this.t) {
      c += a.s;
      while(i < this.t) {
        c += this[i];
        r[i++] = c&this.DM;
        c >>= this.DB;
      }
      c += this.s;
    }
    else {
      c += this.s;
      while(i < a.t) {
        c += a[i];
        r[i++] = c&this.DM;
        c >>= this.DB;
      }
      c += a.s;
    }
    r.s = (c<0)?-1:0;
    if(c > 0) r[i++] = c;
    else if(c < -1) r[i++] = this.DV+c;
    r.t = i;
    r.clamp();
  }

  BigInteger.prototype.fromRadix = bnpFromRadix;
  BigInteger.prototype.chunkSize = bnpChunkSize;
  BigInteger.prototype.signum = bnSigNum;
  BigInteger.prototype.dMultiply = bnpDMultiply;
  BigInteger.prototype.dAddOffset = bnpDAddOffset;
  BigInteger.prototype.toRadix = bnpToRadix;
  BigInteger.prototype.intValue = bnIntValue;
  BigInteger.prototype.addTo = bnpAddTo;

  //======= end jsbn =======

  // Emscripten wrapper
  var Wrapper = {
    abs: function(l, h) {
      var x = new goog.math.Long(l, h);
      var ret;
      if (x.isNegative()) {
        ret = x.negate();
      } else {
        ret = x;
      }
      HEAP32[tempDoublePtr>>2] = ret.low_;
      HEAP32[tempDoublePtr+4>>2] = ret.high_;
    },
    ensureTemps: function() {
      if (Wrapper.ensuredTemps) return;
      Wrapper.ensuredTemps = true;
      Wrapper.two32 = new BigInteger();
      Wrapper.two32.fromString('4294967296', 10);
      Wrapper.two64 = new BigInteger();
      Wrapper.two64.fromString('18446744073709551616', 10);
      Wrapper.temp1 = new BigInteger();
      Wrapper.temp2 = new BigInteger();
    },
    lh2bignum: function(l, h) {
      var a = new BigInteger();
      a.fromString(h.toString(), 10);
      var b = new BigInteger();
      a.multiplyTo(Wrapper.two32, b);
      var c = new BigInteger();
      c.fromString(l.toString(), 10);
      var d = new BigInteger();
      c.addTo(b, d);
      return d;
    },
    stringify: function(l, h, unsigned) {
      var ret = new goog.math.Long(l, h).toString();
      if (unsigned && ret[0] == '-') {
        // unsign slowly using jsbn bignums
        Wrapper.ensureTemps();
        var bignum = new BigInteger();
        bignum.fromString(ret, 10);
        ret = new BigInteger();
        Wrapper.two64.addTo(bignum, ret);
        ret = ret.toString(10);
      }
      return ret;
    },
    fromString: function(str, base, min, max, unsigned) {
      Wrapper.ensureTemps();
      var bignum = new BigInteger();
      bignum.fromString(str, base);
      var bigmin = new BigInteger();
      bigmin.fromString(min, 10);
      var bigmax = new BigInteger();
      bigmax.fromString(max, 10);
      if (unsigned && bignum.compareTo(BigInteger.ZERO) < 0) {
        var temp = new BigInteger();
        bignum.addTo(Wrapper.two64, temp);
        bignum = temp;
      }
      var error = false;
      if (bignum.compareTo(bigmin) < 0) {
        bignum = bigmin;
        error = true;
      } else if (bignum.compareTo(bigmax) > 0) {
        bignum = bigmax;
        error = true;
      }
      var ret = goog.math.Long.fromString(bignum.toString()); // min-max checks should have clamped this to a range goog.math.Long can handle well
      HEAP32[tempDoublePtr>>2] = ret.low_;
      HEAP32[tempDoublePtr+4>>2] = ret.high_;
      if (error) throw 'range error';
    }
  };
  return Wrapper;
})();

//======= end closure i64 code =======



// === Auto-generated postamble setup entry stuff ===

if (memoryInitializer) {
  if (ENVIRONMENT_IS_NODE || ENVIRONMENT_IS_SHELL) {
    var data = Module['readBinary'](memoryInitializer);
    HEAPU8.set(data, STATIC_BASE);
  } else {
    addRunDependency('memory initializer');
    Browser.asyncLoad(memoryInitializer, function(data) {
      HEAPU8.set(data, STATIC_BASE);
      removeRunDependency('memory initializer');
    }, function(data) {
      throw 'could not load memory initializer ' + memoryInitializer;
    });
  }
}

function ExitStatus(status) {
  this.name = "ExitStatus";
  this.message = "Program terminated with exit(" + status + ")";
  this.status = status;
};
ExitStatus.prototype = new Error();
ExitStatus.prototype.constructor = ExitStatus;

var initialStackTop;
var preloadStartTime = null;
var calledMain = false;

dependenciesFulfilled = function runCaller() {
  // If run has never been called, and we should call run (INVOKE_RUN is true, and Module.noInitialRun is not false)
  if (!Module['calledRun'] && shouldRunNow) run();
  if (!Module['calledRun']) dependenciesFulfilled = runCaller; // try this again later, after new deps are fulfilled
}

Module['callMain'] = Module.callMain = function callMain(args) {
  assert(runDependencies == 0, 'cannot call main when async dependencies remain! (listen on __ATMAIN__)');
  assert(__ATPRERUN__.length == 0, 'cannot call main when preRun functions remain to be called');

  args = args || [];

  if (ENVIRONMENT_IS_WEB && preloadStartTime !== null) {
    Module.printErr('preload time: ' + (Date.now() - preloadStartTime) + ' ms');
  }

  ensureInitRuntime();

  var argc = args.length+1;
  function pad() {
    for (var i = 0; i < 4-1; i++) {
      argv.push(0);
    }
  }
  var argv = [allocate(intArrayFromString("/bin/this.program"), 'i8', ALLOC_NORMAL) ];
  pad();
  for (var i = 0; i < argc-1; i = i + 1) {
    argv.push(allocate(intArrayFromString(args[i]), 'i8', ALLOC_NORMAL));
    pad();
  }
  argv.push(0);
  argv = allocate(argv, 'i32', ALLOC_NORMAL);

  initialStackTop = STACKTOP;

  try {

    var ret = Module['_main'](argc, argv, 0);


    // if we're not running an evented main loop, it's time to exit
    if (!Module['noExitRuntime']) {
      exit(ret);
    }
  }
  catch(e) {
    if (e instanceof ExitStatus) {
      // exit() throws this once it's done to make sure execution
      // has been stopped completely
      return;
    } else if (e == 'SimulateInfiniteLoop') {
      // running an evented main loop, don't immediately exit
      Module['noExitRuntime'] = true;
      return;
    } else {
      if (e && typeof e === 'object' && e.stack) Module.printErr('exception thrown: ' + [e, e.stack]);
      throw e;
    }
  } finally {
    calledMain = true;
  }
}




function run(args) {
  args = args || Module['arguments'];

  if (preloadStartTime === null) preloadStartTime = Date.now();

  if (runDependencies > 0) {
    Module.printErr('run() called, but dependencies remain, so not running');
    return;
  }

  preRun();

  if (runDependencies > 0) return; // a preRun added a dependency, run will be called later
  if (Module['calledRun']) return; // run may have just been called through dependencies being fulfilled just in this very frame

  function doRun() {
    if (Module['calledRun']) return; // run may have just been called while the async setStatus time below was happening
    Module['calledRun'] = true;

    ensureInitRuntime();

    preMain();

    if (Module['_main'] && shouldRunNow) {
      Module['callMain'](args);
    }

    postRun();
  }

  if (Module['setStatus']) {
    Module['setStatus']('Running...');
    setTimeout(function() {
      setTimeout(function() {
        Module['setStatus']('');
      }, 1);
      if (!ABORT) doRun();
    }, 1);
  } else {
    doRun();
  }
}
Module['run'] = Module.run = run;

function exit(status) {
  ABORT = true;
  EXITSTATUS = status;
  STACKTOP = initialStackTop;

  // exit the runtime
  exitRuntime();

  // TODO We should handle this differently based on environment.
  // In the browser, the best we can do is throw an exception
  // to halt execution, but in node we could process.exit and
  // I'd imagine SM shell would have something equivalent.
  // This would let us set a proper exit status (which
  // would be great for checking test exit statuses).
  // https://github.com/kripken/emscripten/issues/1371

  // throw an exception to halt the current execution
  throw new ExitStatus(status);
}
Module['exit'] = Module.exit = exit;

function abort(text) {
  if (text) {
    Module.print(text);
    Module.printErr(text);
  }

  ABORT = true;
  EXITSTATUS = 1;

  throw 'abort() at ' + stackTrace();
}
Module['abort'] = Module.abort = abort;

// {{PRE_RUN_ADDITIONS}}

if (Module['preInit']) {
  if (typeof Module['preInit'] == 'function') Module['preInit'] = [Module['preInit']];
  while (Module['preInit'].length > 0) {
    Module['preInit'].pop()();
  }
}

// shouldRunNow refers to calling main(), not run().
var shouldRunNow = true;
if (Module['noInitialRun']) {
  shouldRunNow = false;
}


run();

// {{POST_RUN_ADDITIONS}}






// {{MODULE_ADDITIONS}}



